/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(ne){for(var t=[],S=0,R=ne.length;S<R;S++)t[S]=ge[ne[S]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:it,seal:ut,create:ri}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,S,R){return t.apply(S,R)}),it||(it=function(t){return t}),ut||(ut=function(t){return t}),Nt||(Nt=function(t,S){return new t(...S)});const oi=at(Array.prototype.forEach),Ht=at(Array.prototype.pop),bt=at(Array.prototype.push),Dt=at(String.prototype.toLowerCase),Tt=at(String.prototype.toString),li=at(String.prototype.match),ct=at(String.prototype.replace),ai=at(String.prototype.indexOf),hi=at(String.prototype.trim),ot=at(RegExp.prototype.test),$t=ui(TypeError);function at(ne){return function(t){for(var S=arguments.length,R=new Array(S>1?S-1:0),n=1;n<S;n++)R[n-1]=arguments[n];return Ft(ne,t,R)}}function ui(ne){return function(){for(var t=arguments.length,S=new Array(t),R=0;R<t;R++)S[R]=arguments[R];return Nt(ne,S)}}function je(ne,t,S){var R;S=(R=S)!==null&&R!==void 0?R:Dt,jt&&jt(ne,null);let n=t.length;for(;n--;){let j=t[n];if(typeof j=="string"){const k=S(j);k!==j&&(ii(t)||(t[n]=k),j=k)}ne[j]=!0}return ne}function gt(ne){const t=ri(null);for(const[S,R]of zt(ne))t[S]=R;return t}function yt(ne,t){for(;ne!==null;){const R=si(ne,t);if(R){if(R.get)return at(R.get);if(typeof R.value=="function")return at(R.value)}ne=ni(ne)}function S(R){return console.warn("fallback value for",R),null}return S}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ot=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),_t=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Et=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ut(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ut(/<%[\w\W]*|[\w\W]*%>/gm),mi=ut(/\${[\w\W]*}/gm),bi=ut(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ut(/^aria-[\-\w]+$/),Vt=ut(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ut(/^(?:\w+script|data):/i),wi=ut(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=ut(/^html$/i);var Qt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Vt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Kt});const vi=()=>typeof window>"u"?null:window,Di=function(t,S){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let R=null;const n="data-tt-policy-suffix";S&&S.hasAttribute(n)&&(R=S.getAttribute(n));const j="dompurify"+(R?"#"+R:"");try{return t.createPolicy(j,{createHTML(k){return k},createScriptURL(k){return k}})}catch{return console.warn("TrustedTypes policy "+j+" could not be created."),null}};function xt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Oe=>xt(Oe);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const S=ne.document,R=S.currentScript;let{document:n}=ne;const{DocumentFragment:j,HTMLTemplateElement:k,Node:C,Element:$,NodeFilter:v,NamedNodeMap:y=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:O,DOMParser:r,trustedTypes:l}=ne,e=$.prototype,c=yt(e,"cloneNode"),d=yt(e,"nextSibling"),p=yt(e,"childNodes"),o=yt(e,"parentNode");if(typeof k=="function"){const Oe=n.createElement("template");Oe.content&&Oe.content.ownerDocument&&(n=Oe.content.ownerDocument)}let a,E="";const{implementation:m,createNodeIterator:f,createDocumentFragment:N,getElementsByTagName:B}=n,{importNode:L}=S;let w={};t.isSupported=typeof zt=="function"&&typeof o=="function"&&m&&m.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:P,ERB_EXPR:M,TMPLIT_EXPR:U,DATA_ATTR:V,ARIA_ATTR:F,IS_SCRIPT_OR_DATA:I,ATTR_WHITESPACE:z}=Qt;let{IS_ALLOWED_URI:X}=Qt,G=null;const re=je({},[...Ut,...Rt,...Lt,...Ot,...Wt]);let ie=null;const te=je({},[..._t,...It,...qt,...Et]);let $e=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Fe=null,ke=null,Le=!0,ae=!0,J=!1,le=!0,K=!1,H=!1,Y=!1,be=!1,we=!1,Ce=!1,Ae=!1,ce=!0,D=!1;const i="user-content-";let s=!0,u=!1,h={},g=null;const b=je({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let A=null;const T=je({},["audio","video","img","source","image","track"]);let _=null;const x=je({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ee="http://www.w3.org/1998/Math/MathML",fe="http://www.w3.org/2000/svg",he="http://www.w3.org/1999/xhtml";let ye=he,De=!1,pe=null;const Ie=je({},[ee,fe,he],Tt);let Te;const Ye=["application/xhtml+xml","text/html"],He="text/html";let Me,Ve=null;const Q=n.createElement("form"),se=function(oe){return oe instanceof RegExp||oe instanceof Function},de=function(oe){if(!(Ve&&Ve===oe)){if((!oe||typeof oe!="object")&&(oe={}),oe=gt(oe),Te=Ye.indexOf(oe.PARSER_MEDIA_TYPE)===-1?Te=He:Te=oe.PARSER_MEDIA_TYPE,Me=Te==="application/xhtml+xml"?Tt:Dt,G="ALLOWED_TAGS"in oe?je({},oe.ALLOWED_TAGS,Me):re,ie="ALLOWED_ATTR"in oe?je({},oe.ALLOWED_ATTR,Me):te,pe="ALLOWED_NAMESPACES"in oe?je({},oe.ALLOWED_NAMESPACES,Tt):Ie,_="ADD_URI_SAFE_ATTR"in oe?je(gt(x),oe.ADD_URI_SAFE_ATTR,Me):x,A="ADD_DATA_URI_TAGS"in oe?je(gt(T),oe.ADD_DATA_URI_TAGS,Me):T,g="FORBID_CONTENTS"in oe?je({},oe.FORBID_CONTENTS,Me):b,Fe="FORBID_TAGS"in oe?je({},oe.FORBID_TAGS,Me):{},ke="FORBID_ATTR"in oe?je({},oe.FORBID_ATTR,Me):{},h="USE_PROFILES"in oe?oe.USE_PROFILES:!1,Le=oe.ALLOW_ARIA_ATTR!==!1,ae=oe.ALLOW_DATA_ATTR!==!1,J=oe.ALLOW_UNKNOWN_PROTOCOLS||!1,le=oe.ALLOW_SELF_CLOSE_IN_ATTR!==!1,K=oe.SAFE_FOR_TEMPLATES||!1,H=oe.WHOLE_DOCUMENT||!1,we=oe.RETURN_DOM||!1,Ce=oe.RETURN_DOM_FRAGMENT||!1,Ae=oe.RETURN_TRUSTED_TYPE||!1,be=oe.FORCE_BODY||!1,ce=oe.SANITIZE_DOM!==!1,D=oe.SANITIZE_NAMED_PROPS||!1,s=oe.KEEP_CONTENT!==!1,u=oe.IN_PLACE||!1,X=oe.ALLOWED_URI_REGEXP||Vt,ye=oe.NAMESPACE||he,$e=oe.CUSTOM_ELEMENT_HANDLING||{},oe.CUSTOM_ELEMENT_HANDLING&&se(oe.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&($e.tagNameCheck=oe.CUSTOM_ELEMENT_HANDLING.tagNameCheck),oe.CUSTOM_ELEMENT_HANDLING&&se(oe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&($e.attributeNameCheck=oe.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),oe.CUSTOM_ELEMENT_HANDLING&&typeof oe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&($e.allowCustomizedBuiltInElements=oe.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),K&&(ae=!1),Ce&&(we=!0),h&&(G=je({},[...Wt]),ie=[],h.html===!0&&(je(G,Ut),je(ie,_t)),h.svg===!0&&(je(G,Rt),je(ie,It),je(ie,Et)),h.svgFilters===!0&&(je(G,Lt),je(ie,It),je(ie,Et)),h.mathMl===!0&&(je(G,Ot),je(ie,qt),je(ie,Et))),oe.ADD_TAGS&&(G===re&&(G=gt(G)),je(G,oe.ADD_TAGS,Me)),oe.ADD_ATTR&&(ie===te&&(ie=gt(ie)),je(ie,oe.ADD_ATTR,Me)),oe.ADD_URI_SAFE_ATTR&&je(_,oe.ADD_URI_SAFE_ATTR,Me),oe.FORBID_CONTENTS&&(g===b&&(g=gt(g)),je(g,oe.FORBID_CONTENTS,Me)),s&&(G["#text"]=!0),H&&je(G,["html","head","body"]),G.table&&(je(G,["tbody"]),delete Fe.tbody),oe.TRUSTED_TYPES_POLICY){if(typeof oe.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof oe.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');a=oe.TRUSTED_TYPES_POLICY,E=a.createHTML("")}else a===void 0&&(a=Di(l,R)),a!==null&&typeof E=="string"&&(E=a.createHTML(""));it&&it(oe),Ve=oe}},Ee=je({},["mi","mo","mn","ms","mtext"]),Pe=je({},["foreignobject","desc","title","annotation-xml"]),ze=je({},["title","style","font","a","script"]),Ue=je({},Rt);je(Ue,Lt),je(Ue,ci);const Je=je({},Ot);je(Je,fi);const Ze=function(oe){let Se=o(oe);(!Se||!Se.tagName)&&(Se={namespaceURI:ye,tagName:"template"});const Ne=Dt(oe.tagName),We=Dt(Se.tagName);return pe[oe.namespaceURI]?oe.namespaceURI===fe?Se.namespaceURI===he?Ne==="svg":Se.namespaceURI===ee?Ne==="svg"&&(We==="annotation-xml"||Ee[We]):!!Ue[Ne]:oe.namespaceURI===ee?Se.namespaceURI===he?Ne==="math":Se.namespaceURI===fe?Ne==="math"&&Pe[We]:!!Je[Ne]:oe.namespaceURI===he?Se.namespaceURI===fe&&!Pe[We]||Se.namespaceURI===ee&&!Ee[We]?!1:!Je[Ne]&&(ze[Ne]||!Ue[Ne]):!!(Te==="application/xhtml+xml"&&pe[oe.namespaceURI]):!1},Ke=function(oe){bt(t.removed,{element:oe});try{oe.parentNode.removeChild(oe)}catch{oe.remove()}},_e=function(oe,Se){try{bt(t.removed,{attribute:Se.getAttributeNode(oe),from:Se})}catch{bt(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(oe),oe==="is"&&!ie[oe])if(we||Ce)try{Ke(Se)}catch{}else try{Se.setAttribute(oe,"")}catch{}},tt=function(oe){let Se,Ne;if(be)oe="<remove></remove>"+oe;else{const st=li(oe,/^[\r\n\t ]+/);Ne=st&&st[0]}Te==="application/xhtml+xml"&&ye===he&&(oe='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+oe+"</body></html>");const We=a?a.createHTML(oe):oe;if(ye===he)try{Se=new r().parseFromString(We,Te)}catch{}if(!Se||!Se.documentElement){Se=m.createDocument(ye,"template",null);try{Se.documentElement.innerHTML=De?E:We}catch{}}const et=Se.body||Se.documentElement;return oe&&Ne&&et.insertBefore(n.createTextNode(Ne),et.childNodes[0]||null),ye===he?B.call(Se,H?"html":"body")[0]:H?Se.documentElement:et},nt=function(oe){return f.call(oe.ownerDocument||oe,oe,v.SHOW_ELEMENT|v.SHOW_COMMENT|v.SHOW_TEXT,null,!1)},dt=function(oe){return oe instanceof O&&(typeof oe.nodeName!="string"||typeof oe.textContent!="string"||typeof oe.removeChild!="function"||!(oe.attributes instanceof y)||typeof oe.removeAttribute!="function"||typeof oe.setAttribute!="function"||typeof oe.namespaceURI!="string"||typeof oe.insertBefore!="function"||typeof oe.hasChildNodes!="function")},lt=function(oe){return typeof C=="object"?oe instanceof C:oe&&typeof oe=="object"&&typeof oe.nodeType=="number"&&typeof oe.nodeName=="string"},ft=function(oe,Se,Ne){w[oe]&&oi(w[oe],We=>{We.call(t,Se,Ne,Ve)})},At=function(oe){let Se;if(ft("beforeSanitizeElements",oe,null),dt(oe))return Ke(oe),!0;const Ne=Me(oe.nodeName);if(ft("uponSanitizeElement",oe,{tagName:Ne,allowedTags:G}),oe.hasChildNodes()&&!lt(oe.firstElementChild)&&(!lt(oe.content)||!lt(oe.content.firstElementChild))&&ot(/<[/\w]/g,oe.innerHTML)&&ot(/<[/\w]/g,oe.textContent))return Ke(oe),!0;if(!G[Ne]||Fe[Ne]){if(!Fe[Ne]&&kt(Ne)&&($e.tagNameCheck instanceof RegExp&&ot($e.tagNameCheck,Ne)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(Ne)))return!1;if(s&&!g[Ne]){const We=o(oe)||oe.parentNode,et=p(oe)||oe.childNodes;if(et&&We){const st=et.length;for(let Qe=st-1;Qe>=0;--Qe)We.insertBefore(c(et[Qe],!0),d(oe))}}return Ke(oe),!0}return oe instanceof $&&!Ze(oe)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&ot(/<\/no(script|embed|frames)/i,oe.innerHTML)?(Ke(oe),!0):(K&&oe.nodeType===3&&(Se=oe.textContent,Se=ct(Se,P," "),Se=ct(Se,M," "),Se=ct(Se,U," "),oe.textContent!==Se&&(bt(t.removed,{element:oe.cloneNode()}),oe.textContent=Se)),ft("afterSanitizeElements",oe,null),!1)},pt=function(oe,Se,Ne){if(ce&&(Se==="id"||Se==="name")&&(Ne in n||Ne in Q))return!1;if(!(ae&&!ke[Se]&&ot(V,Se))){if(!(Le&&ot(F,Se))){if(!ie[Se]||ke[Se]){if(!(kt(oe)&&($e.tagNameCheck instanceof RegExp&&ot($e.tagNameCheck,oe)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(oe))&&($e.attributeNameCheck instanceof RegExp&&ot($e.attributeNameCheck,Se)||$e.attributeNameCheck instanceof Function&&$e.attributeNameCheck(Se))||Se==="is"&&$e.allowCustomizedBuiltInElements&&($e.tagNameCheck instanceof RegExp&&ot($e.tagNameCheck,Ne)||$e.tagNameCheck instanceof Function&&$e.tagNameCheck(Ne))))return!1}else if(!_[Se]){if(!ot(X,ct(Ne,z,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&oe!=="script"&&ai(Ne,"data:")===0&&A[oe])){if(!(J&&!ot(I,ct(Ne,z,"")))){if(Ne)return!1}}}}}}return!0},kt=function(oe){return oe.indexOf("-")>0},St=function(oe){let Se,Ne,We,et;ft("beforeSanitizeAttributes",oe,null);const{attributes:st}=oe;if(!st)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(et=st.length;et--;){Se=st[et];const{name:ht,namespaceURI:wt}=Se;if(Ne=ht==="value"?Se.value:hi(Se.value),We=Me(ht),Qe.attrName=We,Qe.attrValue=Ne,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,ft("uponSanitizeAttribute",oe,Qe),Ne=Qe.attrValue,Qe.forceKeepAttr||(_e(ht,oe),!Qe.keepAttr))continue;if(!le&&ot(/\/>/i,Ne)){_e(ht,oe);continue}K&&(Ne=ct(Ne,P," "),Ne=ct(Ne,M," "),Ne=ct(Ne,U," "));const Ct=Me(oe.nodeName);if(pt(Ct,We,Ne)){if(D&&(We==="id"||We==="name")&&(_e(ht,oe),Ne=i+Ne),a&&typeof l=="object"&&typeof l.getAttributeType=="function"&&!wt)switch(l.getAttributeType(Ct,We)){case"TrustedHTML":{Ne=a.createHTML(Ne);break}case"TrustedScriptURL":{Ne=a.createScriptURL(Ne);break}}try{wt?oe.setAttributeNS(wt,ht,Ne):oe.setAttribute(ht,Ne),Ht(t.removed)}catch{}}}ft("afterSanitizeAttributes",oe,null)},Mt=function Oe(oe){let Se;const Ne=nt(oe);for(ft("beforeSanitizeShadowDOM",oe,null);Se=Ne.nextNode();)ft("uponSanitizeShadowNode",Se,null),!At(Se)&&(Se.content instanceof j&&Oe(Se.content),St(Se));ft("afterSanitizeShadowDOM",oe,null)};return t.sanitize=function(Oe){let oe=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Se,Ne,We,et;if(De=!Oe,De&&(Oe="<!-->"),typeof Oe!="string"&&!lt(Oe))if(typeof Oe.toString=="function"){if(Oe=Oe.toString(),typeof Oe!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Oe;if(Y||de(oe),t.removed=[],typeof Oe=="string"&&(u=!1),u){if(Oe.nodeName){const ht=Me(Oe.nodeName);if(!G[ht]||Fe[ht])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Oe instanceof C)Se=tt("<!---->"),Ne=Se.ownerDocument.importNode(Oe,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Se=Ne:Se.appendChild(Ne);else{if(!we&&!K&&!H&&Oe.indexOf("<")===-1)return a&&Ae?a.createHTML(Oe):Oe;if(Se=tt(Oe),!Se)return we?null:Ae?E:""}Se&&be&&Ke(Se.firstChild);const st=nt(u?Oe:Se);for(;We=st.nextNode();)At(We)||(We.content instanceof j&&Mt(We.content),St(We));if(u)return Oe;if(we){if(Ce)for(et=N.call(Se.ownerDocument);Se.firstChild;)et.appendChild(Se.firstChild);else et=Se;return(ie.shadowroot||ie.shadowrootmode)&&(et=L.call(S,et,!0)),et}let Qe=H?Se.outerHTML:Se.innerHTML;return H&&G["!doctype"]&&Se.ownerDocument&&Se.ownerDocument.doctype&&Se.ownerDocument.doctype.name&&ot(Kt,Se.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+Se.ownerDocument.doctype.name+`>
`+Qe),K&&(Qe=ct(Qe,P," "),Qe=ct(Qe,M," "),Qe=ct(Qe,U," ")),a&&Ae?a.createHTML(Qe):Qe},t.setConfig=function(Oe){de(Oe),Y=!0},t.clearConfig=function(){Ve=null,Y=!1},t.isValidAttribute=function(Oe,oe,Se){Ve||de({});const Ne=Me(Oe),We=Me(oe);return pt(Ne,We,Se)},t.addHook=function(Oe,oe){typeof oe=="function"&&(w[Oe]=w[Oe]||[],bt(w[Oe],oe))},t.removeHook=function(Oe){if(w[Oe])return Ht(w[Oe])},t.removeHooks=function(Oe){w[Oe]&&(w[Oe]=[])},t.removeAllHooks=function(){w={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(ge[41],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=t.$JQ=void 0;class S{constructor(k){this.domNode=k,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(k){const C=R(k);this.a!==C&&(this.a=C,this.domNode.style.maxWidth=this.a)}setWidth(k){const C=R(k);this.b!==C&&(this.b=C,this.domNode.style.width=this.b)}setHeight(k){const C=R(k);this.c!==C&&(this.c=C,this.domNode.style.height=this.c)}setTop(k){const C=R(k);this.d!==C&&(this.d=C,this.domNode.style.top=this.d)}setLeft(k){const C=R(k);this.e!==C&&(this.e=C,this.domNode.style.left=this.e)}setBottom(k){const C=R(k);this.f!==C&&(this.f=C,this.domNode.style.bottom=this.f)}setRight(k){const C=R(k);this.g!==C&&(this.g=C,this.domNode.style.right=this.g)}setPaddingTop(k){const C=R(k);this.h!==C&&(this.h=C,this.domNode.style.paddingTop=this.h)}setPaddingLeft(k){const C=R(k);this.i!==C&&(this.i=C,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(k){const C=R(k);this.j!==C&&(this.j=C,this.domNode.style.paddingBottom=this.j)}setPaddingRight(k){const C=R(k);this.k!==C&&(this.k=C,this.domNode.style.paddingRight=this.k)}setFontFamily(k){this.l!==k&&(this.l=k,this.domNode.style.fontFamily=this.l)}setFontWeight(k){this.m!==k&&(this.m=k,this.domNode.style.fontWeight=this.m)}setFontSize(k){const C=R(k);this.n!==C&&(this.n=C,this.domNode.style.fontSize=this.n)}setFontStyle(k){this.o!==k&&(this.o=k,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(k){this.p!==k&&(this.p=k,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(k){this.q!==k&&(this.q=k,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(k){this.r!==k&&(this.r=k,this.domNode.style.textDecoration=this.r)}setLineHeight(k){const C=R(k);this.s!==C&&(this.s=C,this.domNode.style.lineHeight=this.s)}setLetterSpacing(k){const C=R(k);this.t!==C&&(this.t=C,this.domNode.style.letterSpacing=this.t)}setClassName(k){this.u!==k&&(this.u=k,this.domNode.className=this.u)}toggleClassName(k,C){this.domNode.classList.toggle(k,C),this.u=this.domNode.className}setDisplay(k){this.v!==k&&(this.v=k,this.domNode.style.display=this.v)}setPosition(k){this.w!==k&&(this.w=k,this.domNode.style.position=this.w)}setVisibility(k){this.x!==k&&(this.x=k,this.domNode.style.visibility=this.x)}setColor(k){this.y!==k&&(this.y=k,this.domNode.style.color=this.y)}setBackgroundColor(k){this.z!==k&&(this.z=k,this.domNode.style.backgroundColor=this.z)}setLayerHinting(k){this.A!==k&&(this.A=k,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(k){this.C!==k&&(this.C=k,this.domNode.style.boxShadow=k)}setContain(k){this.B!==k&&(this.B=k,this.domNode.style.contain=this.B)}setAttribute(k,C){this.domNode.setAttribute(k,C)}removeAttribute(k){this.domNode.removeAttribute(k)}appendChild(k){this.domNode.appendChild(k.domNode)}removeChild(k){this.domNode.removeChild(k.domNode)}}t.$JQ=S;function R(j){return typeof j=="number"?`${j}px`:j}function n(j){return new S(j)}t.$KQ=n}),define(ge[69],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4O=t.$3O=void 0;const S=new WeakMap;function R(C){if(!C.parent||C.parent===C)return null;try{const $=C.location,v=C.parent.location;if($.origin!=="null"&&v.origin!=="null"&&$.origin!==v.origin)return null}catch{return null}return C.parent}class n{static a($){let v=S.get($);if(!v){v=[],S.set($,v);let y=$,O;do O=R(y),O?v.push({window:new WeakRef(y),iframeElement:y.frameElement||null}):v.push({window:new WeakRef(y),iframeElement:null}),y=O;while(y)}return v.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow($,v){if(!v||$===v)return{top:0,left:0};let y=0,O=0;const r=this.a($);for(const l of r){const e=l.window.deref();if(y+=e?.scrollY??0,O+=e?.scrollX??0,e===v||!l.iframeElement)break;const c=l.iframeElement.getBoundingClientRect();y+=c.top,O+=c.left}return{top:y,left:O}}}t.$3O=n;async function j(C,$){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const v=JSON.stringify({parentOrigin:C,salt:$}),O=new TextEncoder().encode(v),r=await crypto.subtle.digest("sha-256",O);return k(r)}t.$4O=j;function k(C){const v=Array.from(new Uint8Array(C)).map(y=>y.toString(16).padStart(2,"0")).join("");return BigInt(`0x${v}`).toString(32).padStart(52,"0")}}),define(ge[70],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=t.$gR=t.$fR=t.ListDragOverEffect=void 0;var S;(function(j){j[j.Copy=0]="Copy",j[j.Move=1]="Move"})(S||(t.ListDragOverEffect=S={})),t.$fR={reject(){return{accept:!1}},accept(){return{accept:!0}}};class R extends Error{constructor(k,C){super(`ListError [${k}] ${C}`)}}t.$gR=R;class n{constructor(){this.c=new WeakMap}getHeight(k){return this.c.get(k)??this.d(k)}setDynamicHeight(k,C){C>0&&this.c.set(k,C)}}t.$hR=n}),define(ge[71],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=void 0;class S{constructor(n){this.a=n}splice(n,j,k){this.a.forEach(C=>C.splice(n,j,k))}}t.$eR=S}),define(ge[42],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=void 0;const S=20;class R{constructor(j,k,C,$,v,y){this.a=Math.round(k),this.b=Math.round(C),this.c=Math.round(j),this.d=$,this.e=v,this.f=y,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new R(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(j){const k=Math.round(j);return this.d!==k?(this.d=k,this.m(),!0):!1}setScrollSize(j){const k=Math.round(j);return this.e!==k?(this.e=k,this.m(),!0):!1}setScrollPosition(j){const k=Math.round(j);return this.f!==k?(this.f=k,this.m(),!0):!1}setScrollbarSize(j){this.a=Math.round(j)}setOppositeScrollbarSize(j){this.b=Math.round(j)}static l(j,k,C,$,v){const y=Math.max(0,C-j),O=Math.max(0,y-2*k),r=$>0&&$>C;if(!r)return{computedAvailableSize:Math.round(y),computedIsNeeded:r,computedSliderSize:Math.round(O),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(S,Math.floor(C*O/$))),e=(O-l)/($-C),c=v*e;return{computedAvailableSize:Math.round(y),computedIsNeeded:r,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(c)}}m(){const j=R.l(this.b,this.c,this.d,this.e,this.f);this.g=j.computedAvailableSize,this.h=j.computedIsNeeded,this.i=j.computedSliderSize,this.j=j.computedSliderRatio,this.k=j.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(j){if(!this.h)return 0;const k=j-this.c-this.i/2;return Math.round(k/this.j)}getDesiredScrollPositionFromOffsetPaged(j){if(!this.h)return 0;const k=j-this.c;let C=this.f;return k<this.k?C-=this.d:C+=this.d,C}getDesiredScrollPositionFromDelta(j){if(!this.h)return 0;const k=this.k+j;return Math.round(k/this.j)}}t.$PQ=R}),define(ge[26],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=t.$fT=t.$eT=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var S;(function($){$[$.Hidden=0]="Hidden",$[$.Visible=1]="Visible",$[$.Recurse=2]="Recurse"})(S||(t.TreeVisibility=S={}));var R;(function($){$[$.Expanded=0]="Expanded",$[$.Collapsed=1]="Collapsed",$[$.PreserveOrExpanded=2]="PreserveOrExpanded",$[$.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(R||(t.ObjectTreeElementCollapseState=R={}));var n;(function($){$[$.Unknown=0]="Unknown",$[$.Twistie=1]="Twistie",$[$.Element=2]="Element",$[$.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var j;(function($){$[$.Down=0]="Down",$[$.Up=1]="Up"})(j||(t.TreeDragOverBubble=j={})),t.$eT={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown($=!1){return{accept:!0,bubble:0,autoExpand:$}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown($=!1){return{accept:!0,bubble:0,effect:0,autoExpand:$}}};class k extends Error{constructor(v,y){super(`TreeError [${v}] ${y}`)}}t.$fT=k;class C{constructor(v){this.a=v,this.b=new WeakMap}map(v){let y=this.b.get(v);return y||(y=this.a(v),this.b.set(v,y)),y}}t.$gT=C}),define(ge[21],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HO=t.$window=t.$FO=t.$EO=void 0;function S(n,j){const k=n;typeof k.vscodeWindowId!="number"&&Object.defineProperty(k,"vscodeWindowId",{get:()=>j})}t.$EO=S,t.$FO=window,t.$window=t.$FO;function R(n){return n===t.$FO?!1:typeof n?.vscodeWindowId=="number"}t.$HO=R}),define(ge[72],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function S(c,d,p){const o=R(c,d);if(o!==-1)return c[o]}t.$fb=S;function R(c,d,p=c.length-1){for(let o=p;o>=0;o--){const a=c[o];if(d(a))return o}return-1}t.$gb=R;function n(c,d){const p=j(c,d);return p===-1?void 0:c[p]}t.$hb=n;function j(c,d,p=0,o=c.length){let a=p,E=o;for(;a<E;){const m=Math.floor((a+E)/2);d(c[m])?a=m+1:E=m}return a-1}t.$ib=j;function k(c,d){const p=C(c,d);return p===c.length?void 0:c[p]}t.$jb=k;function C(c,d,p=0,o=c.length){let a=p,E=o;for(;a<E;){const m=Math.floor((a+E)/2);d(c[m])?E=m:a=m+1}return a}t.$kb=C;function $(c,d,p=0,o=c.length){const a=C(c,d,p,o);return a===c.length?-1:a}t.$lb=$;class v{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(v.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!d(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const p=j(this.e,d,this.c);return this.c=p+1,p===-1?void 0:this.e[p]}}t.$mb=v;function y(c,d){if(c.length===0)return;let p=c[0];for(let o=1;o<c.length;o++){const a=c[o];d(a,p)>0&&(p=a)}return p}t.$nb=y;function O(c,d){if(c.length===0)return;let p=c[0];for(let o=1;o<c.length;o++){const a=c[o];d(a,p)>=0&&(p=a)}return p}t.$ob=O;function r(c,d){return y(c,(p,o)=>-d(p,o))}t.$pb=r;function l(c,d){if(c.length===0)return-1;let p=0;for(let o=1;o<c.length;o++){const a=c[o];d(a,c[p])>0&&(p=o)}return p}t.$qb=l;function e(c,d){for(const p of c){const o=d(p);if(o!==void 0)return o}}t.$rb=e}),define(ge[73],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function S(k,C){const $=Object.create(null);for(const v of k){const y=C(v);let O=$[y];O||(O=$[y]=[]),O.push(v)}return $}t.$K=S;function R(k,C){const $=[],v=[];for(const y of k)C.has(y)||$.push(y);for(const y of C)k.has(y)||v.push(y);return{removed:$,added:v}}t.$L=R;function n(k,C){const $=[],v=[];for(const[y,O]of k)C.has(y)||$.push(O);for(const[y,O]of C)k.has(y)||v.push(O);return{removed:$,added:v}}t.$M=n;function j(k,C){const $=new Set;for(const v of C)k.has(v)&&$.add(v);return $}t.$N=j}),define(ge[74],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=t.$8s=t.$7s=t.$6s=void 0;function S(C,$){const v=Math.pow(10,$);return Math.round(C*v)/v}class R{constructor($,v,y,O=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,$))|0,this.g=Math.min(255,Math.max(0,v))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=S(Math.max(Math.min(1,O),0),3)}static equals($,v){return $.r===v.r&&$.g===v.g&&$.b===v.b&&$.a===v.a}}t.$6s=R;class n{constructor($,v,y,O){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,$),0)|0,this.s=S(Math.max(Math.min(1,v),0),3),this.l=S(Math.max(Math.min(1,y),0),3),this.a=S(Math.max(Math.min(1,O),0),3)}static equals($,v){return $.h===v.h&&$.s===v.s&&$.l===v.l&&$.a===v.a}static fromRGBA($){const v=$.r/255,y=$.g/255,O=$.b/255,r=$.a,l=Math.max(v,y,O),e=Math.min(v,y,O);let c=0,d=0;const p=(e+l)/2,o=l-e;if(o>0){switch(d=Math.min(p<=.5?o/(2*p):o/(2-2*p),1),l){case v:c=(y-O)/o+(y<O?6:0);break;case y:c=(O-v)/o+2;break;case O:c=(v-y)/o+4;break}c*=60,c=Math.round(c)}return new n(c,d,p,r)}static i($,v,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?$+(v-$)*6*y:y<1/2?v:y<2/3?$+(v-$)*(2/3-y)*6:$}static toRGBA($){const v=$.h/360,{s:y,l:O,a:r}=$;let l,e,c;if(y===0)l=e=c=O;else{const d=O<.5?O*(1+y):O+y-O*y,p=2*O-d;l=n.i(p,d,v+1/3),e=n.i(p,d,v),c=n.i(p,d,v-1/3)}return new R(Math.round(l*255),Math.round(e*255),Math.round(c*255),r)}}t.$7s=n;class j{constructor($,v,y,O){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,$),0)|0,this.s=S(Math.max(Math.min(1,v),0),3),this.v=S(Math.max(Math.min(1,y),0),3),this.a=S(Math.max(Math.min(1,O),0),3)}static equals($,v){return $.h===v.h&&$.s===v.s&&$.v===v.v&&$.a===v.a}static fromRGBA($){const v=$.r/255,y=$.g/255,O=$.b/255,r=Math.max(v,y,O),l=Math.min(v,y,O),e=r-l,c=r===0?0:e/r;let d;return e===0?d=0:r===v?d=((y-O)/e%6+6)%6:r===y?d=(O-v)/e+2:d=(v-y)/e+4,new j(Math.round(d*60),c,r,$.a)}static toRGBA($){const{h:v,s:y,v:O,a:r}=$,l=O*y,e=l*(1-Math.abs(v/60%2-1)),c=O-l;let[d,p,o]=[0,0,0];return v<60?(d=l,p=e):v<120?(d=e,p=l):v<180?(p=l,o=e):v<240?(p=e,o=l):v<300?(d=e,o=l):v<=360&&(d=l,o=e),d=Math.round((d+c)*255),p=Math.round((p+c)*255),o=Math.round((o+c)*255),new R(d,p,o,r)}}t.$8s=j;class k{static fromHex($){return k.Format.CSS.parseHex($)||k.red}static equals($,v){return!$&&!v?!0:!$||!v?!1:$.equals(v)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor($){if($)if($ instanceof R)this.rgba=$;else if($ instanceof n)this.i=$,this.rgba=n.toRGBA($);else if($ instanceof j)this.j=$,this.rgba=j.toRGBA($);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals($){return!!$&&R.equals(this.rgba,$.rgba)&&n.equals(this.hsla,$.hsla)&&j.equals(this.hsva,$.hsva)}getRelativeLuminance(){const $=k.k(this.rgba.r),v=k.k(this.rgba.g),y=k.k(this.rgba.b),O=.2126*$+.7152*v+.0722*y;return S(O,4)}static k($){const v=$/255;return v<=.03928?v/12.92:Math.pow((v+.055)/1.055,2.4)}getContrastRatio($){const v=this.getRelativeLuminance(),y=$.getRelativeLuminance();return v>y?(v+.05)/(y+.05):(y+.05)/(v+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan($){const v=this.getRelativeLuminance(),y=$.getRelativeLuminance();return v>y}isDarkerThan($){const v=this.getRelativeLuminance(),y=$.getRelativeLuminance();return v<y}lighten($){return new k(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*$,this.hsla.a))}darken($){return new k(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*$,this.hsla.a))}transparent($){const{r:v,g:y,b:O,a:r}=this.rgba;return new k(new R(v,y,O,r*$))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new k(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend($){const v=$.rgba,y=this.rgba.a,O=v.a,r=y+O*(1-y);if(r<1e-6)return k.transparent;const l=this.rgba.r*y/r+v.r*O*(1-y)/r,e=this.rgba.g*y/r+v.g*O*(1-y)/r,c=this.rgba.b*y/r+v.b*O*(1-y)/r;return new k(new R(l,e,c,r))}makeOpaque($){if(this.isOpaque()||$.rgba.a!==1)return this;const{r:v,g:y,b:O,a:r}=this.rgba;return new k(new R($.rgba.r-r*($.rgba.r-v),$.rgba.g-r*($.rgba.g-y),$.rgba.b-r*($.rgba.b-O),1))}flatten(...$){const v=$.reduceRight((y,O)=>k.o(O,y));return k.o(this,v)}static o($,v){const y=1-$.rgba.a;return new k(new R(y*v.rgba.r+$.rgba.a*$.rgba.r,y*v.rgba.g+$.rgba.a*$.rgba.g,y*v.rgba.b+$.rgba.a*$.rgba.b))}toString(){return this.u||(this.u=k.Format.CSS.format(this)),this.u}static getLighterColor($,v,y){if($.isLighterThan(v))return $;y=y||.5;const O=$.getRelativeLuminance(),r=v.getRelativeLuminance();return y=y*(r-O)/r,$.lighten(y)}static getDarkerColor($,v,y){if($.isDarkerThan(v))return $;y=y||.5;const O=$.getRelativeLuminance(),r=v.getRelativeLuminance();return y=y*(O-r)/O,$.darken(y)}static{this.white=new k(new R(255,255,255,1))}static{this.black=new k(new R(0,0,0,1))}static{this.red=new k(new R(255,0,0,1))}static{this.blue=new k(new R(0,0,255,1))}static{this.green=new k(new R(0,255,0,1))}static{this.cyan=new k(new R(0,255,255,1))}static{this.lightgrey=new k(new R(211,211,211,1))}static{this.transparent=new k(new R(0,0,0,0))}}t.$9s=k,function(C){let $;(function(v){let y;(function(O){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:C.Format.CSS.formatRGBA(f)}O.formatRGB=r;function l(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}O.formatRGBA=l;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(f)}O.formatHSL=e;function c(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}O.formatHSLA=c;function d(f){const N=f.toString(16);return N.length!==2?"0"+N:N}function p(f){return`#${d(f.rgba.r)}${d(f.rgba.g)}${d(f.rgba.b)}`}O.formatHex=p;function o(f,N=!1){return N&&f.rgba.a===1?C.Format.CSS.formatHex(f):`#${d(f.rgba.r)}${d(f.rgba.g)}${d(f.rgba.b)}${d(Math.round(f.rgba.a*255))}`}O.formatHexA=o;function a(f){return f.isOpaque()?C.Format.CSS.formatHex(f):C.Format.CSS.formatRGBA(f)}O.format=a;function E(f){const N=f.length;if(N===0||f.charCodeAt(0)!==35)return null;if(N===7){const B=16*m(f.charCodeAt(1))+m(f.charCodeAt(2)),L=16*m(f.charCodeAt(3))+m(f.charCodeAt(4)),w=16*m(f.charCodeAt(5))+m(f.charCodeAt(6));return new C(new R(B,L,w,1))}if(N===9){const B=16*m(f.charCodeAt(1))+m(f.charCodeAt(2)),L=16*m(f.charCodeAt(3))+m(f.charCodeAt(4)),w=16*m(f.charCodeAt(5))+m(f.charCodeAt(6)),P=16*m(f.charCodeAt(7))+m(f.charCodeAt(8));return new C(new R(B,L,w,P/255))}if(N===4){const B=m(f.charCodeAt(1)),L=m(f.charCodeAt(2)),w=m(f.charCodeAt(3));return new C(new R(16*B+B,16*L+L,16*w+w))}if(N===5){const B=m(f.charCodeAt(1)),L=m(f.charCodeAt(2)),w=m(f.charCodeAt(3)),P=m(f.charCodeAt(4));return new C(new R(16*B+B,16*L+L,16*w+w,(16*P+P)/255))}return null}O.parseHex=E;function m(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=v.CSS||(v.CSS={}))})($=C.Format||(C.Format={}))}(k||(t.$9s=k={}))}),define(ge[27],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uh=t.$th=t.$sh=void 0;function S(k){return(C,$,v)=>{let y=null,O=null;if(typeof v.value=="function"?(y="value",O=v.value):typeof v.get=="function"&&(y="get",O=v.get),!O)throw new Error("not supported");v[y]=k(O,$)}}function R(k,C,$){let v=null,y=null;if(typeof $.value=="function"?(v="value",y=$.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(v="get",y=$.get),!y)throw new Error("not supported");const O=`$memoize$${C}`;$[v]=function(...r){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,r)}),this[O]}}t.$sh=R;function n(k,C,$){return S((v,y)=>{const O=`$debounce$${y}`,r=`$debounce$result$${y}`;return function(...l){this[r]||(this[r]=$?$():void 0),clearTimeout(this[O]),C&&(this[r]=C(this[r],...l),l=[this[r]]),this[O]=setTimeout(()=>{v.apply(this,l),this[r]=$?$():void 0},k)}})}t.$th=n;function j(k,C,$){return S((v,y)=>{const O=`$throttle$timer$${y}`,r=`$throttle$result$${y}`,l=`$throttle$lastRun$${y}`,e=`$throttle$pending$${y}`;return function(...c){if(this[r]||(this[r]=$?$():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),C&&(this[r]=C(this[r],...c)),this[e])return;const d=this[l]+k;d<=Date.now()?(this[l]=Date.now(),v.apply(this,[this[r]]),this[r]=$?$():void 0):(this[e]=!0,this[O]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),v.apply(this,[this[r]]),this[r]=$?$():void 0},d-Date.now()))}})}t.$uh=j}),define(ge[75],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hs=void 0;class S{constructor(n,j,k,C){this.originalStart=n,this.originalLength=j,this.modifiedStart=k,this.modifiedLength=C}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Hs=S}),define(ge[6],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class S{constructor(){this.b=[],this.a=function(f){setTimeout(()=>{throw f.stack?a.isErrorNoTelemetry(f)?new a(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.b.push(f),()=>{this.d(f)}}c(f){this.b.forEach(N=>{N(f)})}d(f){this.b.splice(this.b.indexOf(f),1)}setUnexpectedErrorHandler(f){this.a=f}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(f){this.a(f),this.c(f)}onUnexpectedExternalError(f){this.a(f)}}t.$W=S,t.$X=new S;function R(m){t.$X.setUnexpectedErrorHandler(m)}t.setUnexpectedErrorHandler=R;function n(m){if(!m||typeof m!="object")return!1;const f=m;return f.code==="EPIPE"&&f.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function j(m){v(m)||t.$X.onUnexpectedError(m)}t.$1=j;function k(m){v(m)||t.$X.onUnexpectedExternalError(m)}t.$2=k;function C(m){if(m instanceof Error){const{name:f,message:N}=m,B=m.stacktrace||m.stack;return{$isError:!0,name:f,message:N,stack:B,noTelemetry:a.isErrorNoTelemetry(m)}}return m}t.$3=C;const $="Canceled";function v(m){return m instanceof y?!0:m instanceof Error&&m.name===$&&m.message===$}t.$4=v;class y extends Error{constructor(){super($),this.name=this.message}}t.$5=y;function O(){const m=new Error($);return m.name=m.message,m}t.$6=O;function r(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}t.$7=r;function l(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}t.$8=l;class e extends TypeError{constructor(f){super(f?`${f} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function c(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}t.$0=c;class d extends Error{constructor(f){super("NotImplemented"),f&&(this.message=f)}}t.$$=d;class p extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}t.$_=p;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=o;class a extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof a)return f;const N=new a;return N.message=f.message,N.stack=f.stack,N}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}t.$bb=a;class E extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}t.$cb=E}),define(ge[12],me([1,0,6,72]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(D,i=0){return D[D.length-(1+i)]}t.$sb=n;function j(D){if(D.length===0)throw new Error("Invalid tail call");return[D.slice(0,D.length-1),D[D.length-1]]}t.$tb=j;function k(D,i,s=(u,h)=>u===h){if(D===i)return!0;if(!D||!i||D.length!==i.length)return!1;for(let u=0,h=D.length;u<h;u++)if(!s(D[u],i[u]))return!1;return!0}t.$ub=k;function C(D,i){const s=D.length-1;i<s&&(D[i]=D[s]),D.pop()}t.$vb=C;function $(D,i,s){return v(D.length,u=>s(D[u],i))}t.$wb=$;function v(D,i){let s=0,u=D-1;for(;s<=u;){const h=(s+u)/2|0,g=i(h);if(g<0)s=h+1;else if(g>0)u=h-1;else return h}return-(s+1)}t.$xb=v;function y(D,i,s){if(D=D|0,D>=i.length)throw new TypeError("invalid index");const u=i[Math.floor(i.length*Math.random())],h=[],g=[],b=[];for(const A of i){const T=s(A,u);T<0?h.push(A):T>0?g.push(A):b.push(A)}return D<h.length?y(D,h,s):D<h.length+b.length?b[0]:y(D-(h.length+b.length),g,s)}t.$yb=y;function O(D,i){const s=[];let u;for(const h of D.slice(0).sort(i))!u||i(u[0],h)!==0?(u=[h],s.push(u)):u.push(h);return s}t.$zb=O;function*r(D,i){let s,u;for(const h of D)u!==void 0&&i(u,h)?s.push(h):(s&&(yield s),s=[h]),u=h;s&&(yield s)}t.$Ab=r;function l(D,i){for(let s=0;s<=D.length;s++)i(s===0?void 0:D[s-1],s===D.length?void 0:D[s])}t.$Bb=l;function e(D,i){for(let s=0;s<D.length;s++)i(s===0?void 0:D[s-1],D[s],s+1===D.length?void 0:D[s+1])}t.$Cb=e;function c(D,i,s){const u=[];function h(A,T,_){if(T===0&&_.length===0)return;const x=u[u.length-1];x&&x.start+x.deleteCount===A?(x.deleteCount+=T,x.toInsert.push(..._)):u.push({start:A,deleteCount:T,toInsert:_})}let g=0,b=0;for(;;){if(g===D.length){h(g,0,i.slice(b));break}if(b===i.length){h(g,D.length-g,[]);break}const A=D[g],T=i[b],_=s(A,T);_===0?(g+=1,b+=1):_<0?(h(g,1,[]),g+=1):_>0&&(h(g,0,[T]),b+=1)}return u}t.$Db=c;function d(D,i,s){const u=c(D,i,s),h=[],g=[];for(const b of u)h.push(...D.slice(b.start,b.start+b.deleteCount)),g.push(...b.toInsert);return{removed:h,added:g}}t.$Eb=d;function p(D,i,s){if(s===0)return[];const u=D.slice(0,s).sort(i);return a(D,i,u,s,D.length),u}t.top=p;function o(D,i,s,u,h){return s===0?Promise.resolve([]):new Promise((g,b)=>{(async()=>{const A=D.length,T=D.slice(0,s).sort(i);for(let _=s,x=Math.min(s+u,A);_<A;_=x,x=Math.min(x+u,A)){if(_>s&&await new Promise(ee=>setTimeout(ee)),h&&h.isCancellationRequested)throw new S.$5;a(D,i,T,_,x)}return T})().then(g,b)})}t.$Gb=o;function a(D,i,s,u,h){for(const g=s.length;u<h;u++){const b=D[u];if(i(b,s[g-1])<0){s.pop();const A=(0,R.$kb)(s,T=>i(b,T)<0);s.splice(A,0,b)}}}function E(D){return D.filter(i=>!!i)}t.$Hb=E;function m(D){let i=0;for(let s=0;s<D.length;s++)D[s]&&(D[i]=D[s],i+=1);D.length=i}t.$Ib=m;function f(D,i,s){D.splice(s,0,D.splice(i,1)[0])}t.$Jb=f;function N(D){return!Array.isArray(D)||D.length===0}t.$Kb=N;function B(D){return Array.isArray(D)&&D.length>0}t.$Lb=B;function L(D,i=s=>s){const s=new Set;return D.filter(u=>{const h=i(u);return s.has(h)?!1:(s.add(h),!0)})}t.$Mb=L;function w(D){const i=new Set;return s=>{const u=D(s);return i.has(u)?!1:(i.add(u),!0)}}t.$Nb=w;function P(D,i){return D.length>0?D[0]:i}t.$Ob=P;function M(D,i){return D.length>0?D[D.length-1]:i}t.$Pb=M;function U(D,i,s=(u,h)=>u===h){let u=0;for(let h=0,g=Math.min(D.length,i.length);h<g&&s(D[h],i[h]);h++)u++;return u}t.$Qb=U;function V(D){return[].concat(...D)}t.$Rb=V;function F(D,i){let s=typeof i=="number"?D:0;typeof i=="number"?s=D:(s=0,i=D);const u=[];if(s<=i)for(let h=s;h<i;h++)u.push(h);else for(let h=s;h>i;h--)u.push(h);return u}t.$Sb=F;function I(D,i,s){return D.reduce((u,h)=>(u[i(h)]=s?s(h):h,u),Object.create(null))}t.$Tb=I;function z(D,i){return D.push(i),()=>X(D,i)}t.$Ub=z;function X(D,i){const s=D.indexOf(i);if(s>-1)return D.splice(s,1),i}t.$Vb=X;function G(D,i,s){const u=D.slice(0,i),h=D.slice(i);return u.concat(s,h)}t.$Wb=G;function re(D,i){let s;if(typeof i=="number"){let u=i;s=()=>{const h=Math.sin(u++)*179426549;return h-Math.floor(h)}}else s=Math.random;for(let u=D.length-1;u>0;u-=1){const h=Math.floor(s()*(u+1)),g=D[u];D[u]=D[h],D[h]=g}}t.$Xb=re;function ie(D,i){const s=D.indexOf(i);s>-1&&(D.splice(s,1),D.unshift(i))}t.$Yb=ie;function te(D,i){const s=D.indexOf(i);s>-1&&(D.splice(s,1),D.push(i))}t.$Zb=te;function $e(D,i){for(const s of i)D.push(s)}t.$1b=$e;function Fe(D,i){return Array.isArray(D)?D.map(i):i(D)}t.$2b=Fe;function ke(D){return Array.isArray(D)?D:[D]}t.$3b=ke;function Le(D){return D[Math.floor(Math.random()*D.length)]}t.$4b=Le;function ae(D,i,s){const u=le(D,i),h=D.length,g=s.length;D.length=h+g;for(let b=h-1;b>=u;b--)D[b+g]=D[b];for(let b=0;b<g;b++)D[b+u]=s[b]}t.$5b=ae;function J(D,i,s,u){const h=le(D,i);let g=D.splice(h,s);return g===void 0&&(g=[]),ae(D,h,u),g}t.$6b=J;function le(D,i){return i<0?Math.max(i+D.length,0):Math.min(i,D.length)}var K;(function(D){function i(g){return g<0}D.isLessThan=i;function s(g){return g<=0}D.isLessThanOrEqual=s;function u(g){return g>0}D.isGreaterThan=u;function h(g){return g===0}D.isNeitherLessOrGreaterThan=h,D.greaterThan=1,D.lessThan=-1,D.neitherLessOrGreaterThan=0})(K||(t.CompareResult=K={}));function H(D,i){return(s,u)=>i(D(s),D(u))}t.$7b=H;function Y(...D){return(i,s)=>{for(const u of D){const h=u(i,s);if(!K.isNeitherLessOrGreaterThan(h))return h}return K.neitherLessOrGreaterThan}}t.$8b=Y;const be=(D,i)=>D-i;t.$9b=be;const we=(D,i)=>(0,t.$9b)(D?1:0,i?1:0);t.$0b=we;function Ce(D){return(i,s)=>-D(i,s)}t.$$b=Ce;class Ae{constructor(i){this.g=i,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(i){let s=this.c;for(;s<this.g.length&&i(this.g[s]);)s++;const u=s===this.c?null:this.g.slice(this.c,s);return this.c=s,u}takeFromEndWhile(i){let s=this.d;for(;s>=0&&i(this.g[s]);)s--;const u=s===this.d?null:this.g.slice(s+1,this.d+1);return this.d=s,u}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const i=this.g[this.c];return this.c++,i}removeLast(){const i=this.g[this.d];return this.d--,i}takeCount(i){const s=this.g.slice(this.c,this.c+i);return this.c+=i,s}}t.$_b=Ae;class ce{static{this.empty=new ce(i=>{})}constructor(i){this.iterate=i}forEach(i){this.iterate(s=>(i(s),!0))}toArray(){const i=[];return this.iterate(s=>(i.push(s),!0)),i}filter(i){return new ce(s=>this.iterate(u=>i(u)?s(u):!0))}map(i){return new ce(s=>this.iterate(u=>s(i(u))))}some(i){let s=!1;return this.iterate(u=>(s=i(u),!s)),s}findFirst(i){let s;return this.iterate(u=>i(u)?(s=u,!1):!0),s}findLast(i){let s;return this.iterate(u=>(i(u)&&(s=u),!0)),s}findLastMaxBy(i){let s,u=!0;return this.iterate(h=>((u||K.isGreaterThan(i(h,s)))&&(u=!1,s=h),!0)),s}}t.$ac=ce}),define(ge[76],me([1,0,6]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=t.$7c=t.$6c=t.$5c=t.ok=void 0;function R($,v){if(!$)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}t.ok=R;function n($,v="Unreachable"){throw new Error(v)}t.$5c=n;function j($){if(!$)throw new S.$cb("Assertion Failed")}t.$6c=j;function k($){if(!$()){debugger;$(),(0,S.$1)(new S.$cb("Assertion Failed"))}}t.$7c=k;function C($,v){let y=0;for(;y<$.length-1;){const O=$[y],r=$[y+1];if(!v(O,r))return!1;y++}return!0}t.$8c=C}),define(ge[43],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function S(R,n){const j=this;let k=!1,C;return function(){if(k)return C;if(k=!0,n)try{C=R.apply(j,arguments)}finally{n()}else C=R.apply(j,arguments);return C}}t.$db=S}),define(ge[77],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PM=t.$OM=void 0;class S{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$OM=S,t.$PM=new S("id#")}),define(ge[28],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var S;(function(R){function n(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}R.is=n;const j=Object.freeze([]);function k(){return j}R.empty=k;function*C(m){yield m}R.single=C;function $(m){return n(m)?m:C(m)}R.wrap=$;function v(m){return m||j}R.from=v;function*y(m){for(let f=m.length-1;f>=0;f--)yield m[f]}R.reverse=y;function O(m){return!m||m[Symbol.iterator]().next().done===!0}R.isEmpty=O;function r(m){return m[Symbol.iterator]().next().value}R.first=r;function l(m,f){for(const N of m)if(f(N))return!0;return!1}R.some=l;function e(m,f){for(const N of m)if(f(N))return N}R.find=e;function*c(m,f){for(const N of m)f(N)&&(yield N)}R.filter=c;function*d(m,f){let N=0;for(const B of m)yield f(B,N++)}R.map=d;function*p(...m){for(const f of m)yield*f}R.concat=p;function o(m,f,N){let B=N;for(const L of m)B=f(B,L);return B}R.reduce=o;function*a(m,f,N=m.length){for(f<0&&(f+=m.length),N<0?N+=m.length:N>m.length&&(N=m.length);f<N;f++)yield m[f]}R.slice=a;function E(m,f=Number.POSITIVE_INFINITY){const N=[];if(f===0)return[N,m];const B=m[Symbol.iterator]();for(let L=0;L<f;L++){const w=B.next();if(w.done)return[N,R.empty()];N.push(w.value)}return[N,{[Symbol.iterator](){return B}}]}R.consume=E})(S||(t.Iterable=S={}))}),define(ge[44],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qq=t.KeyMod=t.KeyCodeUtils=t.$Pq=t.$Oq=t.$Nq=t.$Mq=t.$Lq=t.ScanCode=t.KeyCode=void 0;var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(S||(t.KeyCode=S={}));var R;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(R||(t.ScanCode=R={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,d){this._keyCodeToStr[c]=d,this._strToKeyCode[d.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const j=new n,k=new n,C=new n;t.$Lq=new Array(230),t.$Mq={};const $=[],v=Object.create(null),y=Object.create(null);t.$Nq={lowerCaseToEnum:e=>y[e]||0,toEnum:e=>v[e]||0,toString:e=>$[e]||"None"},t.$Oq=[],t.$Pq=[];for(let e=0;e<=193;e++)t.$Oq[e]=-1;for(let e=0;e<=132;e++)t.$Pq[e]=-1;(function(){const e="",c=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],d=[],p=[];for(const o of c){const[a,E,m,f,N,B,L,w,P]=o;if(p[E]||(p[E]=!0,$[E]=m,v[m]=E,y[m.toLowerCase()]=E,a&&(t.$Oq[E]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.$Pq[f]=E))),!d[f]){if(d[f]=!0,!N)throw new Error(`String representation missing for key code ${f} around scan code ${m}`);j.define(f,N),k.define(f,w||N),C.define(f,P||w||N)}B&&(t.$Lq[B]=f),L&&(t.$Mq[L]=f)}t.$Pq[3]=46})();var O;(function(e){function c(m){return j.keyCodeToStr(m)}e.toString=c;function d(m){return j.strToKeyCode(m)}e.fromString=d;function p(m){return k.keyCodeToStr(m)}e.toUserSettingsUS=p;function o(m){return C.keyCodeToStr(m)}e.toUserSettingsGeneral=o;function a(m){return k.strToKeyCode(m)||C.strToKeyCode(m)}e.fromUserSettings=a;function E(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return j.keyCodeToStr(m)}e.toElectronAccelerator=E})(O||(t.KeyCodeUtils=O={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function l(e,c){const d=(c&65535)<<16>>>0;return(e|d)>>>0}t.$Qq=l}),define(ge[78],me([1,0,6]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xq=t.$Wq=t.$Vq=t.$Uq=t.$Tq=t.$Sq=t.$Rq=void 0;var R;(function(O){O[O.CtrlCmd=2048]="CtrlCmd",O[O.Shift=1024]="Shift",O[O.Alt=512]="Alt",O[O.WinCtrl=256]="WinCtrl",O[O.KeyCode=255]="KeyCode"})(R||(R={}));function n(O,r){if(typeof O=="number"){if(O===0)return null;const l=(O&65535)>>>0,e=(O&4294901760)>>>16;return e!==0?new $([j(l,r),j(e,r)]):new $([j(l,r)])}else{const l=[];for(let e=0;e<O.length;e++)l.push(j(O[e],r));return new $(l)}}t.$Rq=n;function j(O,r){const l=!!(O&2048),e=!!(O&256),c=r===2?e:l,d=!!(O&1024),p=!!(O&512),o=r===2?l:e,a=O&255;return new k(c,d,p,o,a)}t.$Sq=j;class k{constructor(r,l,e,c,d){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=c,this.keyCode=d}equals(r){return r instanceof k&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`K${r}${l}${e}${c}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new $([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Tq=k;class C{constructor(r,l,e,c,d){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=c,this.scanCode=d}equals(r){return r instanceof C&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`S${r}${l}${e}${c}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Uq=C;class ${constructor(r){if(r.length===0)throw(0,S.$7)("chords");this.chords=r}getHashCode(){let r="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(r+=";"),r+=this.chords[l].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(r.chords[l]))return!1;return!0}}t.$Vq=$;class v{constructor(r,l,e,c,d,p){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=c,this.keyLabel=d,this.keyAriaLabel=p}}t.$Wq=v;class y{}t.$Xq=y}),define(ge[23],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class S{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=S}),define(ge[45],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(j){this.element=j,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let j=this.a;for(;j!==S.Undefined;){const k=j.next;j.prev=S.Undefined,j.next=S.Undefined,j=k}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,k){const C=new S(j);if(this.a===S.Undefined)this.a=C,this.b=C;else if(k){const v=this.b;this.b=C,C.prev=v,v.next=C}else{const v=this.a;this.a=C,C.next=v,v.prev=C}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(C))}}shift(){if(this.a!==S.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==S.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==S.Undefined&&j.next!==S.Undefined){const k=j.prev;k.next=j.next,j.next.prev=k}else j.prev===S.Undefined&&j.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):j.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):j.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==S.Undefined;)yield j.element,j=j.next}}t.$3c=R}),define(ge[32],me([1,0]),function(ne,t){"use strict";var S,R,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function j(o,a,E){let m=o.get(a);return m===void 0&&(m=E,o.set(a,m)),m}t.$xc=j;function k(o){const a=[];return o.forEach((E,m)=>{a.push(`${m} => ${E}`)}),`Map(${o.size}) {${a.join(", ")}}`}t.$yc=k;function C(o){const a=[];return o.forEach(E=>{a.push(E)}),`Set(${o.size}) {${a.join(", ")}}`}t.$zc=C;class ${constructor(a,E){this.uri=a,this.value=E}}function v(o){return Array.isArray(o)}class y{static{this.a=a=>a.toString()}constructor(a,E){if(this[S]="ResourceMap",a instanceof y)this.b=new Map(a.b),this.c=E??y.a;else if(v(a)){this.b=new Map,this.c=E??y.a;for(const[m,f]of a)this.set(m,f)}else this.b=new Map,this.c=a??y.a}set(a,E){return this.b.set(this.c(a),new $(a,E)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,E){typeof E<"u"&&(a=a.bind(E));for(const[m,f]of this.b)a(f.value,f.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}t.$Ac=y;class O{constructor(a,E){this[R]="ResourceSet",!a||typeof a=="function"?this.a=new y(a):(this.a=new y(E),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,E){this.a.forEach((m,f)=>a.call(E,f,f,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=O;var r;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(r||(t.Touch=r={}));class l{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,E=0){const m=this.a.get(a);if(m)return E!==0&&this.j(m,E),m.value}set(a,E,m=0){let f=this.a.get(a);if(f)f.value=E,m!==0&&this.j(f,m);else{switch(f={key:a,value:E,next:void 0,previous:void 0},m){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(a,f),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const E=this.a.get(a);if(E)return this.a.delete(a),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,E){const m=this.e;let f=this.b;for(;f;){if(E?a.bind(E)(f.value,f.key,this):a(f.value,f.key,this),this.e!==m)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const a=this,E=this.e;let m=this.b;const f={[Symbol.iterator](){return f},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(m){const N={value:m.key,done:!1};return m=m.next,N}else return{value:void 0,done:!0}}};return f}values(){const a=this,E=this.e;let m=this.b;const f={[Symbol.iterator](){return f},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(m){const N={value:m.value,done:!1};return m=m.next,N}else return{value:void 0,done:!0}}};return f}entries(){const a=this,E=this.e;let m=this.b;const f={[Symbol.iterator](){return f},next(){if(a.e!==E)throw new Error("LinkedMap got modified during iteration.");if(m){const N={value:[m.key,m.value],done:!1};return m=m.next,N}else return{value:void 0,done:!0}}};return f}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let E=this.b,m=this.size;for(;E&&m>a;)this.a.delete(E.key),E=E.next,m--;this.b=E,this.d=m,E&&(E.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const E=a.next,m=a.previous;if(!E||!m)throw new Error("Invalid list");E.previous=m,m.next=E}a.next=void 0,a.previous=void 0,this.e++}j(a,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(a===this.b)return;const m=a.next,f=a.previous;a===this.c?(f.next=void 0,this.c=f):(m.previous=f,f.next=m),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(E===2){if(a===this.c)return;const m=a.next,f=a.previous;a===this.b?(m.previous=void 0,this.b=m):(m.previous=f,f.next=m),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((E,m)=>{a.push([m,E])}),a}fromJSON(a){this.clear();for(const[E,m]of a)this.set(E,m)}}t.$Cc=l;class e extends l{constructor(a,E=1){super(),this.k=a,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,E=2){return super.get(a,E)}peek(a){return super.get(a,0)}set(a,E){return super.set(a,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class c{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let E=this.a.get(a)||0;return E===0?!1:(E--,E===0?this.a.delete(a):this.a.set(a,E),!0)}has(a){return this.a.has(a)}}t.$Ec=c;class d{constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[E,m]of a)this.set(E,m)}clear(){this.a.clear(),this.b.clear()}set(a,E){this.a.set(a,E),this.b.set(E,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const E=this.a.get(a);return E===void 0?!1:(this.a.delete(a),this.b.delete(E),!0)}forEach(a,E){this.a.forEach((m,f)=>{a.call(E,m,f,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=d;class p{constructor(){this.a=new Map}add(a,E){let m=this.a.get(a);m||(m=new Set,this.a.set(a,m)),m.add(E)}delete(a,E){const m=this.a.get(a);m&&(m.delete(E),m.size===0&&this.a.delete(a))}forEach(a,E){const m=this.a.get(a);m&&m.forEach(E)}get(a){const E=this.a.get(a);return E||new Set}}t.$Gc=p}),define(ge[2],me([1,0,12,73,32,43,28]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const C=!1;let $=null;class v{constructor(){this.b=new Map}static{this.a=0}c(z){let X=this.b.get(z);return X||(X={parent:null,source:null,isSingleton:!1,value:z,idx:v.a++},this.b.set(z,X)),X}trackDisposable(z){const X=this.c(z);X.source||(X.source=new Error().stack)}setParent(z,X){const G=this.c(z);G.parent=X}markAsDisposed(z){this.b.delete(z)}markAsSingleton(z){this.c(z).isSingleton=!0}f(z,X){const G=X.get(z);if(G)return G;const re=z.parent?this.f(this.c(z.parent),X):z;return X.set(z,re),re}getTrackedDisposables(){const z=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,z).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(z=10,X){let G;if(X)G=X;else{const Fe=new Map,ke=[...this.b.values()].filter(ae=>ae.source!==null&&!this.f(ae,Fe).isSingleton);if(ke.length===0)return;const Le=new Set(ke.map(ae=>ae.value));if(G=ke.filter(ae=>!(ae.parent&&Le.has(ae.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function re(Fe){function ke(ae,J){for(;ae.length>0&&J.some(le=>typeof le=="string"?le===ae[0]:ae[0].match(le));)ae.shift()}const Le=Fe.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return ke(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const ie=new n.$Gc;for(const Fe of G){const ke=re(Fe);for(let Le=0;Le<=ke.length;Le++)ie.add(ke.slice(0,Le).join(`
`),Fe)}G.sort((0,S.$7b)(Fe=>Fe.idx,S.$9b));let te="",$e=0;for(const Fe of G.slice(0,z)){$e++;const ke=re(Fe),Le=[];for(let ae=0;ae<ke.length;ae++){let J=ke[ae];J=`(shared with ${ie.get(ke.slice(0,ae+1).join(`
`)).size}/${G.length} leaks) at ${J}`;const K=ie.get(ke.slice(0,ae).join(`
`)),H=(0,R.$K)([...K].map(Y=>re(Y)[ae]),Y=>Y);delete H[ke[ae]];for(const[Y,be]of Object.entries(H))Le.unshift(`    - stacktraces of ${be.length} other leaks continue with ${Y}`);Le.unshift(J)}te+=`


==================== Leaking disposable ${$e}/${G.length}: ${Fe.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return G.length>z&&(te+=`


... and ${G.length-z} more leaking disposables

`),{leaks:G,details:te}}}t.$Hc=v;function y(I){$=I}if(t.$Ic=y,C){const I="__is_disposable_tracked__";y(new class{trackDisposable(z){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{z[I]||console.log(X)},3e3)}setParent(z,X){if(z&&z!==f.None)try{z[I]=!0}catch{}}markAsDisposed(z){if(z&&z!==f.None)try{z[I]=!0}catch{}}markAsSingleton(z){}})}function O(I){return $?.trackDisposable(I),I}t.$Jc=O;function r(I){$?.markAsDisposed(I)}t.$Kc=r;function l(I,z){$?.setParent(I,z)}function e(I,z){if($)for(const X of I)$.setParent(X,z)}function c(I){return $?.markAsSingleton(I),I}t.$Lc=c;function d(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Mc=d;function p(I){if(k.Iterable.is(I)){const z=[];for(const X of I)if(X)try{X.dispose()}catch(G){z.push(G)}if(z.length===1)throw z[0];if(z.length>1)throw new AggregateError(z,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Nc=p;function o(I){for(const z of I)d(z)&&z.dispose();return[]}t.$Oc=o;function a(...I){const z=E(()=>p(I));return e(I,z),z}t.$Pc=a;function E(I){const z=O({dispose:(0,j.$db)(()=>{r(z),I()})});return z}t.$Qc=E;class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,O(this)}dispose(){this.g||(r(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{p(this.f)}finally{this.f.clear()}}add(z){if(!z)return z;if(z===this)throw new Error("Cannot register a disposable on itself!");return l(z,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(z),z}delete(z){if(z){if(z===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(z),z.dispose()}}deleteAndLeak(z){z&&this.f.has(z)&&(this.f.delete(z),l(z,null))}}t.$Rc=m;class f{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,O(this),l(this.q,this)}dispose(){r(this),this.q.dispose()}B(z){if(z===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(z)}}t.$Sc=f;class N{constructor(){this.b=!1,O(this)}get value(){return this.b?void 0:this.a}set value(z){this.b||z===this.a||(this.a?.dispose(),z&&l(z,this),this.a=z)}clear(){this.value=void 0}dispose(){this.b=!0,r(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const z=this.a;return this.a=void 0,z&&l(z,null),z}}t.$Tc=N;class B{constructor(z){this.a=new N,this.b=!1,this.a.value=z}get value(){return this.a.value}set value(z){this.b||z===this.a.value||(this.a.value=z)}dispose(){this.b=!0,this.a.dispose()}}t.$Uc=B;class L{constructor(z){this.b=z,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Vc=L;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,O(this)}set(z){let X=z;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,r(this))},this}}t.$Wc=w;class P{constructor(){this.a=new Map}acquire(z,...X){let G=this.a.get(z);G||(G={counter:0,object:this.b(z,...X)},this.a.set(z,G));const{object:re}=G,ie=(0,j.$db)(()=>{--G.counter===0&&(this.c(z,G.object),this.a.delete(z))});return G.counter++,{object:re,dispose:ie}}}t.$Xc=P;class M{constructor(z){this.a=z}async acquire(z,...X){const G=this.a.acquire(z,...X);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(re){throw G.dispose(),re}}}t.$Yc=M;class U{constructor(z){this.object=z}dispose(){}}t.$Zc=U;function V(I){const z=new m;try{I(z)}finally{z.dispose()}}t.$1c=V;class F{constructor(){this.a=new Map,this.b=!1,O(this)}dispose(){r(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(z){return this.a.has(z)}get size(){return this.a.size}get(z){return this.a.get(z)}set(z,X,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(z)?.dispose(),this.a.set(z,X)}deleteAndDispose(z){this.a.get(z)?.dispose(),this.a.delete(z)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$2c=F}),function(ne,t){typeof define=="function"&&define.amd?define(ge[79],me([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(i,s){for(var u=0;u<s.length;u++){var h=s[u];h.enumerable=h.enumerable||!1,h.configurable=!0,"value"in h&&(h.writable=!0),Object.defineProperty(i,h.key,h)}}function S(i,s,u){return s&&t(i.prototype,s),u&&t(i,u),Object.defineProperty(i,"prototype",{writable:!1}),i}function R(i,s){if(i){if(typeof i=="string")return n(i,s);var u=Object.prototype.toString.call(i).slice(8,-1);if(u==="Object"&&i.constructor&&(u=i.constructor.name),u==="Map"||u==="Set")return Array.from(i);if(u==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(u))return n(i,s)}}function n(i,s){(s==null||s>i.length)&&(s=i.length);for(var u=0,h=new Array(s);u<s;u++)h[u]=i[u];return h}function j(i,s){var u=typeof Symbol<"u"&&i[Symbol.iterator]||i["@@iterator"];if(u)return(u=u.call(i)).next.bind(u);if(Array.isArray(i)||(u=R(i))||s&&i&&typeof i.length=="number"){u&&(i=u);var h=0;return function(){return h>=i.length?{done:!0}:{done:!1,value:i[h++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=k();function C(i){ne.defaults=i}var $=/[&<>"']/,v=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,O=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(s){return r[s]};function e(i,s){if(s){if($.test(i))return i.replace(v,l)}else if(y.test(i))return i.replace(O,l);return i}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(i){return i.replace(c,function(s,u){return u=u.toLowerCase(),u==="colon"?":":u.charAt(0)==="#"?u.charAt(1)==="x"?String.fromCharCode(parseInt(u.substring(2),16)):String.fromCharCode(+u.substring(1)):""})}var p=/(^|[^\[])\^/g;function o(i,s){i=typeof i=="string"?i:i.source,s=s||"";var u={replace:function(g,b){return b=b.source||b,b=b.replace(p,"$1"),i=i.replace(g,b),u},getRegex:function(){return new RegExp(i,s)}};return u}var a=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(i,s,u){if(i){var h;try{h=decodeURIComponent(d(u)).replace(a,"").toLowerCase()}catch{return null}if(h.indexOf("javascript:")===0||h.indexOf("vbscript:")===0||h.indexOf("data:")===0)return null}s&&!E.test(u)&&(u=w(s,u));try{u=encodeURI(u).replace(/%25/g,"%")}catch{return null}return u}var f={},N=/^[^:]+:\/*[^/]*$/,B=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(i,s){f[" "+i]||(N.test(i)?f[" "+i]=i+"/":f[" "+i]=V(i,"/",!0)),i=f[" "+i];var u=i.indexOf(":")===-1;return s.substring(0,2)==="//"?u?s:i.replace(B,"$1")+s:s.charAt(0)==="/"?u?s:i.replace(L,"$1")+s:i+s}var P={exec:function(){}};function M(i){for(var s=1,u,h;s<arguments.length;s++){u=arguments[s];for(h in u)Object.prototype.hasOwnProperty.call(u,h)&&(i[h]=u[h])}return i}function U(i,s){var u=i.replace(/\|/g,function(b,A,T){for(var _=!1,x=A;--x>=0&&T[x]==="\\";)_=!_;return _?"|":" |"}),h=u.split(/ \|/),g=0;if(h[0].trim()||h.shift(),h.length>0&&!h[h.length-1].trim()&&h.pop(),h.length>s)h.splice(s);else for(;h.length<s;)h.push("");for(;g<h.length;g++)h[g]=h[g].trim().replace(/\\\|/g,"|");return h}function V(i,s,u){var h=i.length;if(h===0)return"";for(var g=0;g<h;){var b=i.charAt(h-g-1);if(b===s&&!u)g++;else if(b!==s&&u)g++;else break}return i.slice(0,h-g)}function F(i,s){if(i.indexOf(s[1])===-1)return-1;for(var u=i.length,h=0,g=0;g<u;g++)if(i[g]==="\\")g++;else if(i[g]===s[0])h++;else if(i[g]===s[1]&&(h--,h<0))return g;return-1}function I(i){i&&i.sanitize&&!i.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(i,s){if(s<1)return"";for(var u="";s>1;)s&1&&(u+=i),s>>=1,i+=i;return u+i}function X(i,s,u,h){var g=s.href,b=s.title?e(s.title):null,A=i[1].replace(/\\([\[\]])/g,"$1");if(i[0].charAt(0)!=="!"){h.state.inLink=!0;var T={type:"link",raw:u,href:g,title:b,text:A,tokens:h.inlineTokens(A)};return h.state.inLink=!1,T}return{type:"image",raw:u,href:g,title:b,text:e(A)}}function G(i,s){var u=i.match(/^(\s+)(?:```)/);if(u===null)return s;var h=u[1];return s.split(`
`).map(function(g){var b=g.match(/^\s+/);if(b===null)return g;var A=b[0];return A.length>=h.length?g.slice(h.length):g}).join(`
`)}var re=function(){function i(u){this.options=u||ne.defaults}var s=i.prototype;return s.space=function(h){var g=this.rules.block.newline.exec(h);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},s.code=function(h){var g=this.rules.block.code.exec(h);if(g){var b=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?b:V(b,`
`)}}},s.fences=function(h){var g=this.rules.block.fences.exec(h);if(g){var b=g[0],A=G(b,g[3]||"");return{type:"code",raw:b,lang:g[2]?g[2].trim():g[2],text:A}}},s.heading=function(h){var g=this.rules.block.heading.exec(h);if(g){var b=g[2].trim();if(/#$/.test(b)){var A=V(b,"#");(this.options.pedantic||!A||/ $/.test(A))&&(b=A.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:b,tokens:this.lexer.inline(b)}}},s.hr=function(h){var g=this.rules.block.hr.exec(h);if(g)return{type:"hr",raw:g[0]}},s.blockquote=function(h){var g=this.rules.block.blockquote.exec(h);if(g){var b=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(b,[]),text:b}}},s.list=function(h){var g=this.rules.block.list.exec(h);if(g){var b,A,T,_,x,ee,fe,he,ye,De,pe,Ie,Te=g[1].trim(),Ye=Te.length>1,He={type:"list",raw:"",ordered:Ye,start:Ye?+Te.slice(0,-1):"",loose:!1,items:[]};Te=Ye?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=Ye?Te:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");h&&(Ie=!1,!(!(g=Me.exec(h))||this.rules.block.hr.test(h)));){if(b=g[0],h=h.substring(b.length),he=g[2].split(`
`,1)[0],ye=h.split(`
`,1)[0],this.options.pedantic?(_=2,pe=he.trimLeft()):(_=g[2].search(/[^ ]/),_=_>4?1:_,pe=he.slice(_),_+=g[1].length),ee=!1,!he&&/^ *$/.test(ye)&&(b+=ye+`
`,h=h.substring(ye.length+1),Ie=!0),!Ie)for(var Ve=new RegExp("^ {0,"+Math.min(3,_-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Q=new RegExp("^ {0,"+Math.min(3,_-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,_-1)+"}(?:```|~~~)"),de=new RegExp("^ {0,"+Math.min(3,_-1)+"}#");h&&(De=h.split(`
`,1)[0],he=De,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(he)||de.test(he)||Ve.test(he)||Q.test(h)));){if(he.search(/[^ ]/)>=_||!he.trim())pe+=`
`+he.slice(_);else if(!ee)pe+=`
`+he;else break;!ee&&!he.trim()&&(ee=!0),b+=De+`
`,h=h.substring(De.length+1)}He.loose||(fe?He.loose=!0:/\n *\n *$/.test(b)&&(fe=!0)),this.options.gfm&&(A=/^\[[ xX]\] /.exec(pe),A&&(T=A[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:b,task:!!A,checked:T,loose:!1,text:pe}),He.raw+=b}He.items[He.items.length-1].raw=b.trimRight(),He.items[He.items.length-1].text=pe.trimRight(),He.raw=He.raw.trimRight();var Ee=He.items.length;for(x=0;x<Ee;x++){this.lexer.state.top=!1,He.items[x].tokens=this.lexer.blockTokens(He.items[x].text,[]);var Pe=He.items[x].tokens.filter(function(Ue){return Ue.type==="space"}),ze=Pe.every(function(Ue){for(var Je=Ue.raw.split(""),Ze=0,Ke=j(Je),_e;!(_e=Ke()).done;){var tt=_e.value;if(tt===`
`&&(Ze+=1),Ze>1)return!0}return!1});!He.loose&&Pe.length&&ze&&(He.loose=!0,He.items[x].loose=!0)}return He}},s.html=function(h){var g=this.rules.block.html.exec(h);if(g){var b={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var A=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);b.type="paragraph",b.text=A,b.tokens=this.lexer.inline(A)}return b}},s.def=function(h){var g=this.rules.block.def.exec(h);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var b=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:b,raw:g[0],href:g[2],title:g[3]}}},s.table=function(h){var g=this.rules.block.table.exec(h);if(g){var b={type:"table",header:U(g[1]).map(function(fe){return{text:fe}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(b.header.length===b.align.length){b.raw=g[0];var A=b.align.length,T,_,x,ee;for(T=0;T<A;T++)/^ *-+: *$/.test(b.align[T])?b.align[T]="right":/^ *:-+: *$/.test(b.align[T])?b.align[T]="center":/^ *:-+ *$/.test(b.align[T])?b.align[T]="left":b.align[T]=null;for(A=b.rows.length,T=0;T<A;T++)b.rows[T]=U(b.rows[T],b.header.length).map(function(fe){return{text:fe}});for(A=b.header.length,_=0;_<A;_++)b.header[_].tokens=this.lexer.inline(b.header[_].text);for(A=b.rows.length,_=0;_<A;_++)for(ee=b.rows[_],x=0;x<ee.length;x++)ee[x].tokens=this.lexer.inline(ee[x].text);return b}}},s.lheading=function(h){var g=this.rules.block.lheading.exec(h);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},s.paragraph=function(h){var g=this.rules.block.paragraph.exec(h);if(g){var b=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:b,tokens:this.lexer.inline(b)}}},s.text=function(h){var g=this.rules.block.text.exec(h);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},s.escape=function(h){var g=this.rules.inline.escape.exec(h);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},s.tag=function(h){var g=this.rules.inline.tag.exec(h);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},s.link=function(h){var g=this.rules.inline.link.exec(h);if(g){var b=g[2].trim();if(!this.options.pedantic&&/^</.test(b)){if(!/>$/.test(b))return;var A=V(b.slice(0,-1),"\\");if((b.length-A.length)%2===0)return}else{var T=F(g[2],"()");if(T>-1){var _=g[0].indexOf("!")===0?5:4,x=_+g[1].length+T;g[2]=g[2].substring(0,T),g[0]=g[0].substring(0,x).trim(),g[3]=""}}var ee=g[2],fe="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);he&&(ee=he[1],fe=he[3])}else fe=g[3]?g[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(b)?ee=ee.slice(1):ee=ee.slice(1,-1)),X(g,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},s.reflink=function(h,g){var b;if((b=this.rules.inline.reflink.exec(h))||(b=this.rules.inline.nolink.exec(h))){var A=(b[2]||b[1]).replace(/\s+/g," ");if(A=g[A.toLowerCase()],!A||!A.href){var T=b[0].charAt(0);return{type:"text",raw:T,text:T}}return X(b,A,b[0],this.lexer)}},s.emStrong=function(h,g,b){b===void 0&&(b="");var A=this.rules.inline.emStrong.lDelim.exec(h);if(A&&!(A[3]&&b.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var T=A[1]||A[2]||"";if(!T||T&&(b===""||this.rules.inline.punctuation.exec(b))){var _=A[0].length-1,x,ee,fe=_,he=0,ye=A[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ye.lastIndex=0,g=g.slice(-1*h.length+_);(A=ye.exec(g))!=null;)if(x=A[1]||A[2]||A[3]||A[4]||A[5]||A[6],!!x){if(ee=x.length,A[3]||A[4]){fe+=ee;continue}else if((A[5]||A[6])&&_%3&&!((_+ee)%3)){he+=ee;continue}if(fe-=ee,!(fe>0)){if(ee=Math.min(ee,ee+fe+he),Math.min(_,ee)%2){var De=h.slice(1,_+A.index+ee);return{type:"em",raw:h.slice(0,_+A.index+ee+1),text:De,tokens:this.lexer.inlineTokens(De)}}var pe=h.slice(2,_+A.index+ee-1);return{type:"strong",raw:h.slice(0,_+A.index+ee+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},s.codespan=function(h){var g=this.rules.inline.code.exec(h);if(g){var b=g[2].replace(/\n/g," "),A=/[^ ]/.test(b),T=/^ /.test(b)&&/ $/.test(b);return A&&T&&(b=b.substring(1,b.length-1)),b=e(b,!0),{type:"codespan",raw:g[0],text:b}}},s.br=function(h){var g=this.rules.inline.br.exec(h);if(g)return{type:"br",raw:g[0]}},s.del=function(h){var g=this.rules.inline.del.exec(h);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},s.autolink=function(h,g){var b=this.rules.inline.autolink.exec(h);if(b){var A,T;return b[2]==="@"?(A=e(this.options.mangle?g(b[1]):b[1]),T="mailto:"+A):(A=e(b[1]),T=A),{type:"link",raw:b[0],text:A,href:T,tokens:[{type:"text",raw:A,text:A}]}}},s.url=function(h,g){var b;if(b=this.rules.inline.url.exec(h)){var A,T;if(b[2]==="@")A=e(this.options.mangle?g(b[0]):b[0]),T="mailto:"+A;else{var _;do _=b[0],b[0]=this.rules.inline._backpedal.exec(b[0])[0];while(_!==b[0]);A=e(b[0]),b[1]==="www."?T="http://"+A:T=A}return{type:"link",raw:b[0],text:A,href:T,tokens:[{type:"text",raw:A,text:A}]}}},s.inlineText=function(h,g){var b=this.rules.inline.text.exec(h);if(b){var A;return this.lexer.state.inRawBlock?A=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(b[0]):e(b[0]):b[0]:A=e(this.options.smartypants?g(b[0]):b[0]),{type:"text",raw:b[0],text:A}}},i}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:P,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=o(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=o(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=o(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=o(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=o(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=o(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=M({},ie),ie.gfm=M({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=o(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=o(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=M({},ie.normal,{html:o(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:P,paragraph:o(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:P,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:P,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=o(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=o(ie._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=o(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=o(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=o(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=o(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=o(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=o(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=o(te.reflink).replace("label",te._label).replace("ref",ie._label).getRegex(),te.nolink=o(te.nolink).replace("ref",ie._label).getRegex(),te.reflinkSearch=o(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=M({},te),te.pedantic=M({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:o(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:o(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=M({},te.normal,{escape:o(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=o(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=M({},te.gfm,{br:o(te.br).replace("{2,}","*").getRegex(),text:o(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $e(i){return i.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Fe(i){var s="",u,h,g=i.length;for(u=0;u<g;u++)h=i.charCodeAt(u),Math.random()>.5&&(h="x"+h.toString(16)),s+="&#"+h+";";return s}var ke=function(){function i(u){this.tokens=[],this.tokens.links=Object.create(null),this.options=u||ne.defaults,this.options.tokenizer=this.options.tokenizer||new re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var h={block:ie.normal,inline:te.normal};this.options.pedantic?(h.block=ie.pedantic,h.inline=te.pedantic):this.options.gfm&&(h.block=ie.gfm,this.options.breaks?h.inline=te.breaks:h.inline=te.gfm),this.tokenizer.rules=h}i.lex=function(h,g){var b=new i(g);return b.lex(h)},i.lexInline=function(h,g){var b=new i(g);return b.inlineTokens(h)};var s=i.prototype;return s.lex=function(h){h=h.replace(/\r\n|\r/g,`
`),this.blockTokens(h,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},s.blockTokens=function(h,g){var b=this;g===void 0&&(g=[]),this.options.pedantic?h=h.replace(/\t/g,"    ").replace(/^ +$/gm,""):h=h.replace(/^( *)(\t+)/gm,function(fe,he,ye){return he+"    ".repeat(ye.length)});for(var A,T,_,x;h;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(A=fe.call({lexer:b},h,g))?(h=h.substring(A.raw.length),g.push(A),!0):!1}))){if(A=this.tokenizer.space(h)){h=h.substring(A.raw.length),A.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(A);continue}if(A=this.tokenizer.code(h)){h=h.substring(A.raw.length),T=g[g.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+A.raw,T.text+=`
`+A.text,this.inlineQueue[this.inlineQueue.length-1].src=T.text):g.push(A);continue}if(A=this.tokenizer.fences(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.heading(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.hr(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.blockquote(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.list(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.html(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.def(h)){h=h.substring(A.raw.length),T=g[g.length-1],T&&(T.type==="paragraph"||T.type==="text")?(T.raw+=`
`+A.raw,T.text+=`
`+A.raw,this.inlineQueue[this.inlineQueue.length-1].src=T.text):this.tokens.links[A.tag]||(this.tokens.links[A.tag]={href:A.href,title:A.title});continue}if(A=this.tokenizer.table(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.lheading(h)){h=h.substring(A.raw.length),g.push(A);continue}if(_=h,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,he=h.slice(1),ye=void 0;b.options.extensions.startBlock.forEach(function(De){ye=De.call({lexer:this},he),typeof ye=="number"&&ye>=0&&(fe=Math.min(fe,ye))}),fe<1/0&&fe>=0&&(_=h.substring(0,fe+1))}(),this.state.top&&(A=this.tokenizer.paragraph(_))){T=g[g.length-1],x&&T.type==="paragraph"?(T.raw+=`
`+A.raw,T.text+=`
`+A.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):g.push(A),x=_.length!==h.length,h=h.substring(A.raw.length);continue}if(A=this.tokenizer.text(h)){h=h.substring(A.raw.length),T=g[g.length-1],T&&T.type==="text"?(T.raw+=`
`+A.raw,T.text+=`
`+A.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=T.text):g.push(A);continue}if(h){var ee="Infinite loop on byte: "+h.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,g},s.inline=function(h,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:h,tokens:g}),g},s.inlineTokens=function(h,g){var b=this;g===void 0&&(g=[]);var A,T,_,x=h,ee,fe,he;if(this.tokens.links){var ye=Object.keys(this.tokens.links);if(ye.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(x))!=null;)ye.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(x=x.slice(0,ee.index)+"["+z("a",ee[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(x))!=null;)x=x.slice(0,ee.index)+"["+z("a",ee[0].length-2)+"]"+x.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(x))!=null;)x=x.slice(0,ee.index)+"++"+x.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;h;)if(fe||(he=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(A=pe.call({lexer:b},h,g))?(h=h.substring(A.raw.length),g.push(A),!0):!1}))){if(A=this.tokenizer.escape(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.tag(h)){h=h.substring(A.raw.length),T=g[g.length-1],T&&A.type==="text"&&T.type==="text"?(T.raw+=A.raw,T.text+=A.text):g.push(A);continue}if(A=this.tokenizer.link(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.reflink(h,this.tokens.links)){h=h.substring(A.raw.length),T=g[g.length-1],T&&A.type==="text"&&T.type==="text"?(T.raw+=A.raw,T.text+=A.text):g.push(A);continue}if(A=this.tokenizer.emStrong(h,x,he)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.codespan(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.br(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.del(h)){h=h.substring(A.raw.length),g.push(A);continue}if(A=this.tokenizer.autolink(h,Fe)){h=h.substring(A.raw.length),g.push(A);continue}if(!this.state.inLink&&(A=this.tokenizer.url(h,Fe))){h=h.substring(A.raw.length),g.push(A);continue}if(_=h,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Ie=h.slice(1),Te=void 0;b.options.extensions.startInline.forEach(function(Ye){Te=Ye.call({lexer:this},Ie),typeof Te=="number"&&Te>=0&&(pe=Math.min(pe,Te))}),pe<1/0&&pe>=0&&(_=h.substring(0,pe+1))}(),A=this.tokenizer.inlineText(_,$e)){h=h.substring(A.raw.length),A.raw.slice(-1)!=="_"&&(he=A.raw.slice(-1)),fe=!0,T=g[g.length-1],T&&T.type==="text"?(T.raw+=A.raw,T.text+=A.text):g.push(A);continue}if(h){var De="Infinite loop on byte: "+h.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return g},S(i,null,[{key:"rules",get:function(){return{block:ie,inline:te}}}]),i}(),Le=function(){function i(u){this.options=u||ne.defaults}var s=i.prototype;return s.code=function(h,g,b){var A=(g||"").match(/\S*/)[0];if(this.options.highlight){var T=this.options.highlight(h,A);T!=null&&T!==h&&(b=!0,h=T)}return h=h.replace(/\n$/,"")+`
`,A?'<pre><code class="'+this.options.langPrefix+e(A,!0)+'">'+(b?h:e(h,!0))+`</code></pre>
`:"<pre><code>"+(b?h:e(h,!0))+`</code></pre>
`},s.blockquote=function(h){return`<blockquote>
`+h+`</blockquote>
`},s.html=function(h){return h},s.heading=function(h,g,b,A){if(this.options.headerIds){var T=this.options.headerPrefix+A.slug(b);return"<h"+g+' id="'+T+'">'+h+"</h"+g+`>
`}return"<h"+g+">"+h+"</h"+g+`>
`},s.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},s.list=function(h,g,b){var A=g?"ol":"ul",T=g&&b!==1?' start="'+b+'"':"";return"<"+A+T+`>
`+h+"</"+A+`>
`},s.listitem=function(h){return"<li>"+h+`</li>
`},s.checkbox=function(h){return"<input "+(h?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},s.paragraph=function(h){return"<p>"+h+`</p>
`},s.table=function(h,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+h+`</thead>
`+g+`</table>
`},s.tablerow=function(h){return`<tr>
`+h+`</tr>
`},s.tablecell=function(h,g){var b=g.header?"th":"td",A=g.align?"<"+b+' align="'+g.align+'">':"<"+b+">";return A+h+("</"+b+`>
`)},s.strong=function(h){return"<strong>"+h+"</strong>"},s.em=function(h){return"<em>"+h+"</em>"},s.codespan=function(h){return"<code>"+h+"</code>"},s.br=function(){return this.options.xhtml?"<br/>":"<br>"},s.del=function(h){return"<del>"+h+"</del>"},s.link=function(h,g,b){if(h=m(this.options.sanitize,this.options.baseUrl,h),h===null)return b;var A='<a href="'+e(h)+'"';return g&&(A+=' title="'+g+'"'),A+=">"+b+"</a>",A},s.image=function(h,g,b){if(h=m(this.options.sanitize,this.options.baseUrl,h),h===null)return b;var A='<img src="'+h+'" alt="'+b+'"';return g&&(A+=' title="'+g+'"'),A+=this.options.xhtml?"/>":">",A},s.text=function(h){return h},i}(),ae=function(){function i(){}var s=i.prototype;return s.strong=function(h){return h},s.em=function(h){return h},s.codespan=function(h){return h},s.del=function(h){return h},s.html=function(h){return h},s.text=function(h){return h},s.link=function(h,g,b){return""+b},s.image=function(h,g,b){return""+b},s.br=function(){return""},i}(),J=function(){function i(){this.seen={}}var s=i.prototype;return s.serialize=function(h){return h.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},s.getNextSafeSlug=function(h,g){var b=h,A=0;if(this.seen.hasOwnProperty(b)){A=this.seen[h];do A++,b=h+"-"+A;while(this.seen.hasOwnProperty(b))}return g||(this.seen[h]=A,this.seen[b]=0),b},s.slug=function(h,g){g===void 0&&(g={});var b=this.serialize(h);return this.getNextSafeSlug(b,g.dryrun)},i}(),le=function(){function i(u){this.options=u||ne.defaults,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ae,this.slugger=new J}i.parse=function(h,g){var b=new i(g);return b.parse(h)},i.parseInline=function(h,g){var b=new i(g);return b.parseInline(h)};var s=i.prototype;return s.parse=function(h,g){g===void 0&&(g=!0);var b="",A,T,_,x,ee,fe,he,ye,De,pe,Ie,Te,Ye,He,Me,Ve,Q,se,de,Ee=h.length;for(A=0;A<Ee;A++){if(pe=h[A],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(de=this.options.extensions.renderers[pe.type].call({parser:this},pe),de!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){b+=de||"";continue}switch(pe.type){case"space":continue;case"hr":{b+=this.renderer.hr();continue}case"heading":{b+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,d(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{b+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(ye="",he="",x=pe.header.length,T=0;T<x;T++)he+=this.renderer.tablecell(this.parseInline(pe.header[T].tokens),{header:!0,align:pe.align[T]});for(ye+=this.renderer.tablerow(he),De="",x=pe.rows.length,T=0;T<x;T++){for(fe=pe.rows[T],he="",ee=fe.length,_=0;_<ee;_++)he+=this.renderer.tablecell(this.parseInline(fe[_].tokens),{header:!1,align:pe.align[_]});De+=this.renderer.tablerow(he)}b+=this.renderer.table(ye,De);continue}case"blockquote":{De=this.parse(pe.tokens),b+=this.renderer.blockquote(De);continue}case"list":{for(Ie=pe.ordered,Te=pe.start,Ye=pe.loose,x=pe.items.length,De="",T=0;T<x;T++)Me=pe.items[T],Ve=Me.checked,Q=Me.task,He="",Me.task&&(se=this.renderer.checkbox(Ve),Ye?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=se+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=se+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:se}):He+=se),He+=this.parse(Me.tokens,Ye),De+=this.renderer.listitem(He,Q,Ve);b+=this.renderer.list(De,Ie,Te);continue}case"html":{b+=this.renderer.html(pe.text);continue}case"paragraph":{b+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(De=pe.tokens?this.parseInline(pe.tokens):pe.text;A+1<Ee&&h[A+1].type==="text";)pe=h[++A],De+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);b+=g?this.renderer.paragraph(De):De;continue}default:{var Pe='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return b},s.parseInline=function(h,g){g=g||this.renderer;var b="",A,T,_,x=h.length;for(A=0;A<x;A++){if(T=h[A],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[T.type]&&(_=this.options.extensions.renderers[T.type].call({parser:this},T),_!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(T.type))){b+=_||"";continue}switch(T.type){case"escape":{b+=g.text(T.text);break}case"html":{b+=g.html(T.text);break}case"link":{b+=g.link(T.href,T.title,this.parseInline(T.tokens,g));break}case"image":{b+=g.image(T.href,T.title,T.text);break}case"strong":{b+=g.strong(this.parseInline(T.tokens,g));break}case"em":{b+=g.em(this.parseInline(T.tokens,g));break}case"codespan":{b+=g.codespan(T.text);break}case"br":{b+=g.br();break}case"del":{b+=g.del(this.parseInline(T.tokens,g));break}case"text":{b+=g.text(T.text);break}default:{var ee='Token with "'+T.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return b},i}();function K(i,s,u){if(typeof i>"u"||i===null)throw new Error("marked(): input parameter is undefined or null");if(typeof i!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(i)+", string expected");if(typeof s=="function"&&(u=s,s=null),s=M({},K.defaults,s||{}),I(s),u){var h=s.highlight,g;try{g=ke.lex(i,s)}catch(x){return u(x)}var b=function(ee){var fe;if(!ee)try{s.walkTokens&&K.walkTokens(g,s.walkTokens),fe=le.parse(g,s)}catch(he){ee=he}return s.highlight=h,ee?u(ee):u(null,fe)};if(!h||h.length<3||(delete s.highlight,!g.length))return b();var A=0;K.walkTokens(g,function(x){x.type==="code"&&(A++,setTimeout(function(){h(x.text,x.lang,function(ee,fe){if(ee)return b(ee);fe!=null&&fe!==x.text&&(x.text=fe,x.escaped=!0),A--,A===0&&b()})},0))}),A===0&&b();return}function T(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,s.silent)return"<p>An error occurred:</p><pre>"+e(x.message+"",!0)+"</pre>";throw x}try{var _=ke.lex(i,s);if(s.walkTokens){if(s.async)return Promise.all(K.walkTokens(_,s.walkTokens)).then(function(){return le.parse(_,s)}).catch(T);K.walkTokens(_,s.walkTokens)}return le.parse(_,s)}catch(x){T(x)}}K.options=K.setOptions=function(i){return M(K.defaults,i),C(K.defaults),K},K.getDefaults=k,K.defaults=ne.defaults,K.use=function(){for(var i=arguments.length,s=new Array(i),u=0;u<i;u++)s[u]=arguments[u];var h=M.apply(void 0,[{}].concat(s)),g=K.defaults.extensions||{renderers:{},childTokens:{}},b;s.forEach(function(A){if(A.extensions&&(b=!0,A.extensions.forEach(function(_){if(!_.name)throw new Error("extension name required");if(_.renderer){var x=g.renderers?g.renderers[_.name]:null;x?g.renderers[_.name]=function(){for(var ee=arguments.length,fe=new Array(ee),he=0;he<ee;he++)fe[he]=arguments[he];var ye=_.renderer.apply(this,fe);return ye===!1&&(ye=x.apply(this,fe)),ye}:g.renderers[_.name]=_.renderer}if(_.tokenizer){if(!_.level||_.level!=="block"&&_.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[_.level]?g[_.level].unshift(_.tokenizer):g[_.level]=[_.tokenizer],_.start&&(_.level==="block"?g.startBlock?g.startBlock.push(_.start):g.startBlock=[_.start]:_.level==="inline"&&(g.startInline?g.startInline.push(_.start):g.startInline=[_.start]))}_.childTokens&&(g.childTokens[_.name]=_.childTokens)})),A.renderer&&function(){var _=K.defaults.renderer||new Le,x=function(he){var ye=_[he];_[he]=function(){for(var De=arguments.length,pe=new Array(De),Ie=0;Ie<De;Ie++)pe[Ie]=arguments[Ie];var Te=A.renderer[he].apply(_,pe);return Te===!1&&(Te=ye.apply(_,pe)),Te}};for(var ee in A.renderer)x(ee);h.renderer=_}(),A.tokenizer&&function(){var _=K.defaults.tokenizer||new re,x=function(he){var ye=_[he];_[he]=function(){for(var De=arguments.length,pe=new Array(De),Ie=0;Ie<De;Ie++)pe[Ie]=arguments[Ie];var Te=A.tokenizer[he].apply(_,pe);return Te===!1&&(Te=ye.apply(_,pe)),Te}};for(var ee in A.tokenizer)x(ee);h.tokenizer=_}(),A.walkTokens){var T=K.defaults.walkTokens;h.walkTokens=function(_){var x=[];return x.push(A.walkTokens.call(this,_)),T&&(x=x.concat(T.call(this,_))),x}}b&&(h.extensions=g),K.setOptions(h)})},K.walkTokens=function(i,s){for(var u=[],h=function(){var T=b.value;switch(u=u.concat(s.call(K,T)),T.type){case"table":{for(var _=j(T.header),x;!(x=_()).done;){var ee=x.value;u=u.concat(K.walkTokens(ee.tokens,s))}for(var fe=j(T.rows),he;!(he=fe()).done;)for(var ye=he.value,De=j(ye),pe;!(pe=De()).done;){var Ie=pe.value;u=u.concat(K.walkTokens(Ie.tokens,s))}break}case"list":{u=u.concat(K.walkTokens(T.items,s));break}default:K.defaults.extensions&&K.defaults.extensions.childTokens&&K.defaults.extensions.childTokens[T.type]?K.defaults.extensions.childTokens[T.type].forEach(function(Te){u=u.concat(K.walkTokens(T[Te],s))}):T.tokens&&(u=u.concat(K.walkTokens(T.tokens,s)))}},g=j(i),b;!(b=g()).done;)h();return u},K.parseInline=function(i,s){if(typeof i>"u"||i===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof i!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(i)+", string expected");s=M({},K.defaults,s||{}),I(s);try{var u=ke.lexInline(i,s);return s.walkTokens&&K.walkTokens(u,s.walkTokens),le.parseInline(u,s)}catch(h){if(h.message+=`
Please report this to https://github.com/markedjs/marked.`,s.silent)return"<p>An error occurred:</p><pre>"+e(h.message+"",!0)+"</pre>";throw h}},K.Parser=le,K.parser=le.parse,K.Renderer=Le,K.TextRenderer=ae,K.Lexer=ke,K.lexer=ke.lex,K.Tokenizer=re,K.Slugger=J,K.parse=K;var H=K.options,Y=K.setOptions,be=K.use,we=K.walkTokens,Ce=K.parseInline,Ae=K,ce=le.parse,D=ke.lex;ne.Lexer=ke,ne.Parser=le,ne.Renderer=Le,ne.Slugger=J,ne.TextRenderer=ae,ne.Tokenizer=re,ne.getDefaults=k,ne.lexer=D,ne.marked=K,ne.options=H,ne.parse=Ae,ne.parseInline=Ce,ne.parser=ce,ne.setOptions=Y,ne.use=be,ne.walkTokens=we,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ge[80],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xS=void 0;class S{constructor(n,j=0,k=n.length,C=j-1){this.a=n,this.b=j,this.c=k,this.d=C}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$xS=S}),define(ge[81],me([1,0,80]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zS=t.$yS=void 0;class R{constructor(k=[],C=10){this.h(k),this.b=C,this.d()}getHistory(){return this.j}add(k){this.a.delete(k),this.a.add(k),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(k){return this.a.has(k)}clear(){this.h([]),this.d()}d(){this.f();const k=this.j;this.c=new S.$xS(k,0,k.length,k.length)}f(){const k=this.j;k.length>this.b&&this.h(k.slice(k.length-this.b))}g(){const k=this.c.current();return k?this.j.indexOf(k):-1}h(k){this.a=new Set;for(const C of k)this.a.add(C)}get j(){const k=[];return this.a.forEach(C=>k.push(C)),k}}t.$yS=R;class n{get size(){return this.f}constructor(k,C=10){if(this.g=C,k.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:k[0],previous:void 0,next:void 0},this.a=new Set([k[0]]);for(let $=1;$<k.length;$++)this.add(k[$])}add(k){const C={value:k,previous:this.c,next:void 0};for(this.c.next=C,this.c=C,this.d=this.c,this.f++,this.a.has(k)?this.h(k):this.a.add(k);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(k){if(this.c.value===k)return k;const C=this.c.value;return this.a.delete(C),this.c.value=k,this.a.has(k)?this.h(k):this.a.add(k),C}prepend(k){if(this.f===this.g||this.a.has(k))return;const C={value:k,previous:void 0,next:this.b};this.b.previous=C,this.b=C,this.f++,this.a.add(k)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(k){return this.a.has(k)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let k=this.b;for(;k;)yield k.value,k=k.next}h(k){let C=this.b;for(;C!==this.c;)C.value===k&&(C===this.b?(this.b=this.b.next,this.b.previous=void 0):(C.previous.next=C.next,C.next.previous=C.previous),this.f--),C=C.next}}t.$zS=n}),define(ge[46],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4l=t.$3l=t.$2l=t.rot=t.$Zl=void 0;function S(C,$,v){return Math.min(Math.max(C,$),v)}t.$Zl=S;function R(C,$){return($+C%$)%$}t.rot=R;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$2l=n;class j{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$3l=j;class k{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const v=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$4l=k}),define(ge[47],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var S;(function(R){function n($,v){if($.start>=v.end||v.start>=$.end)return{start:0,end:0};const y=Math.max($.start,v.start),O=Math.min($.end,v.end);return O-y<=0?{start:0,end:0}:{start:y,end:O}}R.intersect=n;function j($){return $.end-$.start<=0}R.isEmpty=j;function k($,v){return!j(n($,v))}R.intersects=k;function C($,v){const y=[],O={start:$.start,end:Math.min(v.start,$.end)},r={start:Math.max(v.end,$.start),end:$.end};return j(O)||y.push(O),j(r)||y.push(r),y}R.relativeComplement=C})(S||(t.Range=S={}))}),define(ge[82],me([1,0,47]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=t.$jR=t.$iR=void 0;function R($,v){const y=[];for(const O of v){if($.start>=O.range.end)continue;if($.end<O.range.start)break;const r=S.Range.intersect($,O.range);S.Range.isEmpty(r)||y.push({range:r,size:O.size})}return y}t.$iR=R;function n({start:$,end:v},y){return{start:$+y,end:v+y}}t.$jR=n;function j($){const v=[];let y=null;for(const O of $){const r=O.range.start,l=O.range.end,e=O.size;if(y&&e===y.size){y.range.end=l;continue}y={range:{start:r,end:l},size:e},v.push(y)}return v}t.$kR=j;function k(...$){return j($.reduce((v,y)=>v.concat(y),[]))}class C{get paddingTop(){return this.c}set paddingTop(v){this.b=this.b+v-this.c,this.c=v}constructor(v){this.a=[],this.b=0,this.c=0,this.c=v??0,this.b=this.c}splice(v,y,O=[]){const r=O.length-y,l=R({start:0,end:v},this.a),e=R({start:v+y,end:Number.POSITIVE_INFINITY},this.a).map(d=>({range:n(d.range,r),size:d.size})),c=O.map((d,p)=>({range:{start:v+p,end:v+p+1},size:d.size}));this.a=k(l,c,e),this.b=this.c+this.a.reduce((d,p)=>d+p.size*(p.range.end-p.range.start),0)}get count(){const v=this.a.length;return v?this.a[v-1].range.end:0}get size(){return this.b}indexAt(v){if(v<0)return-1;if(v<this.c)return 0;let y=0,O=this.c;for(const r of this.a){const l=r.range.end-r.range.start,e=O+l*r.size;if(v<e)return y+Math.floor((v-O)/r.size);y+=l,O=e}return y}indexAfter(v){return Math.min(this.indexAt(v)+1,this.count)}positionAt(v){if(v<0)return-1;let y=0,O=0;for(const r of this.a){const l=r.range.end-r.range.start,e=O+l;if(v<e)return this.c+y+(v-O)*r.size;y+=l*r.size,O=e}return-1}}t.$lR=C}),define(ge[83],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Od=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(j){return new R(j)}constructor(j){this.c=S&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Od=R}),define(ge[4],me([1,0,6,43,2,45,83]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.Event=void 0;const C=!1,$=!1;var v;(function(V){V.None=()=>n.$Sc.None;function F(g){if($){const{onDidAddListener:b}=g,A=e.create();let T=0;g.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),A.print()),b?.()}}}function I(g,b){return Le(g,()=>{},0,void 0,!0,void 0,b)}V.defer=I;function z(g){return(b,A=null,T)=>{let _=!1,x;return x=g(ee=>{if(!_)return x?x.dispose():_=!0,b.call(A,ee)},null,T),_&&x.dispose(),x}}V.once=z;function X(g,b,A){return Fe((T,_=null,x)=>g(ee=>T.call(_,b(ee)),null,x),A)}V.map=X;function G(g,b,A){return Fe((T,_=null,x)=>g(ee=>{b(ee),T.call(_,ee)},null,x),A)}V.forEach=G;function re(g,b,A){return Fe((T,_=null,x)=>g(ee=>b(ee)&&T.call(_,ee),null,x),A)}V.filter=re;function ie(g){return g}V.signal=ie;function te(...g){return(b,A=null,T)=>{const _=(0,n.$Pc)(...g.map(x=>x(ee=>b.call(A,ee))));return ke(_,T)}}V.any=te;function $e(g,b,A,T){let _=A;return X(g,x=>(_=b(_,x),_),T)}V.reduce=$e;function Fe(g,b){let A;const T={onWillAddFirstListener(){A=g(_.fire,_)},onDidRemoveLastListener(){A?.dispose()}};b||F(T);const _=new a(T);return b?.add(_),_.event}function ke(g,b){return b instanceof Array?b.push(g):b&&b.add(g),g}function Le(g,b,A=100,T=!1,_=!1,x,ee){let fe,he,ye,De=0,pe;const Ie={leakWarningThreshold:x,onWillAddFirstListener(){fe=g(Ye=>{De++,he=b(he,Ye),T&&!ye&&(Te.fire(he),he=void 0),pe=()=>{const He=he;he=void 0,ye=void 0,(!T||De>1)&&Te.fire(He),De=0},typeof A=="number"?(clearTimeout(ye),ye=setTimeout(pe,A)):ye===void 0&&(ye=0,queueMicrotask(pe))})},onWillRemoveListener(){_&&De>0&&pe?.()},onDidRemoveLastListener(){pe=void 0,fe.dispose()}};ee||F(Ie);const Te=new a(Ie);return ee?.add(Te),Te.event}V.debounce=Le;function ae(g,b=0,A){return V.debounce(g,(T,_)=>T?(T.push(_),T):[_],b,void 0,!0,void 0,A)}V.accumulate=ae;function J(g,b=(T,_)=>T===_,A){let T=!0,_;return re(g,x=>{const ee=T||!b(x,_);return T=!1,_=x,ee},A)}V.latch=J;function le(g,b,A){return[V.filter(g,b,A),V.filter(g,T=>!b(T),A)]}V.split=le;function K(g,b=!1,A=[],T){let _=A.slice(),x=g(he=>{_?_.push(he):fe.fire(he)});T&&T.add(x);const ee=()=>{_?.forEach(he=>fe.fire(he)),_=null},fe=new a({onWillAddFirstListener(){x||(x=g(he=>fe.fire(he)),T&&T.add(x))},onDidAddFirstListener(){_&&(b?setTimeout(ee):ee())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return T&&T.add(fe),fe.event}V.buffer=K;function H(g,b){return(T,_,x)=>{const ee=b(new be);return g(function(fe){const he=ee.evaluate(fe);he!==Y&&T.call(_,he)},void 0,x)}}V.chain=H;const Y=Symbol("HaltChainable");class be{constructor(){this.f=[]}map(b){return this.f.push(b),this}forEach(b){return this.f.push(A=>(b(A),A)),this}filter(b){return this.f.push(A=>b(A)?A:Y),this}reduce(b,A){let T=A;return this.f.push(_=>(T=b(T,_),T)),this}latch(b=(A,T)=>A===T){let A=!0,T;return this.f.push(_=>{const x=A||!b(_,T);return A=!1,T=_,x?_:Y}),this}evaluate(b){for(const A of this.f)if(b=A(b),b===Y)break;return b}}function we(g,b,A=T=>T){const T=(...fe)=>ee.fire(A(...fe)),_=()=>g.on(b,T),x=()=>g.removeListener(b,T),ee=new a({onWillAddFirstListener:_,onDidRemoveLastListener:x});return ee.event}V.fromNodeEventEmitter=we;function Ce(g,b,A=T=>T){const T=(...fe)=>ee.fire(A(...fe)),_=()=>g.addEventListener(b,T),x=()=>g.removeEventListener(b,T),ee=new a({onWillAddFirstListener:_,onDidRemoveLastListener:x});return ee.event}V.fromDOMEventEmitter=Ce;function Ae(g){return new Promise(b=>z(g)(b))}V.toPromise=Ae;function ce(g){const b=new a;return g.then(A=>{b.fire(A)},()=>{b.fire(void 0)}).finally(()=>{b.dispose()}),b.event}V.fromPromise=ce;function D(g,b,A){return b(A),g(T=>b(T))}V.runAndSubscribe=D;function i(g,b){let A=null;function T(x){A?.dispose(),A=new n.$Rc,b(x,A)}T(void 0);const _=g(x=>T(x));return(0,n.$Qc)(()=>{_.dispose(),A?.dispose()})}V.runAndSubscribeWithStore=i;class s{constructor(b,A){this._observable=b,this.f=0,this.g=!1;const T={onWillAddFirstListener:()=>{b.addObserver(this)},onDidRemoveLastListener:()=>{b.removeObserver(this)}};A||F(T),this.emitter=new a(T),A&&A.add(this.emitter)}beginUpdate(b){this.f++}handlePossibleChange(b){}handleChange(b,A){this.g=!0}endUpdate(b){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function u(g,b){return new s(g,b).emitter.event}V.fromObservable=u;function h(g){return b=>{let A=0,T=!1;const _={beginUpdate(){A++},endUpdate(){A--,A===0&&(g.reportChanges(),T&&(T=!1,b()))},handlePossibleChange(){},handleChange(){T=!0}};return g.addObserver(_),g.reportChanges(),{dispose(){g.removeObserver(_)}}}}V.fromObservableLight=h})(v||(t.Event=v={}));class y{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${y.f++}`,y.all.add(this)}start(F){this.g=new k.$Od,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}t.$Qd=y;let O=-1;function r(V){const F=O;return O=V,{dispose(){O=F}}}t.$Rd=r;class l{constructor(F,I=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=I,this.g=0}dispose(){this.f?.clear()}check(F,I){const z=this.threshold;if(z<=0||I<z)return;this.f||(this.f=new Map);const X=this.f.get(F.value)||0;if(this.f.set(F.value,X+1),this.g-=1,this.g<=0){this.g=z*.5;let G,re=0;for(const[ie,te]of this.f)(!G||re<te)&&(G=ie,re=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${re}):`),console.warn(G)}return()=>{const G=this.f.get(F.value)||0;this.f.set(F.value,G-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class d{constructor(F){this.value=F,this.id=c++}}const p=2,o=(V,F)=>{if(V instanceof d)F(V);else for(let I=0;I<V.length;I++){const z=V[I];z&&F(z)}};class a{constructor(F){this.w=0,this.f=F,this.g=O>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??O):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const F=this.t;queueMicrotask(()=>{o(F,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,I,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Sc.None;if(this.m)return n.$Sc.None;I&&(F=F.bind(I));const X=new d(F);let G,re;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),G=this.g.check(X.stack,this.w+1)),C&&(X.stack=re??e.create()),this.t?this.t instanceof d?(this.u??=new m,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const ie=(0,n.$Qc)(()=>{G?.(),this.x(X)});return z instanceof n.$Rc?z.add(ie):Array.isArray(z)&&z.push(ie),ie},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,z=I.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[z]=void 0;const X=this.u.current===this;if(this.w*p<=I.length){let G=0;for(let re=0;re<I.length;re++)I[re]?I[G++]=I[re]:X&&(this.u.end--,G<this.u.i&&this.u.i--);I.length=G}}y(F,I){if(!F)return;const z=this.f?.onListenerError||S.$1;if(!z){F.value(I);return}try{F.value(I)}catch(X){z(X)}}z(F){const I=F.current.t;for(;F.i<F.end;)this.y(I[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,F);else{const I=this.u;I.enqueue(this,F,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Sd=a;const E=()=>new m;t.$Td=E;class m{constructor(){this.i=-1,this.end=0}enqueue(F,I,z){this.i=0,this.end=z,this.current=F,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends a{async fireAsync(F,I,z){if(this.t)for(this.h||(this.h=new j.$3c),o(this.t,X=>this.h.push([X.value,F]));this.h.size>0&&!I.isCancellationRequested;){const[X,G]=this.h.shift(),re=[],ie={...G,token:I,waitUntil:te=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");z&&(te=z(te,X)),re.push(te)}};try{X(ie)}catch(te){(0,S.$1)(te);continue}Object.freeze(re),await Promise.allSettled(re).then(te=>{for(const $e of te)$e.status==="rejected"&&(0,S.$1)($e.reason)})}}}t.$Ud=f;class N extends a{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new j.$3c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}t.$Vd=N;class B extends N{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}t.$Wd=B;class L extends a{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$Xd=L;class w{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const I={event:F,listener:null};this.h.push(I),this.g&&this.m(I);const z=()=>{this.g&&this.o(I);const X=this.h.indexOf(I);this.h.splice(X,1)};return(0,n.$Qc)((0,R.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(I=>this.f.fire(I))}o(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.f.dispose()}}t.$Yd=w;class P{constructor(F,I,z,X){this.f=new n.$Rc;const G=this.f.add(new w),re=this.f.add(new n.$2c);function ie(te){re.set(te,G.add(X(te)))}for(const te of F)ie(te);this.f.add(I(te=>{ie(te)})),this.f.add(z(te=>{re.deleteAndDispose(te)})),this.event=G.event}dispose(){this.f.dispose()}}t.$Zd=P;class M{constructor(){this.f=[]}wrapEvent(F){return(I,z,X)=>F(G=>{const re=this.f[this.f.length-1];re?re.push(()=>I.call(z,G)):I.call(z,G)},void 0,X)}bufferEvents(F){const I=[];this.f.push(I);const z=F();return this.f.pop(),I.forEach(X=>X()),z}}t.$1d=M;class U{constructor(){this.f=!1,this.g=v.None,this.h=n.$Sc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$2d=U}),define(ge[16],me([1,0,21,4,2]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=void 0;class j{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new R.$Sd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new j}getZoomLevel(){return this.a}setZoomLevel(m){this.a!==m&&(this.a=m)}getZoomFactor(){return this.b}setZoomFactor(m){this.b=m}setFullscreen(m){this.c!==m&&(this.c=m,this.d.fire())}isFullscreen(){return this.c}}class k extends n.$Sc{constructor(){super(),this.a=this.B(new R.$Sd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(m){this.c?.removeEventListener("change",this.b),this.c=S.$window.matchMedia(`(resolution: ${S.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),m&&this.a.fire()}}class C extends n.$Sc{get value(){return this.b}constructor(){super(),this.a=this.B(new R.$Sd),this.onDidChange=this.a.event,this.b=this.c();const m=this.B(new k);this.B(m.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const m=document.createElement("canvas").getContext("2d"),f=S.$window.devicePixelRatio||1,N=m.webkitBackingStorePixelRatio||m.mozBackingStorePixelRatio||m.msBackingStorePixelRatio||m.oBackingStorePixelRatio||m.backingStorePixelRatio||1;return f/N}}class ${constructor(){this.a=null}b(){return this.a||(this.a=(0,n.$Lc)(new C)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function v(E,m){typeof E=="string"&&(E=S.$window.matchMedia(E)),E.addEventListener("change",m)}t.$JO=v,t.$KO=new $;function y(E){j.INSTANCE.setZoomLevel(E)}t.$LO=y;function O(){return j.INSTANCE.getZoomLevel()}t.$MO=O;function r(){return j.INSTANCE.getZoomFactor()}t.$NO=r;function l(E){j.INSTANCE.setZoomFactor(E)}t.$OO=l;function e(E){j.INSTANCE.setFullscreen(E)}t.$PO=e;function c(){return j.INSTANCE.isFullscreen()}t.$QO=c,t.$RO=j.INSTANCE.onDidChangeFullscreen;const d=navigator.userAgent;t.$SO=d.indexOf("Firefox")>=0,t.$TO=d.indexOf("AppleWebKit")>=0,t.$UO=d.indexOf("Chrome")>=0,t.$VO=!t.$UO&&d.indexOf("Safari")>=0,t.$WO=!t.$UO&&!t.$VO&&t.$TO,t.$XO=d.indexOf("Electron/")>=0,t.$YO=d.indexOf("Android")>=0;let p=!1;if(S.$window.matchMedia){const E=S.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),m=S.$window.matchMedia("(display-mode: fullscreen)");p=E.matches,v(E,({matches:f})=>{p&&m.matches||(p=f)})}function o(){return p}t.$ZO=o;function a(){return navigator?.windowControlsOverlay?.visible}t.$1O=a}),define(ge[22],me([1,0,4]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=void 0;class R{get event(){return this.a.event}constructor(j,k,C){const $=v=>this.a.fire(v);this.a=new S.$Sd({onWillAddFirstListener:()=>j.addEventListener(k,$,C),onDidRemoveLastListener:()=>j.removeEventListener(k,$,C)})}dispose(){this.a.dispose()}}t.$aR=R}),define(ge[29],me([1,0,4]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=t.CancellationToken=void 0;const R=Object.freeze(function(C,$){const v=setTimeout(C.bind($),0);return{dispose(){clearTimeout(v)}}});var n;(function(C){function $(v){return v===C.None||v===C.Cancelled||v instanceof j?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}C.isCancellationToken=$,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(n||(t.CancellationToken=n={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=n.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=n.None}}t.$3d=k}),define(ge[84],me([1,0,29]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=t.$Ce=t.$Be=void 0;class R{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new S.$3d,$=this.b(C.token);return this.a={promise:$,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}t.$Be=R;class n{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const $=JSON.stringify(C);return this.b!==$&&(this.b=$,this.a=this.c(C)),this.a}}t.$Ce=n;class j{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const $=this.b(C);return this.a.set(C,$),$}}t.$De=j}),define(ge[48],me([1,0,4,2]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9r=t.$8r=t.$7r=t.$6r=t.ScrollbarVisibility=void 0;var n;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class j{constructor(e,c,d,p,o,a,E){this.c=e,this._scrollStateBrand=void 0,this.c&&(c=c|0,d=d|0,p=p|0,o=o|0,a=a|0,E=E|0),this.rawScrollLeft=p,this.rawScrollTop=E,c<0&&(c=0),p+c>d&&(p=d-c),p<0&&(p=0),o<0&&(o=0),E+o>a&&(E=a-o),E<0&&(E=0),this.width=c,this.scrollWidth=d,this.scrollLeft=p,this.height=o,this.scrollHeight=a,this.scrollTop=E}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,c){return new j(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new j(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,c){const d=this.width!==e.width,p=this.scrollWidth!==e.scrollWidth,o=this.scrollLeft!==e.scrollLeft,a=this.height!==e.height,E=this.scrollHeight!==e.scrollHeight,m=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:c,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:d,scrollWidthChanged:p,scrollLeftChanged:o,heightChanged:a,scrollHeightChanged:E,scrollTopChanged:m}}}t.$6r=j;class k extends R.$Sc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new S.$Sd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new j(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,c){const d=this.g.withScrollDimensions(e,c);this.n(d,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const c=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(e,c){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const d=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===d.scrollLeft&&this.h.to.scrollTop===d.scrollTop)return;let p;c?p=new y(this.h.from,d,this.h.startTime,this.h.duration):p=this.h.combine(this.g,d,this.c),this.h.dispose(),this.h=p}else{const d=this.g.withScrollPosition(e);this.h=y.start(this.g,d,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),c=this.g.withScrollPosition(e);if(this.n(c,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,c){const d=this.g;d.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(d,c)))}}t.$7r=k;class C{constructor(e,c,d){this.scrollLeft=e,this.scrollTop=c,this.isDone=d}}t.$8r=C;function $(l,e){const c=e-l;return function(d){return l+c*r(d)}}function v(l,e,c){return function(d){return d<c?l(d/c):e((d-c)/(1-c))}}class y{constructor(e,c,d,p){this.from=e,this.to=c,this.duration=p,this.startTime=d,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,c,d){if(Math.abs(e-c)>2.5*d){let o,a;return e<c?(o=e+.75*d,a=c-.75*d):(o=e-.75*d,a=c+.75*d),v($(e,o),$(a,c),.33)}return $(e,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const c=(e-this.startTime)/this.duration;if(c<1){const d=this.c(c),p=this.d(c);return new C(d,p,!1)}return new C(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,c,d){return y.start(e,c,d)}static start(e,c,d){d=d+10;const p=Date.now()-10;return new y(e,c,p,d)}}t.$9r=y;function O(l){return Math.pow(l,3)}function r(l){return 1-O(1-l)}}),define(ge[85],me([1,0,6,2]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=void 0;function n(E){const m=E;return m?typeof m.read=="function":!1}t.$4d=n;function j(E){const m=E;return m?[m.on,m.pause,m.resume,m.destroy].every(f=>typeof f=="function"):!1}t.$5d=j;function k(E){const m=E;return m?j(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}t.$6d=k;function C(E,m){return new $(E,m)}t.$7d=C;class ${constructor(m,f){this.e=m,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(f=>f(m))}h(m){this.c.error.length===0?(0,S.$1)(m):this.c.error.slice(0).forEach(f=>f(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,f){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(m,f){if(this.a.destroyed)return;let N;switch(m){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const B=N.indexOf(f);B>=0&&N.splice(B,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(E,m){const f=[];let N;for(;(N=E.read())!==null;)f.push(N);return m(f)}t.$8d=v;function y(E,m,f){const N=[];let B;for(;(B=E.read())!==null&&N.length<f;)N.push(B);return B===null&&N.length>0?m(N):{read:()=>{if(N.length>0)return N.shift();if(typeof B<"u"){const L=B;return B=void 0,L}return E.read()}}}t.$9d=y;function O(E,m){return new Promise((f,N)=>{const B=[];r(E,{onData:L=>{m&&B.push(L)},onError:L=>{m?N(L):f(void 0)},onEnd:()=>{f(m?m(B):void 0)}})})}t.$0d=O;function r(E,m,f){E.on("error",N=>{f?.isCancellationRequested||m.onError(N)}),E.on("end",()=>{f?.isCancellationRequested||m.onEnd()}),E.on("data",N=>{f?.isCancellationRequested||m.onData(N)})}t.$$d=r;function l(E,m){return new Promise((f,N)=>{const B=new R.$Rc,L=[],w=U=>{if(L.push(U),L.length>m)return B.dispose(),E.pause(),f({stream:E,buffer:L,ended:!1})},P=U=>(B.dispose(),N(U)),M=()=>(B.dispose(),f({stream:E,buffer:L,ended:!0}));B.add((0,R.$Qc)(()=>E.removeListener("error",P))),E.on("error",P),B.add((0,R.$Qc)(()=>E.removeListener("end",M))),E.on("end",M),B.add((0,R.$Qc)(()=>E.removeListener("data",w))),E.on("data",w)})}t.$_d=l;function e(E,m){const f=C(m);return f.end(E),f}t.$ae=e;function c(){const E=C(()=>{throw new Error("not supported")});return E.end(),E}t.$be=c;function d(E){let m=!1;return{read:()=>m?null:(m=!0,E)}}t.$ce=d;function p(E,m,f){const N=C(f);return r(E,{onData:B=>N.write(m.data(B)),onError:B=>N.error(m.error?m.error(B):B),onEnd:()=>N.end()}),N}t.$de=p;function o(E,m,f){let N=!1;return{read:()=>{const B=m.read();return N?B:(N=!0,B!==null?f([E,B]):E)}}}t.$ee=o;function a(E,m,f){let N=!1;const B=C(f);return r(m,{onData:L=>N?B.write(L):(N=!0,B.write(f([E,L]))),onError:L=>B.error(L),onEnd:()=>{N||(N=!0,B.write(E)),B.end()}}),B}t.$fe=a}),define(ge[33],me([1,0,23,85]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=void 0;const n=typeof Buffer<"u",j=new S.$V(()=>new Uint8Array(256));let k,C;class ${static alloc(I){return n?new $(Buffer.allocUnsafe(I)):new $(new Uint8Array(I))}static wrap(I){return n&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new $(I)}static fromString(I,z){return!(z?.dontUseNodeBuffer||!1)&&n?new $(Buffer.from(I)):(k||(k=new TextEncoder),new $(k.encode(I)))}static fromByteArray(I){const z=$.alloc(I.length);for(let X=0,G=I.length;X<G;X++)z.buffer[X]=I[X];return z}static concat(I,z){if(typeof z>"u"){z=0;for(let re=0,ie=I.length;re<ie;re++)z+=I[re].byteLength}const X=$.alloc(z);let G=0;for(let re=0,ie=I.length;re<ie;re++){const te=I[re];X.set(te,G),G+=te.byteLength}return X}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=$.alloc(this.byteLength);return I.set(this),I}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(I,z){return new $(this.buffer.subarray(I,z))}set(I,z){if(I instanceof $)this.buffer.set(I.buffer,z);else if(I instanceof Uint8Array)this.buffer.set(I,z);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),z);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return r(this.buffer,I)}writeUInt32BE(I,z){l(this.buffer,I,z)}readUInt32LE(I){return e(this.buffer,I)}writeUInt32LE(I,z){c(this.buffer,I,z)}readUInt8(I){return d(this.buffer,I)}writeUInt8(I,z){p(this.buffer,I,z)}indexOf(I,z=0){return v(this.buffer,I instanceof $?I.buffer:I,z)}}t.$ge=$;function v(F,I,z=0){const X=I.byteLength,G=F.byteLength;if(X===0)return 0;if(X===1)return F.indexOf(I[0]);if(X>G-z)return-1;const re=j.value;re.fill(I.length);for(let Fe=0;Fe<I.length;Fe++)re[I[Fe]]=I.length-Fe-1;let ie=z+I.length-1,te=ie,$e=-1;for(;ie<G;)if(F[ie]===I[te]){if(te===0){$e=ie;break}ie--,te--}else ie+=Math.max(I.length-te,re[F[ie]]),te=I.length-1;return $e}t.$he=v;function y(F,I){return F[I+0]<<0>>>0|F[I+1]<<8>>>0}t.$ie=y;function O(F,I,z){F[z+0]=I&255,I=I>>>8,F[z+1]=I&255}t.$je=O;function r(F,I){return F[I]*2**24+F[I+1]*2**16+F[I+2]*2**8+F[I+3]}t.$ke=r;function l(F,I,z){F[z+3]=I,I=I>>>8,F[z+2]=I,I=I>>>8,F[z+1]=I,I=I>>>8,F[z]=I}t.$le=l;function e(F,I){return F[I+0]<<0>>>0|F[I+1]<<8>>>0|F[I+2]<<16>>>0|F[I+3]<<24>>>0}t.$me=e;function c(F,I,z){F[z+0]=I&255,I=I>>>8,F[z+1]=I&255,I=I>>>8,F[z+2]=I&255,I=I>>>8,F[z+3]=I&255}t.$ne=c;function d(F,I){return F[I]}t.$oe=d;function p(F,I,z){F[z]=I}t.$pe=p;function o(F){return R.$8d(F,I=>$.concat(I))}t.$qe=o;function a(F){return R.$ce(F)}t.$re=a;function E(F){return R.$0d(F,I=>$.concat(I))}t.$se=E;async function m(F){return F.ended?$.concat(F.buffer):$.concat([...F.buffer,await E(F.stream)])}t.$te=m;function f(F){return R.$ae(F,I=>$.concat(I))}t.$ue=f;function N(F){return R.$de(F,{data:I=>typeof I=="string"?$.fromString(I):$.wrap(I)},I=>$.concat(I))}t.$ve=N;function B(F){return R.$7d(I=>$.concat(I),F)}t.$we=B;function L(F,I){return R.$ee(F,I,z=>$.concat(z))}t.$xe=L;function w(F,I){return R.$fe(F,I,z=>$.concat(z))}t.$ye=w;function P(F){let I=0,z=0,X=0;const G=new Uint8Array(Math.floor(F.length/4*3)),re=te=>{switch(z){case 3:G[X++]=I|te,z=0;break;case 2:G[X++]=I|te>>>2,I=te<<6,z=3;break;case 1:G[X++]=I|te>>>4,I=te<<4,z=2;break;default:I=te<<2,z=1}};for(let te=0;te<F.length;te++){const $e=F.charCodeAt(te);if($e>=65&&$e<=90)re($e-65);else if($e>=97&&$e<=122)re($e-97+26);else if($e>=48&&$e<=57)re($e-48+52);else if($e===43||$e===45)re(62);else if($e===47||$e===95)re(63);else{if($e===61)break;throw new SyntaxError(`Unexpected base64 character ${F[te]}`)}}const ie=X;for(;z>0;)re(0);return $.wrap(G).slice(0,ie)}t.$ze=P;const M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:F},I=!0,z=!1){const X=z?U:M;let G="";const re=F.byteLength%3;let ie=0;for(;ie<F.byteLength-re;ie+=3){const te=F[ie+0],$e=F[ie+1],Fe=F[ie+2];G+=X[te>>>2],G+=X[(te<<4|$e>>>4)&63],G+=X[($e<<2|Fe>>>6)&63],G+=X[Fe&63]}if(re===1){const te=F[ie+0];G+=X[te>>>2],G+=X[te<<4&63],I&&(G+="==")}else if(re===2){const te=F[ie+0],$e=F[ie+1];G+=X[te>>>2],G+=X[(te<<4|$e>>>4)&63],G+=X[$e<<2&63],I&&(G+="=")}return G}t.$Ae=V}),define(ge[10],me([1,0,84,23]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cf=t.$Bf=t.$Af=t.$zf=t.GraphemeBreakType=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=void 0;function n(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}t.$Ge=n;const j=/{(\d+)}/g;function k(Q,...se){return se.length===0?Q:Q.replace(j,function(de,Ee){const Pe=parseInt(Ee,10);return isNaN(Pe)||Pe<0||Pe>=se.length?de:se[Pe]})}t.$He=k;const C=/{([^}]+)}/g;function $(Q,se){return Object.keys(se).length===0?Q:Q.replace(C,(de,Ee)=>se[Ee]??de)}t.$Ie=$;function v(Q){return Q.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}t.$Je=v;function y(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ke=y;function O(Q,se){let de=0;const Ee=se.charCodeAt(0);for(let Pe=Q.length-1;Pe>=0;Pe--)Q.charCodeAt(Pe)===Ee&&de++;return de}t.$Le=O;function r(Q,se,de="\u2026"){return Q.length<=se?Q:`${Q.substr(0,se)}${de}`}t.$Me=r;function l(Q,se=" "){const de=e(Q,se);return c(de,se)}t.$Ne=l;function e(Q,se){if(!Q||!se)return Q;const de=se.length;if(de===0||Q.length===0)return Q;let Ee=0;for(;Q.indexOf(se,Ee)===Ee;)Ee=Ee+de;return Q.substring(Ee)}t.$Oe=e;function c(Q,se){if(!Q||!se)return Q;const de=se.length,Ee=Q.length;if(de===0||Ee===0)return Q;let Pe=Ee,ze=-1;for(;ze=Q.lastIndexOf(se,Pe-1),!(ze===-1||ze+de!==Pe);){if(ze===0)return"";Pe=ze}return Q.substring(0,Pe)}t.$Pe=c;function d(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Qe=d;function p(Q){return Q.replace(/\*/g,"")}t.$Re=p;function o(Q,se,de={}){if(!Q)throw new Error("Cannot create regex from empty string");se||(Q=y(Q)),de.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let Ee="";return de.global&&(Ee+="g"),de.matchCase||(Ee+="i"),de.multiline&&(Ee+="m"),de.unicode&&(Ee+="u"),new RegExp(Q,Ee)}t.$Se=o;function a(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}t.$Te=a;function E(Q){return Q.split(/\r\n|\r|\n/)}t.$Ue=E;function m(Q){for(let se=0,de=Q.length;se<de;se++){const Ee=Q.charCodeAt(se);if(Ee!==32&&Ee!==9)return se}return-1}t.$Ve=m;function f(Q,se=0,de=Q.length){for(let Ee=se;Ee<de;Ee++){const Pe=Q.charCodeAt(Ee);if(Pe!==32&&Pe!==9)return Q.substring(se,Ee)}return Q.substring(se,de)}t.$We=f;function N(Q,se=Q.length-1){for(let de=se;de>=0;de--){const Ee=Q.charCodeAt(de);if(Ee!==32&&Ee!==9)return de}return-1}t.$Xe=N;function B(Q,se,de){const Ee=[];let Pe=0;for(const ze of Q.matchAll(se)){if(Ee.push(Q.slice(Pe,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Pe=ze.index+ze[0].length,Ee.push(de(ze[0],...ze.slice(1),ze.index,Q,ze.groups))}return Ee.push(Q.slice(Pe)),Promise.all(Ee).then(ze=>ze.join(""))}t.$Ye=B;function L(Q,se){return Q<se?-1:Q>se?1:0}t.$Ze=L;function w(Q,se,de=0,Ee=Q.length,Pe=0,ze=se.length){for(;de<Ee&&Pe<ze;de++,Pe++){const Ze=Q.charCodeAt(de),Ke=se.charCodeAt(Pe);if(Ze<Ke)return-1;if(Ze>Ke)return 1}const Ue=Ee-de,Je=ze-Pe;return Ue<Je?-1:Ue>Je?1:0}t.$1e=w;function P(Q,se){return M(Q,se,0,Q.length,0,se.length)}t.$2e=P;function M(Q,se,de=0,Ee=Q.length,Pe=0,ze=se.length){for(;de<Ee&&Pe<ze;de++,Pe++){let Ze=Q.charCodeAt(de),Ke=se.charCodeAt(Pe);if(Ze===Ke)continue;if(Ze>=128||Ke>=128)return w(Q.toLowerCase(),se.toLowerCase(),de,Ee,Pe,ze);V(Ze)&&(Ze-=32),V(Ke)&&(Ke-=32);const _e=Ze-Ke;if(_e!==0)return _e}const Ue=Ee-de,Je=ze-Pe;return Ue<Je?-1:Ue>Je?1:0}t.$3e=M;function U(Q){return Q>=48&&Q<=57}t.$4e=U;function V(Q){return Q>=97&&Q<=122}t.$5e=V;function F(Q){return Q>=65&&Q<=90}t.$6e=F;function I(Q,se){return Q.length===se.length&&M(Q,se)===0}t.$7e=I;function z(Q,se){const de=se.length;return se.length>Q.length?!1:M(Q,se,0,de)===0}t.$8e=z;function X(Q,se){const de=Math.min(Q.length,se.length);let Ee;for(Ee=0;Ee<de;Ee++)if(Q.charCodeAt(Ee)!==se.charCodeAt(Ee))return Ee;return de}t.$9e=X;function G(Q,se){const de=Math.min(Q.length,se.length);let Ee;const Pe=Q.length-1,ze=se.length-1;for(Ee=0;Ee<de;Ee++)if(Q.charCodeAt(Pe-Ee)!==se.charCodeAt(ze-Ee))return Ee;return de}t.$0e=G;function re(Q){return 55296<=Q&&Q<=56319}t.$$e=re;function ie(Q){return 56320<=Q&&Q<=57343}t.$_e=ie;function te(Q,se){return(Q-55296<<10)+(se-56320)+65536}t.$af=te;function $e(Q,se,de){const Ee=Q.charCodeAt(de);if(re(Ee)&&de+1<se){const Pe=Q.charCodeAt(de+1);if(ie(Pe))return te(Ee,Pe)}return Ee}t.$bf=$e;function Fe(Q,se){const de=Q.charCodeAt(se-1);if(ie(de)&&se>1){const Ee=Q.charCodeAt(se-2);if(re(Ee))return te(Ee,de)}return de}class ke{get offset(){return this.e}constructor(se,de=0){this.c=se,this.d=se.length,this.e=de}setOffset(se){this.e=se}prevCodePoint(){const se=Fe(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=$e(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}t.$cf=ke;class Le{get offset(){return this.c.offset}constructor(se,de=0){this.c=new ke(se,de)}nextGraphemeLength(){const se=De.getInstance(),de=this.c,Ee=de.offset;let Pe=se.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const ze=de.offset,Ue=se.getGraphemeBreakType(de.nextCodePoint());if(he(Pe,Ue)){de.setOffset(ze);break}Pe=Ue}return de.offset-Ee}prevGraphemeLength(){const se=De.getInstance(),de=this.c,Ee=de.offset;let Pe=se.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const ze=de.offset,Ue=se.getGraphemeBreakType(de.prevCodePoint());if(he(Ue,Pe)){de.setOffset(ze);break}Pe=Ue}return Ee-de.offset}eol(){return this.c.eol()}}t.$df=Le;function ae(Q,se){return new Le(Q,se).nextGraphemeLength()}t.$ef=ae;function J(Q,se){return new Le(Q,se).prevGraphemeLength()}t.$ff=J;function le(Q,se){se>0&&ie(Q.charCodeAt(se))&&se--;const de=se+ae(Q,se);return[de-J(Q,de),de]}t.$gf=le;function K(Q){const se=new Le(Q);let de=0;for(;!se.eol();)de++,se.nextGraphemeLength();return de}t.$hf=K;let H;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(Q){return H||(H=Y()),H.test(Q)}t.$if=be;const we=/^[\t\n\r\x20-\x7E]*$/;function Ce(Q){return we.test(Q)}t.$jf=Ce,t.$kf=/[\u2028\u2029]/;function Ae(Q){return t.$kf.test(Q)}t.$lf=Ae;function ce(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}t.$mf=ce;function D(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}t.$nf=D;function i(Q,se){if(Q.length<se)return Q;const de=/\b/g;let Ee=0;for(;de.test(Q)&&!(Q.length-de.lastIndex<se);)Ee=de.lastIndex,de.lastIndex+=1;return Q.substring(Ee).replace(/^\s/,"")}t.$of=i;const s=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,u=/\x1b\].*?\x07/g;function h(Q){return Q&&(Q=Q.replace(s,"").replace(u,"")),Q}t.$pf=h,t.$qf=String.fromCharCode(65279);function g(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}t.$rf=g;function b(Q){return g(Q)?Q.substr(1):Q}t.$sf=b;function A(Q,se){if(!Q||!se||Q.length<se.length)return!1;const de=se.length,Ee=Q.toLowerCase();let Pe=0,ze=-1;for(;Pe<de;){const Ue=Ee.indexOf(se[Pe],ze+1);if(Ue<0)return!1;ze=Ue,Pe++}return!0}t.$tf=A;function T(Q,se=!1){return Q?(se&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}t.$uf=T;function _(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}t.$vf=_;function x(Q,se=1){if(se===0)return"";let de=-1;do de=Q.indexOf(`
`,de+1),se--;while(se>0&&de>=0);return de===-1?Q:(Q[de-1]==="\r"&&de--,Q.substr(0,de))}t.$wf=x;function ee(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}t.$xf=ee;function fe(Q){return De.getInstance().getGraphemeBreakType(Q)}t.$yf=fe;function he(Q,se){return Q===0?se!==5&&se!==7:Q===2&&se===3?!1:Q===4||Q===2||Q===3||se===4||se===2||se===3?!0:!(Q===8&&(se===8||se===9||se===11||se===12)||(Q===11||Q===9)&&(se===9||se===10)||(Q===12||Q===10)&&se===10||se===5||se===13||se===7||Q===1||Q===13&&se===14||Q===6&&se===6)}var ye;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(ye||(t.GraphemeBreakType=ye={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=pe()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const de=this.d,Ee=de.length/3;let Pe=1;for(;Pe<=Ee;)if(se<de[3*Pe])Pe=2*Pe;else if(se>de[3*Pe+1])Pe=2*Pe+1;else return de[3*Pe+2];return 0}}function pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(Q,se){if(Q===0)return 0;const de=Te(Q,se);if(de!==void 0)return de;const Ee=new ke(se,Q);return Ee.prevCodePoint(),Ee.offset}t.$zf=Ie;function Te(Q,se){const de=new ke(se,Q);let Ee=de.prevCodePoint();for(;Ye(Ee)||Ee===65039||Ee===8419;){if(de.offset===0)return;Ee=de.prevCodePoint()}if(!D(Ee))return;let Pe=de.offset;return Pe>0&&de.prevCodePoint()===8205&&(Pe=de.offset),Pe}function Ye(Q){return 127995<=Q&&Q<=127999}var He;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$Af="\xA0";class Me{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Ce(se=>{function de(_e){const tt=new Map;for(let nt=0;nt<_e.length;nt+=2)tt.set(_e[nt],_e[nt+1]);return tt}function Ee(_e,tt){const nt=new Map(_e);for(const[dt,lt]of tt)nt.set(dt,lt);return nt}function Pe(_e,tt){if(!_e)return tt;const nt=new Map;for(const[dt,lt]of _e)tt.has(dt)&&nt.set(dt,lt);return nt}const ze=this.c.value;let Ue=se.filter(_e=>!_e.startsWith("_")&&_e in ze);Ue.length===0&&(Ue=["_default"]);let Je;for(const _e of Ue){const tt=de(ze[_e]);Je=Pe(Je,tt)}const Ze=de(ze._common),Ke=Ee(Ze,Je);return new Me(Ke)})}static getInstance(se){return Me.d.get(Array.from(se))}static{this.e=new R.$V(()=>Object.keys(Me.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Me.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Bf=Me;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(se){return Ve.e().has(se)}static get codePoints(){return Ve.e()}}t.$Cf=Ve}),define(ge[34],me([1,0,32,10]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=t.$2j=t.$1j=t.$Zj=t.FuzzyScore=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.or=void 0;function n(...b){return function(A,T){for(let _=0,x=b.length;_<x;_++){const ee=b[_](A,T);if(ee)return ee}return null}}t.or=n,t.$Nj=j.bind(void 0,!1),t.$Oj=j.bind(void 0,!0);function j(b,A,T){if(!T||T.length<A.length)return null;let _;return b?_=R.$8e(T,A):_=T.indexOf(A)===0,_?A.length>0?[{start:0,end:A.length}]:[]:null}function k(b,A){const T=A.toLowerCase().indexOf(b.toLowerCase());return T===-1?null:[{start:T,end:T+b.length}]}t.$Pj=k;function C(b,A){return $(b.toLowerCase(),A.toLowerCase(),0,0)}t.$Qj=C;function $(b,A,T,_){if(T===b.length)return[];if(_===A.length)return null;if(b[T]===A[_]){let x=null;return(x=$(b,A,T+1,_+1))?p({start:_,end:_+1},x):null}return $(b,A,T,_+1)}function v(b){return 97<=b&&b<=122}function y(b){return 65<=b&&b<=90}t.$Rj=y;function O(b){return 48<=b&&b<=57}function r(b){return b===32||b===9||b===10||b===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(b=>l.add(b.charCodeAt(0)));function e(b){return r(b)||l.has(b)}function c(b,A){return b===A||e(b)&&e(A)}function d(b){return v(b)||y(b)||O(b)}function p(b,A){return A.length===0?A=[b]:b.end===A[0].start?A[0].start=b.start:A.unshift(b),A}function o(b,A){for(let T=A;T<b.length;T++){const _=b.charCodeAt(T);if(y(_)||O(_)||T>0&&!d(b.charCodeAt(T-1)))return T}return b.length}function a(b,A,T,_){if(T===b.length)return[];if(_===A.length)return null;if(b[T]!==A[_].toLowerCase())return null;{let x=null,ee=_+1;for(x=a(b,A,T+1,_+1);!x&&(ee=o(A,ee))<A.length;)x=a(b,A,T+1,ee),ee++;return x===null?null:p({start:_,end:_+1},x)}}function E(b){let A=0,T=0,_=0,x=0,ee=0;for(let pe=0;pe<b.length;pe++)ee=b.charCodeAt(pe),y(ee)&&A++,v(ee)&&T++,d(ee)&&_++,O(ee)&&x++;const fe=A/b.length,he=T/b.length,ye=_/b.length,De=x/b.length;return{upperPercent:fe,lowerPercent:he,alphaPercent:ye,numericPercent:De}}function m(b){const{upperPercent:A,lowerPercent:T}=b;return T===0&&A>.6}function f(b){const{upperPercent:A,lowerPercent:T,alphaPercent:_,numericPercent:x}=b;return T>.2&&A<.8&&_>.6&&x<.2}function N(b){let A=0,T=0,_=0,x=0;for(let ee=0;ee<b.length;ee++)_=b.charCodeAt(ee),y(_)&&A++,v(_)&&T++,r(_)&&x++;return(A===0||T===0)&&x===0?b.length<=30:A<=5}function B(b,A){if(!A||(A=A.trim(),A.length===0)||!N(b)||A.length>60)return null;const T=E(A);if(!f(T)){if(!m(T))return null;A=A.toLowerCase()}let _=null,x=0;for(b=b.toLowerCase();x<A.length&&(_=a(b,A,0,x))===null;)x=o(A,x+1);return _}t.$Sj=B;function L(b,A,T=!1){if(!A||A.length===0)return null;let _=null,x=0;for(b=b.toLowerCase(),A=A.toLowerCase();x<A.length&&(_=w(b,A,0,x,T))===null;)x=P(A,x+1);return _}t.$Tj=L;function w(b,A,T,_,x){if(T===b.length)return[];if(_===A.length)return null;if(c(b.charCodeAt(T),A.charCodeAt(_))){let ee=null,fe=_+1;if(ee=w(b,A,T+1,_+1,x),!x)for(;!ee&&(fe=P(A,fe))<A.length;)ee=w(b,A,T+1,fe,x),fe++;return ee?b.charCodeAt(T)!==A.charCodeAt(_)?ee:p({start:_,end:_+1},ee):null}else return null}function P(b,A){for(let T=A;T<b.length;T++)if(e(b.charCodeAt(T))||T>0&&e(b.charCodeAt(T-1)))return T;return b.length}const M=n(t.$Oj,B,k),U=n(t.$Oj,B,C),V=new S.$Dc(1e4);function F(b,A,T=!1){if(typeof b!="string"||typeof A!="string")return null;let _=V.get(b);_||(_=new RegExp(R.$Qe(b),"i"),V.set(b,_));const x=_.exec(A);return x?[{start:x.index,end:x.index+x[0].length}]:T?U(b,A):M(b,A)}t.$Uj=F;function I(b,A){const T=ce(b,b.toLowerCase(),0,A,A.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?X(T):null}t.$Vj=I;function z(b,A,T,_,x,ee){const fe=Math.min(13,b.length);for(;T<fe;T++){const he=ce(b,A,T,_,x,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,ee]}t.$Wj=z;function X(b){if(typeof b>"u")return[];const A=[],T=b[1];for(let _=b.length-1;_>1;_--){const x=b[_]+T,ee=A[A.length-1];ee&&ee.end===x?ee.end=x+1:A.push({start:x,end:x+1})}return A}t.$Xj=X;const G=128;function re(){const b=[],A=[];for(let T=0;T<=G;T++)A[T]=0;for(let T=0;T<=G;T++)b.push(A.slice(0));return b}function ie(b){const A=[];for(let T=0;T<=b;T++)A[T]=0;return A}const te=ie(2*G),$e=ie(2*G),Fe=re(),ke=re(),Le=re(),ae=!1;function J(b,A,T,_,x){function ee(he,ye,De=" "){for(;he.length<ye;)he=De+he;return he}let fe=` |   |${_.split("").map(he=>ee(he,3)).join("|")}
`;for(let he=0;he<=T;he++)he===0?fe+=" |":fe+=`${A[he-1]}|`,fe+=b[he].slice(0,x+1).map(ye=>ee(ye.toString(),3)).join("|")+`
`;return fe}function le(b,A,T,_){b=b.substr(A),T=T.substr(_),console.log(J(ke,b,b.length,T,T.length)),console.log(J(Le,b,b.length,T,T.length)),console.log(J(Fe,b,b.length,T,T.length))}function K(b,A){if(A<0||A>=b.length)return!1;const T=b.codePointAt(A);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$nf(T)}}function H(b,A){if(A<0||A>=b.length)return!1;switch(b.charCodeAt(A)){case 32:case 9:return!0;default:return!1}}function Y(b,A,T){return A[b]!==T[b]}function be(b,A,T,_,x,ee,fe=!1){for(;A<T&&x<ee;)b[A]===_[x]&&(fe&&(te[A]=x),A+=1),x+=1;return A===T}t.$Yj=be;var we;(function(b){b[b.Diag=1]="Diag",b[b.Left=2]="Left",b[b.LeftLeft=3]="LeftLeft"})(we||(we={}));var Ce;(function(b){b.Default=[-100,0];function A(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}b.isDefault=A})(Ce||(t.FuzzyScore=Ce={}));class Ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(A,T){this.firstMatchCanBeWeak=A,this.boostFullMatch=T}}t.$Zj=Ae;function ce(b,A,T,_,x,ee,fe=Ae.default){const he=b.length>G?G:b.length,ye=_.length>G?G:_.length;if(T>=he||ee>=ye||he-T>ye-ee||!be(A,T,he,x,ee,ye,!0))return;D(he,ye,T,ee,A,x);let De=1,pe=1,Ie=T,Te=ee;const Ye=[!1];for(De=1,Ie=T;Ie<he;De++,Ie++){const se=te[Ie],de=$e[Ie],Ee=Ie+1<he?$e[Ie+1]:ye;for(pe=se-ee+1,Te=se;Te<Ee;pe++,Te++){let Pe=Number.MIN_SAFE_INTEGER,ze=!1;Te<=de&&(Pe=i(b,A,Ie,T,_,x,Te,ye,ee,Fe[De-1][pe-1]===0,Ye));let Ue=0;Pe!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ue=Pe+ke[De-1][pe-1]);const Je=Te>se,Ze=Je?ke[De][pe-1]+(Fe[De][pe-1]>0?-5:0):0,Ke=Te>se+1&&Fe[De][pe-1]>0,_e=Ke?ke[De][pe-2]+(Fe[De][pe-2]>0?-5:0):0;if(Ke&&(!Je||_e>=Ze)&&(!ze||_e>=Ue))ke[De][pe]=_e,Le[De][pe]=3,Fe[De][pe]=0;else if(Je&&(!ze||Ze>=Ue))ke[De][pe]=Ze,Le[De][pe]=2,Fe[De][pe]=0;else if(ze)ke[De][pe]=Ue,Le[De][pe]=1,Fe[De][pe]=Fe[De-1][pe-1]+1;else throw new Error("not possible")}}if(ae&&le(b,T,_,ee),!Ye[0]&&!fe.firstMatchCanBeWeak)return;De--,pe--;const He=[ke[De][pe],ee];let Me=0,Ve=0;for(;De>=1;){let se=pe;do{const de=Le[De][se];if(de===3)se=se-2;else if(de===2)se=se-1;else break}while(se>=1);Me>1&&A[T+De-1]===x[ee+pe-1]&&!Y(se+ee-1,_,x)&&Me+1>Fe[De][se]&&(se=pe),se===pe?Me++:Me=1,Ve||(Ve=se),De--,pe=se-1,He.push(pe)}ye===he&&fe.boostFullMatch&&(He[0]+=2);const Q=Ve-he;return He[0]-=Q,He}t.$1j=ce;function D(b,A,T,_,x,ee){let fe=b-1,he=A-1;for(;fe>=T&&he>=_;)x[fe]===ee[he]&&($e[fe]=he,fe--),he--}function i(b,A,T,_,x,ee,fe,he,ye,De,pe){if(A[T]!==ee[fe])return Number.MIN_SAFE_INTEGER;let Ie=1,Te=!1;return fe===T-_?Ie=b[T]===x[fe]?7:5:Y(fe,x,ee)&&(fe===0||!Y(fe-1,x,ee))?(Ie=b[T]===x[fe]?7:5,Te=!0):K(ee,fe)&&(fe===0||!K(ee,fe-1))?Ie=5:(K(ee,fe-1)||H(ee,fe-1))&&(Ie=5,Te=!0),Ie>1&&T===_&&(pe[0]=!0),Te||(Te=Y(fe,x,ee)||K(ee,fe-1)||H(ee,fe-1)),T===_?fe>ye&&(Ie-=Te?3:5):De?Ie+=Te?2:0:Ie+=Te?0:1,fe+1===he&&(Ie-=Te?3:5),Ie}function s(b,A,T,_,x,ee,fe){return h(b,A,T,_,x,ee,!0,fe)}t.$2j=s;function u(b,A,T,_,x,ee,fe){return h(b,A,T,_,x,ee,!1,fe)}t.$3j=u;function h(b,A,T,_,x,ee,fe,he){let ye=ce(b,A,T,_,x,ee,he);if(ye&&!fe)return ye;if(b.length>=3){const De=Math.min(7,b.length-1);for(let pe=T+1;pe<De;pe++){const Ie=g(b,pe);if(Ie){const Te=ce(Ie,Ie.toLowerCase(),T,_,x,ee,he);Te&&(Te[0]-=3,(!ye||Te[0]>ye[0])&&(ye=Te))}}}return ye}function g(b,A){if(A+1>=b.length)return;const T=b[A],_=b[A+1];if(T!==_)return b.slice(0,A)+_+T+b.slice(A+2)}}),define(ge[49],me([1,0,10]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ui=t.$Ti=t.$Si=t.$Ri=t.$Qi=t.$Pi=t.$Oi=void 0;function R(p){return n(p,0)}t.$Oi=R;function n(p,o){switch(typeof p){case"object":return p===null?j(349,o):Array.isArray(p)?$(p,o):v(p,o);case"string":return C(p,o);case"boolean":return k(p,o);case"number":return j(p,o);case"undefined":return j(937,o);default:return j(617,o)}}t.$Pi=n;function j(p,o){return(o<<5)-o+p|0}t.$Qi=j;function k(p,o){return j(p?433:863,o)}function C(p,o){o=j(149417,o);for(let a=0,E=p.length;a<E;a++)o=j(p.charCodeAt(a),o);return o}t.$Ri=C;function $(p,o){return o=j(104579,o),p.reduce((a,E)=>n(E,a),o)}function v(p,o){return o=j(181387,o),Object.keys(p).sort().reduce((a,E)=>(a=C(E,a),n(p[E],a)),o)}class y{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=n(o,this.g),this.g}}t.$Si=y;var O;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function r(p,o,a=32){const E=a-o,m=~((1<<E)-1);return(p<<o|(m&p)>>>E)>>>0}function l(p,o=0,a=p.byteLength,E=0){for(let m=0;m<a;m++)p[o+m]=E}function e(p,o,a="0"){for(;p.length<o;)p=a+p;return p}function c(p,o=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(a=>a.toString(16).padStart(2,"0")).join(""):e((p>>>0).toString(16),o/4)}t.$Ti=c;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const a=o.length;if(a===0)return;const E=this.p;let m=this.r,f=this.u,N,B;for(f!==0?(N=f,B=-1,f=0):(N=o.charCodeAt(0),B=0);;){let L=N;if(S.$$e(N))if(B+1<a){const w=o.charCodeAt(B+1);S.$_e(w)?(B++,L=S.$af(N,w)):L=65533}else{f=N;break}else S.$_e(N)&&(L=65533);if(m=this.w(E,m,L),B++,B<a)N=o.charCodeAt(B);else break}this.r=m,this.u=f}w(o,a,E){return E<128?o[a++]=E:E<2048?(o[a++]=192|(E&1984)>>>6,o[a++]=128|(E&63)>>>0):E<65536?(o[a++]=224|(E&61440)>>>12,o[a++]=128|(E&4032)>>>6,o[a++]=128|(E&63)>>>0):(o[a++]=240|(E&1835008)>>>18,o[a++]=128|(E&258048)>>>12,o[a++]=128|(E&4032)>>>6,o[a++]=128|(E&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=d.g,a=this.q;for(let M=0;M<64;M+=4)o.setUint32(M,a.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)o.setUint32(M,r(o.getUint32(M-12,!1)^o.getUint32(M-32,!1)^o.getUint32(M-56,!1)^o.getUint32(M-64,!1),1),!1);let E=this.h,m=this.l,f=this.m,N=this.n,B=this.o,L,w,P;for(let M=0;M<80;M++)M<20?(L=m&f|~m&N,w=1518500249):M<40?(L=m^f^N,w=1859775393):M<60?(L=m&f|m&N|f&N,w=2400959708):(L=m^f^N,w=3395469782),P=r(E,5)+L+B+w+o.getUint32(M*4,!1)&4294967295,B=N,N=f,f=r(m,30),m=E,E=P;this.h=this.h+E&4294967295,this.l=this.l+m&4294967295,this.m=this.m+f&4294967295,this.n=this.n+N&4294967295,this.o=this.o+B&4294967295}}t.$Ui=d}),define(ge[86],me([1,0,75,49]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ks=t.$Js=t.$Is=void 0;class n{constructor(r){this.a=r}getElements(){const r=this.a,l=new Int32Array(r.length);for(let e=0,c=r.length;e<c;e++)l[e]=r.charCodeAt(e);return l}}t.$Is=n;function j(O,r,l){return new y(new n(O),new n(r)).ComputeDiff(l).changes}t.$Js=j;class k{static Assert(r,l){if(!r)throw new Error(l)}}class C{static Copy(r,l,e,c,d){for(let p=0;p<d;p++)e[c+p]=r[l+p]}static Copy2(r,l,e,c,d){for(let p=0;p<d;p++)e[c+p]=r[l+p]}}var $;(function(O){O[O.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})($||($={}));class v{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new S.$Hs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(r,l,e=null){this.a=e,this.b=r,this.c=l;const[c,d,p]=y.o(r),[o,a,E]=y.o(l);this.d=p&&E,this.e=c,this.f=d,this.g=o,this.h=a,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const l=r.getElements();if(y.n(l)){const e=new Int32Array(l.length);for(let c=0,d=l.length;c<d;c++)e[c]=(0,R.$Ri)(l[c],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(r,l){return this.f[r]!==this.h[l]?!1:this.d?this.e[r]===this.g[l]:!0}q(r,l){if(!this.p(r,l))return!1;const e=y.r(this.b,r),c=y.r(this.c,l);return e===c}static r(r,l){return typeof r.getStrictElement=="function"?r.getStrictElement(l):null}s(r,l){return this.f[r]!==this.f[l]?!1:this.d?this.e[r]===this.e[l]:!0}u(r,l){return this.h[r]!==this.h[l]?!1:this.d?this.g[r]===this.g[l]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,l,e,c,d){const p=[!1];let o=this.w(r,l,e,c,p);return d&&(o=this.z(o)),{quitEarly:p[0],changes:o}}w(r,l,e,c,d){for(d[0]=!1;r<=l&&e<=c&&this.p(r,e);)r++,e++;for(;l>=r&&c>=e&&this.p(l,c);)l--,c--;if(r>l||e>c){let f;return e<=c?(k.Assert(r===l+1,"originalStart should only be one more than originalEnd"),f=[new S.$Hs(r,0,e,c-e+1)]):r<=l?(k.Assert(e===c+1,"modifiedStart should only be one more than modifiedEnd"),f=[new S.$Hs(r,l-r+1,e,0)]):(k.Assert(r===l+1,"originalStart should only be one more than originalEnd"),k.Assert(e===c+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const p=[0],o=[0],a=this.y(r,l,e,c,p,o,d),E=p[0],m=o[0];if(a!==null)return a;if(!d[0]){const f=this.w(r,E,e,m,d);let N=[];return d[0]?N=[new S.$Hs(E+1,l-(E+1)+1,m+1,c-(m+1)+1)]:N=this.w(E+1,l,m+1,c,d),this.H(f,N)}return[new S.$Hs(r,l-r+1,e,c-e+1)]}x(r,l,e,c,d,p,o,a,E,m,f,N,B,L,w,P,M,U){let V=null,F=null,I=new v,z=l,X=e,G=B[0]-P[0]-c,re=-1073741824,ie=this.k.length-1;do{const te=G+r;te===z||te<X&&E[te-1]<E[te+1]?(f=E[te+1],L=f-G-c,f<re&&I.MarkNextChange(),re=f,I.AddModifiedElement(f+1,L),G=te+1-r):(f=E[te-1]+1,L=f-G-c,f<re&&I.MarkNextChange(),re=f-1,I.AddOriginalElement(f,L+1),G=te-1-r),ie>=0&&(E=this.k[ie],r=E[0],z=1,X=E.length-1)}while(--ie>=-1);if(V=I.getReverseChanges(),U[0]){let te=B[0]+1,$e=P[0]+1;if(V!==null&&V.length>0){const Fe=V[V.length-1];te=Math.max(te,Fe.getOriginalEnd()),$e=Math.max($e,Fe.getModifiedEnd())}F=[new S.$Hs(te,N-te+1,$e,w-$e+1)]}else{I=new v,z=p,X=o,G=B[0]-P[0]-a,re=1073741824,ie=M?this.m.length-1:this.m.length-2;do{const te=G+d;te===z||te<X&&m[te-1]>=m[te+1]?(f=m[te+1]-1,L=f-G-a,f>re&&I.MarkNextChange(),re=f+1,I.AddOriginalElement(f+1,L+1),G=te+1-d):(f=m[te-1],L=f-G-a,f>re&&I.MarkNextChange(),re=f,I.AddModifiedElement(f+1,L+1),G=te-1-d),ie>=0&&(m=this.m[ie],d=m[0],z=1,X=m.length-1)}while(--ie>=-1);F=I.getChanges()}return this.H(V,F)}y(r,l,e,c,d,p,o){let a=0,E=0,m=0,f=0,N=0,B=0;r--,e--,d[0]=0,p[0]=0,this.k=[],this.m=[];const L=l-r+(c-e),w=L+1,P=new Int32Array(w),M=new Int32Array(w),U=c-e,V=l-r,F=r-e,I=l-c,X=(V-U)%2===0;P[U]=r,M[V]=l,o[0]=!1;for(let G=1;G<=L/2+1;G++){let re=0,ie=0;m=this.J(U-G,G,U,w),f=this.J(U+G,G,U,w);for(let $e=m;$e<=f;$e+=2){$e===m||$e<f&&P[$e-1]<P[$e+1]?a=P[$e+1]:a=P[$e-1]+1,E=a-($e-U)-F;const Fe=a;for(;a<l&&E<c&&this.p(a+1,E+1);)a++,E++;if(P[$e]=a,a+E>re+ie&&(re=a,ie=E),!X&&Math.abs($e-V)<=G-1&&a>=M[$e])return d[0]=a,p[0]=E,Fe<=M[$e]&&1447>0&&G<=1447+1?this.x(U,m,f,F,V,N,B,I,P,M,a,l,d,E,c,p,X,o):null}const te=(re-r+(ie-e)-G)/2;if(this.a!==null&&!this.a(re,te))return o[0]=!0,d[0]=re,p[0]=ie,te>0&&1447>0&&G<=1447+1?this.x(U,m,f,F,V,N,B,I,P,M,a,l,d,E,c,p,X,o):(r++,e++,[new S.$Hs(r,l-r+1,e,c-e+1)]);N=this.J(V-G,G,V,w),B=this.J(V+G,G,V,w);for(let $e=N;$e<=B;$e+=2){$e===N||$e<B&&M[$e-1]>=M[$e+1]?a=M[$e+1]-1:a=M[$e-1],E=a-($e-V)-I;const Fe=a;for(;a>r&&E>e&&this.p(a,E);)a--,E--;if(M[$e]=a,X&&Math.abs($e-U)<=G&&a<=P[$e])return d[0]=a,p[0]=E,Fe>=P[$e]&&1447>0&&G<=1447+1?this.x(U,m,f,F,V,N,B,I,P,M,a,l,d,E,c,p,X,o):null}if(G<=1447){let $e=new Int32Array(f-m+2);$e[0]=U-m+1,C.Copy2(P,m,$e,1,f-m+1),this.k.push($e),$e=new Int32Array(B-N+2),$e[0]=V-N+1,C.Copy2(M,N,$e,1,B-N+1),this.m.push($e)}}return this.x(U,m,f,F,V,N,B,I,P,M,a,l,d,E,c,p,X,o)}z(r){for(let l=0;l<r.length;l++){const e=r[l],c=l<r.length-1?r[l+1].originalStart:this.f.length,d=l<r.length-1?r[l+1].modifiedStart:this.h.length,p=e.originalLength>0,o=e.modifiedLength>0;for(;e.originalStart+e.originalLength<c&&e.modifiedStart+e.modifiedLength<d&&(!p||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!o||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const E=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!E)break;e.originalStart++,e.modifiedStart++}const a=[null];if(l<r.length-1&&this.I(r[l],r[l+1],a)){r[l]=a[0],r.splice(l+1,1),l--;continue}}for(let l=r.length-1;l>=0;l--){const e=r[l];let c=0,d=0;if(l>0){const f=r[l-1];c=f.originalStart+f.originalLength,d=f.modifiedStart+f.modifiedLength}const p=e.originalLength>0,o=e.modifiedLength>0;let a=0,E=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const N=e.originalStart-f,B=e.modifiedStart-f;if(N<c||B<d||p&&!this.s(N,N+e.originalLength)||o&&!this.u(B,B+e.modifiedLength))break;const w=(N===c&&B===d?5:0)+this.G(N,e.originalLength,B,e.modifiedLength);w>E&&(E=w,a=f)}e.originalStart-=a,e.modifiedStart-=a;const m=[null];if(l>0&&this.I(r[l-1],r[l],m)){r[l-1]=m[0],r.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=r.length;l<e;l++){const c=r[l-1],d=r[l],p=d.originalStart-c.originalStart-c.originalLength,o=c.originalStart,a=d.originalStart+d.originalLength,E=a-o,m=c.modifiedStart,f=d.modifiedStart+d.modifiedLength,N=f-m;if(p<5&&E<20&&N<20){const B=this.A(o,E,m,N,p);if(B){const[L,w]=B;(L!==c.originalStart+c.originalLength||w!==c.modifiedStart+c.modifiedLength)&&(c.originalLength=L-c.originalStart,c.modifiedLength=w-c.modifiedStart,d.originalStart=L+p,d.modifiedStart=w+p,d.originalLength=a-d.originalStart,d.modifiedLength=f-d.modifiedStart)}}}return r}A(r,l,e,c,d){if(l<d||c<d)return null;const p=r+l-d+1,o=e+c-d+1;let a=0,E=0,m=0;for(let f=r;f<p;f++)for(let N=e;N<o;N++){const B=this.B(f,N,d);B>0&&B>a&&(a=B,E=f,m=N)}return a>0?[E,m]:null}B(r,l,e){let c=0;for(let d=0;d<e;d++){if(!this.p(r+d,l+d))return 0;c+=this.e[r+d].length}return c}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,l){if(this.C(r)||this.C(r-1))return!0;if(l>0){const e=r+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,l){if(this.E(r)||this.E(r-1))return!0;if(l>0){const e=r+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,l,e,c){const d=this.D(r,l)?1:0,p=this.F(e,c)?1:0;return d+p}H(r,l){const e=[];if(r.length===0||l.length===0)return l.length>0?l:r;if(this.I(r[r.length-1],l[0],e)){const c=new Array(r.length+l.length-1);return C.Copy(r,0,c,0,r.length-1),c[r.length-1]=e[0],C.Copy(l,1,c,r.length,l.length-1),c}else{const c=new Array(r.length+l.length);return C.Copy(r,0,c,0,r.length),C.Copy(l,0,c,r.length,l.length),c}}I(r,l,e){if(k.Assert(r.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),k.Assert(r.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=l.originalStart||r.modifiedStart+r.modifiedLength>=l.modifiedStart){const c=r.originalStart;let d=r.originalLength;const p=r.modifiedStart;let o=r.modifiedLength;return r.originalStart+r.originalLength>=l.originalStart&&(d=l.originalStart+l.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=l.modifiedStart&&(o=l.modifiedStart+l.modifiedLength-r.modifiedStart),e[0]=new S.$Hs(c,d,p,o),!0}else return e[0]=null,!1}J(r,l,e,c){if(r>=0&&r<c)return r;const d=e,p=c-e-1,o=l%2===0;if(r<0){const a=d%2===0;return o===a?0:1}else{const a=p%2===0;return o===a?c-1:c-2}}}t.$Ks=y}),define(ge[50],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pd=void 0,t.$Pd=Symbol("MicrotaskDelay")}),define(ge[87],me([1,0,12,10]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=t.$6h=t.$5h=t.$4h=t.$3h=void 0;class n{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),c=this.b.charCodeAt(this.c);return e-c}value(){return this.b[this.c]}}t.$3h=n;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,R.$1e)(l,this.b,0,l.length,this.c,this.d):(0,R.$3e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$4h=j;class k{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const c=this.b.charCodeAt(e);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,R.$1e)(l,this.b,0,l.length,this.d,this.e):(0,R.$3e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$5h=k;var C;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(C||(C={}));class ${constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,R.$2e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,R.$2e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,R.$Ze)(l,this.c.query);if(this.d[this.e]===5)return(0,R.$Ze)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$6h=$;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(y||(y={}));class O{static forUris(l=()=>!1,e=()=>!1){return new O(new $(l,e))}static forPaths(l=!1){return new O(new k(void 0,!l))}static forStrings(){return new O(new n)}static forConfigKeys(){return new O(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const c=e.slice(0);(0,S.$Xb)(c);for(const d of c)this.set(d,l)}else{const c=l.slice(0);(0,S.$Xb)(c);for(const d of c)this.set(d[0],d[1])}}set(l,e){const c=this.b.reset(l);let d;this.c||(this.c=new v,this.c.segment=c.value());const p=[];for(d=this.c;;){const a=c.cmp(d.segment);if(a>0)d.left||(d.left=new v,d.left.segment=c.value()),p.push([-1,d]),d=d.left;else if(a<0)d.right||(d.right=new v,d.right.segment=c.value()),p.push([1,d]),d=d.right;else if(c.hasNext())c.next(),d.mid||(d.mid=new v,d.mid.segment=c.value()),p.push([0,d]),d=d.mid;else break}const o=d.value;d.value=e,d.key=l;for(let a=p.length-1;a>=0;a--){const E=p[a][1];E.updateHeight();const m=E.balanceFactor();if(m<-1||m>1){const f=p[a][0],N=p[a+1][0];if(f===1&&N===1)p[a][1]=E.rotateLeft();else if(f===-1&&N===-1)p[a][1]=E.rotateRight();else if(f===1&&N===-1)E.right=p[a+1][1]=p[a+1][1].rotateRight(),p[a][1]=E.rotateLeft();else if(f===-1&&N===1)E.left=p[a+1][1]=p[a+1][1].rotateLeft(),p[a][1]=E.rotateRight();else throw new Error;if(a>0)switch(p[a-1][0]){case-1:p[a-1][1].left=p[a][1];break;case 1:p[a-1][1].right=p[a][1];break;case 0:p[a-1][1].mid=p[a][1];break}else this.c=p[0][1]}}return o}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let c=this.c;for(;c;){const d=e.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(e.hasNext())e.next(),c=c.mid;else break}return c}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const c=this.b.reset(l),d=[];let p=this.c;for(;p;){const o=c.cmp(p.segment);if(o>0)d.push([-1,p]),p=p.left;else if(o<0)d.push([1,p]),p=p.right;else if(c.hasNext())c.next(),d.push([0,p]),p=p.mid;else break}if(p){if(e?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const o=this.f(p.right);if(o.key){const{key:a,value:E,segment:m}=o;this.e(o.key,!1),p.key=a,p.value=E,p.segment=m}}else{const o=p.left??p.right;if(d.length>0){const[a,E]=d[d.length-1];switch(a){case-1:E.left=o;break;case 0:E.mid=o;break;case 1:E.right=o;break}}else this.c=o}for(let o=d.length-1;o>=0;o--){const a=d[o][1];a.updateHeight();const E=a.balanceFactor();if(E>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),d[o][1]=a.rotateLeft()):E<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),d[o][1]=a.rotateRight()),o>0)switch(d[o-1][0]){case-1:d[o-1][1].left=d[o][1];break;case 1:d[o-1][1].right=d[o][1];break;case 0:d[o-1][1].mid=d[o][1];break}else this.c=d[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let c=this.c,d;for(;c;){const p=e.cmp(c.segment);if(p>0)c=c.left;else if(p<0)c=c.right;else if(e.hasNext())e.next(),d=c.value||d,c=c.mid;else break}return c&&c.value||d}findSuperstr(l){return this.g(l,!1)}g(l,e){const c=this.b.reset(l);let d=this.c;for(;d;){const p=c.cmp(d.segment);if(p>0)d=d.left;else if(p<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else return d.mid?this.h(d.mid):e?d.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,c]of this)l(c,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const c=e.balanceFactor();return c<-1||c>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.$7h=O}),define(ge[7],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=void 0;function S(m){return typeof m=="string"}t.$Df=S;function R(m){return Array.isArray(m)&&m.every(f=>S(f))}t.$Ef=R;function n(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}t.$Ff=n;function j(m){const f=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof f}t.$Gf=j;function k(m){return typeof m=="number"&&!isNaN(m)}t.$Hf=k;function C(m){return!!m&&typeof m[Symbol.iterator]=="function"}t.$If=C;function $(m){return m===!0||m===!1}t.$Jf=$;function v(m){return typeof m>"u"}t.$Kf=v;function y(m){return!O(m)}t.$Lf=y;function O(m){return v(m)||m===null}t.$Mf=O;function r(m,f){if(!m)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}t.$Nf=r;function l(m){if(O(m))throw new Error("Assertion Failed: argument is undefined or null");return m}t.$Of=l;function e(...m){const f=[];for(let N=0;N<m.length;N++){const B=m[N];if(O(B))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);f.push(B)}return f}t.$Pf=e;const c=Object.prototype.hasOwnProperty;function d(m){if(!n(m))return!1;for(const f in m)if(c.call(m,f))return!1;return!0}t.$Qf=d;function p(m){return typeof m=="function"}t.$Rf=p;function o(...m){return m.length>0&&m.every(p)}t.$Sf=o;function a(m,f){const N=Math.min(m.length,f.length);for(let B=0;B<N;B++)E(m[B],f[B])}t.$Tf=a;function E(m,f){if(S(f)){if(typeof m!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(p(f)){try{if(m instanceof f)return}catch{}if(!O(m)&&m.constructor===f||f.length===1&&f.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Uf=E}),define(ge[17],me([1,0,7]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6j=t.$5j=t.$4j=void 0;const R=Object.create(null);function n(C,$){if((0,S.$Df)($)){const v=R[$];if(v===void 0)throw new Error(`${C} references an unknown codicon: ${$}`);$=v}return R[C]=$,{id:C}}function j(){return R}t.$4j=j;function k(){return Object.values(t.$6j)}t.$5j=k,t.$6j={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),robot:n("robot",60448),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ge[51],me([1,0,7]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qn=t.$pn=t.$on=t.$nn=t.$mn=t.$ln=t.$kn=t.$jn=t.$in=t.$hn=t.$gn=t.$fn=void 0;function R(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const o=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([a,E])=>{o[a]=E&&typeof E=="object"?R(E):E}),o}t.$fn=R;function n(p){if(!p||typeof p!="object")return p;const o=[p];for(;o.length>0;){const a=o.shift();Object.freeze(a);for(const E in a)if(j.call(a,E)){const m=a[E];typeof m=="object"&&!Object.isFrozen(m)&&!(0,S.$Gf)(m)&&o.push(m)}}return p}t.$gn=n;const j=Object.prototype.hasOwnProperty;function k(p,o){return C(p,o,new Set)}t.$hn=k;function C(p,o,a){if((0,S.$Mf)(p))return p;const E=o(p);if(typeof E<"u")return E;if(Array.isArray(p)){const m=[];for(const f of p)m.push(C(f,o,a));return m}if((0,S.$Ff)(p)){if(a.has(p))throw new Error("Cannot clone recursive data-structure");a.add(p);const m={};for(const f in p)j.call(p,f)&&(m[f]=C(p[f],o,a));return a.delete(p),m}return p}function $(p,o,a=!0){return(0,S.$Ff)(p)?((0,S.$Ff)(o)&&Object.keys(o).forEach(E=>{E in p?a&&((0,S.$Ff)(p[E])&&(0,S.$Ff)(o[E])?$(p[E],o[E],a):p[E]=o[E]):p[E]=o[E]}),p):o}t.$in=$;function v(p,o){if(p===o)return!0;if(p==null||o===null||o===void 0||typeof p!=typeof o||typeof p!="object"||Array.isArray(p)!==Array.isArray(o))return!1;let a,E;if(Array.isArray(p)){if(p.length!==o.length)return!1;for(a=0;a<p.length;a++)if(!v(p[a],o[a]))return!1}else{const m=[];for(E in p)m.push(E);m.sort();const f=[];for(E in o)f.push(E);if(f.sort(),!v(m,f))return!1;for(a=0;a<m.length;a++)if(!v(p[m[a]],o[m[a]]))return!1}return!0}t.$jn=v;function y(p){const o=new Set;return JSON.stringify(p,(a,E)=>{if((0,S.$Ff)(E)||Array.isArray(E)){if(o.has(E))return"[Circular]";o.add(E)}return E})}t.$kn=y;function O(p,o){const a=Object.create(null);return!p||!o||Object.keys(o).forEach(m=>{const f=p[m],N=o[m];v(f,N)||(a[m]=N)}),a}t.$ln=O;function r(p,o){const a=o.toLowerCase(),E=Object.keys(p).find(m=>m.toLowerCase()===a);return E?p[E]:p[o]}t.$mn=r;function l(p,o){const a=Object.create(null);for(const[E,m]of Object.entries(p))o(E,m)&&(a[E]=m);return a}t.$nn=l;function e(p){let o=[];for(;Object.prototype!==p;)o=o.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return o}t.$on=e;function c(p){const o=[];for(const a of e(p))typeof p[a]=="function"&&o.push(a);return o}t.$pn=c;function d(p,o){const a=m=>function(){const f=Array.prototype.slice.call(arguments,0);return o(m,f)},E={};for(const m of p)E[m]=a(m);return E}t.$qn=d}),define(ge[18],me([1,0,17]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$7j=t.ThemeColor=void 0;var R;(function(k){function C($){return $&&typeof $=="object"&&typeof $.id=="string"}k.isThemeColor=C})(R||(t.ThemeColor=R={}));function n(k){return{id:k}}t.$7j=n;var j;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function $(o){const a=C.exec(o.id);if(!a)return $(S.$6j.error);const[,E,m]=a,f=["codicon","codicon-"+E];return m&&f.push("codicon-modifier-"+m.substring(1)),f}k.asClassNameArray=$;function v(o){return $(o).join(" ")}k.asClassName=v;function y(o){return"."+$(o).join(".")}k.asCSSSelector=y;function O(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||R.isThemeColor(o.color))}k.isThemeIcon=O;const r=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function l(o){const a=r.exec(o);if(!a)return;const[,E]=a;return{id:E}}k.fromString=l;function e(o){return{id:o}}k.fromId=e;function c(o,a){let E=o.id;const m=E.lastIndexOf("~");return m!==-1&&(E=E.substring(0,m)),a&&(E=`${E}~${a}`),{id:E}}k.modify=c;function d(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}k.getModifier=d;function p(o,a){return o.id===a.id&&o.color?.id===a.color?.id}k.isEqual=p})(j||(t.ThemeIcon=j={}))}),define(ge[35],me([1,0,34,10,18]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=void 0;const j="$(",k=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${k.source}`,"g");function $(p){return p.replace(C,(o,a)=>a?o:`\\${o}`)}t.$8j=$;const v=new RegExp(`\\\\${k.source}`,"g");function y(p){return p.replace(v,o=>`\\${o}`)}t.$9j=y;const O=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function r(p){return p.indexOf(j)===-1?p:p.replace(O,(o,a,E,m)=>E?o:a||m||"")}t.$0j=r;function l(p){return p?p.replace(/\$\((.*?)\)/g,(o,a)=>` ${a} `).trim():""}t.$$j=l;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(p){e.lastIndex=0;let o="";const a=[];let E=0;for(;;){const m=e.lastIndex,f=e.exec(p),N=p.substring(m,f?.index);if(N.length>0){o+=N;for(let B=0;B<N.length;B++)a.push(E)}if(!f)break;E+=f[0].length}return{text:o,iconOffsets:a}}t.$_j=c;function d(p,o,a=!1){const{text:E,iconOffsets:m}=o;if(!m||m.length===0)return(0,S.$Uj)(p,E,a);const f=(0,R.$Oe)(E," "),N=E.length-f.length,B=(0,S.$Uj)(p,f,a);if(B)for(const L of B){const w=m[L.start+N]+N;L.start+=w,L.end+=w}return B}t.$ak=d}),define(ge[88],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9T=t.$8T=void 0,t.$8T="vscode:contextmenu",t.$9T="vscode:onCloseContextMenu"}),define(ge[89],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dU=void 0;class S{constructor(n,j){this.a=n,this.onMessage=j}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$dU=S}),define(ge[30],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const S=globalThis.vscode;t.$O=S.ipcRenderer,t.$P=S.ipcMessagePort,t.$Q=S.webFrame,t.$R=S.process,t.$S=S.context}),define(ge[90],me([1,0,88,30]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_T=void 0;let n=0;function j(C,$,v){const y=[],O=n++,r=`vscode:onContextMenu${O}`,l=(e,c,d)=>{y[c].click?.(d)};R.$O.once(r,l),R.$O.once(S.$9T,(e,c)=>{c===O&&(R.$O.removeListener(r,l),v?.())}),R.$O.send(S.$8T,O,C.map(e=>k(e,y)),r,$)}t.$_T=j;function k(C,$){const v={id:$.length,label:C.label,type:C.type,accelerator:C.accelerator,checked:C.checked,enabled:typeof C.enabled=="boolean"?C.enabled:!0,visible:typeof C.visible=="boolean"?C.visible:!0};return $.push(C),Array.isArray(C.submenu)&&(v.submenu=C.submenu.map(y=>k(y,$))),v}}),define(ge[52],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([1,0,92,93]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[95],me([8]),{}),define(ge[96],me([8]),{}),define(ge[97],me([8]),{}),define(ge[98],me([8]),{}),define(ge[99],me([8]),{}),define(ge[100],me([8]),{}),define(ge[101],me([8]),{}),define(ge[102],me([8]),{}),define(ge[103],me([8]),{}),define(ge[104],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[105],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[106],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[107],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[108],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[109],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[110],me([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[111],me([13,11]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define(ge[36],me([1,0,4,2,111]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ki=t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=void 0;class j extends R.$Sc{constructor(r,l="",e="",c=!0,d){super(),this.h=this.B(new S.$Sd),this.onDidChange=this.h.event,this.z=!0,this.m=r,this.n=l,this.w=e,this.z=c,this.D=d}get id(){return this.m}get label(){return this.n}set label(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({label:r}))}get tooltip(){return this.u||""}set tooltip(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({tooltip:r}))}get class(){return this.w}set class(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({class:r}))}get enabled(){return this.z}set enabled(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({enabled:r}))}get checked(){return this.C}set checked(r){this.J(r)}J(r){this.C!==r&&(this.C=r,this.h.fire({checked:r}))}async run(r,l){this.D&&await this.D(r)}}t.$Fi=j;class k extends R.$Sc{constructor(){super(...arguments),this.f=this.B(new S.$Sd),this.onWillRun=this.f.event,this.m=this.B(new S.$Sd),this.onDidRun=this.m.event}async run(r,l){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.u(r,l)}catch(c){e=c}this.m.fire({action:r,error:e})}async u(r,l){await r.run(l)}}t.$Gi=k;class C{constructor(){this.id=C.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let l=[];for(const e of r)e.length&&(l.length?l=[...l,new C,...e]:l=e);return l}static{this.ID="vs.actions.separator"}async run(){}}t.$Hi=C;class ${get actions(){return this.a}constructor(r,l,e,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=l,this.class=c,this.a=e}async run(){}}t.$Ii=$;class v extends j{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,n.localize(0,null),void 0,!1)}}t.$Ji=v;function y(O){return{id:O.id,label:O.label,class:O.class,enabled:O.enabled??!0,checked:O.checked??!1,run:async(...r)=>O.run(...r),tooltip:O.label}}t.$Ki=y}),define(ge[112],me([13,11]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,112]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let R=!1,n=!1,j=!1,k=!1,C=!1,$=!1,v=!1,y=!1,O=!1,r=!1,l,e=t.$g,c=t.$g,d,p;const o=globalThis;let a;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?a=o.vscode.process:typeof process<"u"&&(a=process);const E=typeof a?.versions?.electron=="string",m=E&&a?.type==="renderer";if(typeof navigator=="object"&&!m)p=navigator.userAgent,R=p.indexOf("Windows")>=0,n=p.indexOf("Macintosh")>=0,y=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=p.indexOf("Linux")>=0,r=p?.indexOf("Mobi")>=0,$=!0,l=S.getConfiguredDefaultLocale(S.localize(0,null))||t.$g,e=l,c=navigator.language;else if(typeof a=="object"){R=a.platform==="win32",n=a.platform==="darwin",j=a.platform==="linux",k=j&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,v=E,O=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.$g,e=t.$g;const F=a.env.VSCODE_NLS_CONFIG;if(F)try{const I=JSON.parse(F),z=I.availableLanguages["*"];l=I.locale,c=I.osLocale,e=z||t.$g,d=I._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var f;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(f||(t.Platform=f={}));function N(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=N;let B=0;n?B=1:R?B=3:j&&(B=2),t.$i=R,t.$j=n,t.$k=j,t.$l=k,t.$m=C,t.$n=v,t.$o=$,t.$p=$&&typeof o.importScripts=="function",t.$q=t.$p?o.origin:void 0,t.$r=y,t.$s=r,t.$t=O,t.$u=B,t.$v=p,t.$w=e;var L;(function(F){function I(){return t.$w}F.value=I;function z(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}F.isDefaultVariant=z;function X(){return t.$w==="en"}F.isDefault=X})(L||(t.Language=L={})),t.$x=l,t.$y=c,t.$z=d,t.$A=typeof o.postMessage=="function"&&!o.importScripts,t.$B=(()=>{if(t.$A){const F=[];o.addEventListener("message",z=>{if(z.data&&z.data.vscodeScheduleAsyncWork)for(let X=0,G=F.length;X<G;X++){const re=F[X];if(re.id===z.data.vscodeScheduleAsyncWork){F.splice(X,1),re.callback();return}}});let I=0;return z=>{const X=++I;F.push({id:X,callback:z}),o.postMessage({vscodeScheduleAsyncWork:X},"*")}}return F=>setTimeout(F)})();var w;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=n||y?2:R?1:3;let P=!0,M=!1;function U(){if(!M){M=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,P=new Uint16Array(F.buffer)[0]===(2<<8)+1}return P}t.$D=U,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function V(F){return parseFloat(F)>=20}t.$J=V}),define(ge[113],me([1,0,16,21,5]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2O=t.KeyboardSupport=void 0;var j;(function(k){k[k.Always=0]="Always",k[k.FullScreen=1]="FullScreen",k[k.None=2]="None"})(j||(t.KeyboardSupport=j={})),t.$2O={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>n.$m||S.$ZO()?0:navigator.keyboard||S.$VO?1:2)(),touch:"ontouchstart"in R.$FO||navigator.maxTouchPoints>0,pointerEvents:R.$FO.PointerEvent&&("ontouchstart"in R.$FO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[14],me([1,0,16,44,78,5]),function(ne,t,S,R,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0O=t.$9O=t.$8O=void 0;function k(e){if(e.charCode){const d=String.fromCharCode(e.charCode).toUpperCase();return R.KeyCodeUtils.fromString(d)}const c=e.keyCode;if(c===3)return 7;if(S.$SO)switch(c){case 59:return 85;case 60:if(j.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(j.$j)return 57;break}else if(S.$TO){if(j.$j&&c===93)return 57;if(!j.$j&&c===92)return 57}return R.$Lq[c]||0}const C=j.$j?256:2048,$=512,v=1024,y=j.$j?2048:256;function O(e){const c=[];return e.ctrlKey&&c.push("ctrl"),e.shiftKey&&c.push("shift"),e.altKey&&c.push("alt"),e.metaKey&&c.push("meta"),`modifiers: [${c.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$8O=O;function r(e){const c=[];return e.ctrlKey&&c.push("ctrl"),e.shiftKey&&c.push("shift"),e.altKey&&c.push("alt"),e.metaKey&&c.push("meta"),`modifiers: [${c.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${R.KeyCodeUtils.toString(e.keyCode)}')`}t.$9O=r;class l{constructor(c){this._standardKeyboardEventBrand=!0;const d=c;this.browserEvent=d,this.target=d.target,this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,this.altGraphKey=d.getModifierState("AltGraph"),this.keyCode=k(d),this.code=d.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(c){return this.a===c}c(){let c=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(c=this.keyCode);let d=0;return this.ctrlKey&&(d|=C),this.altKey&&(d|=$),this.shiftKey&&(d|=v),this.metaKey&&(d|=y),d|=c,d}d(){let c=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(c=this.keyCode),new n.$Tq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,c)}}t.$0O=l}),define(ge[19],me([1,0,16,69,5]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7O=t.$6O=t.$5O=void 0;class j{constructor(v,y){this.timestamp=Date.now(),this.browserEvent=y,this.leftButton=y.button===0,this.middleButton=y.button===1,this.rightButton=y.button===2,this.buttons=y.buttons,this.target=y.target,this.detail=y.detail||1,y.type==="dblclick"&&(this.detail=2),this.ctrlKey=y.ctrlKey,this.shiftKey=y.shiftKey,this.altKey=y.altKey,this.metaKey=y.metaKey,typeof y.pageX=="number"?(this.posx=y.pageX,this.posy=y.pageY):(this.posx=y.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=y.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const O=R.$3O.getPositionOfChildWindowRelativeToAncestorWindow(v,y.view);this.posx-=O.left,this.posy-=O.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$5O=j;class k extends j{constructor(v,y){super(v,y),this.dataTransfer=y.dataTransfer}}t.$6O=k;class C{constructor(v,y=0,O=0){if(this.browserEvent=v||null,this.target=v?v.target||v.targetNode||v.srcElement:null,this.deltaY=O,this.deltaX=y,v){const r=v,l=v;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(v.type==="wheel"){const e=v;e.deltaMode===e.DOM_DELTA_LINE?S.$SO&&!n.$j?this.deltaY=-v.deltaY/3:this.deltaY=-v.deltaY:this.deltaY=-v.deltaY/40}if(typeof r.wheelDeltaX<"u")S.$VO&&n.$i?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-v.detail/3;else if(v.type==="wheel"){const e=v;e.deltaMode===e.DOM_DELTA_LINE?S.$SO&&!n.$j?this.deltaX=-v.deltaX/3:this.deltaX=-v.deltaX:this.deltaX=-v.deltaX/40}this.deltaY===0&&this.deltaX===0&&v.wheelDelta&&(this.deltaY=v.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$7O=C}),define(ge[114],me([1,0,5]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let R;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const j=n.process;R={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=R.cwd,t.env=R.env,t.$dc=R.platform,t.$ec=R.arch}),define(ge[24],me([1,0,114]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const R=65,n=97,j=90,k=122,C=46,$=47,v=92,y=58,O=63;class r extends Error{constructor(N,B,L){let w;typeof B=="string"&&B.indexOf("not ")===0?(w="must not be",B=B.replace(/^not /,"")):w="must be";const P=N.indexOf(".")!==-1?"property":"argument";let M=`The "${N}" ${P} ${w} of type ${B}`;M+=`. Received type ${typeof L}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function l(f,N){if(f===null||typeof f!="object")throw new r(N,"Object",f)}function e(f,N){if(typeof f!="string")throw new r(N,"string",f)}const c=S.$dc==="win32";function d(f){return f===$||f===v}function p(f){return f===$}function o(f){return f>=R&&f<=j||f>=n&&f<=k}function a(f,N,B,L){let w="",P=0,M=-1,U=0,V=0;for(let F=0;F<=f.length;++F){if(F<f.length)V=f.charCodeAt(F);else{if(L(V))break;V=$}if(L(V)){if(!(M===F-1||U===1))if(U===2){if(w.length<2||P!==2||w.charCodeAt(w.length-1)!==C||w.charCodeAt(w.length-2)!==C){if(w.length>2){const I=w.lastIndexOf(B);I===-1?(w="",P=0):(w=w.slice(0,I),P=w.length-1-w.lastIndexOf(B)),M=F,U=0;continue}else if(w.length!==0){w="",P=0,M=F,U=0;continue}}N&&(w+=w.length>0?`${B}..`:"..",P=2)}else w.length>0?w+=`${B}${f.slice(M+1,F)}`:w=f.slice(M+1,F),P=F-M-1;M=F,U=0}else V===C&&U!==-1?++U:U=-1}return w}function E(f,N){l(N,"pathObject");const B=N.dir||N.root,L=N.base||`${N.name||""}${N.ext||""}`;return B?B===N.root?`${B}${L}`:`${B}${f}${L}`:L}t.$fc={resolve(...f){let N="",B="",L=!1;for(let w=f.length-1;w>=-1;w--){let P;if(w>=0){if(P=f[w],e(P,"path"),P.length===0)continue}else N.length===0?P=S.cwd():(P=S.env[`=${N}`]||S.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==N.toLowerCase()&&P.charCodeAt(2)===v)&&(P=`${N}\\`));const M=P.length;let U=0,V="",F=!1;const I=P.charCodeAt(0);if(M===1)d(I)&&(U=1,F=!0);else if(d(I))if(F=!0,d(P.charCodeAt(1))){let z=2,X=z;for(;z<M&&!d(P.charCodeAt(z));)z++;if(z<M&&z!==X){const G=P.slice(X,z);for(X=z;z<M&&d(P.charCodeAt(z));)z++;if(z<M&&z!==X){for(X=z;z<M&&!d(P.charCodeAt(z));)z++;(z===M||z!==X)&&(V=`\\\\${G}\\${P.slice(X,z)}`,U=z)}}}else U=1;else o(I)&&P.charCodeAt(1)===y&&(V=P.slice(0,2),U=2,M>2&&d(P.charCodeAt(2))&&(F=!0,U=3));if(V.length>0)if(N.length>0){if(V.toLowerCase()!==N.toLowerCase())continue}else N=V;if(L){if(N.length>0)break}else if(B=`${P.slice(U)}\\${B}`,L=F,F&&N.length>0)break}return B=a(B,!L,"\\",d),L?`${N}\\${B}`:`${N}${B}`||"."},normalize(f){e(f,"path");const N=f.length;if(N===0)return".";let B=0,L,w=!1;const P=f.charCodeAt(0);if(N===1)return p(P)?"\\":f;if(d(P))if(w=!0,d(f.charCodeAt(1))){let U=2,V=U;for(;U<N&&!d(f.charCodeAt(U));)U++;if(U<N&&U!==V){const F=f.slice(V,U);for(V=U;U<N&&d(f.charCodeAt(U));)U++;if(U<N&&U!==V){for(V=U;U<N&&!d(f.charCodeAt(U));)U++;if(U===N)return`\\\\${F}\\${f.slice(V)}\\`;U!==V&&(L=`\\\\${F}\\${f.slice(V,U)}`,B=U)}}}else B=1;else o(P)&&f.charCodeAt(1)===y&&(L=f.slice(0,2),B=2,N>2&&d(f.charCodeAt(2))&&(w=!0,B=3));let M=B<N?a(f.slice(B),!w,"\\",d):"";return M.length===0&&!w&&(M="."),M.length>0&&d(f.charCodeAt(N-1))&&(M+="\\"),L===void 0?w?`\\${M}`:M:w?`${L}\\${M}`:`${L}${M}`},isAbsolute(f){e(f,"path");const N=f.length;if(N===0)return!1;const B=f.charCodeAt(0);return d(B)||N>2&&o(B)&&f.charCodeAt(1)===y&&d(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let N,B;for(let P=0;P<f.length;++P){const M=f[P];e(M,"path"),M.length>0&&(N===void 0?N=B=M:N+=`\\${M}`)}if(N===void 0)return".";let L=!0,w=0;if(typeof B=="string"&&d(B.charCodeAt(0))){++w;const P=B.length;P>1&&d(B.charCodeAt(1))&&(++w,P>2&&(d(B.charCodeAt(2))?++w:L=!1))}if(L){for(;w<N.length&&d(N.charCodeAt(w));)w++;w>=2&&(N=`\\${N.slice(w)}`)}return t.$fc.normalize(N)},relative(f,N){if(e(f,"from"),e(N,"to"),f===N)return"";const B=t.$fc.resolve(f),L=t.$fc.resolve(N);if(B===L||(f=B.toLowerCase(),N=L.toLowerCase(),f===N))return"";let w=0;for(;w<f.length&&f.charCodeAt(w)===v;)w++;let P=f.length;for(;P-1>w&&f.charCodeAt(P-1)===v;)P--;const M=P-w;let U=0;for(;U<N.length&&N.charCodeAt(U)===v;)U++;let V=N.length;for(;V-1>U&&N.charCodeAt(V-1)===v;)V--;const F=V-U,I=M<F?M:F;let z=-1,X=0;for(;X<I;X++){const re=f.charCodeAt(w+X);if(re!==N.charCodeAt(U+X))break;re===v&&(z=X)}if(X!==I){if(z===-1)return L}else{if(F>I){if(N.charCodeAt(U+X)===v)return L.slice(U+X+1);if(X===2)return L.slice(U+X)}M>I&&(f.charCodeAt(w+X)===v?z=X:X===2&&(z=3)),z===-1&&(z=0)}let G="";for(X=w+z+1;X<=P;++X)(X===P||f.charCodeAt(X)===v)&&(G+=G.length===0?"..":"\\..");return U+=z,G.length>0?`${G}${L.slice(U,V)}`:(L.charCodeAt(U)===v&&++U,L.slice(U,V))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const N=t.$fc.resolve(f);if(N.length<=2)return f;if(N.charCodeAt(0)===v){if(N.charCodeAt(1)===v){const B=N.charCodeAt(2);if(B!==O&&B!==C)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(o(N.charCodeAt(0))&&N.charCodeAt(1)===y&&N.charCodeAt(2)===v)return`\\\\?\\${N}`;return f},dirname(f){e(f,"path");const N=f.length;if(N===0)return".";let B=-1,L=0;const w=f.charCodeAt(0);if(N===1)return d(w)?f:".";if(d(w)){if(B=L=1,d(f.charCodeAt(1))){let U=2,V=U;for(;U<N&&!d(f.charCodeAt(U));)U++;if(U<N&&U!==V){for(V=U;U<N&&d(f.charCodeAt(U));)U++;if(U<N&&U!==V){for(V=U;U<N&&!d(f.charCodeAt(U));)U++;if(U===N)return f;U!==V&&(B=L=U+1)}}}}else o(w)&&f.charCodeAt(1)===y&&(B=N>2&&d(f.charCodeAt(2))?3:2,L=B);let P=-1,M=!0;for(let U=N-1;U>=L;--U)if(d(f.charCodeAt(U))){if(!M){P=U;break}}else M=!1;if(P===-1){if(B===-1)return".";P=B}return f.slice(0,P)},basename(f,N){N!==void 0&&e(N,"ext"),e(f,"path");let B=0,L=-1,w=!0,P;if(f.length>=2&&o(f.charCodeAt(0))&&f.charCodeAt(1)===y&&(B=2),N!==void 0&&N.length>0&&N.length<=f.length){if(N===f)return"";let M=N.length-1,U=-1;for(P=f.length-1;P>=B;--P){const V=f.charCodeAt(P);if(d(V)){if(!w){B=P+1;break}}else U===-1&&(w=!1,U=P+1),M>=0&&(V===N.charCodeAt(M)?--M===-1&&(L=P):(M=-1,L=U))}return B===L?L=U:L===-1&&(L=f.length),f.slice(B,L)}for(P=f.length-1;P>=B;--P)if(d(f.charCodeAt(P))){if(!w){B=P+1;break}}else L===-1&&(w=!1,L=P+1);return L===-1?"":f.slice(B,L)},extname(f){e(f,"path");let N=0,B=-1,L=0,w=-1,P=!0,M=0;f.length>=2&&f.charCodeAt(1)===y&&o(f.charCodeAt(0))&&(N=L=2);for(let U=f.length-1;U>=N;--U){const V=f.charCodeAt(U);if(d(V)){if(!P){L=U+1;break}continue}w===-1&&(P=!1,w=U+1),V===C?B===-1?B=U:M!==1&&(M=1):B!==-1&&(M=-1)}return B===-1||w===-1||M===0||M===1&&B===w-1&&B===L+1?"":f.slice(B,w)},format:E.bind(null,"\\"),parse(f){e(f,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return N;const B=f.length;let L=0,w=f.charCodeAt(0);if(B===1)return d(w)?(N.root=N.dir=f,N):(N.base=N.name=f,N);if(d(w)){if(L=1,d(f.charCodeAt(1))){let z=2,X=z;for(;z<B&&!d(f.charCodeAt(z));)z++;if(z<B&&z!==X){for(X=z;z<B&&d(f.charCodeAt(z));)z++;if(z<B&&z!==X){for(X=z;z<B&&!d(f.charCodeAt(z));)z++;z===B?L=z:z!==X&&(L=z+1)}}}}else if(o(w)&&f.charCodeAt(1)===y){if(B<=2)return N.root=N.dir=f,N;if(L=2,d(f.charCodeAt(2))){if(B===3)return N.root=N.dir=f,N;L=3}}L>0&&(N.root=f.slice(0,L));let P=-1,M=L,U=-1,V=!0,F=f.length-1,I=0;for(;F>=L;--F){if(w=f.charCodeAt(F),d(w)){if(!V){M=F+1;break}continue}U===-1&&(V=!1,U=F+1),w===C?P===-1?P=F:I!==1&&(I=1):P!==-1&&(I=-1)}return U!==-1&&(P===-1||I===0||I===1&&P===U-1&&P===M+1?N.base=N.name=f.slice(M,U):(N.name=f.slice(M,P),N.base=f.slice(M,U),N.ext=f.slice(P,U))),M>0&&M!==L?N.dir=f.slice(0,M-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(c){const f=/\\/g;return()=>{const N=S.cwd().replace(f,"/");return N.slice(N.indexOf("/"))}}return()=>S.cwd()})();t.$gc={resolve(...f){let N="",B=!1;for(let L=f.length-1;L>=-1&&!B;L--){const w=L>=0?f[L]:m();e(w,"path"),w.length!==0&&(N=`${w}/${N}`,B=w.charCodeAt(0)===$)}return N=a(N,!B,"/",p),B?`/${N}`:N.length>0?N:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const N=f.charCodeAt(0)===$,B=f.charCodeAt(f.length-1)===$;return f=a(f,!N,"/",p),f.length===0?N?"/":B?"./":".":(B&&(f+="/"),N?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===$},join(...f){if(f.length===0)return".";let N;for(let B=0;B<f.length;++B){const L=f[B];e(L,"path"),L.length>0&&(N===void 0?N=L:N+=`/${L}`)}return N===void 0?".":t.$gc.normalize(N)},relative(f,N){if(e(f,"from"),e(N,"to"),f===N||(f=t.$gc.resolve(f),N=t.$gc.resolve(N),f===N))return"";const B=1,L=f.length,w=L-B,P=1,M=N.length-P,U=w<M?w:M;let V=-1,F=0;for(;F<U;F++){const z=f.charCodeAt(B+F);if(z!==N.charCodeAt(P+F))break;z===$&&(V=F)}if(F===U)if(M>U){if(N.charCodeAt(P+F)===$)return N.slice(P+F+1);if(F===0)return N.slice(P+F)}else w>U&&(f.charCodeAt(B+F)===$?V=F:F===0&&(V=0));let I="";for(F=B+V+1;F<=L;++F)(F===L||f.charCodeAt(F)===$)&&(I+=I.length===0?"..":"/..");return`${I}${N.slice(P+V)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const N=f.charCodeAt(0)===$;let B=-1,L=!0;for(let w=f.length-1;w>=1;--w)if(f.charCodeAt(w)===$){if(!L){B=w;break}}else L=!1;return B===-1?N?"/":".":N&&B===1?"//":f.slice(0,B)},basename(f,N){N!==void 0&&e(N,"ext"),e(f,"path");let B=0,L=-1,w=!0,P;if(N!==void 0&&N.length>0&&N.length<=f.length){if(N===f)return"";let M=N.length-1,U=-1;for(P=f.length-1;P>=0;--P){const V=f.charCodeAt(P);if(V===$){if(!w){B=P+1;break}}else U===-1&&(w=!1,U=P+1),M>=0&&(V===N.charCodeAt(M)?--M===-1&&(L=P):(M=-1,L=U))}return B===L?L=U:L===-1&&(L=f.length),f.slice(B,L)}for(P=f.length-1;P>=0;--P)if(f.charCodeAt(P)===$){if(!w){B=P+1;break}}else L===-1&&(w=!1,L=P+1);return L===-1?"":f.slice(B,L)},extname(f){e(f,"path");let N=-1,B=0,L=-1,w=!0,P=0;for(let M=f.length-1;M>=0;--M){const U=f.charCodeAt(M);if(U===$){if(!w){B=M+1;break}continue}L===-1&&(w=!1,L=M+1),U===C?N===-1?N=M:P!==1&&(P=1):N!==-1&&(P=-1)}return N===-1||L===-1||P===0||P===1&&N===L-1&&N===B+1?"":f.slice(N,L)},format:E.bind(null,"/"),parse(f){e(f,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return N;const B=f.charCodeAt(0)===$;let L;B?(N.root="/",L=1):L=0;let w=-1,P=0,M=-1,U=!0,V=f.length-1,F=0;for(;V>=L;--V){const I=f.charCodeAt(V);if(I===$){if(!U){P=V+1;break}continue}M===-1&&(U=!1,M=V+1),I===C?w===-1?w=V:F!==1&&(F=1):w!==-1&&(F=-1)}if(M!==-1){const I=P===0&&B?1:P;w===-1||F===0||F===1&&w===M-1&&w===P+1?N.base=N.name=f.slice(I,M):(N.name=f.slice(I,w),N.base=f.slice(I,M),N.ext=f.slice(w,M))}return P>0?N.dir=f.slice(0,P-1):B&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=c?t.$fc.normalize:t.$gc.normalize,t.$ic=c?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=c?t.$fc.join:t.$gc.join,t.$kc=c?t.$fc.resolve:t.$gc.resolve,t.$lc=c?t.$fc.relative:t.$gc.relative,t.$mc=c?t.$fc.dirname:t.$gc.dirname,t.$nc=c?t.$fc.basename:t.$gc.basename,t.$oc=c?t.$fc.extname:t.$gc.extname,t.$pc=c?t.$fc.format:t.$gc.format,t.$qc=c?t.$fc.parse:t.$gc.parse,t.$rc=c?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=c?t.$fc.sep:t.$gc.sep,t.$tc=c?t.$fc.delimiter:t.$gc.delimiter}),define(ge[115],me([1,0,24,5,10,7]),function(ne,t,S,R,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=void 0;function k(P){return P===47||P===92}t.$Vf=k;function C(P){return P.replace(/[\\/]/g,S.$gc.sep)}t.$Wf=C;function $(P){return P.indexOf("/")===-1&&(P=C(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}t.$Xf=$;function v(P,M=S.$gc.sep){if(!P)return"";const U=P.length,V=P.charCodeAt(0);if(k(V)){if(k(P.charCodeAt(1))&&!k(P.charCodeAt(2))){let I=3;const z=I;for(;I<U&&!k(P.charCodeAt(I));I++);if(z!==I&&!k(P.charCodeAt(I+1))){for(I+=1;I<U;I++)if(k(P.charCodeAt(I)))return P.slice(0,I+1).replace(/[\\/]/g,M)}}return M}else if(p(V)&&P.charCodeAt(1)===58)return k(P.charCodeAt(2))?P.slice(0,2)+M:P.slice(0,2);let F=P.indexOf("://");if(F!==-1){for(F+=3;F<U;F++)if(k(P.charCodeAt(F)))return P.slice(0,F+1)}return""}t.$Yf=v;function y(P){if(!R.$i||!P||P.length<5)return!1;let M=P.charCodeAt(0);if(M!==92||(M=P.charCodeAt(1),M!==92))return!1;let U=2;const V=U;for(;U<P.length&&(M=P.charCodeAt(U),M!==92);U++);return!(V===U||(M=P.charCodeAt(U+1),isNaN(M)||M===92))}t.$Zf=y;const O=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(P,M=R.$i){const U=M?O:r;return!(!P||P.length===0||/^\s+$/.test(P)||(U.lastIndex=0,U.test(P))||M&&l.test(P)||P==="."||P===".."||M&&P[P.length-1]==="."||M&&P.length!==P.trim().length||P.length>255)}t.$1f=e;function c(P,M,U){const V=P===M;return!U||V?V:!P||!M?!1:(0,n.$7e)(P,M)}t.$2f=c;function d(P,M,U,V=S.sep){if(P===M)return!0;if(!P||!M||M.length>P.length)return!1;if(U){if(!(0,n.$8e)(P,M))return!1;if(M.length===P.length)return!0;let I=M.length;return M.charAt(M.length-1)===V&&I--,P.charAt(I)===V}return M.charAt(M.length-1)!==V&&(M+=V),P.indexOf(M)===0}t.$3f=d;function p(P){return P>=65&&P<=90||P>=97&&P<=122}t.$4f=p;function o(P,M){return R.$i&&P.endsWith(":")&&(P+=S.sep),(0,S.$ic)(P)||(P=(0,S.$jc)(M,P)),P=(0,S.$hc)(P),R.$i?(P=(0,n.$Pe)(P,S.sep),P.endsWith(":")&&(P+=S.sep)):(P=(0,n.$Pe)(P,S.sep),P||(P=S.sep)),P}t.$5f=o;function a(P){const M=(0,S.$hc)(P);return R.$i?P.length>3?!1:E(M)&&(P.length===2||M.charCodeAt(2)===92):M===S.$gc.sep}t.$6f=a;function E(P,M=R.$i){return M?p(P.charCodeAt(0))&&P.charCodeAt(1)===58:!1}t.$7f=E;function m(P,M=R.$i){return E(P,M)?P[0]:void 0}t.$8f=m;function f(P,M,U){return M.length>P.length?-1:P===M?0:(U&&(P=P.toLowerCase(),M=M.toLowerCase()),P.indexOf(M))}t.$9f=f;function N(P){const M=P.split(":");let U,V,F;for(const I of M){const z=Number(I);(0,j.$Hf)(z)?V===void 0?V=z:F===void 0&&(F=z):U=U?[U,I].join(":"):I}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:V!==void 0?V:void 0,column:F!==void 0?F:V!==void 0?1:void 0}}t.$0f=N;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(P,M,U=8){let V="";for(let I=0;I<U;I++){let z;I===0&&R.$i&&!M&&(U===3||U===4)?z=L:z=B,V+=z.charAt(Math.floor(Math.random()*z.length))}let F;return M?F=`${M}-${V}`:F=V,P?(0,S.$jc)(P,F):F}t.$$f=w}),define(ge[116],me([1,0,24]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5r=t.$4r=t.$3r=t.$2r=t.$1r=void 0,t.$1r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(y){const O=(0,S.$oc)(y),r=R[O.toLowerCase()];return r!==void 0?r:k(y)}t.$2r=j;function k(y){const O=(0,S.$oc)(y);return n[O.toLowerCase()]}t.$3r=k;function C(y){for(const O in n)if(n[O]===y)return O}t.$4r=C;const $=/^(.+)\/(.+?)(;.+)?$/;function v(y,O){const r=$.exec(y);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:O?void 0:y}t.$5r=v}),define(ge[15],me([1,0,24,5]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,j=/^\//,k=/^\/\//;function C(L,w){if(!L.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!n.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!j.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(L,w){return!L&&!w?"file":L}function v(L,w){switch(L){case"https":case"http":case"file":w?w[0]!==O&&(w=O+w):w=O;break}return w}const y="",O="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(w){return w instanceof l?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,P,M,U,V,F=!1){typeof w=="object"?(this.scheme=w.scheme||y,this.authority=w.authority||y,this.path=w.path||y,this.query=w.query||y,this.fragment=w.fragment||y):(this.scheme=$(w,F),this.authority=P||y,this.path=v(this.scheme,M||y),this.query=U||y,this.fragment=V||y,C(this,F))}get fsPath(){return E(this,!1)}with(w){if(!w)return this;let{scheme:P,authority:M,path:U,query:V,fragment:F}=w;return P===void 0?P=this.scheme:P===null&&(P=y),M===void 0?M=this.authority:M===null&&(M=y),U===void 0?U=this.path:U===null&&(U=y),V===void 0?V=this.query:V===null&&(V=y),F===void 0?F=this.fragment:F===null&&(F=y),P===this.scheme&&M===this.authority&&U===this.path&&V===this.query&&F===this.fragment?this:new d(P,M,U,V,F)}static parse(w,P=!1){const M=r.exec(w);return M?new d(M[2]||y,B(M[4]||y),B(M[5]||y),B(M[7]||y),B(M[9]||y),P):new d(y,y,y,y,y)}static file(w){let P=y;if(R.$i&&(w=w.replace(/\\/g,O)),w[0]===O&&w[1]===O){const M=w.indexOf(O,2);M===-1?(P=w.substring(2),w=O):(P=w.substring(2,M),w=w.substring(M)||O)}return new d("file",P,w,y,y)}static from(w,P){return new d(w.scheme,w.authority,w.path,w.query,w.fragment,P)}static joinPath(w,...P){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return R.$i&&w.scheme==="file"?M=l.file(S.$fc.join(E(w,!0),...P)).path:M=S.$gc.join(w.path,...P),w.with({path:M})}toString(w=!1){return m(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof l)return w;{const P=new d(w);return P._formatted=w.external??null,P._fsPath=w._sep===c?w.fsPath??null:null,P}}else return w}}t.URI=l;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}t.$vc=e;const c=R.$i?1:void 0;class d extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(w=!1){return w?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=c),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(L,w,P){let M,U=-1;for(let V=0;V<L.length;V++){const F=L.charCodeAt(V);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||w&&F===47||P&&F===91||P&&F===93||P&&F===58)U!==-1&&(M+=encodeURIComponent(L.substring(U,V)),U=-1),M!==void 0&&(M+=L.charAt(V));else{M===void 0&&(M=L.substr(0,V));const I=p[F];I!==void 0?(U!==-1&&(M+=encodeURIComponent(L.substring(U,V)),U=-1),M+=I):U===-1&&(U=V)}}return U!==-1&&(M+=encodeURIComponent(L.substring(U))),M!==void 0?M:L}function a(L){let w;for(let P=0;P<L.length;P++){const M=L.charCodeAt(P);M===35||M===63?(w===void 0&&(w=L.substr(0,P)),w+=p[M]):w!==void 0&&(w+=L[P])}return w!==void 0?w:L}function E(L,w){let P;return L.authority&&L.path.length>1&&L.scheme==="file"?P=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?w?P=L.path.substr(1):P=L.path[1].toLowerCase()+L.path.substr(2):P=L.path,R.$i&&(P=P.replace(/\//g,"\\")),P}t.$wc=E;function m(L,w){const P=w?a:o;let M="",{scheme:U,authority:V,path:F,query:I,fragment:z}=L;if(U&&(M+=U,M+=":"),(V||U==="file")&&(M+=O,M+=O),V){let X=V.indexOf("@");if(X!==-1){const G=V.substr(0,X);V=V.substr(X+1),X=G.lastIndexOf(":"),X===-1?M+=P(G,!1,!1):(M+=P(G.substr(0,X),!1,!1),M+=":",M+=P(G.substr(X+1),!1,!0)),M+="@"}V=V.toLowerCase(),X=V.lastIndexOf(":"),X===-1?M+=P(V,!1,!0):(M+=P(V.substr(0,X),!1,!0),M+=V.substr(X))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const X=F.charCodeAt(1);X>=65&&X<=90&&(F=`/${String.fromCharCode(X+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const X=F.charCodeAt(0);X>=65&&X<=90&&(F=`${String.fromCharCode(X+32)}:${F.substr(2)}`)}M+=P(F,!0,!1)}return I&&(M+="?",M+=P(I,!1,!1)),z&&(M+="#",M+=w?z:o(z,!1,!1)),M}function f(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+f(L.substr(3)):L}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function B(L){return L.match(N)?L.replace(N,w=>f(w)):L}}),define(ge[53],me([1,0,33,15]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xh=t.$wh=t.$vh=void 0;function n($){return JSON.stringify($,k)}t.$vh=n;function j($){let v=JSON.parse($);return v=C(v),v}t.$wh=j;function k($,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function C($,v=0){if(!$||v>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return R.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof S.$ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let y=0;y<$.length;++y)$[y]=C($[y],v+1);else for(const y in $)Object.hasOwnProperty.call($,y)&&($[y]=C($[y],v+1))}return $}t.$xh=C}),define(ge[31],me([1,0,6,5,10,15]),function(ne,t,S,R,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.Schemas=void 0;var k;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(k||(t.Schemas=k={}));function C(r,l){return j.URI.isUri(r)?(0,n.$7e)(r.scheme,l):(0,n.$8e)(r,l+":")}t.$_f=C;function $(r,...l){return l.some(e=>C(r,e))}t.$ag=$,t.$bg="vscode-tkn",t.$cg="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${k.vscodeRemoteResource}`}set(l,e,c){this.a[l]=e,this.b[l]=c}setConnectionToken(l,e){this.c[l]=e}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(a){return S.$1(a),l}const e=l.authority;let c=this.a[e];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const d=this.b[e],p=this.c[e];let o=`path=${encodeURIComponent(l.path)}`;return typeof p=="string"&&(o+=`&${t.$cg}=${encodeURIComponent(p)}`),j.URI.from({scheme:R.$o?this.d:k.vscodeRemoteResource,authority:`${c}:${d}`,path:this.f,query:o})}}t.$dg=new v,t.$eg="vs/../../extensions",t.$fg="vs/../../node_modules",t.$gg="vs/../../node_modules.asar",t.$hg="vs/../../node_modules.asar.unpacked",t.$ig="vscode-app";class y{static{this.a=t.$ig}asBrowserUri(l){const e=this.b(l,ne);return this.uriToBrowserUri(e)}uriToBrowserUri(l){return l.scheme===k.vscodeRemote?t.$dg.rewrite(l):l.scheme===k.file&&(R.$m||R.$q===`${k.vscodeFileResource}://${y.a}`)?l.with({scheme:k.vscodeFileResource,authority:l.authority||y.a,query:null,fragment:null}):l}asFileUri(l){const e=this.b(l,ne);return this.uriToFileUri(e)}uriToFileUri(l){return l.scheme===k.vscodeFileResource?l.with({scheme:k.file,authority:l.authority!==y.a?l.authority:null,query:null,fragment:null}):l}b(l,e){return j.URI.isUri(l)?l:j.URI.parse(e.toUrl(l))}}t.$jg=new y;var O;(function(r){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(l.get("3"));const e="vscode-coi";function c(p){let o;typeof p=="string"?o=new URL(p).searchParams:p instanceof URL?o=p.searchParams:j.URI.isUri(p)&&(o=new URL(p.toString(!0)).searchParams);const a=o?.get(e);if(a)return l.get(a)}r.getHeadersFromQuery=c;function d(p,o,a){if(!globalThis.crossOriginIsolated)return;const E=o&&a?"3":a?"2":"1";p instanceof URLSearchParams?p.set(e,E):p[e]=E}r.addSearchParam=d})(O||(t.COI=O={}))}),define(ge[37],me([1,0,115,31,24,5,10,15]),function(ne,t,S,R,n,j,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mg=t.DataUri=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=void 0;function $(l){return(0,C.$wc)(l,!0)}t.$qg=$;class v{constructor(e){this.a=e}compare(e,c,d=!1){return e===c?0:(0,k.$Ze)(this.getComparisonKey(e,d),this.getComparisonKey(c,d))}isEqual(e,c,d=!1){return e===c?!0:!e||!c?!1:this.getComparisonKey(e,d)===this.getComparisonKey(c,d)}getComparisonKey(e,c=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,c,d=!1){if(e.scheme===c.scheme){if(e.scheme===R.Schemas.file)return S.$3f($(e),$(c),this.a(e))&&e.query===c.query&&(d||e.fragment===c.fragment);if((0,t.$Hg)(e.authority,c.authority))return S.$3f(e.path,c.path,this.a(e),"/")&&e.query===c.query&&(d||e.fragment===c.fragment)}return!1}joinPath(e,...c){return C.URI.joinPath(e,...c)}basenameOrAuthority(e){return(0,t.$zg)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let c;return e.scheme===R.Schemas.file?c=C.URI.file(n.$mc($(e))).path:(c=n.$gc.dirname(e.path),e.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),c="/")),e.with({path:c})}normalizePath(e){if(!e.path.length)return e;let c;return e.scheme===R.Schemas.file?c=C.URI.file(n.$hc($(e))).path:c=n.$gc.normalize(e.path),e.with({path:c})}relativePath(e,c){if(e.scheme!==c.scheme||!(0,t.$Hg)(e.authority,c.authority))return;if(e.scheme===R.Schemas.file){const o=n.$lc($(e),$(c));return j.$i?S.$Wf(o):o}let d=e.path||"/";const p=c.path||"/";if(this.a(e)){let o=0;for(const a=Math.min(d.length,p.length);o<a&&!(d.charCodeAt(o)!==p.charCodeAt(o)&&d.charAt(o).toLowerCase()!==p.charAt(o).toLowerCase());o++);d=p.substr(0,o)+d.substr(o)}return n.$gc.relative(d,p)}resolvePath(e,c){if(e.scheme===R.Schemas.file){const d=C.URI.file(n.$kc($(e),c));return e.with({authority:d.authority,path:d.path})}return c=S.$Xf(c),e.with({path:n.$gc.resolve(e.path,c)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,c){return e===c||e!==void 0&&c!==void 0&&(0,k.$7e)(e,c)}hasTrailingPathSeparator(e,c=n.sep){if(e.scheme===R.Schemas.file){const d=$(e);return d.length>S.$Yf(d).length&&d[d.length-1]===c}else{const d=e.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,c=n.sep){return(0,t.$Ig)(e,c)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,c=n.sep){let d=!1;if(e.scheme===R.Schemas.file){const p=$(e);d=p!==void 0&&p.length===S.$Yf(p).length&&p[p.length-1]===c}else{c="/";const p=e.path;d=p.length===1&&p.charCodeAt(p.length-1)===47}return!d&&!(0,t.$Ig)(e,c)?e.with({path:e.path+"/"}):e}}t.$rg=v,t.$sg=new v(()=>!1),t.$tg=new v(l=>l.scheme===R.Schemas.file?!j.$k:!0),t.$ug=new v(l=>!0),t.$vg=t.$sg.isEqual.bind(t.$sg),t.$wg=t.$sg.isEqualOrParent.bind(t.$sg),t.$xg=t.$sg.getComparisonKey.bind(t.$sg),t.$yg=t.$sg.basenameOrAuthority.bind(t.$sg),t.$zg=t.$sg.basename.bind(t.$sg),t.$Ag=t.$sg.extname.bind(t.$sg),t.$Bg=t.$sg.dirname.bind(t.$sg),t.$Cg=t.$sg.joinPath.bind(t.$sg),t.$Dg=t.$sg.normalizePath.bind(t.$sg),t.$Eg=t.$sg.relativePath.bind(t.$sg),t.$Fg=t.$sg.resolvePath.bind(t.$sg),t.$Gg=t.$sg.isAbsolutePath.bind(t.$sg),t.$Hg=t.$sg.isEqualAuthority.bind(t.$sg),t.$Ig=t.$sg.hasTrailingPathSeparator.bind(t.$sg),t.$Jg=t.$sg.removeTrailingPathSeparator.bind(t.$sg),t.$Kg=t.$sg.addTrailingPathSeparator.bind(t.$sg);function y(l,e){const c=[];for(let d=0;d<l.length;d++){const p=e(l[d]);l.some((o,a)=>a===d?!1:(0,t.$wg)(p,e(o)))||c.push(l[d])}return c}t.$Lg=y;var O;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(c){const d=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(a=>{const[E,m]=a.split(":");E&&m&&d.set(E,m)});const o=c.path.substring(0,c.path.indexOf(";"));return o&&d.set(l.META_DATA_MIME,o),d}l.parseMetaData=e})(O||(t.DataUri=O={}));function r(l,e,c){if(e){let d=l.path;return d&&d[0]!==n.$gc.sep&&(d=n.$gc.sep+d),l.with({scheme:c,authority:e,path:d})}return l.with({scheme:c})}t.$Mg=r}),define(ge[9],me([1,0,29,6,4,2,37,5,50,23]),function(ne,t,S,R,n,j,k,C,$,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.Promises=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=void 0;function y(s){return!!s&&typeof s.then=="function"}t.$Ng=y;function O(s){const u=new S.$3d,h=s(u.token),g=new Promise((b,A)=>{const T=u.token.onCancellationRequested(()=>{T.dispose(),u.dispose(),A(new R.$5)});Promise.resolve(h).then(_=>{T.dispose(),u.dispose(),b(_)},_=>{T.dispose(),u.dispose(),A(_)})});return new class{cancel(){u.cancel()}then(b,A){return g.then(b,A)}catch(b){return this.then(void 0,b)}finally(b){return g.finally(b)}}}t.$Og=O;function r(s,u,h){return new Promise((g,b)=>{const A=u.onCancellationRequested(()=>{A.dispose(),g(h)});s.then(g,b).finally(()=>A.dispose())})}t.$Pg=r;function l(s,u){return new Promise((h,g)=>{const b=u.onCancellationRequested(()=>{b.dispose(),g(new R.$5)});s.then(h,g).finally(()=>b.dispose())})}t.$Qg=l;async function e(s){let u=-1;const h=s.map((g,b)=>g.then(A=>(u=b,A)));try{return await Promise.race(h)}finally{s.forEach((g,b)=>{b!==u&&g.cancel()})}}t.$Rg=e;function c(s,u,h){let g;const b=setTimeout(()=>{g?.(void 0),h?.()},u);return Promise.race([s.finally(()=>clearTimeout(b)),new Promise(A=>g=A)])}t.$Sg=c;function d(s){return new Promise((u,h)=>{const g=s();y(g)?g.then(u,h):u(g)})}t.$Tg=d;class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const h=()=>{if(this.b=null,this.f)return;const g=this.queue(this.d);return this.d=null,g};this.b=new Promise(g=>{this.a.then(h,h).then(g)})}return new Promise((h,g)=>{this.b.then(h,g)})}return this.a=u(),new Promise((h,g)=>{this.a.then(b=>{this.a=null,h(b)},b=>{this.a=null,g(b)})})}dispose(){this.f=!0}}t.$Ug=p;class o{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}t.$Vg=o;class a{constructor(){this.a=new Map}queue(u,h){const b=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(h).finally(()=>{this.a.get(u)===b&&this.a.delete(u)});return this.a.set(u,b),b}}t.$Wg=a;const E=(s,u)=>{let h=!0;const g=setTimeout(()=>{h=!1,u()},s);return{isTriggered:()=>h,dispose:()=>{clearTimeout(g),h=!1}}},m=s=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,s())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class f{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,h=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((b,A)=>{this.d=b,this.f=A}).then(()=>{if(this.b=null,this.d=null,this.g){const b=this.g;return this.g=null,b()}}));const g=()=>{this.a=null,this.d?.(null)};return this.a=h===$.$Pd?m(g):E(h,g),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Xg=f;class N{constructor(u){this.a=new f(u),this.b=new p}trigger(u,h){return this.a.trigger(()=>this.b.queue(u),h)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Yg=N;class B{constructor(){this.a=!1,this.b=new Promise((u,h)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Zg=B;class L extends B{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}t.$1g=L;function w(s,u){return u?new Promise((h,g)=>{const b=setTimeout(()=>{A.dispose(),h()},s),A=u.onCancellationRequested(()=>{clearTimeout(b),A.dispose(),g(new R.$5)})}):O(h=>w(s,h))}t.$2g=w;function P(s,u=0,h){const g=setTimeout(()=>{s(),h&&b.dispose()},u),b=(0,j.$Qc)(()=>{clearTimeout(g),h?.deleteAndLeak(b)});return h?.add(b),b}t.$3g=P;function M(s){const u=[];let h=0;const g=s.length;function b(){return h<g?s[h++]():null}function A(T){T!=null&&u.push(T);const _=b();return _?_.then(A):Promise.resolve(u)}return Promise.resolve(null).then(A)}t.$4g=M;function U(s,u=g=>!!g,h=null){let g=0;const b=s.length,A=()=>{if(g>=b)return Promise.resolve(h);const T=s[g++];return Promise.resolve(T()).then(x=>u(x)?Promise.resolve(x):A())};return A()}t.$5g=U;function V(s,u=g=>!!g,h=null){if(s.length===0)return Promise.resolve(h);let g=s.length;const b=()=>{g=-1;for(const A of s)A.cancel?.()};return new Promise((A,T)=>{for(const _ of s)_.then(x=>{--g>=0&&u(x)?(b(),A(x)):g===0&&A(h)}).catch(x=>{--g>=0&&(b(),T(x))})})}t.$6g=V;class F{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new n.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((h,g)=>{this.f.push({factory:u,c:h,e:g}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const h=u.factory();h.then(u.c,u.e),h.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$7g=F;class I extends F{constructor(){super(1)}}t.$8g=I;class z{constructor(){this.a=new J,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}t.$9g=z;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new H;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,h=k.$sg){const g=h.getComparisonKey(u);let b=this.a.get(g);if(!b){b=new I;const A=this.f++,T=n.Event.once(b.onDrained)(()=>{b?.dispose(),this.a.delete(g),this.h(),this.d?.deleteAndDispose(A),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$2c),this.d.set(A,T),this.a.set(g,b)}return b}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$0g=X;class G{constructor(u,h){this.a=-1,typeof u=="function"&&typeof h=="number"&&this.setIfNotSet(u,h)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,h){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},h)}setIfNotSet(u,h){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},h))}}t.$$g=G;class re{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,h,g=globalThis){this.cancel();const b=g.setInterval(()=>{u()},h);this.d=(0,j.$Qc)(()=>{g.clearInterval(b),this.d=void 0})}dispose(){this.cancel()}}t.$_g=re;class ie{constructor(u,h){this.b=-1,this.a=u,this.d=h,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$ah=ie;class te{constructor(u,h){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.a=u,this.b=h,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$bh=te;class $e extends ie{constructor(u,h){super(u,h),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}t.$ch=$e;class Fe extends j.$Sc{constructor(u,h){super(),this.g=u,this.h=h,this.a=[],this.b=this.B(new j.$Tc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const h of u)this.a.push(h);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$dh=Fe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$fh=(s,u)=>{(0,C.$B)(()=>{if(h)return;const g=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,g-Date.now())}}))});let h=!1;return{dispose(){h||(h=!0)}}}:t.$fh=(s,u,h)=>{const g=s.requestIdleCallback(u,typeof h=="number"?{timeout:h}:void 0);let b=!1;return{dispose(){b||(b=!0,s.cancelIdleCallback(g))}}},t.$eh=s=>(0,t.$fh)(globalThis,s)}();class ke{constructor(u,h){this.g=!1,this.d=()=>{try{this.j=h()}catch(g){this.l=g}finally{this.g=!0}},this.f=(0,t.$fh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$gh=ke;class Le extends ke{constructor(u){super(globalThis,u)}}t.$hh=Le;async function ae(s,u,h){let g;for(let b=0;b<h;b++)try{return await s()}catch(A){g=A,await w(u)}throw g}t.$ih=ae;class J{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,h,g){return this.a={taskId:u,cancel:()=>g?.(),promise:h},h.then(()=>this.d(u),()=>this.d(u)),h}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let h,g;const b=new Promise((A,T)=>{h=A,g=T});this.b={run:u,promise:b,promiseResolve:h,promiseReject:g}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$jh=J;class le{constructor(u,h=()=>Date.now()){this.d=u,this.f=h,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}t.$kh=le;var K;(function(s){s[s.Resolved=0]="Resolved",s[s.Rejected=1]="Rejected"})(K||(K={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,h)=>{this.a=u,this.b=h})}complete(u){return new Promise(h=>{this.a(u),this.d={outcome:0,value:u},h()})}error(u){return new Promise(h=>{this.b(u),this.d={outcome:1,value:u},h()})}cancel(){return this.error(new R.$5)}}t.$lh=H;var Y;(function(s){async function u(g){let b;const A=await Promise.all(g.map(T=>T.then(_=>_,_=>{b||(b=_)})));if(typeof b<"u")throw b;return A}s.settled=u;function h(g){return new Promise(async(b,A)=>{try{await g(b,A)}catch(T){A(T)}})}s.withAsyncBody=h})(Y||(t.Promises=Y={}));class be{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(u){this.a=void 0,this.b=void 0,this.d=!1,this.promise=u.then(h=>(this.a=h,this.d=!0,h),h=>{throw this.b=h,this.d=!0,h})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$mh=be;class we{constructor(u){this.b=u,this.a=new v.$V(()=>new be(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}t.$nh=we;var Ce;(function(s){s[s.Initial=0]="Initial",s[s.DoneOK=1]="DoneOK",s[s.DoneError=2]="DoneError"})(Ce||(Ce={}));class Ae{static fromArray(u){return new Ae(h=>{h.emitMany(u)})}static fromPromise(u){return new Ae(async h=>{h.emitMany(await u)})}static fromPromises(u){return new Ae(async h=>{await Promise.all(u.map(async g=>h.emitOne(await g)))})}static merge(u){return new Ae(async h=>{await Promise.all(u.map(async g=>{for await(const b of g)h.emitOne(b)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new n.$Sd,queueMicrotask(async()=>{const h={emitOne:g=>this.g(g),emitMany:g=>this.h(g),reject:g=>this.k(g)};try{await Promise.resolve(u(h)),this.j()}catch(g){this.k(g)}finally{h.emitOne=void 0,h.emitMany=void 0,h.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(u,h){return new Ae(async g=>{for await(const b of u)g.emitOne(h(b))})}map(u){return Ae.map(this,u)}static filter(u,h){return new Ae(async g=>{for await(const b of u)h(b)&&g.emitOne(b)})}filter(u){return Ae.filter(this,u)}static coalesce(u){return Ae.filter(u,h=>!!h)}coalesce(){return Ae.coalesce(this)}static async toPromise(u){const h=[];for await(const g of u)h.push(g);return h}toPromise(){return Ae.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}t.$oh=Ae;class ce extends Ae{constructor(u,h){super(h),this.l=u}cancel(){this.l.cancel()}}t.$ph=ce;function D(s){const u=new S.$3d,h=s(u.token);return new ce(u,async g=>{const b=u.token.onCancellationRequested(()=>{b.dispose(),u.dispose(),g.reject(new R.$5)});try{for await(const A of h){if(u.token.isCancellationRequested)return;g.emitOne(A)}b.dispose(),u.dispose()}catch(A){b.dispose(),u.dispose(),g.reject(A)}})}t.$qh=D;class i{constructor(){this.a=new H,this.b=new Ae(g=>{if(u){g.reject(u);return}return h&&g.emitMany(h),this.d=b=>g.reject(b),this.f=b=>g.emitOne(b),this.a.p});let u,h;this.f=g=>{h||(h=[]),h.push(g)},this.d=g=>{u||(u=g)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}t.$rh=i}),define(ge[3],me([1,0,16,113,14,19,9,6,4,117,2,31,5,15,49,21]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l,e,c){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),t.$EQ=t.$DQ=t.h=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.DetectedFullscreenMode=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$=t.Namespace=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,d=function(){const W=new Map;(0,c.$EO)(c.$FO,1),W.set(c.$FO.vscodeWindowId,{window:c.$FO,disposables:new y.$Rc});const q=new $.$Sd,Z=new $.$Sd,ue=new $.$Sd;return{onDidRegisterWindow:q.event,onWillUnregisterWindow:ue.event,onDidUnregisterWindow:Z.event,registerWindow(ve){if(W.has(ve.vscodeWindowId))return y.$Sc.None;const Re=new y.$Rc,Be={window:ve,disposables:Re.add(new y.$Rc)};return W.set(ve.vscodeWindowId,Be),Re.add((0,y.$Qc)(()=>{W.delete(ve.vscodeWindowId),Z.fire(ve)})),Re.add(a(ve,t.$5P.BEFORE_UNLOAD,()=>{ue.fire(ve)})),q.fire(Be),Re},getWindows(){return W.values()},getWindowsCount(){return W.size},getWindowId(ve){return ve.vscodeWindowId},hasWindow(ve){return W.has(ve)},getWindowById(ve){return W.get(ve)},getWindow(ve){const Re=ve;if(Re?.ownerDocument?.defaultView)return Re.ownerDocument.defaultView.window;const Be=ve;return Be?.view?Be.view.window:c.$FO},getDocument(ve){const Re=ve;return(0,t.getWindow)(Re).document}}}(),t.registerWindow=d.registerWindow,t.getWindow=d.getWindow,t.getDocument=d.getDocument,t.getWindows=d.getWindows,t.getWindowsCount=d.getWindowsCount,t.getWindowId=d.getWindowId,t.getWindowById=d.getWindowById,t.hasWindow=d.hasWindow,t.onDidRegisterWindow=d.onDidRegisterWindow,t.onWillUnregisterWindow=d.onWillUnregisterWindow,t.onDidUnregisterWindow=d.onDidUnregisterWindow;function p(W){for(;W.firstChild;)W.firstChild.remove()}t.$_O=p;class o{constructor(q,Z,ue,ve){this.f=q,this.g=Z,this.d=ue,this.j=ve||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function a(W,q,Z,ue){return new o(W,q,Z,ue)}t.$aP=a;function E(W,q){return function(Z){return q(new j.$5O(W,Z))}}function m(W){return function(q){return W(new n.$0O(q))}}const f=function(q,Z,ue,ve){let Re=ue;return Z==="click"||Z==="mousedown"?Re=E((0,t.getWindow)(q),ue):(Z==="keydown"||Z==="keypress"||Z==="keyup")&&(Re=m(ue)),a(q,Z,Re,ve)};t.$bP=f;const N=function(q,Z,ue){const ve=E((0,t.getWindow)(q),Z);return L(q,ve,ue)};t.$cP=N;const B=function(q,Z,ue){const ve=E((0,t.getWindow)(q),Z);return P(q,ve,ue)};t.$dP=B;function L(W,q,Z){return a(W,r.$r&&R.$2O.pointerEvents?t.$5P.POINTER_DOWN:t.$5P.MOUSE_DOWN,q,Z)}t.$eP=L;function w(W,q,Z){return a(W,r.$r&&R.$2O.pointerEvents?t.$5P.POINTER_MOVE:t.$5P.MOUSE_MOVE,q,Z)}t.$fP=w;function P(W,q,Z){return a(W,r.$r&&R.$2O.pointerEvents?t.$5P.POINTER_UP:t.$5P.MOUSE_UP,q,Z)}t.$gP=P;function M(W,q,Z){return(0,k.$fh)(W,q,Z)}t.$hP=M;class U extends k.$gh{constructor(q,Z){super(q,Z)}}t.$iP=U;function V(W,q,Z,ue){let ve=0;const Re=W.setInterval(()=>{ve++,(typeof ue=="number"&&ve>=ue||q()===!0)&&Be.dispose()},Z),Be=(0,y.$Qc)(()=>{W.clearInterval(Re)});return Be}t.$lP=V;class F extends k.$_g{cancelAndSet(q,Z,ue){return super.cancelAndSet(q,Z,ue)}}t.$mP=F;class I{constructor(q,Z=0){this.d=q,this.priority=Z,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,C.$1)(q)}}static sort(q,Z){return Z.priority-q.priority}}(function(){const W=new Map,q=new Map,Z=new Map,ue=new Map,ve=Re=>{Z.set(Re,!1);const Be=W.get(Re)??[];for(q.set(Re,Be),W.set(Re,[]),ue.set(Re,!0);Be.length>0;)Be.sort(I.sort),Be.shift().execute();ue.set(Re,!1)};t.$kP=(Re,Be,xe=0)=>{const Ge=(0,t.getWindowId)(Re),qe=new I(Be,xe);let rt=W.get(Ge);return rt||(rt=[],W.set(Ge,rt)),rt.push(qe),Z.get(Ge)||(Z.set(Ge,!0),Re.requestAnimationFrame(()=>ve(Ge))),qe},t.$jP=(Re,Be,xe)=>{const Ge=(0,t.getWindowId)(Re);if(ue.get(Ge)){const qe=new I(Be,xe);let rt=q.get(Ge);return rt||(rt=[],q.set(Ge,rt)),rt.push(qe),qe}else return(0,t.$kP)(Re,Be,xe)}})();function z(W,q){return(0,t.$kP)(W,q,1e4)}t.$nP=z;function X(W,q){return(0,t.$kP)(W,q,-1e4)}t.$oP=X;const G=8,re=function(W,q){return q};class ie extends y.$Sc{constructor(q,Z,ue,ve=re,Re=G){super();let Be=null,xe=0;const Ge=this.B(new k.$$g),qe=()=>{xe=new Date().getTime(),ue(Be),Be=null};this.B(a(q,Z,rt=>{Be=ve(Be,rt);const Pt=new Date().getTime()-xe;Pt>=Re?(Ge.cancel(),qe()):Ge.setIfNotSet(qe,Re-Pt)}))}}function te(W,q,Z,ue,ve){return new ie(W,q,Z,ue,ve)}t.$pP=te;function $e(W){return(0,t.getWindow)(W).getComputedStyle(W,null)}t.$qP=$e;function Fe(W){const q=W.ownerDocument,Z=q.defaultView?.window;if(W!==q.body)return new Le(W.clientWidth,W.clientHeight);if(r.$r&&Z?.visualViewport)return new Le(Z.visualViewport.width,Z.visualViewport.height);if(Z?.innerWidth&&Z.innerHeight)return new Le(Z.innerWidth,Z.innerHeight);if(q.body&&q.body.clientWidth&&q.body.clientHeight)return new Le(q.body.clientWidth,q.body.clientHeight);if(q.documentElement&&q.documentElement.clientWidth&&q.documentElement.clientHeight)return new Le(q.documentElement.clientWidth,q.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$rP=Fe;class ke{static d(q,Z){return parseFloat(Z)||0}static f(q,Z,ue){const ve=$e(q),Re=ve?ve.getPropertyValue(Z):"0";return ke.d(q,Re)}static getBorderLeftWidth(q){return ke.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return ke.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return ke.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return ke.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return ke.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return ke.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return ke.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return ke.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return ke.f(q,"margin-left","marginLeft")}static getMarginTop(q){return ke.f(q,"margin-top","marginTop")}static getMarginRight(q){return ke.f(q,"margin-right","marginRight")}static getMarginBottom(q){return ke.f(q,"margin-bottom","marginBottom")}}class Le{static{this.None=new Le(0,0)}constructor(q,Z){this.width=q,this.height=Z}with(q=this.width,Z=this.height){return q!==this.width||Z!==this.height?new Le(q,Z):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof Le?q:new Le(q.width,q.height)}static equals(q,Z){return q===Z?!0:!q||!Z?!1:q.width===Z.width&&q.height===Z.height}}t.$sP=Le;function ae(W){let q=W.offsetParent,Z=W.offsetTop,ue=W.offsetLeft;for(;(W=W.parentNode)!==null&&W!==W.ownerDocument.body&&W!==W.ownerDocument.documentElement;){Z-=W.scrollTop;const ve=T(W)?null:$e(W);ve&&(ue-=ve.direction!=="rtl"?W.scrollLeft:-W.scrollLeft),W===q&&(ue+=ke.getBorderLeftWidth(W),Z+=ke.getBorderTopWidth(W),Z+=W.offsetTop,ue+=W.offsetLeft,q=W.offsetParent)}return{left:ue,top:Z}}t.$tP=ae;function J(W,q,Z){typeof q=="number"&&(W.style.width=`${q}px`),typeof Z=="number"&&(W.style.height=`${Z}px`)}t.$uP=J;function le(W,q,Z,ue,ve,Re="absolute"){typeof q=="number"&&(W.style.top=`${q}px`),typeof Z=="number"&&(W.style.right=`${Z}px`),typeof ue=="number"&&(W.style.bottom=`${ue}px`),typeof ve=="number"&&(W.style.left=`${ve}px`),W.style.position=Re}t.$vP=le;function K(W){const q=W.getBoundingClientRect(),Z=(0,t.getWindow)(W);return{left:q.left+Z.scrollX,top:q.top+Z.scrollY,width:q.width,height:q.height}}t.$wP=K;function H(W){let q=W,Z=1;do{const ue=$e(q).zoom;ue!=null&&ue!=="1"&&(Z*=ue),q=q.parentElement}while(q!==null&&q!==q.ownerDocument.documentElement);return Z}t.$xP=H;function Y(W){const q=ke.getMarginLeft(W)+ke.getMarginRight(W);return W.offsetWidth+q}t.$yP=Y;function be(W){const q=ke.getBorderLeftWidth(W)+ke.getBorderRightWidth(W),Z=ke.getPaddingLeft(W)+ke.getPaddingRight(W);return W.offsetWidth-q-Z}t.$zP=be;function we(W){const q=ke.getMarginLeft(W)+ke.getMarginRight(W);return W.scrollWidth+q}t.$AP=we;function Ce(W){const q=ke.getBorderTopWidth(W)+ke.getBorderBottomWidth(W),Z=ke.getPaddingTop(W)+ke.getPaddingBottom(W);return W.offsetHeight-q-Z}t.$BP=Ce;function Ae(W){const q=ke.getMarginTop(W)+ke.getMarginBottom(W);return W.offsetHeight+q}t.$CP=Ae;function ce(W,q){if(W===null)return 0;const Z=ae(W),ue=ae(q);return Z.left-ue.left}function D(W,q){const Z=q.map(ve=>Math.max(we(ve),Y(ve))+ce(ve,W)||0);return Math.max(...Z)}t.$DP=D;function i(W,q){return!!q?.contains(W)}t.$EP=i;const s="parentFlowToElementId";function u(W,q){W.dataset[s]=q.id}t.$FP=u;function h(W){const q=W.dataset[s];return typeof q=="string"?W.ownerDocument.getElementById(q):null}function g(W,q){let Z=W;for(;Z;){if(Z===q)return!0;if(Z instanceof HTMLElement){const ue=h(Z);if(ue){Z=ue;continue}}Z=Z.parentNode}return!1}t.$GP=g;function b(W,q,Z){for(;W&&W.nodeType===W.ELEMENT_NODE;){if(W.classList.contains(q))return W;if(Z){if(typeof Z=="string"){if(W.classList.contains(Z))return null}else if(W===Z)return null}W=W.parentNode}return null}t.$HP=b;function A(W,q,Z){return!!b(W,q,Z)}t.$IP=A;function T(W){return W&&!!W.host&&!!W.mode}t.$JP=T;function _(W){return!!x(W)}t.$KP=_;function x(W){for(;W.parentNode;){if(W===W.ownerDocument?.body)return null;W=W.parentNode}return T(W)?W:null}t.$LP=x;function ee(){let W=De().activeElement;for(;W?.shadowRoot;)W=W.shadowRoot.activeElement;return W}t.$MP=ee;function fe(W){return W.ownerDocument.activeElement===W}t.$NP=fe;function he(W){return i(W.ownerDocument.activeElement,W)}t.$OP=he;function ye(W){return W.ownerDocument===De()}t.$PP=ye;function De(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:q})=>q.document).find(q=>q.hasFocus())??document}t.$QP=De;function pe(){return De().defaultView?.window??c.$FO}t.$RP=pe;function Ie(W){const q=(0,t.getWindow)(W);q!==pe()&&q.focus()}t.$SP=Ie;const Te=new Map;function Ye(W){return Te.has(W)}t.$TP=Ye;function He(W=c.$FO.document.head,q,Z){const ue=document.createElement("style");if(ue.type="text/css",ue.media="screen",q?.(ue),W.appendChild(ue),Z&&Z.add((0,y.$Qc)(()=>W.removeChild(ue))),W===c.$FO.document.head){const ve=new Set;Te.set(ue,ve);for(const{window:Re,disposables:Be}of(0,t.getWindows)()){if(Re===c.$FO)continue;const xe=Be.add(Ve(ue,ve,Re));Z?.add(xe)}}return ue}t.$UP=He;function Me(W){const q=new y.$Rc;for(const[Z,ue]of Te)q.add(Ve(Z,ue,W));return q}t.$VP=Me;function Ve(W,q,Z){const ue=new y.$Rc,ve=W.cloneNode(!0);Z.document.head.appendChild(ve),ue.add((0,y.$Qc)(()=>Z.document.head.removeChild(ve)));for(const Re of Ee(W))ve.sheet?.insertRule(Re.cssText,ve.sheet?.cssRules.length);return ue.add(t.$WP.observe(W,ue,{childList:!0})(()=>{ve.textContent=W.textContent})),q.add(ve),ue.add((0,y.$Qc)(()=>q.delete(ve))),ue}t.$WP=new class{constructor(){this.mutationObservers=new Map}observe(W,q,Z){let ue=this.mutationObservers.get(W);ue||(ue=new Map,this.mutationObservers.set(W,ue));const ve=(0,e.$Oi)(Z);let Re=ue.get(ve);if(Re)Re.users+=1;else{const Be=new $.$Sd,xe=new MutationObserver(qe=>Be.fire(qe));xe.observe(W,Z);const Ge=Re={users:1,observer:xe,onDidMutate:Be.event};q.add((0,y.$Qc)(()=>{Ge.users-=1,Ge.users===0&&(Be.dispose(),xe.disconnect(),ue?.delete(ve),ue?.size===0&&this.mutationObservers.delete(W))})),ue.set(ve,Re)}return Re.onDidMutate}};function Q(W=c.$FO.document.head){const q=document.createElement("meta");return W.appendChild(q),q}t.$XP=Q;let se=null;function de(){return se||(se=He()),se}function Ee(W){return W?.sheet?.rules?W.sheet.rules:W?.sheet?.cssRules?W.sheet.cssRules:[]}function Pe(W,q,Z=de()){if(!(!Z||!q)){Z.sheet?.insertRule(`${W} {${q}}`,0);for(const ue of Te.get(Z)??[])Pe(W,q,ue)}}t.$YP=Pe;function ze(W,q=de()){if(!q)return;const Z=Ee(q),ue=[];for(let ve=0;ve<Z.length;ve++){const Re=Z[ve];Ue(Re)&&Re.selectorText.indexOf(W)!==-1&&ue.push(ve)}for(let ve=ue.length-1;ve>=0;ve--)q.sheet?.deleteRule(ue[ve]);for(const ve of Te.get(q)??[])ze(W,ve)}t.$ZP=ze;function Ue(W){return typeof W.selectorText=="string"}function Je(W){return W instanceof MouseEvent||W instanceof(0,t.getWindow)(W).MouseEvent}t.$1P=Je;function Ze(W){return W instanceof KeyboardEvent||W instanceof(0,t.getWindow)(W).KeyboardEvent}t.$2P=Ze;function Ke(W){return W instanceof PointerEvent||W instanceof(0,t.getWindow)(W).PointerEvent}t.$3P=Ke;function _e(W){return W instanceof DragEvent||W instanceof(0,t.getWindow)(W).DragEvent}t.$4P=_e,t.$5P={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:S.$TO?"webkitAnimationStart":"animationstart",ANIMATION_END:S.$TO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:S.$TO?"webkitAnimationIteration":"animationiteration"};function tt(W){const q=W;return!!(q&&typeof q.preventDefault=="function"&&typeof q.stopPropagation=="function")}t.$6P=tt,t.$7P={stop:(W,q)=>(W.preventDefault(),q&&W.stopPropagation(),W)};function nt(W){const q=[];for(let Z=0;W&&W.nodeType===W.ELEMENT_NODE;Z++)q[Z]=W.scrollTop,W=W.parentNode;return q}t.$8P=nt;function dt(W,q){for(let Z=0;W&&W.nodeType===W.ELEMENT_NODE;Z++)W.scrollTop!==q[Z]&&(W.scrollTop=q[Z]),W=W.parentNode}t.$9P=dt;class lt extends y.$Sc{static m(q){if(q instanceof HTMLElement){const Z=x(q),ue=Z?Z.activeElement:q.ownerDocument.activeElement;return i(ue,q)}else{const Z=q;return i(Z.document.activeElement,Z.document)}}constructor(q){super(),this.f=this.B(new $.$Sd),this.onDidFocus=this.f.event,this.g=this.B(new $.$Sd),this.onDidBlur=this.g.event;let Z=lt.m(q),ue=!1;const ve=()=>{ue=!1,Z||(Z=!0,this.f.fire())},Re=()=>{Z&&(ue=!0,(q instanceof HTMLElement?(0,t.getWindow)(q):q).setTimeout(()=>{ue&&(ue=!1,Z=!1,this.g.fire())},0))};this.j=()=>{lt.m(q)!==Z&&(Z?Re():ve())},this.B(a(q,t.$5P.FOCUS,ve,!0)),this.B(a(q,t.$5P.BLUR,Re,!0)),q instanceof HTMLElement&&(this.B(a(q,t.$5P.FOCUS_IN,()=>this.j())),this.B(a(q,t.$5P.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function ft(W){return new lt(W)}t.$0P=ft;function At(W,q){return W.after(q),q}t.$$P=At;function pt(W,...q){if(W.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}t.$_P=pt;function kt(W,q){return W.insertBefore(q,W.firstChild),q}t.$aQ=kt;function St(W,...q){W.innerText="",pt(W,...q)}t.$bQ=St;const Mt=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Oe;(function(W){W.HTML="http://www.w3.org/1999/xhtml",W.SVG="http://www.w3.org/2000/svg"})(Oe||(t.Namespace=Oe={}));function oe(W,q,Z,...ue){const ve=Mt.exec(q);if(!ve)throw new Error("Bad use of emmet");const Re=ve[1]||"div";let Be;return W!==Oe.HTML?Be=document.createElementNS(W,Re):Be=document.createElement(Re),ve[3]&&(Be.id=ve[3]),ve[4]&&(Be.className=ve[4].replace(/\./g," ").trim()),Z&&Object.entries(Z).forEach(([xe,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(xe)?Be[xe]=Ge:xe==="selected"?Ge&&Be.setAttribute(xe,"true"):Be.setAttribute(xe,Ge))}),Be.append(...ue),Be}function Se(W,q,...Z){return oe(Oe.HTML,W,q,...Z)}t.$=Se,Se.SVG=function(W,q,...Z){return oe(Oe.SVG,W,q,...Z)};function Ne(W,q){const Z=[];return W.forEach((ue,ve)=>{ve>0&&(q instanceof Node?Z.push(q.cloneNode()):Z.push(document.createTextNode(q))),Z.push(ue)}),Z}t.$dQ=Ne;function We(W,...q){W?et(...q):st(...q)}t.$eQ=We;function et(...W){for(const q of W)q.style.display="",q.removeAttribute("aria-hidden")}t.$fQ=et;function st(...W){for(const q of W)q.style.display="none",q.setAttribute("aria-hidden","true")}t.$gQ=st;function Qe(W,q){for(;W&&W.nodeType===W.ELEMENT_NODE;){if(W instanceof HTMLElement&&W.hasAttribute(q))return W;W=W.parentNode}return null}function ht(W){!W||!W.hasAttribute("tabIndex")||(W.ownerDocument.activeElement===W&&Qe(W.parentElement,"tabIndex")?.focus(),W.removeAttribute("tabindex"))}t.$hQ=ht;function wt(W){return q=>{q.preventDefault(),q.stopPropagation(),W(q)}}t.$iQ=wt;function Ct(W){return new Promise(q=>{if(W.document.readyState==="complete"||W.document&&W.document.body!==null)q(void 0);else{const ue=()=>{W.window.removeEventListener("DOMContentLoaded",ue,!1),q()};W.window.addEventListener("DOMContentLoaded",ue,!1)}})}t.$jQ=Ct;function Gt(W,q){const Z=W.devicePixelRatio*q;return Math.max(1,Math.floor(Z))/W.devicePixelRatio}t.$kQ=Gt;function Ai(W){c.$FO.open(W,"_blank","noopener")}t.$lQ=Ai;const Xt=780,Yt=640;function ki(W){const q=Math.floor(c.$FO.screenLeft+c.$FO.innerWidth/2-Xt/2),Z=Math.floor(c.$FO.screenTop+c.$FO.innerHeight/2-Yt/2);c.$FO.open(W,"_blank",`width=${Xt},height=${Yt},top=${Z},left=${q}`)}t.$mQ=ki;function Si(W,q=!0){const Z=c.$FO.open();return Z?(q&&(Z.opener=null),Z.location.href=W,!0):!1}t.$nQ=Si;function Ci(W,q){const Z=()=>{q(),ue=(0,t.$kP)(W,Z)};let ue=(0,t.$kP)(W,Z);return(0,y.$Qc)(()=>ue.dispose())}t.$oQ=Ci,O.$dg.setPreferredWebSchema(/^https:/.test(c.$FO.location.href)?"https":"http");function Pi(W){return W?`url('${O.$jg.uriToBrowserUri(W).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$pQ=Pi;function Fi(W){return`'${W.replace(/'/g,"%27")}'`}t.$qQ=Fi;function Jt(W,q){if(W!==void 0){const Z=W.match(/^\s*var\((.+)\)$/);if(Z){const ue=Z[1].split(",",2);return ue.length===2&&(q=Jt(ue[1].trim(),q)),`var(${ue[0]}, ${q})`}return W}return q}t.$rQ=Jt;function Ni(W,q){let Z;if(l.URI.isUri(W))Z=W.toString(!0);else{const Re=new Blob([W]);Z=URL.createObjectURL(Re),setTimeout(()=>URL.revokeObjectURL(Z))}const ue=pe(),ve=document.createElement("a");ue.document.body.appendChild(ve),ve.download=q,ve.href=Z,ve.click(),setTimeout(()=>ue.document.body.removeChild(ve))}t.$sQ=Ni;function Ti(){return new Promise(W=>{const q=pe(),Z=document.createElement("input");q.document.body.appendChild(Z),Z.type="file",Z.multiple=!0,$.Event.once($.Event.fromDOMEventEmitter(Z,"input"))(()=>{W(Z.files??void 0)}),Z.click(),setTimeout(()=>q.document.body.removeChild(Z))})}t.$tQ=Ti;var vt;(function(W){W[W.DOCUMENT=1]="DOCUMENT",W[W.BROWSER=2]="BROWSER"})(vt||(t.DetectedFullscreenMode=vt={}));function Ri(W){return W.document.fullscreenElement||W.document.webkitFullscreenElement||W.document.webkitIsFullScreen?{mode:vt.DOCUMENT,guess:!1}:W.innerHeight===W.screen.height?{mode:vt.BROWSER,guess:!1}:(r.$j||r.$k)&&W.outerHeight===W.screen.height&&W.outerWidth===W.screen.width?{mode:vt.BROWSER,guess:!0}:null}t.$uQ=Ri;function Zt(W,q=!1){const Z=document.createElement("a");return v.addHook("afterSanitizeAttributes",ue=>{for(const ve of["href","src"])if(ue.hasAttribute(ve)){const Re=ue.getAttribute(ve);if(ve==="href"&&Re.startsWith("#"))continue;if(Z.href=Re,!W.includes(Z.protocol.replace(/:$/,""))){if(q&&ve==="src"&&Z.href.startsWith("data:"))continue;ue.removeAttribute(ve)}}}),(0,y.$Qc)(()=>{v.removeHook("afterSanitizeAttributes")})}t.$vQ=Zt;const Li=[O.Schemas.http,O.Schemas.https,O.Schemas.command];t.$wQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Oi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ii(W,q){const Z=Zt(Li);try{const ue=v.sanitize(q,Oi);W.innerHTML=ue}finally{Z.dispose()}}t.$xQ=Ii;function Mi(W){const q=new Uint16Array(W.length);for(let ve=0;ve<q.length;ve++)q[ve]=W.charCodeAt(ve);let Z="";const ue=new Uint8Array(q.buffer);for(let ve=0;ve<ue.length;ve++)Z+=String.fromCharCode(ue[ve]);return Z}function Bi(W){return btoa(Mi(W))}t.$yQ=Bi;class mt extends $.$Sd{constructor(){super(),this.o=new y.$Rc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add($.Event.runAndSubscribe(t.onDidRegisterWindow,({window:q,disposables:Z})=>this.B(q,Z),{window:c.$FO,disposables:this.o}))}B(q,Z){Z.add(a(q,"keydown",ue=>{if(ue.defaultPrevented)return;const ve=new n.$0O(ue);if(!(ve.keyCode===6&&ue.repeat)){if(ue.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ue.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ue.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ue.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ve.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ue.altKey,this.s.ctrlKey=ue.ctrlKey,this.s.metaKey=ue.metaKey,this.s.shiftKey=ue.shiftKey,this.s.lastKeyPressed&&(this.s.event=ue,this.fire(this.s))}},!0)),Z.add(a(q,"keyup",ue=>{ue.defaultPrevented||(!ue.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ue.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ue.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ue.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ue.altKey,this.s.ctrlKey=ue.ctrlKey,this.s.metaKey=ue.metaKey,this.s.shiftKey=ue.shiftKey,this.s.lastKeyReleased&&(this.s.event=ue,this.fire(this.s)))},!0)),Z.add(a(q.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),Z.add(a(q.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),Z.add(a(q.document.body,"mousemove",ue=>{ue.buttons&&(this.s.lastKeyPressed=void 0)},!0)),Z.add(a(q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$zQ=mt;function zi(W){const q=document.cookie.match("(^|[^;]+)\\s*"+W+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}t.$AQ=zi;class ji extends y.$Sc{constructor(q,Z){super(),this.j=q,this.m=Z,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(a(this.j,t.$5P.DRAG_START,q=>{this.m.onDragStart?.(q)})),this.m.onDrag&&this.B(a(this.j,t.$5P.DRAG,q=>{this.m.onDrag?.(q)})),this.B(a(this.j,t.$5P.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.m.onDragEnter?.(q)})),this.B(a(this.j,t.$5P.DRAG_OVER,q=>{q.preventDefault(),this.m.onDragOver?.(q,q.timeStamp-this.g)})),this.B(a(this.j,t.$5P.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(q))})),this.B(a(this.j,t.$5P.DRAG_END,q=>{this.f=0,this.g=0,this.m.onDragEnd?.(q)})),this.B(a(this.j,t.$5P.DROP,q=>{this.f=0,this.g=0,this.m.onDrop?.(q)}))}}t.$BQ=ji;const Hi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ui(W,...q){let Z,ue;Array.isArray(q[0])?(Z={},ue=q[0]):(Z=q[0]||{},ue=q[1]);const ve=Hi.exec(W);if(!ve||!ve.groups)throw new Error("Bad use of h");const Re=ve.groups.tag||"div",Be=document.createElement(Re);ve.groups.id&&(Be.id=ve.groups.id);const xe=[];if(ve.groups.class)for(const qe of ve.groups.class.split("."))qe!==""&&xe.push(qe);if(Z.className!==void 0)for(const qe of Z.className.split("."))qe!==""&&xe.push(qe);xe.length>0&&(Be.className=xe.join(" "));const Ge={};if(ve.groups.name&&(Ge[ve.groups.name]=Be),ue)for(const qe of ue)qe instanceof HTMLElement?Be.appendChild(qe):typeof qe=="string"?Be.append(qe):"root"in qe&&(Object.assign(Ge,qe),Be.appendChild(qe.root));for(const[qe,rt]of Object.entries(Z))if(qe!=="className")if(qe==="style")for(const[Pt,Bt]of Object.entries(rt))Be.style.setProperty(ei(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?Be.tabIndex=rt:Be.setAttribute(ei(qe),rt.toString());return Ge.root=Be,Ge}t.h=Ui;function ei(W){return W.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(W,q){for(const{name:Z,value:ue}of W.attributes)q.setAttribute(Z,ue)}t.$DQ=ti;function Wi(W,q,Z){const ue=W.getAttribute(Z);ue?q.setAttribute(Z,ue):q.removeAttribute(Z)}function _i(W,q,Z){ti(W,q);const ue=new y.$Rc;return ue.add(t.$WP.observe(W,ue,{attributes:!0,attributeFilter:Z})(ve=>{for(const Re of ve)Re.type==="attributes"&&Re.attributeName&&Wi(W,q,Re.attributeName)})),ue}t.$EQ=_i}),define(ge[54],me([1,0,3,2,116]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HQ=t.$GQ=t.$FQ=void 0;class j extends R.$Sc{constructor($,v){super(),this.B((0,S.$aP)($,"dragover",y=>{y.preventDefault(),this.a||(this.a=setTimeout(()=>{v(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(y=>{this.B((0,S.$aP)($,y,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$FQ=j,t.$GQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$1r.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function k(C,$,v,y,O){const r=document.createElement("div");if(r.className=v,r.textContent=$,O&&(r.style.color=O),y&&(r.style.background=y),C.dataTransfer){const l=(0,S.getWindow)(C).document;l.body.appendChild(r),C.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>l.body.removeChild(r),0)}}t.$HQ=k}),define(ge[55],me([1,0,3]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=t.$$Q=t.$0Q=void 0;function R(r,l={}){const e=j(l);return e.textContent=r,e}t.$0Q=R;function n(r,l={}){const e=j(l);return $(e,v(r,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.$$Q=n;function j(r){const l=r.inline?"span":"div",e=document.createElement(l);return r.className&&(e.className=r.className),e}t.$_Q=j;class k{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var C;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(C||(C={}));function $(r,l,e,c){let d;if(l.type===2)d=document.createTextNode(l.content||"");else if(l.type===3)d=document.createElement("b");else if(l.type===4)d=document.createElement("i");else if(l.type===7&&c)d=document.createElement("code");else if(l.type===5&&e){const p=document.createElement("a");e.disposables.add(S.$bP(p,"click",o=>{e.callback(String(l.index),o)})),d=p}else l.type===8?d=document.createElement("br"):l.type===1&&(d=r);d&&r!==d&&r.appendChild(d),d&&Array.isArray(l.children)&&l.children.forEach(p=>{$(d,p,e,c)})}function v(r,l){const e={type:1,children:[]};let c=0,d=e;const p=[],o=new k(r);for(;!o.eos();){let a=o.next();const E=a==="\\"&&O(o.peek(),l)!==0;if(E&&(a=o.next()),!E&&y(a,l)&&a===o.peek()){o.advance(),d.type===2&&(d=p.pop());const m=O(a,l);if(d.type===m||d.type===5&&m===6)d=p.pop();else{const f={type:m,children:[]};m===5&&(f.index=c,c++),d.children.push(f),p.push(d),d=f}}else if(a===`
`)d.type===2&&(d=p.pop()),d.children.push({type:8});else if(d.type!==2){const m={type:2,content:a};d.children.push(m),p.push(d),d=m}else d.content+=a}return d.type===2&&(d=p.pop()),p.length,e}function y(r,l){return O(r,l)!==0}function O(r,l){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(ge[56],me([1,0,3,2]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LQ=void 0;class n{constructor(){this.a=new R.$Rc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(k,C){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const $=this.c;this.c=null,k&&$&&$(C)}isMonitoring(){return!!this.b}startMonitoring(k,C,$,v,y){this.isMonitoring()&&this.stopMonitoring(!1),this.b=v,this.c=y;let O=k;try{k.setPointerCapture(C),this.a.add((0,R.$Qc)(()=>{try{k.releasePointerCapture(C)}catch{}}))}catch{O=S.getWindow(k)}this.a.add(S.$aP(O,S.$5P.POINTER_MOVE,r=>{if(r.buttons!==$){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(S.$aP(O,S.$5P.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.$LQ=n});var Xe=this&&this.__decorate||function(ne,t,S,R){var n=arguments.length,j=n<3?t:R===null?R=Object.getOwnPropertyDescriptor(t,S):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,t,S,R);else for(var C=ne.length-1;C>=0;C--)(k=ne[C])&&(j=(n<3?k(j):n>3?k(t,S,j):k(t,S))||j);return n>3&&j&&Object.defineProperty(t,S,j),j};define(ge[25],me([1,0,3,21,12,27,4,2,45]),function(ne,t,S,R,n,j,k,C,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=t.EventType=void 0;var v;(function(O){O.Tap="-monaco-gesturetap",O.Change="-monaco-gesturechange",O.Start="-monaco-gesturestart",O.End="-monaco-gesturesend",O.Contextmenu="-monaco-gesturecontextmenu"})(v||(t.EventType=v={}));class y extends C.$Sc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new $.$3c,this.h=new $.$3c,this.m={},this.j=null,this.n=0,this.B(k.Event.runAndSubscribe(S.onDidRegisterWindow,({window:r,disposables:l})=>{l.add(S.$aP(r.document,"touchstart",e=>this.s(e),{passive:!1})),l.add(S.$aP(r.document,"touchend",e=>this.u(r,e))),l.add(S.$aP(r.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:R.$FO,disposables:this.q}))}static addTarget(r){if(!y.isTouchDevice())return C.$Sc.None;y.b||(y.b=(0,C.$Lc)(new y));const l=y.b.g.push(r);return(0,C.$Qc)(l)}static ignoreTarget(r){if(!y.isTouchDevice())return C.$Sc.None;y.b||(y.b=(0,C.$Lc)(new y));const l=y.b.h.push(r);return(0,C.$Qc)(l)}static isTouchDevice(){return"ontouchstart"in R.$FO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(r){const l=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,c=r.targetTouches.length;e<c;e++){const d=r.targetTouches.item(e);this.m[d.identifier]={id:d.identifier,initialTarget:d.target,initialTimeStamp:l,initialPageX:d.pageX,initialPageY:d.pageY,rollingTimestamps:[l],rollingPageX:[d.pageX],rollingPageY:[d.pageY]};const p=this.w(v.Start,d.target);p.pageX=d.pageX,p.pageY=d.pageY,this.z(p)}this.f&&(r.preventDefault(),r.stopPropagation(),this.f=!1)}u(r,l){const e=Date.now(),c=Object.keys(this.m).length;for(let d=0,p=l.changedTouches.length;d<p;d++){const o=l.changedTouches.item(d);if(!this.m.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const a=this.m[o.identifier],E=Date.now()-a.initialTimeStamp;if(E<y.c&&Math.abs(a.initialPageX-n.$sb(a.rollingPageX))<30&&Math.abs(a.initialPageY-n.$sb(a.rollingPageY))<30){const m=this.w(v.Tap,a.initialTarget);m.pageX=n.$sb(a.rollingPageX),m.pageY=n.$sb(a.rollingPageY),this.z(m)}else if(E>=y.c&&Math.abs(a.initialPageX-n.$sb(a.rollingPageX))<30&&Math.abs(a.initialPageY-n.$sb(a.rollingPageY))<30){const m=this.w(v.Contextmenu,a.initialTarget);m.pageX=n.$sb(a.rollingPageX),m.pageY=n.$sb(a.rollingPageY),this.z(m)}else if(c===1){const m=n.$sb(a.rollingPageX),f=n.$sb(a.rollingPageY),N=n.$sb(a.rollingTimestamps)-a.rollingTimestamps[0],B=m-a.rollingPageX[0],L=f-a.rollingPageY[0],w=[...this.g].filter(P=>a.initialTarget instanceof Node&&P.contains(a.initialTarget));this.C(r,w,e,Math.abs(B)/N,B>0?1:-1,m,Math.abs(L)/N,L>0?1:-1,f)}this.z(this.w(v.End,a.initialTarget)),delete this.m[o.identifier]}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}w(r,l){const e=document.createEvent("CustomEvent");return e.initEvent(r,!1,!0),e.initialTarget=l,e.tapCount=0,e}z(r){if(r.type===v.Tap){const l=new Date().getTime();let e=0;l-this.n>y.r?e=1:e=2,this.n=l,r.tapCount=e}else(r.type===v.Change||r.type===v.Contextmenu)&&(this.n=0);if(r.initialTarget instanceof Node){for(const l of this.h)if(l.contains(r.initialTarget))return;for(const l of this.g)l.contains(r.initialTarget)&&(l.dispatchEvent(r),this.f=!0)}}C(r,l,e,c,d,p,o,a,E){this.j=S.$kP(r,()=>{const m=Date.now(),f=m-e;let N=0,B=0,L=!0;c+=y.a*f,o+=y.a*f,c>0&&(L=!1,N=d*c*f),o>0&&(L=!1,B=a*o*f);const w=this.w(v.Change);w.translationX=N,w.translationY=B,l.forEach(P=>P.dispatchEvent(w)),L||this.C(r,l,m,c,d,p+N,o,a,E+B)})}D(r){const l=Date.now();for(let e=0,c=r.changedTouches.length;e<c;e++){const d=r.changedTouches.item(e);if(!this.m.hasOwnProperty(String(d.identifier))){console.warn("end of an UNKNOWN touch",d);continue}const p=this.m[d.identifier],o=this.w(v.Change,p.initialTarget);o.translationX=d.pageX-n.$sb(p.rollingPageX),o.translationY=d.pageY-n.$sb(p.rollingPageY),o.pageX=d.pageX,o.pageY=d.pageY,this.z(o),p.rollingPageX.length>3&&(p.rollingPageX.shift(),p.rollingPageY.shift(),p.rollingTimestamps.shift()),p.rollingPageX.push(d.pageX),p.rollingPageY.push(d.pageY),p.rollingTimestamps.push(l)}this.f&&(r.preventDefault(),r.stopPropagation(),this.f=!1)}}t.$IQ=y,Xe([j.$sh],y,"isTouchDevice",null)}),define(ge[57],me([1,0,3,91]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=t.$cR=t.$bR=void 0;const R=2e4;let n,j,k,C,$;function v(l){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const d=document.createElement("div");return d.className="monaco-alert",d.setAttribute("role","alert"),d.setAttribute("aria-atomic","true"),n.appendChild(d),d};j=e(),k=e();const c=()=>{const d=document.createElement("div");return d.className="monaco-status",d.setAttribute("aria-live","polite"),d.setAttribute("aria-atomic","true"),n.appendChild(d),d};C=c(),$=c(),l.appendChild(n)}t.$bR=v;function y(l){n&&(j.textContent!==l?(S.$_O(k),r(j,l)):(S.$_O(j),r(k,l)))}t.$cR=y;function O(l){n&&(C.textContent!==l?(S.$_O($),r(C,l)):(S.$_O(C),r($,l)))}t.$dR=O;function r(l,e){S.$_O(l),e.length>R&&(e=e.substr(0,R)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define(ge[118],me([1,0,3,18]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=t.$FR=void 0;const n=new RegExp(`(\\\\)?\\$\\((${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?)\\)`,"g");function j(C){const $=new Array;let v,y=0,O=0;for(;(v=n.exec(C))!==null;){O=v.index||0,y<O&&$.push(C.substring(y,O)),y=(v.index||0)+v[0].length;const[,r,l]=v;$.push(r?`$(${l})`:k({id:l}))}return y<C.length&&$.push(C.substring(y)),$}t.$FR=j;function k(C){const $=S.$("span");return $.classList.add(...R.ThemeIcon.asClassNameArray(C)),$}t.$GR=k}),define(ge[119],me([1,0,3]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=void 0;function R(j){try{j.parentElement?.removeChild(j)}catch{}}class n{constructor(k){this.d=k,this.a=new Map,this.b=new Set,this.c=!1}alloc(k){let C=this.h(k).pop(),$=!1;if(C)$=this.b.has(C.domNode),$&&this.b.delete(C.domNode);else{const v=(0,S.$)(".monaco-list-row"),O=this.i(k).renderTemplate(v);C={domNode:v,templateId:k,templateData:O}}return{row:C,isReusingConnectedDomNode:$}}release(k){k&&this.f(k)}transact(k){if(this.c)throw new Error("Already in transaction");this.c=!0;try{k()}finally{for(const C of this.b)this.g(C);this.b.clear(),this.c=!1}}f(k){const{domNode:C,templateId:$}=k;C&&(this.c?this.b.add(C):this.g(C)),this.h($).push(k)}g(k){k.classList.remove("scrolling"),R(k)}h(k){let C=this.a.get(k);return C||(C=[],this.a.set(k,C)),C}dispose(){this.a.forEach((k,C)=>{for(const $ of k)this.i(C).disposeTemplate($.templateData),$.templateData=null}),this.a.clear(),this.b.clear()}i(k){const C=this.d.get(k);if(!C)throw new Error(`No renderer found for ${k}`);return C}}t.$mR=n}),define(ge[120],me([1,0,9,2]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=void 0;class n extends R.$Sc{constructor(k,C,$){super(),this.a=k,this.b=C,this.c=$,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new S.$$g)}setVisibility(k){this.a!==k&&(this.a=k,this.s())}setShouldBeVisible(k){this.g=k,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const k=this.r();this.h!==k&&(this.h=k,this.ensureVisibility())}setIsNeeded(k){this.j!==k&&(this.j=k,this.ensureVisibility())}setDomNode(k){this.f=k,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(k){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(k?" fade":"")))}}t.$QQ=n}),define(ge[121],me([1,0,3,25,12,4,2,5]),function(ne,t,S,R,n,j,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=void 0;class $ extends k.$Sc{constructor(y,O,r,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new j.$Sd),this.h=r,this.j(),this.setOptions(y,O)}j(){this.B(R.$IQ.addTarget(this.a)),[R.EventType.Tap].forEach(y=>{this.B(S.$aP(this.a,y,O=>{this.a.focus()}))}),this.B(S.$bP(this.a,"click",y=>{S.$7P.stop(y,!0)})),this.B(S.$bP(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(S.$bP(this.a,"keydown",y=>{let O=!1;C.$j?(y.keyCode===18||y.keyCode===16||y.keyCode===10)&&(O=!0):(y.keyCode===18&&y.altKey||y.keyCode===10||y.keyCode===3)&&(O=!0),O&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,O){(!this.c||!n.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((r,l)=>{this.a.add(this.m(r.text,l,r.isDisabled))})),O!==void 0&&this.select(O)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,O,r){const l=document.createElement("option");return l.value=y,l.text=y,l.disabled=!!r,l}}t.$NR=$}),define(ge[58],me([1,0,26,12,9,50,86,4,28]),function(ne,t,S,R,n,j,k,C,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.$iT=t.$hT=void 0;function v(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.$hT=v;function y(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.$iT=y;function O(l){return typeof l.collapsible=="boolean"}class r{constructor(e,c,d,p={}){this.o=e,this.p=c,this.rootRef=[],this.d=new C.$1d,this.f=new C.$Sd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new C.$Sd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new C.$Sd,this.onDidSplice=this.l.event,this.m=new n.$Xg(j.$Pd),this.h=typeof p.collapseByDefault>"u"?!1:p.collapseByDefault,this.j=p.filter,this.k=typeof p.autoExpandSingleChildren>"u"?!1:p.autoExpandSingleChildren,this.c={parent:void 0,element:d,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,c,d=$.Iterable.empty(),p={}){if(e.length===0)throw new S.$fT(this.o,"Invalid tree location");p.diffIdentityProvider?this.q(p.diffIdentityProvider,e,c,d,p):this.s(e,c,d,p)}q(e,c,d,p=$.Iterable.empty(),o,a=o.diffDepth??0){const{parentNode:E}=this.G(c);if(!E.lastDiffIds)return this.s(c,d,p,o);const m=[...p],f=c[c.length-1],N=new k.$Ks({getElements:()=>E.lastDiffIds},{getElements:()=>[...E.children.slice(0,f),...m,...E.children.slice(f+d)].map(M=>e.getId(M.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return E.lastDiffIds=void 0,this.s(c,d,m,o);const B=c.slice(0,-1),L=(M,U,V)=>{if(a>0)for(let F=0;F<V;F++)M--,U--,this.q(e,[...B,M,0],Number.MAX_SAFE_INTEGER,m[U].children,o,a-1)};let w=Math.min(E.children.length,f+d),P=m.length;for(const M of N.changes.sort((U,V)=>V.originalStart-U.originalStart))L(w,P,w-(M.originalStart+M.originalLength)),w=M.originalStart,P=M.modifiedStart-f,this.s([...B,w],M.originalLength,$.Iterable.slice(m,P,P+M.modifiedLength),o);L(w,P,w)}s(e,c,d=$.Iterable.empty(),{onDidCreateNode:p,onDidDeleteNode:o,diffIdentityProvider:a}){const{parentNode:E,listIndex:m,revealed:f,visible:N}=this.G(e),B=[],L=$.Iterable.map(d,re=>this.w(re,E,E.visible?1:0,f,B,p)),w=e[e.length-1],P=E.children.length>0;let M=0;for(let re=w;re>=0&&re<E.children.length;re--){const ie=E.children[re];if(ie.visible){M=ie.visibleChildIndex;break}}const U=[];let V=0,F=0;for(const re of L)U.push(re),F+=re.renderNodeCount,re.visible&&(re.visibleChildIndex=M+V++);const I=(0,R.$6b)(E.children,w,c,U);a?E.lastDiffIds?(0,R.$6b)(E.lastDiffIds,w,c,U.map(re=>a.getId(re.element).toString())):E.lastDiffIds=E.children.map(re=>a.getId(re.element).toString()):E.lastDiffIds=void 0;let z=0;for(const re of I)re.visible&&z++;if(z!==0)for(let re=w+U.length;re<E.children.length;re++){const ie=E.children[re];ie.visible&&(ie.visibleChildIndex-=z)}if(E.visibleChildrenCount+=V-z,f&&N){const re=I.reduce((ie,te)=>ie+(te.visible?te.renderNodeCount:0),0);this.B(E,F-re),this.p.splice(m,re,B)}if(I.length>0&&o){const re=ie=>{o(ie),ie.children.forEach(re)};I.forEach(re)}this.l.fire({insertedNodes:U,deletedNodes:I});const X=E.children.length>0;P!==X&&this.setCollapsible(e.slice(0,-1),X);let G=E;for(;G;){if(G.visibility===2){this.m.trigger(()=>this.refilter());break}G=G.parent}}rerender(e){if(e.length===0)throw new S.$fT(this.o,"Invalid tree location");const{node:c,listIndex:d,revealed:p}=this.F(e);c.visible&&p&&this.p.splice(d,1,[c])}updateElementHeight(e,c){if(e.length===0)throw new S.$fT(this.o,"Invalid tree location");const{listIndex:d}=this.F(e);this.p.updateElementHeight(d,c)}has(e){return this.D(e)}getListIndex(e){const{listIndex:c,visible:d,revealed:p}=this.F(e);return d&&p?c:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,c){const d=this.E(e);typeof c>"u"&&(c=!d.collapsible);const p={collapsible:c};return this.d.bufferEvents(()=>this.t(e,p))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,c,d){const p=this.E(e);typeof c>"u"&&(c=!p.collapsed);const o={collapsed:c,recursive:d||!1};return this.d.bufferEvents(()=>this.t(e,o))}t(e,c){const{node:d,listIndex:p,revealed:o}=this.F(e),a=this.u(d,p,o,c);if(d!==this.c&&this.k&&a&&!O(c)&&d.collapsible&&!d.collapsed&&!c.recursive){let E=-1;for(let m=0;m<d.children.length;m++)if(d.children[m].visible)if(E>-1){E=-1;break}else E=m;E>-1&&this.t([...e,E],c)}return a}u(e,c,d,p){const o=this.v(e,p,!1);if(!d||!e.visible||!o)return o;const a=e.renderNodeCount,E=this.x(e),m=a-(c===-1?0:1);return this.p.splice(c+1,m,E.slice(1)),o}v(e,c,d){let p;if(e===this.c?p=!1:(O(c)?(p=e.collapsible!==c.collapsible,e.collapsible=c.collapsible):e.collapsible?(p=e.collapsed!==c.collapsed,e.collapsed=c.collapsed):p=!1,p&&this.f.fire({node:e,deep:d})),!O(c)&&c.recursive)for(const o of e.children)p=this.v(o,c,!0)||p;return p}expandTo(e){this.d.bufferEvents(()=>{let c=this.E(e);for(;c.parent;)c=c.parent,e=e.slice(0,e.length-1),c.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,c=this.z(this.c);this.p.splice(0,e,c),this.m.cancel()}w(e,c,d,p,o,a){const E={parent:c,element:e.element,children:[],depth:c.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},m=this.C(E,d);E.visibility=m,p&&o.push(E);const f=e.children||$.Iterable.empty(),N=p&&m!==0&&!E.collapsed;let B=0,L=1;for(const w of f){const P=this.w(w,E,m,N,o,a);E.children.push(P),L+=P.renderNodeCount,P.visible&&(P.visibleChildIndex=B++)}return E.collapsible=E.collapsible||E.children.length>0,E.visibleChildrenCount=B,E.visible=m===2?B>0:m===1,E.visible?E.collapsed||(E.renderNodeCount=L):(E.renderNodeCount=0,p&&o.pop()),a?.(E),E}x(e){const c=e.renderNodeCount,d=[];return this.y(e,d),this.B(e.parent,d.length-c),d}y(e,c){if(e.visible===!1)return 0;if(c.push(e),e.renderNodeCount=1,!e.collapsed)for(const d of e.children)e.renderNodeCount+=this.y(d,c);return this.g.fire(e),e.renderNodeCount}z(e){const c=e.renderNodeCount,d=[];return this.A(e,e.visible?1:0,d),this.B(e.parent,d.length-c),d}A(e,c,d,p=!0){let o;if(e!==this.c){if(o=this.C(e,c),o===0)return e.visible=!1,e.renderNodeCount=0,!1;p&&d.push(e)}const a=d.length;e.renderNodeCount=e===this.c?0:1;let E=!1;if(!e.collapsed||o!==0){let m=0;for(const f of e.children)E=this.A(f,o,d,p&&!e.collapsed)||E,f.visible&&(f.visibleChildIndex=m++);e.visibleChildrenCount=m}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=o===2?E:o===1,e.visibility=o),e.visible?e.collapsed||(e.renderNodeCount+=d.length-a):(e.renderNodeCount=0,p&&d.pop()),this.g.fire(e),e.visible}B(e,c){if(c!==0)for(;e;)e.renderNodeCount+=c,this.g.fire(e),e=e.parent}C(e,c){const d=this.j?this.j.filter(e.element,c):1;return typeof d=="boolean"?(e.filterData=void 0,d?1:0):v(d)?(e.filterData=d.data,y(d.visibility)):(e.filterData=void 0,y(d))}D(e,c=this.c){if(!e||e.length===0)return!0;const[d,...p]=e;return d<0||d>c.children.length?!1:this.D(p,c.children[d])}E(e,c=this.c){if(!e||e.length===0)return c;const[d,...p]=e;if(d<0||d>c.children.length)throw new S.$fT(this.o,"Invalid tree location");return this.E(p,c.children[d])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:c,listIndex:d,revealed:p,visible:o}=this.G(e),a=e[e.length-1];if(a<0||a>c.children.length)throw new S.$fT(this.o,"Invalid tree location");const E=c.children[a];return{node:E,listIndex:d,revealed:p,visible:o&&E.visible}}G(e,c=this.c,d=0,p=!0,o=!0){const[a,...E]=e;if(a<0||a>c.children.length)throw new S.$fT(this.o,"Invalid tree location");for(let m=0;m<a;m++)d+=c.children[m].renderNodeCount;return p=p&&!c.collapsed,o=o&&c.visible,E.length===0?{parentNode:c,listIndex:d,revealed:p,visible:o}:this.G(E,c.children[a],d+1,p,o)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const c=[];let d=e;for(;d.parent;)c.push(d.parent.children.indexOf(d)),d=d.parent;return c.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,R.$tb)(e)[0]}getFirstElementChild(e){const c=this.E(e);if(c.children.length!==0)return c.children[0].element}getLastElementAncestor(e=[]){const c=this.E(e);if(c.children.length!==0)return this.H(c)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$jT=r}),define(ge[122],me([1,0,58,26,28]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qT=void 0;class j{get size(){return this.d.size}constructor(C,$,v={}){this.k=C,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new S.$jT(C,$,null,v),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,v.sorter&&(this.j={compare(y,O){return v.sorter.compare(y.element,O.element)}}),this.h=v.identityProvider}setChildren(C,$=n.Iterable.empty(),v={}){const y=this.o(C);this.l(y,this.m($),v)}l(C,$=n.Iterable.empty(),v){const y=new Set,O=new Set,r=e=>{if(e.element===null)return;const c=e;if(y.add(c.element),this.d.set(c.element,c),this.h){const d=this.h.getId(c.element).toString();O.add(d),this.f.set(d,c)}v.onDidCreateNode?.(c)},l=e=>{if(e.element===null)return;const c=e;if(y.has(c.element)||this.d.delete(c.element),this.h){const d=this.h.getId(c.element).toString();O.has(d)||this.f.delete(d)}v.onDidDeleteNode?.(c)};this.c.splice([...C,0],Number.MAX_VALUE,$,{...v,onDidCreateNode:r,onDidDeleteNode:l})}m(C=n.Iterable.empty()){return this.j&&(C=[...C].sort(this.j.compare.bind(this.j))),n.Iterable.map(C,$=>{let v=this.d.get($.element);if(!v&&this.h){const r=this.h.getId($.element).toString();v=this.f.get(r)}if(!v){let r;return typeof $.collapsed>"u"?r=void 0:$.collapsed===R.ObjectTreeElementCollapseState.Collapsed||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:$.collapsed===R.ObjectTreeElementCollapseState.Expanded||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!$.collapsed,{...$,children:this.m($.children),collapsed:r}}const y=typeof $.collapsible=="boolean"?$.collapsible:v.collapsible;let O;return typeof $.collapsed>"u"||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrCollapsed||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrExpanded?O=v.collapsed:$.collapsed===R.ObjectTreeElementCollapseState.Collapsed?O=!0:$.collapsed===R.ObjectTreeElementCollapseState.Expanded?O=!1:O=!!$.collapsed,{...$,collapsible:y,collapsed:O,children:this.m($.children)}})}rerender(C){const $=this.o(C);this.c.rerender($)}updateElementHeight(C,$){const v=this.o(C);this.c.updateElementHeight(v,$)}resort(C=null,$=!0){if(!this.j)return;const v=this.o(C),y=this.c.getNode(v);this.l(v,this.n(y,$),{})}n(C,$,v=!0){let y=[...C.children];return($||v)&&(y=y.sort(this.j.compare.bind(this.j))),n.Iterable.map(y,O=>({element:O.element,collapsible:O.collapsible,collapsed:O.collapsed,children:this.n(O,$,!1)}))}getFirstElementChild(C=null){const $=this.o(C);return this.c.getFirstElementChild($)}getLastElementAncestor(C=null){const $=this.o(C);return this.c.getLastElementAncestor($)}has(C){return this.d.has(C)}getListIndex(C){const $=this.o(C);return this.c.getListIndex($)}getListRenderCount(C){const $=this.o(C);return this.c.getListRenderCount($)}isCollapsible(C){const $=this.o(C);return this.c.isCollapsible($)}setCollapsible(C,$){const v=this.o(C);return this.c.setCollapsible(v,$)}isCollapsed(C){const $=this.o(C);return this.c.isCollapsed($)}setCollapsed(C,$,v){const y=this.o(C);return this.c.setCollapsed(y,$,v)}expandTo(C){const $=this.o(C);this.c.expandTo($)}refilter(){this.c.refilter()}getNode(C=null){if(C===null)return this.c.getNode(this.c.rootRef);const $=this.d.get(C);if(!$)throw new R.$fT(this.k,`Tree element not found: ${C}`);return $}getNodeLocation(C){return C.element}getParentNodeLocation(C){if(C===null)throw new R.$fT(this.k,"Invalid getParentNodeLocation call");const $=this.d.get(C);if(!$)throw new R.$fT(this.k,`Tree element not found: ${C}`);const v=this.c.getNodeLocation($),y=this.c.getParentNodeLocation(v);return this.c.getNode(y).element}o(C){if(C===null)return[];const $=this.d.get(C);if(!$)throw new R.$fT(this.k,`Tree element not found: ${C}`);return this.c.getNodeLocation($)}}t.$qT=j}),define(ge[20],me([1,0,3,14,19,25,2]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MQ=void 0;class C extends k.$Sc{f(v,y){this.B(S.$aP(v,S.$5P.CLICK,O=>y(new n.$5O(S.getWindow(v),O))))}j(v,y){this.B(S.$aP(v,S.$5P.MOUSE_DOWN,O=>y(new n.$5O(S.getWindow(v),O))))}m(v,y){this.B(S.$aP(v,S.$5P.MOUSE_OVER,O=>y(new n.$5O(S.getWindow(v),O))))}u(v,y){this.B(S.$aP(v,S.$5P.MOUSE_LEAVE,O=>y(new n.$5O(S.getWindow(v),O))))}z(v,y){this.B(S.$aP(v,S.$5P.KEY_DOWN,O=>y(new R.$0O(O))))}C(v,y){this.B(S.$aP(v,S.$5P.KEY_UP,O=>y(new R.$0O(O))))}D(v,y){this.B(S.$aP(v,S.$5P.INPUT,y))}F(v,y){this.B(S.$aP(v,S.$5P.BLUR,y))}G(v,y){this.B(S.$aP(v,S.$5P.FOCUS,y))}H(v,y){this.B(S.$aP(v,S.$5P.CHANGE,y))}I(v){return j.$IQ.ignoreTarget(v)}}t.$MQ=C}),define(ge[38],me([1,0,56,20,9,18,3]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OQ=t.$NQ=void 0,t.$NQ=11;class C extends R.$MQ{constructor(v){super(),this.a=v.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=v.bgWidth+"px",this.bgDomNode.style.height=v.bgHeight+"px",typeof v.top<"u"&&(this.bgDomNode.style.top="0px"),typeof v.left<"u"&&(this.bgDomNode.style.left="0px"),typeof v.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof v.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=v.className,this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(v.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$NQ+"px",this.domNode.style.height=t.$NQ+"px",typeof v.top<"u"&&(this.domNode.style.top=v.top+"px"),typeof v.left<"u"&&(this.domNode.style.left=v.left+"px"),typeof v.bottom<"u"&&(this.domNode.style.bottom=v.bottom+"px"),typeof v.right<"u"&&(this.domNode.style.right=v.right+"px"),this.g=this.B(new S.$LQ),this.B(k.$bP(this.bgDomNode,k.$5P.POINTER_DOWN,y=>this.h(y))),this.B(k.$bP(this.domNode,k.$5P.POINTER_DOWN,y=>this.h(y))),this.b=this.B(new k.$mP),this.c=this.B(new n.$$g)}h(v){if(!v.target||!(v.target instanceof Element))return;const y=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,k.getWindow(v))};this.a(),this.b.cancel(),this.c.cancelAndSet(y,200),this.g.startMonitoring(v.target,v.pointerId,v.buttons,O=>{},()=>{this.b.cancel(),this.c.cancel()}),v.preventDefault()}}t.$OQ=C}),define(ge[59],me([1,0,3,41,56,38,120,20,5]),function(ne,t,S,R,n,j,k,C,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=void 0;const v=140;class y extends C.$MQ{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.n=this.B(new k.$QQ(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$LQ),this.s=!0,this.domNode=(0,R.$KQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(S.$aP(this.domNode.domNode,S.$5P.POINTER_DOWN,l=>this.M(l)))}t(r){const l=this.B(new j.$OQ(r));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}w(r,l,e,c){this.slider=(0,R.$KQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof c=="number"&&this.slider.setHeight(c),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(S.$aP(this.slider.domNode,S.$5P.POINTER_DOWN,d=>{d.button===0&&(d.preventDefault(),this.O(d))})),this.f(this.slider.domNode,d=>{d.leftButton&&d.stopPropagation()})}y(r){return this.h.setVisibleSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(r){return this.h.setScrollSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(r){return this.h.setScrollPosition(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(r){r.target===this.domNode.domNode&&this.N(r)}delegatePointerDown(r){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),c=l+this.h.getSliderPosition()+this.h.getSliderSize(),d=this.U(r);e<=d&&d<=c?r.button===0&&(r.preventDefault(),this.O(r)):this.N(r)}N(r){let l,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")l=r.offsetX,e=r.offsetY;else{const d=S.$wP(this.domNode.domNode);l=r.pageX-d.left,e=r.pageY-d.top}const c=this.S(l,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(c):this.h.getDesiredScrollPositionFromOffset(c)),r.button===0&&(r.preventDefault(),this.O(r))}O(r){if(!r.target||!(r.target instanceof Element))return;const l=this.U(r),e=this.W(r),c=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(r.target,r.pointerId,r.buttons,d=>{const p=this.W(d),o=Math.abs(p-e);if($.$i&&o>v){this.P(c.getScrollPosition());return}const E=this.U(d)-l;this.P(c.getDesiredScrollPositionFromDelta(E))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(r){const l={};this.writeScrollPosition(l,r),this.b.setScrollPositionNow(l)}updateScrollbarSize(r){this.X(r),this.h.setScrollbarSize(r),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$RQ=y}),define(ge[123],me([1,0,19,59,38,42,17]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SQ=void 0;class C extends R.$RQ{constructor(v,y,O){const r=v.getScrollDimensions(),l=v.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:O,scrollbarState:new j.$PQ(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===2?0:y.horizontalScrollbarSize,y.vertical===2?0:y.verticalScrollbarSize,r.width,r.scrollWidth,l.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:v,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const e=(y.arrowSize-n.$NQ)/2,c=(y.horizontalScrollbarSize-n.$NQ)/2;this.t({className:"scra",icon:k.$6j.scrollbarButtonLeft,top:c,left:e,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new S.$7O(null,1,0))}),this.t({className:"scra",icon:k.$6j.scrollbarButtonRight,top:c,left:void 0,bottom:void 0,right:e,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new S.$7O(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(v,y){this.slider.setWidth(v),this.slider.setLeft(y)}Q(v,y){this.domNode.setWidth(v),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(v){return this.s=this.J(v.scrollWidth)||this.s,this.s=this.L(v.scrollLeft)||this.s,this.s=this.y(v.width)||this.s,this.s}S(v,y){return v}U(v){return v.pageX}W(v){return v.pageY}X(v){this.slider.setHeight(v)}writeScrollPosition(v,y){v.scrollLeft=y}updateOptions(v){this.updateScrollbarSize(v.horizontal===2?0:v.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(v.vertical===2?0:v.verticalScrollbarSize),this.n.setVisibility(v.horizontal),this.c=v.scrollByPage}}t.$SQ=C}),define(ge[124],me([1,0,19,59,38,42,17]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=void 0;class C extends R.$RQ{constructor(v,y,O){const r=v.getScrollDimensions(),l=v.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:O,scrollbarState:new j.$PQ(y.verticalHasArrows?y.arrowSize:0,y.vertical===2?0:y.verticalScrollbarSize,0,r.height,r.scrollHeight,l.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:v,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const e=(y.arrowSize-n.$NQ)/2,c=(y.verticalScrollbarSize-n.$NQ)/2;this.t({className:"scra",icon:k.$6j.scrollbarButtonUp,top:e,left:c,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new S.$7O(null,0,1))}),this.t({className:"scra",icon:k.$6j.scrollbarButtonDown,top:void 0,left:c,bottom:e,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new S.$7O(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(v,y){this.slider.setHeight(v),this.slider.setTop(y)}Q(v,y){this.domNode.setWidth(y),this.domNode.setHeight(v),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(v){return this.s=this.J(v.scrollHeight)||this.s,this.s=this.L(v.scrollTop)||this.s,this.s=this.y(v.height)||this.s,this.s}S(v,y){return y}U(v){return v.pageY}W(v){return v.pageX}X(v){this.slider.setWidth(v)}writeScrollPosition(v,y){v.scrollTop=y}updateOptions(v){this.updateScrollbarSize(v.vertical===2?0:v.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(v.vertical),this.c=v.scrollByPage}}t.$TQ=C}),define(ge[60],me([1,0,16,3,41,19,123,124,20,9,4,2,5,48,98]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=void 0;const e=500,c=50,d=!0;class p{constructor(L,w,P){this.timestamp=L,this.deltaX=w,this.deltaY=P,this.score=0}}class o{static{this.INSTANCE=new o}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,w=0,P=1,M=this.d;do{const U=M===this.c?L:Math.pow(2,-P);if(L-=U,w+=this.b[M].score*U,M===this.c)break;M=(this.a+M-1)%this.a,P++}while(!0);return w<=.5}acceptStandardWheelEvent(L){const w=R.getWindow(L.browserEvent).devicePixelRatio/(0,S.$NO)();r.$i||r.$k?this.accept(Date.now(),L.deltaX/w,L.deltaY/w):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,w,P){const M=new p(L,w,P);M.score=this.f(M),this.c===-1&&this.d===-1?(this.b[0]=M,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=M)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let w=.5;const P=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(w+=.25),Math.min(Math.max(w,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$UQ=o;class a extends $.$MQ{get options(){return this.a}constructor(L,w,P){super(),this.O=this.B(new y.$Sd),this.onScroll=this.O.event,this.P=this.B(new y.$Sd),this.onWillScroll=this.P.event,L.style.overflow="hidden",this.a=N(w),this.b=P,this.B(this.b.onScroll(U=>{this.P.fire(U),this.S(U),this.O.fire(U)}));const M={onMouseWheel:U=>this.R(U),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new C.$TQ(this.b,this.a,M)),this.g=this.B(new k.$SQ(this.b,this.a,M)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$KQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$KQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$KQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,U=>this.Z(U)),this.u(this.t,U=>this.Y(U)),this.L=this.B(new v.$$g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,O.$Nc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,r.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(L){this.N=L}delegateScrollFromMouseWheelEvent(L){this.R(new j.$7O(L))}Q(L){if(this.w.length>0!==L&&(this.w=(0,O.$Nc)(this.w),L)){const P=M=>{this.R(new j.$7O(M))};this.w.push(R.$aP(this.t,R.$5P.MOUSE_WHEEL,P,{passive:!1}))}}R(L){if(L.browserEvent?.defaultPrevented)return;const w=o.INSTANCE;d&&w.acceptStandardWheelEvent(L);let P=!1;if(L.deltaY||L.deltaX){let U=L.deltaY*this.a.mouseWheelScrollSensitivity,V=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+U===0?V=U=0:Math.abs(U)>=Math.abs(V)?V=0:U=0),this.a.flipAxes&&([U,V]=[V,U]);const F=!r.$j&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||F)&&!V&&(V=U,U=0),L.browserEvent&&L.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,U=U*this.a.fastScrollSensitivity);const I=this.b.getFutureScrollPosition();let z={};if(U){const X=c*U,G=I.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(z,G)}if(V){const X=c*V,G=I.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(z,G)}z=this.b.validateScrollPosition(z),(I.scrollLeft!==z.scrollLeft||I.scrollTop!==z.scrollTop)&&(d&&this.a.mouseWheelSmoothScroll&&w.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(z):this.b.setScrollPositionNow(z),P=!0)}let M=P;!M&&this.a.alwaysConsumeMouseWheel&&(M=!0),!M&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(M=!0),M&&(L.preventDefault(),L.stopPropagation())}S(L){this.M=this.g.onDidScroll(L)||this.M,this.M=this.c.onDidScroll(L)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),w=L.scrollTop>0,P=L.scrollLeft>0,M=P?" left":"",U=w?" top":"",V=P||w?" top-left-corner":"";this.n.setClassName(`shadow${M}`),this.r.setClassName(`shadow${U}`),this.s.setClassName(`shadow${V}${U}${M}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(L){this.J=!1,this.ab()}Z(L){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$VQ=a;class E extends a{constructor(L,w){w=w||{},w.mouseWheelSmoothScroll=!1;const P=new l.$7r({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>R.$kP(R.getWindow(L),M)});super(L,w,P),this.B(P)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$WQ=E;class m extends a{constructor(L,w,P){super(L,w,P)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$XQ=m;class f extends a{constructor(L,w){w=w||{},w.mouseWheelSmoothScroll=!1;const P=new l.$7r({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:M=>R.$kP(R.getWindow(L),M)});super(L,w,P),this.B(P),this.cb=L,this.B(this.onScroll(M=>{M.scrollTopChanged&&(this.cb.scrollTop=M.scrollTop),M.scrollLeftChanged&&(this.cb.scrollLeft=M.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$YQ=f;function N(B){const L={lazyRender:typeof B.lazyRender<"u"?B.lazyRender:!1,className:typeof B.className<"u"?B.className:"",useShadows:typeof B.useShadows<"u"?B.useShadows:!0,handleMouseWheel:typeof B.handleMouseWheel<"u"?B.handleMouseWheel:!0,flipAxes:typeof B.flipAxes<"u"?B.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof B.consumeMouseWheelIfScrollbarIsNeeded<"u"?B.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof B.alwaysConsumeMouseWheel<"u"?B.alwaysConsumeMouseWheel:!1,scrollYToX:typeof B.scrollYToX<"u"?B.scrollYToX:!1,mouseWheelScrollSensitivity:typeof B.mouseWheelScrollSensitivity<"u"?B.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof B.fastScrollSensitivity<"u"?B.fastScrollSensitivity:5,scrollPredominantAxis:typeof B.scrollPredominantAxis<"u"?B.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof B.mouseWheelSmoothScroll<"u"?B.mouseWheelSmoothScroll:!0,arrowSize:typeof B.arrowSize<"u"?B.arrowSize:11,listenOnDomNode:typeof B.listenOnDomNode<"u"?B.listenOnDomNode:null,horizontal:typeof B.horizontal<"u"?B.horizontal:1,horizontalScrollbarSize:typeof B.horizontalScrollbarSize<"u"?B.horizontalScrollbarSize:10,horizontalSliderSize:typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:0,horizontalHasArrows:typeof B.horizontalHasArrows<"u"?B.horizontalHasArrows:!1,vertical:typeof B.vertical<"u"?B.vertical:1,verticalScrollbarSize:typeof B.verticalScrollbarSize<"u"?B.verticalScrollbarSize:10,verticalHasArrows:typeof B.verticalHasArrows<"u"?B.verticalHasArrows:!1,verticalSliderSize:typeof B.verticalSliderSize<"u"?B.verticalSliderSize:0,scrollByPage:typeof B.scrollByPage<"u"?B.scrollByPage:!1};return L.horizontalSliderSize=typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof B.verticalSliderSize<"u"?B.verticalSliderSize:L.verticalScrollbarSize,r.$j&&(L.className+=" mac"),L}}),define(ge[61],me([1,0,54,3,22,25,60,12,9,27,4,2,47,48,82,119,6]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l,e,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=t.$pR=t.$oR=t.$nR=void 0;const p={CurrentDragAndDropData:void 0},o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class a{get context(){return this.d}set context(w){this.d=w}constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$nR=a;class E{constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$oR=E;class m{constructor(){this.types=[],this.files=[]}update(w){if(w.types&&this.types.splice(0,this.types.length,...w.types),w.files){this.files.splice(0,this.files.length);for(let P=0;P<w.files.length;P++){const M=w.files.item(P);M&&(M.size||M.type)&&this.files.push(M)}}}getData(){return{types:this.types,files:this.files}}}t.$pR=m;function f(L,w){return Array.isArray(L)&&Array.isArray(w)?(0,C.$ub)(L,w):L===w}class N{constructor(w){w?.getSetSize?this.getSetSize=w.getSetSize.bind(w):this.getSetSize=(P,M,U)=>U,w?.getPosInSet?this.getPosInSet=w.getPosInSet.bind(w):this.getPosInSet=(P,M)=>M+1,w?.getRole?this.getRole=w.getRole.bind(w):this.getRole=P=>"listitem",w?.isChecked?this.isChecked=w.isChecked.bind(w):this.isChecked=P=>{}}}class B{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(w){if(w!==this.O){if(w&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=w,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const P of this.d)this.Y(P);this.V(),this.q.setScrollDimensions({width:(0,R.$zP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(w,P,M,U=o){if(this.Q=P,this.domId=`list_id_${++B.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new $.$Xg(50),this.v=!1,this.x=O.$Sc.None,this.y=0,this.G=!1,this.J=O.$Sc.None,this.K=O.$Sc.None,this.L=new O.$Rc,this.M=new y.$Sd,this.N=new y.$Sd,this.onDidChangeContentHeight=y.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=y.Event.latch(this.N.event,void 0,this.L),this.O=!1,U.horizontalScrolling&&U.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$lR(U.paddingTop??0);for(const F of M)this.j.set(F.templateId,F);this.h=this.L.add(new c.$mR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof U.mouseSupport=="boolean"?U.mouseSupport:!0),this.O=U.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof U.paddingBottom>"u"?0:U.paddingBottom,this.D=new N(U.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(U.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(j.$IQ.addTarget(this.o)),this.p=this.L.add(new l.$7r({forceIntegerValues:!0,smoothScrollDuration:U.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:F=>(0,R.$kP)((0,R.getWindow)(this.domNode),F)})),this.q=this.L.add(new k.$XQ(this.o,{alwaysConsumeMouseWheel:U.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:U.verticalScrollMode??o.verticalScrollMode,useShadows:U.useShadows??o.useShadows,mouseWheelScrollSensitivity:U.mouseWheelScrollSensitivity,fastScrollSensitivity:U.fastScrollSensitivity,scrollByPage:U.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),w.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,R.$aP)(this.o,j.EventType.Change,F=>this.hb(F))),this.L.add((0,R.$aP)(this.q.getDomNode(),"scroll",F=>F.target.scrollTop=0)),this.L.add((0,R.$aP)(this.domNode,"dragover",F=>this.jb(this.fb(F)))),this.L.add((0,R.$aP)(this.domNode,"drop",F=>this.lb(this.fb(F)))),this.L.add((0,R.$aP)(this.domNode,"dragleave",F=>this.kb(this.fb(F)))),this.L.add((0,R.$aP)(this.domNode,"dragend",F=>this.mb(F))),this.z=U.setRowLineHeight??o.setRowLineHeight,this.A=U.setRowHeight??o.setRowHeight,this.B=U.supportDynamicHeights??o.supportDynamicHeights,this.F=U.dnd??this.L.add(o.dnd),this.layout(U.initialSize?.height,U.initialSize?.width)}updateOptions(w){w.paddingBottom!==void 0&&(this.C=w.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),w.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(w.smoothScrolling?125:0),w.horizontalScrolling!==void 0&&(this.P=w.horizontalScrolling);let P;if(w.scrollByPage!==void 0&&(P={...P??{},scrollByPage:w.scrollByPage}),w.mouseWheelScrollSensitivity!==void 0&&(P={...P??{},mouseWheelScrollSensitivity:w.mouseWheelScrollSensitivity}),w.fastScrollSensitivity!==void 0&&(P={...P??{},fastScrollSensitivity:w.fastScrollSensitivity}),P&&this.q.updateOptions(P),w.paddingTop!==void 0&&w.paddingTop!==this.g.paddingTop){const M=this.sb(this.k,this.m),U=w.paddingTop-this.g.paddingTop;this.g.paddingTop=w.paddingTop,this.W(M,Math.max(0,this.k+U),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(w){this.q.delegateScrollFromMouseWheelEvent(w)}delegateVerticalScrollbarPointerDown(w){this.q.delegateVerticalScrollbarPointerDown(w)}updateElementHeight(w,P,M){if(w<0||w>=this.d.length)return;const U=this.d[w].size;if(typeof P>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[w].lastDynamicHeightWidth=void 0,P=U+this.ub(w)}if(U===P)return;const V=this.sb(this.k,this.m);let F=0;w<V.start||M!==null&&M>w&&M<V.end?F=P-U:F=0,this.g.splice(w,1,[{size:P}]),this.d[w].size=P,this.W(V,Math.max(0,this.k+F),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(w,P,M=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(w,P,M)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(w,P,M=[]){const U=this.sb(this.k,this.m),V={start:w,end:w+P},F=r.Range.intersect(U,V),I=new Map;for(let H=F.end-1;H>=F.start;H--){const Y=this.d[H];if(Y.dragStartDisposable.dispose(),Y.checkedDisposable.dispose(),Y.row){let be=I.get(Y.templateId);be||(be=[],I.set(Y.templateId,be));const we=this.j.get(Y.templateId);we&&we.disposeElement&&we.disposeElement(Y.element,H,Y.row.templateData,Y.size),be.push(Y.row)}Y.row=null}const z={start:w+P,end:this.d.length},X=r.Range.intersect(z,U),G=r.Range.relativeComplement(z,U),re=M.map(H=>({id:String(this.f++),element:H,templateId:this.Q.getTemplateId(H),size:this.Q.getHeight(H),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(H),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:O.$Sc.None,checkedDisposable:O.$Sc.None}));let ie;w===0&&P>=this.d.length?(this.g=new e.$lR(this.g.paddingTop),this.g.splice(0,0,re),ie=this.d,this.d=re):(this.g.splice(w,P,re),ie=this.d.splice(w,P,...re));const te=M.length-P,$e=this.sb(this.k,this.m),Fe=(0,e.$jR)(X,te),ke=r.Range.intersect($e,Fe);for(let H=ke.start;H<ke.end;H++)this.Z(this.d[H],H);const Le=r.Range.relativeComplement(Fe,$e);for(const H of Le)for(let Y=H.start;Y<H.end;Y++)this.ab(Y);const ae=G.map(H=>(0,e.$jR)(H,te)),le=[{start:w,end:w+M.length},...ae].map(H=>r.Range.intersect($e,H)),K=this.vb(le);for(const H of le)for(let Y=H.start;Y<H.end;Y++){const be=this.d[Y],Ce=I.get(be.templateId)?.pop();this.X(Y,K,Ce)}for(const H of I.values())for(const Y of H)this.h.release(Y);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ie.map(H=>H.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,R.$kP)((0,R.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let w=0;for(const P of this.d)typeof P.width<"u"&&(w=Math.max(w,P.width));this.E=w,this.q.setScrollDimensions({scrollWidth:w===0?0:w+10}),this.N.fire(this.E)}updateWidth(w){if(!this.P||typeof this.E>"u")return;const P=this.d[w];this.Y(P),typeof P.width<"u"&&P.width>this.E&&(this.E=P.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const w of this.d)w.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.sb(this.k,this.m).start}get firstMostlyVisibleIndex(){const w=this.firstVisibleIndex,P=this.g.positionAt(w),M=this.g.positionAt(w+1);return M!==-1&&(M-P)/2+P<this.scrollTop?w+1:w}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(w){return this.d[w].element}indexOf(w){return this.d.findIndex(P=>P.element===w)}domElement(w){const P=this.d[w].row;return P&&P.domNode}elementHeight(w){return this.d[w].size}elementTop(w){return this.g.positionAt(w)}indexAt(w){return this.g.indexAt(w)}indexAfter(w){return this.g.indexAfter(w)}layout(w,P){const M={height:typeof w=="number"?w:(0,R.$BP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,M.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(M),typeof P<"u"&&(this.n=P,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof P=="number"?P:(0,R.$zP)(this.domNode)})}W(w,P,M,U,V,F=!1){const I=this.sb(P,M),z=r.Range.relativeComplement(I,w),X=r.Range.relativeComplement(w,I),G=this.vb(z);if(F){const re=r.Range.intersect(w,I);for(let ie=re.start;ie<re.end;ie++)this.Z(this.d[ie],ie)}this.h.transact(()=>{for(const re of X)for(let ie=re.start;ie<re.end;ie++)this.ab(ie);for(const re of z)for(let ie=re.start;ie<re.end;ie++)this.X(ie,G)}),U!==void 0&&(this.o.style.left=`-${U}px`),this.o.style.top=`-${P}px`,this.P&&V!==void 0&&(this.o.style.width=`${Math.max(V,this.n)}px`),this.k=P,this.m=M}X(w,P,M){const U=this.d[w];let V=!1;if(!U.row)if(M)U.row=M;else{const G=this.h.alloc(U.templateId);U.row=G.row,V=G.isReusingConnectedDomNode}const F=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",F);const I=this.D.isChecked(U.element);if(typeof I=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!I));else if(I){const G=re=>U.row.domNode.setAttribute("aria-checked",String(!!re));G(I.value),U.checkedDisposable=I.onDidChange(G)}(V||!U.row.domNode.parentElement)&&(P?this.o.insertBefore(U.row.domNode,P):this.o.appendChild(U.row.domNode)),this.Z(U,w);const z=this.j.get(U.templateId);if(!z)throw new Error(`No renderer found for template id ${U.templateId}`);z?.renderElement(U.element,w,U.row.templateData,U.size);const X=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!X,X&&(U.dragStartDisposable=(0,R.$aP)(U.row.domNode,"dragstart",G=>this.ib(U.element,X,G))),this.P&&(this.Y(U),this.U())}Y(w){if(!w.row||!w.row.domNode)return;w.row.domNode.style.width="fit-content",w.width=(0,R.$zP)(w.row.domNode);const P=(0,R.getWindow)(w.row.domNode).getComputedStyle(w.row.domNode);P.paddingLeft&&(w.width+=parseFloat(P.paddingLeft)),P.paddingRight&&(w.width+=parseFloat(P.paddingRight)),w.row.domNode.style.width=""}Z(w,P){w.row.domNode.style.top=`${this.elementTop(P)}px`,this.A&&(w.row.domNode.style.height=`${w.size}px`),this.z&&(w.row.domNode.style.lineHeight=`${w.size}px`),w.row.domNode.setAttribute("data-index",`${P}`),w.row.domNode.setAttribute("data-last-element",P===this.length-1?"true":"false"),w.row.domNode.setAttribute("data-parity",P%2===0?"even":"odd"),w.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(w.element,P,this.length))),w.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(w.element,P))),w.row.domNode.setAttribute("id",this.getElementDomId(P)),w.row.domNode.classList.toggle("drop-target",w.dropTarget)}ab(w){const P=this.d[w];if(P.dragStartDisposable.dispose(),P.checkedDisposable.dispose(),P.row){const M=this.j.get(P.templateId);M&&M.disposeElement&&M.disposeElement(P.element,w,P.row.templateData,P.size),this.h.release(P.row),P.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(w,P){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:w,reuseAnimation:P})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:w})}get scrollTop(){return this.getScrollTop()}set scrollTop(w){this.setScrollTop(w)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"click")).event,w=>this.bb(w),this.L)}get onMouseDblClick(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"dblclick")).event,w=>this.bb(w),this.L)}get onMouseMiddleClick(){return y.Event.filter(y.Event.map(this.L.add(new n.$aR(this.domNode,"auxclick")).event,w=>this.bb(w),this.L),w=>w.browserEvent.button===1,this.L)}get onMouseUp(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"mouseup")).event,w=>this.bb(w),this.L)}get onMouseDown(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"mousedown")).event,w=>this.bb(w),this.L)}get onMouseOver(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"mouseover")).event,w=>this.bb(w),this.L)}get onMouseMove(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"mousemove")).event,w=>this.bb(w),this.L)}get onMouseOut(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"mouseout")).event,w=>this.bb(w),this.L)}get onContextMenu(){return y.Event.any(y.Event.map(this.L.add(new n.$aR(this.domNode,"contextmenu")).event,w=>this.bb(w),this.L),y.Event.map(this.L.add(new n.$aR(this.domNode,j.EventType.Contextmenu)).event,w=>this.eb(w),this.L))}get onTouchStart(){return y.Event.map(this.L.add(new n.$aR(this.domNode,"touchstart")).event,w=>this.db(w),this.L)}get onTap(){return y.Event.map(this.L.add(new n.$aR(this.o,j.EventType.Tap)).event,w=>this.eb(w),this.L)}bb(w){const P=this.rb(w.target||null),M=typeof P>"u"?void 0:this.d[P],U=M&&M.element;return{browserEvent:w,index:P,element:U}}db(w){const P=this.rb(w.target||null),M=typeof P>"u"?void 0:this.d[P],U=M&&M.element;return{browserEvent:w,index:P,element:U}}eb(w){const P=this.rb(w.initialTarget||null),M=typeof P>"u"?void 0:this.d[P],U=M&&M.element;return{browserEvent:w,index:P,element:U}}fb(w){const P=this.rb(w.target||null),M=typeof P>"u"?void 0:this.d[P],U=M&&M.element;return{browserEvent:w,index:P,element:U}}gb(w){try{const P=this.sb(this.k,this.m);this.W(P,w.scrollTop,w.height,w.scrollLeft,w.scrollWidth),this.B&&this.tb(w.scrollTop,w.height,w.inSmoothScrolling)}catch(P){throw console.error("Got bad scroll event:",w),P}}hb(w){w.preventDefault(),w.stopPropagation(),this.scrollTop-=w.translationY}ib(w,P,M){if(!M.dataTransfer)return;const U=this.F.getDragElements(w);if(M.dataTransfer.effectAllowed="copyMove",M.dataTransfer.setData(S.$GQ.TEXT,P),M.dataTransfer.setDragImage){let V;this.F.getDragLabel&&(V=this.F.getDragLabel(U,M)),typeof V>"u"&&(V=String(U.length));const F=(0,R.$)(".monaco-drag-image");F.textContent=V;const z=(X=>{for(;X&&!X.classList.contains("monaco-workbench");)X=X.parentElement;return X||this.domNode.ownerDocument})(this.domNode);z.appendChild(F),M.dataTransfer.setDragImage(F,-10,-10),setTimeout(()=>z.removeChild(F),0)}this.domNode.classList.add("dragging"),this.H=new a(U),p.CurrentDragAndDropData=new E(U),this.F.onDragStart?.(this.H,M)}jb(w){if(w.browserEvent.preventDefault(),this.K.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(w.browserEvent),!w.browserEvent.dataTransfer))return!1;if(!this.H)if(p.CurrentDragAndDropData)this.H=p.CurrentDragAndDropData;else{if(!w.browserEvent.dataTransfer.types)return!1;this.H=new m}const P=this.F.onDragOver(this.H,w.element,w.index,w.browserEvent);if(this.G=typeof P=="boolean"?P:P.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;w.browserEvent.dataTransfer.dropEffect=typeof P!="boolean"&&P.effect===0?"copy":"move";let M;if(typeof P!="boolean"&&P.feedback?M=P.feedback:typeof w.index>"u"?M=[-1]:M=[w.index],M=(0,C.$Mb)(M).filter(U=>U>=-1&&U<this.length).sort((U,V)=>U-V),M=M[0]===-1?[-1]:M,f(this.I,M))return!0;if(this.I=M,this.J.dispose(),M[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,O.$Qc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const U of M){const V=this.d[U];V.dropTarget=!0,V.row?.domNode.classList.add("drop-target")}this.J=(0,O.$Qc)(()=>{for(const U of M){const V=this.d[U];V.dropTarget=!1,V.row?.domNode.classList.remove("drop-target")}})}return!0}kb(w){this.K.dispose(),this.K=(0,$.$3g)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,w.element,w.index,w.browserEvent)}lb(w){if(!this.G)return;const P=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,!(!P||!w.browserEvent.dataTransfer)&&(w.browserEvent.preventDefault(),P.update(w.browserEvent.dataTransfer),this.F.drop(P,w.element,w.index,w.browserEvent))}mb(w){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(w)}nb(){this.I=void 0,this.J.dispose(),this.J=O.$Sc.None}ob(w){if(!this.w){const P=(0,R.$tP)(this.domNode).top;this.w=(0,R.$oQ)((0,R.getWindow)(this.domNode),this.pb.bind(this,P))}this.x.dispose(),this.x=(0,$.$3g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=w.pageY}pb(w){if(this.y===void 0)return;const P=this.y-w,M=this.renderHeight-35;P<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(P-35))):P>M&&(this.scrollTop+=Math.min(14,Math.floor(.3*(P-M))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(w){const P=this.q.getDomNode();let M=w;for(;M instanceof HTMLElement&&M!==this.o&&P.contains(M);){const U=M.getAttribute("data-index");if(U){const V=Number(U);if(!isNaN(V))return V}M=M.parentElement}}sb(w,P){return{start:this.g.indexAt(w),end:this.g.indexAfter(w+P-1)}}tb(w,P,M){const U=this.sb(w,P);let V,F;w===this.elementTop(U.start)?(V=U.start,F=0):U.end-U.start>1&&(V=U.start+1,F=this.elementTop(V)-w);let I=0;for(;;){const z=this.sb(w,P);let X=!1;for(let G=z.start;G<z.end;G++){const re=this.ub(G);re!==0&&this.g.splice(G,1,[this.d[G]]),I+=re,X=X||re!==0}if(!X){I!==0&&this.S();const G=r.Range.relativeComplement(U,z);for(const ie of G)for(let te=ie.start;te<ie.end;te++)this.d[te].row&&this.ab(te);const re=r.Range.relativeComplement(z,U);for(const ie of re)for(let te=ie.start;te<ie.end;te++){const $e=te+1,Fe=$e<this.d.length?this.d[$e].row:null,ke=Fe?Fe.domNode:null;this.X(te,ke)}for(let ie=z.start;ie<z.end;ie++)this.d[ie].row&&this.Z(this.d[ie],ie);if(typeof V=="number"){const ie=this.p.getFutureScrollPosition().scrollTop-w,te=this.elementTop(V)-F+ie;this.setScrollTop(te,M)}this.M.fire(this.contentHeight);return}}}ub(w){const P=this.d[w];if(this.Q.getDynamicHeight){const F=this.Q.getDynamicHeight(P.element);if(F!==null){const I=P.size;return P.size=F,P.lastDynamicHeightWidth=this.n,F-I}}if(!P.hasDynamicHeight||P.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(P.element))return 0;const M=P.size;if(P.row)return P.row.domNode.style.height="",P.size=P.row.domNode.offsetHeight,P.lastDynamicHeightWidth=this.n,P.size-M;const{row:U}=this.h.alloc(P.templateId);U.domNode.style.height="",this.o.appendChild(U.domNode);const V=this.j.get(P.templateId);if(!V)throw new d.$cb("Missing renderer for templateId: "+P.templateId);return V.renderElement(P.element,w,U.templateData,void 0),P.size=U.domNode.offsetHeight,V.disposeElement?.(P.element,w,U.templateData,void 0),this.Q.setDynamicHeight?.(P.element,P.size),P.lastDynamicHeightWidth=this.n,this.o.removeChild(U.domNode),this.h.release(U),P.size-M}vb(w){const P=w[w.length-1];if(!P)return null;const M=this.d[P.end];return!M||!M.row?null:M.row.domNode}getElementDomId(w){return`${this.domId}_${w}`}dispose(){for(const w of this.d)if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const P=this.j.get(w.row.templateId);P&&(P.disposeElement?.(w.element,-1,w.row.templateData,void 0),P.disposeTemplate(w.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$qR=B,Xe([v.$sh],B.prototype,"onMouseClick",null),Xe([v.$sh],B.prototype,"onMouseDblClick",null),Xe([v.$sh],B.prototype,"onMouseMiddleClick",null),Xe([v.$sh],B.prototype,"onMouseUp",null),Xe([v.$sh],B.prototype,"onMouseDown",null),Xe([v.$sh],B.prototype,"onMouseOver",null),Xe([v.$sh],B.prototype,"onMouseMove",null),Xe([v.$sh],B.prototype,"onMouseOut",null),Xe([v.$sh],B.prototype,"onContextMenu",null),Xe([v.$sh],B.prototype,"onTouchStart",null),Xe([v.$sh],B.prototype,"onTap",null)}),define(ge[39],me([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,97]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l,e,c,d,p,o,a,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=t.$DR=t.$CR=t.$BR=t.$AR=t.$zR=t.$yR=t.TypeNavigationMode=t.$xR=t.$wR=t.$vR=t.$uR=t.$tR=t.$sR=t.$rR=void 0;class m{constructor(D){this.d=D,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(D){return D}renderElement(D,i,s){const u=this.c.findIndex(h=>h.templateData===s);if(u>=0){const h=this.c[u];this.d.unrender(s),h.index=i}else{const h={index:i,templateData:s};this.c.push(h)}this.d.renderIndex(i,s)}splice(D,i,s){const u=[];for(const h of this.c)h.index<D?u.push(h):h.index>=D+i&&u.push({index:h.index+s-i,templateData:h.templateData});this.c=u}renderIndexes(D){for(const{index:i,templateData:s}of this.c)D.indexOf(i)>-1&&this.d.renderIndex(i,s)}disposeTemplate(D){const i=this.c.findIndex(s=>s.templateData===D);i<0||this.c.splice(i,1)}}class f{get name(){return this.h}get renderer(){return new m(this)}constructor(D){this.h=D,this.c=0,this.d=[],this.f=[],this.g=new r.$Sd,this.onChange=this.g.event}splice(D,i,s){i=Math.max(0,Math.min(i,this.c-D));const u=s.length-i,h=D+i,g=[];let b=0;for(;b<this.f.length&&this.f[b]<D;)g.push(this.f[b++]);for(let T=0;T<s.length;T++)s[T]&&g.push(T+D);for(;b<this.f.length&&this.f[b]>=h;)g.push(this.f[b++]+u);const A=this.c+u;if(this.f.length>0&&g.length===0&&A>0){const T=this.f.find(_=>_>=D)??A-1;g.push(Math.min(T,A-1))}this.renderer.splice(D,i,s.length),this.k(g,g),this.c=A}renderIndex(D,i){i.classList.toggle(this.h,this.contains(D))}unrender(D){D.classList.remove(this.h)}set(D,i){return this.k(D,[...D].sort(Y),i)}k(D,i,s){const u=this.d,h=this.f;this.d=D,this.f=i;const g=K(h,D);return this.renderer.renderIndexes(g),this.g.fire({indexes:D,browserEvent:s}),u}get(){return this.d}contains(D){return(0,$.$wb)(this.f,D,Y)>=0}dispose(){(0,e.$Nc)(this.g)}}Xe([O.$sh],f.prototype,"renderer",null);class N extends f{constructor(D){super("selected"),this.l=D}renderIndex(D,i){super.renderIndex(D,i),this.l&&(this.contains(D)?i.setAttribute("aria-selected","true"):i.setAttribute("aria-selected","false"))}}class B{constructor(D,i,s){this.c=D,this.d=i,this.f=s}splice(D,i,s){if(!this.f)return this.c.splice(D,i,new Array(s.length).fill(!1));const u=this.c.get().map(b=>this.f.getId(this.d.element(b)).toString());if(u.length===0)return this.c.splice(D,i,new Array(s.length).fill(!1));const h=new Set(u),g=s.map(b=>h.has(this.f.getId(b).toString()));this.c.splice(D,i,g)}}function L(ce){return ce.tagName==="INPUT"||ce.tagName==="TEXTAREA"}t.$rR=L;function w(ce,D){return ce.classList.contains(D)?!0:ce.classList.contains("monaco-list")||!ce.parentElement?!1:w(ce.parentElement,D)}function P(ce){return w(ce,"monaco-editor")}t.$sR=P;function M(ce){return w(ce,"monaco-custom-toggle")}t.$tR=M;function U(ce){return w(ce,"action-item")}t.$uR=U;function V(ce){return w(ce,"monaco-tl-twistie")}t.$vR=V;function F(ce){return w(ce,"monaco-tree-sticky-row")}t.$wR=F;function I(ce){return ce.tagName==="A"&&ce.classList.contains("monaco-button")||ce.tagName==="DIV"&&ce.classList.contains("monaco-button-dropdown")?!0:ce.classList.contains("monaco-list")||!ce.parentElement?!1:I(ce.parentElement)}t.$xR=I;class z{get g(){return r.Event.chain(this.c.add(new R.$aR(this.k.domNode,"keydown")).event,D=>D.filter(i=>!L(i.target)).map(i=>new n.$0O(i)))}constructor(D,i,s){this.h=D,this.k=i,this.c=new e.$Rc,this.d=new e.$Rc,this.f=s.multipleSelectionSupport,this.c.add(this.g(u=>{switch(u.keyCode){case 3:return this.l(u);case 16:return this.o(u);case 18:return this.p(u);case 11:return this.q(u);case 12:return this.s(u);case 9:return this.u(u);case 31:this.f&&(d.$j?u.metaKey:u.ctrlKey)&&this.t(u)}}))}updateOptions(D){D.multipleSelectionSupport!==void 0&&(this.f=D.multipleSelectionSupport)}l(D){D.preventDefault(),D.stopPropagation(),this.h.setSelection(this.h.getFocus(),D.browserEvent)}o(D){D.preventDefault(),D.stopPropagation(),this.h.focusPrevious(1,!1,D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}p(D){D.preventDefault(),D.stopPropagation(),this.h.focusNext(1,!1,D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}q(D){D.preventDefault(),D.stopPropagation(),this.h.focusPreviousPage(D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}s(D){D.preventDefault(),D.stopPropagation(),this.h.focusNextPage(D.browserEvent);const i=this.h.getFocus()[0];this.h.setAnchor(i),this.h.reveal(i),this.k.domNode.focus()}t(D){D.preventDefault(),D.stopPropagation(),this.h.setSelection((0,$.$Sb)(this.h.length),D.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(D){this.h.getSelection().length&&(D.preventDefault(),D.stopPropagation(),this.h.setSelection([],D.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([O.$sh],z.prototype,"g",null);var X;(function(ce){ce[ce.Automatic=0]="Automatic",ce[ce.Trigger=1]="Trigger"})(X||(t.TypeNavigationMode=X={}));var G;(function(ce){ce[ce.Idle=0]="Idle",ce[ce.Typing=1]="Typing"})(G||(G={})),t.$yR=new class{mightProducePrintableCharacter(ce){return ce.ctrlKey||ce.metaKey||ce.altKey?!1:ce.keyCode>=31&&ce.keyCode<=56||ce.keyCode>=21&&ce.keyCode<=30||ce.keyCode>=98&&ce.keyCode<=107||ce.keyCode>=85&&ce.keyCode<=95}};class re{constructor(D,i,s,u,h){this.o=D,this.p=i,this.q=s,this.s=u,this.t=h,this.c=!1,this.d=G.Idle,this.f=X.Automatic,this.g=!1,this.h=-1,this.k=new e.$Rc,this.l=new e.$Rc,this.updateOptions(D.options)}updateOptions(D){D.typeNavigationEnabled??!0?this.u():this.v(),this.f=D.typeNavigationMode??X.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let D=!1;const i=r.Event.chain(this.k.add(new R.$aR(this.p.domNode,"keydown")).event,h=>h.filter(g=>!L(g.target)).filter(()=>this.f===X.Automatic||this.g).map(g=>new n.$0O(g)).filter(g=>D||this.s(g)).filter(g=>this.t.mightProducePrintableCharacter(g)).forEach(g=>S.$7P.stop(g,!0)).map(g=>g.browserEvent.key)),s=r.Event.debounce(i,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(i,s),(h,g)=>g===null?null:(h||"")+g,void 0,this.k)(this.x,this,this.k),s(this.w,this,this.k),i(()=>D=!0,void 0,this.k),s(()=>D=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const D=this.o.getFocus();if(D.length>0&&D[0]===this.h){const i=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(D[0]));i&&(0,k.$cR)(i)}this.h=-1}x(D){if(!D){this.d=G.Idle,this.g=!1;return}const i=this.o.getFocus(),s=i.length>0?i[0]:0,u=this.d===G.Idle?1:0;this.d=G.Typing;for(let h=0;h<this.o.length;h++){const g=(s+h+u)%this.o.length,b=this.q.getKeyboardNavigationLabel(this.p.element(g)),A=b&&b.toString();if(this.o.options.typeNavigationEnabled){if(typeof A<"u"){if((0,l.$Oj)(D,A)){this.h=s,this.o.setFocus([g]),this.o.reveal(g);return}const T=(0,l.$Vj)(D,A);if(T&&T[0].end-T[0].start>1&&T.length===1){this.h=s,this.o.setFocus([g]),this.o.reveal(g);return}}}else if(typeof A>"u"||(0,l.$Oj)(D,A)){this.h=s,this.o.setFocus([g]),this.o.reveal(g);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ie{constructor(D,i){this.d=D,this.f=i,this.c=new e.$Rc;const s=r.Event.chain(this.c.add(new R.$aR(i.domNode,"keydown")).event,h=>h.filter(g=>!L(g.target)).map(g=>new n.$0O(g)));r.Event.chain(s,h=>h.filter(g=>g.keyCode===2&&!g.ctrlKey&&!g.metaKey&&!g.shiftKey&&!g.altKey))(this.g,this,this.c)}g(D){if(D.target!==this.f.domNode)return;const i=this.d.getFocus();if(i.length===0)return;const s=this.f.domElement(i[0]);if(!s)return;const u=s.querySelector("[tabIndex]");if(!u||!(u instanceof HTMLElement)||u.tabIndex===-1)return;const h=(0,S.getWindow)(u).getComputedStyle(u);h.visibility==="hidden"||h.display==="none"||(D.preventDefault(),D.stopPropagation(),u.focus())}dispose(){this.c.dispose()}}function te(ce){return d.$j?ce.browserEvent.metaKey:ce.browserEvent.ctrlKey}t.$zR=te;function $e(ce){return ce.browserEvent.shiftKey}t.$AR=$e;function Fe(ce){return(0,S.$1P)(ce)&&ce.button===2}const ke={isSelectionSingleChangeEvent:te,isSelectionRangeChangeEvent:$e};class Le{constructor(D){this.k=D,this.f=new e.$Rc,this.g=new r.$Sd,this.onPointer=this.g.event,D.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ke),this.d=typeof D.options.mouseSupport>"u"||!!D.options.mouseSupport,this.d&&(D.onMouseDown(this.s,this,this.f),D.onContextMenu(this.t,this,this.f),D.onMouseDblClick(this.v,this,this.f),D.onTouchStart(this.s,this,this.f),this.f.add(j.$IQ.addTarget(D.getHTMLElement()))),r.Event.any(D.onMouseClick,D.onMouseMiddleClick,D.onTap)(this.u,this,this.f)}updateOptions(D){D.multipleSelectionSupport!==void 0&&(this.c=void 0,D.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ke))}o(D){return this.c?this.c.isSelectionSingleChangeEvent(D):!1}p(D){return this.c?this.c.isSelectionRangeChangeEvent(D):!1}q(D){return this.o(D)||this.p(D)}s(D){P(D.browserEvent.target)||(0,S.$MP)()!==D.browserEvent.target&&this.k.domFocus()}t(D){if(L(D.browserEvent.target)||P(D.browserEvent.target))return;const i=typeof D.index>"u"?[]:[D.index];this.k.setFocus(i,D.browserEvent)}u(D){if(!this.d||L(D.browserEvent.target)||P(D.browserEvent.target)||D.browserEvent.isHandledByList)return;D.browserEvent.isHandledByList=!0;const i=D.index;if(typeof i>"u"){this.k.setFocus([],D.browserEvent),this.k.setSelection([],D.browserEvent),this.k.setAnchor(void 0);return}if(this.q(D))return this.w(D);this.k.setFocus([i],D.browserEvent),this.k.setAnchor(i),Fe(D.browserEvent)||this.k.setSelection([i],D.browserEvent),this.g.fire(D)}v(D){if(L(D.browserEvent.target)||P(D.browserEvent.target)||this.q(D)||D.browserEvent.isHandledByList)return;D.browserEvent.isHandledByList=!0;const i=this.k.getFocus();this.k.setSelection(i,D.browserEvent)}w(D){const i=D.index;let s=this.k.getAnchor();if(this.p(D)){typeof s>"u"&&(s=this.k.getFocus()[0]??i,this.k.setAnchor(s));const u=Math.min(s,i),h=Math.max(s,i),g=(0,$.$Sb)(u,h+1),b=this.k.getSelection(),A=le(K(b,[s]),s);if(A.length===0)return;const T=K(g,H(b,A));this.k.setSelection(T,D.browserEvent),this.k.setFocus([i],D.browserEvent)}else if(this.o(D)){const u=this.k.getSelection(),h=u.filter(g=>g!==i);this.k.setFocus([i]),this.k.setAnchor(i),u.length===h.length?this.k.setSelection([...h,i],D.browserEvent):this.k.setSelection(h,D.browserEvent)}}dispose(){this.f.dispose()}}t.$BR=Le;class ae{constructor(D,i){this.c=D,this.d=i}style(D){const i=this.d&&`.${this.d}`,s=[];D.listBackground&&s.push(`.monaco-list${i} .monaco-list-rows { background: ${D.listBackground}; }`),D.listFocusBackground&&(s.push(`.monaco-list${i}:focus .monaco-list-row.focused { background-color: ${D.listFocusBackground}; }`),s.push(`.monaco-list${i}:focus .monaco-list-row.focused:hover { background-color: ${D.listFocusBackground}; }`)),D.listFocusForeground&&s.push(`.monaco-list${i}:focus .monaco-list-row.focused { color: ${D.listFocusForeground}; }`),D.listActiveSelectionBackground&&(s.push(`.monaco-list${i}:focus .monaco-list-row.selected { background-color: ${D.listActiveSelectionBackground}; }`),s.push(`.monaco-list${i}:focus .monaco-list-row.selected:hover { background-color: ${D.listActiveSelectionBackground}; }`)),D.listActiveSelectionForeground&&s.push(`.monaco-list${i}:focus .monaco-list-row.selected { color: ${D.listActiveSelectionForeground}; }`),D.listActiveSelectionIconForeground&&s.push(`.monaco-list${i}:focus .monaco-list-row.selected .codicon { color: ${D.listActiveSelectionIconForeground}; }`),D.listFocusAndSelectionBackground&&s.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.selected.focused { background-color: ${D.listFocusAndSelectionBackground}; }
			`),D.listFocusAndSelectionForeground&&s.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.selected.focused { color: ${D.listFocusAndSelectionForeground}; }
			`),D.listInactiveFocusForeground&&(s.push(`.monaco-list${i} .monaco-list-row.focused { color:  ${D.listInactiveFocusForeground}; }`),s.push(`.monaco-list${i} .monaco-list-row.focused:hover { color:  ${D.listInactiveFocusForeground}; }`)),D.listInactiveSelectionIconForeground&&s.push(`.monaco-list${i} .monaco-list-row.focused .codicon { color:  ${D.listInactiveSelectionIconForeground}; }`),D.listInactiveFocusBackground&&(s.push(`.monaco-list${i} .monaco-list-row.focused { background-color:  ${D.listInactiveFocusBackground}; }`),s.push(`.monaco-list${i} .monaco-list-row.focused:hover { background-color:  ${D.listInactiveFocusBackground}; }`)),D.listInactiveSelectionBackground&&(s.push(`.monaco-list${i} .monaco-list-row.selected { background-color:  ${D.listInactiveSelectionBackground}; }`),s.push(`.monaco-list${i} .monaco-list-row.selected:hover { background-color:  ${D.listInactiveSelectionBackground}; }`)),D.listInactiveSelectionForeground&&s.push(`.monaco-list${i} .monaco-list-row.selected { color: ${D.listInactiveSelectionForeground}; }`),D.listHoverBackground&&s.push(`.monaco-list${i}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${D.listHoverBackground}; }`),D.listHoverForeground&&s.push(`.monaco-list${i}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${D.listHoverForeground}; }`);const u=(0,S.$rQ)(D.listFocusAndSelectionOutline,(0,S.$rQ)(D.listSelectionOutline,D.listFocusOutline??""));u&&s.push(`.monaco-list${i}:focus .monaco-list-row.focused.selected { outline: 1px solid ${u}; outline-offset: -1px;}`),D.listFocusOutline&&s.push(`
				.monaco-drag-image,
				.monaco-list${i}:focus .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${i}.last-focused .monaco-list-row.focused { outline: 1px solid ${D.listFocusOutline}; outline-offset: -1px; }
			`);const h=(0,S.$rQ)(D.listSelectionOutline,D.listInactiveFocusOutline??"");h&&s.push(`.monaco-list${i} .monaco-list-row.focused.selected { outline: 1px dotted ${h}; outline-offset: -1px; }`),D.listSelectionOutline&&s.push(`.monaco-list${i} .monaco-list-row.selected { outline: 1px dotted ${D.listSelectionOutline}; outline-offset: -1px; }`),D.listInactiveFocusOutline&&s.push(`.monaco-list${i} .monaco-list-row.focused { outline: 1px dotted ${D.listInactiveFocusOutline}; outline-offset: -1px; }`),D.listHoverOutline&&s.push(`.monaco-list${i} .monaco-list-row:hover { outline: 1px dashed ${D.listHoverOutline}; outline-offset: -1px; }`),D.listDropBackground&&s.push(`
				.monaco-list${i}.drop-target,
				.monaco-list${i} .monaco-list-rows.drop-target,
				.monaco-list${i} .monaco-list-row.drop-target { background-color: ${D.listDropBackground} !important; color: inherit !important; }
			`),D.tableColumnsBorder&&s.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${D.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),D.tableOddRowsBackgroundColor&&s.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${D.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=s.join(`
`)}}t.$CR=ae,t.$DR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:y.$9s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:y.$9s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:y.$9s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const J={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function le(ce,D){const i=ce.indexOf(D);if(i===-1)return[];const s=[];let u=i-1;for(;u>=0&&ce[u]===D-(i-u);)s.push(ce[u--]);for(s.reverse(),u=i;u<ce.length&&ce[u]===D+(u-i);)s.push(ce[u++]);return s}function K(ce,D){const i=[];let s=0,u=0;for(;s<ce.length||u<D.length;)if(s>=ce.length)i.push(D[u++]);else if(u>=D.length)i.push(ce[s++]);else if(ce[s]===D[u]){i.push(ce[s]),s++,u++;continue}else ce[s]<D[u]?i.push(ce[s++]):i.push(D[u++]);return i}function H(ce,D){const i=[];let s=0,u=0;for(;s<ce.length||u<D.length;)if(s>=ce.length)i.push(D[u++]);else if(u>=D.length)i.push(ce[s++]);else if(ce[s]===D[u]){s++,u++;continue}else ce[s]<D[u]?i.push(ce[s++]):u++;return i}const Y=(ce,D)=>ce-D;class be{constructor(D,i){this.c=D,this.d=i}get templateId(){return this.c}renderTemplate(D){return this.d.map(i=>i.renderTemplate(D))}renderElement(D,i,s,u){let h=0;for(const g of this.d)g.renderElement(D,i,s[h++],u)}disposeElement(D,i,s,u){let h=0;for(const g of this.d)g.disposeElement?.(D,i,s[h],u),h+=1}disposeTemplate(D){let i=0;for(const s of this.d)s.disposeTemplate(D[i++])}}class we{constructor(D){this.c=D,this.templateId="a18n"}renderTemplate(D){return D}renderElement(D,i,s){const u=this.c.getAriaLabel(D);u?s.setAttribute("aria-label",u):s.removeAttribute("aria-label");const h=this.c.getAriaLevel&&this.c.getAriaLevel(D);typeof h=="number"?s.setAttribute("aria-level",`${h}`):s.removeAttribute("aria-level")}disposeTemplate(D){}}class Ce{constructor(D,i){this.c=D,this.d=i}getDragElements(D){const i=this.c.getSelectedElements();return i.indexOf(D)>-1?i:[D]}getDragURI(D){return this.d.getDragURI(D)}getDragLabel(D,i){if(this.d.getDragLabel)return this.d.getDragLabel(D,i)}onDragStart(D,i){this.d.onDragStart?.(D,i)}onDragOver(D,i,s,u){return this.d.onDragOver(D,i,s,u)}onDragLeave(D,i,s,u){this.d.onDragLeave?.(D,i,s,u)}onDragEnd(D){this.d.onDragEnd?.(D)}drop(D,i,s,u){this.d.drop(D,i,s,u)}dispose(){this.d.dispose()}}class Ae{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),D=>this.G(D),this.y)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),D=>this.G(D),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let D=!1;const i=r.Event.chain(this.y.add(new R.$aR(this.k.domNode,"keydown")).event,h=>h.map(g=>new n.$0O(g)).filter(g=>D=g.keyCode===58||g.shiftKey&&g.keyCode===68).map(g=>S.$7P.stop(g,!0)).filter(()=>!1)),s=r.Event.chain(this.y.add(new R.$aR(this.k.domNode,"keyup")).event,h=>h.forEach(()=>D=!1).map(g=>new n.$0O(g)).filter(g=>g.keyCode===58||g.shiftKey&&g.keyCode===68).map(g=>S.$7P.stop(g,!0)).map(({browserEvent:g})=>{const b=this.getFocus(),A=b.length?b[0]:void 0,T=typeof A<"u"?this.k.element(A):void 0,_=typeof A<"u"?this.k.domElement(A):this.k.domNode;return{index:A,element:T,anchor:_,browserEvent:g}})),u=r.Event.chain(this.k.onContextMenu,h=>h.filter(g=>!D).map(({element:g,index:b,browserEvent:A})=>({element:g,index:b,anchor:new E.$5O((0,S.getWindow)(this.k.domNode),A),browserEvent:A})));return r.Event.any(i,s,u)}get onKeyDown(){return this.y.add(new R.$aR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new R.$aR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new R.$aR(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.y.add(new R.$aR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.y.add(new R.$aR(this.k.domNode,"blur",!0)).event)}constructor(D,i,s,u,h=J){this.A=D,this.B=h,this.c=new f("focused"),this.f=new f("anchor"),this.g=new r.$1d,this.x="",this.y=new e.$Rc,this.z=new r.$Sd,this.onDidDispose=this.z.event;const g=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(g!=="listbox");const b=[this.c.renderer,this.d.renderer];this.u=h.accessibilityProvider,this.u&&(b.push(new we(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),u=u.map(T=>new be(T.templateId,[...b,T]));const A={...h,dnd:h.dnd&&new Ce(this,h.dnd)};if(this.k=this.C(i,s,u,A),this.k.domNode.setAttribute("role",g),h.styleController)this.q=h.styleController(this.k.domId);else{const T=(0,S.$UP)(this.k.domNode);this.q=new ae(T,this.k.domId)}if(this.o=new C.$eR([new B(this.c,this.k,h.identityProvider),new B(this.d,this.k,h.identityProvider),new B(this.f,this.k,h.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ie(this,this.k)),(typeof h.keyboardSupport!="boolean"||h.keyboardSupport)&&(this.v=new z(this,this.k,h),this.y.add(this.v)),h.keyboardNavigationLabelProvider){const T=h.keyboardNavigationDelegate||t.$yR;this.t=new re(this,this.k,h.keyboardNavigationLabelProvider,h.keyboardNavigationEventFilter??(()=>!0),T),this.y.add(this.t)}this.w=this.D(h),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(D,i,s,u){return new a.$qR(D,i,s,u)}D(D){return new Le(this)}updateOptions(D={}){this.B={...this.B,...D},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(D),this.v?.updateOptions(D),this.k.updateOptions(D)}get options(){return this.B}splice(D,i,s=[]){if(D<0||D>this.k.length)throw new o.$gR(this.A,`Invalid start index: ${D}`);if(i<0)throw new o.$gR(this.A,`Invalid delete count: ${i}`);i===0&&s.length===0||this.g.bufferEvents(()=>this.o.splice(D,i,s))}updateWidth(D){this.k.updateWidth(D)}updateElementHeight(D,i){this.k.updateElementHeight(D,i,null)}rerender(){this.k.rerender()}element(D){return this.k.element(D)}indexOf(D){return this.k.indexOf(D)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(D){this.k.setScrollTop(D)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(D){this.k.setScrollLeft(D)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(D){this.x=D,this.k.domNode.setAttribute("aria-label",D)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(D,i){this.k.layout(D,i)}triggerTypeNavigation(){this.t?.trigger()}setSelection(D,i){for(const s of D)if(s<0||s>=this.length)throw new o.$gR(this.A,`Invalid index ${s}`);this.d.set(D,i)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(D=>this.k.element(D))}setAnchor(D){if(typeof D>"u"){this.f.set([]);return}if(D<0||D>=this.length)throw new o.$gR(this.A,`Invalid index ${D}`);this.f.set([D])}getAnchor(){return(0,$.$Ob)(this.f.get(),void 0)}getAnchorElement(){const D=this.getAnchor();return typeof D>"u"?void 0:this.element(D)}setFocus(D,i){for(const s of D)if(s<0||s>=this.length)throw new o.$gR(this.A,`Invalid index ${s}`);this.c.set(D,i)}focusNext(D=1,i=!1,s,u){if(this.length===0)return;const h=this.c.get(),g=this.E(h.length>0?h[0]+D:0,i,u);g>-1&&this.setFocus([g],s)}focusPrevious(D=1,i=!1,s,u){if(this.length===0)return;const h=this.c.get(),g=this.F(h.length>0?h[0]-D:0,i,u);g>-1&&this.setFocus([g],s)}async focusNextPage(D,i){let s=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);s=s===0?0:s-1;const u=this.getFocus()[0];if(u!==s&&(u===void 0||s>u)){const h=this.F(s,!1,i);h>-1&&u!==h?this.setFocus([h],D):this.setFocus([s],D)}else{const h=this.k.getScrollTop();let g=h+this.k.renderHeight;s>u&&(g-=this.k.elementHeight(s)),this.k.setScrollTop(g),this.k.getScrollTop()!==h&&(this.setFocus([]),await(0,v.$2g)(0),await this.focusNextPage(D,i))}}async focusPreviousPage(D,i){let s;const u=this.k.getScrollTop();u===0?s=this.k.indexAt(u):s=this.k.indexAfter(u-1);const h=this.getFocus()[0];if(h!==s&&(h===void 0||h>=s)){const g=this.E(s,!1,i);g>-1&&h!==g?this.setFocus([g],D):this.setFocus([s],D)}else{const g=u;this.k.setScrollTop(u-this.k.renderHeight),this.k.getScrollTop()!==g&&(this.setFocus([]),await(0,v.$2g)(0),await this.focusPreviousPage(D,i))}}focusLast(D,i){if(this.length===0)return;const s=this.F(this.length-1,!1,i);s>-1&&this.setFocus([s],D)}focusFirst(D,i){this.focusNth(0,D,i)}focusNth(D,i,s){if(this.length===0)return;const u=this.E(D,!1,s);u>-1&&this.setFocus([u],i)}E(D,i=!1,s){for(let u=0;u<this.length;u++){if(D>=this.length&&!i)return-1;if(D=D%this.length,!s||s(this.element(D)))return D;D++}return-1}F(D,i=!1,s){for(let u=0;u<this.length;u++){if(D<0&&!i)return-1;if(D=(this.length+D%this.length)%this.length,!s||s(this.element(D)))return D;D--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(D=>this.k.element(D))}reveal(D,i,s=0){if(D<0||D>=this.length)throw new o.$gR(this.A,`Invalid index ${D}`);const u=this.k.getScrollTop(),h=this.k.elementTop(D),g=this.k.elementHeight(D);if((0,p.$Hf)(i)){const b=g-this.k.renderHeight+s;this.k.setScrollTop(b*(0,c.$Zl)(i,0,1)+h-s)}else{const b=h+g,A=u+this.k.renderHeight;h<u+s&&b>=A||(h<u+s||b>=A&&g>=this.k.renderHeight?this.k.setScrollTop(h-s):b>=A&&this.k.setScrollTop(b-this.k.renderHeight))}}getRelativeTop(D,i=0){if(D<0||D>=this.length)throw new o.$gR(this.A,`Invalid index ${D}`);const s=this.k.getScrollTop(),u=this.k.elementTop(D),h=this.k.elementHeight(D);if(u<s+i||u+h>s+this.k.renderHeight)return null;const g=h-this.k.renderHeight+i;return Math.abs((s+i-u)/g)}isDOMFocused(){return(0,S.$NP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(D){return this.k.getElementDomId(D)}getElementTop(D){return this.k.elementTop(D)}style(D){this.q.style(D)}G({indexes:D,browserEvent:i}){return{indexes:D,elements:D.map(s=>this.k.element(s)),browserEvent:i}}H(){const D=this.c.get();this.k.domNode.classList.toggle("element-focused",D.length>0),this.I()}I(){const D=this.c.get();if(D.length>0){let i;this.u?.getActiveDescendantId&&(i=this.u.getActiveDescendantId(this.k.element(D[0]))),this.k.domNode.setAttribute("aria-activedescendant",i||this.k.getElementDomId(D[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const D=this.d.get();this.k.domNode.classList.toggle("selection-none",D.length===0),this.k.domNode.classList.toggle("selection-single",D.length===1),this.k.domNode.classList.toggle("selection-multiple",D.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$ER=Ae,Xe([O.$sh],Ae.prototype,"onDidChangeFocus",null),Xe([O.$sh],Ae.prototype,"onDidChangeSelection",null),Xe([O.$sh],Ae.prototype,"onContextMenu",null),Xe([O.$sh],Ae.prototype,"onKeyDown",null),Xe([O.$sh],Ae.prototype,"onKeyUp",null),Xe([O.$sh],Ae.prototype,"onKeyPress",null),Xe([O.$sh],Ae.prototype,"onDidFocus",null),Xe([O.$sh],Ae.prototype,"onDidBlur",null)}),define(ge[62],me([1,0,6,35,37,10,15]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.MarkdownStringTextNewlineStyle=void 0;var C;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(C||(t.MarkdownStringTextNewlineStyle=C={}));class ${constructor(p="",o=!1){if(this.value=p,typeof this.value!="string")throw(0,S.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(p,o=0){return this.value+=r(this.supportThemeIcons?(0,R.$8j)(p):p).replace(/([ \t]+)/g,(a,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,o){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}appendLink(p,o,a){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(p),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(p,o){const a=new RegExp((0,j.$Ke)(o),"g");return p.replace(a,(E,m)=>p.charAt(m-1)!=="\\"?`\\${E}`:E)}}t.$bk=$;function v(d){return y(d)?!d.value:Array.isArray(d)?d.every(v):!0}t.$ck=v;function y(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}t.$dk=y;function O(d,p){return d===p?!0:!d||!p?!1:d.value===p.value&&d.isTrusted===p.isTrusted&&d.supportThemeIcons===p.supportThemeIcons&&d.supportHtml===p.supportHtml&&(d.baseUri===p.baseUri||!!d.baseUri&&!!p.baseUri&&(0,n.$vg)(k.URI.from(d.baseUri),k.URI.from(p.baseUri)))}t.$ek=O;function r(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$fk=r;function l(d){return d.replace(/"/g,"&quot;")}t.$gk=l;function e(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$hk=e;function c(d){const p=[],o=d.split("|").map(E=>E.trim());d=o[0];const a=o[1];if(a){const E=/height=(\d+)/.exec(a),m=/width=(\d+)/.exec(a),f=E?E[1]:"",N=m?m[1]:"",B=isFinite(parseInt(N)),L=isFinite(parseInt(f));B&&p.push(`width="${N}"`),L&&p.push(`height="${f}"`)}return{href:d,dimensions:p}}t.$ik=c}),define(ge[125],me([1,0,3,117,22,55,14,19,118,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l,e,c,d,p,o,a,E,m,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LR=t.$KR=t.$JR=t.$IR=t.$HR=void 0;const N=Object.freeze({image:(K,H,Y)=>{let be=[],we=[];return K&&({href:K,dimensions:be}=(0,O.$ik)(K),we.push(`src="${(0,O.$gk)(K)}"`)),Y&&we.push(`alt="${(0,O.$gk)(Y)}"`),H&&we.push(`title="${(0,O.$gk)(H)}"`),be.length&&(we=we.concat(be)),"<img "+we.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,H,Y)=>typeof K!="string"?"":(K===Y&&(Y=(0,O.$hk)(Y)),H=typeof H=="string"?(0,O.$gk)((0,O.$hk)(H)):"",K=(0,O.$hk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${H||K}" draggable="false">${Y}</a>`)});function B(K,H={},Y={}){const be=new c.$Rc;let we=!1;const Ce=(0,j.$_Q)(H),Ae=function(A){let T;try{T=(0,p.$wh)(decodeURIComponent(A))}catch{}return T?(T=(0,a.$hn)(T,_=>{if(K.uris&&K.uris[_])return f.URI.revive(K.uris[_])}),encodeURIComponent(JSON.stringify(T))):A},ce=function(A,T){const _=K.uris&&K.uris[A];let x=f.URI.revive(_);return T?A.startsWith(o.Schemas.data+":")?A:(x||(x=f.URI.parse(A)),o.$jg.uriToBrowserUri(x).toString(!0)):!x||f.URI.parse(A).toString()===x.toString()?A:(x.query&&(x=x.with({query:Ae(x.query)})),x.toString())},D=new d.marked.Renderer;D.image=N.image,D.link=N.link,D.paragraph=N.paragraph;const i=[],s=[];if(H.codeBlockRendererSync?D.code=(A,T)=>{const _=l.$PM.nextId(),x=H.codeBlockRendererSync(L(T),A);return s.push([_,x]),`<div class="code" data-code="${_}">${(0,m.$Je)(A)}</div>`}:H.codeBlockRenderer&&(D.code=(A,T)=>{const _=l.$PM.nextId(),x=H.codeBlockRenderer(L(T),A);return i.push(x.then(ee=>[_,ee])),`<div class="code" data-code="${_}">${(0,m.$Je)(A)}</div>`}),H.actionHandler){const A=function(x){let ee=x.target;if(!(ee.tagName!=="A"&&(ee=ee.parentElement,!ee||ee.tagName!=="A")))try{let fe=ee.dataset.href;fe&&(K.baseUri&&(fe=w(f.URI.from(K.baseUri),fe)),H.actionHandler.callback(fe,x))}catch(fe){(0,v.$1)(fe)}finally{x.preventDefault()}},T=H.actionHandler.disposables.add(new n.$aR(Ce,"click")),_=H.actionHandler.disposables.add(new n.$aR(Ce,"auxclick"));H.actionHandler.disposables.add(y.Event.any(T.event,_.event)(x=>{const ee=new C.$5O(S.getWindow(Ce),x);!ee.leftButton&&!ee.middleButton||A(ee)})),H.actionHandler.disposables.add(S.$aP(Ce,"keydown",x=>{const ee=new k.$0O(x);!ee.equals(10)&&!ee.equals(3)||A(ee)}))}K.supportHtml||(Y.sanitizer=A=>(K.isTrusted?A.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?A:"",Y.sanitize=!0,Y.silent=!0),Y.renderer=D;let u=K.value??"";u.length>1e5&&(u=`${u.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(u=(0,r.$9j)(u));let h;if(H.fillInIncompleteTokens){const A={...d.marked.defaults,...Y},T=d.marked.lexer(u,A),_=G(T);h=d.marked.parser(_,A)}else h=d.marked.parse(u,Y);K.supportThemeIcons&&(h=(0,$.$FR)(h).map(T=>typeof T=="string"?T:T.outerHTML).join(""));const b=new DOMParser().parseFromString(P(K,h),"text/html");if(b.body.querySelectorAll("img").forEach(A=>{const T=A.getAttribute("src");if(T){let _=T;try{K.baseUri&&(_=w(f.URI.from(K.baseUri),_))}catch{}A.src=ce(_,!0)}}),b.body.querySelectorAll("a").forEach(A=>{const T=A.getAttribute("href");if(A.setAttribute("href",""),!T||/^data:|javascript:/i.test(T)||/^command:/i.test(T)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(T))A.replaceWith(...A.childNodes);else{let _=ce(T,!1);K.baseUri&&(_=w(f.URI.from(K.baseUri),T)),A.dataset.href=_}}),Ce.innerHTML=P(K,b.body.innerHTML),i.length>0)Promise.all(i).then(A=>{if(we)return;const T=new Map(A),_=Ce.querySelectorAll("div[data-code]");for(const x of _){const ee=T.get(x.dataset.code??"");ee&&S.$bQ(x,ee)}H.asyncRenderCallback?.()});else if(s.length>0){const A=new Map(s),T=Ce.querySelectorAll("div[data-code]");for(const _ of T){const x=A.get(_.dataset.code??"");x&&S.$bQ(_,x)}}if(H.asyncRenderCallback)for(const A of Ce.getElementsByTagName("img")){const T=be.add(S.$aP(A,"load",()=>{T.dispose(),H.asyncRenderCallback()}))}return{element:Ce,dispose:()=>{we=!0,be.dispose()}}}t.$HR=B;function L(K){if(!K)return"";const H=K.split(/[\s+|:|,|\{|\?]/,1);return H.length?H[0]:K}function w(K,H){return/^\w[\w\d+.-]*:/.test(H)?H:K.path.endsWith("/")?(0,E.$Fg)(K,H).toString():(0,E.$Fg)((0,E.$Bg)(K),H).toString()}function P(K,H){const{config:Y,allowedSchemes:be}=M(K);R.addHook("uponSanitizeAttribute",(Ce,Ae)=>{if(Ae.attrName==="style"||Ae.attrName==="class"){if(Ce.tagName==="SPAN"){if(Ae.attrName==="style"){Ae.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ae.attrValue);return}else if(Ae.attrName==="class"){Ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ae.attrValue);return}}Ae.keepAttr=!1;return}});const we=S.$vQ(be);try{return R.sanitize(H,{...Y,RETURN_TRUSTED_TYPE:!0})}finally{R.removeHook("uponSanitizeAttribute"),we.dispose()}}t.$IR=["align","autoplay","alt","class","controls","data-code","data-href","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function M(K){const H=[o.Schemas.http,o.Schemas.https,o.Schemas.mailto,o.Schemas.data,o.Schemas.file,o.Schemas.vscodeFileResource,o.Schemas.vscodeRemote,o.Schemas.vscodeRemoteResource];return K.isTrusted&&H.push(o.Schemas.command),{config:{ALLOWED_TAGS:[...S.$wQ],ALLOWED_ATTR:t.$IR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:H}}function U(K){return typeof K=="string"?K:V(K)}t.$JR=U;function V(K){let H=K.value??"";H.length>1e5&&(H=`${H.substr(0,1e5)}\u2026`);const Y=d.marked.parse(H,{renderer:I.value}).replace(/&(#\d+|[a-zA-Z]+);/g,be=>F.get(be)??be);return P({isTrusted:!1},Y).toString()}t.$KR=V;const F=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),I=new e.$V(()=>{const K=new d.marked.Renderer;return K.code=H=>H,K.blockquote=H=>H,K.html=H=>"",K.heading=(H,Y,be)=>H+`
`,K.hr=()=>"",K.list=(H,Y)=>H,K.listitem=H=>H+`
`,K.paragraph=H=>H+`
`,K.table=(H,Y)=>H+Y+`
`,K.tablerow=H=>H,K.tablecell=(H,Y)=>H+" ",K.strong=H=>H,K.em=H=>H,K.codespan=H=>H,K.br=()=>`
`,K.del=H=>H,K.image=(H,Y,be)=>"",K.text=H=>H,K.link=(H,Y,be)=>be,K});function z(K){let H="";return K.forEach(Y=>{H+=Y.raw}),H}function X(K){for(const H of K.tokens)if(H.type==="text"){const Y=H.raw.split(`
`),be=Y[Y.length-1];if(be.includes("`"))return ie(K);if(be.includes("**"))return Le(K);if(be.match(/\*\w/))return te(K);if(be.match(/(^|\s)__\w/))return ae(K);if(be.match(/(^|\s)_\w/))return $e(K);if(be.match(/(^|\s)\[.*\]\(\w*/))return Fe(K);if(be.match(/(^|\s)\[\w/))return ke(K)}}function G(K){let H,Y;for(H=0;H<K.length;H++){const be=K[H];if(be.type==="paragraph"&&be.raw.match(/(\n|^)```/)){Y=re(K.slice(H));break}if(be.type==="paragraph"&&be.raw.match(/(\n|^)\|/)){Y=le(K.slice(H));break}if(H===K.length-1&&be.type==="paragraph"){const we=X(be);if(we){Y=[we];break}}}if(Y){const be=[...K.slice(0,H),...Y];return be.links=K.links,be}return K}t.$LR=G;function re(K){const H=z(K);return d.marked.lexer(H+"\n```")}function ie(K){return J(K,"`")}function te(K){return J(K,"*")}function $e(K){return J(K,"_")}function Fe(K){return J(K,")")}function ke(K){return J(K,"](about:blank)")}function Le(K){return J(K,"**")}function ae(K){return J(K,"__")}function J(K,H){const Y=z(Array.isArray(K)?K:[K]);return d.marked.lexer(Y+H)[0]}function le(K){const H=z(K),Y=H.split(`
`);let be,we=!1;for(let Ce=0;Ce<Y.length;Ce++){const Ae=Y[Ce].trim();if(typeof be>"u"&&Ae.match(/^\s*\|/)){const ce=Ae.match(/(\|[^\|]+)(?=\||$)/g);ce&&(be=ce.length)}else if(typeof be=="number")if(Ae.match(/^\s*\|/)){if(Ce!==Y.length-1)return;we=!0}else return}if(typeof be=="number"&&be>0){const Ce=we?Y.slice(0,-1).join(`
`):H,Ae=!!Ce.match(/\|\s*$/),ce=Ce+(Ae?"":"|")+`
|${" --- |".repeat(be)}`;return d.marked.lexer(ce)}}}),define(ge[126],me([1,0,3,9,29,62,35,2,7,107]),function(ne,t,S,R,n,j,k,C,$,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=t.$3Q=void 0;function y(l,e){(0,$.$Df)(e)?l.title=(0,k.$0j)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.$3Q=y;class O{constructor(e,c,d){this.c=e,this.d=c,this.f=d}async update(e,c,d){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let p;if(e===void 0||(0,$.$Df)(e)||e instanceof HTMLElement)p=e;else if(!(0,$.$Rf)(e.markdown))p=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,v.localize)(0,null),c),this.b=new n.$3d;const o=this.b.token;if(p=await e.markdown(o),p===void 0&&(p=e.markdownNotSupportedFallback),this.isDisposed||o.isCancellationRequested)return}this.g(p,c,d)}g(e,c,d){const p=this.a;if(this.h(e)){const o={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!p,...d};this.a=this.c.showHover(o,c)}p?.dispose()}h(e){return e?(0,j.$dk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(l,e,c,d){let p,o;const a=(B,L)=>{const w=o!==void 0;B&&(o?.dispose(),o=void 0),L&&(p?.dispose(),p=void 0),w&&l.onDidHideHover?.()},E=(B,L,w)=>new R.$$g(async()=>{(!o||o.isDisposed)&&(o=new O(l,w||e,B>0),await o.update(c,L,d))},B),m=()=>{if(p)return;const B=new C.$Rc,L=M=>a(!1,M.fromElement===e);B.add(S.$aP(e,S.$5P.MOUSE_LEAVE,L,!0));const w=()=>a(!0,!0);B.add(S.$aP(e,S.$5P.MOUSE_DOWN,w,!0));const P={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const M=U=>{P.x=U.x+10,U.target instanceof HTMLElement&&U.target.classList.contains("action-label")&&a(!0,!0)};B.add(S.$aP(e,S.$5P.MOUSE_MOVE,M,!0))}B.add(E(l.delay,!1,P)),p=B},f=S.$aP(e,S.$5P.MOUSE_OVER,m,!0);return{show:B=>{a(!1,!0),E(0,B)},hide:()=>{a(!0,!0)},update:async(B,L)=>{c=B,await o?.update(c,void 0,L)},dispose:()=>{f.dispose(),a(!0,!0)}}}t.$4Q=r}),define(ge[127],me([1,0,3,22,14,125,39,12,4,44,2,5,109,100]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MR=void 0;const l=S.$,e="selectOption.entry.template";class c{get templateId(){return e}renderTemplate(o){const a=Object.create(null);return a.root=o,a.text=S.$_P(o,l(".option-text")),a.detail=S.$_P(o,l(".option-detail")),a.decoratorRight=S.$_P(o,l(".option-decorator-right")),a}renderElement(o,a,E){const m=E,f=o.text,N=o.detail,B=o.decoratorRight,L=o.isDisabled;m.text.textContent=f,m.detail.textContent=N||"",m.decoratorRight.innerText=B||"",L?m.root.classList.add("option-disabled"):m.root.classList.remove("option-disabled")}disposeTemplate(o){}}class d extends y.$Sc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,a,E,m,f){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=m,this.g=f||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=d.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new $.$Sd,this.B(this.r),this.O(),this.N(E),this.n=a||0,o&&this.setOptions(o,a),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(o){this.u=o,this.w=S.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=S.$_P(this.w,l(".select-box-details-pane"));const a=S.$_P(this.w,l(".select-box-dropdown-container-width-control")),E=S.$_P(a,l(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",S.$_P(E,this.D),this.G=0,this.y=S.$UP(this.w),this.w.setAttribute("draggable","true"),this.B(S.$aP(this.w,S.$5P.DRAG_START,m=>{S.$7P.stop(m,!0)}))}O(){this.B(S.$bP(this.h,"change",a=>{this.n=a.target.selectedIndex,this.r.fire({index:a.target.selectedIndex,selected:a.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(S.$aP(this.h,S.$5P.CLICK,a=>{S.$7P.stop(a),this.f?this.X(!0):this.W()})),this.B(S.$aP(this.h,S.$5P.MOUSE_DOWN,a=>{S.$7P.stop(a)}));let o;this.B(S.$aP(this.h,"touchstart",a=>{o=this.f})),this.B(S.$aP(this.h,"touchend",a=>{S.$7P.stop(a),o?this.X(!0):this.W()})),this.B(S.$aP(this.h,S.$5P.KEY_DOWN,a=>{const E=new n.$0O(a);let m=!1;O.$j?(E.keyCode===18||E.keyCode===16||E.keyCode===10||E.keyCode===3)&&(m=!0):(E.keyCode===18&&E.altKey||E.keyCode===16&&E.altKey||E.keyCode===10||E.keyCode===3)&&(m=!0),m&&(this.W(),S.$7P.stop(a,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,a){C.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((E,m)=>{this.h.add(this.U(E.text,m,E.isDisabled)),typeof E.description=="string"&&(this.H=!0)})),a!==void 0&&(this.select(a),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.R()}Q(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}R(){const o=this.s.selectBackground??"",a=this.s.selectForeground??"",E=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=a,this.h.style.borderColor=E}S(){const o=this.s.selectBackground??"",a=S.$rQ(this.s.selectListBackground,o);this.C.style.backgroundColor=a,this.I.style.backgroundColor=a;const E=this.s.focusBorder??"";this.w.style.outlineColor=E,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(o,a,E){const m=document.createElement("option");return m.value=o,m.text=o,m.disabled=!!E,m}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.Y(o,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.Y(o),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}Y(o,a){return o.appendChild(this.w),this.ab(a),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}Z(){let o=0;return this.m.forEach((a,E)=>{this.hb(E),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}ab(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const a=S.getWindow(this.h),E=S.$wP(this.h),m=S.getWindow(this.h).getComputedStyle(this.h),f=parseFloat(m.getPropertyValue("--dropdown-padding-top"))+parseFloat(m.getPropertyValue("--dropdown-padding-bottom")),N=a.innerHeight-E.top-E.height-(this.g.minBottomMargin||0),B=E.top-d.b,L=this.h.offsetWidth,w=this.bb(this.D),P=Math.max(w,Math.round(L)).toString()+"px";this.w.style.width=P,this.z.getHTMLElement().style.height="",this.z.layout();let M=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const U=this.H?this.L:0,V=M+f+U,F=Math.floor((N-f-U)/this.getHeight()),I=Math.floor((B-f-U)/this.getHeight());if(o)return E.top+E.height>a.innerHeight-22||E.top<d.b||F<1&&I<1?!1:(F<d.c&&I>F&&this.m.length>F?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(E.top+E.height>a.innerHeight-22||E.top<d.b||this.G===0&&F<1||this.G===1&&I<1)return this.X(!0),!1;if(this.G===0){if(this.f&&F+I<1)return this.X(!0),!1;V>N&&(M=F*this.getHeight())}else V>B&&(M=I*this.getHeight());return this.z.layout(M),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=M+f+"px",this.w.style.height=""):this.w.style.height=M+f+"px",this.hb(this.n),this.w.style.width=P,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(o){let a=0;if(o){let E=0,m=0;this.m.forEach((f,N)=>{const B=f.detail?f.detail.length:0,L=f.decoratorRight?f.decoratorRight.length:0,w=f.text.length+B+L;w>m&&(E=N,m=w)}),o.textContent=this.m[E].text+(this.m[E].decoratorRight?this.m[E].decoratorRight+" ":""),a=S.$yP(o)}return a}cb(o){if(this.z)return;this.C=S.$_P(o,l(".select-box-dropdown-list-container")),this.t=new c,this.z=new k.$ER("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:m=>{let f=m.text;return m.detail&&(f+=`. ${m.detail}`),m.decoratorRight&&(f+=`. ${m.decoratorRight}`),m.description&&(f+=`. ${m.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>O.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const a=this.B(new R.$aR(this.C,"keydown")),E=$.Event.chain(a.event,m=>m.filter(()=>this.z.length>0).map(f=>new n.$0O(f)));this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===3))(this.jb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===2))(this.jb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===9))(this.ib,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===16))(this.lb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===18))(this.kb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===12))(this.nb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===11))(this.mb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===14))(this.ob,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode===13))(this.pb,this)),this.B($.Event.chain(E,m=>m.filter(f=>f.keyCode>=21&&f.keyCode<=56||f.keyCode>=85&&f.keyCode<=113))(this.qb,this)),this.B(S.$aP(this.z.getHTMLElement(),S.$5P.POINTER_UP,m=>this.db(m))),this.B(this.z.onMouseOver(m=>typeof m.index<"u"&&this.z.setFocus([m.index]))),this.B(this.z.onDidChangeFocus(m=>this.gb(m))),this.B(S.$aP(this.w,S.$5P.FOCUS_OUT,m=>{!this.f||S.$EP(m.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(o){if(!this.z.length)return;S.$7P.stop(o);const a=o.target;if(!a||a.classList.contains("slider"))return;const E=a.closest(".monaco-list-row");if(!E)return;const m=Number(E.getAttribute("data-index")),f=E.classList.contains("option-disabled");m>=0&&m<this.m.length&&!f&&(this.n=m,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(o,a){const E=f=>{for(let N=0;N<f.childNodes.length;N++){const B=f.childNodes.item(N);(B.tagName&&B.tagName.toLowerCase())==="img"?f.removeChild(B):E(B)}},m=(0,j.$HR)({value:o,supportThemeIcons:!0},{actionHandler:a});return m.element.classList.add("select-box-description-markdown"),E(m.element),m.element}gb(o){!this.f||!this.H||this.hb(o.indexes[0])}hb(o){this.I.innerText="";const a=this.m[o],E=a?.description??"",m=a?.descriptionIsMarkdown??!1;if(E){if(m){const f=a.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(E,f))}else this.I.innerText=E;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(o){S.$7P.stop(o),this.select(this.F),this.X(!0)}jb(o){S.$7P.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(o){if(this.n<this.m.length-1){S.$7P.stop(o,!0);const a=this.m[this.n+1].isDisabled;if(a&&this.m.length>this.n+2)this.n+=2;else{if(a)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(o){this.n>0&&(S.$7P.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(o){S.$7P.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(o){S.$7P.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(o){S.$7P.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(o){S.$7P.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(o){const a=v.KeyCodeUtils.toString(o.keyCode);let E=-1;for(let m=0;m<this.m.length-1;m++)if(E=(m+this.n+1)%this.m.length,this.m[E].text.charAt(0).toUpperCase()===a&&!this.m[E].isDisabled){this.select(E),this.z.setFocus([E]),this.z.reveal(this.z.getFocus()[0]),S.$7P.stop(o);break}}dispose(){this.X(!1),super.dispose()}}t.$MR=d}),define(ge[128],me([1,0,39,127,121,20,5,99]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PR=t.$OR=void 0,t.$OR={...S.$DR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class C extends j.$MQ{constructor(v,y,O,r,l){super(),k.$j&&!l?.useCustomDrawn?this.a=new n.$NR(v,y,r,l):this.a=new R.$MR(v,y,O,r,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(v,y){this.a.setOptions(v,y)}select(v){this.a.select(v)}setAriaLabel(v){this.a.setAriaLabel(v)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(v){this.a.setFocusable(v)}render(v){this.a.render(v)}}t.$PR=C}),define(ge[63],me([1,0,16,54,3,25,126,128,36,2,5,7,104,52]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XR=t.$WR=t.$VR=void 0;class l extends v.$Sc{get action(){return this._action}constructor(p,o,a={}){super(),this.t=a,this._context=p||this,this._action=o,o instanceof $.$Fi&&this.B(o.onDidChange(E=>{this.element&&this.u(E)}))}u(p){p.enabled!==void 0&&this.w(),p.checked!==void 0&&this.I(),p.class!==void 0&&this.H(),p.label!==void 0&&(this.z(),this.F()),p.tooltip!==void 0&&this.F()}get actionRunner(){return this.m||(this.m=this.B(new $.$Gi)),this.m}set actionRunner(p){this.m=p}isEnabled(){return this._action.enabled}setActionContext(p){this._context=p}render(p){const o=this.element=p;this.B(j.$IQ.addTarget(p));const a=this.t&&this.t.draggable;a&&(p.draggable=!0,S.$SO&&this.B((0,n.$aP)(p,n.$5P.DRAG_START,E=>E.dataTransfer?.setData(R.$GQ.TEXT,this._action.label)))),this.B((0,n.$aP)(o,j.EventType.Tap,E=>this.onClick(E,!0))),this.B((0,n.$aP)(o,n.$5P.MOUSE_DOWN,E=>{a||n.$7P.stop(E,!0),this._action.enabled&&E.button===0&&o.classList.add("active")})),y.$j&&this.B((0,n.$aP)(o,n.$5P.CONTEXT_MENU,E=>{E.button===0&&E.ctrlKey===!0&&this.onClick(E)})),this.B((0,n.$aP)(o,n.$5P.CLICK,E=>{n.$7P.stop(E,!0),this.t&&this.t.isMenu||this.onClick(E)})),this.B((0,n.$aP)(o,n.$5P.DBLCLICK,E=>{n.$7P.stop(E,!0)})),[n.$5P.MOUSE_UP,n.$5P.MOUSE_OUT].forEach(E=>{this.B((0,n.$aP)(o,E,m=>{n.$7P.stop(m),o.classList.remove("active")}))})}onClick(p,o=!1){n.$7P.stop(p,!0);const a=O.$Mf(this._context)?this.t?.useEventAsContext?p:{preserveFocus:o}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(p){this.element&&(this.element.tabIndex=p?0:-1)}get trapsArrowNavigation(){return!1}w(){}z(){}C(){return this.action.class}D(){return this.action.tooltip}F(){if(!this.element)return;const p=this.D()??"";this.G(),this.t.hoverDelegate?(this.element.title="",this.f?this.f.update(p):(this.f=(0,k.$4Q)(this.t.hoverDelegate,this.element,p),this.q.add(this.f))):this.element.title=p}G(){if(this.element){const p=this.D()??"";this.element.setAttribute("aria-label",p)}}H(){}I(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$VR=l;class e extends l{constructor(p,o,a){super(p,o,a),this.t=a,this.t.icon=a.icon!==void 0?a.icon:!1,this.t.label=a.label!==void 0?a.label:!0,this.M=""}render(p){super.render(p),O.$Nf(this.element);const o=document.createElement("a");if(o.classList.add("action-label"),o.setAttribute("role",this.N()),this.J=o,this.element.appendChild(o),this.t.label&&this.t.keybinding){const a=document.createElement("span");a.classList.add("keybinding"),a.textContent=this.t.keybinding,this.element.appendChild(a)}this.H(),this.z(),this.F(),this.w(),this.I()}N(){return this._action.id===$.$Hi.ID?"presentation":this.t.isMenu?"menuitem":"button"}focus(){this.J&&(this.J.tabIndex=0,this.J.focus())}isFocused(){return!!this.J&&this.J?.tabIndex===0}blur(){this.J&&(this.J.tabIndex=-1)}setFocusable(p){this.J&&(this.J.tabIndex=p?0:-1)}z(){this.t.label&&this.J&&(this.J.textContent=this.action.label)}D(){let p=null;return this.action.tooltip?p=this.action.tooltip:!this.t.label&&this.action.label&&this.t.icon&&(p=this.action.label,this.t.keybinding&&(p=r.localize(0,null,p,this.t.keybinding))),p??void 0}H(){this.M&&this.J&&this.J.classList.remove(...this.M.split(" ")),this.t.icon?(this.M=this.C(),this.J&&(this.J.classList.add("codicon"),this.M&&this.J.classList.add(...this.M.split(" "))),this.w()):this.J?.classList.remove("codicon")}w(){this.action.enabled?(this.J&&(this.J.removeAttribute("aria-disabled"),this.J.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.J&&(this.J.setAttribute("aria-disabled","true"),this.J.classList.add("disabled")),this.element?.classList.add("disabled"))}G(){if(this.J){const p=this.D()??"";this.J.setAttribute("aria-label",p)}}I(){this.J&&(this.action.checked!==void 0?(this.J.classList.toggle("checked",this.action.checked),this.J.setAttribute("aria-checked",this.action.checked?"true":"false"),this.J.setAttribute("role","checkbox")):(this.J.classList.remove("checked"),this.J.removeAttribute("aria-checked"),this.J.setAttribute("role",this.N())))}}t.$WR=e;class c extends l{constructor(p,o,a,E,m,f,N){super(p,o),this.b=new C.$PR(a,E,m,f,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(p,o){this.b.setOptions(p,o)}select(p){this.b.select(p)}g(){this.B(this.b.onDidSelect(p=>this.j(p.selected,p.index)))}j(p,o){this.actionRunner.run(this._action,this.n(p,o))}n(p,o){return p}setFocusable(p){this.b.setFocusable(p)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(p){this.b.render(p)}}t.$XR=c}),define(ge[64],me([1,0,3,14,63,36,4,2,7,52]),function(ne,t,S,R,n,j,k,C,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Q=t.$5Q=t.ActionsOrientation=void 0;var v;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(v||(t.ActionsOrientation=v={}));class y extends C.$Sc{constructor(l,e={}){super(),this.g=this.B(new C.$Rc),this.r=this.B(new C.$2c),this.w=!1,this.y=!0,this.C=this.B(new k.$Sd),this.onDidBlur=this.C.event,this.D=this.B(new k.$Sd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new k.$Sd),this.onDidRun=this.G.event,this.H=this.B(new k.$Sd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new j.$Gi,this.g.add(this.f)),this.g.add(this.f.onDidRun(p=>this.G.fire(p))),this.g.add(this.f.onWillRun(p=>this.H.fire(p))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let c,d;switch(this.m){case 0:c=[15],d=[17];break;case 1:c=[16],d=[18],this.domNode.className+=" vertical";break}this.B(S.$aP(this.domNode,S.$5P.KEY_DOWN,p=>{const o=new R.$0O(p);let a=!0;const E=typeof this.t=="number"?this.viewItems[this.t]:void 0;c&&(o.equals(c[0])||o.equals(c[1]))?a=this.P():d&&(o.equals(d[0])||o.equals(d[1]))?a=this.O():o.equals(9)&&this.F?this.D.fire():o.equals(14)?a=this.M():o.equals(13)?a=this.N():o.equals(2)&&E instanceof n.$VR&&E.trapsArrowNavigation?a=this.O():this.J(o)?this.n.keyDown?this.R(o):this.w=!0:a=!1,a&&(o.preventDefault(),o.stopPropagation())})),this.B(S.$aP(this.domNode,S.$5P.KEY_UP,p=>{const o=new R.$0O(p);this.J(o)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(o)),o.preventDefault(),o.stopPropagation()):(o.equals(2)||o.equals(1026))&&this.L()})),this.u=this.B(S.$0P(this.domNode)),this.B(this.u.onDidBlur(()=>{(S.$MP()===this.domNode||!S.$EP(S.$MP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),l.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(l){l?this.z.setAttribute("aria-label",l):this.z.removeAttribute("aria-label")}setFocusable(l){if(this.y=l,this.y){const e=this.viewItems.find(c=>c instanceof n.$VR&&c.isEnabled());e instanceof n.$VR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$VR&&e.setFocusable(!1)})}J(l){let e=!1;return this.n.keys.forEach(c=>{e=e||l.equals(c)}),e}L(){for(let l=0;l<this.z.children.length;l++){const e=this.z.children[l];if(S.$EP(S.$MP(),e)){this.t=l,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.z;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const c=Array.isArray(l)?l:[l];let d=$.$Hf(e.index)?e.index:null;c.forEach(p=>{const o=document.createElement("li");o.className="action-item",o.setAttribute("role","presentation");let a;const E={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(a=this.b.actionViewItemProvider(p,E)),a||(a=new n.$WR(this.context,p,E)),this.b.allowContextMenu||this.r.set(a,S.$aP(o,S.$5P.CONTEXT_MENU,m=>{S.$7P.stop(m,!0)})),a.actionRunner=this.f,a.setActionContext(this.context),a.render(o),this.y&&a instanceof n.$VR&&this.viewItems.length===0&&a.setFocusable(!0),d===null||d<0||d>=this.z.children.length?(this.z.appendChild(o),this.viewItems.push(a)):(this.z.insertBefore(o,this.z.children[d]),this.viewItems.splice(d,0,a),d++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[l]),this.r.deleteAndDispose(this.viewItems[l]),(0,C.$Nc)(this.viewItems.splice(l,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,C.$Nc)(this.viewItems),this.r.clearAndDisposeAll(),S.$_O(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,c;if(l===void 0?e=!0:typeof l=="number"?c=l:typeof l=="boolean"&&(e=l),e&&typeof this.t>"u"){const d=this.viewItems.findIndex(p=>p.isEnabled());this.t=d===-1?void 0:d,this.Q(void 0,void 0,!0)}else c!==void 0&&(this.t=c),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(l){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let c;do{if(!l&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,c=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===j.$Hi.ID));return this.Q(),!0}P(l){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let c;do{if(this.t=this.t-1,this.t<0){if(!l&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}c=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===j.$Hi.ID));return this.Q(!0),!0}Q(l,e,c=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const d=this.t!==void 0?this.viewItems[this.t]:void 0;if(d){let p=!0;$.$Rf(d.focus)||(p=!1),this.b.focusOnlyEnabledItems&&$.$Rf(d.isEnabled)&&!d.isEnabled()&&(p=!1),d.action.id===j.$Hi.ID&&(p=!1),p&&d.showHover?.(),p?(c||this.s!==this.t)&&(d.focus(l),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(l){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$VR){const c=e._context===null||e._context===void 0?l:e._context;this.run(e._action,c)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,C.$Nc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$5Q=y;function O(r){if(!r.length)return r;let l=-1;for(let c=0;c<r.length;c++)if(r[c].id!==j.$Hi.ID){l=c;break}if(l===-1)return[];r=r.slice(l);for(let c=r.length-1;c>=0&&r[c].id===j.$Hi.ID;c--)r.splice(c,1);let e=!1;for(let c=r.length-1;c>=0;c--){const d=r[c].id===j.$Hi.ID;d&&!e?r.splice(c,1):d?d&&(e=!1):e=!0}return r}t.$6Q=O}),define(ge[65],me([1,0,3,22,55,64,57,60,20,4,81,51,108,96]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=t.$BS=t.$AS=t.MessageType=void 0;const l=S.$;var e;(function(p){p[p.INFO=1]="INFO",p[p.WARNING=2]="WARNING",p[p.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$AS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class c extends $.$MQ{constructor(o,a,E){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new v.$Sd),this.onDidChange=this.O.event,this.P=this.B(new v.$Sd),this.onDidHeightChange=this.P.event,this.a=a,this.g=E,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=S.$_P(o,l(".monaco-inputbox.idle"));const m=this.g.flexibleHeight?"textarea":"input",f=S.$_P(this.element,l(".ibwrapper"));if(this.b=S.$_P(f,l(m+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=S.$_P(f,l("div.mirror")),this.y.innerText="\xA0",this.N=new C.$WQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),S.$_P(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(L=>this.b.scrollTop=L.scrollTop));const N=this.B(new R.$aR(o.ownerDocument,"selectionchange")),B=v.Event.filter(N.event,()=>o.ownerDocument.getSelection()?.anchorNode===f);this.B(B(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new j.$5Q(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.b.title=o}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Y())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:S.$CP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return S.$NP(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(o){o?this.enable():this.disable()}get width(){return S.$yP(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let a=0;if(this.y){const E=parseFloat(this.y.style.paddingLeft||"")||0,m=parseFloat(this.y.style.paddingRight||"")||0;a=E+m}this.b.style.width=o-a+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,a=this.J,E=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:a}),this.N.setScrollPosition({scrollTop:E})}showMessage(o,a){if(this.w==="open"&&(0,O.$jn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(o.type));const E=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${S.$rQ(E.border,"transparent")}`,this.h.content&&(this.hasFocus()||a)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const a=this.g.inputBoxStyles;switch(o){case 1:return{border:a.inputValidationInfoBorder,background:a.inputValidationInfoBackground,foreground:a.inputValidationInfoForeground};case 2:return{border:a.inputValidationWarningBorder,background:a.inputValidationWarningBackground,foreground:a.inputValidationWarningForeground};default:return{border:a.inputValidationErrorBorder,background:a.inputValidationErrorBackground,foreground:a.inputValidationErrorForeground}}}U(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let o;const a=()=>o.style.width=S.$yP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:m=>{if(!this.h)return null;o=S.$_P(m,l(".monaco-inputbox-container")),a();const f={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,n.$$Q)(this.h.content,f):(0,n.$0Q)(this.h.content,f);N.classList.add(this.U(this.h.type));const B=this.stylesForType(this.h.type);return N.style.backgroundColor=B.background??"",N.style.color=B.foreground??"",N.style.border=B.border?`1px solid ${B.border}`:"",S.$_P(o,N),null},onHide:()=>{this.w="closed"},layout:a});let E;this.h.type===3?E=r.localize(0,null,this.h.content):this.h.type===2?E=r.localize(1,null,this.h.content):E=r.localize(2,null,this.h.content),k.$cR(E),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const o=this.value,E=o.charCodeAt(o.length-1)===10?" ":"";(o+E).replace(/\u000c/g,"")?this.y.textContent=o+E:this.y.innerText="\xA0",this.layout()}ab(){const o=this.g.inputBoxStyles,a=o.inputBackground??"",E=o.inputForeground??"",m=o.inputBorder??"";this.element.style.backgroundColor=a,this.element.style.color=E,this.b.style.backgroundColor="inherit",this.b.style.color=E,this.element.style.border=`1px solid ${S.$rQ(m,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=S.$CP(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(o){const a=this.inputElement,E=a.selectionStart,m=a.selectionEnd,f=a.value;E!==null&&m!==null&&(this.value=f.substr(0,E)+o+f.substr(m),a.setSelectionRange(E+1,E+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$BS=c;class d extends c{constructor(o,a,E){const m=r.localize(3,null,"\u21C5"),f=r.localize(4,null,"\u21C5");super(o,a,E),this.db=this.B(new v.$Sd),this.onDidFocus=this.db.event,this.eb=this.B(new v.$Sd),this.onDidBlur=this.eb.event,this.bb=new y.$yS(E.history,100);const N=()=>{if(E.showHistoryHint&&E.showHistoryHint()&&!this.n.endsWith(m)&&!this.n.endsWith(f)&&this.bb.getHistory().length){const B=this.n.endsWith(")")?m:f,L=this.n+B;E.showPlaceholderOnFocus&&!S.$NP(this.b)?this.n=L:this.setPlaceHolder(L)}};this.cb=new MutationObserver((B,L)=>{B.forEach(w=>{w.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const B=L=>{if(this.n.endsWith(L)){const w=this.n.slice(0,this.n.length-L.length);return E.showPlaceholderOnFocus?this.n=w:this.setPlaceHolder(w),!0}else return!1};B(f)||B(m)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(o){this.value&&(o||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(o){const a=this.getHistory();this.clearHistory(),o.forEach(E=>{this.bb.add(E)}),a.forEach(E=>{this.bb.add(E)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),this.value=o??"",k.$dR(this.value?this.value:r.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let o=this.ib();o&&(o=o===this.value?this.ib():o),o&&(this.value=o,k.$dR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let o=this.bb.current();return o||(o=this.bb.last(),this.bb.next()),o}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$CS=d}),define(ge[66],me([1,0,63,20,17,18,4,3,101]),function(ne,t,S,R,n,j,k,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UR=t.$TR=t.$SR=t.$RR=t.$QR=void 0,t.$QR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class $ extends S.$VR{constructor(l,e,c){super(l,e,c),this.a=this.B(new v({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.t.keybinding?`${this._action.label} (${this.t.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:c.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:c.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:c.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(l){this.element=l,this.element.appendChild(this.a.domNode)}w(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}I(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(l){this.a.domNode.tabIndex=l?0:-1}}t.$RR=$;class v extends R.$MQ{constructor(l){super(),this.a=this.B(new k.$Sd),this.onChange=this.a.event,this.b=this.B(new k.$Sd),this.onKeyDown=this.b.event,this.c=l,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...j.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,c=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),c.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,c=>{if(c.keyCode===10||c.keyCode===3){this.checked=!this.s,this.a.fire(!0),c.preventDefault(),c.stopPropagation();return}this.b.fire(c)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(l){this.s=l,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(l){this.g&&this.domNode.classList.remove(...j.ThemeIcon.asClassNameArray(this.g)),this.g=l,this.g&&this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.$SR=v;class y extends R.$MQ{constructor(l,e,c){super(),this.g=l,this.h=e,this.a=this.B(new k.$Sd),this.onChange=this.a.event,this.b=new v({title:this.g,isChecked:this.h,icon:n.$6j.check,actionClassName:"monaco-checkbox",...t.$QR}),this.domNode=this.b.domNode,this.c=c,this.n(),this.B(this.b.onChange(d=>{this.n(),this.a.fire(d)}))}get checked(){return this.b.checked}set checked(l){this.b.checked=l,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,C.$NP)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$TR=y;class O extends S.$VR{constructor(l,e,c){super(l,e,c),this.a=this.B(new y(this._action.label,!!this._action.checked,c.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(l){if(this.element=l,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.t.label&&this._action.label){const e=this.element.appendChild((0,C.$)("span.checkbox-label",void 0,this._action.label));this.B((0,C.$aP)(e,C.$5P.CLICK,c=>{this.a.checked=!this.a.checked,c.stopPropagation(),c.preventDefault(),this.c()}))}this.w(),this.H(),this.I()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}w(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}I(){this.a.checked=!!this._action.checked}H(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.C(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(l){this.a.domNode.tabIndex=l?0:-1}}t.$UR=O}),define(ge[129],me([1,0,66,17,106]),function(ne,t,S,R,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PS=t.$OS=t.$NS=void 0;const j=n.localize(0,null),k=n.localize(1,null),C=n.localize(2,null);class $ extends S.$SR{constructor(r){super({icon:R.$6j.caseSensitive,title:j+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$NS=$;class v extends S.$SR{constructor(r){super({icon:R.$6j.wholeWord,title:k+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$OS=v;class y extends S.$SR{constructor(r){super({icon:R.$6j.regex,title:C+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$PS=y}),define(ge[130],me([1,0,3,129,65,20,4,105,2,95]),function(ne,t,S,R,n,j,k,C,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QS=void 0;const v=C.localize(0,null);class y extends j.$MQ{static{this.OPTION_CHANGE="optionChange"}constructor(r,l,e){super(),this.n=!0,this.s=!1,this.w=this.B(new $.$Tc),this.N=[],this.O=this.B(new k.$Sd),this.onDidOptionChange=this.O.event,this.P=this.B(new k.$Sd),this.onKeyDown=this.P.event,this.Q=this.B(new k.$Sd),this.onMouseDown=this.Q.event,this.R=this.B(new k.$Sd),this.onInput=this.R.event,this.S=this.B(new k.$Sd),this.onKeyUp=this.S.event,this.U=this.B(new k.$Sd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new k.$Sd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||v,this.h=!!e.showCommonFindToggles;const c=e.appendCaseSensitiveLabel||"",d=e.appendWholeWordsLabel||"",p=e.appendRegexLabel||"",o=e.history||[],a=!!e.flexibleHeight,E=!!e.flexibleWidth,m=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$CS(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:o,showHistoryHint:e.showHistoryHint,flexibleHeight:a,flexibleWidth:E,flexibleMaxHeight:m,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new R.$PS({appendTitle:p,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new R.$OS({appendTitle:d,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new R.$NS({appendTitle:c,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const f=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const B=f.indexOf(this.domNode.ownerDocument.activeElement);if(B>=0){let L=-1;N.equals(17)?L=(B+1)%f.length:N.equals(15)&&(B===0?L=f.length-1:L=B-1),N.equals(9)?(f[B].blur(),this.inputBox.focus()):L>=0&&f[L].focus(),S.$7P.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),r?.appendChild(this.domNode),this.B(S.$aP(this.inputBox.inputElement,"compositionstart",f=>{this.s=!0})),this.B(S.$aP(this.inputBox.inputElement,"compositionend",f=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,f=>this.P.fire(f)),this.C(this.inputBox.inputElement,f=>this.S.fire(f)),this.D(this.inputBox.inputElement,f=>this.R.fire()),this.j(this.inputBox.inputElement,f=>this.Q.fire(f))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.X(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const r of this.N)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const r of this.N)r.disable()}setFocusInputOnOptionClick(r){this.n=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const l of this.N)l.domNode.remove();this.N=[],this.w.value=new $.$Rc;for(const l of r??[])this.w.value.add(l),this.y.appendChild(l.domNode),this.w.value.add(l.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(l);this.N.length>0&&(this.y.style.display=""),this.X()}X(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((l,e)=>l+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(r){this.M&&(this.M.checked=r)}getWholeWords(){return this.L?.checked??!1}setWholeWords(r){this.L&&(this.L.checked=r)}getRegex(){return this.J?.checked??!1}setRegex(r){this.J&&(this.J.checked=r,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$QS=y}),define(ge[131],me([1,0,3,22,14,64,130,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,110,102]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l,e,c,d,p,o,a,E,m,f,N,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=t.TreeFindMatchType=t.TreeFindMode=t.$oT=t.$nT=t.$mT=t.RenderIndentGuides=t.$lT=t.$kT=void 0;class L extends $.$nR{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(s=>s.element)),this.c=i}}function w(D){return D instanceof $.$nR?new L(D):D}class P{constructor(i,s){this.d=i,this.f=s,this.b=m.$Sc.None,this.c=new m.$Rc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,s){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(u=>u.element),s)}onDragStart(i,s){this.f.onDragStart?.(w(i),s)}onDragOver(i,s,u,h,g=!0){const b=this.f.onDragOver(w(i),s&&s.element,u,h),A=this.a!==s;if(A&&(this.b.dispose(),this.a=s),typeof s>"u")return b;if(A&&typeof b!="boolean"&&b.autoExpand&&(this.b=(0,c.$3g)(()=>{const fe=this.d(),he=fe.getNodeLocation(s);fe.isCollapsed(he)&&fe.setCollapsed(he,!1),this.a=void 0},500,this.c)),typeof b=="boolean"||!b.accept||typeof b.bubble>"u"||b.feedback){if(!g){const fe=typeof b=="boolean"?b:b.accept,he=typeof b=="boolean"?void 0:b.effect;return{accept:fe,effect:he,feedback:[u]}}return b}if(b.bubble===1){const fe=this.d(),he=fe.getNodeLocation(s),ye=fe.getParentNodeLocation(he),De=fe.getNode(ye),pe=ye&&fe.getListIndex(ye);return this.onDragOver(i,De,pe,h,!1)}const T=this.d(),_=T.getNodeLocation(s),x=T.getListIndex(_),ee=T.getListRenderCount(_);return{...b,feedback:(0,e.$Sb)(x,x+ee)}}drop(i,s,u,h){this.b.dispose(),this.a=void 0,this.f.drop(w(i),s&&s.element,u,h)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function M(D,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(s){return i.identityProvider.getId(s.element)}},dnd:i.dnd&&new P(D,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(s){return i.multipleSelectionController.isSelectionSingleChangeEvent({...s,element:s.element})},isSelectionRangeChangeEvent(s){return i.multipleSelectionController.isSelectionRangeChangeEvent({...s,element:s.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(s){const u=D(),h=u.getNodeLocation(s),g=u.getParentNodeLocation(h);return u.getNode(g).visibleChildrenCount},getPosInSet(s){return s.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?s=>i.accessibilityProvider.isChecked(s.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?s=>i.accessibilityProvider.getRole(s.element):()=>"treeitem",getAriaLabel(s){return i.accessibilityProvider.getAriaLabel(s.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?s=>i.accessibilityProvider.getAriaLevel(s.element):s=>s.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(s=>i.accessibilityProvider.getActiveDescendantId(s.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(s){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(s.element)}}}}class U{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,s){this.a.setDynamicHeight?.(i.element,s)}}t.$kT=U;class V{static lift(i){return i instanceof V?i:new V(i)}static empty(i=0){return new V({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const s of i.expanded)this.expanded[s]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$lT=V;var F;(function(D){D.None="none",D.OnHover="onHover",D.Always="always"})(F||(t.RenderIndentGuides=F={}));class I{get elements(){return this.b}constructor(i,s=[]){this.b=s,this.a=new m.$Rc,this.onDidChange=a.Event.forEach(i,u=>this.b=u,this.a)}dispose(){this.a.dispose()}}class z{static{this.a=8}constructor(i,s,u,h,g,b={}){this.o=i,this.p=s,this.q=h,this.s=g,this.b=new Map,this.c=new Map,this.d=z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=m.$Sc.None,this.m=new m.$Rc,this.templateId=i.templateId,this.updateOptions(b),a.Event.map(u,A=>A.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const s=(0,f.$Zl)(i.indent,0,40);if(s!==this.d){this.d=s;for(const[u,h]of this.c)this.v(u,h)}}if(typeof i.renderIndentGuides<"u"){const s=i.renderIndentGuides!==F.None;if(s!==this.g){this.g=s;for(const[u,h]of this.c)this.w(u,h);if(this.k.dispose(),s){const u=new m.$Rc;this.q.onDidChange(this.x,this,u),this.k=u,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const s=(0,S.$_P)(i,(0,S.$)(".monaco-tl-row")),u=(0,S.$_P)(s,(0,S.$)(".monaco-tl-indent")),h=(0,S.$_P)(s,(0,S.$)(".monaco-tl-twistie")),g=(0,S.$_P)(s,(0,S.$)(".monaco-tl-contents")),b=this.o.renderTemplate(g);return{container:i,indent:u,twistie:h,indentGuidesDisposable:m.$Sc.None,templateData:b}}renderElement(i,s,u,h){this.c.set(i,u),this.b.set(i.element,i),this.v(i,u),this.o.renderElement(i,s,u.templateData,h)}disposeElement(i,s,u,h){u.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,s,u.templateData,h),typeof h=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const s=this.b.get(i);s&&this.u(s)}u(i){const s=this.c.get(i);s&&(this.x(this.q.elements),this.v(i,s))}v(i,s){const u=z.a+(i.depth-1)*this.d;s.twistie.style.paddingLeft=`${u}px`,s.indent.style.width=`${u+this.d-16}px`,i.collapsible?s.container.setAttribute("aria-expanded",String(!i.collapsed)):s.container.removeAttribute("aria-expanded"),s.twistie.classList.remove(...p.ThemeIcon.asClassNameArray(d.$6j.treeItemExpanded));let h=!1;this.o.renderTwistie&&(h=this.o.renderTwistie(i.element,s.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(h||s.twistie.classList.add(...p.ThemeIcon.asClassNameArray(d.$6j.treeItemExpanded)),s.twistie.classList.add("collapsible"),s.twistie.classList.toggle("collapsed",i.collapsed)):s.twistie.classList.remove("collapsible","collapsed"),this.w(i,s)}w(i,s){if((0,S.$_O)(s.indent),s.indentGuidesDisposable.dispose(),!this.g)return;const u=new m.$Rc,h=this.p();for(;;){const g=h.getNodeLocation(i),b=h.getParentNodeLocation(g);if(!b)break;const A=h.getNode(b),T=(0,S.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(A)&&T.classList.add("active"),s.indent.childElementCount===0?s.indent.appendChild(T):s.indent.insertBefore(T,s.indent.firstElementChild),this.s.add(A,T),u.add((0,m.$Qc)(()=>this.s.delete(A,T))),i=A}s.indentGuidesDisposable=u}x(i){if(!this.g)return;const s=new Set,u=this.p();i.forEach(h=>{const g=u.getNodeLocation(h);try{const b=u.getParentNodeLocation(g);h.collapsible&&h.children.length>0&&!h.collapsed?s.add(h):b&&s.add(u.getNode(b))}catch{}}),this.j.forEach(h=>{s.has(h)||this.s.forEach(h,g=>g.classList.remove("active"))}),s.forEach(h=>{this.j.has(h)||this.s.forEach(h,g=>g.classList.add("active"))}),this.j=s}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,m.$Nc)(this.m)}}t.$mT=z;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,s,u){this.g=i,this.j=s,this.k=u,this.a=0,this.b=0,this.c="",this.d="",this.f=new m.$Rc,i.onWillRefilter(this.m,this,this.f)}filter(i,s){let u=1;if(this.k){const b=this.k.filter(i,s);if(typeof b=="boolean"?u=b?1:0:(0,O.$hT)(b)?u=(0,O.$iT)(b.visibility):u=b,u===0)return!1}if(this.a++,!this.c)return this.b++,{data:E.FuzzyScore.Default,visibility:u};const h=this.j.getKeyboardNavigationLabel(i),g=Array.isArray(h)?h:[h];for(const b of g){const A=b&&b.toString();if(typeof A>"u")return{data:E.FuzzyScore.Default,visibility:u};let T;if(this.g.findMatchType===$e.Contiguous){const _=A.toLowerCase().indexOf(this.d);if(_>-1){T=[Number.MAX_SAFE_INTEGER,0];for(let x=this.d.length;x>0;x--)T.push(_+x-1)}}else T=(0,E.$1j)(this.c,this.d,0,A,A.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(T)return this.b++,g.length===1?{data:T,visibility:u}:{data:{label:A,score:T},visibility:u}}return this.g.findMode===te.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:E.FuzzyScore.Default,visibility:u}}m(){this.a=0,this.b=0}dispose(){(0,m.$Nc)(this.f)}}class G extends y.$SR{constructor(i){super({icon:d.$6j.listFilter,title:(0,B.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$nT=G;class re extends y.$SR{constructor(i){super({icon:d.$6j.searchFuzzy,title:(0,B.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$oT=re;const ie={inputBoxStyles:C.$AS,toggleStyles:y.$QR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(D){D[D.Highlight=0]="Highlight",D[D.Filter=1]="Filter"})(te||(t.TreeFindMode=te={}));var $e;(function(D){D[D.Fuzzy=0]="Fuzzy",D[D.Contiguous=1]="Contiguous"})($e||(t.TreeFindMatchType=$e={}));class Fe extends m.$Sc{set mode(i){this.b.checked=i===te.Filter,this.f.inputBox.setPlaceHolder(i===te.Filter?(0,B.localize)(2,null):(0,B.localize)(3,null))}set matchType(i){this.c.checked=i===$e.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,s,u,h,g,b){super(),this.t=s,this.a=(0,S.h)(".monaco-tree-type-filter",[(0,S.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,S.h)(".monaco-tree-type-filter-input@findInput"),(0,S.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new a.$Sd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,m.$Qc)(()=>i.removeChild(this.a.root)));const A=b?.styles??ie;A.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=A.listFilterWidgetBackground),A.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${A.listFilterWidgetShadow}`),this.b=this.B(new G({...A.toggleStyles,isChecked:h===te.Filter})),this.c=this.B(new re({...A.toggleStyles,isChecked:g===$e.Fuzzy})),this.onDidChangeMode=a.Event.map(this.b.onChange,()=>this.b.checked?te.Filter:te.Highlight,this.q),this.onDidChangeMatchType=a.Event.map(this.c.onChange,()=>this.c.checked?$e.Fuzzy:$e.Contiguous,this.q),this.f=this.B(new k.$QS(this.a.findInput,u,{label:(0,B.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:A.inputBoxStyles,toggleStyles:A.toggleStyles,history:b?.history})),this.g=this.B(new j.$5Q(this.a.actionbar)),this.mode=h;const T=this.B(new R.$aR(this.f.inputBox.inputElement,"keydown")),_=a.Event.chain(T.event,he=>he.map(ye=>new n.$0O(ye)));this.B(_(he=>{if(he.equals(3)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(he.equals(18)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(he.equals(16)){he.preventDefault(),he.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const x=this.B(new l.$Fi("close",(0,B.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(x,{icon:!0,label:!1});const ee=this.B(new R.$aR(this.a.grab,"mousedown"));this.B(ee.event(he=>{const ye=new m.$Rc,De=ye.add(new R.$aR((0,S.getWindow)(he),"mousemove")),pe=ye.add(new R.$aR((0,S.getWindow)(he),"mouseup")),Ie=this.m,Te=he.pageX,Ye=this.s,He=he.pageY;this.a.grab.classList.add("grabbing");const Me=this.a.root.style.transition;this.a.root.style.transition="unset";const Ve=Q=>{const se=Q.pageX-Te;this.m=Ie-se;const de=Q.pageY-He;this.s=Ye+de,this.layout()};ye.add(De.event(Ve)),ye.add(pe.event(Q=>{Ve(Q),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Me,ye.dispose()}))}));const fe=a.Event.chain(this.B(new R.$aR(this.a.grab,"keydown")).event,he=>he.map(ye=>new n.$0O(ye)));this.B(fe(he=>{let ye,De;if(he.keyCode===15?ye=Number.POSITIVE_INFINITY:he.keyCode===17?ye=0:he.keyCode===10&&(ye=this.m===0?Number.POSITIVE_INFINITY:0),he.keyCode===16?De=0:he.keyCode===18&&(De=Number.POSITIVE_INFINITY),ye!==void 0&&(he.preventDefault(),he.stopPropagation(),this.m=ye,this.layout()),De!==void 0){he.preventDefault(),he.stopPropagation(),this.s=De;const pe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=pe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,f.$Zl)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,f.$Zl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,c.$2g)(300),super.dispose()}}class ke{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,s,u,h,g,b={}){this.t=i,this.u=u,this.v=h,this.w=g,this.x=b,this.b="",this.c="",this.j=0,this.k=new a.$Sd,this.onDidChangeMode=this.k.event,this.m=new a.$Sd,this.onDidChangeMatchType=this.m.event,this.o=new a.$Sd,this.onDidChangePattern=this.o.event,this.p=new a.$Sd,this.onDidChangeOpenState=this.p.event,this.q=new m.$Rc,this.s=new m.$Rc,this.d=i.options.defaultFindMode??te.Highlight,this.f=i.options.defaultFindMatchType??$e.Fuzzy,s.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Fe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,u=>!E.FuzzyScore.isDefault(u.filterData));const s=this.t.getFocus();if(s.length>0){const u=s[0];this.t.getRelativeTop(u)===null&&this.t.reveal(u,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,B.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.d===te.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!E.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Le(D,i){return D.position===i.position&&D.node.element===i.node.element&&D.startIndex===i.startIndex&&D.height===i.height&&D.endIndex===i.endIndex}class ae extends m.$Sc{constructor(i=[]){super(),this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Le)}addDisposable(i){this.B(i)}}class J extends m.$Sc{get f(){const i=this.m.firstVisibleIndex;if(!(i<0||i>=this.m.length))return this.m.element(i)}constructor(i,s,u,h,g,b={}){super(),this.g=i,this.j=s,this.m=u,this.s=g,this.b=.4;const A=this.validateStickySettings(b);this.a=A.stickyScrollMaxItemCount,this.c=this.B(new le(u.getScrollableElement(),u,s,h,g)),this.B(u.onDidScroll(()=>this.t())),this.B(u.onDidChangeContentHeight(()=>this.t())),this.B(i.onDidChangeCollapseState(()=>this.t())),this.t()}get height(){return this.c.height}get count(){return this.c.count}getNode(i){return this.c.getNode(i)}t(){const i=this.f;if(!i||this.g.scrollTop===0){this.c.setState(void 0);return}const s=this.u(i);this.c.setState(s)}u(i){const s=[],u=this.m.renderHeight*this.b;let h=i,g=0,b=this.y(h,void 0,g);for(;b&&g+b.height<u&&(s.push(b),g+=b.height,!(s.length>=this.a||(h=this.w(h),!h)));)b=this.y(h,b.node,g);return s.length?new ae(s):void 0}w(i){const s=this.I(i);return s===-1||s===this.m.length-1?void 0:this.m.element(s+1)}y(i,s,u){const h=this.D(i,s);if(h&&!(h===i&&(!this.H(i)||this.z(i,u))))return this.C(h,u)}z(i,s){const u=this.I(i),h=this.m.getElementTop(u),g=s;return this.m.scrollTop===h-g}C(i,s){const u=this.s.getHeight(i),{startIndex:h,endIndex:g}=this.J(i),b=this.F(g,s);return{node:i,position:b,height:u,startIndex:h,endIndex:g}}D(i,s=void 0){let u=i,h=this.G(u);for(;h;){if(h===s)return u;u=h,h=this.G(u)}if(s===void 0)return u}F(i,s){let u=this.m.getRelativeTop(i);if(u===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const T=this.s.getHeight(this.m.element(i)),_=this.m.getRelativeTop(i+1);u=_?_-T/this.m.renderHeight:null}if(u===null)return s;const h=this.m.element(i),g=this.s.getHeight(h),b=u*this.m.renderHeight,A=b+g;return s>b&&s<=A?b:s}G(i){const s=this.j.getNodeLocation(i),u=this.j.getParentNodeLocation(s);return u?this.j.getNode(u):void 0}H(i){const s=this.j.getNodeLocation(i);return this.j.getListRenderCount(s)>1}I(i,s){return s===void 0&&(s=this.j.getNodeLocation(i)),this.j.getListIndex(s)}J(i){const s=this.j.getNodeLocation(i),u=this.j.getListIndex(s);if(u<0)throw new Error("Node not found in tree");const h=this.j.getListRenderCount(s),g=u+h-1;return{startIndex:u,endIndex:g}}nodePositionTopBelowWidget(i){const s=[];let u=this.G(i);for(;u;)s.push(u),u=this.G(u);let h=0;for(let g=0;g<s.length&&g<this.a;g++)h+=this.s.getHeight(s[g]);return h}updateOptions(i={}){const s=this.validateStickySettings(i);this.a!==s.stickyScrollMaxItemCount&&(this.a=s.stickyScrollMaxItemCount,this.t())}validateStickySettings(i){let s=5;return typeof i.stickyScrollMaxItemCount=="number"&&(s=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:s}}}class le{constructor(i,s,u,h,g){this.d=s,this.f=u,this.g=h,this.j=g,this.c=new m.$Tc,this.a=document.createElement("div"),this.a.classList.add("monaco-tree-sticky-container"),i.appendChild(this.a)}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(s=>s.node===i)}setState(i){const s=!!this.b&&this.b.count>0,u=!!i&&i.count>0;if(!s&&!u||s&&u&&this.b.equal(i)||(s!==u&&this.o(u),this.b?.dispose(),this.b=i,!u))return;for(let b=i.count-1;b>=0;b--){const A=i.stickyNodes[b],T=b?i.stickyNodes[b-1]:void 0,_=T?T.position+T.height:0,{element:x,disposable:ee}=this.k(A,_);this.a.appendChild(x),i.addDisposable(ee)}const h=(0,S.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(h),i.addDisposable((0,m.$Qc)(()=>h.remove()));const g=i.stickyNodes[i.count-1];this.a.style.height=`${g.position+g.height}px`}k(i,s){const u=this.f.getNodeLocation(i.node),h=this.f.getListIndex(u),g=document.createElement("div");g.style.top=`${i.position}px`,g.style.height=`${i.height}px`,g.style.lineHeight=`${i.height}px`,g.classList.add("monaco-tree-sticky-row"),g.classList.add("monaco-list-row"),g.setAttribute("data-index",`${h}`),g.setAttribute("data-parity",h%2===0?"even":"odd"),g.setAttribute("id",this.d.getElementID(h));const b=this.j.getTemplateId(i.node),A=this.g.find(fe=>fe.templateId===b);if(!A)throw new Error(`No renderer found for template id ${b}`);const T=new Proxy(i.node,{}),_=A.renderTemplate(g);A.renderElement(T,i.startIndex,_,i.height);const x=this.m(g,i,s),ee=(0,m.$Qc)(()=>{A.disposeElement(T,i.startIndex,_,i.height),A.disposeTemplate(_),x.dispose(),g.remove()});return{element:g,disposable:ee}}m(i,s,u){return(0,S.$aP)(i,"mouseup",h=>{h.button!==2&&((0,v.$tR)(h.target)||(0,v.$uR)(h.target)||(this.c.value=(0,c.$3g)(()=>{const b=this.d.getElementTop(s.startIndex),A=u;this.d.scrollTop=b-A,this.d.setFocus([s.startIndex]),this.d.setSelection([s.startIndex])},0)))})}o(i){this.a.style.display=i?"block":"none"}dispose(){this.c.dispose(),this.b?.dispose(),this.a.remove()}}function K(D){let i=r.TreeMouseEventTarget.Unknown;return(0,S.$IP)(D.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=r.TreeMouseEventTarget.Twistie:(0,S.$IP)(D.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=r.TreeMouseEventTarget.Element:(0,S.$IP)(D.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=r.TreeMouseEventTarget.Filter),{browserEvent:D.browserEvent,element:D.element?D.element.element:null,target:i}}function H(D){return{element:D.element?D.element.element:null,browserEvent:D.browserEvent,anchor:D.anchor}}function Y(D,i){i(D),D.children.forEach(s=>Y(s,i))}class be{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,s){this.g=i,this.j=s,this.a=[],this.c=new a.$Sd,this.onDidChange=this.c.event}set(i,s){!s?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,s)}k(i,s,u){if(this.a=[...i],this.b=void 0,this.d=void 0,!s){const h=this;this.c.fire({get elements(){return h.get()},browserEvent:u})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:s}){if(!this.j){const T=this.m(),_=x=>T.delete(x);s.forEach(x=>Y(x,_)),this.set([...T.values()]);return}const u=new Set,h=T=>u.add(this.j.getId(T.element).toString());s.forEach(T=>Y(T,h));const g=new Map,b=T=>g.set(this.j.getId(T.element).toString(),T);i.forEach(T=>Y(T,b));const A=[];for(const T of this.a){const _=this.j.getId(T.element).toString();if(!u.has(_))A.push(T);else{const ee=g.get(_);ee&&ee.visible&&A.push(ee)}}if(this.a.length>0&&A.length===0){const T=this.g();T&&A.push(T)}this.k(A,!0)}m(){const i=new Set;for(const s of this.a)i.add(s);return i}}class we extends v.$BR{constructor(i,s){super(i),this.x=s}u(i){if((0,v.$xR)(i.browserEvent.target)||(0,v.$rR)(i.browserEvent.target)||(0,v.$sR)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const s=i.element;if(!s)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const u=i.browserEvent.target,h=u.classList.contains("monaco-tl-twistie")||u.classList.contains("monaco-icon-label")&&u.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,g=(0,v.$wR)(i.browserEvent.target);let b=!1;if(g?b=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?b=this.x.expandOnlyOnTwistieClick(s.element):b=!!this.x.expandOnlyOnTwistieClick,!g){if(b&&!h&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(s.collapsible&&(!g||h)){const A=this.x.getNodeLocation(s),T=i.browserEvent.altKey;if(this.x.setFocus([A]),this.x.toggleCollapsed(A,T),b&&h){i.browserEvent.isHandledByList=!0;return}}g||super.u(i)}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}}class Ce extends v.$ER{constructor(i,s,u,h,g,b,A,T){super(i,s,u,h,T),this.p=g,this.s=b,this.K=A}D(i){return new we(this,i.tree)}splice(i,s,u=[]){if(super.splice(i,s,u),u.length===0)return;const h=[],g=[];let b;u.forEach((A,T)=>{this.p.has(A)&&h.push(i+T),this.s.has(A)&&g.push(i+T),this.K.has(A)&&(b=i+T)}),h.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...h])),g.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...g])),typeof b=="number"&&super.setAnchor(b)}setFocus(i,s,u=!1){super.setFocus(i,s),u||this.p.set(i.map(h=>this.element(h)),s)}setSelection(i,s,u=!1){super.setSelection(i,s),u||this.s.set(i.map(h=>this.element(h)),s)}setAnchor(i,s=!1){super.setAnchor(i),s||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}class Ae{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.x.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.x.wrapEvent(this.u.onDidChange)}get onMouseClick(){return a.Event.map(this.j.onMouseClick,K)}get onMouseDblClick(){return a.Event.filter(a.Event.map(this.j.onMouseDblClick,K),i=>i.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return a.Event.map(this.j.onContextMenu,H)}get onTap(){return a.Event.map(this.j.onTap,K)}get onPointer(){return a.Event.map(this.j.onPointer,K)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return a.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.y?.mode??te.Highlight}set findMode(i){this.y&&(this.y.mode=i)}get findMatchType(){return this.y?.matchType??$e.Fuzzy}set findMatchType(i){this.y&&(this.y.matchType=i)}get onDidChangeFindPattern(){return this.y?this.y.onDidChangePattern:a.Event.None}get expandOnDoubleClick(){return typeof this.G.expandOnDoubleClick>"u"?!0:this.G.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.G.expandOnlyOnTwistieClick>"u"?!0:this.G.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,s,u,h,g={}){this.F=i,this.G=g,this.x=new a.$1d,this.onDidChangeFindOpenState=a.Event.None,this.C=new m.$Rc,this.D=new a.$Sd,this.onWillRefilter=this.D.event,this.E=new a.$Sd,this.onDidUpdateOptions=this.E.event,this.p=new U(u);const b=new a.$2d,A=new a.$2d,T=this.C.add(new I(A.event)),_=new o.$Gc;this.k=h.map(ye=>new z(ye,()=>this.o,b.event,T,_,g));for(const ye of this.k)this.C.add(ye);let x;g.keyboardNavigationLabelProvider&&(x=new X(this,g.keyboardNavigationLabelProvider,g.filter),g={...g,filter:x},this.C.add(x)),this.q=new be(()=>this.j.getFocusedElements()[0],g.identityProvider),this.u=new be(()=>this.j.getSelectedElements()[0],g.identityProvider),this.w=new be(()=>this.j.getAnchorElement(),g.identityProvider),this.j=new Ce(i,s,this.p,this.k,this.q,this.u,this.w,{...M(()=>this.o,g),tree:this}),this.o=this.L(i,this.j,g),b.input=this.o.onDidChangeCollapseState;const ee=a.Event.forEach(this.o.onDidSplice,ye=>{this.x.bufferEvents(()=>{this.q.onDidModelSplice(ye),this.u.onDidModelSplice(ye)})},this.C);ee(()=>null,null,this.C);const fe=this.C.add(new a.$Sd),he=this.C.add(new c.$Xg(0));if(this.C.add(a.Event.any(ee,this.q.onDidChange,this.u.onDidChange)(()=>{he.trigger(()=>{const ye=new Set;for(const De of this.q.getNodes())ye.add(De);for(const De of this.u.getNodes())ye.add(De);fe.fire([...ye.values()])})})),A.input=fe.event,g.keyboardSupport!==!1){const ye=a.Event.chain(this.j.onKeyDown,De=>De.filter(pe=>!(0,v.$rR)(pe.target)).map(pe=>new n.$0O(pe)));a.Event.chain(ye,De=>De.filter(pe=>pe.keyCode===15))(this.I,this,this.C),a.Event.chain(ye,De=>De.filter(pe=>pe.keyCode===17))(this.J,this,this.C),a.Event.chain(ye,De=>De.filter(pe=>pe.keyCode===10))(this.K,this,this.C)}if((g.findWidgetEnabled??!0)&&g.keyboardNavigationLabelProvider&&g.contextViewProvider){const ye=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.y=new ke(this,this.o,this.j,x,g.contextViewProvider,ye),this.z=De=>this.y.shouldAllowFocus(De),this.onDidChangeFindOpenState=this.y.onDidChangeOpenState,this.C.add(this.y),this.onDidChangeFindMode=this.y.onDidChangeMode,this.onDidChangeFindMatchType=this.y.onDidChangeMatchType}else this.onDidChangeFindMode=a.Event.None,this.onDidChangeFindMatchType=a.Event.None;g.enableStickyScroll&&(this.A=new J(this,this.o,this.j,this.k,this.p,g)),this.B=(0,S.$UP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.G.renderIndentGuides===F.Always)}updateOptions(i={}){this.G={...this.G,...i};for(const s of this.k)s.updateOptions(i);this.j.updateOptions(this.G),this.y?.updateOptions(i),this.H(i),this.E.fire(this.G),this.getHTMLElement().classList.toggle("always",this.G.renderIndentGuides===F.Always)}get options(){return this.G}H(i){!this.A&&this.G.enableStickyScroll?this.A=new J(this,this.o,this.j,this.k,this.p,this.G):this.A&&!this.G.enableStickyScroll&&(this.A.dispose(),this.A=void 0),this.A?.updateOptions(i)}updateWidth(i){const s=this.o.getListIndex(i);s!==-1&&this.j.updateWidth(s)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.A&&(i+=this.A.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.u.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,S.$NP)(this.getHTMLElement())}layout(i,s){this.j.layout(i,s),(0,N.$Hf)(s)&&this.y?.layout(s)}style(i){const s=`.${this.j.domId}`,u=[];i.treeIndentGuidesStroke&&(u.push(`.monaco-list${s}:hover .monaco-tl-indent > .indent-guide, .monaco-list${s}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),u.push(`.monaco-list${s} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(u.push(`.monaco-list${s} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),u.push(`.monaco-list${s} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),this.B.textContent=u.join(`
`),this.j.style(i)}getParentElement(i){const s=this.o.getParentNodeLocation(i);return this.o.getNode(s).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,s=!1){return this.o.setCollapsed(i,!0,s)}expand(i,s=!1){return this.o.setCollapsed(i,!1,s)}toggleCollapsed(i,s=!1){return this.o.setCollapsed(i,void 0,s)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,s){return this.o.setCollapsible(i,s)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.y?.open()}closeFind(){this.y?.close()}refilter(){this.D.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);const s=this.o.getNode(i);this.w.set([s]);const u=this.o.getListIndex(i);u>-1&&this.j.setAnchor(u,!0)}getAnchor(){return(0,e.$Ob)(this.w.get(),void 0)}setSelection(i,s){const u=i.map(g=>this.o.getNode(g));this.u.set(u,s);const h=i.map(g=>this.o.getListIndex(g)).filter(g=>g>-1);this.j.setSelection(h,s,!0)}getSelection(){return this.u.get()}setFocus(i,s){const u=i.map(g=>this.o.getNode(g));this.q.set(u,s);const h=i.map(g=>this.o.getListIndex(g)).filter(g=>g>-1);this.j.setFocus(h,s,!0)}focusNext(i=1,s=!1,u,h=this.z){this.j.focusNext(i,s,u,h)}focusPrevious(i=1,s=!1,u,h=this.z){this.j.focusPrevious(i,s,u,h)}focusNextPage(i,s=this.z){return this.j.focusNextPage(i,s)}focusPreviousPage(i,s=this.z){return this.j.focusPreviousPage(i,s)}focusLast(i,s=this.z){this.j.focusLast(i,s)}focusFirst(i,s=this.z){this.j.focusFirst(i,s)}getFocus(){return this.q.get()}reveal(i,s){this.o.expandTo(i);const u=this.o.getListIndex(i);if(u!==-1)if(!this.A)this.j.reveal(u,s);else{const h=this.A.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(u,s,h)}}getRelativeTop(i){const s=this.o.getListIndex(i);if(s===-1)return null;const u=this.A?.getNode(this.getNode(i));return this.j.getRelativeTop(s,u?.position??this.A?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new r.$fT(this.F,"Can't get tree view state without an identity provider");const s=b=>i.getId(b).toString(),u=V.empty(this.scrollTop);for(const b of this.getFocus())u.focus.add(s(b));for(const b of this.getSelection())u.selection.add(s(b));const h=this.o.getNode(),g=[h];for(;g.length>0;){const b=g.shift();b!==h&&b.collapsible&&(u.expanded[s(b.element)]=b.collapsed?0:1),g.push(...b.children)}return u}I(i){i.preventDefault(),i.stopPropagation();const s=this.j.getFocusedElements();if(s.length===0)return;const u=s[0],h=this.o.getNodeLocation(u);if(!this.o.setCollapsed(h,!0)){const b=this.o.getParentNodeLocation(h);if(!b)return;const A=this.o.getListIndex(b);this.j.reveal(A),this.j.setFocus([A])}}J(i){i.preventDefault(),i.stopPropagation();const s=this.j.getFocusedElements();if(s.length===0)return;const u=s[0],h=this.o.getNodeLocation(u);if(!this.o.setCollapsed(h,!1)){if(!u.children.some(T=>T.visible))return;const[b]=this.j.getFocus(),A=b+1;this.j.reveal(A),this.j.setFocus([A])}}K(i){i.preventDefault(),i.stopPropagation();const s=this.j.getFocusedElements();if(s.length===0)return;const u=s[0],h=this.o.getNodeLocation(u),g=i.browserEvent.altKey;this.o.setCollapsed(h,void 0,g)}navigate(i){return new ce(this.j,this.o,i)}dispose(){(0,m.$Nc)(this.C),this.A?.dispose(),this.j.dispose()}}t.$pT=Ae;class ce{constructor(i,s,u){this.b=i,this.c=s,u?this.a=this.c.getListIndex(u):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[132],me([1,0,131,122,26,28]),function(ne,t,S,R,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AT=void 0;class k extends S.$pT{constructor($,v,y,O,r,l={}){super($,v,y,O,l),this.f=$,this.g=r,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput($,v){if(v&&!this.c)throw new n.$fT(this.f,"Can't restore tree view state without an identity provider");if(this.b=$,!$){this.d.clear(),this.o.setChildren(null,j.Iterable.empty());return}if(!v){this.m($);return}const y=[],O=[],r=e=>{const c=this.c.getId(e).toString();return!v.expanded[c]},l=e=>{const c=this.c.getId(e.element).toString();v.focus.has(c)&&y.push(e.element),v.selection.has(c)&&O.push(e.element)};this.m($,r,l),this.setFocus(y),this.setSelection(O),v&&typeof v.scrollTop=="number"&&(this.scrollTop=v.scrollTop)}updateChildren($=this.b){if(typeof this.b>"u")throw new n.$fT(this.f,"Tree input not set");let v;this.c&&(v=y=>{const O=this.c.getId(y).toString(),r=this.d.get(O);if(r)return r.collapsed}),this.m($,v)}resort($=this.b,v=!0){this.o.resort($===this.b?null:$,v)}refresh($){if($===void 0){this.j.rerender();return}this.o.rerender($)}m($,v,y){let O;if(this.c){const r=new Set,l=y;y=e=>{const c=this.c.getId(e.element).toString();r.add(c),this.d.set(c,e),l?.(e)},O=e=>{const c=this.c.getId(e.element).toString();r.has(c)||this.d.delete(c)}}this.o.setChildren($===this.b?null:$,this.s($,v).elements,{onDidCreateNode:y,onDidDeleteNode:O})}s($,v){const y=[...this.g.getChildren($)];return{elements:j.Iterable.map(y,r=>{const{elements:l,size:e}=this.s(r,v),c=this.g.hasChildren?this.g.hasChildren(r):void 0,d=e===0?void 0:v&&v(r);return{element:r,children:l,collapsible:c,collapsed:d}}),size:y.length}}L($,v,y){return new R.$qT($,v,y)}}t.$AT=k}),define(ge[67],me([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jh=t.ProxyChannel=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.RequestInitiator=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=void 0;var l;(function(ae){ae[ae.Promise=100]="Promise",ae[ae.PromiseCancel=101]="PromiseCancel",ae[ae.EventListen=102]="EventListen",ae[ae.EventDispose=103]="EventDispose"})(l||(l={}));function e(ae){switch(ae){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(ae){ae[ae.Initialize=200]="Initialize",ae[ae.PromiseSuccess=201]="PromiseSuccess",ae[ae.PromiseError=202]="PromiseError",ae[ae.PromiseErrorObj=203]="PromiseErrorObj",ae[ae.EventFire=204]="EventFire"})(c||(c={}));function d(ae){switch(ae){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(ae){ae[ae.Uninitialized=0]="Uninitialized",ae[ae.Idle=1]="Idle"})(p||(p={}));function o(ae){let J=0;for(let le=0;;le+=7){const K=ae.read(1);if(J|=(K.buffer[0]&127)<<le,!(K.buffer[0]&128))return J}}const a=B(0);function E(ae,J){if(J===0){ae.write(a);return}let le=0;for(let H=J;H!==0;H=H>>>7)le++;const K=n.$ge.alloc(le);for(let H=0;J!==0;H++)K.buffer[H]=J&127,J=J>>>7,J>0&&(K.buffer[H]|=128);ae.write(K)}class m{constructor(J){this.b=J,this.a=0}read(J){const le=this.b.slice(this.a,this.a+J);return this.a+=le.byteLength,le}}t.$yh=m;class f{constructor(){this.a=[]}get buffer(){return n.$ge.concat(this.a)}write(J){this.a.push(J)}}t.$zh=f;var N;(function(ae){ae[ae.Undefined=0]="Undefined",ae[ae.String=1]="String",ae[ae.Buffer=2]="Buffer",ae[ae.VSBuffer=3]="VSBuffer",ae[ae.Array=4]="Array",ae[ae.Object=5]="Object",ae[ae.Int=6]="Int"})(N||(N={}));function B(ae){const J=n.$ge.alloc(1);return J.writeUInt8(ae,0),J}const L={Undefined:B(N.Undefined),String:B(N.String),Buffer:B(N.Buffer),VSBuffer:B(N.VSBuffer),Array:B(N.Array),Object:B(N.Object),Uint:B(N.Int)},w=typeof Buffer<"u";function P(ae,J){if(typeof J>"u")ae.write(L.Undefined);else if(typeof J=="string"){const le=n.$ge.fromString(J);ae.write(L.String),E(ae,le.byteLength),ae.write(le)}else if(w&&Buffer.isBuffer(J)){const le=n.$ge.wrap(J);ae.write(L.Buffer),E(ae,le.byteLength),ae.write(le)}else if(J instanceof n.$ge)ae.write(L.VSBuffer),E(ae,J.byteLength),ae.write(J);else if(Array.isArray(J)){ae.write(L.Array),E(ae,J.length);for(const le of J)P(ae,le)}else if(typeof J=="number"&&(J|0)===J)ae.write(L.Uint),E(ae,J);else{const le=n.$ge.fromString(JSON.stringify(J));ae.write(L.Object),E(ae,le.byteLength),ae.write(le)}}t.$Ah=P;function M(ae){switch(ae.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return ae.read(o(ae)).toString();case N.Buffer:return ae.read(o(ae)).buffer;case N.VSBuffer:return ae.read(o(ae));case N.Array:{const le=o(ae),K=[];for(let H=0;H<le;H++)K.push(M(ae));return K}case N.Object:return JSON.parse(ae.read(o(ae)).toString());case N.Int:return o(ae)}}t.$Bh=M;class U{constructor(J,le,K=null,H=1e3){this.h=J,this.j=le,this.k=K,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(J,le){this.b.set(J,le),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const le=this.o([J.type]);this.k?.logOutgoing(le,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const le=this.o([J.type,J.id],J.data);this.k?.logOutgoing(le,J.id,1,d(J.type),J.data);return}}}o(J,le=void 0){const K=new f;return P(K,J),P(K,le),this.p(K.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const le=new m(J),K=M(le),H=M(le),Y=K[0];switch(Y){case 100:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Y)}: ${K[2]}.${K[3]}`,H),this.s({type:Y,id:K[1],channelName:K[2],name:K[3],arg:H});case 102:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Y)}: ${K[2]}.${K[3]}`,H),this.t({type:Y,id:K[1],channelName:K[2],name:K[3],arg:H});case 101:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Y)}`),this.u({type:Y,id:K[1]});case 103:return this.k?.logIncoming(J.byteLength,K[1],1,`${e(Y)}`),this.u({type:Y,id:K[1]})}}s(J){const le=this.b.get(J.channelName);if(!le){this.v(J);return}const K=new j.$3d;let H;try{H=le.call(this.j,J.name,J.arg,K.token)}catch(we){H=Promise.reject(we)}const Y=J.id;H.then(we=>{this.m({id:Y,data:we,type:201})},we=>{we instanceof Error?this.m({id:Y,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.m({id:Y,data:we,type:203})}).finally(()=>{be.dispose(),this.d.delete(J.id)});const be=(0,v.$Qc)(()=>K.cancel());this.d.set(J.id,be)}t(J){const le=this.b.get(J.channelName);if(!le){this.v(J);return}const K=J.id,Y=le.listen(this.j,J.name,J.arg)(be=>this.m({id:K,data:be,type:204}));this.d.set(J.id,Y)}u(J){const le=this.d.get(J.id);le&&(le.dispose(),this.d.delete(J.id))}v(J){let le=this.g.get(J.channelName);le||(le=[],this.g.set(J.channelName,le));const K=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);le.push({request:J,timeoutTimer:K})}w(J){const le=this.g.get(J);if(le){for(const K of le)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}t.$Ch=U;var V;(function(ae){ae[ae.LocalSide=0]="LocalSide",ae[ae.OtherSide=1]="OtherSide"})(V||(t.RequestInitiator=V={}));class F{constructor(J,le=null){this.l=J,this.a=!1,this.b=p.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=le}getChannel(J){const le=this;return{call(K,H,Y){return le.a?Promise.reject(new C.$5):le.m(J,K,H,Y)},listen(K,H){return le.a?$.Event.None:le.o(J,K,H)}}}m(J,le,K,H=j.CancellationToken.None){const Y=this.g++,we={id:Y,type:100,channelName:J,name:le,arg:K};if(H.isCancellationRequested)return Promise.reject(new C.$5);let Ce;return new Promise((ce,D)=>{if(H.isCancellationRequested)return D(new C.$5);const i=()=>{const g=b=>{switch(b.type){case 201:this.f.delete(Y),ce(b.data);break;case 202:{this.f.delete(Y);const A=new Error(b.data.message);A.stack=Array.isArray(b.data.stack)?b.data.stack.join(`
`):b.data.stack,A.name=b.data.name,D(A);break}case 203:this.f.delete(Y),D(b.data);break}};this.f.set(Y,g),this.p(we)};let s=null;this.b===p.Idle?i():(s=(0,R.$Og)(g=>this.u()),s.then(()=>{s=null,i()}));const u=()=>{s?(s.cancel(),s=null):this.p({id:Y,type:101}),D(new C.$5)},h=H.onCancellationRequested(u);Ce=(0,v.$Pc)((0,v.$Qc)(u),h),this.d.add(Ce)}).finally(()=>{Ce.dispose(),this.d.delete(Ce)})}o(J,le,K){const H=this.g++,be={id:H,type:102,channelName:J,name:le,arg:K};let we=null;const Ce=new $.$Sd({onWillAddFirstListener:()=>{we=(0,R.$Og)(ce=>this.u()),we.then(()=>{we=null,this.d.add(Ce),this.p(be)})},onDidRemoveLastListener:()=>{we?(we.cancel(),we=null):(this.d.delete(Ce),this.p({id:H,type:103}))}}),Ae=ce=>Ce.fire(ce.data);return this.f.set(H,Ae),Ce.event}p(J){switch(J.type){case 100:case 102:{const le=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(le,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const le=this.q([J.type,J.id]);this.j?.logOutgoing(le,J.id,0,e(J.type));return}}}q(J,le=void 0){const K=new f;return P(K,J),P(K,le),this.r(K.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const le=new m(J),K=M(le),H=M(le),Y=K[0];switch(Y){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(Y)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,K[1],0,d(Y),H),this.t({type:K[0],id:K[1],data:H})}}t(J){if(J.type===200){this.b=p.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}t.$Dh=F,Xe([k.$sh],F.prototype,"onDidInitializePromise",null);class I{get connections(){const J=[];return this.f.forEach(le=>J.push(le)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new $.$Sd,this.onDidAddConnection=this.g.event,this.h=new $.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new v.$Rc,this.j.add(J(({protocol:le,onDidClientDisconnect:K})=>{const H=$.Event.once(le.onMessage);this.j.add(H(Y=>{const be=new m(Y),we=M(be),Ce=new U(le,we),Ae=new F(le);this.a.forEach((D,i)=>Ce.registerChannel(i,D));const ce={channelServer:Ce,channelClient:Ae,ctx:we};this.f.add(ce),this.g.fire(ce),this.j.add(K(()=>{Ce.dispose(),Ae.dispose(),this.f.delete(ce),this.h.fire(ce)}))}))}))}getChannel(J,le){const K=this;return{call(H,Y,be){let we;if((0,r.$Rf)(le)){const Ae=(0,S.$4b)(K.connections.filter(le));we=Ae?Promise.resolve(Ae):$.Event.toPromise($.Event.filter(K.onDidAddConnection,le))}else we=le.routeCall(K,H,Y);const Ce=we.then(Ae=>Ae.channelClient.getChannel(J));return X(Ce).call(H,Y,be)},listen(H,Y){if((0,r.$Rf)(le))return K.k(J,le,H,Y);const be=le.routeEvent(K,H,Y).then(we=>we.channelClient.getChannel(J));return X(be).listen(H,Y)}}}k(J,le,K,H){const Y=this;let be;const we=new $.$Sd({onWillAddFirstListener:()=>{be=new v.$Rc;const Ce=new $.$Yd,Ae=new Map,ce=i=>{const u=i.channelClient.getChannel(J).listen(K,H),h=Ce.add(u);Ae.set(i,h)},D=i=>{const s=Ae.get(i);s&&(s.dispose(),Ae.delete(i))};Y.connections.filter(le).forEach(ce),$.Event.filter(Y.onDidAddConnection,le)(ce,void 0,be),Y.onDidRemoveConnection(D,void 0,be),Ce.event(we.fire,we,be),be.add(Ce)},onDidRemoveLastListener:()=>{be?.dispose(),be=void 0}});return we.event}registerChannel(J,le){this.a.set(J,le);for(const K of this.f)K.channelServer.registerChannel(J,le)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Eh=I;class z{constructor(J,le,K=null){const H=new f;P(H,le),J.send(H.buffer),this.a=new F(J,K),this.d=new U(J,le,K)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,le){this.d.registerChannel(J,le)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Fh=z;function X(ae){return{call(J,le,K){return ae.then(H=>H.call(J,le,K))},listen(J,le){const K=new $.$2d;return ae.then(H=>K.input=H.listen(J,le)),K.event}}}t.$Gh=X;function G(ae){let J=!1;return{call(le,K,H){return J?ae.call(le,K,H):(0,R.$2g)(0).then(()=>J=!0).then(()=>ae.call(le,K,H))},listen(le,K){if(J)return ae.listen(le,K);const H=new $.$2d;return(0,R.$2g)(0).then(()=>J=!0).then(()=>H.input=ae.listen(le,K)),H.event}}}t.$Hh=G;class re{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const le of J.connections)if(await Promise.resolve(this.a(le.ctx)))return Promise.resolve(le);return await $.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Ih=re;var ie;(function(ae){function J(Y,be,we){const Ce=Y,Ae=we&&we.disableMarshalling,ce=new Map;for(const D in Ce)K(D)&&ce.set(D,$.Event.buffer(Ce[D],!0,void 0,be));return new class{listen(D,i,s){const u=ce.get(i);if(u)return u;if(H(i)){const h=Ce[i];if(typeof h=="function")return h.call(Ce,s)}throw new C.$bb(`Event not found: ${i}`)}call(D,i,s){const u=Ce[i];if(typeof u=="function"){if(!Ae&&Array.isArray(s))for(let g=0;g<s.length;g++)s[g]=(0,y.$xh)(s[g]);let h=u.apply(Ce,s);return h instanceof Promise||(h=Promise.resolve(h)),h}throw new C.$bb(`Method not found: ${i}`)}}}ae.fromService=J;function le(Y,be){const we=be&&be.disableMarshalling;return new Proxy({},{get(Ce,Ae){if(typeof Ae=="string")return be?.properties?.has(Ae)?be.properties.get(Ae):H(Ae)?function(ce){return Y.listen(Ae,ce)}:K(Ae)?Y.listen(Ae):async function(...ce){let D;be&&!(0,r.$Mf)(be.context)?D=[be.context,...ce]:D=ce;const i=await Y.call(Ae,D);return we?i:(0,y.$xh)(i)};throw new C.$bb(`Property not found: ${String(Ae)}`)}})}ae.toService=le;function K(Y){return Y[0]==="o"&&Y[1]==="n"&&O.$6e(Y.charCodeAt(2))}function H(Y){return/^onDynamic/.test(Y)&&O.$6e(Y.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $e(ae){if(Array.isArray(ae))return ae;if(ae&&typeof ae=="object"&&typeof ae.toString=="function"){const J=ae.toString();if(J!=="[object Object]")return J}return ae}function Fe(ae){return Array.isArray(ae)?ae.map($e):$e(ae)}function ke(ae,J,le,K,H,Y,be){be=Fe(be);const we=te[H],Ce=we[K%we.length];let Ae=[`%c[${ae}]%c[${String(J).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(Y)?(Ae=Ae.concat(be),Ae.push(")")):Ae.push(be),console.log.apply(console,Ae)}class Le{constructor(J,le){this.d=J,this.f=le,this.a=0,this.b=0}logOutgoing(J,le,K,H,Y){this.b+=J,ke(this.d,this.b,J,le,K,H,Y)}logIncoming(J,le,K,H,Y){this.a+=J,ke(this.f,this.a,J,le,K,H,Y)}}t.$Jh=Le}),define(ge[133],me([1,0,33,4,67,89,30]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hU=void 0;class C extends n.$Fh{static f(){const v=R.Event.fromNodeEventEmitter(k.$O,"vscode:message",(y,O)=>S.$ge.wrap(O));return k.$O.send("vscode:hello"),new j.$dU(k.$O,v)}constructor(v){const y=C.f();super(y,v),this.b=y}dispose(){this.b.disconnect()}}t.$hU=C}),define(ge[134],me([13,11]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define(ge[135],me([13,11]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[40],me([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2h=t.$1h=t.$Zh=t._util=void 0;var S;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function C($){return $[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=C})(S||(t._util=S={})),t.$Zh=n("instantiationService");function R(k,C,$){C[S.DI_TARGET]===C?C[S.DI_DEPENDENCIES].push({id:k,index:$}):(C[S.DI_DEPENDENCIES]=[{id:k,index:$}],C[S.DI_TARGET]=C)}function n(k){if(S.serviceIds.has(k))return S.serviceIds.get(k);const C=function($,v,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(C,$,y)};return C.toString=()=>k,S.serviceIds.set(k,C),C}t.$1h=n;function j(k){return k}t.$2h=j}),define(ge[136],me([1,0,40]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dm=t.$Cm=t.$Bm=t.ID=void 0,t.ID="diagnosticsService",t.$Bm=(0,S.$1h)(t.ID);function R(j){return!!j.hostName&&!!j.errorMessage}t.$Cm=R;class n{async getPerformanceInfo(k,C){return{}}async getSystemInfo(k,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,C){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}t.$Dm=n}),define(ge[137],me([1,0,87,24,10,7,15,134,40,5,31,23]),function(ne,t,S,R,n,j,k,C,$,v,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.FileKind=t.$Nk=t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.FileOperationResult=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.FileChangeType=t.$Bk=t.FileOperation=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.FileSystemProviderErrorCode=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.$ok=t.$nk=t.$mk=t.FileSystemProviderCapabilities=t.$lk=t.FilePermission=t.FileType=t.$kk=t.$jk=void 0,t.$jk=(0,$.$1h)("fileService");function r(H){return H.create===!0}t.$kk=r;var l;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(l||(t.FileType=l={}));var e;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function c(H){const Y=H;return!!Y&&typeof Y.onDidChange=="function"}t.$lk=c;var d;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(d||(t.FileSystemProviderCapabilities=d={}));function p(H){return!!(H.capabilities&2)}t.$mk=p;function o(H){return!!(H.capabilities&8)}t.$nk=o;function a(H){return!!(H.capabilities&131072)}t.$ok=a;function E(H){return!!(H.capabilities&4)}t.$pk=E;function m(H){return!!(H.capabilities&16)}t.$qk=m;function f(H){return p(H)?!!(H.capabilities&16384):!1}t.$rk=f;function N(H){return p(H)?!!(H.capabilities&32768):!1}t.$sk=N;function B(H){return!!(H.capabilities&65536)}t.$tk=B;function L(H){return!!(H.capabilities&2048)}t.$uk=L;var w;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(w||(t.FileSystemProviderErrorCode=w={}));class P extends Error{static create(Y,be){const we=new P(Y.toString(),be);return V(we,be),we}constructor(Y,be){super(Y),this.code=be}}t.$vk=P;function M(H,Y){return P.create(H,Y)}t.$wk=M;function U(H){return H||M((0,C.localize)(0,null),w.Unknown)}t.$xk=U;function V(H,Y){return H.name=Y?`${Y} (FileSystemError)`:"FileSystemError",H}t.$yk=V;function F(H){if(!H)return w.Unknown;if(H instanceof P)return H.code;const Y=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Y)return w.Unknown;switch(Y[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}t.$zk=F;function I(H){if(H instanceof te)return H.fileOperationResult;switch(F(H)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}t.$Ak=I;var z;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(z||(t.FileOperation=z={}));class X{constructor(Y,be,we){this.resource=Y,this.operation=be,this.target=we}isOperation(Y){return this.operation===Y}}t.$Bk=X;var G;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(G||(t.FileChangeType=G={}));class re{static{this.a=null}constructor(Y,be){this.c=be,this.b=void 0,this.d=new O.$V(()=>{const we=S.$7h.forUris(()=>this.c);return we.fill(this.rawAdded.map(Ce=>[Ce,!0])),we}),this.f=new O.$V(()=>{const we=S.$7h.forUris(()=>this.c);return we.fill(this.rawUpdated.map(Ce=>[Ce,!0])),we}),this.g=new O.$V(()=>{const we=S.$7h.forUris(()=>this.c);return we.fill(this.rawDeleted.map(Ce=>[Ce,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of Y){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==re.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=re.a):this.b!==void 0&&(this.b=re.a))}}contains(Y,...be){return this.h(Y,{includeChildren:!1},...be)}affects(Y,...be){return this.h(Y,{includeChildren:!0},...be)}h(Y,be,...we){if(!Y)return!1;const Ce=we.length>0;return!!((!Ce||we.includes(1))&&(this.d.value.get(Y)||be.includeChildren&&this.d.value.findSuperstr(Y))||(!Ce||we.includes(0))&&(this.f.value.get(Y)||be.includeChildren&&this.f.value.findSuperstr(Y))||(!Ce||we.includes(2))&&(this.g.value.findSubstr(Y)||be.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}t.$Ck=re;function ie(H,Y,be){return!H||!Y||H===Y||Y.length>H.length?!1:(Y.charAt(Y.length-1)!==R.sep&&(Y+=R.sep),be?(0,n.$8e)(H,Y):H.indexOf(Y)===0)}t.$Dk=ie;class te extends Error{constructor(Y,be,we){super(Y),this.fileOperationResult=be,this.options=we}}t.$Ek=te;class $e extends te{constructor(Y,be,we,Ce){super(Y,be,Ce),this.fileOperationResult=be,this.size=we}}t.$Fk=$e;class Fe extends te{constructor(Y,be,we){super(Y,2,we),this.stat=be}}t.$Gk=Fe;var ke;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ke||(t.FileOperationResult=ke={})),t.$Hk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Ik={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Jk="files.associations",t.$Kk="files.exclude",t.$Lk="files.readonlyInclude",t.$Mk="files.readonlyExclude",t.$Nk="files.readonlyFromPermissions";var Le;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(Le||(t.FileKind=Le={})),t.$Ok="";function ae(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}t.$Pk=ae;async function J(H,Y){if(!Y.hasProvider(k.URI.from({scheme:H.scheme})))return new Promise(be=>{const we=Y.onDidChangeFileSystemProviderRegistrations(Ce=>{Ce.scheme===H.scheme&&Ce.added&&(we.dispose(),be())})})}t.$Qk=J;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(Y){return(0,j.$Hf)(Y)||(Y=0),Y<le.KB?(0,C.localize)(1,null,Y.toFixed(0)):Y<le.MB?(0,C.localize)(2,null,(Y/le.KB).toFixed(2)):Y<le.GB?(0,C.localize)(3,null,(Y/le.MB).toFixed(2)):Y<le.TB?(0,C.localize)(4,null,(Y/le.GB).toFixed(2)):(0,C.localize)(5,null,(Y/le.TB).toFixed(2))}}t.$Rk=le;function K(H){const Y=typeof H=="string"||H?.scheme===y.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===y.Schemas.file?1024*le.MB:Y?10*le.MB:v.$o?50*le.MB:1024*le.MB}t.$Sk=K}),define(ge[138],me([1,0,40]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Z0b=t.$Y0b=void 0,t.$Y0b=(0,S.$1h)("mainProcessService");class R{constructor(j,k){this.a=j,this.b=k}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,k){this.a.registerChannel(j,k)}}t.$Z0b=R}),define(ge[139],me([1,0,2,133]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$10b=void 0;class n extends S.$Sc{constructor(k){super(),this.a=this.B(new R.$hU(`window:${k}`))}getChannel(k){return this.a.getChannel(k)}registerChannel(k,C){this.a.registerChannel(k,C)}}t.$10b=n});var Ei=this&&this.__param||function(ne,t){return function(S,R){t(S,R,ne)}};define(ge[140],me([1,0,67,138]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$50b=void 0;let n=class{constructor(k,C){return this.windowId=k,S.ProxyChannel.toService(C.getChannel("nativeHost"),{context:k,properties:(()=>{const $=new Map;return $.set("windowId",k),$})()})}};t.$50b=n,t.$50b=n=Xe([Ei(1,R.$Y0b)],n)}),define(ge[68],me([1,0,76,7]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rn=void 0;class n{constructor(){this.a=new Map}add(k,C){S.ok(R.$Df(k)),S.ok(R.$Ff(C)),S.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,C)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}t.$rn=new n}),define(ge[141],me([1,0,4,68]),function(ne,t,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sn=void 0,t.$sn={JSONContribution:"base.contributions.json"};function n(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class j{constructor(){this.b=new S.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,v){this.a[n($)]=v,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const k=new j;R.$rn.add(t.$sn.JSONContribution,k)}),define(ge[142],me([1,0,9,17,18,4,7,15,135,141,68]),function(ne,t,S,R,n,j,k,C,$,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nw=t.$mw=t.$lw=t.$kw=t.$jw=t.$iw=t.$hw=t.$gw=t.IconFontDefinition=t.IconContribution=t.$fw=void 0,t.$fw={IconContribution:"base.contributions.icons"};var O;(function(E){function m(f,N){let B=f.defaults;for(;n.ThemeIcon.isThemeIcon(B);){const L=e.getIcon(B.id);if(!L)return;B=L.defaults}return B}E.getDefinition=m})(O||(t.IconContribution=O={}));var r;(function(E){function m(N){return{weight:N.weight,style:N.style,src:N.src.map(B=>({format:B.format,location:B.location.toString()}))}}E.toJSONObject=m;function f(N){const B=L=>(0,k.$Df)(L)?L:void 0;if(N&&Array.isArray(N.src)&&N.src.every(L=>(0,k.$Df)(L.format)&&(0,k.$Df)(L.location)))return{weight:B(N.weight),style:B(N.style),src:N.src.map(L=>({format:L.format,location:C.URI.parse(L.location)}))}}E.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class l{constructor(){this.a=new j.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(m,f,N,B){const L=this.b[m];if(L){if(N&&!L.description){L.description=N,this.d.properties[m].markdownDescription=`${N} $(${m})`;const M=this.e.enum.indexOf(m);M!==-1&&(this.e.enumDescriptions[M]=N),this.a.fire()}return L}const w={id:m,description:N,defaults:f,deprecationMessage:B};this.b[m]=w;const P={$ref:"#/definitions/icons"};return B&&(P.deprecationMessage=B),N&&(P.markdownDescription=`${N}: $(${m})`),this.d.properties[m]=P,this.e.enum.push(m),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:m}}deregisterIcon(m){delete this.b[m],delete this.d.properties[m];const f=this.e.enum.indexOf(m);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(m=>this.b[m])}getIcon(m){return this.b[m]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(m,f){const N=this.f[m];return N||(this.f[m]=f,this.a.fire(),f)}deregisterIconFont(m){delete this.f[m]}getIconFont(m){return this.f[m]}toString(){const m=(L,w)=>L.id.localeCompare(w.id),f=L=>{for(;n.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const B=Object.keys(this.b).map(L=>this.b[L]);for(const L of B.filter(w=>!!w.description).sort(m))N.push(`|<i class="${f(L)}"></i>|${L.id}|${n.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const L of B.filter(w=>!n.ThemeIcon.isThemeIcon(w.defaults)).sort(m))N.push(`|<i class="${f(L)}"></i>|${L.id}|`);return N.join(`
`)}}const e=new l;y.$rn.add(t.$fw.IconContribution,e);function c(E,m,f,N){return e.registerIcon(E,m,f,N)}t.$gw=c;function d(){return e}t.$hw=d;function p(){const E=(0,R.$4j)();for(const m in E){const f="\\"+E[m].toString(16);e.registerIcon(m,{fontCharacter:f})}}p(),t.$iw="vscode://schemas/icons";const o=y.$rn.as(v.$sn.JSONContribution);o.registerSchema(t.$iw,e.getIconSchema());const a=new S.$ah(()=>o.notifySchemaChanged(t.$iw),200);e.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.$jw=c("widget-close",R.$6j.close,(0,$.localize)(2,null)),t.$kw=c("goto-previous-location",R.$6j.arrowUp,(0,$.localize)(3,null)),t.$lw=c("goto-next-location",R.$6j.arrowDown,(0,$.localize)(4,null)),t.$mw=n.ThemeIcon.modify(R.$6j.sync,"spin"),t.$nw=n.ThemeIcon.modify(R.$6j.loading,"spin")}),define(ge[143],me([1,0,3,4,2,18,142]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sEb=t.$rEb=void 0;function C(v){const y=new n.$Rc,O=y.add(new R.$Sd),r=(0,k.$hw)();return y.add(r.onDidChange(()=>O.fire())),v&&y.add(v.onDidProductIconThemeChange(()=>O.fire())),{dispose:()=>y.dispose(),onDidChange:O.event,getCSS(){const l=v?v.getProductIconTheme():new $,e={},c=p=>{const o=l.getIcon(p);if(!o)return;const a=o.font;return a?(e[a.id]=a.definition,`.codicon-${p.id}:before { content: '${o.fontCharacter}'; font-family: ${(0,S.$qQ)(a.id)}; }`):`.codicon-${p.id}:before { content: '${o.fontCharacter}'; }`},d=[];for(const p of r.getIcons()){const o=c(p);o&&d.push(o)}for(const p in e){const o=e[p],a=o.weight?`font-weight: ${o.weight};`:"",E=o.style?`font-style: ${o.style};`:"",m=o.src.map(f=>`${(0,S.$pQ)(f.location)} format('${f.format}')`).join(", ");d.push(`@font-face { src: ${m}; font-family: ${(0,S.$qQ)(p)};${a}${E} font-display: block; }`)}return d.join(`
`)}}}t.$rEb=C;class ${getIcon(y){const O=(0,k.$hw)();let r=y.defaults;for(;j.ThemeIcon.isThemeIcon(r);){const l=O.getIcon(r.id);if(!l)return;r=l.defaults}return r}}t.$sEb=$}),define(ge[144],me([1,0,5]),function(ne,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BC=t.$AC=t.$zC=t.$yC=t.$xC=t.$wC=t.$vC=t.$uC=t.$tC=t.$sC=void 0,t.$sC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(r){return typeof r.parentId=="number"}t.$tC=R;function n(r){return!!r.workspaceUri}t.$uC=n;function j(r){return!!r.folderUri}t.$vC=j;function k(r){return!!r.fileUri}t.$wC=k;function C(r){const l=$(r),e=r.getValue("window.menuBarVisibility");return e==="default"||l==="native"&&e==="compact"||S.$j&&S.$m?"classic":e}t.$xC=C;function $(r){if(S.$o)return"custom";const l=r.getValue("window");if(l){if(S.$j&&l.nativeTabs===!0||S.$j&&l.nativeFullScreen===!1)return"native";const d=l.titleBarStyle;if(d==="native"||d==="custom")return d}return S.$k?"native":"custom"}t.$yC=$;function v(r){return!(!S.$i||S.$o||$(r)==="native")}t.$zC=v;function y(r){const l=r.getValue("window");return!l||typeof l.nativeFullScreen!="boolean"||l.nativeTabs?!0:l.nativeFullScreen!==!1}t.$AC=y;function O(r=0){return Math.pow(1.2,r)}t.$BC=O}),define(ge[145],me([1,0,16,3,21,30,144]),function(ne,t,S,R,n,j,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$90b=t.$80b=t.$70b=void 0;function C(O){for(const{window:r}of(0,R.getWindows)())$(r)?.webFrame?.setZoomLevel(O);(0,S.$OO)((0,k.$BC)(O)),(0,S.$LO)(O)}t.$70b=C;function $(O){if(O===n.$FO)return{ipcRenderer:j.$O,webFrame:j.$Q};{const r=O;if(r?.vscode?.ipcRenderer&&r?.vscode?.webFrame)return r.vscode}}function v(){C((0,S.$MO)()+1)}t.$80b=v;function y(){C((0,S.$MO)()-1)}t.$90b=y}),define(ge[146],me([1,0,11,3,132,9,90,30,136,137,139,140,143,145,14,21,103,94]),function(ne,t,S,R,n,j,k,C,$,v,y,O,r,l,e,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const d=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,p=/\s--inspect-port=(?<port>\d+)/;class o{getHeight(F){return 22}getTemplateId(F){return w(F)?"process":B(F)?"machine":(0,$.$Cm)(F)?"error":L(F)?"header":""}}class a{hasChildren(F){return(0,$.$Cm)(F)?!1:w(F)?!!F.children?.length:!0}getChildren(F){return w(F)?F.children?F.children:[]:(0,$.$Cm)(F)?[]:L(F)?F.processRoots.length>1?F.processRoots:[F.processRoots[0].rootProcess]:B(F)?[F.rootProcess]:[F.processes]}}class E{constructor(){this.templateId="header"}renderTemplate(F){const I=(0,R.$_P)(F,(0,R.$)(".row")),z=(0,R.$_P)(I,(0,R.$)(".nameLabel")),X=(0,R.$_P)(I,(0,R.$)(".cpu")),G=(0,R.$_P)(I,(0,R.$)(".memory")),re=(0,R.$_P)(I,(0,R.$)(".pid"));return{name:z,CPU:X,memory:G,PID:re}}renderElement(F,I,z,X){z.name.textContent=(0,S.localize)(0,null),z.CPU.textContent=(0,S.localize)(1,null),z.PID.textContent=(0,S.localize)(2,null),z.memory.textContent=(0,S.localize)(3,null)}disposeTemplate(F){}}class m{constructor(){this.templateId="machine"}renderTemplate(F){const I=Object.create(null),z=(0,R.$_P)(F,(0,R.$)(".row"));return I.name=(0,R.$_P)(z,(0,R.$)(".nameLabel")),I}renderElement(F,I,z,X){z.name.textContent=F.element.name}disposeTemplate(F){}}class f{constructor(){this.templateId="error"}renderTemplate(F){const I=Object.create(null),z=(0,R.$_P)(F,(0,R.$)(".row"));return I.name=(0,R.$_P)(z,(0,R.$)(".nameLabel")),I}renderElement(F,I,z,X){z.name.textContent=F.element.errorMessage}disposeTemplate(F){}}class N{constructor(F,I,z){this.a=F,this.b=I,this.c=z,this.templateId="process"}renderTemplate(F){const I=(0,R.$_P)(F,(0,R.$)(".row")),z=(0,R.$_P)(I,(0,R.$)(".nameLabel")),X=(0,R.$_P)(I,(0,R.$)(".cpu")),G=(0,R.$_P)(I,(0,R.$)(".memory")),re=(0,R.$_P)(I,(0,R.$)(".pid"));return{name:z,CPU:X,PID:re,memory:G}}renderElement(F,I,z,X){const{element:G}=F,re=G.pid.toFixed(0);let ie=G.name;this.c.has(G.pid)&&(ie=this.c.get(G.pid)),z.name.textContent=ie,z.name.title=G.cmd,z.CPU.textContent=G.load.toFixed(0),z.PID.textContent=re,z.PID.parentElement.id=`pid-${re}`;const te=this.a==="win32"?G.mem:this.b*(G.mem/100);z.memory.textContent=(te/v.$Rk.MB).toFixed(0)}disposeTemplate(F){}}function B(V){return!!V.name&&!!V.rootProcess}function L(V){return!!V.processRoots}function w(V){return!!V.pid}class P{constructor(F,I){this.f=I,this.b=new Map;const z=new y.$10b(F);this.c=new O.$50b(F,z),this.k(I.styles),this.g(I),C.$O.on("vscode:pidToNameResponse",(X,G)=>{this.b=new Map;for(const[re,ie]of G)this.b.set(re,ie)}),C.$O.on("vscode:listProcessesResponse",async(X,G)=>{G.forEach((re,ie)=>{w(re.rootProcess)&&(re.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:G}}),this.d.layout(c.$FO.innerHeight,c.$FO.innerWidth)):await this.h(G),this.m(0)}),this.a=Date.now(),C.$O.send("vscode:pidToNameRequest"),C.$O.send("vscode:listProcesses")}g(F){c.$FO.document.onkeydown=I=>{const z=F.platform==="darwin"?I.metaKey:I.ctrlKey;z&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),C.$O.send("vscode:closeProcessExplorer")),z&&I.keyCode===187&&(0,l.$80b)(),z&&I.keyCode===189&&(0,l.$90b)()}}async h(F){const I=c.$FO.document.getElementById("process-list");if(!I)return;const{totalmem:z}=await this.c.getOSStatistics(),X=[new N(this.f.platform,z,this.b),new E,new m,new f];this.d=new n.$AT("processExplorer",I,new o,X,new a,{identityProvider:{getId:G=>w(G)?G.pid.toString():(0,$.$Cm)(G)?G.hostName:L(G)?"processes":B(G)?G.name:"header"}}),this.d.setInput({processes:{processRoots:F}}),this.d.layout(c.$FO.innerHeight,c.$FO.innerWidth),this.d.onKeyDown(G=>{const re=new e.$0O(G);if(re.keyCode===35&&re.altKey){const ie=this.n();Promise.all(ie.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(G=>{w(G.element)&&this.l(G.element,!0)}),I.style.height=`${c.$FO.innerHeight}px`,c.$FO.addEventListener("resize",()=>{I.style.height=`${c.$FO.innerHeight}px`,this.d?.layout(c.$FO.innerHeight,c.$FO.innerWidth)})}i(F){const I=d.exec(F);return I&&I.groups.port!=="0"||F.indexOf("node ")>=0||F.indexOf("node.exe")>=0}j(F){const I={type:"node",request:"attach",name:`process ${F.pid}`};let z=d.exec(F.cmd);z?I.port=Number(z.groups.port):I.processId=String(F.pid),z=p.exec(F.cmd),z&&(I.port=Number(z.groups.port)),C.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(F){const I=(0,R.$UP)(),z=[];F.listFocusBackground&&(z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${F.listFocusBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${F.listFocusBackground}; }`)),F.listFocusForeground&&z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${F.listFocusForeground}; }`),F.listActiveSelectionBackground&&(z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${F.listActiveSelectionBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${F.listActiveSelectionBackground}; }`)),F.listActiveSelectionForeground&&z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${F.listActiveSelectionForeground}; }`),F.listHoverBackground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${F.listHoverBackground}; }`),F.listHoverForeground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${F.listHoverForeground}; }`),F.listFocusOutline&&z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }`),F.listHoverOutline&&z.push(`.monaco-list-row:hover { outline: 1px dashed ${F.listHoverOutline}; outline-offset: -1px; }`),F.scrollbarShadowColor&&z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${F.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),F.scrollbarSliderBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${F.scrollbarSliderBackgroundColor};
				}
			`),F.scrollbarSliderHoverBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${F.scrollbarSliderHoverBackgroundColor};
				}
			`),F.scrollbarSliderActiveBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${F.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=z.join(`
`),F.color&&(c.$FO.document.body.style.color=F.color)}l(F,I){const z=[],X=Number(F.pid);I&&(z.push({accelerator:"Alt+E",label:(0,S.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),z.push({label:(0,S.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),z.push({type:"separator"})),z.push({label:(0,S.localize)(6,null),click:()=>{const G=this.n();G?.includes(X)||(G.length=0,G.push(X));const re=G?.map(ie=>c.$FO.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(re){const ie=re.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(ie.join(`
`))}}}),z.push({label:(0,S.localize)(7,null),click:()=>{const G=c.$FO.document.getElementById("process-list");G&&this.c.writeClipboardText(G.innerText)}}),F&&I&&this.i(F.cmd)&&(z.push({type:"separator"}),z.push({label:(0,S.localize)(8,null),click:()=>{this.j(F)}})),(0,k.$_T)(z)}m(F){setTimeout(()=>{const I=Date.now(),z=F+I-this.a;this.a=I,z>1e3?(C.$O.send("vscode:pidToNameRequest"),C.$O.send("vscode:listProcesses")):this.m(z)},200)}n(){return this.d?.getSelection()?.map(F=>{if(!(!F||!("pid"in F)))return F.pid}).filter(F=>!!F)}}function M(){const V=(0,R.$UP)();V.id="codiconStyles";const F=(0,r.$rEb)(void 0);function I(){V.textContent=F.getCSS()}const z=new j.$ah(I,0);F.onDidChange(()=>z.schedule()),z.schedule()}function U(V){const F=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";c.$FO.document.body.classList.add(F),M(),(0,l.$70b)(V.data.zoomLevel),new P(V.windowId,V.data)}t.startup=U})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f6b7ba78b8850751f083306b8f5d745c8a0ddcf/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
