/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],L=0,R=G.length;L<R;L++)e[L]=te[G[L]];return e};define(te[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const D=new Map,A=new Map,N=new Map,b=new Map;function h(f,E){f.has(E.detail)||f.set(E.detail,-E.timestamp)}function c(f,E){const v=f.get(E.detail);v&&(v>=0||f.set(E.detail,v+E.timestamp))}let P=[];typeof G=="function"&&typeof G.getStats=="function"&&(P=G.getStats().slice(0).sort((f,E)=>f.timestamp-E.timestamp));for(const f of P)switch(f.type){case 10:h(D,f);break;case 11:case 12:c(D,f);break;case 21:h(A,f);break;case 22:c(A,f);break;case 33:h(N,f);break;case 34:c(N,f);break;case 31:h(b,f);break;case 32:c(b,f);break}let I=0;N.forEach(f=>I+=f);function d(f){const E=[];return f.forEach((v,$)=>E.push([$,v])),E}return{amdLoad:d(D),amdInvoke:d(A),nodeRequire:d(N),nodeEval:d(b),nodeRequireTotal:I}}static toMarkdownTable(D,A){let N="";const b=[];return D.forEach((h,c)=>{b[c]=h.length}),A.forEach(h=>{h.forEach((c,P)=>{typeof c>"u"&&(c=h[P]="-");const I=c.toString().length;b[P]=Math.max(I,b[P])})}),D.forEach((h,c)=>{N+=`| ${h+" ".repeat(b[c]-h.toString().length)} `}),N+=`|
`,D.forEach((h,c)=>{N+=`| ${"-".repeat(b[c])} `}),N+=`|
`,A.forEach(h=>{h.forEach((c,P)=>{typeof c<"u"&&(N+=`| ${c+" ".repeat(b[P]-c.toString().length)} `)}),N+=`|
`}),N}}e.$U=L}),define(te[52],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function L(N){return(b,h,c)=>{let P=null,I=null;if(typeof c.value=="function"?(P="value",I=c.value):typeof c.get=="function"&&(P="get",I=c.get),!I)throw new Error("not supported");c[P]=N(I,h)}}function R(N,b,h){let c=null,P=null;if(typeof h.value=="function"?(c="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",P=h.get),!P)throw new Error("not supported");const I=`$memoize$${b}`;h[c]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[I]}}e.$sh=R;function D(N,b,h){return L((c,P)=>{const I=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[I]),b&&(this[d]=b(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},N)}})}e.$th=D;function A(N,b,h){return L((c,P)=>{const I=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,E=`$throttle$pending$${P}`;return function(...v){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),b&&(this[d]=b(this[d],...v)),this[E])return;const $=this[f]+N;$<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},$-Date.now()))}})}e.$uh=A}),define(te[71],ne([0,1,9]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function R(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function D(h,c="Unreachable"){throw new Error(c)}e.$5c=D;function A(h){if(!h)throw new L.$cb("Assertion Failed")}e.$6c=A;function N(h){if(!h()){debugger;h(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$7c=N;function b(h,c){let P=0;for(;P<h.length-1;){const I=h[P],d=h[P+1];if(!c(I,d))return!1;P++}return!0}e.$8c=b}),define(te[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var R;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(s,o=!1){let t=0;const i=s.length;let n="",r=0,u=16,k=0;function S(se){let ue=0,ce=0;for(;ue<se;){const oe=s.charCodeAt(t);if(oe>=48&&oe<=57)ce=ce*16+oe-48;else if(oe>=65&&oe<=70)ce=ce*16+oe-65+10;else if(oe>=97&&oe<=102)ce=ce*16+oe-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function w(se){t=se,n="",r=0,u=16,k=0}function O(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else k=3;return s.substring(se,ue)}function H(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=S(4);q>=0?se+=String.fromCharCode(q):k=4;break}default:k=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),k=2;break}else k=6;t++}return se}function ee(){if(n="",k=0,r=t,t>=i)return r=i,u=17;let se=s.charCodeAt(t);if(b(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(b(se));return u=15}if(h(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),u=14;switch(se){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,n=H(),u=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ue,t),u=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let oe=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,oe=!0;break}t++}return oe||(t++,k=1),n=s.substring(ue,t),u=13}return n+=String.fromCharCode(se),t++,u=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),u=11;default:for(;t<i&&_(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return n+=String.fromCharCode(se),t++,u=16}}function _(se){if(b(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=ee();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:o?re:ee,getToken:()=>u,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$6m=N;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function I(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function k(S,w,O,H){r.value=S,r.offset=w,r.length=O,r.type=H,r.colonOffset=void 0,n=r}try{j(s,{onObjectBegin:(S,w)=>{if(o<=S)throw i;n=void 0,u=o>S,t.push("")},onObjectProperty:(S,w,O)=>{if(o<w||(k(S,w,O,"property"),t[t.length-1]=S,o<=w+O))throw i},onObjectEnd:(S,w)=>{if(o<=S)throw i;n=void 0,t.pop()},onArrayBegin:(S,w)=>{if(o<=S)throw i;n=void 0,t.push(0)},onArrayEnd:(S,w)=>{if(o<=S)throw i;n=void 0,t.pop()},onLiteralValue:(S,w,O)=>{if(o<w||(k(S,w,O,y(S)),o<=w+O))throw i},onSeparator:(S,w,O)=>{if(o<=w)throw i;if(S===":"&&n&&n.type==="property")n.colonOffset=w,u=!1,n=void 0;else if(S===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(u=!0,t[t.length-1]=""),n=void 0}}})}catch(S){if(S!==i)throw S}return{path:t,previousNode:n,isAtPropertyKey:u,matches:S=>{let w=0;for(let O=0;w<S.length&&O<t.length;O++)if(S[w]===t[O]||S[w]==="*")w++;else if(S[w]!=="**")return!1;return w===S.length}}}e.$7m=I;function d(s,o=[],t=A.DEFAULT){let i=null,n=[];const r=[];function u(S){Array.isArray(n)?n.push(S):i!==null&&(n[i]=S)}return j(s,{onObjectBegin:()=>{const S={};u(S),r.push(n),n=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const S=[];u(S),r.push(n),n=S,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:u,onError:(S,w,O)=>{o.push({error:S,offset:w,length:O})}},t),n[0]}e.$8m=d;function f(s,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function r(S){return i.children.push(S),S}j(s,{onObjectBegin:S=>{i=r({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,w,O)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:w,length:O,parent:i})},onObjectEnd:(S,w)=>{i.length=S+w-i.offset,i=i.parent,n(S+w)},onArrayBegin:(S,w)=>{i=r({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,w)=>{i.length=S+w-i.offset,i=i.parent,n(S+w)},onLiteralValue:(S,w,O)=>{r({type:y(S),offset:w,length:O,parent:i,value:S}),n(w+O)},onSeparator:(S,w,O)=>{i.type==="property"&&(S===":"?i.colonOffset=w:S===","&&n(w))},onError:(S,w,O)=>{o.push({error:S,offset:w,length:O})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$9m=f;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$0m=E;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$$m=v;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$_m=$;function l(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$an=l;function p(s,o,t=!1){if(l(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=p(i[n],o,t);if(r)return r}return s}}e.$bn=p;function j(s,o,t=A.DEFAULT){const i=N(s,!1);function n(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Y){return Y?Q=>Y(Q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=n(o.onObjectBegin),k=r(o.onObjectProperty),S=n(o.onObjectEnd),w=n(o.onArrayBegin),O=n(o.onArrayEnd),H=r(o.onLiteralValue),ee=r(o.onSeparator),_=n(o.onComment),re=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:se||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Y){case 12:case 13:se?oe(10):_();break;case 16:oe(1);break;case 15:case 14:break;default:return Y}}}function oe(Y,Q=[],F=[]){if(re(Y),Q.length+F.length>0){let C=i.getToken();for(;C!==17;){if(Q.indexOf(C)!==-1){ce();break}else if(F.indexOf(C)!==-1)break;C=ce()}}}function q(Y){const Q=i.getTokenValue();return Y?H(Q):k(Q),ce(),!0}function K(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(oe(2),Y=0)}catch{oe(2)}H(Y);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(ee(":"),ce(),J()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function M(){u(),ce();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||oe(4,[],[]),ee(","),ce(),i.getToken()===2&&ue)break}else Y&&oe(6,[],[]);T()||oe(4,[],[2,5]),Y=!0}return S(),i.getToken()!==2?oe(7,[2],[]):ce(),!0}function B(){w(),ce();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||oe(4,[],[]),ee(","),ce(),i.getToken()===4&&ue)break}else Y&&oe(6,[],[]);J()||oe(4,[],[4,5]),Y=!0}return O(),i.getToken()!==4?oe(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return B();case 1:return M();case 10:return q(!0);default:return K()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(oe(4,[],[]),!1):J()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$cn=j;function g(s,o){const t=N(s),i=[];let n,r=0,u;do switch(u=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==u&&i.push(s.substring(r,u)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$dn=g;function y(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$en=y}),define(te[72],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.rot=e.$Zl=void 0;function L(b,h,c){return Math.min(Math.max(b,h),c)}e.$Zl=L;function R(b,h){return(h+b%h)%h}e.rot=R;class D{constructor(){this.a=0}getNext(){return this.a++}}e.$2l=D;class A{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$3l=A;class N{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$4l=N}),function(){function G(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function N(h){A.push(h,Date.now())}function b(){const h=[];for(let c=0;c<A.length;c+=2)h.push({name:A[c],startTime:A[c+1]});return h}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(D+N.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function L(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=L(R))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var R in L)(typeof exports=="object"?exports:G)[R]=L[R]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function L(R){if(e[R])return e[R].exports;var D=e[R]={i:R,l:!1,exports:{}};return G[R].call(D.exports,D,D.exports,L),D.l=!0,D.exports}return L.m=G,L.c=e,L.d=function(R,D,A){L.o(R,D)||Object.defineProperty(R,D,{enumerable:!0,get:A})},L.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},L.t=function(R,D){if(1&D&&(R=L(R)),8&D||4&D&&typeof R=="object"&&R&&R.__esModule)return R;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:R}),2&D&&typeof R!="string")for(var N in R)L.d(A,N,function(b){return R[b]}.bind(null,N));return A},L.n=function(R){var D=R&&R.__esModule?function(){return R.default}:function(){return R};return L.d(D,"a",D),D},L.o=function(R,D){return Object.prototype.hasOwnProperty.call(R,D)},L.p="",L(L.s=0)}([function(G,e,L){(function(R){var D;e=G.exports=F,D=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],h=e.src=[],c=0,P=c++;h[P]="0|[1-9]\\d*";var I=c++;h[I]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[P]+")\\.("+h[P]+")\\.("+h[P]+")";var E=c++;h[E]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var v=c++;h[v]="(?:"+h[P]+"|"+h[d]+")";var $=c++;h[$]="(?:"+h[I]+"|"+h[d]+")";var l=c++;h[l]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var p=c++;h[p]="(?:-?("+h[$]+"(?:\\."+h[$]+")*))";var j=c++;h[j]="[0-9A-Za-z-]+";var g=c++;h[g]="(?:\\+("+h[j]+"(?:\\."+h[j]+")*))";var y=c++,s="v?"+h[f]+h[l]+"?"+h[g]+"?";h[y]="^"+s+"$";var o="[v=\\s]*"+h[E]+h[p]+"?"+h[g]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[I]+"|x|X|\\*";var r=c++;h[r]=h[P]+"|x|X|\\*";var u=c++;h[u]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[l]+")?"+h[g]+"?)?)?";var k=c++;h[k]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[p]+")?"+h[g]+"?)?)?";var S=c++;h[S]="^"+h[i]+"\\s*"+h[u]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[k]+"$";var O=c++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;h[H]="(?:~>?)";var ee=c++;h[ee]="(\\s*)"+h[H]+"\\s+",b[ee]=new RegExp(h[ee],"g");var _=c++;h[_]="^"+h[H]+h[u]+"$";var re=c++;h[re]="^"+h[H]+h[k]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",b[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[u]+"$";var oe=c++;h[oe]="^"+h[se]+h[k]+"$";var q=c++;h[q]="^"+h[i]+"\\s*("+o+")$|^$";var K=c++;h[K]="^"+h[i]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[u]+")",b[T]=new RegExp(h[T],"g");var M=c++;h[M]="^\\s*("+h[u]+")\\s+-\\s+("+h[u]+")\\s*$";var B=c++;h[B]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var J=c++;h[J]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)D(Y,h[Y]),b[Y]||(b[Y]=new RegExp(h[Y]));function Q(V,Z){if(V instanceof F)return V;if(typeof V!="string"||V.length>A||!(Z?b[t]:b[y]).test(V))return null;try{return new F(V,Z)}catch{return null}}function F(V,Z){if(V instanceof F){if(V.loose===Z)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(V,Z);D("SemVer",V,Z),this.loose=Z;var x=V.trim().match(Z?b[t]:b[y]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<N)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=Q,e.valid=function(V,Z){var x=Q(V,Z);return x?x.version:null},e.clean=function(V,Z){var x=Q(V.trim().replace(/^[=v]+/,""),Z);return x?x.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return D("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Z=0;do{var x=this.prerelease[Z],$e=V.prerelease[Z];if(D("prerelease compare",Z,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++Z)},F.prototype.inc=function(V,Z){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Z,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new F(V,x).inc(Z,$e).version}catch{return null}},e.diff=function(V,Z){if(X(V,Z))return null;var x=Q(V),$e=Q(Z);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var C=/^[0-9]+$/;function a(V,Z){var x=C.test(V),$e=C.test(Z);return x&&$e&&(V=+V,Z=+Z),x&&!$e?-1:$e&&!x?1:V<Z?-1:V>Z?1:0}function m(V,Z,x){return new F(V,x).compare(new F(Z,x))}function z(V,Z,x){return m(V,Z,x)>0}function U(V,Z,x){return m(V,Z,x)<0}function X(V,Z,x){return m(V,Z,x)===0}function W(V,Z,x){return m(V,Z,x)!==0}function le(V,Z,x){return m(V,Z,x)>=0}function ae(V,Z,x){return m(V,Z,x)<=0}function me(V,Z,x,$e){var ye;switch(Z){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V!==x;break;case"":case"=":case"==":ye=X(V,x,$e);break;case"!=":ye=W(V,x,$e);break;case">":ye=z(V,x,$e);break;case">=":ye=le(V,x,$e);break;case"<":ye=U(V,x,$e);break;case"<=":ye=ae(V,x,$e);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function de(V,Z){if(V instanceof de){if(V.loose===Z)return V;V=V.value}if(!(this instanceof de))return new de(V,Z);D("comparator",V,Z),this.loose=Z,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(V,Z){return a(Z,V)},e.major=function(V,Z){return new F(V,Z).major},e.minor=function(V,Z){return new F(V,Z).minor},e.patch=function(V,Z){return new F(V,Z).patch},e.compare=m,e.compareLoose=function(V,Z){return m(V,Z,!0)},e.rcompare=function(V,Z,x){return m(Z,V,x)},e.sort=function(V,Z){return V.sort(function(x,$e){return e.compare(x,$e,Z)})},e.rsort=function(V,Z){return V.sort(function(x,$e){return e.rcompare(x,$e,Z)})},e.gt=z,e.lt=U,e.eq=X,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Z){if(V instanceof fe)return V.loose===Z?V:new fe(V.raw,Z);if(V instanceof de)return new fe(V.value,Z);if(!(this instanceof fe))return new fe(V,Z);if(this.loose=Z,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Z,x,$e,ye,De,Se,Le,Ie,Ne,Me,je,Re){return((Z=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+Z)+" "+(Le=he(Ie)?"":he(Ne)?"<"+(+Ie+1)+".0.0":he(Me)?"<"+Ie+"."+(+Ne+1)+".0":je?"<="+Ie+"."+Ne+"."+Me+"-"+je:"<="+Le)).trim()}function be(V,Z){for(var x=0;x<V.length;x++)if(!V[x].test(Z))return!1;if(Z.prerelease.length){for(x=0;x<V.length;x++)if(D(V[x].semver),V[x].semver!==ge&&V[x].semver.prerelease.length>0){var $e=V[x].semver;if($e.major===Z.major&&$e.minor===Z.minor&&$e.patch===Z.patch)return!0}return!1}return!0}function ke(V,Z,x){try{Z=new fe(Z,x)}catch{return!1}return Z.test(V)}function Fe(V,Z,x,$e){var ye,De,Se,Le,Ie;switch(V=new F(V,$e),Z=new fe(Z,$e),x){case">":ye=z,De=ae,Se=U,Le=">",Ie=">=";break;case"<":ye=U,De=le,Se=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Z,$e))return!1;for(var Ne=0;Ne<Z.set.length;++Ne){var Me=Z.set[Ne],je=null,Re=null;if(Me.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),je=je||ze,Re=Re||ze,ye(ze.semver,je.semver,$e)?je=ze:Se(ze.semver,Re.semver,$e)&&(Re=ze)}),je.operator===Le||je.operator===Ie||(!Re.operator||Re.operator===Le)&&De(V,Re.semver)||Re.operator===Ie&&Se(V,Re.semver))return!1}return!0}de.prototype.parse=function(V){var Z=this.loose?b[q]:b[K],x=V.match(Z);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new F(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return D("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new F(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Z){if(!(V instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(V.value,Z),ke(this.value,x,Z);if(V.operator==="")return x=new fe(this.value,Z),ke(V.semver,x,Z);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Z)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||De&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Z=this.loose;V=V.trim(),D("range",V,Z);var x=Z?b[B]:b[M];V=V.replace(x,we),D("hyphen replace",V),V=V.replace(b[T],"$1$2$3"),D("comparator trim",V,b[T]),V=(V=(V=V.replace(b[ee],"$1~")).replace(b[ue],"$1^")).split(/\s+/).join(" ");var $e=Z?b[q]:b[K],ye=V.split(" ").map(function(De){return function(Se,Le){return D("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Me){return function(je,Re){D("caret",je,Re);var ze=Re?b[oe]:b[ce];return je.replace(ze,function(Ae,ve,Ee,Pe,Oe){var Ce;return D("caret",je,Ae,ve,Ee,Pe,Oe),he(ve)?Ce="":he(Ee)?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Ce=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ce=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Oe+" <"+(+ve+1)+".0.0"):(D("no pr"),Ce=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),D("caret return",Ce),Ce})}(Me,Ne)}).join(" ")}(Se,Le),D("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Me){return function(je,Re){var ze=Re?b[re]:b[_];return je.replace(ze,function(Ae,ve,Ee,Pe,Oe){var Ce;return D("tilde",je,Ae,ve,Ee,Pe,Oe),he(ve)?Ce="":he(Ee)?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?Ce=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ce=">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0"):Ce=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",D("tilde return",Ce),Ce})}(Me,Ne)}).join(" ")}(Se,Le),D("tildes",Se),Se=function(Ie,Ne){return D("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Me){return function(je,Re){je=je.trim();var ze=Re?b[w]:b[S];return je.replace(ze,function(Ae,ve,Ee,Pe,Oe,Ce){D("xRange",je,Ae,ve,Ee,Pe,Oe,Ce);var qe=he(Ee),Ue=qe||he(Pe),Te=Ue||he(Oe);return ve==="="&&Te&&(ve=""),qe?Ae=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ue&&(Pe=0),Te&&(Oe=0),ve===">"?(ve=">=",Ue?(Ee=+Ee+1,Pe=0,Oe=0):Te&&(Pe=+Pe+1,Oe=0)):ve==="<="&&(ve="<",Ue?Ee=+Ee+1:Pe=+Pe+1),Ae=ve+Ee+"."+Pe+"."+Oe):Ue?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ae=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),D("xRange return",Ae),Ae})}(Me,Ne)}).join(" ")}(Se,Le),D("xrange",Se),Se=function(Ie,Ne){return D("replaceStars",Ie,Ne),Ie.trim().replace(b[J],"")}(Se,Le),D("stars",Se),Se}(De,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match($e)})),ye=ye.map(function(De){return new de(De,Z)})},fe.prototype.intersects=function(V,Z){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return V.set.some(function(ye){return ye.every(function(De){return $e.intersects(De,Z)})})})})},e.toComparators=function(V,Z){return new fe(V,Z).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var Z=0;Z<this.set.length;Z++)if(be(this.set[Z],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Z,x){var $e=null,ye=null;try{var De=new fe(Z,x)}catch{return null}return V.forEach(function(Se){De.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new F($e=Se,x)))}),$e},e.minSatisfying=function(V,Z,x){var $e=null,ye=null;try{var De=new fe(Z,x)}catch{return null}return V.forEach(function(Se){De.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new F($e=Se,x)))}),$e},e.validRange=function(V,Z){try{return new fe(V,Z).range||"*"}catch{return null}},e.ltr=function(V,Z,x){return Fe(V,Z,"<",x)},e.gtr=function(V,Z,x){return Fe(V,Z,">",x)},e.outside=Fe,e.prerelease=function(V,Z){var x=Q(V,Z);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,Z,x){return V=new fe(V,x),Z=new fe(Z,x),V.intersects(Z)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var Z=V.match(b[O]);return Z==null?null:Q((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,L(1))},function(G,e){var L,R,D=G.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{R=typeof clearTimeout=="function"?clearTimeout:N}catch{R=N}})();var h,c=[],P=!1,I=-1;function d(){P&&h&&(P=!1,h.length?c=h.concat(c):I=-1,c.length&&f())}function f(){if(!P){var $=b(d);P=!0;for(var l=c.length;l;){for(h=c,c=[];++I<l;)h&&h[I].run();I=-1,l=c.length}h=null,P=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===N||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}($)}}function E($,l){this.fun=$,this.array=l}function v(){}D.nextTick=function($){var l=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)l[p-1]=arguments[p];c.push(new E($,l)),c.length!==1||P||b(f)},E.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=v,D.addListener=v,D.once=v,D.off=v,D.removeListener=v,D.removeAllListeners=v,D.emit=v,D.prependListener=v,D.prependOnceListener=v,D.listeners=function($){return[]},D.binding=function($){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function($){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(G,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;class R{constructor(b,h,c){this.level=b,this.key=h,this.value=c,this.forward=[]}}const D=void 0;class A{constructor(b,h=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new R(this.c,D,D)}get size(){return this.f}clear(){this.e=new R(this.c,D,D),this.f=0}has(b){return!!A.g(this,b,this.comparator)}get(b){return A.g(this,b,this.comparator)?.value}set(b,h){return A.h(this,b,h,this.comparator)&&(this.f+=1),this}delete(b){const h=A.k(this,b,this.comparator);return h&&(this.f-=1),h}forEach(b,h){let c=this.e.forward[0];for(;c;)b.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",h=this.e.forward[0];for(;h;)b+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return b}static g(b,h,c){let P=b.e;for(let I=b.d-1;I>=0;I--)for(;P.forward[I]&&c(P.forward[I].key,h)<0;)P=P.forward[I];if(P=P.forward[0],P&&c(P.key,h)===0)return P}static h(b,h,c,P){const I=[];let d=b.e;for(let f=b.d-1;f>=0;f--){for(;d.forward[f]&&P(d.forward[f].key,h)<0;)d=d.forward[f];I[f]=d}if(d=d.forward[0],d&&P(d.key,h)===0)return d.value=c,!1;{const f=A.j(b);if(f>b.d){for(let E=b.d;E<f;E++)I[E]=b.e;b.d=f}d=new R(f,h,c);for(let E=0;E<f;E++)d.forward[E]=I[E].forward[E],I[E].forward[E]=d;return!0}}static j(b,h=.5){let c=1;for(;Math.random()<h&&c<b.c;)c+=1;return c}static k(b,h,c){const P=[];let I=b.e;for(let d=b.d-1;d>=0;d--){for(;I.forward[d]&&c(I.forward[d].key,h)<0;)I=I.forward[d];P[d]=I}if(I=I.forward[0],!I||c(I.key,h)!==0)return!1;for(let d=0;d<b.d&&P[d].forward[d]===I;d++)P[d].forward[d]=I.forward[d];for(;b.d>0&&b.e.forward[b.d-1]===D;)b.d-=1;return!0}}e.$Jr=A}),define(te[45],ne([0,1,9,2]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function D(g){const y=g;return y?typeof y.read=="function":!1}e.$4d=D;function A(g){const y=g;return y?[y.on,y.pause,y.resume,y.destroy].every(s=>typeof s=="function"):!1}e.$5d=A;function N(g){const y=g;return y?A(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$6d=N;function b(g,y){return new h(g,y)}e.$7d=b;class h{constructor(y,s){this.e=y,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(s=>s(y))}h(y){this.c.error.length===0?(0,L.$1)(y):this.c.error.slice(0).forEach(s=>s(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,s){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(y,s){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,y){const s=[];let o;for(;(o=g.read())!==null;)s.push(o);return y(s)}e.$8d=c;function P(g,y,s){const o=[];let t;for(;(t=g.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}e.$9d=P;function I(g,y){return new Promise((s,o)=>{const t=[];d(g,{onData:i=>{y&&t.push(i)},onError:i=>{y?o(i):s(void 0)},onEnd:()=>{s(y?y(t):void 0)}})})}e.$0d=I;function d(g,y,s){g.on("error",o=>{s?.isCancellationRequested||y.onError(o)}),g.on("end",()=>{s?.isCancellationRequested||y.onEnd()}),g.on("data",o=>{s?.isCancellationRequested||y.onData(o)})}e.$$d=d;function f(g,y){return new Promise((s,o)=>{const t=new R.$Rc,i=[],n=k=>{if(i.push(k),i.length>y)return t.dispose(),g.pause(),s({stream:g,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),u=()=>(t.dispose(),s({stream:g,buffer:i,ended:!0}));t.add((0,R.$Qc)(()=>g.removeListener("error",r))),g.on("error",r),t.add((0,R.$Qc)(()=>g.removeListener("end",u))),g.on("end",u),t.add((0,R.$Qc)(()=>g.removeListener("data",n))),g.on("data",n)})}e.$_d=f;function E(g,y){const s=b(y);return s.end(g),s}e.$ae=E;function v(){const g=b(()=>{throw new Error("not supported")});return g.end(),g}e.$be=v;function $(g){let y=!1;return{read:()=>y?null:(y=!0,g)}}e.$ce=$;function l(g,y,s){const o=b(s);return d(g,{onData:t=>o.write(y.data(t)),onError:t=>o.error(y.error?y.error(t):t),onEnd:()=>o.end()}),o}e.$de=l;function p(g,y,s){let o=!1;return{read:()=>{const t=y.read();return o?t:(o=!0,t!==null?s([g,t]):g)}}}e.$ee=p;function j(g,y,s){let o=!1;const t=b(s);return d(y,{onData:i=>o?t.write(i):(o=!0,t.write(s([g,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(g)),t.end()}}),t}e.$fe=j}),define(te[14],ne([0,1,164,45]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const D=typeof Buffer<"u",A=new L.$V(()=>new Uint8Array(256));let N,b;class h{static alloc(O){return D?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return D&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,H){return!(H?.dontUseNodeBuffer||!1)&&D?new h(Buffer.from(O)):(N||(N=new TextEncoder),new h(N.encode(O)))}static fromByteArray(O){const H=h.alloc(O.length);for(let ee=0,_=O.length;ee<_;ee++)H.buffer[ee]=O[ee];return H}static concat(O,H){if(typeof H>"u"){H=0;for(let re=0,se=O.length;re<se;re++)H+=O[re].byteLength}const ee=h.alloc(H);let _=0;for(let re=0,se=O.length;re<se;re++){const ue=O[re];ee.set(ue,_),_+=ue.byteLength}return ee}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return D?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(O,H){return new h(this.buffer.subarray(O,H))}set(O,H){if(O instanceof h)this.buffer.set(O.buffer,H);else if(O instanceof Uint8Array)this.buffer.set(O,H);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),H);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return d(this.buffer,O)}writeUInt32BE(O,H){f(this.buffer,O,H)}readUInt32LE(O){return E(this.buffer,O)}writeUInt32LE(O,H){v(this.buffer,O,H)}readUInt8(O){return $(this.buffer,O)}writeUInt8(O,H){l(this.buffer,O,H)}indexOf(O,H=0){return c(this.buffer,O instanceof h?O.buffer:O,H)}}e.$ge=h;function c(w,O,H=0){const ee=O.byteLength,_=w.byteLength;if(ee===0)return 0;if(ee===1)return w.indexOf(O[0]);if(ee>_-H)return-1;const re=A.value;re.fill(O.length);for(let oe=0;oe<O.length;oe++)re[O[oe]]=O.length-oe-1;let se=H+O.length-1,ue=se,ce=-1;for(;se<_;)if(w[se]===O[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(O.length-ue,re[w[se]]),ue=O.length-1;return ce}e.$he=c;function P(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0}e.$ie=P;function I(w,O,H){w[H+0]=O&255,O=O>>>8,w[H+1]=O&255}e.$je=I;function d(w,O){return w[O]*2**24+w[O+1]*2**16+w[O+2]*2**8+w[O+3]}e.$ke=d;function f(w,O,H){w[H+3]=O,O=O>>>8,w[H+2]=O,O=O>>>8,w[H+1]=O,O=O>>>8,w[H]=O}e.$le=f;function E(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0|w[O+2]<<16>>>0|w[O+3]<<24>>>0}e.$me=E;function v(w,O,H){w[H+0]=O&255,O=O>>>8,w[H+1]=O&255,O=O>>>8,w[H+2]=O&255,O=O>>>8,w[H+3]=O&255}e.$ne=v;function $(w,O){return w[O]}e.$oe=$;function l(w,O,H){w[H]=O}e.$pe=l;function p(w){return R.$8d(w,O=>h.concat(O))}e.$qe=p;function j(w){return R.$ce(w)}e.$re=j;function g(w){return R.$0d(w,O=>h.concat(O))}e.$se=g;async function y(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await g(w.stream)])}e.$te=y;function s(w){return R.$ae(w,O=>h.concat(O))}e.$ue=s;function o(w){return R.$de(w,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}e.$ve=o;function t(w){return R.$7d(O=>h.concat(O),w)}e.$we=t;function i(w,O){return R.$ee(w,O,H=>h.concat(H))}e.$xe=i;function n(w,O){return R.$fe(w,O,H=>h.concat(H))}e.$ye=n;function r(w){let O=0,H=0,ee=0;const _=new Uint8Array(Math.floor(w.length/4*3)),re=ue=>{switch(H){case 3:_[ee++]=O|ue,H=0;break;case 2:_[ee++]=O|ue>>>2,O=ue<<6,H=3;break;case 1:_[ee++]=O|ue>>>4,O=ue<<4,H=2;break;default:O=ue<<2,H=1}};for(let ue=0;ue<w.length;ue++){const ce=w.charCodeAt(ue);if(ce>=65&&ce<=90)re(ce-65);else if(ce>=97&&ce<=122)re(ce-97+26);else if(ce>=48&&ce<=57)re(ce-48+52);else if(ce===43||ce===45)re(62);else if(ce===47||ce===95)re(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ue]}`)}}const se=ee;for(;H>0;)re(0);return h.wrap(_).slice(0,se)}e.$ze=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:w},O=!0,H=!1){const ee=H?k:u;let _="";const re=w.byteLength%3;let se=0;for(;se<w.byteLength-re;se+=3){const ue=w[se+0],ce=w[se+1],oe=w[se+2];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[(ce<<2|oe>>>6)&63],_+=ee[oe&63]}if(re===1){const ue=w[se+0];_+=ee[ue>>>2],_+=ee[ue<<4&63],O&&(_+="==")}else if(re===2){const ue=w[se+0],ce=w[se+1];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[ce<<2&63],O&&(_+="=")}return _}e.$Ae=S}),define(te[41],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=void 0;function R(l){return D(l,0)}e.$Oi=R;function D(l,p){switch(typeof l){case"object":return l===null?A(349,p):Array.isArray(l)?h(l,p):c(l,p);case"string":return b(l,p);case"boolean":return N(l,p);case"number":return A(l,p);case"undefined":return A(937,p);default:return A(617,p)}}e.$Pi=D;function A(l,p){return(p<<5)-p+l|0}e.$Qi=A;function N(l,p){return A(l?433:863,p)}function b(l,p){p=A(149417,p);for(let j=0,g=l.length;j<g;j++)p=A(l.charCodeAt(j),p);return p}e.$Ri=b;function h(l,p){return p=A(104579,p),l.reduce((j,g)=>D(g,j),p)}function c(l,p){return p=A(181387,p),Object.keys(l).sort().reduce((j,g)=>(j=b(g,j),D(l[g],j)),p)}class P{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=D(p,this.g),this.g}}e.$Si=P;var I;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(l,p,j=32){const g=j-p,y=~((1<<g)-1);return(l<<p|(y&l)>>>g)>>>0}function f(l,p=0,j=l.byteLength,g=0){for(let y=0;y<j;y++)l[p+y]=g}function E(l,p,j="0"){for(;l.length<p;)l=j+l;return l}function v(l,p=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(j=>j.toString(16).padStart(2,"0")).join(""):E((l>>>0).toString(16),p/4)}e.$Ti=v;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const j=p.length;if(j===0)return;const g=this.p;let y=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=p.charCodeAt(0),t=0);;){let i=o;if(L.$$e(o))if(t+1<j){const n=p.charCodeAt(t+1);L.$_e(n)?(t++,i=L.$af(o,n)):i=65533}else{s=o;break}else L.$_e(o)&&(i=65533);if(y=this.w(g,y,i),t++,t<j)o=p.charCodeAt(t);else break}this.r=y,this.u=s}w(p,j,g){return g<128?p[j++]=g:g<2048?(p[j++]=192|(g&1984)>>>6,p[j++]=128|(g&63)>>>0):g<65536?(p[j++]=224|(g&61440)>>>12,p[j++]=128|(g&4032)>>>6,p[j++]=128|(g&63)>>>0):(p[j++]=240|(g&1835008)>>>18,p[j++]=128|(g&258048)>>>12,p[j++]=128|(g&4032)>>>6,p[j++]=128|(g&63)>>>0),j>=64&&(this.y(),j-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),j}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=$.g,j=this.q;for(let u=0;u<64;u+=4)p.setUint32(u,j.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,d(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let g=this.h,y=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let u=0;u<80;u++)u<20?(i=y&s|~y&o,n=1518500249):u<40?(i=y^s^o,n=1859775393):u<60?(i=y&s|y&o|s&o,n=2400959708):(i=y^s^o,n=3395469782),r=d(g,5)+i+t+n+p.getUint32(u*4,!1)&4294967295,t=o,o=s,s=d(y,30),y=g,g=r;this.h=this.h+g&4294967295,this.l=this.l+y&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Ui=$}),define(te[54],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const A="error",N="warning",b="warn",h="info",c="ignore";function P(d){return d?L.$7e(A,d)?D.Error:L.$7e(N,d)||L.$7e(b,d)?D.Warning:L.$7e(h,d)?D.Info:D.Ignore:D.Ignore}D.fromValue=P;function I(d){switch(d){case D.Error:return A;case D.Warning:return N;case D.Info:return h;default:return c}}D.toString=I}(R||(R={})),e.default=R}),define(te[30],ne([0,1,3]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=void 0;function R(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const p=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([j,g])=>{p[j]=g&&typeof g=="object"?R(g):g}),p}e.$fn=R;function D(l){if(!l||typeof l!="object")return l;const p=[l];for(;p.length>0;){const j=p.shift();Object.freeze(j);for(const g in j)if(A.call(j,g)){const y=j[g];typeof y=="object"&&!Object.isFrozen(y)&&!(0,L.$Gf)(y)&&p.push(y)}}return l}e.$gn=D;const A=Object.prototype.hasOwnProperty;function N(l,p){return b(l,p,new Set)}e.$hn=N;function b(l,p,j){if((0,L.$Mf)(l))return l;const g=p(l);if(typeof g<"u")return g;if(Array.isArray(l)){const y=[];for(const s of l)y.push(b(s,p,j));return y}if((0,L.$Ff)(l)){if(j.has(l))throw new Error("Cannot clone recursive data-structure");j.add(l);const y={};for(const s in l)A.call(l,s)&&(y[s]=b(l[s],p,j));return j.delete(l),y}return l}function h(l,p,j=!0){return(0,L.$Ff)(l)?((0,L.$Ff)(p)&&Object.keys(p).forEach(g=>{g in l?j&&((0,L.$Ff)(l[g])&&(0,L.$Ff)(p[g])?h(l[g],p[g],j):l[g]=p[g]):l[g]=p[g]}),l):p}e.$in=h;function c(l,p){if(l===p)return!0;if(l==null||p===null||p===void 0||typeof l!=typeof p||typeof l!="object"||Array.isArray(l)!==Array.isArray(p))return!1;let j,g;if(Array.isArray(l)){if(l.length!==p.length)return!1;for(j=0;j<l.length;j++)if(!c(l[j],p[j]))return!1}else{const y=[];for(g in l)y.push(g);y.sort();const s=[];for(g in p)s.push(g);if(s.sort(),!c(y,s))return!1;for(j=0;j<y.length;j++)if(!c(l[y[j]],p[y[j]]))return!1}return!0}e.$jn=c;function P(l){const p=new Set;return JSON.stringify(l,(j,g)=>{if((0,L.$Ff)(g)||Array.isArray(g)){if(p.has(g))return"[Circular]";p.add(g)}return g})}e.$kn=P;function I(l,p){const j=Object.create(null);return!l||!p||Object.keys(p).forEach(y=>{const s=l[y],o=p[y];c(s,o)||(j[y]=o)}),j}e.$ln=I;function d(l,p){const j=p.toLowerCase(),g=Object.keys(l).find(y=>y.toLowerCase()===j);return g?l[g]:l[p]}e.$mn=d;function f(l,p){const j=Object.create(null);for(const[g,y]of Object.entries(l))p(g,y)&&(j[g]=y);return j}e.$nn=f;function E(l){let p=[];for(;Object.prototype!==l;)p=p.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return p}e.$on=E;function v(l){const p=[];for(const j of E(l))typeof l[j]=="function"&&p.push(j);return p}e.$pn=v;function $(l,p){const j=y=>function(){const s=Array.prototype.slice.call(arguments,0);return p(y,s)},g={};for(const y of l)g[y]=j(y);return g}e.$qn=$}),define(te[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return L.test(D)}e.$kg=R,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(b){for(let h=0;h<b.length;h++)b[h]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,c="";return c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+="-",c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c+=N[A[h++]],c}}()}),define(te[74],ne([0,1,33]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(N){const b=N.replace(/\-/g,":").toLowerCase();return!R.has(b)}function A(){const N=(0,L.networkInterfaces)();for(const b in N){const h=N[b];if(h){for(const{mac:c}of h)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$2m=A}),define(te[75],ne([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=void 0;const R=60,D=R*60,A=D*24,N=A*7,b=A*30,h=A*365;function c(I,d,f,E){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!E&&v<30)return(0,L.localize)(1,null);let $;return v<R?($=v,d?$===1?f?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):f?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?f?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):f?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):v<D?($=Math.floor(v/R),d?$===1?f?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):f?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?f?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):f?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):v<A?($=Math.floor(v/D),d?$===1?f?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):f?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?f?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):f?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):v<N?($=Math.floor(v/A),d?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):v<b?($=Math.floor(v/N),d?$===1?f?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):f?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?f?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):f?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):v<h?($=Math.floor(v/b),d?$===1?f?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):f?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?f?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):f?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(v/h),d?$===1?f?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):f?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?f?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):f?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$om=c;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$pm=P}),define(te[77],ne([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function A(I,d){return d&&(I.stack||I.stacktrace)?D.localize(0,null,b(I),N(I.stack)||N(I.stacktrace)):b(I)}function N(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?D.localize(1,null,I.message):I.message||D.localize(2,null)}function h(I=null,d=!1){if(!I)return D.localize(3,null);if(Array.isArray(I)){const f=L.$Hb(I),E=h(f[0],d);return f.length>1?D.localize(4,null,E,f.length):E}if(R.$Df(I))return I;if(I.detail){const f=I.detail;if(f.error)return A(f.error,d);if(f.exception)return A(f.exception,d)}return I.stack?A(I,d):I.message?I.message:D.localize(5,null)}e.$Li=h;function c(I){const d=I;return d instanceof Error&&Array.isArray(d.actions)}e.$Mi=c;function P(I,d){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=d,f}e.$Ni=P}),define(te[78],ne([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;function R(D){switch(D){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Hp=R}),define(te[55],ne([0,1,13]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.TerminateResponseCode=e.Source=void 0;var R;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(R||(e.Source=R={}));var D;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(b,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<P.length;f++)if(d.search(P[f])!==-1){delete b[d];break}})}e.$Kl=A;function N(b){b&&(delete b.DEBUG,L.$j&&delete b.DYLD_LIBRARY_PATH,L.$k&&delete b.LD_PRELOAD)}e.$Ll=N}),define(te[80],ne([0,1,11]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$$p=e.$0p=e.$9p=void 0;function R(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$9p=R;function D(c){const P=[];let I;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),I=f.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:I}}e.$0p=D;function A(c){if(typeof c!="string")return A(D(c).stack);const P=c;if(P){const I=N(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$$p=A;function N(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function b(c,P){const{args:I,stack:d}=D(c),f=typeof I[0]=="string"&&I.length===1;let E=N(d);E&&(E=`(${E.trim()})`);let v=[];if(typeof I[0]=="string"?E&&f?v=[`%c[${P}] %c${I[0]} %c${E}`,h("blue"),h(""),h("grey")]:v=[`%c[${P}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:v=[`%c[${P}]%`,h("blue"),...I],E&&!f&&v.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=b;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function D(h){return JSON.stringify(h,N)}e.$vh=D;function A(h){let c=JSON.parse(h);return c=b(c),c}e.$wh=A;function N(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return R.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$ge||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let P=0;P<h.length;++P)h[P]=b(h[P],c+1);else for(const P in h)Object.hasOwnProperty.call(h,P)&&(h[P]=b(h[P],c+1))}return h}e.$xh=b}),define(te[81],ne([0,1,70,15,13,11]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=void 0;class N{constructor(d,f,E){this.id=d,this.dependencies=f,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,E)=>{typeof d!="string"&&(E=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new N(d,f,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,E)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const $=()=>{v.removeEventListener("load",l),v.removeEventListener("error",p)},l=j=>{$(),f(this.c.pop())},p=j=>{$(),E(j)};v.addEventListener("load",l),v.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),v.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(v)})}i(d){return new Promise((f,E)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(v){E(v)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(d).fsPath,l=f.readFileSync($).toString(),p=v.wrap(l.replace(/^#!.*/,""));return new E.Script(p).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function P(I,d,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const E=`${I}/${d}`;if(h.has(E))return h.get(E);let v;if(/^\w[\w\d+.-]*:\/\//.test(E))v=E;else{const j=`${f&&!D.$o?R.$gg:R.$fg}/${E}`;v=R.$jg.asBrowserUri(j).toString(!0)}const $=b.INSTANCE.load(v);return h.set(E,$),$}else return await new Promise((E,v)=>{G([I],E,v)})}e.$VC=P}),define(te[82],ne([0,1,33,47,28,74,13]),function(G,e,L,R,D,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=void 0,e.$3m=new class{c(d){return this.a||(this.a=R.$7h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const E=(0,L.networkInterfaces)();for(const v in E){const $=E[v];if($)for(const{mac:l,internal:p}of $)p||(f+=1,this.c(l.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let b;async function h(d){return b||(b=(async()=>await c(d)||D.$lg())()),b}e.$4m=h;async function c(d){try{const f=await new Promise((v,$)=>{G(["crypto"],v,$)}),E=(0,A.$2m)();return f.createHash("sha256").update(E,"utf8").digest("hex")}catch(f){d(f);return}}const P="Software\\Microsoft\\SQMClient";async function I(d){if(N.$i){const f=await new Promise((E,v)=>{G(["@vscode/windows-registry"],E,v)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(E){return d(E),""}}return""}e.$5m=I}),define(te[83],ne([0,1,33,16,24]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0;const A=/^\d+$/,N=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class I{constructor(y,s,o){this.exePath=y,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:g=!1,findPreview:y=!1}={}){const s=d({useAlternateBitness:g});if(!s)return null;const o=R.$jc(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const u of await D.Promises.readdir(o)){let k=-1;if(y){const w=u.indexOf("-");if(w<0)continue;const O=u.substring(0,w);if(!A.test(O)||u.substring(w+1)!=="preview")continue;k=parseInt(O,10)}else{if(!A.test(u))continue;k=parseInt(u,10)}if(k<=t)continue;const S=R.$jc(o,u,"pwsh.exe");await D.SymlinkSupport.existsFile(S)&&(i=S,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=y?" Preview":"";return new I(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const y=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=g?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(y))if(s.test(t)){const i=R.$jc(y,t,"pwsh.exe");return new I(i,o)}return null}function v(){const g=R.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new I(g,".NET Core PowerShell Global Tool")}function $(){const g=R.$jc(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(g,"Windows PowerShell",!0)}async function*l(){let g=await f();g&&(yield g),g=await f({useAlternateBitness:!0}),g&&(yield g),g=await E(),g&&(yield g),g=v(),g&&(yield g),g=await f({findPreview:!0}),g&&(yield g),g=await E({findPreview:!0}),g&&(yield g),g=await f({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=$(),g&&(yield g)}async function*p(){for await(const g of l())await g.exists()&&(yield g)}e.$Il=p;async function j(){for await(const g of p())return g;return null}e.$Jl=j}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(G,e,L,R,D,A,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Nl=e.$Ml=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(I=D.env){return I.comspec||"cmd.exe"}e.$Ml=h;function c(I){let d=[],f=!1;const E=function(v){if(f){d.push(v);return}(!I.send(v,l=>{if(l&&console.error(l),f=!1,d.length>0){const p=d.slice(0);d=[],p.forEach(j=>E(j))}})||R.$i)&&(f=!0)};return{send:E}}e.$Nl=c;var P;(function(I){async function d(f,E,v){if(L.$ic(f))return f;if(E===void 0&&(E=D.cwd()),L.$mc(f)!=="."||(v===void 0&&N.$Df(D.env.PATH)&&(v=D.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(E,f);async function l(p){if(await b.Promises.exists(p)){let j;try{j=await b.Promises.stat(p)}catch(g){g.message.startsWith("EACCES")&&(j=await b.Promises.lstat(p))}return j?!j.isDirectory():!1}return!1}for(const p of v){let j;if(L.$ic(p)?j=L.$jc(p,f):j=L.$jc(E,p,f),await l(j))return j;let g=j+".com";if(await l(g)||(g=j+".exe",await l(g)))return g}return L.$jc(E,f)}I.findExecutable=d})(P||(e.win32=P={}))}),define(te[84],ne([0,1,33,13,83,56]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=void 0;async function N(I,d){return I===1?R.$i?P():A.$Ml(d):h(I,d)}e.$Ol=N;let b=null;function h(I,d){if(R.$k&&I===2||R.$j&&I===3)return"/bin/bash";if(!b){let f;if(R.$i)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}b=f}return b}let c=null;async function P(){return c||(c=(await(0,D.$Jl)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,L,R){var D=arguments.length,A=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,L):R,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,L,R);else for(var b=G.length-1;b>=0;b--)(N=G[b])&&(A=(D<3?N(A):D>3?N(e,L,A):N(e,L))||A);return D>3&&A&&Object.defineProperty(e,L,A),A};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,L,R,D,A,N,b,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.ProxyChannel=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.RequestInitiator=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function E(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(l||(l={}));function p(T){let M=0;for(let B=0;;B+=7){const J=T.read(1);if(M|=(J.buffer[0]&127)<<B,!(J.buffer[0]&128))return M}}const j=t(0);function g(T,M){if(M===0){T.write(j);return}let B=0;for(let Y=M;Y!==0;Y=Y>>>7)B++;const J=D.$ge.alloc(B);for(let Y=0;M!==0;Y++)J.buffer[Y]=M&127,M=M>>>7,M>0&&(J.buffer[Y]|=128);T.write(J)}class y{constructor(M){this.b=M,this.a=0}read(M){const B=this.b.slice(this.a,this.a+M);return this.a+=B.byteLength,B}}e.$yh=y;class s{constructor(){this.a=[]}get buffer(){return D.$ge.concat(this.a)}write(M){this.a.push(M)}}e.$zh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const M=D.$ge.alloc(1);return M.writeUInt8(T,0),M}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,M){if(typeof M>"u")T.write(i.Undefined);else if(typeof M=="string"){const B=D.$ge.fromString(M);T.write(i.String),g(T,B.byteLength),T.write(B)}else if(n&&Buffer.isBuffer(M)){const B=D.$ge.wrap(M);T.write(i.Buffer),g(T,B.byteLength),T.write(B)}else if(M instanceof D.$ge)T.write(i.VSBuffer),g(T,M.byteLength),T.write(M);else if(Array.isArray(M)){T.write(i.Array),g(T,M.length);for(const B of M)r(T,B)}else if(typeof M=="number"&&(M|0)===M)T.write(i.Uint),g(T,M);else{const B=D.$ge.fromString(JSON.stringify(M));T.write(i.Object),g(T,B.byteLength),T.write(B)}}e.$Ah=r;function u(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(p(T)).toString();case o.Buffer:return T.read(p(T)).buffer;case o.VSBuffer:return T.read(p(T));case o.Array:{const B=p(T),J=[];for(let Y=0;Y<B;Y++)J.push(u(T));return J}case o.Object:return JSON.parse(T.read(p(T)).toString());case o.Int:return p(T)}}e.$Bh=u;class k{constructor(M,B,J=null,Y=1e3){this.h=M,this.j=B,this.k=J,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(M,B){this.b.set(M,B),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const B=this.o([M.type]);this.k?.logOutgoing(B,0,1,$(M.type));return}case 201:case 202:case 204:case 203:{const B=this.o([M.type,M.id],M.data);this.k?.logOutgoing(B,M.id,1,$(M.type),M.data);return}}}o(M,B=void 0){const J=new s;return r(J,M),r(J,B),this.p(J.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const B=new y(M),J=u(B),Y=u(B),Q=J[0];switch(Q){case 100:return this.k?.logIncoming(M.byteLength,J[1],1,`${E(Q)}: ${J[2]}.${J[3]}`,Y),this.s({type:Q,id:J[1],channelName:J[2],name:J[3],arg:Y});case 102:return this.k?.logIncoming(M.byteLength,J[1],1,`${E(Q)}: ${J[2]}.${J[3]}`,Y),this.t({type:Q,id:J[1],channelName:J[2],name:J[3],arg:Y});case 101:return this.k?.logIncoming(M.byteLength,J[1],1,`${E(Q)}`),this.u({type:Q,id:J[1]});case 103:return this.k?.logIncoming(M.byteLength,J[1],1,`${E(Q)}`),this.u({type:Q,id:J[1]})}}s(M){const B=this.b.get(M.channelName);if(!B){this.v(M);return}const J=new A.$3d;let Y;try{Y=B.call(this.j,M.name,M.arg,J.token)}catch(C){Y=Promise.reject(C)}const Q=M.id;Y.then(C=>{this.m({id:Q,data:C,type:201})},C=>{C instanceof Error?this.m({id:Q,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:Q,data:C,type:203})}).finally(()=>{F.dispose(),this.d.delete(M.id)});const F=(0,c.$Qc)(()=>J.cancel());this.d.set(M.id,F)}t(M){const B=this.b.get(M.channelName);if(!B){this.v(M);return}const J=M.id,Q=B.listen(this.j,M.name,M.arg)(F=>this.m({id:J,data:F,type:204}));this.d.set(M.id,Q)}u(M){const B=this.d.get(M.id);B&&(B.dispose(),this.d.delete(M.id))}v(M){let B=this.g.get(M.channelName);B||(B=[],this.g.set(M.channelName,B));const J=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:M,timeoutTimer:J})}w(M){const B=this.g.get(M);if(B){for(const J of B)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$Ch=k;var S;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class w{constructor(M,B=null){this.l=M,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=B}getChannel(M){const B=this;return{call(J,Y,Q){return B.a?Promise.reject(new b.$5):B.m(M,J,Y,Q)},listen(J,Y){return B.a?h.Event.None:B.o(M,J,Y)}}}m(M,B,J,Y=A.CancellationToken.None){const Q=this.g++,C={id:Q,type:100,channelName:M,name:B,arg:J};if(Y.isCancellationRequested)return Promise.reject(new b.$5);let a;return new Promise((z,U)=>{if(Y.isCancellationRequested)return U(new b.$5);const X=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(Q),z(de.data);break;case 202:{this.f.delete(Q);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.f.delete(Q),U(de.data);break}};this.f.set(Q,me),this.p(C)};let W=null;this.b===l.Idle?X():(W=(0,R.$Og)(me=>this.u()),W.then(()=>{W=null,X()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:Q,type:101}),U(new b.$5)},ae=Y.onCancellationRequested(le);a=(0,c.$Pc)((0,c.$Qc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(M,B,J){const Y=this.g++,F={id:Y,type:102,channelName:M,name:B,arg:J};let C=null;const a=new h.$Sd({onWillAddFirstListener:()=>{C=(0,R.$Og)(z=>this.u()),C.then(()=>{C=null,this.d.add(a),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(a),this.p({id:Y,type:103}))}}),m=z=>a.fire(z.data);return this.f.set(Y,m),a.event}p(M){switch(M.type){case 100:case 102:{const B=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(B,M.id,0,`${E(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const B=this.q([M.type,M.id]);this.j?.logOutgoing(B,M.id,0,E(M.type));return}}}q(M,B=void 0){const J=new s;return r(J,M),r(J,B),this.r(J.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const B=new y(M),J=u(B),Y=u(B),Q=J[0];switch(Q){case 200:return this.j?.logIncoming(M.byteLength,0,0,$(Q)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,J[1],0,$(Q),Y),this.t({type:J[0],id:J[1],data:Y})}}t(M){if(M.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=w,pe([N.$sh],w.prototype,"onDidInitializePromise",null);class O{get connections(){const M=[];return this.f.forEach(B=>M.push(B)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new h.$Sd,this.onDidAddConnection=this.g.event,this.h=new h.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(M(({protocol:B,onDidClientDisconnect:J})=>{const Y=h.Event.once(B.onMessage);this.j.add(Y(Q=>{const F=new y(Q),C=u(F),a=new k(B,C),m=new w(B);this.a.forEach((U,X)=>a.registerChannel(X,U));const z={channelServer:a,channelClient:m,ctx:C};this.f.add(z),this.g.fire(z),this.j.add(J(()=>{a.dispose(),m.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(M,B){const J=this;return{call(Y,Q,F){let C;if((0,d.$Rf)(B)){const m=(0,L.$4b)(J.connections.filter(B));C=m?Promise.resolve(m):h.Event.toPromise(h.Event.filter(J.onDidAddConnection,B))}else C=B.routeCall(J,Y,Q);const a=C.then(m=>m.channelClient.getChannel(M));return ee(a).call(Y,Q,F)},listen(Y,Q){if((0,d.$Rf)(B))return J.k(M,B,Y,Q);const F=B.routeEvent(J,Y,Q).then(C=>C.channelClient.getChannel(M));return ee(F).listen(Y,Q)}}}k(M,B,J,Y){const Q=this;let F;const C=new h.$Sd({onWillAddFirstListener:()=>{F=new c.$Rc;const a=new h.$Yd,m=new Map,z=X=>{const le=X.channelClient.getChannel(M).listen(J,Y),ae=a.add(le);m.set(X,ae)},U=X=>{const W=m.get(X);W&&(W.dispose(),m.delete(X))};Q.connections.filter(B).forEach(z),h.Event.filter(Q.onDidAddConnection,B)(z,void 0,F),Q.onDidRemoveConnection(U,void 0,F),a.event(C.fire,C,F),F.add(a)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return C.event}registerChannel(M,B){this.a.set(M,B);for(const J of this.f)J.channelServer.registerChannel(M,B)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Eh=O;class H{constructor(M,B,J=null){const Y=new s;r(Y,B),M.send(Y.buffer),this.a=new w(M,J),this.d=new k(M,B,J)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,B){this.d.registerChannel(M,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Fh=H;function ee(T){return{call(M,B,J){return T.then(Y=>Y.call(M,B,J))},listen(M,B){const J=new h.$2d;return T.then(Y=>J.input=Y.listen(M,B)),J.event}}}e.$Gh=ee;function _(T){let M=!1;return{call(B,J,Y){return M?T.call(B,J,Y):(0,R.$2g)(0).then(()=>M=!0).then(()=>T.call(B,J,Y))},listen(B,J){if(M)return T.listen(B,J);const Y=new h.$2d;return(0,R.$2g)(0).then(()=>M=!0).then(()=>Y.input=T.listen(B,J)),Y.event}}}e.$Hh=_;class re{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const B of M.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await h.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$Ih=re;var se;(function(T){function M(Q,F,C){const a=Q,m=C&&C.disableMarshalling,z=new Map;for(const U in a)J(U)&&z.set(U,h.Event.buffer(a[U],!0,void 0,F));return new class{listen(U,X,W){const le=z.get(X);if(le)return le;if(Y(X)){const ae=a[X];if(typeof ae=="function")return ae.call(a,W)}throw new b.$bb(`Event not found: ${X}`)}call(U,X,W){const le=a[X];if(typeof le=="function"){if(!m&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,P.$xh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new b.$bb(`Method not found: ${X}`)}}}T.fromService=M;function B(Q,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(a,m){if(typeof m=="string")return F?.properties?.has(m)?F.properties.get(m):Y(m)?function(z){return Q.listen(m,z)}:J(m)?Q.listen(m):async function(...z){let U;F&&!(0,d.$Mf)(F.context)?U=[F.context,...z]:U=z;const X=await Q.call(m,U);return C?X:(0,P.$xh)(X)};throw new b.$bb(`Property not found: ${String(m)}`)}})}T.toService=B;function J(Q){return Q[0]==="o"&&Q[1]==="n"&&I.$6e(Q.charCodeAt(2))}function Y(Q){return/^onDynamic/.test(Q)&&I.$6e(Q.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const M=T.toString();if(M!=="[object Object]")return M}return T}function oe(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,M,B,J,Y,Q,F){F=oe(F);const C=ue[Y],a=C[J%C.length];let m=[`%c[${T}]%c[${String(M).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Q)?(m=m.concat(F),m.push(")")):m.push(F),console.log.apply(console,m)}class K{constructor(M,B){this.d=M,this.f=B,this.a=0,this.b=0}logOutgoing(M,B,J,Y,Q){this.b+=M,q(this.d,this.b,M,B,J,Y,Q)}logIncoming(M,B,J,Y,Q){this.a+=M,q(this.f,this.a,M,B,J,Y,Q)}}e.$Jh=K}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class E extends f.$Ch{constructor(l){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>D.$ge.wrap(Buffer.from(p,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$aq=E;class v{constructor(l,p){this.i=l,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.$Sd,this.onDidProcessExit=this.h.event;const j=p&&p.timeout?p.timeout:6e4;this.b=new R.$Xg(j),this.d=null,this.f=null}getChannel(l){const p=this;return{call(j,g,y){return p.k(l,j,g,y)},listen(j,g){return p.l(l,j,g)}}}k(l,p,j,g=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const y=this.n(l),s=(0,R.$Og)(i=>y.call(p,j,i)),o=g.onCancellationRequested(()=>s.cancel()),t=(0,c.$Qc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,p,j){if(!this.b)return h.Event.None;this.b.cancel();let g;const y=new h.$Sd({onWillAddFirstListener:()=>{g=this.n(l).listen(p,j)(y.fire,y),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,P.$fn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$Ll)(p.env),this.d=(0,L.fork)(this.i,l,p);const j=new h.$Sd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$9p)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}j.fire(D.$ge.wrap(Buffer.from(n,"base64")))});const y=this.j.useQueue?(0,I.$Nl)(this.d):this.d,s=n=>this.d&&this.d.connected&&y.send(n.buffer.toString("base64")),o=j.event,t={send:s,onMessage:o};this.f=new f.$Dh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(u=>(0,c.$Nc)(u)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(l){let p=this.g.get(l);return p||(p=this.m.getChannel(l),this.g.set(l,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$bq=v}),define(te[86],ne([0,1,8,4,2,46,3]),function(G,e,L,R,D,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.StorageState=e.$_o=e.StorageHint=void 0;var b;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$_o=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class P extends D.$Sc{static{this.a=100}constructor(f,E=Object.create(null)){super(),this.r=f,this.s=E,this.b=this.B(new R.$Vd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Yg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((E,v)=>this.w(v,E)),f.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(f,E){if(this.c===c.Closed)return;let v=!1;(0,N.$Mf)(E)?v=this.f.delete(f):this.f.get(f)!==E&&(this.f.set(f,E),v=!0),v&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,E){const v=this.f.get(f);return(0,N.$Mf)(v)?E:v}getBoolean(f,E){const v=this.get(f);return(0,N.$Mf)(v)?E:v==="true"}getNumber(f,E){const v=this.get(f);return(0,N.$Mf)(v)?E:parseInt(v,10)}getObject(f,E){const v=this.get(f);return(0,N.$Mf)(v)?E:(0,A.$wh)(v)}async set(f,E,v=!1){if(this.c===c.Closed)return;if((0,N.$Mf)(E))return this.delete(f,v);const $=(0,N.$Ff)(E)||Array.isArray(E)?(0,A.$vh)(E):String(E);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:v}),this.D()}async delete(f,E=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$ap=P;class I{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((E,v)=>this.a.set(v,E)),f.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$bp=I}),define(te[87],ne([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(te[48],ne([0,1,88,8,16,3,24,87]),function(G,e,L,R,D,A,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.zip=e.$wp=e.$vp=void 0,e.$vp="end of central directory record signature not found";const h=new RegExp(e.$vp);class c extends Error{constructor(y,s){let o=s.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=s}}e.$wp=c;function P(g){const y=g.externalFileAttributes>>16||33188;return[448,56,7].map(s=>y&s).reduce((s,o)=>s+o,y&61440)}function I(g){if(g instanceof c)return g;let y;return h.test(g.message)&&(y="CorruptZip"),new c(y,g)}function d(g,y,s,o,t,i){const n=D.$mc(y),r=D.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(b.localize(0,null,y)));const u=D.$jc(o,y);let k;return i.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(N.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((S,w)=>{if(!i.isCancellationRequested)try{k=(0,L.createWriteStream)(u,{mode:s}),k.once("close",()=>S()),k.once("error",w),g.once("error",w),g.pipe(k)}catch(O){w(O)}}))}function f(g,y,s,o){let t=(0,R.$Og)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),g.close()});return new Promise((r,u)=>{const k=new R.$Vg,S=w=>{w.isCancellationRequested||(i++,g.readEntry())};g.once("error",u),g.once("close",()=>t.then(()=>{o.isCancellationRequested||g.entryCount===i?r():u(new c("Incomplete",new Error(b.localize(1,null,i,g.entryCount))))},u)),g.readEntry(),g.on("entry",w=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(w.fileName)){S(o);return}const O=w.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const _=D.$jc(y,O);t=(0,R.$Og)(re=>N.Promises.mkdir(_,{recursive:!0}).then(()=>S(re)).then(void 0,u));return}const H=v(g,w),ee=P(w);t=(0,R.$Og)(_=>k.queue(()=>H.then(re=>d(re,O,ee,y,s,_).then(()=>S(_)))).then(null,u))})}).finally(()=>n.dispose())}async function E(g,y=!1){const{open:s}=await new Promise((o,t)=>{G(["yauzl"],o,t)});return new Promise((o,t)=>{s(g,y?{lazyEntries:!0}:void 0,(i,n)=>{i?t(I(i)):o((0,A.$Of)(n))})})}function v(g,y){return new Promise((s,o)=>{g.openReadStream(y,(t,i)=>{t?o(I(t)):s((0,A.$Of)(i))})})}async function $(g,y){const{ZipFile:s}=await new Promise((o,t)=>{G(["yazl"],o,t)});return new Promise((o,t)=>{const i=new s;y.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,L.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(g))})}e.zip=$;function l(g,y,s={},o){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=E(g,!0);return s.overwrite&&(i=i.then(n=>N.Promises.rm(y).then(()=>n))),i.then(n=>f(n,y,{sourcePathRegex:t},o))}e.$yp=l;function p(g,y){return E(g).then(s=>new Promise((o,t)=>{s.on("entry",i=>{i.fileName===y&&v(s,i).then(n=>o(n),n=>t(n))}),s.once("close",()=>t(new Error(b.localize(2,null,y))))}))}function j(g,y){return p(g,y).then(s=>new Promise((o,t)=>{const i=[];s.once("error",t),s.on("data",n=>i.push(n)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$zp=j}),define(te[89],ne([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[90],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[91],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[92],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[93],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[94],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[95],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[96],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[97],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[98],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[99],ne([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[100],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[101],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[102],ne([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[103],ne([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[104],ne([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[105],ne([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[106],ne([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[107],ne([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[108],ne([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[109],ne([0,1,9,91]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var D;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const N=(0,R.localize)(3,null),b=(0,R.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:I,lexeme:d,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),d=h.b.get(I);d?this.k(d):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,d=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(b);return}const E=this.c.charCodeAt(P);if(I)I=!1;else if(E===47&&!d){P++;break}else E===91?d=!0:E===92?I=!0:E===93&&(d=!1);P++}for(;P<this.c.length&&h.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=h}),define(te[110],ne([0,1,76,52,15,16,35,17,11]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=void 0,e.$qm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$mc)(D.$jg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,b.$Cg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$Cg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$pm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$Cg)(h.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$Cg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$Cg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$Cg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=N.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$jc)(f,"argv.json")):(0,b.$Cg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.$kc)(f):(0,A.$hc)((0,A.$jc)(D.$jg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,A.$kc)(f)):h.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.$kc)(f);const E=N.env.VSCODE_EXTENSIONS;if(E)return E;const v=N.env.VSCODE_PORTABLE;return v?(0,A.$jc)(v,"extensions"):(0,b.$Cg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,A.$hc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,A.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$qm.test(f))}get extensionLogLevel(){const f=[];for(const E of this.args.log||[]){const v=e.$qm.exec(E);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,b.$Cg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=N.env.VSCODE_PORTABLE;return f?h.URI.file((0,A.$jc)(f,"policy.json")):(0,b.$Cg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,E,v){this.a=f,this.b=E,this.c=v,this.editSessionId=this.args.editSessionId}}e.$rm=c,pe([R.$sh],c.prototype,"appRoot",null),pe([R.$sh],c.prototype,"userHome",null),pe([R.$sh],c.prototype,"userDataPath",null),pe([R.$sh],c.prototype,"appSettingsHome",null),pe([R.$sh],c.prototype,"tmpDir",null),pe([R.$sh],c.prototype,"cacheHome",null),pe([R.$sh],c.prototype,"stateResource",null),pe([R.$sh],c.prototype,"userRoamingDataHome",null),pe([R.$sh],c.prototype,"userDataSyncHome",null),pe([R.$sh],c.prototype,"sync",null),pe([R.$sh],c.prototype,"machineSettingsResource",null),pe([R.$sh],c.prototype,"workspaceStorageHome",null),pe([R.$sh],c.prototype,"localHistoryHome",null),pe([R.$sh],c.prototype,"keyboardLayoutResource",null),pe([R.$sh],c.prototype,"argvResource",null),pe([R.$sh],c.prototype,"isExtensionDevelopment",null),pe([R.$sh],c.prototype,"untitledWorkspacesHome",null),pe([R.$sh],c.prototype,"builtinExtensionsPath",null),pe([R.$sh],c.prototype,"extensionsPath",null),pe([R.$sh],c.prototype,"extensionDevelopmentLocationURI",null),pe([R.$sh],c.prototype,"extensionDevelopmentKind",null),pe([R.$sh],c.prototype,"extensionTestsLocationURI",null),pe([R.$sh],c.prototype,"debugExtensionHost",null),pe([R.$sh],c.prototype,"logLevel",null),pe([R.$sh],c.prototype,"extensionLogLevel",null),pe([R.$sh],c.prototype,"serviceMachineIdResource",null),pe([R.$sh],c.prototype,"disableTelemetry",null),pe([R.$sh],c.prototype,"disableWorkspaceTrust",null),pe([R.$sh],c.prototype,"useInMemorySecretStorage",null),pe([R.$sh],c.prototype,"policyFile",null);function P(d,f){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$sm=P;function I(d,f,E,v,$,l){const j=Number(f||d)||(v?null:E),g=j?!!f:!1;let y;if(l)try{y=JSON.parse(l)}catch{}return{port:j,break:g,debugId:$,env:y}}e.$tm=I}),function(){"use strict";function G(e,L,R){function D(N,b){const h=A(N,b),c=[h];return e.isAbsolute(h)||c.unshift(R),e.resolve(...c)}function A(N,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const P=N["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:D}}if(typeof define=="function")define(te[111],ne([165,33,35]),function(e,L,R){return G(e,L,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=G(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[112],ne([0,1,33,110,111]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=e.$um=void 0;class A extends R.$rm{constructor(c,P){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,P.nameShort)},P)}}e.$um=A;function N(h,c){return(0,R.$tm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$vm=N;function b(h,c){return(0,R.$tm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$wm=b}),define(te[113],ne([0,1,3,95]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;function D(N,b,h,c){try{A(N,b,h,c)}catch(P){N.error(P?.message??P)}return b}e.$Ip=D;function A(N,b,h,c){const P=(I,d,f)=>{const E=I[d];if((0,L.$Df)(E)){const v=E,$=v.length;if($>1&&v[0]==="%"&&v[$-1]==="%"){const l=v.substr(1,$-2);let p=h[l];p===void 0&&c&&(p=c[l]);const j=typeof p=="string"?p:p?.message,g=c?.[l],y=typeof g=="string"?g:g?.message;if(!j){y||N.warn(`[${b.name}]: ${(0,R.localize)(0,null,l)}`);return}if(f&&(d==="title"||d==="category")&&y&&y!==j){const s={value:j,original:y};I[d]=s}else I[d]=j}}else if((0,L.$Ff)(E))for(const v in E)E.hasOwnProperty(v)&&(v==="commands"?P(E,v,!0):P(E,v,f));else if(Array.isArray(E))for(let v=0;v<E.length;v++)P(E,v,f)};for(const I in b)b.hasOwnProperty(I)&&P(b,I)}}),define(te[114],ne([0,1,48,98]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;function D(A){return(0,L.$zp)(A,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$Qp=D}),define(te[49],ne([0,1,17,54,99,42]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function h(l){return l=l.trim(),l==="*"||N.test(l)}e.$Wo=h;function c(l){if(!h(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=l.match(N);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$Xo=c;function P(l){if(!l)return null;const p=l.majorBase,j=l.majorMustEqual,g=l.minorBase;let y=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(p===0||(y=!1),o=!1);let t=0;if(l.preRelease){const i=b.exec(l.preRelease);if(i){const[,n,r,u]=i;t=Date.UTC(Number(n),Number(r)-1,Number(u))}}return{majorBase:p,majorMustEqual:j,minorBase:g,minorMustEqual:y,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:t}}e.$Yo=P;function I(l,p,j){let g;typeof l=="string"?g=P(c(l)):g=l;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let s;if(typeof j=="string"?s=P(c(j)):s=j,!g||!s)return!1;const o=g.majorBase,t=g.minorBase,i=g.patchBase;let n=s.majorBase,r=s.minorBase,u=s.patchBase;const k=s.notBefore;let S=s.majorMustEqual,w=s.minorMustEqual,O=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||y&&y<k?!1:i>=u:(o===1&&n===0&&(!S||!w||!O)&&(n=1,r=0,u=0,S=!0,w=!1,O=!1),o<n?!1:o>n?!S:t<r?!1:t>r?!w:i<u?!1:i>u?!O:!(y&&y<k))}e.$Zo=I;function d(l,p,j,g,y){const s=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return s.push([R.default.Error,D.localize(0,null)]),s;if(typeof g.name!="string")return s.push([R.default.Error,D.localize(1,null,"name")]),s;if(typeof g.version!="string")return s.push([R.default.Error,D.localize(2,null,"version")]),s;if(!g.engines)return s.push([R.default.Error,D.localize(3,null,"engines")]),s;if(typeof g.engines.vscode!="string")return s.push([R.default.Error,D.localize(4,null,"engines.vscode")]),s;if(typeof g.extensionDependencies<"u"&&!$(g.extensionDependencies))return s.push([R.default.Error,D.localize(5,null,"extensionDependencies")]),s;if(typeof g.activationEvents<"u"){if(!$(g.activationEvents))return s.push([R.default.Error,D.localize(6,null,"activationEvents")]),s;if(typeof g.main>"u"&&typeof g.browser>"u")return s.push([R.default.Error,D.localize(7,null,"activationEvents","main","browser")]),s}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&s.push([R.default.Warning,D.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return s.push([R.default.Error,D.localize(9,null,"main")]),s;{const i=(0,L.$Cg)(j,g.main);(0,L.$wg)(i,j)||s.push([R.default.Warning,D.localize(10,null,i.path,j.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return s.push([R.default.Error,D.localize(11,null,"browser")]),s;{const i=(0,L.$Cg)(j,g.browser);(0,L.$wg)(i,j)||s.push([R.default.Warning,D.localize(12,null,i.path,j.path)])}}if(!A.valid(g.version))return s.push([R.default.Error,D.localize(13,null)]),s;const o=[];if(!f(l,p,g,y,o))for(const i of o)s.push([R.default.Error,i]);return s}e.$1o=d;function f(l,p,j,g,y){return g||typeof j.main>"u"&&typeof j.browser>"u"?!0:v(l,p,j.engines.vscode,y)}e.$2o=f;function E(l,p,j){return l==="*"||v(p,j,l)}e.$3o=E;function v(l,p,j,g=[]){const y=P(c(j));if(!y)return g.push(D.localize(14,null,j)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(D.localize(15,null,j)),!1}else if(!y.majorMustEqual)return g.push(D.localize(16,null,j)),!1;return I(l,p,y)?!0:(g.push(D.localize(17,null,l,j)),!1)}function $(l){if(!Array.isArray(l))return!1;for(let p=0,j=l.length;p<j;p++)if(typeof l[p]!="string")return!1;return!0}}),define(te[115],ne([0,1,14,28]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;async function D(A,N,b){let h=b&&b.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const P=(await N.readFile(A.serviceMachineIdResource)).value.toString();h=(0,R.$kg)(P)?P:null}catch{h=null}if(!h){h=(0,R.$lg)();try{await N.writeFile(A.serviceMachineIdResource,L.$ge.fromString(h))}catch{}}return b?.store("storage.serviceMachineId",h,-1,1),h}e.$kp=D}),define(te[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class L{constructor(D,A=[],N=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$Xh=L}),define(te[116],ne([0,1,50]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.InstantiationType=void 0;const R=[];var D;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(b,h,c){h instanceof L.$Xh||(h=new L.$Xh(h,[],!!c)),R.push([b,h])}e.$Hr=A;function N(){return R}e.$Ir=N}),define(te[117],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0;class L{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$mq=L;class R{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const b=this.lookupOrInsertNode(A),h=this.lookupOrInsertNode(N);b.outgoing.set(h.key,h),h.incoming.set(b.key,b)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let b=this.a.get(N);return b||(b=new L(N,A),this.a.set(N,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,b]of this.a)A.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const b=new Set([A]),h=this.c(N,b);if(h)return h}}c(A,N){for(const[b,h]of A.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const c=this.c(h,N);if(c)return c;N.delete(b)}}}e.$nq=R}),define(te[25],ne([0,1,3,11,10]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.ConfigurationTarget=e.$wi=e.$vi=e.$ui=void 0,e.$ui=(0,D.$1h)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}e.$vi=A;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}e.$wi=N;var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function h(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$xi=h;function c(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$yi=c;function P(l,p){const j=Object.create(null);for(const g in l)I(j,g,l[g],p);return j}e.$zi=P;function I(l,p,j,g){const y=p.split("."),s=y.pop();let o=l;for(let t=0;t<y.length;t++){const i=y[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${p} as ${y.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=j}catch{g(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Ai=I;function d(l,p){const j=p.split(".");f(l,j)}e.$Bi=d;function f(l,p){const j=p.shift();if(p.length===0){delete l[j];return}if(Object.keys(l).indexOf(j)!==-1){const g=l[j];typeof g=="object"&&!Array.isArray(g)&&(f(g,p),Object.keys(g).length===0&&delete l[j])}}function E(l,p,j){function g(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const y=p.split("."),s=g(l,y);return typeof s>"u"?j:s}e.$Ci=E;function v(l,p,j){Object.keys(p).forEach(g=>{g!=="__proto__"&&(g in l?L.$Ff(l[g])&&L.$Ff(p[g])?v(l[g],p[g],j):j&&(l[g]=p[g]):l[g]=p[g])})}e.$Di=v;function $(l){return l.replace(/[\[\]]/g,"")}e.$Ei=$}),define(te[118],ne([0,1,13,29,109,10,90,9]),function(G,e,L,R,D,A,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$j),h.set("isLinux",L.$k),h.set("isWindows",L.$i),h.set("isWeb",L.$o),h.set("isMacNative",L.$j&&!L.$o),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(C,a){if(h.get(C)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(C,a)}e.$Wi=c;const P=Object.prototype.hasOwnProperty;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const d={regexParsingWithErrorRecovery:!0},f=(0,N.localize)(0,null),E=(0,N.localize)(1,null),v=(0,N.localize)(2,null),$=(0,N.localize)(3,null),l=(0,N.localize)(4,null),p=(0,N.localize)(5,null),j=(0,N.localize)(6,null),g=(0,N.localize)(7,null);class y{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new D.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const z=this.D(),U=z.type===17?p:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:D.$Vi.getLexeme(z),additionalInfo:U}),y.c}return m}catch(m){if(m!==y.c)throw m;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const m=this.o();a.push(m)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const m=this.s();a.push(m)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=a.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const X=U.lexeme,W=X.lastIndexOf("/"),le=W===X.length-1?void 0:this.w(X.substring(W+1));let ae;try{ae=new RegExp(X.substring(1,W),le)}catch{throw this.B("REGEX",U)}return ce.create(m,ae)}switch(U.type){case 10:case 19:{const X=[U.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;X.push(D.$Vi.getLexeme(W)),this.z(),W=this.D()}const ae=X.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",U)}return s.regex(m,ge)}case 18:{const X=U.lexeme;this.z();let W=null;if(!(0,R.$Ge)(X)){const le=X.indexOf("/"),ae=X.lastIndexOf("/");if(le!==ae&&le>=0){const me=X.slice(le+1,ae),de=X[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",U)}}}if(W===null)throw this.B("REGEX",U);return ce.create(m,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const U=this.u();return s.notIn(m,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return s.equals(m,U);switch(U){case"true":return s.has(m);case"false":return s.not(m);default:return s.equals(m,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return s.notEquals(m,U);switch(U){case"true":return s.not(m);case"false":return s.has(m);default:return s.notEquals(m,U)}}case 5:return this.z(),se.create(m,this.u());case 6:return this.z(),ue.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),re.create(m,this.u());case 13:return this.z(),s.in(m,this.u());default:return s.has(m)}}case 20:throw this.h.push({message:j,offset:a.offset,lexeme:"",additionalInfo:g}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,m){if(this.C(a))return this.z();throw this.B(m,this.D())}B(a,m,z){const U=(0,N.localize)(8,null,a,D.$Vi.getLexeme(m)),X=m.offset,W=D.$Vi.getLexeme(m);return this.h.push({message:U,offset:X,lexeme:W,additionalInfo:z}),y.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=y;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return u.create(a)}static equals(a,m){return k.create(a,m)}static notEquals(a,m){return O.create(a,m)}static regex(a,m){return ce.create(a,m)}static in(a,m){return S.create(a,m)}static notIn(a,m){return w.create(a,m)}static not(a){return H.create(a)}static and(...a){return K.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,m){return _.create(a,m)}static greaterEquals(a,m){return re.create(a,m)}static smaller(a,m){return se.create(a,m)}static smallerEquals(a,m){return ue.create(a,m)}static{this.c=new y({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Yi=s;function o(C){const a=new y({regexParsingWithErrorRecovery:!1});return C.map(m=>(a.parse(m),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,N.localize)(9,null,z.additionalInfo):(0,N.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Zi=o;function t(C,a){const m=C?C.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!m&&!z?!0:!m||!z?!1:m.equals(z)}e.$1i=t;function i(C,a){return C.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$2i=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$3i=r;class u{static create(a,m=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new u(a,m)}constructor(a,m){this.key=a,this.c=m,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$4i=u;class k{static create(a,m,z=null){if(typeof m=="boolean")return m?u.create(a,z):H.create(a,z);const U=h.get(a);return typeof U=="boolean"?m===(U?"true":"false")?r.INSTANCE:n.INSTANCE:new k(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$5i=k;class S{static create(a,m){return new S(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:J(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(m)?m.includes(z):typeof z=="string"&&typeof m=="object"&&m!==null?P.call(m,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$6i=S;class w{static create(a,m){return new w(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=11,this.c=S.create(a,m)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=w;class O{static create(a,m,z=null){if(typeof m=="boolean")return m?H.create(a,z):u.create(a,z);const U=h.get(a);return typeof U=="boolean"?m===(U?"true":"false")?n.INSTANCE:r.INSTANCE:new O(a,m,z)}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const m=a?"true":"false";return this.d===m?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$8i=O;class H{static create(a,m=null){const z=h.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new H(a,m)}constructor(a,m){this.c=a,this.d=m,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$9i=H;function ee(C,a){if(typeof C=="string"){const m=parseFloat(C);isNaN(m)||(C=m)}return typeof C=="string"||typeof C=="number"?a(C):n.INSTANCE}class _{static create(a,m,z=null){return ee(m,U=>new _(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$0i=_;class re{static create(a,m,z=null){return ee(m,U=>new re(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$$i=re;class se{static create(a,m,z=null){return ee(m,U=>new se(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$_i=se;class ue{static create(a,m,z=null){return ee(m,U=>new ue(a,U,z))}constructor(a,m,z){this.c=a,this.d=m,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$aj=ue;class ce{static create(a,m){return new ce(a,m)}constructor(a,m){this.d=a,this.f=m,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return m<z?-1:m>z?1:0}equals(a){if(a.type===this.type){const m=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&m===z}return!1}substituteConstants(){return this}evaluate(a){const m=a.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$bj=ce;class oe{static create(a){return new oe(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new oe(this.c.map(a))}negate(){return this.c}}e.$cj=oe;function q(C){let a=null;for(let m=0,z=C.length;m<z;m++){const U=C[m].substituteConstants();if(C[m]!==U&&a===null){a=[];for(let X=0;X<m;X++)a[X]=C[X]}a!==null&&(a[m]=U)}return a===null?C:a}class K{static create(a,m,z){return K.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:K.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].evaluate(a))return!1;return!0}static d(a,m,z){const U=[];let X=!1;for(const W of a)if(W){if(W.type===1){X=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){U.push(...W.expr);continue}U.push(W)}if(U.length===0&&X)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];for(;U.length>1;){const W=U[U.length-1];if(W.type!==9)break;U.pop();const le=U.pop(),ae=U.length===0,me=T.create(W.expr.map(de=>K.create([de,le],null,z)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return n.INSTANCE;if(U.length===1)return U[0]}return new K(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new K(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());this.c=T.create(a,this,!0)}return this.c}}e.$dj=K;class T{static create(a,m,z){return T.d(a,m,z)}constructor(a,m){this.expr=a,this.c=m,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let m=0,z=this.expr.length;m<z;m++){const U=i(this.expr[m],a.expr[m]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let m=0,z=this.expr.length;m<z;m++)if(!this.expr[m].equals(a.expr[m]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let m=0,z=this.expr.length;m<z;m++)if(this.expr[m].evaluate(a))return!0;return!1}static d(a,m,z){let U=[],X=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){X=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&X)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return r.INSTANCE;if(U.length===1)return U[0]}return new T(U,m)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const m of this.expr)a.push(...m.keys());return a}map(a){return new T(this.expr.map(m=>m.map(a)),null)}negate(){if(!this.c){const a=[];for(const m of this.expr)a.push(m.negate());for(;a.length>1;){const m=a.shift(),z=a.shift(),U=[];for(const X of F(m))for(const W of F(z))U.push(K.create([X,W],null,!1));a.unshift(T.create(U,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$ej=T;class M extends u{static{this.d=[]}static all(){return M.d.values()}constructor(a,m,z){super(a,null),this.f=m,typeof z=="object"?M.d.push({...z,key:a}):z!==!0&&M.d.push({key:a,description:z,type:m!=null?typeof m:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return O.create(this.key,a)}}e.$fj=M,e.$gj=(0,A.$1h)("contextKeyService");function B(C,a){return C<a?-1:C>a?1:0}function J(C,a,m,z){return C<m?-1:C>m?1:a<z?-1:a>z?1:0}function Y(C,a){if(C.type===0||a.type===1)return!0;if(C.type===9)return a.type===9?Q(C.expr,a.expr):!1;if(a.type===9){for(const m of a.expr)if(Y(C,m))return!0;return!1}if(C.type===6){if(a.type===6)return Q(a.expr,C.expr);for(const m of C.expr)if(Y(m,a))return!0;return!1}return C.equals(a)}e.$hj=Y;function Q(C,a){let m=0,z=0;for(;m<C.length&&z<a.length;){const U=C[m].cmp(a[z]);if(U<0)return!1;U===0&&m++,z++}return m===C.length}function F(C){return C.type===9?C.expr:[C]}}),define(te[59],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0,e.$Zn=(0,L.$1h)("downloadService")}),define(te[18],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=void 0,e.$8h=(0,L.$1h)("environmentService"),e.$9h=(0,L.$2h)(e.$8h)}),define(te[21],ne([0,1,93,10]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$io=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=void 0,e.$9n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0n=new RegExp(e.$9n),e.$$n="__web_extension",e.$_n="skipWalkthrough",e.$ao="extensionsSync",e.$bo="dependecyOrPackExtensionInstall";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$co=D;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$do=A;function N(l,p){switch(l){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$eo=N;function b(l,p){return p==="web"&&!l.includes("web")}e.$fo=b;function h(l,p,j){return b(p,j)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===j}e.$go=h;function c(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$ho=c;var P;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var I;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var d;(function(l){l.Install="install",l.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$io=(0,R.$1h)("extensionGalleryService");var E;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var v;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class $ extends Error{constructor(p,j){super(p),this.code=j,this.name=j}}e.$jo=$,e.$ko=(0,R.$1h)("extensionManagementService"),e.$lo="extensionsIdentifiers/disabled",e.$mo="extensionsIdentifiers/enabled",e.$no=(0,R.$1h)("IGlobalExtensionEnablementService"),e.$oo=(0,R.$1h)("IExtensionTipsService"),e.$po=(0,L.localize)(0,null),e.$qo={value:e.$po,original:"Extensions"},e.$ro={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=void 0,e.$pp=(0,L.$1h)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((A,N)=>G(["node-vsce-sign"],async b=>A(b),N))),this.a}async verify(A,N,b){let h;try{h=await this.b()}catch{return!1}return h.verify(A,N,b)}}e.$qp=R}),define(te[61],ne([0,1,14,9,101,12]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;async function N(P,I,d,f,E,v){let $;try{await b(P,I,d,f,E,v)}catch(l){$=l}finally{$&&E.errorTransformer&&($=E.errorTransformer($)),typeof $<"u"&&d.error($),d.end()}}e.$Xp=N;async function b(P,I,d,f,E,v){h(v);const $=await P.open(I,{create:!1});try{h(v);let l=0,p=0,j=E&&typeof E.length=="number"?E.length:void 0,g=L.$ge.alloc(Math.min(E.bufferSize,typeof j=="number"?j:E.bufferSize)),y=E&&typeof E.position=="number"?E.position:0,s=0;do p=await P.read($,y,g.buffer,s,g.byteLength-s),y+=p,s+=p,l+=p,typeof j=="number"&&(j-=p),s===g.byteLength&&(await d.write(f(g)),g=L.$ge.alloc(Math.min(E.bufferSize,typeof j=="number"?j:E.bufferSize)),s=0);while(p>0&&(typeof j!="number"||j>0)&&h(v)&&c(l,E));if(s>0){let o=s;typeof j=="number"&&(o=Math.min(s,j)),d.write(f(g.slice(0,o)))}}catch(l){throw(0,A.$xk)(l)}finally{await P.close($)}}function h(P){if(P.isCancellationRequested)throw(0,R.$6)();return!0}function c(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,A.$wk)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[119],ne([0,1,4,166,2,13,167]),function(G,e,L,R,D,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;class b extends D.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.j(c),I=P.filter(f=>{const E=this.c.get(f.path);return E?!(0,R.$Lj)(E.request.excludes,f.excludes)||!(0,R.$Lj)(E.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!P.find(E=>E.path===f.path&&(0,R.$Lj)(E.excludes,f.excludes)&&(0,R.$Lj)(E.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of I)this.g(f)}g(c){const P=new N.$hq(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),I={request:c,instance:P};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}j(c){const P=new Map;for(const I of c){const d=A.$k?I.path:I.path.toLowerCase();let f=P.get(I.correlationId);f||(f=new Map,P.set(I.correlationId,f)),f.set(d,I)}return Array.from(P.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$jq=b}),define(te[120],ne([0,1,62,119]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class D extends L.$2p{constructor(N,b,h){super(N,b,h),this.s()}r(N){return N.add(new R.$jq)}}e.$kq=D}),define(te[121],ne([0,1,15,57,85,62]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class N extends A.$3p{constructor(h,c,P){super(h,c,P),this.s()}r(h){const c=h.add(new D.$bq(L.$jg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:P,signal:I})=>this.t(`terminated by itself with code ${P}, signal: ${I}`))),R.ProxyChannel.toService((0,R.$Hh)(c.getChannel("watcher")))}}e.$cq=N}),define(te[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class L{constructor(...D){this.a=new Map;for(const[A,N]of D)this.set(A,N)}set(D,A){const N=this.a.get(D);return this.a.set(D,A),N}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$Yh=L}),define(te[122],ne([0,1,8,9,2,50,117,10,63,168]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;const P=!1;class I extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class d{constructor($=new h.$Yh,l=!1,p,j=P){this.f=$,this.g=l,this.h=p,this.i=j,this.o=new Set,this.f.set(b.$Zh,this),this._globalGraph=j?p?._globalGraph??new N.$nq(g=>g):void 0}createChild($){return new d($,this.g,this,this.i)}invokeFunction($,...l){const p=E.traceInvocation(this.i,$);let j=!1;try{return $({get:y=>{if(j)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(y,p);if(!s)throw new Error(`[invokeFunction] unknown service '${y}'`);return s}},...l)}finally{j=!0,p.stop()}}createInstance($,...l){let p,j;return $ instanceof A.$Xh?(p=E.traceCreation(this.i,$.ctor),j=this.j($.ctor,$.staticArguments.concat(l),p)):(p=E.traceCreation(this.i,$),j=this.j($,l,p)),p.stop(),j}j($,l=[],p){const j=b._util.getServiceDependencies($).sort((s,o)=>s.index-o.index),g=[];for(const s of j){const o=this.m(s.id,p);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),g.push(o)}const y=j.length>0?j[0].index:l.length;if(l.length!==y){console.trace(`[createInstance] First service dependency of ${$.name} at position ${y+1} conflicts with ${l.length} static arguments`);const s=y-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,y)}return Reflect.construct($,l.concat(g))}k($,l){if(this.f.get($)instanceof A.$Xh)this.f.set($,l);else if(this.h)this.h.k($,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const l=this.f.get($);return!l&&this.h?this.h.l($):l}m($,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const p=this.l($);return p instanceof A.$Xh?this.q($,p,l.branch($,!0)):(l.branch($,!1),p)}q($,l,p){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,l,p)}finally{this.o.delete($)}}r($,l,p){const j=new N.$nq(s=>s.id.toString());let g=0;const y=[{id:$,desc:l,_trace:p}];for(;y.length;){const s=y.pop();if(j.lookupOrInsertNode(s),g++>1e3)throw new I(j);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Xh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};j.insertEdge(s,i),y.push(i)}}}for(;;){const s=j.roots();if(s.length===0){if(!j.isEmpty())throw new I(j);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Xh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}j.removeNode(o)}}return this.l($)}s($,l,p=[],j,g){if(this.f.get($)instanceof A.$Xh)return this.t($,l,p,j,g);if(this.h)return this.h.s($,l,p,j,g);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t($,l,p=[],j,g){if(j){const y=new d(void 0,this.g,this,this.i);y.c=String($);const s=new Map,o=new L.$hh(()=>{const t=y.j(l,p,g);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const u of n)r.apply(t,u)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let u=s.get(i);return u||(u=new c.$3c,s.set(i,u)),(S,w,O)=>{const H=u.push([S,w,O]);return(0,D.$Qc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,p,g)}u($,l){if(l&&console.warn($),this.g)throw new Error($)}}e.$oq=d;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,l){return $?new E(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation($,l){return $?new E(1,l.name):E.c}static{this.f=0}constructor($,l){this.type=$,this.name=l,this.g=Date.now(),this.h=[]}branch($,l){const p=new E(3,$.toString());return this.h.push([$,l,p]),p}stop(){const $=Date.now()-this.g;E.f+=$;let l=!1;function p(g,y){const s=[],o=new Array(g+1).join("	");for(const[t,i,n]of y.h)if(i&&n){l=!0,s.push(`${o}CREATES -> ${t}`);const r=p(g+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const j=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];($>2||l)&&E.all.add(j.join(`
`))}}e.$pq=E});var ie=this&&this.__param||function(G,e){return function(L,R){e(L,R,G)}};define(te[64],ne([0,1,20,2,13,103,21,10]),function(G,e,L,R,D,A,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0;function h(P){return P.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$3q=h,e.$4q=(0,b.$1h)("languagePackService");let c=class extends R.$Sc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$3d;setTimeout(()=>I.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const E=d.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some($=>$.startsWith("lp-"))).map(v=>{const $=v.properties.localizedLanguages?.[0],l=h(v);return{...this.f(l,$,v),extensionId:v.identifier.id,galleryExtension:v}});return E.push(this.f("en","English")),E}f(I,d,f){const E=d??I;let v;if(E!==I&&(v=`(${I})`),I.toLowerCase()===D.$w.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),f?.installCount){v??="";const $=f.installCount;let l;$>1e6?l=`${Math.floor($/1e5)/10}M`:$>1e3?l=`${Math.floor($/1e3)}K`:l=String($),v+=` $(cloud-download) ${l}`}return{id:I,label:E,description:v}}};e.$5q=c,e.$5q=c=pe([ie(0,N.$io)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,118,10]),function(G,e,L,R,D,A,N,b,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,d.$1h)("logService"),e.$jj=(0,d.$1h)("loggerService");function f(){return new Date().toISOString()}function E(S){return(0,c.$Hf)(S)}e.$kj=E;var v;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$lj=v.Info;function $(S,w,O){switch(w){case v.Trace:S.trace(O);break;case v.Debug:S.debug(O);break;case v.Info:S.info(O);break;case v.Warning:S.warn(O);break;case v.Error:S.error(O);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=$;function l(S,w=!1){let O="";for(let H=0;H<S.length;H++){let ee=S[H];if(ee instanceof Error&&(ee=(0,L.$Li)(ee,w)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}O+=(H>0?" ":"")+ee}return O}class p extends A.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new R.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$nj=p;class j extends p{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...O){this.f(v.Trace)&&this.g(v.Trace,l([w,...O],!0))}debug(w,...O){this.f(v.Debug)&&this.g(v.Debug,l([w,...O]))}info(w,...O){this.f(v.Info)&&this.g(v.Info,l([w,...O]))}warn(w,...O){this.f(v.Warning)&&this.g(v.Warning,l([w,...O]))}error(w,...O){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,l(H))}else this.g(v.Error,l([w,...O]))}flush(){}}e.$oj=j;class g extends p{constructor(w=e.$lj){super(),this.setLevel(w),this.g=!b.$i}trace(w,...O){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}debug(w,...O){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}info(w,...O){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}warn(w,...O){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...O):console.warn(`[main ${f()}]`,w,...O))}error(w,...O){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...O):console.error(`[main ${f()}]`,w,...O))}dispose(){}flush(){}}e.$pj=g;class y extends p{constructor(w=e.$lj,O=!0){super(),this.g=O,this.setLevel(w)}trace(w,...O){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}dispose(){}flush(){}}e.$qj=y;class s extends p{constructor(w,O=e.$lj){super(),this.g=w,this.setLevel(O)}trace(w,...O){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...O])}debug(w,...O){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...O])}info(w,...O){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...O])}warn(w,...O){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...O])}error(w,...O){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...O])}h(w){return typeof w=="string"?w:(0,L.$Li)(w,this.f(v.Trace))}dispose(){}flush(){}}e.$rj=s;class o extends p{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.g)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const H of this.g)H.trace(w,...O)}debug(w,...O){for(const H of this.g)H.debug(w,...O)}info(w,...O){for(const H of this.g)H.info(w,...O)}warn(w,...O){for(const H of this.g)H.warn(w,...O)}error(w,...O){for(const H of this.g)H.error(w,...O)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$sj=o;class t extends A.$Sc{constructor(w,O,H){if(super(),this.h=w,this.j=O,this.b=new N.$Ac,this.c=this.B(new R.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Sd),this.onDidChangeVisibility=this.g.event,H)for(const ee of H)this.b.set(ee.resource,{logger:void 0,info:ee})}m(w){return(0,c.$Df)(w)?[...this.b.values()].find(O=>O.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,O){const H=this.n(w),ee=(0,c.$Df)(w)?w:O?.id??(0,D.$Oi)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const re=O?.logLevel==="always"?v.Trace:O?.logLevel;_||(_=this.s(H,re??this.getLogLevel(H)??this.h,{...O,id:ee}));const se={logger:_,info:{resource:H,id:ee,logLevel:re,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(se.info),this.b.set(H,se),_}n(w){return(0,c.$Df)(w)?(0,h.$Cg)(this.j,`${w}.log`):w}setLogLevel(w,O){if(P.URI.isUri(w)){const H=w,ee=O,_=this.b.get(H);_&&ee!==_.info.logLevel&&(_.info.logLevel=ee===this.h?void 0:ee,_.logger?.setLevel(ee),this.b.set(_.info.resource,_),this.f.fire([H,ee]))}else{this.h=w;for(const[H,ee]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,O){const H=this.m(w);H&&O!==!H.info.hidden&&(H.info.hidden=!O,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this.b.get(w)?.info.logLevel),O??this.h}registerLogger(w){const O=this.b.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this.b.get(w);O&&(O.logger&&O.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=t;class i{constructor(){this.onDidChangeLogLevel=new R.$Sd().event}setLevel(w){}getLevel(){return v.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.$uj=i;class n extends i{}e.$vj=n;function r(S){if(S.verbose)return v.Trace;if(typeof S.logLevel=="string"){const w=k(S.logLevel.toLowerCase());if(w!==void 0)return w}return e.$lj}e.$wj=r;function u(S){switch(S){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$xj=u;function k(S){switch(S){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$yj=k,e.$zj=new I.$fj("logLevel",u(v.Info))}),define(te[123],ne([0,1,19,8,9,4,2,16,62,6]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class P extends N.$Sc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new A.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Yg(0)),this.w=[],this.y=this.B(new R.$Yg(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},v=(0,L.$Ub)(this.j,E);return this.r(),(0,N.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,D.$1)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$4p)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$Zp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$Zp)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},v=(0,L.$Ub)(this.w,E);return this.C(),(0,N.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,D.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$4p)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,b.$hc)(d.fsPath)}}e.$8p=P}),define(te[124],ne([0,1,19,8,14,20,4,41,65,2,47,15,125,17,45,100,12,61,6,9]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;let y=class extends c.$Sc{static{g=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new N.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$Sd),this.Y=this.B(new N.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$0g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new c.$Rc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new $.$Ck(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await R.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Gg)(o))throw new $.$Ek((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new j.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,$.$pk)(t)||(0,$.$mk)(t)||(0,$.$qk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,$.$pk)(t)||(0,$.$mk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,$.$zk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Ek((0,v.localize)(2,null,this.sb(o)),1):(0,$.$xk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,u=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,S=await i.stat(o);let w;return this.t(i,o,S,void 0,!!k,(O,H)=>(w||(w=P.$7h.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(O.resource)||w.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&u?H===1:!1))}async t(o,t,i,n,r,u){const{providerExtUri:k}=this.R(o),S={resource:t,name:k.basename(t),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Pk)({mtime:i.mtime,size:i.size}),children:void 0};if(S.isDirectory&&u(S,n)){try{const w=await o.readdir(t),O=await R.Promises.settled(w.map(async([H,ee])=>{try{const _=k.joinPath(t,H),re=r?await o.stat(_):{type:ee};return await this.t(o,_,re,w.length,r,u)}catch(_){return this.b.trace(_),null}}));S.children=(0,L.$Hb)(O)}catch(w){this.b.trace(w),S.children=[]}return S}return S}async resolveAll(o){return R.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new $.$Ek((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=D.$ge.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new $.$Bk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let u=i;if((0,$.$sk)(n)&&!u?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(u={...i,atomic:k})}try{await this.w(n,o,u)||await this.U(n,r.dirname(o));let S;if((0,$.$mk)(n)&&!(t instanceof D.$ge))if((0,E.$5d)(t)){const w=await(0,E.$_d)(t,3);w.ended?S=D.$ge.concat(w.buffer):S=w}else S=(0,E.$9d)(t,w=>D.$ge.concat(w),3);else S=t;!(0,$.$pk)(n)||(0,$.$mk)(n)&&S instanceof D.$ge||(0,$.$mk)(n)&&(0,$.$sk)(n)&&u?.atomic?await this.hb(n,o,u,S):await this.db(n,o,u,S instanceof D.$ge?(0,D.$re)(S):S),this.r.fire(new $.$Bk(o,4))}catch(k){throw new $.$Ek((0,v.localize)(4,null,this.sb(o),(0,$.$xk)(k).toString()),(0,$.$Ak)(k),u)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let u;try{u=await o.stat(t)}catch{return}if(u.type&$.FileType.Directory)throw new $.$Ek((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,u),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Ok&&typeof u.mtime=="number"&&typeof u.size=="number"&&i.mtime<u.mtime&&i.etag!==(0,$.$Pk)({mtime:i.mtime,size:u.size}))throw new $.$Ek((0,v.localize)(10,null),3,i);return u}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,u)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){u(k)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,D.$se)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new A.$3d(n);let u=i;(0,$.$rk)(o)&&o.enforceAtomicReadFile?.(t)&&(u={...i,atomic:!0});const k=this.J(t,u).then(w=>w,w=>{throw r.dispose(!0),w});let S;try{return typeof u?.etag=="string"&&u.etag!==$.$Ok&&await k,u?.atomic&&(0,$.$rk)(o)||!((0,$.$pk)(o)||(0,$.$qk)(o))||(0,$.$mk)(o)&&u?.preferUnbuffered?S=this.I(o,t,u):(0,$.$qk)(o)?S=this.G(o,t,r.token,u):S=this.H(o,t,r.token,u),S.on("end",()=>r.dispose()),S.on("error",()=>r.dispose()),{...await k,value:S}}catch(w){throw S&&await(0,E.$0d)(S),this.F(w,t,u)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,$.$xk)(o).toString());return o instanceof $.$Gk?new $.$Gk(n,o.stat,i):o instanceof $.$Fk?new $.$Fk(n,o.fileOperationResult,o.size,o.options):new $.$Ek(n,(0,$.$Ak)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$de)(r,{data:u=>u instanceof D.$ge?u:D.$ge.wrap(u),error:u=>this.F(u,t,n)},u=>D.$ge.concat(u))}H(o,t,i,n=Object.create(null)){const r=(0,D.$we)();return(0,l.$Xp)(o,t,r,u=>u,{...n,bufferSize:this.a,errorTransformer:u=>this.F(u,t,n)},i),r}I(o,t,i){const n=(0,E.$7d)(r=>D.$ge.concat(r));return(async()=>{try{let r;i?.atomic&&(0,$.$rk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(D.$ge.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$Ek((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Ok&&t.etag===i.etag)throw new $.$Gk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new $.$Fk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),u=this.qb(await this.n(t),t);await this.Q(r,o,u,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),u=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$Bk(o,u==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),u=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$Bk(o,u==="copy"?3:2,k)),k}async N(o,t,i,n,r,u){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:S}=await this.Q(o,t,i,n,r,u);if(k&&!S&&u&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,$.$nk)(o))await o.copy(t,n,{overwrite:u});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:u}),r):(await this.N(o,t,i,n,"copy",u),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,$.$pk)(o)&&(0,$.$pk)(i))return this.jb(o,t,i,n);if((0,$.$pk)(o)&&(0,$.$mk)(i))return this.pb(o,t,i,n);if((0,$.$mk)(o)&&(0,$.$pk)(i))return this.nb(o,t,i,n);if((0,$.$mk)(o)&&(0,$.$mk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async r=>{const u=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,u):this.O(o,r.resource,i,u)}))}async Q(o,t,i,n,r,u){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:O}=this.R(o);if(O||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const S=await this.exists(n);if(S&&!k){if(!u)throw new $.$Ek((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:S,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$sg:f.$ug,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$Bk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&$.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,$.$zk)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(u){if((0,$.$zk)(u)!==$.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let u;try{u=await i.stat(o)}catch{}if(u)this.rb(o,u);else throw new $.$Ek((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const S=await this.resolve(o);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,$.$tk)(i)&&!n?.atomic){const S=i.enforceAtomicDelete?.(o);S&&(n={...t,atomic:S})}const r=!!n?.useTrash,u=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:u,useTrash:r,atomic:k}),this.r.fire(new $.$Bk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,$.$ok)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$nk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:g.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Rc;let n=!1,r=()=>{n=!0};i.add((0,c.$Qc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,c.$Nc)(k):r=()=>(0,c.$Nc)(k)}catch(k){this.b.error(k)}})();const u=t.correlationId;if(typeof u=="number"){const k=i.add(new N.$Sd);return i.add(this.X.event(w=>{w.correlates(u)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Oi)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Nc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$5d)(n)||(0,E.$6d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(u){throw(0,$.$xk)(u)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$6d)(i)){if(i.buffer.length>0){const u=D.$ge.concat(i.buffer);await this.gb(o,t,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((u,k)=>{(0,E.$$d)(r,{onData:async S=>{r.pause();try{await this.gb(o,t,S,S.byteLength,n,0)}catch(w){return k(w)}n+=S.byteLength,setTimeout(()=>r.resume())},onError:S=>k(S),onEnd:()=>u()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,u){let k=0;for(;k<n;){const S=await o.write(t,r+k,i.buffer,u+k,n-k);k+=S}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof D.$ge?r=n:(0,E.$5d)(n)?r=await(0,D.$se)(n):(0,E.$6d)(n)?r=await(0,D.$te)(n):r=(0,D.$qe)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,u;try{r=await o.open(t,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const k=D.$ge.alloc(this.a);let S=0,w=0,O=0;do O=await o.read(r,S,k.buffer,w,k.byteLength-w),await this.gb(i,u,k,O,S,w),S+=O,w+=O,w===k.byteLength&&(w=0);while(O>0)}catch(k){throw(0,$.$xk)(k)}finally{await R.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const u=await o.readFile(t);await this.gb(i,r,D.$ge.wrap(u),u.byteLength,0,0)}catch(u){throw(0,$.$xk)(u)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,D.$se)(this.H(o,t,A.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new $.$Ek((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$Ek((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.$Yp=y,e.$Yp=y=g=pe([ie(0,p.$ij)],y)}),define(te[126],ne([0,1,88,169,8,31,14,4,170,2,16,13,17,45,24,102,12,61,123,34,121,120]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0,(()=>{try{(0,R.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,j.$Li)(o)}`)}})();class s extends p.$8p{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$Ac(n=>d.$tg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let u;r.isSymbolicLink()?u=(await this.stat((0,d.$Cg)(t,r.name))).type:u=this.M(r),n.push([r.name,u])}catch(u){this.a.trace(u)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=$.FileType.Unknown:t.isFile()?n=$.FileType.File:t.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new D.$Zg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$7d)(u=>N.$ge.concat(u.map(k=>N.$ge.wrap(k))).buffer);return(0,l.$Xp)(this,t,r,u=>u.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Cg)((0,d.$Bg)(t),`${(0,d.$zg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const u=new c.$Rc;try{u.add(await this.O(t)),u.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{u.dispose()}}async S(t,i,n,r){let u;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(k)){if(!n.overwrite)throw(0,$.$wk)((0,v.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$wk)((0,v.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(u,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof u=="number"&&await this.close(u)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let u;(0,$.$kk)(i)&&!n&&(u=await this.O(t));let k;try{if((0,$.$kk)(i)&&i.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let S;if((0,$.$kk)(i)){if(I.$i)try{await E.Promises.truncate(r,0),S="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}S||(S="w")}else S="r";k=await E.Promises.open(r,S)}catch(S){throw u?.dispose(),(0,$.$kk)(i)?await this.gb(t,S):this.fb(S)}if(this.U.set(k,0),(0,$.$kk)(i)&&this.X.set(k,t),u){const S=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,u),S&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),S.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,u){const k=this.Z(t,i);let S=null;try{S=(await E.Promises.read(t,n,r,u,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,S)}return S}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,u){return(0,D.$ih)(()=>this.ab(t,i,n,r,u),100,3)}async ab(t,i,n,r,u){const k=this.Z(t,i);let S=null;try{S=(await E.Promises.write(t,n,r,u,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,S)}return S}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(n),`${(0,P.$nc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let u=!1;try{const{stat:k,symbolicLink:S}=await E.SymlinkSupport.stat(n);u=k.isDirectory()&&!S}catch{}if(u)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),u=this.H(i);if(r!==u)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,u)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(u)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),u=this.H(i);if(r!==u)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,u,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(u)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const u=this.H(t),k=this.H(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,h.$2f)(u,k,!0)),S){if(n==="copy")throw(0,$.$wk)((0,v.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const O=await this.L(t);if(!O)throw(0,$.$wk)((0,v.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,$.$wk)((0,v.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);O.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),u=this.H(i),k=!!(this.capabilities&1024);if((0,h.$2f)(r,u,!k))return;const S=new c.$Rc;try{S.add(await this.O(t)),S.add(await this.O(i)),n&&await E.Promises.mkdir((0,P.$mc)(u),{recursive:!0}),await E.Promises.copyFile(r,u)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{S.dispose()}}t(t,i,n){return new g.$cq(r=>t(r),r=>i(r),n)}F(t,i,n){return new y.$kq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof $.$vk)return t;let i=t,n;switch(t.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$wk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,$.$wk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$lq=s}),define(te[127],ne([0,1,2,6]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;class D extends L.$Sc{constructor(N,b=[]){super(),this.a=new R.$sj([N,...b]),this.B(N.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...b){this.a.trace(N,...b)}debug(N,...b){this.a.debug(N,...b)}info(N,...b){this.a.info(N,...b)}warn(N,...b){this.a.warn(N,...b)}error(N,...b){this.a.error(N,...b)}flush(){this.a.flush()}}e.$7N=D}),define(te[128],ne([0,1,12,6]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function A(c,P,I,d,f){try{const E=await new Promise(($,l)=>{G(["@vscode/spdlog"],$,l)});E.setFlushOn(D.Trace);const v=await E.createAsyncRotatingLogger(c,P,I,d);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(E){console.error(E)}return null}function N(c,P,I){switch(P){case R.LogLevel.Trace:c.trace(I);break;case R.LogLevel.Debug:c.debug(I);break;case R.LogLevel.Info:c.info(I);break;case R.LogLevel.Warning:c.warn(I);break;case R.LogLevel.Error:c.error(I);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function b(c,P){switch(P){case R.LogLevel.Trace:c.setLevel(D.Trace);break;case R.LogLevel.Debug:c.setLevel(D.Debug);break;case R.LogLevel.Info:c.setLevel(D.Info);break;case R.LogLevel.Warning:c.setLevel(D.Warning);break;case R.LogLevel.Error:c.setLevel(D.Error);break;case R.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class h extends R.$oj{constructor(P,I,d,f,E){super(),this.m=[],this.setLevel(E),this.n=this.s(P,I,d,f),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(P,I,d,f){const E=d?6:1,v=30/E*L.$Rk.MB,$=await A(P,I,v,E,f);if($){this.r=$,b(this.r,this.getLevel());for(const{level:l,message:p}of this.m)N(this.r,l,p);this.m=[]}}g(P,I){this.r?N(this.r,P,I):this.getLevel()<=P&&this.m.push({level:P,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$VN=h}),define(te[129],ne([0,1,28,6,128]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=void 0;class A extends R.$tj{s(b,h,c){return new D.$VN((0,L.$lg)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$WN=A}),define(te[38],ne([0,1,4,65,2,10]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=void 0,e.$tn=(0,A.$1h)("policy");class N extends D.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(I,[d,f])=>({...I,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[P,I])=>({...c,[P]:{definition:I,value:this.g.get(P)}}),{})}}e.$un=N;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$vn=b}),define(te[130],ne([0,1,8,4,65,3,12,6,38]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0b=void 0;function c(I,d){const f=[];for(const E of new Set(D.Iterable.concat(I.keys(),d.keys())))I.get(E)!==d.get(E)&&f.push(E);return f}let P=class extends h.$un{constructor(d,f,E){super(),this.m=d,this.n=f,this.s=E,this.c=this.B(new L.$Yg(500));const v=R.Event.filter(f.onDidFilesChange,$=>$.affects(d));this.B(f.watch(d)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),E=JSON.parse(f.value.toString());if(!(0,A.$Ff)(E))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(E))this.f[v]&&d.set(v,E[v])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$W0b=P,e.$W0b=P=pe([ie(1,N.$jk),ie(2,b.$ij)],P)}),define(te[131],ne([0,1,38,8,2,6]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;let N=class extends L.$un{constructor(h,c){super(),this.m=h,this.n=c,this.a=new R.$Ug,this.b=this.B(new D.$Tc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((P,I)=>{G(["@vscode/policy-watcher"],P,I)});await this.a.queue(()=>new Promise((P,I)=>{try{this.b.value=c(this.n,h,d=>{this.t(d),P()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),I(d)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const P=h[c];P===void 0?this.g.delete(c):this.g.set(c,P)}this.h.fire(Object.keys(h))}};e.$V0b=N,e.$V0b=N=pe([ie(0,A.$ij)],N)}),define(te[32],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,L.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0;class D{constructor(){this.a=new Map}add(N,b){L.ok(R.$Df(N)),L.ok(R.$Ff(b)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$rn=new D}),define(te[132],ne([0,1,4,36]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0,e.$sn={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new L.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[D(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;R.$rn.add(e.$sn.JSONContribution,N)}),define(te[43],ne([0,1,19,4,3,89,25,132,36]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.ConfigurationScope=e.$wn=e.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$wn={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn="vscode://schemas/settings/resourceLanguage",e.$En="vscode://schemas/settings/configurationDefaults";const I=h.$rn.as(b.$sn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.$Sd,this.onDidSchemaChange=this.i.event,this.j=new R.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$Dn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),I.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),I.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),I.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$Gn.test(r)){const u=this.a.get(r),k=u?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))k.set(H,n);const S={...u?.value||{},...i[r]};this.a.set(r,{source:n,value:S,valuesSources:k});const w=(0,N.$Ei)(r),O={type:"object",default:S,description:A.localize(1,null,w),$ref:e.$Dn,defaultDefaultValue:S,source:D.$Df(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=O,this.b.properties[r]=O}else{this.a.set(r,{value:i[r],source:n});const u=this.d[r];u&&(this.w(r,u),this.r(r,u))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),u=D.$Df(i)?i:i?.id,k=D.$Df(r?.source)?r?.source:r?.source?.id;if(u===k)if(o.add(n),this.a.delete(n),e.$Gn.test(n))delete this.d[n],delete this.b.properties[n];else{const S=this.d[n];S&&(this.w(n,S),this.r(n,S))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=D.$Mf(s.scope)?n:s.scope;const u=s.properties;if(u)for(const S in u){const w=u[S];if(o&&j(S,w)){delete u[S];continue}if(w.source=t,w.defaultDefaultValue=u[S].default,this.w(S,w),e.$Gn.test(S)?w.scope=void 0:(w.scope=D.$Mf(w.scope)?n:w.scope,w.restricted=D.$Mf(w.restricted)?!!i?.includes(S):w.restricted),u[S].hasOwnProperty("included")&&!u[S].included){this.f[S]=u[S],delete u[S];continue}else this.d[S]=u[S],u[S].policy?.name&&this.e.set(u[S].policy.name,S);!u[S].deprecationMessage&&u[S].markdownDeprecationMessage&&(u[S].deprecationMessage=u[S].markdownDeprecationMessage),r.add(S)}const k=s.allOf;if(k)for(const S of k)this.p(S,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$xn.properties[s]=o,o.scope){case 1:e.$yn.properties[s]=o;break;case 2:e.$zn.properties[s]=o;break;case 6:e.$An.properties[s]=o;break;case 3:e.$Bn.properties[s]=o;break;case 4:e.$Cn.properties[s]=o;break;case 5:e.$Cn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$xn.properties[s],o.scope){case 1:delete e.$yn.properties[s];break;case 2:delete e.$zn.properties[s];break;case 6:delete e.$An.properties[s];break;case 3:delete e.$Bn.properties[s];break;case 4:case 5:delete e.$Cn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Dn};this.w(o,t),e.$xn.properties[o]=t,e.$yn.properties[o]=t,e.$zn.properties[o]=t,e.$An.properties[o]=t,e.$Bn.properties[o]=t,e.$Cn.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Dn};e.$xn.patternProperties[e.$Fn]=s,e.$yn.patternProperties[e.$Fn]=s,e.$zn.patternProperties[e.$Fn]=s,e.$An.patternProperties[e.$Fn]=s,e.$Bn.patternProperties[e.$Fn]=s,e.$Cn.patternProperties[e.$Fn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;D.$Kf(i)&&(i=o.defaultDefaultValue,n=void 0),D.$Kf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",E=new RegExp(f,"g");e.$Fn=`^(${f})+$`,e.$Gn=new RegExp(e.$Fn);function v(y){const s=[];if(e.$Gn.test(y)){let o=E.exec(y);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(y)}}return(0,L.$Mb)(s)}e.$Hn=v;function $(y){return y.reduce((s,o)=>`${s}[${o}]`,"")}e.$In=$;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Jn=l;const p=new d;h.$rn.add(e.$wn.Configuration,p);function j(y,s){return y.trim()?e.$Gn.test(y)?A.localize(7,null,y):p.getConfigurationProperties()[y]!==void 0?A.localize(8,null,y):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,y,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Kn=j;function g(){const y=[],s=p.getConfigurationProperties();for(const o of Object.keys(s))y.push([o,s[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$Ln=g}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,L,R,D,A,N,b,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0;function f(o){return Object.isFrozen(o)?o:b.$gn(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.$Ci)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,u=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:u}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,P.$Ci)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$fn(this.contents),n=b.$fn(this.overrides),r=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const k of t)if(u.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const S of k.overrides){const[w]=n.filter(O=>L.$ub(O.identifiers,S.identifiers));w?(this.h(w.contents,S.contents),w.keys.push(...S.keys),w.keys=L.$Mb(w.keys)):n.push(b.$fn(S))}for(const S of k.keys)r.indexOf(S)===-1&&r.push(S)}return new E(i,r,n,u.every(k=>k instanceof E)?void 0:u)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[r];const k=i[r];k&&(typeof u=="object"&&typeof k=="object"?(u=b.$fn(u),this.h(u,k)):u=k),n[r]=u}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$Ff(t[n])&&h.$Ff(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$fn(i[n])}}i(t){let i=null,n=null;const r=u=>{u&&(n?this.h(n,u):n=b.$fn(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?i=u.contents:u.identifiers.includes(t)&&r(u.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.$Bi)(this.contents,t),I.$Gn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,I.$Hn)(t))),1))}j(t,i,n){(0,P.$Ai)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$Gn.test(t)&&this.overrides.push({identifiers:(0,I.$Hn)(t),keys:Object.keys(this.contents[t]),contents:(0,P.$zi)(this.contents[t],r=>console.error(r))})}}e.$Mn=E;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$Mf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:u,restricted:k,hasExcludedProperties:S}=this.h(t,i);this.b=new E(n,r,u,S?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const u=[],k=[];function S(O){Array.isArray(r)?r.push(O):n!==null&&(r[n]=O)}const w={onObjectBegin:()=>{const O={};S(O),u.push(r),r=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const O=[];S(O),u.push(r),r=O,n=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:S,onError:(O,H,ee)=>{k.push({error:O,offset:H,length:ee})}};if(t)try{D.$cn(t,w),i=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(t,i){const n=d.$rn.as(I.$wn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const u=(0,P.$zi)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),S=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:u,keys:k,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let u=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const k={},S=[];for(const w in t)if(I.$Gn.test(w)&&n){const O=this.i(t[w],i,!1,r);k[w]=O.raw,u=u||O.hasExcludedProperties,S.push(...O.restricted)}else{const O=i[w],H=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&S.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&O?.restricted))?k[w]=t[w]:u=!0}return{raw:k,restricted:S,hasExcludedProperties:u}}j(t,i){const n=[];for(const r of Object.keys(t))if(I.$Gn.test(r)){const u={};for(const k in t[r])u[k]=t[r][k];n.push({identifiers:(0,I.$Hn)(r),keys:Object.keys(u),contents:(0,P.$zi)(u,i)})}return n}}e.$Nn=v;class $ extends A.$Sc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new R.$Sd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,u=>u.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&n.isEqual(u.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$On=$;class l{constructor(t,i,n,r,u,k,S,w,O,H,ee,_,re){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=u,this.f=k,this.g=S,this.h=w,this.i=O,this.j=H,this.k=ee,this.l=_,this.m=re}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(t,i,n,r,u=new E,k=new E,S=new N.$Ac,w=new E,O=new N.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=u,this.i=k,this.j=S,this.l=w,this.m=O,this.a=null,this.b=new N.$Ac,this.n=null}getValue(t,i,n){return this.p(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.p(t,i,n),u=this.t(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,S=new Set;for(const w of r.overrides)for(const O of w.identifiers)r.getOverrideValue(t,O)!==void 0&&S.add(O);return new l(t,i,r.getValue(t),S.size?[...S]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,u||void 0,k)}keys(t){const i=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:u,removed:k}=y(this.c,t);i=[...r,...u,...k]}for(const r of i)for(const u of(0,I.$Hn)(r)){const k=this.c.getKeysForOverrideIdentifier(u),S=t.getKeysForOverrideIdentifier(u),w=[...S.filter(O=>k.indexOf(O)===-1),...k.filter(O=>S.indexOf(O)===-1),...k.filter(O=>!b.$jn(this.c.override(u).getValue(O),t.override(u).getValue(O)))];n.push([u,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=y(this.d,t),u=[...i,...n,...r];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:u}=y(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:u,removed:k,overrides:S}=y(n,i),w=[...r,...u,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:S}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:u,overrides:k}=y(i,void 0);return{keys:[...n,...r,...u],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,i,n){let r=this.q(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},i){let n=this.r();if(i&&t){const r=i.getFolder(t);r&&(n=this.s(r.uri)||n);const u=this.m.get(t);u&&(n=n.merge(u))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let i=this.b.get(t);if(!i){const n=this.r(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}t(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:u}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}v(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.w(t.defaults),n=this.w(t.policy),r=this.w(t.application),u=this.w(t.user),k=this.w(t.workspace),S=t.folders.reduce((w,O)=>(w.set(c.URI.revive(O[0]),this.w(O[1])),w),new N.$Ac);return new p(i,n,r,u,new E,k,S,new E,new N.$Ac)}static w(t){return new E(t.contents,t.keys,t.overrides)}}e.$Pn=p;function j(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(u=>t.add(u)),r.overrides.forEach(([u,k])=>{const S=(0,N.$xc)(i,u,new Set);k.forEach(w=>S.add(w))});const n=[];return i.forEach((r,u)=>n.push([u,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Qn=j;class g{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const u of t.keys)this.affectedKeys.add(u);for(const[,u]of t.overrides)for(const k of u)this.affectedKeys.add(k);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const u=r+n.length;if(u>=this.d.length)return!1;const k=this.d.charCodeAt(u);if(k!==this.b&&k!==this.c)return!1;if(i){const S=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$jn(S,w)}return!0}}e.$Rn=g;function y(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),u=[],k=o?.getAllOverrideIdentifiers()||[],S=t?.getAllOverrideIdentifiers()||[];if(t){const w=S.filter(O=>!k.includes(O));for(const O of w)u.push([O,t.getKeysForOverrideIdentifier(O)])}if(o){const w=k.filter(O=>!S.includes(O));for(const O of w)u.push([O,o.getKeysForOverrideIdentifier(O)])}if(t&&o){for(const w of k)if(S.includes(w)){const O=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});u.push([w,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:n,updated:r,overrides:u}}function s(o,t){const i=o?t?o.keys.filter(u=>t.keys.indexOf(u)===-1):[...o.keys]:[],n=t?o?t.keys.filter(u=>o.keys.indexOf(u)===-1):[...t.keys]:[],r=[];if(o&&t){for(const u of t.keys)if(o.keys.indexOf(u)!==-1){const k=(0,P.$Ci)(t.contents,u),S=(0,P.$Ci)(o.contents,u);b.$jn(k,S)||r.push(u)}}return{added:i,removed:n,updated:r}}}),define(te[133],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,L,R,D,A,N,b,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=void 0;class d extends D.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Mn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$rn.as(h.$wn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:l})=>this.c(Array.from($),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,l){this.h($,I.$rn.as(h.$wn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new b.$Mn;const $=I.$rn.as(h.$wn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,l){const p=this.f();for(const j of $){const g=p[j],y=l[j];g!==void 0?this.b.addValue(j,g):y?this.b.addValue(j,y.default):this.b.removeValue(j)}}}e.$Sn=d;class f{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new b.$Mn}async initialize(){return this.configurationModel}}e.$Tn=f;let E=class extends D.$Sc{get configurationModel(){return this.b}constructor($,l,p){super(),this.c=$,this.f=l,this.g=p,this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Mn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const l={},p=[],j=I.$rn.as(h.$wn.Configuration).getConfigurationProperties();for(const g of $){const y=j[g];if(!y){p.push(g);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}p.push(g),l[y.policy.name]={type:y.type}}}return(0,N.$Qf)(l)||await this.f.updatePolicyDefinitions(l),p}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const l=I.$rn.as(h.$wn.Configuration).getPolicyConfigurations(),p=(0,L.$Hb)($.map(j=>l.get(j)));this.m(p,!0)}m($,l){this.g.trace("PolicyConfiguration#update",$);const p=I.$rn.as(h.$wn.Configuration).getConfigurationProperties(),j=[],g=this.b.isEmpty();for(const y of $){const s=p[y]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(g?o!==void 0:!(0,A.$jn)(this.b.getValue(y),o))&&j.push([y,o])}else this.b.getValue(y)!==void 0&&j.push([y,void 0])}if(j.length){this.g.trace("PolicyConfiguration#changed",j);const y=this.b;this.b=new b.$Mn;for(const s of y.keys)this.b.setValue(s,y.getValue(s));for(const[s,o]of j)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);l&&this.a.fire(this.b)}}};e.$Un=E,e.$Un=E=pe([ie(1,P.$tn),ie(2,c.$ij)],E)}),define(te[134],ne([0,1,8,4,2,17,25,66,133,38]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=void 0;class P extends D.$Sc{constructor(d,f,E,v){super(),this.j=d,this.h=this.B(new R.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Sn),this.c=E instanceof c.$vn?new h.$Tn:this.B(new h.$Un(this.b,E,v)),this.f=this.B(new b.$On(this.j,{},A.$tg,f)),this.a=new b.$Pn(this.b.configurationModel,this.c.configurationModel,new b.$Mn,new b.$Mn),this.g=this.B(new L.$ah(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:l})=>this.n($,l))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$Pn(d,f,new b.$Mn,E)}getConfigurationData(){return this.a.toData()}getValue(d,f){const E=typeof d=="string"?d:void 0,v=(0,N.$vi)(d)?d:(0,N.$vi)(f)?f:{};return this.a.getValue(E,v,void 0)}updateValue(d,f,E,v){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(E,f,2)}n(d,f){const E=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(v,E,7)}r(d){const f=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(d);this.s(E,f,7)}s(d,f,E){const v=new b.$Rn(d,{data:f},this.a);v.source=E,v.sourceConfig=this.t(E),this.h.fire(v)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Vn=P}),define(te[67],ne([0,1,15]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=void 0;function R(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$6k=R;function D(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.$7k=D;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$8k=A;function N(c){const{host:P,port:I}=h(c);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$9k=N;function b(c,P){let{host:I,port:d}=h(c);return typeof d>"u"&&(d=P),{host:I,port:d}}e.$0k=b;function h(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.TargetPlatform=e.ExtensionType=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l="extensions.user.cache",e.$_l="extensions.builtin.cache",e.$am="undefined_publisher",e.$bm=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$cm=A,e.$dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(N||(e.ExtensionType=N={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class h{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,l){if(typeof $>"u"||$===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof $=="string"||typeof l=="string"){const p=typeof $=="string"?$:$.value,j=typeof l=="string"?l:l.value;return L.$7e(p,j)}return $._lower===l._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$em=h;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const l of $)this.add(l)}add($){this.c.add(h.toKey($))}delete($){return this.c.delete(h.toKey($))}has($){return this.c.has(h.toKey($))}}e.$fm=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(h.toKey($))}get($){return this.c.get(h.toKey($))}has($){return this.c.has(h.toKey($))}set($,l){this.c.set(h.toKey($),l)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$gm=P;function I(v){return d(v)}e.$hm=I;function d(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$im=d;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$jm=f;function E(v,$){if($){const l=`onResolveRemoteAuthority:${(0,D.$7k)($)}`;return!!v.activationEvents?.includes(l)}return!1}e.$km=E,e.$lm=(0,R.$1h)("IBuiltinExtensionsScannerService")}),define(te[135],ne([0,1,2,37,12]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class A extends L.$Sc{constructor(b,h,c,P,I){super(),this.a=b,this.b=h,this.c=c,this.f=I,this.B(P.onDidInstallExtensions(d=>this.g(d))),this.B(P.onDidUninstallExtension(d=>this.h(d)))}g(b){for(const h of b)h.local&&this.invalidate(h.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,b)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,R.$$l))}catch(h){(0,D.$Ak)(h)!==1&&this.f.error(h)}}}e.$Rp=A}),define(te[44],ne([0,1,14,9,2,104,43,10,6,36]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$4o=(0,b.$1h)("requestService");class P{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?y[s]="*****":y[s]=this.b[s];this.a=y}return this.a}}class I extends D.$Sc{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,A.localize)(0,null),when:h.$zj.isEqualTo((0,h.$xj)(h.LogLevel.Trace)).serialize()})}async c(y,s,o){const t=`${y} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,R.$0)(i)),i}}}e.$5o=I;function d(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.$6o=d;function f(g){return g.res.statusCode===204}e.$7o=f;async function E(g){return f(g)?null:(await(0,L.$se)(g.stream)).toString()}e.$8o=E;async function v(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);return E(g)}e.$9o=v;async function $(g){if(!d(g))throw new Error("Server returned "+g.res.statusCode);if(f(g))return null;const s=(await(0,L.$se)(g.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$0o=$;function l(g){j(g)}e.$$o=l;let p;function j(g){const y=c.$rn.as(N.$wn.Configuration),s=p;p={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[p],remove:s?[s]:[]})}j(1)}),define(te[136],ne([0,1,20,15,12,44]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;let N=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,P=L.CancellationToken.None){if(h.scheme===R.Schemas.file||h.scheme===R.Schemas.vscodeRemote){await this.b.copy(h,c);return}const I={type:"GET",url:h.toString(!0)},d=await this.a.request(I,P);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,A.$9o)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$jO=N,e.$jO=N=pe([ie(0,A.$4o),ie(1,D.$jk)],N)}),define(te[137],ne([0,1,138,3]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;function D(N,b){return N.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:N.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(N,b,h={}){const c=(0,L.parse)(N),P=h.proxyUrl||D(c,b);if(!P)return null;const I=(0,L.parse)(P);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,R.$Jf)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,E)=>{G(["http-proxy-agent"],f,E)})).HttpProxyAgent(P,d):new(await new Promise((f,E)=>{G(["https-proxy-agent"],f,E)})).HttpsProxyAgent(P,d)}e.$9q=A}),define(te[139],ne([0,1,58,16,105,20,34,9,13,28,84,171,8,72]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=void 0;let E;async function v(l,p,j,g){return j["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$Yl)(g)&&!j["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$Yl)(g)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=d.Promises.withAsyncBody(async(y,s)=>{const o=new A.$3d;let t=1e4;const i=l.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$Zl)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,D.localize)(0,null)))},t);try{y(await $(p,o.token))}catch(r){!(0,b.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,D.localize)(1,null,(0,N.$Li)(r)))):y({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$5l=v;async function $(l,p){const j=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",j);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",g);const y=(0,c.$lg)().replace(/-/g,"").substr(0,12),s=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",o);const t=await(0,P.$Ol)(h.OS,o);return l.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(p.isCancellationRequested)return n(new b.$5);const r=(0,R.$nc)(t);let u,k;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(u=`& '${process.execPath}' ${S} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,k=["-Login","-Command"]):r==="nu"?(u=`^'${process.execPath}' ${S} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,k=["-i","-l","-c"]):(u=`'${process.execPath}' ${S} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),u);const w=(0,L.spawn)(t,[...k,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(w.kill(),n(new b.$5))),w.on("error",ee=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.$Li)(ee)),n(ee)});const O=[];w.stdout.on("data",ee=>O.push(ee));const H=[];w.stderr.on("data",ee=>H.push(ee)),w.on("close",(ee,_)=>{const re=Buffer.concat(O).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(H).toString("utf8");if(se.trim()&&l.trace("getUnixShellEnvironment#stderr",se),ee||_)return n(new Error((0,D.localize)(2,null,ee,_)));const ue=s.exec(re),ce=ue?ue[1]:"{}";try{const oe=JSON.parse(ce);j?oe.ELECTRON_RUN_AS_NODE=j:delete oe.ELECTRON_RUN_AS_NODE,g?oe.ELECTRON_NO_ATTACH_CONSOLE=g:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){l.error("getUnixShellEnvironment#errorCaught",(0,N.$Li)(oe)),n(oe)}})})}}),define(te[140],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=e.$XN=void 0,e.$XN=(0,L.$1h)("stateReadService"),e.$YN=(0,L.$1h)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=e.$1N=e.$ZN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class P extends D.$Sc{constructor(E,v,$,l){super(),this.h=E,this.j=v,this.m=$,this.n=l,this.a=Object.create(null),this.b="",this.c=this.B(new L.$Yg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.m.error(E)}}getItem(E,v){const $=this.a[E];return(0,A.$Mf)($)?v:$}setItem(E,v){this.setItems([{key:E,data:v}])}setItems(E){let v=!1;for(const{key:$,data:l}of E)this.a[$]!==l&&((0,A.$Mf)(l)?(0,A.$Kf)(this.a[$])||(this.a[$]=void 0,v=!0):(this.a[$]=l,v=!0));v&&this.s()}removeItem(E){(0,A.$Kf)(this.a[E])||(this.a[E]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.n.writeFile(this.h,R.$ge.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$ZN=P;let I=class extends D.$Sc{constructor(E,v,$,l){super(),this.a=this.B(new P(v.stateResource,E,$,l))}async init(){await this.a.init()}getItem(E,v){return this.a.getItem(E,v)}};e.$1N=I,e.$1N=I=pe([ie(1,N.$8h),ie(2,h.$ij),ie(3,b.$jk)],I);class d extends I{setItem(E,v){this.a.setItem(E,v)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$2N=d}),define(te[69],ne([0,1,13,35,28]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=void 0;function A(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function N(h,c,P,I,d,f,E,v,$){const l=Object.create(null);l["common.machineId"]=f,l["common.sqmId"]=E,l.sessionID=(0,D.$lg)()+Date.now(),l.commitHash=I,l.version=d,l["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,L.$h)(L.$u),l["common.nodePlatform"]=R.$dc,l["common.nodeArch"]=P,l["common.product"]=$||"desktop",v&&(l["common.msftInternal"]=v);let p=0;const j=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-j,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),L.$l&&(l["common.snap"]="true");const g=A(c);return g&&(l["common.platformDetail"]=g),l}e.$so=N;function b(h){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const P=c.toLowerCase();return h.some(I=>P===I)}e.$to=b}),define(te[26],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=void 0,e.$nl=(0,L.$1h)("telemetryService"),e.$ol=(0,L.$1h)("customEndpointTelemetryService"),e.$pl="telemetry.currentSessionDate",e.$ql="telemetry.firstSessionDate",e.$rl="telemetry.lastSessionDate",e.$sl="telemetry.machineId",e.$tl="telemetry.sqmId",e.$ul="telemetry",e.$vl="telemetry.telemetryLevel",e.$wl="telemetry.enableCrashReporter",e.$xl="telemetry.enableTelemetry";var R;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$uo=c;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vo=P,e.$wo=new P;class I{async publicLog(n,r,u){}async publicLogError(n,r,u){}}e.$xo=I,e.$yo="telemetry",e.$zo="extensionTelemetryLog",e.$Ao={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return D.Event.debounce(n.onDidChangeConfiguration,(u,k)=>{const S=u?new Set([...u.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:S}},1e3,!0)(u=>{u.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$xi)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.$Bo=d;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Co=f;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Do=E;function v(i){const n=i.getValue(h.$vl),r=i.getValue(h.$wl);if(i.getValue(h.$xl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Eo=v;function $(i){const n={},r={},u={};j(i,u);for(let k in u){k=k.length>150?k.substr(k.length-149):k;const S=u[k];typeof S=="number"?r[k]=S:typeof S=="boolean"?r[k]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${S.length}`),n[k]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(n[k]=S)}return{properties:n,measurements:r}}e.$Fo=$;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const n=(0,N.$7k)(i);return l.has(n)?n:"other"}e.$Go=p;function j(i,n,r=0,u){if(i)for(const k of Object.getOwnPropertyNames(i)){const S=i[k],w=u?u+k:k;Array.isArray(S)?n[w]=(0,L.$kn)(S):S instanceof Date?n[w]=S.toISOString():(0,R.$Ff)(S)?r<2?j(S,n,r+1,w+"."):n[w]=(0,L.$kn)(S):n[w]=S}}function g(i,n){const r=i.msftInternalDomains||[],u=n.getValue("telemetry.internalTesting");return(0,b.$to)(r)||u}e.$Ho=g;function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Io=y;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const u=[];for(const O of n)for(;;){const H=O.exec(i);if(!H)break;u.push([H.index,O.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const O=S.exec(i);if(!O)break;const H=u.some(([ee,_])=>O.index<_&&ee<S.lastIndex);!k.test(O[0])&&!H&&(r+=i.substring(w,O.index)+"<REDACTED: user-file-path>",w=S.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$hn)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let u=r.replaceAll("%20"," ");u=s(u,n);for(const k of n)u=u.replace(k,"");return u=o(u),u}})}e.$Jo=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$2e)(t.id,i.id)===0}e.$Ko=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,r)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Lo=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=f.exec(t);return i&&i[1]?[$(i[1]),i[2]]:[$(t),void 0]}e.$Mo=E;function v(t,i){return`${t}.${i}`}e.$No=v;function $(t){return t.toLowerCase()}e.$Oo=$;function l(t,i){return $(v(t??D.$am,i))}e.$Po=l;function p(t,i){const n=[],r=u=>{for(const k of n)if(k.some(S=>P(i(S),i(u))))return k;return null};for(const u of t){const k=r(u);k?k.push(u):n.push([u])}return n}e.$Qo=p;function j(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Ro=j;function g(t){return{id:new c.$uo(t.identifier.id),name:new c.$uo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$So=g,e.$To=new D.$em("pprice.better-merge");function y(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const u=r.shift();if(u&&n.every(k=>!P(k.identifier,{id:u}))){const k=t.filter(S=>P(S.identifier,{id:u}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Uo=y;async function s(t,i){if(!A.$k)return!1;let n;try{n=(await t.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){i.debug("Error while getting the os-release file.",(0,b.$0)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,R.$eo)(n?"alpine":A.$u,h.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Vo=o}),define(te[141],ne([0,1,20,9,15,17,42,11,94,21,27,37]),function(G,e,L,R,D,A,N,b,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=void 0;const d=$=>(0,h.localize)(0,null,$),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function E($,l){return l?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let v=class{constructor(l,p,j){this.a=l,this.b=p,this.d=j}get f(){}async listExtensions(l,p,j){let g=await this.b.getInstalled(1,j);const y=I.$dm.map(o=>o.toLowerCase());if(p&&p!==""){if(y.indexOf(p.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){this.a.info("Possible Categories: "),y.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),g=g.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of g)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(E(o.manifest,l)))}async installExtensions(l,p,j,g){const y=[];try{const s=[];l.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const i=(r,u,k)=>{t.push({id:r,version:u!=="prerelease"?u:void 0,installOptions:{...j,isBuiltin:k,installPreReleaseVersion:u==="prerelease"||j.installPreReleaseVersion}})};for(const r of l)if(r instanceof b.URI)o.push({vsix:r,installOptions:j});else{const[u,k]=(0,P.$Mo)(r);i(u,k,!1)}for(const r of p)if(r instanceof b.URI)o.push({vsix:r,installOptions:{...j,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[u,k]=(0,P.$Mo)(r);i(u,k,!0)}const n=await this.b.getInstalled(1,j.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:u})=>{try{const k=await this.g(r,u,g,n);k&&s.push(k)}catch(k){this.a.error(k),y.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:u})=>{const k=n.find(S=>(0,P.$Ko)(S.identifier,{id:r}));if(k){if(!g&&(!u||u==="prerelease"&&k.preRelease))return this.a.info((0,h.localize)(5,null,r,k.manifest.version,r)),!1;if(u&&k.manifest.version===u)return this.a.info((0,h.localize)(6,null,`${r}@${u}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async u=>{const k=r.get(u.id.toLowerCase());if(k)try{const S=await this.j(u,k,n);S&&s.push(S)}catch(S){this.a.error(S.message||S.stack||S),y.push(u.id)}else this.a.error(`${d(u.version?`${u.id}@${u.version}`:u.id)}
${f}`),y.push(u.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,R.$0)(s))),s}if(y.length)throw new Error((0,h.localize)(8,null,y.join(", ")))}async g(l,p,j,g){const y=await this.b.getManifest(l);if(!y)throw new Error("Invalid vsix");if(await this.l(y,j,p.profileLocation,g))try{return await this.b.install(l,p),this.a.info((0,h.localize)(9,null,(0,A.$zg)(l))),y}catch(o){if((0,R.$4)(o))return this.a.info((0,h.localize)(10,null,(0,A.$zg)(l))),null;throw o}return null}async h(l){const p=new Map,j=l.some(s=>s.installOptions.installPreReleaseVersion),g=await this.b.getTargetPlatform(),y=[];for(const s of l)c.$0n.test(s.id)&&y.push({...s,preRelease:j});if(y.length){const s=await this.d.getExtensions(y,{targetPlatform:g},L.CancellationToken.None);for(const o of s)p.set(o.identifier.id.toLowerCase(),o)}return p}async j({id:l,version:p,installOptions:j},g,y){const s=await this.d.getManifest(g,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=y.find(t=>(0,P.$Ko)(t.identifier,g.identifier));if(o){if(g.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,p?`${l}@${p}`:l)),null;this.a.info((0,h.localize)(12,null,l,g.version))}try{j.isBuiltin?this.a.info(p?(0,h.localize)(13,null,l,p):(0,h.localize)(14,null,l)):this.a.info(p?(0,h.localize)(15,null,l,p):(0,h.localize)(16,null,l));const t=await this.b.installFromGallery(g,{...j,installGivenVersion:!!p});return this.a.info((0,h.localize)(17,null,l,t.manifest.version)),s}catch(t){if((0,R.$4)(t))return this.a.info((0,h.localize)(18,null,l)),null;throw t}}k(l){return!0}async l(l,p,j,g){if(!p){const y={id:(0,P.$Po)(l.publisher,l.name)},s=g.find(o=>(0,P.$Ko)(y,o.identifier)&&(0,N.gt)(o.manifest.version,l.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,l.version)),!1}return this.k(l)}async uninstallExtensions(l,p,j){const g=async s=>{if(s instanceof b.URI){const o=await this.b.getManifest(s);return E(o)}return s},y=[];for(const s of l){const o=await g(s),i=(await this.b.getInstalled(void 0,j)).filter(n=>(0,P.$Ko)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!p&&i.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:j}),y.push(n);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(l){const p=await this.b.getInstalled();l.forEach(j=>{p.forEach(g=>{if(g.identifier.id===j&&g.location.scheme===D.Schemas.file){this.a.info(g.location.fsPath);return}})})}m(l){return this.f?(0,h.localize)(25,null,l,this.f):(0,h.localize)(26,null,l)}};e.$rp=v,e.$rp=v=pe([ie(1,c.$ko),ie(2,c.$io)],v)}),define(te[142],ne([0,1,8,9,2,15,17,42,3,28,24,48,25,18,21,27,60,12,6]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let g=class extends D.$Sc{static{j=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,N.$Cg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$jo(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(u){const k=u;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.$jo(I.$vp,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(u){this.r.error(u)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Jf)(o)?o:!0}async u(s){await this.g;const o=(0,N.$Cg)(this.extensionsDownloadDir,`${this.z(s)}${j.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,N.$Cg)(this.extensionsDownloadDir,`.${(0,c.$lg)()}`);await this.h.exists(i)||await t(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const u of s.children)if(u.name.endsWith(j.c))i.push(u.resource);else{const k=v.$Lo.parse(u.name);k&&t.push([k,u])}const n=(0,v.$Qo)(t,([u])=>u),r=[];for(const u of n)u.sort((k,S)=>b.rcompare(k[0].version,S[0].version)),o.push(...u.slice(1).map(k=>k[1].resource)),r.push(u[0][1]);r.sort((u,k)=>u.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(u=>u.resource)),o.push(...i),await L.Promises.settled(o.map(u=>(this.r.trace("Deleting from cache",u.path),this.h.del(u))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$Lo.create(s).toString().toLowerCase():(0,c.$lg)()}};e.$Op=g,e.$Op=g=j=pe([ie(0,f.$9h),ie(1,l.$jk),ie(2,E.$io),ie(3,d.$ui),ie(4,$.$pp),ie(5,p.$ij)],g)}),define(te[143],ne([0,1,4,2,31,27,37]),function(G,e,L,R,D,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class b extends R.$Sc{constructor(c,P,I,d,f,E,v){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=E,this.r=v,this.a=this.B(new L.$Sd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$2c),this.s().then(null,$=>v.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(P=>(this.c.set(P.id,(0,R.$Pc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(c){for(const P of c.extensions)this.I(this.L(P.identifier,P.version),c.profileLocation)}async y(c){for(const P of c.extensions){const I=this.L(P.identifier,P.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const P of c.extensions)this.J(this.L(P.identifier,P.version),c.profileLocation)}async C(c){const P=[],I=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),I.push(this.f.scanInstalledExtensionAtLocation(d.location).then(E=>{E?P.push(E):this.r.info("Extension not found at the location",d.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(I),P.length&&await this.H(P)}catch(d){this.r.error(d)}}D(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(c){const P=[],I=[],d=await this.j.scanProfileExtensions(c),f=new Set,E=new Set;for(const[v,$]of this.b)$.has(c)&&E.add(v);for(const v of d){const $=this.L(v.identifier,v.version);f.add($),E.has($)||(P.push(v.identifier),this.I($,c))}for(const v of E)if(!f.has(v)){const $=this.M(v);$&&(I.push($.identifier),this.J(v,c))}(P.length||I.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const P=await this.j.scanProfileExtensions(c);for(const I of P)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,P){let I=this.b.get(c);I||this.b.set(c,I=new D.$Bc(d=>this.m.extUri.getComparisonKey(d))),I.add(P)}J(c,P){const I=this.b.get(c);I&&I.delete(P),I?.size||this.b.delete(c)}L(c,P){return`${N.$em.toKey(c.id)}@${P}`}M(c){const[P,I]=(0,A.$Mo)(c);return I?{identifier:{id:P},version:I}:void 0}}e.$Sp=b}),define(te[144],ne([0,1,115,39]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;async function D(A,N,b,h,c,P,I){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${N.nameShort})`};if((0,R.$Co)(N,b)&&(0,R.$Eo)(h)===3){const f=await(0,L.$kp)(b,c,P);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=I.machineId||f}return d}e.$lp=D}),define(te[145],ne([0,1,172,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let v=class extends f.$5q{constructor(j,g,y,s){super(y),this.h=j,this.j=s,this.g=this.B(new $(g,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(j,g){const s=(await this.g.getLanguagePacks())[g];if(!s){this.j.warn(`No language pack found for ${g}`);return}const o=s.translations[j];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const j=await this.g.getLanguagePacks(),g=Object.keys(j).map(y=>{const s=j[y];return{...this.f(y,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((y,s)=>y.label.localeCompare(s.label)),g}async m(j){j&&j.manifest&&j.manifest.contributes&&j.manifest.contributes.localizations&&j.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",j.identifier.id),await this.update())}async n(j){const g=await this.g.getLanguagePacks();Object.keys(g).some(y=>g[y]&&g[y].extensions.some(s=>(0,I.$Ko)(s.extensionIdentifier,j.identifier)))&&(this.j.info("Removing language packs from the extension",j.identifier.id),await this.update())}async update(){const[j,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(g);return!(0,R.$ub)(Object.keys(j),Object.keys(y))}};e.$6q=v,e.$6q=v=pe([ie(0,P.$ko),ie(1,c.$9h),ie(2,P.$io),ie(3,d.$ij)],v);let $=class extends A.$Sc{constructor(j,g){super(),this.j=g,this.c={},this.f=(0,b.$jc)(j.userDataPath,"languagepacks.json"),this.g=new D.$8g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(j){return this.s(g=>{Object.keys(g).forEach(y=>delete g[y]),this.m(g,...j)}).then(()=>this.c)}m(j,...g){for(const y of g)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.n(j,y);Object.keys(j).forEach(y=>this.r(j[y]))}n(j,g){const y=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const o of s)if(g.location.scheme===N.Schemas.file&&l(o)){let t=j[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},j[o.languageId]=t);const i=t.extensions.filter(n=>(0,I.$Ko)(n.extensionIdentifier,y))[0];i?i.version=g.manifest.version:t.extensions.push({extensionIdentifier:y,version:g.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$jc)(g.location.fsPath,n.path)}}r(j){if(j){const g=(0,L.createHash)("md5");for(const y of j.extensions)g.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);j.hash=g.digest("hex")}}s(j=()=>null){return this.g.queue(()=>{let g=null;return h.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(g=j(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>g,y=>this.j.error(y))})}};$=pe([ie(0,c.$9h),ie(1,d.$ij)],$);function l(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const j of p.translations)if(typeof j.id!="string"||typeof j.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(te[146],ne([0,1,81,9,30,39]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function h(P,I,d){const f=await(0,L.$VC)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$VC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new f.AppInsightsCore,$=new E.PostChannel,l={instrumentationKey:P,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(d){l.extensionConfig={};const p={alwaysUseXhrOverride:!0,httpXHROverride:d};l.extensionConfig[$.identifier]=p}return v.initialize(l,[]),v.addTelemetryInitializer(p=>{I&&(p.ext=p.ext??{},p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),v}class c{constructor(I,d,f,E,v){this.e=I,this.f=d,this.g=f,this.h=v,this.c=N,this.d=b,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{I(d)},d=>{(0,R.$1)(d),console.error(d)})}}log(I,d){if(!this.a)return;d=(0,D.$in)(d,this.g),d=(0,A.$Fo)(d);const f=this.f+"/"+I;try{this.i(E=>{E.pluginVersionString=d?.properties.version??"Unknown",E.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$TN=c}),define(te[147],ne([0,1,2,30,13,29,106,25,43,148,32,36,26,39]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,p,j){this.k=p,this.l=j,this.d={},this.i=new L.$Rc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,A.$Ke)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ke)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(d.$vl)||g.affectsConfiguration(d.$xl)||g.affectsConfiguration(d.$wl))&&this.m()}))}setExperimentProperty(l,p){this.d[l]=p}m(){let l=(0,f.$Eo)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const j=p.usage?3:p.error?2:0;l=Math.min(l,j)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,p,j){this.g<p||(j=(0,R.$in)(j,this.d),j=(0,f.$Jo)(j,this.j),j=(0,R.$in)(j,this.c),this.b.forEach(g=>g.log(l,j)))}publicLog(l,p){this.n(l,3,p)}publicLog2(l,p){this.publicLog(l,p)}publicLogError(l,p){this.h&&this.n(l,2,p)}publicLogError2(l,p){this.publicLogError(l,p)}};e.$_q=E,e.$_q=E=pe([ie(1,b.$ui),ie(2,P.$Aj)],E);function v(){const $=(0,N.localize)(0,null,c.default.nameLong),l=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=D.$o?"":(0,N.localize)(3,null),j=(0,N.localize)(4,null),g=(0,N.localize)(5,null),y=(0,N.localize)(6,null),s=(0,N.localize)(7,null),o=`
|       | ${j} | ${g} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${$} ${l} ${p}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}I.$rn.as(h.$wn.Configuration).registerConfiguration({id:d.$ul,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[d.$vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$rn.as(h.$wn.Configuration).registerConfiguration({id:d.$ul,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[d.$xl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${d.$vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[149],ne([0,1,14,20,173,146]),function(G,e,L,R,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=void 0;async function N(P,I){const d=await I.request(P,R.CancellationToken.None),f=(await(0,L.$se)(d.stream)).toString(),E=d.res.statusCode??200;return{headers:d.res.headers,statusCode:E,responseData:f}}async function b(P){const I={method:P.type,headers:P.headers};return new Promise((f,E)=>{const v=D.request(P.url??"",I,$=>{$.on("data",function(l){f({headers:$.headers,statusCode:$.statusCode??200,responseData:l.toString()})}),$.on("error",function(l){E(l)})});v.write(P.data,$=>{$&&E($)}),v.end()})}async function h(P,I,d){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),E={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const v=P?await N(E,P):await b(E);d(v.statusCode,v.headers,v.responseData)}catch{d(0,{})}}class c extends A.$TN{constructor(I,d,f,E,v){const $={sendPOST:(l,p)=>{h(I,l,p)}};super(d,f,E,v,$)}}e.$UN=c}),define(te[150],ne([0,1,16,24]),function(G,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=void 0;async function D(A,N){const b=Object.create(null),h=(P,I)=>{const d=JSON.parse(P);b[I]=d};if(N){const P=[],I=await R.Promises.readdir(N);for(const f of I)try{(await R.Promises.stat((0,L.$jc)(N,f))).isDirectory()&&P.push(f)}catch{}const d=[];for(const f of P)(await R.Promises.readdir((0,L.$jc)(N,f))).filter(v=>v==="telemetry.json").length===1&&d.push(f);for(const f of d){const E=(await R.Promises.readFile((0,L.$jc)(N,f,"telemetry.json"))).toString();h(E,f)}}let c=(await R.Promises.readFile((0,L.$jc)(A,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await R.Promises.readFile((0,L.$jc)(A,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$h$b=D}),define(te[151],ne([0,1,13,82,26]),function(G,e,L,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=e.$z0b=void 0;async function A(b,h){let c=b.getItem(D.$sl);return(typeof c!="string"||L.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,R.$4m)(h.error.bind(h))),c}e.$z0b=A;async function N(b,h){let c=b.getItem(D.$tl);return typeof c!="string"&&(c=await(0,R.$5m)(h.error.bind(h))),c}e.$A0b=N}),define(te[22],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=void 0,e.$Tk=(0,L.$1h)("IUriIdentityService")}),define(te[152],ne([0,1,22,116,12,17,73,4,2]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let P=class{constructor(d){this.g=d,this.c=new h.$Rc,this.f=2**16;const f=new Map,E=v=>{let $=f.get(v.scheme);return $===void 0&&($=d.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,$)),$};this.c.add(b.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new A.$rg(E),this.d=new N.$Jr((v,$)=>this.extUri.compare(v,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$Dg)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((E,v)=>E[1].time<v[1].time?1:E[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let E=0;E<f;E++)this.d.set(d[E][0],d[E][1].touch())}};e.$Kr=P,e.$Kr=P=pe([ie(0,D.$jk)],P),(0,R.$Hr)(L.$Tk,P,1)}),define(te[153],ne([0,1,4,2,12,47,31]),function(G,e,L,R,D,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=void 0;class b extends R.$Sc{constructor(c,P,I,d,f,E){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Sd),this.onDidChangeFile=this.a.event,this.b=A.$7h.forUris(()=>!(this.capabilities&1024)),this.c=new N.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,P){return this.g.open(this.t(c),P)}close(c){return this.g.close(c)}read(c,P,I,d,f){return this.g.read(c,P,I,d,f)}write(c,P,I,d,f){return this.g.write(c,P,I,d,f)}watch(c,P){this.b.set(c,c);const I=this.g.watch(this.t(c),P);return(0,R.$Qc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,P,I){return this.g.rename(this.t(c),this.t(P),I)}readFile(c,P){return this.g.readFile(this.t(c),P)}readFileStream(c,P,I){return this.g.readFileStream(this.t(c),P,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,P,I){return this.g.writeFile(this.t(c),P,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,P){return this.g.delete(this.t(c),P)}copy(c,P,I){if((0,D.$nk)(this.g))return this.g.copy(this.t(c),this.t(P),I);throw new Error("copy not supported")}cloneFile(c,P){if((0,D.$ok)(this.g))return this.g.cloneFile(this.t(c),this.t(P));throw new Error("clone not supported")}s(c){const P=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const d=this.u(I.resource);this.b.findSubstr(d)&&P.push({resource:d,type:I.type,cId:I.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$X0b=b}),define(te[154],ne([0,1,108,16,47,17,11,10,15]),function(G,e,L,R,D,A,N,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.WorkbenchState=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0,e.$0h=(0,b.$1h)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$$h=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.$_h=P,e.$ai={id:"ext-dev"},e.$bi={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$ai:e.$bi;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$ci=I;function d(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$di=d;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$ei=f;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$fi=v;function $(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$gi=$;class l{constructor(n,r,u,k,S){this.h=n,this.j=u,this.k=k,this.l=S,this.c=D.$7h.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=D.$7h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$hi=l;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$Cg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ii=p;function j(i){return new p({uri:i,index:0,name:(0,A.$yg)(i)},{uri:i.toString()})}e.$ji=j,e.$ki="code-workspace",e.$li=`.${e.$ki}`,e.$mi=[{name:(0,L.localize)(0,null),extensions:[e.$ki]}],e.$ni="workspace.json";function g(i,n){return A.$tg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$oi=g;function y(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$pi=y,e.$qi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$qi}e.$ri=s;function o(i,n){return!g(i,n)&&!y(i)}e.$si=o;function t(i){return(typeof i=="string"?(0,R.$oc)(i):(0,A.$Ag)(i))===e.$li}e.$ti=t}),define(te[23],ne([0,1,41,4,2,17,11,107,18,12,10,6,154,31,22,8,28,29,3]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.ProfileResourceType=void 0;var j;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(j||(e.ProfileResourceType=j={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Uk=g,e.$Vk=(0,P.$1h)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Wk=y;function s(i,n,r,u,k,S){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:S&&k?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.$Cg)(r,"globalStorage"),settingsResource:S&&k?.useDefaultFlags?.settings?S.settingsResource:(0,A.$Cg)(r,"settings.json"),keybindingsResource:S&&k?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.$Cg)(r,"keybindings.json"),tasksResource:S&&k?.useDefaultFlags?.tasks?S.tasksResource:(0,A.$Cg)(r,"tasks.json"),snippetsHome:S&&k?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.$Cg)(r,"snippets"),extensionsResource:S&&k?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.$Cg)(r,"extensions.json"),cacheHome:(0,A.$Cg)(u,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Xk=s;let o=class extends D.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,u,k){super(),this.t=n,this.u=r,this.w=u,this.y=k,this.f=!0,this.h=this.B(new R.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Cg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Cg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,p.$Df)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}r.push(s((0,A.$zg)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},n))}}catch(S){this.y.error(S)}const u=new f.$Ac,k=new Map;if(r.length)try{const S=this.Q();if(S.workspaces)for(const[w,O]of Object.entries(S.workspaces)){const H=N.URI.parse(w),ee=r.find(_=>_.id===O);ee&&u.set(H,ee)}if(S.emptyWindows)for(const[w,O]of Object.entries(S.emptyWindows)){const H=r.find(ee=>ee.id===O);H&&k.set(w,H)}}catch(S){this.y.error(S)}this.z={profiles:r,workspaces:u,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",u=new RegExp(`${(0,l.$Ke)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const O=u.exec(w.name),H=O?parseInt(O[1]):0;k=H>k?H:k}const S=`${r} ${k+1}`;return this.createProfile((0,L.$Oi)((0,$.$lg)()).toString(16),S,{transient:!0},n)}async createNamedProfile(n,r,u){return this.createProfile((0,L.$Oi)((0,$.$lg)()).toString(16),n,r,u)}async createProfile(n,r,u,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(n,r,u);return k&&await this.setProfileForWorkspace(k,S),S}async F(n,r,u){if(!(0,p.$Df)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const S=this.profiles.find(H=>H.name===r||H.id===n);if(S)return S;const w=s(n,r,(0,A.$Cg)(this.profilesHome,n),this.g,u,this.defaultProfile);await this.u.createFolder(w.location);const O=[];return this.j.fire({profile:w,join(H){O.push(H)}}),await v.Promises.settled(O),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(k=>k.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=s(u.id,r.name??u.name,u.location,this.g,{shortName:r.shortName??u.shortName,icon:r.icon===null?void 0:r.icon??u.icon,transient:r.transient??u.isTransient,useDefaultFlags:r.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this.m.fire({profile:r,join(k){u.push(k)}});try{await Promise.allSettled(u)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$Ak)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(k=>k.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,u)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return N.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$$h)(n)?n.uri:(0,d.$di)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,u){const k=[...this.profiles,...n],S=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(O=>w.id===O.id)||(w=u.find(O=>w.id===O.id)??w,w.isTransient?this.s.profiles.push(w):S.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(S),this.z=void 0,this.J(n,r,u)}J(n,r,u){this.h.fire({added:n,removed:r,updated:u,all:this.profiles})}L(n,r,u){u=r?.isTransient?!0:u,u||this.L(n,void 0,!0);const k=this.G(n),S=u?this.s:this.C;N.URI.isUri(k)?(S.workspaces.delete(k),r&&S.workspaces.set(k,r)):(S.emptyWindows.delete(k),r&&S.emptyWindows.set(k,r)),u||this.M()}M(){const n={};for(const[u,k]of this.C.workspaces.entries())n[u.toString()]=k.id;const r={};for(const[u,k]of this.C.emptyWindows.entries())r[u.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},u=this.D();if(n.workspaces)for(const[S,w]of Object.entries(n.workspaces)){const O=N.URI.parse(w);r[S]=this.w.extUri.isEqual(O,u.location)?u.id:this.w.extUri.basename(O)}const k={};if(n.emptyWindows)for(const[S,w]of Object.entries(n.emptyWindows)){const O=N.URI.parse(w);k[S]=this.w.extUri.isEqual(O,u.location)?u.id:this.w.extUri.basename(O)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Yk=o,e.$Yk=o=pe([ie(0,h.$8h),ie(1,c.$jk),ie(2,E.$Tk),ie(3,I.$ij)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Zk=t}),define(te[155],ne([0,1,19,8,20,9,4,2,13,3,11,92,21,27,37,6,32,26,22,23]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=void 0;let g=class extends b.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,u,k,S,w){super(),this.z=n,this.C=r,this.D=u,this.F=k,this.G=S,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$Sd),this.s=this.B(new N.$Sd),this.t=this.B(new N.$Sd),this.u=this.B(new N.$Sd),this.w=this.B(new N.$Sd),this.y=[],this.B((0,b.$Qc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(u=>(0,d.$go)(u,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:S})=>(0,f.$Ko)(S,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(u){throw s(u)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$jo(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],u=[];await Promise.allSettled(n.map(async({extension:k,options:S})=>{try{const w=await this.O(k,!!S?.installGivenVersion,!!S?.installPreReleaseVersion);u.push({...w,options:S})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),u.length&&r.push(...await this.I(u));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!P.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$So)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$hm)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let u=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(u=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const S=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,f.$Ko)(w.identifier,n.identifier));S?this.w.fire(S):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:2,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async u=>{try{const k=await this.J(u,(S,w)=>n.some(O=>(0,f.$Oo)(w.identifier.id)===(0,f.$Po)(O.manifest.publisher,O.manifest.name))?!1:this.L(S,w));r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$Po)(u.manifest.publisher,u.manifest.name)},operation:2,source:u.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:u},k){const S=u.isApplicationScoped||u.isBuiltin||(0,E.$hm)(n),w={...u,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?u.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:S,profileLocation:S?this.H.defaultProfile.extensionsResource:u.profileLocation??this.Y()},O=ue=>`${f.$Lo.create(ue).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const ue=this.j.get(O(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const H=[],ee=[],_=[],re=this.Z(n,r,w);P.URI.isUri(r)||this.j.set(O(r),{task:re,waitingTasks:[]}),this.n.fire({identifier:re.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",re.identifier.id),H.push({task:re,manifest:n});let se=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",re.identifier.id);else try{const ce=await this.N(re.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),oe=await this.getInstalled(void 0,w.profileLocation),q={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[d.$bo]:!0}};for(const{gallery:K,manifest:T}of(0,L.$Mb)(ce,({gallery:M})=>M.identifier.id)){se=se||!!T.extensionDependencies?.some(J=>(0,f.$Ko)({id:J},re.identifier));const M=O(K),B=this.j.get(M);if(B){if(k(re,B.task)){const J=B.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,re.identifier.id),B.waitingTasks.push(re),ee.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,Y=>Y.some(Q=>(0,f.$Ko)(Q.identifier,J)))).then(Y=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,re.identifier.id),!Y.find(F=>(0,f.$Ko)(F.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!oe.some(({identifier:J})=>(0,f.$Ko)(J,K.identifier))){const J=this.Z(T,K,q);this.j.set(M,{task:J,waitingTasks:[re]}),this.n.fire({identifier:J.identifier,source:K,profileLocation:w.profileLocation}),this.F.info("Installing extension:",J.identifier.id,re.identifier.id),H.push({task:J,manifest:T})}}}catch(ce){if(P.URI.isUri(re.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",re.identifier.id,ce.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",re.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",re.identifier.id),ce}const ue=H.reduce((ce,{task:oe,manifest:q})=>(ce.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:q}),ce),new Map);for(;ue.size;){let ce;const oe=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(K=>ue.has(K.toLowerCase())));oe.length?ce=ue.size===1?oe:oe.filter(({task:q})=>!(q===re&&!se)):(this.F.info("Found extensions with circular dependencies",oe.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const K=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(M=>M.postInstall(T,q.source,w,D.CancellationToken.None))),!P.URI.isUri(q.source)){const M=q.operation===3,B=M?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$So)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-K,durationSinceUpdate:B}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}_.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw P.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$So)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-K,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return ee.length&&await this.M(ee),_.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),_}catch(ue){if(H.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:oe})=>this.$(oe,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let oe=0;oe<ce.length;oe++){const q=ce[oe],{identifier:K}=_[oe];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",K.id):this.F.warn("Rollback: Error while uninstalling extension",K.id,(0,A.$0)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,A.$0)(ce),_.map(({identifier:oe})=>oe.id))}return H.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:ue}))}finally{for(const{task:ue}of H)ue.source&&!P.URI.isUri(ue.source)&&this.j.delete(O(ue.source))}}L(n,r){for(const[,{task:u,waitingTasks:k}]of this.j.entries())if(u===n&&(k.includes(r)||k.some(S=>this.L(S,r)))||u===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],u=[],k=await Promise.allSettled(n);for(const S of k)S.status==="fulfilled"?r.push(S.value):u.push(S.reason);if(u.length)throw y(u);return r}async N(n,r,u,k,S){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,S),O=[],H=[],ee=async(_,re)=>{O.push(_);const se=re.extensionDependencies||[],ue=[...se];if(re.extensionPack){const ce=u?w.find(oe=>(0,f.$Ko)(oe.identifier,_)):void 0;for(const oe of re.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Ko)({id:q},{id:oe}))||ue.every(q=>!(0,f.$Ko)({id:q},{id:oe}))&&ue.push(oe)}if(ue.length){const ce=ue.filter(oe=>O.every(q=>!(0,f.$Ko)(q,{id:oe})));if(ce.length){const oe=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),D.CancellationToken.None);for(const q of oe){if(O.find(M=>(0,f.$Ko)(M,q.identifier)))continue;const K=se.some(M=>(0,f.$Ko)({id:M},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(M){if(K)throw M;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$0)(M));continue}H.push({gallery:T.extension,manifest:T.manifest}),await ee(T.extension.identifier,T.manifest)}}}};return await ee(n,r),H}async O(n,r,u){let k;const S=await this.getExtensionsControlManifest();if(S.malicious.some(H=>(0,f.$Ko)(n.identifier,H)))throw new d.$jo(I.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=S.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!k)throw new d.$jo(I.localize(2,null,n.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new d.$jo(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$co)(H)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,u),!k)throw!u&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],D.CancellationToken.None))[0]?new d.$jo(I.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$jo(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const O=await this.z.getManifest(k,D.CancellationToken.None);if(O===null)throw new d.$jo(`Missing manifest for extension ${k.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(O.version!==k.version)throw new d.$jo(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:O}}async P(n,r,u){const k=await this.getTargetPlatform();let S=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==u&&(S=(await this.z.getExtensions([{...n.identifier,preRelease:u}],{targetPlatform:k,compatible:!0},D.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(n,u,k)&&(S=n),S||(r?S=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},D.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(n,u,k)),S}async Q(n,r){const u={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=_=>`${_.id.toLowerCase()}${u.versionOnly?`-${n.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,S=this.m.get(k(n.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),S.waitUntilTaskIsFinished();const w=_=>{const re=this.$(_,u);return this.m.set(k(re.extension.identifier),re),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:u.profileLocation,applicationScoped:_.isApplicationScoped}),re},O=(_,re)=>{re?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,u.profileLocation.toString(),re.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,re.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Ro)(_),error:re}),this.u.fire({identifier:_.identifier,error:re?.code,profileLocation:u.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],ee=[];try{H.push(w(n));const _=await this.getInstalled(1,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const re=this.U(n,_);for(const se of re)this.m.has(k(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):H.push(w(se))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(re=>re.extension),_,n),await this.M(H.map(async re=>{try{if(await re.run(),await this.M(this.y.map(se=>se.postUninstall(re.extension,u,D.CancellationToken.None))),re.extension.identifier.uuid)try{await this.z.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}O(re.extension)}catch(se){const ue=se instanceof d.$jo?se:new d.$jo((0,A.$0)(se),d.ExtensionManagementErrorCode.Internal);throw O(re.extension,ue),ue}finally{ee.push(re)}}))}catch(_){const re=_ instanceof d.$jo?_:new d.$jo((0,A.$0)(_),d.ExtensionManagementErrorCode.Internal);for(const se of H){try{se.cancel()}catch{}ee.includes(se)||O(se.extension,re)}throw re}finally{for(const _ of H)this.m.delete(k(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,u){for(const k of n){const S=this.W(k,r);if(S.length){const w=S.filter(O=>!n.some(H=>(0,f.$Ko)(H.identifier,O.identifier)));if(w.length)throw new Error(this.S(k,w,u))}}}S(n,r,u){return u===n?r.length===1?I.localize(6,null,u.manifest.displayName||u.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,u.manifest.displayName||u.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,u.manifest.displayName||u.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,u=[]){if(u.indexOf(n)!==-1)return[];u.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const S=r.filter(O=>!O.isBuiltin&&k.some(H=>(0,f.$Ko)({id:H},O.identifier))),w=[];for(const O of S)w.push(...this.U(O,r,u));return[...S,...w]}return[]}W(n,r){return r.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(k=>(0,f.$Ko)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Ap=g,e.$Ap=g=pe([ie(0,d.$io),ie(1,l.$nl),ie(2,p.$Tk),ie(3,v.$ij),ie(4,$.$Aj),ie(5,j.$Vk)],g);function y(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,u)=>new Error(`${r.message}${r.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}e.$Bp=y;function s(i){if(i instanceof d.$jo)return i;const n=new d.$jo(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$Cp=s;function o(i,n,{extensionData:r,verificationStatus:u,duration:k,error:S,durationSinceUpdate:w}){let O,H;(0,c.$Lf)(u)&&(u===!0?u="Verified":(u===!1||(O=d.ExtensionManagementErrorCode.Signature,H=u),u="Unverified")),S&&(S instanceof d.$jo?(O=S.code,S.code===d.ExtensionManagementErrorCode.Signature&&(H=S.message)):O=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:u,success:!S,duration:k,errorcode:O,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new R.$Zg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Og)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Og)(n=>new Promise((r,u)=>{const k=n.onCancellationRequested(()=>{k.dispose(),u(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$Dp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class j extends Error{constructor(t,i){super(t),this.code=i}}e.$Ep=j,e.$Fp=(0,I.$1h)("IExtensionsProfileScannerService");let g=class extends D.$Sc{constructor(t,i,n,r,u,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=u,this.t=k,this.b=this.B(new A.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new N.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,u=>{const k=[];for(const S of u)t.some(([w])=>(0,c.$Ko)(w.identifier,S.identifier)&&w.manifest.version!==S.version)?n.push(S):k.push(S);for(const[S,w]of t){const O=k.findIndex(ee=>(0,c.$Ko)(ee.identifier,S.identifier)&&ee.version===S.manifest.version),H={identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:w};O===-1?(r.push(H),k.push(H)):k.splice(O,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(u){throw r.length&&this.c.fire({extensions:r,error:u,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:u,profileLocation:i}),u}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const u=[];for(const k of r){const S=t.find(([w])=>(0,c.$Ko)(w.identifier,k.identifier)&&w.manifest.version===k.version);S&&(k.metadata={...k.metadata,...S[1]},n.push(k)),u.push(k)}return u}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const u=[];for(const k of r)(0,c.$Ko)(k.identifier,t.identifier)?n.push(k):u.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),u}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],u;try{const k=await this.m.readFile(t);u=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,P.$Ak)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&n?.bailOutWhenFileNotFound)throw new j((0,$.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.w(t);let k=!1;for(const S of u){y(S)||this.w(t);let w;if((0,v.$Df)(S.relativeLocation)&&S.relativeLocation)w=this.z(S.relativeLocation);else if((0,v.$Df)(S.location))w=this.z(S.location),k=!0,S.relativeLocation=S.location,S.location=w.toJSON();else{w=b.URI.revive(S.location);const O=this.y(w);O&&(k=!0,S.relativeLocation=O)}r.push({identifier:S.identifier,location:w,version:S.version,metadata:S.metadata})}k&&await this.m.writeFile(t,R.$ge.fromString(JSON.stringify(u)))}if(i){r=i(r);const k=r.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(t,R.$ge.fromString(JSON.stringify(k)))}return r})}w(t){const i=new j(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(u){if((0,P.$Ak)(u)===1)return;throw u}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const u=JSON.parse(n);Array.isArray(u)&&u.every(k=>y(k))?r=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ge.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,P.$Ak)(u)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(t)}catch(u){(0,P.$Ak)(u)!==1&&this.t.error(u)}try{await this.m.del(i)}catch(u){(0,P.$Ak)(u)!==1&&this.t.error(u)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$8g,this.h.set(t,i)),i}};e.$Gp=g,e.$Gp=g=pe([ie(1,P.$jk),ie(2,f.$Vk),ie(3,E.$Tk),ie(4,l.$nl),ie(5,d.$ij)],g);function y(o){return(0,v.$Ff)(o)&&(0,h.$ho)(o.identifier)&&(s(o.location)||(0,v.$Df)(o.location)&&o.location)&&((0,v.$Kf)(o.relativeLocation)||(0,v.$Df)(o.relativeLocation))&&o.version&&(0,v.$Df)(o.version)}function s(o){return o?(0,v.$Df)(o.path)&&(0,v.$Df)(o.scheme):!1}}),define(te[51],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,96,18,27,37,49,12,10,6,32,4,46,40,23,22,113]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j,g,y,s,o,t,i,n,r,u,k,S,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.Translations=void 0;var H;(function(oe){function q(K,T){if(K===T)return!0;const M=Object.keys(K),B=new Set;for(const J of Object.keys(T))B.add(J);if(M.length!==B.size)return!1;for(const J of M){if(K[J]!==T[J])return!1;B.delete(J)}return B.size===0}oe.equals=q})(H||(e.Translations=H={})),e.$Jp=(0,t.$1h)("IExtensionsScannerService");let ee=class extends c.$Sc{constructor(q,K,T,M,B,J,Y,Q,F,C,a,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=K,this.r=T,this.s=M,this.t=B,this.u=J,this.w=Y,this.y=Q,this.z=F,this.C=C,this.D=a,this.F=m,this.g=this.B(new r.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Cg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Vo)(this.w,this.y)),this.G}async scanAllExtensions(q,K,T){const[M,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(K)]),J=T?await this.scanExtensionsUnderDevelopment(q,[...M,...B]):[];return this.L(M,B,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const K=[];K.push(this.M(!!q.useCache,q.language)),K.push(this.N(q.language,!!q.checkControlFile));const[T,M]=await Promise.all(K);return this.J([...T,...M],0,q,!1)}async scanUserExtensions(q){const K=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(K,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let J;try{J=await B.scanExtensions(M)}catch(Y){if(Y instanceof k.$Ep&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),J=await B.scanExtensions(M);else throw Y}return J=await this.J(J,1,q,!0),this.y.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(q,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===P.Schemas.file).map(async M=>{const B=await this.P(M,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Y=>(Y.type=K.find(Q=>(0,g.$Ko)(Q.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,K,T){const M=await this.P(q,!1,K,!0,T.language,!0,void 0),B=await this.n.scanExtension(M);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,K,T){const M=await this.P(q,!1,K,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(M);return this.J(B,K,T,!0)}async scanMetadata(q){const K=(0,f.$Cg)(q,"package.json"),T=(await this.w.readFile(K)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,K){const T=(0,f.$Cg)(q,"package.json"),M=(await this.w.readFile(T)).value.toString(),B=JSON.parse(M);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,B.__metadata={...B.__metadata,...K},await this.w.writeFile((0,f.$Cg)(q,"package.json"),A.$ge.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$Ep&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ge.fromString(JSON.stringify([])))}catch(K){(0,o.$Ak)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,K,T,M){return T.includeAllVersions||(q=this.L(K===0?q:void 0,K===1?q:void 0,K==="development"?q:void 0,await this.getTargetPlatform(),M)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,J)=>{const Y=I.$nc(B.location.fsPath),Q=I.$nc(J.location.fsPath);return Y<Q?-1:Y>Q?1:0})}L(q,K,T,M,B){const J=(Q,F,C)=>{if(Q.isValid&&!F.isValid)return!1;if(Q.isValid===F.isValid){if(B&&E.gt(Q.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(E.eq(Q.manifest.version,F.manifest.version)){if(Q.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===M)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`),!0},Y=new y.$gm;return q?.forEach(Q=>{const F=Y.get(Q.identifier.id);(!F||J(F,Q,!1))&&Y.set(Q.identifier.id,Q)}),K?.forEach(Q=>{const F=Y.get(Q.identifier.id);if(!F&&q&&Q.type===0){this.y.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!F||J(F,Q,!1))&&Y.set(Q.identifier.id,Q)}),T?.forEach(Q=>{const F=Y.get(Q.identifier.id);(!F||J(F,Q,!0))&&Y.set(Q.identifier.id,Q),Y.set(Q.identifier.id,Q)}),[...Y.values()]}async M(q,K){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,K){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const M=K?await this.O():{},B=[],J=l.URI.file(I.$hc(I.$jc(P.$jg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of T){const F=M[Q.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":B.push((0,f.$Cg)(J,Q.name));break;default:B.push(l.URI.file(F));break}}const Y=await Promise.all(B.map(async Q=>this.n.scanExtension(await this.P(Q,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,L.$Hb)(Y)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,K,T,M,B,J,Y){const Q=await this.f(B??d.$w),F=await this.Q(q),C=K&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=C?await this.Q(C):void 0;return new _(q,F,C,a,K,Y,T,M,J,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,Q)}async Q(q){try{const K=await this.w.stat(q);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Kp=ee,e.$Kp=ee=pe([ie(4,S.$Vk),ie(5,k.$Fp),ie(6,o.$jk),ie(7,i.$ij),ie(8,j.$8h),ie(9,n.$Aj),ie(10,w.$Tk),ie(11,t.$Zh)],ee);class _{constructor(q,K,T,M,B,J,Y,Q,F,C,a,m,z,U,X){this.location=q,this.mtime=K,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=M,this.profile=B,this.profileScanOptions=J,this.type=Y,this.excludeObsolete=Q,this.validate=F,this.productVersion=C,this.productDate=a,this.productCommit=m,this.devMode=z,this.language=U,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,K){return(0,f.$vg)(q.location,K.location)&&q.mtime===K.mtime&&(0,f.$vg)(q.applicationExtensionslocation,K.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&q.profile===K.profile&&D.$jn(q.profileScanOptions,K.profileScanOptions)&&q.type===K.type&&q.excludeObsolete===K.excludeObsolete&&q.validate===K.validate&&q.productVersion===K.productVersion&&q.productDate===K.productDate&&q.productCommit===K.productCommit&&q.devMode===K.devMode&&q.language===K.language&&H.equals(q.translations,K.translations)}}e.$Lp=_;let re=class extends c.$Sc{constructor(q,K,T,M,B){super(),this.f=q,this.g=K,this.h=T,this.j=M,this.m=B}async scanExtensions(q){const K=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(M)}catch{}return(0,$.$Qf)(T)?K:K.filter(M=>!T[g.$Lo.create(M).toString()])}async n(q){const K=await this.j.resolve(q.location);if(!K.children?.length)return[];const T=await Promise.all(K.children.map(async M=>{if(!M.isDirectory||q.type===1&&(0,f.$zg)(M.resource).indexOf(".")===0)return null;const B=new _(M.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Hb)(T).sort((M,B)=>M.location.path<B.location.path?-1:1)}async r(q){let K=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){K=K.filter(M=>!M.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,q);K.push(...T)}return K}async s(q,K,T){const M=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!M.length)return[];const B=await Promise.all(M.map(async J=>{if(K(J)){const Y=new _(J.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Y,J.metadata)}return null}));return(0,L.$Hb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$Cg)(q.location,"package.json"))){const K=await this.scanExtension(q);return K?[K]:[]}else return await this.scanExtensions(q)}catch(K){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,N.$0)(K)),[]}}async scanExtension(q,K){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=y.$am),K=K??T.__metadata,delete T.__metadata;const M=(0,g.$Po)(T.publisher,T.name),B=K?.id?{id:M,uuid:K.id}:{id:M},J=K?.isSystem?0:q.type,Y=J===0||!!K?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const Q={type:J,identifier:B,manifest:T,location:q.location,isBuiltin:Y,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return q.validate?this.validate(Q,q):Q}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,K){let T=!0;const M=(0,s.$1o)(K.productVersion,K.productDate,K.location,q.manifest,q.isBuiltin);for(const[B,J]of M)B===v.default.Error&&(T=!1,this.m.error(this.z(K.location,J)));return q.isValid=T,q.validations=M,q}async scanExtensionManifest(q){const K=(0,f.$Cg)(q,"package.json");let T;try{T=(await this.j.readFile(K)).value.toString()}catch(B){return(0,o.$Ak)(B)!==1&&this.m.error(this.z(q,(0,p.localize)(0,null,K.path,B.message))),null}let M;try{M=JSON.parse(T)}catch{const J=[];(0,b.$8m)(T,J);for(const Y of J)this.m.error(this.z(q,(0,p.localize)(1,null,K.path,Y.offset,Y.length,(0,h.$Hp)(Y.error))));return null}return(0,b.$en)(M)!=="object"?(this.m.error(this.z(q,(0,p.localize)(2,null,K.path))),null):M}async t(q,K,T){const M=await this.u(q,K,T);if(M)try{const B=[],J=await this.w(M.default,B);if(B.length>0)return B.forEach(Q=>{this.m.error(this.z(q,(0,p.localize)(3,null,M.default?.path,(0,h.$Hp)(Q.error))))}),K;if((0,b.$en)(M)!=="object")return this.m.error(this.z(q,(0,p.localize)(4,null,M.default?.path))),K;const Y=M.values||Object.create(null);return(0,O.$Ip)(this.m,K,Y,J)}catch{}return K}async u(q,K,T){const M=(0,f.$Cg)(q,"package.nls.json"),B=(F,C)=>{C.forEach(a=>{this.m.error(this.z(q,(0,p.localize)(5,null,F?.path,(0,h.$Hp)(a.error))))})},J=F=>{this.m.error(this.z(q,(0,p.localize)(6,null,F?.path)))},Y=`${K.publisher}.${K.name}`,Q=T.translations[Y];if(Q)try{const F=l.URI.file(Q),C=(await this.j.readFile(F)).value.toString(),a=[],m=(0,b.$8m)(C,a);return a.length>0?(B(F,a),{values:void 0,default:M}):(0,b.$en)(m)!=="object"?(J(F),{values:void 0,default:M}):{values:m.contents?m.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let C;try{C=await this.y(q,T)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const a=(await this.j.readFile(C.localized)).value.toString(),m=[],z=(0,b.$8m)(a,m);return m.length>0?(B(C.localized,m),{values:void 0,default:C.original}):(0,b.$en)(z)!=="object"?(J(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(q,K){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,b.$8m)(T,K)}catch{}}y(q,K){return new Promise((T,M)=>{const B=J=>{const Y=(0,f.$Cg)(q,`package.nls.${J}.json`);this.j.exists(Y).then(Q=>{Q&&T({localized:Y,original:(0,f.$Cg)(q,"package.nls.json")});const F=J.lastIndexOf("-");F===-1?T({localized:(0,f.$Cg)(q,"package.nls.json"),original:null}):(J=J.substring(0,F),B(J))})};if(K.devMode||K.pseudo||!K.language)return T({localized:(0,f.$Cg)(q,"package.nls.json"),original:null});B(K.language)})}z(q,K){return`[${q.path}]: ${K}`}};re=pe([ie(1,k.$Fp),ie(2,w.$Tk),ie(3,o.$jk),ie(4,i.$ij)],re);let se=class extends re{constructor(q,K,T,M,B,J,Y){super(K,M,B,J,Y),this.G=q,this.H=T,this.D=this.B(new R.$Yg(3e3)),this.F=this.B(new r.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const K=this.M(q),T=await this.I(K);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=l.URI.revive(B.location),B));const M=await super.scanExtensions(q);return await this.J(K,{input:q,result:M}),M}async I(q){try{const K=await this.j.readFile(q),T=JSON.parse(K.value.toString());return{result:T.result,input:(0,u.$xh)(T.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",q.path,(0,N.$0)(K))}return null}async J(q,K){try{await this.j.writeFile(q,A.$ge.fromString(JSON.stringify(K)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,N.$0)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),K=await this.I(q);if(!K)return;const T=K.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$jn(M,T))try{this.m.info("Invalidating Cache",T,M),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const K=this.N(q);return this.h.extUri.joinPath(K.cacheHome,q.type===0?y.$_l:y.$$l)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(q.location,K.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,S.$Vk),ie(3,k.$Fp),ie(4,w.$Tk),ie(5,o.$jk),ie(6,i.$ij)],se);function ue(oe,q){const K=(0,g.$No)(oe.manifest.publisher,oe.manifest.name);return{id:K,identifier:new y.$em(K),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:q,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$Mp=ue;class ce extends ee{constructor(q,K,T,M,B,J,Y,Q,F,C,a,m){super(q,K,(0,f.$Cg)(T,".vscode-oss-dev","extensions","control.json"),M,B,J,Y,Q,F,C,a,m),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(l.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Np=ce}),define(te[156],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,L,R,D,A,N,b,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;let d=class extends N.$Sc{constructor(E,v){super(),this.b=E,this.f=v,this.a=new R.$7g(5)}async postUninstall(E){const v=this.g(E,"uninstall");v&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(E))}catch($){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error($)}}g(E,v){const $=`vscode:${v}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[$]=="string"){const l=E.manifest.scripts[$].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${$} should be a node script`),null):{script:(0,h.$jc)(E.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(E,v,$,l,p){return new Promise((j,g)=>{const y=this.j(E,v,$,p);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?g(t):j(void 0)};y.on("error",t=>{o((0,D.$Li)(t)||"Unknown")}),y.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),l&&(s=setTimeout(()=>{s=null,y.kill(),g("timed out")},5e3))})}j(E,v,$,l){const p={silent:!0,execArgv:void 0},j=(0,L.fork)(E,[`--type=extension-post-${v}`,...$],p);j.stdout.setEncoding("utf8"),j.stderr.setEncoding("utf8");const g=A.Event.fromNodeEventEmitter(j.stdout,"data"),y=A.Event.fromNodeEventEmitter(j.stderr,"data");g(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${v}`,t)),y(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${v}`,t));const s=A.Event.any(A.Event.map(g,t=>({data:`%c${t}`,format:[""]})),A.Event.map(y,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),j}m(E){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Pp=d,e.$Pp=d=pe([ie(0,I.$Vk),ie(1,P.$ij)],d)}),define(te[157],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,48,97,59,18,155,21,27,40,51,142,156,114,135,143,49,12,10,6,32,26,22,23]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j,g,y,s,o,t,i,n,r,u,k,S,w,O,H,ee,_,re,se,ue,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0,e.$Tp=(0,_.$2h)(t.$ko);const q=".vsctmp";let K=class extends o.$Ap{constructor(F,C,a,m,z,U,X,W,le,ae,me,de){super(F,C,me,a,ae,de),this.fb=z,this.gb=U,this.hb=X,this.ib=le,this.eb=new Map,this.rb=new P.$Bc;const ge=this.B(W.createInstance(k.$Pp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Rp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(u.$Op));const fe=this.B(new O.$Sp(this,this.fb,de,U,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Vo)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.pb(F),a=await(0,j.zip)((0,f.$Cg)(this.db.extensionsDownloadDir,(0,l.$lg)()).fsPath,C);return $.URI.file(a)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:a}=await this.lb(F),m=d.$kc(C.fsPath);try{return await(0,S.$Qp)(m)}finally{await a()}}getInstalled(F,C=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,C={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:a,cleanup:m}=await this.lb(F);try{const z=await(0,S.$Qp)(d.$kc(a.fsPath)),U=(0,i.$Po)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,H.$3o)(z.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,U,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:C}])).find(({identifier:le})=>(0,i.$Ko)(le,{id:U}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$Cp)(new Error(`Unknown error while installing extension ${U}`))}finally{await m()}}async installFromLocation(F,C){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const a=await this.bb.scanUserExtensionAtLocation(F);if(!a)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[a,void 0]],C),this.F.info("Successfully installed extension",a.identifier.id,C.toString()),a}async installExtensionsFromProfile(F,C,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),a.toString());const m=(await this.bb.scanExtensions(1,C)).filter(z=>F.some(U=>(0,i.$Ko)(U,z.identifier)));if(m.length){const z=await Promise.all(m.map(U=>this.bb.scanMetadata(U,C)));await this.ub(m.map((U,X)=>[U,z[X]]),a),this.F.info("Successfully installed extensions",m.map(U=>U.identifier.id),a.toString())}return m}async updateMetadata(F,C,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped===!1&&(C.isMachineScoped=void 0),C.isBuiltin===!1&&(C.isBuiltin=void 0),C.pinned===!1&&(C.pinned=void 0),F=await this.bb.updateMetadata(F,C,a),this.cb.invalidate(a),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const C=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},D.CancellationToken.None);if(!a)throw new Error(g.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(m){throw new Error(g.localize(3,null,(0,A.$Li)(m)))}return this.installFromGallery(a)}ab(F,C,a,m){return this.bb.copyExtension(F,C,a,m)}copyExtensions(F,C){return this.bb.copyExtensions(F,C)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,C,a){const{location:m}=await this.db.download(F,C,!a);return m}async lb(F){if(F.scheme===I.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const C=(0,f.$Cg)(this.db.extensionsDownloadDir,(0,l.$lg)());return await this.hb.download(F,C),this.F.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.ib.del(C)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,C,a){if($.URI.isUri(C))return new J(F,C,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=i.$Lo.create(C).toString();let z=this.eb.get(m);return z||(this.eb.set(m,z=new B(F,C,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),z}$(F,C){return new Y(F,C.profileLocation,this.gb)}async pb(F){const C=async m=>{let z=await p.Promises.readdir(m);z=z.map(W=>d.$jc(m,W));const U=await Promise.all(z.map(W=>p.Promises.stat(W)));let X=Promise.resolve([]);return U.forEach((W,le)=>{const ae=z[le];W.isFile()&&(X=X.then(me=>[...me,ae])),W.isDirectory()&&(X=X.then(me=>C(ae).then(de=>[...me,...de])))}),X};return(await C(F.location.fsPath)).map(m=>({path:`extension/${d.$lc(F.location.fsPath,m)}`,localPath:m}))}async qb({added:F,removed:C}){if(C){const a=F&&this.D.extUri.isEqual(C.profileLocation,F.profileLocation)?C.extensions.filter(m=>F.extensions.every(z=>!(0,i.$Ko)(z,m))):C.extensions;for(const m of a)this.F.info("Extensions removed from another source",m.id,C.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:C.profileLocation})}if(F){const m=(await this.bb.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(U=>(0,i.$Ko)(U,z.identifier)));this.s.fire(m.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(C=>this.rb.add(C)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.rb.add(C.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(C=>this.tb(C)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const C=[];for(const a of F.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(a);m&&m.installedTimestamp===void 0&&(this.rb.add(a),C.push(m))}C.length&&(await this.ub(C.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",C.map(a=>a.identifier.id)))}async ub(F,C){const a=F.map(m=>m[0]);await this.vb(a),await this.gb.addExtensionsToProfile(F,C),this.s.fire(a.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:C})))}async vb(F){const C=await this.bb.getUninstalledExtensions();for(const a of F){const m=i.$Lo.create(a);C[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Up=K,e.$Up=K=pe([ie(0,t.$io),ie(1,ue.$nl),ie(2,re.$ij),ie(3,s.$9h),ie(4,r.$Jp),ie(5,n.$Fp),ie(6,y.$Zn),ie(7,_.$Zh),ie(8,ee.$jk),ie(9,se.$Aj),ie(10,ce.$Tk),ie(11,oe.$Vk)],K);let T=class extends c.$Sc{constructor(F,C,a,m,z,U){super(),this.j=F,this.m=C,this.n=a,this.s=m,this.t=z,this.u=U,this.h=this.B(new b.$Sd),this.onExtract=this.h.event,this.c=(0,f.$Cg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$8g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,C){const a={includeInvalid:!0,profileLocation:C};let m=[];return F===null||F===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):F===1&&m.push(...await this.n.scanUserExtensions(a)),m=F!==null?m.filter(z=>z.type===F):m,Promise.all(m.map(z=>this.F(z)))}async scanAllUserExtensions(F){const C=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(a=>this.F(a)))}async scanUserExtensionAtLocation(F){try{const C=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.F(C)}catch(C){this.u.error(C)}return null}async extractUserExtension(F,C,a,m,z){const U=F.toString(),X=$.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$lg)()}`)),W=$.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,U));let le=await this.m.exists(W);if(le&&m){try{await this.y(F.id,W,"removeExisting")}catch{throw new t.$jo(g.localize(4,null,W.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${C} to ${W.fsPath}`),await(0,j.$yp)(C,X.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,F.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof j.$wp&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$jo(ae.message,me)}await this.n.updateMetadata(X,a);try{this.u.trace(`Started renaming the extension from ${X.fsPath} to ${W.fsPath}`),await this.C(X.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,N.$0)(ae)}. Deleted from extracted location`,X),ae}this.h.fire(W)}catch(ae){try{await this.m.del(X,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(F,C){return C?(await this.w(F,C))?.metadata:this.n.scanMetadata(F.location)}async w(F,C){return(await this.s.scanProfileExtensions(C)).find(m=>(0,i.$Ko)(m.identifier,F.identifier))}async updateMetadata(F,C,a){return a?await this.s.updateMetadata([[F,C]],a):await this.n.updateMetadata(F.location,C),this.D(F.location,F.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const C=F.map(a=>i.$Lo.create(a));await this.z(a=>C.forEach(m=>{a[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(F){await this.z(C=>delete C[F.toString()])}async removeExtension(F,C){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,C)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(C=>delete C[i.$Lo.create(F).toString()])}async copyExtension(F,C,a,m){const z=await this.w(F,C),U=await this.w(F,a);return m={...z?.metadata,...m},U?await this.s.updateMetadata([[F,{...U.metadata,...m}]],a):await this.s.addExtensionsToProfile([[F,m]],a),this.D(F.location,F.type,a)}async copyExtensions(F,C){const a=await this.scanExtensions(1,F),m=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(m,C)}async y(F,C,a){this.u.trace(`Deleting ${a} extension from disk`,F,C.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(C),`${this.t.extUri.basename(C)}.${(0,h.$Oi)((0,l.$lg)()).toString(16)}${q}`);await this.C(C.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,F,C.fsPath)}async z(F){return this.g.queue(async()=>{let C;try{C=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,ee.$Ak)(m)!==1)throw m}let a={};if(C)try{a=JSON.parse(C)}catch{}return F&&(F(a),Object.keys(a).length?await this.m.writeFile(this.c,R.$ge.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(F,C){try{await p.Promises.rename(F,C,2*60*1e3)}catch(a){throw new t.$jo(a.message||g.localize(5,null,F,C),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,C,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(U=>this.t.extUri.isEqual(U.location,F));if(z)return this.F(z)}else{const m=await this.n.scanExistingExtension(F,C,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(g.localize(6,null,F.path))}async F(F){const C=await this.m.resolve(F.location);let a,m;return C.children&&(a=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,m=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:a,changelogUrl:m,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of C)F[i.$Lo.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Qo)(C,U=>U.identifier);await L.Promises.settled(z.map(async U=>{const X=U.sort((W,le)=>E.rcompare(W.manifest.version,le.manifest.version))[0];a.has(X.identifier.id.toLowerCase())||await this.j(await this.F(X))}))}catch(z){this.u.error(z)}const m=C.filter(z=>z.metadata&&F[i.$Lo.create(z).toString()]);await Promise.allSettled(m.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(C){(0,ee.$Ak)(C)!==1&&this.u.error(C);return}if(F?.children)try{await Promise.allSettled(F.children.map(async C=>{if(!(!C.isDirectory||!C.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",C.resource.toString());try{await this.m.del(C.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",C.resource.toString())}catch(a){(0,ee.$Ak)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Vp=T,e.$Vp=T=pe([ie(1,ee.$jk),ie(2,r.$Jp),ie(3,n.$Fp),ie(4,ce.$Tk),ie(5,re.$ij)],T);class M extends o.$Dp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Kf)(this.options.operation)?this.l:this.options.operation}constructor(F,C,a,m,z,U,X,W,le){super(),this.identifier=F,this.source=C,this.options=a,this.m=m,this.n=z,this.o=U,this.p=X,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[C,a]=await this.x(F);return this.j=C.isBuiltin||C.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,a]],this.j),C}async u({zipPath:F,key:C,metadata:a},m,z){let U=await this.v(C);return U||(this.s.trace("Extracting extension...",C.id),U=await this.m.extractUserExtension(C,F,a,m,z),this.s.info("Extracting extension completed.",C.id)),U}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(m=>i.$Lo.create(m).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class B extends M{constructor(F,C,a,m,z,U,X,W,le,ae){super(C.identifier,C,a,z,U,X,W,le,ae),this.y=C,this.z=m}async x(F){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(X=>(0,i.$Ko)(X.identifier,this.y.identifier));a&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??a?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Jf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,m),m];const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Lo.create(this.y),metadata:m},!1,F),m]}catch(X){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,N.$0)(W))}throw X}}async B(F){try{await(0,S.$Qp)(F)}catch(C){throw new t.$jo((0,o.$Bp)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Wp=B;class J extends M{constructor(F,C,a,m,z,U,X,W,le,ae){super({id:(0,i.$Po)(F.publisher,F.name)},C,a,z,U,X,W,le,ae),this.y=F,this.z=C,this.A=m}async h(F){const C=await super.h(F);return this.D(C,F),C}async x(F){const C=new i.$Lo(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,i.$Ko)(this.identifier,X.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??m?.pinned};if(m)if(this.l=3,C.equals(new i.$Lo(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(g.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const X=await this.v(C);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(g.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:C,metadata:z},!0,F),z]}async D(F,C){try{let[a]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],C);if(a||([a]=await this.A.getExtensions([{id:F.identifier.id}],C)),a){const m={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,m,this.options.profileLocation)}}catch{}}}class Y extends o.$Dp{constructor(F,C,a){super(),this.extension=F,this.j=C,this.k=a}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[158],ne([0,1,6,23,22,26,40,12,18,11]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=void 0;let P=class extends N.$Gp{constructor(d,f,E,v,$,l){super(c.URI.file(d.extensionsPath),f,E,v,$,l)}};e.$6N=P,e.$6N=P=pe([ie(0,h.$9h),ie(1,b.$jk),ie(2,R.$Vk),ie(3,D.$Tk),ie(4,A.$nl),ie(5,L.$ij)],P)}),define(te[159],ne([0,1,11,18,40,51,12,10,6,32,22,23]),function(G,e,L,R,D,A,N,b,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w0b=void 0;let d=class extends A.$Np{constructor(E,v,$,l,p,j,g,y){super(L.URI.file(p.builtinExtensionsPath),L.URI.file(p.extensionsPath),p.userHome,E.defaultProfile,E,v,$,l,p,j,g,y)}};e.$w0b=d,e.$w0b=d=pe([ie(0,I.$Vk),ie(1,D.$Fp),ie(2,N.$jk),ie(3,h.$ij),ie(4,R.$9h),ie(5,c.$Aj),ie(6,P.$Tk),ie(7,b.$Zh)],d)}),define(te[160],ne([0,1,8,4,2,125,3,86,10,23]),function(G,e,L,R,D,A,N,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$ep=e.$dp=e.$cp=void 0,e.$cp="__$__isNewStorageMarker",e.$dp="__$__targetStorageMarker",e.$ep=(0,h.$1h)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f(p){const j=p.get(e.$dp);if(j)try{return JSON.parse(j)}catch{}return Object.create(null)}e.$fp=f;class E extends D.$Sc{static{this.a=60*1e3}constructor(j={flushInterval:E.a}){super(),this.m=j,this.b=this.B(new R.$Vd),this.c=this.B(new R.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$ah(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(j,g,y){return R.Event.filter(this.b.event,s=>s.scope===j&&(g===void 0||s.key===g),y)}n(){this.j.value=(0,L.$eh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(j,g){const{key:y,external:s}=g;if(y===e.$dp){switch(j){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:j})}else this.b.fire({scope:j,key:y,target:this.J(j)[y],external:s})}w(j){this.f.fire({reason:j})}get(j,g,y){return this.P(g)?.get(j,y)}getBoolean(j,g,y){return this.P(g)?.getBoolean(j,y)}getNumber(j,g,y){return this.P(g)?.getNumber(j,y)}getObject(j,g,y){return this.P(g)?.getObject(j,y)}storeAll(j,g){this.y(()=>{for(const y of j)this.store(y.key,y.value,y.scope,y.target,g)})}store(j,g,y,s,o=!1){if((0,N.$Mf)(g)){this.remove(j,y,o);return}this.y(()=>{this.z(j,y,s),this.P(y)?.set(j,g,o)})}remove(j,g,y=!1){this.y(()=>{this.z(j,g,void 0),this.P(g)?.delete(j,y)})}y(j){this.b.pause(),this.c.pause();try{j()}finally{this.b.resume(),this.c.resume()}}keys(j,g){const y=[],s=this.J(j);for(const o of Object.keys(s))s[o]===g&&y.push(o);return y}z(j,g,y,s=!1){const o=this.J(g);typeof y=="number"?o[j]!==y&&(o[j]=y,this.P(g)?.set(e.$dp,JSON.stringify(o),s)):typeof o[j]=="number"&&(delete o[j],this.P(g)?.set(e.$dp,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(j){switch(j){case-1:return this.I;case 0:return this.G;default:return this.D}}L(j){const g=this.P(j);return g?f(g):Object.create(null)}isNew(j){return this.getBoolean(e.$cp,j)===!0}async flush(j=P.NONE){this.f.fire({reason:j});const g=this.P(-1),y=this.P(0),s=this.P(1);switch(j){case P.NONE:await L.Promises.settled([g?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([g?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const j=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,y=this.P(1)?.items??new Map;return l(j,g,y,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(j){return await this.flush(),this.P(j)?.optimize()}async switch(j,g){return this.w(P.NONE),(0,c.$Uk)(j)?this.R(j,g):this.S(j,g)}M(j,g){return!(j.id===g.id||v(g)&&v(j))}N(j,g,y){this.y(()=>{const s=new Set;for(const[o,t]of j)s.add(o),g.get(o)!==t&&this.u(y,{key:o,external:!0});for(const[o]of g.items)s.has(o)||this.u(y,{key:o,external:!0})})}}e.$gp=E;function v(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$hp=v;class $ extends E{constructor(){super(),this.U=this.B(new b.$ap(new b.$bp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$ap(new b.$bp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$ap(new b.$bp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(j=>this.u(1,j))),this.B(this.W.onDidChangeStorage(j=>this.u(0,j))),this.B(this.U.onDidChangeStorage(j=>this.u(-1,j)))}P(j){switch(j){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(j){switch(j){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(j){return!1}}e.$ip=$;async function l(p,j,g,y,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;p.forEach((H,ee)=>{i.set(ee,H),n.set(ee,t(H))});const r=new Map,u=new Map;j.forEach((H,ee)=>{r.set(ee,H),u.set(ee,t(H))});const k=new Map,S=new Map;g.forEach((H,ee)=>{k.set(ee,H),S.set(ee,t(H))}),console.group(y!==s?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const w=[];if(i.forEach((H,ee)=>{w.push({key:ee,value:H})}),console.table(w),console.groupEnd(),console.log(n),y!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((ee,_)=>{H.push({key:_,value:ee})}),console.table(H),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const O=[];k.forEach((H,ee)=>{O.push({key:ee,value:H})}),console.table(O),console.groupEnd(),console.log(S)}e.$jp=l}),define(te[161],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,49,12,6,32,44,144,160,26,174]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=void 0;const s=A.$o?"web":(0,I.$eo)(A.$u,N.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((m,z)=>m|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(m=S){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,z=this.d.pageSize){return new w({...this.d,pageNumber:m,pageSize:z})}withFilter(m,...z){const U=[...this.d.criteria,...z.length?z.map(X=>({filterType:m,value:X})):[{filterType:m}]];return new w({...this.d,criteria:U})}withSortBy(m){return new w({...this.d,sortBy:m})}withSortOrder(m){return new w({...this.d,sortOrder:m})}withFlags(...m){return new w({...this.d,flags:m.reduce((z,U)=>z|U,0)})}withAssetTypes(...m){return new w({...this.d,assetTypes:m})}withSource(m){return new w({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:z,pageSize:U,sortBy:X,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:m,pageNumber:z,pageSize:U,sortBy:X,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const m=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(a,m){const z=(a||[]).filter(U=>U.statisticName===m)[0];return z?z.value:0}function H(a){const m="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf(m)===0).reduce((U,X)=>{const W=re(a,X.assetType);return W&&U.push([X.assetType.substring(m.length),W]),U},[])}function ee(a){if(a.properties){const m=a.properties.filter(X=>X.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=m.filter(X=>z.test(X.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return re(a,r.Repository)}function _(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function re(a,m){return a.files.filter(U=>U.assetType===m)[0]?{uri:`${a.assetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${m}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,m){const z=a.properties?a.properties.filter(X=>X.key===m):[],U=z.length>0&&z[0].value;return U?U.split(",").map(X=>(0,d.$Oo)(X)):[]}function ue(a){const m=a.properties?a.properties.filter(z=>z.key===u.Engine):[];return m.length>0&&m[0].value||""}function ce(a){const m=a.properties?a.properties.filter(z=>z.key===u.PreRelease):[];return m.length>0&&m[0].value==="true"}function oe(a){const m=a.properties?a.properties.filter(U=>U.key===u.LocalizedLanguages):[],z=m.length>0&&m[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(m=>m.key===u.SponsorLink)?.value}function K(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$do)(a.targetPlatform):"undefined"}function M(a){const m=(0,L.$Mb)(a.versions.map(T)),z=!!a.tags?.includes(I.$$n),U=m.indexOf("web");return z?U===-1&&m.push("web"):U!==-1&&m.splice(U,1),m}function B(a,m){for(let z=0;z<a.length;z++){const U=a[z];if(U.version===a[z-1]?.version){let X=z;if(T(U)===m)for(;X>0&&a[X-1].version===U.version;)X--;X!==z&&(a.splice(z,1),a.splice(X,0,U))}}return a}e.$mp=B;function J(a,m,z){a.telemetryData={index:m,querySource:z,queryActivityId:a.queryContext?.[o]}}function Y(a,m,z,U){const X=a.versions[0],W={manifest:re(m,r.Manifest),readme:re(m,r.Details),changelog:re(m,r.Changelog),license:re(m,r.License),repository:ee(m),download:_(m),icon:re(m,r.Icon),signature:re(m,r.Signature),coreTranslations:H(m)};return{identifier:{id:(0,d.$Po)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:m.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(X),description:a.shortDescription||"",installCount:O(a.statistics,"install"),rating:O(a.statistics,"averagerating"),ratingCount:O(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(m,u.Dependency),extensionPack:se(m,u.ExtensionPack),engine:ue(m),localizedLanguages:oe(m),targetPlatform:T(m),isPreReleaseVersion:ce(m)},hasPreReleaseVersion:ce(X),hasReleaseVersion:!0,preview:K(a.flags),isSigned:!!W.signature,queryContext:U}}let Q=class{constructor(m,z,U,X,W,le,ae,me){this.k=z,this.l=U,this.n=X,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,p.$lp)(ae.version,ae,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,z,U){const X=R.CancellationToken.isCancellationToken(z)?{}:z,W=R.CancellationToken.isCancellationToken(z)?z:U,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of m){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new w().withPage(1,m.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(X.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),X.source&&(fe=fe.withSource(X.source));const{extensions:he}=await this.z(fe,{targetPlatform:X.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!X.compatible},W);return X.source&&he.forEach((we,be)=>J(we,be,X.source)),he}async getCompatibleExtension(m,z,U){if((0,I.$fo)(m.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible(m,z,U))return m;const X=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,m.identifier.uuid),{extensions:W}=await this.z(X,{targetPlatform:U,compatible:!0,includePreRelease:z},R.CancellationToken.None);return W[0]||null}async isExtensionCompatible(m,z,U){if(!(0,I.$go)(m.properties.targetPlatform,m.allTargetPlatforms,U)||!z&&m.properties.isPreReleaseVersion)return!1;let X=m.properties.engine;if(!X){const W=await this.getManifest(m,R.CancellationToken.None);if(!W)throw new Error("Manifest was not found");X=W.engines.vscode}return(0,f.$3o)(X,this.u.version,this.u.date)}async y(m,z,U,X,W){if(!(0,I.$go)(T(m),X,W)||z!=="any"&&ce(m)!==(z==="prerelease"))return!1;if(U)try{const le=await this.E(m);if(!(0,f.$3o)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,D.$0)(le)),!1}return!0}async query(m,z){let U=m.text||"";const X=m.pageSize??50;let W=new w().withPage(1,X);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),W=W.withFilter(n.SearchText,U)),W=W.withSortBy(0)):m.ids?W=W.withFilter(n.ExtensionId,...m.ids):m.names?W=W.withFilter(n.ExtensionName,...m.names):W=W.withSortBy(4),typeof m.sortBy=="number"&&(W=W.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(W=W.withSortOrder(m.sortOrder)),m.source&&(W=W.withSource(m.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,ke)=>J(be,(ge.pageNumber-1)*ge.pageSize+ke,m.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new D.$5;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(m,z,U){const X=m.flags;m.flags&t.IncludeLatestVersionOnly&&m.flags&t.IncludeVersions&&(m=m.withFlags(m.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(m.flags&t.IncludeLatestVersionOnly)&&!(m.flags&t.IncludeVersions)&&(m=m.withFlags(m.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(m=m.withFlags(m.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),m=m.withFlags(m.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(m,U);if(!(m.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$Po)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,b.$Jf)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Fe=>(0,d.$Ko)(Fe,we))?.includePreRelease;if(z.compatible&&(0,I.$fo)(M(he),z.targetPlatform))continue;const ke=await this.A(he,z,ae);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==z.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new y.$Od,he=new w().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,U);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(m,z,U){const X={id:(0,d.$Po)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},W=z.versions?.find(de=>(0,d.$Ko)(de,X))?.version,le=(0,b.$Jf)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$Ko)(de,X))?.includePreRelease,ae=M(m),me=B(m.versions,z.targetPlatform);if(z.compatible&&(0,I.$fo)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Y(m,ge,ae,U);if(W&&ge.version===W)return null}}return W||z.compatible?null:Y(m,m.versions[0],ae)}async B(m,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.j,X=JSON.stringify(m.raw),W={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},le=new y.$Od;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,l.$0o)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(X.length),duration:le.elapsed(),success:!!ae&&(0,l.$6o)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,D.$4)(me)?"canceled":(0,D.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,z,U,X){if(!this.isEnabled())return;const W=A.$o?this.x(`/itemName/${m}.${z}/version/${U}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${z}/${U}/stats?statType=${X}`),le=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},R.CancellationToken.None)}catch{}}async download(m,z,U){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const X=(0,d.$So)(m),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${m.assets.download.uri}${h.URI.parse(m.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${m.assets.download.fallbackUri}${h.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:m.assets.download,de=m.queryContext?.[o]?{[o]:m.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(m,z){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const U=await this.D(m.assets.signature);await this.q.writeFile(z,U.stream)}async getReadme(m,z){if(m.assets.readme){const U=await this.D(m.assets.readme,{},z);return await(0,l.$9o)(U)||""}return""}async getManifest(m,z){if(m.assets.manifest){const U=await this.D(m.assets.manifest,{},z),X=await(0,l.$9o)(U);return X?JSON.parse(X):null}return null}async C(m,z){const U=re(m,r.Manifest);if(!U)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},W=await this.D(U,{headers:X});return await(0,l.$0o)(W)}async getCoreTranslation(m,z){const U=m.assets.coreTranslations.filter(X=>X[0]===z.toUpperCase())[0];if(U){const X=await this.D(U[1]),W=await(0,l.$9o)(X);return W?JSON.parse(W):null}return null}async getChangelog(m,z){if(m.assets.changelog){const U=await this.D(m.assets.changelog,{},z);return await(0,l.$9o)(U)||""}return""}async getAllCompatibleVersions(m,z,U){let X=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?X=X.withFilter(n.ExtensionId,m.identifier.uuid):X=X.withFilter(n.ExtensionName,m.identifier.id);const{galleryExtensions:W}=await this.B(X,R.CancellationToken.None);if(!W.length)return[];const le=M(W[0]);if((0,I.$fo)(le,U))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of B(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(m,z={},U=R.CancellationToken.None){const X=await this.j,W={type:"GET"},le={...X,...z.headers||{}};z={...z,...W,headers:le};const ae=m.uri,me=m.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,U);if(ge.res.statusCode===200)return ge;const fe=await(0,l.$9o)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,D.$4)(ge))throw ge;const fe=(0,D.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,U)}}async E(m){let z=ue(m);if(!z){const U=await this.C(m,R.CancellationToken.None);if(!U)throw new Error("Manifest was not found");z=U.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,l.$0o)(m),U=[],X={},W=[];if(z){for(const le of z.malicious)U.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$3o)(ae.engine,this.u.version,this.u.date))&&(X[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(X[le.toLowerCase()]=(0,b.$Jf)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:U,deprecated:X,search:W}}};Q=pe([ie(1,l.$4o),ie(2,v.$ij),ie(3,P.$8h),ie(4,g.$nl),ie(5,E.$jk),ie(6,$.$Aj),ie(7,c.$ui)],Q);let F=class extends Q{constructor(m,z,U,X,W,le,ae,me){super(m,z,U,X,W,le,ae,me)}};e.$np=F,e.$np=F=pe([ie(0,j.$ep),ie(1,l.$4o),ie(2,v.$ij),ie(3,P.$8h),ie(4,g.$nl),ie(5,E.$jk),ie(6,$.$Aj),ie(7,c.$ui)],F);let C=class extends Q{constructor(m,z,U,X,W,le,ae){super(void 0,m,z,U,X,W,le,ae)}};e.$op=C,e.$op=C=pe([ie(0,l.$4o),ie(1,v.$ij),ie(2,P.$8h),ie(3,g.$nl),ie(4,E.$jk),ie(5,$.$Aj),ie(6,c.$ui)],C)}),define(te[162],ne([0,1,11,18,12,6,140,22,23,3,68]),function(G,e,L,R,D,A,N,b,h,c,P){"use strict";var I,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=e.$4N=e.$3N=void 0;let f=class extends h.$Yk{static{I=this}static{this.a="profileAssociationsMigration"}constructor(l,p,j,g,y){super(j,g,p,y),this.U=l,this.W=j}O(){return this.U.getItem(I.b,[]).map(p=>({...p,location:(0,c.$Df)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):L.URI.revive(p.location)}))}Q(){const l=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?l:this.N(l)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$3N=f,e.$3N=f=I=pe([ie(0,N.$XN),ie(1,b.$Tk),ie(2,R.$9h),ie(3,D.$jk),ie(4,A.$ij)],f);let E=d=class extends f{constructor(l,p,j,g,y){super(l,p,j,g,y),this.$=l}P(l){l.length?this.$.setItem(d.b,l.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const l=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(l),this.$.setItem("userDataProfilesMigration",!0)),l}R(l){l.emptyWindows||l.workspaces?this.$.setItem(d.c,l):this.$.removeItem(d.c)}Q(){const l="workspaceAndProfileInfo",p=this.$.getItem(l,void 0);if(p){this.$.removeItem(l);const g=p.reduce((y,{workspace:s,profile:o})=>(y[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),y),{});this.$.setItem(d.c,{workspaces:g})}const j=super.Q();return this.$.getItem(d.a,!1)||(this.R(j),this.$.setItem(d.a,!0)),j}};e.$4N=E,e.$4N=E=d=pe([ie(0,N.$YN),ie(1,b.$Tk),ie(2,R.$9h),ie(3,D.$jk),ie(4,A.$ij)],E);let v=class extends E{constructor(l,p,j,g){super(new P.$2N(0,p,g,j),l,p,j,g)}async init(){return await this.$.init(),super.init()}};e.$5N=v,e.$5N=v=pe([ie(0,b.$Tk),ie(1,R.$9h),ie(2,D.$jk),ie(3,A.$ij)],v)}),define(te[163],ne([0,1,138,8,14,9,3,25,18,139,6,44,137,175]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=void 0;let E=class extends I.$5o{constructor(p,j,g,y){super(y),this.m=p,this.n=j,this.r=g,this.s(),this.B(p.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,j){const{f:g,g:y}=this;let s;try{s=await(0,c.$5l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(i)))}const o={...process.env,...s},t=p.agent?p.agent:await(0,d.$9q)(p.url||"",o,{proxyUrl:g,strictSSL:y});return p.agent=t,p.strictSSL=y,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>$(p,j))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((j,g)=>{G(["@vscode/proxy-agent"],j,g)})).loadSystemCertificates({log:this.r})}};e.$0q=E,e.$0q=E=pe([ie(0,b.$ui),ie(1,h.$9h),ie(2,P.$ij),ie(3,P.$jj)],E);async function v(l){return((0,L.parse)(l.url).protocol==="https:"?await new Promise((g,y)=>{G(["https"],g,y)}):await new Promise((g,y)=>{G(["http"],g,y)})).request}async function $(l,p){return R.Promises.withAsyncBody(async(j,g)=>{const y=(0,L.parse)(l.url),s=l.getRawRequest?l.getRawRequest(l):await v(l),o={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,N.$Jf)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(o.auth=l.user+":"+l.password);const t=s(o,i=>{const n=(0,N.$Hf)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...l,url:i.headers.location,followRedirects:n-1},p).then(j,g);else{let r=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),j({res:i,stream:(0,D.$ve)(r)})}});t.on("error",g),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),p.onCancellationRequested(()=>{t.abort(),g(new A.$5)})})}e.$$q=$}),define(te[176],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,134,59,136,18,112,161,21,60,141,40,51,157,159,12,124,126,50,122,63,64,145,6,130,38,131,148,32,44,163,68,69,26,147,39,149,150,22,152,23,162,151,158,127,129,5,153]),function(G,e,L,R,D,A,N,b,h,c,P,I,d,f,E,v,$,l,p,j,g,y,s,o,t,i,n,r,u,k,S,w,O,H,ee,_,re,se,ue,ce,oe,q,K,T,M,B,J,Y,Q,F,C,a,m,z,U,X,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends N.$Sc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(_.$ij),Fe=be.get(r.$jk),V=be.get(l.$9h),Z=be.get(m.$Vk);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Fe,Z,he),await Promise.all(we.map(x=>{(0,R.$Sg)(x.flush(),1e3)}))})}async f(){const he=new O.$Yh,we={_serviceBrand:void 0,...ce.default};he.set(oe.$Aj,we);const be=new p.$um(this.b,we);he.set(l.$9h,be),await Promise.all([be.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,be.extensionsPath].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0));const ke=new le.$WN((0,_.$wj)(be),be.logsHome);he.set(_.$jj,ke);const Fe=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),V=[];ke.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$qj(ke.getLogLevel()));const Z=this.B(new W.$7N(Fe,V));he.set(_.$ij,Z);const x=this.B(new u.$Yp(Z));he.set(r.$jk,x);const $e=this.B(new k.$lq(Z));x.registerProvider(b.Schemas.file,$e);const ye=new a.$Kr(x);he.set(C.$Tk,ye);const De=new T.$1N(1,be,Z,x),Se=new z.$3N(De,ye,be,x,Z);he.set(m.$Vk,Se),x.registerProvider(b.Schemas.vscodeUserData,new me.$X0b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Se,ye,Z));const Le=c.$i&&we.win32RegValueName?this.B(new ue.$V0b(Z,we.win32RegValueName)):be.policyFile?this.B(new re.$W0b(be.policyFile,x,Z)):new se.$vn;he.set(se.$tn,Le);const Ie=this.B(new E.$Vn(Se.defaultProfile.settingsResource,x,Le,Z));he.set(f.$ui,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,U.$z0b)(De,Z)}catch(Ae){Ae.code!=="ENOENT"&&Z.error(Ae)}const Me=await(0,U.$A0b)(De,Z);Se.init(),he.set(C.$Tk,new a.$Kr(x));const je=new K.$0q(Ie,be,Z,ke);he.set(q.$4o,je),he.set(v.$Zn,new S.$Xh($.$jO,void 0,!0)),he.set(o.$Fp,new S.$Xh(X.$6N,void 0,!0)),he.set(t.$Jp,new S.$Xh(n.$w0b,void 0,!0)),he.set(y.$pp,new S.$Xh(y.$qp,void 0,!0)),he.set(i.$Tp,new S.$Xh(i.$Up,void 0,!0)),he.set(g.$io,new S.$Xh(j.$op,void 0,!0)),he.set(H.$4q,new S.$Xh(ee.$6q,void 0,!1));const Re=[],ze=(0,Y.$Ho)(we,Ie);if((0,Y.$Co)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Re.push(new Q.$UN(je,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const Ae={appenders:Re,sendErrorTelemetry:!1,commonProperties:(0,M.$so)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ne,Me,ze),piiPaths:(0,Y.$Io)(be)};he.set(B.$nl,new S.$Xh(J.$_q,[Ae],!1))}else he.set(B.$nl,Y.$wo);return[new w.$oq(he),Re]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,D.$Li)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async h(he,we,be,ke){let Fe;if(he.args.profile&&(Fe=be.profiles.find(Z=>Z.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$rp,new _.$qj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(s.$rp,new _.$qj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Z,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$rp,new _.$qj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return ke.createInstance(s.$rp,new _.$qj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$h$b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,h.$ic)(we)?we:(0,h.$jc)((0,P.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f6b7ba78b8850751f083306b8f5d745c8a0ddcf/core/vs/code/node/cliProcessMain.js.map
