/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function($e){for(var e=[],D=0,O=$e.length;D<O;D++)e[D]=Se[$e[D]];return e};define(Se[157],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,P=new Map,M=new Map,b=new Map;function $(v,k){v.has(k.detail)||v.set(k.detail,-k.timestamp)}function y(v,k){const f=v.get(k.detail);f&&(f>=0||v.set(k.detail,f+k.timestamp))}let R=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(R=$e.getStats().slice(0).sort((v,k)=>v.timestamp-k.timestamp));for(const v of R)switch(v.type){case 10:$(g,v);break;case 11:case 12:y(g,v);break;case 21:$(P,v);break;case 22:y(P,v);break;case 33:$(M,v);break;case 34:y(M,v);break;case 31:$(b,v);break;case 32:y(b,v);break}let C=0;M.forEach(v=>C+=v);function m(v){const k=[];return v.forEach((f,d)=>k.push([d,f])),k}return{amdLoad:m(g),amdInvoke:m(P),nodeRequire:m(M),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,P){let M="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),P.forEach($=>{$.forEach((y,R)=>{typeof y>"u"&&(y=$[R]="-");const C=y.toString().length;b[R]=Math.max(C,b[R])})}),g.forEach(($,y)=>{M+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),M+=`|
`,g.forEach(($,y)=>{M+=`| ${"-".repeat(b[y])} `}),M+=`|
`,P.forEach($=>{$.forEach((y,R)=>{typeof y<"u"&&(M+=`| ${y+" ".repeat(b[R]-y.toString().length)} `)}),M+=`|
`}),M}}e.$U=D}),define(Se[158],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(f,d,s){const i=O(f,d);if(i!==-1)return f[i]}e.$fb=D;function O(f,d,s=f.length-1){for(let i=s;i>=0;i--){const n=f[i];if(d(n))return i}return-1}e.$gb=O;function g(f,d){const s=P(f,d);return s===-1?void 0:f[s]}e.$hb=g;function P(f,d,s=0,i=f.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);d(f[a])?n=a+1:o=a}return n-1}e.$ib=P;function M(f,d){const s=b(f,d);return s===f.length?void 0:f[s]}e.$jb=M;function b(f,d,s=0,i=f.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);d(f[a])?o=a:n=a+1}return n}e.$kb=b;function $(f,d,s=0,i=f.length){const n=b(f,d,s,i);return n===f.length?-1:n}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!d(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const s=P(this.e,d,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=y;function R(f,d){if(f.length===0)return;let s=f[0];for(let i=1;i<f.length;i++){const n=f[i];d(n,s)>0&&(s=n)}return s}e.$nb=R;function C(f,d){if(f.length===0)return;let s=f[0];for(let i=1;i<f.length;i++){const n=f[i];d(n,s)>=0&&(s=n)}return s}e.$ob=C;function m(f,d){return R(f,(s,i)=>-d(s,i))}e.$pb=m;function v(f,d){if(f.length===0)return-1;let s=0;for(let i=1;i<f.length;i++){const n=f[i];d(n,f[s])>0&&(s=i)}return s}e.$qb=v;function k(f,d){for(const s of f){const i=d(s);if(i!==void 0)return i}}e.$rb=k}),define(Se[73],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(M,b){const $=Object.create(null);for(const y of M){const R=b(y);let C=$[R];C||(C=$[R]=[]),C.push(y)}return $}e.$K=D;function O(M,b){const $=[],y=[];for(const R of M)b.has(R)||$.push(R);for(const R of b)M.has(R)||y.push(R);return{removed:$,added:y}}e.$L=O;function g(M,b){const $=[],y=[];for(const[R,C]of M)b.has(R)||$.push(C);for(const[R,C]of b)M.has(R)||y.push(C);return{removed:$,added:y}}e.$M=g;function P(M,b){const $=new Set;for(const y of b)M.has(y)&&$.add(y);return $}e.$N=P}),define(Se[59],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function D(M){return(b,$,y)=>{let R=null,C=null;if(typeof y.value=="function"?(R="value",C=y.value):typeof y.get=="function"&&(R="get",C=y.get),!C)throw new Error("not supported");y[R]=M(C,$)}}function O(M,b,$){let y=null,R=null;if(typeof $.value=="function"?(y="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",R=$.get),!R)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[C]}}e.$sh=O;function g(M,b,$){return D((y,R)=>{const C=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...v){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,v),this[m]=$?$():void 0},M)}})}e.$th=g;function P(M,b,$){return D((y,R)=>{const C=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,v=`$throttle$lastRun$${R}`,k=`$throttle$pending$${R}`;return function(...f){if(this[m]||(this[m]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...f)),this[k])return;const d=this[v]+M;d<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[k]=!0,this[C]=setTimeout(()=>{this[k]=!1,this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},d-Date.now()))}})}e.$uh=P}),define(Se[8],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function O(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=O;function g(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function P(a){y(a)||e.$X.onUnexpectedError(a)}e.$1=P;function M(a){y(a)||e.$X.onUnexpectedExternalError(a)}e.$2=M;function b(a){if(a instanceof Error){const{name:t,message:r}=a,h=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:h,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$3=b;const $="Canceled";function y(a){return a instanceof R?!0:a instanceof Error&&a.name===$&&a.message===$}e.$4=y;class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function C(){const a=new Error($);return a.name=a.message,a}e.$6=C;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=m;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=v;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function f(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=f;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=d;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(Se[19],ke([1,0,8,158]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(fe,me=0){return fe[fe.length-(1+me)]}e.$sb=g;function P(fe){if(fe.length===0)throw new Error("Invalid tail call");return[fe.slice(0,fe.length-1),fe[fe.length-1]]}e.$tb=P;function M(fe,me,ee=(ie,G)=>ie===G){if(fe===me)return!0;if(!fe||!me||fe.length!==me.length)return!1;for(let ie=0,G=fe.length;ie<G;ie++)if(!ee(fe[ie],me[ie]))return!1;return!0}e.$ub=M;function b(fe,me){const ee=fe.length-1;me<ee&&(fe[me]=fe[ee]),fe.pop()}e.$vb=b;function $(fe,me,ee){return y(fe.length,ie=>ee(fe[ie],me))}e.$wb=$;function y(fe,me){let ee=0,ie=fe-1;for(;ee<=ie;){const G=(ee+ie)/2|0,te=me(G);if(te<0)ee=G+1;else if(te>0)ie=G-1;else return G}return-(ee+1)}e.$xb=y;function R(fe,me,ee){if(fe=fe|0,fe>=me.length)throw new TypeError("invalid index");const ie=me[Math.floor(me.length*Math.random())],G=[],te=[],J=[];for(const ce of me){const be=ee(ce,ie);be<0?G.push(ce):be>0?te.push(ce):J.push(ce)}return fe<G.length?R(fe,G,ee):fe<G.length+J.length?J[0]:R(fe-(G.length+J.length),te,ee)}e.$yb=R;function C(fe,me){const ee=[];let ie;for(const G of fe.slice(0).sort(me))!ie||me(ie[0],G)!==0?(ie=[G],ee.push(ie)):ie.push(G);return ee}e.$zb=C;function*m(fe,me){let ee,ie;for(const G of fe)ie!==void 0&&me(ie,G)?ee.push(G):(ee&&(yield ee),ee=[G]),ie=G;ee&&(yield ee)}e.$Ab=m;function v(fe,me){for(let ee=0;ee<=fe.length;ee++)me(ee===0?void 0:fe[ee-1],ee===fe.length?void 0:fe[ee])}e.$Bb=v;function k(fe,me){for(let ee=0;ee<fe.length;ee++)me(ee===0?void 0:fe[ee-1],fe[ee],ee+1===fe.length?void 0:fe[ee+1])}e.$Cb=k;function f(fe,me,ee){const ie=[];function G(ce,be,Ie){if(be===0&&Ie.length===0)return;const Fe=ie[ie.length-1];Fe&&Fe.start+Fe.deleteCount===ce?(Fe.deleteCount+=be,Fe.toInsert.push(...Ie)):ie.push({start:ce,deleteCount:be,toInsert:Ie})}let te=0,J=0;for(;;){if(te===fe.length){G(te,0,me.slice(J));break}if(J===me.length){G(te,fe.length-te,[]);break}const ce=fe[te],be=me[J],Ie=ee(ce,be);Ie===0?(te+=1,J+=1):Ie<0?(G(te,1,[]),te+=1):Ie>0&&(G(te,0,[be]),J+=1)}return ie}e.$Db=f;function d(fe,me,ee){const ie=f(fe,me,ee),G=[],te=[];for(const J of ie)G.push(...fe.slice(J.start,J.start+J.deleteCount)),te.push(...J.toInsert);return{removed:G,added:te}}e.$Eb=d;function s(fe,me,ee){if(ee===0)return[];const ie=fe.slice(0,ee).sort(me);return n(fe,me,ie,ee,fe.length),ie}e.top=s;function i(fe,me,ee,ie,G){return ee===0?Promise.resolve([]):new Promise((te,J)=>{(async()=>{const ce=fe.length,be=fe.slice(0,ee).sort(me);for(let Ie=ee,Fe=Math.min(ee+ie,ce);Ie<ce;Ie=Fe,Fe=Math.min(Fe+ie,ce)){if(Ie>ee&&await new Promise(B=>setTimeout(B)),G&&G.isCancellationRequested)throw new D.$5;n(fe,me,be,Ie,Fe)}return be})().then(te,J)})}e.$Gb=i;function n(fe,me,ee,ie,G){for(const te=ee.length;ie<G;ie++){const J=fe[ie];if(me(J,ee[te-1])<0){ee.pop();const ce=(0,O.$kb)(ee,be=>me(J,be)<0);ee.splice(ce,0,J)}}}function o(fe){return fe.filter(me=>!!me)}e.$Hb=o;function a(fe){let me=0;for(let ee=0;ee<fe.length;ee++)fe[ee]&&(fe[me]=fe[ee],me+=1);fe.length=me}e.$Ib=a;function t(fe,me,ee){fe.splice(ee,0,fe.splice(me,1)[0])}e.$Jb=t;function r(fe){return!Array.isArray(fe)||fe.length===0}e.$Kb=r;function h(fe){return Array.isArray(fe)&&fe.length>0}e.$Lb=h;function u(fe,me=ee=>ee){const ee=new Set;return fe.filter(ie=>{const G=me(ie);return ee.has(G)?!1:(ee.add(G),!0)})}e.$Mb=u;function c(fe){const me=new Set;return ee=>{const ie=fe(ee);return me.has(ie)?!1:(me.add(ie),!0)}}e.$Nb=c;function l(fe,me){return fe.length>0?fe[0]:me}e.$Ob=l;function S(fe,me){return fe.length>0?fe[fe.length-1]:me}e.$Pb=S;function L(fe,me,ee=(ie,G)=>ie===G){let ie=0;for(let G=0,te=Math.min(fe.length,me.length);G<te&&ee(fe[G],me[G]);G++)ie++;return ie}e.$Qb=L;function w(fe){return[].concat(...fe)}e.$Rb=w;function p(fe,me){let ee=typeof me=="number"?fe:0;typeof me=="number"?ee=fe:(ee=0,me=fe);const ie=[];if(ee<=me)for(let G=ee;G<me;G++)ie.push(G);else for(let G=ee;G>me;G--)ie.push(G);return ie}e.$Sb=p;function E(fe,me,ee){return fe.reduce((ie,G)=>(ie[me(G)]=ee?ee(G):G,ie),Object.create(null))}e.$Tb=E;function A(fe,me){return fe.push(me),()=>z(fe,me)}e.$Ub=A;function z(fe,me){const ee=fe.indexOf(me);if(ee>-1)return fe.splice(ee,1),me}e.$Vb=z;function N(fe,me,ee){const ie=fe.slice(0,me),G=fe.slice(me);return ie.concat(ee,G)}e.$Wb=N;function I(fe,me){let ee;if(typeof me=="number"){let ie=me;ee=()=>{const G=Math.sin(ie++)*179426549;return G-Math.floor(G)}}else ee=Math.random;for(let ie=fe.length-1;ie>0;ie-=1){const G=Math.floor(ee()*(ie+1)),te=fe[ie];fe[ie]=fe[G],fe[G]=te}}e.$Xb=I;function j(fe,me){const ee=fe.indexOf(me);ee>-1&&(fe.splice(ee,1),fe.unshift(me))}e.$Yb=j;function T(fe,me){const ee=fe.indexOf(me);ee>-1&&(fe.splice(ee,1),fe.push(me))}e.$Zb=T;function F(fe,me){for(const ee of me)fe.push(ee)}e.$1b=F;function W(fe,me){return Array.isArray(fe)?fe.map(me):me(fe)}e.$2b=W;function Y(fe){return Array.isArray(fe)?fe:[fe]}e.$3b=Y;function le(fe){return fe[Math.floor(Math.random()*fe.length)]}e.$4b=le;function Q(fe,me,ee){const ie=x(fe,me),G=fe.length,te=ee.length;fe.length=G+te;for(let J=G-1;J>=ie;J--)fe[J+te]=fe[J];for(let J=0;J<te;J++)fe[J+ie]=ee[J]}e.$5b=Q;function Z(fe,me,ee,ie){const G=x(fe,me);let te=fe.splice(G,ee);return te===void 0&&(te=[]),Q(fe,G,ie),te}e.$6b=Z;function x(fe,me){return me<0?Math.max(me+fe.length,0):Math.min(me,fe.length)}var oe;(function(fe){function me(te){return te<0}fe.isLessThan=me;function ee(te){return te<=0}fe.isLessThanOrEqual=ee;function ie(te){return te>0}fe.isGreaterThan=ie;function G(te){return te===0}fe.isNeitherLessOrGreaterThan=G,fe.greaterThan=1,fe.lessThan=-1,fe.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function X(fe,me){return(ee,ie)=>me(fe(ee),fe(ie))}e.$7b=X;function ve(...fe){return(me,ee)=>{for(const ie of fe){const G=ie(me,ee);if(!oe.isNeitherLessOrGreaterThan(G))return G}return oe.neitherLessOrGreaterThan}}e.$8b=ve;const ge=(fe,me)=>fe-me;e.$9b=ge;const H=(fe,me)=>(0,e.$9b)(fe?1:0,me?1:0);e.$0b=H;function U(fe){return(me,ee)=>-fe(me,ee)}e.$$b=U;class ne{constructor(me){this.g=me,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(me){let ee=this.c;for(;ee<this.g.length&&me(this.g[ee]);)ee++;const ie=ee===this.c?null:this.g.slice(this.c,ee);return this.c=ee,ie}takeFromEndWhile(me){let ee=this.d;for(;ee>=0&&me(this.g[ee]);)ee--;const ie=ee===this.d?null:this.g.slice(ee+1,this.d+1);return this.d=ee,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const me=this.g[this.c];return this.c++,me}removeLast(){const me=this.g[this.d];return this.d--,me}takeCount(me){const ee=this.g.slice(this.c,this.c+me);return this.c+=me,ee}}e.$_b=ne;class ye{static{this.empty=new ye(me=>{})}constructor(me){this.iterate=me}forEach(me){this.iterate(ee=>(me(ee),!0))}toArray(){const me=[];return this.iterate(ee=>(me.push(ee),!0)),me}filter(me){return new ye(ee=>this.iterate(ie=>me(ie)?ee(ie):!0))}map(me){return new ye(ee=>this.iterate(ie=>ee(me(ie))))}some(me){let ee=!1;return this.iterate(ie=>(ee=me(ie),!ee)),ee}findFirst(me){let ee;return this.iterate(ie=>me(ie)?(ee=ie,!1):!0),ee}findLast(me){let ee;return this.iterate(ie=>(me(ie)&&(ee=ie),!0)),ee}findLastMaxBy(me){let ee,ie=!0;return this.iterate(G=>((ie||oe.isGreaterThan(me(G,ee)))&&(ie=!1,ee=G),!0)),ee}}e.$ac=ye}),define(Se[60],ke([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function O($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=O;function g($,y="Unreachable"){throw new Error(y)}e.$5c=g;function P($){if(!$)throw new D.$cb("Assertion Failed")}e.$6c=P;function M($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$7c=M;function b($,y){let R=0;for(;R<$.length-1;){const C=$[R],m=$[R+1];if(!y(C,m))return!1;R++}return!0}e.$8c=b}),define(Se[74],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(O,g){const P=this;let M=!1,b;return function(){if(M)return b;if(M=!0,g)try{b=O.apply(P,arguments)}finally{g()}else b=O.apply(P,arguments);return b}}e.$db=D}),define(Se[121],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$OM=D,e.$PM=new D("id#")}),define(Se[52],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}O.is=g;const P=Object.freeze([]);function M(){return P}O.empty=M;function*b(a){yield a}O.single=b;function $(a){return g(a)?a:b(a)}O.wrap=$;function y(a){return a||P}O.from=y;function*R(a){for(let t=a.length-1;t>=0;t--)yield a[t]}O.reverse=R;function C(a){return!a||a[Symbol.iterator]().next().done===!0}O.isEmpty=C;function m(a){return a[Symbol.iterator]().next().value}O.first=m;function v(a,t){for(const r of a)if(t(r))return!0;return!1}O.some=v;function k(a,t){for(const r of a)if(t(r))return r}O.find=k;function*f(a,t){for(const r of a)t(r)&&(yield r)}O.filter=f;function*d(a,t){let r=0;for(const h of a)yield t(h,r++)}O.map=d;function*s(...a){for(const t of a)yield*t}O.concat=s;function i(a,t,r){let h=r;for(const u of a)h=t(h,u);return h}O.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}O.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const h=a[Symbol.iterator]();for(let u=0;u<t;u++){const c=h.next();if(c.done)return[r,O.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return h}}]}O.consume=o})(D||(e.Iterable=D={}))}),define(Se[159],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function M(t,r=!1){let h=0;const u=t.length;let c="",l=0,S=16,L=0;function w(j){let T=0,F=0;for(;T<j;){const W=t.charCodeAt(h);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;h++,T++}return T<j&&(F=-1),F}function p(j){h=j,c="",l=0,S=16,L=0}function E(){const j=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&y(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&y(t.charCodeAt(h)))for(h++;h<t.length&&y(t.charCodeAt(h));)h++;else return L=3,t.substring(j,h);let T=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&y(t.charCodeAt(h))){for(h++;h<t.length&&y(t.charCodeAt(h));)h++;T=h}else L=3;return t.substring(j,T)}function A(){let j="",T=h;for(;;){if(h>=u){j+=t.substring(T,h),L=2;break}const F=t.charCodeAt(h);if(F===34){j+=t.substring(T,h),h++;break}if(F===92){if(j+=t.substring(T,h),h++,h>=u){L=2;break}switch(t.charCodeAt(h++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Y=w(4);Y>=0?j+=String.fromCharCode(Y):L=4;break}default:L=5}T=h;continue}if(F>=0&&F<=31)if($(F)){j+=t.substring(T,h),L=2;break}else L=6;h++}return j}function z(){if(c="",L=0,l=h,h>=u)return l=u,S=17;let j=t.charCodeAt(h);if(b(j)){do h++,c+=String.fromCharCode(j),j=t.charCodeAt(h);while(b(j));return S=15}if($(j))return h++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(h)===10&&(h++,c+=`
`),S=14;switch(j){case 123:return h++,S=1;case 125:return h++,S=2;case 91:return h++,S=3;case 93:return h++,S=4;case 58:return h++,S=6;case 44:return h++,S=5;case 34:return h++,c=A(),S=10;case 47:{const T=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<u&&!$(t.charCodeAt(h));)h++;return c=t.substring(T,h),S=12}if(t.charCodeAt(h+1)===42){h+=2;const F=u-1;let W=!1;for(;h<F;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,W=!0;break}h++}return W||(h++,L=1),c=t.substring(T,h),S=13}return c+=String.fromCharCode(j),h++,S=16}case 45:if(c+=String.fromCharCode(j),h++,h===u||!y(t.charCodeAt(h)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=E(),S=11;default:for(;h<u&&N(j);)h++,j=t.charCodeAt(h);if(l!==h){switch(c=t.substring(l,h),c){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return c+=String.fromCharCode(j),h++,S=16}}function N(j){if(b(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function I(){let j;do j=z();while(j>=12&&j<=15);return j}return{setPosition:p,getPosition:()=>h,scan:r?I:z,getToken:()=>S,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>h-l,getTokenError:()=>L}}e.$6m=M;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,r){const h=[],u=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function L(w,p,E,A){l.value=w,l.offset=p,l.length=E,l.type=A,l.colonOffset=void 0,c=l}try{n(t,{onObjectBegin:(w,p)=>{if(r<=w)throw u;c=void 0,S=r>w,h.push("")},onObjectProperty:(w,p,E)=>{if(r<p||(L(w,p,E,"property"),h[h.length-1]=w,r<=p+E))throw u},onObjectEnd:(w,p)=>{if(r<=w)throw u;c=void 0,h.pop()},onArrayBegin:(w,p)=>{if(r<=w)throw u;c=void 0,h.push(0)},onArrayEnd:(w,p)=>{if(r<=w)throw u;c=void 0,h.pop()},onLiteralValue:(w,p,E)=>{if(r<p||(L(w,p,E,a(w)),r<=p+E))throw u},onSeparator:(w,p,E)=>{if(r<=p)throw u;if(w===":"&&c&&c.type==="property")c.colonOffset=p,S=!1,c=void 0;else if(w===","){const A=h[h.length-1];typeof A=="number"?h[h.length-1]=A+1:(S=!0,h[h.length-1]=""),c=void 0}}})}catch(w){if(w!==u)throw w}return{path:h,previousNode:c,isAtPropertyKey:S,matches:w=>{let p=0;for(let E=0;p<w.length&&E<h.length;E++)if(w[p]===h[E]||w[p]==="*")p++;else if(w[p]!=="**")return!1;return p===w.length}}}e.$7m=C;function m(t,r=[],h=P.DEFAULT){let u=null,c=[];const l=[];function S(w){Array.isArray(c)?c.push(w):u!==null&&(c[u]=w)}return n(t,{onObjectBegin:()=>{const w={};S(w),l.push(c),c=w,u=null},onObjectProperty:w=>{u=w},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const w=[];S(w),l.push(c),c=w,u=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:S,onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},h),c[0]}e.$8m=m;function v(t,r=[],h=P.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){u.type==="property"&&(u.length=w-u.offset,u=u.parent)}function l(w){return u.children.push(w),w}n(t,{onObjectBegin:w=>{u=l({type:"object",offset:w,length:-1,parent:u,children:[]})},onObjectProperty:(w,p,E)=>{u=l({type:"property",offset:p,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:w,offset:p,length:E,parent:u})},onObjectEnd:(w,p)=>{u.length=w+p-u.offset,u=u.parent,c(w+p)},onArrayBegin:(w,p)=>{u=l({type:"array",offset:w,length:-1,parent:u,children:[]})},onArrayEnd:(w,p)=>{u.length=w+p-u.offset,u=u.parent,c(w+p)},onLiteralValue:(w,p,E)=>{l({type:a(w),offset:p,length:E,parent:u,value:w}),c(p+E)},onSeparator:(w,p,E)=>{u.type==="property"&&(w===":"?u.colonOffset=p:w===","&&c(p))},onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},h);const L=u.children[0];return L&&delete L.parent,L}e.$9m=v;function k(t,r){if(!t)return;let h=t;for(const u of r)if(typeof u=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let c=!1;for(const l of h.children)if(Array.isArray(l.children)&&l.children[0].value===u){h=l.children[1],c=!0;break}if(!c)return}else{const c=u;if(h.type!=="array"||c<0||!Array.isArray(h.children)||c>=h.children.length)return;h=h.children[c]}return h}e.$0m=k;function f(t){if(!t.parent||!t.parent.children)return[];const r=f(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;r.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&r.push(h)}return r}e.$$m=f;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const r=Object.create(null);for(const h of t.children){const u=h.children[1];u&&(r[h.children[0].value]=d(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$_m=d;function s(t,r,h=!1){return r>=t.offset&&r<t.offset+t.length||h&&r===t.offset+t.length}e.$an=s;function i(t,r,h=!1){if(s(t,r,h)){const u=t.children;if(Array.isArray(u))for(let c=0;c<u.length&&u[c].offset<=r;c++){const l=i(u[c],r,h);if(l)return l}return t}}e.$bn=i;function n(t,r,h=P.DEFAULT){const u=M(t,!1);function c(X){return X?()=>X(u.getTokenOffset(),u.getTokenLength()):()=>!0}function l(X){return X?ve=>X(ve,u.getTokenOffset(),u.getTokenLength()):()=>!0}const S=c(r.onObjectBegin),L=l(r.onObjectProperty),w=c(r.onObjectEnd),p=c(r.onArrayBegin),E=c(r.onArrayEnd),A=l(r.onLiteralValue),z=l(r.onSeparator),N=c(r.onComment),I=l(r.onError),j=h&&h.disallowComments,T=h&&h.allowTrailingComma;function F(){for(;;){const X=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:j||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(X){case 12:case 13:j?W(10):N();break;case 16:W(1);break;case 15:case 14:break;default:return X}}}function W(X,ve=[],ge=[]){if(I(X),ve.length+ge.length>0){let H=u.getToken();for(;H!==17;){if(ve.indexOf(H)!==-1){F();break}else if(ge.indexOf(H)!==-1)break;H=F()}}}function Y(X){const ve=u.getTokenValue();return X?A(ve):L(ve),F(),!0}function le(){switch(u.getToken()){case 11:{let X=0;try{X=JSON.parse(u.getTokenValue()),typeof X!="number"&&(W(2),X=0)}catch{W(2)}A(X);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return F(),!0}function Q(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(Y(!1),u.getToken()===6?(z(":"),F(),oe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Z(){S(),F();let X=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(X||W(4,[],[]),z(","),F(),u.getToken()===2&&T)break}else X&&W(6,[],[]);Q()||W(4,[],[2,5]),X=!0}return w(),u.getToken()!==2?W(7,[2],[]):F(),!0}function x(){p(),F();let X=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(X||W(4,[],[]),z(","),F(),u.getToken()===4&&T)break}else X&&W(6,[],[]);oe()||W(4,[],[4,5]),X=!0}return E(),u.getToken()!==4?W(8,[4],[]):F(),!0}function oe(){switch(u.getToken()){case 3:return x();case 1:return Z();case 10:return Y(!0);default:return le()}}return F(),u.getToken()===17?h.allowEmptyContent?!0:(W(4,[],[]),!1):oe()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$cn=n;function o(t,r){const h=M(t),u=[];let c,l=0,S;do switch(S=h.getPosition(),c=h.scan(),c){case 12:case 13:case 17:l!==S&&u.push(t.substring(l,S)),r!==void 0&&u.push(h.getTokenValue().replace(/[^\r\n]/g,r)),l=h.getPosition();break}while(c!==17);return u.join("")}e.$dn=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$en=a}),define(Se[43],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Se[75],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(P){this.element=P,this.next=D.Undefined,this.prev=D.Undefined}}class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let P=this.a;for(;P!==D.Undefined;){const M=P.next;P.prev=D.Undefined,P.next=D.Undefined,P=M}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,M){const b=new D(P);if(this.a===D.Undefined)this.a=b,this.b=b;else if(M){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==D.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==D.Undefined&&P.next!==D.Undefined){const M=P.prev;M.next=P.next,P.next.prev=M}else P.prev===D.Undefined&&P.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):P.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):P.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==D.Undefined;)yield P.element,P=P.next}}e.$3c=O}),define(Se[28],ke([1,0]),function($e,e){"use strict";var D,O,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$xc=P;function M(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$yc=M;function b(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$zc=b;class ${constructor(n,o){this.uri=n,this.value=o}}function y(i){return Array.isArray(i)}class R{static{this.a=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof R)this.b=new Map(n.b),this.c=o??R.a;else if(y(n)){this.b=new Map,this.c=o??R.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??R.a}set(n,o){return this.b.set(this.c(n),new $(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$Ac=R;class C{constructor(n,o){this[O]="ResourceSet",!n||typeof n=="function"?this.a=new R(n):(this.a=new R(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Cc=v;class k extends v{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class f{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Ec=f;class d{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=d;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Gc=s}),define(Se[3],ke([1,0,19,73,28,74,52]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(A){let z=this.b.get(A);return z||(z={parent:null,source:null,isSingleton:!1,value:A,idx:y.a++},this.b.set(A,z)),z}trackDisposable(A){const z=this.c(A);z.source||(z.source=new Error().stack)}setParent(A,z){const N=this.c(A);N.parent=z}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,z){const N=z.get(A);if(N)return N;const I=A.parent?this.f(this.c(A.parent),z):A;return z.set(A,I),I}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,A).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(A=10,z){let N;if(z)N=z;else{const W=new Map,Y=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,W).isSingleton);if(Y.length===0)return;const le=new Set(Y.map(Q=>Q.value));if(N=Y.filter(Q=>!(Q.parent&&le.has(Q.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function I(W){function Y(Q,Z){for(;Q.length>0&&Z.some(x=>typeof x=="string"?x===Q[0]:Q[0].match(x));)Q.shift()}const le=W.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return Y(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const j=new g.$Gc;for(const W of N){const Y=I(W);for(let le=0;le<=Y.length;le++)j.add(Y.slice(0,le).join(`
`),W)}N.sort((0,D.$7b)(W=>W.idx,D.$9b));let T="",F=0;for(const W of N.slice(0,A)){F++;const Y=I(W),le=[];for(let Q=0;Q<Y.length;Q++){let Z=Y[Q];Z=`(shared with ${j.get(Y.slice(0,Q+1).join(`
`)).size}/${N.length} leaks) at ${Z}`;const oe=j.get(Y.slice(0,Q).join(`
`)),X=(0,O.$K)([...oe].map(ve=>I(ve)[Q]),ve=>ve);delete X[Y[Q]];for(const[ve,ge]of Object.entries(X))le.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${ve}`);le.unshift(Z)}T+=`


==================== Leaking disposable ${F}/${N.length}: ${W.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return N.length>A&&(T+=`


... and ${N.length-A} more leaking disposables

`),{leaks:N,details:T}}}e.$Hc=y;function R(E){$=E}if(e.$Ic=R,b){const E="__is_disposable_tracked__";R(new class{trackDisposable(A){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[E]||console.log(z)},3e3)}setParent(A,z){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsSingleton(A){}})}function C(E){return $?.trackDisposable(E),E}e.$Jc=C;function m(E){$?.markAsDisposed(E)}e.$Kc=m;function v(E,A){$?.setParent(E,A)}function k(E,A){if($)for(const z of E)$.setParent(z,A)}function f(E){return $?.markAsSingleton(E),E}e.$Lc=f;function d(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=d;function s(E){if(M.Iterable.is(E)){const A=[];for(const z of E)if(z)try{z.dispose()}catch(N){A.push(N)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=s;function i(E){for(const A of E)d(A)&&A.dispose();return[]}e.$Oc=i;function n(...E){const A=o(()=>s(E));return k(E,A),A}e.$Pc=n;function o(E){const A=C({dispose:(0,P.$db)(()=>{m(A),E()})});return A}e.$Qc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return v(A,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),v(A,null))}}e.$Rc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),v(this.q,this)}dispose(){m(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Sc=t;class r{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&v(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&v(A,null),A}}e.$Tc=r;class h{constructor(A){this.a=new r,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=h;class u{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(A){let z=A;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,m(this))},this}}e.$Wc=c;class l{constructor(){this.a=new Map}acquire(A,...z){let N=this.a.get(A);N||(N={counter:0,object:this.b(A,...z)},this.a.set(A,N));const{object:I}=N,j=(0,P.$db)(()=>{--N.counter===0&&(this.c(A,N.object),this.a.delete(A))});return N.counter++,{object:I,dispose:j}}}e.$Xc=l;class S{constructor(A){this.a=A}async acquire(A,...z){const N=this.a.acquire(A,...z);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(I){throw N.dispose(),I}}}e.$Yc=S;class L{constructor(A){this.object=A}dispose(){}}e.$Zc=L;function w(E){const A=new a;try{E(A)}finally{A.dispose()}}e.$1c=w;class p{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,z,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(A)?.dispose(),this.a.set(A,z)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=p}),function($e,e){typeof define=="function"&&define.amd?define(Se[160],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(me,ee){for(var ie=0;ie<ee.length;ie++){var G=ee[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(me,G.key,G)}}function D(me,ee,ie){return ee&&e(me.prototype,ee),ie&&e(me,ie),Object.defineProperty(me,"prototype",{writable:!1}),me}function O(me,ee){if(me){if(typeof me=="string")return g(me,ee);var ie=Object.prototype.toString.call(me).slice(8,-1);if(ie==="Object"&&me.constructor&&(ie=me.constructor.name),ie==="Map"||ie==="Set")return Array.from(me);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return g(me,ee)}}function g(me,ee){(ee==null||ee>me.length)&&(ee=me.length);for(var ie=0,G=new Array(ee);ie<ee;ie++)G[ie]=me[ie];return G}function P(me,ee){var ie=typeof Symbol<"u"&&me[Symbol.iterator]||me["@@iterator"];if(ie)return(ie=ie.call(me)).next.bind(ie);if(Array.isArray(me)||(ie=O(me))||ee&&me&&typeof me.length=="number"){ie&&(me=ie);var G=0;return function(){return G>=me.length?{done:!0}:{done:!1,value:me[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=M();function b(me){$e.defaults=me}var $=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ee){return m[ee]};function k(me,ee){if(ee){if($.test(me))return me.replace(y,v)}else if(R.test(me))return me.replace(C,v);return me}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(me){return me.replace(f,function(ee,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(me,ee){me=typeof me=="string"?me:me.source,ee=ee||"";var ie={replace:function(te,J){return J=J.source||J,J=J.replace(s,"$1"),me=me.replace(te,J),ie},getRegex:function(){return new RegExp(me,ee)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(me,ee,ie){if(me){var G;try{G=decodeURIComponent(d(ie)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}ee&&!o.test(ie)&&(ie=c(ee,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(me,ee){t[" "+me]||(r.test(me)?t[" "+me]=me+"/":t[" "+me]=w(me,"/",!0)),me=t[" "+me];var ie=me.indexOf(":")===-1;return ee.substring(0,2)==="//"?ie?ee:me.replace(h,"$1")+ee:ee.charAt(0)==="/"?ie?ee:me.replace(u,"$1")+ee:me+ee}var l={exec:function(){}};function S(me){for(var ee=1,ie,G;ee<arguments.length;ee++){ie=arguments[ee];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(me[G]=ie[G])}return me}function L(me,ee){var ie=me.replace(/\|/g,function(J,ce,be){for(var Ie=!1,Fe=ce;--Fe>=0&&be[Fe]==="\\";)Ie=!Ie;return Ie?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>ee)G.splice(ee);else for(;G.length<ee;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function w(me,ee,ie){var G=me.length;if(G===0)return"";for(var te=0;te<G;){var J=me.charAt(G-te-1);if(J===ee&&!ie)te++;else if(J!==ee&&ie)te++;else break}return me.slice(0,G-te)}function p(me,ee){if(me.indexOf(ee[1])===-1)return-1;for(var ie=me.length,G=0,te=0;te<ie;te++)if(me[te]==="\\")te++;else if(me[te]===ee[0])G++;else if(me[te]===ee[1]&&(G--,G<0))return te;return-1}function E(me){me&&me.sanitize&&!me.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(me,ee){if(ee<1)return"";for(var ie="";ee>1;)ee&1&&(ie+=me),ee>>=1,me+=me;return ie+me}function z(me,ee,ie,G){var te=ee.href,J=ee.title?k(ee.title):null,ce=me[1].replace(/\\([\[\]])/g,"$1");if(me[0].charAt(0)!=="!"){G.state.inLink=!0;var be={type:"link",raw:ie,href:te,title:J,text:ce,tokens:G.inlineTokens(ce)};return G.state.inLink=!1,be}return{type:"image",raw:ie,href:te,title:J,text:k(ce)}}function N(me,ee){var ie=me.match(/^(\s+)(?:```)/);if(ie===null)return ee;var G=ie[1];return ee.split(`
`).map(function(te){var J=te.match(/^\s+/);if(J===null)return te;var ce=J[0];return ce.length>=G.length?te.slice(G.length):te}).join(`
`)}var I=function(){function me(ie){this.options=ie||$e.defaults}var ee=me.prototype;return ee.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ee.code=function(G){var te=this.rules.block.code.exec(G);if(te){var J=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?J:w(J,`
`)}}},ee.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var J=te[0],ce=N(J,te[3]||"");return{type:"code",raw:J,lang:te[2]?te[2].trim():te[2],text:ce}}},ee.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var J=te[2].trim();if(/#$/.test(J)){var ce=w(J,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(J=ce.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:J,tokens:this.lexer.inline(J)}}},ee.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},ee.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var J=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},ee.list=function(G){var te=this.rules.block.list.exec(G);if(te){var J,ce,be,Ie,Fe,B,_,se,K,ae,de,Ae,Be=te[1].trim(),Xe=Be.length>1,Ye={type:"list",raw:"",ordered:Xe,start:Xe?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Xe?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Xe?Be:"[*+-]");for(var it=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Ae=!1,!(!(te=it.exec(G))||this.rules.block.hr.test(G)));){if(J=te[0],G=G.substring(J.length),se=te[2].split(`
`,1)[0],K=G.split(`
`,1)[0],this.options.pedantic?(Ie=2,de=se.trimLeft()):(Ie=te[2].search(/[^ ]/),Ie=Ie>4?1:Ie,de=se.slice(Ie),Ie+=te[1].length),B=!1,!se&&/^ *$/.test(K)&&(J+=K+`
`,G=G.substring(K.length+1),Ae=!0),!Ae)for(var st=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Pe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Te=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");G&&(ae=G.split(`
`,1)[0],se=ae,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Te.test(se)||qe.test(se)||st.test(se)||Pe.test(G)));){if(se.search(/[^ ]/)>=Ie||!se.trim())de+=`
`+se.slice(Ie);else if(!B)de+=`
`+se;else break;!B&&!se.trim()&&(B=!0),J+=ae+`
`,G=G.substring(ae.length+1)}Ye.loose||(_?Ye.loose=!0:/\n *\n *$/.test(J)&&(_=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(de),ce&&(be=ce[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:J,task:!!ce,checked:be,loose:!1,text:de}),Ye.raw+=J}Ye.items[Ye.items.length-1].raw=J.trimRight(),Ye.items[Ye.items.length-1].text=de.trimRight(),Ye.raw=Ye.raw.trimRight();var Re=Ye.items.length;for(Fe=0;Fe<Re;Fe++){this.lexer.state.top=!1,Ye.items[Fe].tokens=this.lexer.blockTokens(Ye.items[Fe].text,[]);var xe=Ye.items[Fe].tokens.filter(function(ue){return ue.type==="space"}),he=xe.every(function(ue){for(var Ce=ue.raw.split(""),Ve=0,Je=P(Ce),et;!(et=Je()).done;){var ot=et.value;if(ot===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&xe.length&&he&&(Ye.loose=!0,Ye.items[Fe].loose=!0)}return Ye}},ee.html=function(G){var te=this.rules.block.html.exec(G);if(te){var J={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]);J.type="paragraph",J.text=ce,J.tokens=this.lexer.inline(ce)}return J}},ee.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var J=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:te[0],href:te[2],title:te[3]}}},ee.table=function(G){var te=this.rules.block.table.exec(G);if(te){var J={type:"table",header:L(te[1]).map(function(_){return{text:_}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=te[0];var ce=J.align.length,be,Ie,Fe,B;for(be=0;be<ce;be++)/^ *-+: *$/.test(J.align[be])?J.align[be]="right":/^ *:-+: *$/.test(J.align[be])?J.align[be]="center":/^ *:-+ *$/.test(J.align[be])?J.align[be]="left":J.align[be]=null;for(ce=J.rows.length,be=0;be<ce;be++)J.rows[be]=L(J.rows[be],J.header.length).map(function(_){return{text:_}});for(ce=J.header.length,Ie=0;Ie<ce;Ie++)J.header[Ie].tokens=this.lexer.inline(J.header[Ie].text);for(ce=J.rows.length,Ie=0;Ie<ce;Ie++)for(B=J.rows[Ie],Fe=0;Fe<B.length;Fe++)B[Fe].tokens=this.lexer.inline(B[Fe].text);return J}}},ee.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ee.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var J=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:J,tokens:this.lexer.inline(J)}}},ee.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ee.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:k(te[1])}},ee.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]}},ee.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var J=te[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var ce=w(J.slice(0,-1),"\\");if((J.length-ce.length)%2===0)return}else{var be=p(te[2],"()");if(be>-1){var Ie=te[0].indexOf("!")===0?5:4,Fe=Ie+te[1].length+be;te[2]=te[2].substring(0,be),te[0]=te[0].substring(0,Fe).trim(),te[3]=""}}var B=te[2],_="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);se&&(B=se[1],_=se[3])}else _=te[3]?te[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(J)?B=B.slice(1):B=B.slice(1,-1)),z(te,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:_&&_.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ee.reflink=function(G,te){var J;if((J=this.rules.inline.reflink.exec(G))||(J=this.rules.inline.nolink.exec(G))){var ce=(J[2]||J[1]).replace(/\s+/g," ");if(ce=te[ce.toLowerCase()],!ce||!ce.href){var be=J[0].charAt(0);return{type:"text",raw:be,text:be}}return z(J,ce,J[0],this.lexer)}},ee.emStrong=function(G,te,J){J===void 0&&(J="");var ce=this.rules.inline.emStrong.lDelim.exec(G);if(ce&&!(ce[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=ce[1]||ce[2]||"";if(!be||be&&(J===""||this.rules.inline.punctuation.exec(J))){var Ie=ce[0].length-1,Fe,B,_=Ie,se=0,K=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,te=te.slice(-1*G.length+Ie);(ce=K.exec(te))!=null;)if(Fe=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!Fe){if(B=Fe.length,ce[3]||ce[4]){_+=B;continue}else if((ce[5]||ce[6])&&Ie%3&&!((Ie+B)%3)){se+=B;continue}if(_-=B,!(_>0)){if(B=Math.min(B,B+_+se),Math.min(Ie,B)%2){var ae=G.slice(1,Ie+ce.index+B);return{type:"em",raw:G.slice(0,Ie+ce.index+B+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var de=G.slice(2,Ie+ce.index+B-1);return{type:"strong",raw:G.slice(0,Ie+ce.index+B+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},ee.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var J=te[2].replace(/\n/g," "),ce=/[^ ]/.test(J),be=/^ /.test(J)&&/ $/.test(J);return ce&&be&&(J=J.substring(1,J.length-1)),J=k(J,!0),{type:"codespan",raw:te[0],text:J}}},ee.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},ee.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ee.autolink=function(G,te){var J=this.rules.inline.autolink.exec(G);if(J){var ce,be;return J[2]==="@"?(ce=k(this.options.mangle?te(J[1]):J[1]),be="mailto:"+ce):(ce=k(J[1]),be=ce),{type:"link",raw:J[0],text:ce,href:be,tokens:[{type:"text",raw:ce,text:ce}]}}},ee.url=function(G,te){var J;if(J=this.rules.inline.url.exec(G)){var ce,be;if(J[2]==="@")ce=k(this.options.mangle?te(J[0]):J[0]),be="mailto:"+ce;else{var Ie;do Ie=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(Ie!==J[0]);ce=k(J[0]),J[1]==="www."?be="http://"+ce:be=ce}return{type:"link",raw:J[0],text:ce,href:be,tokens:[{type:"text",raw:ce,text:ce}]}}},ee.inlineText=function(G,te){var J=this.rules.inline.text.exec(G);if(J){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):k(J[0]):J[0]:ce=k(this.options.smartypants?te(J[0]):J[0]),{type:"text",raw:J[0],text:ce}}},me}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=i(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=i(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=i(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=i(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=i(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=i(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=i(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=i(T.reflink).replace("label",T._label).replace("ref",j._label).getRegex(),T.nolink=i(T.nolink).replace("ref",j._label).getRegex(),T.reflinkSearch=i(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=S({},T),T.pedantic=S({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=S({},T.normal,{escape:i(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=i(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=S({},T.gfm,{br:i(T.br).replace("{2,}","*").getRegex(),text:i(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(me){return me.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(me){var ee="",ie,G,te=me.length;for(ie=0;ie<te;ie++)G=me.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),ee+="&#"+G+";";return ee}var Y=function(){function me(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||$e.defaults,this.options.tokenizer=this.options.tokenizer||new I,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:T.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=T.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=T.breaks:G.inline=T.gfm),this.tokenizer.rules=G}me.lex=function(G,te){var J=new me(te);return J.lex(G)},me.lexInline=function(G,te){var J=new me(te);return J.inlineTokens(G)};var ee=me.prototype;return ee.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ee.blockTokens=function(G,te){var J=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(_,se,K){return se+"    ".repeat(K.length)});for(var ce,be,Ie,Fe;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(_){return(ce=_.call({lexer:J},G,te))?(G=G.substring(ce.raw.length),te.push(ce),!0):!1}))){if(ce=this.tokenizer.space(G)){G=G.substring(ce.raw.length),ce.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(ce);continue}if(ce=this.tokenizer.code(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):te.push(ce);continue}if(ce=this.tokenizer.fences(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.heading(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.hr(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.blockquote(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.list(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.html(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.def(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.lheading(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(Ie=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var _=1/0,se=G.slice(1),K=void 0;J.options.extensions.startBlock.forEach(function(ae){K=ae.call({lexer:this},se),typeof K=="number"&&K>=0&&(_=Math.min(_,K))}),_<1/0&&_>=0&&(Ie=G.substring(0,_+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(Ie))){be=te[te.length-1],Fe&&be.type==="paragraph"?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):te.push(ce),Fe=Ie.length!==G.length,G=G.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&be.type==="text"?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):te.push(ce);continue}if(G){var B="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,te},ee.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},ee.inlineTokens=function(G,te){var J=this;te===void 0&&(te=[]);var ce,be,Ie,Fe=G,B,_,se;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)K.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,B.index)+"["+A("a",B[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,B.index)+"["+A("a",B[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Fe))!=null;)Fe=Fe.slice(0,B.index)+"++"+Fe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(_||(se=""),_=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(ce=de.call({lexer:J},G,te))?(G=G.substring(ce.raw.length),te.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.tag(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&ce.type==="text"&&be.type==="text"?(be.raw+=ce.raw,be.text+=ce.text):te.push(ce);continue}if(ce=this.tokenizer.link(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&ce.type==="text"&&be.type==="text"?(be.raw+=ce.raw,be.text+=ce.text):te.push(ce);continue}if(ce=this.tokenizer.emStrong(G,Fe,se)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.codespan(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.br(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.del(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.autolink(G,W)){G=G.substring(ce.raw.length),te.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(G,W))){G=G.substring(ce.raw.length),te.push(ce);continue}if(Ie=G,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Ae=G.slice(1),Be=void 0;J.options.extensions.startInline.forEach(function(Xe){Be=Xe.call({lexer:this},Ae),typeof Be=="number"&&Be>=0&&(de=Math.min(de,Be))}),de<1/0&&de>=0&&(Ie=G.substring(0,de+1))}(),ce=this.tokenizer.inlineText(Ie,F)){G=G.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(se=ce.raw.slice(-1)),_=!0,be=te[te.length-1],be&&be.type==="text"?(be.raw+=ce.raw,be.text+=ce.text):te.push(ce);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return te},D(me,null,[{key:"rules",get:function(){return{block:j,inline:T}}}]),me}(),le=function(){function me(ie){this.options=ie||$e.defaults}var ee=me.prototype;return ee.code=function(G,te,J){var ce=(te||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(G,ce);be!=null&&be!==G&&(J=!0,G=be)}return G=G.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+k(ce,!0)+'">'+(J?G:k(G,!0))+`</code></pre>
`:"<pre><code>"+(J?G:k(G,!0))+`</code></pre>
`},ee.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},ee.html=function(G){return G},ee.heading=function(G,te,J,ce){if(this.options.headerIds){var be=this.options.headerPrefix+ce.slug(J);return"<h"+te+' id="'+be+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(G,te,J){var ce=te?"ol":"ul",be=te&&J!==1?' start="'+J+'"':"";return"<"+ce+be+`>
`+G+"</"+ce+`>
`},ee.listitem=function(G){return"<li>"+G+`</li>
`},ee.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(G){return"<p>"+G+`</p>
`},ee.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},ee.tablerow=function(G){return`<tr>
`+G+`</tr>
`},ee.tablecell=function(G,te){var J=te.header?"th":"td",ce=te.align?"<"+J+' align="'+te.align+'">':"<"+J+">";return ce+G+("</"+J+`>
`)},ee.strong=function(G){return"<strong>"+G+"</strong>"},ee.em=function(G){return"<em>"+G+"</em>"},ee.codespan=function(G){return"<code>"+G+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(G){return"<del>"+G+"</del>"},ee.link=function(G,te,J){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return J;var ce='<a href="'+k(G)+'"';return te&&(ce+=' title="'+te+'"'),ce+=">"+J+"</a>",ce},ee.image=function(G,te,J){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return J;var ce='<img src="'+G+'" alt="'+J+'"';return te&&(ce+=' title="'+te+'"'),ce+=this.options.xhtml?"/>":">",ce},ee.text=function(G){return G},me}(),Q=function(){function me(){}var ee=me.prototype;return ee.strong=function(G){return G},ee.em=function(G){return G},ee.codespan=function(G){return G},ee.del=function(G){return G},ee.html=function(G){return G},ee.text=function(G){return G},ee.link=function(G,te,J){return""+J},ee.image=function(G,te,J){return""+J},ee.br=function(){return""},me}(),Z=function(){function me(){this.seen={}}var ee=me.prototype;return ee.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(G,te){var J=G,ce=0;if(this.seen.hasOwnProperty(J)){ce=this.seen[G];do ce++,J=G+"-"+ce;while(this.seen.hasOwnProperty(J))}return te||(this.seen[G]=ce,this.seen[J]=0),J},ee.slug=function(G,te){te===void 0&&(te={});var J=this.serialize(G);return this.getNextSafeSlug(J,te.dryrun)},me}(),x=function(){function me(ie){this.options=ie||$e.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Q,this.slugger=new Z}me.parse=function(G,te){var J=new me(te);return J.parse(G)},me.parseInline=function(G,te){var J=new me(te);return J.parseInline(G)};var ee=me.prototype;return ee.parse=function(G,te){te===void 0&&(te=!0);var J="",ce,be,Ie,Fe,B,_,se,K,ae,de,Ae,Be,Xe,Ye,it,st,Pe,Te,qe,Re=G.length;for(ce=0;ce<Re;ce++){if(de=G[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(qe=this.options.extensions.renderers[de.type].call({parser:this},de),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){J+=qe||"";continue}switch(de.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(de.tokens),de.depth,d(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(K="",se="",Fe=de.header.length,be=0;be<Fe;be++)se+=this.renderer.tablecell(this.parseInline(de.header[be].tokens),{header:!0,align:de.align[be]});for(K+=this.renderer.tablerow(se),ae="",Fe=de.rows.length,be=0;be<Fe;be++){for(_=de.rows[be],se="",B=_.length,Ie=0;Ie<B;Ie++)se+=this.renderer.tablecell(this.parseInline(_[Ie].tokens),{header:!1,align:de.align[Ie]});ae+=this.renderer.tablerow(se)}J+=this.renderer.table(K,ae);continue}case"blockquote":{ae=this.parse(de.tokens),J+=this.renderer.blockquote(ae);continue}case"list":{for(Ae=de.ordered,Be=de.start,Xe=de.loose,Fe=de.items.length,ae="",be=0;be<Fe;be++)it=de.items[be],st=it.checked,Pe=it.task,Ye="",it.task&&(Te=this.renderer.checkbox(st),Xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Te+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Te+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Te}):Ye+=Te),Ye+=this.parse(it.tokens,Xe),ae+=this.renderer.listitem(Ye,Pe,st);J+=this.renderer.list(ae,Ae,Be);continue}case"html":{J+=this.renderer.html(de.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ae=de.tokens?this.parseInline(de.tokens):de.text;ce+1<Re&&G[ce+1].type==="text";)de=G[++ce],ae+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);J+=te?this.renderer.paragraph(ae):ae;continue}default:{var xe='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}}return J},ee.parseInline=function(G,te){te=te||this.renderer;var J="",ce,be,Ie,Fe=G.length;for(ce=0;ce<Fe;ce++){if(be=G[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Ie=this.options.extensions.renderers[be.type].call({parser:this},be),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){J+=Ie||"";continue}switch(be.type){case"escape":{J+=te.text(be.text);break}case"html":{J+=te.html(be.text);break}case"link":{J+=te.link(be.href,be.title,this.parseInline(be.tokens,te));break}case"image":{J+=te.image(be.href,be.title,be.text);break}case"strong":{J+=te.strong(this.parseInline(be.tokens,te));break}case"em":{J+=te.em(this.parseInline(be.tokens,te));break}case"codespan":{J+=te.codespan(be.text);break}case"br":{J+=te.br();break}case"del":{J+=te.del(this.parseInline(be.tokens,te));break}case"text":{J+=te.text(be.text);break}default:{var B='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return J},me}();function oe(me,ee,ie){if(typeof me>"u"||me===null)throw new Error("marked(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");if(typeof ee=="function"&&(ie=ee,ee=null),ee=S({},oe.defaults,ee||{}),E(ee),ie){var G=ee.highlight,te;try{te=Y.lex(me,ee)}catch(Fe){return ie(Fe)}var J=function(B){var _;if(!B)try{ee.walkTokens&&oe.walkTokens(te,ee.walkTokens),_=x.parse(te,ee)}catch(se){B=se}return ee.highlight=G,B?ie(B):ie(null,_)};if(!G||G.length<3||(delete ee.highlight,!te.length))return J();var ce=0;oe.walkTokens(te,function(Fe){Fe.type==="code"&&(ce++,setTimeout(function(){G(Fe.text,Fe.lang,function(B,_){if(B)return J(B);_!=null&&_!==Fe.text&&(Fe.text=_,Fe.escaped=!0),ce--,ce===0&&J()})},0))}),ce===0&&J();return}function be(Fe){if(Fe.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+k(Fe.message+"",!0)+"</pre>";throw Fe}try{var Ie=Y.lex(me,ee);if(ee.walkTokens){if(ee.async)return Promise.all(oe.walkTokens(Ie,ee.walkTokens)).then(function(){return x.parse(Ie,ee)}).catch(be);oe.walkTokens(Ie,ee.walkTokens)}return x.parse(Ie,ee)}catch(Fe){be(Fe)}}oe.options=oe.setOptions=function(me){return S(oe.defaults,me),b(oe.defaults),oe},oe.getDefaults=M,oe.defaults=$e.defaults,oe.use=function(){for(var me=arguments.length,ee=new Array(me),ie=0;ie<me;ie++)ee[ie]=arguments[ie];var G=S.apply(void 0,[{}].concat(ee)),te=oe.defaults.extensions||{renderers:{},childTokens:{}},J;ee.forEach(function(ce){if(ce.extensions&&(J=!0,ce.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var Fe=te.renderers?te.renderers[Ie.name]:null;Fe?te.renderers[Ie.name]=function(){for(var B=arguments.length,_=new Array(B),se=0;se<B;se++)_[se]=arguments[se];var K=Ie.renderer.apply(this,_);return K===!1&&(K=Fe.apply(this,_)),K}:te.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[Ie.level]?te[Ie.level].unshift(Ie.tokenizer):te[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?te.startBlock?te.startBlock.push(Ie.start):te.startBlock=[Ie.start]:Ie.level==="inline"&&(te.startInline?te.startInline.push(Ie.start):te.startInline=[Ie.start]))}Ie.childTokens&&(te.childTokens[Ie.name]=Ie.childTokens)})),ce.renderer&&function(){var Ie=oe.defaults.renderer||new le,Fe=function(se){var K=Ie[se];Ie[se]=function(){for(var ae=arguments.length,de=new Array(ae),Ae=0;Ae<ae;Ae++)de[Ae]=arguments[Ae];var Be=ce.renderer[se].apply(Ie,de);return Be===!1&&(Be=K.apply(Ie,de)),Be}};for(var B in ce.renderer)Fe(B);G.renderer=Ie}(),ce.tokenizer&&function(){var Ie=oe.defaults.tokenizer||new I,Fe=function(se){var K=Ie[se];Ie[se]=function(){for(var ae=arguments.length,de=new Array(ae),Ae=0;Ae<ae;Ae++)de[Ae]=arguments[Ae];var Be=ce.tokenizer[se].apply(Ie,de);return Be===!1&&(Be=K.apply(Ie,de)),Be}};for(var B in ce.tokenizer)Fe(B);G.tokenizer=Ie}(),ce.walkTokens){var be=oe.defaults.walkTokens;G.walkTokens=function(Ie){var Fe=[];return Fe.push(ce.walkTokens.call(this,Ie)),be&&(Fe=Fe.concat(be.call(this,Ie))),Fe}}J&&(G.extensions=te),oe.setOptions(G)})},oe.walkTokens=function(me,ee){for(var ie=[],G=function(){var be=J.value;switch(ie=ie.concat(ee.call(oe,be)),be.type){case"table":{for(var Ie=P(be.header),Fe;!(Fe=Ie()).done;){var B=Fe.value;ie=ie.concat(oe.walkTokens(B.tokens,ee))}for(var _=P(be.rows),se;!(se=_()).done;)for(var K=se.value,ae=P(K),de;!(de=ae()).done;){var Ae=de.value;ie=ie.concat(oe.walkTokens(Ae.tokens,ee))}break}case"list":{ie=ie.concat(oe.walkTokens(be.items,ee));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[be.type]?oe.defaults.extensions.childTokens[be.type].forEach(function(Be){ie=ie.concat(oe.walkTokens(be[Be],ee))}):be.tokens&&(ie=ie.concat(oe.walkTokens(be.tokens,ee)))}},te=P(me),J;!(J=te()).done;)G();return ie},oe.parseInline=function(me,ee){if(typeof me>"u"||me===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");ee=S({},oe.defaults,ee||{}),E(ee);try{var ie=Y.lexInline(me,ee);return ee.walkTokens&&oe.walkTokens(ie,ee.walkTokens),x.parseInline(ie,ee)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+k(G.message+"",!0)+"</pre>";throw G}},oe.Parser=x,oe.parser=x.parse,oe.Renderer=le,oe.TextRenderer=Q,oe.Lexer=Y,oe.lexer=Y.lex,oe.Tokenizer=I,oe.Slugger=Z,oe.parse=oe;var X=oe.options,ve=oe.setOptions,ge=oe.use,H=oe.walkTokens,U=oe.parseInline,ne=oe,ye=x.parse,fe=Y.lex;$e.Lexer=Y,$e.Parser=x,$e.Renderer=le,$e.Slugger=Z,$e.TextRenderer=Q,$e.Tokenizer=I,$e.getDefaults=M,$e.lexer=fe,$e.marked=oe,$e.options=X,$e.parse=ne,$e.parseInline=U,$e.parser=ye,$e.setOptions=ve,$e.use=ge,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(Se[76],ke([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.$zl=void 0;const O=new D.$Dc(1e4);function g(y){return $(y,"NFC",O)}e.$zl=g;const P=new D.$Dc(1e4);function M(y){return $(y,"NFD",P)}e.$Al=M;const b=/[^\u0000-\u0080]/;function $(y,R,C){if(!y)return y;const m=C.get(y);if(m)return m;let v;return b.test(y)?v=y.normalize(R):v=y,C.set(y,v),v}e.$Bl=function(){const y=/[\u0300-\u036f]/g;return function(R){return M(R).replace(y,"")}}()}),define(Se[122],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.rot=e.$Zl=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$Zl=D;function O(b,$){return($+b%$)%$}e.rot=O;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$2l=g;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$3l=P;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$4l=M}),function(){function $e(g){const P=[];typeof g=="number"&&P.push("code/timeOrigin",g);function M($){P.push($,Date.now())}function b(){const $=[];for(let y=0;y<P.length;y+=2)$.push({name:P[y],startTime:P[y+1]});return $}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const M of performance.getEntriesByType("mark"))P.push({name:M.name,startTime:Math.round(g+M.startTime)});return P}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:$e)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(O){if(e[O])return e[O].exports;var g=e[O]={i:O,l:!1,exports:{}};return $e[O].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=$e,D.c=e,D.d=function(O,g,P){D.o(O,g)||Object.defineProperty(O,g,{enumerable:!0,get:P})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,g){if(1&g&&(O=D(O)),8&g||4&g&&typeof O=="object"&&O&&O.__esModule)return O;var P=Object.create(null);if(D.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:O}),2&g&&typeof O!="string")for(var M in O)D.d(P,M,function(b){return O[b]}.bind(null,M));return P},D.n=function(O){var g=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(g,"a",g),g},D.o=function(O,g){return Object.prototype.hasOwnProperty.call(O,g)},D.p="",D(D.s=0)}([function($e,e,D){(function(O){var g;e=$e.exports=ge,g=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,R=y++;$[R]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;$[v]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var k=y++;$[k]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var f=y++;$[f]="(?:"+$[R]+"|"+$[m]+")";var d=y++;$[d]="(?:"+$[C]+"|"+$[m]+")";var s=y++;$[s]="(?:-("+$[f]+"(?:\\."+$[f]+")*))";var i=y++;$[i]="(?:-?("+$[d]+"(?:\\."+$[d]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var o=y++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var a=y++,t="v?"+$[v]+$[s]+"?"+$[o]+"?";$[a]="^"+t+"$";var r="[v=\\s]*"+$[k]+$[i]+"?"+$[o]+"?",h=y++;$[h]="^"+r+"$";var u=y++;$[u]="((?:<|>)?=?)";var c=y++;$[c]=$[C]+"|x|X|\\*";var l=y++;$[l]=$[R]+"|x|X|\\*";var S=y++;$[S]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[s]+")?"+$[o]+"?)?)?";var L=y++;$[L]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[i]+")?"+$[o]+"?)?)?";var w=y++;$[w]="^"+$[u]+"\\s*"+$[S]+"$";var p=y++;$[p]="^"+$[u]+"\\s*"+$[L]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=y++;$[A]="(?:~>?)";var z=y++;$[z]="(\\s*)"+$[A]+"\\s+",b[z]=new RegExp($[z],"g");var N=y++;$[N]="^"+$[A]+$[S]+"$";var I=y++;$[I]="^"+$[A]+$[L]+"$";var j=y++;$[j]="(?:\\^)";var T=y++;$[T]="(\\s*)"+$[j]+"\\s+",b[T]=new RegExp($[T],"g");var F=y++;$[F]="^"+$[j]+$[S]+"$";var W=y++;$[W]="^"+$[j]+$[L]+"$";var Y=y++;$[Y]="^"+$[u]+"\\s*("+r+")$|^$";var le=y++;$[le]="^"+$[u]+"\\s*("+t+")$|^$";var Q=y++;$[Q]="(\\s*)"+$[u]+"\\s*("+r+"|"+$[S]+")",b[Q]=new RegExp($[Q],"g");var Z=y++;$[Z]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var x=y++;$[x]="^\\s*("+$[L]+")\\s+-\\s+("+$[L]+")\\s*$";var oe=y++;$[oe]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)g(X,$[X]),b[X]||(b[X]=new RegExp($[X]));function ve(K,ae){if(K instanceof ge)return K;if(typeof K!="string"||K.length>P||!(ae?b[h]:b[a]).test(K))return null;try{return new ge(K,ae)}catch{return null}}function ge(K,ae){if(K instanceof ge){if(K.loose===ae)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ge))return new ge(K,ae);g("SemVer",K,ae),this.loose=ae;var de=K.trim().match(ae?b[h]:b[a]);if(!de)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ae){if(/^[0-9]+$/.test(Ae)){var Be=+Ae;if(Be>=0&&Be<M)return Be}return Ae}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ve,e.valid=function(K,ae){var de=ve(K,ae);return de?de.version:null},e.clean=function(K,ae){var de=ve(K.trim().replace(/^[=v]+/,""),ae);return de?de.version:null},e.SemVer=ge,ge.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ge.prototype.toString=function(){return this.version},ge.prototype.compare=function(K){return g("SemVer.compare",this.version,this.loose,K),K instanceof ge||(K=new ge(K,this.loose)),this.compareMain(K)||this.comparePre(K)},ge.prototype.compareMain=function(K){return K instanceof ge||(K=new ge(K,this.loose)),U(this.major,K.major)||U(this.minor,K.minor)||U(this.patch,K.patch)},ge.prototype.comparePre=function(K){if(K instanceof ge||(K=new ge(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var ae=0;do{var de=this.prerelease[ae],Ae=K.prerelease[ae];if(g("prerelease compare",ae,de,Ae),de===void 0&&Ae===void 0)return 0;if(Ae===void 0)return 1;if(de===void 0)return-1;if(de!==Ae)return U(de,Ae)}while(++ae)},ge.prototype.inc=function(K,ae){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,ae,de,Ae){typeof de=="string"&&(Ae=de,de=void 0);try{return new ge(K,de).inc(ae,Ae).version}catch{return null}},e.diff=function(K,ae){if(me(K,ae))return null;var de=ve(K),Ae=ve(ae);if(de.prerelease.length||Ae.prerelease.length){for(var Be in de)if((Be==="major"||Be==="minor"||Be==="patch")&&de[Be]!==Ae[Be])return"pre"+Be;return"prerelease"}for(var Be in de)if((Be==="major"||Be==="minor"||Be==="patch")&&de[Be]!==Ae[Be])return Be},e.compareIdentifiers=U;var H=/^[0-9]+$/;function U(K,ae){var de=H.test(K),Ae=H.test(ae);return de&&Ae&&(K=+K,ae=+ae),de&&!Ae?-1:Ae&&!de?1:K<ae?-1:K>ae?1:0}function ne(K,ae,de){return new ge(K,de).compare(new ge(ae,de))}function ye(K,ae,de){return ne(K,ae,de)>0}function fe(K,ae,de){return ne(K,ae,de)<0}function me(K,ae,de){return ne(K,ae,de)===0}function ee(K,ae,de){return ne(K,ae,de)!==0}function ie(K,ae,de){return ne(K,ae,de)>=0}function G(K,ae,de){return ne(K,ae,de)<=0}function te(K,ae,de,Ae){var Be;switch(ae){case"===":typeof K=="object"&&(K=K.version),typeof de=="object"&&(de=de.version),Be=K===de;break;case"!==":typeof K=="object"&&(K=K.version),typeof de=="object"&&(de=de.version),Be=K!==de;break;case"":case"=":case"==":Be=me(K,de,Ae);break;case"!=":Be=ee(K,de,Ae);break;case">":Be=ye(K,de,Ae);break;case">=":Be=ie(K,de,Ae);break;case"<":Be=fe(K,de,Ae);break;case"<=":Be=G(K,de,Ae);break;default:throw new TypeError("Invalid operator: "+ae)}return Be}function J(K,ae){if(K instanceof J){if(K.loose===ae)return K;K=K.value}if(!(this instanceof J))return new J(K,ae);g("comparator",K,ae),this.loose=ae,this.parse(K),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(K,ae){return U(ae,K)},e.major=function(K,ae){return new ge(K,ae).major},e.minor=function(K,ae){return new ge(K,ae).minor},e.patch=function(K,ae){return new ge(K,ae).patch},e.compare=ne,e.compareLoose=function(K,ae){return ne(K,ae,!0)},e.rcompare=function(K,ae,de){return ne(ae,K,de)},e.sort=function(K,ae){return K.sort(function(de,Ae){return e.compare(de,Ae,ae)})},e.rsort=function(K,ae){return K.sort(function(de,Ae){return e.rcompare(de,Ae,ae)})},e.gt=ye,e.lt=fe,e.eq=me,e.neq=ee,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=J;var ce={};function be(K,ae){if(K instanceof be)return K.loose===ae?K:new be(K.raw,ae);if(K instanceof J)return new be(K.value,ae);if(!(this instanceof be))return new be(K,ae);if(this.loose=ae,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Ie(K){return!K||K.toLowerCase()==="x"||K==="*"}function Fe(K,ae,de,Ae,Be,Xe,Ye,it,st,Pe,Te,qe,Re){return((ae=Ie(de)?"":Ie(Ae)?">="+de+".0.0":Ie(Be)?">="+de+"."+Ae+".0":">="+ae)+" "+(it=Ie(st)?"":Ie(Pe)?"<"+(+st+1)+".0.0":Ie(Te)?"<"+st+"."+(+Pe+1)+".0":qe?"<="+st+"."+Pe+"."+Te+"-"+qe:"<="+it)).trim()}function B(K,ae){for(var de=0;de<K.length;de++)if(!K[de].test(ae))return!1;if(ae.prerelease.length){for(de=0;de<K.length;de++)if(g(K[de].semver),K[de].semver!==ce&&K[de].semver.prerelease.length>0){var Ae=K[de].semver;if(Ae.major===ae.major&&Ae.minor===ae.minor&&Ae.patch===ae.patch)return!0}return!1}return!0}function _(K,ae,de){try{ae=new be(ae,de)}catch{return!1}return ae.test(K)}function se(K,ae,de,Ae){var Be,Xe,Ye,it,st;switch(K=new ge(K,Ae),ae=new be(ae,Ae),de){case">":Be=ye,Xe=G,Ye=fe,it=">",st=">=";break;case"<":Be=fe,Xe=ie,Ye=ye,it="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_(K,ae,Ae))return!1;for(var Pe=0;Pe<ae.set.length;++Pe){var Te=ae.set[Pe],qe=null,Re=null;if(Te.forEach(function(xe){xe.semver===ce&&(xe=new J(">=0.0.0")),qe=qe||xe,Re=Re||xe,Be(xe.semver,qe.semver,Ae)?qe=xe:Ye(xe.semver,Re.semver,Ae)&&(Re=xe)}),qe.operator===it||qe.operator===st||(!Re.operator||Re.operator===it)&&Xe(K,Re.semver)||Re.operator===st&&Ye(K,Re.semver))return!1}return!0}J.prototype.parse=function(K){var ae=this.loose?b[Y]:b[le],de=K.match(ae);if(!de)throw new TypeError("Invalid comparator: "+K);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new ge(de[2],this.loose):this.semver=ce},J.prototype.toString=function(){return this.value},J.prototype.test=function(K){return g("Comparator.test",K,this.loose),this.semver===ce||(typeof K=="string"&&(K=new ge(K,this.loose)),te(K,this.operator,this.semver,this.loose))},J.prototype.intersects=function(K,ae){if(!(K instanceof J))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new be(K.value,ae),_(this.value,de,ae);if(K.operator==="")return de=new be(this.value,ae),_(K.semver,de,ae);var Ae=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Xe=this.semver.version===K.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),it=te(this.semver,"<",K.semver,ae)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),st=te(this.semver,">",K.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return Ae||Be||Xe&&Ye||it||st},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(K){var ae=this.loose;K=K.trim(),g("range",K,ae);var de=ae?b[x]:b[Z];K=K.replace(de,Fe),g("hyphen replace",K),K=K.replace(b[Q],"$1$2$3"),g("comparator trim",K,b[Q]),K=(K=(K=K.replace(b[z],"$1~")).replace(b[T],"$1^")).split(/\s+/).join(" ");var Ae=ae?b[Y]:b[le],Be=K.split(" ").map(function(Xe){return function(Ye,it){return g("comp",Ye),Ye=function(st,Pe){return st.trim().split(/\s+/).map(function(Te){return function(qe,Re){g("caret",qe,Re);var xe=Re?b[W]:b[F];return qe.replace(xe,function(he,ue,Ce,Ve,Je){var et;return g("caret",qe,he,ue,Ce,Ve,Je),Ie(ue)?et="":Ie(Ce)?et=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ie(Ve)?et=ue==="0"?">="+ue+"."+Ce+".0 <"+ue+"."+(+Ce+1)+".0":">="+ue+"."+Ce+".0 <"+(+ue+1)+".0.0":Je?(g("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),et=ue==="0"?Ce==="0"?">="+ue+"."+Ce+"."+Ve+Je+" <"+ue+"."+Ce+"."+(+Ve+1):">="+ue+"."+Ce+"."+Ve+Je+" <"+ue+"."+(+Ce+1)+".0":">="+ue+"."+Ce+"."+Ve+Je+" <"+(+ue+1)+".0.0"):(g("no pr"),et=ue==="0"?Ce==="0"?">="+ue+"."+Ce+"."+Ve+" <"+ue+"."+Ce+"."+(+Ve+1):">="+ue+"."+Ce+"."+Ve+" <"+ue+"."+(+Ce+1)+".0":">="+ue+"."+Ce+"."+Ve+" <"+(+ue+1)+".0.0"),g("caret return",et),et})}(Te,Pe)}).join(" ")}(Ye,it),g("caret",Ye),Ye=function(st,Pe){return st.trim().split(/\s+/).map(function(Te){return function(qe,Re){var xe=Re?b[I]:b[N];return qe.replace(xe,function(he,ue,Ce,Ve,Je){var et;return g("tilde",qe,he,ue,Ce,Ve,Je),Ie(ue)?et="":Ie(Ce)?et=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ie(Ve)?et=">="+ue+"."+Ce+".0 <"+ue+"."+(+Ce+1)+".0":Je?(g("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),et=">="+ue+"."+Ce+"."+Ve+Je+" <"+ue+"."+(+Ce+1)+".0"):et=">="+ue+"."+Ce+"."+Ve+" <"+ue+"."+(+Ce+1)+".0",g("tilde return",et),et})}(Te,Pe)}).join(" ")}(Ye,it),g("tildes",Ye),Ye=function(st,Pe){return g("replaceXRanges",st,Pe),st.split(/\s+/).map(function(Te){return function(qe,Re){qe=qe.trim();var xe=Re?b[p]:b[w];return qe.replace(xe,function(he,ue,Ce,Ve,Je,et){g("xRange",qe,he,ue,Ce,Ve,Je,et);var ot=Ie(Ce),ut=ot||Ie(Ve),je=ut||Ie(Je);return ue==="="&&je&&(ue=""),ot?he=ue===">"||ue==="<"?"<0.0.0":"*":ue&&je?(ut&&(Ve=0),je&&(Je=0),ue===">"?(ue=">=",ut?(Ce=+Ce+1,Ve=0,Je=0):je&&(Ve=+Ve+1,Je=0)):ue==="<="&&(ue="<",ut?Ce=+Ce+1:Ve=+Ve+1),he=ue+Ce+"."+Ve+"."+Je):ut?he=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":je&&(he=">="+Ce+"."+Ve+".0 <"+Ce+"."+(+Ve+1)+".0"),g("xRange return",he),he})}(Te,Pe)}).join(" ")}(Ye,it),g("xrange",Ye),Ye=function(st,Pe){return g("replaceStars",st,Pe),st.trim().replace(b[oe],"")}(Ye,it),g("stars",Ye),Ye}(Xe,ae)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Xe){return!!Xe.match(Ae)})),Be=Be.map(function(Xe){return new J(Xe,ae)})},be.prototype.intersects=function(K,ae){if(!(K instanceof be))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ae){return K.set.some(function(Be){return Be.every(function(Xe){return Ae.intersects(Xe,ae)})})})})},e.toComparators=function(K,ae){return new be(K,ae).set.map(function(de){return de.map(function(Ae){return Ae.value}).join(" ").trim().split(" ")})},be.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new ge(K,this.loose));for(var ae=0;ae<this.set.length;ae++)if(B(this.set[ae],K))return!0;return!1},e.satisfies=_,e.maxSatisfying=function(K,ae,de){var Ae=null,Be=null;try{var Xe=new be(ae,de)}catch{return null}return K.forEach(function(Ye){Xe.test(Ye)&&(Ae&&Be.compare(Ye)!==-1||(Be=new ge(Ae=Ye,de)))}),Ae},e.minSatisfying=function(K,ae,de){var Ae=null,Be=null;try{var Xe=new be(ae,de)}catch{return null}return K.forEach(function(Ye){Xe.test(Ye)&&(Ae&&Be.compare(Ye)!==1||(Be=new ge(Ae=Ye,de)))}),Ae},e.validRange=function(K,ae){try{return new be(K,ae).range||"*"}catch{return null}},e.ltr=function(K,ae,de){return se(K,ae,"<",de)},e.gtr=function(K,ae,de){return se(K,ae,">",de)},e.outside=se,e.prerelease=function(K,ae){var de=ve(K,ae);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(K,ae,de){return K=new be(K,de),ae=new be(ae,de),K.intersects(ae)},e.coerce=function(K){if(K instanceof ge)return K;if(typeof K!="string")return null;var ae=K.match(b[E]);return ae==null?null:ve((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function($e,e){var D,O,g=$e.exports={};function P(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(d){if(D===setTimeout)return setTimeout(d,0);if((D===P||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:P}catch{D=P}try{O=typeof clearTimeout=="function"?clearTimeout:M}catch{O=M}})();var $,y=[],R=!1,C=-1;function m(){R&&$&&(R=!1,$.length?y=$.concat(y):C=-1,y.length&&v())}function v(){if(!R){var d=b(m);R=!0;for(var s=y.length;s;){for($=y,y=[];++C<s;)$&&$[C].run();C=-1,s=y.length}$=null,R=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===M||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(d)}}function k(d,s){this.fun=d,this.array=s}function f(){}g.nextTick=function(d){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new k(d,s)),y.length!==1||R||b(v)},k.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=f,g.addListener=f,g.once=f,g.off=f,g.removeListener=f,g.removeAllListeners=f,g.emit=f,g.prependListener=f,g.prependOnceListener=f,g.listeners=function(d){return[]},g.binding=function(d){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(d){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[38],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(P){return new O(P)}constructor(P){this.c=D&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=O}),define(Se[4],ke([1,0,8,74,3,75,38]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const b=!1,$=!1;var y;(function(w){w.None=()=>g.$Sc.None;function p(te){if($){const{onDidAddListener:J}=te,ce=k.create();let be=0;te.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),J?.()}}}function E(te,J){return le(te,()=>{},0,void 0,!0,void 0,J)}w.defer=E;function A(te){return(J,ce=null,be)=>{let Ie=!1,Fe;return Fe=te(B=>{if(!Ie)return Fe?Fe.dispose():Ie=!0,J.call(ce,B)},null,be),Ie&&Fe.dispose(),Fe}}w.once=A;function z(te,J,ce){return W((be,Ie=null,Fe)=>te(B=>be.call(Ie,J(B)),null,Fe),ce)}w.map=z;function N(te,J,ce){return W((be,Ie=null,Fe)=>te(B=>{J(B),be.call(Ie,B)},null,Fe),ce)}w.forEach=N;function I(te,J,ce){return W((be,Ie=null,Fe)=>te(B=>J(B)&&be.call(Ie,B),null,Fe),ce)}w.filter=I;function j(te){return te}w.signal=j;function T(...te){return(J,ce=null,be)=>{const Ie=(0,g.$Pc)(...te.map(Fe=>Fe(B=>J.call(ce,B))));return Y(Ie,be)}}w.any=T;function F(te,J,ce,be){let Ie=ce;return z(te,Fe=>(Ie=J(Ie,Fe),Ie),be)}w.reduce=F;function W(te,J){let ce;const be={onWillAddFirstListener(){ce=te(Ie.fire,Ie)},onDidRemoveLastListener(){ce?.dispose()}};J||p(be);const Ie=new n(be);return J?.add(Ie),Ie.event}function Y(te,J){return J instanceof Array?J.push(te):J&&J.add(te),te}function le(te,J,ce=100,be=!1,Ie=!1,Fe,B){let _,se,K,ae=0,de;const Ae={leakWarningThreshold:Fe,onWillAddFirstListener(){_=te(Xe=>{ae++,se=J(se,Xe),be&&!K&&(Be.fire(se),se=void 0),de=()=>{const Ye=se;se=void 0,K=void 0,(!be||ae>1)&&Be.fire(Ye),ae=0},typeof ce=="number"?(clearTimeout(K),K=setTimeout(de,ce)):K===void 0&&(K=0,queueMicrotask(de))})},onWillRemoveListener(){Ie&&ae>0&&de?.()},onDidRemoveLastListener(){de=void 0,_.dispose()}};B||p(Ae);const Be=new n(Ae);return B?.add(Be),Be.event}w.debounce=le;function Q(te,J=0,ce){return w.debounce(te,(be,Ie)=>be?(be.push(Ie),be):[Ie],J,void 0,!0,void 0,ce)}w.accumulate=Q;function Z(te,J=(be,Ie)=>be===Ie,ce){let be=!0,Ie;return I(te,Fe=>{const B=be||!J(Fe,Ie);return be=!1,Ie=Fe,B},ce)}w.latch=Z;function x(te,J,ce){return[w.filter(te,J,ce),w.filter(te,be=>!J(be),ce)]}w.split=x;function oe(te,J=!1,ce=[],be){let Ie=ce.slice(),Fe=te(se=>{Ie?Ie.push(se):_.fire(se)});be&&be.add(Fe);const B=()=>{Ie?.forEach(se=>_.fire(se)),Ie=null},_=new n({onWillAddFirstListener(){Fe||(Fe=te(se=>_.fire(se)),be&&be.add(Fe))},onDidAddFirstListener(){Ie&&(J?setTimeout(B):B())},onDidRemoveLastListener(){Fe&&Fe.dispose(),Fe=null}});return be&&be.add(_),_.event}w.buffer=oe;function X(te,J){return(be,Ie,Fe)=>{const B=J(new ge);return te(function(_){const se=B.evaluate(_);se!==ve&&be.call(Ie,se)},void 0,Fe)}}w.chain=X;const ve=Symbol("HaltChainable");class ge{constructor(){this.f=[]}map(J){return this.f.push(J),this}forEach(J){return this.f.push(ce=>(J(ce),ce)),this}filter(J){return this.f.push(ce=>J(ce)?ce:ve),this}reduce(J,ce){let be=ce;return this.f.push(Ie=>(be=J(be,Ie),be)),this}latch(J=(ce,be)=>ce===be){let ce=!0,be;return this.f.push(Ie=>{const Fe=ce||!J(Ie,be);return ce=!1,be=Ie,Fe?Ie:ve}),this}evaluate(J){for(const ce of this.f)if(J=ce(J),J===ve)break;return J}}function H(te,J,ce=be=>be){const be=(..._)=>B.fire(ce(..._)),Ie=()=>te.on(J,be),Fe=()=>te.removeListener(J,be),B=new n({onWillAddFirstListener:Ie,onDidRemoveLastListener:Fe});return B.event}w.fromNodeEventEmitter=H;function U(te,J,ce=be=>be){const be=(..._)=>B.fire(ce(..._)),Ie=()=>te.addEventListener(J,be),Fe=()=>te.removeEventListener(J,be),B=new n({onWillAddFirstListener:Ie,onDidRemoveLastListener:Fe});return B.event}w.fromDOMEventEmitter=U;function ne(te){return new Promise(J=>A(te)(J))}w.toPromise=ne;function ye(te){const J=new n;return te.then(ce=>{J.fire(ce)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}w.fromPromise=ye;function fe(te,J,ce){return J(ce),te(be=>J(be))}w.runAndSubscribe=fe;function me(te,J){let ce=null;function be(Fe){ce?.dispose(),ce=new g.$Rc,J(Fe,ce)}be(void 0);const Ie=te(Fe=>be(Fe));return(0,g.$Qc)(()=>{Ie.dispose(),ce?.dispose()})}w.runAndSubscribeWithStore=me;class ee{constructor(J,ce){this._observable=J,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ce||p(be),this.emitter=new n(be),ce&&ce.add(this.emitter)}beginUpdate(J){this.f++}handlePossibleChange(J){}handleChange(J,ce){this.g=!0}endUpdate(J){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(te,J){return new ee(te,J).emitter.event}w.fromObservable=ie;function G(te){return J=>{let ce=0,be=!1;const Ie={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(te.reportChanges(),be&&(be=!1,J()))},handlePossibleChange(){},handleChange(){be=!0}};return te.addObserver(Ie),te.reportChanges(),{dispose(){te.removeObserver(Ie)}}}}w.fromObservableLight=G})(y||(e.Event=y={}));class R{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${R.f++}`,R.all.add(this)}start(p){this.g=new M.$Od,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Qd=R;let C=-1;function m(w){const p=C;return C=w,{dispose(){C=p}}}e.$Rd=m;class v{constructor(p,E=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=E,this.g=0}dispose(){this.f?.clear()}check(p,E){const A=this.threshold;if(A<=0||E<A)return;this.f||(this.f=new Map);const z=this.f.get(p.value)||0;if(this.f.set(p.value,z+1),this.g-=1,this.g<=0){this.g=A*.5;let N,I=0;for(const[j,T]of this.f)(!N||I<T)&&(N=j,I=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${I}):`),console.warn(N)}return()=>{const N=this.f.get(p.value)||0;this.f.set(p.value,N-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class d{constructor(p){this.value=p,this.id=f++}}const s=2,i=(w,p)=>{if(w instanceof d)p(w);else for(let E=0;E<w.length;E++){const A=w[E];A&&p(A)}};class n{constructor(p){this.w=0,this.f=p,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,E,A)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Sc.None;if(this.m)return g.$Sc.None;E&&(p=p.bind(E));const z=new d(p);let N,I;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=k.create(),N=this.g.check(z.stack,this.w+1)),b&&(z.stack=I??k.create()),this.t?this.t instanceof d?(this.u??=new a,this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Qc)(()=>{N?.(),this.x(z)});return A instanceof g.$Rc?A.add(j):Array.isArray(A)&&A.push(j),j},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,A=E.indexOf(p);if(A===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[A]=void 0;const z=this.u.current===this;if(this.w*s<=E.length){let N=0;for(let I=0;I<E.length;I++)E[I]?E[N++]=E[I]:z&&(this.u.end--,N<this.u.i&&this.u.i--);E.length=N}}y(p,E){if(!p)return;const A=this.f?.onListenerError||D.$1;if(!A){p.value(E);return}try{p.value(E)}catch(z){A(z)}}z(p){const E=p.current.t;for(;p.i<p.end;)this.y(E[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,p);else{const E=this.u;E.enqueue(this,p,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=n;const o=()=>new a;e.$Td=o;class a{constructor(){this.i=-1,this.end=0}enqueue(p,E,A){this.i=0,this.end=A,this.current=p,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,E,A){if(this.t)for(this.h||(this.h=new P.$3c),i(this.t,z=>this.h.push([z.value,p]));this.h.size>0&&!E.isCancellationRequested;){const[z,N]=this.h.shift(),I=[],j={...N,token:E,waitUntil:T=>{if(Object.isFrozen(I))throw new Error("waitUntil can NOT be called asynchronous");A&&(T=A(T,z)),I.push(T)}};try{z(j)}catch(T){(0,D.$1)(T);continue}Object.freeze(I),await Promise.allSettled(I).then(T=>{for(const F of T)F.status==="rejected"&&(0,D.$1)(F.reason)})}}}e.$Ud=t;class r extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new P.$3c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Vd=r;class h extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Wd=h;class u extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$Xd=u;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const E={event:p,listener:null};this.h.push(E),this.g&&this.m(E);const A=()=>{this.g&&this.o(E);const z=this.h.indexOf(E);this.h.splice(z,1)};return(0,g.$Qc)((0,O.$db)(A))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(E=>this.f.fire(E))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Yd=c;class l{constructor(p,E,A,z){this.f=new g.$Rc;const N=this.f.add(new c),I=this.f.add(new g.$2c);function j(T){I.set(T,N.add(z(T)))}for(const T of p)j(T);this.f.add(E(T=>{j(T)})),this.f.add(A(T=>{I.deleteAndDispose(T)})),this.event=N.event}dispose(){this.f.dispose()}}e.$Zd=l;class S{constructor(){this.f=[]}wrapEvent(p){return(E,A,z)=>p(N=>{const I=this.f[this.f.length-1];I?I.push(()=>E.call(A,N)):E.call(A,N)},void 0,z)}bufferEvents(p){const E=[];this.f.push(E);const A=p();return this.f.pop(),E.forEach(z=>z()),A}}e.$1d=S;class L{constructor(){this.f=!1,this.g=y.None,this.h=g.$Sc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=L}),define(Se[21],ke([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const O=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof P?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(g||(e.CancellationToken=g={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=g.None}}e.$3d=M}),define(Se[161],ke([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class O{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$3d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Be=O;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Ce=g;class P{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$De=P}),define(Se[98],ke([1,0,8,3]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function g(o){const a=o;return a?typeof a.read=="function":!1}e.$4d=g;function P(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$5d=P;function M(o){const a=o;return a?P(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$6d=M;function b(o,a){return new $(o,a)}e.$7d=b;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const h=r.indexOf(t);h>=0&&r.splice(h,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$8d=y;function R(o,a,t){const r=[];let h;for(;(h=o.read())!==null&&r.length<t;)r.push(h);return h===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof h<"u"){const u=h;return h=void 0,u}return o.read()}}}e.$9d=R;function C(o,a){return new Promise((t,r)=>{const h=[];m(o,{onData:u=>{a&&h.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(h):void 0)}})})}e.$0d=C;function m(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$$d=m;function v(o,a){return new Promise((t,r)=>{const h=new O.$Rc,u=[],c=L=>{if(u.push(L),u.length>a)return h.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},l=L=>(h.dispose(),r(L)),S=()=>(h.dispose(),t({stream:o,buffer:u,ended:!0}));h.add((0,O.$Qc)(()=>o.removeListener("error",l))),o.on("error",l),h.add((0,O.$Qc)(()=>o.removeListener("end",S))),o.on("end",S),h.add((0,O.$Qc)(()=>o.removeListener("data",c))),o.on("data",c)})}e.$_d=v;function k(o,a){const t=b(a);return t.end(o),t}e.$ae=k;function f(){const o=b(()=>{throw new Error("not supported")});return o.end(),o}e.$be=f;function d(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$ce=d;function s(o,a,t){const r=b(t);return m(o,{onData:h=>r.write(a.data(h)),onError:h=>r.error(a.error?a.error(h):h),onEnd:()=>r.end()}),r}e.$de=s;function i(o,a,t){let r=!1;return{read:()=>{const h=a.read();return r?h:(r=!0,h!==null?t([o,h]):o)}}}e.$ee=i;function n(o,a,t){let r=!1;const h=b(t);return m(a,{onData:u=>r?h.write(u):(r=!0,h.write(t([o,u]))),onError:u=>h.error(u),onEnd:()=>{r||(r=!0,h.write(o)),h.end()}}),h}e.$fe=n}),define(Se[22],ke([1,0,43,98]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const g=typeof Buffer<"u",P=new D.$V(()=>new Uint8Array(256));let M,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,A){return!(A?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(M||(M=new TextEncoder),new $(M.encode(E)))}static fromByteArray(E){const A=$.alloc(E.length);for(let z=0,N=E.length;z<N;z++)A.buffer[z]=E[z];return A}static concat(E,A){if(typeof A>"u"){A=0;for(let I=0,j=E.length;I<j;I++)A+=E[I].byteLength}const z=$.alloc(A);let N=0;for(let I=0,j=E.length;I<j;I++){const T=E[I];z.set(T,N),N+=T.byteLength}return z}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,A){return new $(this.buffer.subarray(E,A))}set(E,A){if(E instanceof $)this.buffer.set(E.buffer,A);else if(E instanceof Uint8Array)this.buffer.set(E,A);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),A);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,A){v(this.buffer,E,A)}readUInt32LE(E){return k(this.buffer,E)}writeUInt32LE(E,A){f(this.buffer,E,A)}readUInt8(E){return d(this.buffer,E)}writeUInt8(E,A){s(this.buffer,E,A)}indexOf(E,A=0){return y(this.buffer,E instanceof $?E.buffer:E,A)}}e.$ge=$;function y(p,E,A=0){const z=E.byteLength,N=p.byteLength;if(z===0)return 0;if(z===1)return p.indexOf(E[0]);if(z>N-A)return-1;const I=P.value;I.fill(E.length);for(let W=0;W<E.length;W++)I[E[W]]=E.length-W-1;let j=A+E.length-1,T=j,F=-1;for(;j<N;)if(p[j]===E[T]){if(T===0){F=j;break}j--,T--}else j+=Math.max(E.length-T,I[p[j]]),T=E.length-1;return F}e.$he=y;function R(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0}e.$ie=R;function C(p,E,A){p[A+0]=E&255,E=E>>>8,p[A+1]=E&255}e.$je=C;function m(p,E){return p[E]*2**24+p[E+1]*2**16+p[E+2]*2**8+p[E+3]}e.$ke=m;function v(p,E,A){p[A+3]=E,E=E>>>8,p[A+2]=E,E=E>>>8,p[A+1]=E,E=E>>>8,p[A]=E}e.$le=v;function k(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0|p[E+2]<<16>>>0|p[E+3]<<24>>>0}e.$me=k;function f(p,E,A){p[A+0]=E&255,E=E>>>8,p[A+1]=E&255,E=E>>>8,p[A+2]=E&255,E=E>>>8,p[A+3]=E&255}e.$ne=f;function d(p,E){return p[E]}e.$oe=d;function s(p,E,A){p[A]=E}e.$pe=s;function i(p){return O.$8d(p,E=>$.concat(E))}e.$qe=i;function n(p){return O.$ce(p)}e.$re=n;function o(p){return O.$0d(p,E=>$.concat(E))}e.$se=o;async function a(p){return p.ended?$.concat(p.buffer):$.concat([...p.buffer,await o(p.stream)])}e.$te=a;function t(p){return O.$ae(p,E=>$.concat(E))}e.$ue=t;function r(p){return O.$de(p,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ve=r;function h(p){return O.$7d(E=>$.concat(E),p)}e.$we=h;function u(p,E){return O.$ee(p,E,A=>$.concat(A))}e.$xe=u;function c(p,E){return O.$fe(p,E,A=>$.concat(A))}e.$ye=c;function l(p){let E=0,A=0,z=0;const N=new Uint8Array(Math.floor(p.length/4*3)),I=T=>{switch(A){case 3:N[z++]=E|T,A=0;break;case 2:N[z++]=E|T>>>2,E=T<<6,A=3;break;case 1:N[z++]=E|T>>>4,E=T<<4,A=2;break;default:E=T<<2,A=1}};for(let T=0;T<p.length;T++){const F=p.charCodeAt(T);if(F>=65&&F<=90)I(F-65);else if(F>=97&&F<=122)I(F-97+26);else if(F>=48&&F<=57)I(F-48+52);else if(F===43||F===45)I(62);else if(F===47||F===95)I(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${p[T]}`)}}const j=z;for(;A>0;)I(0);return $.wrap(N).slice(0,j)}e.$ze=l;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:p},E=!0,A=!1){const z=A?L:S;let N="";const I=p.byteLength%3;let j=0;for(;j<p.byteLength-I;j+=3){const T=p[j+0],F=p[j+1],W=p[j+2];N+=z[T>>>2],N+=z[(T<<4|F>>>4)&63],N+=z[(F<<2|W>>>6)&63],N+=z[W&63]}if(I===1){const T=p[j+0];N+=z[T>>>2],N+=z[T<<4&63],E&&(N+="==")}else if(I===2){const T=p[j+0],F=p[j+1];N+=z[T>>>2],N+=z[(T<<4|F>>>4)&63],N+=z[F<<2&63],E&&(N+="=")}return N}e.$Ae=w}),define(Se[13],ke([1,0,161,43]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cf=e.$Bf=e.$Af=e.$zf=e.GraphemeBreakType=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function g(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Ge=g;const P=/{(\d+)}/g;function M(Pe,...Te){return Te.length===0?Pe:Pe.replace(P,function(qe,Re){const xe=parseInt(Re,10);return isNaN(xe)||xe<0||xe>=Te.length?qe:Te[xe]})}e.$He=M;const b=/{([^}]+)}/g;function $(Pe,Te){return Object.keys(Te).length===0?Pe:Pe.replace(b,(qe,Re)=>Te[Re]??qe)}e.$Ie=$;function y(Pe){return Pe.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.$Je=y;function R(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=R;function C(Pe,Te){let qe=0;const Re=Te.charCodeAt(0);for(let xe=Pe.length-1;xe>=0;xe--)Pe.charCodeAt(xe)===Re&&qe++;return qe}e.$Le=C;function m(Pe,Te,qe="\u2026"){return Pe.length<=Te?Pe:`${Pe.substr(0,Te)}${qe}`}e.$Me=m;function v(Pe,Te=" "){const qe=k(Pe,Te);return f(qe,Te)}e.$Ne=v;function k(Pe,Te){if(!Pe||!Te)return Pe;const qe=Te.length;if(qe===0||Pe.length===0)return Pe;let Re=0;for(;Pe.indexOf(Te,Re)===Re;)Re=Re+qe;return Pe.substring(Re)}e.$Oe=k;function f(Pe,Te){if(!Pe||!Te)return Pe;const qe=Te.length,Re=Pe.length;if(qe===0||Re===0)return Pe;let xe=Re,he=-1;for(;he=Pe.lastIndexOf(Te,xe-1),!(he===-1||he+qe!==xe);){if(he===0)return"";xe=he}return Pe.substring(0,xe)}e.$Pe=f;function d(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Qe=d;function s(Pe){return Pe.replace(/\*/g,"")}e.$Re=s;function i(Pe,Te,qe={}){if(!Pe)throw new Error("Cannot create regex from empty string");Te||(Pe=R(Pe)),qe.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Re="";return qe.global&&(Re+="g"),qe.matchCase||(Re+="i"),qe.multiline&&(Re+="m"),qe.unicode&&(Re+="u"),new RegExp(Pe,Re)}e.$Se=i;function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$Te=n;function o(Pe){return Pe.split(/\r\n|\r|\n/)}e.$Ue=o;function a(Pe){for(let Te=0,qe=Pe.length;Te<qe;Te++){const Re=Pe.charCodeAt(Te);if(Re!==32&&Re!==9)return Te}return-1}e.$Ve=a;function t(Pe,Te=0,qe=Pe.length){for(let Re=Te;Re<qe;Re++){const xe=Pe.charCodeAt(Re);if(xe!==32&&xe!==9)return Pe.substring(Te,Re)}return Pe.substring(Te,qe)}e.$We=t;function r(Pe,Te=Pe.length-1){for(let qe=Te;qe>=0;qe--){const Re=Pe.charCodeAt(qe);if(Re!==32&&Re!==9)return qe}return-1}e.$Xe=r;function h(Pe,Te,qe){const Re=[];let xe=0;for(const he of Pe.matchAll(Te)){if(Re.push(Pe.slice(xe,he.index)),he.index===void 0)throw new Error("match.index should be defined");xe=he.index+he[0].length,Re.push(qe(he[0],...he.slice(1),he.index,Pe,he.groups))}return Re.push(Pe.slice(xe)),Promise.all(Re).then(he=>he.join(""))}e.$Ye=h;function u(Pe,Te){return Pe<Te?-1:Pe>Te?1:0}e.$Ze=u;function c(Pe,Te,qe=0,Re=Pe.length,xe=0,he=Te.length){for(;qe<Re&&xe<he;qe++,xe++){const Ve=Pe.charCodeAt(qe),Je=Te.charCodeAt(xe);if(Ve<Je)return-1;if(Ve>Je)return 1}const ue=Re-qe,Ce=he-xe;return ue<Ce?-1:ue>Ce?1:0}e.$1e=c;function l(Pe,Te){return S(Pe,Te,0,Pe.length,0,Te.length)}e.$2e=l;function S(Pe,Te,qe=0,Re=Pe.length,xe=0,he=Te.length){for(;qe<Re&&xe<he;qe++,xe++){let Ve=Pe.charCodeAt(qe),Je=Te.charCodeAt(xe);if(Ve===Je)continue;if(Ve>=128||Je>=128)return c(Pe.toLowerCase(),Te.toLowerCase(),qe,Re,xe,he);w(Ve)&&(Ve-=32),w(Je)&&(Je-=32);const et=Ve-Je;if(et!==0)return et}const ue=Re-qe,Ce=he-xe;return ue<Ce?-1:ue>Ce?1:0}e.$3e=S;function L(Pe){return Pe>=48&&Pe<=57}e.$4e=L;function w(Pe){return Pe>=97&&Pe<=122}e.$5e=w;function p(Pe){return Pe>=65&&Pe<=90}e.$6e=p;function E(Pe,Te){return Pe.length===Te.length&&S(Pe,Te)===0}e.$7e=E;function A(Pe,Te){const qe=Te.length;return Te.length>Pe.length?!1:S(Pe,Te,0,qe)===0}e.$8e=A;function z(Pe,Te){const qe=Math.min(Pe.length,Te.length);let Re;for(Re=0;Re<qe;Re++)if(Pe.charCodeAt(Re)!==Te.charCodeAt(Re))return Re;return qe}e.$9e=z;function N(Pe,Te){const qe=Math.min(Pe.length,Te.length);let Re;const xe=Pe.length-1,he=Te.length-1;for(Re=0;Re<qe;Re++)if(Pe.charCodeAt(xe-Re)!==Te.charCodeAt(he-Re))return Re;return qe}e.$0e=N;function I(Pe){return 55296<=Pe&&Pe<=56319}e.$$e=I;function j(Pe){return 56320<=Pe&&Pe<=57343}e.$_e=j;function T(Pe,Te){return(Pe-55296<<10)+(Te-56320)+65536}e.$af=T;function F(Pe,Te,qe){const Re=Pe.charCodeAt(qe);if(I(Re)&&qe+1<Te){const xe=Pe.charCodeAt(qe+1);if(j(xe))return T(Re,xe)}return Re}e.$bf=F;function W(Pe,Te){const qe=Pe.charCodeAt(Te-1);if(j(qe)&&Te>1){const Re=Pe.charCodeAt(Te-2);if(I(Re))return T(Re,qe)}return qe}class Y{get offset(){return this.e}constructor(Te,qe=0){this.c=Te,this.d=Te.length,this.e=qe}setOffset(Te){this.e=Te}prevCodePoint(){const Te=W(this.c,this.e);return this.e-=Te>=65536?2:1,Te}nextCodePoint(){const Te=F(this.c,this.d,this.e);return this.e+=Te>=65536?2:1,Te}eol(){return this.e>=this.d}}e.$cf=Y;class le{get offset(){return this.c.offset}constructor(Te,qe=0){this.c=new Y(Te,qe)}nextGraphemeLength(){const Te=ae.getInstance(),qe=this.c,Re=qe.offset;let xe=Te.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,ue=Te.getGraphemeBreakType(qe.nextCodePoint());if(se(xe,ue)){qe.setOffset(he);break}xe=ue}return qe.offset-Re}prevGraphemeLength(){const Te=ae.getInstance(),qe=this.c,Re=qe.offset;let xe=Te.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,ue=Te.getGraphemeBreakType(qe.prevCodePoint());if(se(ue,xe)){qe.setOffset(he);break}xe=ue}return Re-qe.offset}eol(){return this.c.eol()}}e.$df=le;function Q(Pe,Te){return new le(Pe,Te).nextGraphemeLength()}e.$ef=Q;function Z(Pe,Te){return new le(Pe,Te).prevGraphemeLength()}e.$ff=Z;function x(Pe,Te){Te>0&&j(Pe.charCodeAt(Te))&&Te--;const qe=Te+Q(Pe,Te);return[qe-Z(Pe,qe),qe]}e.$gf=x;function oe(Pe){const Te=new le(Pe);let qe=0;for(;!Te.eol();)qe++,Te.nextGraphemeLength();return qe}e.$hf=oe;let X;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ge(Pe){return X||(X=ve()),X.test(Pe)}e.$if=ge;const H=/^[\t\n\r\x20-\x7E]*$/;function U(Pe){return H.test(Pe)}e.$jf=U,e.$kf=/[\u2028\u2029]/;function ne(Pe){return e.$kf.test(Pe)}e.$lf=ne;function ye(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$mf=ye;function fe(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$nf=fe;function me(Pe,Te){if(Pe.length<Te)return Pe;const qe=/\b/g;let Re=0;for(;qe.test(Pe)&&!(Pe.length-qe.lastIndex<Te);)Re=qe.lastIndex,qe.lastIndex+=1;return Pe.substring(Re).replace(/^\s/,"")}e.$of=me;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function G(Pe){return Pe&&(Pe=Pe.replace(ee,"").replace(ie,"")),Pe}e.$pf=G,e.$qf=String.fromCharCode(65279);function te(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$rf=te;function J(Pe){return te(Pe)?Pe.substr(1):Pe}e.$sf=J;function ce(Pe,Te){if(!Pe||!Te||Pe.length<Te.length)return!1;const qe=Te.length,Re=Pe.toLowerCase();let xe=0,he=-1;for(;xe<qe;){const ue=Re.indexOf(Te[xe],he+1);if(ue<0)return!1;he=ue,xe++}return!0}e.$tf=ce;function be(Pe,Te=!1){return Pe?(Te&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$uf=be;function Ie(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$vf=Ie;function Fe(Pe,Te=1){if(Te===0)return"";let qe=-1;do qe=Pe.indexOf(`
`,qe+1),Te--;while(Te>0&&qe>=0);return qe===-1?Pe:(Pe[qe-1]==="\r"&&qe--,Pe.substr(0,qe))}e.$wf=Fe;function B(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$xf=B;function _(Pe){return ae.getInstance().getGraphemeBreakType(Pe)}e.$yf=_;function se(Pe,Te){return Pe===0?Te!==5&&Te!==7:Pe===2&&Te===3?!1:Pe===4||Pe===2||Pe===3||Te===4||Te===2||Te===3?!0:!(Pe===8&&(Te===8||Te===9||Te===11||Te===12)||(Pe===11||Pe===9)&&(Te===9||Te===10)||(Pe===12||Pe===10)&&Te===10||Te===5||Te===13||Te===7||Pe===1||Pe===13&&Te===14||Pe===6&&Te===6)}var K;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(K||(e.GraphemeBreakType=K={}));class ae{static{this.c=null}static getInstance(){return ae.c||(ae.c=new ae),ae.c}constructor(){this.d=de()}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const qe=this.d,Re=qe.length/3;let xe=1;for(;xe<=Re;)if(Te<qe[3*xe])xe=2*xe;else if(Te>qe[3*xe+1])xe=2*xe+1;else return qe[3*xe+2];return 0}}function de(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(Pe,Te){if(Pe===0)return 0;const qe=Be(Pe,Te);if(qe!==void 0)return qe;const Re=new Y(Te,Pe);return Re.prevCodePoint(),Re.offset}e.$zf=Ae;function Be(Pe,Te){const qe=new Y(Te,Pe);let Re=qe.prevCodePoint();for(;Xe(Re)||Re===65039||Re===8419;){if(qe.offset===0)return;Re=qe.prevCodePoint()}if(!fe(Re))return;let xe=qe.offset;return xe>0&&qe.prevCodePoint()===8205&&(xe=qe.offset),xe}function Xe(Pe){return 127995<=Pe&&Pe<=127999}var Ye;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$Af="\xA0";class it{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce(Te=>{function qe(et){const ot=new Map;for(let ut=0;ut<et.length;ut+=2)ot.set(et[ut],et[ut+1]);return ot}function Re(et,ot){const ut=new Map(et);for(const[je,St]of ot)ut.set(je,St);return ut}function xe(et,ot){if(!et)return ot;const ut=new Map;for(const[je,St]of et)ot.has(je)&&ut.set(je,St);return ut}const he=this.c.value;let ue=Te.filter(et=>!et.startsWith("_")&&et in he);ue.length===0&&(ue=["_default"]);let Ce;for(const et of ue){const ot=qe(he[et]);Ce=xe(Ce,ot)}const Ve=qe(he._common),Je=Re(Ve,Ce);return new it(Je)})}static getInstance(Te){return it.d.get(Array.from(Te))}static{this.e=new O.$V(()=>Object.keys(it.c.value).filter(Te=>!Te.startsWith("_")))}static getLocales(){return it.e.value}constructor(Te){this.f=Te}isAmbiguous(Te){return this.f.has(Te)}getPrimaryConfusable(Te){return this.f.get(Te)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Bf=it;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Te){return st.e().has(Te)}static get codePoints(){return st.e()}}e.$Cf=st}),define(Se[123],ke([1,0,28,13]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.FuzzyScore=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.or=void 0;function g(...J){return function(ce,be){for(let Ie=0,Fe=J.length;Ie<Fe;Ie++){const B=J[Ie](ce,be);if(B)return B}return null}}e.or=g,e.$Nj=P.bind(void 0,!1),e.$Oj=P.bind(void 0,!0);function P(J,ce,be){if(!be||be.length<ce.length)return null;let Ie;return J?Ie=O.$8e(be,ce):Ie=be.indexOf(ce)===0,Ie?ce.length>0?[{start:0,end:ce.length}]:[]:null}function M(J,ce){const be=ce.toLowerCase().indexOf(J.toLowerCase());return be===-1?null:[{start:be,end:be+J.length}]}e.$Pj=M;function b(J,ce){return $(J.toLowerCase(),ce.toLowerCase(),0,0)}e.$Qj=b;function $(J,ce,be,Ie){if(be===J.length)return[];if(Ie===ce.length)return null;if(J[be]===ce[Ie]){let Fe=null;return(Fe=$(J,ce,be+1,Ie+1))?s({start:Ie,end:Ie+1},Fe):null}return $(J,ce,be,Ie+1)}function y(J){return 97<=J&&J<=122}function R(J){return 65<=J&&J<=90}e.$Rj=R;function C(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>v.add(J.charCodeAt(0)));function k(J){return m(J)||v.has(J)}function f(J,ce){return J===ce||k(J)&&k(ce)}function d(J){return y(J)||R(J)||C(J)}function s(J,ce){return ce.length===0?ce=[J]:J.end===ce[0].start?ce[0].start=J.start:ce.unshift(J),ce}function i(J,ce){for(let be=ce;be<J.length;be++){const Ie=J.charCodeAt(be);if(R(Ie)||C(Ie)||be>0&&!d(J.charCodeAt(be-1)))return be}return J.length}function n(J,ce,be,Ie){if(be===J.length)return[];if(Ie===ce.length)return null;if(J[be]!==ce[Ie].toLowerCase())return null;{let Fe=null,B=Ie+1;for(Fe=n(J,ce,be+1,Ie+1);!Fe&&(B=i(ce,B))<ce.length;)Fe=n(J,ce,be+1,B),B++;return Fe===null?null:s({start:Ie,end:Ie+1},Fe)}}function o(J){let ce=0,be=0,Ie=0,Fe=0,B=0;for(let de=0;de<J.length;de++)B=J.charCodeAt(de),R(B)&&ce++,y(B)&&be++,d(B)&&Ie++,C(B)&&Fe++;const _=ce/J.length,se=be/J.length,K=Ie/J.length,ae=Fe/J.length;return{upperPercent:_,lowerPercent:se,alphaPercent:K,numericPercent:ae}}function a(J){const{upperPercent:ce,lowerPercent:be}=J;return be===0&&ce>.6}function t(J){const{upperPercent:ce,lowerPercent:be,alphaPercent:Ie,numericPercent:Fe}=J;return be>.2&&ce<.8&&Ie>.6&&Fe<.2}function r(J){let ce=0,be=0,Ie=0,Fe=0;for(let B=0;B<J.length;B++)Ie=J.charCodeAt(B),R(Ie)&&ce++,y(Ie)&&be++,m(Ie)&&Fe++;return(ce===0||be===0)&&Fe===0?J.length<=30:ce<=5}function h(J,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!r(J)||ce.length>60)return null;const be=o(ce);if(!t(be)){if(!a(be))return null;ce=ce.toLowerCase()}let Ie=null,Fe=0;for(J=J.toLowerCase();Fe<ce.length&&(Ie=n(J,ce,0,Fe))===null;)Fe=i(ce,Fe+1);return Ie}e.$Sj=h;function u(J,ce,be=!1){if(!ce||ce.length===0)return null;let Ie=null,Fe=0;for(J=J.toLowerCase(),ce=ce.toLowerCase();Fe<ce.length&&(Ie=c(J,ce,0,Fe,be))===null;)Fe=l(ce,Fe+1);return Ie}e.$Tj=u;function c(J,ce,be,Ie,Fe){if(be===J.length)return[];if(Ie===ce.length)return null;if(f(J.charCodeAt(be),ce.charCodeAt(Ie))){let B=null,_=Ie+1;if(B=c(J,ce,be+1,Ie+1,Fe),!Fe)for(;!B&&(_=l(ce,_))<ce.length;)B=c(J,ce,be+1,_,Fe),_++;return B?J.charCodeAt(be)!==ce.charCodeAt(Ie)?B:s({start:Ie,end:Ie+1},B):null}else return null}function l(J,ce){for(let be=ce;be<J.length;be++)if(k(J.charCodeAt(be))||be>0&&k(J.charCodeAt(be-1)))return be;return J.length}const S=g(e.$Oj,h,M),L=g(e.$Oj,h,b),w=new D.$Dc(1e4);function p(J,ce,be=!1){if(typeof J!="string"||typeof ce!="string")return null;let Ie=w.get(J);Ie||(Ie=new RegExp(O.$Qe(J),"i"),w.set(J,Ie));const Fe=Ie.exec(ce);return Fe?[{start:Fe.index,end:Fe.index+Fe[0].length}]:be?L(J,ce):S(J,ce)}e.$Uj=p;function E(J,ce){const be=ye(J,J.toLowerCase(),0,ce,ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?z(be):null}e.$Vj=E;function A(J,ce,be,Ie,Fe,B){const _=Math.min(13,J.length);for(;be<_;be++){const se=ye(J,ce,be,Ie,Fe,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,B]}e.$Wj=A;function z(J){if(typeof J>"u")return[];const ce=[],be=J[1];for(let Ie=J.length-1;Ie>1;Ie--){const Fe=J[Ie]+be,B=ce[ce.length-1];B&&B.end===Fe?B.end=Fe+1:ce.push({start:Fe,end:Fe+1})}return ce}e.$Xj=z;const N=128;function I(){const J=[],ce=[];for(let be=0;be<=N;be++)ce[be]=0;for(let be=0;be<=N;be++)J.push(ce.slice(0));return J}function j(J){const ce=[];for(let be=0;be<=J;be++)ce[be]=0;return ce}const T=j(2*N),F=j(2*N),W=I(),Y=I(),le=I(),Q=!1;function Z(J,ce,be,Ie,Fe){function B(se,K,ae=" "){for(;se.length<K;)se=ae+se;return se}let _=` |   |${Ie.split("").map(se=>B(se,3)).join("|")}
`;for(let se=0;se<=be;se++)se===0?_+=" |":_+=`${ce[se-1]}|`,_+=J[se].slice(0,Fe+1).map(K=>B(K.toString(),3)).join("|")+`
`;return _}function x(J,ce,be,Ie){J=J.substr(ce),be=be.substr(Ie),console.log(Z(Y,J,J.length,be,be.length)),console.log(Z(le,J,J.length,be,be.length)),console.log(Z(W,J,J.length,be,be.length))}function oe(J,ce){if(ce<0||ce>=J.length)return!1;const be=J.codePointAt(ce);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$nf(be)}}function X(J,ce){if(ce<0||ce>=J.length)return!1;switch(J.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function ve(J,ce,be){return ce[J]!==be[J]}function ge(J,ce,be,Ie,Fe,B,_=!1){for(;ce<be&&Fe<B;)J[ce]===Ie[Fe]&&(_&&(T[ce]=Fe),ce+=1),Fe+=1;return ce===be}e.$Yj=ge;var H;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(H||(H={}));var U;(function(J){J.Default=[-100,0];function ce(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}J.isDefault=ce})(U||(e.FuzzyScore=U={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ce,be){this.firstMatchCanBeWeak=ce,this.boostFullMatch=be}}e.$Zj=ne;function ye(J,ce,be,Ie,Fe,B,_=ne.default){const se=J.length>N?N:J.length,K=Ie.length>N?N:Ie.length;if(be>=se||B>=K||se-be>K-B||!ge(ce,be,se,Fe,B,K,!0))return;fe(se,K,be,B,ce,Fe);let ae=1,de=1,Ae=be,Be=B;const Xe=[!1];for(ae=1,Ae=be;Ae<se;ae++,Ae++){const Te=T[Ae],qe=F[Ae],Re=Ae+1<se?F[Ae+1]:K;for(de=Te-B+1,Be=Te;Be<Re;de++,Be++){let xe=Number.MIN_SAFE_INTEGER,he=!1;Be<=qe&&(xe=me(J,ce,Ae,be,Ie,Fe,Be,K,B,W[ae-1][de-1]===0,Xe));let ue=0;xe!==Number.MAX_SAFE_INTEGER&&(he=!0,ue=xe+Y[ae-1][de-1]);const Ce=Be>Te,Ve=Ce?Y[ae][de-1]+(W[ae][de-1]>0?-5:0):0,Je=Be>Te+1&&W[ae][de-1]>0,et=Je?Y[ae][de-2]+(W[ae][de-2]>0?-5:0):0;if(Je&&(!Ce||et>=Ve)&&(!he||et>=ue))Y[ae][de]=et,le[ae][de]=3,W[ae][de]=0;else if(Ce&&(!he||Ve>=ue))Y[ae][de]=Ve,le[ae][de]=2,W[ae][de]=0;else if(he)Y[ae][de]=ue,le[ae][de]=1,W[ae][de]=W[ae-1][de-1]+1;else throw new Error("not possible")}}if(Q&&x(J,be,Ie,B),!Xe[0]&&!_.firstMatchCanBeWeak)return;ae--,de--;const Ye=[Y[ae][de],B];let it=0,st=0;for(;ae>=1;){let Te=de;do{const qe=le[ae][Te];if(qe===3)Te=Te-2;else if(qe===2)Te=Te-1;else break}while(Te>=1);it>1&&ce[be+ae-1]===Fe[B+de-1]&&!ve(Te+B-1,Ie,Fe)&&it+1>W[ae][Te]&&(Te=de),Te===de?it++:it=1,st||(st=Te),ae--,de=Te-1,Ye.push(de)}K===se&&_.boostFullMatch&&(Ye[0]+=2);const Pe=st-se;return Ye[0]-=Pe,Ye}e.$1j=ye;function fe(J,ce,be,Ie,Fe,B){let _=J-1,se=ce-1;for(;_>=be&&se>=Ie;)Fe[_]===B[se]&&(F[_]=se,_--),se--}function me(J,ce,be,Ie,Fe,B,_,se,K,ae,de){if(ce[be]!==B[_])return Number.MIN_SAFE_INTEGER;let Ae=1,Be=!1;return _===be-Ie?Ae=J[be]===Fe[_]?7:5:ve(_,Fe,B)&&(_===0||!ve(_-1,Fe,B))?(Ae=J[be]===Fe[_]?7:5,Be=!0):oe(B,_)&&(_===0||!oe(B,_-1))?Ae=5:(oe(B,_-1)||X(B,_-1))&&(Ae=5,Be=!0),Ae>1&&be===Ie&&(de[0]=!0),Be||(Be=ve(_,Fe,B)||oe(B,_-1)||X(B,_-1)),be===Ie?_>K&&(Ae-=Be?3:5):ae?Ae+=Be?2:0:Ae+=Be?0:1,_+1===se&&(Ae-=Be?3:5),Ae}function ee(J,ce,be,Ie,Fe,B,_){return G(J,ce,be,Ie,Fe,B,!0,_)}e.$2j=ee;function ie(J,ce,be,Ie,Fe,B,_){return G(J,ce,be,Ie,Fe,B,!1,_)}e.$3j=ie;function G(J,ce,be,Ie,Fe,B,_,se){let K=ye(J,ce,be,Ie,Fe,B,se);if(K&&!_)return K;if(J.length>=3){const ae=Math.min(7,J.length-1);for(let de=be+1;de<ae;de++){const Ae=te(J,de);if(Ae){const Be=ye(Ae,Ae.toLowerCase(),be,Ie,Fe,B,se);Be&&(Be[0]-=3,(!K||Be[0]>K[0])&&(K=Be))}}}return K}function te(J,ce){if(ce+1>=J.length)return;const be=J[ce],Ie=J[ce+1];if(be!==Ie)return J.slice(0,ce)+Ie+be+J.slice(ce+2)}}),define(Se[53],ke([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=void 0;function O(s){return g(s,0)}e.$Oi=O;function g(s,i){switch(typeof s){case"object":return s===null?P(349,i):Array.isArray(s)?$(s,i):y(s,i);case"string":return b(s,i);case"boolean":return M(s,i);case"number":return P(s,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Pi=g;function P(s,i){return(i<<5)-i+s|0}e.$Qi=P;function M(s,i){return P(s?433:863,i)}function b(s,i){i=P(149417,i);for(let n=0,o=s.length;n<o;n++)i=P(s.charCodeAt(n),i);return i}e.$Ri=b;function $(s,i){return i=P(104579,i),s.reduce((n,o)=>g(o,n),i)}function y(s,i){return i=P(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=b(o,n),g(s[o],n)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Si=R;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function v(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function k(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function f(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((s>>>0).toString(16),i/4)}e.$Ti=f;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,h;for(t!==0?(r=t,h=-1,t=0):(r=i.charCodeAt(0),h=0);;){let u=r;if(D.$$e(r))if(h+1<n){const c=i.charCodeAt(h+1);D.$_e(c)?(h++,u=D.$af(r,c)):u=65533}else{t=r;break}else D.$_e(r)&&(u=65533);if(a=this.w(o,a,u),h++,h<n)r=i.charCodeAt(h);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=d.g,n=this.q;for(let S=0;S<64;S+=4)i.setUint32(S,n.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)i.setUint32(S,m(i.getUint32(S-12,!1)^i.getUint32(S-32,!1)^i.getUint32(S-56,!1)^i.getUint32(S-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,h=this.o,u,c,l;for(let S=0;S<80;S++)S<20?(u=a&t|~a&r,c=1518500249):S<40?(u=a^t^r,c=1859775393):S<60?(u=a&t|a&r|t&r,c=2400959708):(u=a^t^r,c=3395469782),l=m(o,5)+u+h+c+i.getUint32(S*4,!1)&4294967295,h=r,r=t,t=m(a,30),a=o,o=l;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+h&4294967295}}e.$Ui=d}),define(Se[39],ke([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(O||(O={})),function(g){const P="error",M="warning",b="warn",$="info",y="ignore";function R(m){return m?D.$7e(P,m)?g.Error:D.$7e(M,m)||D.$7e(b,m)?g.Warning:D.$7e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=R;function C(m){switch(m){case g.Error:return P;case g.Warning:return M;case g.Info:return $;default:return y}}g.toString=C}(O||(O={})),e.default=O}),define(Se[162],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Se[77],ke([1,0,19,13]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const k=v.charCodeAt(0),f=this.b.charCodeAt(this.c);return k-f}value(){return this.b[this.c]}}e.$3h=g;class P{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,O.$1e)(v,this.b,0,v.length,this.c,this.d):(0,O.$3e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$4h=P;class M{constructor(v=!0,k=!0){this.f=v,this.g=k}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let k=v.length-1;k>=0;k--,this.c--){const f=this.b.charCodeAt(k);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,O.$1e)(v,this.b,0,v.length,this.d,this.e):(0,O.$3e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$5h=M;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(v,k){this.f=v,this.g=k,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,O.$2e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,O.$2e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,O.$Ze)(v,this.c.query);if(this.d[this.e]===5)return(0,O.$Ze)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$6h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(R||(R={}));class C{static forUris(v=()=>!1,k=()=>!1){return new C(new $(v,k))}static forPaths(v=!1){return new C(new M(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new P)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,k){if(k){const f=k.slice(0);(0,D.$Xb)(f);for(const d of f)this.set(d,v)}else{const f=v.slice(0);(0,D.$Xb)(f);for(const d of f)this.set(d[0],d[1])}}set(v,k){const f=this.b.reset(v);let d;this.c||(this.c=new y,this.c.segment=f.value());const s=[];for(d=this.c;;){const n=f.cmp(d.segment);if(n>0)d.left||(d.left=new y,d.left.segment=f.value()),s.push([-1,d]),d=d.left;else if(n<0)d.right||(d.right=new y,d.right.segment=f.value()),s.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new y,d.mid.segment=f.value()),s.push([0,d]),d=d.mid;else break}const i=d.value;d.value=k,d.key=v;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const k=this.b.reset(v);let f=this.c;for(;f;){const d=k.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(k.hasNext())k.next(),f=f.mid;else break}return f}has(v){const k=this.d(v);return!(k?.value===void 0&&k?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,k){const f=this.b.reset(v),d=[];let s=this.c;for(;s;){const i=f.cmp(s.segment);if(i>0)d.push([-1,s]),s=s.left;else if(i<0)d.push([1,s]),s=s.right;else if(f.hasNext())f.next(),d.push([0,s]),s=s.mid;else break}if(s){if(k?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(d.length>0){const[n,o]=d[d.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=d.length-1;i>=0;i--){const n=d[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),d[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),d[i][1]=n.rotateRight()),i>0)switch(d[i-1][0]){case-1:d[i-1][1].left=d[i][1];break;case 1:d[i-1][1].right=d[i][1];break;case 0:d[i-1][1].mid=d[i][1];break}else this.c=d[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const k=this.b.reset(v);let f=this.c,d;for(;f;){const s=k.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(k.hasNext())k.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(v){return this.g(v,!1)}g(v,k){const f=this.b.reset(v);let d=this.c;for(;d;){const s=f.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):k?d.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[k,f]of this)v(f,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const k=[];return this.j(v,k),k[Symbol.iterator]()}j(v,k){v&&(v.left&&this.j(v.left,k),v.value&&k.push([v.key,v.value]),v.mid&&this.j(v.mid,k),v.right&&this.j(v.right,k))}_isBalanced(){const v=k=>{if(!k)return!0;const f=k.balanceFactor();return f<-1||f>1?!1:v(k.left)&&v(k.right)};return v(this.c)}}e.$7h=C}),define(Se[18],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=void 0;function D(a){return typeof a=="string"}e.$Df=D;function O(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Ef=O;function g(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ff=g;function P(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Gf=P;function M(a){return typeof a=="number"&&!isNaN(a)}e.$Hf=M;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$If=b;function $(a){return a===!0||a===!1}e.$Jf=$;function y(a){return typeof a>"u"}e.$Kf=y;function R(a){return!C(a)}e.$Lf=R;function C(a){return y(a)||a===null}e.$Mf=C;function m(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Nf=m;function v(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Of=v;function k(...a){const t=[];for(let r=0;r<a.length;r++){const h=a[r];if(C(h))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(h)}return t}e.$Pf=k;const f=Object.prototype.hasOwnProperty;function d(a){if(!g(a))return!1;for(const t in a)if(f.call(a,t))return!1;return!0}e.$Qf=d;function s(a){return typeof a=="function"}e.$Rf=s;function i(...a){return a.length>0&&a.every(s)}e.$Sf=i;function n(a,t){const r=Math.min(a.length,t.length);for(let h=0;h<r;h++)o(a[h],t[h])}e.$Tf=n;function o(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Uf=o}),define(Se[78],ke([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=void 0;const O=Object.create(null);function g(b,$){if((0,D.$Df)($)){const y=O[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return O[b]=$,{id:b}}function P(){return O}e.$4j=P;function M(){return Object.values(e.$6j)}e.$5j=M,e.$6j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),robot:g("robot",60448),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Se[24],ke([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=void 0;function O(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?O(o):o}),i}e.$fn=O;function g(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(P.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Gf)(a)&&i.push(a)}}return s}e.$gn=g;const P=Object.prototype.hasOwnProperty;function M(s,i){return b(s,i,new Set)}e.$hn=M;function b(s,i,n){if((0,D.$Mf)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(b(t,i,n));return a}if((0,D.$Ff)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)P.call(s,t)&&(a[t]=b(s[t],i,n));return n.delete(s),a}return s}function $(s,i,n=!0){return(0,D.$Ff)(s)?((0,D.$Ff)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.$Ff)(s[o])&&(0,D.$Ff)(i[o])?$(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$in=$;function y(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!y(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!y(a,t))return!1;for(n=0;n<a.length;n++)if(!y(s[a[n]],i[a[n]]))return!1}return!0}e.$jn=y;function R(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.$Ff)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$kn=R;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];y(t,r)||(n[a]=r)}),n}e.$ln=C;function m(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$mn=m;function v(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$nn=v;function k(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$on=k;function f(s){const i=[];for(const n of k(s))typeof s[n]=="function"&&i.push(n);return i}e.$pn=f;function d(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$qn=d}),define(Se[61],ke([1,0,78]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$7j=e.ThemeColor=void 0;var O;(function(M){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=b})(O||(e.ThemeColor=O={}));function g(M){return{id:M}}e.$7j=g;var P;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(i){const n=b.exec(i.id);if(!n)return $(D.$6j.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}M.asClassNameArray=$;function y(i){return $(i).join(" ")}M.asClassName=y;function R(i){return"."+$(i).join(".")}M.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}M.isThemeIcon=C;const m=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(i){const n=m.exec(i);if(!n)return;const[,o]=n;return{id:o}}M.fromString=v;function k(i){return{id:i}}M.fromId=k;function f(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}M.modify=f;function d(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}M.getModifier=d;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}M.isEqual=s})(P||(e.ThemeIcon=P={}))}),define(Se[163],ke([1,0,123,13,61]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=void 0;const P="$(",M=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function $(s){return s.replace(b,(i,n)=>n?i:`\\${i}`)}e.$8j=$;const y=new RegExp(`\\\\${M.source}`,"g");function R(s){return s.replace(y,i=>`\\${i}`)}e.$9j=R;const C=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(s){return s.indexOf(P)===-1?s:s.replace(C,(i,n,o,a)=>o?i:n||a||"")}e.$0j=m;function v(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$$j=v;const k=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(s){k.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=k.lastIndex,t=k.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let h=0;h<r.length;h++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$_j=f;function d(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$Uj)(s,o,n);const t=(0,O.$Oe)(o," "),r=o.length-t.length,h=(0,D.$Uj)(s,t,n);if(h)for(const u of h){const c=a[u.start+r]+r;u.start+=c,u.end+=c}return h}e.$ak=d}),define(Se[124],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.Constants=void 0;var D;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function O(P){return P<0?0:P>255?255:P|0}e.$Ee=O;function g(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Fe=g}),define(Se[30],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(g){return D.test(g)}e.$kg=O,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const P=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){g(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,y="";return y+=M[P[$++]],y+=M[P[$++]],y+=M[P[$++]],y+=M[P[$++]],y+="-",y+=M[P[$++]],y+=M[P[$++]],y+="-",y+=M[P[$++]],y+=M[P[$++]],y+="-",y+=M[P[$++]],y+=M[P[$++]],y+="-",y+=M[P[$++]],y+=M[P[$++]],y+=M[P[$++]],y+=M[P[$++]],y+=M[P[$++]],y+=M[P[$++]],y}}()}),define(Se[164],ke([1,0,19,52,30]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.$at=e.$_s=e.$$s=e.$0s=void 0;function P(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$0s=P;function M(C,m,v){const k={id:(0,g.$lg)(),name:C,uri:m,data:v};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$$s=M;class b{constructor(){this.a=new Map}get size(){let m=0;for(const v of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const v=[...this.a.keys()];return O.Iterable.some(this,([k,f])=>f.asFile())&&v.push("files"),R($(m),v)}get(m){return this.a.get(this.b(m))?.[0]}append(m,v){const k=this.a.get(m);k?k.push(v):this.a.set(this.b(m),[v])}replace(m,v){this.a.set(this.b(m),[v])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,v]of this.a)for(const k of v)yield[m,k]}b(m){return $(m)}}e.$_s=b;function $(C){return C.toLowerCase()}function y(C,m){return R($(C),m.map($))}e.$at=y;function R(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[k,f,d]=v;return d==="*"?m.some(s=>s.startsWith(f+"/")):!1}e.$bt=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$bt.split(C).filter(m=>!m.startsWith("#"))})}),define(Se[165],ke([1,0,62]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pg=e.$og=e.$ng=void 0;function O(b,$,y,R=1){let C=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,R,k=>{if(!C)return C=!0,clearTimeout(v),m(k)})})}e.$ng=O;function g(b,$,y,R){if($===0)return R(0);const C=new D.Socket;C.once("connect",()=>(M(C),g(b+y,$-1,y,R))),C.once("data",()=>{}),C.once("error",m=>(M(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,R):R(b))),C.connect(b,"127.0.0.1")}e.$og={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(b,$,y,R="127.0.0.1"){let C=!1,m,v=1;const k=D.createServer({pauseOnConnect:!0});function f(d,s){C||(C=!0,k.removeAllListeners(),k.close(),m&&clearTimeout(m),s(d))}return new Promise(d=>{m=setTimeout(()=>{f(0,d)},y),k.on("listening",()=>{f(b,d)}),k.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&v<$?(b++,v++,k.listen(b,R)):f(0,d)}),k.on("close",()=>{f(0,d)}),k.listen(b,R)})}e.$pg=P;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Se[125],ke([1,0,124]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=void 0;class O{constructor(b){const $=(0,D.$Ee)(b);this.c=$,this.a=O.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$Ee)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$2s=O;var g;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(g||(g={}));class P{constructor(){this.a=new O(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$3s=P}),define(Se[166],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function O(g){let P=0,M=0,b=0,$=0;for(let y=0,R=g.length;y<R;y++){const C=g.charCodeAt(y);C===13?(P===0&&(M=y),P++,y+1<R&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,P===0&&(M=y),P++,b=y+1)}return P===0&&(M=g.length),[P,M,g.length-b,$]}e.$et=O}),define(Se[49],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class D{constructor(g,P){this.lineNumber=g,this.column=P}with(g=this.lineNumber,P=this.column){return g===this.lineNumber&&P===this.column?this:new D(g,P)}delta(g=0,P=0){return this.with(this.lineNumber+g,this.column+P)}equals(g){return D.equals(this,g)}static equals(g,P){return!g&&!P?!0:!!g&&!!P&&g.lineNumber===P.lineNumber&&g.column===P.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,P){return g.lineNumber<P.lineNumber?!0:P.lineNumber<g.lineNumber?!1:g.column<P.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,P){return g.lineNumber<P.lineNumber?!0:P.lineNumber<g.lineNumber?!1:g.column<=P.column}static compare(g,P){const M=g.lineNumber|0,b=P.lineNumber|0;if(M===b){const $=g.column|0,y=P.column|0;return $-y}return M-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ds=D}),define(Se[29],ke([1,0,49]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class O{constructor(P,M,b,$){P>b||P===b&&M>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=P,this.endColumn=M):(this.startLineNumber=P,this.startColumn=M,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return O.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return O.containsPosition(this,P)}static containsPosition(P,M){return!(M.lineNumber<P.startLineNumber||M.lineNumber>P.endLineNumber||M.lineNumber===P.startLineNumber&&M.column<P.startColumn||M.lineNumber===P.endLineNumber&&M.column>P.endColumn)}static strictContainsPosition(P,M){return!(M.lineNumber<P.startLineNumber||M.lineNumber>P.endLineNumber||M.lineNumber===P.startLineNumber&&M.column<=P.startColumn||M.lineNumber===P.endLineNumber&&M.column>=P.endColumn)}containsRange(P){return O.containsRange(this,P)}static containsRange(P,M){return!(M.startLineNumber<P.startLineNumber||M.endLineNumber<P.startLineNumber||M.startLineNumber>P.endLineNumber||M.endLineNumber>P.endLineNumber||M.startLineNumber===P.startLineNumber&&M.startColumn<P.startColumn||M.endLineNumber===P.endLineNumber&&M.endColumn>P.endColumn)}strictContainsRange(P){return O.strictContainsRange(this,P)}static strictContainsRange(P,M){return!(M.startLineNumber<P.startLineNumber||M.endLineNumber<P.startLineNumber||M.startLineNumber>P.endLineNumber||M.endLineNumber>P.endLineNumber||M.startLineNumber===P.startLineNumber&&M.startColumn<=P.startColumn||M.endLineNumber===P.endLineNumber&&M.endColumn>=P.endColumn)}plusRange(P){return O.plusRange(this,P)}static plusRange(P,M){let b,$,y,R;return M.startLineNumber<P.startLineNumber?(b=M.startLineNumber,$=M.startColumn):M.startLineNumber===P.startLineNumber?(b=M.startLineNumber,$=Math.min(M.startColumn,P.startColumn)):(b=P.startLineNumber,$=P.startColumn),M.endLineNumber>P.endLineNumber?(y=M.endLineNumber,R=M.endColumn):M.endLineNumber===P.endLineNumber?(y=M.endLineNumber,R=Math.max(M.endColumn,P.endColumn)):(y=P.endLineNumber,R=P.endColumn),new O(b,$,y,R)}intersectRanges(P){return O.intersectRanges(this,P)}static intersectRanges(P,M){let b=P.startLineNumber,$=P.startColumn,y=P.endLineNumber,R=P.endColumn;const C=M.startLineNumber,m=M.startColumn,v=M.endLineNumber,k=M.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>v?(y=v,R=k):y===v&&(R=Math.min(R,k)),b>y||b===y&&$>R?null:new O(b,$,y,R)}equalsRange(P){return O.equalsRange(this,P)}static equalsRange(P,M){return!P&&!M?!0:!!P&&!!M&&P.startLineNumber===M.startLineNumber&&P.startColumn===M.startColumn&&P.endLineNumber===M.endLineNumber&&P.endColumn===M.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(P){return new D.$Ds(P.endLineNumber,P.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(P){return new D.$Ds(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,M){return new O(this.startLineNumber,this.startColumn,P,M)}setStartPosition(P,M){return new O(P,M,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(P){return new O(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(P){return new O(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new O(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,M=P){return new O(P.lineNumber,P.column,M.lineNumber,M.column)}static lift(P){return P?new O(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,M){return!(P.endLineNumber<M.startLineNumber||P.endLineNumber===M.startLineNumber&&P.endColumn<M.startColumn||M.endLineNumber<P.startLineNumber||M.endLineNumber===P.startLineNumber&&M.endColumn<P.startColumn)}static areIntersecting(P,M){return!(P.endLineNumber<M.startLineNumber||P.endLineNumber===M.startLineNumber&&P.endColumn<=M.startColumn||M.endLineNumber<P.startLineNumber||M.endLineNumber===P.startLineNumber&&M.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,M){if(P&&M){const y=P.startLineNumber|0,R=M.startLineNumber|0;if(y===R){const C=P.startColumn|0,m=M.startColumn|0;if(C===m){const v=P.endLineNumber|0,k=M.endLineNumber|0;if(v===k){const f=P.endColumn|0,d=M.endColumn|0;return f-d}return v-k}return C-m}return y-R}return(P?1:0)-(M?1:0)}static compareRangesUsingEnds(P,M){return P.endLineNumber===M.endLineNumber?P.endColumn===M.endColumn?P.startLineNumber===M.startLineNumber?P.startColumn-M.startColumn:P.startLineNumber-M.startLineNumber:P.endColumn-M.endColumn:P.endLineNumber-M.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Es=O}),define(Se[167],ke([1,0,29]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class O{static insert(P,M){return{range:new D.$Es(P.lineNumber,P.column,P.lineNumber,P.column),text:M,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,M){return{range:P,text:M}}static replaceMove(P,M){return{range:P,text:M,forceMoveMarkers:!0}}}e.$Fs=O}),define(Se[168],ke([1,0,49,29]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=e.SelectionDirection=void 0;var g;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class P extends O.$Es{constructor(b,$,y,R){super(b,$,y,R),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return P.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,b,$):new P(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Ds(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Ds(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new P(b,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new P(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new P(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new P(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new P(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,R=b.length;y<R;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,R,C){return C===0?new P(b,$,y,R):new P(y,R,b,$)}}e.$Gs=P}),define(Se[169],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,e.$bs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[170],ke([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=e.WordCharacterClass=void 0;var O;(function(M){M[M.Regular=0]="Regular",M[M.Whitespace=1]="Whitespace",M[M.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class g extends D.$2s{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$4s=g;function P(M){const b={};return $=>(b.hasOwnProperty($)||(b[$]=M($)),b[$])}e.$5s=P(M=>new g(M))}),define(Se[126],ke([1,0,52,3,75]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=e.$ds=e.$cs=void 0,e.$cs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$cs)C.indexOf(v)>=0||(m+="\\"+v);return m+="\\s]+)",new RegExp(m,"g")}e.$ds=P();function M(C){let m=e.$ds;if(C&&C instanceof RegExp)if(C.global)m=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),m=new RegExp(C.source,v)}return m.lastIndex=0,m}e.$es=M;const b=new g.$3c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,O.$Qc)(m)}e.$fs=$;function y(C,m,v,k,f){if(m=M(m),f||(f=D.Iterable.first(b)),v.length>f.maxLen){let o=C-f.maxLen/2;return o<0?o=0:k+=o,v=v.substring(o,C+f.maxLen/2),y(C,m,v,k,f)}const d=Date.now(),s=C-1-k;let i=-1,n=null;for(let o=1;!(Date.now()-d>=f.timeBudget);o++){const a=s-f.windowSize*o;m.lastIndex=Math.max(0,a);const t=R(m,v,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return m.lastIndex=0,o}return null}e.$gs=y;function R(C,m,v,k){let f;for(;f=C.exec(m);){const d=f.index||0;if(d<=v&&C.lastIndex>=v)return f;if(k>0&&d>k)return null}return null}}),define(Se[171],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=e.IndentAction=void 0;var D;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),R=b.getStandardTokenType(y);return this.isOK(R)}g(b,$){for(let y=b;y<=$;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Bt=O;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Ct=g;function P(M,b,$){M.has(b)?M.get(b).push($):M.set(b,[$])}}),define(Se[172],ke([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eZ=e.$dZ=e.$cZ=e.State=void 0;var O;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class g{constructor(k,f,d){const s=new Uint8Array(k*f);for(let i=0,n=k*f;i<n;i++)s[i]=d;this.a=s,this.rows=k,this.cols=f}get(k,f){return this.a[k*this.cols+f]}set(k,f,d){this.a[k*this.cols+f]=d}}class P{constructor(k){let f=0,d=0;for(let i=0,n=k.length;i<n;i++){const[o,a,t]=k[i];a>f&&(f=a),o>d&&(d=o),t>d&&(d=t)}f++,d++;const s=new g(d,f,0);for(let i=0,n=k.length;i<n;i++){const[o,a,t]=k[i];s.set(o,a,t)}this.a=s,this.b=f}nextState(k,f){return f<0||f>=this.b?0:this.a.get(k,f)}}e.$cZ=P;let M=null;function b(){return M===null&&(M=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var $;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function R(){if(y===null){y=new D.$2s(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<v.length;f++)y.set(v.charCodeAt(f),1);const k=".,;:";for(let f=0;f<k.length;f++)y.set(k.charCodeAt(f),2)}return y}class C{static a(k,f,d,s,i){let n=i-1;do{const o=f.charCodeAt(n);if(k.get(o)!==2)break;n--}while(n>s);if(s>0){const o=f.charCodeAt(s-1),a=f.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:d,startColumn:s+1,endLineNumber:d,endColumn:n+2},url:f.substring(s,n+1)}}static computeLinks(k,f=b()){const d=R(),s=[];for(let i=1,n=k.getLineCount();i<=n;i++){const o=k.getLineContent(i),a=o.length;let t=0,r=0,h=0,u=1,c=!1,l=!1,S=!1,L=!1;for(;t<a;){let w=!1;const p=o.charCodeAt(t);if(u===13){let E;switch(p){case 40:c=!0,E=0;break;case 41:E=c?0:1;break;case 91:S=!0,l=!0,E=0;break;case 93:S=!1,E=l?0:1;break;case 123:L=!0,E=0;break;case 125:E=L?0:1;break;case 39:case 34:case 96:h===p?E=1:h===39||h===34||h===96?E=0:E=1;break;case 42:E=h===42?1:0;break;case 124:E=h===124?1:0;break;case 32:E=S?0:1;break;default:E=d.get(p)}E===1&&(s.push(C.a(d,o,i,r,t)),w=!0)}else if(u===12){let E;p===91?(l=!0,E=0):E=d.get(p),E===1?w=!0:u=13}else u=f.nextState(u,p),u===0&&(w=!0);w&&(u=1,c=!1,l=!1,L=!1,r=t+1,h=p),t++}u===13&&s.push(C.a(d,o,i,r,a))}return s}}e.$dZ=C;function m(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$eZ=m}),define(Se[79],ke([1,0,24]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.$Zu=e.$Yu=e.ModelConstants=e.PositionAffinity=e.$Xu=e.TrackedRangeStickiness=e.$Wu=e.$Vu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var g;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var P;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var M;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(M||(e.InjectedTextCursorStops=M={}));var b;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$jn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Vu=R;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Wu=C;var m;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function v(o){return o&&typeof o.read=="function"}e.$Xu=v;var k;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class d{constructor(a,t,r,h,u,c){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.$Yu=d;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$Zu=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$1u=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$2u=n}),define(Se[173],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.NodeColor=e.$xB=void 0;class D{constructor(d,s){this.piece=d,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$yB)return g(this.right);let d=this;for(;d.parent!==e.$yB&&d.parent.left!==d;)d=d.parent;return d.parent===e.$yB?e.$yB:d.parent}prev(){if(this.left!==e.$yB)return P(this.left);let d=this;for(;d.parent!==e.$yB&&d.parent.right!==d;)d=d.parent;return d.parent===e.$yB?e.$yB:d.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$xB=D;var O;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$yB=new D(null,0),e.$yB.parent=e.$yB,e.$yB.left=e.$yB,e.$yB.right=e.$yB,e.$yB.color=0;function g(f){for(;f.left!==e.$yB;)f=f.left;return f}e.$zB=g;function P(f){for(;f.right!==e.$yB;)f=f.right;return f}e.$AB=P;function M(f){return f===e.$yB?0:f.size_left+f.piece.length+M(f.right)}function b(f){return f===e.$yB?0:f.lf_left+f.piece.lineFeedCnt+b(f.right)}function $(){e.$yB.parent=e.$yB}function y(f,d){const s=d.right;s.size_left+=d.size_left+(d.piece?d.piece.length:0),s.lf_left+=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),d.right=s.left,s.left!==e.$yB&&(s.left.parent=d),s.parent=d.parent,d.parent===e.$yB?f.root=s:d.parent.left===d?d.parent.left=s:d.parent.right=s,s.left=d,d.parent=s}e.$BB=y;function R(f,d){const s=d.left;d.left=s.right,s.right!==e.$yB&&(s.right.parent=d),s.parent=d.parent,d.size_left-=s.size_left+(s.piece?s.piece.length:0),d.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),d.parent===e.$yB?f.root=s:d===d.parent.right?d.parent.right=s:d.parent.left=s,s.right=d,d.parent=s}e.$CB=R;function C(f,d){let s,i;if(d.left===e.$yB?(i=d,s=i.right):d.right===e.$yB?(i=d,s=i.left):(i=g(d.right),s=i.right),i===f.root){f.root=s,s.color=0,d.detach(),$(),f.root.parent=e.$yB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===d?(s.parent=i.parent,k(f,s)):(i.parent===d?s.parent=i:s.parent=i.parent,k(f,s),i.left=d.left,i.right=d.right,i.parent=d.parent,i.color=d.color,d===f.root?f.root=i:d===d.parent.left?d.parent.left=i:d.parent.right=i,i.left!==e.$yB&&(i.left.parent=i),i.right!==e.$yB&&(i.right.parent=i),i.size_left=d.size_left,i.lf_left=d.lf_left,k(f,i)),d.detach(),s.parent.left===s){const a=M(s),t=b(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,h=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,v(f,s.parent,r,h)}}if(k(f,s.parent),n){$();return}let o;for(;s!==f.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,y(f,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,R(f,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,y(f,s.parent),s=f.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,R(f,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,y(f,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,R(f,s.parent),s=f.root));s.color=0,$()}e.$DB=C;function m(f,d){for(k(f,d);d!==f.root&&d.parent.color===1;)if(d.parent===d.parent.parent.left){const s=d.parent.parent.right;s.color===1?(d.parent.color=0,s.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.right&&(d=d.parent,y(f,d)),d.parent.color=0,d.parent.parent.color=1,R(f,d.parent.parent))}else{const s=d.parent.parent.left;s.color===1?(d.parent.color=0,s.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.left&&(d=d.parent,R(f,d)),d.parent.color=0,d.parent.parent.color=1,y(f,d.parent.parent))}f.root.color=0}e.$EB=m;function v(f,d,s,i){for(;d!==f.root&&d!==e.$yB;)d.parent.left===d&&(d.parent.size_left+=s,d.parent.lf_left+=i),d=d.parent}e.$FB=v;function k(f,d){let s=0,i=0;if(d!==f.root){for(;d!==f.root&&d===d.parent.right;)d=d.parent;if(d!==f.root)for(d=d.parent,s=M(d.left)-d.size_left,i=b(d.left)-d.lf_left,d.size_left+=s,d.lf_left+=i;d!==f.root&&(s!==0||i!==0);)d.parent.left===d&&(d.parent.size_left+=s,d.parent.lf_left+=i),d=d.parent}}e.$GB=k}),define(Se[174],ke([1,0,19,124]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.$5u=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,O.$Fe)($);const R=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(R.length+m),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,O.$Fe)($),y=(0,O.$Fe)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,O.$Fe)($),y=(0,O.$Fe)(y);const R=this.a,C=this.b;if($>=R.length)return!1;const m=R.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(R.length-y),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,O.$Fe)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let R=y;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,R=this.a.length-1,C=0,m=0,v=0;for(;y<=R;)if(C=y+(R-y)/2|0,m=this.b[C],v=m-this.a[C],$<v)R=C-1;else if($>=m)y=C+1;else break;return new M(C,$-v)}}e.$5u=g;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],R=y>0?this.d[y-1]:0;return new M(y,$-R)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const R=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+R;for(let m=0;m<R;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$6u=P;class M{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$7u=M}),define(Se[175],ke([1,0,13,49,174]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=void 0;class P{constructor(b,$,y,R){this.d=b,this.f=$,this.g=y,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new O.$Ds(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let R=0;R<$;R++)y[R]=this.f[R].length+b;this.j=new g.$5u(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Ue)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const R=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),R[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$8u=P}),define(Se[99],ke([1,0,13,170,49,29,79]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const b=999;class ${constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Se(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new M.$Zu(n,this.wordSeparators?(0,O.$5s)(this.wordSeparators):null,o?this.searchString:null)}}e.$HB=$;function y(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$IB=y;function R(s,i,n){if(!n)return new M.$Wu(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new M.$Wu(s,o)}e.$JB=R;class C{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class m{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new d(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let h,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),h=n+t+u):h=n+t;let c;if(a){const w=a.findLineFeedCountBeforeOffset(t+r.length)-u;c=h+r.length+w}else c=h+r.length;const l=i.getPositionAt(h),S=i.getPositionAt(c);return new P.$Es(l.lineNumber,l.column,S.lineNumber,S.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),h=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new C(h):null,c=[];let l=0,S;for(o.reset(0);S=o.next(h);)if(c[l++]=R(this.a(i,r,h,u,S.index,S[0]),S,a),l>=t)return c;return c}static c(i,n,o,a,t){const r=[];let h=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return h=this.d(o,c,n.startLineNumber,n.startColumn-1,h,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);h=this.d(o,u,n.startLineNumber,n.startColumn-1,h,r,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&h<t;c++)h=this.d(o,i.getLineContent(c),c,0,h,r,a,t);if(h<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);h=this.d(o,c,n.endLineNumber,0,h,r,a,t)}return r}static d(i,n,o,a,t,r,h,u){const c=i.wordSeparators;if(!h&&i.simpleSearch){const L=i.simpleSearch,w=L.length,p=n.length;let E=-w;for(;(E=n.indexOf(L,E+w))!==-1;)if((!c||f(c,n,p,E,w))&&(r[t++]=new M.$Wu(new P.$Es(o,E+1+a,o,E+1+w+a),null),t>=u))return t;return t}const l=new d(i.wordSeparators,i.regex);let S;l.reset(0);do if(S=l.next(n),S&&(r[t++]=R(new P.$Es(o,S.index+1+a,o,S.index+1+S[0].length+a),S,h),t>=u))return t;while(S);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new g.$Ds(n.lineNumber,1),r=i.getOffsetAt(t),h=i.getLineCount(),u=i.getValueInRange(new P.$Es(t.lineNumber,t.column,h,i.getLineMaxColumn(h)),1),c=i.getEOL()===`\r
`?new C(u):null;o.reset(n.column-1);const l=o.next(u);return l?R(this.a(i,r,u,c,l.index,l[0]),l,a):n.lineNumber!==1||n.column!==1?this.e(i,new g.$Ds(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r),u=this.g(o,h,r,n.column,a);if(u)return u;for(let c=1;c<=t;c++){const l=(r+c-1)%t,S=i.getLineContent(l+1),L=this.g(o,S,l+1,1,a);if(L)return L}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?R(new P.$Es(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new P.$Es(1,1,n.lineNumber,n.column),o,a,10*b);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new g.$Ds(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,h,r,a);if(u)return u;for(let c=1;c<=t;c++){const l=(t+r-c-1)%t,S=i.getLineContent(l+1),L=this.k(o,S,l+1,a);if(L)return L}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=R(new P.$Es(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$KB=m;function v(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function k(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function f(s,i,n,o,a){return v(s,i,n,o,a)&&k(s,i,n,o,a)}e.$LB=f;class d{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){D.$bf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||f(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$MB=d}),define(Se[127],ke([1,0,49,29,79,173,99]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=e.$QB=e.$PB=e.$OB=e.$NB=void 0;const b=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function R(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?$(n):n}e.$NB=R;function C(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,c=i.length;u<c;u++){const l=i.charCodeAt(u);l===13?u+1<c&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):l===10?(a++,s[n++]=u+1):r&&l!==9&&(l<32||l>126)&&(r=!1)}const h=new y($(s),o,a,t,r);return s.length=0,h}e.$OB=C;class m{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$PB=m;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$QB=v;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==P.$yB&&i.iterate(i.root,o=>(o!==P.$yB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class d{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=P.$yB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const h=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,h)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const h=[];if(this.iterate(this.root,u=>{const c=this.R(u),l=c.length;if(r<=o||r+l<a)return t+=c,r+=l,!0;const S=t.replace(/\r\n|\r|\n/g,i);return h.push(new v(S,R(S))),t=c,r=l,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);h.push(new v(u,R(u)))}this.create(h,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===P.$yB)return!0;const t=this.R(a),r=t.length,h=i.G(n),u=i.G(n+r),c=i.getValueInRange2(h,u);return n+=r,t===c})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==P.$yB;)if(a.left!==P.$yB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==P.$yB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),h=a-r;return new D.$Ds(o+1,h+1)}return new D.$Ds(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===P.$yB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new D.$Ds(o+1,r+1)}else n=n.right;return new D.$Ds(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const h=i.node,u=this.a[h.piece.bufferIndex].buffer,c=this.u(h.piece.bufferIndex,h.piece.start);return u.substring(c+i.remainder,c+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==P.$yB;){const h=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=h.substring(u,u+n.remainder);break}else r+=h.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===P.$yB)return!0;const r=t.piece;let h=r.length;if(h===0)return!0;const u=this.a[r.bufferIndex].buffer,c=this.a[r.bufferIndex].lineStarts,l=r.start.line,S=r.end.line;let L=c[l]+r.start.column;if(a&&(u.charCodeAt(L)===10&&(L++,h--),i[n++]=o,o="",a=!1,h===0))return!0;if(l===S)return!this.f&&u.charCodeAt(L+h-1)===13?(a=!0,o+=u.substr(L,h-1)):o+=u.substr(L,h),!0;o+=this.f?u.substring(L,Math.max(L,c[l+1]-this.e)):u.substring(L,c[l+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let w=l+1;w<S;w++)o=this.f?u.substring(c[w],c[w+1]-this.e):u.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(c[S]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(c[S],r.end.column-1)):o=u.substr(c[S],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,h,u,c,l,S){const L=this.a[i.piece.bufferIndex],w=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,r);let A;const z={line:0,column:0};let N,I;n._wordSeparators?(N=L.buffer.substring(p,E),I=j=>j+p,n.reset(0)):(N=L.buffer,I=j=>j,n.reset(p));do if(A=n.next(N),A){if(I(A.index)>=E)return l;this.s(i,I(A.index)-w,z);const j=this.t(i.piece.bufferIndex,t,z),T=z.line===t.line?z.column-t.column+a:z.column+1,F=T+A[0].length;if(S[l++]=(0,M.$JB)(new O.$Es(o+j,T,o+j,F),A,u),I(A.index)+A[0].length>=E||l>=c)return l}while(A);return l}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const h=new M.$MB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let l=this.s(u.node,u.remainder);const S=this.s(c.node,c.remainder);if(u.node===c.node)return this.findMatchesInNode(u.node,h,i.startLineNumber,i.startColumn,l,S,n,o,a,r,t),t;let L=i.startLineNumber,w=u.node;for(;w!==c.node;){const E=this.t(w.piece.bufferIndex,l,w.piece.end);if(E>=1){const z=this.a[w.piece.bufferIndex].lineStarts,N=this.u(w.piece.bufferIndex,w.piece.start),I=z[l.line+E],j=L===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(w,h,L,j,l,this.s(w,I-N),n,o,a,r,t),r>=a)return t;L+=E}const A=L===i.startLineNumber?i.startColumn-1:0;if(L===i.endLineNumber){const z=this.getLineContent(L).substring(A,i.endColumn-1);return r=this.n(n,h,z,i.endLineNumber,A,r,t,o,a),t}if(r=this.n(n,h,this.getLineContent(L).substr(A),L,A,r,t,o,a),r>=a)return t;L++,u=this.H(L,1),w=u.node,l=this.s(u.node,u.remainder)}if(L===i.endLineNumber){const E=L===i.startLineNumber?i.startColumn-1:0,A=this.getLineContent(L).substring(E,i.endColumn-1);return r=this.n(n,h,A,i.endLineNumber,E,r,t,o,a),t}const p=L===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(c.node,h,L,p,l,S,n,o,a,r,t),t}n(i,n,o,a,t,r,h,u,c){const l=i.wordSeparators;if(!u&&i.simpleSearch){const L=i.simpleSearch,w=L.length,p=o.length;let E=-w;for(;(E=o.indexOf(L,E+w))!==-1;)if((!l||(0,M.$LB)(l,o,p,E,w))&&(h[r++]=new g.$Wu(new O.$Es(a,E+1+t,a,E+1+w+t),null),r>=c))return r;return r}let S;n.reset(0);do if(S=n.next(o),S&&(h[r++]=(0,M.$JB)(new O.$Es(a,S.index+1+t,a,S.index+1+S[0].length+t),S,u),r>=c))return r;while(S);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==P.$yB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),h=a.piece,u=h.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&r+h.length===i&&n.length<b){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const l=[];let S=new m(h.bufferIndex,c,h.end,this.t(h.bufferIndex,c,h.end),this.u(u,h.end)-this.u(u,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const E={line:S.start.line+1,column:0};S=new m(S.bufferIndex,E,S.end,this.t(S.bufferIndex,E,S.end),S.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const E=this.s(a,t-1);this.C(a,E),n="\r"+n,a.piece.length===0&&l.push(a)}else this.C(a,c);else this.C(a,c);const L=this.w(n);S.length>0&&this.S(a,S);let w=a;for(let p=0;p<L.length;p++)w=this.S(w,L[p]);this.v(l)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===P.$yB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const L=this.s(t,o.remainder),w=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,P.$DB)(this,t),this.N(p),this.y();return}this.D(t,w),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,L),this.O(t),this.y();return}this.E(t,L,w),this.y();return}const h=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&h.push(t);const c=this.s(r,a.remainder);this.D(r,c),r.piece.length===0&&h.push(r);const l=t.next();for(let L=l;L!==P.$yB&&L!==r;L=L.next())h.push(L);const S=t.piece.length===0?t.prev():t;this.v(h),this.O(S),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,h={line:r.start.line+1,column:0},u=new m(r.bufferIndex,h,r.end,this.t(r.bufferIndex,h,r.end),r.length-1);n.piece=u,i+=`
`,(0,P.$FB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let c=a.start.line,l=a.end.line,S=0,L=0,w=0;for(;c<=l&&(S=c+(l-c)/2|0,w=r[S],S!==l);)if(L=r[S+1],u<w)l=S-1;else if(u>=L)c=S+1;else break;return o?(o.line=S,o.column=u-w,null):{line:S,column:u-w}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const h=r-1;return this.a[i].buffer.charCodeAt(h)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,P.$DB)(this,i[n])}w(i){if(i.length>b){const l=[];for(;i.length>b;){const L=i.charCodeAt(b-1);let w;L===13||L>=55296&&L<=56319?(w=i.substring(0,b-1),i=i.substring(b-1)):(w=i.substring(0,b),i=i.substring(b));const p=R(w);l.push(new m(this.a.length,{line:0,column:0},{line:p.length-1,column:w.length-p[p.length-1]},p.length-1,w.length)),this.a.push(new v(w,p))}const S=R(i);return l.push(new m(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new v(i,S)),l}let n=this.a[0].buffer.length;const o=R(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let l=0;l<o.length;l++)o[l]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let l=0;l<o.length;l++)o[l]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[r],u={line:r,column:h},c=new m(0,a,u,this.t(0,a,u),t-n);return this.g=u,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),h=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=h.substring(u+r,u+o.piece.length);else{const c=this.B(o,i-t.nodeStartLineNumber);return h.substring(u+r,u+c-n)}}else{let r=0;const h=i;for(;o!==P.$yB;)if(o.left!==P.$yB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),c=this.B(o,i-o.lf_left-1),l=this.a[o.piece.bufferIndex].buffer,S=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:h-(i-1-o.lf_left)}),l.substring(S+u,S+c-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),c=this.a[o.piece.bufferIndex].buffer,l=this.u(o.piece.bufferIndex,o.piece.start);a=c.substring(l+u,l+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==P.$yB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const h=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+h-n),a}else{const h=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(h,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==P.$yB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,h=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),c=u-a,l=h-t,S=o.length+l;i.piece=new m(o.bufferIndex,o.start,r,u,S),(0,P.$FB)(this,i,l,c)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,h=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),c=h-a,l=t-u,S=o.length+l;i.piece=new m(o.bufferIndex,r,o.end,h,S),(0,P.$FB)(this,i,l,c)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,h=a.length,u=a.lineFeedCnt,c=n,l=this.t(a.bufferIndex,a.start,c),S=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new m(a.bufferIndex,a.start,c,l,S),(0,P.$FB)(this,i,S-h,l-u);const L=new m(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),w=this.S(i,L);this.N(w)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=R(n,!1);for(let w=0;w<t.length;w++)t[w]+=a;if(o){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:h},c=i.piece.length+n.length,l=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,u),L=S-l;i.piece=new m(i.piece.bufferIndex,i.piece.start,u,S,c),this.g=u,(0,P.$FB)(this,i,n.length,L)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==P.$yB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==P.$yB;)if(o.left!==P.$yB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==P.$yB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$yB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$yB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,h=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,h,r),(0,P.$FB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},c=n.piece.length-1,l=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new m(n.piece.bufferIndex,u,n.piece.end,l,c),(0,P.$FB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const S=this.w(`\r
`);this.S(i,S[0]);for(let L=0;L<o.length;L++)(0,P.$DB)(this,o[L])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,P.$DB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,h=this.t(a.bufferIndex,t,a.end);o.piece=new m(a.bufferIndex,t,a.end,h,r),(0,P.$FB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===P.$yB)return n(P.$yB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===P.$yB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new P.$xB(n,1);if(o.left=P.$yB,o.right=P.$yB,o.parent=P.$yB,o.size_left=0,o.lf_left=0,this.root===P.$yB)this.root=o,o.color=0;else if(i.right===P.$yB)i.right=o,o.parent=i;else{const t=(0,P.$zB)(i.right);t.left=o,o.parent=t}return(0,P.$EB)(this,o),o}T(i,n){const o=new P.$xB(n,1);if(o.left=P.$yB,o.right=P.$yB,o.parent=P.$yB,o.size_left=0,o.lf_left=0,this.root===P.$yB)this.root=o,o.color=0;else if(i.left===P.$yB)i.left=o,o.parent=i;else{const a=(0,P.$AB)(i.left);a.right=o,o.parent=a}return(0,P.$EB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$RB=d}),define(Se[176],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47=e.$37=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const M=this.a.get(P);return this.a.delete(P),M}}addDragOperationTransfer(P,M){this.a.set(P,M)}}e.$37=D;class O{constructor(P){this.identifier=P}}e.$47=O}),define(Se[177],ke([1,0,4,3]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,O.$Qc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new P(this,b,$);return this.b.set(b,y),(0,O.$Qc)(()=>{const R=this.b.get(b);!R||R!==y||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$dt=g;class P extends O.$Sc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Se[178],ke([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Se[179],ke([1,0,4,3,178]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class P extends O.$Sc{constructor(m,v="",k="",f=!0,d){super(),this.h=this.B(new D.$Sd),this.onDidChange=this.h.event,this.z=!0,this.m=m,this.n=v,this.w=k,this.z=f,this.D=d}get id(){return this.m}get label(){return this.n}set label(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({label:m}))}get tooltip(){return this.u||""}set tooltip(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({tooltip:m}))}get class(){return this.w}set class(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({class:m}))}get enabled(){return this.z}set enabled(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({enabled:m}))}get checked(){return this.C}set checked(m){this.J(m)}J(m){this.C!==m&&(this.C=m,this.h.fire({checked:m}))}async run(m,v){this.D&&await this.D(m)}}e.$Fi=P;class M extends O.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Sd),this.onWillRun=this.f.event,this.m=this.B(new D.$Sd),this.onDidRun=this.m.event}async run(m,v){if(!m.enabled)return;this.f.fire({action:m});let k;try{await this.u(m,v)}catch(f){k=f}this.m.fire({action:m,error:k})}async u(m,v){await m.run(v)}}e.$Gi=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let v=[];for(const k of m)k.length&&(v.length?v=[...v,new b,...k]:v=k);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Hi=b;class ${get actions(){return this.a}constructor(m,v,k,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=v,this.class=f,this.a=k}async run(){}}e.$Ii=$;class y extends P{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Ji=y;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Ki=R}),define(Se[180],ke([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Se[181],ke([1,0,180]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=void 0;const O=60,g=O*60,P=g*24,M=P*7,b=P*30,$=P*365;function y(C,m,v,k){typeof C!="number"&&(C=C.getTime());const f=Math.round((new Date().getTime()-C)/1e3);if(f<-30)return(0,D.localize)(0,null,y(new Date().getTime()+f*1e3,!1));if(!k&&f<30)return(0,D.localize)(1,null);let d;return f<O?(d=f,m?d===1?v?(0,D.localize)(2,null,d):(0,D.localize)(3,null,d):v?(0,D.localize)(4,null,d):(0,D.localize)(5,null,d):d===1?v?(0,D.localize)(6,null,d):(0,D.localize)(7,null,d):v?(0,D.localize)(8,null,d):(0,D.localize)(9,null,d)):f<g?(d=Math.floor(f/O),m?d===1?v?(0,D.localize)(10,null,d):(0,D.localize)(11,null,d):v?(0,D.localize)(12,null,d):(0,D.localize)(13,null,d):d===1?v?(0,D.localize)(14,null,d):(0,D.localize)(15,null,d):v?(0,D.localize)(16,null,d):(0,D.localize)(17,null,d)):f<P?(d=Math.floor(f/g),m?d===1?v?(0,D.localize)(18,null,d):(0,D.localize)(19,null,d):v?(0,D.localize)(20,null,d):(0,D.localize)(21,null,d):d===1?v?(0,D.localize)(22,null,d):(0,D.localize)(23,null,d):v?(0,D.localize)(24,null,d):(0,D.localize)(25,null,d)):f<M?(d=Math.floor(f/P),m?d===1?(0,D.localize)(26,null,d):(0,D.localize)(27,null,d):d===1?(0,D.localize)(28,null,d):(0,D.localize)(29,null,d)):f<b?(d=Math.floor(f/M),m?d===1?v?(0,D.localize)(30,null,d):(0,D.localize)(31,null,d):v?(0,D.localize)(32,null,d):(0,D.localize)(33,null,d):d===1?v?(0,D.localize)(34,null,d):(0,D.localize)(35,null,d):v?(0,D.localize)(36,null,d):(0,D.localize)(37,null,d)):f<$?(d=Math.floor(f/b),m?d===1?v?(0,D.localize)(38,null,d):(0,D.localize)(39,null,d):v?(0,D.localize)(40,null,d):(0,D.localize)(41,null,d):d===1?v?(0,D.localize)(42,null,d):(0,D.localize)(43,null,d):v?(0,D.localize)(44,null,d):(0,D.localize)(45,null,d)):(d=Math.floor(f/$),m?d===1?v?(0,D.localize)(46,null,d):(0,D.localize)(47,null,d):v?(0,D.localize)(48,null,d):(0,D.localize)(49,null,d):d===1?v?(0,D.localize)(50,null,d):(0,D.localize)(51,null,d):v?(0,D.localize)(52,null,d):(0,D.localize)(53,null,d))}e.$om=y;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$pm=R}),define(Se[182],ke([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Se[44],ke([1,0,19,18,182]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function P(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),M(C.stack)||M(C.stacktrace)):b(C)}function M(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Hb(C),k=$(v[0],m);return v.length>1?g.localize(4,null,k,v.length):k}if(O.$Df(C))return C;if(C.detail){const v=C.detail;if(v.error)return P(v.error,m);if(v.exception)return P(v.exception,m)}return C.stack?P(C,m):C.message?C.message:g.localize(5,null)}e.$Li=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Mi=y;function R(C,m){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=m,v}e.$Ni=R}),define(Se[183],ke([9,10]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(Se[11],ke([1,0,183]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let O=!1,g=!1,P=!1,M=!1,b=!1,$=!1,y=!1,R=!1,C=!1,m=!1,v,k=e.$g,f=e.$g,d,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,O=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,$=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,k=v,f=navigator.language;else if(typeof n=="object"){O=n.platform==="win32",g=n.platform==="darwin",P=n.platform==="linux",M=P&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=o,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,k=e.$g;const p=n.env.VSCODE_NLS_CONFIG;if(p)try{const E=JSON.parse(p),A=E.availableLanguages["*"];v=E.locale,f=E.osLocale,k=A||e.$g,d=E._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let h=0;g?h=1:O?h=3:P&&(h=2),e.$i=O,e.$j=g,e.$k=P,e.$l=M,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=m,e.$t=C,e.$u=h,e.$v=s,e.$w=k;var u;(function(p){function E(){return e.$w}p.value=E;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}p.isDefaultVariant=A;function z(){return e.$w==="en"}p.isDefault=z})(u||(e.Language=u={})),e.$x=v,e.$y=f,e.$z=d,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const p=[];i.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let z=0,N=p.length;z<N;z++){const I=p[z];if(I.id===A.data.vscodeScheduleAsyncWork){p.splice(z,1),I.callback();return}}});let E=0;return A=>{const z=++E;p.push({id:z,callback:A}),i.postMessage({vscodeScheduleAsyncWork:z},"*")}}return p=>setTimeout(p)})();var c;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=g||R?2:O?1:3;let l=!0,S=!1;function L(){if(!S){S=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,l=new Uint16Array(p.buffer)[0]===(2<<8)+1}return l}e.$D=L,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(p){return parseFloat(p)>=20}e.$J=w}),define(Se[50],ke([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const P=g.process;O={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(Se[16],ke([1,0,50]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,g=97,P=90,M=122,b=46,$=47,y=92,R=58,C=63;class m extends Error{constructor(r,h,u){let c;typeof h=="string"&&h.indexOf("not ")===0?(c="must not be",h=h.replace(/^not /,"")):c="must be";const l=r.indexOf(".")!==-1?"property":"argument";let S=`The "${r}" ${l} ${c} of type ${h}`;S+=`. Received type ${typeof u}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,r){if(t===null||typeof t!="object")throw new m(r,"Object",t)}function k(t,r){if(typeof t!="string")throw new m(r,"string",t)}const f=D.$dc==="win32";function d(t){return t===$||t===y}function s(t){return t===$}function i(t){return t>=O&&t<=P||t>=g&&t<=M}function n(t,r,h,u){let c="",l=0,S=-1,L=0,w=0;for(let p=0;p<=t.length;++p){if(p<t.length)w=t.charCodeAt(p);else{if(u(w))break;w=$}if(u(w)){if(!(S===p-1||L===1))if(L===2){if(c.length<2||l!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const E=c.lastIndexOf(h);E===-1?(c="",l=0):(c=c.slice(0,E),l=c.length-1-c.lastIndexOf(h)),S=p,L=0;continue}else if(c.length!==0){c="",l=0,S=p,L=0;continue}}r&&(c+=c.length>0?`${h}..`:"..",l=2)}else c.length>0?c+=`${h}${t.slice(S+1,p)}`:c=t.slice(S+1,p),l=p-S-1;S=p,L=0}else w===b&&L!==-1?++L:L=-1}return c}function o(t,r){v(r,"pathObject");const h=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return h?h===r.root?`${h}${u}`:`${h}${t}${u}`:u}e.$fc={resolve(...t){let r="",h="",u=!1;for(let c=t.length-1;c>=-1;c--){let l;if(c>=0){if(l=t[c],k(l,"path"),l.length===0)continue}else r.length===0?l=D.cwd():(l=D.env[`=${r}`]||D.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===y)&&(l=`${r}\\`));const S=l.length;let L=0,w="",p=!1;const E=l.charCodeAt(0);if(S===1)d(E)&&(L=1,p=!0);else if(d(E))if(p=!0,d(l.charCodeAt(1))){let A=2,z=A;for(;A<S&&!d(l.charCodeAt(A));)A++;if(A<S&&A!==z){const N=l.slice(z,A);for(z=A;A<S&&d(l.charCodeAt(A));)A++;if(A<S&&A!==z){for(z=A;A<S&&!d(l.charCodeAt(A));)A++;(A===S||A!==z)&&(w=`\\\\${N}\\${l.slice(z,A)}`,L=A)}}}else L=1;else i(E)&&l.charCodeAt(1)===R&&(w=l.slice(0,2),L=2,S>2&&d(l.charCodeAt(2))&&(p=!0,L=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(u){if(r.length>0)break}else if(h=`${l.slice(L)}\\${h}`,u=p,p&&r.length>0)break}return h=n(h,!u,"\\",d),u?`${r}\\${h}`:`${r}${h}`||"."},normalize(t){k(t,"path");const r=t.length;if(r===0)return".";let h=0,u,c=!1;const l=t.charCodeAt(0);if(r===1)return s(l)?"\\":t;if(d(l))if(c=!0,d(t.charCodeAt(1))){let L=2,w=L;for(;L<r&&!d(t.charCodeAt(L));)L++;if(L<r&&L!==w){const p=t.slice(w,L);for(w=L;L<r&&d(t.charCodeAt(L));)L++;if(L<r&&L!==w){for(w=L;L<r&&!d(t.charCodeAt(L));)L++;if(L===r)return`\\\\${p}\\${t.slice(w)}\\`;L!==w&&(u=`\\\\${p}\\${t.slice(w,L)}`,h=L)}}}else h=1;else i(l)&&t.charCodeAt(1)===R&&(u=t.slice(0,2),h=2,r>2&&d(t.charCodeAt(2))&&(c=!0,h=3));let S=h<r?n(t.slice(h),!c,"\\",d):"";return S.length===0&&!c&&(S="."),S.length>0&&d(t.charCodeAt(r-1))&&(S+="\\"),u===void 0?c?`\\${S}`:S:c?`${u}\\${S}`:`${u}${S}`},isAbsolute(t){k(t,"path");const r=t.length;if(r===0)return!1;const h=t.charCodeAt(0);return d(h)||r>2&&i(h)&&t.charCodeAt(1)===R&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,h;for(let l=0;l<t.length;++l){const S=t[l];k(S,"path"),S.length>0&&(r===void 0?r=h=S:r+=`\\${S}`)}if(r===void 0)return".";let u=!0,c=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++c;const l=h.length;l>1&&d(h.charCodeAt(1))&&(++c,l>2&&(d(h.charCodeAt(2))?++c:u=!1))}if(u){for(;c<r.length&&d(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$fc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r)return"";const h=e.$fc.resolve(t),u=e.$fc.resolve(r);if(h===u||(t=h.toLowerCase(),r=u.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===y;)c++;let l=t.length;for(;l-1>c&&t.charCodeAt(l-1)===y;)l--;const S=l-c;let L=0;for(;L<r.length&&r.charCodeAt(L)===y;)L++;let w=r.length;for(;w-1>L&&r.charCodeAt(w-1)===y;)w--;const p=w-L,E=S<p?S:p;let A=-1,z=0;for(;z<E;z++){const I=t.charCodeAt(c+z);if(I!==r.charCodeAt(L+z))break;I===y&&(A=z)}if(z!==E){if(A===-1)return u}else{if(p>E){if(r.charCodeAt(L+z)===y)return u.slice(L+z+1);if(z===2)return u.slice(L+z)}S>E&&(t.charCodeAt(c+z)===y?A=z:z===2&&(A=3)),A===-1&&(A=0)}let N="";for(z=c+A+1;z<=l;++z)(z===l||t.charCodeAt(z)===y)&&(N+=N.length===0?"..":"\\..");return L+=A,N.length>0?`${N}${u.slice(L,w)}`:(u.charCodeAt(L)===y&&++L,u.slice(L,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const h=r.charCodeAt(2);if(h!==C&&h!==b)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){k(t,"path");const r=t.length;if(r===0)return".";let h=-1,u=0;const c=t.charCodeAt(0);if(r===1)return d(c)?t:".";if(d(c)){if(h=u=1,d(t.charCodeAt(1))){let L=2,w=L;for(;L<r&&!d(t.charCodeAt(L));)L++;if(L<r&&L!==w){for(w=L;L<r&&d(t.charCodeAt(L));)L++;if(L<r&&L!==w){for(w=L;L<r&&!d(t.charCodeAt(L));)L++;if(L===r)return t;L!==w&&(h=u=L+1)}}}}else i(c)&&t.charCodeAt(1)===R&&(h=r>2&&d(t.charCodeAt(2))?3:2,u=h);let l=-1,S=!0;for(let L=r-1;L>=u;--L)if(d(t.charCodeAt(L))){if(!S){l=L;break}}else S=!1;if(l===-1){if(h===-1)return".";l=h}return t.slice(0,l)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let h=0,u=-1,c=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(h=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,L=-1;for(l=t.length-1;l>=h;--l){const w=t.charCodeAt(l);if(d(w)){if(!c){h=l+1;break}}else L===-1&&(c=!1,L=l+1),S>=0&&(w===r.charCodeAt(S)?--S===-1&&(u=l):(S=-1,u=L))}return h===u?u=L:u===-1&&(u=t.length),t.slice(h,u)}for(l=t.length-1;l>=h;--l)if(d(t.charCodeAt(l))){if(!c){h=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":t.slice(h,u)},extname(t){k(t,"path");let r=0,h=-1,u=0,c=-1,l=!0,S=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(r=u=2);for(let L=t.length-1;L>=r;--L){const w=t.charCodeAt(L);if(d(w)){if(!l){u=L+1;break}continue}c===-1&&(l=!1,c=L+1),w===b?h===-1?h=L:S!==1&&(S=1):h!==-1&&(S=-1)}return h===-1||c===-1||S===0||S===1&&h===c-1&&h===u+1?"":t.slice(h,c)},format:o.bind(null,"\\"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.length;let u=0,c=t.charCodeAt(0);if(h===1)return d(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(d(c)){if(u=1,d(t.charCodeAt(1))){let A=2,z=A;for(;A<h&&!d(t.charCodeAt(A));)A++;if(A<h&&A!==z){for(z=A;A<h&&d(t.charCodeAt(A));)A++;if(A<h&&A!==z){for(z=A;A<h&&!d(t.charCodeAt(A));)A++;A===h?u=A:A!==z&&(u=A+1)}}}}else if(i(c)&&t.charCodeAt(1)===R){if(h<=2)return r.root=r.dir=t,r;if(u=2,d(t.charCodeAt(2))){if(h===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let l=-1,S=u,L=-1,w=!0,p=t.length-1,E=0;for(;p>=u;--p){if(c=t.charCodeAt(p),d(c)){if(!w){S=p+1;break}continue}L===-1&&(w=!1,L=p+1),c===b?l===-1?l=p:E!==1&&(E=1):l!==-1&&(E=-1)}return L!==-1&&(l===-1||E===0||E===1&&l===L-1&&l===S+1?r.base=r.name=t.slice(S,L):(r.name=t.slice(S,l),r.base=t.slice(S,L),r.ext=t.slice(l,L))),S>0&&S!==u?r.dir=t.slice(0,S-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(f){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",h=!1;for(let u=t.length-1;u>=-1&&!h;u--){const c=u>=0?t[u]:a();k(c,"path"),c.length!==0&&(r=`${c}/${r}`,h=c.charCodeAt(0)===$)}return r=n(r,!h,"/",s),h?`/${r}`:r.length>0?r:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$,h=t.charCodeAt(t.length-1)===$;return t=n(t,!r,"/",s),t.length===0?r?"/":h?"./":".":(h&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let r;for(let h=0;h<t.length;++h){const u=t[h];k(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(k(t,"from"),k(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const h=1,u=t.length,c=u-h,l=1,S=r.length-l,L=c<S?c:S;let w=-1,p=0;for(;p<L;p++){const A=t.charCodeAt(h+p);if(A!==r.charCodeAt(l+p))break;A===$&&(w=p)}if(p===L)if(S>L){if(r.charCodeAt(l+p)===$)return r.slice(l+p+1);if(p===0)return r.slice(l+p)}else c>L&&(t.charCodeAt(h+p)===$?w=p:p===0&&(w=0));let E="";for(p=h+w+1;p<=u;++p)(p===u||t.charCodeAt(p)===$)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(l+w)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$;let h=-1,u=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!u){h=c;break}}else u=!1;return h===-1?r?"/":".":r&&h===1?"//":t.slice(0,h)},basename(t,r){r!==void 0&&k(r,"ext"),k(t,"path");let h=0,u=-1,c=!0,l;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let S=r.length-1,L=-1;for(l=t.length-1;l>=0;--l){const w=t.charCodeAt(l);if(w===$){if(!c){h=l+1;break}}else L===-1&&(c=!1,L=l+1),S>=0&&(w===r.charCodeAt(S)?--S===-1&&(u=l):(S=-1,u=L))}return h===u?u=L:u===-1&&(u=t.length),t.slice(h,u)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===$){if(!c){h=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":t.slice(h,u)},extname(t){k(t,"path");let r=-1,h=0,u=-1,c=!0,l=0;for(let S=t.length-1;S>=0;--S){const L=t.charCodeAt(S);if(L===$){if(!c){h=S+1;break}continue}u===-1&&(c=!1,u=S+1),L===b?r===-1?r=S:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||u===-1||l===0||l===1&&r===u-1&&r===h+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){k(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.charCodeAt(0)===$;let u;h?(r.root="/",u=1):u=0;let c=-1,l=0,S=-1,L=!0,w=t.length-1,p=0;for(;w>=u;--w){const E=t.charCodeAt(w);if(E===$){if(!L){l=w+1;break}continue}S===-1&&(L=!1,S=w+1),E===b?c===-1?c=w:p!==1&&(p=1):c!==-1&&(p=-1)}if(S!==-1){const E=l===0&&h?1:l;c===-1||p===0||p===1&&c===S-1&&c===l+1?r.base=r.name=t.slice(E,S):(r.name=t.slice(E,c),r.base=t.slice(E,S),r.ext=t.slice(c,S))}return l>0?r.dir=t.slice(0,l-1):h&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=f?e.$fc.normalize:e.$gc.normalize,e.$ic=f?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=f?e.$fc.join:e.$gc.join,e.$kc=f?e.$fc.resolve:e.$gc.resolve,e.$lc=f?e.$fc.relative:e.$gc.relative,e.$mc=f?e.$fc.dirname:e.$gc.dirname,e.$nc=f?e.$fc.basename:e.$gc.basename,e.$oc=f?e.$fc.extname:e.$gc.extname,e.$pc=f?e.$fc.format:e.$gc.format,e.$qc=f?e.$fc.parse:e.$gc.parse,e.$rc=f?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=f?e.$fc.sep:e.$gc.sep,e.$tc=f?e.$fc.delimiter:e.$gc.delimiter}),define(Se[128],ke([1,0,43,16]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=void 0;const g=new D.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),P=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(L,w,p=!1){const E=L||"",A=w||"",z=g.value.collator.compare(E,A);return g.value.collatorIsNumeric&&z===0&&E!==A?E<A?-1:1:z}e.$sq=b;function $(L,w){const p=P.value.collator;return L=L||"",w=w||"",o(p,L,w)}e.$tq=$;function y(L,w){const p=P.value.collator;return L=L||"",w=w||"",h(L,w)||o(p,L,w)}e.$uq=y;function R(L,w){const p=P.value.collator;return L=L||"",w=w||"",r(L,w)||o(p,L,w)}e.$vq=R;function C(L,w){return L=L||"",w=w||"",L===w?0:L<w?-1:1}e.$wq=C;function m(L,w){const[p,E]=i(L),[A,z]=i(w);let N=g.value.collator.compare(E,z);if(N===0){if(g.value.collatorIsNumeric&&E!==z)return E<z?-1:1;if(N=g.value.collator.compare(p,A),g.value.collatorIsNumeric&&N===0&&p!==A)return p<A?-1:1}return N}e.$xq=m;function v(L,w){L=L||"",w=w||"";const p=n(L),E=n(w),A=P.value.collator,z=M.value.collator;return o(z,p,E)||o(A,L,w)}e.$yq=v;function k(L,w){L=L||"",w=w||"";const p=n(L),E=n(w),A=P.value.collator,z=M.value.collator;return o(z,p,E)||h(L,w)||o(A,L,w)}e.$zq=k;function f(L,w){L=L||"",w=w||"";const p=n(L),E=n(w),A=P.value.collator,z=M.value.collator;return o(z,p,E)||r(L,w)||o(A,L,w)}e.$Aq=f;function d(L,w){L=L||"",w=w||"";const p=n(L).toLowerCase(),E=n(w).toLowerCase();return p!==E?p<E?-1:1:L!==w?L<w?-1:1:0}e.$Bq=d;const s=/^(.*?)(\.([^.]*))?$/;function i(L,w=!1){const p=L?s.exec(L):[];let E=[p&&p[1]||"",p&&p[3]||""];return w&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(L){const w=L?s.exec(L):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function o(L,w,p){const E=L.compare(w,p);return E!==0?E:w.length!==p.length?w.length<p.length?-1:1:0}function a(L){const w=L.charAt(0);return w.toLocaleUpperCase()!==w}function t(L){const w=L.charAt(0);return w.toLocaleLowerCase()!==w}function r(L,w){return a(L)&&t(w)?-1:t(L)&&a(w)?1:0}function h(L,w){return t(L)&&a(w)?-1:a(L)&&t(w)?1:0}function u(L,w,p=!1){return p||(L=L&&L.toLowerCase(),w=w&&w.toLowerCase()),L===w?0:L<w?-1:1}function c(L,w,p=!1){const E=L.split(O.sep),A=w.split(O.sep),z=E.length-1,N=A.length-1;let I,j;for(let T=0;;T++){if(I=z===T,j=N===T,I&&j)return b(E[T],A[T],p);if(I)return-1;if(j)return 1;const F=u(E[T],A[T],p);if(F!==0)return F}}e.$Cq=c;function l(L,w,p){const E=L.toLowerCase(),A=w.toLowerCase(),z=S(L,w,p);if(z)return z;const N=E.endsWith(p),I=A.endsWith(p);if(N!==I)return N?-1:1;const j=b(E,A);return j!==0?j:E.localeCompare(A)}e.$Dq=l;function S(L,w,p){const E=L.toLowerCase(),A=w.toLowerCase(),z=E.startsWith(p),N=A.startsWith(p);if(z!==N)return z?-1:1;if(z&&N){if(E.length<A.length)return-1;if(E.length>A.length)return 1}return 0}e.$Eq=S}),define(Se[33],ke([1,0,16,11,13,18]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function M(l){return l===47||l===92}e.$Vf=M;function b(l){return l.replace(/[\\/]/g,D.$gc.sep)}e.$Wf=b;function $(l){return l.indexOf("/")===-1&&(l=b(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Xf=$;function y(l,S=D.$gc.sep){if(!l)return"";const L=l.length,w=l.charCodeAt(0);if(M(w)){if(M(l.charCodeAt(1))&&!M(l.charCodeAt(2))){let E=3;const A=E;for(;E<L&&!M(l.charCodeAt(E));E++);if(A!==E&&!M(l.charCodeAt(E+1))){for(E+=1;E<L;E++)if(M(l.charCodeAt(E)))return l.slice(0,E+1).replace(/[\\/]/g,S)}}return S}else if(s(w)&&l.charCodeAt(1)===58)return M(l.charCodeAt(2))?l.slice(0,2)+S:l.slice(0,2);let p=l.indexOf("://");if(p!==-1){for(p+=3;p<L;p++)if(M(l.charCodeAt(p)))return l.slice(0,p+1)}return""}e.$Yf=y;function R(l){if(!O.$i||!l||l.length<5)return!1;let S=l.charCodeAt(0);if(S!==92||(S=l.charCodeAt(1),S!==92))return!1;let L=2;const w=L;for(;L<l.length&&(S=l.charCodeAt(L),S!==92);L++);return!(w===L||(S=l.charCodeAt(L+1),isNaN(S)||S===92))}e.$Zf=R;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(l,S=O.$i){const L=S?C:m;return!(!l||l.length===0||/^\s+$/.test(l)||(L.lastIndex=0,L.test(l))||S&&v.test(l)||l==="."||l===".."||S&&l[l.length-1]==="."||S&&l.length!==l.trim().length||l.length>255)}e.$1f=k;function f(l,S,L){const w=l===S;return!L||w?w:!l||!S?!1:(0,g.$7e)(l,S)}e.$2f=f;function d(l,S,L,w=D.sep){if(l===S)return!0;if(!l||!S||S.length>l.length)return!1;if(L){if(!(0,g.$8e)(l,S))return!1;if(S.length===l.length)return!0;let E=S.length;return S.charAt(S.length-1)===w&&E--,l.charAt(E)===w}return S.charAt(S.length-1)!==w&&(S+=w),l.indexOf(S)===0}e.$3f=d;function s(l){return l>=65&&l<=90||l>=97&&l<=122}e.$4f=s;function i(l,S){return O.$i&&l.endsWith(":")&&(l+=D.sep),(0,D.$ic)(l)||(l=(0,D.$jc)(S,l)),l=(0,D.$hc)(l),O.$i?(l=(0,g.$Pe)(l,D.sep),l.endsWith(":")&&(l+=D.sep)):(l=(0,g.$Pe)(l,D.sep),l||(l=D.sep)),l}e.$5f=i;function n(l){const S=(0,D.$hc)(l);return O.$i?l.length>3?!1:o(S)&&(l.length===2||S.charCodeAt(2)===92):S===D.$gc.sep}e.$6f=n;function o(l,S=O.$i){return S?s(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$7f=o;function a(l,S=O.$i){return o(l,S)?l[0]:void 0}e.$8f=a;function t(l,S,L){return S.length>l.length?-1:l===S?0:(L&&(l=l.toLowerCase(),S=S.toLowerCase()),l.indexOf(S))}e.$9f=t;function r(l){const S=l.split(":");let L,w,p;for(const E of S){const A=Number(E);(0,P.$Hf)(A)?w===void 0?w=A:p===void 0&&(p=A):L=L?[L,E].join(":"):E}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:w!==void 0?w:void 0,column:p!==void 0?p:w!==void 0?1:void 0}}e.$0f=r;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(l,S,L=8){let w="";for(let E=0;E<L;E++){let A;E===0&&O.$i&&!S&&(L===3||L===4)?A=u:A=h,w+=A.charAt(Math.floor(Math.random()*A.length))}let p;return S?p=`${S}-${w}`:p=w,l?(0,D.$jc)(l,p):p}e.$$f=c}),define(Se[129],ke([1,0,128,123,53,16,11,13]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.$Hq=e.$Gq=e.$Fq=void 0;const $=0,y=[$,[]];function R(W,Y,le,Q){if(!W||!Y)return y;const Z=W.length,x=Y.length;if(Z<x)return y;const oe=W.toLowerCase();return C(Y,le,x,W,oe,Z,Q)}e.$Fq=R;function C(W,Y,le,Q,Z,x,oe){const X=[],ve=[];for(let ne=0;ne<le;ne++){const ye=ne*x,fe=ye-x,me=ne>0,ee=W[ne],ie=Y[ne];for(let G=0;G<x;G++){const te=G>0,J=ye+G,ce=J-1,be=fe+G-1,Ie=te?X[ce]:0,Fe=me&&te?X[be]:0,B=me&&te?ve[be]:0;let _;!Fe&&me?_=0:_=m(ee,ie,Q,Z,G,B),_&&Fe+_>=Ie&&(oe||me||Z.startsWith(Y,G))?(ve[J]=B+1,X[J]=Fe+_):(ve[J]=$,X[J]=Ie)}}const ge=[];let H=le-1,U=x-1;for(;H>=0&&U>=0;){const ne=H*x+U;ve[ne]===$||(ge.push(U),H--),U--}return[X[le*x-1],ge.reverse()]}function m(W,Y,le,Q,Z,x){let oe=0;if(!v(Y,Q[Z]))return oe;if(oe+=1,x>0&&(oe+=x*5),W===le[Z]&&(oe+=1),Z===0)oe+=8;else{const X=k(le.charCodeAt(Z-1));X?oe+=X:(0,O.$Rj)(le.charCodeAt(Z))&&x===0&&(oe+=2)}return oe}function v(W,Y){return W===Y?!0:W==="/"||W==="\\"?Y==="/"||Y==="\\":!1}function k(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(W,Y,le=0,Q=0){const Z=Y;return Z.values&&Z.values.length>1?s(W,Z.values,le,Q):i(W,Y,le,Q)}e.$Gq=d;function s(W,Y,le,Q){let Z=0;const x=[];for(const oe of Y){const[X,ve]=i(W,oe,le,Q);if(typeof X!="number")return f;Z+=X,x.push(...ve)}return[Z,L(x)]}function i(W,Y,le,Q){const Z=(0,O.$1j)(Y.original,Y.originalLowercase,le,W,W.toLowerCase(),Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,O.$Xj)(Z)]:f}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(W,Y,le,Q){const Z=Q.values?Q.values:[Q];return(0,g.$Oi)({[Q.normalized]:{values:Z.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:W,description:Y,allowNonContiguousMatches:le}})}function h(W,Y,le,Q,Z){if(!W||!Y.normalized)return n;const x=Q.getItemLabel(W);if(!x)return n;const oe=Q.getItemDescription(W),X=r(x,oe,le,Y),ve=Z[X];if(ve)return ve;const ge=u(x,oe,Q.getItemPath(W),Y,le);return Z[X]=ge,ge}e.$Hq=h;function u(W,Y,le,Q,Z){const x=!le||!Q.containsPathSeparator;return le&&(M.$k?Q.pathNormalized===le:(0,b.$7e)(Q.pathNormalized,le))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:Q.values&&Q.values.length>1?c(W,Y,le,Q.values,x,Z):l(W,Y,le,Q,x,Z)}function c(W,Y,le,Q,Z,x){let oe=0;const X=[],ve=[];for(const ge of Q){const{score:H,labelMatch:U,descriptionMatch:ne}=l(W,Y,le,ge,Z,x);if(H===$)return n;oe+=H,U&&X.push(...U),ne&&ve.push(...ne)}return{score:oe,labelMatch:L(X),descriptionMatch:L(ve)}}function l(W,Y,le,Q,Z,x){if(Z||!Y){const[oe,X]=R(W,Q.normalized,Q.normalizedLowercase,x&&!Q.expectContiguousMatch);if(oe){const ve=(0,O.$Oj)(Q.normalized,W);let ge;if(ve){ge=a;const H=Math.round(Q.normalized.length/W.length*100);ge+=H}else ge=t;return{score:ge+oe,labelMatch:ve||S(X)}}}if(Y){let oe=Y;le&&(oe=`${Y}${P.sep}`);const X=oe.length,ve=`${oe}${W}`,[ge,H]=R(ve,Q.normalized,Q.normalizedLowercase,x&&!Q.expectContiguousMatch);if(ge){const U=S(H),ne=[],ye=[];return U.forEach(fe=>{fe.start<X&&fe.end>X?(ne.push({start:0,end:fe.end-X}),ye.push({start:fe.start,end:X})):fe.start>=X?ne.push({start:fe.start-X,end:fe.end-X}):ye.push(fe)}),{score:ge,labelMatch:ne,descriptionMatch:ye}}}return n}function S(W){const Y=[];if(!W)return Y;let le;for(const Q of W)le&&le.end===Q?le.end+=1:(le={start:Q,end:Q+1},Y.push(le));return Y}function L(W){const Y=W.sort((Z,x)=>Z.start-x.start),le=[];let Q;for(const Z of Y)!Q||!w(Q,Z)?(Q=Z,le.push(Z)):(Q.start=Math.min(Q.start,Z.start),Q.end=Math.max(Q.end,Z.end));return le}function w(W,Y){return!(W.end<Y.start||Y.end<W.start)}function p(W,Y,le,Q,Z,x){const oe=h(W,le,Q,Z,x),X=h(Y,le,Q,Z,x),ve=oe.score,ge=X.score;if((ve===o||ge===o)&&ve!==ge)return ve===o?-1:1;if(ve>t||ge>t){if(ve!==ge)return ve>ge?-1:1;if(ve<a&&ge<a){const ee=A(oe.labelMatch,X.labelMatch);if(ee!==0)return ee}const fe=Z.getItemLabel(W)||"",me=Z.getItemLabel(Y)||"";if(fe.length!==me.length)return fe.length-me.length}if(ve!==ge)return ve>ge?-1:1;const H=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(H&&!U)return-1;if(U&&!H)return 1;const ne=E(W,oe,Z),ye=E(Y,X,Z);return ne&&ye&&ne!==ye?ye>ne?-1:1:z(W,Y,le,Z)}e.$Iq=p;function E(W,Y,le){let Q=-1,Z=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?Q=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(Q=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(Z=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const x=le.getItemDescription(W);x&&(Z+=x.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(Z=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return Z-Q}function A(W,Y){if(!W&&!Y||(!W||!W.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!W||!W.length)return 1;const le=W[0].start,Z=W[W.length-1].end-le,x=Y[0].start,X=Y[Y.length-1].end-x;return Z===X?0:X<Z?1:-1}function z(W,Y,le,Q){const Z=Q.getItemLabel(W)||"",x=Q.getItemLabel(Y)||"",oe=Q.getItemDescription(W),X=Q.getItemDescription(Y),ve=Z.length+(oe?oe.length:0),ge=x.length+(X?X.length:0);if(ve!==ge)return ve-ge;const H=Q.getItemPath(W),U=Q.getItemPath(Y);return H&&U&&H.length!==U.length?H.length-U.length:Z!==x?(0,D.$Dq)(Z,x,le.normalized):oe&&X&&oe!==X?(0,D.$Dq)(oe,X,le.normalized):H&&U&&H!==U?(0,D.$Dq)(H,U,le.normalized):0}function N(W){return W.startsWith('"')&&W.endsWith('"')}const I=" ";function j(W){typeof W!="string"&&(W="");const Y=W.toLowerCase(),{pathNormalized:le,normalized:Q,normalizedLowercase:Z}=T(W),x=le.indexOf(P.sep)>=0,oe=N(W);let X;const ve=W.split(I);if(ve.length>1)for(const ge of ve){const H=N(ge),{pathNormalized:U,normalized:ne,normalizedLowercase:ye}=T(ge);ne&&(X||(X=[]),X.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:ye,expectContiguousMatch:H}))}return{original:W,originalLowercase:Y,pathNormalized:le,normalized:Q,normalizedLowercase:Z,values:X,containsPathSeparator:x,expectContiguousMatch:oe}}e.$Jq=j;function T(W){let Y;M.$i?Y=W.replace(/\//g,P.sep):Y=W.replace(/\\/g,P.sep);const le=(0,b.$Re)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:le,normalizedLowercase:le.toLowerCase()}}function F(W){return Array.isArray(W)?j(W.map(Y=>Y.original).join(I)):j(W.original)}e.$Kq=F}),define(Se[100],ke([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.$3r=e.$2r=e.$1r=void 0,e.$1r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const C=(0,D.$oc)(R),m=O[C.toLowerCase()];return m!==void 0?m:M(R)}e.$2r=P;function M(R){const C=(0,D.$oc)(R);return g[C.toLowerCase()]}e.$3r=M;function b(R){for(const C in g)if(g[C]===R)return C}e.$4r=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(R,C){const m=$.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:R}e.$5r=y}),define(Se[101],ke([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function P(b,...$){const y=$.reduce((m,v)=>(m[v]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let v=0;v<R.length;v++)if(m.search(R[v])!==-1){delete b[m];break}})}e.$Kl=P;function M(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Ll=M}),define(Se[2],ke([1,0,16,11]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,P=/^\//,M=/^\/\//;function b(u,c){if(!u.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!g.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!P.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(u,c){return!u&&!c?"file":u}function y(u,c){switch(u){case"https":case"http":case"file":c?c[0]!==C&&(c=C+c):c=C;break}return c}const R="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,l,S,L,w,p=!1){typeof c=="object"?(this.scheme=c.scheme||R,this.authority=c.authority||R,this.path=c.path||R,this.query=c.query||R,this.fragment=c.fragment||R):(this.scheme=$(c,p),this.authority=l||R,this.path=y(this.scheme,S||R),this.query=L||R,this.fragment=w||R,b(this,p))}get fsPath(){return o(this,!1)}with(c){if(!c)return this;let{scheme:l,authority:S,path:L,query:w,fragment:p}=c;return l===void 0?l=this.scheme:l===null&&(l=R),S===void 0?S=this.authority:S===null&&(S=R),L===void 0?L=this.path:L===null&&(L=R),w===void 0?w=this.query:w===null&&(w=R),p===void 0?p=this.fragment:p===null&&(p=R),l===this.scheme&&S===this.authority&&L===this.path&&w===this.query&&p===this.fragment?this:new d(l,S,L,w,p)}static parse(c,l=!1){const S=m.exec(c);return S?new d(S[2]||R,h(S[4]||R),h(S[5]||R),h(S[7]||R),h(S[9]||R),l):new d(R,R,R,R,R)}static file(c){let l=R;if(O.$i&&(c=c.replace(/\\/g,C)),c[0]===C&&c[1]===C){const S=c.indexOf(C,2);S===-1?(l=c.substring(2),c=C):(l=c.substring(2,S),c=c.substring(S)||C)}return new d("file",l,c,R,R)}static from(c,l){return new d(c.scheme,c.authority,c.path,c.query,c.fragment,l)}static joinPath(c,...l){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return O.$i&&c.scheme==="file"?S=v.file(D.$fc.join(o(c,!0),...l)).path:S=D.$gc.join(c.path,...l),c.with({path:S})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const l=new d(c);return l._formatted=c.external??null,l._fsPath=c._sep===f?c.fsPath??null:null,l}}else return c}}e.URI=v;function k(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$vc=k;const f=O.$i?1:void 0;class d extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=f),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,c,l){let S,L=-1;for(let w=0;w<u.length;w++){const p=u.charCodeAt(w);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||c&&p===47||l&&p===91||l&&p===93||l&&p===58)L!==-1&&(S+=encodeURIComponent(u.substring(L,w)),L=-1),S!==void 0&&(S+=u.charAt(w));else{S===void 0&&(S=u.substr(0,w));const E=s[p];E!==void 0?(L!==-1&&(S+=encodeURIComponent(u.substring(L,w)),L=-1),S+=E):L===-1&&(L=w)}}return L!==-1&&(S+=encodeURIComponent(u.substring(L))),S!==void 0?S:u}function n(u){let c;for(let l=0;l<u.length;l++){const S=u.charCodeAt(l);S===35||S===63?(c===void 0&&(c=u.substr(0,l)),c+=s[S]):c!==void 0&&(c+=u[l])}return c!==void 0?c:u}function o(u,c){let l;return u.authority&&u.path.length>1&&u.scheme==="file"?l=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?c?l=u.path.substr(1):l=u.path[1].toLowerCase()+u.path.substr(2):l=u.path,O.$i&&(l=l.replace(/\//g,"\\")),l}e.$wc=o;function a(u,c){const l=c?n:i;let S="",{scheme:L,authority:w,path:p,query:E,fragment:A}=u;if(L&&(S+=L,S+=":"),(w||L==="file")&&(S+=C,S+=C),w){let z=w.indexOf("@");if(z!==-1){const N=w.substr(0,z);w=w.substr(z+1),z=N.lastIndexOf(":"),z===-1?S+=l(N,!1,!1):(S+=l(N.substr(0,z),!1,!1),S+=":",S+=l(N.substr(z+1),!1,!0)),S+="@"}w=w.toLowerCase(),z=w.lastIndexOf(":"),z===-1?S+=l(w,!1,!0):(S+=l(w.substr(0,z),!1,!0),S+=w.substr(z))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const z=p.charCodeAt(1);z>=65&&z<=90&&(p=`/${String.fromCharCode(z+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const z=p.charCodeAt(0);z>=65&&z<=90&&(p=`${String.fromCharCode(z+32)}:${p.substr(2)}`)}S+=l(p,!0,!1)}return E&&(S+="?",S+=l(E,!1,!1)),A&&(S+="#",S+=c?A:i(A,!1,!1)),S}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(u){return u.match(r)?u.replace(r,c=>t(c)):u}}),define(Se[184],ke([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$$p=e.$0p=e.$9p=void 0;function O(y){const R=y;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$9p=O;function g(y){const R=[];let C;try{const m=JSON.parse(y.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),C=v.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",y.arguments)}return{args:R,stack:C}}e.$0p=g;function P(y){if(typeof y!="string")return P(g(y).stack);const R=y;if(R){const C=M(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$$p=P;function M(y){if(!y)return y;const R=y.indexOf(`
`);return R===-1?y:y.substring(0,R)}function b(y,R){const{args:C,stack:m}=g(y),v=typeof C[0]=="string"&&C.length===1;let k=M(m);k&&(k=`(${k.trim()})`);let f=[];if(typeof C[0]=="string"?k&&v?f=[`%c[${R}] %c${C[0]} %c${k}`,$("blue"),$(""),$("grey")]:f=[`%c[${R}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:f=[`%c[${R}]%`,$("blue"),...C],k&&!v&&f.push(k),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,f)}e.log=b;function $(y){return`color: ${y}`}}),define(Se[54],ke([1,0,22,2]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function g($){return JSON.stringify($,M)}e.$vh=g;function P($){let y=JSON.parse($);return y=b(y),y}e.$wh=P;function M($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=b($[R],y+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=b($[R],y+1))}return $}e.$xh=b}),define(Se[17],ke([1,0,8,11,13,2]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var M;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={}));function b(m,v){return P.URI.isUri(m)?(0,g.$7e)(m.scheme,v):(0,g.$8e)(m,v+":")}e.$_f=b;function $(m,...v){return v.some(k=>b(m,k))}e.$ag=$,e.$bg="vscode-tkn",e.$cg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${M.vscodeRemoteResource}`}set(v,k,f){this.a[v]=k,this.b[v]=f}setConnectionToken(v,k){this.c[v]=k}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return D.$1(n),v}const k=v.authority;let f=this.a[k];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const d=this.b[k],s=this.c[k];let i=`path=${encodeURIComponent(v.path)}`;return typeof s=="string"&&(i+=`&${e.$cg}=${encodeURIComponent(s)}`),P.URI.from({scheme:O.$o?this.d:M.vscodeRemoteResource,authority:`${f}:${d}`,path:this.f,query:i})}}e.$dg=new y,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class R{static{this.a=e.$ig}asBrowserUri(v){const k=this.b(v,$e);return this.uriToBrowserUri(k)}uriToBrowserUri(v){return v.scheme===M.vscodeRemote?e.$dg.rewrite(v):v.scheme===M.file&&(O.$m||O.$q===`${M.vscodeFileResource}://${R.a}`)?v.with({scheme:M.vscodeFileResource,authority:v.authority||R.a,query:null,fragment:null}):v}asFileUri(v){const k=this.b(v,$e);return this.uriToFileUri(k)}uriToFileUri(v){return v.scheme===M.vscodeFileResource?v.with({scheme:M.file,authority:v.authority!==R.a?v.authority:null,query:null,fragment:null}):v}b(v,k){return P.URI.isUri(v)?v:P.URI.parse(k.toUrl(v))}}e.$jg=new R;var C;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const k="vscode-coi";function f(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:P.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(k);if(n)return v.get(n)}m.getHeadersFromQuery=f;function d(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(k,o):s[k]=o}m.addSearchParam=d})(C||(e.COI=C={}))}),define(Se[185],ke([1,0,157,17,11,2]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=void 0;class M{constructor(m,v,k){this.id=m,this.dependencies=v,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,v,k)=>{typeof m!="string"&&(k=v,v=m,m=null),(typeof v!="object"||!Array.isArray(v))&&(k=v,v=null),this.c.push(new M(m,v,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const v=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!v)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h(m){return new Promise((v,k)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const d=()=>{f.removeEventListener("load",s),f.removeEventListener("error",i)},s=n=>{d(),v(this.c.pop())},i=n=>{d(),k(n)};f.addEventListener("load",s),f.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),f.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(m){return new Promise((v,k)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),v(this.c.pop())}catch(f){k(f)}})}async j(m){try{const v=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,d=P.URI.parse(m).fsPath,s=v.readFileSync(d).toString(),i=f.wrap(s.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function R(C,m,v){if(D.$T){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const k=`${C}/${m}`;if($.has(k))return $.get(k);let f;if(/^\w[\w\d+.-]*:\/\//.test(k))f=k;else{const n=`${v&&!g.$o?O.$gg:O.$fg}/${k}`;f=O.$jg.asBrowserUri(n).toString(!0)}const d=b.INSTANCE.load(f);return $.set(k,d),d}else return await new Promise((k,f)=>{$e([C],k,f)})}e.$VC=R}),define(Se[23],ke([1,0,33,17,16,11,13,2]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function $(v){return(0,b.$wc)(v,!0)}e.$qg=$;class y{constructor(k){this.a=k}compare(k,f,d=!1){return k===f?0:(0,M.$Ze)(this.getComparisonKey(k,d),this.getComparisonKey(f,d))}isEqual(k,f,d=!1){return k===f?!0:!k||!f?!1:this.getComparisonKey(k,d)===this.getComparisonKey(f,d)}getComparisonKey(k,f=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,f,d=!1){if(k.scheme===f.scheme){if(k.scheme===O.Schemas.file)return D.$3f($(k),$(f),this.a(k))&&k.query===f.query&&(d||k.fragment===f.fragment);if((0,e.$Hg)(k.authority,f.authority))return D.$3f(k.path,f.path,this.a(k),"/")&&k.query===f.query&&(d||k.fragment===f.fragment)}return!1}joinPath(k,...f){return b.URI.joinPath(k,...f)}basenameOrAuthority(k){return(0,e.$zg)(k)||k.authority}basename(k){return g.$gc.basename(k.path)}extname(k){return g.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let f;return k.scheme===O.Schemas.file?f=b.URI.file(g.$mc($(k))).path:(f=g.$gc.dirname(k.path),k.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),f="/")),k.with({path:f})}normalizePath(k){if(!k.path.length)return k;let f;return k.scheme===O.Schemas.file?f=b.URI.file(g.$hc($(k))).path:f=g.$gc.normalize(k.path),k.with({path:f})}relativePath(k,f){if(k.scheme!==f.scheme||!(0,e.$Hg)(k.authority,f.authority))return;if(k.scheme===O.Schemas.file){const i=g.$lc($(k),$(f));return P.$i?D.$Wf(i):i}let d=k.path||"/";const s=f.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(d.length,s.length);i<n&&!(d.charCodeAt(i)!==s.charCodeAt(i)&&d.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);d=s.substr(0,i)+d.substr(i)}return g.$gc.relative(d,s)}resolvePath(k,f){if(k.scheme===O.Schemas.file){const d=b.URI.file(g.$kc($(k),f));return k.with({authority:d.authority,path:d.path})}return f=D.$Xf(f),k.with({path:g.$gc.resolve(k.path,f)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,f){return k===f||k!==void 0&&f!==void 0&&(0,M.$7e)(k,f)}hasTrailingPathSeparator(k,f=g.sep){if(k.scheme===O.Schemas.file){const d=$(k);return d.length>D.$Yf(d).length&&d[d.length-1]===f}else{const d=k.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,f=g.sep){return(0,e.$Ig)(k,f)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,f=g.sep){let d=!1;if(k.scheme===O.Schemas.file){const s=$(k);d=s!==void 0&&s.length===D.$Yf(s).length&&s[s.length-1]===f}else{f="/";const s=k.path;d=s.length===1&&s.charCodeAt(s.length-1)===47}return!d&&!(0,e.$Ig)(k,f)?k.with({path:k.path+"/"}):k}}e.$rg=y,e.$sg=new y(()=>!1),e.$tg=new y(v=>v.scheme===O.Schemas.file?!P.$k:!0),e.$ug=new y(v=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function R(v,k){const f=[];for(let d=0;d<v.length;d++){const s=k(v[d]);v.some((i,n)=>n===d?!1:(0,e.$wg)(s,k(i)))||f.push(v[d])}return f}e.$Lg=R;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function k(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&d.set(o,a)});const i=f.path.substring(0,f.path.indexOf(";"));return i&&d.set(v.META_DATA_MIME,i),d}v.parseMetaData=k})(C||(e.DataUri=C={}));function m(v,k,f){if(k){let d=v.path;return d&&d[0]!==g.$gc.sep&&(d=g.$gc.sep+d),v.with({scheme:f,authority:k,path:d})}return v.with({scheme:f})}e.$Mg=m}),define(Se[12],ke([1,0,21,8,4,3,23,11,162,43]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function R(ee){return!!ee&&typeof ee.then=="function"}e.$Ng=R;function C(ee){const ie=new D.$3d,G=ee(ie.token),te=new Promise((J,ce)=>{const be=ie.token.onCancellationRequested(()=>{be.dispose(),ie.dispose(),ce(new O.$5)});Promise.resolve(G).then(Ie=>{be.dispose(),ie.dispose(),J(Ie)},Ie=>{be.dispose(),ie.dispose(),ce(Ie)})});return new class{cancel(){ie.cancel()}then(J,ce){return te.then(J,ce)}catch(J){return this.then(void 0,J)}finally(J){return te.finally(J)}}}e.$Og=C;function m(ee,ie,G){return new Promise((te,J)=>{const ce=ie.onCancellationRequested(()=>{ce.dispose(),te(G)});ee.then(te,J).finally(()=>ce.dispose())})}e.$Pg=m;function v(ee,ie){return new Promise((G,te)=>{const J=ie.onCancellationRequested(()=>{J.dispose(),te(new O.$5)});ee.then(G,te).finally(()=>J.dispose())})}e.$Qg=v;async function k(ee){let ie=-1;const G=ee.map((te,J)=>te.then(ce=>(ie=J,ce)));try{return await Promise.race(G)}finally{ee.forEach((te,J)=>{J!==ie&&te.cancel()})}}e.$Rg=k;function f(ee,ie,G){let te;const J=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([ee.finally(()=>clearTimeout(J)),new Promise(ce=>te=ce)])}e.$Sg=f;function d(ee){return new Promise((ie,G)=>{const te=ee();R(te)?te.then(ie,G):ie(te)})}e.$Tg=d;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(J=>{this.a=null,G(J)},J=>{this.a=null,te(J)})})}dispose(){this.f=!0}}e.$Ug=s;class i{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Vg=i;class n{constructor(){this.a=new Map}queue(ie,G){const J=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===J&&this.a.delete(ie)});return this.a.set(ie,J),J}}e.$Wg=n;const o=(ee,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},ee);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},a=ee=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ee())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((J,ce)=>{this.d=J,this.f=ce}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Pd?a(te):o(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=t;class r{constructor(ie){this.a=new t(ie),this.b=new s}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=r;class h{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=h;class u extends h{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$1g=u;function c(ee,ie){return ie?new Promise((G,te)=>{const J=setTimeout(()=>{ce.dispose(),G()},ee),ce=ie.onCancellationRequested(()=>{clearTimeout(J),ce.dispose(),te(new O.$5)})}):C(G=>c(ee,G))}e.$2g=c;function l(ee,ie=0,G){const te=setTimeout(()=>{ee(),G&&J.dispose()},ie),J=(0,P.$Qc)(()=>{clearTimeout(te),G?.deleteAndLeak(J)});return G?.add(J),J}e.$3g=l;function S(ee){const ie=[];let G=0;const te=ee.length;function J(){return G<te?ee[G++]():null}function ce(be){be!=null&&ie.push(be);const Ie=J();return Ie?Ie.then(ce):Promise.resolve(ie)}return Promise.resolve(null).then(ce)}e.$4g=S;function L(ee,ie=te=>!!te,G=null){let te=0;const J=ee.length,ce=()=>{if(te>=J)return Promise.resolve(G);const be=ee[te++];return Promise.resolve(be()).then(Fe=>ie(Fe)?Promise.resolve(Fe):ce())};return ce()}e.$5g=L;function w(ee,ie=te=>!!te,G=null){if(ee.length===0)return Promise.resolve(G);let te=ee.length;const J=()=>{te=-1;for(const ce of ee)ce.cancel?.()};return new Promise((ce,be)=>{for(const Ie of ee)Ie.then(Fe=>{--te>=0&&ie(Fe)?(J(),ce(Fe)):te===0&&ce(G)}).catch(Fe=>{--te>=0&&(J(),be(Fe))})})}e.$6g=w;class p{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new g.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=p;class E extends p{constructor(){super(1)}}e.$8g=E;class A{constructor(){this.a=new Z,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$9g=A;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new X;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=M.$sg){const te=G.getComparisonKey(ie);let J=this.a.get(te);if(!J){J=new E;const ce=this.f++,be=g.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ce),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$2c),this.d.set(ce,be),this.a.set(te,J)}return J}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=z;class N{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$$g=N;class I{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const J=te.setInterval(()=>{ie()},G);this.d=(0,P.$Qc)(()=>{te.clearInterval(J),this.d=void 0})}dispose(){this.cancel()}}e.$_g=I;class j{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=j;class T{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=T;class F extends j{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$ch=F;class W extends P.$Sc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new P.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(ee,ie)=>{(0,b.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$fh=(ee,ie,G)=>{const te=ee.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let J=!1;return{dispose(){J||(J=!0,ee.cancelIdleCallback(te))}}},e.$eh=ee=>(0,e.$fh)(globalThis,ee)}();class Y{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$fh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=Y;class le extends Y{constructor(ie){super(globalThis,ie)}}e.$hh=le;async function Q(ee,ie,G){let te;for(let J=0;J<G;J++)try{return await ee()}catch(ce){te=ce,await c(ie)}throw te}e.$ih=Q;class Z{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const J=new Promise((ce,be)=>{G=ce,te=be});this.b={run:ie,promise:J,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=Z;class x{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$kh=x;var oe;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(oe||(oe={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new O.$5)}}e.$lh=X;var ve;(function(ee){async function ie(te){let J;const ce=await Promise.all(te.map(be=>be.then(Ie=>Ie,Ie=>{J||(J=Ie)})));if(typeof J<"u")throw J;return ce}ee.settled=ie;function G(te){return new Promise(async(J,ce)=>{try{await te(J,ce)}catch(be){ce(be)}})}ee.withAsyncBody=G})(ve||(e.Promises=ve={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=ge;class H{constructor(ie){this.b=ie,this.a=new y.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=H;var U;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(U||(U={}));class ne{static fromArray(ie){return new ne(G=>{G.emitMany(ie)})}static fromPromise(ie){return new ne(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>{for await(const J of te)G.emitOne(J)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new g.$Sd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new ne(async te=>{for await(const J of ie)te.emitOne(G(J))})}map(ie){return ne.map(this,ie)}static filter(ie,G){return new ne(async te=>{for await(const J of ie)G(J)&&te.emitOne(J)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,G=>!!G)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$oh=ne;class ye extends ne{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$ph=ye;function fe(ee){const ie=new D.$3d,G=ee(ie.token);return new ye(ie,async te=>{const J=ie.token.onCancellationRequested(()=>{J.dispose(),ie.dispose(),te.reject(new O.$5)});try{for await(const ce of G){if(ie.token.isCancellationRequested)return;te.emitOne(ce)}J.dispose(),ie.dispose()}catch(ce){J.dispose(),ie.dispose(),te.reject(ce)}})}e.$qh=fe;class me{constructor(){this.a=new X,this.b=new ne(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=J=>te.reject(J),this.f=J=>te.emitOne(J),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$rh=me}),define(Se[34],ke([1,0,19,12,33,28,16,11,13]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;function y(){return Object.create(null)}e.$Cj=y,e.$Dj="**",e.$Ej="/";const R="[/\\\\]",C="[^/\\\\]",m=/\//g;function v(le,Q){switch(le){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${Q?`|${R}${C}+`:""})*?`}}function k(le,Q){if(!le)return[];const Z=[];let x=!1,oe=!1,X="";for(const ve of le){switch(ve){case Q:if(!x&&!oe){Z.push(X),X="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}X+=ve}return X&&Z.push(X),Z}e.$Fj=k;function f(le){if(!le)return"";let Q="";const Z=k(le,e.$Ej);if(Z.every(x=>x===e.$Dj))Q=".*";else{let x=!1;Z.forEach((oe,X)=>{if(oe===e.$Dj){if(x)return;Q+=v(2,X===Z.length-1)}else{let ve=!1,ge="",H=!1,U="";for(const ne of oe){if(ne!=="}"&&ve){ge+=ne;continue}if(H&&(ne!=="]"||!U)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!U?ye="^":ne===e.$Ej?ye="":ye=(0,$.$Ke)(ne),U+=ye;continue}switch(ne){case"{":ve=!0;continue;case"[":H=!0;continue;case"}":{const fe=`(?:${k(ge,",").map(me=>f(me)).join("|")})`;Q+=fe,ve=!1,ge="";break}case"]":{Q+="["+U+"]",H=!1,U="";break}case"?":Q+=C;continue;case"*":Q+=v(1);continue;default:Q+=(0,$.$Ke)(ne)}}X<Z.length-1&&(Z[X+1]!==e.$Dj||X+2<Z.length)&&(Q+=R)}x=oe===e.$Dj})}return Q}const d=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),r=function(){return!1},h=function(){return null};function u(le,Q){if(!le)return h;let Z;typeof le!="string"?Z=le.pattern:Z=le,Z=Z.trim();const x=`${Z}_${!!Q.trimForExclusions}`;let oe=t.get(x);if(oe)return c(oe,le);let X;return d.test(Z)?oe=S(Z.substr(4),Z):(X=s.exec(l(Z,Q)))?oe=L(X[1],Z):(Q.trimForExclusions?n:i).test(Z)?oe=w(Z,Q):(X=o.exec(l(Z,Q)))?oe=p(X[1].substr(1),Z,!0):(X=a.exec(l(Z,Q)))?oe=p(X[1],Z,!1):oe=E(Z),t.set(x,oe),c(oe,le)}function c(le,Q){if(typeof Q=="string")return le;const Z=function(x,oe){return(0,g.$3f)(x,Q.base,!b.$k)?le((0,$.$Oe)(x.substr(Q.base.length),M.sep),oe):null};return Z.allBasenames=le.allBasenames,Z.allPaths=le.allPaths,Z.basenames=le.basenames,Z.patterns=le.patterns,Z}function l(le,Q){return Q.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function S(le,Q){return function(Z,x){return typeof Z=="string"&&Z.endsWith(le)?Q:null}}function L(le,Q){const Z=`/${le}`,x=`\\${le}`,oe=function(ve,ge){return typeof ve!="string"?null:ge?ge===le?Q:null:ve===le||ve.endsWith(Z)||ve.endsWith(x)?Q:null},X=[le];return oe.basenames=X,oe.patterns=[Q],oe.allBasenames=X,oe}function w(le,Q){const Z=W(le.slice(1,-1).split(",").map(ge=>u(ge,Q)).filter(ge=>ge!==h),le),x=Z.length;if(!x)return h;if(x===1)return Z[0];const oe=function(ge,H){for(let U=0,ne=Z.length;U<ne;U++)if(Z[U](ge,H))return le;return null},X=Z.find(ge=>!!ge.allBasenames);X&&(oe.allBasenames=X.allBasenames);const ve=Z.reduce((ge,H)=>H.allPaths?ge.concat(H.allPaths):ge,[]);return ve.length&&(oe.allPaths=ve),oe}function p(le,Q,Z){const x=M.sep===M.$gc.sep,oe=x?le:le.replace(m,M.sep),X=M.sep+oe,ve=M.$gc.sep+le;let ge;return Z?ge=function(H,U){return typeof H=="string"&&(H===oe||H.endsWith(X)||!x&&(H===le||H.endsWith(ve)))?Q:null}:ge=function(H,U){return typeof H=="string"&&(H===oe||!x&&H===le)?Q:null},ge.allPaths=[(Z?"*/":"./")+le],ge}function E(le){try{const Q=new RegExp(`^${f(le)}$`);return function(Z){return Q.lastIndex=0,typeof Z=="string"&&Q.test(Z)?le:null}}catch{return h}}function A(le,Q,Z){return!le||typeof Q!="string"?!1:z(le)(Q,void 0,Z)}e.$Gj=A;function z(le,Q={}){if(!le)return r;if(typeof le=="string"||N(le)){const Z=u(le,Q);if(Z===h)return r;const x=function(oe,X){return!!Z(oe,X)};return Z.allBasenames&&(x.allBasenames=Z.allBasenames),Z.allPaths&&(x.allPaths=Z.allPaths),x}return T(le,Q)}e.$Hj=z;function N(le){const Q=le;return Q?typeof Q.base=="string"&&typeof Q.pattern=="string":!1}e.$Ij=N;function I(le){return le.allBasenames||[]}e.$Jj=I;function j(le){return le.allPaths||[]}e.$Kj=j;function T(le,Q){const Z=W(Object.getOwnPropertyNames(le).map(ge=>F(ge,le[ge],Q)).filter(ge=>ge!==h)),x=Z.length;if(!x)return h;if(!Z.some(ge=>!!ge.requiresSiblings)){if(x===1)return Z[0];const ge=function(ne,ye){let fe;for(let me=0,ee=Z.length;me<ee;me++){const ie=Z[me](ne,ye);if(typeof ie=="string")return ie;(0,O.$Ng)(ie)&&(fe||(fe=[]),fe.push(ie))}return fe?(async()=>{for(const me of fe){const ee=await me;if(typeof ee=="string")return ee}return null})():null},H=Z.find(ne=>!!ne.allBasenames);H&&(ge.allBasenames=H.allBasenames);const U=Z.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return U.length&&(ge.allPaths=U),ge}const oe=function(ge,H,U){let ne,ye;for(let fe=0,me=Z.length;fe<me;fe++){const ee=Z[fe];ee.requiresSiblings&&U&&(H||(H=(0,M.$nc)(ge)),ne||(ne=H.substr(0,H.length-(0,M.$oc)(ge).length)));const ie=ee(ge,H,ne,U);if(typeof ie=="string")return ie;(0,O.$Ng)(ie)&&(ye||(ye=[]),ye.push(ie))}return ye?(async()=>{for(const fe of ye){const me=await fe;if(typeof me=="string")return me}return null})():null},X=Z.find(ge=>!!ge.allBasenames);X&&(oe.allBasenames=X.allBasenames);const ve=Z.reduce((ge,H)=>H.allPaths?ge.concat(H.allPaths):ge,[]);return ve.length&&(oe.allPaths=ve),oe}function F(le,Q,Z){if(Q===!1)return h;const x=u(le,Z);if(x===h)return h;if(typeof Q=="boolean")return x;if(Q){const oe=Q.when;if(typeof oe=="string"){const X=(ve,ge,H,U)=>{if(!U||!x(ve,ge))return null;const ne=oe.replace("$(basename)",()=>H),ye=U(ne);return(0,O.$Ng)(ye)?ye.then(fe=>fe?le:null):ye?le:null};return X.requiresSiblings=!0,X}}return x}function W(le,Q){const Z=le.filter(ge=>!!ge.basenames);if(Z.length<2)return le;const x=Z.reduce((ge,H)=>{const U=H.basenames;return U?ge.concat(U):ge},[]);let oe;if(Q){oe=[];for(let ge=0,H=x.length;ge<H;ge++)oe.push(Q)}else oe=Z.reduce((ge,H)=>{const U=H.patterns;return U?ge.concat(U):ge},[]);const X=function(ge,H){if(typeof ge!="string")return null;if(!H){let ne;for(ne=ge.length;ne>0;ne--){const ye=ge.charCodeAt(ne-1);if(ye===47||ye===92)break}H=ge.substr(ne)}const U=x.indexOf(H);return U!==-1?oe[U]:null};X.basenames=x,X.patterns=oe,X.allBasenames=x;const ve=le.filter(ge=>!ge.basenames);return ve.push(X),ve}function Y(le,Q){return(0,D.$ub)(le,Q,(Z,x)=>typeof Z=="string"&&typeof x=="string"?Z===x:typeof Z!="string"&&typeof x!="string"?Z.base===x.base&&Z.pattern===x.pattern:!1)}e.$Lj=Y}),define(Se[80],ke([1,0,8,163,23,13,2]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,D.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=m(this.supportThemeIcons?(0,O.$8j)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,P.$Ke)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$bk=$;function y(d){return R(d)?!d.value:Array.isArray(d)?d.every(y):!0}e.$ck=y;function R(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.$dk=R;function C(d,s){return d===s?!0:!d||!s?!1:d.value===s.value&&d.isTrusted===s.isTrusted&&d.supportThemeIcons===s.supportThemeIcons&&d.supportHtml===s.supportHtml&&(d.baseUri===s.baseUri||!!d.baseUri&&!!s.baseUri&&(0,g.$vg)(M.URI.from(d.baseUri),M.URI.from(s.baseUri)))}e.$ek=C;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$fk=m;function v(d){return d.replace(/"/g,"&quot;")}e.$gk=v;function k(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$hk=k;function f(d){const s=[],i=d.split("|").map(o=>o.trim());d=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",h=isFinite(parseInt(r)),u=isFinite(parseInt(t));h&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:d,dimensions:s}}e.$ik=f}),define(Se[102],ke([1,0,19,33,16,11,23,13]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=void 0;function $(u,c){const{os:l,tildify:S,relative:L}=c;if(L){const E=y(u,L,l);if(typeof E=="string")return E}let w=u.fsPath;if(l===1&&!P.$i?w=w.replace(/\//g,"\\"):l!==1&&P.$i&&(w=w.replace(/\\/g,"/")),l!==1&&S?.userHome){const E=S.userHome.fsPath;let A;u.scheme!==S.userHome.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep?A=S.userHome.with({path:u.path}).fsPath:A=w,w=m(A,E,l)}return(l===1?g.$fc:g.$gc).normalize(R(w,l===1))}e.$Ev=$;function y(u,c,l){const S=l===1?g.$fc:g.$gc,L=l===3?M.$sg:M.$ug,w=c.getWorkspace(),p=(0,D.$Ob)(w.folders);if(!p)return;u.scheme!==p.uri.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep&&(u=p.uri.with({path:u.path}));const E=c.getWorkspaceFolder(u);if(!E)return;let A;if(L.isEqual(E.uri,u)?A="":A=L.relativePath(E.uri,u)??"",A&&(A=S.normalize(A)),w.folders.length>1&&!c.noPrefix){const z=E.name?E.name:L.basenameOrAuthority(E.uri);A=A?`${z} \u2022 ${A}`:z}return A}function R(u,c=P.$i){return(0,O.$7f)(u,c)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$Fv=R;let C=Object.create(null);function m(u,c,l=P.OS){if(l===1||!u||!c)return u;let S=C.original===c?C.normalized:void 0;S||(S=c,P.$i&&(S=(0,O.$Wf)(S)),S=`${(0,b.$Pe)(S,g.$gc.sep)}${g.$gc.sep}`,C={original:c,normalized:S});let L=u;return P.$i&&(L=(0,O.$Wf)(L)),(l===3?L.startsWith(S):(0,b.$8e)(L,S))?`~/${L.substr(S.length)}`:u}e.$Gv=m;function v(u,c){return u.replace(/^~($|\/|\\)/,`${c}$1`)}e.$Hv=v;const k="\u2026",f="\\\\",d="~";function s(u,c=g.sep){const l=new Array(u.length);let S=!1;for(let L=0;L<u.length;L++){const w=u[L];if(w===""){l[L]=`.${c}`;continue}if(!w){l[L]=w;continue}S=!0;let p="",E=w;E.indexOf(f)===0?(p=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length)):E.indexOf(c)===0?(p=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(d)===0&&(p=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const A=E.split(c);for(let z=1;S&&z<=A.length;z++)for(let N=A.length-z;S&&N>=0;N--){S=!1;let I=A.slice(N,N+z).join(c);for(let j=0;!S&&j<u.length;j++)if(j!==L&&u[j]&&u[j].indexOf(I)>-1){const T=N+z===A.length,F=N>0&&u[j].indexOf(c)>-1?c+I:I,W=u[j].endsWith(F);S=!T||W}if(!S){let j="";(A[0].endsWith(":")||p!=="")&&(N===1&&(N=0,z++,I=A[0]+c+I),N>0&&(j=A[0]+c),j=p+j),N>0&&(j=j+k+c),j=j+I,N+z<A.length&&(j=j+c+k),l[L]=j}}S&&(l[L]=w)}return l}e.$Iv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,c=Object.create(null)){const l=[];let S=!1,L="";for(const w of u)if(w==="$"||S&&w==="{")L&&l.push({value:L,type:i.TEXT}),L="",S=!0;else if(w==="}"&&S){const p=c[L];if(typeof p=="string")p.length&&l.push({value:p,type:i.VARIABLE});else if(p){const E=l[l.length-1];(!E||E.type!==i.SEPARATOR)&&l.push({value:p.label,type:i.SEPARATOR})}L="",S=!1}else L+=w;return L&&!S&&l.push({value:L,type:i.TEXT}),l.filter((w,p)=>{if(w.type===i.SEPARATOR){const E=l[p-1],A=l[p+1];return[E,A].every(z=>z&&(z.type===i.VARIABLE||z.type===i.TEXT)&&z.value.length>0)}return!0}).map(w=>w.value).join("")}e.$Jv=n;function o(u,c){return P.$j||c?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):u.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$Kv=o;function a(u,c){return P.$j||c?u.replace(/\(&&\w\)|&&/g,""):P.$i?u.replace(/&&|&/g,l=>l==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Lv=a;function t(u){return u.replace(/&/g,"&&")}e.$Mv=t;function r(u){if(u.endsWith("]")){const c=u.lastIndexOf(" [",u.length-2);if(c!==-1){const l=h(u.substring(0,c));return{name:l.name,parentPath:l.parentPath+u.substring(c)}}}return h(u)}e.$Nv=r;function h(u){const c=u.indexOf("/")!==-1?g.$gc:g.$fc,l=c.basename(u),S=c.dirname(u);return l.length?{name:l,parentPath:S}:{name:S,parentPath:""}}}),define(Se[130],ke([1,0,22,2]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=void 0;function g(C){return C.toJSON()}class P{constructor(m){this.a=m}transformIncoming(m){const v=this.a.transformIncoming(m);return v===m?m:g(O.URI.from(v))}transformOutgoing(m){const v=this.a.transformOutgoing(m);return v===m?m:g(O.URI.from(v))}transformOutgoingURI(m){const v=this.a.transformOutgoing(m);return v===m?m:O.URI.from(v)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$Wm=P,e.$Xm=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function M(C,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return m.transformOutgoing(C);for(const k in C)if(Object.hasOwnProperty.call(C,k)){const f=M(C[k],m,v+1);f!==null&&(C[k]=f)}}return null}function b(C,m){const v=M(C,m,0);return v===null?C:v}e.$Ym=b;function $(C,m,v,k){if(!C||k>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?O.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$ge)return null;for(const f in C)if(Object.hasOwnProperty.call(C,f)){const d=$(C[f],m,v,k+1);d!==null&&(C[f]=d)}}return null}function y(C,m){const v=$(C,m,!1,0);return v===null?C:v}e.$Zm=y;function R(C,m){const v=$(C,m,!0,0);return v===null?C:v}e.$1m=R}),define(Se[31],ke([1,0,55,63,384,12,33,76,16,11,23,2]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function v(F,W=m.UNLINK,Y){if((0,M.$6f)(F))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?f(F):k(F,Y)}async function k(F,W=(0,M.$$f)((0,O.tmpdir)())){try{try{await D.promises.rename(F,W)}catch(Y){return Y.code==="ENOENT"?void 0:f(F)}f(W).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function f(F){return(0,g.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function d(F){if((0,M.$6f)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function s(F,W){return o(await(W?i(F):(0,g.promisify)(D.readdir)(F)))}async function i(F){try{return await(0,g.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const W=[],Y=await s(F);for(const le of Y){let Q=!1,Z=!1,x=!1;try{const oe=await e.Promises.lstat((0,$.$jc)(F,le));Q=oe.isFile(),Z=oe.isDirectory(),x=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}W.push({name:le,isFile:()=>Q,isDirectory:()=>Z,isSymbolicLink:()=>x})}return W}function n(F){return o(D.readdirSync(F))}e.readdirSync=n;function o(F){return F.map(W=>typeof W=="string"?y.$j?(0,b.$zl)(W):W:(W.name=y.$j?(0,b.$zl)(W.name):W.name,W))}async function a(F){const W=await s(F),Y=[];for(const le of W)await r.existsDirectory((0,$.$jc)(F,le))&&Y.push(le);return Y}function t(F,W=1e3){return new Promise(Y=>{let le=!1;const Q=setInterval(()=>{le||(le=!0,D.access(F,Z=>{le=!1,Z&&(clearInterval(Q),Y(void 0))}))},W)})}e.whenDeleted=t;var r;(function(F){async function W(Q){let Z;try{if(Z=await e.Promises.lstat(Q),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(y.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw oe}throw x}}F.stat=W;async function Y(Q){try{const{stat:Z,symbolicLink:x}=await F.stat(Q);return Z.isFile()&&x?.dangling!==!0}catch{}return!1}F.existsFile=Y;async function le(Q){try{const{stat:Z,symbolicLink:x}=await F.stat(Q);return Z.isDirectory()&&x?.dangling!==!0}catch{}return!1}F.existsDirectory=le})(r||(e.SymlinkSupport=r={}));const h=new P.$0g;function u(F,W,Y){return h.queueFor(C.URI.file(F),R.$tg).queue(()=>{const le=w(Y);return new Promise((Q,Z)=>S(F,W,le,x=>x?Z(x):Q()))})}let c=!0;function l(F){c=F}e.configureFlushOnWrite=l;function S(F,W,Y,le){if(!c)return D.writeFile(F,W,{mode:Y.mode,flag:Y.flag},le);D.open(F,Y.flag,Y.mode,(Q,Z)=>{if(Q)return le(Q);D.writeFile(Z,W,x=>{if(x)return D.close(Z,()=>le(x));D.fdatasync(Z,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),l(!1)),D.close(Z,X=>le(X))))})})}function L(F,W,Y){const le=w(Y);if(!c)return D.writeFileSync(F,W,{mode:le.mode,flag:le.flag});const Q=D.openSync(F,le.flag,le.mode);try{D.writeFileSync(Q,W);try{D.fdatasyncSync(Q)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),l(!1)}}finally{D.closeSync(Q)}}e.writeFileSync=L;function w(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function p(F,W,Y=6e4){if(F!==W)try{y.$i&&typeof Y=="number"?await E(F,W,Date.now(),Y):await(0,g.promisify)(D.rename)(F,W)}catch(le){if(F.toLowerCase()!==W.toLowerCase()&&le.code==="EXDEV"||F.endsWith("."))await A(F,W,{preserveSymlinks:!1}),await v(F,m.MOVE);else throw le}}async function E(F,W,Y,le,Q=0){try{return await(0,g.promisify)(D.rename)(F,W)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-Y>=le)throw console.error(`[node.js fs] rename failed after ${Q} retries with error: ${Z}`),Z;if(Q===0){let x=!1;try{const{stat:oe}=await r.stat(W);oe.isFile()||(x=!0)}catch{}if(x)throw Z}return await(0,P.$2g)(Math.min(100,Q*10)),E(F,W,Y,le,Q+1)}}async function A(F,W,Y){return N(F,W,{root:{source:F,target:W},options:Y,handledSourcePaths:new Set})}const z=511;async function N(F,W,Y){if(Y.handledSourcePaths.has(F))return;Y.handledSourcePaths.add(F);const{stat:le,symbolicLink:Q}=await r.stat(F);if(Q){if(Y.options.preserveSymlinks)try{return await T(F,W,Y)}catch{}if(Q.dangling)return}return le.isDirectory()?I(F,W,le.mode&z,Y):j(F,W,le.mode&z)}async function I(F,W,Y,le){await e.Promises.mkdir(W,{recursive:!0,mode:Y});const Q=await s(F);for(const Z of Q)await N((0,$.$jc)(F,Z),(0,$.$jc)(W,Z),le)}async function j(F,W,Y){await e.Promises.copyFile(F,W),await e.Promises.chmod(W,Y)}async function T(F,W,Y){let le=await e.Promises.readlink(F);(0,M.$3f)(le,Y.root.source,!y.$k)&&(le=(0,$.$jc)(Y.root.target,le.substr(Y.root.source.length+1))),await e.Promises.symlink(le,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(F,W,Y,le,Q)=>new Promise((Z,x)=>{D.read(F,W,Y,le,Q,(oe,X,ve)=>oe?x(oe):Z({bytesRead:X,buffer:ve}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(F,W,Y,le,Q)=>new Promise((Z,x)=>{D.write(F,W,Y,le,Q,(oe,X,ve)=>oe?x(oe):Z({bytesWritten:X,buffer:ve}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return v}get rename(){return p}get copy(){return A}}}),define(Se[103],ke([1,0,55,16,11,13,31]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=void 0;function b(m){if(g.$k)return m;const v=(0,O.$mc)(m);if(m===v)return m;const k=((0,O.$nc)(m)||m).toLowerCase();try{const d=(0,M.readdirSync)(v).filter(s=>s.toLowerCase()===k);if(d.length===1){const s=b(v);if(s)return(0,O.$jc)(s,d[0])}else if(d.length>1){const s=d.indexOf(k);if(s>=0){const i=b(v);if(i)return(0,O.$jc)(i,d[s])}}}catch{}return null}e.$dq=b;async function $(m){if(g.$k)return m;const v=(0,O.$mc)(m);if(m===v)return m;const k=((0,O.$nc)(m)||m).toLowerCase();try{const d=(await M.Promises.readdir(v)).filter(s=>s.toLowerCase()===k);if(d.length===1){const s=await $(v);if(s)return(0,O.$jc)(s,d[0])}else if(d.length>1){const s=d.indexOf(k);if(s>=0){const i=await $(v);if(i)return(0,O.$jc)(i,d[s])}}}catch{}return null}e.$eq=$;async function y(m){try{return await M.Promises.realpath(m)}catch{const k=C(m);return await M.Promises.access(k,D.constants.R_OK),k}}e.$fq=y;function R(m){try{return D.realpathSync(m)}catch{const k=C(m);return D.accessSync(k,D.constants.R_OK),k}}e.$gq=R;function C(m){return(0,P.$Pe)((0,O.$hc)(m),O.sep)}}),define(Se[104],ke([1,0,16,11,50,101,18,31]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Nl=e.$Ml=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Ml=$;function y(C){let m=[],v=!1;const k=function(f){if(v){m.push(f);return}(!C.send(f,s=>{if(s&&console.error(s),v=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>k(n))}})||O.$i)&&(v=!0)};return{send:k}}e.$Nl=y;var R;(function(C){async function m(v,k,f){if(D.$ic(v))return v;if(k===void 0&&(k=g.cwd()),D.$mc(v)!=="."||(f===void 0&&M.$Df(g.env.PATH)&&(f=g.env.PATH.split(D.$tc)),f===void 0||f.length===0))return D.$jc(k,v);async function s(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of f){let n;if(D.$ic(i)?n=D.$jc(i,v):n=D.$jc(k,i,v),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.$jc(k,v)}C.findExecutable=m})(R||(e.win32=R={}))});var Ge=this&&this.__decorate||function($e,e,D,O){var g=arguments.length,P=g<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate($e,e,D,O);else for(var b=$e.length-1;b>=0;b--)(M=$e[b])&&(P=(g<3?M(P):g>3?M(e,D,P):M(e,D))||P);return g>3&&P&&Object.defineProperty(e,D,P),P};define(Se[81],ke([1,0,19,12,22,21,59,8,4,3,54,13,18]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.ProxyChannel=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.RequestInitiator=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0;var v;(function(Q){Q[Q.Promise=100]="Promise",Q[Q.PromiseCancel=101]="PromiseCancel",Q[Q.EventListen=102]="EventListen",Q[Q.EventDispose=103]="EventDispose"})(v||(v={}));function k(Q){switch(Q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(Q){Q[Q.Initialize=200]="Initialize",Q[Q.PromiseSuccess=201]="PromiseSuccess",Q[Q.PromiseError=202]="PromiseError",Q[Q.PromiseErrorObj=203]="PromiseErrorObj",Q[Q.EventFire=204]="EventFire"})(f||(f={}));function d(Q){switch(Q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(Q){Q[Q.Uninitialized=0]="Uninitialized",Q[Q.Idle=1]="Idle"})(s||(s={}));function i(Q){let Z=0;for(let x=0;;x+=7){const oe=Q.read(1);if(Z|=(oe.buffer[0]&127)<<x,!(oe.buffer[0]&128))return Z}}const n=h(0);function o(Q,Z){if(Z===0){Q.write(n);return}let x=0;for(let X=Z;X!==0;X=X>>>7)x++;const oe=g.$ge.alloc(x);for(let X=0;Z!==0;X++)oe.buffer[X]=Z&127,Z=Z>>>7,Z>0&&(oe.buffer[X]|=128);Q.write(oe)}class a{constructor(Z){this.b=Z,this.a=0}read(Z){const x=this.b.slice(this.a,this.a+Z);return this.a+=x.byteLength,x}}e.$yh=a;class t{constructor(){this.a=[]}get buffer(){return g.$ge.concat(this.a)}write(Z){this.a.push(Z)}}e.$zh=t;var r;(function(Q){Q[Q.Undefined=0]="Undefined",Q[Q.String=1]="String",Q[Q.Buffer=2]="Buffer",Q[Q.VSBuffer=3]="VSBuffer",Q[Q.Array=4]="Array",Q[Q.Object=5]="Object",Q[Q.Int=6]="Int"})(r||(r={}));function h(Q){const Z=g.$ge.alloc(1);return Z.writeUInt8(Q,0),Z}const u={Undefined:h(r.Undefined),String:h(r.String),Buffer:h(r.Buffer),VSBuffer:h(r.VSBuffer),Array:h(r.Array),Object:h(r.Object),Uint:h(r.Int)},c=typeof Buffer<"u";function l(Q,Z){if(typeof Z>"u")Q.write(u.Undefined);else if(typeof Z=="string"){const x=g.$ge.fromString(Z);Q.write(u.String),o(Q,x.byteLength),Q.write(x)}else if(c&&Buffer.isBuffer(Z)){const x=g.$ge.wrap(Z);Q.write(u.Buffer),o(Q,x.byteLength),Q.write(x)}else if(Z instanceof g.$ge)Q.write(u.VSBuffer),o(Q,Z.byteLength),Q.write(Z);else if(Array.isArray(Z)){Q.write(u.Array),o(Q,Z.length);for(const x of Z)l(Q,x)}else if(typeof Z=="number"&&(Z|0)===Z)Q.write(u.Uint),o(Q,Z);else{const x=g.$ge.fromString(JSON.stringify(Z));Q.write(u.Object),o(Q,x.byteLength),Q.write(x)}}e.$Ah=l;function S(Q){switch(Q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return Q.read(i(Q)).toString();case r.Buffer:return Q.read(i(Q)).buffer;case r.VSBuffer:return Q.read(i(Q));case r.Array:{const x=i(Q),oe=[];for(let X=0;X<x;X++)oe.push(S(Q));return oe}case r.Object:return JSON.parse(Q.read(i(Q)).toString());case r.Int:return i(Q)}}e.$Bh=S;class L{constructor(Z,x,oe=null,X=1e3){this.h=Z,this.j=x,this.k=oe,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ve=>this.q(ve)),this.m({type:200})}registerChannel(Z,x){this.b.set(Z,x),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const x=this.o([Z.type]);this.k?.logOutgoing(x,0,1,d(Z.type));return}case 201:case 202:case 204:case 203:{const x=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(x,Z.id,1,d(Z.type),Z.data);return}}}o(Z,x=void 0){const oe=new t;return l(oe,Z),l(oe,x),this.p(oe.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const x=new a(Z),oe=S(x),X=S(x),ve=oe[0];switch(ve){case 100:return this.k?.logIncoming(Z.byteLength,oe[1],1,`${k(ve)}: ${oe[2]}.${oe[3]}`,X),this.s({type:ve,id:oe[1],channelName:oe[2],name:oe[3],arg:X});case 102:return this.k?.logIncoming(Z.byteLength,oe[1],1,`${k(ve)}: ${oe[2]}.${oe[3]}`,X),this.t({type:ve,id:oe[1],channelName:oe[2],name:oe[3],arg:X});case 101:return this.k?.logIncoming(Z.byteLength,oe[1],1,`${k(ve)}`),this.u({type:ve,id:oe[1]});case 103:return this.k?.logIncoming(Z.byteLength,oe[1],1,`${k(ve)}`),this.u({type:ve,id:oe[1]})}}s(Z){const x=this.b.get(Z.channelName);if(!x){this.v(Z);return}const oe=new P.$3d;let X;try{X=x.call(this.j,Z.name,Z.arg,oe.token)}catch(H){X=Promise.reject(H)}const ve=Z.id;X.then(H=>{this.m({id:ve,data:H,type:201})},H=>{H instanceof Error?this.m({id:ve,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ve,data:H,type:203})}).finally(()=>{ge.dispose(),this.d.delete(Z.id)});const ge=(0,y.$Qc)(()=>oe.cancel());this.d.set(Z.id,ge)}t(Z){const x=this.b.get(Z.channelName);if(!x){this.v(Z);return}const oe=Z.id,ve=x.listen(this.j,Z.name,Z.arg)(ge=>this.m({id:oe,data:ge,type:204}));this.d.set(Z.id,ve)}u(Z){const x=this.d.get(Z.id);x&&(x.dispose(),this.d.delete(Z.id))}v(Z){let x=this.g.get(Z.channelName);x||(x=[],this.g.set(Z.channelName,x));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:Z,timeoutTimer:oe})}w(Z){const x=this.g.get(Z);if(x){for(const oe of x)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Ch=L;var w;(function(Q){Q[Q.LocalSide=0]="LocalSide",Q[Q.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class p{constructor(Z,x=null){this.l=Z,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=x}getChannel(Z){const x=this;return{call(oe,X,ve){return x.a?Promise.reject(new b.$5):x.m(Z,oe,X,ve)},listen(oe,X){return x.a?$.Event.None:x.o(Z,oe,X)}}}m(Z,x,oe,X=P.CancellationToken.None){const ve=this.g++,H={id:ve,type:100,channelName:Z,name:x,arg:oe};if(X.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((ye,fe)=>{if(X.isCancellationRequested)return fe(new b.$5);const me=()=>{const te=J=>{switch(J.type){case 201:this.f.delete(ve),ye(J.data);break;case 202:{this.f.delete(ve);const ce=new Error(J.data.message);ce.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ce.name=J.data.name,fe(ce);break}case 203:this.f.delete(ve),fe(J.data);break}};this.f.set(ve,te),this.p(H)};let ee=null;this.b===s.Idle?me():(ee=(0,O.$Og)(te=>this.u()),ee.then(()=>{ee=null,me()}));const ie=()=>{ee?(ee.cancel(),ee=null):this.p({id:ve,type:101}),fe(new b.$5)},G=X.onCancellationRequested(ie);U=(0,y.$Pc)((0,y.$Qc)(ie),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Z,x,oe){const X=this.g++,ge={id:X,type:102,channelName:Z,name:x,arg:oe};let H=null;const U=new $.$Sd({onWillAddFirstListener:()=>{H=(0,O.$Og)(ye=>this.u()),H.then(()=>{H=null,this.d.add(U),this.p(ge)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(U),this.p({id:X,type:103}))}}),ne=ye=>U.fire(ye.data);return this.f.set(X,ne),U.event}p(Z){switch(Z.type){case 100:case 102:{const x=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(x,Z.id,0,`${k(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const x=this.q([Z.type,Z.id]);this.j?.logOutgoing(x,Z.id,0,k(Z.type));return}}}q(Z,x=void 0){const oe=new t;return l(oe,Z),l(oe,x),this.r(oe.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const x=new a(Z),oe=S(x),X=S(x),ve=oe[0];switch(ve){case 200:return this.j?.logIncoming(Z.byteLength,0,0,d(ve)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,oe[1],0,d(ve),X),this.t({type:oe[0],id:oe[1],data:X})}}t(Z){if(Z.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=p,Ge([M.$sh],p.prototype,"onDidInitializePromise",null);class E{get connections(){const Z=[];return this.f.forEach(x=>Z.push(x)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new $.$Sd,this.onDidAddConnection=this.g.event,this.h=new $.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Rc,this.j.add(Z(({protocol:x,onDidClientDisconnect:oe})=>{const X=$.Event.once(x.onMessage);this.j.add(X(ve=>{const ge=new a(ve),H=S(ge),U=new L(x,H),ne=new p(x);this.a.forEach((fe,me)=>U.registerChannel(me,fe));const ye={channelServer:U,channelClient:ne,ctx:H};this.f.add(ye),this.g.fire(ye),this.j.add(oe(()=>{U.dispose(),ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Z,x){const oe=this;return{call(X,ve,ge){let H;if((0,m.$Rf)(x)){const ne=(0,D.$4b)(oe.connections.filter(x));H=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(oe.onDidAddConnection,x))}else H=x.routeCall(oe,X,ve);const U=H.then(ne=>ne.channelClient.getChannel(Z));return z(U).call(X,ve,ge)},listen(X,ve){if((0,m.$Rf)(x))return oe.k(Z,x,X,ve);const ge=x.routeEvent(oe,X,ve).then(H=>H.channelClient.getChannel(Z));return z(ge).listen(X,ve)}}}k(Z,x,oe,X){const ve=this;let ge;const H=new $.$Sd({onWillAddFirstListener:()=>{ge=new y.$Rc;const U=new $.$Yd,ne=new Map,ye=me=>{const ie=me.channelClient.getChannel(Z).listen(oe,X),G=U.add(ie);ne.set(me,G)},fe=me=>{const ee=ne.get(me);ee&&(ee.dispose(),ne.delete(me))};ve.connections.filter(x).forEach(ye),$.Event.filter(ve.onDidAddConnection,x)(ye,void 0,ge),ve.onDidRemoveConnection(fe,void 0,ge),U.event(H.fire,H,ge),ge.add(U)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return H.event}registerChannel(Z,x){this.a.set(Z,x);for(const oe of this.f)oe.channelServer.registerChannel(Z,x)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Eh=E;class A{constructor(Z,x,oe=null){const X=new t;l(X,x),Z.send(X.buffer),this.a=new p(Z,oe),this.d=new L(Z,x,oe)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,x){this.d.registerChannel(Z,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Fh=A;function z(Q){return{call(Z,x,oe){return Q.then(X=>X.call(Z,x,oe))},listen(Z,x){const oe=new $.$2d;return Q.then(X=>oe.input=X.listen(Z,x)),oe.event}}}e.$Gh=z;function N(Q){let Z=!1;return{call(x,oe,X){return Z?Q.call(x,oe,X):(0,O.$2g)(0).then(()=>Z=!0).then(()=>Q.call(x,oe,X))},listen(x,oe){if(Z)return Q.listen(x,oe);const X=new $.$2d;return(0,O.$2g)(0).then(()=>Z=!0).then(()=>X.input=Q.listen(x,oe)),X.event}}}e.$Hh=N;class I{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const x of Z.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$Ih=I;var j;(function(Q){function Z(ve,ge,H){const U=ve,ne=H&&H.disableMarshalling,ye=new Map;for(const fe in U)oe(fe)&&ye.set(fe,$.Event.buffer(U[fe],!0,void 0,ge));return new class{listen(fe,me,ee){const ie=ye.get(me);if(ie)return ie;if(X(me)){const G=U[me];if(typeof G=="function")return G.call(U,ee)}throw new b.$bb(`Event not found: ${me}`)}call(fe,me,ee){const ie=U[me];if(typeof ie=="function"){if(!ne&&Array.isArray(ee))for(let te=0;te<ee.length;te++)ee[te]=(0,R.$xh)(ee[te]);let G=ie.apply(U,ee);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$bb(`Method not found: ${me}`)}}}Q.fromService=Z;function x(ve,ge){const H=ge&&ge.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return ge?.properties?.has(ne)?ge.properties.get(ne):X(ne)?function(ye){return ve.listen(ne,ye)}:oe(ne)?ve.listen(ne):async function(...ye){let fe;ge&&!(0,m.$Mf)(ge.context)?fe=[ge.context,...ye]:fe=ye;const me=await ve.call(ne,fe);return H?me:(0,R.$xh)(me)};throw new b.$bb(`Property not found: ${String(ne)}`)}})}Q.toService=x;function oe(ve){return ve[0]==="o"&&ve[1]==="n"&&C.$6e(ve.charCodeAt(2))}function X(ve){return/^onDynamic/.test(ve)&&C.$6e(ve.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const T=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(Q){if(Array.isArray(Q))return Q;if(Q&&typeof Q=="object"&&typeof Q.toString=="function"){const Z=Q.toString();if(Z!=="[object Object]")return Z}return Q}function W(Q){return Array.isArray(Q)?Q.map(F):F(Q)}function Y(Q,Z,x,oe,X,ve,ge){ge=W(ge);const H=T[X],U=H[oe%H.length];let ne=[`%c[${Q}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ve}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ve)?(ne=ne.concat(ge),ne.push(")")):ne.push(ge),console.log.apply(console,ne)}class le{constructor(Z,x){this.d=Z,this.f=x,this.a=0,this.b=0}logOutgoing(Z,x,oe,X,ve){this.b+=Z,Y(this.d,this.b,Z,x,oe,X,ve)}logIncoming(Z,x,oe,X,ve){this.a+=Z,Y(this.f,this.a,Z,x,oe,X,ve)}}e.$Jh=le}),define(Se[82],ke([1,0,22,4,3,81]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.ProtocolConstants=e.$Kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(u){u.enableDiagnostics=!1,u.records=[];const c=new WeakMap;let l=0;function S(w,p){if(!c.has(w)){const E=String(++l);c.set(w,E)}return c.get(w)}function L(w,p,E,A){if(!u.enableDiagnostics)return;const z=S(w,p);if(A instanceof D.$ge||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const N=D.$ge.alloc(A.byteLength);N.set(A),u.records.push({timestamp:Date.now(),id:z,label:p,type:E,buff:N})}else u.records.push({timestamp:Date.now(),id:z,label:p,type:E,data:A})}u.traceSocketEvent=L})(b||(e.SocketDiagnostics=b={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function R(){return y||(y=D.$ge.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,l){if(c===0)return R();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const p=this.a[0];return l&&(this.a.shift(),this.b-=c),p}if(this.a[0].byteLength>c){const p=this.a[0].slice(0,c);return l&&(this.a[0]=this.a[0].slice(c),this.b-=c),p}const S=D.$ge.alloc(c);let L=0,w=0;for(;c>0;){const p=this.a[w];if(p.byteLength>c){const E=p.slice(0,c);S.set(E,L),L+=c,l&&(this.a[w]=p.slice(c),this.b-=c),c-=c}else S.set(p,L),L+=p.byteLength,l?(this.a.shift(),this.b-=p.byteLength):w++,c-=p.byteLength}return S}}e.$Kh=C;var m;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class f{constructor(c,l,S,L){this.type=c,this.id=l,this.ack=S,this.data=L,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends g.$Sc{constructor(c){super(),this.f=this.B(new O.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new C,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,L=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new f(S,L,w,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.$ge.alloc(13);l.writeUInt8(c.type,0),l.writeUInt32BE(c.id,1),l.writeUInt32BE(c.ack,5),l.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(l,c.data)}g(c,l){const S=this.f===0;return this.d.push(c,l),this.f+=c.byteLength+l.byteLength,S}h(){const c=D.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,l){this.g(c,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends g.$Sc{constructor(c){super(),this.f=new O.$Sd,this.onMessage=this.f.event,this.g=new O.$Sd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new s(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new f(1,0,0,c))}}e.$Lh=i;class n extends P.$Fh{static fromSocket(c,l){return new n(new i(c),l)}get onDidDispose(){return this.b.onDidDispose}constructor(c,l,S=null){super(c,l,S),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$Mh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Nh=o;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,l=this.a;for(;l;)l=l.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let l=0,S=this.a;for(;S;)c[l++]=S.data,S=S.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const l=new a(c);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let l=0;l<r.a;l++)this.c[l]=c-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),l=(1+r.a)*1e3;let S=0;for(let L=0;L<r.a;L++)c-this.c[L]<=l&&S++;return 1-S/r.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Rc,this.o=c.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new f(5,0,0,R());this.p.write(c),this.p.flush()}sendPause(){const c=new f(7,0,0,R());this.p.write(c)}sendResume(){const c=new f(8,0,0,R());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,l){this.a=!0,this.r.dispose(),this.r=new g.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new f(3,0,this.h,R());this.p.write(c);const l=this.b.toArray();for(let S=0,L=l.length;S<L;S++)this.p.write(l[S]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const l=this.b.peek();if(l&&l.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new f(6,0,0,R())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let S=0,L=l.length;S<L;S++)this.p.write(l[S]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const l=++this.c;this.h=this.g;const S=new f(1,l,this.h,c);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(c){const l=new f(2,0,0,c);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),l=Date.now()-c.writtenTime,S=Date.now()-this.q.lastReadTime,L=Date.now()-this.n;if(l>=2e4&&S>=2e4&&L>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:S});return}const w=Math.max(2e4-l,2e4-S,2e4-L,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new f(3,0,this.h,R());this.p.write(c)}D(){this.h=this.g;const c=new f(9,0,this.h,R());this.p.write(c)}}e.$Oh=h}),define(Se[186],ke([1,0,51,12,22,21,184,8,4,3,24,104,101,81]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class k extends v.$Ch{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$ge.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$aq=k;class f{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Sd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new O.$Xg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const a=this.n(s),t=(0,O.$Og)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),h=(0,y.$Qc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{r.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const a=new $.$Sd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$fn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,m.$Ll)(i.env),this.d=(0,D.fork)(this.i,s,i);const n=new $.$Sd;$.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,M.$9p)(c)){(0,M.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$ge.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,C.$Nl)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),r=n.event,h={send:t,onMessage:r};this.f=new v.$Dh(h);const u=()=>this.o();process.once("exit",u),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,l)=>{process.removeListener("exit",u),this.c.forEach(S=>(0,y.$Nc)(S)),this.c.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:l})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$bq=f}),define(Se[187],ke([1,0,12,4,3,54,18]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.StorageState=e.$_o=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$_o=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class R extends g.$Sc{static{this.a=100}constructor(v,k=Object.create(null)){super(),this.r=v,this.s=k,this.b=this.B(new O.$Vd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$Yg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((k,f)=>this.w(f,k)),v.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(v,k){if(this.c===y.Closed)return;let f=!1;(0,M.$Mf)(k)?f=this.f.delete(v):this.f.get(v)!==k&&(this.f.set(v,k),f=!0),f&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,k){const f=this.f.get(v);return(0,M.$Mf)(f)?k:f}getBoolean(v,k){const f=this.get(v);return(0,M.$Mf)(f)?k:f==="true"}getNumber(v,k){const f=this.get(v);return(0,M.$Mf)(f)?k:parseInt(f,10)}getObject(v,k){const f=this.get(v);return(0,M.$Mf)(f)?k:(0,P.$wh)(f)}async set(v,k,f=!1){if(this.c===y.Closed)return;if((0,M.$Mf)(k))return this.delete(v,f);const d=(0,M.$Ff)(k)||Array.isArray(k)?(0,P.$vh)(k):String(k);if(this.f.get(v)!==d)return this.f.set(v,d),this.j.set(v,d),this.h.delete(v),this.b.fire({key:v,external:f}),this.D()}async delete(v,k=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:k}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$ap=R;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((k,f)=>this.a.set(f,k)),v.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$bp=C}),define(Se[188],ke([1,0,13,11,22]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.$Ws=void 0;let P;function M(){return P||(P=new TextDecoder("UTF-16LE")),P}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function R(){return y||(y=O.$D()?M():$()),y}e.$Ws=R;function C(k,f,d){const s=new Uint16Array(k.buffer,f,d);return d>0&&(s[0]===65279||s[0]===65534)?m(k,f,d):M().decode(s)}e.$Xs=C;function m(k,f,d){const s=[];let i=0;for(let n=0;n<d;n++){const o=g.$ie(k,f);f+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class v{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return R().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const d=this.a-this.d;d<=1&&(d===0||D.$$e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const d=f.length;if(this.d+d>=this.a){this.f(),this.c[this.c.length]=f;return}for(let s=0;s<d;s++)this.b[this.d++]=f.charCodeAt(s)}}e.$Ys=v}),define(Se[189],ke([1,0,22,188]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,C,m){this.oldPosition=y,this.oldText=R,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,R,C){const m=R.length;D.$le(y,m,C),C+=4;for(let v=0;v<m;v++)D.$je(y,R.charCodeAt(v),C),C+=2;return C}static d(y,R){const C=D.$ke(y,R);return R+=4,(0,O.$Xs)(y,R,C)}writeSize(){return 4+4+P.a(this.oldText)+P.a(this.newText)}write(y,R){return D.$le(y,this.oldPosition,R),R+=4,D.$le(y,this.newPosition,R),R+=4,R=P.c(y,this.oldText,R),R=P.c(y,this.newText,R),R}static read(y,R,C){const m=D.$ke(y,R);R+=4;const v=D.$ke(y,R);R+=4;const k=P.d(y,R);R+=P.a(k);const f=P.d(y,R);return R+=P.a(f),C.push(new P(m,k,v,f)),R}}e.$Zs=P;function M($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$1s=M;class b{constructor(y,R){this.a=y,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,R=0,C=this.n(y),m=this.l(R);for(;y<this.f||R<this.h;){if(C===null){this.k(m),m=this.l(++R);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++R);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[s,i]=b.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=b.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let f,d;if(m.oldEnd===C.newEnd)f=C,d=m,C=this.n(++y),m=this.l(++R);else if(m.oldEnd<C.newEnd){const[s,i]=b.q(C,m.oldLength);f=s,d=m,C=i,m=this.l(++R)}else{const[s,i]=b.r(m,C.newLength);f=C,d=s,C=this.n(++y),m=i}this.d[this.e++]=new P(f.oldPosition,f.oldText,d.newPosition,d.newText),this.g+=f.newLength-f.oldLength,this.j+=d.newLength-d.oldLength}const v=b.s(this.d);return b.t(v)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,R){return new P(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static p(y,R){return new P(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static q(y,R){const C=y.newText.substr(0,R),m=y.newText.substr(R);return[new P(y.oldPosition,y.oldText,y.newPosition,C),new P(y.oldEnd,"",y.newPosition+R,m)]}static r(y,R){const C=y.oldText.substr(0,R),m=y.oldText.substr(R);return[new P(y.oldPosition,C,y.newPosition,y.newText),new P(y.oldPosition+R,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const R=[];let C=0,m=y[0];for(let v=1;v<y.length;v++){const k=y[v];m.oldEnd===k.oldPosition?m=new P(m.oldPosition,m.oldText+k.oldText,m.newPosition,m.newText+k.newText):(R[C++]=m,m=k)}return R[C++]=m,R}static t(y){if(y.length===0)return y;const R=[];let C=0;for(let m=0;m<y.length;m++){const v=y[m];v.oldText!==v.newText&&(R[C++]=v)}return R}}}),define(Se[190],ke([1,0,34,16]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0;function g(P,M,b,$,y,R){if(Array.isArray(P)){let C=0;for(const m of P){const v=g(m,M,b,$,y,R);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof P=="string")return $?P==="*"?5:P===b?10:0:0;if(P){const{language:C,pattern:m,scheme:v,hasAccessToAllModels:k,notebookType:f}=P;if(!$&&!k)return 0;f&&y&&(M=y);let d=0;if(v)if(v===M.scheme)d=10;else if(v==="*")d=5;else return 0;if(C)if(C===b)d=10;else if(C==="*")d=Math.max(d,5);else return 0;if(f)if(f===R)d=10;else if(f==="*"&&R!==void 0)d=Math.max(d,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,O.$hc)(m.base)},s===M.fsPath||(0,D.$Gj)(s,M.fsPath))d=10;else return 0}return d}else return 0}}e.$lt=g}),define(Se[191],ke([1,0,4,13,29,79,127,166,189,3]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=void 0;class R extends y.$Sc{constructor(m,v,k,f,d,s,i){super(),this.m=this.B(new D.$Sd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!s,this.g=f,this.h=d,this.c=new M.$RB(m,k,i)}equals(m){return!(m instanceof R)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,v){return this.c.getOffsetAt(m,v)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,v){const k=m+v,f=this.getPositionAt(m),d=this.getPositionAt(k);return new g.$Es(f.lineNumber,f.column,d.lineNumber,d.column)}getValueInRange(m,v=0){if(m.isEmpty())return"";const k=this.n(v);return this.c.getValueInRange(m,k)}getValueLengthInRange(m,v=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const k=this.getOffsetAt(m.startLineNumber,m.startColumn),f=this.getOffsetAt(m.endLineNumber,m.endColumn);let d=0;const s=this.n(v),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=m.endLineNumber-m.startLineNumber;d=n*o}return f-k+d}getCharacterCountInRange(m,v=0){if(this.j){let k=0;const f=m.startLineNumber,d=m.endLineNumber;for(let s=f;s<=d;s++){const i=this.getLineContent(s),n=s===f?m.startColumn-1:0,o=s===d?m.endColumn-1:i.length;for(let a=n;a<o;a++)O.$$e(i.charCodeAt(a))?(k=k+1,a=a+1):k=k+1}return k+=this.n(v).length*(d-f),k}return this.getValueLengthInRange(m,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,v){return this.c.getLineCharCode(m,v)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const v=O.$Ve(this.getLineContent(m));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(m){const v=O.$Xe(this.getLineContent(m));return v===-1?0:v+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,v,k){let f=this.g,d=this.h,s=this.j,i=!0,n=[];for(let c=0;c<m.length;c++){const l=m[c];i&&l._isTracked&&(i=!1);const S=l.range;if(l.text){let A=!0;s||(A=!O.$jf(l.text),s=A),!f&&A&&(f=O.$if(l.text)),!d&&A&&(d=O.$lf(l.text))}let L="",w=0,p=0,E=0;if(l.text){let A;[w,p,E,A]=(0,b.$et)(l.text);const z=this.getEOL();A===0||A===(z===`\r
`?2:1)?L=l.text:L=l.text.replace(/\r\n|\r|\n/g,z)}n[c]={sortIndex:c,identifier:l.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:L,eolCount:w,firstLineLength:p,lastLineLength:E,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}n.sort(R.u);let o=!1;for(let c=0,l=n.length-1;c<l;c++){const S=n[c].range.getEndPosition(),L=n[c+1].range.getStartPosition();if(L.isBeforeOrEqual(S)){if(L.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=k||v?R._getInverseEditRanges(n):[],t=[];if(v)for(let c=0;c<n.length;c++){const l=n[c],S=a[c];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let L=S.startLineNumber;L<=S.endLineNumber;L++){let w="";L===S.startLineNumber&&(w=this.getLineContent(l.range.startLineNumber),O.$Ve(w)!==-1)||t.push({lineNumber:L,oldContent:w})}}let r=null;if(k){let c=0;r=[];for(let l=0;l<n.length;l++){const S=n[l],L=a[l],w=this.getValueInRange(S.range),p=S.rangeOffset+c;c+=S.text.length-w.length,r[l]={sortIndex:S.sortIndex,identifier:S.identifier,range:L,text:w,textChange:new $.$Zs(S.rangeOffset,w,p,S.text)}}o||r.sort((l,S)=>l.sortIndex-S.sortIndex)}this.g=f,this.h=d,this.j=s;const h=this.t(n);let u=null;if(v&&t.length>0){t.sort((c,l)=>l.lineNumber-c.lineNumber),u=[];for(let c=0,l=t.length;c<l;c++){const S=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===S)continue;const L=t[c].oldContent,w=this.getLineContent(S);w.length===0||w===L||O.$Ve(w)!==-1||u.push(S)}}return this.m.fire(),new P.$1u(r,h,u)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let v=!1;const k=m[0].range,f=m[m.length-1].range,d=new g.$Es(k.startLineNumber,k.startColumn,f.endLineNumber,f.endColumn);let s=k.startLineNumber,i=k.startColumn;const n=[];for(let h=0,u=m.length;h<u;h++){const c=m[h],l=c.range;v=v||c.forceMoveMarkers,n.push(this.getValueInRange(new g.$Es(s,i,l.startLineNumber,l.startColumn))),c.text.length>0&&n.push(c.text),s=l.endLineNumber,i=l.endColumn}const o=n.join(""),[a,t,r]=(0,b.$et)(o);return{sortIndex:0,identifier:m[0].identifier,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(m){m.sort(R.w);const v=[];for(let k=0;k<m.length;k++){const f=m[k],d=f.range.startLineNumber,s=f.range.startColumn,i=f.range.endLineNumber,n=f.range.endColumn;if(d===i&&s===n&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const o=new g.$Es(d,s,i,n);v.push({range:o,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return v}findMatchesLineByLine(m,v,k,f){return this.c.findMatchesLineByLine(m,v,k,f)}getPieceTree(){return this.c}static _getInverseEditRange(m,v){const k=m.startLineNumber,f=m.startColumn,[d,s,i]=(0,b.$et)(v);let n;if(v.length>0){const o=d+1;o===1?n=new g.$Es(k,f,k,f+s):n=new g.$Es(k,f,k+o-1,i+1)}else n=new g.$Es(k,f,k,f);return n}static _getInverseEditRanges(m){const v=[];let k=0,f=0,d=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let o,a;d?d.range.endLineNumber===n.range.startLineNumber?(o=k,a=f+(n.range.startColumn-d.range.endColumn)):(o=k+(n.range.startLineNumber-d.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new g.$Es(o,a,o,a+n.firstLineLength):t=new g.$Es(o,a,o+r-1,n.lastLineLength+1)}else t=new g.$Es(o,a,o,a);k=t.endLineNumber,f=t.endColumn,v.push(t),d=n}return v}static u(m,v){const k=g.$Es.compareRangesUsingEnds(m.range,v.range);return k===0?m.sortIndex-v.sortIndex:k}static w(m,v){const k=g.$Es.compareRangesUsingEnds(m.range,v.range);return k===0?v.sortIndex-m.sortIndex:-k}}e.$SB=R}),define(Se[192],ke([1,0,13,127,191]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TB=void 0;class P{constructor($,y,R,C,m,v,k,f,d){this.a=$,this.b=y,this.c=R,this.d=C,this.e=m,this.f=v,this.g=k,this.h=f,this.j=d}k($){const y=this.c+this.d+this.e,R=this.c+this.e;return y===0?$===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create($){const y=this.k($),R=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,v=R.length;m<v;m++){const k=R[m].buffer.replace(/\r\n|\r|\n/g,y),f=(0,O.$NB)(k);R[m]=new O.$QB(k,f)}const C=new g.$SB(R,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$rf($)&&(this.b=D.$qf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,O.$OB)(this.e,$);this.a.push(new O.$QB($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$if($)),this.k||(this.k=D.$lf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,O.$NB)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$TB=M}),define(Se[131],ke([1,0,22,11]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$=e.$_0=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function P(C){for(let m=0,v=C.length;m<v;m+=4){const k=C[m+0],f=C[m+1],d=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=d,C[m+2]=f,C[m+3]=k}}function M(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return O.$D()||P(m),D.$ge.wrap(m)}function b(C){const m=C.buffer;if(O.$D()||P(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(C){const m=new Uint32Array(y(C));let v=0;if(m[v++]=C.id,C.type==="full")m[v++]=1,m[v++]=C.data.length,m.set(C.data,v),v+=C.data.length;else{m[v++]=2,m[v++]=C.deltas.length;for(const k of C.deltas)m[v++]=k.start,m[v++]=k.deleteCount,k.data?(m[v++]=k.data.length,m.set(k.data,v),v+=k.data.length):m[v++]=0}return M(m)}e.$_0=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&(m+=v.data.length)}return m}function R(C){const m=b(C);let v=0;const k=m[v++];if(m[v++]===1){const i=m[v++],n=m.subarray(v,v+i);return v+=i,{id:k,type:"full",data:n}}const d=m[v++],s=[];for(let i=0;i<d;i++){const n=m[v++],o=m[v++],a=m[v++];let t;a>0&&(t=m.subarray(v,v+a),v+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:k,type:"delta",deltas:s}}e.$a$=R}),define(Se[193],ke([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Se[132],ke([1,0,19,24,11,169,126,193]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(ue,Ce,Ve,Je){this.id=ue,this.name=Ce,this.defaultValue=Ve,this.schema=Je}applyUpdate(ue,Ce){return v(ue,Ce)}compute(ue,Ce,Ve){return Ve}}class m{constructor(ue,Ce){this.newValue=ue,this.didChange=Ce}}e.ApplyUpdateResult=m;function v(he,ue){if(typeof he!="object"||typeof ue!="object"||!he||!ue)return new m(ue,he!==ue);if(Array.isArray(he)||Array.isArray(ue)){const Ve=Array.isArray(he)&&Array.isArray(ue)&&D.$ub(he,ue);return new m(ue,!Ve)}let Ce=!1;for(const Ve in ue)if(ue.hasOwnProperty(Ve)){const Je=v(he[Ve],ue[Ve]);Je.didChange&&(he[Ve]=Je.newValue,Ce=!0)}return new m(he,Ce)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ce){return v(ue,Ce)}validate(ue){return this.defaultValue}}class f{constructor(ue,Ce,Ve,Je){this.id=ue,this.name=Ce,this.defaultValue=Ve,this.schema=Je}applyUpdate(ue,Ce){return v(ue,Ce)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ce,Ve){return Ve}}function d(he,ue){return typeof he>"u"?ue:he==="false"?!1:!!he}e.boolean=d;class s extends f{constructor(ue,Ce,Ve,Je=void 0){typeof Je<"u"&&(Je.type="boolean",Je.default=Ve),super(ue,Ce,Ve,Je)}validate(ue){return d(ue,this.defaultValue)}}function i(he,ue,Ce,Ve){if(typeof he>"u")return ue;let Je=parseInt(he,10);return isNaN(Je)?ue:(Je=Math.max(Ce,Je),Je=Math.min(Ve,Je),Je|0)}e.clampedInt=i;class n extends f{static clampedInt(ue,Ce,Ve,Je){return i(ue,Ce,Ve,Je)}constructor(ue,Ce,Ve,Je,et,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Ve,ot.minimum=Je,ot.maximum=et),super(ue,Ce,Ve,ot),this.minimum=Je,this.maximum=et}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function o(he,ue,Ce,Ve){if(typeof he>"u")return ue;const Je=a.float(he,ue);return a.clamp(Je,Ce,Ve)}e.clampedFloat=o;class a extends f{static clamp(ue,Ce,Ve){return ue<Ce?Ce:ue>Ve?Ve:ue}static float(ue,Ce){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ce;const Ve=parseFloat(ue);return isNaN(Ve)?Ce:Ve}constructor(ue,Ce,Ve,Je,et){typeof et<"u"&&(et.type="number",et.default=Ve),super(ue,Ce,Ve,et),this.validationFn=Je}validate(ue){return this.validationFn(a.float(ue,this.defaultValue))}}class t extends f{static string(ue,Ce){return typeof ue!="string"?Ce:ue}constructor(ue,Ce,Ve,Je=void 0){typeof Je<"u"&&(Je.type="string",Je.default=Ve),super(ue,Ce,Ve,Je)}validate(ue){return t.string(ue,this.defaultValue)}}function r(he,ue,Ce,Ve){return typeof he!="string"?ue:Ve&&he in Ve?Ve[he]:Ce.indexOf(he)===-1?ue:he}e.stringSet=r;class h extends f{constructor(ue,Ce,Ve,Je,et=void 0){typeof et<"u"&&(et.type="string",et.enum=Je,et.default=Ve),super(ue,Ce,Ve,et),this.c=Je}validate(ue){return r(ue,this.defaultValue,this.c)}}class u extends C{constructor(ue,Ce,Ve,Je,et,ot,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=et,ut.default=Je),super(ue,Ce,Ve,ut),this.c=et,this.d=ot}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ce,Ve){return Ve===0?ue.accessibilitySupport:Ve}}class S extends C{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{insertSpace:d(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function w(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function E(he){switch(he){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function A(he){switch(he){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class z extends k{constructor(){super(140)}compute(ue,Ce,Ve){const Je=["monaco-editor"];return Ce.get(39)&&Je.push(Ce.get(39)),ue.extraEditorClassName&&Je.push(ue.extraEditorClassName),Ce.get(73)==="default"?Je.push("mouse-default"):Ce.get(73)==="copy"&&Je.push("mouse-copy"),Ce.get(110)&&Je.push("showUnused"),Ce.get(138)&&Je.push("showDeprecated"),Je.join(" ")}}class N extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Ce,Ve){return Ve&&ue.emptySelectionClipboard}}class I extends C{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{cursorMoveOnType:d(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":r(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":r(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(Ce.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.ON:ue:ue?j.ON:j.OFF}}e.EditorFontLigatures=j;class T extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",T.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?T.OFF:ue==="true"?T.TRANSLATE:ue:ue?T.TRANSLATE:T.OFF}compute(ue,Ce,Ve){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=T;class F extends k{constructor(){super(50)}compute(ue,Ce,Ve){return ue.fontInfo}}class W extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Ce=a.float(ue,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(ue,Ce,Ve){return ue.fontInfo.fontSize}}class Y extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class le extends C{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{multiple:r(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??r(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??r(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??r(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??r(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??r(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends C{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:d(Ce.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(Ce.above,this.defaultValue.above)}}}var Z;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class x extends k{constructor(){super(143)}compute(ue,Ce,Ve){return x.computeLayout(Ce,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ce=ue.height/ue.lineHeight,Ve=Math.floor(ue.paddingTop/ue.lineHeight);let Je=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Je=Math.max(Je,Ce-1));const et=(Ve+ue.viewLineCount+Je)/(ue.pixelRatio*ue.height),ot=Math.floor(ue.viewLineCount/et);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Je,desiredRatio:et,minimapLineCount:ot}}static c(ue,Ce){const Ve=ue.outerWidth,Je=ue.outerHeight,et=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Je};const ot=Ce.stableMinimapLayoutInput,ut=ot&&ue.outerHeight===ot.outerHeight&&ue.lineHeight===ot.lineHeight&&ue.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&ue.pixelRatio===ot.pixelRatio&&ue.scrollBeyondLastLine===ot.scrollBeyondLastLine&&ue.paddingTop===ot.paddingTop&&ue.paddingBottom===ot.paddingBottom&&ue.minimap.enabled===ot.minimap.enabled&&ue.minimap.side===ot.minimap.side&&ue.minimap.size===ot.minimap.size&&ue.minimap.showSlider===ot.minimap.showSlider&&ue.minimap.renderCharacters===ot.minimap.renderCharacters&&ue.minimap.maxColumn===ot.minimap.maxColumn&&ue.minimap.scale===ot.minimap.scale&&ue.verticalScrollbarWidth===ot.verticalScrollbarWidth&&ue.isViewportWrapping===ot.isViewportWrapping,je=ue.lineHeight,St=ue.typicalHalfwidthCharacterWidth,Ht=ue.scrollBeyondLastLine,zt=ue.minimap.renderCharacters;let wt=et>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const qt=ue.minimap.maxColumn,Ut=ue.minimap.size,Kt=ue.minimap.side,Gt=ue.verticalScrollbarWidth,Lt=ue.viewLineCount,It=ue.remainingWidth,tt=ue.isViewportWrapping,Jt=zt?2:3;let Vt=Math.floor(et*Je);const lt=Vt/et;let mt=!1,Zt=!1,Pt=Jt*wt,kt=wt/et,ft=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:gt,extraLinesBeyondLastLine:Rt,desiredRatio:Me,minimapLineCount:Oe}=x.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Ht,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Je,lineHeight:je,pixelRatio:et});if(Lt/Oe>1)mt=!0,Zt=!0,wt=1,Pt=1,kt=wt/et;else{let re=!1,Ne=wt+1;if(Ut==="fit"){const He=Math.ceil((gt+Lt+Rt)*Pt);tt&&ut&&It<=Ce.stableFitRemainingWidth?(re=!0,Ne=Ce.stableFitMaxMinimapScale):re=He>Vt}if(Ut==="fill"||re){mt=!0;const He=wt;Pt=Math.min(je*et,Math.max(1,Math.floor(1/Me))),tt&&ut&&It<=Ce.stableFitRemainingWidth&&(Ne=Ce.stableFitMaxMinimapScale),wt=Math.min(Ne,Math.max(1,Math.floor(Pt/Jt))),wt>He&&(ft=Math.min(2,wt/He)),kt=wt/et/ft,Vt=Math.ceil(Math.max(Qt,gt+Lt+Rt)*Pt),tt?(Ce.stableMinimapLayoutInput=ue,Ce.stableFitRemainingWidth=It,Ce.stableFitMaxMinimapScale=wt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Mt=Math.floor(qt*kt),Nt=Math.min(Mt,Math.max(0,Math.floor((It-Gt-2)*kt/(St+kt)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(et*Nt);const Qe=yt/et;yt=Math.floor(yt*ft);const Ft=zt?1:2,Bt=Kt==="left"?0:Ve-Nt-Gt;return{renderMinimap:Ft,minimapLeft:Bt,minimapWidth:Nt,minimapHeightIsEditorHeight:mt,minimapIsSampling:Zt,minimapScale:wt,minimapLineHeight:Pt,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:lt}}static computeLayout(ue,Ce){const Ve=Ce.outerWidth|0,Je=Ce.outerHeight|0,et=Ce.lineHeight|0,ot=Ce.lineNumbersDigitCount|0,ut=Ce.typicalHalfwidthCharacterWidth,je=Ce.maxDigitWidth,St=Ce.pixelRatio,Ht=Ce.viewLineCount,zt=ue.get(135),wt=zt==="inherit"?ue.get(134):zt,qt=wt==="inherit"?ue.get(130):wt,Ut=ue.get(133),Kt=Ce.isDominatedByLongLines,Gt=ue.get(57),Lt=ue.get(67).renderType!==0,It=ue.get(68),tt=ue.get(104),Jt=ue.get(83),Vt=ue.get(72),lt=ue.get(102),mt=lt.verticalScrollbarSize,Zt=lt.verticalHasArrows,Pt=lt.arrowSize,kt=lt.horizontalScrollbarSize,ft=ue.get(43),Mt=ue.get(109)!=="never";let Nt=ue.get(65);ft&&Mt&&(Nt+=16);let yt=0;if(Lt){const Ke=Math.max(ot,It);yt=Math.round(Ke*je)}let Qe=0;Gt&&(Qe=et*Ce.glyphMarginDecorationLaneCount);let Ft=0,Bt=Ft+Qe,Qt=Bt+yt,gt=Qt+Nt;const Rt=Ve-Qe-yt-Nt;let Me=!1,Oe=!1,De=-1;wt==="inherit"&&Kt?(Me=!0,Oe=!0):qt==="on"||qt==="bounded"?Oe=!0:qt==="wordWrapColumn"&&(De=Ut);const re=x.c({outerWidth:Ve,outerHeight:Je,lineHeight:et,typicalHalfwidthCharacterWidth:ut,pixelRatio:St,scrollBeyondLastLine:tt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Vt,verticalScrollbarWidth:mt,viewLineCount:Ht,remainingWidth:Rt,isViewportWrapping:Oe},Ce.memory||new R);re.renderMinimap!==0&&re.minimapLeft===0&&(Ft+=re.minimapWidth,Bt+=re.minimapWidth,Qt+=re.minimapWidth,gt+=re.minimapWidth);const Ne=Rt-re.minimapWidth,He=Math.max(1,Math.floor((Ne-mt-2)/ut)),_e=Zt?Pt:0;return Oe&&(De=Math.max(1,He),qt==="bounded"&&(De=Math.min(De,Ut))),{width:Ve,height:Je,glyphMarginLeft:Ft,glyphMarginWidth:Qe,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Bt,lineNumbersWidth:yt,decorationsLeft:Qt,decorationsWidth:Nt,contentLeft:gt,contentWidth:Ne,minimap:re,viewportColumn:He,isWordWrapMinified:Me,isViewportWrapping:Oe,wrappingColumn:De,verticalScrollbarWidth:mt,horizontalScrollbarHeight:kt,overviewRuler:{top:_e,width:mt,height:Je-2*_e,right:0}}}}e.EditorLayoutInfoComputer=x;class oe extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return r(ue,"simple",["simple","advanced"])}compute(ue,Ce,Ve){return Ce.get(2)===2?"advanced":Ve}}class X extends C{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:b.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:d(ue.enabled,this.defaultValue.enabled)}}}class ve extends C{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ge extends C{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:r(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:d(Ce.padding,this.defaultValue.padding)}}}class H extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ce,Ve){return Ve<0?n.clampedInt(-Ve*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>a.clamp(ue,0,150),{markdownDescription:b.localize(63,null)})}compute(ue,Ce,Ve){return ue.fontInfo.lineHeight}}class ne extends C{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ue.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),autohide:d(Ce.autohide,this.defaultValue.autohide),size:r(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ce.side,this.defaultValue.side,["right","left"]),showSlider:r(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ce.scale,1,1,3),maxColumn:n.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(he){return he==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class fe extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{top:n.clampedInt(Ce.top,0,0,1e3),bottom:n.clampedInt(Ce.bottom,0,0,1e3)}}}class me extends C{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),cycle:d(Ce.cycle,this.defaultValue.cycle)}}}class ee extends k{constructor(){super(141)}compute(ue,Ce,Ve){return ue.pixelRatio}}class ie extends C{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ue.strings,description:b.localize(82,null)},comments:{anyOf:Ce,default:ue.comments,description:b.localize(83,null)},other:{anyOf:Ce,default:ue.other,description:b.localize(84,null)}},default:ue,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const St=ue?"on":"off";return{comments:St,strings:St,other:St}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ce,comments:Ve,strings:Je}=ue,et=["on","inline","off"];let ot,ut,je;return typeof Ce=="boolean"?ot=Ce?"on":"off":ot=r(Ce,this.defaultValue.other,et),typeof Ve=="boolean"?ut=Ve?"on":"off":ut=r(Ve,this.defaultValue.comments,et),typeof Je=="boolean"?je=Je?"on":"off":je=r(Je,this.defaultValue.strings,et),{other:ot,comments:ut,strings:je}}}var G;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(G||(e.RenderLineNumbersType=G={}));class te extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ue){let Ce=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ce=4,Ve=ue):ue==="interval"?Ce=3:ue==="relative"?Ce=2:ue==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ve}}}function J(he){const ue=he.get(97);return ue==="editable"?he.get(90):ue!=="on"}e.filterValidationDecorations=J;class ce extends C{constructor(){const ue=[],Ce={type:"number",description:b.localize(91,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ue,description:b.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ce=[];for(const Ve of ue)if(typeof Ve=="number")Ce.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Je=Ve;Ce.push({column:n.clampedInt(Je.column,0,0,1e4),color:Je.color})}return Ce.sort((Ve,Je)=>Ve.column-Je.column),Ce}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Ie(he,ue){if(typeof he!="string")return ue;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class Fe extends C{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(105,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue,Ve=n.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Je=n.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:d(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(Ce.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Je,verticalSliderSize:n.clampedInt(Ce.verticalSliderSize,Je,0,1e3),scrollByPage:d(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class B extends C{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(112,null)}})}applyUpdate(ue,Ce){let Ve=!1;Ce.allowedCharacters&&ue&&(O.$jn(ue.allowedCharacters,Ce.allowedCharacters)||(ue={...ue,allowedCharacters:Ce.allowedCharacters},Ve=!0)),Ce.allowedLocales&&ue&&(O.$jn(ue.allowedLocales,Ce.allowedLocales)||(ue={...ue,allowedLocales:Ce.allowedLocales},Ve=!0));const Je=super.applyUpdate(ue,Ce);return Ve?new m(Je.newValue,!0):Je}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{nonBasicASCII:ae(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ae(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ae(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ce){if(typeof ue!="object"||!ue)return Ce;const Ve={};for(const[Je,et]of Object.entries(ue))et===!0&&(Ve[Je]=!0);return Ve}}class _ extends C{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(114,null),b.localize(115,null),b.localize(116,null)],description:b.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(118,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),mode:r(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends C{constructor(){const ue={enabled:P.$bs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$bs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(120,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends C{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(121,null),b.localize(122,null),b.localize(123,null)],default:ue.bracketPairs,description:b.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null)],default:ue.bracketPairsHorizontal,description:b.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(131,null),b.localize(132,null),b.localize(133,null)],default:ue.highlightActiveIndentation,description:b.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{bracketPairs:ae(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:ae(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ae(he,ue,Ce){const Ve=Ce.indexOf(he);return Ve===-1?ue:Ce[Ve]}class de extends C{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(135,null),b.localize(136,null)],default:ue.insertMode,description:b.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(141,null),b.localize(142,null),b.localize(143,null),b.localize(144,null)],default:ue.selectionMode,markdownDescription:b.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{insertMode:r(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(Ce.preview,this.defaultValue.preview),previewMode:r(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(Ce.showMethods,this.defaultValue.showMethods),showFunctions:d(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(Ce.showFields,this.defaultValue.showFields),showVariables:d(Ce.showVariables,this.defaultValue.showVariables),showClasses:d(Ce.showClasses,this.defaultValue.showClasses),showStructs:d(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(Ce.showModules,this.defaultValue.showModules),showProperties:d(Ce.showProperties,this.defaultValue.showProperties),showEvents:d(Ce.showEvents,this.defaultValue.showEvents),showOperators:d(Ce.showOperators,this.defaultValue.showOperators),showUnits:d(Ce.showUnits,this.defaultValue.showUnits),showValues:d(Ce.showValues,this.defaultValue.showValues),showConstants:d(Ce.showConstants,this.defaultValue.showConstants),showEnums:d(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(Ce.showKeywords,this.defaultValue.showKeywords),showWords:d(Ce.showWords,this.defaultValue.showWords),showColors:d(Ce.showColors,this.defaultValue.showColors),showFiles:d(Ce.showFiles,this.defaultValue.showFiles),showReferences:d(Ce.showReferences,this.defaultValue.showReferences),showFolders:d(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(Ce.showUsers,this.defaultValue.showUsers),showIssues:d(Ce.showIssues,this.defaultValue.showIssues)}}}class Ae extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(184,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Xe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(185,null),b.localize(186,null),b.localize(187,null),b.localize(188,null)],description:b.localize(189,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ce,Ve){return Ce.get(2)===2?0:Ve}}class Ye extends k{constructor(){super(144)}compute(ue,Ce,Ve){const Je=Ce.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Je.isWordWrapMinified,isViewportWrapping:Je.isViewportWrapping,wrappingColumn:Je.wrappingColumn}}}class it extends C{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(192,null),b.localize(193,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showDropSelector:r(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(196,null),b.localize(197,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ce=ue;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showPasteSelector:r(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Te:g.$k?qe:Pe,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(he){return e.editorOptionsRegistry[he.id]=he,he}var xe;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.occurrencesHighlight=80]="occurrencesHighlight",he[he.overviewRulerBorder=81]="overviewRulerBorder",he[he.overviewRulerLanes=82]="overviewRulerLanes",he[he.padding=83]="padding",he[he.pasteAs=84]="pasteAs",he[he.parameterHints=85]="parameterHints",he[he.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",he[he.quickSuggestions=88]="quickSuggestions",he[he.quickSuggestionsDelay=89]="quickSuggestionsDelay",he[he.readOnly=90]="readOnly",he[he.readOnlyMessage=91]="readOnlyMessage",he[he.renameOnType=92]="renameOnType",he[he.renderControlCharacters=93]="renderControlCharacters",he[he.renderFinalNewline=94]="renderFinalNewline",he[he.renderLineHighlight=95]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=97]="renderValidationDecorations",he[he.renderWhitespace=98]="renderWhitespace",he[he.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",he[he.roundedSelection=100]="roundedSelection",he[he.rulers=101]="rulers",he[he.scrollbar=102]="scrollbar",he[he.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=104]="scrollBeyondLastLine",he[he.scrollPredominantAxis=105]="scrollPredominantAxis",he[he.selectionClipboard=106]="selectionClipboard",he[he.selectionHighlight=107]="selectionHighlight",he[he.selectOnLineNumbers=108]="selectOnLineNumbers",he[he.showFoldingControls=109]="showFoldingControls",he[he.showUnused=110]="showUnused",he[he.snippetSuggestions=111]="snippetSuggestions",he[he.smartSelect=112]="smartSelect",he[he.smoothScrolling=113]="smoothScrolling",he[he.stickyScroll=114]="stickyScroll",he[he.stickyTabStops=115]="stickyTabStops",he[he.stopRenderingLineAfter=116]="stopRenderingLineAfter",he[he.suggest=117]="suggest",he[he.suggestFontSize=118]="suggestFontSize",he[he.suggestLineHeight=119]="suggestLineHeight",he[he.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",he[he.suggestSelection=121]="suggestSelection",he[he.tabCompletion=122]="tabCompletion",he[he.tabIndex=123]="tabIndex",he[he.unicodeHighlighting=124]="unicodeHighlighting",he[he.unusualLineTerminators=125]="unusualLineTerminators",he[he.useShadowDOM=126]="useShadowDOM",he[he.useTabStops=127]="useTabStops",he[he.wordBreak=128]="wordBreak",he[he.wordSeparators=129]="wordSeparators",he[he.wordWrap=130]="wordWrap",he[he.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=133]="wordWrapColumn",he[he.wordWrapOverride1=134]="wordWrapOverride1",he[he.wordWrapOverride2=135]="wordWrapOverride2",he[he.wrappingIndent=136]="wrappingIndent",he[he.wrappingStrategy=137]="wrappingStrategy",he[he.showDeprecated=138]="showDeprecated",he[he.inlayHints=139]="inlayHints",he[he.editorClassName=140]="editorClassName",he[he.pixelRatio=141]="pixelRatio",he[he.tabFocusMode=142]="tabFocusMode",he[he.layoutInfo=143]="layoutInfo",he[he.wrappingInfo=144]="wrappingInfo",he[he.defaultColorDecorators=145]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(xe||(e.EditorOption=xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(198,null)})),acceptSuggestionOnEnter:Re(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(199,null),""],markdownDescription:b.localize(200,null)})),accessibilitySupport:Re(new l),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(201,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",b.localize(202,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:Re(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(204,null),b.localize(205,null),""],description:b.localize(206,null)})),autoClosingComments:Re(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingDelete:Re(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(210,null),""],description:b.localize(211,null)})),autoClosingOvertype:Re(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(212,null),""],description:b.localize(213,null)})),autoClosingQuotes:Re(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(214,null),b.localize(215,null),""],description:b.localize(216,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null),b.localize(220,null),b.localize(221,null)],description:b.localize(222,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(223,null),b.localize(224,null),b.localize(225,null),""],description:b.localize(226,null)})),bracketPairColorization:Re(new se),bracketPairGuides:Re(new K),stickyTabStops:Re(new s(115,"stickyTabStops",!1,{description:b.localize(227,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:b.localize(228,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:b.localize(229,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(230,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:b.localize(231,null)})),colorDecoratorActivatedOn:Re(new h(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(236,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:b.localize(237,null)})),comments:Re(new S),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(238,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(239,null)})),cursorSmoothCaretAnimation:Re(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(240,null),b.localize(241,null),b.localize(242,null)],description:b.localize(243,null)})),cursorStyle:Re(new u(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:b.localize(244,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(245,null)})),cursorSurroundingLinesStyle:Re(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(246,null),b.localize(247,null)],markdownDescription:b.localize(248,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(249,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:b.localize(250,null)})),emptySelectionClipboard:Re(new N),dropIntoEditor:Re(new it),stickyScroll:Re(new ve),experimentalWhitespaceRendering:Re(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(251,null),b.localize(252,null),b.localize(253,null)],description:b.localize(254,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:b.localize(255,null)})),find:Re(new I),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:b.localize(256,null)})),foldingStrategy:Re(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:b.localize(260,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:b.localize(261,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(262,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(263,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(264,null)})),fontInfo:Re(new F),fontLigatures2:Re(new j),fontSize:Re(new W),fontWeight:Re(new Y),fontVariations:Re(new T),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:b.localize(265,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:b.localize(266,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:b.localize(267,null)})),gotoLocation:Re(new le),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(268,null)})),hover:Re(new Q),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>a.clamp(he,-5,20),{description:b.localize(269,null)})),lightbulb:Re(new X),lineDecorationsWidth:Re(new H),lineHeight:Re(new U),lineNumbers:Re(new te),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:b.localize(270,null)})),links:Re(new s(70,"links",!0,{description:b.localize(271,null)})),matchBrackets:Re(new h(71,"matchBrackets","always",["always","near","never"],{description:b.localize(272,null)})),minimap:Re(new ne),mouseStyle:Re(new h(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:b.localize(273,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(274,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:b.localize(275,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[b.localize(276,null),b.localize(277,null)],markdownDescription:b.localize(278,null)})),multiCursorPaste:Re(new h(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(279,null),b.localize(280,null)],markdownDescription:b.localize(281,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(282,null)})),occurrencesHighlight:Re(new h(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null),b.localize(285,null)],markdownDescription:b.localize(286,null)})),overviewRulerBorder:Re(new s(81,"overviewRulerBorder",!0,{description:b.localize(287,null)})),overviewRulerLanes:Re(new n(82,"overviewRulerLanes",3,0,3)),padding:Re(new fe),pasteAs:Re(new st),parameterHints:Re(new me),peekWidgetDefaultFocus:Re(new h(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(288,null),b.localize(289,null)],description:b.localize(290,null)})),definitionLinkOpensInPeek:Re(new s(87,"definitionLinkOpensInPeek",!1,{description:b.localize(291,null)})),quickSuggestions:Re(new ie),quickSuggestionsDelay:Re(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(292,null)})),readOnly:Re(new s(90,"readOnly",!1)),readOnlyMessage:Re(new be),renameOnType:Re(new s(92,"renameOnType",!1,{description:b.localize(293,null),markdownDeprecationMessage:b.localize(294,null)})),renderControlCharacters:Re(new s(93,"renderControlCharacters",!0,{description:b.localize(295,null),restricted:!0})),renderFinalNewline:Re(new h(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(296,null)})),renderLineHighlight:Re(new h(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(297,null)],description:b.localize(298,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(299,null)})),renderValidationDecorations:Re(new h(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new h(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(300,null),b.localize(301,null),b.localize(302,null),""],description:b.localize(303,null)})),revealHorizontalRightPadding:Re(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(100,"roundedSelection",!0,{description:b.localize(304,null)})),rulers:Re(new ce),scrollbar:Re(new Fe),scrollBeyondLastColumn:Re(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(305,null)})),scrollBeyondLastLine:Re(new s(104,"scrollBeyondLastLine",!0,{description:b.localize(306,null)})),scrollPredominantAxis:Re(new s(105,"scrollPredominantAxis",!0,{description:b.localize(307,null)})),selectionClipboard:Re(new s(106,"selectionClipboard",!0,{description:b.localize(308,null),included:g.$k})),selectionHighlight:Re(new s(107,"selectionHighlight",!0,{description:b.localize(309,null)})),selectOnLineNumbers:Re(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new h(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(310,null),b.localize(311,null),b.localize(312,null)],description:b.localize(313,null)})),showUnused:Re(new s(110,"showUnused",!0,{description:b.localize(314,null)})),showDeprecated:Re(new s(138,"showDeprecated",!0,{description:b.localize(315,null)})),inlayHints:Re(new ge),snippetSuggestions:Re(new h(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(316,null),b.localize(317,null),b.localize(318,null),b.localize(319,null)],description:b.localize(320,null)})),smartSelect:Re(new Ae),smoothScrolling:Re(new s(113,"smoothScrolling",!1,{description:b.localize(321,null)})),stopRenderingLineAfter:Re(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new de),inlineSuggest:Re(new _),inlineCompletionsAccessibilityVerbose:Re(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(322,null)})),suggestFontSize:Re(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(120,"suggestOnTriggerCharacters",!0,{description:b.localize(325,null)})),suggestSelection:Re(new h(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(326,null),b.localize(327,null),b.localize(328,null)],description:b.localize(329,null)})),tabCompletion:Re(new h(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabIndex:Re(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new B),unusualLineTerminators:Re(new h(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),useShadowDOM:Re(new s(126,"useShadowDOM",!0)),useTabStops:Re(new s(127,"useTabStops",!0,{description:b.localize(338,null)})),wordBreak:Re(new h(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),wordSeparators:Re(new t(129,"wordSeparators",M.$cs,{description:b.localize(342,null)})),wordWrap:Re(new h(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null),b.localize(346,null)],description:b.localize(347,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(348,null)})),wordWrapOverride1:Re(new h(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new h(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new z),defaultColorDecorators:Re(new s(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(349,null)})),pixelRatio:Re(new ee),tabFocusMode:Re(new s(142,"tabFocusMode",!1,{markdownDescription:b.localize(350,null)})),layoutInfo:Re(new x),wrappingInfo:Re(new Ye),wrappingIndent:Re(new Xe),wrappingStrategy:Re(new oe)}}),define(Se[194],ke([9,10]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(Se[83],ke([1,0,78,2,167,29,177,194]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$wt=e.$vt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ut=e.$tt=e.SymbolKinds=e.SymbolTag=e.$st=e.$rt=e.SymbolKind=e.$qt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$pt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ot=e.$nt=e.$mt=void 0;class ${constructor(j,T,F){this.offset=j,this.type=T,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$mt=$;class y{constructor(j,T){this.tokens=j,this.endState=T,this._tokenizationResultBrand=void 0}}e.$nt=y;class R{constructor(j,T){this.tokens=j,this.endState=T,this._encodedTokenizationResultBrand=void 0}}e.$ot=R;var C;(function(I){I[I.Method=0]="Method",I[I.Function=1]="Function",I[I.Constructor=2]="Constructor",I[I.Field=3]="Field",I[I.Variable=4]="Variable",I[I.Class=5]="Class",I[I.Struct=6]="Struct",I[I.Interface=7]="Interface",I[I.Module=8]="Module",I[I.Property=9]="Property",I[I.Event=10]="Event",I[I.Operator=11]="Operator",I[I.Unit=12]="Unit",I[I.Value=13]="Value",I[I.Constant=14]="Constant",I[I.Enum=15]="Enum",I[I.EnumMember=16]="EnumMember",I[I.Keyword=17]="Keyword",I[I.Text=18]="Text",I[I.Color=19]="Color",I[I.File=20]="File",I[I.Reference=21]="Reference",I[I.Customcolor=22]="Customcolor",I[I.Folder=23]="Folder",I[I.TypeParameter=24]="TypeParameter",I[I.User=25]="User",I[I.Issue=26]="Issue",I[I.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(I){const j=new Map;j.set(0,D.$6j.symbolMethod),j.set(1,D.$6j.symbolFunction),j.set(2,D.$6j.symbolConstructor),j.set(3,D.$6j.symbolField),j.set(4,D.$6j.symbolVariable),j.set(5,D.$6j.symbolClass),j.set(6,D.$6j.symbolStruct),j.set(7,D.$6j.symbolInterface),j.set(8,D.$6j.symbolModule),j.set(9,D.$6j.symbolProperty),j.set(10,D.$6j.symbolEvent),j.set(11,D.$6j.symbolOperator),j.set(12,D.$6j.symbolUnit),j.set(13,D.$6j.symbolValue),j.set(15,D.$6j.symbolEnum),j.set(14,D.$6j.symbolConstant),j.set(15,D.$6j.symbolEnum),j.set(16,D.$6j.symbolEnumMember),j.set(17,D.$6j.symbolKeyword),j.set(27,D.$6j.symbolSnippet),j.set(18,D.$6j.symbolText),j.set(19,D.$6j.symbolColor),j.set(20,D.$6j.symbolFile),j.set(21,D.$6j.symbolReference),j.set(22,D.$6j.symbolCustomColor),j.set(23,D.$6j.symbolFolder),j.set(24,D.$6j.symbolTypeParameter),j.set(25,D.$6j.account),j.set(26,D.$6j.issues);function T(Y){let le=j.get(Y);return le||(console.info("No codicon found for CompletionItemKind "+Y),le=D.$6j.symbolProperty),le}I.toIcon=T;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function W(Y,le){let Q=F.get(Y);return typeof Q>"u"&&!le&&(Q=9),Q}I.fromString=W})(m||(e.CompletionItemKinds=m={}));var v;(function(I){I[I.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var k;(function(I){I[I.None=0]="None",I[I.KeepWhitespace=1]="KeepWhitespace",I[I.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var f;(function(I){I[I.Invoke=0]="Invoke",I[I.TriggerCharacter=1]="TriggerCharacter",I[I.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var d;(function(I){I[I.Automatic=0]="Automatic",I[I.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class s{constructor(j,T,F,W){this.range=j,this.text=T,this.completionKind=F,this.isSnippetText=W}equals(j){return P.$Es.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$pt=s;var i;(function(I){I[I.Invoke=1]="Invoke",I[I.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(I){I[I.Invoke=1]="Invoke",I[I.TriggerCharacter=2]="TriggerCharacter",I[I.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(I){I[I.Text=0]="Text",I[I.Read=1]="Read",I[I.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(I){return I&&O.URI.isUri(I.uri)&&P.$Es.isIRange(I.range)&&(P.$Es.isIRange(I.originSelectionRange)||P.$Es.isIRange(I.targetSelectionRange))}e.$qt=a;var t;(function(I){I[I.File=0]="File",I[I.Module=1]="Module",I[I.Namespace=2]="Namespace",I[I.Package=3]="Package",I[I.Class=4]="Class",I[I.Method=5]="Method",I[I.Property=6]="Property",I[I.Field=7]="Field",I[I.Constructor=8]="Constructor",I[I.Enum=9]="Enum",I[I.Interface=10]="Interface",I[I.Function=11]="Function",I[I.Variable=12]="Variable",I[I.Constant=13]="Constant",I[I.String=14]="String",I[I.Number=15]="Number",I[I.Boolean=16]="Boolean",I[I.Array=17]="Array",I[I.Object=18]="Object",I[I.Key=19]="Key",I[I.Null=20]="Null",I[I.EnumMember=21]="EnumMember",I[I.Struct=22]="Struct",I[I.Event=23]="Event",I[I.Operator=24]="Operator",I[I.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$rt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function r(I,j){return(0,b.localize)(26,null,I,e.$rt[j])}e.$st=r;var h;(function(I){I[I.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var u;(function(I){const j=new Map;j.set(0,D.$6j.symbolFile),j.set(1,D.$6j.symbolModule),j.set(2,D.$6j.symbolNamespace),j.set(3,D.$6j.symbolPackage),j.set(4,D.$6j.symbolClass),j.set(5,D.$6j.symbolMethod),j.set(6,D.$6j.symbolProperty),j.set(7,D.$6j.symbolField),j.set(8,D.$6j.symbolConstructor),j.set(9,D.$6j.symbolEnum),j.set(10,D.$6j.symbolInterface),j.set(11,D.$6j.symbolFunction),j.set(12,D.$6j.symbolVariable),j.set(13,D.$6j.symbolConstant),j.set(14,D.$6j.symbolString),j.set(15,D.$6j.symbolNumber),j.set(16,D.$6j.symbolBoolean),j.set(17,D.$6j.symbolArray),j.set(18,D.$6j.symbolObject),j.set(19,D.$6j.symbolKey),j.set(20,D.$6j.symbolNull),j.set(21,D.$6j.symbolEnumMember),j.set(22,D.$6j.symbolStruct),j.set(23,D.$6j.symbolEvent),j.set(24,D.$6j.symbolOperator),j.set(25,D.$6j.symbolTypeParameter);function T(F){let W=j.get(F);return W||(console.info("No codicon found for SymbolKind "+F),W=D.$6j.symbolProperty),W}I.toIcon=T})(u||(e.SymbolKinds=u={}));class c{static asEditOperation(j){return g.$Fs.replace(P.$Es.lift(j.range),j.text)}}e.$tt=c;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(j){switch(j){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(j)}constructor(j){this.value=j}}e.$ut=l;var S;(function(I){function j(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}I.is=j})(S||(e.Command=S={}));var L;(function(I){I[I.Collapsed=0]="Collapsed",I[I.Expanded=1]="Expanded"})(L||(e.CommentThreadCollapsibleState=L={}));var w;(function(I){I[I.Unresolved=0]="Unresolved",I[I.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var p;(function(I){I[I.Editing=0]="Editing",I[I.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var E;(function(I){I[I.Published=0]="Published",I[I.Draft=1]="Draft"})(E||(e.CommentState=E={}));var A;(function(I){I[I.Type=1]="Type",I[I.Parameter=2]="Parameter"})(A||(e.InlayHintKind=A={}));class z{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$vt=z,e.$wt=new M.$dt;var N;(function(I){I[I.None=0]="None",I[I.Option=1]="Option",I[I.Default=2]="Default",I[I.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(Se[195],ke([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[196],ke([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[197],ke([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Se[198],ke([9,10]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[199],ke([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[200],ke([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[201],ke([9,10]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[202],ke([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Se[203],ke([9,10]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(Se[204],ke([9,10]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[205],ke([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Se[206],ke([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[207],ke([9,10]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[208],ke([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Se[209],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[210],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[211],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[212],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[213],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[214],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[215],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[216],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[217],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[218],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[219],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[220],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[221],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[222],ke([9,10]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[223],ke([9,10]),function($e,e){return $e.create("vs/workbench/common/configuration",e)}),define(Se[224],ke([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Se[225],ke([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Se[226],ke([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[227],ke([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[228],ke([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[229],ke([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[230],ke([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[231],ke([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[232],ke([9,10]),function($e,e){return $e.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[233],ke([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[234],ke([9,10]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[235],ke([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[236],ke([1,0,8,197]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function P(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const M=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:R}),this.f.push(v)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,m=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const k=this.c.charCodeAt(R);if(C)C=!1;else if(k===47&&!m){R++;break}else k===91?m=!0:k===92?C=!0:k===93&&(m=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=$}),define(Se[237],ke([1,0,23,39,200,385]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||M.test(s)}e.$Wo=$;function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(M);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Xo=y;function R(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let h=0;if(s.preRelease){const u=b.exec(s.preRelease);if(u){const[,c,l,S]=u;h=Date.UTC(Number(c),Number(l)-1,Number(S))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:h}}e.$Yo=R;function C(s,i,n){let o;typeof s=="string"?o=R(y(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=R(y(n)):t=n,!o||!t)return!1;const r=o.majorBase,h=o.minorBase,u=o.patchBase;let c=t.majorBase,l=t.minorBase,S=t.patchBase;const L=t.notBefore;let w=t.majorMustEqual,p=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:h>l?!0:h<l||a&&a<L?!1:u>=S:(r===1&&c===0&&(!w||!p||!E)&&(c=1,l=0,S=0,w=!0,p=!1,E=!1),r<c?!1:r>c?!w:h<l?!1:h>l?!p:u<S?!1:u>S?!E:!(a&&a<L))}e.$Zo=C;function m(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([O.default.Error,g.localize(0,null)]),t;if(typeof o.name!="string")return t.push([O.default.Error,g.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([O.default.Error,g.localize(2,null,"version")]),t;if(!o.engines)return t.push([O.default.Error,g.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([O.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!d(o.extensionDependencies))return t.push([O.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!d(o.activationEvents))return t.push([O.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([O.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([O.default.Warning,g.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([O.default.Error,g.localize(9,null,"main")]),t;{const u=(0,D.$Cg)(n,o.main);(0,D.$wg)(u,n)||t.push([O.default.Warning,g.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([O.default.Error,g.localize(11,null,"browser")]),t;{const u=(0,D.$Cg)(n,o.browser);(0,D.$wg)(u,n)||t.push([O.default.Warning,g.localize(12,null,u.path,n.path)])}}if(!P.valid(o.version))return t.push([O.default.Error,g.localize(13,null)]),t;const r=[];if(!v(s,i,o,a,r))for(const u of r)t.push([O.default.Error,u]);return t}e.$1o=m;function v(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:f(s,i,n.engines.vscode,a)}e.$2o=v;function k(s,i,n){return s==="*"||f(i,n,s)}e.$3o=k;function f(s,i,n,o=[]){const a=R(y(n));if(!a)return o.push(g.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(g.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(g.localize(16,null,n)),!1;return C(s,i,a)?!0:(o.push(g.localize(17,null,s,n)),!1)}function d(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Se[105],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class D{constructor(g,P=[],M=!1){this.ctor=g,this.staticArguments=P,this.supportsDelayedInstantiation=M}}e.$Xh=D}),define(Se[106],ke([1,0,105]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.InstantiationType=void 0;const O=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function P(b,$,y){$ instanceof D.$Xh||($=new D.$Xh($,[],!!y)),O.push([b,$])}e.$Hr=P;function M(){return O}e.$Ir=M}),define(Se[238],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0;class D{constructor(P,M){this.key=P,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$mq=D;class O{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const M of this.a.values())M.outgoing.size===0&&P.push(M);return P}insertEdge(P,M){const b=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(M);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(P){const M=this.b(P);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(P){const M=this.b(P);let b=this.a.get(M);return b||(b=new D(M,P),this.a.set(M,b)),b}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[M,b]of this.a)P.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,M]of this.a){const b=new Set([P]),$=this.c(M,b);if($)return $}}c(P,M){for(const[b,$]of P.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const y=this.c($,M);if(y)return y;M.delete(b)}}}e.$nq=O}),define(Se[5],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e._util=void 0;var D;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(D||(e._util=D={})),e.$Zh=g("instantiationService");function O(M,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:M,index:$}):(b[D.DI_DEPENDENCIES]=[{id:M,index:$}],b[D.DI_TARGET]=b)}function g(M){if(D.serviceIds.has(M))return D.serviceIds.get(M);const b=function($,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,$,R)};return b.toString=()=>M,D.serviceIds.set(M,b),b}e.$1h=g;function P(M){return M}e.$2h=P}),define(Se[45],ke([1,0,18,2,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.ConfigurationTarget=e.$wi=e.$vi=e.$ui=void 0,e.$ui=(0,g.$1h)("configurationService");function P(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof O.URI)}e.$vi=P;function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof O.URI)}e.$wi=M;var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$xi=$;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$yi=y;function R(s,i){const n=Object.create(null);for(const o in s)C(n,o,s[o],i);return n}e.$zi=R;function C(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let h=0;h<a.length;h++){const u=a[h];let c=r[u];switch(typeof c){case"undefined":c=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$Ai=C;function m(s,i){const n=i.split(".");v(s,n)}e.$Bi=m;function v(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete s[n])}}function k(s,i,n){function o(r,h){let u=r;for(const c of h){if(typeof u!="object"||u===null)return;u=u[c]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$Ci=k;function f(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.$Ff(s[o])&&D.$Ff(i[o])?f(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$Di=f;function d(s){return s.replace(/[\[\]]/g,"")}e.$Ei=d}),define(Se[46],ke([1,0,11,13,236,5,196,8]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(H,U){if($.get(H)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(H,U)}e.$Wi=y;const R=Object.prototype.hasOwnProperty;var C;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),k=(0,M.localize)(1,null),f=(0,M.localize)(2,null),d=(0,M.localize)(3,null),s=(0,M.localize)(4,null),i=(0,M.localize)(5,null),n=(0,M.localize)(6,null),o=(0,M.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new g.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),fe=ye.type===17?i:void 0;throw this.h.push({message:s,offset:ye.offset,lexeme:g.$Vi.getLexeme(ye),additionalInfo:fe}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,d),ne?.negate()}case 17:return this.z(),A.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,d),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),fe.type!==10)throw this.B("REGEX",fe);const me=fe.lexeme,ee=me.lastIndexOf("/"),ie=ee===me.length-1?void 0:this.w(me.substring(ee+1));let G;try{G=new RegExp(me.substring(1,ee),ie)}catch{throw this.B("REGEX",fe)}return F.create(ne,G)}switch(fe.type){case 10:case 19:{const me=[fe.lexeme];this.z();let ee=this.D(),ie=0;for(let be=0;be<fe.lexeme.length;be++)fe.lexeme.charCodeAt(be)===40?ie++:fe.lexeme.charCodeAt(be)===41&&ie--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let be=0;be<ee.lexeme.length;be++)ee.lexeme.charCodeAt(be)===40?ie++:fe.lexeme.charCodeAt(be)===41&&ie--}if(ie<0)break;me.push(g.$Vi.getLexeme(ee)),this.z(),ee=this.D()}const G=me.join(""),te=G.lastIndexOf("/"),J=te===G.length-1?void 0:this.w(G.substring(te+1));let ce;try{ce=new RegExp(G.substring(1,te),J)}catch{throw this.B("REGEX",fe)}return t.regex(ne,ce)}case 18:{const me=fe.lexeme;this.z();let ee=null;if(!(0,O.$Ge)(me)){const ie=me.indexOf("/"),G=me.lastIndexOf("/");if(ie!==G&&ie>=0){const te=me.slice(ie+1,G),J=me[G+1]==="i"?"i":"";try{ee=new RegExp(te,J)}catch{throw this.B("REGEX",fe)}}}if(ee===null)throw this.B("REGEX",fe);return F.create(ne,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const fe=this.u();return t.notIn(ne,fe)}switch(this.D().type){case 3:{this.z();const fe=this.u();if(this.x().type===18)return t.equals(ne,fe);switch(fe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,fe)}}case 4:{this.z();const fe=this.u();if(this.x().type===18)return t.notEquals(ne,fe);switch(fe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,fe)}}case 5:return this.z(),j.create(ne,this.u());case 6:return this.z(),T.create(ne,this.u());case 7:return this.z(),N.create(ne,this.u());case 8:return this.z(),I.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,ye){const fe=(0,M.localize)(8,null,U,g.$Vi.getLexeme(ne)),me=ne.offset,ee=g.$Vi.getLexeme(ne);return this.h.push({message:fe,offset:me,lexeme:ee,additionalInfo:ye}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=a;class t{static false(){return c.INSTANCE}static true(){return l.INSTANCE}static has(U){return S.create(U)}static equals(U,ne){return L.create(U,ne)}static notEquals(U,ne){return E.create(U,ne)}static regex(U,ne){return F.create(U,ne)}static in(U,ne){return w.create(U,ne)}static notIn(U,ne){return p.create(U,ne)}static not(U){return A.create(U)}static and(...U){return le.create(U,null,!0)}static or(...U){return Q.create(U,null,!0)}static greater(U,ne){return N.create(U,ne)}static greaterEquals(U,ne){return I.create(U,ne)}static smaller(U,ne){return j.create(U,ne)}static smallerEquals(U,ne){return T.create(U,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Yi=t;function r(H){const U=new a({regexParsingWithErrorRecovery:!1});return H.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,M.localize)(9,null,ye.additionalInfo):(0,M.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$Zi=r;function h(H,U){const ne=H?H.substituteConstants():void 0,ye=U?U.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}e.$1i=h;function u(H,U){return H.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$2i=c;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$3i=l;class S{static create(U,ne=null){const ye=$.get(U);return typeof ye=="boolean"?ye?l.INSTANCE:c.INSTANCE:new S(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$4i=S;class L{static create(U,ne,ye=null){if(typeof ne=="boolean")return ne?S.create(U,ye):A.create(U,ye);const fe=$.get(U);return typeof fe=="boolean"?ne===(fe?"true":"false")?l.INSTANCE:c.INSTANCE:new L(U,ne,ye)}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?l.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$5i=L;class w{static create(U,ne){return new w(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),ye=U.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?R.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$6i=w;class p{static create(U,ne){return new p(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=w.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=p;class E{static create(U,ne,ye=null){if(typeof ne=="boolean")return ne?A.create(U,ye):S.create(U,ye);const fe=$.get(U);return typeof fe=="boolean"?ne===(fe?"true":"false")?c.INSTANCE:l.INSTANCE:new E(U,ne,ye)}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?c.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$8i=E;class A{static create(U,ne=null){const ye=$.get(U);return typeof ye=="boolean"?ye?c.INSTANCE:l.INSTANCE:new A(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$9i=A;function z(H,U){if(typeof H=="string"){const ne=parseFloat(H);isNaN(ne)||(H=ne)}return typeof H=="string"||typeof H=="number"?U(H):c.INSTANCE}class N{static create(U,ne,ye=null){return z(ne,fe=>new N(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$0i=N;class I{static create(U,ne,ye=null){return z(ne,fe=>new I(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$$i=I;class j{static create(U,ne,ye=null){return z(ne,fe=>new j(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$_i=j;class T{static create(U,ne,ye=null){return z(ne,fe=>new T(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$aj=T;class F{static create(U,ne){return new F(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",ye=U.f?U.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",ye=U.f?U.f.source:"";return this.d===U.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$bj=F;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$cj=W;function Y(H){let U=null;for(let ne=0,ye=H.length;ne<ye;ne++){const fe=H[ne].substituteConstants();if(H[ne]!==fe&&U===null){U=[];for(let me=0;me<ne;me++)U[me]=H[me]}U!==null&&(U[ne]=fe)}return U===null?H:U}class le{static create(U,ne,ye){return le.d(U,ne,ye)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const fe=u(this.expr[ne],U.expr[ne]);if(fe!==0)return fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=Y(this.expr);return U===this.expr?this:le.create(U,this.c,!1)}evaluate(U){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,ye){const fe=[];let me=!1;for(const ee of U)if(ee){if(ee.type===1){me=!0;continue}if(ee.type===0)return c.INSTANCE;if(ee.type===6){fe.push(...ee.expr);continue}fe.push(ee)}if(fe.length===0&&me)return l.INSTANCE;if(fe.length!==0){if(fe.length===1)return fe[0];fe.sort(u);for(let ee=1;ee<fe.length;ee++)fe[ee-1].equals(fe[ee])&&(fe.splice(ee,1),ee--);if(fe.length===1)return fe[0];for(;fe.length>1;){const ee=fe[fe.length-1];if(ee.type!==9)break;fe.pop();const ie=fe.pop(),G=fe.length===0,te=Q.create(ee.expr.map(J=>le.create([J,ie],null,ye)),null,G);te&&(fe.push(te),fe.sort(u))}if(fe.length===1)return fe[0];if(ye){for(let ee=0;ee<fe.length;ee++)for(let ie=ee+1;ie<fe.length;ie++)if(fe[ee].negate().equals(fe[ie]))return c.INSTANCE;if(fe.length===1)return fe[0]}return new le(fe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new le(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=Q.create(U,this,!0)}return this.c}}e.$dj=le;class Q{static create(U,ne,ye){return Q.d(U,ne,ye)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const fe=u(this.expr[ne],U.expr[ne]);if(fe!==0)return fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=Y(this.expr);return U===this.expr?this:Q.create(U,this.c,!1)}evaluate(U){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,ye){let fe=[],me=!1;if(U){for(let ee=0,ie=U.length;ee<ie;ee++){const G=U[ee];if(G){if(G.type===0){me=!0;continue}if(G.type===1)return l.INSTANCE;if(G.type===9){fe=fe.concat(G.expr);continue}fe.push(G)}}if(fe.length===0&&me)return c.INSTANCE;fe.sort(u)}if(fe.length!==0){if(fe.length===1)return fe[0];for(let ee=1;ee<fe.length;ee++)fe[ee-1].equals(fe[ee])&&(fe.splice(ee,1),ee--);if(fe.length===1)return fe[0];if(ye){for(let ee=0;ee<fe.length;ee++)for(let ie=ee+1;ie<fe.length;ie++)if(fe[ee].negate().equals(fe[ie]))return l.INSTANCE;if(fe.length===1)return fe[0]}return new Q(fe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new Q(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),ye=U.shift(),fe=[];for(const me of ge(ne))for(const ee of ge(ye))fe.push(le.create([me,ee],null,!1));U.unshift(Q.create(fe,null,!1))}this.c=Q.create(U,this,!0)}return this.c}}e.$ej=Q;class Z extends S{static{this.d=[]}static all(){return Z.d.values()}constructor(U,ne,ye){super(U,null),this.f=ne,typeof ye=="object"?Z.d.push({...ye,key:U}):ye!==!0&&Z.d.push({key:U,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return L.create(this.key,U)}notEqualsTo(U){return E.create(this.key,U)}}e.$fj=Z,e.$gj=(0,P.$1h)("contextKeyService");function x(H,U){return H<U?-1:H>U?1:0}function oe(H,U,ne,ye){return H<ne?-1:H>ne?1:U<ye?-1:U>ye?1:0}function X(H,U){if(H.type===0||U.type===1)return!0;if(H.type===9)return U.type===9?ve(H.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(X(H,ne))return!0;return!1}if(H.type===6){if(U.type===6)return ve(U.expr,H.expr);for(const ne of H.expr)if(X(ne,U))return!0;return!1}return H.equals(U)}e.$hj=X;function ve(H,U){let ne=0,ye=0;for(;ne<H.length&&ye<U.length;){const fe=H[ne].cmp(U[ye]);if(fe<0)return!1;fe===0&&ne++,ye++}return ne===H.length}function ge(H){return H.type===9?H.expr:[H]}}),define(Se[239],ke([1,0,23,39,198,5,102,11,24]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sv=e.$Rv=e.ConfirmResult=e.$Qv=e.$Pv=e.$Ov=void 0,e.$Ov=(0,P.$1h)("dialogService");var y;(function(f){f[f.Confirmation=1]="Confirmation",f[f.Prompt=2]="Prompt",f[f.Input=3]="Input"})(y||(y={}));class R{a(d){return this.d(d,y.Confirmation)}b(d){return this.d(d,y.Prompt)}c(d){return this.d(d,y.Input)}d(d,s){const i=[];switch(s){case y.Confirmation:{const n=d;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const n=d;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const n=d;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===O.default.Info?"info":d===O.default.Error?"error":d===O.default.Warning?"warning":"none"}f(d,s,i){const n=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&n.push(d.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Pv=R,e.$Qv=(0,P.$1h)("fileDialogService");var C;(function(f){f[f.SAVE=0]="SAVE",f[f.DONT_SAVE=1]="DONT_SAVE",f[f.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function v(f){const d=[];return d.push(...f.slice(0,m).map(s=>typeof s=="string"?s:(0,D.$zg)(s))),f.length>m&&(f.length-m===1?d.push((0,g.localize)(7,null)):d.push((0,g.localize)(8,null,f.length-m))),d.push(""),d.join(`
`)}e.$Rv=v;function k(f,d){const s=(0,$.$fn)(f);let i=(s.buttons??[]).map(t=>(0,M.$Lv)(t)),n=(f.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||d.nameLong,{options:s,buttonIndeces:n}}e.$Sv=k}),define(Se[133],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=void 0,e.$8h=(0,D.$1h)("environmentService"),e.$9h=(0,D.$2h)(e.$8h)}),define(Se[134],ke([1,0,199,5]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$io=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=void 0,e.$9n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0n=new RegExp(e.$9n),e.$$n="__web_extension",e.$_n="skipWalkthrough",e.$ao="extensionsSync",e.$bo="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$co=g;function P(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$do=P;function M(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$eo=M;function b(s,i){return i==="web"&&!s.includes("web")}e.$fo=b;function $(s,i,n){return b(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$go=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$ho=y;var R;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$io=(0,O.$1h)("extensionGalleryService");var k;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var f;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class d extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$jo=d,e.$ko=(0,O.$1h)("extensionManagementService"),e.$lo="extensionsIdentifiers/disabled",e.$mo="extensionsIdentifiers/enabled",e.$no=(0,O.$1h)("IGlobalExtensionEnablementService"),e.$oo=(0,O.$1h)("IExtensionTipsService"),e.$po=(0,D.localize)(0,null),e.$qo={value:e.$po,original:"Extensions"},e.$ro={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Se[240],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L1b=e.$K1b=void 0,e.$K1b=(0,D.$1h)("externalTerminal"),e.$L1b="Terminal.app"}),define(Se[241],ke([1,0,51,17,16,11,101,31,104,201,240]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I9b=e.$H9b=e.$G9b=void 0;const C=y.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends m{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(D,o,$.$Ml(),a)}spawnTerminal(o,a,t,r){const h=a.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=g.$nc(h,".exe").toLowerCase();if(u==="cmder")return o.spawn(h,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return h.indexOf(" ")>=0&&c.push('""'),c.push(h),u==="wt"&&c.push("-d ."),new Promise((l,S)=>{const L=d(process),w=o.spawn(t,c,{cwd:r,env:L});w.on("error",S),w.on("exit",()=>l())})}runInTerminal(o,a,t,r,h){const u="windowsExec"in h&&h.windowsExec?h.windowsExec:v.getDefaultTerminalWindows();return new Promise((c,l)=>{const S=`"${a} - ${C}"`,L=`""${t.join('" "')}" & pause"`,w=Object.assign({},d(process),r);Object.keys(w).filter(N=>w[N]===null).forEach(N=>delete w[N]);const p={cwd:a,env:w,windowsVerbatimArguments:!0};let E,A;g.$nc(u,".exe")==="wt"?(E=u,A=["-d",".",v.b,"/c",L]):(E=v.b,A=["/c","start",S,"/wait",u,"/c",L]),D.spawn(E,A,p).on("error",N=>{l(s(N))}),c(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v.d}}e.$G9b=v;class k extends m{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,h){const u=h.osxExec||R.$L1b;return new Promise((c,l)=>{if(u===R.$L1b||u==="iTerm.app"){const S=u===R.$L1b?"TerminalHelper":"iTermHelper",w=[O.$jg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",o||C,"-w",a];for(const A of t)w.push("-a"),w.push(A);if(r){const A=Object.assign({},d(process),r);for(const z in A){const N=A[z];N===null?(w.push("-u"),w.push(z)):(w.push("-e"),w.push(`${z}=${N}`))}}let p="";const E=D.spawn(k.b,w);E.on("error",A=>{l(s(A))}),E.stderr.on("data",A=>{p+=A.toString()}),E.on("exit",A=>{if(A===0)c(void 0);else if(p){const z=p.split(`
`,1);l(new Error(z[0]))}else l(new Error(y.localize(1,null,S,A)))})}else l(new Error(y.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||R.$L1b;return new Promise((h,u)=>{const c=["-a",r];t&&c.push(t);const l=d(process),S=o.spawn("/usr/bin/open",c,{cwd:t,env:l});S.on("error",u),S.on("exit",()=>h())})}}e.$H9b=k;class f extends m{static{this.b=y.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,h){const u=h.linuxExec?Promise.resolve(h.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,l)=>{const S=[];u.then(L=>{L.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const w=`${i(t)}; echo; read -p "${f.b}" -n1;`;S.push(`''${w}''`);const p=Object.assign({},d(process),r);Object.keys(p).filter(N=>p[N]===null).forEach(N=>delete p[N]);const E={cwd:a,env:p};let A="";const z=D.spawn(L,S,E);z.on("error",N=>{l(s(N))}),z.stderr.on("data",N=>{A+=N.toString()}),z.on("exit",N=>{if(N===0)c(void 0);else if(A){const I=A.split(`
`,1);l(new Error(I[0]))}else l(new Error(y.localize(4,null,L,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!P.$k)f.d=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");f.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return f.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((h,u)=>{r.then(c=>{const l=d(process),S=o.spawn(c,[],{cwd:t,env:l});S.on("error",u),S.on("exit",()=>h())})})}}e.$I9b=f;function d(n){const o={...n.env};return(0,M.$Kl)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(y.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(Se[32],ke([1,0,77,16,13,18,2,202,5,11,17,43]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileKind=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileOperationResult=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileChangeType=e.$Bk=e.FileOperation=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderErrorCode=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileSystemProviderCapabilities=e.$lk=e.FilePermission=e.FileType=e.$kk=e.$jk=void 0,e.$jk=(0,$.$1h)("fileService");function m(X){return X.create===!0}e.$kk=m;var v;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var k;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function f(X){const ve=X;return!!ve&&typeof ve.onDidChange=="function"}e.$lk=f;var d;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function s(X){return!!(X.capabilities&2)}e.$mk=s;function i(X){return!!(X.capabilities&8)}e.$nk=i;function n(X){return!!(X.capabilities&131072)}e.$ok=n;function o(X){return!!(X.capabilities&4)}e.$pk=o;function a(X){return!!(X.capabilities&16)}e.$qk=a;function t(X){return s(X)?!!(X.capabilities&16384):!1}e.$rk=t;function r(X){return s(X)?!!(X.capabilities&32768):!1}e.$sk=r;function h(X){return!!(X.capabilities&65536)}e.$tk=h;function u(X){return!!(X.capabilities&2048)}e.$uk=u;var c;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class l extends Error{static create(ve,ge){const H=new l(ve.toString(),ge);return w(H,ge),H}constructor(ve,ge){super(ve),this.code=ge}}e.$vk=l;function S(X,ve){return l.create(X,ve)}e.$wk=S;function L(X){return X||S((0,b.localize)(0,null),c.Unknown)}e.$xk=L;function w(X,ve){return X.name=ve?`${ve} (FileSystemError)`:"FileSystemError",X}e.$yk=w;function p(X){if(!X)return c.Unknown;if(X instanceof l)return X.code;const ve=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ve)return c.Unknown;switch(ve[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$zk=p;function E(X){if(X instanceof T)return X.fileOperationResult;switch(p(X)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$Ak=E;var A;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class z{constructor(ve,ge,H){this.resource=ve,this.operation=ge,this.target=H}isOperation(ve){return this.operation===ve}}e.$Bk=z;var N;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class I{static{this.a=null}constructor(ve,ge){this.c=ge,this.b=void 0,this.d=new C.$V(()=>{const H=D.$7h.forUris(()=>this.c);return H.fill(this.rawAdded.map(U=>[U,!0])),H}),this.f=new C.$V(()=>{const H=D.$7h.forUris(()=>this.c);return H.fill(this.rawUpdated.map(U=>[U,!0])),H}),this.g=new C.$V(()=>{const H=D.$7h.forUris(()=>this.c);return H.fill(this.rawDeleted.map(U=>[U,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ve){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==I.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=I.a):this.b!==void 0&&(this.b=I.a))}}contains(ve,...ge){return this.h(ve,{includeChildren:!1},...ge)}affects(ve,...ge){return this.h(ve,{includeChildren:!0},...ge)}h(ve,ge,...H){if(!ve)return!1;const U=H.length>0;return!!((!U||H.includes(1))&&(this.d.value.get(ve)||ge.includeChildren&&this.d.value.findSuperstr(ve))||(!U||H.includes(0))&&(this.f.value.get(ve)||ge.includeChildren&&this.f.value.findSuperstr(ve))||(!U||H.includes(2))&&(this.g.value.findSubstr(ve)||ge.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$Ck=I;function j(X,ve,ge){return!X||!ve||X===ve||ve.length>X.length?!1:(ve.charAt(ve.length-1)!==O.sep&&(ve+=O.sep),ge?(0,g.$8e)(X,ve):X.indexOf(ve)===0)}e.$Dk=j;class T extends Error{constructor(ve,ge,H){super(ve),this.fileOperationResult=ge,this.options=H}}e.$Ek=T;class F extends T{constructor(ve,ge,H,U){super(ve,ge,U),this.fileOperationResult=ge,this.size=H}}e.$Fk=F;class W extends T{constructor(ve,ge,H){super(ve,2,H),this.stat=ge}}e.$Gk=W;var Y;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Hk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ik={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Jk="files.associations",e.$Kk="files.exclude",e.$Lk="files.readonlyInclude",e.$Mk="files.readonlyExclude",e.$Nk="files.readonlyFromPermissions";var le;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Ok="";function Q(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$Pk=Q;async function Z(X,ve){if(!ve.hasProvider(M.URI.from({scheme:X.scheme})))return new Promise(ge=>{const H=ve.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===X.scheme&&U.added&&(H.dispose(),ge())})})}e.$Qk=Z;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(ve){return(0,P.$Hf)(ve)||(ve=0),ve<x.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<x.MB?(0,b.localize)(2,null,(ve/x.KB).toFixed(2)):ve<x.GB?(0,b.localize)(3,null,(ve/x.MB).toFixed(2)):ve<x.TB?(0,b.localize)(4,null,(ve/x.GB).toFixed(2)):(0,b.localize)(5,null,(ve/x.TB).toFixed(2))}}e.$Rk=x;function oe(X){const ve=typeof X=="string"||X?.scheme===R.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===R.Schemas.file?1024*x.MB:ve?10*x.MB:y.$o?50*x.MB:1024*x.MB}e.$Sk=oe}),define(Se[242],ke([1,0,22,8,203,32]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;async function M(R,C,m,v,k,f){let d;try{await b(R,C,m,v,k,f)}catch(s){d=s}finally{d&&k.errorTransformer&&(d=k.errorTransformer(d)),typeof d<"u"&&m.error(d),m.end()}}e.$Xp=M;async function b(R,C,m,v,k,f){$(f);const d=await R.open(C,{create:!1});try{$(f);let s=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),a=k&&typeof k.position=="number"?k.position:0,t=0;do i=await R.read(d,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await m.write(v(o)),o=D.$ge.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(f)&&y(s,k));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),m.write(v(o.slice(0,r)))}}catch(s){throw(0,P.$xk)(s)}finally{await R.close(d)}}function $(R){if(R.isCancellationRequested)throw(0,O.$6)();return!0}function y(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,P.$wk)((0,g.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],ke([1,0,34,3,16,11,2,32]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=void 0;function $(s){return s.recursive===!0}e.$Zp=$;class y extends O.$Sc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new O.$Tc),this.f=void 0,this.g=0}s(){const i=new O.$Rc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$1p=y;class R extends y{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$2p=R;class C extends y{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$3p=C;function m(s){return s.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}e.$4p=m;function v(s){const i=new d;for(const n of s)i.processEvent(n);return i.coalesce()}e.$5p=v;function k(s,i){return typeof i=="string"&&!i.startsWith(D.$Dj)&&!(0,g.$ic)(i)?{base:s,pattern:i}:i}e.$6p=k;function f(s,i){const n=[];for(const o of i)n.push((0,D.$Hj)(k(s,o)));return n}e.$7p=f;class d{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,b.$Dk)(o.resource.fsPath,a,!P.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(Se[243],ke([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class f extends M.$Sc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new O.$dh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$ch(t=>this.z(t),f.b)),this.g=(0,k.$7p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$7p)(this.m.path,this.m.includes):void 0,this.j=new g.$3d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$eq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,P.$3f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.$Sc.None;const o=new g.$3d(this.j.token),a=new M.$Rc;try{const t=C.URI.file(this.m.path),r=(0,$.$nc)(i),h=(0,D.watch)(i);a.add((0,M.$Qc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const l of await v.Promises.readdir(i))u.add(l)}catch(l){this.D(l)}const c=new Map;a.add((0,M.$Qc)(()=>{for(const[,l]of c)l.dispose();c.clear()})),h.on("error",(l,S)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${l}, ${S})`),this.dispose()}),h.on("change",(l,S)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${S}`);let L="";if(S&&(L=S.toString(),y.$j&&(L=(0,b.$zl)(L))),!(!L||l!=="change"&&l!=="rename"))if(n)if(l==="rename"){c.get(L)?.dispose();const w=setTimeout(async()=>{if(c.delete(L),L===r&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,$.$jc)(i,L));if(o.token.isCancellationRequested)return;let E;p?u.has(L)?E=0:(E=1,u.add(L)):(u.delete(L),E=2),this.y({resource:(0,R.$Cg)(t,L),type:E,cId:this.m.correlationId})},f.a);c.set(L,(0,M.$Qc)(()=>clearTimeout(w)))}else{let w;u.has(L)?w=0:(w=1,u.add(L)),this.y({resource:(0,R.$Cg)(t,L),type:w,cId:this.m.correlationId})}else if(l==="rename"||L!==r){const w=setTimeout(async()=>{const p=await v.Promises.exists(i);o.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},f.a);a.clear(),a.add((0,M.$Qc)(()=>clearTimeout(w)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,M.$Qc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$5p)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await v.Promises.readdir((0,$.$mc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$hq=f;async function d(s,i,n,o,a=512){const t=await v.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),h=new g.$3d(o);let u,c=!1;const l={path:s,excludes:[],recursive:!1},S=new f(l,L=>{(async()=>{for(const{type:w}of L)if(w===0){if(c)return;c=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,r,0,a,null);if(!p||h.token.isCancellationRequested)break;i(r.slice(0,p))}}catch(p){u=new Error(p),h.dispose(!0)}finally{c=!1}}})()});return await S.ready,n(),new Promise((L,w)=>{h.token.onCancellationRequested(async()=>{S.dispose();try{await v.Promises.close(t)}catch(p){u=new Error(p)}u?w(u):L()})})}e.$iq=d}),define(Se[244],ke([1,0,4,34,3,11,243]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;class b extends g.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const R=this.j(y),C=R.filter(v=>{const k=this.c.get(v.path);return k?!(0,O.$Lj)(k.request.excludes,v.excludes)||!(0,O.$Lj)(k.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!R.find(k=>k.path===v.path&&(0,O.$Lj)(k.excludes,v.excludes)&&(0,O.$Lj)(k.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of C)this.g(v)}g(y){const R=new M.$hq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:R};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const R=this.c.get(y);R&&(this.c.delete(y),R.instance.dispose())}j(y){const R=new Map;for(const C of y){const m=P.$k?C.path:C.path.toLowerCase();let v=R.get(C.correlationId);v||(v=new Map,R.set(C.correlationId,v)),v.set(m,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,R]of this.c)R.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,R){return R?`[File Watcher (node.js)] ${y} (path: ${R.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$jq=b}),define(Se[245],ke([1,0,84,244]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class g extends D.$2p{constructor(M,b,$){super(M,b,$),this.s()}r(M){return M.add(new O.$jq)}}e.$kq=g}),define(Se[246],ke([1,0,17,81,186,84]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class M extends P.$3p{constructor($,y,R){super($,y,R),this.s()}r($){const y=$.add(new g.$bq(D.$jg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),O.ProxyChannel.toService((0,O.$Hh)(y.getChannel("watcher")))}}e.$cq=M}),define(Se[107],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class D{constructor(...g){this.a=new Map;for(const[P,M]of g)this.set(P,M)}set(g,P){const M=this.a.get(g);return this.a.set(g,P),M}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Yh=D}),define(Se[247],ke([1,0,12,8,3,105,238,5,107,75]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;const R=!1;class C extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class m{constructor(d=new $.$Yh,s=!1,i,n=R){this.f=d,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Zh,this),this._globalGraph=n?i?._globalGraph??new M.$nq(o=>o):void 0}createChild(d){return new m(d,this.g,this,this.i)}invokeFunction(d,...s){const i=k.traceInvocation(this.i,d);let n=!1;try{return d({get:a=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(d,...s){let i,n;return d instanceof P.$Xh?(i=k.traceCreation(this.i,d.ctor),n=this.j(d.ctor,d.staticArguments.concat(s),i)):(i=k.traceCreation(this.i,d),n=this.j(d,s,i)),i.stop(),n}j(d,s=[],i){const n=b._util.getServiceDependencies(d).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${d.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(d,s.concat(o))}k(d,s){if(this.f.get(d)instanceof P.$Xh)this.f.set(d,s);else if(this.h)this.h.k(d,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const s=this.f.get(d);return!s&&this.h?this.h.l(d):s}m(d,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const i=this.l(d);return i instanceof P.$Xh?this.q(d,i,s.branch(d,!0)):(s.branch(d,!1),i)}q(d,s,i){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,s,i)}finally{this.o.delete(d)}}r(d,s,i){const n=new M.$nq(t=>t.id.toString());let o=0;const a=[{id:d,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new C(n);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const h=this.l(r.id);if(h||this.u(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),h instanceof P.$Xh){const u={id:r.id,desc:h,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof P.$Xh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(d)}s(d,s,i=[],n,o){if(this.f.get(d)instanceof P.$Xh)return this.t(d,s,i,n,o);if(this.h)return this.h.s(d,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(d,s,i=[],n,o){if(n){const a=new m(void 0,this.g,this,this.i);a.c=String(d);const t=new Map,r=new D.$hh(()=>{const h=a.j(s,i,o);for(const[u,c]of t){const l=h[u];if(typeof l=="function")for(const S of c)l.apply(h,S)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let S=t.get(u);return S||(S=new y.$3c,t.set(u,S)),(w,p,E)=>{const A=S.push([w,p,E]);return(0,g.$Qc)(A)}}if(u in h)return h[u];const c=r.value;let l=c[u];return typeof l!="function"||(l=l.bind(c),h[u]=l),l},set(h,u,c){return r.value[u]=c,!0},getPrototypeOf(h){return s.prototype}})}else return this.j(s,i,o)}u(d,s){if(s&&console.warn(d),this.g)throw new Error(d)}}e.$oq=m;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,s){return d?new k(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(d,s){return d?new k(1,s.name):k.c}static{this.f=0}constructor(d,s){this.type=d,this.name=s,this.g=Date.now(),this.h=[]}branch(d,s){const i=new k(3,d.toString());return this.h.push([d,s,i]),i}stop(){const d=Date.now()-this.g;k.f+=d;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[h,u,c]of a.h)if(u&&c){s=!0,t.push(`${r}CREATES -> ${h}`);const l=i(o+1,c);l&&t.push(l)}else t.push(`${r}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(d>2||s)&&k.all.add(n.join(`
`))}}e.$pq=k}),define(Se[14],ke([1,0,44,4,53,3,28,11,23,18,2,46,5]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,m.$1h)("logService"),e.$jj=(0,m.$1h)("loggerService");function v(){return new Date().toISOString()}function k(w){return(0,y.$Hf)(w)}e.$kj=k;var f;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$lj=f.Info;function d(w,p,E){switch(p){case f.Trace:w.trace(E);break;case f.Debug:w.debug(E);break;case f.Info:w.info(E);break;case f.Warning:w.warn(E);break;case f.Error:w.error(E);break;case f.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=d;function s(w,p=!1){let E="";for(let A=0;A<w.length;A++){let z=w[A];if(z instanceof Error&&(z=(0,D.$Li)(z,p)),typeof z=="object")try{z=JSON.stringify(z)}catch{}E+=(A>0?" ":"")+z}return E}class i extends P.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new O.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==f.Off&&this.b<=p}}e.$nj=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...E){this.f(f.Trace)&&this.g(f.Trace,s([p,...E],!0))}debug(p,...E){this.f(f.Debug)&&this.g(f.Debug,s([p,...E]))}info(p,...E){this.f(f.Info)&&this.g(f.Info,s([p,...E]))}warn(p,...E){this.f(f.Warning)&&this.g(f.Warning,s([p,...E]))}error(p,...E){if(this.f(f.Error))if(p instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=p.stack,this.g(f.Error,s(A))}else this.g(f.Error,s([p,...E]))}flush(){}}e.$oj=n;class o extends i{constructor(p=e.$lj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...E){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}debug(p,...E){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}info(p,...E){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}warn(p,...E){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...E):console.warn(`[main ${v()}]`,p,...E))}error(p,...E){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...E):console.error(`[main ${v()}]`,p,...E))}dispose(){}flush(){}}e.$pj=o;class a extends i{constructor(p=e.$lj,E=!0){super(),this.g=E,this.setLevel(p)}trace(p,...E){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...E):console.log(p,...E))}debug(p,...E){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...E):console.log(p,...E))}info(p,...E){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...E):console.log(p,...E))}warn(p,...E){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...E):console.log(p,...E))}error(p,...E){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...E):console.error(p,...E))}dispose(){}flush(){}}e.$qj=a;class t extends i{constructor(p,E=e.$lj){super(),this.g=p,this.setLevel(E)}trace(p,...E){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(p),...E])}debug(p,...E){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(p),...E])}info(p,...E){this.f(f.Info)&&this.g.log(f.Info,[this.h(p),...E])}warn(p,...E){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(p),...E])}error(p,...E){this.f(f.Error)&&this.g.log(f.Error,[this.h(p),...E])}h(p){return typeof p=="string"?p:(0,D.$Li)(p,this.f(f.Trace))}dispose(){}flush(){}}e.$rj=t;class r extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const E of this.g)E.setLevel(p);super.setLevel(p)}trace(p,...E){for(const A of this.g)A.trace(p,...E)}debug(p,...E){for(const A of this.g)A.debug(p,...E)}info(p,...E){for(const A of this.g)A.info(p,...E)}warn(p,...E){for(const A of this.g)A.warn(p,...E)}error(p,...E){for(const A of this.g)A.error(p,...E)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$sj=r;class h extends P.$Sc{constructor(p,E,A){if(super(),this.h=p,this.j=E,this.b=new M.$Ac,this.c=this.B(new O.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Sd),this.onDidChangeVisibility=this.g.event,A)for(const z of A)this.b.set(z.resource,{logger:void 0,info:z})}m(p){return(0,y.$Df)(p)?[...this.b.values()].find(E=>E.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,E){const A=this.n(p),z=(0,y.$Df)(p)?p:E?.id??(0,g.$Oi)(A.toString()).toString(16);let N=this.b.get(A)?.logger;const I=E?.logLevel==="always"?f.Trace:E?.logLevel;N||(N=this.s(A,I??this.getLogLevel(A)??this.h,{...E,id:z}));const j={logger:N,info:{resource:A,id:z,logLevel:I,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(A,j),N}n(p){return(0,y.$Df)(p)?(0,$.$Cg)(this.j,`${p}.log`):p}setLogLevel(p,E){if(R.URI.isUri(p)){const A=p,z=E,N=this.b.get(A);N&&z!==N.info.logLevel&&(N.info.logLevel=z===this.h?void 0:z,N.logger?.setLevel(z),this.b.set(N.info.resource,N),this.f.fire([A,z]))}else{this.h=p;for(const[A,z]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,E){const A=this.m(p);A&&E!==!A.info.hidden&&(A.info.hidden=!E,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,E]))}getLogLevel(p){let E;return p&&(E=this.b.get(p)?.info.logLevel),E??this.h}registerLogger(p){const E=this.b.get(p.resource);E?E.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const E=this.b.get(p);E&&(E.logger&&E.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=h;class u{constructor(){this.onDidChangeLogLevel=new O.$Sd().event}setLevel(p){}getLevel(){return f.Info}trace(p,...E){}debug(p,...E){}info(p,...E){}warn(p,...E){}error(p,...E){}critical(p,...E){}dispose(){}flush(){}}e.$uj=u;class c extends u{}e.$vj=c;function l(w){if(w.verbose)return f.Trace;if(typeof w.logLevel=="string"){const p=L(w.logLevel.toLowerCase());if(p!==void 0)return p}return e.$lj}e.$wj=l;function S(w){switch(w){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$xj=S;function L(w){switch(w){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$yj=L,e.$zj=new C.$fj("logLevel",S(f.Info))}),define(Se[248],ke([1,0,19,12,8,4,3,16,84,14]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class R extends M.$Sc{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new P.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Yg(0)),this.w=[],this.y=this.B(new O.$Yg(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(m,v):this.z(m,v)}n(m,v){const k={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},f=(0,D.$Ub)(this.j,k);return this.r(),(0,M.$Qc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,$.$4p)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,$.$Zp)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,$.$Zp)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,v){const k={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},f=(0,D.$Ub)(this.w,k);return this.C(),(0,M.$Qc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$4p)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$8p=R}),define(Se[249],ke([1,0,55,386,12,28,22,4,33,3,16,11,23,98,31,204,32,242,248,44,246,245]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Li)(r)}`)}})();class t extends i.$8p{static{this.I=!1}constructor(h,u){super(h,u),this.onDidChangeCapabilities=b.Event.None,this.N=new P.$Ac(c=>m.$tg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(h){try{const{stat:u,symbolicLink:c}=await k.SymlinkSupport.stat(this.H(h));return{type:this.M(u,c),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:d.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const u=await k.Promises.readdir(this.H(h),{withFileTypes:!0}),c=[];return await Promise.all(u.map(async l=>{try{let S;l.isSymbolicLink()?S=(await this.stat((0,m.$Cg)(h,l.name))).type:S=this.M(l),c.push([l.name,S])}catch(S){this.a.trace(S)}})),c}catch(u){throw this.fb(u)}}M(h,u){let c;return u?.dangling?c=d.FileType.Unknown:h.isFile()?c=d.FileType.File:h.isDirectory()?c=d.FileType.Directory:c=d.FileType.Unknown,u&&(c|=d.FileType.SymbolicLink),c}async O(h){const u=this.H(h);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let c;for(;c=this.N.get(h);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await c.wait();const l=new g.$Zg;return this.N.set(h,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,y.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(h)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(h)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),l.open()})}async readFile(h,u){let c;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(h)})`),c=await this.O(h));const l=this.H(h);return await k.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{c?.dispose()}}P(h){t.I&&this.a.trace(h)}readFileStream(h,u,c){const l=(0,v.$7d)(S=>M.$ge.concat(S.map(L=>M.$ge.wrap(L))).buffer);return(0,s.$Xp)(this,h,l,S=>S.buffer,{...u,bufferSize:256*1024},c),l}async writeFile(h,u,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(h)?this.R(h,(0,m.$Cg)((0,m.$Bg)(h),`${(0,m.$zg)(h)}${c.atomic.postfix}`),u,c):this.S(h,u,c)}async Q(h){try{const u=this.H(h),{symbolicLink:c}=await k.SymlinkSupport.stat(u);if(c)return!1}catch{}return!0}async R(h,u,c,l){const S=new y.$Rc;try{S.add(await this.O(h)),S.add(await this.O(u)),await this.S(u,c,l,!0);try{await this.rename(u,h,{overwrite:!0})}catch(L){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw L}}finally{S.dispose()}}async S(h,u,c,l){let S;try{const L=this.H(h);if(!c.create||!c.overwrite){if(await k.Promises.exists(L)){if(!c.overwrite)throw(0,d.$wk)((0,f.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,d.$wk)((0,f.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(h,{create:!0,unlock:c.unlock},l),await this.write(S,0,u,0,u.byteLength)}catch(L){throw await this.gb(h,L)}finally{typeof S=="number"&&await this.close(S)}}static{this.Y=!0}static configureFlushOnWrite(h){t.Y=h}async open(h,u,c){const l=this.H(h);let S;(0,d.$kk)(u)&&!c&&(S=await this.O(h));let L;try{if((0,d.$kk)(u)&&u.unlock)try{const{stat:p}=await k.SymlinkSupport.stat(l);p.mode&128||await k.Promises.chmod(l,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let w;if((0,d.$kk)(u)){if(C.$i)try{await k.Promises.truncate(l,0),w="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}w||(w="w")}else w="r";L=await k.Promises.open(l,w)}catch(w){throw S?.dispose(),(0,d.$kk)(u)?await this.gb(h,w):this.fb(w)}if(this.U.set(L,0),(0,d.$kk)(u)&&this.X.set(L,h),S){const w=this.W.get(L);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${L} (${l})`),this.W.set(L,S),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${L} (${l})`),w.dispose())}return L}async close(h){const u=this.W.get(h);try{if(this.U.delete(h),this.X.delete(h)&&t.Y)try{await k.Promises.fdatasync(h)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await k.Promises.close(h)}catch(c){throw this.fb(c)}finally{u&&(this.W.get(h)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.W.delete(h)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),u.dispose())}}async read(h,u,c,l,S){const L=this.Z(h,u);let w=null;try{w=(await k.Promises.read(h,c,l,S,L)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(h,L,w)}return w}Z(h,u){return u===this.U.get(h)?null:u}$(h,u,c){const l=this.U.get(h);typeof l=="number"&&(typeof u=="number"||(typeof c=="number"?this.U.set(h,l+c):this.U.delete(h)))}async write(h,u,c,l,S){return(0,g.$ih)(()=>this.ab(h,u,c,l,S),100,3)}async ab(h,u,c,l,S){const L=this.Z(h,u);let w=null;try{w=(await k.Promises.write(h,c,l,S,L)).bytesWritten}catch(p){throw await this.gb(this.X.get(h),p)}finally{this.$(h,L,w)}return w}async mkdir(h){try{await k.Promises.mkdir(this.H(h))}catch(u){throw this.fb(u)}}async delete(h,u){try{const c=this.H(h);if(u.recursive){let l;u?.atomic!==!1&&u.atomic.postfix&&(l=(0,R.$jc)((0,R.$mc)(c),`${(0,R.$nc)(c)}${u.atomic.postfix}`)),await k.Promises.rm(c,k.RimRafMode.MOVE,l)}else try{await k.Promises.unlink(c)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let S=!1;try{const{stat:L,symbolicLink:w}=await k.SymlinkSupport.stat(c);S=L.isDirectory()&&!w}catch{}if(S)await k.Promises.rmdir(c);else throw l}else throw l}}catch(c){throw this.fb(c)}}async rename(h,u,c){const l=this.H(h),S=this.H(u);if(l!==S)try{await this.bb(h,u,"move",c.overwrite),await k.Promises.rename(l,S)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,f.localize)(2,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)(S)),L.toString()))),this.fb(L)}}async copy(h,u,c){const l=this.H(h),S=this.H(u);if(l!==S)try{await this.bb(h,u,"copy",c.overwrite),await k.Promises.copy(l,S,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,f.localize)(3,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)(S)),L.toString()))),this.fb(L)}}async bb(h,u,c,l){const S=this.H(h),L=this.H(u);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$2f)(S,L,!0)),w){if(c==="copy")throw(0,d.$wk)((0,f.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const E=await this.L(h);if(!E)throw(0,d.$wk)((0,f.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(u);if(A){if(!l)throw(0,d.$wk)((0,f.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);E.type&d.FileType.File&&A.type&d.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,u){return this.cb(h,u,!1)}async cb(h,u,c){const l=this.H(h),S=this.H(u),L=!!(this.capabilities&1024);if((0,$.$2f)(l,S,!L))return;const w=new y.$Rc;try{w.add(await this.O(h)),w.add(await this.O(u)),c&&await k.Promises.mkdir((0,R.$mc)(S),{recursive:!0}),await k.Promises.copyFile(l,S)}catch(p){if(p.code==="ENOENT"&&!c)return this.cb(h,u,!0);throw this.fb(p)}finally{w.dispose()}}t(h,u,c){return new o.$cq(l=>h(l),l=>u(l),c)}F(h,u,c){return new a.$kq(l=>h(l),l=>u(l),c)}fb(h){if(h instanceof d.$vk)return h;let u=h,c;switch(h.code){case"ENOENT":c=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=d.FileSystemProviderErrorCode.Unknown;break;default:c=d.FileSystemProviderErrorCode.Unknown}return(0,d.$wk)(u,c)}async gb(h,u){let c=this.fb(u);if(h&&c.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await k.SymlinkSupport.stat(this.H(h));l.mode&128||(c=(0,d.$wk)(u,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return c}}e.$lq=t}),define(Se[250],ke([1,0,3,14]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;class g extends D.$Sc{constructor(M,b=[]){super(),this.a=new O.$sj([M,...b]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$7N=g}),define(Se[251],ke([1,0,32,14]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function P(y,R,C,m,v){try{const k=await new Promise((d,s)=>{$e(["@vscode/spdlog"],d,s)});k.setFlushOn(g.Trace);const f=await k.createAsyncRotatingLogger(y,R,C,m);return v?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(k){console.error(k)}return null}function M(y,R,C){switch(R){case O.LogLevel.Trace:y.trace(C);break;case O.LogLevel.Debug:y.debug(C);break;case O.LogLevel.Info:y.info(C);break;case O.LogLevel.Warning:y.warn(C);break;case O.LogLevel.Error:y.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(y,R){switch(R){case O.LogLevel.Trace:y.setLevel(g.Trace);break;case O.LogLevel.Debug:y.setLevel(g.Debug);break;case O.LogLevel.Info:y.setLevel(g.Info);break;case O.LogLevel.Warning:y.setLevel(g.Warning);break;case O.LogLevel.Error:y.setLevel(g.Error);break;case O.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends O.$oj{constructor(R,C,m,v,k){super(),this.m=[],this.setLevel(k),this.n=this.s(R,C,m,v),this.B(this.onDidChangeLogLevel(f=>{this.r&&b(this.r,f)}))}async s(R,C,m,v){const k=m?6:1,f=30/k*D.$Rk.MB,d=await P(R,C,f,k,v);if(d){this.r=d,b(this.r,this.getLevel());for(const{level:s,message:i}of this.m)M(this.r,s,i);this.m=[]}}g(R,C){this.r?M(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$VN=$}),define(Se[135],ke([1,0,39,205,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function y(k,f){return f-k}$.compare=y;const R=Object.create(null);R[$.Error]=(0,O.localize)(0,null),R[$.Warning]=(0,O.localize)(1,null),R[$.Info]=(0,O.localize)(2,null);function C(k){return R[k]||""}$.toString=C;function m(k){switch(k){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function v(k){switch(k){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=v}(M||(e.MarkerSeverity=M={}));var b;(function($){const y="";function R(m){return C(m,!0)}$.makeKey=R;function C(m,v){const k=[y];return m.source?k.push(m.source.replace("\xA6","\\\xA6")):k.push(y),m.code?typeof m.code=="string"?k.push(m.code.replace("\xA6","\\\xA6")):k.push(m.code.value.replace("\xA6","\\\xA6")):k.push(y),m.severity!==void 0&&m.severity!==null?k.push(M.toString(m.severity)):k.push(y),m.message&&v?k.push(m.message.replace("\xA6","\\\xA6")):k.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?k.push(m.startLineNumber.toString()):k.push(y),m.startColumn!==void 0&&m.startColumn!==null?k.push(m.startColumn.toString()):k.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?k.push(m.endLineNumber.toString()):k.push(y),m.endColumn!==void 0&&m.endColumn!==null?k.push(m.endColumn.toString()):k.push(y),k.push(y),k.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$kt=(0,g.$1h)("markerService")}),define(Se[252],ke([1,0,4,39,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$_u=e.Severity=void 0,e.Severity=O.default,e.$_u=(0,g.$1h)("notificationService");var P;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var M;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));var b;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class ${constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$av=$;class y{infinite(){}done(){}total(C){}worked(C){}}e.$bv=y}),define(Se[253],ke([1,0,50]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const P=g.context.configuration();if(P)O=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:P.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(Se[136],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,D.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"});var We=this&&this.__param||function($e,e){return function(D,O){e(D,O,$e)}};define(Se[85],ke([1,0,12,21,3,5]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProgressLocation=e.$cv=void 0,e.$cv=(0,P.$1h)("progressService");var M;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$dv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$ev=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const v=this.d;this.d=()=>{v?.(),m()}}):Promise.resolve()}}e.$fv=$;let y=class extends g.$Sc{constructor(m,v){super(),this.a=new D.$lh,v.withProgress(m,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,g.$Qc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$gv=y,e.$gv=y=Ge([We(1,e.$cv)],y);class R extends g.$Sc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Rc)}start(m){this.stop();const v=++this.a,k=new O.$3d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Qc)(()=>k.cancel())),this.b.add((0,g.$Qc)(()=>this.c?this.c.done():void 0)),{id:v,token:k.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$hv=R,e.$iv=(0,P.$1h)("editorProgressService")}),define(Se[37],ke([1,0,60,18]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0;class g{constructor(){this.a=new Map}add(M,b){D.ok(O.$Df(M)),D.ok(O.$Ff(b)),D.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$rn=new g}),define(Se[108],ke([1,0,4,37]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0,e.$sn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class P{constructor(){this.b=new D.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new P;O.$rn.add(e.$sn.JSONContribution,M)}),define(Se[86],ke([1,0,19,4,18,195,45,108,37]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.ConfigurationScope=e.$wn=e.EditPresentationTypes=void 0;var y;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$wn={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn="vscode://schemas/settings/resourceLanguage",e.$En="vscode://schemas/settings/configurationDefaults";const C=$.$rn.as(b.$sn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new O.$Sd,this.onDidSchemaChange=this.i.event,this.j=new O.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Dn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const h=new Set;this.n(t,r,h),C.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const h=new Set;this.o(r,h),this.n(t,!1,h),C.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const h=[];for(const{overrides:u,source:c}of t)for(const l in u)if(r.add(l),e.$Gn.test(l)){const S=this.a.get(l),L=S?.valuesSources??new Map;if(c)for(const A of Object.keys(u[l]))L.set(A,c);const w={...S?.value||{},...u[l]};this.a.set(l,{source:c,value:w,valuesSources:L});const p=(0,M.$Ei)(l),E={type:"object",default:w,description:P.localize(1,null,p),$ref:e.$Dn,defaultDefaultValue:w,source:g.$Df(c)?void 0:c,defaultValueSource:c};h.push(...f(l)),this.d[l]=E,this.b.properties[l]=E}else{this.a.set(l,{value:u[l],source:c});const S=this.d[l];S&&(this.w(l,S),this.r(l,S))}this.m(h)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:h,source:u}of t)for(const c in h){const l=this.a.get(c),S=g.$Df(u)?u:u?.id,L=g.$Df(l?.source)?l?.source:l?.source?.id;if(S===L)if(r.add(c),this.a.delete(c),e.$Gn.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let r=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,h){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,h),this.c.push(u),this.q(u)})}o(t,r){const h=u=>{if(u.properties)for(const c in u.properties){r.add(c);const l=this.d[c];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[c],this.s(c,u.properties[c])}u.allOf?.forEach(c=>h(c))};for(const u of t){h(u);const c=this.c.indexOf(u);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,h,u,c=3,l){c=g.$Mf(t.scope)?c:t.scope;const S=t.properties;if(S)for(const w in S){const p=S[w];if(r&&n(w,p)){delete S[w];continue}if(p.source=h,p.defaultDefaultValue=S[w].default,this.w(w,p),e.$Gn.test(w)?p.scope=void 0:(p.scope=g.$Mf(p.scope)?c:p.scope,p.restricted=g.$Mf(p.restricted)?!!u?.includes(w):p.restricted),S[w].hasOwnProperty("included")&&!S[w].included){this.f[w]=S[w],delete S[w];continue}else this.d[w]=S[w],S[w].policy?.name&&this.e.set(S[w].policy.name,w);!S[w].deprecationMessage&&S[w].markdownDeprecationMessage&&(S[w].deprecationMessage=S[w].markdownDeprecationMessage),l.add(w)}const L=t.allOf;if(L)for(const w of L)this.p(w,r,h,u,c,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=h=>{const u=h.properties;if(u)for(const l in u)this.r(l,u[l]);h.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$xn.properties[t]=r,r.scope){case 1:e.$yn.properties[t]=r;break;case 2:e.$zn.properties[t]=r;break;case 6:e.$An.properties[t]=r;break;case 3:e.$Bn.properties[t]=r;break;case 4:e.$Cn.properties[t]=r;break;case 5:e.$Cn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$xn.properties[t],r.scope){case 1:delete e.$yn.properties[t];break;case 2:delete e.$zn.properties[t];break;case 6:delete e.$An.properties[t];break;case 3:delete e.$Bn.properties[t];break;case 4:case 5:delete e.$Cn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,h={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Dn};this.w(r,h),e.$xn.properties[r]=h,e.$yn.properties[r]=h,e.$zn.properties[r]=h,e.$An.properties[r]=h,e.$Bn.properties[r]=h,e.$Cn.properties[r]=h}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Dn};e.$xn.patternProperties[e.$Fn]=t,e.$yn.patternProperties[e.$Fn]=t,e.$zn.patternProperties[e.$Fn]=t,e.$An.patternProperties[e.$Fn]=t,e.$Bn.patternProperties[e.$Fn]=t,e.$Cn.patternProperties[e.$Fn]=t,this.i.fire()}w(t,r){const h=this.a.get(t);let u=h?.value,c=h?.source;g.$Kf(u)&&(u=r.defaultDefaultValue,c=void 0),g.$Kf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",k=new RegExp(v,"g");e.$Fn=`^(${v})+$`,e.$Gn=new RegExp(e.$Fn);function f(a){const t=[];if(e.$Gn.test(a)){let r=k.exec(a);for(;r?.length;){const h=r[1].trim();h&&t.push(h),r=k.exec(a)}}return(0,D.$Mb)(t)}e.$Hn=f;function d(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$In=d;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Jn=s;const i=new m;$.$rn.add(e.$wn.Configuration,i);function n(a,t){return a.trim()?e.$Gn.test(a)?P.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?P.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$Kn=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Ln=o}),define(Se[254],ke([1,0,19,4,159,3,28,24,18,2,45,86,37]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0;function v(r){return Object.isFrozen(r)?r:b.$gn(r)}class k{constructor(h={},u=[],c=[],l){this.b=h,this.c=u,this.d=c,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const h=this.raw.map(u=>{if(u instanceof k)return u;const c=new f("");return c.parseRaw(u),c.configurationModel});this.f=h.reduce((u,c)=>c===u?c:u.merge(c),h[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,R.$Ci)(this.contents,h):this.contents}inspect(h,u){const c=this.rawConfiguration.getValue(h),l=u?this.rawConfiguration.getOverrideValue(h,u):void 0,S=u?this.rawConfiguration.override(u).getValue(h):c;return{value:c,override:l,merged:S}}getOverrideValue(h,u){const c=this.i(u);return c?h?(0,R.$Ci)(c,h):c:void 0}getKeysForOverrideIdentifier(h){const u=[];for(const c of this.overrides)c.identifiers.includes(h)&&u.push(...c.keys);return D.$Mb(u)}getAllOverrideIdentifiers(){const h=[];for(const u of this.overrides)h.push(...u.identifiers);return D.$Mb(h)}override(h){let u=this.a.get(h);return u||(u=this.g(h),this.a.set(h,u)),u}merge(...h){const u=b.$fn(this.contents),c=b.$fn(this.overrides),l=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const L of h)if(S.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(u,L.contents);for(const w of L.overrides){const[p]=c.filter(E=>D.$ub(E.identifiers,w.identifiers));p?(this.h(p.contents,w.contents),p.keys.push(...w.keys),p.keys=D.$Mb(p.keys)):c.push(b.$fn(w))}for(const w of L.keys)l.indexOf(w)===-1&&l.push(w)}return new k(u,l,c,S.every(L=>L instanceof k)?void 0:S)}g(h){const u=this.i(h);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const c={};for(const l of D.$Mb([...Object.keys(this.contents),...Object.keys(u)])){let S=this.contents[l];const L=u[l];L&&(typeof S=="object"&&typeof L=="object"?(S=b.$fn(S),this.h(S,L)):S=L),c[l]=S}return new k(c,this.keys,this.overrides)}h(h,u){for(const c of Object.keys(u)){if(c in h&&$.$Ff(h[c])&&$.$Ff(u[c])){this.h(h[c],u[c]);continue}h[c]=b.$fn(u[c])}}i(h){let u=null,c=null;const l=S=>{S&&(c?this.h(c,S):c=b.$fn(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===h?u=S.contents:S.identifiers.includes(h)&&l(S.contents);return l(u),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,u){this.j(h,u,!0)}setValue(h,u){this.j(h,u,!1)}removeValue(h){const u=this.keys.indexOf(h);u!==-1&&(this.keys.splice(u,1),(0,R.$Bi)(this.contents,h),C.$Gn.test(h)&&this.overrides.splice(this.overrides.findIndex(c=>D.$ub(c.identifiers,(0,C.$Hn)(h))),1))}j(h,u,c){(0,R.$Ai)(this.contents,h,u,l=>console.error(l)),c=c||this.keys.indexOf(h)===-1,c&&this.keys.push(h),C.$Gn.test(h)&&this.overrides.push({identifiers:(0,C.$Hn)(h),keys:Object.keys(this.contents[h]),contents:(0,R.$zi)(this.contents[h],l=>console.error(l))})}}e.$Mn=k;class f{constructor(h){this.f=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,u){if(!$.$Mf(h)){const c=this.g(h);this.parseRaw(c,u)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,u){this.a=h;const{contents:c,keys:l,overrides:S,restricted:L,hasExcludedProperties:w}=this.h(h,u);this.b=new k(c,l,S,w?[h]:void 0),this.c=L||[]}g(h){let u={},c=null,l=[];const S=[],L=[];function w(E){Array.isArray(l)?l.push(E):c!==null&&(l[c]=E)}const p={onObjectBegin:()=>{const E={};w(E),S.push(l),l=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{l=S.pop()},onArrayBegin:()=>{const E=[];w(E),S.push(l),l=E,c=null},onArrayEnd:()=>{l=S.pop()},onLiteralValue:w,onError:(E,A,z)=>{L.push({error:E,offset:A,length:z})}};if(h)try{g.$cn(h,p),u=l[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return u}h(h,u){const c=m.$rn.as(C.$wn.Configuration).getConfigurationProperties(),l=this.i(h,c,!0,u);h=l.raw;const S=(0,R.$zi)(h,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),L=Object.keys(h),w=this.j(h,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:S,keys:L,overrides:w,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(h,u,c,l){let S=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:S};const L={},w=[];for(const p in h)if(C.$Gn.test(p)&&c){const E=this.i(h[p],u,!1,l);L[p]=E.raw,S=S||E.hasExcludedProperties,w.push(...E.restricted)}else{const E=u[p],A=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&w.push(p),!l.exclude?.includes(p)&&(l.include?.includes(p)||(A===void 0||l.scopes===void 0||l.scopes.includes(A))&&!(l.skipRestricted&&E?.restricted))?L[p]=h[p]:S=!0}return{raw:L,restricted:w,hasExcludedProperties:S}}j(h,u){const c=[];for(const l of Object.keys(h))if(C.$Gn.test(l)){const S={};for(const L in h[l])S[L]=h[l][L];c.push({identifiers:(0,C.$Hn)(l),keys:Object.keys(S),contents:(0,R.$zi)(S,u)})}return c}}e.$Nn=f;class d extends P.$Sc{constructor(h,u,c,l){super(),this.c=h,this.f=u,this.g=l,this.b=this.B(new O.$Sd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&c.isEqual(S.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$On=d;class s{constructor(h,u,c,l,S,L,w,p,E,A,z,N,I){this.a=h,this.b=u,this.c=c,this.overrideIdentifiers=l,this.d=S,this.f=L,this.g=w,this.h=p,this.i=E,this.j=A,this.k=z,this.l=N,this.m=I}get value(){return v(this.c)}n(h,u,c){const l=h.inspect(u,c);return{get value(){return v(l.value)},get override(){return v(l.override)},get merged(){return v(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(h,u,c,l,S=new k,L=new k,w=new M.$Ac,p=new k,E=new M.$Ac){this.c=h,this.d=u,this.f=c,this.g=l,this.h=S,this.i=L,this.j=w,this.l=p,this.m=E,this.a=null,this.b=new M.$Ac,this.n=null}getValue(h,u,c){return this.p(h,u,c).getValue(h)}updateValue(h,u,c={}){let l;c.resource?(l=this.m.get(c.resource),l||(l=new k,this.m.set(c.resource,l))):l=this.l,u===void 0?l.removeValue(h):l.setValue(h,u),c.resource||(this.a=null)}inspect(h,u,c){const l=this.p(h,u,c),S=this.t(u.resource,c),L=u.resource?this.m.get(u.resource)||this.l:this.l,w=new Set;for(const p of l.overrides)for(const E of p.identifiers)l.getOverrideValue(h,E)!==void 0&&w.add(E);return new s(h,u,l.getValue(h),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,S||void 0,L)}keys(h){const u=this.t(void 0,h);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(h){this.c=h,this.a=null,this.b.clear()}updatePolicyConfiguration(h){this.d=h}updateApplicationConfiguration(h){this.f=h,this.a=null,this.b.clear()}updateLocalUserConfiguration(h){this.g=h,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(h){this.h=h,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(h){this.i=h,this.a=null,this.b.clear()}updateFolderConfiguration(h,u){this.j.set(h,u),this.b.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.b.delete(h)}compareAndUpdateDefaultConfiguration(h,u){const c=[];if(!u){const{added:l,updated:S,removed:L}=a(this.c,h);u=[...l,...S,...L]}for(const l of u)for(const S of(0,C.$Hn)(l)){const L=this.c.getKeysForOverrideIdentifier(S),w=h.getKeysForOverrideIdentifier(S),p=[...w.filter(E=>L.indexOf(E)===-1),...L.filter(E=>w.indexOf(E)===-1),...L.filter(E=>!b.$jn(this.c.override(S).getValue(E),h.override(S).getValue(E)))];c.push([S,p])}return this.updateDefaultConfiguration(h),{keys:u,overrides:c}}compareAndUpdatePolicyConfiguration(h){const{added:u,updated:c,removed:l}=a(this.d,h),S=[...u,...c,...l];return S.length&&this.updatePolicyConfiguration(h),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:u,updated:c,removed:l,overrides:S}=a(this.applicationConfiguration,h),L=[...u,...c,...l];return L.length&&this.updateApplicationConfiguration(h),{keys:L,overrides:S}}compareAndUpdateLocalUserConfiguration(h){const{added:u,updated:c,removed:l,overrides:S}=a(this.localUserConfiguration,h),L=[...u,...c,...l];return L.length&&this.updateLocalUserConfiguration(h),{keys:L,overrides:S}}compareAndUpdateRemoteUserConfiguration(h){const{added:u,updated:c,removed:l,overrides:S}=a(this.remoteUserConfiguration,h),L=[...u,...c,...l];return L.length&&this.updateRemoteUserConfiguration(h),{keys:L,overrides:S}}compareAndUpdateWorkspaceConfiguration(h){const{added:u,updated:c,removed:l,overrides:S}=a(this.workspaceConfiguration,h),L=[...u,...c,...l];return L.length&&this.updateWorkspaceConfiguration(h),{keys:L,overrides:S}}compareAndUpdateFolderConfiguration(h,u){const c=this.folderConfigurations.get(h),{added:l,updated:S,removed:L,overrides:w}=a(c,u),p=[...l,...S,...L];return(p.length||!c)&&this.updateFolderConfiguration(h,u),{keys:p,overrides:w}}compareAndDeleteFolderConfiguration(h){const u=this.folderConfigurations.get(h);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:c,updated:l,removed:S,overrides:L}=a(u,void 0);return{keys:[...c,...l,...S],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(h,u,c){let l=this.q(u,c);return u.overrideIdentifier&&(l=l.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(h)!==void 0&&(l=l.merge(this.d)),l}q({resource:h},u){let c=this.r();if(u&&h){const l=u.getFolder(h);l&&(c=this.s(l.uri)||c);const S=this.m.get(h);S&&(c=c.merge(S))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(h){let u=this.b.get(h);if(!u){const c=this.r(),l=this.j.get(h);l?(u=c.merge(l),this.b.set(h,u)):u=c}return u}t(h,u){if(u&&h){const c=u.getFolder(h);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((h,u)=>{const{contents:c,overrides:l,keys:S}=this.j.get(u);return h.push([u,{contents:c,overrides:l,keys:S}]),h},[])}}allKeys(){const h=new Set;return this.c.keys.forEach(u=>h.add(u)),this.userConfiguration.keys.forEach(u=>h.add(u)),this.i.keys.forEach(u=>h.add(u)),this.j.forEach(u=>u.keys.forEach(c=>h.add(c))),[...h.values()]}u(){const h=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(c=>h.add(c))),[...h.values()]}v(h){const u=new Set;return this.c.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.i.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(h).forEach(l=>u.add(l))),[...u.values()]}static parse(h){const u=this.w(h.defaults),c=this.w(h.policy),l=this.w(h.application),S=this.w(h.user),L=this.w(h.workspace),w=h.folders.reduce((p,E)=>(p.set(y.URI.revive(E[0]),this.w(E[1])),p),new M.$Ac);return new i(u,c,l,S,new k,L,w,new k,new M.$Ac)}static w(h){return new k(h.contents,h.keys,h.overrides)}}e.$Pn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const h=new Set,u=new Map;for(const l of r)l.keys.forEach(S=>h.add(S)),l.overrides.forEach(([S,L])=>{const w=(0,M.$xc)(u,S,new Set);L.forEach(p=>w.add(p))});const c=[];return u.forEach((l,S)=>c.push([S,[...l.values()]])),{keys:[...h.values()],overrides:c}}e.$Qn=n;class o{constructor(h,u,c,l){this.change=h,this.f=u,this.g=c,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of h.keys)this.affectedKeys.add(S);for(const[,S]of h.overrides)for(const L of S)this.affectedKeys.add(L);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(h,u){const c=this.a+h,l=this.d.indexOf(c);if(l<0)return!1;const S=l+c.length;if(S>=this.d.length)return!1;const L=this.d.charCodeAt(S);if(L!==this.b&&L!==this.c)return!1;if(u){const w=this.previousConfiguration?this.previousConfiguration.getValue(h,u,this.f?.workspace):void 0,p=this.g.getValue(h,u,this.h);return!b.$jn(w,p)}return!0}}e.$Rn=o;function a(r,h){const{added:u,removed:c,updated:l}=t(h?.rawConfiguration,r?.rawConfiguration),S=[],L=r?.getAllOverrideIdentifiers()||[],w=h?.getAllOverrideIdentifiers()||[];if(h){const p=w.filter(E=>!L.includes(E));for(const E of p)S.push([E,h.getKeysForOverrideIdentifier(E)])}if(r){const p=L.filter(E=>!w.includes(E));for(const E of p)S.push([E,r.getKeysForOverrideIdentifier(E)])}if(h&&r){for(const p of L)if(w.includes(p)){const E=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:h.getOverrideValue(void 0,p)||{},keys:h.getKeysForOverrideIdentifier(p)});S.push([p,[...E.added,...E.removed,...E.updated]])}}return{added:u,removed:c,updated:l,overrides:S}}function t(r,h){const u=r?h?r.keys.filter(S=>h.keys.indexOf(S)===-1):[...r.keys]:[],c=h?r?h.keys.filter(S=>r.keys.indexOf(S)===-1):[...h.keys]:[],l=[];if(r&&h){for(const S of h.keys)if(r.keys.indexOf(S)!==-1){const L=(0,R.$Ci)(h.contents,S),w=(0,R.$Ci)(r.contents,S);b.$jn(L,w)||l.push(S)}}return{added:u,removed:c,updated:l}}}),define(Se[255],ke([1,0,22,4,3,82]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qb=e.$4qb=e.$3qb=e.$2qb=void 0;const M=(y,R,C)=>{const m=new Uint8Array(16);for(let f=0;f<16;f++)m[f]=Math.round(Math.random()*256);const v=(0,D.$Ae)(D.$ge.wrap(m));return[`GET ws://localhost${y}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$2qb=M,e.$3qb=D.$ge.fromString(`\r
\r
`);async function b(y,R,C,m,v){y.write(D.$ge.fromString((0,e.$2qb)(R,C,m)));const k=new g.$Rc;try{return await new Promise((f,d)=>{let s;k.add(y.onData(i=>{s?s=D.$ge.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$3qb);if(n===-1)return;f(y),y.pauseData();const o=s.slice(n+e.$3qb.byteLength);o.byteLength&&v.onData.fire(o)})),k.add(y.onClose(i=>d(i??new Error("socket closed")))),k.add(y.onEnd(()=>d(new Error("socket ended"))))})}catch(f){throw y.dispose(),f}finally{k.dispose()}}e.$4qb=b;class $ extends g.$Sc{constructor(R,C){super(),this.g=R,this.a=this.B(new O.$Vd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new O.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$5qb=$}),define(Se[64],ke([1,0,8,5]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.RemoteAuthorityResolverErrorCode=e.$3k=e.$2k=e.RemoteConnectionType=e.$1k=void 0,e.$1k=(0,O.$1h)("remoteAuthorityResolverService");var g;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class P{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$2k=P;class M{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$3k=M;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,v){super(C),this._message=C,this._code=m,this._detail=v,this.isHandled=m===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$4k=$;function y(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$5k=y}),define(Se[65],ke([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=void 0;function O(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$6k=O;function g(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.$7k=g;function P(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$8k=P;function M(y){const{host:R,port:C}=$(y);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:C}}e.$9k=M;function b(y,R){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=R),{host:C,port:m}}e.$0k=b;function $(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(Se[26],ke([1,0,13,5,65]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.TargetPlatform=e.ExtensionType=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l="extensions.user.cache",e.$_l="extensions.builtin.cache",e.$am="undefined_publisher",e.$bm=["ui","workspace","web"];function P(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$cm=P,e.$dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var M;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,s){if(typeof d>"u"||d===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof d=="string"||typeof s=="string"){const i=typeof d=="string"?d:d.value,n=typeof s=="string"?s:s.value;return D.$7e(i,n)}return d._lower===s._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$em=$;class y{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const s of d)this.add(s)}add(d){this.c.add($.toKey(d))}delete(d){return this.c.delete($.toKey(d))}has(d){return this.c.has($.toKey(d))}}e.$fm=y;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete($.toKey(d))}get(d){return this.c.get($.toKey(d))}has(d){return this.c.has($.toKey(d))}set(d,s){this.c.set($.toKey(d),s)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$gm=R;function C(f){return m(f)}e.$hm=C;function m(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$im=m;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$jm=v;function k(f,d){if(d){const s=`onResolveRemoteAuthority:${(0,g.$7k)(d)}`;return!!f.activationEvents?.includes(s)}return!1}e.$km=k,e.$lm=(0,O.$1h)("IBuiltinExtensionsScannerService")}),define(Se[137],ke([1,0,8,26]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const $ of M){const y=this.readActivationEvents($);y.length>0&&(b[O.$em.toKey($.identifier)]=y)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${O.$em.toKey(M.identifier)}`);if(!M.contributes)return b;for(const $ in M.contributes){const y=this.a.get($);if(!y)continue;const R=M.contributes[$],C=Array.isArray(R)?R:[R];try{y(C,b)}catch(m){(0,D.$1)(m)}}return b}}e.$CF=g,e.$DF=new g}),define(Se[256],ke([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.PersistentConnectionEventType=e.$el=e.$dl=e.$cl=e.ConnectionType=void 0;const k=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function d(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(H){const U=new g.$3d;return setTimeout(()=>U.cancel(),H),U.token}function i(H,U){if(H.isCancellationRequested||U.isCancellationRequested)return g.CancellationToken.Cancelled;const ne=new g.$3d;return H.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Rc,this.promise=new Promise((ne,ye)=>{this.f=ne,this.g=ye}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function o(H,U){const ne=new n(U);return ne.registerDisposable(H.onControlMessage(ye=>{const fe=JSON.parse(ye.toString()),me=Z(fe);me?ne.reject(me):ne.resolve(fe)})),ne.promise}function a(H,U,ne,ye,fe,me,ee,ie){const G=new n(ie),te=y.$Od.create(!1);return H.info(`Creating a socket (${ee})...`),$.mark(`code/willCreateSocket/${me}`),U.connect(ne,ye,fe,ee).then(J=>{G.didTimeout?($.mark(`code/didCreateSocketError/${me}`),H.info(`Creating a socket (${ee}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),J?.dispose()):($.mark(`code/didCreateSocketOK/${me}`),H.info(`Creating a socket (${ee}) was successful after ${te.elapsed()} ms.`),G.resolve(J))},J=>{$.mark(`code/didCreateSocketError/${me}`),H.info(`Creating a socket (${ee}) returned an error after ${te.elapsed()} ms.`),H.error(J),G.reject(J)}),G.promise}function t(H,U){const ne=new n(U);return H.then(ye=>{ne.didTimeout||ne.resolve(ye)},ye=>{ne.didTimeout||ne.reject(ye)}),ne.promise}async function r(H,U,ne,ye){const fe=ve(H,U);H.logService.trace(`${fe} 1/6. invoking socketFactory.connect().`);let me;try{me=await a(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,v.$8k)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,d(U),`renderer-${d(U)}-${H.reconnectionToken}`,ye)}catch(J){throw H.logService.error(`${fe} socketFactory.connect() failed or timed out. Error:`),H.logService.error(J),J}H.logService.trace(`${fe} 2/6. socketFactory.connect() was successful.`);let ee,ie;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(me,null),ee=H.reconnectionProtocol,ie=!1):(ee=new C.$Oh({socket:me}),ie=!0),H.logService.trace(`${fe} 3/6. sending AuthRequest control message.`);const G=await t(H.signService.createNewMessage((0,R.$lg)()),ye),te={type:"auth",auth:H.connectionToken||"00000000000000000000",data:G.data};ee.sendControl(O.$ge.fromString(JSON.stringify(te)));try{const J=await o(ee,i(ye,s(1e4)));if(J.type!=="sign"||typeof J.data!="string"){const Fe=new Error("Unexpected handshake message");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}if(H.logService.trace(`${fe} 4/6. received SignRequest control message.`),!await t(H.signService.validate(G,J.signedData),ye)){const Fe=new Error("Refused to connect to unsupported server");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}const be=await t(H.signService.sign(J.data),ye),Ie={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:U};return ne&&(Ie.args=ne),H.logService.trace(`${fe} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(O.$ge.fromString(JSON.stringify(Ie))),{protocol:ee,ownsProtocol:ie}}catch(J){throw J&&J.code==="ETIMEDOUT"&&(H.logService.error(`${fe} the handshake timed out. Error:`),H.logService.error(J)),J&&J.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${fe} received error control message when negotiating connection. Error:`),H.logService.error(J)),ie&&Q(ee),J}}async function h(H,U,ne,ye){const fe=Date.now(),me=ve(H,U),{protocol:ee,ownsProtocol:ie}=await r(H,U,ne,ye),G=new n(ye);return G.registerDisposable(ee.onControlMessage(te=>{const J=JSON.parse(te.toString()),ce=Z(J);ce?(H.logService.error(`${me} received error control message when negotiating connection. Error:`),H.logService.error(ce),ie&&Q(ee),G.reject(ce)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${me} 6/6. handshake finished, connection is up and running after ${ge(fe)}!`),G.resolve({protocol:ee,firstMessage:J}))})),G.promise}async function u(H,U){const{protocol:ne}=await h(H,1,void 0,U);return{protocol:ne}}async function c(H,U,ne){const{protocol:ye,firstMessage:fe}=await h(H,2,U,ne),me=fe&&fe.debugPort;return{protocol:ye,debugPort:me}}async function l(H,U,ne){const ye=Date.now(),fe=ve(H,3),{protocol:me}=await r(H,3,U,ne);return H.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${ge(ye)}!`),me}async function S(H,U,ne){const{connectTo:ye,connectionToken:fe}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:ye,connectionToken:fe,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function L(H,U,ne){return p(H,async ye=>{const{protocol:fe}=await u(ye,g.CancellationToken.None);return new Y(H,U,ne,ye.reconnectionToken,fe)})}e.$cl=L;async function w(H,U){return p(H,async ne=>{const{protocol:ye,debugPort:fe}=await c(ne,U,g.CancellationToken.None);return new le(H,U,ne.reconnectionToken,ye,fe)})}e.$dl=w;async function p(H,U){for(let ye=1;;ye++)try{const fe=(0,R.$lg)(),me=await S(H,fe,null);return await U(me)}catch(fe){if(ye<5)H.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(fe);else throw H.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(fe),W.triggerPermanentFailure(0,0,m.$4k.isHandled(fe)),fe}}async function E(H,U,ne){const ye=await S(H,(0,R.$lg)(),null);return await l(ye,{host:U,port:ne},g.CancellationToken.None)}e.$el=E;function A(H){return(0,D.$Og)(U=>new Promise((ne,ye)=>{const fe=setTimeout(ne,H*1e3);U.onCancellationRequested(()=>{clearTimeout(fe),ne()})}))}var z;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class N{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$fl=N;class I{constructor(U,ne,ye,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=ye,this.c=fe,this.type=1}skipWait(){this.c.cancel()}}e.$gl=I;class j{constructor(U,ne,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=2}}e.$hl=j;class T{constructor(U,ne,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=4}}e.$il=T;class F{constructor(U,ne,ye,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.handled=fe,this.type=3}}e.$jl=F;class W extends b.$Sc{static triggerPermanentFailure(U,ne,ye){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=ye,this.j.forEach(fe=>fe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ne,ye,fe,me){super(),this.t=U,this.u=ne,this.reconnectionToken=ye,this.protocol=fe,this.w=me,this.m=this.B(new M.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new T(this.reconnectionToken,0,0)),this.B(fe.onSocketClose(ee=>{const ie=X(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(fe.onSocketTimeout(ee=>{const ie=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Qc)(()=>{const ee=W.j.indexOf(this);ee>=0&&W.j.splice(ee,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const fe=ye<ne.length?ne[ye]:ne[ne.length-1];try{if(fe>0){const ee=A(fe);this.m.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe,ee)),this.u.logService.info(`${U} waiting for ${fe} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${U} resolving connection...`);const me=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${me.connectTo}...`),await this.G(me,s(k)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(me){if(me.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$4k.isTemporarilyNotAvailable(me)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if((me.code==="ETIMEDOUT"||me.code==="ENETUNREACH"||me.code==="ECONNREFUSED"||me.code==="ECONNRESET")&&me.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if((0,P.$4)(me)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if(me instanceof m.$4k){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$4k.isHandled(me));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,ye){this.w?W.triggerPermanentFailure(U,ne,ye):this.D(U,ne,ye)}D(U,ne,ye){this.m.fire(new F(this.reconnectionToken,U,ne,ye)),Q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$kl=W;class Y extends W{constructor(U,ne,ye,fe,me){super(1,U,fe,me,!0),this.client=this.B(new C.$Mh(me,{remoteAuthority:ne,clientId:ye},U.ipcLogger))}async G(U,ne){await u(U,ne)}}e.$ll=Y;class le extends W{constructor(U,ne,ye,fe,me){super(2,U,ye,fe,!1),this.H=ne,this.debugPort=me}async G(U,ne){await c(U,this.H,ne)}}e.$ml=le;function Q(H){try{H.acceptDisconnect();const U=H.getSocket();H.dispose(),U.dispose()}catch(U){(0,P.$1)(U)}}function Z(H){if(H&&H.type==="error"){const U=new Error(`Connection error: ${H.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(H,U){for(;H.length<U;)H+=" ";return H}function oe(H,U){return`[remote-connection][${x(d(H),13)}][${U.substr(0,5)}\u2026]`}function X(H,U,ne){return`${oe(H,U)}[${ne?"reconnect":"initial"}]`}function ve(H,U){return`${X(U,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function ge(H){return`${Date.now()-H} ms`}}),define(Se[257],ke([1,0,3,5]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=void 0,e.$$k=(0,O.$1h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,D.$Qc)(()=>{const $=this.a[M]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[M]?.splice($,1)})}b(M){return(this.a[M.type]||[]).find($=>$.supports(M))}connect(M,b,$,y){const R=this.b(M);if(!R)throw new Error(`No socket factory found for ${M}`);return R.connect(M,b,$,y)}}e.$_k=g}),define(Se[258],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const P=await this.c();if(P){const M=String(D.a++);return this.b.set(M,P),{id:M,data:P.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,P){if(!g.id)return!0;const M=this.b.get(g.id);if(!M)return!1;this.b.delete(g.id);try{return M.validate(P)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$Z5b=D}),define(Se[109],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=void 0,e.$al="signService",e.$bl=(0,D.$1h)(e.$al)}),define(Se[138],ke([1,0,258]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U0b=void 0;class O extends D.$Z5b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(M=>new M.signer().sign(P))}h(){return new Promise((P,M)=>$e(["vsda"],P,M))}}e.$U0b=O}),define(Se[259],ke([1,0,11,50,30]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=void 0;function P($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,y,R,C,m,v,k,f,d){const s=Object.create(null);s["common.machineId"]=v,s["common.sqmId"]=k,s.sessionID=(0,g.$lg)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$u),s["common.nodePlatform"]=O.$dc,s["common.nodeArch"]=R,s["common.product"]=d||"desktop",f&&(s["common.msftInternal"]=f);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const o=P(y);return o&&(s["common.platformDetail"]=o),s}e.$so=M;function b($){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return $.some(C=>R===C)}e.$to=b}),define(Se[260],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=void 0,e.$nl=(0,D.$1h)("telemetryService"),e.$ol=(0,D.$1h)("customEndpointTelemetryService"),e.$pl="telemetry.currentSessionDate",e.$ql="telemetry.firstSessionDate",e.$rl="telemetry.lastSessionDate",e.$sl="telemetry.machineId",e.$tl="telemetry.sqmId",e.$ul="telemetry",e.$vl="telemetry.telemetryLevel",e.$wl="telemetry.enableCrashReporter",e.$xl="telemetry.enableTelemetry";var O;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var g;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Se[87],ke([1,0,24,18,4,45,65,259,260]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0;class y{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$uo=y;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vo=R,e.$wo=new R;class C{async publicLog(c,l,S){}async publicLogError(c,l,S){}}e.$xo=C,e.$yo="telemetry",e.$zo="extensionTelemetryLog",e.$Ao={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,c){return g.Event.debounce(c.onDidChangeConfiguration,(S,L)=>{const w=S?new Set([...S.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:w}},1e3,!0)(S=>{S.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,P.$xi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Bo=m;function v(u,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!u.enableTelemetry)}e.$Co=v;function k(u,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$Do=k;function f(u){const c=u.getValue($.$vl),l=u.getValue($.$wl);if(u.getValue($.$xl)===!1||l===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Eo=f;function d(u){const c={},l={},S={};n(u,S);for(let L in S){L=L.length>150?L.substr(L.length-149):L;const w=S[L];typeof w=="number"?l[L]=w:typeof w=="boolean"?l[L]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${w.length}`),c[L]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(c[L]=w)}return{properties:c,measurements:l}}e.$Fo=d;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const c=(0,M.$7k)(u);return s.has(c)?c:"other"}e.$Go=i;function n(u,c,l=0,S){if(u)for(const L of Object.getOwnPropertyNames(u)){const w=u[L],p=S?S+L:L;Array.isArray(w)?c[p]=(0,D.$kn)(w):w instanceof Date?c[p]=w.toISOString():(0,O.$Ff)(w)?l<2?n(w,c,l+1,p+"."):c[p]=(0,D.$kn)(w):c[p]=w}}function o(u,c){const l=u.msftInternalDomains||[],S=c.getValue("telemetry.internalTesting");return(0,b.$to)(l)||S}e.$Ho=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Io=a;function t(u,c){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let l=u;const S=[];for(const E of c)for(;;){const A=E.exec(u);if(!A)break;S.push([A.index,E.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(l="";;){const E=w.exec(u);if(!E)break;const A=S.some(([z,N])=>E.index<N&&z<w.lastIndex);!L.test(E[0])&&!A&&(l+=u.substring(p,E.index)+"<REDACTED: user-file-path>",p=w.lastIndex)}return p<u.length&&(l+=u.substr(p)),l}function r(u){if(!u)return u;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of c)if(l.regex.test(u))return`<REDACTED: ${l.label}>`;return u}function h(u,c){return(0,D.$hn)(u,l=>{if(l instanceof y||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let S=l.replaceAll("%20"," ");S=t(S,c);for(const L of c)S=S.replace(L,"");return S=r(S),S}})}e.$Jo=h}),define(Se[261],ke([1,0,13,134,26,11,2,8,50,87]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0;function R(h,u){return h.uuid&&u.uuid?h.uuid===u.uuid:h.id===u.id?!0:(0,D.$2e)(h.id,u.id)===0}e.$Ko=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(u){const c=u.manifest?u.manifest.version:u.version,l=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new m(u.identifier,c,l)}static parse(u){const c=C.exec(u);return c&&c[1]&&c[2]?new m({id:c[1]},c[2],c[4]||void 0):null}constructor(u,c,l="undefined"){this.version=c,this.targetPlatform=l,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof m?R(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Lo=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(h){const u=v.exec(h);return u&&u[1]?[d(u[1]),u[2]]:[d(h),void 0]}e.$Mo=k;function f(h,u){return`${h}.${u}`}e.$No=f;function d(h){return h.toLowerCase()}e.$Oo=d;function s(h,u){return d(f(h??g.$am,u))}e.$Po=s;function i(h,u){const c=[],l=S=>{for(const L of c)if(L.some(w=>R(u(w),u(S))))return L;return null};for(const S of h){const L=l(S);L?L.push(S):c.push([S])}return c}e.$Qo=i;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.$Ro=n;function o(h){return{id:new y.$uo(h.identifier.id),name:new y.$uo(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$So=o,e.$To=new g.$em("pprice.better-merge");function a(h,u){const c=[],l=u.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const S=l.shift();if(S&&c.every(L=>!R(L.identifier,{id:S}))){const L=h.filter(w=>R(w.identifier,{id:S}));L.length===1&&(c.push(L[0]),l.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$Uo=a;async function t(h,u){if(!P.$k)return!1;let c;try{c=(await h.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await h.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){u.debug("Error while getting the os-release file.",(0,b.$0)(S))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(h,u){const c=await t(h,u),l=(0,O.$eo)(c?"alpine":P.$u,$.$ec);return u.debug("ComputeTargetPlatform:",l),l}e.$Vo=r}),define(Se[262],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.$yr=e.$xr=e.$wr=e.$vr=void 0;function D($){return[...$.entries()]}e.$vr=D;function O($){return $?[...$.entries()]:[]}e.$wr=O;function g($){return new Map($)}e.$xr=g;function P($){return new Map($??[])}e.$yr=P;function M($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),O(y[1].descriptionMap)])}e.$zr=M;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:P(y[2])}]))}e.$Ar=b}),define(Se[263],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,P,M=5){const b=P($=>{const y=typeof $=="string"?$:$.data;let R=this.a.get(g);if(R){R.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),M);R={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,R)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const P=this.a.get(g);P&&(this.a.delete(g),this.b(g,P.data.join("")))}}e.$jrb=D}),define(Se[264],ke([1,0,12,78,61,4,18,2,206,108,37]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.IconFontDefinition=e.IconContribution=e.$fw=void 0,e.$fw={IconContribution:"base.contributions.icons"};var C;(function(o){function a(t,r){let h=t.defaults;for(;g.ThemeIcon.isThemeIcon(h);){const u=k.getIcon(h.id);if(!u)return;h=u.defaults}return h}o.getDefinition=a})(C||(e.IconContribution=C={}));var m;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(h=>({format:h.format,location:h.location.toString()}))}}o.toJSONObject=a;function t(r){const h=u=>(0,M.$Df)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,M.$Df)(u.format)&&(0,M.$Df)(u.location)))return{weight:h(r.weight),style:h(r.style),src:r.src.map(u=>({format:u.format,location:b.URI.parse(u.location)}))}}o.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class v{constructor(){this.a=new P.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,h){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const S=this.e.enum.indexOf(a);S!==-1&&(this.e.enumDescriptions[S]=r),this.a.fire()}return u}const c={id:a,description:r,defaults:t,deprecationMessage:h};this.b[a]=c;const l={$ref:"#/definitions/icons"};return h&&(l.deprecationMessage=h),r&&(l.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=l,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,c)=>u.id.localeCompare(c.id),t=u=>{for(;g.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.b).map(u=>this.b[u]);for(const u of h.filter(c=>!!c.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${g.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of h.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const k=new v;R.$rn.add(e.$fw.IconContribution,k);function f(o,a,t,r){return k.registerIcon(o,a,t,r)}e.$gw=f;function d(){return k}e.$hw=d;function s(){const o=(0,O.$4j)();for(const a in o){const t="\\"+o[a].toString(16);k.registerIcon(a,{fontCharacter:t})}}s(),e.$iw="vscode://schemas/icons";const i=R.$rn.as(y.$sn.JSONContribution);i.registerSchema(e.$iw,k.getIconSchema());const n=new D.$ah(()=>i.notifySchemaChanged(e.$iw),200);k.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$jw=f("widget-close",O.$6j.close,(0,$.localize)(2,null)),e.$kw=f("goto-previous-location",O.$6j.arrowUp,(0,$.localize)(3,null)),e.$lw=f("goto-next-location",O.$6j.arrowDown,(0,$.localize)(4,null)),e.$mw=g.ThemeIcon.modify(O.$6j.sync,"spin"),e.$nw=g.ThemeIcon.modify(O.$6j.loading,"spin")}),define(Se[88],ke([1,0,4,45,5,14]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.ProvidedOnAutoForward=e.$lv=e.TunnelPrivacyId=e.TunnelProtocol=e.$kv=e.$jv=void 0,e.$jv=(0,g.$1h)("tunnelService"),e.$kv=(0,g.$1h)("sharedTunnelsService");var M;(function(d){d.Http="http",d.Https="https"})(M||(e.TunnelProtocol=M={}));var b;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(d){return!!d.forwardPort}e.$lv=$;var y;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(s)return{address:s[1],port:+s[2]}}e.$mv=R,e.$nv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(d){return e.$nv.indexOf(d)>=0}e.$ov=C,e.$pv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(d){return e.$pv.indexOf(d)>=0}e.$qv=m;function v(d,s,i,n){if(i===1)return!1;if(i===2&&m(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return d<1024}e.$rv=v;class k{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new D.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sv=k;let f=class{constructor(s,i){this.j=s,this.k=i,this.a=new D.$Sd,this.onTunnelOpened=this.a.event,this.b=new D.$Sd,this.onTunnelClosed=this.b.event,this.c=new D.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(m(s)||C(s))&&(s=e.$nv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,h){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(u,i,n,o,a,t,r,h);return c?c.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(l);return(l.tunnelRemoteHost!==i||l.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&l.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];C(s)?(n.push(...e.$nv),n.push(...e.$pv)):m(s)&&n.push(...e.$pv);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!R(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const h=n;this.i.add(h);const u=o===void 0?n:o,c={elevationRequired:a?this.isPortPrivileged(u):!1},l={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==b.Private:void 0,protocol:r},S=s.forwardPort(l,c);return S?(this.p(i,n,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(h)})):this.i.delete(h),S}};e.$tv=f,e.$tv=f=Ge([We(0,P.$ij),We(1,O.$ui)],f)}),define(Se[265],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=void 0,e.$Tk=(0,D.$1h)("IUriIdentityService")}),define(Se[266],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uv=void 0,e.$uv=(0,D.$1h)("editSessionIdentityService");var O;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[267],ke([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=void 0;function O($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$cK=O;function g($){if($.folders.length)return $.folders.every(y=>O(y.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}e.$dK=g;function P($){return g($)?.scheme}e.$eK=P;function M($){return g($)?.authority}e.$fK=M;function b($){return g($)!==void 0}e.$gK=b}),define(Se[40],ke([1,0,208,16,77,23,2,5,17]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.WorkbenchState=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0,e.$0h=(0,b.$1h)("contextService");function y(u){const c=u;return typeof c?.id=="string"&&M.URI.isUri(c.uri)}e.$$h=y;function R(u){return typeof u?.id=="string"&&!y(u)&&!m(u)}e.$_h=R,e.$ai={id:"ext-dev"},e.$bi={id:"empty-window"};function C(u,c){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,O.$nc)(u)}:c?e.$ai:e.$bi;const l=u;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$ci=C;function m(u){const c=u;return typeof c?.id=="string"&&M.URI.isUri(c.configPath)}e.$di=m;function v(u){const c=u;if(c?.uri)return{id:c.id,uri:M.URI.revive(c.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:M.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}e.$ei=v;var k;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function f(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$fi=f;function d(u){const c=u;return!!(c&&typeof c=="object"&&M.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$gi=d;class s{constructor(c,l,S,L,w){this.h=c,this.j=S,this.k=L,this.l=w,this.c=g.$7h.forUris(this.l,()=>!0),this.folders=l}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$7h.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$hi=s;class i{constructor(c,l){this.raw=l,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,P.$Cg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ii=i;function n(u){return new i({uri:u,index:0,name:(0,P.$yg)(u)},{uri:u.toString()})}e.$ji=n,e.$ki="code-workspace",e.$li=`.${e.$ki}`,e.$mi=[{name:(0,D.localize)(0,null),extensions:[e.$ki]}],e.$ni="workspace.json";function o(u,c){return P.$tg.isEqualOrParent(u,c.untitledWorkspacesHome)}e.$oi=o;function a(u){let c;return M.URI.isUri(u)?c=u:c=u.configuration,c?.scheme===$.Schemas.tmp}e.$pi=a,e.$qi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$qi}e.$ri=t;function r(u,c){return!o(u,c)&&!a(u)}e.$si=r;function h(u){return(typeof u=="string"?(0,O.$oc)(u):(0,P.$Ag)(u))===e.$li}e.$ti=h}),define(Se[268],ke([1,0,53,4,3,23,2,207,133,32,5,14,40,28,265,12,30,13,18]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&M.URI.isUri(c.location)&&M.URI.isUri(c.globalStorageHome)&&M.URI.isUri(c.settingsResource)&&M.URI.isUri(c.keybindingsResource)&&M.URI.isUri(c.tasksResource)&&M.URI.isUri(c.snippetsHome)&&M.URI.isUri(c.extensionsResource))}e.$Uk=o,e.$Vk=(0,R.$1h)("IUserDataProfilesService");function a(u,c){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:M.URI.revive(u.location).with({scheme:c}),globalStorageHome:M.URI.revive(u.globalStorageHome).with({scheme:c}),settingsResource:M.URI.revive(u.settingsResource).with({scheme:c}),keybindingsResource:M.URI.revive(u.keybindingsResource).with({scheme:c}),tasksResource:M.URI.revive(u.tasksResource).with({scheme:c}),snippetsHome:M.URI.revive(u.snippetsHome).with({scheme:c}),extensionsResource:M.URI.revive(u.extensionsResource).with({scheme:c}),cacheHome:M.URI.revive(u.cacheHome).with({scheme:c}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Wk=a;function t(u,c,l,S,L,w){return{id:u,name:c,location:l,isDefault:!1,shortName:L?.shortName,icon:L?.icon,globalStorageHome:w&&L?.useDefaultFlags?.globalState?w.globalStorageHome:(0,P.$Cg)(l,"globalStorage"),settingsResource:w&&L?.useDefaultFlags?.settings?w.settingsResource:(0,P.$Cg)(l,"settings.json"),keybindingsResource:w&&L?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,P.$Cg)(l,"keybindings.json"),tasksResource:w&&L?.useDefaultFlags?.tasks?w.tasksResource:(0,P.$Cg)(l,"tasks.json"),snippetsHome:w&&L?.useDefaultFlags?.snippets?w.snippetsHome:(0,P.$Cg)(l,"snippets"),extensionsResource:w&&L?.useDefaultFlags?.extensions?w.extensionsResource:(0,P.$Cg)(l,"extensions.json"),cacheHome:(0,P.$Cg)(S,u),useDefaultFlags:L?.useDefaultFlags,isTransient:L?.transient}}e.$Xk=t;let r=class extends g.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,l,S,L){super(),this.t=c,this.u=l,this.w=S,this.y=L,this.f=!0,this.h=this.B(new O.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Cg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Cg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),l=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,i.$Df)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}l.push(t((0,P.$zg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const S=new v.$Ac,L=new Map;if(l.length)try{const w=this.Q();if(w.workspaces)for(const[p,E]of Object.entries(w.workspaces)){const A=M.URI.parse(p),z=l.find(N=>N.id===E);z&&S.set(A,z)}if(w.emptyWindows)for(const[p,E]of Object.entries(w.emptyWindows)){const A=l.find(z=>z.id===E);A&&L.set(p,A)}}catch(w){this.y.error(w)}this.z={profiles:l,workspaces:S,emptyWindows:L}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const l="Temp",S=new RegExp(`${(0,s.$Ke)(l)}\\s(\\d+)`);let L=0;for(const p of this.profiles){const E=S.exec(p.name),A=E?parseInt(E[1]):0;L=A>L?A:L}const w=`${l} ${L+1}`;return this.createProfile((0,D.$Oi)((0,d.$lg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,l,S){return this.createProfile((0,D.$Oi)((0,d.$lg)()).toString(16),c,l,S)}async createProfile(c,l,S,L){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,l,S);return L&&await this.setProfileForWorkspace(L,w),w}async F(c,l,S){if(!(0,i.$Df)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let L=this.r.get(l);return L||(L=(async()=>{try{const w=this.profiles.find(A=>A.name===l||A.id===c);if(w)return w;const p=t(c,l,(0,P.$Cg)(this.profilesHome,c),this.g,S,this.defaultProfile);await this.u.createFolder(p.location);const E=[];return this.j.fire({profile:p,join(A){E.push(A)}}),await f.Promises.settled(E),this.I([p],[],[]),p}finally{this.r.delete(l)}})(),this.r.set(l,L)),L}async updateProfile(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(L=>L.id===c.id);if(!S)throw new Error(`Profile '${c.name}' does not exist`);return S=t(S.id,l.name??S.name,S.location,this.g,{shortName:l.shortName??S.shortName,icon:l.icon===null?void 0:l.icon??S.icon,transient:l.transient??S.isTransient,useDefaultFlags:l.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(L=>L.id===c.id);if(!l)throw new Error(`Profile '${c.name}' does not exist`);const S=[];this.m.fire({profile:l,join(L){S.push(L)}});try{await Promise.allSettled(S)}catch(L){this.y.error(L)}for(const L of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(L)?.id&&this.C.emptyWindows.delete(L);for(const L of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(L)?.id&&this.C.workspaces.delete(L);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(L){(0,y.$Ak)(L)!==1&&this.y.error(L)}}async setProfileForWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(L=>L.id===l.id);if(!S)throw new Error(`Profile '${l.name}' does not exist`);this.L(c,S)}unsetWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(l=>l.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(c.map(l=>this.removeProfile(l)))}getProfileForWorkspace(c){const l=this.G(c);return M.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(c){return(0,m.$$h)(c)?c.uri:(0,m.$di)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location)))}I(c,l,S){const L=[...this.profiles,...c],w=[];this.s.profiles=[];for(let p of L)p.isDefault||l.some(E=>p.id===E.id)||(p=S.find(E=>p.id===E.id)??p,p.isTransient?this.s.profiles.push(p):w.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,l,S)}J(c,l,S){this.h.fire({added:c,removed:l,updated:S,all:this.profiles})}L(c,l,S){S=l?.isTransient?!0:S,S||this.L(c,void 0,!0);const L=this.G(c),w=S?this.s:this.C;M.URI.isUri(L)?(w.workspaces.delete(L),l&&w.workspaces.set(L,l)):(w.emptyWindows.delete(L),l&&w.emptyWindows.set(L,l)),S||this.M()}M(){const c={};for(const[S,L]of this.C.workspaces.entries())c[S.toString()]=L.id;const l={};for(const[S,L]of this.C.emptyWindows.entries())l[S.toString()]=L.id;this.R({workspaces:c,emptyWindows:l}),this.z=void 0}N(c){const l={},S=this.D();if(c.workspaces)for(const[w,p]of Object.entries(c.workspaces)){const E=M.URI.parse(p);l[w]=this.w.extUri.isEqual(E,S.location)?S.id:this.w.extUri.basename(E)}const L={};if(c.emptyWindows)for(const[w,p]of Object.entries(c.emptyWindows)){const E=M.URI.parse(p);L[w]=this.w.extUri.isEqual(E,S.location)?S.id:this.w.extUri.basename(E)}return{workspaces:l,emptyWindows:L}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Yk=r,e.$Yk=r=Ge([We(0,$.$8h),We(1,y.$jk),We(2,k.$Tk),We(3,C.$ij)],r);class h extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Zk=h}),define(Se[269],ke([1,0,12,4,3,56,18,187,5,268]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$ep=e.$dp=e.$cp=void 0,e.$cp="__$__isNewStorageMarker",e.$dp="__$__targetStorageMarker",e.$ep=(0,$.$1h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(i){const n=i.get(e.$dp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$fp=v;class k extends g.$Sc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new O.$Vd),this.c=this.B(new O.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$ah(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return O.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,D.$eh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$dp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,M.$Mf)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$dp,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$dp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?v(o):Object.create(null)}isNew(n){return this.getBoolean(e.$cp,n)===!0}async flush(n=R.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case R.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(R.NONE),(0,y.$Uk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||f(o)&&f(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,h]of n)t.add(r),o.get(r)!==h&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$gp=k;function f(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$hp=f;class d extends k{constructor(){super(),this.U=this.B(new b.$ap(new b.$bp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$ap(new b.$bp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$ap(new b.$bp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$ip=d;async function s(i,n,o,a,t,r){const h=A=>{try{return JSON.parse(A)}catch{return A}},u=new Map,c=new Map;i.forEach((A,z)=>{u.set(z,A),c.set(z,h(A))});const l=new Map,S=new Map;n.forEach((A,z)=>{l.set(z,A),S.set(z,h(A))});const L=new Map,w=new Map;o.forEach((A,z)=>{L.set(z,A),w.set(z,h(A))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(u.forEach((A,z)=>{p.push({key:z,value:A})}),console.table(p),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];l.forEach((z,N)=>{A.push({key:N,value:z})}),console.table(A),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${r})`);const E=[];L.forEach((A,z)=>{E.push({key:z,value:A})}),console.table(E),console.groupEnd(),console.log(w)}e.$jp=s}),define(Se[110],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const P=this.c++;return this.b.set(P,g),this.e(),P}get(g,P){return this.b.has(g)?this.b.get(g)[P]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Nec=D}),define(Se[57],ke([1,0,17,23,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=void 0;class P{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new O.$rg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Qec=P,e.$Rec=(0,g.$1h)("IExtHostFileSystemInfo")}),define(Se[27],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0,e.$ZM=(0,D.$1h)("IExtHostInitDataService")}),define(Se[270],ke([1,0,213,14,250,27]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;let M=class extends g.$7N{constructor($,y,R){const C=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=R.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$Xgc=M,e.$Xgc=M=Ge([We(1,O.$jj),We(2,P.$ZM)],M)}),define(Se[271],ke([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0;class O{constructor(M,b,$){this.h=new Map,this.a=M,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$ah(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of y.values())R.complete()}catch(R){for(const C of y.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let $=this.f[M];return typeof $>"u"&&($=b),$}update(M,b){this.f[M]=b;const $=this.h.get(M);if($!==void 0)return $.p;const y=new D.$lh;return this.h.set(M,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$zfc=O;class g extends O{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Afc=g}),define(Se[272],ke([1,0,4,2]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class g{constructor(M){this.c=M,this.a=new D.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,$,y){const C=this.c.getNotebookDocument(O.URI.revive(M)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(O.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(O.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$ngc=g}),define(Se[20],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0,e.$JM=(0,D.$1h)("IExtHostRpcService");class O{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$KM=O}),define(Se[273],ke([1,0,26,4]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class g{#e;constructor(M,b){this.b=new O.$Sd,this.onDidChange=this.b.event,this.a=D.$em.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$Hfc=g}),define(Se[66],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0,e.$0ec=(0,D.$1h)("IURITransformerService");class O{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$$ec=O}),define(Se[274],ke([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkb=e.$Mkb=void 0;class O{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new O,C=JSON.stringify(b,(v,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k)};if(ArrayBuffer.isView(k)){const f=P(k);if(f)return{$$vscode_array_buffer_reference$$:!0,index:y.add(k.buffer),view:{type:f,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),m=y.buffers.map(v=>{const k=new Uint8Array(v);return D.$ge.wrap(k)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$Mkb=g;function P(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,$){const y=$.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),R=$.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const k=v,{index:f}=k,d=y[f];if(k.view)switch(k.view.type){case 1:return new Int8Array(d,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return v}:void 0;return{message:JSON.parse(b,R),arrayBuffers:y}}e.$Nkb=M}),define(Se[275],ke([1,0,276,387,388,62,2,14,389]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;const y=!1;function R(n,o,a,t,r,h){const u=h.environment.useHostProxy,c=typeof u=="boolean"?u:!h.remote.isRemote,l={resolveProxy:w=>n.resolveProxy(w),lookupProxyAuthorization:d.bind(void 0,t,r,o,{},h.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(o),addCertificatesV2:()=>v(o),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return p(w)}function p(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(h.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),w.push(p)}return(await Promise.all(w)).flat()},env:process.env},S=(0,$.createProxyResolver)(l),L=C(l,S);return f(a,L)}e.$thc=R;function C(n,o){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,o)),https:Object.assign(O,(0,$.createHttpPatch)(n,O,o)),net:Object.assign(P,(0,$.createNetPatch)(n,P)),tls:Object.assign(g,(0,$.createTlsPatch)(n,g))}}function m(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}function v(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}const k=new Map;function f(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,c,l){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const S=a.findSubstr(M.URI.file(c.filename));let L=k.get(S);if(L||k.set(S,L={}),!L[u]){const w=o[u];L[u]={...w}}return L[u]}})}async function d(n,o,a,t,r,h,u,c){const l=t[h];u&&(t[h]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${l}`);const S=u||l,L=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(i(o,L,r),L.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((N,I)=>{$e(["kerberos"],N,I)}),p=new URL(h),E=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${E}`),"Negotiate "+await(await w.initializeClient(E)).step("")}catch(w){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Se[277],ke([1,0,130]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;function O(P){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:P,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function g(P){return new D.$Wm(O(P))}e.$Lr=g}),define(Se[139],ke([1,0,224,18,2,3,5,37,32,17,44,179,39]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IE=e.$HE=e.$GE=e.EditorsOrder=e.$FE=e.CloseDirection=e.$EE=e.$DE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.EditorInputCapabilities=e.$uE=e.SaveReason=e.Verbosity=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=void 0,e.$hE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$iE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$jE="workbench.editor.sidebysideEditor",e.$kE="workbench.editors.textDiffEditor",e.$lE="workbench.editors.binaryResourceDiffEditor";var v;(function(ge){ge[ge.PROGRAMMATIC=1]="PROGRAMMATIC",ge[ge.USER=2]="USER",ge[ge.EDIT=3]="EDIT",ge[ge.NAVIGATION=4]="NAVIGATION",ge[ge.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var k;(function(ge){ge[ge.IDENTICAL=1]="IDENTICAL",ge[ge.SIMILAR=2]="SIMILAR",ge[ge.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function f(ge){const H=ge;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.$mE=f;function d(ge,H,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===H&&ge.matches(ne.input))return ne.getViewState()}e.$nE=d;function s(ge){if(S(ge))return!1;const H=ge;return g.URI.isUri(H?.resource)}e.$oE=s;function i(ge){if(S(ge))return!1;const H=ge;return H?.original!==void 0&&H.modified!==void 0}e.$pE=i;function n(ge){if(S(ge))return!1;const H=ge;return Array.isArray(H?.resources)}e.$qE=n;function o(ge){if(S(ge)||i(ge))return!1;const H=ge;return H?.primary!==void 0&&H.secondary!==void 0}e.$rE=o;function a(ge){if(S(ge))return!1;const H=ge;return H?H.resource===void 0||H.resource.scheme===y.Schemas.untitled||H.forceUntitled===!0:!1}e.$sE=a;function t(ge){if(S(ge))return!1;const H=ge;return g.URI.isUri(H?.base?.resource)&&g.URI.isUri(H?.input1?.resource)&&g.URI.isUri(H?.input2?.resource)&&g.URI.isUri(H?.result?.resource)}e.$tE=t;var r;(function(ge){ge[ge.SHORT=0]="SHORT",ge[ge.MEDIUM=1]="MEDIUM",ge[ge.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var h;(function(ge){ge[ge.EXPLICIT=1]="EXPLICIT",ge[ge.AUTO=2]="AUTO",ge[ge.FOCUS_CHANGE=3]="FOCUS_CHANGE",ge[ge.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class u{constructor(){this.a=new Map}registerSource(H,U){let ne=this.a.get(H);return ne||(ne={source:H,label:U},this.a.set(H,ne)),ne.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$uE=new u;var c;(function(ge){ge[ge.None=0]="None",ge[ge.Readonly=2]="Readonly",ge[ge.Untitled=4]="Untitled",ge[ge.Singleton=8]="Singleton",ge[ge.RequiresTrust=16]="RequiresTrust",ge[ge.CanSplitInGroup=32]="CanSplitInGroup",ge[ge.ForceDescription=64]="ForceDescription",ge[ge.CanDropIntoEditor=128]="CanDropIntoEditor",ge[ge.MultipleEditors=256]="MultipleEditors",ge[ge.Scratchpad=512]="Scratchpad",ge[ge.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class l extends P.$Sc{}e.$vE=l;function S(ge){return ge instanceof l}e.$wE=S;function L(ge){const H=ge;return g.URI.isUri(H?.preferredResource)}function w(ge){const H=ge;return S(H?.primary)&&S(H?.secondary)}e.$xE=w;function p(ge){const H=ge;return S(H?.modified)&&S(H?.original)}e.$yE=p;function E(ge,H,U,ne,ye){return ve(ne,[(0,C.$Ki)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const fe={...U,limits:{size:Number.MAX_VALUE}};ge.openEditor(H,fe)}}),(0,C.$Ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$zE=E;function A(ge){return S(ge?.editor)}e.$AE=A;function z(ge){const H=ge;return A(ge)&&H?.group!==void 0}e.$BE=z;function N(ge){const H=ge;return typeof H?.groupId=="number"&&S(H.editor)}e.$CE=N;var I;(function(ge){ge[ge.UNKNOWN=0]="UNKNOWN",ge[ge.REPLACE=1]="REPLACE",ge[ge.MOVE=2]="MOVE",ge[ge.UNPIN=3]="UNPIN"})(I||(e.EditorCloseContext=I={}));var j;(function(ge){ge[ge.GROUP_ACTIVE=0]="GROUP_ACTIVE",ge[ge.GROUP_INDEX=1]="GROUP_INDEX",ge[ge.GROUP_LABEL=2]="GROUP_LABEL",ge[ge.GROUP_LOCKED=3]="GROUP_LOCKED",ge[ge.EDITOR_OPEN=4]="EDITOR_OPEN",ge[ge.EDITOR_CLOSE=5]="EDITOR_CLOSE",ge[ge.EDITOR_MOVE=6]="EDITOR_MOVE",ge[ge.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ge[ge.EDITOR_LABEL=8]="EDITOR_LABEL",ge[ge.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ge[ge.EDITOR_PIN=10]="EDITOR_PIN",ge[ge.EDITOR_STICKY=11]="EDITOR_STICKY",ge[ge.EDITOR_DIRTY=12]="EDITOR_DIRTY",ge[ge.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var T;(function(ge){ge[ge.PRIMARY=1]="PRIMARY",ge[ge.SECONDARY=2]="SECONDARY",ge[ge.BOTH=3]="BOTH",ge[ge.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class F{getOriginalUri(H,U){if(!H)return;if(t(H))return e.$EE.getOriginalUri(H.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:fe}=this.a(H);if(ye&&fe){if(U?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getOriginalUri(ye,{filterByScheme:U.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:U.filterByScheme});H=U.supportSideBySide===T.PRIMARY?ye:fe}}if(i(H)||n(H)||o(H)||t(H))return;const ne=L(H)?H.preferredResource:H.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(H){return w(H)||o(H)?{primary:H.primary,secondary:H.secondary}:p(H)||i(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,U){if(!H)return;if(t(H))return e.$EE.getCanonicalUri(H.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:fe}=this.a(H);if(ye&&fe){if(U?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:U.filterByScheme});H=U.supportSideBySide===T.PRIMARY?ye:fe}}if(i(H)||n(H)||o(H)||t(H))return;const ne=H.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(H,U){if(Array.isArray(U)){if(U.some(ne=>H.scheme===ne))return H}else if(U===H.scheme)return H}}var W;(function(ge){ge[ge.UNKNOWN=0]="UNKNOWN",ge[ge.KEYBOARD=1]="KEYBOARD",ge[ge.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Y(ge,H,U,ne){if(!ge.isSticky(H))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$DE=Y,e.$EE=new F;var le;(function(ge){ge[ge.LEFT=0]="LEFT",ge[ge.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(H){const U=this.a=H.get(M.$Zh);for(const[ne,ye]of this.c)this.e(ne,ye,U);this.c.clear()}e(H,U,ne){const ye=ne.createInstance(U);this.d.set(H,ye)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,O.$Of)(this.b)}registerEditorSerializer(H,U){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,U,this.a):this.c.set(H,U),(0,P.$Qc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}b.$rn.add(e.$hE.EditorFactory,new Q);async function Z(ge,H,U){return!ge||!ge.length?[]:await Promise.all(ge.map(async ne=>{const ye=g.URI.revive(ne.fileUri);if(!ye){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await H.canHandleResource(ye)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let me=ne.exists,ee=ne.type;if(typeof me!="boolean"||typeof ee!="number")try{ee=(await H.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,me=!0}catch(G){U.error(G),me=!1}if(!me&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(ee===$.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return me?{resource:ye,options:ie}:{resource:ye,options:ie,forceUntitled:!0}}))}e.$FE=Z;var x;(function(ge){ge[ge.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ge[ge.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function oe(ge){const H=ge;if(!H)return!1;const U=H;if(U.modified)return oe(U.modified);const ne=H;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$GE=oe;function X(ge){return(0,R.$Mi)(ge)}e.$HE=X;function ve(ge,H,U){const ne=(0,R.$Ni)(ge,H);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$IE=ve}),define(Se[278],ke([1,0,4,225,5,3,28,37,19,24,78,264]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$PE=e.$OE=e.ViewContentGroups=e.$NE=e.$ME=e.ViewContainerLocation=e.Extensions=e.$LE=e.$KE=e.$JE=void 0,e.$JE="views",e.$KE=(0,O.localize)(0,null),e.$LE=(0,C.$gw)("default-view-icon",R.$6j.window,(0,O.localize)(1,null));var m;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$ME=[0,1,2];function k(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$NE=k;class f extends P.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(h,u,c){const l=this.get(h.id);if(l)return l;const S=h;return S.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,M.$xc)(this.g,u,[]).push(S),c?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:u}),S}deregisterViewContainer(h){for(const u of this.g.keys()){const c=this.g.get(u),l=c?.indexOf(h);if(l!==-1){c?.splice(l,1),c.length===0&&this.g.delete(u),this.f.fire({viewContainer:h,viewContainerLocation:u});return}}}get(h){return this.all.filter(u=>u.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(c=>c?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(u=>this.getViewContainerLocation(u)===h)}}b.$rn.add(m.ViewContainersRegistry,new f);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d||(e.ViewContentGroups=d={}));function s(r,h){const u=r.group??d.More,c=h.group??d.More;return u!==c?u.localeCompare(c):(r.order??5)-(h.order??5)}class i extends P.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Gc}registerViews(h,u){this.registerViews2([{views:h,viewContainer:u}])}registerViews2(h){h.forEach(({views:u,viewContainer:c})=>this.r(u,c)),this.c.fire(h)}deregisterViews(h,u){const c=this.s(h,u);c.length&&this.f.fire({views:c,viewContainer:u})}moveViews(h,u){for(const c of this.m.keys())if(c!==u){const l=this.s(h,c);l.length&&(this.r(l,u),this.g.fire({views:l,from:c,to:u}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const u of this.j){const c=(this.m.get(u)||[]).filter(l=>l.id===h)[0];if(c)return c}return null}getViewContainer(h){for(const u of this.j)if((this.m.get(u)||[]).filter(l=>l.id===h)[0])return u;return null}registerViewWelcomeContent(h,u){return this.n.add(h,u),this.h.fire(h),(0,P.$Qc)(()=>{this.n.delete(h,u),this.h.fire(h)})}registerViewWelcomeContent2(h,u){const c=new Map;for(const[l,S]of u)this.n.add(h,S),c.set(l,(0,P.$Qc)(()=>{this.n.delete(h,S),this.h.fire(h)}));return this.h.fire(h),c}getViewWelcomeContent(h){const u=[];return this.n.forEach(h,c=>u.push(c)),u.sort(s)}r(h,u){let c=this.m.get(u);c||(c=[],this.m.set(u,c),this.j.push(u));for(const l of h){if(this.getView(l.id)!==null)throw new Error((0,O.localize)(2,null,l.id));c.push(l)}}s(h,u){const c=this.m.get(u);if(!c)return[];const l=[],S=[];for(const L of c)h.includes(L)?l.push(L):S.push(L);return l.length&&(S.length?this.m.set(u,S):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),l}}b.$rn.add(m.ViewsRegistry,new i),e.$OE=(0,g.$1h)("viewsService"),e.$PE=(0,g.$1h)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(h,u){this.c=!1,this.d=!1,(0,y.$in)(this,h),this.d=!!u,this.resolve=async c=>{if(u&&!this.c){const l=await u(c);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$QE=a;class t extends Error{constructor(h){super((0,O.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$RE=t}),define(Se[279],ke([1,0,2,29,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$eF=e.$dF=void 0;function P(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(O.$Es.isIRange)}e.$dF=P;function M(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(P)}e.$eF=M;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.InteractiveSessionCopyKind=$={})),e.$fF=(0,g.$1h)("IChatService")}),define(Se[140],ke([1,0,4,12,226]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new D.$Sd,this.n=new D.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,R){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const k={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,R,b)};v(k)}},R)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,O.$2g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,O.$2g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$glb=P}),define(Se[280],ke([1,0,227,46,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$qH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$pH=e.MemoryRangeType=e.$oH=e.State=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=void 0,e.$lG="workbench.view.debug",e.$mG="workbench.debug.variablesView",e.$nG="workbench.debug.watchExpressionsView",e.$oG="workbench.debug.callStackView",e.$pG="workbench.debug.loadedScriptsView",e.$qG="workbench.debug.breakPointsView",e.$rG="workbench.debug.disassemblyView",e.$sG="workbench.panel.repl",e.$tG="workbench.panel.repl.view",e.$uG=new O.$fj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$vG=new O.$fj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$wG=new O.$fj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$xG="debugUx",e.$yG=new O.$fj(e.$xG,"default",{type:"string",description:D.localize(3,null)}),e.$zG=new O.$fj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$AG=new O.$fj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$BG=new O.$fj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$CG=new O.$fj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$DG=new O.$fj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$EG=new O.$fj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$FG=new O.$fj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$GG=new O.$fj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$HG=new O.$fj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$IG=new O.$fj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$JG=new O.$fj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$KG=new O.$fj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$LG=new O.$fj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$MG=new O.$fj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$NG=new O.$fj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$OG=new O.$fj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$PG=new O.$fj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$QG=new O.$fj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$RG=new O.$fj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$SG=new O.$fj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$TG=new O.$fj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$UG=new O.$fj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$VG=new O.$fj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$WG=new O.$fj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$XG=new O.$fj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$YG=new O.$fj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$ZG=new O.$fj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$1G=new O.$fj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$2G=new O.$fj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$3G=new O.$fj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$4G=new O.$fj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$5G=new O.$fj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$6G=new O.$fj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$7G=new O.$fj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$8G=new O.$fj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$9G=new O.$fj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$0G=new O.$fj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$$G=new O.$fj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$_G=new O.$fj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$aH=new O.$fj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$bH=new O.$fj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$cH=new O.$fj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$dH=new O.$fj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$eH=new O.$fj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$fH=new O.$fj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$gH=new O.$fj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$hH=new O.$fj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$iH=new O.$fj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const P=m=>D.localize(52,null,m);e.$jH=P,e.$kH="editor.contrib.debug",e.$lH="editor.contrib.breakpoint",e.$mH="debug",e.$nH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var M;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(M||(e.State=M={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$oH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$pH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$qH=(0,g.$1h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Se[281],ke([1,0,13,2,16,24,17,29,21,19]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=void 0;const R=/{([^}]+)}/g;function C(L,w,p){return L.replace(R,function(E,A){return w&&A.length>0&&A[0]!=="_"?E:p&&p.hasOwnProperty(A)?p[A]:E})}e.$kF=C;function m(L){const w={};for(const p of Object.keys(L))p.startsWith("!")||(w[p]=L[p]);return w}e.$lF=m;function v(L){return L.configuration.request==="attach"&&!k(L)&&(!L.parentSession||v(L.parentSession))}e.$mF=v;function k(L){let w=L.configuration.type;if(w)return w==="vslsShare"&&(w=L.configuration.adapterProxy.configuration.type),(0,D.$7e)(w,"extensionhost")||(0,D.$7e)(w,"pwa-extensionhost")?L:L.parentSession?k(L.parentSession):void 0}e.$nF=k;function f(L){return L.type&&(L.label||L.program||L.runtime)}e.$oF=f;function d(L,w,p){let E,A=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=z.exec(L);){const I=N.index+1,j=I+N[0].length;if(I<=w&&j>=p){E=N[0],A=I;break}}if(E){const I=/\w+/g;let j=null;for(;(j=I.exec(E))&&!(j.index+1+A+j[0].length>=p););j&&(E=E.substring(0,I.lastIndex))}return E?{start:A,end:A+E.length-1}:{start:0,end:0}}e.$pF=d;async function s(L,w,p,E){if(L.evaluatableExpressionProvider.has(w)){const A=L.evaluatableExpressionProvider.ordered(w),z=(0,y.$Hb)(await Promise.all(A.map(async N=>{try{return await N.provideEvaluatableExpression(w,p,E??$.CancellationToken.None)}catch{return}})));if(z.length>0){let N=z[0].expression;const I=z[0].range;return N||(N=w.getLineContent(p.lineNumber).substring(I.startColumn-1,I.endColumn-1)),{range:I,matchingExpression:N}}}else{const A=w.getLineContent(p.lineNumber),{start:z,end:N}=d(A,p.column,p.column),I=A.substring(z-1,N);return{matchingExpression:I,range:new b.$Es(p.lineNumber,z,p.lineNumber,z+I.length)}}return null}e.$qF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(L){return!!(L&&L.match(i))}e.$rF=n;function o(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(n(L.path))return O.URI.parse(L.path);if((0,g.$ic)(L.path))return O.URI.file(L.path)}return L.path}function a(L){if(typeof L.path=="object"){const w=O.URI.revive(L.path);if(w)return w.scheme===M.Schemas.file?w.fsPath:w.toString()}return L.path}function t(L,w){const p=w?o:a,E=(0,P.$fn)(L);return h(E,(A,z)=>{A&&z&&(z.path=p(z))}),E}e.$sF=t;function r(L,w){const p=w?o:a,E=(0,P.$fn)(L);return h(E,(A,z)=>{!A&&z&&(z.path=p(z))}),E}e.$tF=r;function h(L,w){switch(L.type){case"event":{const p=L;switch(p.event){case"output":w(!1,p.body.source);break;case"loadedSource":w(!1,p.body.source);break;case"breakpoint":w(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=L;switch(p.command){case"setBreakpoints":w(!0,p.arguments.source);break;case"breakpointLocations":w(!0,p.arguments.source);break;case"source":w(!0,p.arguments.source);break;case"gotoTargets":w(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(E=>w(!1,E));break;default:break}break}case"response":{const p=L;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(E=>w(!1,E.source));break;case"loadedSources":p.body.sources.forEach(E=>w(!1,E));break;case"scopes":p.body.scopes.forEach(E=>w(!1,E.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"setBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"disassemble":p.body?.instructions.forEach(A=>w(!1,A.location));break;default:break}break}}}function u(L){return L.filter(w=>!w.presentation?.hidden).sort((w,p)=>w.presentation?p.presentation?w.presentation.group?p.presentation.group?w.presentation.group!==p.presentation.group?w.presentation.group.localeCompare(p.presentation.group):c(w.presentation.order,p.presentation.order):-1:p.presentation.group?1:c(w.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$uF=u;function c(L,w){return typeof L!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:L-w}async function l(L,w){const p=L.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(p!=="none"&&(await w.saveAll(),p==="allEditorsInActiveGroup")){const E=w.activeEditorPane;E&&E.input.resource?.scheme===M.Schemas.untitled&&await w.save({editor:E.input,groupId:E.group.id})}await L.reloadConfiguration()}e.$vF=l;const S=(L,w)=>!L||!w?L===w:L.name===w.name&&L.path===w.path&&L.sourceReference===w.sourceReference;e.$wF=S}),define(Se[282],ke([1,0,51,62,24,16,11,13,31,228,140]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=e.$5gc=e.$4gc=void 0;class C extends R.$glb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(C.b);for(const a of o){const t=a.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$4gc=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$5gc=m;class v extends m{constructor(s){super(),this.z=s}y(s){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$6gc=v;class k extends m{constructor(s){super(),this.z=s}y(s){return O.createConnection(this.z.path,s)}}e.$7gc=k;class f extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(P.$ic(s)){if(!await $.Promises.exists(s))throw new Error(y.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=g.$in(g.$fn(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),M.$i?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=P.$jc(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(P.$ic(s.program)?n.program=s.program:n.program=P.$jc(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=f.A(o.win,i)),o.winx86&&(n.winx86=f.A(o.winx86,i)),o.windows&&(n.windows=f.A(o.windows,i)),o.osx&&(n.osx=f.A(o.osx,i)),o.linux&&(n.linux=f.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const c=u.contributes.debuggers;c&&c.length>0&&c.filter(l=>typeof l.type=="string"&&b.$7e(l.type,i)).forEach(l=>{const S=f.A(l,u.extensionLocation.fsPath);n=g.$in(n,S,u.isBuiltin)})}let o;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:M.$i?o=n.win||n.windows:M.$j?o=n.osx:M.$k&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,h=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(h||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$8gc=f}),define(Se[283],ke([1,0,51,33,11]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;function P(y,R){return new Promise((C,m)=>{let v="";const k=D.spawn(y,R);k.pid&&k.stdout.on("data",f=>{v+=f.toString()}),k.on("error",f=>{m(f)}),k.on("close",f=>{C(v)})})}async function M(y){if(y)if(g.$i){const R=await new Promise((C,m)=>{$e(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{R.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(y)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$9gc=M;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,R,C,m,v){y=y.trim().toLowerCase();let k;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?k=1:y.indexOf("cmd.exe")>=0?k=0:y.indexOf("bash")>=0?k=2:g.$i?k=0:k=2;let f,d=" ";switch(k){case 1:if(f=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,O.$8f)(m);s&&(d+=`${s}:; `),d+=`cd ${f(m)}; `}if(v)for(const s in v){const i=v[s];i===null?d+=`Remove-Item env:${s}; `:d+=`\${env:${s}}='${i}'; `}if(R.length>0){const s=R.shift(),i=C?s:f(s);d+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of R)d+=n==="<"||n===">"||C?n:f(n),d+=" "}break;case 0:if(f=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,O.$8f)(m);s&&(d+=`${s}: && `),d+=`cd ${f(m)} && `}if(v){d+='cmd /C "';for(const s in v){let i=v[s];i===null?d+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),d+=`set "${s}=${i}" && `)}}for(const s of R)d+=s==="<"||s===">"||C?s:f(s),d+=" ";v&&(d+='"');break;case 2:{f=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(d+=`cd ${f(m)} ; `),v){d+="/usr/bin/env";for(const i in v){const n=v[i];n===null?d+=` -u ${s(i)}`:d+=` ${s(`${i}=${n}`)}`}d+=" "}for(const i of R)d+=i==="<"||i===">"||C?i:f(i),d+=" ";break}}return d}e.$0gc=$}),define(Se[111],ke([1,0,22,34,52,100,17,16,11,46]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=e.$KI=e.$JI=e.$II=e.CellStatusbarAlignment=e.$HI=e.$GI=e.$FI=e.NotebookEditorPriority=e.$EI=e.$DI=e.$CI=e.$BI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AI=e.$zI=e.$yI=e.$xI=e.CellKind=e.$wI=e.$vI=e.$uI=void 0,e.$uI="workbench.editor.notebook",e.$vI="workbench.editor.notebookTextDiffEditor",e.$wI="workbench.editor.interactive";var R;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(R||(e.CellKind=R={})),e.$xI=["application/json","application/javascript","text/html","image/svg+xml",P.$1r.latex,P.$1r.markdown,"image/png","image/jpeg",P.$1r.text],e.$yI=[P.$1r.latex,P.$1r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$1r.text],e.$zI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AI="_notAvailable";var C;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var v;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var k;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var f;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var d;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(F){F.scheme=M.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${W.join("")}]+`),le=7;function Q(ge,H){const U=H.toString(le),ye=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,D.$Ae)(D.$ge.fromString(ge.scheme),!0,!0)}`;return ge.with({scheme:F.scheme,fragment:ye})}F.generate=Q;function Z(ge){if(ge.scheme!==F.scheme)return;const H=ge.fragment.indexOf("s");if(H<0)return;const U=parseInt(ge.fragment.substring(0,H).replace(Y,""),le),ne=(0,D.$ze)(ge.fragment.substring(H+1)).toString();if(!isNaN(U))return{handle:U,notebook:ge.with({scheme:ne,fragment:null})}}F.parse=Z;function x(ge,H){return ge.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${ge.scheme!==M.Schemas.file?ge.scheme:""}`})}F.generateCellOutputUri=x;function oe(ge){if(ge.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!H)return;const U=H[1]&&H[1]!==""?H[1]:void 0,ne=H[2];return{outputId:U,notebook:ge.with({scheme:ne||M.Schemas.file,fragment:null})}}F.parseCellOutputUri=oe;function X(ge,H,U){return F.generate(ge,H).with({scheme:U})}F.generateCellPropertyUri=X;function ve(ge,H){if(ge.scheme===H)return F.parse(ge.with({scheme:F.scheme}))}F.parseCellPropertyUri=ve})(n||(e.CellUri=n={}));const o=F=>$.$i?F.replace(/\//g,"\\"):F;class a{constructor(W=[],Y=e.$xI){this.e=Y,this.d=[...new Set(W)].map(le=>({pattern:le,matches:O.$Hj(o(le))}))}sort(W){const Y=new Map(g.Iterable.map(W,Q=>[Q,o(Q)]));let le=[];for(const{matches:Q}of this.d)for(const[Z,x]of Y)if(Q(x)){le.push(Z),Y.delete(Z);break}return Y.size&&(le=le.concat([...Y.keys()].sort((Q,Z)=>this.e.indexOf(Q)-this.e.indexOf(Z)))),le}prioritize(W,Y){const le=this.f(W);if(le===-1){this.d.unshift({pattern:W,matches:O.$Hj(o(W))});return}const Q=new Set(Y.map(x=>this.f(x,le)));Q.delete(-1);const Z=Array.from(Q).sort();this.d.splice(le+1,0,...Z.map(x=>this.d[x]));for(let x=Z.length-1;x>=0;x--)this.d.splice(Z[x],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Y=this.d.length){const le=o(W);for(let Q=0;Q<Y;Q++)if(this.d[Q].matches(le))return Q;return-1}}e.$BI=a;function t(F,W,Y,le=(Q,Z)=>Q===Z){const Q=[];function Z(X,ve,ge){if(ve===0&&ge.length===0)return;const H=Q[Q.length-1];H&&H.start+H.deleteCount===X?(H.deleteCount+=ve,H.toInsert.push(...ge)):Q.push({start:X,deleteCount:ve,toInsert:ge})}let x=0,oe=0;for(;;){if(x===F.length){Z(x,0,W.slice(oe));break}if(oe===W.length){Z(x,F.length-x,[]);break}const X=F[x],ve=W[oe];if(le(X,ve)){x+=1,oe+=1;continue}Y(ve)?(Z(x,1,[]),x+=1):(Z(x,0,[ve]),oe+=1)}return Q}e.$CI=t,e.$DI=new y.$fj("notebookEditorCursorAtBoundary","none"),e.$EI=new y.$fj("notebookEditorCursorAtLineBoundary","none");var r;(function(F){F.default="default",F.option="option"})(r||(e.NotebookEditorPriority=r={}));function h(F){const W=F;return!!((typeof W.include=="string"||O.$Ij(W.include))&&(typeof W.exclude=="string"||O.$Ij(W.exclude)))}e.$FI=h;function u(F,W,Y){if(Array.isArray(F.viewType)&&F.viewType.indexOf(W)>=0||F.viewType===W)return!0;if(F.filenamePattern){const le=h(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Q=h(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(O.$Gj(le,(0,b.$nc)(Y.fsPath).toLowerCase()))return!(Q&&O.$Gj(Q,(0,b.$nc)(Y.fsPath).toLowerCase()))}return!1}e.$GI=u,e.$HI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class l{static{this.d="notebook/"}static create(W){return`${l.d}${W}`}static parse(W){if(W.startsWith(l.d))return W.substring(l.d.length)}}e.$II=l;function S(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$JI=S;const L=new TextDecoder;function w(F){const W=[];let Y=!1;for(const x of F)(W.length===0||Y)&&(W.push(x),Y=!0);let le=A(W);const Q=D.$ge.concat(W.map(x=>D.$ge.wrap(x))),Z=T(Q);return le=le||Z.byteLength!==Q.byteLength,{data:Z,didCompression:le}}e.$KI=w,e.$LI=`${String.fromCharCode(27)}[A`;const p=e.$LI.split("").map(F=>F.charCodeAt(0)),E=10;function A(F){let W=!1;return F.forEach((Y,le)=>{if(le===0||Y.length<e.$LI.length)return;const Q=F[le-1],Z=Y.subarray(0,e.$LI.length);if(Z[0]===p[0]&&Z[1]===p[1]&&Z[2]===p[2]){const x=Q.lastIndexOf(E);if(x===-1)return;W=!0,F[le-1]=Q.subarray(0,x),F[le]=Y.subarray(e.$LI.length)}}),W}function z(F){let W=F;do F=W,W=F.replace(/[^\n]\x08/gm,"");while(W.length<F.length);return F}function N(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const W=F.match(/^(.*)\r+/m)[1];let Y=F.match(/\r+(.*)$/m)[1];Y=Y+W.slice(Y.length,W.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return F}const I="\b".charCodeAt(0),j="\r".charCodeAt(0);function T(F){return!F.buffer.includes(I)&&!F.buffer.includes(j)?F:D.$ge.fromString(N(z(L.decode(F.buffer))))}}),define(Se[7],ke([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k){"use strict";var f,d,s,i,n,o,a,t,r,h,u,c,l,S,L,w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$yM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$xM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.TestRunProfileKind=e.TestResultState=e.$dM=e.$cM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$bM=e.NotebookVariablesRequestKind=e.$aM=e.$_L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$$L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.ColorThemeKind=e.$5L=e.$4L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$3L=e.DebugConsoleMode=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$WL=e.$VL=e.FileChangeType=e.$UL=e.$TL=e.$SL=e.$RL=e.InlineCompletionTriggerKind=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.ConfigurationTarget=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$uL=e.ViewBadge=e.ProgressLocation=e.$tL=e.$sL=e.TaskScope=e.ShellQuoting=e.$rL=e.$qL=e.$pL=e.TaskPanelKind=e.TaskRevealKind=e.$oL=e.TerminalLocation=e.$nL=e.$mL=e.$lL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$kL=e.$jL=e.$iL=e.$hL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$gL=e.StatusBarAlignment=e.ViewColumn=e.$fL=e.$eL=e.$dL=e.$cL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$bL=e.$aL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.LanguageStatusSeverity=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.CodeActionTriggerKind=e.$1K=e.$ZK=e.SymbolTag=e.SymbolKind=e.$YK=e.$XK=e.DocumentHighlightKind=e.$WK=e.$VK=e.$UK=e.$TK=e.DiagnosticSeverity=e.DiagnosticTag=e.$SK=e.$RK=e.FileEditType=e.$QK=e.$PK=e.$OK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(V){return Object.assign(V,{apply:function(...we){if(we.length===0)return Reflect.construct(V,[]);{const Le=we.length===1?[]:we[1];return Reflect.construct(V,Le,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(V,[]);{const[Le,...Ze]=we;return Reflect.construct(V,Ze,Le.constructor)}}})}var A;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var z;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let N=f=class{static from(...q){let we=q;return new f(function(){if(we){for(const Le of we)Le&&typeof Le.dispose=="function"&&Le.dispose();we=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$HK=N,e.$HK=N=f=Ge([E],N);let I=d=class{static Min(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isBefore(we)&&(we=Ze)}return we}static Max(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isAfter(we)&&(we=Ze)}return we}static isPosition(q){if(!q)return!1;if(q instanceof d)return!0;const{line:we,character:Le}=q;return typeof we=="number"&&typeof Le=="number"}static of(q){if(q instanceof d)return q;if(this.isPosition(q))return new d(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,we){if(q<0)throw(0,O.$7)("line must be non-negative");if(we<0)throw(0,O.$7)("character must be non-negative");this.c=q,this.e=we}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,we=0){if(q===null||we===null)throw(0,O.$7)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,we=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&we===0?this:new d(this.line+Le,this.character+we)}with(q,we=this.character){if(q===null||we===null)throw(0,O.$7)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,we=typeof q.character=="number"?q.character:this.character),Le===this.line&&we===this.character?this:new d(Le,we)}toJSON(){return{line:this.line,character:this.character}}};e.$IK=I,e.$IK=I=d=Ge([E],I);let j=s=class{static isRange(q){return q instanceof s?!0:q?I.isPosition(q.start)&&I.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,we,Le,Ze){let nt,ct;if(typeof q=="number"&&typeof we=="number"&&typeof Le=="number"&&typeof Ze=="number"?(nt=new I(q,we),ct=new I(Le,Ze)):I.isPosition(q)&&I.isPosition(we)&&(nt=I.of(q),ct=I.of(we)),!nt||!ct)throw new Error("Invalid arguments");nt.isBefore(ct)?(this.c=nt,this.e=ct):(this.c=ct,this.e=nt)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):I.isPosition(q)?!(I.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const we=I.Max(q.start,this.c),Le=I.Min(q.end,this.e);if(!we.isAfter(Le))return new s(we,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const we=I.Min(q.start,this.c),Le=I.Max(q.end,this.end);return new s(we,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,we=this.end){if(q===null||we===null)throw(0,O.$7)();let Le;return q?I.isPosition(q)?Le=q:(Le=q.start||this.start,we=q.end||this.end):Le=this.start,Le.isEqual(this.c)&&we.isEqual(this.end)?this:new s(Le,we)}toJSON(){return[this.start,this.end]}};e.$JK=j,e.$JK=j=s=Ge([E],j);let T=i=class extends j{static isSelection(q){return q instanceof i?!0:q?j.isRange(q)&&I.isPosition(q.anchor)&&I.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,we,Le,Ze){let nt,ct;if(typeof q=="number"&&typeof we=="number"&&typeof Le=="number"&&typeof Ze=="number"?(nt=new I(q,we),ct=new I(Le,Ze)):I.isPosition(q)&&I.isPosition(we)&&(nt=I.of(q),ct=I.of(we)),!nt||!ct)throw new Error("Invalid arguments");super(nt,ct),this.f=nt,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$KK=T,e.$KK=T=i=Ge([E],T);const F=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,O.$7)("connectionToken")};class W{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we,Le){if(typeof q!="string"||q.length===0)throw(0,O.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,O.$7)("port");typeof Le<"u"&&F(Le),this.host=q,this.port=Math.round(we),this.connectionToken=Le}}e.$LK=W;class Y{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we){this.makeConnection=q,this.connectionToken=we,typeof we<"u"&&F(we)}}e.$MK=Y;class le extends Error{static NotAvailable(q,we){return new le(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(q){return new le(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,we=v.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=we,this._detail=Le,Object.setPrototypeOf(this,le.prototype)}}e.$NK=le;var Q;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var Z;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let x=n=class{static isTextEdit(q){return q instanceof n?!0:q?j.isRange(q)&&typeof q.newText=="string":!1}static replace(q,we){return new n(q,we)}static insert(q,we){return n.replace(new j(q,q),we)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const we=new n(new j(new I(0,0),new I(0,0)),"");return we.newEol=q,we}get range(){return this.c}set range(q){if(q&&!j.isRange(q))throw(0,O.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,O.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,O.$7)("newEol");this.f=q}constructor(q,we){this.c=q,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$OK=x,e.$OK=x=n=Ge([E],x);let oe=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?_t.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,we){return new o(q,we)}static insertCells(q,we){return new o(new _t(q,q),we)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,we){const Le=new o(new _t(q,q),[]);return Le.newCellMetadata=we,Le}static updateNotebookMetadata(q){const we=new o(new _t(0,0),[]);return we.newNotebookMetadata=q,we}constructor(q,we){this.range=q,this.newCells=we}};e.$PK=oe,e.$PK=oe=o=Ge([E],oe);class X{static isSnippetTextEdit(q){return q instanceof X?!0:q?j.isRange(q.range)&&H.isSnippetString(q.snippet):!1}static replace(q,we){return new X(q,we)}static insert(q,we){return X.replace(new j(q,q),we)}constructor(q,we){this.range=q,this.snippet=we}}e.$QK=X;var ve;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let ge=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,we,Le,Ze){this.c.push({_type:1,from:q,to:we,options:Le,metadata:Ze})}createFile(q,we,Le){this.c.push({_type:1,from:void 0,to:q,options:we,metadata:Le})}deleteFile(q,we,Le){this.c.push({_type:1,from:q,to:void 0,options:we,metadata:Le})}e(q,we,Le){this.c.push({_type:3,metadata:Le,uri:q,edit:{editType:5,metadata:we},notebookMetadata:we})}f(q,we,Le,Ze){const nt=we.start,ct=we.end;(nt!==ct||Le.length>0)&&this.c.push({_type:5,uri:q,index:nt,count:ct-nt,cells:Le,metadata:Ze})}g(q,we,Le,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:we,metadata:Le}})}replace(q,we,Le,Ze){this.c.push({_type:2,uri:q,edit:new x(we,Le),metadata:Ze})}insert(q,we,Le,Ze){this.replace(q,new j(we,we),Le,Ze)}delete(q,we,Le){this.replace(q,we,"",Le)}has(q){return this.c.some(we=>we._type===2&&we.uri.toString()===q.toString())}set(q,we){if(we)for(const Le of we){if(!Le)continue;let Ze,nt;Array.isArray(Le)?(Ze=Le[0],nt=Le[1]):Ze=Le,oe.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,nt):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,nt):this.f(q,Ze.range,Ze.newCells,nt):X.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:nt}):this.c.push({_type:2,uri:q,edit:Ze,metadata:nt})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Le]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const we=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===q.toString()&&we.push(Le.edit);return we}entries(){const q=new P.$Ac;for(const we of this.c)if(we._type===2){let Le=q.get(we.uri);Le||(Le=[we.uri,[]],q.set(we.uri,Le)),Le[1].push(we.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$RK=ge,e.$RK=ge=Ge([E],ge);let H=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,we=this.e++){if(typeof q=="function"){const Le=new a;Le.e=this.e,q(Le),this.e=Le.e,q=Le.value}else q=a.c(q);return this.value+="${",this.value+=we,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,we=this.e++){const Le=q.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,we){if(typeof we=="function"){const Le=new a;Le.e=this.e,we(Le),this.e=Le.e,we=Le.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$SK=H,e.$SK=H=a=Ge([E],H);var U;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?j.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,we){if(this.uri=q,we)if(j.isRange(we))this.range=j.of(we);else if(I.isPosition(we))this.range=new j(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$TK=ye,e.$TK=ye=t=Ge([E],ye);let fe=class{static is(q){return q?typeof q.message=="string"&&q.location&&j.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,we){this.location=q,this.message=we}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.location.range.isEqual(we.location.range)&&q.location.uri.toString()===we.location.uri.toString()}};e.$UK=fe,e.$UK=fe=Ge([E],fe);let me=class{constructor(q,we,Le=ne.Error){if(!j.isRange(q))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=q,this.message=we,this.severity=Le}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.severity===we.severity&&q.code===we.code&&q.severity===we.severity&&q.source===we.source&&q.range.isEqual(we.range)&&(0,D.$ub)(q.tags,we.tags)&&(0,D.$ub)(q.relatedInformation,we.relatedInformation,fe.isEqual)}};e.$VK=me,e.$VK=me=Ge([E],me);let ee=class{constructor(q,we){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=we}};e.$WK=ee,e.$WK=ee=Ge([E],ee);var ie;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(q,we=ie.Text){this.range=q,this.kind=we}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$XK=G,e.$XK=G=Ge([E],G);let te=class{constructor(q,we){this.uri=q,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$YK=te,e.$YK=te=Ge([E],te);var J;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(J||(e.SymbolKind=J={}));var ce;(function(V){V[V.Deprecated=1]="Deprecated"})(ce||(e.SymbolTag=ce={}));let be=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,we,Le,Ze,nt){this.name=q,this.kind=we,this.containerName=nt,typeof Le=="string"&&(this.containerName=Le),Ze instanceof ye?this.location=Ze:Le instanceof j&&(this.location=new ye(Ze,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};e.$ZK=be,e.$ZK=be=r=Ge([E],be);let Ie=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(h.validate)}constructor(q,we,Le,Ze,nt){this.name=q,this.detail=we,this.kind=Le,this.range=Ze,this.selectionRange=nt,this.children=[],h.validate(this)}};e.$1K=Ie,e.$1K=Ie=h=Ge([E],Ie);var Fe;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(Fe||(e.CodeActionTriggerKind=Fe={}));let B=class{constructor(q,we){this.title=q,this.kind=we}};e.$2K=B,e.$2K=B=Ge([E],B);let _=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$3K=_,e.$3K=_=u=Ge([E],_),_.Empty=new _(""),_.QuickFix=_.Empty.append("quickfix"),_.Refactor=_.Empty.append("refactor"),_.RefactorExtract=_.Refactor.append("extract"),_.RefactorInline=_.Refactor.append("inline"),_.RefactorMove=_.Refactor.append("move"),_.RefactorRewrite=_.Refactor.append("rewrite"),_.Source=_.Empty.append("source"),_.SourceOrganizeImports=_.Source.append("organizeImports"),_.SourceFixAll=_.Source.append("fixAll"),_.Notebook=_.Empty.append("notebook");let se=class{constructor(q,we){if(this.range=q,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$4K=se,e.$4K=se=Ge([E],se);class K{constructor(q,we,Le,Ze,nt,ct){this.kind=q,this.name=we,this.detail=Le,this.uri=Ze,this.range=nt,this.selectionRange=ct}}e.$5K=K;class ae{constructor(q,we){this.fromRanges=we,this.from=q}}e.$6K=ae;class de{constructor(q,we){this.fromRanges=we,this.to=q}}e.$7K=de;var Ae;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let Be=class{constructor(q,we){this.range=q,this.command=we}get isResolved(){return!!this.command}};e.$8K=Be,e.$8K=Be=Ge([E],Be);let Xe=c=class{#e;static isMarkdownString(q){return q instanceof c?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,we=!1){this.#e=new g.$bk(q,{supportThemeIcons:we})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,we){return this.#e.appendCodeblock(we??"",q),this}};e.$9K=Xe,e.$9K=Xe=c=Ge([E],Xe);let Ye=class{constructor(q,we){this.label=q,this.documentation=we}};e.$0K=Ye,e.$0K=Ye=Ge([E],Ye);let it=class{constructor(q,we){this.label=q,this.documentation=we,this.parameters=[]}};e.$$K=it,e.$$K=it=Ge([E],it);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$_K=st,e.$_K=st=Ge([E],st);var Pe;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Pe||(e.SignatureHelpTriggerKind=Pe={}));var Te;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Te||(e.InlayHintKind=Te={}));let qe=class{constructor(q){this.value=q}};e.$aL=qe,e.$aL=qe=Ge([E],qe);let Re=class{constructor(q,we,Le){this.position=q,this.label=we,this.kind=Le}};e.$bL=Re,e.$bL=Re=Ge([E],Re);var xe;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe||(e.CompletionTriggerKind=xe={}));var he;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var ue;(function(V){V[V.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ce=class{constructor(q,we){this.label=q,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$cL=Ce,e.$cL=Ce=Ge([E],Ce);let Ve=class{constructor(q=[],we=!1){this.items=q,this.isIncomplete=we}};e.$dL=Ve,e.$dL=Ve=Ge([E],Ve);let Je=class{constructor(q,we,Le){this.insertText=q,this.range=we,this.command=Le}};e.$eL=Je,e.$eL=Je=Ge([E],Je);let et=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$fL=et,e.$fL=et=Ge([E],et);var ot;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var ut;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function je(V,q){return`${C.$em.toKey(V)}.${q}`}e.$gL=je;var St;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Ht;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var zt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(zt||(e.TextEditorRevealType=zt={}));var wt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var qt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(qt||(e.TextDocumentChangeReason=qt={}));var Ut;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ut||(e.DecorationRangeBehavior=Ut={})),function(V){function q(we){switch(we){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=q}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Kt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Kt||(e.SyntaxTokenType=Kt={})),function(V){function q(we){switch(we){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=q}(Kt||(e.SyntaxTokenType=Kt={}));let Gt=class{constructor(q,we){if(we&&!y.URI.isUri(we))throw(0,O.$7)("target");if(!j.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.target=we}};e.$hL=Gt,e.$hL=Gt=Ge([E],Gt);let Lt=class{constructor(q,we,Le,Ze){this.red=q,this.green=we,this.blue=Le,this.alpha=Ze}};e.$iL=Lt,e.$iL=Lt=Ge([E],Lt);let It=class{constructor(q,we){if(we&&!(we instanceof Lt))throw(0,O.$7)("color");if(!j.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.color=we}};e.$jL=It,e.$jL=It=Ge([E],It);let tt=class{constructor(q){if(!q||typeof q!="string")throw(0,O.$7)("label");this.label=q}};e.$kL=tt,e.$kL=tt=Ge([E],tt);var Jt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Vt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var lt;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class mt{constructor(q,we,Le){if(this.startIndex=q,this.length=we,this.tooltip=Le,typeof q!="number"||q<0)throw(0,O.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,O.$7)("length");if(Le!==void 0&&typeof Le!="string")throw(0,O.$7)("tooltip")}}e.$lL=mt;class Zt{constructor(q){this.uri=q}}e.$mL=Zt;class Pt{constructor(q){this.terminalCommand=q}}e.$nL=Pt;var kt;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,O.$7)("options")}}e.$oL=ft;var Mt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Mt||(e.TaskRevealKind=Mt={}));var Nt;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Nt||(e.TaskPanelKind=Nt={}));let yt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(q){switch(q){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(q,we){if(this.label=we,typeof q!="string"||typeof we!="string")throw(0,O.$7)("name");this.c=q}get id(){return this.c}};e.$pL=yt,e.$pL=yt=l=Ge([E],yt);function Qe(V){let q="";for(let we=0;we<V.length;we++)q+=V[we].replace(/,/g,",,")+",";return q}let Ft=class{constructor(q,we,Le){if(typeof q!="string")throw(0,O.$7)("process");this.e=[],this.c=q,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Le):this.f=we)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,O.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const we of this.e)q.push(we);return Qe(q)}};e.$qL=Ft,e.$qL=Ft=Ge([E],Ft);let Bt=class{constructor(q,we,Le){if(this.f=[],Array.isArray(we)){if(!q)throw(0,O.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q,this.f=we,this.g=Le}else{if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q,this.g=we}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)q.push(typeof we=="string"?we:we.value);return Qe(q)}};e.$rL=Bt,e.$rL=Bt=Ge([E],Bt);var Qt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Rt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$lg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$sL=Rt;let Me=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,we,Le,Ze,nt,ct){this.k=!1,this.l=this.definition=q;let dt;typeof we=="string"?(this.n=this.name=we,this.u=this.source=Le,this.execution=Ze,dt=nt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.n=this.name=Le,this.u=this.source=Ze,this.execution=nt,dt=ct):(this.target=we,this.n=this.name=Le,this.u=this.source=Ze,this.execution=nt,dt=ct),typeof dt=="string"?(this.q=[dt],this.r=!0):Array.isArray(dt)?(this.q=dt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Ft?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Bt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Rt?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,R.$lg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,O.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,O.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const we=this.l.type;(S.g===we||S.e===we||S.f===we||S.c===we)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,O.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$tL=Me,e.$tL=Me=S=Ge([E],Me);var Oe;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Oe||(e.ProgressLocation=Oe={}));var De;(function(V){function q(we){const Le=we;return(0,$.$Hf)(Le.value)?Le.tooltip&&!(0,$.$Df)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}V.isViewBadge=q})(De||(e.ViewBadge=De={}));let re=L=class{static isTreeItem(q,we){const Le=q;if(Le.checkboxState!==void 0){const Ze=(0,$.$Hf)(Le.checkboxState)?Le.checkboxState:(0,$.$Ff)(Le.checkboxState)&&(0,$.$Hf)(Le.checkboxState.state)?Le.checkboxState.state:void 0,nt=!(0,$.$Hf)(Le.checkboxState)&&(0,$.$Ff)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==He.Checked&&Ze!==He.Unchecked||nt!==void 0&&!(0,$.$Df)(nt))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof L)return!0;if(Le.label!==void 0&&!(0,$.$Df)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$Df)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$Df)(Le.iconPath)&&!y.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$Df)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,$.$Df)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,$.$Df)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$Df)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!y.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$Df)(Le.tooltip)&&!(Le.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<Ne.None&&Le.collapsibleState>Ne.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$Df)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,we=Ne.None){this.collapsibleState=we,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$uL=re,e.$uL=re=L=Ge([E],re);var Ne;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Ne||(e.TreeItemCollapsibleState=Ne={}));var He;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(He||(e.TreeItemCheckboxState=He={}));let _e=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$vL=_e,e.$vL=_e=Ge([E],_e);class Ke extends _e{}e.$wL=Ke;class rt extends Ke{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$xL=rt;class $t{constructor(q,we,Le,Ze){this.name=q,this.uri=we,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$yL=$t;let jt=class{#e=new Map;constructor(q){for(const[we,Le]of q??[]){const Ze=this.#e.get(this.#t(we));Ze?Ze.push(Le):this.#e.set(this.#t(we),[Le])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,we){this.#e.set(this.#t(q),[we])}forEach(q,we){for(const[Le,Ze]of this.#e)for(const nt of Ze)q.call(we,nt,Le,this)}*[Symbol.iterator](){for(const[q,we]of this.#e)for(const Le of we)yield[q,Le]}#t(q){return q.toLowerCase()}};e.$zL=jt,e.$zL=jt=Ge([E],jt);let Et=class{constructor(q){this.insertText=q}};e.$AL=Et,e.$AL=Et=Ge([E],Et);let Dt=class{constructor(q,we){this.label=we,this.insertText=q}};e.$BL=Dt,e.$BL=Dt=Ge([E],Dt);let vt=class{constructor(q,we){this.id=q,this.color=we}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$CL=vt,e.$CL=vt=Ge([E],vt),vt.File=new vt("file"),vt.Folder=new vt("folder");let mi=class{constructor(q){this.id=q}};e.$DL=mi,e.$DL=mi=Ge([E],mi);var At;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let ki=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,we){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,O.$7)("base");if(typeof we!="string")throw(0,O.$7)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$EL=ki,e.$EL=ki=Ge([E],ki);const qi=new WeakMap;function Ct(V,q){qi.set(V,q)}e.$FL=Ct;let ni=class{constructor(q,we,Le,Ze){this.enabled=typeof q=="boolean"?q:!0,typeof we=="string"&&(this.condition=we),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=qi.get(this)??(0,R.$lg)()),this.c}};e.$GL=ni,e.$GL=ni=Ge([E],ni);let $i=class extends ni{constructor(q,we,Le,Ze,nt){if(super(we,Le,Ze,nt),q===null)throw(0,O.$7)("location");this.location=q}};e.$HL=$i,e.$HL=$i=Ge([E],$i);let ai=class extends ni{constructor(q,we,Le,Ze,nt){super(we,Le,Ze,nt),this.functionName=q}};e.$IL=ai,e.$IL=ai=Ge([E],ai);let Di=class extends ni{constructor(q,we,Le,Ze,nt,ct,dt){if(super(Ze,nt,ct,dt),!we)throw(0,O.$7)("dataId");this.label=q,this.dataId=we,this.canPersist=Le}};e.$JL=Di,e.$JL=Di=Ge([E],Di);let Ci=class{constructor(q,we,Le){this.command=q,this.args=we||[],this.options=Le}};e.$KL=Ci,e.$KL=Ci=Ge([E],Ci);let Tt=class{constructor(q,we){this.port=q,this.host=we}};e.$LL=Tt,e.$LL=Tt=Ge([E],Tt);let bi=class{constructor(q){this.path=q}};e.$ML=bi,e.$ML=bi=Ge([E],bi);let Ii=class{constructor(q){this.implementation=q}};e.$NL=Ii,e.$NL=Ii=Ge([E],Ii);let ci=class{constructor(q,we,Le){this.session=q,this.threadId=we,this.frameId=Le}};e.$OL=ci,e.$OL=ci=Ge([E],ci);let ui=class{constructor(q,we){this.session=q,this.threadId=we}};e.$PL=ui,e.$PL=ui=Ge([E],ui);let ht=class{constructor(q,we){this.range=q,this.expression=we}};e.$QL=ht,e.$QL=ht=Ge([E],ht);var Vi;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let xt=class{constructor(q,we){this.range=q,this.text=we}};e.$RL=xt,e.$RL=xt=Ge([E],xt);let ri=class{constructor(q,we,Le=!0){this.range=q,this.variableName=we,this.caseSensitiveLookup=Le}};e.$SL=ri,e.$SL=ri=Ge([E],ri);let di=class{constructor(q,we){this.range=q,this.expression=we}};e.$TL=di,e.$TL=di=Ge([E],di);let Pi=class{constructor(q,we){this.frameId=q,this.stoppedLocation=we}};e.$UL=Pi,e.$UL=Pi=Ge([E],Pi);var Hi;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Ai=w=class extends Error{static FileExists(q){return new w(q,m.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(q){return new w(q,m.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(q){return new w(q,m.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(q){return new w(q,m.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(q,we=m.FileSystemProviderErrorCode.Unknown,Le){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,m.$yk)(this,we),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$VL=Ai,e.$VL=Ai=w=Ge([E],Ai);let pi=class{constructor(q,we,Le){this.start=q,this.end=we,this.kind=Le}};e.$WL=pi,e.$WL=pi=Ge([E],pi);var Ki;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var Li;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var li;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var wi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(q,we=[]){this.tokenTypes=q,this.tokenModifiers=we}}e.$XL=Ri;function cn(V){return typeof V>"u"||(0,$.$Ef)(V)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let we=0,Le=q.tokenTypes.length;we<Le;we++)this.k.set(q.tokenTypes[we],we);for(let we=0,Le=q.tokenModifiers.length;we<Le;we++)this.l.set(q.tokenModifiers[we],we)}}push(q,we,Le,Ze,nt){if(typeof q=="number"&&typeof we=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.o(q,we,Le,Ze,nt);if(j.isRange(q)&&typeof we=="string"&&cn(Le))return this.n(q,we,Le);throw(0,O.$7)()}n(q,we,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,nt=q.start.character,ct=q.end.character-q.start.character,dt=this.k.get(we);let Wt=0;if(Le)for(const Xt of Le){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Xt);Wt|=1<<ti>>>0}this.o(Ze,nt,ct,dt,Wt)}o(q,we,Le,Ze,nt){if(this.f&&(q<this.c||q===this.c&&we<this.e)){this.f=!1;const Wt=this.g.length/5|0;let Xt=0,ti=0;for(let ii=0;ii<Wt;ii++){let oi=this.g[5*ii],Bi=this.g[5*ii+1];oi===0?(oi=Xt,Bi+=ti):oi+=Xt,this.g[5*ii]=oi,this.g[5*ii+1]=Bi,Xt=oi,ti=Bi}}let ct=q,dt=we;this.f&&this.j>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.j++]=ct,this.g[this.j++]=dt,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=nt,this.c=q,this.e=we}static q(q){const we=[],Le=q.length/5|0;for(let dt=0;dt<Le;dt++)we[dt]=dt;we.sort((dt,Wt)=>{const Xt=q[5*dt],ti=q[5*Wt];if(Xt===ti){const ii=q[5*dt+1],oi=q[5*Wt+1];return ii-oi}return Xt-ti});const Ze=new Uint32Array(q.length);let nt=0,ct=0;for(let dt=0;dt<Le;dt++){const Wt=5*we[dt],Xt=q[Wt+0],ti=q[Wt+1],ii=q[Wt+2],oi=q[Wt+3],Bi=q[Wt+4],kn=Xt-nt,Nn=kn===0?ti-ct:ti,Wi=5*dt;Ze[Wi+0]=kn,Ze[Wi+1]=Nn,Ze[Wi+2]=ii,Ze[Wi+3]=oi,Ze[Wi+4]=Bi,nt=Xt,ct=ti}return Ze}build(q){return this.f?new si(new Uint32Array(this.g),q):new si(Mi.q(this.g),q)}}e.$YL=Mi;class si{constructor(q,we){this.resultId=we,this.data=q}}e.$ZL=si;class un{constructor(q,we,Le){this.start=q,this.deleteCount=we,this.data=Le}}e.$1L=un;class ln{constructor(q,we){this.resultId=we,this.edits=q}}e.$2L=ln;var Ji;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new vt("arrow-left")}}constructor(){}};e.$3L=fi,e.$3L=fi=Ge([E],fi);var Qi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(q){if(typeof q.badge=="string"){let we=(0,b.$ef)(q.badge,0);if(we<q.badge.length&&(we+=(0,b.$ef)(q.badge,we)),q.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!vt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,we,Le){this.badge=q,this.tooltip=we,this.color=Le}}e.$4L=Yi;let Fi=class{constructor(q){this.kind=q}};e.$5L=Fi,e.$5L=Fi=Ge([E],Fi);var Ti;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(q){return q instanceof _t?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,we){if(q<0)throw(0,O.$7)("start must be positive");if(we<0)throw(0,O.$7)("end must be positive");q<=we?(this.c=q,this.e=we):(this.c=we,this.e=q)}with(q){let we=this.c,Le=this.e;return q.start!==void 0&&(we=q.start),q.end!==void 0&&(Le=q.end),we===this.c&&Le===this.e?this:new _t(we,Le)}}e.$6L=_t;class vi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(we=>vi.isNotebookCellData(we))}static isNotebookCellData(q){return!0}constructor(q,we,Le,Ze,nt,ct,dt){this.kind=q,this.value=we,this.languageId=Le,this.mime=Ze,this.outputs=nt??[],this.metadata=ct,this.executionSummary=dt,vi.validate(this)}}e.$7L=vi;class hn{constructor(q){this.cells=q}}e.$8L=hn;class Yt{static isNotebookCellOutputItem(q){return q instanceof Yt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const we={name:q.name,message:q.message,stack:q.stack};return Yt.json(we,"application/vnd.code.notebook.error")}static stdout(q){return Yt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Yt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,we="application/octet-stream"){return new Yt(q,we)}static#e=new TextEncoder;static text(q,we=M.$1r.text){const Le=Yt.#e.encode(String(q));return new Yt(Le,we)}static json(q,we="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return Yt.text(Le,we)}constructor(q,we){this.data=q,this.mime=we;const Le=(0,M.$5r)(we,!0);if(!Le)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$9L=Yt;class yi{static isNotebookCellOutput(q){return q instanceof yi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,we=!1){const Le=new Set,Ze=new Set;for(let nt=0;nt<q.length;nt++){const ct=q[nt],dt=(0,M.$5r)(ct.mime);if(!Le.has(dt)||(0,k.$JI)(dt)){Le.add(dt);continue}Ze.add(nt),we&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ze.size===0?q:q.filter((nt,ct)=>!Ze.has(ct))}constructor(q,we,Le){this.items=yi.ensureUniqueMimeTypes(q,!0),typeof we=="string"?(this.id=we,this.metadata=Le):(this.id=(0,R.$lg)(),this.metadata=we??Le)}}e.$0L=yi;var Ei;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ue;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var ei;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Xi{constructor(q,we){this.text=q,this.alignment=we}}e.$$L=Xi;var bt;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var xi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(q,we=[]){this.uri=q,this.provides=(0,D.$3b)(we)}}e.$_L=dn;class _i{constructor(q){this.label=q}}e.$aM=_i;var en;(function(V){V[V.Named=1]="Named",V[V.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(q,we){this.label=q,this.timestamp=we}};e.$bM=hi,e.$bM=hi=Ge([E],hi);var tn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(q,we){this.ranges=q,this.wordPattern=we}}e.$cM=sn;class fn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$dM=fn;var on;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(q=void 0,we=void 0,Le=void 0,Ze=!1){this.include=q,this.exclude=we,this.profile=Le,this.continuous=Ze}};e.$eM=Ni,e.$eM=Ni=Ge([E],Ni);let ji=p=class{static diff(q,we,Le){const Ze=new p(q);return Ze.expectedOutput=we,Ze.actualOutput=Le,Ze}constructor(q){this.message=q}};e.$fM=ji,e.$fM=ji=p=Ge([E],ji);let zi=class{constructor(q){this.id=q}};e.$gM=zi,e.$gM=zi=Ge([E],zi);class Si{constructor(q,we){this.covered=q,this.total=we}}e.$hM=Si;class Ui{static fromDetails(q,we){const Le=new Si(0,0),Ze=new Si(0,0),nt=new Si(0,0);for(const dt of we)if("branches"in dt){Le.total+=1,Le.covered+=dt.executionCount>0?1:0;for(const Wt of dt.branches)Ze.total+=1,Ze.covered+=Wt.executionCount>0?1:0}else nt.total+=1,nt.covered+=dt.executionCount>0?1:0;const ct=new Ui(q,Le,Ze.total>0?Ze:void 0,nt.total>0?nt:void 0);return ct.detailedCoverage=we,ct}constructor(q,we,Le,Ze){this.uri=q,this.statementCoverage=we,this.branchCoverage=Le,this.functionCoverage=Ze}}e.$iM=Ui;class gn{constructor(q,we,Le=[]){this.executionCount=q,this.location=we,this.branches=Le}}e.$jM=gn;class mn{constructor(q,we){this.executionCount=q,this.location=we}}e.$kM=mn;class pe{constructor(q,we,Le){this.name=q,this.executionCount=we,this.location=Le}}e.$lM=pe;var Ee;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var ze;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(ze||(e.WorkspaceTrustState=ze={}));var at;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(at||(e.PortAutoForwardAction=at={}));class pt{constructor(q,we,Le,Ze,nt,ct){this.kind=q,this.name=we,this.detail=Le,this.uri=Ze,this.range=nt,this.selectionRange=ct}}e.$mM=pt;class Ot{constructor(q){this.uri=q}}e.$nM=Ot;class Dn{constructor(q,we){this.original=q,this.modified=we}}e.$oM=Dn;class Cn{constructor(q,we,Le,Ze){this.base=q,this.input1=we,this.input2=Le,this.result=Ze}}e.$pM=Cn;class In{constructor(q,we){this.uri=q,this.viewType=we}}e.$qM=In;class Pn{constructor(q){this.viewType=q}}e.$rM=Pn;class An{constructor(q,we){this.uri=q,this.notebookType=we}}e.$sM=An;class Ln{constructor(q,we,Le){this.original=q,this.modified=we,this.notebookType=Le}}e.$tM=Ln;class Rn{constructor(){}}e.$uM=Rn;class Mn{constructor(q,we){this.uri=q,this.inputBoxUri=we}}e.$vM=Mn;class Fn{constructor(q){this.providerId=q}}e.$wM=Fn;var $n;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var pn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Tn{constructor(q,we){this.label=q,this.values=we}}e.$xM=Tn;var wn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted",V[V.Bug=4]="Bug"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var vn;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));class On{constructor(q,we){this.role=q,this.content=we}}e.$yM=On;var yn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Sn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Se[141],ke([1,0,60,17,13,175,126,7,19]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.$LM=void 0;const y=new Map;function R(k,f){f?y.set(k,f):y.delete(k)}e.$LM=R;function C(k){return y.get(k)}class m extends P.$8u{constructor(f,d,s,i,n,o,a,t){super(d,s,i,n),this.c=f,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,$.$ub)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===O.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(d){return d?f.s(d):f.getText()},get eol(){return f.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(d){return f.t(d)},offsetAt(d){return f.u(d)},positionAt(d){return f.v(d)},validateRange(d){return f.w(d)},validatePosition(d){return f.x(d)},getWordRangeAtPosition(d,s){return f.y(d,s)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,D.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,D.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const d=this.w(f);if(d.isEmpty)return"";if(d.isSingleLine)return this.f[d.start.line].substring(d.start.character,d.end.character);const s=this.g,i=d.start.line,n=d.end.line,o=[];o.push(this.f[i].substring(d.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,d.end.character)),o.join(s)}t(f){let d;if(f instanceof b.$IK?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this.f.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new v(d,this.f[d],d===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const d=this.j.getIndexOf(f),s=this.f[d.index].length;return new b.$IK(d.index,Math.min(d.remainder,s))}w(f){if(!(f instanceof b.$JK))throw new Error("Invalid argument");const d=this.x(f.start),s=this.x(f.end);return d===f.start&&s===f.end?f:new b.$JK(d.line,d.character,s.line,s.character)}x(f){if(!(f instanceof b.$IK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:d,character:s}=f,i=!1;if(d<0)d=0,s=0,i=!0;else if(d>=this.f.length)d=this.f.length-1,s=this.f[d].length,i=!0;else{const n=this.f[d].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new b.$IK(d,s):f}y(f,d){const s=this.x(f);if(!d)d=C(this.m);else if((0,g.$Te)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const i=(0,M.$gs)(s.character+1,(0,M.$es)(d),this.f[s.line],0);if(i)return new b.$JK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$MM=m;class v{constructor(f,d,s){this.a=f,this.b=d,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$JK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$JK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$NM=v}),define(Se[284],ke([1,0,7,20,4]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let P=class{constructor(b){this.a=new D.$5L(D.ColorThemeKind.Dark),this.b=new g.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$5L($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Lgc=P,e.$Lgc=P=Ge([We(0,O.$JM)],P)}),define(Se[285],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.CellExecutionUpdateType=void 0;var O;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$NI=(0,D.$1h)("INotebookExecutionService")}),define(Se[286],ke([1,0,3,29,192,99]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QPb=void 0;class M extends D.$Sc{constructor($,y,R){super(),this._source=$,this.b=y,this.c=R,this.a=void 0}f($){const y=$.getLineCount();return new O.$Es(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$TB;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:R,disposable:C}=y.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$TB;y.acceptChunk($);const R=y.finish(!0),{textBuffer:C,disposable:m}=R.create(1);return this.B(m),C})),this.a}findInInputs($){const R=new P.$HB($,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs($){const R=new P.$HB($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$QPb=M}),define(Se[67],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(P){P.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class g{static fromExtHostTestItem(M,b,$=M.parent){if(M._isRoot)return new g([b]);const y=[M.id];for(let R=$;R&&R.id!==b;R=R.parent)y.push(R.id);return y.push(b),new g(y.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new g(M.split("\0"))}static join(M,b){return new g([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:g.isChild(M,b)?2:g.isChild(b,M)?3:1}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new g(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new g(this.path,M)}compare(M){if(typeof M=="string")return g.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$xJ=g}),define(Se[89],ke([1,0,2,49,29,67]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$EJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$DJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$CJ=e.$BJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$AJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$zJ=e.$yJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var b;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable",T[T.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$yJ=[2,4,8,16,32,64];const y=T=>"runId"in T;e.$zJ=y;var R;(function(T){T.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),T.deserialize=F=>({range:g.$Es.lift(F.range),uri:D.URI.revive(F.uri)})})(R||(e.IRichLocation=R={}));var C;(function(T){T[T.Error=0]="Error",T[T.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(T){T.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.serialize(F.location)}),T.deserialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.deserialize(F.location)})})(m||(e.ITestErrorMessage=m={}));const v=(T,F)=>`${F?"s":"e"}${T}`;e.$AJ=v;var k;(function(T){T.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&R.serialize(F.location)}),T.deserialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&R.deserialize(F.location)})})(k||(e.ITestOutputMessage=k={}));var f;(function(T){T.serialize=F=>F.type===0?m.serialize(F):k.serialize(F),T.deserialize=F=>F.type===0?m.deserialize(F):k.deserialize(F)})(f||(e.ITestMessage=f={}));var d;(function(T){T.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),T.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(f.serialize)}),T.deserialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(f.deserialize)})})(d||(e.ITestTaskState=d={}));const s="\0",i=(T,F)=>T+s+F;e.$BJ=i;const n=T=>{const F=T.indexOf(s);return{ctrlId:T.slice(0,F),tagId:T.slice(F+1)}};e.$CJ=n;var o;(function(T){T.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),T.deserialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?D.URI.revive(F.uri):void 0,range:F.range?g.$Es.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(o||(e.ITestItem=o={}));var a;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(T){T.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),T.deserialize=F=>({controllerId:P.$xJ.root(F.item.extId),expand:F.expand,item:o.deserialize(F.item)})})(t||(e.InternalTestItem=t={}));var r;(function(T){T.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},T.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?g.$Es.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const h=(T,F)=>{F.expand!==void 0&&(T.expand=F.expand),F.item!==void 0&&(T.item=T.item?Object.assign(T.item,F.item):F.item)};e.$DJ=h;var u;(function(T){T.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(d.serializeWithoutMessages)}),T.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(d.serialize)}),T.deserialize=F=>({...t.deserialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(d.deserialize),retired:!0})})(u||(e.TestResultItem=u={}));var c;(function(T){T.empty=()=>({covered:0,total:0}),T.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(c||(e.ICoveredCount=c={}));var l;(function(T){T.serialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(p.serialize),uri:F.uri.toJSON()}),T.deserialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(p.deserialize),uri:D.URI.from(F.uri)})})(l||(e.IFileCoverage=l={}));function S(T){return{...T,location:T.location?.toJSON()}}function L(T){return T.location=T.location?O.$Ds.isIPosition(T.location)?O.$Ds.lift(T.location):g.$Es.lift(T.location):void 0,T}e.$EJ=3;var w;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(w||(e.DetailType=w={}));var p;(function(T){T.serialize=F=>F.type===0?A.serialize(F):z.serialize(F),T.deserialize=F=>F.type===0?A.deserialize(F):z.deserialize(F)})(p||(e.CoverageDetails=p={}));var E;(function(T){T.serialize=S,T.deserialize=L})(E||(e.IBranchCoverage=E={}));var A;(function(T){T.serialize=S,T.deserialize=L})(A||(e.IFunctionCoverage=A={}));var z;(function(T){T.serialize=F=>({...S(F),branches:F.branches?.map(E.serialize)}),T.deserialize=F=>({...L(F),branches:F.branches?.map(E.deserialize)})})(z||(e.IStatementCoverage=z={}));var N;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.DocumentSynced=2]="DocumentSynced",T[T.Remove=3]="Remove",T[T.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",T[T.Retire=5]="Retire",T[T.AddTag=6]="AddTag",T[T.RemoveTag=7]="RemoveTag"})(N||(e.TestDiffOpType=N={}));var I;(function(T){T.deserialize=F=>F.op===0?{op:F.op,item:t.deserialize(F.item)}:F.op===1?{op:F.op,item:r.deserialize(F.item)}:F.op===2?{op:F.op,uri:D.URI.revive(F.uri),docv:F.docv}:F,T.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:r.serialize(F.item)}:F})(I||(e.TestsDiffOp=I={}));class j{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(F){const W=this.o();for(const Y of F)switch(Y.op){case 0:this.j(t.deserialize(Y.item),W);break;case 1:this.k(r.deserialize(Y.item),W);break;case 3:this.l(Y.itemId,W);break;case 5:this.m(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}W.complete?.()}j(F,W){const Y=P.$xJ.parentId(F.item.extId)?.toString();let le;if(!Y)le=this.p(F),this.f.add(le),this.d.set(F.item.extId,le);else if(this.d.has(Y)){const Q=this.d.get(Y);Q.children.add(F.item.extId),le=this.p(F,Q),this.d.set(F.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(le),F.expand===2&&this.g++,le}k(F,W){const Y=this.d.get(F.extId);if(Y)return F.expand!==void 0&&(Y.expand===2&&this.g--,F.expand===2&&this.g++),(0,e.$DJ)(Y,F),W.update?.(Y),Y}l(F,W){const Y=this.d.get(F);if(!Y)return;const le=P.$xJ.parentId(Y.item.extId)?.toString();le?this.d.get(le).children.delete(Y.item.extId):this.f.delete(Y);const Q=[[F]];for(;Q.length;)for(const Z of Q.pop()){const x=this.d.get(Z);x&&(Q.push(x.children),this.d.delete(Z),W.remove?.(x,x!==Y),x.expand===2&&this.g--)}}m(F){}updatePendingRoots(F){this.h+=F}o(){return{}}}e.$FJ=j}),define(Se[112],ke([1,0,12,4,3,60,89,67]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),m=(i,n)=>{let o;for(const[a,t]of C)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class v extends g.$Sc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$ah(()=>this.flushDiff(),200)),this.g=this.B(new O.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,M.$DJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,M.$DJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(b.$xJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,P.$5c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=b.$xJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const h=this.s.getChildren(r.actual),u=r.actual,c=m(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(n,r,o);for(const[l,S]of h)this.s.getChildren(n).get(S.id)||this.N(b.$xJ.joinToString(a,S.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,M.$BJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$BJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,M.$BJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const h=this.expand(b.$xJ.joinToString(n.fullId,r.id),o);(0,D.$Ng)(h)&&a.push(h)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$Zg;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new D.$Zg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,D.$Ng)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,h]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$xJ.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$zM=v;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$AM=k;class f extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$BM=f;class d extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$CM=d;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const h of a.values())t.call(r,h,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,h=new Set(a.keys()),u={op:5,ops:[]};for(const c of t){if(!(c instanceof o))throw new f(c.id);const l=n(c).controllerId;if(l!==i.controllerId)throw new d(c.id,l,i.controllerId);if(r.has(c.id))throw new k(c.id);r.set(c.id,c),h.delete(c.id),u.ops.push({op:0,item:c})}for(const c of h.keys())u.ops.push({op:3,id:c});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new f(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$DM=s}),define(Se[142],ke([1,0,112]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;const O=new WeakMap,g=(M,b)=>{const $={controllerId:b};return O.set(M,$),$};e.$EM=g;const P=M=>{const b=O.get(M);if(!b)throw new D.$BM(M?.id||"<unknown>");return b};e.$FM=P}),define(Se[113],ke([1,0,17,2]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ub=e.$8ub=e.$7ub=e.$6ub=e.$5ub=void 0,e.$5ub="vscode-cdn.net",e.$6ub=`vscode-resource.${e.$5ub}`,e.$7ub=`'self' https://*.${e.$5ub}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=O.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),O.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${P(b.authority)}.${e.$6ub}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$8ub=g;function P(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$9ub=M}),define(Se[287],ke([1,0,4,3,113]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class P{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new O.$Rc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,R,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){m=n;break}if(!m)throw new Error("not a visible editor");const v=this,k=this.a++,f=new D.$Sd,d=new D.$Sd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$8ub)(n,v.f)}get cspSource(){return g.$7ub}set options(n){this.b=n,v.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(n){return v.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=s,this.onDidDispose=d.event}dispose(){v.c.has(k)&&(v.c.delete(k),v.d.$disposeEditorInset(k),d.fire(),d.dispose(),f.dispose())}};return this.d.$createEditorInset(k,m.id,m.value.document.uri,$+1,y,R||{},C.identifier,C.extensionLocation),this.c.set(k,{editor:b,inset:i,onDidReceiveMessage:f}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$8ec=P}),define(Se[288],ke([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.VariableKind=e.$vN=void 0,e.$vN=(0,D.$1h)("configurationResolverService");var O;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class g extends Error{constructor(M,b){super(b),this.variable=M}}e.$wN=g}),define(Se[289],ke([1,0,16,50,18,24,11,102,231,288,13]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,k,f,d){this.h=new Map,this.a=v,this.b=k,this.g=f,d&&(this.c=d.then(s=>this.i(s)))}i(v){if(M.$i){const k=Object.create(null);return Object.keys(v).forEach(f=>{k[f.toLowerCase()]=v[f]}),k}return v}resolveWithEnvironment(v,k,f){return this.l({env:this.i(v),userHome:void 0},k?k.uri:void 0,f)}async resolveAsync(v,k){const f={env:await this.c,userHome:await this.g};return this.l(f,v?v.uri:void 0,k)}async j(v,k,f,d){const s=P.$fn(k);M.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):M.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):M.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,s,f,d)}async resolveAnyAsync(v,k,f){return this.j(v,k,f)}async resolveAnyMap(v,k,f){const d=new Map;return{newConfig:await this.j(v,k,f,d),resolvedVariables:d}}resolveWithInteractionReplace(v,k,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,k,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,k){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,k)}async l(v,k,f,d,s){if(g.$Df(f))return this.m(v,k,f,d,s);if(Array.isArray(f))return Promise.all(f.map(i=>this.l(v,k,i,d,s)));if(g.$Ff(f)){const i=Object.create(null),n=await Promise.all(Object.keys(f).map(async o=>[await this.m(v,k,o,d,s),await this.l(v,k,f[o],d,s)]));for(const[o,a]of n)i[o]=a;return i}return f}m(v,k,f,d,s){return(0,R.$Ye)(f,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let o=await this.o(v,i,n,k,d);return s?.set(n,o),o!==i&&g.$Df(o)&&o.match(C.VARIABLE_REGEXP)&&(o=await this.m(v,k,o,d,s)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,k,f,d,s){let i;const n=f.split(":");n.length>1&&(f=n[0],i=n[1]);const o=r=>{const h=this.a.getFilePath();if(h)return(0,b.$Fv)(h);throw new y.$wN(r,(0,$.localize)(0,null,k))},a=r=>{const h=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,b.$Fv)(u)}throw new y.$wN(r,(0,$.localize)(1,null,k,D.$nc(h)))},t=r=>{if(i){const h=this.a.getFolderUri(i);if(h)return h;throw new y.$wN(r,(0,$.localize)(2,null,k,i))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new y.$wN(r,(0,$.localize)(3,null,k)):new y.$wN(r,(0,$.localize)(4,null,k))};switch(f){case"env":if(i){if(v.env){const r=v.env[M.$i?i.toLowerCase():i];if(g.$Df(r))return r}return""}throw new y.$wN(y.VariableKind.Env,(0,$.localize)(5,null,k));case"config":if(i){const r=this.a.getConfigurationValue(d,i);if(g.$Mf(r))throw new y.$wN(y.VariableKind.Config,(0,$.localize)(6,null,k,i));if(g.$Ff(r))throw new y.$wN(y.VariableKind.Config,(0,$.localize)(7,null,k,i));return r}throw new y.$wN(y.VariableKind.Config,(0,$.localize)(8,null,k));case"command":return this.p(y.VariableKind.Command,k,i,s,"command");case"input":return this.p(y.VariableKind.Input,k,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$wN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,k,i));return this.n(r.extensionLocation)}throw new y.$wN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,k));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,b.$Fv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return d||i?(0,b.$Fv)(this.n(t(y.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Fv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$wN(y.VariableKind.UserHome,(0,$.localize)(11,null,k))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$wN(y.VariableKind.LineNumber,(0,$.localize)(12,null,k))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$wN(y.VariableKind.SelectedText,(0,$.localize)(13,null,k))}case"file":return o(y.VariableKind.File);case"fileWorkspaceFolder":return a(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(a(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),o(y.VariableKind.RelativeFile)):o(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$mc(o(y.VariableKind.RelativeFileDirname));if(d||i){const h=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return h.length===0?".":h}return r}case"fileDirname":return D.$mc(o(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(o(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(o(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$nc(o(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$oc(r).length)}case"fileDirnameBasename":return D.$nc(D.$mc(o(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||k}case"execInstallFolder":{const r=this.a.getAppRoot();return r||k}case"pathSeparator":return D.sep;default:try{const r=i?`${f}:${i}`:f;return this.p(y.VariableKind.Unknown,k,r,s,void 0)}catch{return k}}}}p(v,k,f,d,s){if(f&&d){const i=s===void 0?d[f]:d[s+":"+f];if(typeof i=="string")return i;throw new y.$wN(v,(0,$.localize)(14,null,k))}return k}}e.$KN=C}),define(Se[143],ke([1,0,5,139]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=e.$PC=e.OpenEditorContext=e.GroupsOrder=e.$OC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$NC=void 0,e.$NC=(0,D.$1h)("editorGroupsService");var g;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var P;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var M;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(k){const f=k;return(0,O.$wE)(f?.editor)&&(0,O.$wE)(f?.replacement)}e.$OC=y;var R;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(k){const f=k;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$PC=m;function v(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$QC=v}),define(Se[290],ke([1,0,5,143]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.$SC=e.$RC=void 0,e.$RC=(0,D.$1h)("editorService"),e.$SC=-1,e.$TC=-2;function g(P){const M=P;return typeof P=="number"||(0,O.$PC)(M)}e.$UC=g}),define(Se[144],ke([1,0,5,133]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=void 0,e.$3J=(0,D.$2h)(O.$8h)}),define(Se[145],ke([1,0,26,4,16,3]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=e.$Z6b=e.$Y6b=void 0;class M{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$Y6b=M;class b{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new O.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(k),this.f=new D.$gm,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=f(this.e,i),this.e=this.e.concat(s);const n=b.l(this.e);return this.e=f(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,h){this.addNode(r),this.addNode(h),this.c.has(r)?this.c.get(r).push(h):this.c.set(r,[h])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,h){const u=i.getArcs(r);for(let c=0;c<u.length;c++)if(!h.has(u[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$gm;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const h of r.extensionDependencies)i.addArc(D.$em.toKey(r.identifier),D.$em.toKey(h));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const h=a[r];i.hasOnlyGoodArcs(h,o)&&(a.splice(r,1),r--,o.add(h),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Z6b=b;class ${constructor(s,i){this.versionId=s,this.extensions=i}}e.$16b=$;class y{constructor(s){this.d=new m,this.c=new b(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new R(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$26b=y;class R extends P.$Sc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$36b=R;class C{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class m{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new C(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,P.$Qc)(o))}}var v;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(v||(v={}));function k(d,s){const i=d.isBuiltin?0:d.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=g.$gc.basename(d.extensionLocation.path),a=g.$gc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function f(d,s){const i=new D.$fm(s);return d.filter(n=>!i.has(n.identifier))}}),define(Se[291],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[O.ENV_KEY]=this.pipeName}}e.$Im=O;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Jm=g;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[P.ENV_KEY]="1"}}e.$Km=P;function M(R){delete R[O.ENV_KEY],delete R[g.ENV_KEY],delete R[P.ENV_KEY]}function b(R,C){M(C),R.serialize(C)}e.$Lm=b;function $(R){if(R[O.ENV_KEY])return y(R,new O(R[O.ENV_KEY]));if(R[g.ENV_KEY])return y(R,new g);if(R[P.ENV_KEY])return y(R,new P);throw new Error("No connection information defined in environment!")}e.$Mm=$;function y(R,C){return M(R),C}}),define(Se[114],ke([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$nm=e.$mm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(O||(e.UIKind=O={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var P;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function M(y){const R=D.$ge.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$mm=M;function b(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$nm=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Se[90],ke([1,0,5,4,14,27,114,65,87,24,2,3,217]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=void 0;let v=class extends C.$Sc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new O.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$zo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,g.$kj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new k(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:i["common.uikind"]="web";break;case M.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$7k)((0,$.$Go)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$1M=v,e.$1M=v=Ge([We(0,P.$ZM),We(1,g.$jj)],v);class k{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new O.$Sd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$Jo)(i,[]),this.c&&(i=(0,y.$in)(i,this.c)),this.b||(i=(0,y.$in)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,$.$Jo)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$2M=k;function f(d){const s=Date.now()-new Date(d).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$3M=f,e.$4M=(0,D.$1h)("IExtHostTelemetry")}),define(Se[25],ke([1,0,4,2,261,137,26,5]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.ActivationKind=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.ExtensionHostStartup=e.$PF=e.$OF=e.$NF=e.$MF=void 0,e.$MF=Object.freeze({identifier:new M.$em("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$NF="extensions.webWorker",e.$OF=(0,b.$1h)("extensionService");class ${constructor(a){this.dependency=a}}e.$PF=$;var y;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$DF.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const h=[],u=[],c=[],l=[],S=C(this.d),L=C(t),w=(N,I)=>N.extensionLocation.toString()===I.extensionLocation.toString()||N.isBuiltin===I.isBuiltin||N.isUserBuiltin===I.isUserBuiltin||N.isUnderDevelopment===I.isUnderDevelopment;for(const N of this.d){const I=L.get(N.identifier);if(!I){h.push(N.identifier),S.delete(N.identifier);continue}if(!w(N,I)){h.push(N.identifier),S.delete(N.identifier);continue}}for(const N of t){const I=S.get(N.identifier);if(!I){u.push(N);continue}if(!w(I,N)){h.push(I.identifier),S.delete(I.identifier);continue}}const p=new M.$fm(this.e),E=new M.$fm(r);for(const N of this.e)E.has(N)||c.push(N);for(const N of r)p.has(N)||l.push(N);const A=P.$DF.createActivationEventsMap(u),z={versionId:a,toRemove:h,toAdd:u,addActivationEvents:A,myToRemove:c,myToAdd:l};return this.delta(z),z}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:h,myToAdd:u}=a,c=new M.$fm(t),l=new M.$fm(h);for(let S=0;S<this.d.length;S++)c.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)l.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of r)this.d.push(S);for(const S of u)this.e.push(S);return this.f=null,a}containsExtension(a){for(const t of this.e)if(M.$em.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=P.$DF.readActivationEvents(t);for(const h of r)a.add(h)}return a}}e.$QF=R;function C(o){const a=new M.$gm;for(const t of o)a.set(t.identifier,t);return a}function m(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$RF=m;function v(o,a){if(!m(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$SF=v;class k{constructor(a,t,r,h){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=h}}e.$TF=k;class f{constructor(a,t){this.description=a,this.value=t}}e.$UF=f;var d;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,g.$Po)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$VF=s;function i(o,a){return{identifier:new M.$em((0,g.$No)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$WF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$XF=n}),define(Se[292],ke([1,0,8,145,26,25,14,12]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.$ufc=e.$tfc=e.$sfc=e.$rfc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$rfc=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$sfc=y;class R{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$tfc=R;class C extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ufc=C;class m extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$vfc=m;class v extends R{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new g.$gm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new v(a));return this.c.onExtensionActivationError(s.id,a,new P.$PF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const h=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${a}'`),c=this.k(s,i.displayName,[],new v(u));return this.c.onExtensionActivationError(i.identifier,u,new P.$PF(a)),c}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new f(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return O.$Z6b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$wfc=k,e.$wfc=k=Ge([We(3,M.$ij)],k);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new b.$Zg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new v(i),this.b&&D.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};f=Ge([We(6,M.$ij)],f)}),define(Se[15],ke([1,0,19,22,164,74,80,28,160,54,100,24,18,2,29,83,135,142,139,111,67,89,290,7,25]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$IM=e.$HM=e.MarkdownString=e.$GM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Me){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Ke}=re,rt=new r.$IK(Ne-1,He-1),$t=new r.$IK(_e-1,Ke-1);return new r.$KK(rt,$t)}Me.to=Oe;function De(re){const{anchor:Ne,active:He}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Me.from=De})(u||(e.Selection=u={}));var c;(function(Me){function Oe(re){if(!re)return;const{start:Ne,end:He}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Me.from=Oe;function De(re){if(!re)return;const{startLineNumber:Ne,startColumn:He,endLineNumber:_e,endColumn:Ke}=re;return new r.$JK(Ne-1,He-1,_e-1,Ke-1)}Me.to=De})(c||(e.Range=c={}));var l;(function(Me){function Oe(De){switch(De){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Oe})(l||(e.TokenType=l={}));var S;(function(Me){function Oe(re){return new r.$IK(re.lineNumber-1,re.column-1)}Me.to=Oe;function De(re){return{lineNumber:re.line+1,column:re.character+1}}Me.from=De})(S||(e.Position=S={}));var L;(function(Me){function Oe(Ne,He,_e){return(0,D.$Hb)((0,D.$3b)(Ne).map(Ke=>De(Ke,He,_e)))}Me.from=Oe;function De(Ne,He,_e){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:_e?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,He),pattern:ue.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:_e?.isBuiltin}}function re(Ne,He){return He&&typeof Ne=="string"?He.transformOutgoingScheme(Ne):Ne}})(L||(e.DocumentSelector=L={}));var w;(function(Me){function Oe(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Oe;function De(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=De})(w||(e.DiagnosticTag=w={}));var p;(function(Me){function Oe(re){let Ne;return re.code&&((0,m.$Df)(re.code)||(0,m.$Hf)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Ne,severity:A.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,D.$Hb)(re.tags.map(w.from)):void 0}}Me.from=Oe;function De(re){const Ne=new r.$VK(c.to(re),re.message,A.to(re.severity));return Ne.source=re.source,Ne.code=(0,m.$Df)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Ne.tags=re.tags&&(0,D.$Hb)(re.tags.map(w.to)),Ne}Me.to=De})(p||(e.Diagnostic=p={}));var E;(function(Me){function Oe(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Me.from=Oe;function De(re){return new r.$UK(new r.$TK(re.resource,c.to(re)),re.message)}Me.to=De})(E||(e.DiagnosticRelatedInformation=E={}));var A;(function(Me){function Oe(re){switch(re){case r.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Me.from=Oe;function De(re){switch(re){case d.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=De})(A||(e.DiagnosticSeverity=A={}));var z;(function(Me){function Oe(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.$TC:t.$SC}Me.from=Oe;function De(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=De})(z||(e.ViewColumn=z={}));function N(Me){return typeof Me.range<"u"}function I(Me){return Me.length===0?!0:!!N(Me[0])}e.$GM=I;var j;(function(Me){function Oe(Ke){return Ke.map(Me.from)}Me.fromMany=Oe;function De(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function re(Ke){let rt;if(De(Ke)){const{language:Dt,value:vt}=Ke;rt={value:"```"+Dt+`
`+vt+"\n```\n"}}else r.$9K.isMarkdownString(Ke)?rt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?rt={value:Ke}:rt={value:""};const $t=Object.create(null);rt.uris=$t;const jt=Dt=>{try{let vt=v.URI.parse(Dt,!0);vt=vt.with({query:Ne(vt.query,$t)}),$t[Dt]=vt}catch{}return""},Et=new $.marked.Renderer;return Et.link=jt,Et.image=Dt=>typeof Dt=="string"?jt(M.$ik(Dt).href):"",(0,$.marked)(rt.value,{renderer:Et}),rt}Me.from=re;function Ne(Ke,rt){if(!Ke)return Ke;let $t;try{$t=(0,y.$wh)(Ke)}catch{}if(!$t)return Ke;let jt=!1;return $t=(0,C.$hn)($t,Et=>{if(v.URI.isUri(Et)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Dt]=Et,jt=!0,Dt}else return}),jt?JSON.stringify($t):Ke}function He(Ke){const rt=new r.$9K(Ke.value,Ke.supportThemeIcons);return rt.isTrusted=Ke.isTrusted,rt.supportHtml=Ke.supportHtml,rt.baseUri=Ke.baseUri?v.URI.from(Ke.baseUri):void 0,rt}Me.to=He;function _e(Ke){if(Ke)return typeof Ke=="string"?Ke:Me.from(Ke)}Me.fromStrict=_e})(j||(e.MarkdownString=j={}));function T(Me){return I(Me)?Me.map(Oe=>({range:c.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?j.fromMany(Oe.hoverMessage):Oe.hoverMessage?j.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Me.map(Oe=>({range:c.from(Oe)}))}e.$HM=T;function F(Me){return typeof Me>"u"?Me:typeof Me=="string"?v.URI.file(Me):Me}e.$IM=F;var W;(function(Me){function Oe(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?F(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Me.from=Oe})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var Y;(function(Me){function Oe(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?F(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?W.from(De.before):void 0,after:De.after?W.from(De.after):void 0}}Me.from=Oe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var le;(function(Me){function Oe(De){if(typeof De>"u")return De;switch(De){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Oe})(le||(e.DecorationRangeBehavior=le={}));var Q;(function(Me){function Oe(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?le.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?Y.from(De.light):void 0,dark:De.dark?Y.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?F(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?W.from(De.before):void 0,after:De.after?W.from(De.after):void 0}}Me.from=Oe})(Q||(e.DecorationRenderOptions=Q={}));var Z;(function(Me){function Oe(re){return{text:re.newText,eol:re.newEol&&Te.from(re.newEol),range:c.from(re.range)}}Me.from=Oe;function De(re){const Ne=new r.$OK(c.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:Te.to(re.eol),Ne}Me.to=De})(Z||(e.TextEdit=Z={}));var x;(function(Me){function Oe(re,Ne){const He={edits:[]};if(re instanceof r.$RK){const _e=new b.$Bc;for(const Ke of re._allEntries())Ke._type===1&&v.URI.isUri(Ke.to)&&Ke.from===void 0&&_e.add(Ke.to);for(const Ke of re._allEntries())if(Ke._type===1){let rt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?rt={type:"base64",value:(0,O.$Ae)(O.$ge.wrap(Ke.options.contents))}:rt={type:"dataTransferItem",id:Ke.options.contents._itemId}),He.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:rt},metadata:Ke.metadata})}else Ke._type===2?He.edits.push({resource:Ke.uri,textEdit:Z.from(Ke.edit),versionId:_e.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?He.edits.push({resource:Ke.uri,textEdit:{range:c.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:_e.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?He.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&He.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(St.from)}})}return He}Me.from=Oe;function De(re){const Ne=new r.$RK,He=new b.$Ac;for(const _e of re.edits)if(_e.textEdit){const Ke=_e,rt=v.URI.revive(Ke.resource),$t=c.to(Ke.textEdit.range),jt=Ke.textEdit.text,Et=Ke.textEdit.insertAsSnippet;let Dt;Et?Dt=r.$QK.replace($t,new r.$SK(jt)):Dt=r.$OK.replace($t,jt);const vt=He.get(rt);vt?vt.push(Dt):He.set(rt,[Dt])}else Ne.renameFile(v.URI.revive(_e.oldResource),v.URI.revive(_e.newResource),_e.options);for(const[_e,Ke]of He)Ne.set(_e,Ke);return Ne}Me.to=De})(x||(e.WorkspaceEdit=x={}));var oe;(function(Me){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function De(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Me.from=De;function re(Ne){for(const He in Oe)if(Oe[He]===Ne)return Number(He);return r.SymbolKind.Property}Me.to=re})(oe||(e.SymbolKind=oe={}));var X;(function(Me){function Oe(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Me.from=Oe;function De(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Me.to=De})(X||(e.SymbolTag=X={}));var ve;(function(Me){function Oe(re){return{name:re.name,kind:oe.from(re.kind),tags:re.tags&&re.tags.map(X.from),containerName:re.containerName,location:ye.from(re.location)}}Me.from=Oe;function De(re){const Ne=new r.$ZK(re.name,oe.to(re.kind),re.containerName,ye.to(re.location));return Ne.tags=re.tags&&re.tags.map(X.to),Ne}Me.to=De})(ve||(e.WorkspaceSymbol=ve={}));var ge;(function(Me){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:oe.from(re.kind),tags:re.tags?.map(X.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Me.from=Oe;function De(re){const Ne=new r.$1K(re.name,re.detail,oe.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,D.$Lb)(re.tags)&&(Ne.tags=re.tags.map(X.to)),re.children&&(Ne.children=re.children.map(De)),Ne}Me.to=De})(ge||(e.DocumentSymbol=ge={}));var H;(function(Me){function Oe(re){const Ne=new r.$5K(oe.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Me.to=Oe;function De(re,Ne,He){if(Ne=Ne??re._sessionId,He=He??re._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,name:re.name,detail:re.detail,kind:oe.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(X.from)}}Me.from=De})(H||(e.CallHierarchyItem=H={}));var U;(function(Me){function Oe(De){return new r.$6K(H.to(De.from),De.fromRanges.map(re=>c.to(re)))}Me.to=Oe})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Me){function Oe(De){return new r.$7K(H.to(De.to),De.fromRanges.map(re=>c.to(re)))}Me.to=Oe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var ye;(function(Me){function Oe(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Me.from=Oe;function De(re){return new r.$TK(v.URI.revive(re.uri),c.to(re.range))}Me.to=De})(ye||(e.location=ye={}));var fe;(function(Me){function Oe(re){const Ne=re,He=re;return{originSelectionRange:Ne.originSelectionRange?c.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:He.uri,range:c.from(Ne.targetRange?Ne.targetRange:He.range),targetSelectionRange:Ne.targetSelectionRange?c.from(Ne.targetSelectionRange):void 0}}Me.from=Oe;function De(re){return{targetUri:v.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Me.to=De})(fe||(e.DefinitionLink=fe={}));var me;(function(Me){function Oe(re){return{range:c.from(re.range),contents:j.fromMany(re.contents)}}Me.from=Oe;function De(re){return new r.$WK(re.contents.map(j.to),c.to(re.range))}Me.to=De})(me||(e.Hover=me={}));var ee;(function(Me){function Oe(re){return{range:c.from(re.range),expression:re.expression}}Me.from=Oe;function De(re){return new r.$QL(c.to(re.range),re.expression)}Me.to=De})(ee||(e.EvaluatableExpression=ee={}));var ie;(function(Me){function Oe(re){if(re instanceof r.$RL)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof r.$SL)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.$TL)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Oe;function De(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Me.to=De})(ie||(e.InlineValue=ie={}));var G;(function(Me){function Oe(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Me.from=Oe;function De(re){return new r.$UL(re.frameId,c.to(re.stoppedLocation))}Me.to=De})(G||(e.InlineValueContext=G={}));var te;(function(Me){function Oe(re){return{range:c.from(re.range),kind:re.kind}}Me.from=Oe;function De(re){return new r.$XK(c.to(re.range),re.kind)}Me.to=De})(te||(e.DocumentHighlight=te={}));var J;(function(Me){function Oe(re){return{uri:re.uri,highlights:re.highlights.map(te.from)}}Me.from=Oe;function De(re){return new r.$YK(v.URI.revive(re.uri),re.highlights.map(te.to))}Me.to=De})(J||(e.MultiDocumentHighlight=J={}));var ce;(function(Me){function Oe(De){switch(De){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Oe})(ce||(e.CompletionTriggerKind=ce={}));var be;(function(Me){function Oe(De){return{triggerKind:ce.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Me.to=Oe})(be||(e.CompletionContext=be={}));var Ie;(function(Me){function Oe(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Oe;function De(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Me.to=De})(Ie||(e.CompletionItemTag=Ie={}));var Fe;(function(Me){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function De(He){return Oe.get(He)??9}Me.from=De;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne(He){return re.get(He)??r.CompletionItemKind.Property}Me.to=Ne})(Fe||(e.CompletionItemKind=Fe={}));var B;(function(Me){function Oe(De,re){const Ne=new r.$cL(De.label);return Ne.insertText=De.insertText,Ne.kind=Fe.to(De.kind),Ne.tags=De.tags?.map(Ie.to),Ne.detail=De.detail,Ne.documentation=M.$dk(De.documentation)?j.to(De.documentation):De.documentation,Ne.sortText=De.sortText,Ne.filterText=De.filterText,Ne.preselect=De.preselect,Ne.commitCharacters=De.commitCharacters,k.$Es.isIRange(De.range)?Ne.range=c.to(De.range):typeof De.range=="object"&&(Ne.range={inserting:c.to(De.range.insert),replacing:c.to(De.range.replace)}),Ne.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Ne.insertText=new r.$SK(De.insertText):(Ne.insertText=De.insertText,Ne.textEdit=Ne.range instanceof r.$JK?new r.$OK(Ne.range,Ne.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Ne.additionalTextEdits=De.additionalTextEdits.map(He=>Z.to(He))),Ne.command=re&&De.command?re.fromInternal(De.command):void 0,Ne}Me.to=Oe})(B||(e.CompletionItem=B={}));var _;(function(Me){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:j.fromStrict(re.documentation)}}Me.from=Oe;function De(re){return{label:re.label,documentation:M.$dk(re.documentation)?j.to(re.documentation):re.documentation}}Me.to=De})(_||(e.ParameterInformation=_={}));var se;(function(Me){function Oe(re){return{label:re.label,documentation:j.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(_.from):[],activeParameter:re.activeParameter}}Me.from=Oe;function De(re){return{label:re.label,documentation:M.$dk(re.documentation)?j.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(_.to):[],activeParameter:re.activeParameter}}Me.to=De})(se||(e.SignatureInformation=se={}));var K;(function(Me){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(se.from):[]}}Me.from=Oe;function De(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(se.to):[]}}Me.to=De})(K||(e.SignatureHelp=K={}));var ae;(function(Me){function Oe(De,re){const Ne=new r.$bL(S.to(re.position),typeof re.label=="string"?re.label:re.label.map(de.to.bind(void 0,De)),re.kind&&Ae.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(Z.to),Ne.tooltip=M.$dk(re.tooltip)?j.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Me.to=Oe})(ae||(e.InlayHint=ae={}));var de;(function(Me){function Oe(De,re){const Ne=new r.$aL(re.label);return Ne.tooltip=M.$dk(re.tooltip)?j.to(re.tooltip):re.tooltip,f.Command.is(re.command)&&(Ne.command=De.fromInternal(re.command)),re.location&&(Ne.location=ye.to(re.location)),Ne}Me.to=Oe})(de||(e.InlayHintLabelPart=de={}));var Ae;(function(Me){function Oe(re){return re}Me.from=Oe;function De(re){return re}Me.to=De})(Ae||(e.InlayHintKind=Ae={}));var Be;(function(Me){function Oe(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Me.from=Oe;function De(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?v.URI.parse(re.url,!0):v.URI.revive(re.url)}catch{}return new r.$hL(c.to(re.range),Ne)}Me.to=De})(Be||(e.DocumentLink=Be={}));var Xe;(function(Me){function Oe(re){const Ne=new r.$kL(re.label);return re.textEdit&&(Ne.textEdit=Z.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map(He=>Z.to(He))),Ne}Me.to=Oe;function De(re){return{label:re.label,textEdit:re.textEdit?Z.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>Z.from(Ne)):void 0}}Me.from=De})(Xe||(e.ColorPresentation=Xe={}));var Ye;(function(Me){function Oe(re){return new r.$iL(re[0],re[1],re[2],re[3])}Me.to=Oe;function De(re){return[re.red,re.green,re.blue,re.alpha]}Me.from=De})(Ye||(e.Color=Ye={}));var it;(function(Me){function Oe(re){return{range:c.from(re.range)}}Me.from=Oe;function De(re){return new r.$4K(c.to(re.range))}Me.to=De})(it||(e.SelectionRange=it={}));var st;(function(Me){function Oe(De){switch(De){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Oe})(st||(e.TextDocumentSaveReason=st={}));var Pe;(function(Me){function Oe(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Oe;function De(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=De})(Pe||(e.TextEditorLineNumbersStyle=Pe={}));var Te;(function(Me){function Oe(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Me.from=Oe;function De(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Me.to=De})(Te||(e.EndOfLine=Te={}));var qe;(function(Me){function Oe(De){if(typeof De=="object")return De.viewId;switch(De){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Oe})(qe||(e.ProgressLocation=qe={}));var Re;(function(Me){function Oe(re){const Ne={start:re.start+1,end:re.end+1};return re.kind&&(Ne.kind=xe.from(re.kind)),Ne}Me.from=Oe;function De(re){const Ne={start:re.start-1,end:re.end-1};return re.kind&&(Ne.kind=xe.to(re.kind)),Ne}Me.to=De})(Re||(e.FoldingRange=Re={}));var xe;(function(Me){function Oe(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return f.$ut.Comment;case r.FoldingRangeKind.Imports:return f.$ut.Imports;case r.FoldingRangeKind.Region:return f.$ut.Region}}Me.from=Oe;function De(re){if(re)switch(re.value){case f.$ut.Comment.value:return r.FoldingRangeKind.Comment;case f.$ut.Imports.value:return r.FoldingRangeKind.Imports;case f.$ut.Region.value:return r.FoldingRangeKind.Region}}Me.to=De})(xe||(e.FoldingRangeKind=xe={}));var he;(function(Me){function Oe(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?c.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$iE.id:void 0}}Me.from=Oe})(he||(e.TextEditorOpenOptions=he={}));var ue;(function(Me){function Oe(He){return He instanceof r.$EL?He.toJSON():typeof He=="string"?He:De(He)||re(He)?new r.$EL(He.baseUri??He.base,He.pattern).toJSON():He}Me.from=Oe;function De(He){const _e=He;return _e?v.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(He){return typeof He=="string"?He:new r.$EL(v.URI.revive(He.baseUri),He.pattern)}Me.to=Ne})(ue||(e.GlobPattern=ue={}));var Ce;(function(Me){function Oe(De){if(De){if(Array.isArray(De))return De.map(Oe);if(typeof De=="string")return De;{const re=De;return{language:re.language,scheme:re.scheme,pattern:ue.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Me.from=Oe})(Ce||(e.LanguageSelector=Ce={}));var Ve;(function(Me){function Oe(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(He=>He&&typeof He=="object"&&"uri"in He&&v.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(_e=>_e instanceof r.$JK)))}Me.is=Oe;function De(re){return{documents:re.documents.map(Ne=>Ne.map(He=>({uri:v.URI.from(He.uri),version:He.version,ranges:He.ranges.map(_e=>c.from(_e))})))}}Me.from=De})(Ve||(e.MappedEditsContext=Ve={}));var Je;(function(Me){function Oe(re){return{start:re.start,end:re.end}}Me.from=Oe;function De(re){return new r.$6L(re.start,re.end)}Me.to=De})(Je||(e.NotebookRange=Je={}));var et;(function(Me){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Me.to=Oe;function De(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Me.from=De})(et||(e.NotebookCellExecutionSummary=et={}));var ot;(function(Me){function Oe(De){if(De===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(De===n.NotebookCellExecutionState.Pending)return;if(De===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Me.to=Oe})(ot||(e.NotebookCellExecutionState=ot={}));var ut;(function(Me){function Oe(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Oe;function De(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=De})(ut||(e.NotebookCellKind=ut={}));var je;(function(Me){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)r.$7L.validate(He),Ne.cells.push(St.from(He));return Ne}Me.from=Oe;function De(re){const Ne=new r.$8L(re.cells.map(St.to));return(0,m.$Qf)(re.metadata)||(Ne.metadata=re.metadata),Ne}Me.to=De})(je||(e.NotebookData=je={}));var St;(function(Me){function Oe(re){return{cellKind:ut.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:et.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(zt.from):[]}}Me.from=Oe;function De(re){return new r.$7L(ut.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(zt.to):void 0,re.metadata,re.internalMetadata?et.to(re.internalMetadata):void 0)}Me.to=De})(St||(e.NotebookCellData=St={}));var Ht;(function(Me){function Oe(re){return{mime:re.mime,valueBytes:O.$ge.wrap(re.data)}}Me.from=Oe;function De(re){return new r.$9L(re.valueBytes.buffer,re.mime)}Me.to=De})(Ht||(e.NotebookCellOutputItem=Ht={}));var zt;(function(Me){function Oe(re){return{outputId:re.id,items:re.items.map(Ht.from),metadata:re.metadata}}Me.from=Oe;function De(re){const Ne=re.items.map(Ht.to);return new r.$0L(Ne,re.outputId,re.metadata)}Me.to=De})(zt||(e.NotebookCellOutput=zt={}));var wt;(function(Me){function Oe(Ne){return re(Ne)?{include:ue.from(Ne.include)??void 0,exclude:ue.from(Ne.exclude)??void 0}:ue.from(Ne)??void 0}Me.from=Oe;function De(Ne){return re(Ne)?{include:ue.to(Ne.include),exclude:ue.to(Ne.exclude)}:ue.to(Ne)}Me.to=De;function re(Ne){const He=Ne;return He?!(0,m.$Mf)(He.include)&&!(0,m.$Mf)(He.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var qt;(function(Me){function Oe(De,re,Ne){const He=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Ne),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Me.from=Oe})(qt||(e.NotebookStatusBarItem=qt={}));var Ut;(function(Me){function Oe(De,re,Ne){const He=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:re.toInternal(He,Ne),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Me.from=Oe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Kt;(function(Me){function Oe(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Me.from=Oe})(Kt||(e.NotebookDocumentContentOptions=Kt={}));var Gt;(function(Me){function Oe(re){return{uri:re.uri,provides:re.provides}}Me.from=Oe;function De(re){return new r.$_L(v.URI.revive(re.uri),re.provides)}Me.to=De})(Gt||(e.NotebookRendererScript=Gt={}));var Lt;(function(Me){function Oe(re){return{message:j.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Me.from=Oe;function De(re){const Ne=new r.$fM(typeof re.message=="string"?re.message:j.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.contextValue=re.contextValue,Ne.location=re.location?ye.to(re.location):void 0,Ne}Me.to=De})(Lt||(e.TestMessage=Lt={}));var It;(function(Me){Me.namespace=a.$BJ,Me.denamespace=a.$CJ})(It||(e.TestTag=It={}));var tt;(function(Me){function Oe(re){const Ne=(0,s.$FM)(re).controllerId;return{extId:o.$xJ.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:v.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>It.namespace(Ne,He.id)),range:k.$Es.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&j.fromStrict(re.error)||null}}Me.from=Oe;function De(re){return{parent:void 0,error:void 0,id:o.$xJ.fromString(re.extId).localId,label:re.label,uri:v.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:He}=It.denamespace(Ne);return new r.$gM(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Me.toPlain=De})(tt||(e.TestItem=tt={})),function(Me){function Oe(re){return{id:re.id}}Me.from=Oe;function De(re){return new r.$gM(re.id)}Me.to=De}(It||(e.TestTag=It={}));var Jt;(function(Me){const Oe=(re,Ne)=>{const He=[];for(const[Ke,rt]of Ne)o.$xJ.compare(rt.item.extId,Ke)===2&&(Ne.delete(Ke),He.push(rt));const _e={...tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(rt=>rt.type===0).map(Lt.to)})),children:He.map(Ke=>Oe(Ke,Ne))};for(const Ke of _e.children)Ke.parent=_e;return _e};function De(re){const Ne=[],He=new Map;for(const _e of re.items){He.set(_e.item.extId,_e);const Ke=o.$xJ.root(_e.item.extId);re.request.targets.some(rt=>rt.controllerId===Ke&&rt.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:re.completedAt,results:Ne.map(_e=>Oe(_e,He))}}Me.to=De})(Jt||(e.TestResults=Jt={}));var Vt;(function(Me){function Oe(He){return{covered:He.covered,total:He.total}}function De(He){return"line"in He?S.from(He):c.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:De(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&De(_e.location)})):void 0}:{type:0,name:He.name,count:He.executionCount,location:De(He.location)}}Me.fromDetailed=re;function Ne(He){return{uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),function:He.functionCoverage&&Oe(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Me.fromFile=Ne})(Vt||(e.TestCoverage=Vt={}));var lt;(function(Me){function Oe(De){switch(De){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Oe})(lt||(e.CodeActionTriggerKind=lt={}));var mt;(function(Me){function Oe(re){const Ne=new r.$mM(oe.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Me.to=Oe;function De(re,Ne,He){if(Ne=Ne??re._sessionId,He=He??re._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,kind:oe.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(X.from)}}Me.from=De})(mt||(e.TypeHierarchyItem=mt={}));var Zt;(function(Me){function Oe(De){if(De)return{value:De.value,tooltip:De.tooltip}}Me.from=Oe})(Zt||(e.ViewBadge=Zt={}));var Pt;(function(Me){function Oe(He,_e,Ke){const rt=_e.fileData;return rt?new r.$xL(new r.$yL(rt.name,v.URI.revive(rt.uri),rt.id,(0,P.$db)(()=>Ke(rt.id)))):He===R.$1r.uriList&&_e.uriListData?new r.$wL(Ne(_e.uriListData)):new r.$wL(_e.asString)}Me.to=Oe;async function De(He,_e){const Ke=await _e.asString();if(He===R.$1r.uriList)return{asString:Ke,fileData:void 0,uriListData:re(Ke)};const rt=_e.asFile();return{asString:Ke,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=De;function re(He){return g.$bt.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return v.URI.parse(_e)}catch{}return _e})}function Ne(He){return g.$bt.create(He.map(_e=>typeof _e=="string"?_e:v.URI.revive(_e)))}})(Pt||(e.DataTransferItem=Pt={}));var kt;(function(Me){function Oe(re,Ne){const He=re.items.map(([_e,Ke])=>[_e,Pt.to(_e,Ke,Ne)]);return new r.$zL(He)}Me.toDataTransfer=Oe;async function De(re){const Ne={items:[]},He=[];for(const[_e,Ke]of re)He.push((async()=>{Ne.items.push([_e,await Pt.from(_e,Ke)])})());return await Promise.all(He),Ne}Me.from=De})(kt||(e.DataTransfer=kt={}));var ft;(function(Me){function Oe(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Me.from=Oe})(ft||(e.ChatReplyFollowup=ft={}));var Mt;(function(Me){function Oe(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:ft.from(De)}Me.from=Oe})(Mt||(e.ChatFollowup=Mt={}));var Nt;(function(Me){function Oe(re){const Ne=new r.$yM(yt.to(re.role),re.content);return Ne.name=re.name,Ne}Me.to=Oe;function De(re){return{role:yt.from(re.role),content:re.content,name:re.name}}Me.from=De})(Nt||(e.ChatMessage=Nt={}));var yt;(function(Me){function Oe(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Oe;function De(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=De})(yt||(e.ChatMessageRole=yt={}));var Qe;(function(Me){function Oe(Ne){const He={};for(const _e of Object.keys(Ne))He[_e]=Ne[_e].map(Me.to);return He}Me.objectTo=Oe;function De(Ne){return{level:Ft.to(Ne.level),kind:Ne.kind,value:(0,y.$xh)(Ne.value),description:Ne.description}}Me.to=De;function re(Ne){return{level:Ft.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Me.from=re})(Qe||(e.ChatVariable=Qe={}));var Ft;(function(Me){function Oe(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Oe;function De(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=De})(Ft||(e.ChatVariableLevel=Ft={}));var Bt;(function(Me){function Oe(De){switch(De){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Oe})(Bt||(e.InteractiveEditorResponseFeedbackKind=Bt={}));var Qt;(function(Me){function Oe(De,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,h.$SF)(De,"chatAgents2Additions"),{content:j.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,h.$SF)(De,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,h.$SF)(De,"chatAgents2Additions"),{content:j.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Ne=>({uri:Ne.uri,version:Ne.version,ranges:Ne.ranges.map(He=>c.from(He))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:c.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:c.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,h.$SF)(De,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Me.from=Oe})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Me){function Oe(De){return{label:De.label,values:De.values.map(Qe.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Me.from=Oe})(gt||(e.ChatAgentCompletionItem=gt={}));var Rt;(function(Me){function Oe(De,re,Ne){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:re.toInternal(De,Ne)}Me.from=Oe})(Rt||(e.TerminalQuickFix=Rt={}))}),define(Se[293],ke([1,0,2,8,7,15,75]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class b{constructor(y,R,C,m={timeout:1500,errors:3}){this.c=y,this.d=R,this.f=C,this.g=m,this.a=new M.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(R,C,m)=>{const k={dispose:this.a.push([R,C,y])};return Array.isArray(m)&&m.push(k),k}}async $participateInSave(y,R){const C=D.URI.revive(y);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),k=[];try{for(const f of[...this.a]){if(m)break;const d=this.d.getDocument(C),s=await this.h(f,{document:d,reason:P.TextDocumentSaveReason.to(R)});k.push(s)}}finally{clearTimeout(v)}return k}h([y,R,C],m){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,y,R,m).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const f=this.b.get(y);this.b.set(y,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,R,C,m){const v=[],k=Date.now(),{document:f,reason:d}=m,{version:s}=f,i=Object.freeze({document:f,reason:d,waitUntil(n){if(Object.isFrozen(v))throw(0,O.$8)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{R.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof g.$OK))for(const{newText:t,newEol:r,range:h}of a)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:h&&P.Range.from(h),text:t,eol:r&&P.EndOfLine.from(r)}});if(o.edits.length!==0)return s===f.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$3fc=b}),define(Se[294],ke([1,0,17,2,15,7,111]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class b{constructor(C,m,v,k){this.start=C,this.deletedCount=m,this.deletedItems=v,this.items=k}asApiEvent(){return{range:new P.$6L(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,v){this.notebook=C,this.h=m,this.j=v,this.handle=v.handle,this.uri=O.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(k){C.g=k},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,v){const k=v.map(g.NotebookCellOutputItem.to),f=this.a.find(d=>d.id===C);if(f&&(m||(f.items.length=0),f.items.push(...k),f.items.length>1&&f.items.every(d=>M.$JI(d.mime)))){const d=new Map,s=[];f.items.forEach(i=>{let n;d.has(i.mime)?n=d.get(i.mime):(n=[],d.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),f.items.length=0,s.forEach(i=>{const n=M.$KI(d.get(i));f.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$8fc=$;class y{static{this.a=0}constructor(C,m,v,k,f){this.k=C,this.l=m,this.m=v,this.uri=k,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(f=>f.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,v){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const k={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const s of C.rawEvents)s.kind===M.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,k.contentChanges):s.kind===M.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,k.contentChanges):s.kind===M.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),f.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),f.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),f.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===M.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),f.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),f.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const d=new Map;for(let s=0;s<f.length;s++){const i=f[s],n=d.get(i.cell);if(n===void 0){const o=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});d.set(i.cell,o-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,v=C.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),C.with({start:m,end:v})}p(C){C=this.o(C);const m=[];for(let v=C.start;v<C.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,v){if(this.j)return;const k=[],f=[],d=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new $(this,this.l,t);return m||f.push($.asModelAddData(this.apiNotebook,t)),r}),o=new b(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)d.push(t.uri),o.deletedItems.push(t.apiCell);k.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),v)for(const s of k)v.push(s.asApiEvent())}s(C,m,v,k){const f=this.b.splice(C,m);this.b.splice(v,0,...f);const d=[new b(C,m,f.map(s=>s.apiCell),[]),new b(v,0,[],f)];for(const s of d)k.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,v,k){this.b[C].setOutputItems(m,v,k)}v(C,m){const v=this.b[C];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(C,m){const v=this.b[C];v.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$9fc=y}),define(Se[295],ke([1,0,4,2,15,7]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class M{constructor($,y,R,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=R,this.f=C,this.a=new D.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,R,C)=>{const m=function(k){y.call(R,k)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,R){const C=O.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},R,async(f,d)=>{const s=Date.now(),i=await await Promise.resolve(f);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.$RK?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(v.length===0)return!0;const k={edits:[]};for(const f of v){const{edits:d}=g.WorkspaceEdit.from(f);k.edits=k.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$mgc=M}),define(Se[146],ke([1,0,8,15,7]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,R,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$6L.isNotebookRange))throw(0,D.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,O.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$0fc=P}),define(Se[296],ke([1,0,8,4,14,15]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;let M=class{constructor($,y){this.c=$,this.d=y,this.a=new O.$Sd({onListenerError:D.$2}),this.b=new O.$Sd({onListenerError:D.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,y);const R=this.d.getEditorById($);y.visibleRanges&&R._acceptVisibleRanges(y.visibleRanges.ranges.map(P.NotebookRange.to)),y.selections&&R._acceptSelections(y.selections.selections.map(P.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns($){for(const y in $)this.d.getEditorById(y)._acceptViewColumn(P.ViewColumn.to($[y]))}};e.$ogc=M,e.$ogc=M=Ge([We(0,g.$ij)],M)}),define(Se[297],ke([1,0,15,85,215,21,59,8]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class ${constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,k){const f=this.b++,{title:d,location:s,cancellable:i}=v,n={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(f,{location:D.ProgressLocation.from(s),title:d,source:n,cancellable:i},m.isUnderDevelopment?void 0:m.identifier.value).catch(b.$2),this.d(f,k,!!i)}d(m,v,k){let f;k&&(f=new P.$3d,this.c.set(m,f));const d=i=>{this.a.$progressEnd(i),this.c.delete(i),f?.dispose()};let s;try{s=v(new R(this.a,m),k&&f?f.token:P.CancellationToken.None)}catch(i){throw d(m),i}return s.then(i=>d(m),i=>d(m)),s}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.$vgc=$;function y(C,m){return C.message=m.message,typeof m.increment=="number"&&(typeof C.increment=="number"?C.increment+=m.increment:C.increment=m.increment),C}class R extends O.$ev{constructor(m,v){super(k=>this.throttledReport(k)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}Ge([(0,M.$uh)(100,(C,m)=>y(C,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[147],ke([1,0,29,142,67,112,89,15,2]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=e.$VM=void 0;const y=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(h){if(!a(r,h)){const u=r;r=h,n.listener?.(t(h,u))}}}},R=(n,o)=>n===o,C={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},m=n=>o=>({op:4,update:n(o)}),v=(n,o)=>({range:(()=>{let a;const t=m(r=>({range:D.$Es.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),C.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:y(n,o,C.label,m(a=>({label:a}))),description:y(n,void 0,C.description,m(a=>({description:a}))),sortText:y(n,void 0,C.sortText,m(a=>({sortText:a}))),canResolveChildren:y(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:y(n,!1,C.busy,m(a=>({busy:a}))),error:y(n,void 0,C.error,m(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:y(n,[],C.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=n=>{const o=g.$xJ.fromString(n.extId),a=new d(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,M.$CJ)(t).tagId})),a},f=n=>{let o;for(const a of n.tests){const t=k(a.item);(0,O.$FM)(t).parent=o,o=t}return o};e.$VM=f;class d{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const h=(0,O.$EM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof s?void 0:h.parent}},children:{value:(0,P.$DM)(h,O.$FM,d),enumerable:!0,writable:!1},...v(h,t)})}}e.$WM=d;class s extends d{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$XM=s;class i extends P.$zM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:O.$FM,getChildren:r=>r.children,root:new s(o,a),toITestItem:b.TestItem.from})}}e.$YM=i}),define(Se[148],ke([1,0,60,8,121,15,7]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0;class b{static{this.c=new g.$OM("TextEditorDecorationType")}constructor(m,v,k){const f=b.c.nextId();m.$registerTextEditorDecorationType(v.identifier,f,P.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:f,dispose(){m.$removeTextEditorDecorationType(f)}})}}e.$QM=b;class ${constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let k=null;if(m instanceof M.$IK)k=new M.$JK(m,m);else if(m instanceof M.$JK)k=m;else throw new Error("Unrecognized location");this.l(k,v,!1)}insert(m,v){this.k(),this.l(new M.$JK(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof M.$JK)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,k){const f=this.c.validateRange(m);this.g.push({range:f,text:v,forceMoveMarkers:k})}setEndOfLine(m){if(this.k(),m!==M.EndOfLine.LF&&m!==M.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=m}}class y{constructor(m,v,k,f){this.c=m,this.d=v,this._accept(k),this.e=f;const d=this;this.value={get tabSize(){return d.f},set tabSize(s){d.m(s)},get indentSize(){return d.g},set indentSize(s){d.o(s)},get insertSpaces(){return d.h},set insertSpaces(s){d.q(s)},get cursorStyle(){return d.j},set cursorStyle(s){d.s(s)},get lineNumbers(){return d.k},set lineNumbers(s){d.t(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=P.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}m(m){const v=this.l(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}o(m){const v=this.n(m);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(m){return m==="auto"?"auto":m==="false"?!1:!!m}q(m){const v=this.p(m);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let k=!1;if(typeof m.tabSize<"u"){const f=this.l(m.tabSize);f==="auto"?(k=!0,v.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,k=!0,v.tabSize=f)}if(typeof m.indentSize<"u"){const f=this.n(m.indentSize);f==="tabSize"?(k=!0,v.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,k=!0,v.indentSize=f)}if(typeof m.insertSpaces<"u"){const f=this.p(m.insertSpaces);f==="auto"?(k=!0,v.insertSpaces=f):this.h!==f&&(this.h=f,k=!0,v.insertSpaces=f)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,k=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,k=!0,v.lineNumbers=P.TextEditorLineNumbersStyle.from(m.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(m,v){v.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(k)})}}e.$RM=y;class R{constructor(m,v,k,f,d,s,i,n){this.id=m,this.j=v,this.k=k,this.g=!1,this.h=new Set,this.c=d,this.d=new y(this.j,this.id,s,k),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return f.value},set document(a){throw new O.$9("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof M.$KK))throw(0,O.$7)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof M.$KK)))throw(0,O.$7)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new O.$9("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new O.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(f.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=o.c.map(u=>P.Range.from(u));else if(t instanceof M.$IK){const{lineNumber:u,column:c}=P.Position.from(t);h=[{startLineNumber:u,startColumn:c,endLineNumber:u,endColumn:c}]}else if(t instanceof M.$JK)h=[P.Range.from(t)];else{h=[];for(const u of t)if(u instanceof M.$JK)h.push(P.Range.from(u));else{const{lineNumber:c,column:l}=P.Position.from(u);h.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return v.$tryInsertSnippet(m,f.value.version,a.value,h,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(P.$GM(t))return v.$trySetDecorations(m,a.key,P.$HM(t));{const h=new Array(4*t.length);for(let u=0,c=t.length;u<c;u++){const l=t[u];h[4*u]=l.start.line+1,h[4*u+1]=l.start.character+1,h[4*u+2]=l.end.line+1,h[4*u+3]=l.end.character+1}return v.$trySetDecorationsFast(m,a.key,h)}}))},revealRange(a,t){o.n(()=>v.$tryRevealRange(m,P.Range.from(a),t||M.TextEditorRevealType.Default))},show(a){v.$tryShowEditor(m,P.ViewColumn.from(a))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const k=v.edits.map(d=>d.range);k.sort((d,s)=>d.end.line===s.end.line?d.end.character===s.end.character?d.start.line===s.start.line?d.start.character-s.start.character:d.start.line-s.start.line:d.end.character-s.end.character:d.end.line-s.end.line);for(let d=0,s=k.length-1;d<s;d++){const i=k[d].end;if(k[d+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(d=>({range:P.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?P.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$SM=R}),define(Se[298],ke([1,0,219,23,2,4,3,278,12,7,18,19,15,80,21,176,25]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;function s(o,a){if((0,R.$Df)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends M.$Sc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new f.$37;function h(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>h(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(c=>h(c)?this.r(c):c):u})}registerTreeDataProvider(a,t,r){const h=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>h.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,S=this.m(a,t,r),L={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:u,hasHandleDrag:c,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(a,L),p={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,d.$SF)(r,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,d.$SF)(r,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(E){(0,v.$dk)(E)&&(0,d.$SF)(r,"treeViewMarkdownMessage"),S.message=E},get title(){return S.title},set title(E){S.title=E},get description(){return S.description},set description(E){S.description=E},get badge(){return S.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?S.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(S.badge=void 0)},reveal:(E,A)=>S.reveal(E,A),dispose:async()=>{await w,this.a.delete(a),S.dispose()}};return this.B(p),p}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new b.$RE(a))}async $handleDrop(a,t,r,h,u,c,l,S){const L=this.a.get(a);if(!L)return Promise.reject(new b.$RE(a));const w=m.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return l===a&&S&&await this.j(w,L,S,u,c),L.onDrop(w,h,u)}async j(a,t,r,h,u){const c=this.b.removeDragOperationTransfer(u);if(c)(await c)?.forEach((l,S)=>{l&&a.set(S,l)});else if(u&&t.handleDrag){const l=t.handleDrag(r,a,h);this.b.addDragOperationTransfer(u,l),await l}return a}async $handleDrag(a,t,r,h){const u=this.a.get(a);if(!u)return Promise.reject(new b.$RE(a));const c=await this.j(new y.$zL,u,t,h,r);if(!(!c||h.isCancellationRequested))return m.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$RE(a);return t.hasResolve}$resolve(a,t,r){const h=this.a.get(a);if(!h)throw new b.$RE(a);return h.resolveTreeItem(t,r)}$setExpanded(a,t,r){const h=this.a.get(a);if(!h)throw new b.$RE(a);h.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const h=this.a.get(a);if(!h)throw new b.$RE(a);h.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new b.$RE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new b.$RE(a);r.setCheckboxState(t)}m(a,t,r){const h=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,h),h}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Ogc=i;class n extends M.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.$Mf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,h,u,c){if(super(),this.I=a,this.J=r,this.L=h,this.M=u,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$3d,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const p of c.contributes.views[w])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let l,S;const L=P.Event.debounce(this.F.event,(w,p)=>(w||(w={message:!1,elements:[]}),p.element!==!1&&(l||(l=new Promise(E=>S=E),this.G=this.G.then(()=>l)),Array.isArray(p.element)?w.elements.push(...p.element):w.elements.push(p.element)),p.message&&(w.message=!0),w),200,!0);this.B(L(({message:w,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const E=S;return l=null,this.$(p).then(()=>E())})),w&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(h=>h.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,R.$Mf)(t.select)?!0:t.select,h=(0,R.$Mf)(t.focus)?!1:t.focus,u=(0,R.$Mf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:c.map(S=>S.item)},{select:r,focus:h,expand:u})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:h,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=m.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,C.$ub)(this.s,a);this.s=a;const h=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const h=this.getExtensionElement(r.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const h=[];for(const u of a){const c=this.getExtensionElement(u);c&&h.push(c)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,$.$Tg)(()=>this.g?.handleDrop?this.g.handleDrop(h,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const h=this.m.get(r);if(h){const u=await this.f.resolveTreeItem(h.extensionItem,r,t)??h.extensionItem;return this.hb(u),h.item.tooltip=this.eb(u.tooltip),h.item.command=this.fb(h.disposableStore,u.command),h.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(h=>(r.push(h),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Tg)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,$.$Tg)(()=>this.f.getTreeItem(a)).then(h=>this.kb(a,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(h);if(u){const c=this.m.get(u);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new k.$3d(this.Z.token);try{const r=a?this.m.get(a):void 0,h=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,C.$Hb)(h||[]).map(async c=>{const l=await this.f.getTreeItem(c);return l&&!t.token.isCancellationRequested?this.db(c,l,r):null}));return t.token.isCancellationRequested?void 0:(0,C.$Hb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new k.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let c=u;for(;c&&c.parent&&r.findIndex(l=>c&&c.parent&&l&&l.item.handle===c.parent.item.handle)===-1;){const l=this.j.get(c.parent.item.handle);c=l?this.m.get(l):void 0}c&&!c.parent&&t.add(u.item.handle)}const h=[];return t.forEach(u=>{const c=this.j.get(u);if(c){const l=this.m.get(c);l&&(!l.parent||!t.has(l.parent.item.handle))&&h.push(u)}}),h}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(h=>{h&&(t[r]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,$.$Tg)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const u=this.ib(t,h,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const h=this.ib(a,t,r);if(t.id&&this.j.has(h.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,h),this.qb(h,r),h}eb(a){return y.$9K.isMarkdownString(a)?m.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,h;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,h=a.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:h}}hb(a){if(!y.$uL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const h=this.B(new M.$Rc),u=this.kb(a,t,r),c=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,R.$Mf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(a){return a.iconPath instanceof y.$CL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:h},u,c){if(t)return`${n.b}/${t}`;const l=s(r,this.N),S=u?u.item.handle:n.a;let L=l?l.label:h?(0,O.$zg)(h):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const w=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(u)||[];let E,A=0;do{if(E=`${S}/${A}:${L}`,c||!this.j.has(E)||w===E)break;A++}while(A<=p.length);return E}lb(a){if(a.iconPath&&!(a.iconPath instanceof y.$CL))return typeof a.iconPath=="string"||g.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof y.$CL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return g.URI.isUri(a)?a:g.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,h){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(h)||[],c=u.filter(l=>l.item.handle===r.item.handle)[0];c&&u.splice(u.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const h=this.j.get(r.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const h=this.j.get(r.item.handle);h&&this.sb(h)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[299],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[300],ke([1,0,233,8,39,134,108,37,26,299,136,137]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=void 0;const m=b.$rn.as(M.$sn.JSONContribution);class v{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(g.default.Error,a)}warn(a){this.d(g.default.Warning,a)}info(a){this.d(g.default.Info,a)}}e.$YF=v;class k{static a(a){const t=new $.$fm;for(let r=0,h=a.length;r<h;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new k(t,[]);if(!t||!t.length)return new k([],a);const r=this.a(a),h=this.a(t),u=t.filter(l=>!r.has(l.description.identifier)),c=a.filter(l=>!h.has(l.description.identifier));return new k(u,c)}constructor(a,t){this.added=a,this.removed=t}}e.$ZF=k;class f{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=k.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,O.$1)(a)}}}e.$1F=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$2F={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$dm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$9n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$9n}},extensionKind:{description:D.localize(52,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new f(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$DF.register(a.extensionPoint,a.activationEventsGenerator),e.$2F.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,m.registerSchema(s,e.$2F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$3F=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$rn.add(n.ExtensionsRegistry,new i),e.$4F=b.$rn.as(n.ExtensionsRegistry),m.registerSchema(s,e.$2F),m.registerSchema(R.$Bj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[301],ke([1,0,229,18,24,300,46,4]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function v(k,f,d){if(!k)return;const s=O.$Df(k.type)?k.type:void 0;if(!s||s.length===0){d.error(D.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)O.$Df(n)&&i.push(n);return{extensionId:f.value,taskType:s,required:i,properties:k.properties?g.$fn(k.properties):{},when:k.when?M.$Yi.deserialize(k.when):void 0}}m.from=v})(y||(y={}));const R=P.$4F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,v)=>{for(const k of m)k.type&&v.push(`onTaskType:${k.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,k)=>{R.setHandler((f,d)=>{this.c=void 0;try{for(const s of d.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of d.added){const i=s.value;for(const n of i){const o=y.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const k of this.all()){const f={type:"object",additionalProperties:!1};k.required.length>0&&(f.required=k.required.slice(0)),k.properties!==void 0?f.properties=g.$fn(k.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[k.taskType]},v.push(f)}this.c={oneOf:v}}return this.c}}e.$aG=new C}),define(Se[302],ke([1,0,230,18,23,24,46,301]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$kG=e.JsonSchemaVersion=e.ExecutionEngine=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$eG=e.ShellQuoting=e.$dG=e.$cG=e.$bG=void 0,e.$bG="settings",e.$cG=new M.$fj("taskRunning",!1,D.localize(0,null)),e.$dG={value:D.localize(1,null),original:"Tasks"};var $;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$eG="$customized",function(T){function F(W){if(!W)return T.Strong;switch(W.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=F}($||(e.ShellQuoting=$={}));var y;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(R||(e.RevealKind=R={})),function(T){function F(W){switch(W.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=F}(R||(e.RevealKind=R={}));var C;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(T){function F(W){switch(W.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=F}(C||(e.RevealProblemKind=C={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m||(e.PanelKind=m={})),function(T){function F(W){switch(W.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=F}(m||(e.PanelKind=m={}));var v;(function(T){T.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var k;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(T){function F(Y){switch(Y.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=F;function W(Y){switch(Y){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=W}(k||(e.RuntimeType=k={}));var f;(function(T){function F(W){return O.$Df(W)?W:W.value}T.value=F})(f||(e.CommandString=f={}));var d;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function F(Y){return Y===T.Clean._id||Y===T.Build._id||Y===T.Rebuild._id||Y===T.Test._id}T.is=F;function W(Y){if(Y!==void 0)return O.$Df(Y)?F(Y)?{_id:Y,isDefault:!1}:void 0:Y}T.from=W})(d||(e.TaskGroup=d={}));var s;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function F(W){switch(W){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var n;(function(T){T.parallel="parallel",T.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(F,W,Y,le,Q,Z){this._label="",this._id=F,W&&(this._label=W),Y&&(this.type=Y),this.runOptions=le,this.configurationProperties=Q,this._source=Z}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(O.$Df(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$fG=t;class r extends t{constructor(F,W,Y,le,Q,Z,x,oe){super(F,Y,void 0,x,oe,W),this.command={},this._source=W,this.hasDefinedMatchers=Z,Q&&(this.command=Q)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case k.Shell:W="shell";break;case k.Process:W="process";break;case k.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof r}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$bG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const Y={type:e.$eG,folder:F,id:W};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$zg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new r(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$gG=r;class h extends t{constructor(F,W,Y,le,Q,Z,x){super(F,Y,le,Z,x,W),this._source=W,this.configures=Q}static is(F){return F instanceof h}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$zg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$bG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const Y={type:e.$eG,folder:F,id:W};return JSON.stringify(Y)}}e.$hG=h;class u extends t{constructor(F,W,Y,le,Q,Z,x,oe,X){super(F,Y,le,oe,X,W),this.defines=Q,this.hasDefinedMatchers=x,this.command=Z,this.icon=X.icon,this.hide=X.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$iG=u;class c extends t{constructor(F,W,Y,le,Q,Z){super(F,Y,le,Q,Z,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new c(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$jG=c;var l;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(T){T._default=T.Terminal}(l||(e.ExecutionEngine=l={}));var S;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class L{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const Y=F.getWorkspaceFolder(),le=W.getWorkspaceFolder();if(Y&&le){let Q=this.c.get(Y.uri.toString());Q=Q===void 0?0:Q+1;let Z=this.c.get(le.uri.toString());return Z=Z===void 0?0:Z+1,Q===Z?F._label.localeCompare(W._label):Q-Z}else return!Y&&le?-1:Y&&!le?1:0}}e.$kG=L;var w;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(w||(e.TaskEventKind=w={}));var p;(function(T){T.SingleRun="singleRun",T.Background="background"})(p||(e.TaskRunType=p={}));var E;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var A;(function(T){function F(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function W(oe,X,ve){return{...F(oe),kind:"start",terminalId:X,resolvedVariables:ve}}T.start=W;function Y(oe,X,ve){return{...F(oe),kind:"processStarted",terminalId:X,processId:ve}}T.processStarted=Y;function le(oe,X,ve){return{...F(oe),kind:"processEnded",terminalId:X,exitCode:ve}}T.processEnded=le;function Q(oe,X,ve){return{...F(oe),kind:"terminated",exitReason:ve,terminalId:X}}T.terminated=Q;function Z(oe,X,ve){return{...F(X),kind:oe,terminalId:ve}}T.general=Z;function x(){return{kind:"changed"}}T.changed=x})(A||(e.TaskEvent=A={}));var z;(function(T){function F(Y){const le=Object.keys(Y).sort();let Q="";for(const Z of le){let x=Y[Z];x instanceof Object?x=F(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),Q+=Z+","+x+","}return Q}function W(Y){const Q={_key:F(Y),type:Y.taskType};return Object.assign(Q,Y),Q}T.create=W})(z||(e.KeyedTaskIdentifier=z={}));var N;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection",T.VerboseLogging="task.verboseLogging"})(N||(e.TaskSettingId=N={}));var I;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(I||(e.TasksSchemaProperties=I={}));var j;(function(T){function F(W,Y){const le=b.$aG.get(W.type);if(le===void 0){const oe=P.$fn(W);return delete oe._key,z.create(oe)}const Q=Object.create(null);Q.type=le.taskType;const Z=new Set;le.required.forEach(oe=>Z.add(oe));const x=le.properties;for(const oe of Object.keys(x)){const X=W[oe];if(X!=null)Q[oe]=X;else if(Z.has(oe)){const ve=x[oe];if(ve.default!==void 0)Q[oe]=P.$fn(ve.default);else switch(ve.type){case"boolean":Q[oe]=!1;break;case"number":case"integer":Q[oe]=0;break;case"string":Q[oe]="";break;default:Y.error(D.localize(2,null,JSON.stringify(W,void 0,0),oe));return}}}return z.create(Q)}T.createTaskIdentifier=F})(j||(e.TaskDefinition=j={}))}),define(Se[303],ke([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,D.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$46b=O;class g extends O{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$56b=g}),define(Se[68],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cv=e.$Bv=e.$Av=e.$zv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$zv=D;const O=[];function g(b){const $=new D(b);return O[$.nid]=$,$}e.$Av=g;function P(b){return O[b].sid}e.$Bv=P;class M{constructor($){this.value=$}}e.$Cv=M}),define(Se[6],ke([1,0,68]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$EK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var g;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var P;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var M;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(d){return d._id=C.a++,d}}e.$EK=C;var m;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var k;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$FK={MainThreadAuthentication:(0,D.$Av)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Av)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Av)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Av)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Av)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Av)("MainThreadClipboard"),MainThreadCommands:(0,D.$Av)("MainThreadCommands"),MainThreadComments:(0,D.$Av)("MainThreadComments"),MainThreadConfiguration:(0,D.$Av)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Av)("MainThreadConsole"),MainThreadDebugService:(0,D.$Av)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Av)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Av)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Av)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Av)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Av)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Av)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Av)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Av)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Av)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Av)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Av)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Av)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Av)("MainThreadLanguages"),MainThreadLogger:(0,D.$Av)("MainThreadLogger"),MainThreadMessageService:(0,D.$Av)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Av)("MainThreadOutputService"),MainThreadProgress:(0,D.$Av)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Av)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Av)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Av)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Av)("MainThreadSecretState"),MainThreadStorage:(0,D.$Av)("MainThreadStorage"),MainThreadSpeech:(0,D.$Av)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Av)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Av)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Av)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Av)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Av)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Av)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Av)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Av)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Av)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Av)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Av)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Av)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Av)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Av)("MainThreadSCM"),MainThreadSearch:(0,D.$Av)("MainThreadSearch"),MainThreadShare:(0,D.$Av)("MainThreadShare"),MainThreadTask:(0,D.$Av)("MainThreadTask"),MainThreadWindow:(0,D.$Av)("MainThreadWindow"),MainThreadLabelService:(0,D.$Av)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Av)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Av)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Av)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Av)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Av)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Av)("MainThreadInteractive"),MainThreadChat:(0,D.$Av)("MainThreadChat"),MainThreadInlineChat:(0,D.$Av)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Av)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Av)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Av)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Av)("MainThreadTimeline"),MainThreadTesting:(0,D.$Av)("MainThreadTesting"),MainThreadLocalization:(0,D.$Av)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Av)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Av)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Av)("MainThreadIssueReporter")},e.$GK={ExtHostCommands:(0,D.$Av)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Av)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Av)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Av)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Av)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Av)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Av)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Av)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Av)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Av)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Av)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Av)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Av)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Av)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Av)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Av)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Av)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Av)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Av)("ExtHostStatusBar"),ExtHostShare:(0,D.$Av)("ExtHostShare"),ExtHostExtensionService:(0,D.$Av)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Av)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Av)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Av)("ExtHostSCM"),ExtHostSearch:(0,D.$Av)("ExtHostSearch"),ExtHostTask:(0,D.$Av)("ExtHostTask"),ExtHostWorkspace:(0,D.$Av)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Av)("ExtHostWindow"),ExtHostWebviews:(0,D.$Av)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Av)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Av)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Av)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Av)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Av)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Av)("ExtHostProgress"),ExtHostComments:(0,D.$Av)("ExtHostComments"),ExtHostSecretState:(0,D.$Av)("ExtHostSecretState"),ExtHostStorage:(0,D.$Av)("ExtHostStorage"),ExtHostUrls:(0,D.$Av)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Av)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Av)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Av)("ExtHostOutputService"),ExtHosLabelService:(0,D.$Av)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Av)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Av)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Av)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Av)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Av)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Av)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Av)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Av)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Av)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Av)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Av)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Av)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Av)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Av)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Av)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Av)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Av)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Av)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Av)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Av)("ExtHostTimeline"),ExtHostTesting:(0,D.$Av)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Av)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Av)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Av)("ExtHostIssueReporter")}}),define(Se[304],ke([1,0,6,7]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class g{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(D.$FK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(M);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(M,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(M,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new O.$HK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$Oec=g}),define(Se[91],ke([1,0,5,14,6,20]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=e.$Uec=void 0,e.$Uec=(0,D.$1h)("IExtHostApiDeprecationService");let M=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$FK.MainThreadTelemetry)}report($,y,R){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$Vec=M,e.$Vec=M=Ge([We(0,P.$JM),We(1,O.$ij)],M),e.$Wec=Object.freeze(new class{report(b,$,y){}})}),define(Se[305],ke([1,0,4,6,7,26]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class M{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Sd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=y.getProxy(O.$FK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,R,C,m={}){const v=P.$em.toKey(y.identifier),k=[...C].sort().join(" ");return await this.f.getOrCreate(`${v} ${R} ${k}`,async()=>{await this.a.$ensureProvider(R);const f=y.displayName||y.name;return this.a.$getSession(R,C,v,f,m)})}async getSessions(y,R,C){const m=P.$em.toKey(y.identifier),v=[...C].sort().join(" ");return await this.g.getOrCreate(`${m} ${v}`,async()=>{await this.a.$ensureProvider(R);const k=y.displayName||y.name;return this.a.$getSessions(R,C,m,k)})}async removeSession(y,R){const C=this.b.get(y);return C?C.provider.removeSession(R):this.a.$removeSession(y,R)}registerAuthenticationProvider(y,R,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:R,provider:C,options:m??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:R});const v=C.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,R,m?.supportsMultipleAccounts??!1),new g.$HK(()=>{v.dispose(),this.b.delete(y);const k=this.c.findIndex(f=>f.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,R,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(R,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,R){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,R){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,R){return this.d.fire({provider:{id:y,label:R}}),Promise.resolve()}}e.$Zec=M;class b{constructor(){this.a=new Map}getOrCreate(y,R){const C=this.a.get(y);if(C)return C;const m=R().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(Se[306],ke([1,0,6,20,15]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let P=class{constructor(b,$){this.a=b.getProxy(D.$FK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const R=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.$1ec=P,e.$1ec=P=Ge([We(0,O.$JM)],P)}),define(Se[307],ke([1,0,4,52,3,6,15]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class b{static{this.a=0}constructor(R,C){this.extension=R,this.provider=C,this.handle=b.a++}}class ${static{this.a=0}constructor(R){this.b=new Map,this.c=new Map,this.d=new D.$Sd,this.onDidPerformUserAction=this.d.event,this.e=R.getProxy(P.$FK.MainThreadChat)}registerChatProvider(R,C,m){const v=new b(R,m);return this.b.set(v.handle,v),this.e.$registerChatProvider(v.handle,C),(0,g.$Qc)(()=>{this.e.$unregisterChatProvider(v.handle),this.b.delete(v.handle)})}transferChatSession(R,C){const m=O.Iterable.find(this.c.keys(),v=>this.c.get(v)===R)??0;typeof m=="number"&&this.e.$transferChatSession(m,C)}sendInteractiveRequestToProvider(R,C){this.e.$sendRequestToProvider(R,C)}async $prepareChat(R,C){const m=this.b.get(R);if(!m)return;const v=await m.provider.prepareSession(C);if(!v)return;const k=$.a++;return this.c.set(k,v),{id:k,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(R,C){const m=this.b.get(R);if(!m||!m.provider.provideWelcomeMessage)return;const v=await m.provider.provideWelcomeMessage(C);if(v)return v.map(k=>typeof k=="string"?k:Array.isArray(k)?k.map(f=>M.ChatReplyFollowup.from(f)):M.MarkdownString.from(k))}async $provideSampleQuestions(R,C){const m=this.b.get(R);if(!m||!m.provider.provideSampleQuestions)return;const v=await m.provider.provideSampleQuestions(C);if(v)return v?.map(k=>M.ChatReplyFollowup.from(k))}$releaseSession(R){this.c.delete(R)}async $onDidPerformUserAction(R){this.d.fire(R)}}e.$2ec=$}),define(Se[308],ke([1,0,12,21,44,4,38,18,2,209,85,6,15,7,279,25]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class d{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$FK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=d.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,h){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function l(){if(c)throw new Error("Only valid while executing the command")}const S=new D.$lh;h.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,S.p);const L=t.command?await u.validateSlashCommand(t.command):void 0,w=M.$Od.create(!1);let p;try{const E=u.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:L},{history:r.history.map(m.ChatMessage.to)},new R.$ev(A=>{l(),typeof p>"u"&&"content"in A&&(p=w.elapsed());const z=m.ChatResponseProgress.from(u.extension,A);if(!z){this.j.error("Unknown progress type: "+JSON.stringify(A));return}if("placeholder"in A&&"resolvedContent"in A){const N=Promise.all([this.d.$handleProgressChunk(a,z),A.resolvedContent]);(0,D.$Pg)(N,h).then(I=>{if(!I)return;const[j,T]=I,F=m.ChatResponseProgress.from(u.extension,T);if(!F){this.j.error("Unknown progress type: "+JSON.stringify(T));return}this.d.$handleProgressChunk(a,F,j??void 0)})}else this.d.$handleProgressChunk(a,z)}),h);return await(0,D.$Pg)(Promise.resolve(E).then(A=>{if(A){this.g.set(o,A);let z=this.h.get(o);z||(z=new Map,this.h.set(o,z)),z.set(a,A);const N={firstProgress:p,totalElapsed:w.elapsed()};return{errorDetails:A.errorDetails,timings:N}}else this.g.delete(o)}),h)}catch(E){return this.j.error(E,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Li)(E)),responseIsIncomplete:!0}}}finally{c=!0,S.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t,r){const h=this.b.get(n);if(!h)return;const u=this.h.get(o)?.get(a);if(!u)return;let c;switch(t){case k.InteractiveSessionVoteDirection.Down:c=v.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:c=v.ChatAgentResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(r?{result:u,kind:c,reportIssue:r}:{result:u,kind:c}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const h=this.h.get(o)?.get(a);h&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:h}))}async $invokeCompletionProvider(n,o,a){const t=this.b.get(n);return t?(await t.invokeCompletionProvider(o,a)).map(m.ChatAgentCompletionItem.from):[]}}e.$4ec=d;class s{constructor(n,o,a,t,r){this.extension=n,this.t=o,this.u=a,this.w=t,this.x=r,this.o=new P.$Sd,this.q=new P.$Sd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async invokeCompletionProvider(n,o){return this.s?await this.s.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(O.CancellationToken.None),(0,b.$Nf)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$CL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,f.$SF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,f.$SF)(t.extension,"defaultChatAgent"),t.j=r,a()},get helpTextPrefix(){return(0,f.$SF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,f.$SF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,a()},get helpTextPostfix(){return(0,f.$SF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,f.$SF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,a()},get isSecondary(){return(0,f.$SF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,f.$SF)(t.extension,"defaultChatAgent"),t.n=r,a()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,a()},get supportIssueReporting(){return(0,f.$SF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,f.$SF)(t.extension,"chatAgents2Additions"),t.r=r,a()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,f.$RF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(n,o,a,t){return this.x(n,o,a,t)}}}),define(Se[309],ke([1,0,21,3,6,15,85,26,12,4]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class R{constructor(k,f){this.stream=new $.$rh,this.stream=f??new $.$rh;const d=this;this.apiObj={option:k,response:d.stream.asyncIterable}}}class C{constructor(k,f){this.a=new y.$Sd,this.b=new Map,this.c=new $.$rh,this.d=!1;const d=this;this.apiObject={result:k,response:d.c.asyncIterable,onDidStartResponseStream:d.a.event,cancel(){f.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let f=this.b.get(k.index);f||(this.b.size===0?f=new R(k.index,this.c):f=new R(k.index),this.b.set(k.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(k.part)}}class m{static{this.a=1}constructor(k,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new b.$gm,this.b=k.getProxy(g.$FK.MainThreadChatProvider)}registerProvider(k,f,d,s){const i=m.a++;return this.c.set(i,{extension:k,provider:d}),this.b.$registerProvider(i,f,{extension:k,displayName:s.name??k.value}),(0,O.$Qc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(k,f,d,s,i){const n=this.c.get(k);if(!n)return;const o=new M.$ev(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:a.index,part:a.part})});return n.provider.provideChatResponse(d.map(P.ChatMessage.to),s,o,i)}allowListExtensionWhile(k,f){this.f.set(k,f),f.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,f){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const d=this;return{get isRevoked(){return!d.f.has(k)},makeRequest(s,i,n){if(!d.f.has(k))throw new Error("Access to chat has been revoked");const o=new D.$3d(n),a=Math.random()*1e6|0,t=d.b.$fetchResponse(k,f,a,s.map(P.ChatMessage.from),i??{},o.token),r=new C(t,o);return d.e.set(a,{res:r}),t.finally(()=>{d.e.delete(a)}),r.apiObject}}}async $handleResponseFragment(k,f){const d=this.e.get(k);d&&d.res.handleFragment(f)}}e.$3ec=m}),define(Se[310],ke([1,0,3,6,8,15]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class M{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(O.$FK.MainThreadChatVariables)}async $resolveVariable($,y,R){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{message:y},R);if(m)return m.map(P.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,R,C){const m=M.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:R},resolver:C}),this.c.$registerVariable(m,{name:y,description:R}),(0,D.$Qc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$5ec=M}),define(Se[311],ke([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class O{constructor(P){const M=P.getProxy(D.$FK.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$6ec=O}),define(Se[35],ke([1,0,18,7,15,24,6,19,14,54,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=void 0;let h=class{#e;#t;#i;constructor(w,p,E){this.b=new Map,this.c=new Map,this.#e=w.getProxy(M.$FK.MainThreadCommands),this.d=p,this.#i=E,this.#t=w.getProxy(M.$FK.MainThreadTelemetry),this.converter=new u(this,A=>{const z=this.c.get(A);return z?.result===l.Void?z:void 0},p),this.f=[{processArgument(A){return(0,y.$xh)(A)}},{processArgument(A){return(0,P.$hn)(A,function(z){if(R.$Es.isIRange(z))return g.Range.to(z);if(C.$Ds.isIPosition(z))return g.Position.to(z);if(R.$Es.isIRange(z.range)&&m.URI.isUri(z.uri))return g.location.to(z);if(z instanceof s.$ge)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const p=this.registerCommand(!1,w.id,async(...E)=>{const A=w.args.map((N,I)=>{if(!N.validate(E[I]))throw new Error(`Invalid argument '${N.name}' when running '${w.id}', received: ${typeof E[I]=="object"?JSON.stringify(E[I],null,"	"):E[I]} `);return N.convert(E[I])}),z=await this.executeCommand(w.internalId,...A);return w.result.convert(z,E,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new O.$HK(()=>{p.dispose(),this.c.delete(w.id)})}registerCommand(w,p,E,A,z,N){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:E,thisArg:A,metadata:z,extension:N}),w&&this.#e.$registerCommand(p),new O.$HK(()=>{this.b.delete(p)&&w&&this.#e.$unregisterCommand(p)})}executeCommand(w,...p){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,p,!0)}async g(w,p,E){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,p,!1);{let A=!1;const z=(0,P.$hn)(p,function(N){if(N instanceof O.$IK)return g.Position.from(N);if(N instanceof O.$JK)return g.Range.from(N);if(N instanceof O.$TK)return g.location.from(N);if(O.$6L.isNotebookRange(N))return g.NotebookRange.from(N);if(N instanceof ArrayBuffer)return A=!0,s.$ge.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return A=!0,s.$ge.wrap(N);if(N instanceof s.$ge)return A=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(w,A?new i.$Cv(z):z,E);return(0,y.$xh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(w,p,!1);throw N}}}async h(w,p,E){const A=this.b.get(w);if(!A)throw new Error("Unknown command");const{callback:z,thisArg:N,metadata:I}=A;if(I?.args)for(let T=0;T<I.args.length;T++)try{(0,D.$Uf)(p[T],I.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${I.args[T].name}' - ${I.args[T].description}`)}const j=o.$Od.create();try{return await z.apply(N,p)}catch(T){if(w===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...p);F&&(w=F.command)}if(this.d.error(T,w,A.extension?.identifier),!E)throw T;if(A.extension?.identifier){const F=this.#i.onExtensionError(A.extension.identifier,T);this.d.trace("forwarded error to extension?",F,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Li)(T)),this.id=w,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,w,j.elapsed())}}j(w,p,E){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new a.$uo(p),duration:E})}$executeContributedCommand(w,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const E=this.b.get(w);return E?(p=p.map(A=>this.f.reduce((z,N)=>N.processArgument(z,E.extension?.identifier),A)),this.h(w,p,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(p=>(w&&(p=p.filter(E=>E[0]!=="_")),p))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[p,E]of this.b){const{metadata:A}=E;A&&(w[p]=A)}return Promise.resolve(w)}};e.$5M=h,e.$5M=h=Ge([We(0,f.$JM),We(1,$.$ij),We(2,t.$4M)],h),e.$6M=(0,k.$1h)("IExtHostCommands");class u{constructor(w,p,E){this.d=w,this.f=p,this.g=E,this.delegatingCommandId=`__vsc${(0,r.$lg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,p){if(!w)return;const E={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return E;const A=this.f(w.command);if(A)E.id=A.internalId,E.arguments=A.args.map((z,N)=>z.convert(w.arguments&&w.arguments[N]));else if((0,b.$Lb)(w.arguments)){const z=`${w.command} /${++this.c}`;this.b.set(z,w),p.add((0,v.$Qc)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),E.$ident=z,E.id=this.delegatingCommandId,E.arguments=[z],this.g.trace("CommandsConverter#CREATE",w.command,z)}return E}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const p=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$7M=u;class c{static{this.Uri=new c("uri","Uri of a text document",w=>m.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>O.$IK.isPosition(w),g.Position.from)}static{this.Range=new c("range","A range in a text document",w=>O.$JK.isRange(w),g.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>O.$KK.isSelection(w),g.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,p=>Array.isArray(p)&&p.every(E=>w.validate(E)),p=>p.map(E=>w.convert(E)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof O.$5K,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof O.$mM,g.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof d.$WM,g.TestItem.from)}constructor(w,p,E,A){this.name=w,this.description=p,this.validate=E,this.convert=A}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,p){return new c(w??this.name,p??this.description,this.validate,this.convert)}}e.$8M=c;class l{static{this.Void=new l("no result",w=>w)}constructor(w,p){this.description=w,this.convert=p}}e.$9M=l;class S{constructor(w,p,E,A,z){this.id=w,this.internalId=p,this.description=E,this.args=A,this.result=z}}e.$0M=S}),define(Se[312],ke([1,0,19,17,2,83,131,46,35,15,7]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;const C=[new $.$0M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new $.$0M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$8M.Uri],new $.$9M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,D.$Kb)(f))return;class s extends R.$ZK{static to(n){const o=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new R.$TK(d[0],y.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=y.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return f.map(s.to)})),new $.$0M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$8M.Uri,new $.$8M("options","Formatting options",f=>!0,f=>f)],new $.$9M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$0M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$8M.Uri,$.$8M.Range,new $.$8M("options","Formatting options",f=>!0,f=>f)],new $.$9M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$0M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$8M.Uri,$.$8M.Position,new $.$8M("ch","Trigger character",f=>typeof f=="string",f=>f),new $.$8M("options","Formatting options",f=>!0,f=>f)],new $.$9M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$0M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$0M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$0M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$0M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$0M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of Location-instances.",v(y.location.to))),new $.$0M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new $.$0M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$8M.Uri,new $.$8M("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>R.$IK.isPosition(d)),f=>f.map(y.Position.from))],new $.$9M("A promise that resolves to an array of ranges.",f=>f.map(d=>{let s;for(const i of d.reverse())s=new R.$4K(y.Range.to(i),s);return s}))),new $.$0M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$8M.String.with("query","Search string")],new $.$9M("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(y.WorkspaceSymbol.to))),new $.$0M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(y.CallHierarchyItem.to))),new $.$0M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$8M.CallHierarchyItem],new $.$9M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(y.CallHierarchyIncomingCall.to))),new $.$0M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$8M.CallHierarchyItem],new $.$9M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(y.CallHierarchyOutgoingCall.to))),new $.$0M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to a range and placeholder text.",f=>{if(f)return{range:y.Range.to(f.range),placeholder:f.text}})),new $.$0M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$8M.Uri,$.$8M.Position,$.$8M.String.with("newName","The new symbol name")],new $.$9M("A promise that resolves to a WorkspaceEdit.",f=>{if(f){if(f.rejectReason)throw new Error(f.rejectReason);return y.WorkspaceEdit.to(f)}})),new $.$0M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$8M.Uri,$.$8M.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$9M("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(y.DocumentLink.to))),new $.$0M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$8M.Uri],new $.$9M("A promise that resolves to SemanticTokensLegend.",f=>{if(f)return new R.$XL(f.tokenTypes,f.tokenModifiers)})),new $.$0M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$8M.Uri],new $.$9M("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,M.$a$)(f);if(d.type==="full")return new R.$ZL(d.data,void 0)})),new $.$0M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$8M.Uri,$.$8M.Range.optional()],new $.$9M("A promise that resolves to SemanticTokensLegend.",f=>{if(f)return new R.$XL(f.tokenTypes,f.tokenModifiers)})),new $.$0M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$8M.Uri,$.$8M.Range],new $.$9M("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,M.$a$)(f);if(d.type==="full")return new R.$ZL(d.data,void 0)})),new $.$0M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$8M.Uri,$.$8M.Position,$.$8M.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$8M.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$9M("A promise that resolves to a CompletionList-instance.",(f,d,s)=>{if(!f)return new R.$dL([]);const i=f.suggestions.map(n=>y.CompletionItem.to(n,s));return new R.$dL(i,f.incomplete)})),new $.$0M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$8M.Uri,$.$8M.Position,$.$8M.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$9M("A promise that resolves to SignatureHelp.",f=>{if(f)return y.SignatureHelp.to(f)})),new $.$0M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$8M.Uri,$.$8M.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$9M("A promise that resolves to an array of CodeLens-instances.",(f,d,s)=>v(i=>new R.$8K(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(f))),new $.$0M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$8M.Uri,new $.$8M("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>R.$JK.isRange(f),f=>R.$KK.isSelection(f)?y.Selection.from(f):y.Range.from(f)),$.$8M.String.with("kind","Code action kind to return code actions for").optional(),$.$8M.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$9M("A promise that resolves to an array of Command-instances.",(f,d,s)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new R.$2K(i.title,i.kind?new R.$3K(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(f))),new $.$0M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$8M.Uri],new $.$9M("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new R.$jL(y.Range.to(d.range),y.Color.to(d.color))):[])),new $.$0M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$8M("color","The color to show and insert",f=>f instanceof R.$iL,y.Color.from),new $.$8M("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:y.Range.from(f.range)}))],new $.$9M("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(y.ColorPresentation.to):[])),new $.$0M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$8M.Uri,$.$8M.Range],new $.$9M("A promise that resolves to an array of Inlay objects",(f,d,s)=>f.map(y.InlayHint.to.bind(void 0,s)))),new $.$0M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$8M.Uri],new $.$9M("A promise that resolves to an array of FoldingRange objects",(f,d)=>{if(f)return f.map(y.FoldingRange.to)})),new $.$0M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$9M("A promise that resolves to an array of NotebookContentProvider static info objects.",v(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>y.NotebookExclusiveDocumentPattern.to(d))})))),new $.$0M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$8M.Uri,$.$8M.Range,new $.$8M("context","An InlineValueContext",f=>f&&typeof f.frameId=="number"&&f.stoppedLocation instanceof R.$JK,f=>y.InlineValueContext.from(f))],new $.$9M("A promise that resolves to an array of InlineValue objects",f=>f.map(y.InlineValue.to))),new $.$0M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$8M("uriOrString","Uri-instance or string (only http/https)",f=>g.URI.isUri(f)||typeof f=="string"&&(0,O.$ag)(f,O.Schemas.http,O.Schemas.https),f=>f),new $.$8M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[y.ViewColumn.from(f),void 0]:[y.ViewColumn.from(f.viewColumn),y.TextEditorOpenOptions.from(f)])).optional(),$.$8M.String.with("label","").optional()],$.$9M.Void),new $.$0M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$8M.Uri.with("resource","Resource to open"),$.$8M.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$8M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[y.ViewColumn.from(f),void 0]:[y.ViewColumn.from(f.viewColumn),y.TextEditorOpenOptions.from(f)])).optional()],$.$9M.Void),new $.$0M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$8M.Uri.with("left","Left-hand side resource of the diff editor"),$.$8M.Uri.with("right","Right-hand side resource of the diff editor"),$.$8M.String.with("title","Human readable title for the diff editor").optional(),new $.$8M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[y.ViewColumn.from(f.viewColumn),y.TextEditorOpenOptions.from(f)]).optional()],$.$9M.Void),new $.$0M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$8M.String.with("title","Human readable title for the changes editor"),new $.$8M("resourceList","List of resources to compare",f=>{for(const d of f){if(d.length!==3)return!1;const[s,i,n]=d;if(!g.URI.isUri(s)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},f=>f)],$.$9M.Void),new $.$0M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$8M.Uri,$.$8M.Position],new $.$9M("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(y.TypeHierarchyItem.to))),new $.$0M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$8M.TypeHierarchyItem],new $.$9M("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(y.TypeHierarchyItem.to))),new $.$0M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$8M.TypeHierarchyItem],new $.$9M("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(y.TypeHierarchyItem.to))),new $.$0M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$8M.TestItem],$.$9M.Void),new $.$0M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$8M.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$9M.Void),new $.$0M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$8M.String.with("name","The context key name"),new $.$8M("value","The context key value",()=>!0,f=>f)],$.$9M.Void),new $.$0M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$8M.Uri,$.$8M.StringArray,new $.$8M("MappedEditsContext","Mapped Edits Context",f=>y.MappedEditsContext.is(f),f=>y.MappedEditsContext.from(f))],new $.$9M("A promise that resolves to a workspace edit or null",f=>f?y.WorkspaceEdit.to(f):null))];class m{static register(d){C.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",b.$Zi)}}e.$Yec=m;function v(f){return d=>{if(Array.isArray(d))return d.map(f)}}function k(f){if(!Array.isArray(f))return;const d=[];for(const s of f)P.$qt(s)?d.push(y.DefinitionLink.to(s)):d.push(y.location.to(s));return d}}),define(Se[313],ke([1,0,12,59,4,3,2,83,26,15,7,6,25]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;function v(k,f,d){const s=k.getProxy(C.$FK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$gm,f.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const S=this.b.get(l.handle);return S?S.value:l}else if(l&&l.$mid===7){const S=this.b.get(l.commentControlHandle);if(!S)return l;const L=S.getCommentThread(l.commentThreadHandle);return L?L.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const S=this.b.get(l.thread.commentControlHandle);if(!S)return l;const L=S.getCommentThread(l.thread.commentThreadHandle);return L?l.$mid===8?L.value:{thread:L.value,text:l.text}:l}else if(l&&l.$mid===10){const S=this.b.get(l.thread.commentControlHandle);if(!S)return l;const L=S.getCommentThread(l.thread.commentThreadHandle);if(!L)return l;const w=l.commentUniqueId,p=L.getCommentByUniqueId(w);return p||l}else if(l&&l.$mid===11){const S=this.b.get(l.thread.commentControlHandle);if(!S)return l;const L=S.getCommentThread(l.thread.commentThreadHandle);if(!L)return l;const w=l.text,p=l.commentUniqueId,E=L.getCommentByUniqueId(p);return E?(typeof E.body=="string"?E.body=w:E.body=new R.$9K(w),E):l}return l}})}createCommentController(l,S,L){const w=i.a++,p=new o(l,w,S,L);this.b.set(p.handle,p);const E=this.c.get(l.identifier)||[];return E.push(p),this.c.set(l.identifier,E),p.value}async $createCommentThreadTemplate(l,S,L){const w=this.b.get(l);w&&w.$createCommentThreadTemplate(S,L)}async $updateCommentThreadTemplate(l,S,L){const w=this.b.get(l);w&&w.$updateCommentThreadTemplate(S,L)}$deleteCommentThread(l,S){this.b.get(l)?.$deleteCommentThread(S)}$provideCommentingRanges(l,S,L){const w=this.b.get(l);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const p=d.getDocument(M.URI.revive(S));return(0,D.$Tg)(async()=>{const E=await w.commentingRangeProvider.provideCommentingRanges(p,L);let A;return Array.isArray(E)?A={ranges:E,fileComments:!1}:E?A={ranges:E.ranges||[],fileComments:E.fileComments||!1}:A=E??void 0,A}).then(E=>{let A;return E&&(A={ranges:E.ranges.map(z=>y.Range.from(z)),fileComments:E.fileComments}),A})}$toggleReaction(l,S,L,w,p){const E=this.b.get(l);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Tg)(()=>{const A=E.getCommentThread(S);if(A){const z=A.getCommentByUniqueId(w.uniqueIdInThread);if(E!==void 0&&z&&E.reactionHandler)return E.reactionHandler(z,r(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,S,L,w,p,E,A,z){this.m=S,this.n=L,this.o=w,this.p=p,this.q=E,this.extensionDescription=A,this.r=z,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Tc,this.l.value=new P.$Rc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(S,this.handle,this.n,this.o,y.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{s.$deleteCommentThread(S,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(I){N.range=I},get comments(){return N.comments},set comments(I){N.comments=I},get collapsibleState(){return N.collapsibleState},set collapsibleState(I){N.collapsibleState=I},get canReply(){return N.canReply},set canReply(I){N.canReply=I},get contextValue(){return N.contextValue},set contextValue(I){N.contextValue=I},get label(){return N.label},set label(I){N.label=I},get state(){return N.state},set state(I){N.state=I},dispose:()=>{N.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Rc);const l=L=>Object.prototype.hasOwnProperty.call(this.b,L),S={};l("range")&&(S.range=y.Range.from(this.p)),l("label")&&(S.label=this.label),l("contextValue")&&(S.contextValue=this.contextValue??null),l("comments")&&(S.comments=this.q.map(L=>a(this,L,this.k,this.extensionDescription))),l("collapsibleState")&&(S.collapseState=h(this.g)),l("canReply")&&(S.canReply=this.canReply),l("state")&&(S.state=u(this.h)),l("isTemplate")&&(S.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(l){for(const S of this.k){const L=S[0],w=S[1];if(l===w)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ge([(0,O.$th)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,S,L,w){this.f=l,this.g=S,this.h=L,this.i=w,this.a=new Map,s.$registerCommentController(this.handle,L,w,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(E){p.options=E},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(E){p.commentingRangeProvider=E},get reactionHandler(){return p.reactionHandler},set reactionHandler(E){p.reactionHandler=E},createCommentThread(E,A,z){return p.createCommentThread(E,A,z).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,S,L){S===void 0&&(0,m.$SF)(this.f,"fileComments");const w=new n(this.id,this.handle,void 0,l,S,L,this.f,!1);return this.a.set(w.handle,w),w}$createCommentThreadTemplate(l,S){const L=new n(this.id,this.handle,void 0,M.URI.revive(l),y.Range.to(S),[],this.f,!0);return L.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(l,S){const L=this.a.get(l);L&&(L.range=y.Range.to(S))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function a(c,l,S,L){let w=S.get(l);return w||(w=++c.commentHandle,S.set(l,w)),l.state!==void 0&&(0,m.$SF)(L,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:w,body:typeof l.body=="string"?l.body:y.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(p=>t(p)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?y.$IM(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?M.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function h(c){if(c!==void 0)switch(c){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function u(c){if(c!==void 0)switch(c){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$9ec=v}),define(Se[314],ke([1,0,24,6,27,20]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;let M=class{constructor(R,C){this.a=R.getProxy(O.$FK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,C){const m=this,v=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m.e(R,C,v,arguments)}})}e(R,C,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(v,this.b)}),this.c&&this.f(R,m,v)}};e.$Wgc=M,e.$Wgc=M=Ge([We(0,P.$JM),We(1,g.$ZM)],M);const b=1e5;function $(y,R){const C=[];if(y.length)for(let m=0;m<y.length;m++){let v=y[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const k=v;k.stack?v=k.stack:v=k.toString()}C.push(v)}if(R){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$kn)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Se[149],ke([1,0,2,6,7,5,20,14,19,13,16,25]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=void 0;let v=class{static{m=this}static{this.c=0}static{this.d=250}constructor(f,d){this.h=d,this.f=new Map,this.g=f.getProxy(O.$FK.MainThreadDecorations)}registerFileDecorationProvider(f,d){const s=m.c++;this.f.set(s,{provider:f,extensionDescription:d}),this.g.$registerDecorationProvider(s,d.identifier.value);const i=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,$.$3b)(n);if(o.length<=m.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,o.length);const a=o.map(h=>({uri:h,rank:(0,y.$Le)(h.path,"/")})),t=(0,$.$zb)(a,(h,u)=>h.rank-u.rank||(0,y.$Ze)(h.uri.path,u.uri.path)),r=[];e:for(const h of t){let u;for(const c of h){const l=(0,R.$mc)(c.uri.path);if(u!==l&&(u=l,r.push(c.uri)>=m.d))break e}}this.g.$onDidChange(s,r)});return new g.$HK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(f,d,s){if(!this.f.has(f))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(f);return await Promise.all(d.map(async a=>{try{const{uri:t,id:r}=a,h=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!h)return;try{g.$4L.validate(h),h.badge&&typeof h.badge!="string"&&(0,C.$SF)(o,"codiconDecoration"),i[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$Yfc=v,e.$Yfc=v=m=Ge([We(0,M.$JM),We(1,b.$ij)],v),e.$Zfc=(0,P.$1h)("IExtHostDecorations")}),define(Se[315],ke([1,0,210,135,2,6,7,15,4,14,28,57]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;class v{#e;#t;#i;constructor(d,s,i,n,o,a,t,r){this.d=d,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new R.$Ac(h=>a.getComparisonKey(h)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(d,s){if(!d){this.clear();return}this.j();let i=[];if(g.URI.isUri(d)){if(!s){this.delete(d);return}this.#i.set(d,s.slice()),i=[d]}else if(Array.isArray(d)){i=[];let a;d=[...d].sort(v.k);for(const t of d){const[r,h]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),h)this.#i.get(r)?.push(...h);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const h=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const c of r)if(c.severity===h[u]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(h=>({...b.Diagnostic.from(h),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(d){this.j(),this.#t.fire([d]),this.#i.delete(d),this.#e?.$changeMany(this.e,[[d,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(d,s){this.j();for(const[i,n]of this)d.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const d of this.#i.keys())yield[d,this.get(d)]}get(d){this.j();const s=this.#i.get(d);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(d){return this.j(),Array.isArray(this.#i.get(d))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(d,s){return d[0].toString()<s[0].toString()?-1:d[0].toString()>s[0].toString()?1:0}}e.$Sec=v;let k=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(d){const s=new R.$Ac;for(const i of d)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(d,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$Wd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=d.getProxy(P.$FK.MainThreadDiagnostics)}createDiagnosticCollection(d,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,h=new class{$changeMany(l,S){n.$changeMany(l,S),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,l,S.length===0?"CLEARING":S)}$clear(l){n.$clear(l),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,l)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+m.c++;while(i.has(u))}return new class extends v{constructor(){super(s,u,m.e,m.d,l=>r.getDocument(l)?.version,t.extUri,h,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(d){if(d)return this.m(d);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(d){let s=[];for(const i of this.g.values())i.has(d)&&(s=s.concat(i.get(d)));return s}$acceptMarkersChange(d){if(!this.n){const s="_generated_mirror",i=new v(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of d)this.n.set(g.URI.revive(s),i.map(b.Diagnostic.to))}};e.$Tec=k,e.$Tec=k=m=Ge([We(1,y.$ij),We(2,C.$Rec)],k)}),define(Se[316],ke([1,0,2,6,25]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class P{constructor(b){this.a=b.getProxy(O.$FK.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$SF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$1fc=P}),define(Se[317],ke([1,0,8,2,7,6,17,21,13]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class y{static{this.a=0}constructor(C,m,v){this.d=m,this.e=v,this.b=new Map,this.c=C.getProxy(P.$FK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(M.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=y.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,C);let k;return typeof m.onDidChange=="function"&&(k=m.onDidChange(f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(d=>{if(!d&&typeof d!="string")return;const s=this.d.getDocument(f);if(!s)return;const i=(0,$.$Ue)(d);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(f,d)},D.$1)})),new g.$HK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(C,m){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(O.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$2fc=y}),define(Se[318],ke([1,0,4,3,2,6,141,15,18,24,7,8]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class m{constructor(k,f){this.a=new D.$Sd({onListenerError:C.$2}),this.b=new D.$Sd({onListenerError:C.$2}),this.c=new D.$Sd({onListenerError:C.$2}),this.d=new D.$Sd({onListenerError:C.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Rc,this.h=new Map,this.f=k.getProxy(P.$FK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(d=>{for(const s of d)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const s of d)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const f=this.g.getDocument(k);if(f)return f}getDocument(k){const f=this.getDocumentData(k);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return f.document}ensureDocumentData(k){const f=this.g.getDocument(k);if(f)return Promise.resolve(f);let d=this.h.get(k.toString());return d||(d=this.f.$tryOpenDocument(k).then(s=>{this.h.delete(k.toString());const i=g.URI.revive(s);return(0,$.$Of)(this.g.getDocument(i))},s=>(this.h.delete(k.toString()),Promise.reject(s))),this.h.set(k.toString(),d)),d}createDocumentData(k){return this.f.$tryCreateDocument(k).then(f=>g.URI.revive(f))}$acceptModelLanguageChanged(k,f){const d=g.URI.revive(k),s=this.g.getDocument(d);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(f),this.a.fire(s.document)}$acceptModelSaved(k){const f=g.URI.revive(k),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(k,f){const d=g.URI.revive(k),s=this.g.getDocument(d);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,f,d){const s=g.URI.revive(k),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),i.onEvents(f);let n;f.isUndoing?n=R.TextDocumentChangeReason.Undo:f.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this.c.fire((0,y.$gn)({document:i.document,contentChanges:f.changes.map(o=>({range:b.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(k,f){(0,M.$LM)(k,f)}}e.$Pec=m}),define(Se[69],ke([1,0,60,4,3,2,5,6,141,20,148,15,14,28,17,52,43]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new O.$Sd,this.e=new O.$Sd,this.f=new O.$Sd,this.g=new O.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const h of o.removedDocuments){const u=P.URI.revive(h),c=this.c.get(u);c?.unref()&&(this.c.delete(u),a.push(c.value))}if(o.addedDocuments)for(const h of o.addedDocuments){const u=P.URI.revive(h.uri);let c=this.c.get(u);if(c&&u.scheme!==k.Schemas.vscodeNotebookCell&&u.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);c||(c=new s(new $.$MM(this.h.getProxy(b.$FK.MainThreadDocuments),u,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty,h.notebook)),this.c.set(u,c),t.push(c.value)),c.ref()}if(o.removedEditors)for(const h of o.removedEditors){const u=this.b.get(h);this.b.delete(h),u&&r.push(u)}if(o.addedEditors)for(const h of o.addedEditors){const u=P.URI.revive(h.documentUri);D.ok(this.c.has(u),`document '${u}' does not exist`),D.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const c=this.c.get(u).value,l=new R.$SM(h.id,this.h.getProxy(b.$FK.MainThreadTextEditors),this.i,new d.$V(()=>c.document),h.selections.map(C.Selection.to),h.options,h.visibleRanges.map(S=>C.Range.to(S)),typeof h.editorPosition=="number"?C.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,l)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,g.$Nc)(a),(0,g.$Nc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return f.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$TM=i,e.$TM=i=Ge([We(0,y.$JM),We(1,m.$ij)],i),e.$UM=(0,M.$1h)("IExtHostDocumentsAndEditors")}),define(Se[70],ke([1,0,73,4,18,2,5,6,20,15,7]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0,e.$pfc=(0,M.$1h)("IExtHostEditorTabs");class C{constructor(d,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,s={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$nM(P.URI.revive(this.b.input.uri));case 2:return new R.$oM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$pM(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$qM(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$rM(this.b.input.viewType);case 4:return new R.$sM(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$tM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$uM;case 9:return new R.$vM(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$wM(this.b.input.providerId);default:return}}}class m{constructor(d,s){this.c=[],this.d="",this.b=d,this.e=s;for(const i of d.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,s={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return y.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(i=>i.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const i=new C(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,i),d.tabDto.isActive&&(this.d=i.tabId),i}else if(d.kind===1){const i=this.c.splice(d.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(d.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,i),i}const s=this.c.find(i=>i.tabId===d.tabDto.id);if(!s)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(d.tabDto),s}activeTabId(){return this.d}}let v=class{constructor(d){this.b=new O.$Sd,this.c=new O.$Sd,this.e=[],this.a=d.getProxy(b.$FK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,s={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(i=>i.apiObject))},get activeTabGroup(){const i=d.d;return(0,g.$Of)(d.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?k(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(d){const s=new Set(this.e.map(h=>h.groupId)),i=new Set(d.map(h=>h.groupId)),n=(0,D.$L)(s,i),o=this.e.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),a=[],t=[];this.e=d.map(h=>{const u=new m(h,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,g.$Of)(d.find(h=>h.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(d){const s=this.e.find(i=>i.groupId===d.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const s=this.e.find(n=>n.groupId===d.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(d){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===d)return i}h(d){return this.e.find(s=>s.apiObject===d)}async i(d,s){const i=[];for(const n of d){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(d,s){const i=[];for(const n of d){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$qfc=v,e.$qfc=v=Ge([We(0,$.$JM)],v);function k(f){return f.tabs!==void 0}}),define(Se[319],ke([1,0,6,7]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class g{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(D.$FK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(M);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector(b,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(M,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new O.$HK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$4fc=g}),define(Se[320],ke([1,0,2,6,3,7,15,172,13,22,25,80]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class m{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const d=this.a.indexOf(f);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),d=[];let s,i,n=14,o=14;for(const a of f){let t=s?(0,$.$9e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,d.push([i,a.toUpperCase().charCodeAt(t),o]),d.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}d.push([9,58,10]),d.push([10,47,12]),this.b=new b.$cZ(d)}}provideDocumentLinks(f){this.c();const d=[],s=b.$dZ.computeLinks({getLineContent(i){return f.lineAt(i-1).text},getLineCount(){return f.lineCount}},this.b);for(const i of s){const n=M.DocumentLink.to(i);n.target&&d.push(n)}return d}}class v{constructor(f,d){this.i=d,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(O.$FK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,d,s,i={}){if(v.j(s),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const n=this.h++;this.b.add(d),this.d.add(d),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$SF)(f,"fsChunks"),o+=4);let a;i.isReadonly&&(0,C.$dk)(i.isReadonly)&&((0,R.$SF)(f,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,d,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${d}`),console.error(r)});const t=s.onDidChangeFile(r=>{const h=[];for(const u of r){const{uri:c,type:l}=u;if(c.scheme!==d)continue;let S;switch(l){case P.FileChangeType.Changed:S=0;break;case P.FileChangeType.Created:S=1;break;case P.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:c,type:S})}this.a.$onFileSystemChange(n,h)});return(0,g.$Qc)(()=>{t.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:d,ctime:s,mtime:i,size:n,permissions:o}=f;return{type:d,ctime:s,mtime:i,size:n,permissions:o}}$stat(f,d){return Promise.resolve(this.l(f).stat(D.URI.revive(d))).then(s=>v.k(s))}$readdir(f,d){return Promise.resolve(this.l(f).readDirectory(D.URI.revive(d)))}$readFile(f,d){return Promise.resolve(this.l(f).readFile(D.URI.revive(d))).then(s=>y.$ge.wrap(s))}$writeFile(f,d,s,i){return Promise.resolve(this.l(f).writeFile(D.URI.revive(d),s.buffer,i))}$delete(f,d,s){return Promise.resolve(this.l(f).delete(D.URI.revive(d),s))}$rename(f,d,s,i){return Promise.resolve(this.l(f).rename(D.URI.revive(d),D.URI.revive(s),i))}$copy(f,d,s,i){const n=this.l(f);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(d),D.URI.revive(s),i))}$mkdir(f,d){return Promise.resolve(this.l(f).createDirectory(D.URI.revive(d)))}$watch(f,d,s,i){const n=this.l(f).watch(D.URI.revive(s),i);this.f.set(d,n)}$unwatch(f,d){const s=this.f.get(d);s&&(s.dispose(),this.f.delete(d))}$open(f,d,s){const i=this.l(f);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(d),s))}$close(f,d){const s=this.l(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(d))}$read(f,d,s,i){const n=this.l(f);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$ge.alloc(i);return Promise.resolve(n.read(d,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(f,d,s,i){const n=this.l(f);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(d,s,i.buffer,0,i.byteLength))}l(f){const d=this.c.get(f);if(!d){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return d}}e.$5fc=v}),define(Se[71],ke([1,0,6,32,7,22,5,20,57,3,12,23,17]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;let k=v=class{constructor(d,s){this.b=new Map,this.c=new R.$0g,this.a=d.getProxy(D.$FK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===O.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return v.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return v.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return v.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,P.$ge.wrap(o))}catch(a){return v.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return v.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return v.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return v.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(d,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await d.stat(i)).type&O.FileType.Directory))throw g.$VL.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(O.$zk(o)!==O.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await d.createDirectory(i)}catch(a){if(O.$zk(a)!==O.FileSystemProviderErrorCode.FileExists)throw a}}}static e(d){if(d instanceof g.$VL)throw d;if(d instanceof O.$vk)switch(d.code){case O.FileSystemProviderErrorCode.FileExists:throw g.$VL.FileExists(d.message);case O.FileSystemProviderErrorCode.FileNotFound:throw g.$VL.FileNotFound(d.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw g.$VL.FileNotADirectory(d.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw g.$VL.FileIsADirectory(d.message);case O.FileSystemProviderErrorCode.NoPermissions:throw g.$VL.NoPermissions(d.message);case O.FileSystemProviderErrorCode.Unavailable:throw g.$VL.Unavailable(d.message);default:throw new g.$VL(d.message,d.name)}if(!(d instanceof Error))throw new g.$VL(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw g.$VL.Unavailable(d.message);switch(d.name){case O.FileSystemProviderErrorCode.FileExists:throw g.$VL.FileExists(d.message);case O.FileSystemProviderErrorCode.FileNotFound:throw g.$VL.FileNotFound(d.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw g.$VL.FileNotADirectory(d.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw g.$VL.FileIsADirectory(d.message);case O.FileSystemProviderErrorCode.NoPermissions:throw g.$VL.NoPermissions(d.message);case O.FileSystemProviderErrorCode.Unavailable:throw g.$VL.Unavailable(d.message);default:throw new g.$VL(d.message,d.name)}}addFileSystemProvider(d,s,i){return this.b.set(d,{impl:s,extUri:i?.isCaseSensitive?C.$sg:C.$ug,isReadonly:!!i?.isReadonly}),(0,y.$Qc)(()=>this.b.delete(d))}getFileSystemProviderExtUri(d){return this.b.get(d)?.extUri??C.$sg}};e.$efc=k,e.$efc=k=v=Ge([We(0,b.$JM),We(1,$.$Rec)],k),e.$ffc=(0,M.$1h)("IExtHostConsumerFileSystem")}),define(Se[321],ke([1,0,4,34,2,6,15,7,43]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,k,f,d,s,i){this.a=Math.random(),this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$Hj)(s),o=typeof s=="string",a=i?.correlate,t=d(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const h of r.created){const u=g.URI.revive(h);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const h of r.changed){const u=g.URI.revive(h);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const h of r.deleted){const u=g.URI.revive(h);n(u.fsPath)&&(!o||k.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=b.$HK.from(this.i(v,f,s,i,i?.correlate),this.b,this.c,this.d,t)}i(v,k,f,d,s){const i=b.$HK.from();if(typeof f=="string")return i;const n=v.getProxy(P.$FK.MainThreadFileSystemEventService);let o=!1;return(f.pattern.includes(O.$Dj)||f.pattern.includes(O.$Ej))&&(o=!0),n.$watch(k.identifier.value,this.a,f.baseUri,{recursive:o,excludes:d?.excludes??[]},!!s),b.$HK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,k,f){this.j=v,this.k=k,this.l=f,this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.g=new D.$Ud,this.h=new D.$Ud,this.i=new D.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,k,f,d){return new y(this.j,v,k,this.a.event,M.GlobPattern.from(f),d)}$onFileEvent(v){this.a.fire(new R(v))}$onDidRunFileOperation(v,k){switch(v){case 2:this.b.fire(Object.freeze({files:k.map(f=>({oldUri:g.URI.revive(f.source),newUri:g.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(f=>g.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(f=>g.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,k){return(f,d,s)=>{const i=function(o){f.call(d,o)};return i.extension=v,k.event(i,void 0,s)}}async $onWillRunFileOperation(v,k,f,d){switch(v){case 2:return await this.n(this.g,{files:k.map(s=>({oldUri:g.URI.revive(s.source),newUri:g.URI.revive(s.target)}))},f,d);case 1:return await this.n(this.i,{files:k.map(s=>g.URI.revive(s.target))},f,d);case 0:case 3:return await this.n(this.h,{files:k.map(s=>g.URI.revive(s.target))},f,d)}}async n(v,k,f,d){const s=new Set,i=[];if(await v.fireAsync(k,d,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof b.$RK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>f&&this.k.warn("SLOW file-participant",a.extension.identifier)}),d.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=M.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$6fc=C}),define(Se[322],ke([1,0,3,2,6,15,7,35,12]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class y{static{this.a=0}constructor(v,k){this.extension=v,this.provider=k,this.handle=y.a++}}class R{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,k,f,d){this.f=f,this.g=d,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$FK.MainThreadInlineChat),k.registerApiCommand(new b.$0M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$8M("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?P.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?P.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?P.Position.from(s.position):void 0}})],b.$9M.Void))}registerProvider(v,k,f){const d=new y(v,k);return this.b.set(d.handle,d),this.e.$registerInteractiveEditorProvider(d.handle,f?.label??v.displayName??v.name,v.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",f?.supportReportIssue??!1),(0,D.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(d.handle),this.b.delete(d.handle)})}async $prepareSession(v,k,f,d){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(O.URI.revive(k)),n=P.Selection.to(f),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},d);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new R(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,k,f,d){const s=this.b.get(v);if(!s)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:f.prompt,selection:P.Selection.to(f.selection),wholeRange:P.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let o=!1;const a={report:async c=>{if(!f.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||d.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:c.message,edits:c.edits?.map(P.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:M.$9K.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,d));let r;try{r=await(0,$.$Pg)(t,d)}finally{o=!0}if(!r)return;const h=i.responses.push(r)-1,u={wholeRange:P.Range.from(r.wholeRange),placeholder:r.placeholder};if(C.h(r)){const{edits:c,contents:l}=r,S=l!==void 0?P.MarkdownString.from(l):void 0;return c instanceof M.$RK?{...u,id:h,type:"bulkEdit",edits:P.WorkspaceEdit.from(c),message:S}:{...u,id:h,type:"editorEdit",edits:c.map(P.TextEdit.from),message:S}}return{...u,id:h,type:"message",message:P.MarkdownString.from(r.contents)}}async $provideFollowups(v,k,f,d){const s=this.b.get(v),i=this.d.get(k),n=i?.responses[f];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,d));return(await(0,$.$Pg)(o,d))?.map(P.ChatReplyFollowup.from)}}$handleFeedback(v,k,f,d){const s=this.b.get(v),i=this.d.get(k),n=i?.responses[f];if(s&&n){const o=P.InteractiveEditorResponseFeedbackKind.to(d);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(v,k){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$7fc=C}),define(Se[323],ke([1,0,2,35]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class g{constructor(M,b,$,y,R){this.a=b,this.b=$,this.c=y;const C=new O.$0M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$8M("showOptions","Show Options",m=>!0,m=>m),new O.$8M("resource","Interactive resource Uri",m=>!0,m=>m),new O.$8M("controllerId","Notebook controller Id",m=>!0,m=>m),new O.$8M("title","Interactive editor title",m=>!0,m=>m)],new O.$9M("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(M,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$hgc=g}),define(Se[324],ke([1,0,6,7]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class g{constructor(M){this.a=new Map,this.b=new Map,this.c=M.getProxy(D.$FK.MainThreadIssueReporter)}async $getIssueReporterUri(M,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(M);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(M);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(M,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(M);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(M,b){const $=M.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new O.$HK(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(M,b){const $=M.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new O.$HK(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$igc=g}),define(Se[325],ke([1,0,3,6]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class g{constructor(M){this.b=0,this.a=M.getProxy(O.$FK.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,D.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$jgc=g}),define(Se[326],ke([1,0,2,24,15,7,83,6,13,29,19,18,168,21,26,3,131,121,110,38,8,12,25,212]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class h{constructor(B,_){this.d=B,this.e=_}async provideDocumentSymbols(B,_){const se=this.d.getDocument(B),K=await this.e.provideDocumentSymbols(se,_);if(!(0,R.$Kb)(K))return K[0]instanceof P.$1K?K.map(g.DocumentSymbol.from):h.f(K)}static f(B){B=B.slice(0).sort((K,ae)=>{let de=K.location.range.start.compareTo(ae.location.range.start);return de===0&&(de=ae.location.range.end.compareTo(K.location.range.end)),de});const _=[],se=[];for(const K of B){const ae={name:K.name||"!!MISSING: name!!",kind:g.SymbolKind.from(K.kind),tags:K.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:g.Range.from(K.location.range),selectionRange:g.Range.from(K.location.range),children:[]};for(;;){if(se.length===0){se.push(ae),_.push(ae);break}const de=se[se.length-1];if(y.$Es.containsRange(de.range,ae.range)&&!y.$Es.equalsRange(de.range,ae.range)){de.children?.push(ae),se.push(ae);break}se.pop()}}return _}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,_,se){this.g=B,this.h=_,this.j=se,this.e=new i.$Nec("CodeLens"),this.f=new Map}async provideCodeLenses(B,_){const se=this.g.getDocument(B),K=await this.j.provideCodeLenses(se,_);if(!K||_.isCancellationRequested)return;const ae=this.e.add(K),de=new f.$Rc;this.f.set(ae,de);const Ae={cacheId:ae,lenses:[]};for(let Be=0;Be<K.length;Be++)Ae.lenses.push({cacheId:[ae,Be],range:g.Range.from(K[Be].range),command:this.h.toInternal(K[Be].command,de)});return Ae}async resolveCodeLens(B,_){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let K;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?K=se:K=await this.j.resolveCodeLens(se,_),K||(K=se),_.isCancellationRequested)return;const ae=B.cacheId&&this.f.get(B.cacheId[0]);if(ae)return B.command=this.h.toInternal(K.command??u.d,ae),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Fe){return Array.isArray(Fe)?Fe.map(g.DefinitionLink.from):Fe?[g.DefinitionLink.from(Fe)]:[]}class l{constructor(B,_){this.d=B,this.e=_}async provideDefinition(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideDefinition(K,ae,se);return c(de)}}class S{constructor(B,_){this.d=B,this.e=_}async provideDeclaration(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideDeclaration(K,ae,se);return c(de)}}class L{constructor(B,_){this.d=B,this.e=_}async provideImplementation(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideImplementation(K,ae,se);return c(de)}}class w{constructor(B,_){this.d=B,this.e=_}async provideTypeDefinition(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideTypeDefinition(K,ae,se);return c(de)}}class p{constructor(B,_){this.d=B,this.e=_}async provideHover(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideHover(K,ae,se);if(!(!de||(0,R.$Kb)(de.contents)))return de.range||(de.range=K.getWordRangeAtPosition(ae)),de.range||(de.range=new P.$JK(ae,ae)),g.Hover.from(de)}}class E{constructor(B,_){this.d=B,this.e=_}async provideEvaluatableExpression(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideEvaluatableExpression(K,ae,se);if(de)return g.EvaluatableExpression.from(de)}}class A{constructor(B,_){this.d=B,this.e=_}async provideInlineValues(B,_,se,K){const ae=this.d.getDocument(B),de=await this.e.provideInlineValues(ae,g.Range.to(_),g.InlineValueContext.to(se),K);if(Array.isArray(de))return de.map(Ae=>g.InlineValue.from(Ae))}}class z{constructor(B,_){this.d=B,this.e=_}async provideDocumentHighlights(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideDocumentHighlights(K,ae,se);if(Array.isArray(de))return de.map(g.DocumentHighlight.from)}}class N{constructor(B,_){this.d=B,this.e=_}async provideMultiDocumentHighlights(B,_,se,K){const ae=this.d.getDocument(B),de=se.map(Xe=>this.d.getDocument(Xe)),Ae=g.Position.to(_),Be=await this.e.provideMultiDocumentHighlights(ae,Ae,de,K);if(Array.isArray(Be))return Be.map(g.MultiDocumentHighlight.from)}}class I{constructor(B,_){this.d=B,this.e=_}async provideLinkedEditingRanges(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideLinkedEditingRanges(K,ae,se);if(de&&Array.isArray(de.ranges))return{ranges:(0,R.$Hb)(de.ranges.map(g.Range.from)),wordPattern:de.wordPattern}}}class j{constructor(B,_){this.d=B,this.e=_}async provideReferences(B,_,se,K){const ae=this.d.getDocument(B),de=g.Position.to(_),Ae=await this.e.provideReferences(ae,de,se,K);if(Array.isArray(Ae))return Ae.map(g.location.from)}}class T{static{this.d=1e3}constructor(B,_,se,K,ae,de,Ae){this.g=B,this.h=_,this.j=se,this.k=K,this.l=ae,this.m=de,this.n=Ae,this.e=new i.$Nec("CodeAction"),this.f=new Map}async provideCodeActions(B,_,se,K){const ae=this.g.getDocument(B),de=m.$Gs.isISelection(_)?g.Selection.to(_):g.Range.to(_),Ae=[];for(const Pe of this.j.getDiagnostics(B))if(de.intersection(Pe.range)&&Ae.push(Pe)>T.d)break;const Be={diagnostics:Ae,only:se.only?new P.$3K(se.only):void 0,triggerKind:g.CodeActionTriggerKind.to(se.trigger)},Xe=await this.k.provideCodeActions(ae,de,Be,K);if(!(0,R.$Lb)(Xe)||K.isCancellationRequested)return;const Ye=this.e.add(Xe),it=new f.$Rc;this.f.set(Ye,it);const st=[];for(let Pe=0;Pe<Xe.length;Pe++){const Te=Xe[Pe];Te&&(T.o(Te)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:Te.title,command:this.h.toInternal(Te,it)})):(Be.only&&(Te.kind?Be.only.contains(Te.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ye,Pe],title:Te.title,command:Te.command&&this.h.toInternal(Te.command,it),diagnostics:Te.diagnostics&&Te.diagnostics.map(g.Diagnostic.from),edit:Te.edit&&g.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,isAI:(0,t.$RF)(this.m,"codeActionAI")?Te.isAI:!1,disabled:Te.disabled?.reason})))}return{cacheId:Ye,actions:st}}async resolveCodeAction(B,_){const[se,K]=B,ae=this.e.get(se,K);if(!ae||T.o(ae))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(ae,_)??ae;let Ae;de.edit&&(Ae=g.WorkspaceEdit.from(de.edit,void 0));let Be;if(de.command){const Xe=this.f.get(se);Xe&&(Be=this.h.toInternal(de.command,Xe))}return{edit:Ae,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class F{static toInternalProviderId(B,_){return B+"."+_}constructor(B,_,se,K,ae){this.d=B,this.e=_,this.f=se,this.g=K,this.h=ae}async prepareDocumentPaste(B,_,se,K){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(B),de=_.map(Xe=>g.Range.to(Xe)),Ae=g.DataTransfer.toDataTransfer(se,()=>{throw new o.$$});if(await this.f.prepareDocumentPaste(ae,de,Ae,K),K.isCancellationRequested)return;const Be=Array.from(Ae).filter(([,Xe])=>!(Xe instanceof P.$wL));return g.DataTransfer.from(Be)}async providePasteEdits(B,_,se,K,ae){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(_),Ae=se.map(Ye=>g.Range.to(Ye)),Be=g.DataTransfer.toDataTransfer(K,async Ye=>(await this.d.$resolvePasteFileData(this.g,B,Ye)).buffer),Xe=await this.f.provideDocumentPasteEdits(de,Ae,Be,ae);if(Xe)return{label:Xe.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Xe.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:F.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Xe.insertText=="string"?Xe.insertText:{snippet:Xe.insertText.value},additionalEdit:Xe.additionalEdit?g.WorkspaceEdit.from(Xe.additionalEdit,void 0):void 0}}}class W{constructor(B,_){this.d=B,this.e=_}async provideDocumentFormattingEdits(B,_,se){const K=this.d.getDocument(B),ae=await this.e.provideDocumentFormattingEdits(K,_,se);if(Array.isArray(ae))return ae.map(g.TextEdit.from)}}class Y{constructor(B,_){this.d=B,this.e=_}async provideDocumentRangeFormattingEdits(B,_,se,K){const ae=this.d.getDocument(B),de=g.Range.to(_),Ae=await this.e.provideDocumentRangeFormattingEdits(ae,de,se,K);if(Array.isArray(Ae))return Ae.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,_,se,K){(0,C.$Nf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(B),de=_.map(g.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ae,de,se,K);if(Array.isArray(Ae))return Ae.map(g.TextEdit.from)}}class le{constructor(B,_){this.d=B,this.e=_,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,_,se,K,ae){const de=this.d.getDocument(B),Ae=g.Position.to(_),Be=await this.e.provideOnTypeFormattingEdits(de,Ae,se,K,ae);if(Array.isArray(Be))return Be.map(g.TextEdit.from)}}class Q{constructor(B,_){this.e=B,this.f=_,this.d=new i.$Nec("WorkspaceSymbols")}async provideWorkspaceSymbols(B,_){const se=await this.e.provideWorkspaceSymbols(B,_);if(!(0,R.$Lb)(se))return{symbols:[]};const K=this.d.add(se),ae={cacheId:K,symbols:[]};for(let de=0;de<se.length;de++){const Ae=se[de];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ae.symbols.push({...g.WorkspaceSymbol.from(Ae),cacheId:[K,de]})}return ae}async resolveWorkspaceSymbol(B,_){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const K=await this.e.resolveWorkspaceSymbol(se,_);return K&&(0,O.$in)(B,g.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Z{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,_,se){this.d=B,this.e=_,this.f=se}async provideRenameEdits(B,_,se,K){const ae=this.d.getDocument(B),de=g.Position.to(_);try{const Ae=await this.e.provideRenameEdits(ae,de,se,K);return Ae?g.WorkspaceEdit.from(Ae):void 0}catch(Ae){const Be=Z.g(Ae);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(B,_,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(B),ae=g.Position.to(_);try{const de=await this.e.prepareRename(K,ae,se);let Ae,Be;if(P.$JK.isRange(de)?(Ae=de,Be=K.getText(de)):(0,C.$Ff)(de)&&(Ae=de.range,Be=de.placeholder),!Ae||!Be)return;if(Ae.start.line>ae.line||Ae.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Ae),text:Be}}catch(de){const Ae=Z.g(de);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class x{constructor(B,_){this.resultId=B,this.tokens=_}}class oe{constructor(B,_){this.f=B,this.g=_,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,_,se){const K=this.f.getDocument(B),ae=_!==0?this.d.get(_):null;let de=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,ae.resultId,se):await this.g.provideDocumentSemanticTokens(K,se);return ae&&this.d.delete(_),de?(de=oe.h(de),this.o(oe.n(ae,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return oe.j(B)?oe.k(B)?B:new P.$ZL(new Uint32Array(B.data),B.resultId):oe.l(B)?oe.m(B)?B:new P.$2L(B.edits.map(_=>new P.$1L(_.start,_.deleteCount,_.data?new Uint32Array(_.data):_.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const _ of B.edits)if(!(_.data instanceof Uint32Array))return!1;return!0}static n(B,_){if(!oe.j(_)||!B||!B.tokens)return _;const se=B.tokens,K=se.length,ae=_.data,de=ae.length;let Ae=0;const Be=Math.min(K,de);for(;Ae<Be&&se[Ae]===ae[Ae];)Ae++;if(Ae===K&&Ae===de)return new P.$2L([],_.resultId);let Xe=0;const Ye=Be-Ae;for(;Xe<Ye&&se[K-Xe-1]===ae[de-Xe-1];)Xe++;return new P.$2L([{start:Ae,deleteCount:K-Ae-Xe,data:ae.subarray(Ae,de-Xe)}],_.resultId)}o(B,_){if(oe.j(B)){const se=this.e++;return this.d.set(se,new x(B.resultId,B.data)),(0,d.$_0)({id:se,type:"full",data:B.data})}if(oe.l(B)){const se=this.e++;return oe.j(_)?this.d.set(se,new x(_.resultId,_.data)):this.d.set(se,new x(B.resultId)),(0,d.$_0)({id:se,type:"delta",deltas:(B.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class X{constructor(B,_){this.d=B,this.e=_}async provideDocumentRangeSemanticTokens(B,_,se){const K=this.d.getDocument(B),ae=await this.e.provideDocumentRangeSemanticTokens(K,g.Range.to(_),se);return ae?this.f(ae):null}f(B){return(0,d.$_0)({id:0,type:"full",data:B.data})}}class ve{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,_,se,K,ae){this.f=B,this.g=_,this.h=se,this.j=K,this.k=ae,this.d=new i.$Nec("CompletionItem"),this.e=new Map}async provideCompletionItems(B,_,se,K){const ae=this.f.getDocument(B),de=g.Position.to(_),Ae=ae.getWordRangeAtPosition(de)||new P.$JK(de,de),Be=Ae.with({end:de}),Xe=new n.$Od,Ye=await this.h.provideCompletionItems(ae,de,K,g.CompletionContext.to(se));if(!Ye||K.isCancellationRequested)return;const it=Array.isArray(Ye)?new P.$dL(Ye):Ye,st=ve.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),Pe=new f.$Rc;this.e.set(st,Pe);const Te=[],qe={x:st,b:Te,a:{replace:g.Range.from(Ae),insert:g.Range.from(Be)},c:it.isIncomplete||void 0,d:Xe.elapsed()};for(let Re=0;Re<it.items.length;Re++){const xe=it.items[Re],he=this.l(xe,[st,Re],Be,Ae);Te.push(he)}return qe}async resolveCompletionItem(B,_){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const K=this.l(se,B),ae=await this.h.resolveCompletionItem(se,_);if(!ae)return;const de=this.l(ae,B);return(K.h!==de.h||K.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==de.n||K.o!==de.o||!(0,O.$jn)(K.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,_,se,K){const ae=this.e.get(_[0]);if(!ae)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,ae),Ae={x:_,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=B.textEdit.newText):typeof B.insertText=="string"?Ae.h=B.insertText:B.insertText instanceof P.$SK&&(Ae.h=B.insertText.value,Ae.i|=4);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),P.$JK.isRange(Be)?Ae.j=g.Range.from(Be):Be&&(!se?.isEqual(Be.inserting)||!K?.isEqual(Be.replacing))&&(Ae.j={insert:g.Range.from(Be.inserting),replace:g.Range.from(Be.replacing)}),Ae}}class ge{async provideInlineCompletions(B,_,se,K){}disposeCompletions(B){}handleDidShowCompletionItem(B,_,se){}handlePartialAccept(B,_,se){}}class H extends ge{constructor(B,_,se,K){super(),this.f=B,this.g=_,this.h=se,this.j=K,this.d=new U,this.e=(0,t.$RF)(this.f,"inlineCompletionsAdditions"),this.k={[M.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[M.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$RF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,_,se,K){const ae=this.g.getDocument(B),de=g.Position.to(_),Ae=await this.h.provideInlineCompletionItems(ae,de,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:g.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},K);if(!Ae||K.isCancellationRequested)return;const Be=Array.isArray(Ae)?Ae:Ae.items,Xe=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],Ye=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Be}),items:Be.map((Pe,Te)=>{let qe;Pe.command&&(it||(it=new f.$Rc),qe=this.j.toInternal(Pe.command,it));const Re=Pe.insertText;return{insertText:typeof Re=="string"?Re:{snippet:Re.value},filterText:Pe.filterText,range:Pe.range?g.Range.from(Pe.range):void 0,command:qe,idx:Te,completeBracketPairs:this.e?Pe.completeBracketPairs:!1}}),commands:Xe.map(Pe=>(it||(it=new f.$Rc),this.j.toInternal(Pe,it))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,_,se){const K=this.d.get(B)?.items[_];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,se)}handlePartialAccept(B,_,se){const K=this.d.get(B)?.items[_];K&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(K,se)}}class U{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const _=this.e++;return this.d.set(_,B),_}disposeReferenceId(B){const _=this.d.get(B);return this.d.delete(B),_}get(B){return this.d.get(B)}}class ne{constructor(B,_){this.e=B,this.f=_,this.d=new i.$Nec("SignatureHelp")}async provideSignatureHelp(B,_,se,K){const ae=this.e.getDocument(B),de=g.Position.to(_),Ae=this.g(se),Be=await this.f.provideSignatureHelp(ae,de,K,Ae);if(Be){const Xe=this.d.add([Be]);return{...g.SignatureHelp.from(Be),id:Xe}}}g(B){let _;if(B.activeSignatureHelp){const se=g.SignatureHelp.to(B.activeSignatureHelp),K=this.d.get(B.activeSignatureHelp.id,0);K?(_=K,_.activeSignature=se.activeSignature,_.activeParameter=se.activeParameter):_=se}return{...B,activeSignatureHelp:_}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,_,se,K,ae){this.f=B,this.g=_,this.h=se,this.j=K,this.k=ae,this.d=new i.$Nec("InlayHints"),this.e=new Map}async provideInlayHints(B,_,se){const K=this.f.getDocument(B),ae=g.Range.to(_),de=await this.h.provideInlayHints(K,ae,se);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(_)}`);return}if(se.isCancellationRequested)return;const Ae=this.d.add(de);this.e.set(Ae,new f.$Rc);const Be={hints:[],cacheId:Ae};for(let Xe=0;Xe<de.length;Xe++)this.l(de[Xe],ae)&&Be.hints.push(this.m(de[Xe],[Ae,Xe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(_)}`),Be}async resolveInlayHint(B,_){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const K=await this.h.resolveInlayHint(se,_);if(K&&this.l(K))return this.m(K,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,_){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(_&&!_.contains(B.position))}m(B,_){const se=this.e.get(_[0]);if(!se)throw Error("DisposableStore is missing...");const K={label:"",cacheId:_,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?K.label=B.label:K.label=B.label.map(ae=>{const de={label:ae.value};return de.tooltip=g.MarkdownString.fromStrict(ae.tooltip),P.$TK.isLocation(ae.location)&&(de.location=g.location.from(ae.location)),ae.command&&(de.command=this.g.toInternal(ae.command,se)),de}),K}}class fe{constructor(B,_){this.e=B,this.f=_,this.d=new i.$Nec("DocumentLink")}async provideLinks(B,_){const se=this.e.getDocument(B),K=await this.f.provideDocumentLinks(se,_);if(!(!Array.isArray(K)||K.length===0)&&!_.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(fe.g).map(g.DocumentLink.from)};{const ae=this.d.add(K),de={links:[],cacheId:ae};for(let Ae=0;Ae<K.length;Ae++){if(!fe.g(K[Ae]))continue;const Be=g.DocumentLink.from(K[Ae]);Be.cacheId=[ae,Ae],de.links.push(Be)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,_){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const K=await this.f.resolveDocumentLink(se,_);if(!(!K||!fe.g(K)))return g.DocumentLink.from(K)}releaseLinks(B){this.d.delete(B)}}class me{constructor(B,_){this.d=B,this.e=_}async provideColors(B,_){const se=this.d.getDocument(B),K=await this.e.provideDocumentColors(se,_);return Array.isArray(K)?K.map(de=>({color:g.Color.from(de.color),range:g.Range.from(de.range)})):[]}async provideColorPresentations(B,_,se){const K=this.d.getDocument(B),ae=g.Range.to(_.range),de=g.Color.to(_.color),Ae=await this.e.provideColorPresentations(de,{document:K,range:ae},se);if(Array.isArray(Ae))return Ae.map(g.ColorPresentation.from)}}class ee{constructor(B,_){this.d=B,this.e=_}async provideFoldingRanges(B,_,se){const K=this.d.getDocument(B),ae=await this.e.provideFoldingRanges(K,_,se);if(Array.isArray(ae))return ae.map(g.FoldingRange.from)}}class ie{constructor(B,_,se){this.d=B,this.e=_,this.f=se}async provideSelectionRanges(B,_,se){const K=this.d.getDocument(B),ae=_.map(g.Position.to),de=await this.e.provideSelectionRanges(K,ae,se);if(!(0,R.$Lb)(de))return[];if(de.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let Be=0;Be<ae.length;Be++){const Xe=[];Ae.push(Xe);let Ye=ae[Be],it=de[Be];for(;;){if(!it.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(g.SelectionRange.from(it)),!it.parent)break;Ye=it.range,it=it.parent}}return Ae}}class G{constructor(B,_){this.f=B,this.g=_,this.d=new s.$OM(""),this.e=new Map}async prepareSession(B,_,se){const K=this.f.getDocument(B),ae=g.Position.to(_),de=await this.g.prepareCallHierarchy(K,ae,se);if(!de)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(de)?de.map(Be=>this.h(Ae,Be)):[this.h(Ae,de)]}async provideCallsTo(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(K,se);if(ae)return ae.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(Ae=>g.Range.from(Ae))}))}async provideCallsFrom(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(K,se);if(ae)return ae.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(Ae=>g.Range.from(Ae))}))}releaseSession(B){this.e.delete(B)}h(B,_){const se=this.e.get(B),K=g.CallHierarchyItem.from(_,B,se.size.toString(36));return se.set(K._itemId,_),K}j(B,_){return this.e.get(B)?.get(_)}}class te{constructor(B,_){this.f=B,this.g=_,this.d=new s.$OM(""),this.e=new Map}async prepareSession(B,_,se){const K=this.f.getDocument(B),ae=g.Position.to(_),de=await this.g.prepareTypeHierarchy(K,ae,se);if(!de)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(de)?de.map(Be=>this.h(Ae,Be)):[this.h(Ae,de)]}async provideSupertypes(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(K,se);if(ae)return ae.map(de=>this.h(B,de))}async provideSubtypes(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(K,se);if(ae)return ae.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,_){const se=this.e.get(B),K=g.TypeHierarchyItem.from(_,B,se.size.toString(36));return se.set(K._itemId,_),K}j(B,_){return this.e.get(B)?.get(_)}}class J{static toInternalProviderId(B,_){return B+"."+_}constructor(B,_,se,K,ae){this.d=B,this.e=_,this.f=se,this.g=K,this.h=ae}async provideDocumentOnDropEdits(B,_,se,K,ae){const de=this.e.getDocument(_),Ae=g.Position.to(se),Be=g.DataTransfer.toDataTransfer(K,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Ye)).buffer),Xe=await this.f.provideDocumentDropEdits(de,Ae,Be,ae);if(Xe)return{label:Xe.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Xe.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:J.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Xe.insertText=="string"?Xe.insertText:{snippet:Xe.insertText.value},additionalEdit:Xe.additionalEdit?g.WorkspaceEdit.from(Xe.additionalEdit,void 0):void 0}}}class ce{constructor(B,_){this.d=B,this.e=_}async provideMappedEdits(B,_,se,K){const ae=D.URI.revive(B),de=this.d.getDocument(ae),Ae=se.documents.map(Ye=>Ye.map(it=>({uri:D.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(st=>g.Range.to(st))}))),Be={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(de,_,Be,K);return Xe?g.WorkspaceEdit.from(Xe):null}}class be{constructor(B,_){this.adapter=B,this.extension=_}}class Ie{static{this.d=0}constructor(B,_,se,K,ae,de,Ae,Be){this.g=_,this.h=se,this.j=K,this.k=ae,this.l=de,this.m=Ae,this.n=Be,this.f=new Map,this.e=B.getProxy(b.$FK.MainThreadLanguageFeatures)}o(B,_){return g.DocumentSelector.from(B,this.g,_)}p(B){return new P.$HK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Ie.d++}async s(B,_,se,K,ae,de=!1){const Ae=this.f.get(B);if(!Ae||!(Ae.adapter instanceof _))return K;const Be=Date.now();de||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const Xe=se(Ae.adapter,Ae.extension);return Promise.resolve(Xe).catch(Ye=>{(0,o.$4)(Ye)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Ae.extension.identifier,Ye))}).finally(()=>{de||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),v.CancellationToken.isCancellationToken(ae)?(0,a.$Qg)(Xe,ae):Xe}t(B,_){const se=this.q();return this.f.set(se,new be(B,_)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,_,se,K){const ae=this.t(new h(this.h,se),B),de=K&&K.label||Ie.u(B);return this.e.$registerDocumentSymbolProvider(ae,this.o(_,B),de),this.p(ae)}$provideDocumentSymbols(B,_,se){return this.s(B,h,K=>K.provideDocumentSymbols(D.URI.revive(_),se),void 0,se)}registerCodeLensProvider(B,_,se){const K=this.q(),ae=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new be(new u(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(K,this.o(_,B),ae);let de=this.p(K);if(ae!==void 0){const Ae=se.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ae));de=P.$HK.from(de,Ae)}return de}$provideCodeLenses(B,_,se){return this.s(B,u,K=>K.provideCodeLenses(D.URI.revive(_),se),void 0,se)}$resolveCodeLens(B,_,se){return this.s(B,u,K=>K.resolveCodeLens(_,se),void 0,void 0)}$releaseCodeLenses(B,_){this.s(B,u,se=>Promise.resolve(se.releaseCodeLenses(_)),void 0,void 0)}registerDefinitionProvider(B,_,se){const K=this.t(new l(this.h,se),B);return this.e.$registerDefinitionSupport(K,this.o(_,B)),this.p(K)}$provideDefinition(B,_,se,K){return this.s(B,l,ae=>ae.provideDefinition(D.URI.revive(_),se,K),[],K)}registerDeclarationProvider(B,_,se){const K=this.t(new S(this.h,se),B);return this.e.$registerDeclarationSupport(K,this.o(_,B)),this.p(K)}$provideDeclaration(B,_,se,K){return this.s(B,S,ae=>ae.provideDeclaration(D.URI.revive(_),se,K),[],K)}registerImplementationProvider(B,_,se){const K=this.t(new L(this.h,se),B);return this.e.$registerImplementationSupport(K,this.o(_,B)),this.p(K)}$provideImplementation(B,_,se,K){return this.s(B,L,ae=>ae.provideImplementation(D.URI.revive(_),se,K),[],K)}registerTypeDefinitionProvider(B,_,se){const K=this.t(new w(this.h,se),B);return this.e.$registerTypeDefinitionSupport(K,this.o(_,B)),this.p(K)}$provideTypeDefinition(B,_,se,K){return this.s(B,w,ae=>ae.provideTypeDefinition(D.URI.revive(_),se,K),[],K)}registerHoverProvider(B,_,se,K){const ae=this.t(new p(this.h,se),B);return this.e.$registerHoverProvider(ae,this.o(_,B)),this.p(ae)}$provideHover(B,_,se,K){return this.s(B,p,ae=>ae.provideHover(D.URI.revive(_),se,K),void 0,K)}registerEvaluatableExpressionProvider(B,_,se,K){const ae=this.t(new E(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(_,B)),this.p(ae)}$provideEvaluatableExpression(B,_,se,K){return this.s(B,E,ae=>ae.provideEvaluatableExpression(D.URI.revive(_),se,K),void 0,K)}registerInlineValuesProvider(B,_,se,K){const ae=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new A(this.h,se),B);this.e.$registerInlineValuesProvider(de,this.o(_,B),ae);let Ae=this.p(de);if(ae!==void 0){const Be=se.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(ae));Ae=P.$HK.from(Ae,Be)}return Ae}$provideInlineValues(B,_,se,K,ae){return this.s(B,A,de=>de.provideInlineValues(D.URI.revive(_),se,K,ae),void 0,ae)}registerDocumentHighlightProvider(B,_,se){const K=this.t(new z(this.h,se),B);return this.e.$registerDocumentHighlightProvider(K,this.o(_,B)),this.p(K)}registerMultiDocumentHighlightProvider(B,_,se){const K=this.t(new N(this.h,se),B);return this.e.$registerMultiDocumentHighlightProvider(K,this.o(_,B)),this.p(K)}$provideDocumentHighlights(B,_,se,K){return this.s(B,z,ae=>ae.provideDocumentHighlights(D.URI.revive(_),se,K),void 0,K)}$provideMultiDocumentHighlights(B,_,se,K,ae){return this.s(B,N,de=>de.provideMultiDocumentHighlights(D.URI.revive(_),se,K.map(Ae=>D.URI.revive(Ae)),ae),void 0,ae)}registerLinkedEditingRangeProvider(B,_,se){const K=this.t(new I(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(K,this.o(_,B)),this.p(K)}$provideLinkedEditingRanges(B,_,se,K){return this.s(B,I,async ae=>{const de=await ae.provideLinkedEditingRanges(D.URI.revive(_),se,K);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Ie.w(de.wordPattern):void 0}},void 0,K)}registerReferenceProvider(B,_,se){const K=this.t(new j(this.h,se),B);return this.e.$registerReferenceSupport(K,this.o(_,B)),this.p(K)}$provideReferences(B,_,se,K,ae){return this.s(B,j,de=>de.provideReferences(D.URI.revive(_),se,K,ae),void 0,ae)}registerCodeActionProvider(B,_,se,K){const ae=new f.$Rc,de=this.t(new T(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(_,B),{providedKinds:K?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:K?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ae)}))},Ie.u(B),!!se.resolveCodeAction),ae.add(this.p(de)),ae}$provideCodeActions(B,_,se,K,ae){return this.s(B,T,de=>de.provideCodeActions(D.URI.revive(_),se,K,ae),void 0,ae)}$resolveCodeAction(B,_,se){return this.s(B,T,K=>K.resolveCodeAction(_,se),{},void 0)}$releaseCodeActions(B,_){this.s(B,T,se=>Promise.resolve(se.releaseCodeActions(_)),void 0,void 0)}registerDocumentFormattingEditProvider(B,_,se){const K=this.t(new W(this.h,se),B);return this.e.$registerDocumentFormattingSupport(K,this.o(_,B),B.identifier,B.displayName||B.name),this.p(K)}$provideDocumentFormattingEdits(B,_,se,K){return this.s(B,W,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(_),se,K),void 0,K)}registerDocumentRangeFormattingEditProvider(B,_,se){const K=typeof se.provideDocumentRangesFormattingEdits=="function",ae=this.t(new Y(this.h,se),B);return this.e.$registerRangeFormattingSupport(ae,this.o(_,B),B.identifier,B.displayName||B.name,K),this.p(ae)}$provideDocumentRangeFormattingEdits(B,_,se,K,ae){return this.s(B,Y,de=>de.provideDocumentRangeFormattingEdits(D.URI.revive(_),se,K,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(B,_,se,K,ae){return this.s(B,Y,de=>de.provideDocumentRangesFormattingEdits(D.URI.revive(_),se,K,ae),void 0,ae)}registerOnTypeFormattingEditProvider(B,_,se,K){const ae=this.t(new le(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(ae,this.o(_,B),K,B.identifier),this.p(ae)}$provideOnTypeFormattingEdits(B,_,se,K,ae,de){return this.s(B,le,Ae=>Ae.provideOnTypeFormattingEdits(D.URI.revive(_),se,K,ae,de),void 0,de)}registerWorkspaceSymbolProvider(B,_){const se=this.t(new Q(_,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof _.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,_,se){return this.s(B,Q,K=>K.provideWorkspaceSymbols(_,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,_,se){return this.s(B,Q,K=>K.resolveWorkspaceSymbol(_,se),void 0,void 0)}$releaseWorkspaceSymbols(B,_){this.s(B,Q,se=>se.releaseWorkspaceSymbols(_),void 0,void 0)}registerRenameProvider(B,_,se){const K=this.t(new Z(this.h,se,this.l),B);return this.e.$registerRenameSupport(K,this.o(_,B),Z.supportsResolving(se)),this.p(K)}$provideRenameEdits(B,_,se,K,ae){return this.s(B,Z,de=>de.provideRenameEdits(D.URI.revive(_),se,K,ae),void 0,ae)}$resolveRenameLocation(B,_,se,K){return this.s(B,Z,ae=>ae.resolveRenameLocation(D.URI.revive(_),se,K),void 0,K)}registerDocumentSemanticTokensProvider(B,_,se,K){const ae=this.t(new oe(this.h,se),B),de=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(_,B),K,de);let Ae=this.p(ae);if(de){const Be=se.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(de));Ae=P.$HK.from(Ae,Be)}return Ae}$provideDocumentSemanticTokens(B,_,se,K){return this.s(B,oe,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(_),se,K),null,K)}$releaseDocumentSemanticTokens(B,_){this.s(B,oe,se=>se.releaseDocumentSemanticColoring(_),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,_,se,K){const ae=this.t(new X(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(_,B),K),this.p(ae)}$provideDocumentRangeSemanticTokens(B,_,se,K){return this.s(B,X,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(_),se,K),null,K)}registerCompletionItemProvider(B,_,se,K){const ae=this.t(new ve(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(ae,this.o(_,B),K,ve.supportsResolving(se),B.identifier),this.p(ae)}$provideCompletionItems(B,_,se,K,ae){return this.s(B,ve,de=>de.provideCompletionItems(D.URI.revive(_),se,K,ae),void 0,ae)}$resolveCompletionItem(B,_,se){return this.s(B,ve,K=>K.resolveCompletionItem(_,se),void 0,se)}$releaseCompletionItems(B,_){this.s(B,ve,se=>se.releaseCompletionItems(_),void 0,void 0)}registerInlineCompletionsProvider(B,_,se,K){const ae=new H(B,this.h,se,this.j.converter),de=this.t(ae,B);return this.e.$registerInlineCompletionsSupport(de,this.o(_,B),ae.supportsHandleEvents,k.$em.toKey(B.identifier.value),K?.yieldTo?.map(Ae=>k.$em.toKey(Ae))||[]),this.p(de)}$provideInlineCompletions(B,_,se,K,ae){return this.s(B,ge,de=>de.provideInlineCompletions(D.URI.revive(_),se,K,ae),void 0,ae)}$handleInlineCompletionDidShow(B,_,se,K){this.s(B,ge,async ae=>{ae.handleDidShowCompletionItem(_,se,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,_,se,K){this.s(B,ge,async ae=>{ae.handlePartialAccept(_,se,K)},void 0,void 0)}$freeInlineCompletionsList(B,_){this.s(B,ge,async se=>{se.disposeCompletions(_)},void 0,void 0)}registerSignatureHelpProvider(B,_,se,K){const ae=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,de=this.t(new ne(this.h,se),B);return this.e.$registerSignatureHelpProvider(de,this.o(_,B),ae),this.p(de)}$provideSignatureHelp(B,_,se,K,ae){return this.s(B,ne,de=>de.provideSignatureHelp(D.URI.revive(_),se,K,ae),void 0,ae)}$releaseSignatureHelp(B,_){this.s(B,ne,se=>se.releaseSignatureHelp(_),void 0,void 0)}registerInlayHintsProvider(B,_,se){const K=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(ae,this.o(_,B),typeof se.resolveInlayHint=="function",K,Ie.u(B));let de=this.p(ae);if(K!==void 0){const Ae=se.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(K));de=P.$HK.from(de,Ae)}return de}$provideInlayHints(B,_,se,K){return this.s(B,ye,ae=>ae.provideInlayHints(D.URI.revive(_),se,K),void 0,K)}$resolveInlayHint(B,_,se){return this.s(B,ye,K=>K.resolveInlayHint(_,se),void 0,se)}$releaseInlayHints(B,_){this.s(B,ye,se=>se.releaseHints(_),void 0,void 0)}registerDocumentLinkProvider(B,_,se){const K=this.t(new fe(this.h,se),B);return this.e.$registerDocumentLinkProvider(K,this.o(_,B),typeof se.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(B,_,se){return this.s(B,fe,K=>K.provideLinks(D.URI.revive(_),se),void 0,se,_.scheme==="output")}$resolveDocumentLink(B,_,se){return this.s(B,fe,K=>K.resolveLink(_,se),void 0,void 0,!0)}$releaseDocumentLinks(B,_){this.s(B,fe,se=>se.releaseLinks(_),void 0,void 0,!0)}registerColorProvider(B,_,se){const K=this.t(new me(this.h,se),B);return this.e.$registerDocumentColorProvider(K,this.o(_,B)),this.p(K)}$provideDocumentColors(B,_,se){return this.s(B,me,K=>K.provideColors(D.URI.revive(_),se),[],se)}$provideColorPresentations(B,_,se,K){return this.s(B,me,ae=>ae.provideColorPresentations(D.URI.revive(_),se,K),void 0,K)}registerFoldingRangeProvider(B,_,se){const K=this.q(),ae=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new be(new ee(this.h,se),B)),this.e.$registerFoldingRangeProvider(K,this.o(_,B),B.identifier,ae);let de=this.p(K);if(ae!==void 0){const Ae=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));de=P.$HK.from(de,Ae)}return de}$provideFoldingRanges(B,_,se,K){return this.s(B,ee,ae=>ae.provideFoldingRanges(D.URI.revive(_),se,K),void 0,K)}registerSelectionRangeProvider(B,_,se){const K=this.t(new ie(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(K,this.o(_,B)),this.p(K)}$provideSelectionRanges(B,_,se,K){return this.s(B,ie,ae=>ae.provideSelectionRanges(D.URI.revive(_),se,K),[],K)}registerCallHierarchyProvider(B,_,se){const K=this.t(new G(this.h,se),B);return this.e.$registerCallHierarchyProvider(K,this.o(_,B)),this.p(K)}$prepareCallHierarchy(B,_,se,K){return this.s(B,G,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(_),se,K)),void 0,K)}$provideCallHierarchyIncomingCalls(B,_,se,K){return this.s(B,G,ae=>ae.provideCallsTo(_,se,K),void 0,K)}$provideCallHierarchyOutgoingCalls(B,_,se,K){return this.s(B,G,ae=>ae.provideCallsFrom(_,se,K),void 0,K)}$releaseCallHierarchy(B,_){this.s(B,G,se=>Promise.resolve(se.releaseSession(_)),void 0,void 0)}registerTypeHierarchyProvider(B,_,se){const K=this.t(new te(this.h,se),B);return this.e.$registerTypeHierarchyProvider(K,this.o(_,B)),this.p(K)}$prepareTypeHierarchy(B,_,se,K){return this.s(B,te,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(_),se,K)),void 0,K)}$provideTypeHierarchySupertypes(B,_,se,K){return this.s(B,te,ae=>ae.provideSupertypes(_,se,K),void 0,K)}$provideTypeHierarchySubtypes(B,_,se,K){return this.s(B,te,ae=>ae.provideSubtypes(_,se,K),void 0,K)}$releaseTypeHierarchy(B,_){this.s(B,te,se=>Promise.resolve(se.releaseSession(_)),void 0,void 0)}registerDocumentOnDropEditProvider(B,_,se,K){const ae=this.q();this.f.set(ae,new be(new J(this.e,this.h,se,ae,B),B));const de=(0,t.$RF)(B,"dropMetadata")&&K?J.toInternalProviderId(B.identifier.value,K.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(_,B),de,(0,t.$RF)(B,"dropMetadata")?K:void 0),this.p(ae)}$provideDocumentOnDropEdits(B,_,se,K,ae,de){return this.s(B,J,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(_,D.URI.revive(se),K,ae,de)),void 0,void 0)}registerMappedEditsProvider(B,_,se){const K=this.t(new ce(this.h,se),B);return this.e.$registerMappedEditsProvider(K,this.o(_,B)),this.p(K)}$provideMappedEdits(B,_,se,K,ae){return this.s(B,ce,de=>Promise.resolve(de.provideMappedEdits(_,se,K,ae)),null,ae)}registerDocumentPasteEditProvider(B,_,se,K){const ae=this.q();this.f.set(ae,new be(new F(this.e,this.h,se,ae,B),B));const de=F.toInternalProviderId(B.identifier.value,K.id);return this.e.$registerPasteEditProvider(ae,this.o(_,B),de,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(B,_,se,K,ae){return this.s(B,F,de=>de.prepareDocumentPaste(D.URI.revive(_),se,K,ae),void 0,ae)}$providePasteEdits(B,_,se,K,ae,de){return this.s(B,F,Ae=>Ae.providePasteEdits(_,D.URI.revive(se),K,ae,de),void 0,de)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Ie.w(B.decreaseIndentPattern),increaseIndentPattern:Ie.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ie.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ie.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Ie.w(B.beforeText),afterText:B.afterText?Ie.w(B.afterText):void 0,previousLineText:B.previousLineText?Ie.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Ie.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(_=>P.SyntaxTokenType.toString(_)):void 0}}static D(B){return B.map(Ie.C)}setLanguageConfiguration(B,_,se){const{wordPattern:K}=se;if(K&&(0,$.$Te)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(_,K):this.h.setWordDefinitionFor(_,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ae=this.q(),de={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?Ie.w(se.wordPattern):void 0,indentationRules:se.indentationRules?Ie.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?Ie.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?Ie.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,_,de),this.p(ae)}$setWordDefinitions(B){for(const _ of B)this.h.setWordDefinitionFor(_.languageId,new RegExp(_.regexSource,_.regexFlags))}}e.$Xec=Ie}),define(Se[327],ke([1,0,6,15,7,39,12,3,25]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class y{constructor(C,m,v,k){this.c=m,this.d=v,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$FK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,m){const v=C.version,k=O.Position.from(m),f=await this.a.$tokensAtPosition(C.uri,k),d={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$JK(m.line,m.character,m.line,m.character)};if(!f)return d;const s={range:O.Range.to(f.range),type:O.TokenType.to(f.type)};return!s.range.contains(m)||v!==C.version?d:s}createLanguageStatusItem(C,m,v){const k=this.f++,f=this.a,d=this.g,s=`${C.identifier.value}/${m}`;if(d.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);d.add(s);const i={selector:v,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new b.$Rc,a=()=>{if(n?.dispose(),!d.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,M.$3g)(()=>{o.clear(),this.a.$setLanguageStatus(k,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?P.default.Error:i.severity===g.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),f.$removeLanguageStatus(k),d.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,$.$SF)(C,"languageStatusText"),i.text=r,a()},get text2(){return(0,$.$SF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$kgc=y}),define(Se[115],ke([1,0,11,13,2,5,14,6,27,20]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;let R=class{constructor(m,v,k){this.f=k,this.d=new Map,this.a=v.getProxy(b.$FK.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,v){const{message:k,args:f,comment:d}=v;if(this.c)return(0,O.$Ie)(k,f??{});let s=k;d&&d.length>0&&(s+=`/${Array.isArray(d)?d.join(""):d}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,O.$Ie)(i??k,f??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const k=await this.g(m);if(!k){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(k),d=JSON.parse(f);v=m.isBuiltin?d.contents?.bundle:d}catch(f){this.f.error(`Failed to load translations for ${m.identifier.value} from ${k}: ${f.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:k})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(v)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ifc=R,e.$Ifc=R=Ge([We(0,$.$ZM),We(1,y.$JM),We(2,M.$ij)],R),e.$Jfc=(0,P.$1h)("IExtHostLocalizationService")}),define(Se[150],ke([1,0,14,6,27,20,2,54]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;let $=class extends D.$tj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(v=>(0,b.$xh)(v))),this.r=C.getProxy(O.$FK.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(M.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,v){return new y(this.r,C,m,v)}};e.$Vgc=$,e.$Vgc=$=Ge([We(0,P.$JM),We(1,g.$ZM)],$);class y extends D.$oj{constructor(C,m,v,k){super(k?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(m,k).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const v=[[C,m]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[116],ke([1,0,6,5,3,20,22]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=void 0,e.$Kfc=(0,O.$1h)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$FK.MainThreadManagedSockets)}setFactory(C,m){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,v=await this.c.makeConnection(),k=new g.$Rc;return this.d.set(m,new y(m,v,k)),k.add((0,g.$Qc)(()=>this.d.delete(m))),k.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),k.dispose()})),k.add(v.onDidClose(f=>{this.a.$onDidManagedSocketClose(m,f?.stack??f?.message),k.dispose()})),k.add(v.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(m,M.$ge.wrap(f)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Lfc=b,e.$Lfc=b=Ge([We(0,P.$JM)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Sc{constructor(C,m,v){super(),this.socketId=C,this.actual=m,this.B(v)}}}),define(Se[328],ke([1,0,6,14,25]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;function P(b){return b&&b.title}let M=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$FK.MainThreadMessageService)}showMessage($,y,R,C,m){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let k;typeof C=="string"||P(C)?k=[C,...m]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,k=m),v.useCustom&&(0,g.$SF)($,"resolvers");const f=[];for(let d=0;d<k.length;d++){const s=k[d];if(typeof s=="string")f.push({title:s,handle:d,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;f.push({title:i,isCloseAffordance:!!n,handle:d})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(y,R,v,f).then(d=>{if(typeof d=="number")return k[d]})}};e.$lgc=M,e.$lgc=M=Ge([We(1,O.$ij)],M)}),define(Se[329],ke([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,285,25,68]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;let n=class{constructor(l,S,L,w,p){this.m=S,this.n=L,this.o=w,this.q=p,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(C.$FK.MainThreadNotebookKernels);const E=new m.$0M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$8M("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const z=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:z}}else if(A&&"notebookEditor"in A){const z=this.n.getIdByEditor(A.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return A})],m.$9M.Void);this.o.registerApiCommand(E)}createNotebookController(l,S,L,w,p,E){for(const X of this.j.values())if(X.controller.id===S&&y.$em.equals(l.identifier,X.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const A=this.k++,z=this;this.q.trace(`NotebookController[${A}], CREATED by ${l.identifier.value}, ${S}`);const N=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${l.identifier}'`);let I=!1;const j=new P.$Sd,T=new P.$Sd,F={id:u(l.identifier,S),notebookType:L,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:w||l.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let W=p??N,Y,le;this.a.$addKernel(A,F).catch(X=>{console.log(X),I=!0});let Q=0;const Z=()=>{if(I)return;const X=++Q;Promise.resolve().then(()=>{X===Q&&this.a.$updateKernel(A,F)})},x=new b.$Ac,oe={get id(){return S},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return F.label},set label(X){F.label=X??l.displayName??l.name,Z()},get detail(){return F.detail??""},set detail(X){F.detail=X,Z()},get description(){return F.description??""},set description(X){F.description=X,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(X){F.supportedLanguages=X,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(X){F.supportsExecutionOrder=X,Z()},get rendererScripts(){return F.preloads?F.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(X){W=X??N},get interruptHandler(){return Y},set interruptHandler(X){Y=X,F.supportsInterrupt=!!X,Z()},set variableProvider(X){(0,s.$SF)(l,"notebookVariableProvider"),le=X,F.hasVariableProvider=!!X,X?.onDidChangeVariables(ve=>z.a.$variablesUpdated(ve.uri)),Z()},get variableProvider(){return le},createNotebookCellExecution(X){if(I)throw new Error("notebook controller is DISPOSED");if(!x.has(X.notebook.uri))throw z.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.notebook.uri.toString()}`);return z._createNotebookCellExecution(X,u(l.identifier,this.id))},createNotebookExecution(X){if((0,s.$SF)(l,"notebookExecution"),I)throw new Error("notebook controller is DISPOSED");if(!x.has(X.uri))throw z.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.uri.toString()}`);return z._createNotebookExecution(X,u(l.identifier,this.id))},dispose:()=>{I||(this.q.trace(`NotebookController[${A}], DISPOSED`),I=!0,this.j.delete(A),j.dispose(),T.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(X,ve){ve===k.NotebookControllerAffinity2.Hidden&&(0,s.$SF)(l,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(A,X.uri,ve)},onDidReceiveMessage:T.event,postMessage(X,ve){return(0,s.$SF)(l,"notebookMessaging"),z.a.$postMessage(A,ve&&z.n.getIdByEditor(ve),X)},asWebviewUri(X){return(0,s.$SF)(l,"notebookMessaging"),(0,f.$8ub)(X,z.m.remote)}};return this.j.set(A,{extensionId:l.identifier,controller:oe,onDidReceiveMessage:T,onDidChangeSelection:j,associatedNotebooks:x}),oe}getIdByController(l){for(const[S,L]of this.j)if(L.controller===l)return u(L.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,S){const L=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(L,S);const p={dispose:()=>{this.f.delete(L),w.a.$removeKernelDetectionTask(L)}};return this.f.set(L,p),p}registerKernelSourceActionProvider(l,S,L){const w=this.i++,p=typeof L.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,E=this;this.h.set(w,L),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,S);let A;return p!==void 0&&(A=L.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(w),E.a.$removeKernelSourceActionProvider(w,w),A?.dispose()}}}async $provideKernelSourceActions(l,S){const L=this.h.get(l);if(L){const w=new M.$Rc;return(await L.provideNotebookKernelSourceActions(S)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.o.converter,w))}return[]}$acceptNotebookAssociation(l,S,L){const w=this.j.get(l);if(w){const p=this.n.getNotebookDocument($.URI.revive(S));L?w.associatedNotebooks.set(p.uri,!0):w.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,p.uri.toString(),L),w.onDidChangeSelection.fire({selected:L,notebook:p.apiNotebook})}}async $executeCells(l,S,L){const w=this.j.get(l);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(S)),E=[];for(const A of L){const z=p.getCell(A);z&&E.push(z.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,p.uri.toString(),E.length),await w.controller.executeHandler.call(w.controller,E,p.apiNotebook,w.controller)}catch(A){this.q.error(`NotebookController[${l}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(l,S,L){const w=this.j.get(l);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(S));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,p.apiNotebook);else for(const E of L){const A=p.getCell(E);A&&this.b.get(A.uri)?.cancel()}if(w.controller.interruptHandler){const E=this.c.get(p.uri);L.length&&Array.isArray(E)&&E.length&&E.forEach(A=>A.dispose())}}async $provideVariables(l,S,L,w,p,E,A){const z=this.j.get(l);if(!z)return;const N=this.n.getNotebookDocument($.URI.revive(L)),I=z.controller.variableProvider;if(!I)return;const j=w?{name:w,value:""}:void 0,T=p==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,F=I.provideVariables(N.apiNotebook,j,T,E,A);for await(const W of F){if(A.isCancellationRequested)return;this.a.$receiveVariable(S,W)}}$acceptKernelMessageFromRenderer(l,S,L){const w=this.j.get(l);if(!w)return;const p=this.n.getEditorById(S);w.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:L}))}$cellExecutionChanged(l,S,L){const p=this.n.getNotebookDocument($.URI.revive(l)).getCell(S);if(p){const E=L?v.NotebookCellExecutionState.to(L):k.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:p.apiCell,state:E})}}_createNotebookCellExecution(l,S){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const p=new a(S,w,this.a);this.b.set(w.uri,p);const E=p.onDidChangeState(()=>{p.state===o.Resolved&&(p.dispose(),E.dispose(),this.b.delete(w.uri))});return p.asApiObject()}_createNotebookExecution(l,S){const L=this.n.getNotebookDocument(l.uri),w=l.getCells().find(A=>{const z=L.getCellFromApiCell(A);return z&&this.b.has(z.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const p=new r(S,L,this.a),E=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),E.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[p,E]),p.asApiObject()}};e.$pgc=n,e.$pgc=n=Ge([We(4,R.$ij)],n);var o;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(o||(o={}));class a extends M.$Sc{static{this.a=0}get state(){return this.f}constructor(l,S,L){super(),this.m=S,this.n=L,this.b=a.a++,this.c=new P.$Sd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new g.$3d),this.h=new h(10,w=>this.s(w)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const S=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new i.$Cv(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let S=this.m;if(l&&(S=this.m.notebook.getCellFromApiCell(l)),!S)throw new Error("INVALID cell");return S.handle}y(l){return l.map(S=>{const L=k.$0L.ensureUniqueMimeTypes(S.items,!0);return L===S.items?v.NotebookCellOutput.from(S):v.NotebookCellOutput.from({items:L,id:S.id,metadata:S.metadata})})}async z(l,S,L){const w=this.w(S),p=this.y((0,D.$3b)(l));return this.r({editType:d.CellExecutionUpdateType.Output,cellHandle:w,append:L,outputs:p})}async C(l,S,L){return l=k.$0L.ensureUniqueMimeTypes((0,D.$3b)(l),!0),this.r({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(v.NotebookCellOutputItem.from),outputId:S.id,append:L})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(L){l.j=L,l.s([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(L){if(l.f===o.Resolved||l.f===o.Started)throw new Error("Cannot call start again");l.f=o.Started,l.c.fire(),l.s({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,w){if(l.f===o.Resolved)throw new Error("Cannot call resolve twice");l.f=o.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new i.$Cv({runEndTime:w,lastRunSuccess:L}))},clearOutput(L){return l.t(),l.z([],L,!1)},appendOutput(L,w){return l.t(),l.z(L,w,!0)},replaceOutput(L,w){return l.t(),l.z(L,w,!1)},appendOutputItems(L,w){return l.t(),l.C(L,w,!0)},replaceOutputItems(L,w){return l.t(),l.C(L,w,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class r extends M.$Sc{static{this.a=0}get state(){return this.f}constructor(l,S,L){super(),this.h=S,this.j=L,this.b=r.a++,this.c=new P.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$3d),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class h{constructor(l,S){this.f=l,this.g=S,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new O.$lh,this.b=Date.now(),(0,O.$2g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>l.complete())}}function u(c,l){return`${c.value}/${l}`}e.$qgc=u}),define(Se[330],ke([1,0,4,6,146]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class P{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(O.$FK.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const R=this.c.getEditorById(b);this.a.get($)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,C,m)=>this.d($).event(R,C,m),postMessage:(R,C)=>{g.$0fc.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const m=C&&g.$0fc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,R)}}}d(b){let $=this.a.get(b);return $||($=new D.$Sd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$rgc=P}),define(Se[331],ke([1,0,3,18,2,25,6]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(M.$FK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,R,C){if((0,P.$SF)(y,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,y.identifier.value),(0,D.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,C,m){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(R,C,m)}async $readProfile(y,R,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,O.$Df)(R)?R:g.URI.revive(R),C)}}e.$ugc=b}),define(Se[332],ke([1,0,2,6,12,15]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class M{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(O.$FK.MainThreadQuickDiff)}$provideOriginalResource($,y,R){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Tg)(()=>m.provideOriginalResource(C,R)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,y,R,C){const m=M.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,P.DocumentSelector.from($,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$wgc=M}),define(Se[333],ke([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;function k(f,d,s){const i=f.getProxy(P.$FK.MainThreadQuickOpen);class n{constructor(S,L){this.e=new Map,this.f=0,this.a=S,this.b=L}showQuickPick(S,L,w,p=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(L),A=++this.f,z=i.$show(A,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},p),N={},I=z.then(()=>N);return Promise.race([I,E]).then(j=>{if(j===N)return;const T=(0,m.$RF)(S,"quickPickItemTooltip");return E.then(F=>{const W=[];for(let Y=0;Y<F.length;Y++){const le=F[Y];if(typeof le=="string")W.push({label:le,handle:Y});else if(le.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:le.label});else{le.tooltip&&!T&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const Q=le.iconPath?h(le.iconPath):void 0;W.push({label:le.label,iconPath:Q?.iconPath,iconClass:Q?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:T?v.MarkdownString.fromStrict(le.tooltip):void 0,handle:Y})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=Y=>{w.onDidSelectItem(F[Y])}),i.$setItems(A,W),z.then(Y=>{if(typeof Y=="number")return F[Y];if(Array.isArray(Y))return Y.map(le=>F[le])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(A,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,L=D.CancellationToken.None){return this.d=S?.validateInput,i.$input(S,typeof this.d=="function",L).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(S){if(!this.d)return;const L=await this.d(S);if(!L||typeof L=="string")return L;let w;switch(L.severity){case b.InputBoxValidationSeverity.Info:w=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=R.default.Error;break;default:w=L.message?R.default.Error:R.default.Ignore;break}return{content:L.message,severity:w}}async showWorkspaceFolderPick(S,L=D.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!w)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(E=>E.uri.toString()===w.uri.toString())}createQuickPick(S){const L=new u(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(S){const L=new c(S,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(S,L){this.e.get(S)?._fireDidChangeValue(L)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,L){const w=this.e.get(S);w instanceof u&&w._fireDidChangeActive(L)}$onDidChangeSelection(S,L){const w=this.e.get(S);w instanceof u&&w._fireDidChangeSelection(L)}$onDidTriggerButton(S,L){this.e.get(S)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(S,L,w){const p=this.e.get(S);p instanceof u&&p._fireDidTriggerItemButton(L,w)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,L){this.x=S,this.y=L,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$Sd,this.q=new O.$Sd,this.r=new O.$Sd,this.s=new O.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((L,w)=>{const p=L===b.$3L.Back?-1:w;this.o.set(p,L)}),this.z({buttons:S.map((L,w)=>({...h(L.iconPath),tooltip:L.tooltip,handle:L===b.$3L.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const L=this.o.get(S);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(S){if(!this.v){for(const L of Object.keys(S)){const w=S[L];this.u[L]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(l){if(l instanceof b.$CL)return{id:l.id};const S=r(l),L=t(l);return{dark:typeof S=="string"?M.URI.file(S):S,light:typeof L=="string"?M.URI.file(L):L}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function r(l){return typeof l=="object"&&"dark"in l?l.dark:l}function h(l){const S=a(l);let L,w;return"id"in S?w=C.ThemeIcon.asClassName(S):L=S,{iconPath:L,iconClass:w}}class u extends o{constructor(S,L){super(S.identifier,L),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$Sd,this.L=[],this.M=new O.$Sd,this.N=new O.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((p,E)=>{this.C.set(E,p),this.D.set(p,E)});const L=(0,m.$RF)(this.O,"quickPickItemTooltip"),w=[];for(let p=0;p<S.length;p++){const E=S[p];if(E.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:E.label});else{E.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=E.iconPath?h(E.iconPath):void 0;w.push({handle:p,label:E.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:L?v.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((z,N)=>({...h(z.iconPath),tooltip:z.tooltip,handle:N}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(S){const L=(0,y.$Hb)(S.map(w=>this.C.get(w)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(S){const L=(0,y.$Hb)(S.map(w=>this.C.get(w)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(S,L){const w=this.C.get(S);if(!w||!w.buttons||!w.buttons.length)return;const p=w.buttons[L];p&&this.N.fire({button:p,item:w})}}class c extends o{constructor(S,L){super(S.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:R.default.Error}):this.z({validationMessage:S.message,severity:S.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new n(d,s)}e.$xgc=k}),define(Se[334],ke([1,0,2,4,59,3,12,6,19,128,14,26,61,15,25,17,11]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;function i(N){return N instanceof D.URI}function n(N,I){return N.scheme===f.Schemas.file&&I.scheme===f.Schemas.file&&d.$k?N.toString()===I.toString():N.toString().toLowerCase()===I.toString().toLowerCase()}function o(N){if(N)return typeof N.iconPath=="string"?D.URI.file(N.iconPath):D.URI.isUri(N.iconPath)||m.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function a(N){if(N?.icon){if(D.URI.isUri(N.icon))return N.icon;if(m.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const I=N.icon;return{light:I.light,dark:I.dark}}}else return}function t(N){if(N.icon){if(D.URI.isUri(N.icon))return N.icon;if(m.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const I=N.icon;return{light:I.light,dark:I.dark}}}else return}function r(N){if(N.icon){if(D.URI.isUri(N.icon))return N.icon;if(m.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const I=N.icon;return{light:I.light,dark:I.dark}}}else return}function h(N,I){if(!N.iconPath&&!I.iconPath)return 0;if(N.iconPath){if(!I.iconPath)return 1}else return-1;const j=typeof N.iconPath=="string"?N.iconPath:D.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,T=typeof I.iconPath=="string"?I.iconPath:D.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,y.$Cq)(j,T)}function u(N,I){let j=0;if(N.strikeThrough!==I.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==I.faded)return N.faded?1:-1;if(N.tooltip!==I.tooltip)return(N.tooltip||"").localeCompare(I.tooltip||"");if(j=h(N,I),j!==0)return j;if(N.light&&I.light)j=h(N.light,I.light);else{if(N.light)return 1;if(I.light)return-1}if(j!==0)return j;if(N.dark&&I.dark)j=h(N.dark,I.dark);else{if(N.dark)return 1;if(I.dark)return-1}return j}function c(N,I){if(N.command!==I.command)return N.command<I.command?-1:1;if(N.title!==I.title)return N.title<I.title?-1:1;if(N.tooltip!==I.tooltip){if(N.tooltip!==void 0&&I.tooltip!==void 0)return N.tooltip<I.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(N.arguments===I.arguments)return 0;if(N.arguments)if(I.arguments){if(N.arguments.length!==I.arguments.length)return N.arguments.length-I.arguments.length}else return 1;else return-1;for(let j=0;j<N.arguments.length;j++){const T=N.arguments[j],F=I.arguments[j];if(T!==F&&!(i(T)&&i(F)&&n(T,F)))return T<F?-1:1}return 0}function l(N,I){let j=(0,y.$Cq)(N.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(j!==0)return j;if(N.command&&I.command)j=c(N.command,I.command);else{if(N.command)return 1;if(I.command)return-1}if(j!==0)return j;if(N.decorations&&I.decorations)j=u(N.decorations,I.decorations);else{if(N.decorations)return 1;if(I.decorations)return-1}return j}function S(N,I){for(let j=0;j<N.length;j++)if(N[j]!==I[j])return!1;return!0}function L(N,I){return N.command===I.command&&N.title===I.title&&N.tooltip===I.tooltip&&(N.arguments&&I.arguments?S(N.arguments,I.arguments):N.arguments===I.arguments)}function w(N,I){return(0,$.$ub)(N,I,L)}class p{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.o,I),this.q(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.o,I),this.f=I}get validateInput(){return(0,k.$SF)(this.m,"scmValidation"),this.g}set validateInput(I){if((0,k.$SF)(this.m,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.o,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.o,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.o,I))}get actionButton(){return(0,k.$SF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(I){(0,k.$SF)(this.m,"scmInputBoxActionButton"),this.l.value=new P.$Rc,this.k=I;const j=I!==void 0?{command:this.n.converter.toInternal(I.command,this.l.value),icon:a(I),enabled:I.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,j??null)}get document(){return(0,k.$SF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(I,j,T,F,W,Y){this.m=I,this.n=j,this.o=W,this.p=Y,this.d="",this.e=new O.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new P.$Tc,this.#t=T,this.#e=F}showValidationMessage(I,j){(0,k.$SF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,I,j)}$onInputBoxValueChange(I){this.q(I)}q(I){this.d=I,this.e.fire(I)}}e.$ygc=p;class E{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,j,T,F,W){this.q=I,this.s=j,this.t=T,this.u=F,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=E.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,j){const T=this.h.get(I);return T?(0,M.$Tg)(()=>this.s.executeCommand(T.command,...T.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(l),T=(0,$.$Db)(this.o,I,l).map(Y=>{const le=Y.toInsert.map(Q=>{const Z=this.e++;this.g.set(Z,Q);const x=Q.resourceUri;let oe;if(Q.command)if(Q.command.command==="vscode.open"||Q.command.command==="vscode.diff"||Q.command.command==="vscode.changes"){const ee=new P.$Rc;oe=this.s.converter.toInternal(Q.command,ee),this.j.set(Z,ee)}else this.h.set(Z,Q.command);const X=o(Q.decorations),ve=Q.decorations&&o(Q.decorations.light)||X,ge=Q.decorations&&o(Q.decorations.dark)||X,H=[ve,ge],U=Q.decorations&&Q.decorations.tooltip||"",ne=Q.decorations&&!!Q.decorations.strikeThrough,ye=Q.decorations&&!!Q.decorations.faded,fe=Q.contextValue||"";return{rawResource:[Z,x,H,U,ne,ye,fe,oe],handle:Z}});return{start:Y.start,deleteCount:Y.deleteCount,toInsert:le}}),F=T.map(({start:Y,deleteCount:le,toInsert:Q})=>[Y,le,Q.map(Z=>Z.rawResource)]),W=T.reverse();for(const{start:Y,deleteCount:le,toInsert:Q}of W){const Z=Q.map(oe=>oe.handle),x=this.n.splice(Y,le,...Z);for(const oe of x)this.g.delete(oe),this.h.delete(oe),this.j.get(oe)?.dispose(),this.j.delete(oe)}return this.o=I,F}dispose(){this.l=!0,this.m.fire()}}class A{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.x,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let j;(0,k.$RF)(this.y,"quickDiffProvider")&&(j=I?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!I,quickDiffLabel:j})}get historyProvider(){return(0,k.$SF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(I){(0,k.$SF)(this.y,"scmHistoryProvider"),this.j=I,this.k.value=new P.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!I}),I&&(this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(I.onDidChangeActionButton(()=>{(0,k.$SF)(this.y,"scmActionButton"),this.m.value=new P.$Rc;const j=I.actionButton!==void 0?{command:this.z.converter.toInternal(I.actionButton.command,this.m.value),description:I.actionButton.description,enabled:I.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,j??null)})))}get commitTemplate(){return this.n}set commitTemplate(I){I!==this.n&&(this.n=I,this.#e.$updateSourceControl(this.x,{commitTemplate:I}))}get acceptInputCommand(){return this.p}set acceptInputCommand(I){this.o.value=new P.$Rc,this.p=I;const j=this.z.converter.toInternal(I,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,k.$SF)(this.y,"scmActionButton"),this.s}set actionButton(I){(0,k.$SF)(this.y,"scmActionButton"),this.q.value=new P.$Rc,this.s=I;const j=I!==void 0?{command:this.z.converter.toInternal(I.command,this.q.value),secondaryCommands:I.secondaryCommands?.map(T=>T.map(F=>this.z.converter.toInternal(F,this.q.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(I){if(this.u&&I&&w(this.u,I))return;this.t.value=new P.$Rc,this.u=I;const j=(I||[]).map(T=>this.z.converter.toInternal(T,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(I,j,T,F,W,Y,le){this.y=I,this.z=F,this.A=W,this.B=Y,this.C=le,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Tc,this.m=new P.$Tc,this.n=void 0,this.o=new P.$Tc,this.p=void 0,this.q=new P.$Tc,this.t=new P.$Tc,this.u=void 0,this.v=!1,this.w=new O.$Sd,this.onDidChangeSelection=this.w.event,this.x=A.d++,this.D=new Map,this.E=new Set,this.#e=T;const Q=D.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${W}/scm${this.x}/input`,query:le?`rootUri=${encodeURIComponent(le.toString())}`:void 0});this.f=new p(I,F,j,this.#e,this.x,Q),this.#e.$registerSourceControl(this.x,W,Y,le,Q)}createResourceGroup(I,j){const T=new E(this.#e,this.z,this.x,I,j),F=O.Event.once(T.onDidDispose)(()=>this.D.delete(T));return this.D.set(T,F),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const I=[],j=[];for(const[T,F]of this.D){F.dispose();const W=T.onDidUpdateResourceStates(()=>{this.E.add(T),this.eventuallyUpdateResourceStates()});O.Event.once(T.onDidDispose)(()=>{this.E.delete(T),W.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.x,T.handle)}),I.push([T.handle,T.id,T.label,T.features]);const Y=T._takeResourceStateSnapshot();Y.length>0&&j.push([T.handle,Y]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.x,I,j),this.D.clear()}eventuallyUpdateResourceStates(){const I=[];this.E.forEach(j=>{const T=j._takeResourceStateSnapshot();T.length!==0&&I.push([j.handle,T])}),I.length>0&&this.#e.$spliceResourceStates(this.x,I),this.E.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.v=I,this.w.fire(I)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ge([(0,g.$th)(100)],A.prototype,"eventuallyAddResourceGroups",null),Ge([(0,g.$th)(100)],A.prototype,"eventuallyUpdateResourceStates",null);let z=class{static{s=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(I,j,T,F){this.n=j,this.o=T,this.p=F,this.h=new Map,this.j=new C.$gm,this.k=new O.$Sd,this.l=new Map,this.f=I.getProxy(b.$FK.MainThreadSCM),this.g=I.getProxy(b.$FK.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const Y=this.h.get(W.sourceControlHandle);if(!Y)return W;const le=Y.getResourceGroup(W.groupHandle);return le?le.getResourceState(W.handle):W}else if(W&&W.$mid===4){const Y=this.h.get(W.sourceControlHandle);return Y?Y.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const Y=this.h.get(W.handle);return Y||W}return W}})}createSourceControl(I,j,T,F){this.p.trace("ExtHostSCM#createSourceControl",I.identifier.value,j,T,F),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const W=s.d++,Y=new A(I,this.o,this.f,this.n,j,T,F);this.h.set(W,Y);const le=this.j.get(I.identifier)||[];return le.push(Y),this.j.set(I.identifier,le),Y}registerSourceControlInputBoxValueProvider(I,j,T){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",I.identifier.value,T.label);const F=s.e++;return this.l.set(F,T),this.f.$registerSourceControlInputBoxValueProvider(F,j,T.label,r(T)),(0,P.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(F),this.l.delete(F)})}async $provideInputBoxValue(I,j,T,F){const W=this.l.get(I);if(W)return await W.provideValue(D.URI.revive(j),T,F)??void 0}getLastInputBox(I){this.p.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const j=this.j.get(I.identifier),T=j&&j[j.length-1];return T&&T.inputBox}$provideOriginalResource(I,j,T){const F=D.URI.revive(j);this.p.trace("ExtHostSCM#$provideOriginalResource",I,F.toString());const W=this.h.get(I);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$Tg)(()=>W.quickDiffProvider.provideOriginalResource(F,T)).then(Y=>Y||null)}$onInputBoxValueChange(I,j){this.p.trace("ExtHostSCM#$onInputBoxValueChange",I);const T=this.h.get(I);return T&&T.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(I,j,T,F){this.p.trace("ExtHostSCM#$executeResourceCommand",I,j,T);const W=this.h.get(I);if(!W)return Promise.resolve(void 0);const Y=W.getResourceGroup(j);return Y?Y.$executeResourceCommand(T,F):Promise.resolve(void 0)}$validateInput(I,j,T){this.p.trace("ExtHostSCM#$validateInput",I);const F=this.h.get(I);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,M.$Tg)(()=>F.inputBox.validateInput(j,T)).then(W=>{if(!W)return Promise.resolve(void 0);const Y=v.MarkdownString.fromStrict(W.message);return Y?Promise.resolve([Y,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.h.get(I)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(I,j,T){return await this.h.get(I)?.historyProvider?.resolveHistoryItemGroupBase(j,T)??void 0}async $resolveHistoryItemGroupCommonAncestor(I,j,T,F){return await this.h.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,T,F)??void 0}async $provideHistoryItems(I,j,T,F){return(await this.h.get(I)?.historyProvider?.provideHistoryItems(j,T,F))?.map(le=>({...le,icon:t(le)}))??void 0}async $provideHistoryItemChanges(I,j,T){return await this.h.get(I)?.historyProvider?.provideHistoryItemChanges(j,T)??void 0}};e.$zgc=z,e.$zgc=z=s=Ge([We(3,R.$ij)],z)}),define(Se[117],ke([1,0,6,4,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0;class P{constructor(b){this.b=new O.$Sd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$FK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Ffc=P,e.$Gfc=(0,g.$1h)("IExtHostSecretState")}),define(Se[335],ke([1,0,6,15,2]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class P{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$FK.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:O.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=P.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,O.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Agc=P}),define(Se[336],ke([1,0,21,3,6]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class P{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$FK.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const R=new O.$Rc,C=new D.$3d;this.d.set($,C);const m=R.add(y.provideSpeechToTextSession(C.token));R.add(m.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const R=P.a++;return this.c.set(R,y),this.b.$registerProvider(R,$,{extension:b,displayName:b.value}),(0,O.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Bgc=P}),define(Se[337],ke([1,0,7,6,216,3,15,18]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$DL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$DL("statusBarItem.warningForeground")]])}#e;#t;constructor(m,v,k,f,d,s=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Rc,this.#e=m,this.#t=v,d&&f){this.c=(0,D.$gL)(f.identifier,d);const n=k.get(this.c);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=f,this.f=d,this.g=s,this.h=this.u(i)}u(m){if((0,b.$Hf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new P.$Rc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=$.b.get(this.o.id));const f=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,v,this.k,f,this.r?.internal,k,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Cgc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const v={message:m};return this.b.unshift(v),this.c(),new D.$HK(()=>{const k=this.b.indexOf(v);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(m,v){this.e=new Map,this.a=m.getProxy(O.$FK.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries(m){for(const v of m)this.e.set(v.entryId,v)}createStatusBarEntry(m,v,k,f){return new $(this.a,this.b,this.e,m,v,k,f)}setStatusBarMessage(m,v){const k=this.c.setMessage(m);let f;return typeof v=="number"?f=setTimeout(()=>k.dispose(),v):typeof v<"u"&&v.then(()=>k.dispose(),()=>k.dispose()),new D.$HK(()=>{k.dispose(),clearTimeout(f)})}}e.$Dgc=R}),define(Se[118],ke([1,0,6,4,5]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=void 0;class P{constructor(b,$){this.c=$,this.b=new O.$Sd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$FK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const R=await this.a.$initializeExtensionStorage(b,$);let C;return R&&(C=this.d(b,$,R)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const R=this.d(b,$,y);R&&this.b.fire({shared:b,key:$,value:R})}d(b,$,y){try{return JSON.parse(y)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${R}`)}}}e.$xfc=P,e.$yfc=(0,g.$1h)("IExtHostStorage")}),define(Se[92],ke([1,0,5,27,14,71,2]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0,e.$gfc=(0,D.$1h)("IExtensionStoragePaths");let b=class{constructor(y,R,C){this.d=R,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return M.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,R=await this.g(y);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(M.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return M.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return M.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$hfc=b,e.$hfc=b=Ge([We(0,O.$ZM),We(1,g.$ij),We(2,P.$ffc)],b)}),define(Se[47],ke([1,0,4,6,5,2,20,3,7,218,8,262,21,30,263,61,12,15,35]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,g.$1h)("IExtHostTerminalService");class n{constructor(w,p,E,A){this.l=w,this._id=p,this.m=E,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(N=>this.f=N);const z=this;this.value={get name(){return z.n||""},get processId(){return z.b},get creationOptions(){return z.m},get exitStatus(){return z.h},get state(){return z.j},get selection(){return z.k},sendText(N,I=!0){z.q(),z.l.$sendText(z._id,N,I)},show(N){z.q(),z.l.$show(z._id,N)},hide(){z.q(),z.l.$hide(z._id)},dispose(){z.a||(z.a=!0,z.l.$dispose(z._id))},get dimensions(){if(!(z.d===void 0||z.g===void 0))return{columns:z.d,rows:z.g}}}}async create(w,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??p?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:f.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(w.location,p?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,p,E,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:E,color:f.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.o(w,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,p){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in w?{viewColumn:s.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,p){this.h=Object.freeze({code:w,reason:p})}setDimensions(w,p){return w===this.d&&p===this.g||w===0||p===0?!1:(this.d=w,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(p=>{p!==w&&(this.b=Promise.resolve(w))})}}e.$Cfc=n;class o{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new D.$Sd,this.onProcessData=this.a.event,this.b=new D.$Sd,this.d=new D.$Sd,this.onDidChangeProperty=this.d.event,this.f=new D.$Sd,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,p){this.g.setDimensions?.({columns:w,rows:p})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,p,E){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Sd,this.onDidChangeShell=this.N.event,this.O=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(O.$FK.MainThreadTerminalService),this.y=new k.$jrb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:A=>{const z=N=>{const I=N;return this.W(I.instanceId)?.value};switch(A?.$mid){case 15:return z(A);default:{if(Array.isArray(A))for(let N=0;N<A.length&&A[N].$mid===15;N++)A[N]=z(A[N]);return A}}}}),this.B({dispose:()=>{for(const[A,z]of this.g)z.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,p){const E=new n(this.a,(0,v.$lg)(),w,w.name),A=new o(w.pty);return E.createExtensionTerminal(w.location,this.R(w,p).resolvedExtHostIdentifier,c(w.iconPath),l(w.color)).then(z=>{const N=this.S(z,A);this.h[z]=N}),this.f.push(E),E.value}R(w,p){if(p=p||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const E=w.location.parentTerminal;if(E){const A=this.f.find(z=>z.value===E);A&&(p.resolvedExtHostIdentifier=A._id)}}else w.location&&typeof w.location!="object"?p.location=w.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(w,p){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const A=new o(p),z=this.S(w,A);this.h[w]=z}async $acceptActiveTerminalChanged(w){const p=this.b;if(w===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const E=this.W(w);E&&(this.b=E,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,p){const E=this.W(w);E&&this.O.fire({terminal:E.value,data:p})}async $acceptTerminalDimensions(w,p,E){const A=this.W(w);A&&A.setDimensions(p,E)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(w,p){const E=this.W(w);E&&this.P.fire({terminal:E.value,...p})}async $acceptTerminalMaximumDimensions(w,p,E){this.g.get(w)?.resize(p,E)}async $acceptTerminalTitleChange(w,p){const E=this.W(w);E&&(E.name=p)}async $acceptTerminalClosed(w,p,E){const A=this.Y(this.f,w);if(A!==null){const z=this.f.splice(A,1)[0];z.setExitStatus(p,E),this.H.fire(z.value)}}$acceptTerminalOpened(w,p,E,A){if(p){const I=this.Y(this.f,p);if(I!==null){this.f[I]._id=w,this.I.fire(this.terminals[I]),this.f[I].isOpen=!0;return}}const z={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:P.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},N=new n(this.a,w,z,E);this.f.push(N),this.I.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(w,p){this.W(w)?._setProcessId(p)}async $startExtensionTerminal(w,p){const E=this.W(w);if(!E)return{message:(0,y.localize)(0,null,w)};E.isOpen||await new Promise(z=>{const N=this.onDidOpenTerminal(async I=>{I===E.value&&(N.dispose(),z())})});const A=this.g.get(w);A?A.startSendingEvents(p):this.j[w]={initialDimensions:p}}S(w,p){const E=new b.$Rc;E.add(p.onProcessReady(z=>this.a.$sendProcessReady(w,z.pid,z.cwd,z.windowsPty))),E.add(p.onDidChangeProperty(z=>this.a.$sendProcessProperty(w,z))),this.y.startBuffering(w,p.onProcessData),E.add(p.onProcessExit(z=>this.U(w,z))),this.g.set(w,p);const A=this.j[w];return A&&p instanceof o&&(p.startSendingEvents(A.initialDimensions),delete this.j[w]),E}$acceptProcessAckDataEvent(w,p){this.g.get(w)?.acknowledgeDataEvent(p)}$acceptProcessInput(w,p){this.g.get(w)?.input(p)}$acceptTerminalInteraction(w){const p=this.W(w);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(w,p){this.W(w)?.setSelection(p)}$acceptProcessResize(w,p,E){try{this.g.get(w)?.resize(p,E)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(w,p){this.g.get(w)?.shutdown(p)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(p=>this.a.$sendProcessProperty(w,{type:"cwd",value:p}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$HK(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,p,E){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,E),this.a.$registerProfileProvider(p,w.identifier.value),new $.$HK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(w,p,E){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,E),this.a.$registerQuickFixProvider(w,p),new $.$HK(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,p){const E=new m.$3d().token;if(E.isCancellationRequested)return;const A=this.D.get(w);if(!A)return;const z=await A.provideTerminalQuickFixes(p,E);if(z===null||Array.isArray(z)&&z.length===0)return;const N=new b.$Rc;if(this.w.value=N,!Array.isArray(z))return z?s.TerminalQuickFix.from(z,this.Q.converter,N):void 0;const I=[];for(const j of z){const T=s.TerminalQuickFix.from(j,this.Q.converter,N);T&&I.push(T)}return I}async $createContributedProfileTerminal(w,p){const E=new m.$3d().token;let A=await this.C.get(w)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,p);return}this.createTerminalFromOptions(A.options,p)}}async $provideLinks(w,p){const E=this.W(w);if(!E)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const z=new m.$3d;this.G.set(w,z);const N=[],I={terminal:E.value,line:p},j=[];for(const W of this.z)j.push(d.Promises.withAsyncBody(async Y=>{z.token.onCancellationRequested(()=>Y({provider:W,links:[]}));const le=await W.provideTerminalLinks(I,z.token)||[];z.token.isCancellationRequested||Y({provider:W,links:le})}));const T=await Promise.all(j);if(z.token.isCancellationRequested)return[];const F=new Map;for(const W of T)W&&W.links.length>0&&N.push(...W.links.map(Y=>{const le={id:a++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return F.set(le.id,{provider:W.provider,link:Y}),le}));return this.F.set(w,F),N}$activateLink(w,p){const E=this.F.get(w)?.get(p);E&&E.provider.handleTerminalLink(E.link)}U(w,p){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const E=this.h[w];E&&(E.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,p)}W(w){return this.X(this.f,w)}X(w,p){const E=this.Y(w,p);return E!==null?w[E]:null}Y(w,p){const E=w.findIndex(A=>A._id===p);return E===-1?null:E}getEnvironmentVariableCollection(w){let p=this.n.get(w.identifier.value);return p||(p=new r,this.$(w.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(w,p){const E=(0,C.$vr)(p.map),A=(0,C.$wr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(w,p.persistent,E.length===0?void 0:E,A)}$initEnvironmentVariableCollections(w){w.forEach(p=>{const E=p[0],A=new r(p[1]);this.$(E,A)})}$acceptDefaultProfile(w,p){const E=this.s;this.s=w,this.u=p,E?.path!==w.path&&this.N.fire(w.path)}$(w,p){this.n.set(w,p),p.onDidChangeCollection(()=>{this.Z(w,p)})}};e.$Dfc=t,e.$Dfc=t=Ge([We(1,i.$6M),We(2,M.$JM)],t);class r{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Sd,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const p=this.h(w);let E=this.a.get(p);return E||(E=new h(this,w),this.a.set(p,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(w,p,E,A){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:A})}append(w,p,E,A){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:A})}prepend(w,p,E,A){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:A})}f(w,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(w,p.scope),A=this.map.get(E),z=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==p.value||A.type!==p.type||A.options?.applyAtProcessCreation!==z.applyAtProcessCreation||A.options?.applyAtShellIntegration!==z.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const N=this.g(w,p.scope),I={variable:w,...p,options:z};this.map.set(N,I),this.d.fire()}}get(w,p){const E=this.g(w,p),A=this.map.get(E);return A?S(A):void 0}g(w,p){const E=this.h(p);return E.length?`${w}:::${E}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const p=new Map;for(const[E,A]of this.map)this.h(A.scope)===this.h(w)&&p.set(A.variable,S(A));return p}delete(w,p){const E=this.g(w,p);this.map.delete(E),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[p,E]of this.map)E.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(p);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,p){const E=this.h(p),A=this.descriptionMap.get(E);if(!A||A.description!==w){let z;typeof w=="string"?z=w:z=w?.value.split(`

`)[0];const N={description:z,scope:p};this.descriptionMap.set(E,N),this.d.fire()}}getDescription(w){const p=this.h(w);return this.descriptionMap.get(p)?.description}k(w){const p=this.h(w);this.descriptionMap.delete(p)}}class h{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,p){this.b=w,this.d=p,this.a=new D.$Sd}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,p,E){this.b.replace(w,p,E,this.d)}append(w,p,E){this.b.append(w,p,E,this.d)}prepend(w,p,E){this.b.prepend(w,p,E,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,p){this.b.getVariableMap(this.d).forEach((E,A)=>w.call(p,A,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(w,p){super(!1,w,p)}createTerminal(w,p,E){throw new R.$_}createTerminalFromOptions(w,p){throw new R.$_}};e.$Efc=u,e.$Efc=u=Ge([We(0,i.$6M),We(1,M.$JM)],u);function c(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function l(L){return f.ThemeColor.isThemeColor(L)?L:void 0}function S(L){const w={...L};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Se[338],ke([1,0,12,22,21,4,74,53,3,24,18,30,6,20,147,15,7,67,112,89,25]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;let a=class extends $.$Sc{constructor(N,I,j){super(),this.u=j,this.f=this.B(new P.$Sd),this.g=new Map,this.s=this.B(new P.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=N.getProxy(m.$FK.MainThreadTesting),this.m=new p(this.h),this.j=new u(this.h),I.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const F=T,W=F.tests[F.tests.length-1].item.extId;return this.g.get(s.$xJ.root(W))?.collection.tree.get(W)?.actual??(0,k.$VM)(T)}case 18:{const{extId:F,message:W}=T;return{test:this.g.get(s.$xJ.root(F))?.collection.tree.get(F)?.actual,message:f.TestMessage.to(W)}}default:return T}}}),I.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await I.executeCommand("_testing.getExplorerSelection"),F=W=>{const Y=this.g.get(s.$xJ.root(W));if(Y)return s.$xJ.isRoot(W)?Y.controller:Y.collection.tree.get(W)?.actual};return{include:T?.include.map(F).filter(R.$Lf)||[],exclude:T?.exclude.map(F).filter(R.$Lf)||[]}})}createTestController(N,I,j,T){if(this.g.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const F=new $.$Rc,W=F.add(new k.$YM(I,j,this.u));W.root.label=j;const Y=new Map,le=new Set,Q=this.h,Z={items:W.root.children,get label(){return j},set label(oe){j=oe,W.root.label=oe,Q.$updateController(I,{label:j})},get refreshHandler(){return T},set refreshHandler(oe){T=oe,Q.$updateController(I,{canRefresh:!!oe})},get id(){return I},createRunProfile:(oe,X,ve,ge,H,U)=>{let ne=(0,b.$Oi)(oe);for(;Y.has(ne);)ne++;return new E(this.h,Y,N,le,this.s.event,I,ne,oe,X,ve,ge,H,U)},createTestItem(oe,X,ve){return new k.$WM(I,oe,X,ve)},createTestRun:(oe,X,ve=!0)=>this.j.createTestRun(N,I,W,oe,X,ve),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const X=oe instanceof Array?oe:[oe];this.h.$markTestRetired(X.map(ve=>s.$xJ.fromExtHostTestItem(ve,I).toString()))}},set resolveHandler(oe){W.resolveHandler=oe},get resolveHandler(){return W.resolveHandler},dispose:()=>{F.dispose()}};Q.$registerTestController(I,j,!!T),F.add((0,$.$Qc)(()=>Q.$unregisterTestController(I)));const x={controller:Z,collection:W,profiles:Y,extension:N,activeProfiles:le};return this.g.set(I,x),F.add((0,$.$Qc)(()=>this.g.delete(I))),F.add(W.onDidGenerateDiff(oe=>Q.$publishDiff(I,oe.map(n.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.m.checkout()}async runTests(N,I=g.CancellationToken.None){const j=c(N);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(j.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(F=>s.$xJ.fromExtHostTestItem(F,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:A[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:N.exclude?.map(F=>F.id)},I)}$syncTests(){for(const{collection:N}of this.g.values())N.flushDiff();return Promise.resolve()}async $provideFileCoverage(N,I,j){return await this.j.getCoverageReport(N,I)?.provideFileCoverage(j)??[]}async $resolveFileCoverage(N,I,j,T){return await this.j.getCoverageReport(N,I)?.resolveFileCoverage(j,T)??[]}$configureRunProfile(N,I){this.g.get(N)?.profiles.get(I)?.configureHandler?.()}$setActiveRunProfiles(N){const I=new Map;for(const[j,T]of Object.entries(N)){const F=this.g.get(j);if(!F)continue;const W=new Map,Y=T.filter(Q=>!F.activeProfiles.has(Q)),le=[...F.activeProfiles].filter(Q=>!T.includes(Q));for(const Q of Y)W.set(Q,!0),F.activeProfiles.add(Q);for(const Q of le)W.set(Q,!1),F.activeProfiles.delete(Q);W.size&&I.set(j,W)}this.s.fire(I)}async $refreshTests(N,I){await this.g.get(N)?.controller.refreshHandler?.(I)}$publishTestResults(N){this.results=Object.freeze(N.map(I=>(0,y.$gn)(f.TestResults.to(I))).concat(this.results).sort((I,j)=>j.completedAt-I.completedAt).slice(0,32)),this.f.fire()}async $expandTest(N,I){const j=this.g.get(s.$xJ.fromString(N).controllerId)?.collection;j&&(await j.expand(N,I<0?1/0:I),j.flushDiff())}$acceptDiff(N){this.m.applyDiff(N.map(n.TestsDiffOp.deserialize))}async $runControllerTests(N,I){return Promise.all(N.map(j=>this.w(j,!1,I)))}async $startContinuousRun(N,I){const j=new g.$3d(I),T=await Promise.all(N.map(F=>this.w(F,!0,j.token)));return!I.isCancellationRequested&&!T.some(F=>F.error)&&await new Promise(F=>I.onCancellationRequested(F)),j.dispose(!0),T}async w(N,I,j){const T=this.g.get(N.controllerId);if(!T)return{};const{collection:F,profiles:W,extension:Y}=T,le=W.get(N.profileId);if(!le)return{};const Q=N.testIds.map(X=>F.tree.get(X)).filter(R.$Lf),Z=N.excludeExtIds.map(X=>T.collection.tree.get(X)).filter(R.$Lf).filter(X=>Q.some(ve=>ve.fullId.compare(X.fullId)===2));if(!Q.length)return{};const x=new d.$eM(Q.some(X=>X.actual instanceof k.$XM)?void 0:Q.map(X=>X.actual),Z.map(X=>X.actual),le,I),oe=(0,n.$zJ)(N)&&this.j.prepareForMainThreadTestRun(x,l.fromInternal(N,T.collection),Y,j);try{return await le.runHandler(x,j),{}}catch(X){return{error:String(X)}}finally{oe&&(oe.hasRunningTasks&&!j.isCancellationRequested&&await P.Event.toPromise(oe.onEnd),oe.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.j.cancelAllRuns():this.j.cancelRunById(N)}};e.$Hgc=a,e.$Hgc=a=Ge([We(0,v.$JM)],a);const t=1e4;var r;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(r||(r={}));class h extends $.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(N,I,j,T){super(),this.s=N,this.u=I,this.w=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Sd),this.m=this.B(new P.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$3d(T));const F=this.B(new D.$ah(()=>this.y(),t));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(N){const I=this.s.id,j=this.s.controllerId,T=(0,C.$lg)(),F=this.w,W=this.m;let Y;const le=oe=>(X,...ve)=>{if(Z){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}this.s.isIncluded(X)&&(this.C(X),oe(X,...ve))},Q=(oe,X)=>{const ve=X instanceof Array?X.map(f.TestMessage.from):[f.TestMessage.from(X)];if(oe.uri&&oe.range){const ge={range:f.Range.from(oe.range),uri:oe.uri};for(const H of ve)H.location=H.location||ge}this.u.$appendTestMessagesInRun(I,T,s.$xJ.fromExtHostTestItem(oe,j).toString(),ve)};let Z=!1;const x={isPersisted:this.s.isPersisted,token:this.h.token,name:N,get coverageProvider(){return Y?.provider},set coverageProvider(oe){(0,o.$SF)(F,"testCoverage"),Y=oe&&new S(oe),W.fire({taskId:T,runId:I,coverage:Y})},enqueued:le(oe=>{this.u.$updateTestStateInRun(I,T,s.$xJ.fromExtHostTestItem(oe,j).toString(),1)}),skipped:le(oe=>{this.u.$updateTestStateInRun(I,T,s.$xJ.fromExtHostTestItem(oe,j).toString(),5)}),started:le(oe=>{this.u.$updateTestStateInRun(I,T,s.$xJ.fromExtHostTestItem(oe,j).toString(),2)}),errored:le((oe,X,ve)=>{Q(oe,X),this.u.$updateTestStateInRun(I,T,s.$xJ.fromExtHostTestItem(oe,j).toString(),6,ve)}),failed:le((oe,X,ve)=>{Q(oe,X),this.u.$updateTestStateInRun(I,T,s.$xJ.fromExtHostTestItem(oe,j).toString(),4,ve)}),passed:le((oe,X)=>{this.u.$updateTestStateInRun(I,T,s.$xJ.fromExtHostTestItem(oe,this.s.controllerId).toString(),3,X)}),appendOutput:(oe,X,ve)=>{Z||(ve&&(this.s.isIncluded(ve)?this.C(ve):ve=void 0),this.u.$appendOutputToRun(I,T,O.$ge.fromString(oe),X&&f.location.from(X),ve&&s.$xJ.fromExtHostTestItem(ve,j).toString()))},end:()=>{Z||(Z=!0,this.u.$finishedTestRunTask(I,T),this.f.delete(T),this.f.size||this.z())}};return this.f.set(T,{run:x}),this.u.$startedTestRunTask(I,{id:T,name:N,running:!0}),x}y(){for(const{run:N}of this.f.values())N.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(N){if(!(N instanceof k.$WM))throw new i.$BM(N.id);if(this.g.has(s.$xJ.fromExtHostTestItem(N,this.s.controllerId).toString()))return;const I=[],j=this.s.colllection.root;for(;;){const T=f.TestItem.from(N);if(I.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),N===j))break;N=N.parent||j}this.u.$addTestsToRun(this.s.controllerId,this.s.id,I)}dispose(){this.z(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(N){this.f=N,this.c=new Map,this.d=[]}getCoverageReport(N,I){return this.d.find(j=>j.runId===N)?.coverage.get(I)}prepareForMainThreadTestRun(N,I,j,T){return this.g(N,I,j,T)}cancelRunById(N){for(const I of this.c.values())if(I.id===N){I.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,I,j,T,F,W){const Y=this.c.get(T);if(Y)return Y.createRun(F);const le=l.fromPublic(I,j,T,W),Q=c(T);this.f.$startedExtensionTestRun({controllerId:I,continuous:!!T.continuous,profile:Q&&{group:A[Q.kind],id:Q.profileId},exclude:T.exclude?.map(x=>s.$xJ.fromExtHostTestItem(x,j.root.id).toString())??[],id:le.id,include:T.include?.map(x=>s.$xJ.fromExtHostTestItem(x,j.root.id).toString())??[j.root.id],persist:W});const Z=this.g(T,le,N);return P.Event.once(Z.onEnd)(()=>{this.f.$finishedExtensionTestRun(le.id),Z.dispose()}),Z.createRun(F)}g(N,I,j,T){const F=new h(I,this.f,j,T);this.c.set(N,F);let W;const Y=F.onDidCoverage(({runId:le,taskId:Q,coverage:Z})=>{W||(W={runId:le,coverage:new Map},this.d.unshift(W),this.d.length>n.$EJ&&this.d.pop()),W.coverage.set(Q,Z),this.f.$signalCoverageAvailable(le,Q,!!Z)});return P.Event.once(F.onEnd)(()=>{this.c.delete(N),Y.dispose()}),F}}e.$Igc=u;const c=z=>{if(z.profile){if(!(z.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class l{static fromPublic(N,I,j,T){return new l(N,(0,C.$lg)(),j.include?.map(F=>s.$xJ.fromExtHostTestItem(F,N).toString())??[N],j.exclude?.map(F=>s.$xJ.fromExtHostTestItem(F,N).toString())??[],T,I)}static fromInternal(N,I){return new l(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,I)}constructor(N,I,j,T,F,W){this.controllerId=N,this.id=I,this.isPersisted=F,this.colllection=W,this.c=j.map(Y=>Y+"\0"),this.d=T.map(Y=>Y+"\0")}isIncluded(N){const I=s.$xJ.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const j of this.d)if(I===j||I.startsWith(j))return!1;for(const j of this.c)if(I===j||I.startsWith(j))return!0;return!1}}e.$Jgc=l;class S{constructor(N){this.provider=N}async provideFileCoverage(N){this.c||(this.c=(async()=>this.provider.provideFileCoverage(N))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(I){throw this.c=void 0,I}}async resolveFileCoverage(N,I){const j=await this.c;let T=j?.[N];return!this.provider||!j||!T?[]:(T.detailedCoverage||(T=j[N]=await this.provider.resolveFileCoverage?.(T,I)??T),T.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class L{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,f.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const I=s.$xJ.parentId(N.item.extId);if(I&&this.g.has(I.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:I,f:j}=this;return{get added(){return[...N].map(T=>T.revived)},get updated(){return[...I].map(T=>T.revived)},get removed(){return[...j].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends n.$FJ{constructor(){super(...arguments),this.q=new P.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,I){return{...N,revived:f.TestItem.toPlain(N.item),depth:I?I.depth+1:0,children:new Set}}o(){return new L(this.q)}}class p{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(I=>I.revived)},dispose:(0,M.$db)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class E{#e;#t;#i;#o;#r;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?f.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}get isSelected(){return(0,o.$SF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,o.$SF)(this.#t,"testingActiveProfile"),P.Event.chain(this.#o,N=>N.map(I=>I.get(this.controllerId)?.get(this.profileId)).filter(R.$Lf))}constructor(N,I,j,T,F,W,Y,le,Q,Z,x=!1,oe=void 0,X=!1){this.controllerId=W,this.profileId=Y,this.d=le,this.kind=Q,this.runHandler=Z,this.f=x,this._tag=oe,this.g=X,this.#e=N,this.#r=I,this.#t=j,this.#i=T,this.#o=F,I.set(Y,this);const ve=A[Q];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);this.#e.$publishTestRunProfile({profileId:Y,controllerId:W,tag:oe?f.TestTag.namespace(this.controllerId,oe.id):null,label:le,group:ve,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Kgc=E;const A={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Se[339],ke([1,0,19,8,4,6,148,15,7]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class y{constructor(C,m){this.i=m,this.a=new g.$Sd({onListenerError:O.$2}),this.b=new g.$Sd({onListenerError:O.$2}),this.c=new g.$Sd({onListenerError:O.$2}),this.d=new g.$Sd({onListenerError:O.$2}),this.f=new g.$Sd({onListenerError:O.$2}),this.g=new g.$Sd({onListenerError:O.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(P.$FK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const m=this.i.allEditors();return C?m:m.map(v=>v.value)}async showTextDocument(C,m,v){let k;typeof m=="number"?k={position:b.ViewColumn.from(m),preserveFocus:v}:typeof m=="object"?k={position:b.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?b.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:k={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(C.uri,k),d=f&&this.i.getEditor(f);if(d)return d.value;throw f?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,m){return new M.$QM(this.h,C,m).value}$acceptEditorPropertiesChanged(C,m){const v=this.i.getEditor(C);if(!v)throw new Error("unknown text editor");if(m.options&&v._acceptOptions(m.options),m.selections){const k=m.selections.selections.map(b.Selection.to);v._acceptSelections(k)}if(m.visibleRanges){const k=D.$Hb(m.visibleRanges.map(b.Range.to));v._acceptVisibleRanges(k)}if(m.options&&this.b.fire({textEditor:v.value,options:{...m.options,lineNumbers:b.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const k=$.TextEditorSelectionChangeKind.fromValue(m.selections.source),f=m.selections.selections.map(b.Selection.to);this.a.fire({textEditor:v.value,selections:f,kind:k})}if(m.visibleRanges){const k=D.$Hb(m.visibleRanges.map(b.Range.to));this.c.fire({textEditor:v.value,visibleRanges:k})}}$acceptEditorPositionData(C){for(const m in C){const v=this.i.getEditor(m);if(!v)throw new Error("Unknown text editor");const k=b.ViewColumn.to(C[m]);v.value.viewColumn!==k&&(v._acceptViewColumn(k),this.d.fire({textEditor:v.value,viewColumn:k}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$7ec=y}),define(Se[340],ke([1,0,2,5,6,3,7,15,26,18]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0,e.$Mgc=(0,O.$1h)("IExtHostTimeline");class R{constructor(v,k){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$FK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&$.$em.equals(d,this.b.get(f.source)?.extension)){const s=f.uri===void 0?void 0:D.URI.revive(f.uri);return this.c.get(f.source)?.get(C(s))?.get(f.handle)}else return;return f}})}async $getTimeline(v,k,f,d){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(k),f,d)}registerTimelineProvider(v,k,f,d){const s=new P.$Rc,i=this.d(k.id,d,s).bind(this);let n;k.onDidChange&&(n=k.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:k.id}),this));const o=this.c;return this.f({...k,scheme:v,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(k.id)?.clear());const h=await k.provideTimeline(a,t,r);if(h==null)return;const u=i(a,t);return{...h,source:k.id,items:h.items.map(u)}},dispose(){for(const a of o.values())a.get(k.id)?.clear();n?.dispose(),s.dispose()}},f)}d(v,k,f){return(d,s)=>{let i;if(s?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const o=C(d);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let r,h,u;n.iconPath&&(o instanceof M.$CL?u={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,h=o):{light:r,dark:h}=o);let c;return M.$9K.isMarkdownString(a.tooltip)?c=b.MarkdownString.from(a.tooltip):(0,y.$Df)(a.tooltip)?c=a.tooltip:M.$9K.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(a.detail)):(0,y.$Df)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:v,command:n.command?k.toInternal(n.command,f):void 0,icon:r,iconDark:h,themeIcon:u,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(v,k){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:k}),(0,P.$Qc)(()=>{for(const d of this.c.values())d.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Ngc=R;function C(m){return m?.toString()}}),define(Se[72],ke([1,0,21,4,3,220,5,14,88,6,27,20,7]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zxb=e.$Yxb=e.TunnelDtoConverter=void 0;class v extends $.$sv{}var k;(function(d){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}d.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}d.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$Yxb=(0,M.$1h)("IExtHostTunnelService");let f=class extends g.$Sc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$FK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$HK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const h of s){const u=this.r.get(h);if(!u)return[];t.push(...await Promise.all(i.map(async c=>{let l;try{l=await u.provider.providePortAttributes({port:c,pid:n,commandLine:o},a)}catch{l=await u.provider.providePortAttributes(c,n,o,a)}return{providedAttributes:l,port:c}})))}const r=t.filter(h=>!!h.providedAttributes);return r.length>0?r.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new D.$3d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,g.$Qc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),k.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Zxb=f,e.$Zxb=f=Ge([We(0,C.$JM),We(1,R.$ZM),We(2,b.$ij)],f)}),define(Se[341],ke([1,0,3,17,2,6]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;class M{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$FK.MainThreadUriOpeners)}registerExternalUriOpener($,y,R,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(v=>!M.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,R),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Qc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,R)}async $openUri($,y,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},R)}}e.$Pgc=M}),define(Se[342],ke([1,0,6,2,3,8,26]),function($e,e,D,O,g,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class b{static{this.a=0}constructor(y){this.c=new M.$fm,this.d=new Map,this.b=y.getProxy(D.$FK.MainThreadUrls)}registerUriHandler(y,R){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,R),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Qc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,R){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(O.URI.revive(R))}catch(m){(0,P.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return O.URI.revive(await this.b.$createAppUri(y))}}e.$Qgc=b}),define(Se[93],ke([1,0,4,3,17,24,2,237,274,113,6]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=e.$ifc=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,a,t,r,h,u,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Sd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=h,this.#n=u,this.#l=m(u),this.#d=v(u),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,y.$8ub)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===g.Schemas.https||o.scheme===g.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+y.$7ub}return y.$7ub}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),P.$jn(this.#s,o)||this.#t.$setOptions(this.#e,d(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,$.$Mkb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,l,S)=>{const L=M.URI.from({scheme:c||"file",path:decodeURIComponent(l)}),w=(0,y.$8ub)(L,{isRemote:a,authority:t}).toString();return`${h}${w}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,l,S)=>{const L=M.URI.from({scheme:c||"file",path:decodeURIComponent(l)}),w=(0,y.$8ub)(L,{isRemote:a,authority:t}).toString();return`${h}${w}${S}`})}}e.$ifc=C;function m(n){try{const o=(0,b.$Yo)((0,b.$Xo)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$jfc=m;function v(n){try{const o=(0,b.$Yo)((0,b.$Xo)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class k extends O.$Sc{constructor(o,a,t,r,h){super(),this.c=a,this.f=t,this.g=r,this.h=h,this.b=new Map,this.a=o.getProxy(R.$FK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:h}=(0,$.$Nkb)(a,t.value);r._onMessageEmitter.fire(h)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new C(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const h=r._onDidDispose(()=>{h.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$kfc=k;function f(n){return{id:n.identifier,location:n.extensionLocation}}e.$lfc=f;function d(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$mfc=d;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>M.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(Se[343],ke([1,0,21,53,3,17,23,2,15,93,110,6,7]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class v{constructor(r,h){this.document=r,this.b=h,this.a=1,this.c=new R.$Nec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,h){await this.f(r).undo(),h||this.disposeBackup()}async redo(r,h){await this.f(r).redo(),h||this.disposeBackup()}disposeEdits(r){for(const h of r)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,M.$Cg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const h=this.c.get(r,0);if(!h)throw new Error("No edit found");return h}}class k{constructor(){this.a=new Map}get(r,h){return this.a.get(this.b(r,h))}add(r,h,u){const c=this.b(r,h.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${h.uri}`);const l=new v(h,u);return this.a.set(c,l),l}delete(r,h){const u=this.b(r,h.uri);this.a.delete(u)}b(r,h){return`${r}@@@${h}`}}var f;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this.a=new Map}addTextProvider(r,h,u){return this.b(0,r,h,u)}addCustomProvider(r,h,u){return this.b(1,r,h,u)}get(r){return this.a.get(r)}b(r,h,u,c){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:r,extension:u,provider:c}),new m.$HK(()=>this.a.delete(h))}}class s{constructor(r,h,u,c,l){this.d=h,this.f=u,this.g=c,this.h=l,this.b=new d,this.c=new k,this.a=r.getProxy(C.$FK.MainThreadCustomEditors)}registerCustomEditorProvider(r,h,u,c){const l=new g.$Rc;return n(u)?(l.add(this.b.addTextProvider(h,r,u)),this.a.$registerTextEditorProvider((0,y.$lfc)(r),h,c.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.$jfc)(r))):(l.add(this.b.addCustomProvider(h,r,u)),i(u)&&l.add(u.onDidChangeCustomDocument(S=>{const L=this.i(h,S.document.uri);if(o(S)){const w=L.addEdit(S);this.a.$onDidEdit(S.document.uri,h,w,S.label)}else this.a.$onContentChange(S.document.uri,h)})),this.a.$registerCustomEditorProvider((0,y.$lfc)(r),h,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,y.$jfc)(r))),m.$HK.from(l,new m.$HK(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(r,h,u,c,l){const S=this.b.get(h);if(!S)throw new Error(`No provider found for '${h}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${h}'`);const L=b.URI.revive(r),w=await S.provider.openCustomDocument(L,{backupId:u,untitledDocumentData:c?.buffer},l);let p;return i(S.provider)&&this.f&&(p=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(h,w,p),{editable:i(S.provider)}}async $disposeCustomDocument(r,h){const u=this.b.get(h);if(!u)throw new Error(`No provider found for '${h}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${h}'`);const c=b.URI.revive(r),{document:l}=this.i(h,c);this.c.delete(h,l),l.dispose()}async $resolveCustomEditor(r,h,u,c,l,S){const L=this.b.get(u);if(!L)throw new Error(`No provider found for '${u}'`);const w=$.ViewColumn.to(l),p=this.g.createNewWebview(h,c.contentOptions,L.extension),E=this.h.createNewWebviewPanel(h,u,c.title,w,c.options,p,c.active),A=b.URI.revive(r);switch(L.type){case 1:{const{document:z}=this.i(u,A);return L.provider.resolveCustomEditor(z,E,S)}case 0:{const z=this.d.getDocument(A);return L.provider.resolveCustomTextEditor(z,E,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,h,u){this.i(h,r).disposeEdits(u)}async $onMoveCustomEditor(r,h,u){const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this.h.getWebviewPanel(r);if(!l)throw new Error("No webview found");const S=b.URI.revive(h),L=this.d.getDocument(S);await c.provider.moveCustomTextEditor(L,l,D.CancellationToken.None)}async $undo(r,h,u,c){return this.i(h,r).undo(u,c)}async $redo(r,h,u,c){return this.i(h,r).redo(u,c)}async $revert(r,h,u){const c=this.i(h,r);await this.j(h).revertCustomDocument(c.document,u),c.disposeBackup()}async $onSave(r,h,u){const c=this.i(h,r);await this.j(h).saveCustomDocument(c.document,u),c.disposeBackup()}async $onSaveAs(r,h,u,c){const l=this.i(h,r);return this.j(h).saveCustomDocumentAs(l.document,b.URI.revive(u),c)}async $backup(r,h,u){const c=this.i(h,r),S=await this.j(h).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},u);return c.updateBackup(S),S.id}i(r,h){const u=this.c.get(r,b.URI.revive(h));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$ofc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,O.$Oi)(r)+""}}),define(Se[344],ke([1,0,4,3,2,30,15,93,6,7]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class R extends O.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(k,f,d,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=f,this.#o=d,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,g.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#s=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:M.ViewColumn.from(k),preserveFocus:!!f})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends O.$Sc{static c(){return(0,P.$lg)()}constructor(k,f,d){super(),this.j=f,this.m=d,this.g=new Map,this.h=new Map,this.f=k.getProxy($.$FK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,f,d,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:M.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,b.$jfc)(k),t=C.c();this.f.$createWebviewPanel((0,b.$lfc)(k),t,f,{title:d,panelOptions:m(i),webviewOptions:(0,b.$mfc)(k,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,f,d,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(k){const f=Object.keys(k);f.sort((d,s)=>{const i=k[d],n=k[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const d of f){const s=this.getWebviewPanel(d);if(!s)continue;const i=k[d];s._updateViewState({active:i.active,visible:i.visible,viewColumn:M.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,f,d){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:d,extension:k}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,b.$jfc)(k)}),new y.$HK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(k,f,d,s){const i=this.h.get(f);if(!i)throw new Error(`No serializer found for '${f}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(k,d.webviewOptions,o),t=this.createNewWebviewPanel(k,f,d.title,s,d.panelOptions,a,d.active);await n.deserializeWebviewPanel(t,d.state)}createNewWebviewPanel(k,f,d,s,i,n,o){const a=new R(k,this.f,n,{viewType:f,title:d,viewColumn:s,panelOptions:i,active:o});return this.g.set(k,a),a}getWebviewPanel(k){return this.g.get(k)}}e.$nfc=C;function m(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Se[345],ke([1,0,4,3,93,15,6,7]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class $ extends O.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,m,v,k,f,d){super(),this.#r=!1,this.#u=this.B(new D.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Sd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=k,this.#e=C,this.#t=m,this.#o=f,this.#n=d}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(M.$FK.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,v,k){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$lfc)(C),m,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$jfc)(C)}),new b.$HK(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,v,k,f){const d=this.b.get(m);if(!d)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=d,n=this.d.createNewWebview(C,{},i),o=new $(C,this.a,m,v,n,!0);this.c.set(C,o),await s.resolveWebviewView(o,{state:k},f)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$Rgc=y}),define(Se[151],ke([1,0,4,6,2,17,13,5,20,25]),function($e,e,D,O,g,P,M,b,$,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(v){const k=this.d;return{get focused(){return k.focused},get active(){return(0,y.$SF)(v,"windowActivity"),k.active}}}constructor(v){this.c=new D.$Sd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=v.getProxy(O.$FK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:f})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,k){k!==this.d[v]&&(this.d={...this.d,[v]:k},this.c.fire(this.d))}openUri(v,k){let f;if(typeof v=="string"){f=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,M.$Ge)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,f,k)}async asExternalUri(v,k){if((0,M.$Ge)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(v,k);return g.URI.from(f)}};e.$Sgc=C,e.$Sgc=C=R=Ge([We(0,$.$JM)],C),e.$Tgc=(0,b.$1h)("IExtHostWindow")}),define(Se[346],ke([1,0,314,27,20]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;const P=1024*1024;let M=class extends D.$Wgc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,R){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const R=process[$],C=R.write;let m="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(v,k,f)=>{if(!this.g){m+=v.toString(k);const d=m.length>P?m.length:m.lastIndexOf(`
`);d!==-1&&(console[y](m.slice(0,d)),m=m.slice(d+1))}C.call(R,v,k,f)}})}};e.$vhc=M,e.$vhc=M=Ge([We(0,g.$JM),We(1,O.$ZM)],M)}),define(Se[347],ke([1,0,71,17,14,249,32,11]),function($e,e,D,O,g,P,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(O.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$whc=$,e.$whc=$=Ge([We(0,D.$ffc),We(1,g.$ij)],$);class y{constructor(C){this.b=C,this.a=new P.$lq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,v){return this.a.writeFile(C,m,{...v,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,v){return this.a.rename(C,m,v)}copy(C,m,v){return this.a.copy(C,m,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(Se[348],ke([1,0,16,63,30,35,3,6,2,20]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;let R=class extends M.$Sc{constructor(m,v){super();const k=m.getProxy(b.$FK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=$.URI.file((0,D.$jc)((0,O.tmpdir)(),(0,g.$lg)()));return await k.$download(f,d),d})}};e.$uhc=R,e.$uhc=R=Ge([We(0,y.$JM),We(1,P.$6M)],R)}),define(Se[349],ke([1,0,150,17,251,30]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class M extends D.$Vgc{s($,y,R){return $.scheme===O.Schemas.file?new g.$VN(R?.name||(0,P.$lg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,y):super.s($,y,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Hhc=M}),define(Se[350],ke([1,0,55,16,2,92,3,17,12,31]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class R extends P.$hfc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==b.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const h=r.fsPath;let u=0;do{let c;u===0?c=h:c=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${u}`:`${h}-${u}`,await C(c);const l=O.$jc(c,"vscode.lock"),S=await f(this.d,l,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),g.URI.file(c);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Ghc=R;async function C(a){try{await y.Promises.stat(a);return}catch{}try{await y.Promises.mkdir(a,{recursive:!0})}catch{}}const m=1e3,v=10*60*1e3;class k extends M.$Sc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new $.$_g),this.a.cancelAndSet(async()=>{const h=await d(t,r);(!h||h.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function f(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const h=await d(a,t);return!h||h.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new k(a,t))}async function d(a,t){let r;try{r=await y.Promises.readFile(t)}catch(h){return a.error(h),null}try{return JSON.parse(String(r))}catch(h){return a.error(h),null}}async function s(a,t){let r;try{r=await y.Promises.stat(t)}catch(h){return a.error(h),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await d(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let S=r.willReleaseAt-Date.now();if(S<5e3){for(S>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,$.$2g)(Math.min(100,S)),await s(a,t)===0)return o(a,t);S=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const h=await s(a,t),u=Date.now()-h;if(u<=v)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$2g)(2e3);const c=await s(a,t),l=Date.now()-c;return l<=v?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return f(a,t,!0)}}),define(Se[351],ke([1,0,30,20,47,35]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;let M=class extends g.$Dfc{constructor($,y){super(!0,$,y)}createTerminal($,y,R){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:R})}createTerminalFromOptions($,y){const R=new g.$Cfc(this.a,(0,D.$lg)(),$,$.name);return this.f.push(R),R.create($,this.R($,y)),R.value}};e.$2gc=M,e.$2gc=M=Ge([We(0,P.$6M),We(1,O.$JM)],M)}),define(Se[352],ke([1,0,12,22,21,8,4,3,130,303,68]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=e.ResponsiveState=e.RequestInitiator=e.$76b=e.$66b=void 0;function m(E,A){try{return JSON.stringify(E,A)}catch{return"null"}}const v="$$ref$$",k={[v]:-1};class f{constructor(A,z){this.jsonString=A,this.referencedBuffers=z}}function d(E,A=null,z=!1){const N=[];return{jsonString:(z?m:JSON.stringify)(E,(j,T)=>{if(typeof T>"u")return k;if(typeof T=="object"){if(T instanceof O.$ge){const F=N.push(T)-1;return{[v]:F}}if(A)return A(j,T)}return T}),referencedBuffers:N}}e.$66b=d;function s(E,A,z){return JSON.parse(E,(N,I)=>{if(I){const j=I[v];if(typeof j=="number")return A[j];if(z&&I.$mid===1)return z.transformIncoming(I)}return I})}e.$76b=s;function i(E,A){return JSON.stringify(E,A)}function n(E){return E?(A,z)=>z&&z.$mid===1?E.transformOutgoing(z):z:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class u extends b.$Sc{static{C=r}static{this.a=3*1e3}constructor(A,z=null,N=null){super(),this[C]=!0,this.b=this.B(new M.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=z,this.g=N,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let I=0,j=R.$zv.count;I<j;I++)this.m[I]=null,this.s[I]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$ah(()=>this.H(),1e3)),this.c.onMessage(I=>this.L(I))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const z=this.w[A];delete this.w[A],z.resolveErr(P.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,$.$Zm)(A,this.g):A}getProxy(A){const{nid:z,sid:N}=A;return this.s[z]||(this.s[z]=this.J(z,N)),this.s[z]}J(A,z){const N={get:(I,j)=>(typeof j=="string"&&!I[j]&&j.charCodeAt(0)===36&&(I[j]=(...T)=>this.U(A,j,T)),j===h?z:I[j])};return new Proxy(Object.create(null),N)}set(A,z){return this.m[A.nid]=z,z}assertRegistered(A){for(let z=0,N=A.length;z<N;z++){const I=A[z];if(!this.m[I.nid])throw new Error(`Missing proxy instance ${I.sid}`)}}L(A){if(this.j)return;const z=A.byteLength,N=l.read(A,0),I=N.readUInt8(),j=N.readUInt32();switch(I){case 1:case 2:{let{rpcId:T,method:F,args:W}=L.deserializeRequestJSONArgs(N);this.g&&(W=(0,$.$Zm)(W,this.g)),this.M(z,j,T,F,W,I===2);break}case 3:case 4:{let{rpcId:T,method:F,args:W}=L.deserializeRequestMixedArgs(N);this.g&&(W=(0,$.$Zm)(W,this.g)),this.M(z,j,T,F,W,I===4);break}case 5:{this.f?.logIncoming(z,j,0,"ack"),this.G(j);break}case 6:{this.N(z,j);break}case 7:{this.O(z,j,void 0);break}case 9:{let T=L.deserializeReplyOKJSON(N);this.g&&(T=(0,$.$Zm)(T,this.g)),this.O(z,j,T);break}case 10:{const T=L.deserializeReplyOKJSONWithBuffers(N,this.g);this.O(z,j,T);break}case 8:{const T=L.deserializeReplyOKVSBuffer(N);this.O(z,j,T);break}case 11:{let T=L.deserializeReplyErrError(N);this.g&&(T=(0,$.$Zm)(T,this.g)),this.P(z,j,T);break}case 12:{this.P(z,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,z,N,I,j,T){this.f?.logIncoming(A,z,1,`receiveRequest ${(0,R.$Bv)(N)}.${I}(`,j);const F=String(z);let W,Y;if(T){const Q=new g.$3d;j.push(Q.token),W=this.Q(N,I,j),Y=()=>Q.cancel()}else W=this.Q(N,I,j),Y=t;this.u[F]=Y;const le=L.serializeAcknowledged(z);this.f?.logOutgoing(le.byteLength,z,1,"ack"),this.c.send(le),W.then(Q=>{delete this.u[F];const Z=L.serializeReplyOK(z,Q,this.h);this.f?.logOutgoing(Z.byteLength,z,1,"reply:",Q),this.c.send(Z)},Q=>{delete this.u[F];const Z=L.serializeReplyErr(z,Q);this.f?.logOutgoing(Z.byteLength,z,1,"replyErr:",Q),this.c.send(Z)})}N(A,z){this.f?.logIncoming(A,z,1,"receiveCancel");const N=String(z);this.u[N]?.()}O(A,z,N){this.f?.logIncoming(A,z,0,"receiveReply:",N);const I=String(z);if(!this.w.hasOwnProperty(I))return;const j=this.w[I];delete this.w[I],j.resolveOk(N)}P(A,z,N){this.f?.logIncoming(A,z,0,"receiveReplyErr:",N);const I=String(z);if(!this.w.hasOwnProperty(I))return;const j=this.w[I];delete this.w[I];let T;N&&(N.$isError?(T=new Error,T.name=N.name,T.message=N.message,T.stack=N.stack):T=N),j.resolveErr(T)}Q(A,z,N){try{return Promise.resolve(this.S(A,z,N))}catch(I){return Promise.reject(I)}}S(A,z,N){const I=this.m[A];if(!I)throw new Error("Unknown actor "+(0,R.$Bv)(A));const j=I[z];if(typeof j!="function")throw new Error("Unknown method "+z+" on actor "+(0,R.$Bv)(A));return j.apply(I,N)}U(A,z,N){if(this.j)return new y.$56b;let I=null;if(N.length>0&&g.CancellationToken.isCancellationToken(N[N.length-1])&&(I=N.pop()),I&&I.isCancellationRequested)return Promise.reject(P.$6());const j=L.serializeRequestArguments(N,this.h),T=++this.t,F=String(T),W=new y.$46b,Y=new b.$Rc;I&&Y.add(I.onCancellationRequested(()=>{const Q=L.serializeCancel(T);this.f?.logOutgoing(Q.byteLength,T,0,"cancel"),this.c.send(L.serializeCancel(T))})),this.w[F]=new c(W,Y),this.F(T);const le=L.serializeRequest(T,A,z,j,!!I);return this.f?.logOutgoing(le.byteLength,T,0,`request: ${(0,R.$Bv)(A)}.${z}(`,N),this.c.send(le),W}}e.$86b=u;class c{constructor(A,z){this.a=A,this.b=z}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class l{static alloc(A,z,N){const I=new l(O.$ge.alloc(N+1+4),0);return I.writeUInt8(A),I.writeUInt32(z),I}static read(A,z){return new l(A,z)}get buffer(){return this.a}constructor(A,z){this.a=A,this.b=z}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+A).toString();return this.b+=A,N}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+A).toString();return this.b+=A,N}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+A);return this.b+=A,z}static sizeMixedArray(A){let z=0;z+=1;for(let N=0,I=A.length;N<I;N++){const j=A[N];switch(z+=1,j.type){case 1:z+=this.sizeLongString(j.value);break;case 2:z+=this.sizeVSBuffer(j.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(j.value);for(let T=0;T<j.buffers.length;++T)z+=this.sizeVSBuffer(j.buffers[T]);break;case 4:break}}return z}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let z=0,N=A.length;z<N;z++){const I=A[z];switch(I.type){case 1:this.writeUInt8(1),this.writeLongString(I.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(I.value);break;case 3:this.writeUInt8(3),this.writeUInt32(I.buffers.length),this.writeLongString(I.value);for(let j=0;j<I.buffers.length;++j)this.writeBuffer(I.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const z=new Array(A);for(let N=0;N<A;N++)switch(this.readUInt8()){case 1:z[N]=this.readLongString();break;case 2:z[N]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),T=this.readLongString(),F=[];for(let W=0;W<j;++W)F.push(this.readVSBuffer());z[N]=new R.$Cv(s(T,F,null));break}case 4:z[N]=void 0;break}return z}}var S;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(S||(S={}));class L{static a(A){for(let z=0,N=A.length;z<N;z++)if(A[z]instanceof O.$ge||A[z]instanceof R.$Cv||typeof A[z]>"u")return!0;return!1}static serializeRequestArguments(A,z){if(this.a(A)){const N=[];for(let I=0,j=A.length;I<j;I++){const T=A[I];if(T instanceof O.$ge)N[I]={type:2,value:T};else if(typeof T>"u")N[I]={type:4};else if(T instanceof R.$Cv){const{jsonString:F,referencedBuffers:W}=d(T.value,z);N[I]={type:3,value:O.$ge.fromString(F),buffers:W}}else N[I]={type:1,value:O.$ge.fromString(i(T,z))}}return{type:1,args:N}}return{type:0,args:i(A,z)}}static serializeRequest(A,z,N,I,j){switch(I.type){case 0:return this.b(A,z,N,I.args,j);case 1:return this.c(A,z,N,I.args,j)}}static b(A,z,N,I,j){const T=O.$ge.fromString(N),F=O.$ge.fromString(I);let W=0;W+=l.sizeUInt8(),W+=l.sizeShortString(T),W+=l.sizeLongString(F);const Y=l.alloc(j?2:1,A,W);return Y.writeUInt8(z),Y.writeShortString(T),Y.writeLongString(F),Y.buffer}static deserializeRequestJSONArgs(A){const z=A.readUInt8(),N=A.readShortString(),I=A.readLongString();return{rpcId:z,method:N,args:JSON.parse(I)}}static c(A,z,N,I,j){const T=O.$ge.fromString(N);let F=0;F+=l.sizeUInt8(),F+=l.sizeShortString(T),F+=l.sizeMixedArray(I);const W=l.alloc(j?4:3,A,F);return W.writeUInt8(z),W.writeShortString(T),W.writeMixedArray(I),W.buffer}static deserializeRequestMixedArgs(A){const z=A.readUInt8(),N=A.readShortString(),I=A.readMixedArray(),j=new Array(I.length);for(let T=0,F=I.length;T<F;T++){const W=I[T];typeof W=="string"?j[T]=JSON.parse(W):j[T]=W}return{rpcId:z,method:N,args:j}}static serializeAcknowledged(A){return l.alloc(5,A,0).buffer}static serializeCancel(A){return l.alloc(6,A,0).buffer}static serializeReplyOK(A,z,N){if(typeof z>"u")return this.d(A);if(z instanceof O.$ge)return this.e(A,z);if(z instanceof R.$Cv){const{jsonString:I,referencedBuffers:j}=d(z.value,N,!0);return this.g(A,I,j)}else return this.f(A,m(z,N))}static d(A){return l.alloc(7,A,0).buffer}static e(A,z){let N=0;N+=l.sizeVSBuffer(z);const I=l.alloc(8,A,N);return I.writeVSBuffer(z),I.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,z){const N=O.$ge.fromString(z);let I=0;I+=l.sizeLongString(N);const j=l.alloc(9,A,I);return j.writeLongString(N),j.buffer}static g(A,z,N){const I=O.$ge.fromString(z);let j=0;j+=l.sizeUInt32,j+=l.sizeLongString(I);for(const F of N)j+=l.sizeVSBuffer(F);const T=l.alloc(10,A,j);T.writeUInt32(N.length),T.writeLongString(I);for(const F of N)T.writeBuffer(F);return T.buffer}static deserializeReplyOKJSON(A){const z=A.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(A,z){const N=A.readUInt32(),I=A.readLongString(),j=[];for(let T=0;T<N;++T)j.push(A.readVSBuffer());return new R.$Cv(s(I,j,z))}static serializeReplyErr(A,z){const N=z?m(P.$3(z),null):void 0;if(typeof N!="string")return this.h(A);const I=O.$ge.fromString(N);let j=0;j+=l.sizeLongString(I);const T=l.alloc(11,A,j);return T.writeLongString(I),T.buffer}static deserializeReplyErrError(A){const z=A.readLongString();return JSON.parse(z)}static h(A){return l.alloc(12,A,0).buffer}}var w;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var p;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[353],ke([1,0,4,37,46,5]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$1J=e.OutputChannelUpdateMode=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=void 0,e.$QJ="text/x-code-output",e.$RJ="output",e.$SJ="Log",e.$TJ="text/x-code-log-output",e.$UJ="log",e.$VJ="workbench.panel.output",e.$WJ=new g.$fj("inOutput",!1),e.$XJ=new g.$fj("activeLogOutput",!1),e.$YJ=new g.$fj("outputView.scrollLock",!1),e.$ZJ=(0,P.$1h)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$1J={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(R=>y.push(R)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}O.$rn.add(e.$1J.OutputChannels,new b),e.$2J=new g.$fj("activeOutputChannel","")}),define(Se[152],ke([1,0,6,5,20,26,14,353,71,27,57,181,22,18,32,4,3]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;class s extends M.$oj{get disposed(){return this.n}constructor(a,t,r,h,u){super(),this.id=a,this.name=t,this.r=r,this.s=h,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=m.$ge.fromString(t).byteLength,(0,M.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,h,u,c){this.i=t,this.j=r,this.k=h,this.l=u,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$FK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,u=(0,v.$Df)(t)?t:void 0;if((0,v.$Df)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const l=this.i.environment.extensionLogLevel?.find(([L])=>P.$em.equals(r.identifier,L))?.[1];l&&(c=(0,M.$yj)(l));const S=h?this.o(a,c,r):this.n(a,u,r);return S.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),h?this.r(a,c??this.m.getLevel(),S):this.q(a,S)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,u=this.k.extUri.joinPath(h,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(a,u,t,r.identifier.value);return new s(l,a,c,this.a,r)}async o(a,t,r){const h=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(h,`${u}.log`),l=`${r.identifier.value}.${u}`,S=this.l.createLogger(c,{id:l,name:a,logLevel:t,extensionId:r.identifier.value});return new i(l,a,S,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(h){if((0,k.$zk)(h)!==k.FileSystemProviderErrorCode.FileExists)throw h}return r})())}return t}q(a,t){let r=!1;const h=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){h(),t.then(c=>c.append(u))},appendLine(u){h(),t.then(c=>c.appendLine(u))},clear(){h(),t.then(u=>u.clear())},replace(u){h(),t.then(c=>c.replace(u))},show(u,c){h(),t.then(l=>l.show(u,c))},hide(){h(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const h=new d.$Rc,u=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},c=h.add(new f.$Sd);function l(S){t=S,c.fire(S)}return r.then(S=>{h.add(S),S.logLevel!==t&&l(S.logLevel),h.add(S.onDidChangeLogLevel(L=>l(L)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(S,...L){u(),r.then(w=>w.trace(S,...L))},debug(S,...L){u(),r.then(w=>w.debug(S,...L))},info(S,...L){u(),r.then(w=>w.info(S,...L))},warn(S,...L){u(),r.then(w=>w.warn(S,...L))},error(S,...L){u(),r.then(w=>w.error(S,...L))},dispose(){h.dispose()}}}};e.$sgc=n,e.$sgc=n=Ge([We(0,g.$JM),We(1,y.$ZM),We(2,$.$ffc),We(3,R.$Rec),We(4,M.$jj),We(5,M.$ij)],n),e.$tgc=(0,O.$1h)("IExtHostOutputService")}),define(Se[153],ke([1,0,5,12]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=void 0,e.$Em=(0,D.$1h)("remoteAgentService"),e.$Fm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let P=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,O.$2g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(P):M=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:P,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof M>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>M*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[354],ke([1,0,223,86,37,40,45,3,4,153,11,24]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=void 0,e.$uH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$vH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$wH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$xH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const v=new m;g.$rn.add(e.$xH.ConfigurationMigration,v);let k=class extends b.$Sc{constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of o){const r=[];for(const u of n.overrideIdentifiers??[]){const c=await this.h(s,{resource:i,overrideIdentifier:u},a);for(const l of c??[]){let S=r.find(([[L,w]])=>L===l[0]&&(0,C.$jn)(w.value,l[1].value));S||r.push(S=[l,[]]),S[1].push(u)}}const h=await this.h(s,{resource:i},a,n);for(const u of h??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,c],l])=>this.a.updateValue(u,c.value,{resource:i,overrideIdentifiers:l},t)))}}async h(s,i,n,o){const a=(o??this.a.inspect(s.key,i))[n];if(a===void 0)return;const t=h=>this.a.inspect(h,i)[n],r=await s.migrateFn(a,t);return Array.isArray(r)?r:[[s.key,r]]}};e.$yH=k,e.$yH=k=Ge([We(0,M.$ui),We(1,P.$0h)],k);let f=class extends b.$Sc{constructor(s){super(),(async()=>{if(!R.$i&&(await s.getEnvironment())?.os!==1)return;g.$rn.as(O.$wn.Configuration).registerConfiguration({...e.$wH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$zH=f,e.$zH=f=Ge([We(0,y.$Em)],f)}),define(Se[355],ke([1,0,34,17,16,23,232,354,86,5,37]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcb=e.$Wcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Vcb=e.$Ucb=void 0,e.$Ucb=(0,y.$1h)("editorResolverService"),e.$Vcb="workbench.editorAssociations";const C=R.$rn.as($.$wn.Configuration),m={...b.$vH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var v;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(v||(e.RegisteredEditorPriority=v={}));var k;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function f(s){switch(s){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Wcb=f;function d(s,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$zg)(i);return D.$Gj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$Xcb=d}),define(Se[356],ke([1,0,33,17,16,11,23,2,5,267,40,144,153]),function($e,e,D,O,g,P,M,b,$,y,R,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$iK=e.$hK=void 0,e.$hK=(0,$.$1h)("pathService");let k=v=class{constructor(d,s,i,n){this.d=d,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??d})()}hasValidBasename(d,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(d,n,s)):this.h(d,s,i)}h(d,s,i){return d.scheme===O.Schemas.file||d.scheme===O.Schemas.vscodeRemote?(0,D.$1f)(i??(0,M.$zg)(d),s===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,s){if(d.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,y.$eK)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:O.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?g.$fc:g.$gc)}async fileURI(d){let s="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const n=d.indexOf("/",2);n===-1?(s=d.substring(2),d="/"):(s=d.substring(2,n),d=d.substring(n)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:s,path:d,query:"",fragment:""})}};e.$iK=k,e.$iK=k=v=Ge([We(1,m.$Em),We(2,C.$3J),We(3,R.$0h)],k)}),define(Se[357],ke([1,0,234,19,59,4,53,3,2,45,239,14,64,269,88,40,144,25,21,18,24,46]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=e.$_J=e.OnPortForward=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.TunnelSource=e.TunnelCloseReason=e.$6J=e.$5J=e.$4J=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$4J="onTunnel",e.$5J=new a.$fj("forwardedPortsViewEnabled",!1,D.localize(0,null));function h(z){const N=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$6J=h;var u;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var c;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$7J={source:c.User,description:D.localize(1,null)},e.$8J={source:c.Auto,description:D.localize(2,null)};function l(z,N,I){const j=z.get(L(N,I));if(j)return j;if((0,k.$ov)(N))for(const T of k.$nv){const F=L(T,I);if(z.has(F))return z.get(F)}else if((0,k.$qv)(N))for(const T of k.$pv){const F=L(T,I);if(z.has(F))return z.get(F)}}e.$9J=l;function S(z,N,I){const j=l(z,N,I);if(j)return j;const T=(0,k.$qv)(N)?"localhost":(0,k.$ov)(N)?"0.0.0.0":void 0;if(T)return l(z,T,I)}e.$0J=S;function L(z,N){return z+":"+N}e.$$J=L;var w;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(w||(e.OnPortForward=w={}));function p(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$_J=p;class E extends b.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.r=N,this.j=[],this.n=new P.$Sd,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(I=>{(I.affectsConfiguration(E.c)||I.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,I,j){let T=this.w(N,I,j,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;T>=0;){const W=this.j[T];W.key===N?(F.onAutoForward=W.onAutoForward??F.onAutoForward,F.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:F.elevateIfNeeded,F.label=W.label??F.label,F.requireLocalPort=W.requireLocalPort,F.protocol=W.protocol):(F.onAutoForward=F.onAutoForward??W.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:W.elevateIfNeeded,F.label=F.label??W.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??W.protocol),T=this.w(N,I,j,this.j,T+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,n.$Df)(N.host)&&(0,n.$Hf)(N.port)}w(N,I,j,T,F){if(F>=T.length)return-1;const W=!(0,k.$ov)(I)&&!(0,k.$qv)(I),le=T.slice(F).findIndex(Q=>(0,n.$Hf)(Q.key)?W?!1:Q.key===N:this.t(Q.key)?W?!1:N>=Q.key.start&&N<=Q.key.end:this.u(Q.key)?N===Q.key.port&&I===Q.key.host:j?Q.key.test(j):!1);return le>=0?le+F:-1}y(){const N=this.r.getValue(E.c);if(!N||!(0,n.$Ff)(N))return[];const I=[];for(const T in N){if(T===void 0)continue;const F=N[T];let W;if(Number(T))W=Number(T);else if((0,n.$Df)(T))if(E.g.test(T)){const Y=T.match(E.g);W={start:Number(Y[1]),end:Number(Y[2])}}else if(E.h.test(T)){const Y=T.match(E.h);W={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(T)}catch{}Y&&(W=Y)}W&&I.push({key:W,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(I)}z(N){function I(j,T){return(0,n.$Hf)(j.key)?j.key:T.t(j.key)?j.key.start:T.u(j.key)?j.key.port:Number.MAX_VALUE}return N.sort((j,T)=>I(j,this)-I(T,this))}C(){return this.m}static providedActionToAction(N){switch(N){case k.ProvidedOnAutoForward.Notify:return w.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return w.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return w.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return w.OpenPreview;case k.ProvidedOnAutoForward.Silent:return w.Silent;case k.ProvidedOnAutoForward.Ignore:return w.Ignore;default:return}}async addAttributes(N,I,j){const F=this.r.inspect(E.c).userRemoteValue;let W;!F||!(0,n.$Ff)(F)?W={}:W=(0,o.$fn)(F),W[`${N}`]||(W[`${N}`]={});for(const Y in I)W[`${N}`][Y]=I[Y];return this.r.updateValue(E.c,W,j)}}e.$aK=E;let A=class extends b.$Sc{constructor(N,I,j,T,F,W,Y,le,Q,Z){super(),this.H=N,this.I=I,this.J=j,this.L=T,this.M=F,this.N=W,this.O=Y,this.P=le,this.Q=Q,this.R=Z,this.c=new Map,this.g=new P.$Sd,this.onForwardPort=this.g.event,this.h=new P.$Sd,this.onClosePort=this.h.event,this.j=new P.$Sd,this.onPortName=this.j.event,this.n=new P.$Sd,this.onCandidatesChanged=this.n.event,this.t=new P.$Sd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Sd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const oe=await this.getAttributes(x.map(X=>({port:X.tunnelRemotePort,host:X.tunnelRemoteHost})));for(const X of x)if(X.localAddress){const ve=L(X.tunnelRemoteHost,X.tunnelRemotePort),ge=S(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort);this.forwarded.set(ve,{remotePort:X.tunnelRemotePort,remoteHost:X.tunnelRemoteHost,localAddress:X.localAddress,protocol:oe?.get(X.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(X.localAddress,oe?.get(X.tunnelRemotePort)),localPort:X.tunnelLocalPort,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:X.privacy,source:e.$7J}),this.f.set(ve,X)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const oe=L(x.tunnelRemoteHost,x.tunnelRemotePort);if(!S(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const X=S(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),ve=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:ve?.protocol??k.TunnelProtocol.Http,localUri:await this.X(x.localAddress,ve),localPort:x.tunnelLocalPort,closeable:!0,runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,privacy:x.privacy,source:e.$7J})}await this.$(),this.f.set(oe,x),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(x=>this.W(x,u.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$4J))?(this.R.createKey(e.$5J.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,I){const j=L(N.host,N.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(N))}X(N,I){if(N.startsWith("http"))return $.URI.parse(N);const j=I?.protocol??"http";return $.URI.parse(`${j}://${N}`)}async Y(){const N=this.N.getWorkspace(),I=N.configuration?(0,M.$Oi)(N.configuration.path):N.folders.length>0?(0,M.$Oi)(N.folders[0].uri.path):void 0;if(I===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${I}`}async Z(){const N=this.I.get(r,1);if(N)return this.I.remove(r,1),await this.$(),N;const I=await this.Y();if(I)return this.I.get(I,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const I=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${I.map(j=>j.remotePort).join(", ")}`);for(const j of I){const T=S(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!T||j.source.source===c.Extension&&T?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!T&&this.D.set(L(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Y();this.w=this.B(new b.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async I=>{I.key===N&&(this.s=Promise.resolve(this.I.get(N,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.y){this.y=N;const I=await this.Y();I&&this.I.store(I,this.y,0,0)}}}async bb(N,I,j){if(!N.tunnelLocalPort||!j?.requireLocalPort||N.tunnelLocalPort===I)return;const T=new Date;if(this.ab.getTime()+t>T.getTime())return;this.ab=T;const F=D.localize(3,null,I,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(F)}async forward(N,I){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.cb(N,I)}async cb(N,I){await this.Q.activateByEvent(e.$4J);const j=S(this.forwarded,N.remote.host,N.remote.port);I=I??(I!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const T=N.local!==void 0?N.local:N.remote.port;let F;if(j)return this.eb(j,N,I);{const W=this.L.remoteAuthority,Y=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,le=L(N.remote.host,N.remote.port);this.c.set(le,!0),N=this.db(le,N);const Q=await this.H.openTunnel(Y,N.remote.host,N.remote.port,void 0,T,N.elevateIfNeeded?N.elevateIfNeeded:I?.elevateIfNeeded,N.privacy,I?.protocol);if(typeof Q=="string")F=Q;else if(Q&&Q.localAddress){const Z=S(this.m??new Map,N.remote.host,N.remote.port),x=Q.protocol?Q.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:I?.protocol??k.TunnelProtocol.Http,oe={remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localPort:Q.tunnelLocalPort,name:I?.label??N.name,closeable:!0,localAddress:Q.localAddress,protocol:x,localUri:await this.X(Q.localAddress,I),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:N.source??e.$7J,privacy:Q.privacy};return this.forwarded.set(le,oe),this.f.set(le,Q),this.c.delete(le),await this.$(),await this.bb(Q,T,I),this.g.fire(oe),Q}this.c.delete(le)}return F}db(N,I){const j=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(j){const T=j.get(N);j.delete(N),T&&(I.name=T.name??I.name,I.local=("local"in T?T.local:"localPort"in T?T.localPort:void 0)??I.local,I.privacy=T.privacy??I.privacy)}return I}async eb(N,I,j){const T=j?.label??I.name;let F;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(F||(F={}));let W=F.None;switch(T!==N.name&&(N.name=T,W=F.Fire),(j?.protocol||N.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==N.protocol&&(I.source=N.source,W=F.Reopen),I.privacy&&N.privacy!==I.privacy&&(W=F.Reopen),W){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(N.remoteHost,N.remotePort,u.User),await this.cb(I,j)}return S(this.f,I.remote.host,I.remote.port)}async name(N,I,j){const T=S(this.forwarded,N,I),F=L(N,I);if(T){T.name=j,await this.$(),this.j.fire({host:N,port:I});return}else this.detected.has(F)&&(this.detected.get(F).name=j,this.j.fire({host:N,port:I}))}async close(N,I,j){const T=L(N,I),F=this.forwarded.get(T);return j===u.AutoForwardEnd&&F&&F.source.source===c.Auto&&this.F.set(T,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(N,I),this.W({host:N,port:I},j)}address(N,I){const j=L(N,I);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const I of N){const j=S(this.m??new Map,I.remoteAddress.host,I.remoteAddress.port),T=typeof I.localAddress=="string"?I.localAddress:L(I.localAddress.host,I.localAddress.port);this.detected.set(L(I.remoteAddress.host,I.remoteAddress.port),{remoteHost:I.remoteAddress.host,remotePort:I.remoteAddress.port,localAddress:T,protocol:k.TunnelProtocol.Http,localUri:this.X(T),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(I.remoteAddress.host,I.remoteAddress.port,T,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let I=N;this.r&&(I=await this.r(N));const j=this.fb(I);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(T=>T.port).join(", ")}`),this.n.fire(j)}fb(N){const I=this.m??new Map,j=new Map;return this.m=j,N.forEach(T=>{const F=L(T.host,T.port);j.set(F,{host:T.host,port:T.port,detail:T.detail,pid:T.pid}),I.has(F)&&I.delete(F);const W=S(this.forwarded,T.host,T.port);W&&(W.runningProcess=T.detail,W.hasRunningProcess=!0,W.pid=T.pid)}),I.forEach((T,F)=>{const W=h(F);if(!W)return;const Y=S(this.forwarded,W.host,W.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const le=S(this.detected,W.host,W.port);le&&(le.runningProcess=void 0,le.hasRunningProcess=!1,le.pid=void 0)}),I}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const N=Array.from(this.forwarded.values()),I=await this.getAttributes(N.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(I)for(const j of N){const T=I.get(j.remotePort);(T?.protocol||j.protocol!==k.TunnelProtocol.Http)&&T?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},T),T&&T.label&&T.label!==j.name&&await this.name(j.remoteHost,j.remotePort,T.label)}}async getAttributes(N,I=!0){const j=new Map,T=new Map;N.forEach(Q=>{const Z=S(this.m??new Map,k.$nv[0],Q.port)??Q;if(Z){j.set(Q.port,Z);const x=p(Z)?Z.pid:void 0;T.has(x)||T.set(x,[]),T.get(x)?.push(Q.port)}});const F=new Map;if(N.forEach(Q=>{const Z=this.configPortsAttributes.getAttributes(Q.port,Q.host,j.get(Q.port)?.detail);Z&&F.set(Q.port,Z)}),this.G.length===0||!I)return F.size>0?F:void 0;const W=await Promise.all((0,O.$Rb)(this.G.map(Q=>Array.from(T.entries()).map(Z=>{const x=Z[1],oe=j.get(x[0]);return Q.providePortAttributes(x,oe?.pid,oe?.detail,new i.$3d().token)})))),Y=new Map;if(W.forEach(Q=>Q.forEach(Z=>{Z&&Y.set(Z.port,Z)})),!F&&!Y)return;const le=new Map;return N.forEach(Q=>{const Z=F.get(Q.port),x=Y.get(Q.port);le.set(Q.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??E.providedActionToAction(x?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),le}addAttributesProvider(N){this.G.push(N)}};e.$bK=A,Ge([(0,g.$th)(1e3)],A.prototype,"$",null),e.$bK=A=Ge([We(0,k.$jv),We(1,v.$ep),We(2,y.$ui),We(3,d.$3J),We(4,m.$1k),We(5,f.$0h),We(6,C.$ij),We(7,R.$Ov),We(8,s.$OF),We(9,a.$gj)],A)}),define(Se[94],ke([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$WI=e.$VI=void 0;class D{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new D(0,0)}with(M){return new D(0,0)}}e.$VI=D;class O{constructor(M,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(M,b),this.end=new D($,y)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new O(0,0,0,0)}with(M){return new O(0,0,0,0)}}e.$WI=O;var g;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Se[36],ke([1,0,19,34,24,33,13,5,16,8,94,12]),function($e,e,D,O,g,P,M,b,$,y,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.SearchErrorCode=e.$_I=e.$$I=e.SearchSortOrder=e.ViewMode=e.$0I=e.$9I=e.$8I=e.$7I=e.SearchCompletionExitCode=e.$6I=e.$5I=e.$4I=e.QueryType=e.SearchProviderType=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$XI="workbench.view.search",e.$YI="workbench.panel.search",e.$ZI="workbench.view.search",e.$1I="search-result",e.$2I="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",k=(m.length+v.length+5)*2;e.$3I=(0,b.$1h)("searchService");var f;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(f||(e.SearchProviderType=f={}));var d;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(d||(e.QueryType=d={}));function s(x){return!!x.preview}e.$4I=s;function i(x){return!!x.resource}e.$5I=i;function n(x){return!!x.message}e.$6I=n;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(oe){this.resource=oe,this.results=[]}}e.$7I=a;class t{constructor(oe,X,ve,ge){this.ranges=X,this.webviewIndex=ge;const H=Array.isArray(X)?X:[X];if(ve&&ve.matchLines===1&&r(H)){oe=(0,M.$wf)(oe,ve.matchLines);let U="",ne=0,ye=0;const fe=Math.floor(ve.charsPerLine/5),me=[];for(const ee of H){const ie=Math.max(ee.startColumn-fe,0),G=ee.startColumn+ve.charsPerLine;if(ie>ye+fe+k){const te=m+(ie-ye)+v;U+=te+oe.slice(ie,G),ne+=ie-(ye+te.length)}else U+=oe.slice(ye,G);me.push(new u(0,ee.startColumn-ne,ee.endColumn-ne)),ye=G}this.preview={text:U,matches:Array.isArray(this.ranges)?me:me[0]}}else{const U=Array.isArray(X)?X[0].startLineNumber:X.startLineNumber;this.preview={text:oe,matches:(0,D.$2b)(X,ne=>new h(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$8I=t;function r(x){const oe=x[0].startLineNumber;for(const X of x)if(X.startLineNumber!==oe||X.endLineNumber!==oe)return!1;return!0}class h{constructor(oe,X,ve,ge){this.startLineNumber=oe,this.startColumn=X,this.endLineNumber=ve,this.endColumn=ge}}e.$9I=h;class u extends h{constructor(oe,X,ve){super(oe,X,oe,ve)}}e.$0I=u;var c;(function(x){x.List="list",x.Tree="tree"})(c||(e.ViewMode=c={}));var l;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function S(x,oe=!0){const X=x&&x.files&&x.files.exclude,ve=oe&&x&&x.search&&x.search.exclude;if(!X&&!ve)return;if(!X||!ve)return X||ve;let ge=Object.create(null);return ge=g.$in(ge,g.$fn(X)),ge=g.$in(ge,g.$fn(ve),!0),ge}e.$$I=S;function L(x,oe){return x.excludePattern&&O.$Gj(x.excludePattern,oe)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&O.$Gj(x.includePattern,oe)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(X=>{const ve=X.folder.fsPath;if(P.$3f(oe,ve)){const ge=$.$lc(ve,oe);return!X.includePattern||!!O.$Gj(X.includePattern,ge)}else return!1}):!1:!0}e.$_I=L;var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class p extends Error{constructor(oe,X){super(oe),this.code=X}}e.$aJ=p;function E(x){const oe=x.message;if((0,y.$4)(x))return new p(oe,w.canceled);try{const X=JSON.parse(oe);return new p(X.message,X.code)}catch{return new p(oe,w.other)}}e.$bJ=E;function A(x){const oe={message:x.message,code:x.code};return new Error(JSON.stringify(oe))}e.$cJ=A;function z(x){return x.type==="error"?!0:x.type==="success"}e.$dJ=z;function N(x){return x.type==="success"}e.$eJ=N;function I(x){return!!x.path}e.$fJ=I;function j(x,oe){const X=x.searchPath?x.searchPath:x.relativePath;return(0,M.$tf)(X,oe)}e.$gJ=j;class T{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$hJ=T;function F(x,oe){const X={...x||{},...oe||{}};return Object.keys(X).filter(ve=>{const ge=X[ve];return typeof ge=="boolean"&&ge})}e.$iJ=F;class W{constructor(oe,X){this.c=null,this.a={...oe.excludePattern||{},...X.excludePattern||{}},this.b=O.$Hj(this.a);let ve=oe.includePattern;X.includePattern&&(ve?ve={...ve,...X.includePattern}:ve=X.includePattern),ve&&(this.c=O.$Hj(ve))}matchesExcludesSync(oe,X,ve){return!!(this.b&&this.b(oe,X,ve))}includedInQuerySync(oe,X,ve){return!(this.b&&this.b(oe,X,ve)||this.c&&!this.c(oe,X,ve))}includedInQuery(oe,X,ve){const ge=this.b(oe,X,ve),H=()=>this.c?!!this.c(oe,X,ve):!0;return(0,C.$Ng)(ge)?ge.then(U=>U?!1:H()):H()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$jJ=W;function Y(x){for(const oe in x)if(typeof x[oe]!="boolean")return!0;return!1}function le(x){if(!x)return;let oe;return X=>(oe||(oe=(x()||Promise.resolve([])).then(ve=>ve?Z(ve):{})),oe.then(ve=>!!ve[X]))}e.$kJ=le;function Q(x){if(!x)return;let oe;return X=>{if(!oe){const ve=x();oe=ve?Z(ve):{}}return!!oe[X]}}e.$lJ=Q;function Z(x){const oe={};for(const X of x)oe[X]=!0;return oe}}),define(Se[41],ke([1,0,19,12,21,4,3,77,17,122,23,13,2,221,5,14,252,40,57,27,20,15,7,66,36,6,54]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=void 0;function l(N,I,j){return new R.$rg(T=>p(T,j)).isEqual(N,I)}function S(N,I,j){return l(N.uri,I.uri,j)?0:(0,C.$Ze)(N.uri.toString(),I.uri.toString())}function L(N,I,j){return N.index!==I.index?N.index<I.index?-1:1:l(N.uri,I.uri,j)?(0,C.$Ze)(N.name,I.name):(0,C.$Ze)(N.uri.toString(),I.uri.toString())}function w(N,I,j,T){const F=N.slice(0).sort((Y,le)=>j(Y,le,T)),W=I.slice(0).sort((Y,le)=>j(Y,le,T));return(0,D.$Eb)(F,W,(Y,le)=>j(Y,le,T))}function p(N,I){const j=I.getCapabilities(N.scheme);return!(j&&j&1024)}class E extends s.$hi{static toExtHostWorkspace(I,j,T,F){if(!I)return{workspace:null,added:[],removed:[]};const{id:W,name:Y,folders:le,configuration:Q,transient:Z,isUntitled:x}=I,oe=[],X=j;j?le.forEach((U,ne)=>{const ye=m.URI.revive(U.uri),fe=E.o(T||j,ye,F);fe?(fe.name=U.name,fe.index=U.index,oe.push(fe)):oe.push({uri:ye,name:U.name,index:ne})}):oe.push(...le.map(({uri:U,name:ne,index:ye})=>({uri:m.URI.revive(U),name:ne,index:ye}))),oe.sort((U,ne)=>U.index<ne.index?-1:1);const ve=new E(W,Y,oe,!!Z,Q?m.URI.revive(Q):null,!!x,U=>p(U,F)),{added:ge,removed:H}=w(X?X.workspaceFolders:[],ve.workspaceFolders,S,F);return{workspace:ve,added:ge,removed:H}}static o(I,j,T){for(let F=0;F<I.folders.length;F++){const W=I.workspaceFolders[F];if(l(W.uri,j,T))return W}}constructor(I,j,T,F,W,Y,le){super(I,T.map(Q=>new s.$ii(Q)),F,W,le),this.t=j,this.u=Y,this.q=[],this.s=b.$7h.forUris(le),T.forEach(Q=>{this.q.push(Q),this.s.set(Q.uri,Q)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(I,j){return j&&this.s.get(I)&&(I=(0,R.$Bg)(I)),this.s.findSubstr(I)}resolveWorkspaceFolder(I){return this.s.get(I)}}let A=class{constructor(I,j,T,F,W){this.c=new P.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new P.$Ud,this.B=new Map,this.h=F,this.s=T,this.t=W,this.j=new y.$2l,this.k=new O.$Zg,this.o=I.getProxy(u.$FK.MainThreadWorkspace),this.q=I.getProxy(u.$FK.MainThreadMessageService);const Y=j.workspace;this.l=Y?new E(Y.id,Y.name,[],!!Y.transient,Y.configuration?m.URI.revive(Y.configuration):null,!!Y.isUntitled,le=>p(le,T)):void 0}$initializeWorkspace(I,j){this.v=j,this.$acceptWorkspaceData(I),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,R.$zg)((0,R.$Bg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(I,j,T,...F){const W=[];if(Array.isArray(F)&&F.forEach(x=>{m.URI.isUri(x.uri)&&!W.some(oe=>l(oe.uri,x.uri,this.s))&&W.push({uri:x.uri,name:x.name||(0,R.$yg)(x.uri)})}),this.n||[j,T].some(x=>typeof x!="number"||x<0)||T===0&&W.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(j+T>Y.length)return!1;const le=Y.slice(0);le.splice(j,T,...W.map(x=>({uri:x.uri,name:x.name||(0,R.$yg)(x.uri),index:void 0})));for(let x=0;x<le.length;x++){const oe=le[x];if(le.some((X,ve)=>ve!==x&&l(oe.uri,X.uri,this.s)))return!1}le.forEach((x,oe)=>x.index=oe);const{added:Q,removed:Z}=w(Y,le,L,this.s);if(Q.length===0&&Z.length===0)return!1;if(this.o){const x=I.displayName||I.name;this.o.$updateWorkspaceFolders(x,j,T,W).then(void 0,oe=>{this.n=void 0;const X={source:{identifier:I.identifier,label:I.displayName||I.name}};this.q.$showMessage(d.Severity.Error,(0,v.localize)(0,null,x,oe.toString()),X,[])})}return this.y(le),!0}getWorkspaceFolder(I,j){if(this.x)return this.x.getWorkspaceFolder(I,j)}async getWorkspaceFolder2(I,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(I,j)}async resolveWorkspaceFolder(I){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(I)}getPath(){if(!this.x)return;const{folders:I}=this.x;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,j){let T,F="";if(typeof I=="string"?(T=m.URI.file(I),F=I):typeof I<"u"&&(T=I,F=I.fsPath),!T)return F;const W=this.getWorkspaceFolder(T,!0);if(!W)return F;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let Y=(0,R.$Eg)(W.uri,T);return j&&W.name&&(Y=`${W.name}/${Y}`),Y}y(I){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:I,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:j,added:T,removed:F}=E.toExtHostWorkspace(I,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:F}))}findFiles(I,j,T,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let Y;if(j===null?Y=!1:j&&(typeof j=="string"?Y=j:Y=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Q}=z(a.GlobPattern.from(I));return this.o.$startFileSearch(le??null,Q??null,Y??null,T??null,W).then(Z=>Array.isArray(Z)?Z.map(x=>m.URI.revive(x)):[])}async findTextInFiles(I,j,T,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),le=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Q,folder:Z}=z(a.GlobPattern.from(j.include)),x=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,oe={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:le,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Q,excludePattern:x},X=!1;if(this.u[Y]=ve=>{if(X)return;const ge=m.URI.revive(ve.resource);ve.results.forEach(H=>{const U=(0,c.$xh)(H);(0,h.$4I)(U)?T({uri:ge,preview:{text:U.preview.text,matches:(0,D.$2b)(U.preview.matches,ne=>new t.$JK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$2b)(U.ranges,ne=>new t.$JK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):T({uri:ge,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(I,Z??null,oe,Y,W);return delete this.u[Y],ve||{}}catch(ve){throw delete this.u[Y],ve}}$handleTextSearchResult(I,j){this.u[j]?.(I)}async save(I){const j=await this.o.$save(I,{saveAs:!1});return m.URI.revive(j)}async saveAs(I){const j=await this.o.$save(I,{saveAs:!0});return m.URI.revive(j)}saveAll(I){return this.o.$saveAll(I)}resolveProxy(I){return this.o.$resolveProxy(I)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(I){return this.o.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(I,j){if(this.w.has(I))throw new Error(`A provider has already been registered for scheme ${I}`);this.w.set(I,j);const T=this.t.transformOutgoingScheme(I),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,T),(0,M.$Qc)(()=>{this.w.delete(I),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(I,j){this.h.info("Getting edit session identifier for workspaceFolder",I);const T=await this.resolveWorkspaceFolder(m.URI.revive(I));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const F=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(T,j);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(I,j,T,F){this.h.info("Getting edit session identifier for workspaceFolder",I);const W=await this.resolveWorkspaceFolder(m.URI.revive(I));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const Y=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!Y),!Y)return;const le=await Y.provideEditSessionIdentityMatch?.(j,T,F);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(I){return(j,T,F)=>{const W=function(le){j.call(T,le)};return W.extension=I,this.A.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(I,j,T){const F=await this.resolveWorkspaceFolder(m.URI.revive(I));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},j,async(W,Y)=>{const le=Date.now();await Promise.resolve(W),Date.now()-le>T&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(I,j){if(this.B.has(I))throw new Error(`A provider has already been registered for scheme ${I}`);this.B.set(I,j);const T=this.t.transformOutgoingScheme(I),F=this.z++;return this.o.$registerCanonicalUriProvider(F,T),(0,M.$Qc)(()=>{this.B.delete(I),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(I,j,T){const F=this.B.get(I.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(m.URI.revive(I),j,T);if(W)return W}async $provideCanonicalUri(I,j,T){return this.provideCanonicalUri(m.URI.revive(I),{targetScheme:j},T)}};e.$_ec=A,e.$_ec=A=Ge([We(0,o.$JM),We(1,n.$ZM),We(2,i.$Rec),We(3,f.$ij),We(4,r.$0ec)],A),e.$afc=(0,k.$1h)("IExtHostWorkspace");function z(N){let I,j;return N&&(typeof N=="string"?I=N:(I=N.pattern,j=m.URI.revive(N.baseUri))),{includePattern:I,folder:j}}}),define(Se[42],ke([1,0,24,4,41,6,7,254,86,18,12,5,20,14,2]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=e.$bfc=void 0;function f(r,h){if(h){const u=h.split(".");let c=r;for(let l=0;c&&l<u.length;l++)c=c[u[l]];return c}}function d(r){return r instanceof k.URI}function s(r){return r&&r.uri instanceof k.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof k.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(d(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(h,u,c){this.a=h.getProxy(P.$FK.MainThreadConfiguration),this.c=u,this.b=c,this.d=new R.$Zg,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,u){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(h,u))}};e.$bfc=a,e.$bfc=a=Ge([We(0,m.$JM),We(1,g.$afc),We(2,v.$ij)],a);class t{constructor(h,u,c,l){this.a=new O.$Sd,this.b=h,this.f=l,this.c=u,this.e=b.$Pn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,u){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Pn.parse(h),this.d=this.k(h.configurationScopes),this.a.fire(this.j(u,c))}getConfiguration(h,u,c){const l=o(u)||{},S=this.g(h?f(this.e.getValue(void 0,l,this.c.workspace),h):this.e.getValue(void 0,l,this.c.workspace));h&&this.h(h,l,c?.identifier);function L(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(p){return typeof f(S,p)<"u"},get:(p,E)=>{this.h(h?`${h}.${p}`:p,l,c?.identifier);let A=f(S,p);if(typeof A>"u")A=E;else{let z;const N=(I,j)=>{if((0,y.$Ff)(I)){let T;const F=()=>{z=z||(0,D.$fn)(S),T=T||f(z,j)};return new Proxy(I,{get:(W,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return F(),()=>T;if(z)return T=T||f(z,j),T[Y];const le=W[Y];return typeof Y=="string"?N(le,`${j}.${Y}`):le},set:(W,Y,le)=>(F(),T&&(T[Y]=le),!0),deleteProperty:(W,Y)=>(F(),T&&delete T[Y],!0),defineProperty:(W,Y,le)=>(F(),T&&Object.defineProperty(T,Y,le),!0)})}return Array.isArray(I)?(0,D.$fn)(I):I};A=N(A,p)}return A},update:(p,E,A,z)=>{p=h?`${h}.${p}`:p;const N=L(A);return E!==void 0?this.b.$updateConfigurationOption(N,p,E,l,z):this.b.$removeConfigurationOption(N,p,l,z)},inspect:p=>{p=h?`${h}.${p}`:p;const E=this.e.inspect(p,l,this.c.workspace);if(E)return{key:p,defaultValue:(0,D.$fn)(E.policy?.value??E.default?.value),globalValue:(0,D.$fn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$fn)(E.workspace?.value),workspaceFolderValue:(0,D.$fn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$fn)(E.default?.override),globalLanguageValue:(0,D.$fn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$fn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$fn)(E.workspaceFolder?.override),languageIds:(0,D.$fn)(E.overrideIdentifiers)}}};return typeof S=="object"&&(0,D.$in)(w,S,!1),Object.freeze(w)}g(h){const u=c=>(0,y.$Ff)(c)?new Proxy(c,{get:(l,S)=>u(l[S]),set:(l,S,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(l,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(l,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return u(h)}h(h,u,c){const l=$.$Gn.test(h)?4:this.d.get(h),S=c?`[${c.value}] `:"";if(l===4){typeof u?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){u?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,u){const c=new b.$Rn(h,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,S)=>c.affectsConfiguration(l,o(S))})}k(h){return h.reduce((u,c)=>(u.set(c[0],c[1]),u),new Map)}}e.$cfc=t,e.$dfc=(0,C.$1h)("IExtHostConfiguration")}),define(Se[95],ke([1,0,2,12,4,6,7,41,69,42,21,47,20,27,5,17,11,14,91,302,8]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=e.$Egc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(N){function I(T){if(T!=null)return T}N.from=I;function j(T){if(T!=null)return T}N.to=j})(a||(a={}));var t;(function(N){function I(T){if(T!=null)return T}N.from=I;function j(T){if(T!=null)return T}N.to=j})(t||(t={}));var r;(function(N){function I(T){if(T!=null)return T}N.from=I;function j(T){if(T!=null)return T}N.to=j})(r||(r={}));var h;(function(N){function I(F){if(F){const W=F;return W&&!!W.process}else return!1}N.is=I;function j(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=r.from(F.options)),W}N.from=j;function T(F){if(F!=null)return new M.$qL(F.process,F.args,F.options)}N.to=T})(h||(h={}));var u;(function(N){function I(T){if(T!=null)return T}N.from=I;function j(T){if(T!=null)return T}N.to=j})(u||(u={}));var c;(function(N){function I(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}N.is=I;function j(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=u.from(F.options)),W}N.from=j;function T(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new M.$rL(F.commandLine,F.options):new M.$rL(F.command,F.args?F.args:[],F.options)}N.to=T})(c||(c={}));var l;(function(N){function I(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}N.is=I;function j(F){return{customExecution:"customExecution"}}N.from=j;function T(F,W){return W.get(F)}N.to=T})(l||(e.CustomExecutionDTO=l={}));var S;(function(N){function I(j,T){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===M.TaskScope.Workspace&&T&&T.workspaceFile?F=T.workspaceFile:F=n.$bG),{id:j._id,workspaceFolder:F}}N.from=I})(S||(e.TaskHandleDTO=S={}));var L;(function(N){function I(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=I})(L||(L={}));var w;(function(N){function I(F,W){if(F==null)return[];const Y=[];for(const le of F){const Q=j(le,W);Q&&Y.push(Q)}return Y}N.fromMany=I;function j(F,W){if(F==null)return;let Y;F.execution instanceof M.$qL?Y=h.from(F.execution):F.execution instanceof M.$rL?Y=c.from(F.execution):F.execution&&F.execution instanceof M.$sL&&(Y=l.from(F.execution));const le=a.from(F.definition);let Q;return F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=M.TaskScope.Workspace,!le||!Q?void 0:{_id:F._id,definition:le,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:Q},execution:Y,isBackground:F.isBackground,group:L.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=j;async function T(F,W,Y){if(F==null)return;let le;h.is(F.execution)?le=h.to(F.execution):c.is(F.execution)?le=c.to(F.execution):l.is(F.execution)&&(le=l.to(F._id,Y));const Q=a.to(F.definition);let Z;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Z=F.source.scope:Z=await W.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):Z=M.TaskScope.Workspace),!Q||!Z)return;const x=new M.$tL(Q,Z,F.name,F.source.label,le,F.problemMatchers);return F.isBackground!==void 0&&(x.isBackground=F.isBackground),F.group!==void 0&&(x.group=M.$pL.from(F.group._id),x.group&&F.group.isDefault&&(x.group=new M.$pL(x.group.id,x.group.label),F.group.isDefault===!0&&(x.group.isDefault=F.group.isDefault))),F.presentationOptions&&(x.presentationOptions=t.to(F.presentationOptions)),F._id&&(x._id=F._id),F.detail&&(x.detail=F.detail),x}N.to=T})(w||(e.TaskDTO=w={}));var p;(function(N){function I(T){return T}N.from=I;function j(T){if(T)return Object.assign(Object.create(null),T)}N.to=j})(p||(p={}));class E{#e;constructor(I,j,T){this._id=j,this.a=T,this.#e=I}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(I){}fireDidEndProcess(I){}}let A=class{constructor(I,j,T,F,W,Y,le,Q){this.q=new g.$Sd,this.r=new g.$Sd,this.s=new g.$Sd,this.t=new g.$Sd,this.a=I.getProxy(P.$FK.MainThreadTask),this.b=T,this.c=F,this.d=W,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(I,j,T){if(!T)return new M.$HK(()=>{});const F=this.w();return this.j.set(F,{type:j,provider:T,extension:I}),this.a.$registerTaskProvider(F,j),new M.$HK(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(I,j){this.a.$registerTaskSystem(I,j)}fetchTasks(I){return this.a.$fetchTasks(p.from(I)).then(async j=>{const T=[];for(const F of j){const W=await w.to(F,this.b,this.m);W&&T.push(W)}return T})}get taskExecutions(){const I=[];return this.k.forEach(j=>I.push(j)),I}terminateTask(I){if(!(I instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(I._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(I,j,T){const F=this.m.get(I.id);F&&(this.o.set(I.id,F),this.e.attachPtyToTerminal(j,await F.callback(T))),this.p=I.id,this.q.fire({execution:await this.y(I)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(I){const j=await this.y(I);this.l.delete(I.id),this.k.delete(I.id),this.A(I),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(I){const j=await this.y(I.id);this.s.fire({execution:j,processId:I.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(I){const j=await this.y(I.id);this.t.fire({execution:j,exitCode:I.exitCode})}$provideTasks(I,j){const T=this.j.get(I);if(!T)return Promise.reject(new Error("no handler found"));const F=[],W=(0,O.$Tg)(()=>T.provider.provideTasks(R.CancellationToken.None)).then(Y=>this.u(j,F,T,Y));return new Promise(Y=>{W.then(le=>{Promise.all(F).then(()=>{Y(le)})})})}async $resolveTask(I,j){const T=this.j.get(I);if(!T)return Promise.reject(new Error("no handler found"));if(j.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${T.type}].`);const F=await w.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await T.provider.resolveTask(F,R.CancellationToken.None);if(!W)return;this.z(W,T);const Y=w.from(W,T.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(Y.execution)&&await this.x(Y,W,!0),await this.v(Y)}w(){return this.h++}async x(I,j,T){const F=await this.a.$createTaskId(I);!T&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async y(I,j){if(typeof I=="string"){const W=this.l.get(I);if(!W)throw new o.$bb("Unexpected: The specified task is missing an execution");return W}const T=this.l.get(I.id);if(T)return T;const F=new Promise((W,Y)=>{function le(Q,Z,x){x?W(new E(Q,Z.id,x)):Y("Unexpected: Task does not exist.")}j?le(this,I,j):w.to(I.task,this.b,this.m).then(Q=>le(this,I,Q))});return this.l.set(I.id,F),F.then(W=>(this.k.set(I.id,W),W),W=>Promise.reject(W))}z(I,j){I._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(I){this.o.get(I.id)&&this.o.delete(I.id),this.n.has(I.id)&&this.p!==I.id&&(this.m.delete(I.id),this.n.delete(I.id));const T=this.n.values();let F=T.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=T.next()}};e.$Egc=A,e.$Egc=A=Ge([We(0,m.$JM),We(1,v.$ZM),We(2,b.$afc),We(3,$.$UM),We(4,y.$dfc),We(5,C.$Bfc),We(6,s.$ij),We(7,i.$Uec)],A);let z=class extends A{constructor(I,j,T,F,W,Y,le,Q){super(I,j,T,F,W,Y,le,Q),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.$h(0)})}async executeTask(I,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const T=w.from(j,I);if(T===void 0)throw new Error("Task is not valid");if(l.is(T.execution))await this.x(T,j,!1);else throw new o.$_;const F=await this.y(await this.a.$getTaskExecution(T),j);return this.a.$executeTask(T).catch(W=>{throw new Error(W)}),F}u(I,j,T,F){const W=[];if(F)for(const Y of F){if(this.z(Y,T),!Y.definition||!I[Y.definition.type]){const Q=Y.source?Y.source:"No task source";this.f.warn(`The task [${Q}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=w.from(Y,T.extension);le&&l.is(le.execution)?(W.push(le),j.push(this.x(le,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:T.extension}}async v(I){if(l.is(I.execution))return I;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(I,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(I,j,T){}};e.$Fgc=z,e.$Fgc=z=Ge([We(0,m.$JM),We(1,v.$ZM),We(2,b.$afc),We(3,$.$UM),We(4,y.$dfc),We(5,C.$Bfc),We(6,s.$ij),We(7,i.$Uec)],z),e.$Ggc=(0,k.$1h)("IExtHostTask")}),define(Se[358],ke([1,0,36,29]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=void 0;function g(M){return"cellResults"in M}e.$rJ=g,e.$sJ="rawCell#";function P(M,b){let $=-1;const y=[];let R=[];return M.forEach(m=>{m.range.startLineNumber!==$&&R.length>0&&(y.push([...R]),R=[]),R.push(m),$=m.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(m=>{const v=[],k=m[0].range.startLineNumber,f=m[m.length-1].range.endLineNumber;for(let d=k;d<=f;d++)v.push(b.getLineContent(d));return new D.$8I(v.join(`
`)+`
`,m.map(d=>new O.$Es(d.range.startLineNumber-1,d.range.startColumn-1,d.range.endLineNumber-1,d.range.endColumn-1)))})}e.$tJ=P}),define(Se[359],ke([1,0,214,22,4,3,28,13,18,2,32,110,6,35,15,7,68,294,146,8,24,17,286,358,355]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,S,L,w,p,E){this.q=L,this.r=w,this.s=p,this.t=E,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new g.$Sd({onListenerError:n.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Sd({onListenerError:n.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Sd({onListenerError:n.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Sd({onListenerError:n.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Nec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(m.$FK.MainThreadNotebook),this.c=l.getProxy(m.$FK.MainThreadNotebookDocuments),this.d=l.getProxy(m.$FK.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===13){const z=A.notebookEditor?.notebookUri,N=A.cell.handle,j=this.g.get(z)?.getCell(N);if(j)return j.apiCell}if(A&&A.$mid===14){const z=A.uri,N=this.g.get(z);if(N)return N.apiNotebook}return A}}),u.B(S)}getEditorById(l){const S=this.h.get(l);if(!S)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(l){for(const[S,L]of this.h)if(L.apiEditor===l)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,S){const L=this.g.get(l);if(!L&&!S)throw new Error(`NO notebook document for '${l}'`);return L}static u(l,S){if(!S)return;const L=S.filenamePattern.map(w=>k.NotebookExclusiveDocumentPattern.from(w)).filter(w=>w!==void 0);if(S.filenamePattern&&!L){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:S.displayName,filenamePattern:L,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,S,L){const w=u.a++,p=typeof L.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(w,L),this.b.$registerNotebookCellStatusBarItemProvider(w,p,S);let E;return p!==void 0&&(E=L.onDidChangeCellStatusBarItems(A=>this.b.$emitCellStatusBarEvent(p))),new f.$HK(()=>{this.f.delete(w),this.b.$unregisterNotebookCellStatusBarItemProvider(w,p),E?.dispose()})}async createNotebookDocument(l){const S=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&k.NotebookData.from(l.content)});return y.URI.revive(S)}async openNotebookDocument(l){const S=this.g.get(l);if(S)return S.apiNotebook;const L=await this.c.$tryOpenNotebook(l),w=this.g.get(y.URI.revive(L));return(0,$.$Of)(w?.apiNotebook)}async showNotebookDocument(l,S){y.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let L;typeof S=="object"?L={position:k.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(k.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:L={preserveFocus:!1};const w=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,L),p=w&&this.h.get(w)?.apiEditor;if(p)return p;throw w?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,S,L,w){const p=this.f.get(l),E=y.URI.revive(S),A=this.g.get(E);if(!A||!p)return;const z=A.getCellFromIndex(L);if(!z)return;const N=await p.provideCellStatusBarItems(z.apiCell,w);if(!N)return;const I=new P.$Rc,j=this.p.add([I]),F=(Array.isArray(N)?N:[N]).map(W=>k.NotebookStatusBarItem.from(W,this.i,I));return{cacheId:j,items:F}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,S,L,w,p){if((0,b.$Ge)(S))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:S,serializer:L,options:w}),this.b.$registerNotebookSerializer(E,{id:l.identifier,location:l.extensionLocation},S,k.NotebookDocumentContentOptions.from(w),u.u(l,p)),(0,P.$Qc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(l,S,L){const w=this.x.get(l);if(!w)throw new Error("NO serializer found");const p=await w.serializer.deserializeNotebook(S.buffer,L);return new d.$Cv(k.NotebookData.from(p))}async $notebookToData(l,S,L){const w=this.x.get(l);if(!w)throw new Error("NO serializer found");const p=await w.serializer.serializeNotebook(k.NotebookData.to(S.value),L);return O.$ge.wrap(p)}async $saveNotebook(l,S,L,w,p){const E=y.URI.revive(S),A=this.x.get(l);if(!A)throw new Error("NO serializer found");const z=this.g.get(E);if(!z)throw new Error("Document NOT found");if(z.versionId!==L)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new R.$Ek((0,D.localize)(0,null,this.z(E)),6);await this.y(E,w);const N={metadata:(0,o.$nn)(z.apiNotebook.metadata,W=>!(A.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of z.apiNotebook.getCells()){const Y=new f.$7L(W.kind,W.document.getText(),W.document.languageId,W.mime,A.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);Y.metadata=(0,o.$nn)(W.metadata,le=>!(A.options?.transientCellMetadata??{})[le]),N.cells.push(Y)}const I=await A.serializer.serializeNotebook(N,p);await this.s.value.writeFile(E,I);const j=this.s.getFileSystemProviderExtUri(E.scheme),T=await this.s.value.stat(E);return{name:j.basename(E),isFile:(T.type&R.FileType.File)!==0,isDirectory:(T.type&R.FileType.Directory)!==0,isSymbolicLink:(T.type&R.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((T.permissions??0)&R.FilePermission.Locked),etag:R.$Pk({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(l,S,L,w,p){const E=this.x.get(l)?.serializer;if(!E)return{limitHit:!1,results:[]};const A=new M.$Bc;await(async(T,F,W)=>{await Promise.all(T.map(async Y=>await Promise.all(Y.filenamePatterns.map(le=>{const Q={...W,type:1,filePattern:le};return this.t.doInternalFileSearchWithCustomCallback(Q,F,Z=>{Z.forEach(x=>{A.has(x)||w.some(X=>Y.isFromSettings&&!X.isFromSettings?!1:X.filenamePatterns.some(ve=>(0,h.$Xcb)(ve,x)))||A.add(x)})})}))))})(L,p,S);const N=new M.$Ac;let I=!1;const j=Array.from(A).map(async T=>{const F=[];try{if(p.isCancellationRequested)return;if(S.maxResults&&[...N.values()].reduce((Q,Z)=>Q+Z.cellResults.length,0)>S.maxResults){I=!0;return}const W=[],Y=this.g.get(T);if(Y)Y.apiNotebook.getCells().forEach(Z=>W.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(x=>x.items.map(oe=>oe.data.toString()))}));else{const Q=await this.s.value.readFile(T),Z=O.$ge.fromString(Q.toString()),x=await E.deserializeNotebook(Z.buffer,p);if(p.isCancellationRequested)return;k.NotebookData.from(x).cells.forEach(X=>W.push({input:X.source,outputs:X.outputs.flatMap(ve=>ve.items.map(ge=>ge.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((Q,Z)=>{const x=S.contentPattern.pattern,oe=new t.$QPb(Q.input,void 0,Q.outputs),X=oe.findInInputs(x),ve=oe.findInOutputs(x),ge=ve.flatMap(H=>(0,r.$tJ)(H.matches,H.textBuffer)).map((H,U)=>(H.webviewIndex=U,H));if(X.length>0||ve.length>0){const H={index:Z,contentResults:(0,r.$tJ)(X,oe.inputTextBuffer),webviewResults:ge};F.push(H)}});const le={resource:T,cellResults:F};N.set(T,le);return}catch{return}});return await Promise.all(j),{limitHit:I,results:[...N.values()]}}async y(l,S){const L=await this.s.value.stat(l);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==R.$Ok&&typeof L.mtime=="number"&&typeof L.size=="number"&&S.mtime<L.mtime&&S.etag!==R.$Pk({mtime:S.mtime,size:L.size}))throw new R.$Ek((0,D.localize)(1,null),3,S)}z(l){return l.scheme===a.Schemas.file?l.fsPath:l.toString()}A(l,S,L){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const w=new i.$0fc(S,this.d,l,L.visibleRanges.map(k.NotebookRange.to),L.selections.map(k.NotebookRange.to),typeof L.viewColumn=="number"?k.ViewColumn.to(L.viewColumn):void 0);this.h.set(S,w)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const L of l.value.removedDocuments){const w=y.URI.revive(L),p=this.g.get(w);p&&(p.dispose(),this.g.delete(w),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(p.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===w.toString()&&this.h.delete(E.id)}if(l.value.addedDocuments){const L=[];for(const w of l.value.addedDocuments){const p=y.URI.revive(w.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const E=new s.$9fc(this.c,this.q,this.r,p,w);L.push(...w.cells.map(A=>s.$8fc.asModelAddData(E.apiNotebook,A))),this.g.get(p)?.dispose(),this.g.set(p,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this.m.fire(E.apiNotebook)}}if(l.value.addedEditors)for(const L of l.value.addedEditors){if(this.h.has(L.id))return;const w=y.URI.revive(L.documentUri),p=this.g.get(w);p&&this.A(p,L.id,L)}const S=[];if(l.value.removedEditors)for(const L of l.value.removedEditors){const w=this.h.get(L);w&&(this.h.delete(L),this.k?.id===w.id&&(this.k=void 0),S.push(w))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(w=>this.h.get(w)).filter(w=>!!w);const L=new Set;this.l.forEach(w=>L.add(w.id));for(const w of this.h.values()){const p=L.has(w.id);w._acceptVisibility(p)}this.l=[...this.h.values()].map(w=>w).filter(w=>w.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const S=v.$8M.String.with("notebookType","A notebook type"),L=new v.$0M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$8M("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>O.$ge.wrap(p))],new v.$9M("Notebook Data",p=>k.NotebookData.to(p.value))),w=new v.$0M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$8M("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new d.$Cv(k.NotebookData.from(p)))],new v.$9M("Bytes",p=>p.buffer));l.registerApiCommand(L),l.registerApiCommand(w)}}e.$ggc=u}),define(Se[360],ke([1,0,16,21,44,34,23,38,36]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class y{constructor(m,v,k){this.k=m,this.l=v,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&P.$Hj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&P.$Hj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((k,f)=>{const d=s=>{this.f++,m(s)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(d,{base:s,basename:n})}),Promise.all(v.map(s=>this.p(s,d))).then(s=>{k({limitHit:this.e,stats:s[0]||void 0})},s=>{f(new Error((0,g.$Li)(s)))})})}async p(m,v){const k=new O.$3d,f=this.q(m),d=this.r(),s=new $.$jJ(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=b.$Od.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,k.token),a=n.elapsed(),t=b.$Od.create();return this.g&&!this.e||(o&&o.forEach(r=>{const h=D.$gc.relative(m.folder.path,r.path);if(i){const u=D.$nc(r.path);this.v(v,{base:m.folder,relativePath:h,basename:u});return}this.s(d,m.folder,h,v)}),this.g&&!this.e)?null:(this.u(d,s,v),{providerTime:a,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(m){const v=(0,$.$iJ)(this.k.includePattern,m.includePattern),k=(0,$.$iJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:k,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,k,f){if(k===this.a){const s=D.$nc(this.a);this.v(f,{base:v,relativePath:this.a,basename:s})}function d(s){const i=D.$nc(s),n=D.$mc(s);let o=m[n];o||(o=m[n]=[],d(n)),o.push({base:v,relativePath:s,basename:i})}d(k)}u({rootEntries:m,pathToEntries:v},k,f){const d=this,s=this.a;function i(n){const o=(0,$.$lJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:h,basename:u}=r;if(k.matchesExcludesSync(h,u,s!==u?o:void 0))continue;const c=v[h];if(c)i(c);else{if(h===s)continue;d.v(f,r)}if(d.e)break}}i(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,v,k,f){const d=this.c(m.cacheKey),s=new y(m,v,d&&d.token);let i=0;const n=o=>{i+=o.length,k(o.map(a=>this.d(a)))};return this.e(s,R.a,n,f).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new O.$3d),this.b.get(m)}d(m){return m.relativePath?{resource:M.$Cg(m.base,m.relativePath)}:{resource:m.base}}e(m,v,k,f){const d=f.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),v>0&&i.length>=v&&(k(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&k(i),d.dispose(),n),n=>(i.length&&k(i),d.dispose(),Promise.reject(n)))}}e.$$fc=R}),define(Se[361],ke([1,0,19,73,34,102,28,17,16,23,13,18,2,99,235,45,14,40,143,356,36]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kK=e.$jK=void 0;let a=class{constructor(p,E,A,z,N){this.a=p,this.b=E,this.c=A,this.d=z,this.e=N}text(p,E,A={}){p=this.f(p,A);const z=this.a.getValue(),N=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(s.$ji),A),type:2,contentPattern:p,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:z.search.usePCRE2||N||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(p,E){const A=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const z={...p,wordSeparators:A.editor.wordSeparators};return this.j(p,E)&&(z.isCaseSensitive=!0),this.k(p)&&(z.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),z}file(p,E={}){return{...this.h(p,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(p,E){return p?(p=Array.isArray(p)?p.map(c):c(p),E?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],E={}){const A=this.g(E.includePattern,E.expandPatterns),z=this.g(E.excludePattern,E.expandPatterns),N=p.length>1,I=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(F=>this.q(F,E,z)):p.map(F=>this.r(F,E,z,N))).filter(F=>!!F),j={_reason:E._reason,folderQueries:I,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:z.pattern,includePattern:A.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const F=D.$Hb(D.$Rb(this.c.groups.map(le=>le.editors.map(Q=>Q.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(le=>(0,o.$_I)(j,le.fsPath)),Y=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...j,...Y}}const T=E.extraFileResources&&E.extraFileResources.filter(F=>(0,o.$_I)(j,F.fsPath));return j.extraFileResources=T&&T.length?T:void 0,j}i(p){const E=[],A=new M.$Ac,z={};let N=!1;return p.forEach(I=>{if(I.scheme===b.Schemas.walkThrough)return;if((0,y.$Gg)(I)){const T=this.b.getWorkspaceFolder(I)?.uri??I.with({path:$.$mc(I.fsPath)});let F=A.get(T);F||(N=!0,F={folder:T,includePattern:{}},E.push(F),A.set(T,F));const W=$.$lc(T.fsPath,I.fsPath);(0,C.$Of)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else I.fsPath&&(N=!0,z[I.fsPath]=!0)}),{folderQueries:E,includePattern:z,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(p,E){if(E.isSmartCase){if(p.isRegExp){if(R.$uf(p.pattern,!0))return!0}else if(R.$uf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$IB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const E=Y=>$.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),z=(Array.isArray(p)?p:h(p)).map(Y=>{const le=this.e.resolvedUserHome;return le?(0,P.$Hv)(Y,le.scheme===b.Schemas.file?le.fsPath:le.path):Y}),N=O.$K(z,Y=>E(Y)?"searchPaths":"exprSegments"),I=(N.exprSegments||[]).map(Y=>R.$Pe(Y,"/")).map(Y=>R.$Pe(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),u(Y))),j={},T=this.m(N.searchPaths||[]);T&&T.length&&(j.searchPaths=T);const F=D.$Rb(I),W=r(...F);return W&&(j.pattern=W),j}l(p,E){return E.disregardExcludeSettings?void 0:(0,o.$$I)(p,!E.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const E=p.flatMap(z=>{let{pathPortion:N,globPortion:I}=t(z);return I&&(I=l(I)),this.n(N).flatMap(T=>this.o(T,I))}),A=new Map;return E.forEach(z=>{const N=z.searchPath.toString(),I=A.get(N);I?z.pattern&&(I.pattern=I.pattern||{},I.pattern[z.pattern]=!0):A.set(N,{searchPath:z.searchPath,pattern:z.pattern?r(z.pattern):void 0})}),Array.from(A.values())}n(p){if($.$ic(p)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:p})}]:[{searchPath:m.URI.file($.$hc(p))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const z=$.$gc.resolve(E.path,p);return[{searchPath:E.with({path:z})}]}const A=l(p);return[{searchPath:E,pattern:A}]}else{if(p==="./"||p===".\\")return[];{const E=p.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(N=>{const I=E.match(new RegExp(`^${R.$Ke(N.name)}(?:/(.*)|$)`));return I?{match:I,folder:N}:null}).filter(C.$Lf);if(z.length)return z.map(N=>{const I=N.match[1];return{searchPath:N.folder.uri,pattern:I&&l(I)}});{const N=p.match(/\.[\/\\](.+)[\/\\]?/),I=N?N[1]:p,j=k.localize(0,null,I);throw new Error(j)}}}}o(p,E){const A=p.pattern&&E?`${p.pattern}/${E}`:p.pattern||E,z=[{searchPath:p.searchPath,pattern:A}];return A&&!A.endsWith("**")&&z.push({searchPath:p.searchPath,pattern:A+"/**"}),z}q(p,E,A){const z=this.r((0,s.$ji)(p.searchPath),E,A,!1);return z?{...z,includePattern:p.pattern}:null}r(p,E,A,z){let N;const I=m.URI.isUri(p)?p:p.uri;if(A.searchPaths){const Y=A.searchPaths.filter(le=>(0,y.$vg)(le.searchPath,I))[0];if(Y&&!Y.pattern)return null;Y&&(N=Y.pattern)}const j=this.a.getValue({resource:I}),F={...this.l(j,E)||{},...N||{}},W=m.URI.isUri(p)?(0,y.$zg)(p):p.name;return{folder:I,folderName:z?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$jK=a,e.$jK=a=Ge([We(0,f.$ui),We(1,s.$0h),We(2,i.$NC),We(3,d.$ij),We(4,n.$hK)],a);function t(w){const p=w.match(/[\*\{\}\(\)\[\]\?]/);if(p){const E=p.index,A=w.substr(0,E).match(/[/|\\][^/\\]*$/);if(A){let z=w.substr(0,A.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:w.substr((A.index||0)+1)}}}return{pathPortion:w}}function r(...w){return w.length?w.reduce((p,E)=>(p[E]=!0,p),Object.create(null)):void 0}function h(w){return g.$Fj(w,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(w){return[`**/${w}/**`,`**/${w}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function l(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(w){return w.replace(/([?*[\]])/g,"[$1]")}function L(w,p){w=D.$Mb(w,z=>z.toString());const E=[],A=p.getWorkspace();return w&&w.forEach(z=>{let N;if(p.getWorkbenchState()===2)N=(0,y.$Eg)(A.folders[0].uri,z),N&&N!=="."&&(N="./"+N);else{const I=p.getWorkspaceFolder(z);if(I){const j=I.name;if(A.folders.filter(F=>F.name===j).length===1){const F=(0,y.$Eg)(I.uri,z);F===""?N=`./${I.name}`:N=`./${I.name}/${F}`}else N=z.fsPath}}N&&E.push(S(N))}),E}e.$kK=L}),define(Se[362],ke([1,0,23,2,21,8,5,361,36,40]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3rb=e.$2rb=void 0;const R=7e3;function C(f,d){const s=d.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const c=u.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||f.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,c)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>m(f,u,t))).then(()=>{}),h=v(f,d.identifier,n,t);return Promise.all([r,h]).then(()=>{o(void 0)}),a}e.$2rb=C;async function m(f,d,s){for(const i of f.folders)if(await f.exists(D.$Cg(O.URI.revive(i),d))){s(`workspaceContains:${d}`);return}}async function v(f,d,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new g.$3d,o=f.checkExists(f.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let t=!1;try{t=await o}catch(r){P.$4(r)||P.$1(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function k(f,d,s,i){const n=f.get(M.$Zh),o=f.get($.$3I),t=n.createInstance(b.$jK).file(d.map(r=>(0,y.$ji)(O.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>P.$4(r)?!1:Promise.reject(r))}e.$3rb=k}),define(Se[48],ke([1,0,211,16,56,23,12,3,77,2,14,6,42,292,118,41,25,145,8,26,22,271,7,64,5,27,92,20,107,72,47,4,362,117,273,17,115,38,11,116]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h,u,c,l,S,L,w,p,E,A,z,N,I,j,T,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=e.$Ofc=e.$Nfc=e.$Mfc=void 0,e.$Mfc=(0,h.$1h)("IHostUtils");let Y=W=class extends b.$Sc{constructor(H,U,ne,ye,fe,me,ee,ie,G,te,J,ce){super(),this.X=ce,this.a=this.B(new p.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=ee,this.j=ye,this.m=fe,this.s=me,this.t=G,this.u=te,this.w=J,this.y=this.g.getProxy(C.$FK.MainThreadWorkspace),this.z=this.g.getProxy(C.$FK.MainThreadTelemetry),this.C=this.g.getProxy(C.$FK.MainThreadExtensionService),this.D=new M.$Zg,this.F=new M.$Zg,this.G=new M.$Zg,this.H=new M.$Zg,this.I=new ve(this.f.extensions.activationEvents),this.L=new s.$Z6b(this.I,this.f.extensions.allExtensions);const be=new n.$fm(this.f.extensions.myExtensions);this.J=new s.$Z6b(this.I,oe(this.L,be)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new k.$xfc(this.g,this.s),this.N=new A.$Ffc(this.g),this.O=ie,this.h=H.createChild(new S.$Yh([k.$yfc,this.M],[A.$Gfc,this.N])),this.P=this.B(new v.$wfc(this.J,this.L,{onExtensionActivationError:(Ie,Fe,B)=>{this.C.$onExtensionActivationError(Ie,i.$3(Fe),B)},actualActivateExtension:async(Ie,Fe)=>{if(s.$Z6b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Fe),new v.$vfc;const B=this.J.getExtensionDescription(Ie);return this.db(B,Fe)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){i.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this.cb(fe))}catch{}await Promise.all(H)}terminate(H,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.Y();Promise.race([(0,M.$2g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const U=await this.C.$getExtension(H);return U&&{...U,identifier:new n.$em(U.identifier.value),extensionLocation:y.URI.revive(U.extensionLocation)}}Z(H,U){return this.P.activateByEvent(H,U)}$(H,U){return this.P.activateById(H,U)}activateByIdWithErrors(H,U){return this.$(H,U).then(()=>{const ne=this.P.getActivatedExtension(H);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===N.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(H.fsPath);return y.URI.file(U)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new X(H))),this.Q}async bb(H){const U=$.$7h.forUris(ne=>P.$tg.ignorePathCasing(ne));return await Promise.all(H.map(async ne=>{if(this.ub(ne)){const ye=await this.ab(ne.extensionLocation);U.set(ye,ne)}})),U}cb(H){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return U;const ne=this.P.getActivatedExtension(H);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(ye)}try{(0,b.$Nc)(ne.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(ye)}return U}async db(H,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,U).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(H.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,U),this.eb(H,U,"success",ye),ne},ne=>{throw this.eb(H,U,"failure"),ne})}eb(H,U,ne,ye){const fe=Q(H,U);this.z.$publicLog2("extensionActivationTimes",{...fe,...ye||{},outcome:ne})}fb(H,U){const ne=Q(H,U);this.z.$publicLog2("activatePlugin",ne);const ye=this.ub(H);if(!ye)return Promise.resolve(new v.$ufc(v.$rfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${H.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const fe=new v.$sfc(U.startup);return Promise.all([this.vb(H,(0,P.$Cg)(H.extensionLocation,ye),fe),this.gb(H)]).then(me=>(g.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),W.hb(this.s,H.identifier,me[0],me[1],fe))).then(me=>(g.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),me))}gb(H){const U=new a.$Afc(H,this.M),ne=new a.$zfc(H.identifier.value,!1,this.M),ye=new z.$Hfc(H,this.N),fe=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ee=this;let ie,G;const te=(0,d.$RF)(H,"ipc")?this.f.messagePorts?.get(n.$em.toKey(H.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:ye,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(J){return O.$jc(H.extensionLocation.fsPath,J)},get storagePath(){return ee.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return ee.O.globalValue(H).fsPath},get logPath(){return O.$jc(ee.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return y.URI.joinPath(ee.f.logsLocation,H.identifier.value)},get storageUri(){return ee.O.workspaceValue(H)},get globalStorageUri(){return ee.O.globalValue(H)},get extensionMode(){return fe},get extension(){return ie===void 0&&(ie=new x(ee,H.identifier,H,me,!1)),ie},get extensionRuntime(){return(0,d.$SF)(H,"extensionRuntime"),ee.extensionRuntime},get environmentVariableCollection(){return ee.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!G){if(!te)return;const J=p.Event.buffer(p.Event.fromDOMEventEmitter(te,"message",ce=>ce.data));te.start(),G={onDidReceiveMessage:J,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(H,U,ne,ye,fe){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(H,U,ne,ye,fe).then(me=>new v.$tfc(!1,null,fe.build(),ne,me,ye.subscriptions))}static ib(H,U,ne,ye,fe){if(typeof ne.activate=="function")try{fe.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${U.value}`);const me=typeof global=="object"?global:self,ee=ne.activate.apply(me,[ye]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(ee).then(ie=>(fe.activateResolveStop(),ie))}catch(me){return Promise.reject(me)}else return Promise.resolve(ne)}jb(H,U){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(H,U=0){const ye=Date.now();(0,T.$B)(()=>{for(let fe=U;fe<H.length;fe+=1){const me=H[fe];for(const ee of me.activationEvents??[])if(ee==="onStartupFinished")if(Date.now()-ye>50){this.kb(H,fe);break}else this.jb(me,ee)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(H=>{const U=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const ye of ne)if(ye.activationEvents)for(const fe of ye.activationEvents)fe==="onStartupFinished"&&this.jb(ye,fe)})}mb(){const H=this.Z("*",!0).then(void 0,me=>{this.s.error(me)});this.B(this.j.onDidChangeWorkspace(me=>this.nb(me.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),ye=this.pb(),fe=Promise.all([ye,H,ne]).then(()=>{});return Promise.race([fe,(0,M.$2g)(1e4)]).then(()=>{this.lb()}),fe}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(H,U))).then(()=>{})}async ob(H,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:H.map(me=>me.uri),forceUsingSearch:ne||!this.c.fsExists,exists:me=>this.c.fsExists(me.fsPath),checkExists:(me,ee,ie)=>this.y.$checkExists(me,ee,ie)},fe=await(0,E.$2rb)(ye,U);if(fe)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:fe.activationEvent}).then(void 0,me=>this.s.error(me))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:U}=this.f.environment;if(!H||!U)throw new Error(D.localize(0,null));const ne=await this.vb(null,U,new v.$sfc(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,U.toString()));return new Promise((ye,fe)=>{const me=(G,te)=>{G?(T.$t&&this.s.error("Test runner called back with error",G),fe(G)):(T.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof te=="number"&&te>0?1:0))},ee=(0,P.$qg)(U),ie=ne.run(ee,me);ie&&ie.then&&ie.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{T.$t&&this.s.error("Test runner finished with error",G),fe(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$2g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,U){return this.R[H]=U,(0,b.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:U}=await this.sb(H);return U?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const U=H.indexOf("+");if(U===-1)throw new t.$NK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=H.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(H,U){const ne=j.$Od.create(!1),ye=()=>`[resolveAuthority(${(0,r.$5k)(H)},${U})][${ne.elapsed()}ms] `,fe=se=>this.s.info(`${ye()}${se}`),me=se=>this.s.warn(`${ye()}${se}`),ee=(se,K=void 0)=>this.s.error(`${ye()}${se}`,K),ie=se=>{if(se instanceof t.$NK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},G=async se=>{fe(`activating resolver for ${se}...`);const{resolver:K,authorityPrefix:ae}=await this.sb(se);if(!K)throw ee(`no resolver for ${ae}`),new t.$NK(`No remote extension installed to resolve ${ae}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:ae,remoteAuthority:se}},te=H.split(/@|%40/g).reverse();fe(`activating remote resolvers ${te.join(" -> ")}`);let J;try{J=await Promise.all(te.map(G)).catch(async se=>{if(!(se instanceof t.$NK)||se._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return me(`resolving nested authorities failed: ${se.message}`),[await G(H)]})}catch(se){return ie(se)}const ce=new M.$_g;ce.cancelAndSet(()=>fe("waiting..."),1e3);let be,Ie;for(const[se,{authorityPrefix:K,resolver:ae,remoteAuthority:de}]of J.entries())try{if(se===J.length-1)fe("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${K}`),be=await ae.resolve(de,{resolveAttempt:U,execServer:Ie}),g.mark(`code/extHost/didResolveAuthorityOK/${K}`),fe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$MK.isManagedResolvedAuthority(be)?be:void 0));else{if(fe(`invoking resolveExecServer() for ${de}`),g.mark(`code/extHost/willResolveExecServer/${K}`),Ie=await ae.resolveExecServer?.(de,{resolveAttempt:U,execServer:Ie}),!Ie)throw new t.$NK(`Exec server was not available for ${de}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(Ae){return g.mark(`code/extHost/didResolveAuthorityError/${K}`),ee("returned an error",Ae),ce.dispose(),ie(Ae)}ce.dispose();const Fe={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},B={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};fe(`returned ${t.$MK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let _;if(t.$MK.isManagedResolvedAuthority(be)){const se=U;this.X.setFactory(se,be.makeConnection),_={authority:H,connectTo:new r.$2k(se),connectionToken:be.connectionToken}}else _={authority:H,connectTo:new r.$3k(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:_,options:B,tunnelInformation:Fe}}}async $getCanonicalURI(H,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$5k)(H)})`);const{resolver:ne}=await this.sb(H);if(!ne)return null;const ye=y.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return ye;const fe=await(0,M.$Tg)(()=>ne.getCanonicalURI(ye));return fe||ye}$startExtensionHost(H){H.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:U,myExtensions:ne}=le(this.I,this.L,this.J,H);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.rb()}$activateByEvent(H,U){return U===1?this.D.wait().then(ne=>this.Z(H,!1)):this.G.wait().then(ne=>this.Z(H,!1))}async $activate(H,U){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,U),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(me=>me.extensionLocation=y.URI.revive(me.extensionLocation));const{globalRegistry:U,myExtensions:ne}=le(this.I,this.L,this.J,H),ye=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const U=o.$ge.alloc(H),ne=Math.random()%256;for(let ye=0;ye<H;ye++)U.writeUInt8(ne,ye);return U}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$Nfc=Y,e.$Nfc=Y=W=Ge([We(0,h.$Zh),We(1,e.$Mfc),We(2,l.$JM),We(3,f.$afc),We(4,m.$dfc),We(5,R.$ij),We(6,u.$ZM),We(7,c.$gfc),We(8,L.$Yxb),We(9,w.$Bfc),We(10,I.$Jfc),We(11,F.$Kfc)],Y);function le(ge,H,U,ne){ge.addActivationEvents(ne.addActivationEvents);const ye=new s.$Z6b(ge,H.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const fe=new n.$fm(U.getAllExtensionDescriptions().map(ee=>ee.identifier));for(const ee of ne.myToRemove)fe.delete(ee);for(const ee of ne.myToAdd)fe.add(ee);const me=oe(ye,fe);return{globalRegistry:ye,myExtensions:me}}function Q(ge,H){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function Z(ge){return ge.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$Ofc=(0,h.$1h)("IExtHostExtensionService");class x{#e;#t;#i;constructor(H,U,ne,ye,fe){this.#e=H,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=O.$hc((0,P.$qg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Pfc=x;function oe(ge,H){return ge.getAllExtensionDescriptions().filter(U=>H.has(U.identifier))}class X{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$Qfc=X;class ve{constructor(H){this.a=new n.$gm,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)??[]}addActivationEvents(H){for(const U of Object.keys(H))this.a.set(U,H[U])}}}),define(Se[363],ke([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;let f=class{constructor(o,a,t,r,h,u,c){this.c=o,this.d=a,this.e=t,this.f=r,this.g=h,this.h=u,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$Ygc=f,e.$Ygc=f=Ge([We(2,R.$Zh),We(3,P.$dfc),We(4,C.$Ofc),We(5,y.$ZM),We(6,m.$ij)],f);let d=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&k.a.size){const a=(0,v.$Ke)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${h}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,h]=a,u=k.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+h}c(o){return o.replace(/\\/g,"/")}};d=k=Ge([We(0,y.$ZM)],d);class s{constructor(o,a,t,r,h){this.c=o,this.d=a,this.e=t,this.f=r,this.g=h,this.nodeModuleName="vscode",this.a=new b.$gm}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((h,u)=>r+=`	${u} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(M.$MF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$FK.MainThreadTelemetry);const r=t.getProxy(g.$FK.MainThreadWindow);this.c=(h,u)=>{const c=O.URI.parse(h);return u?this.g(h,u):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,h,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,h,{}):this.g(h,u)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([We(2,$.$JM)],i)}),define(Se[58],ke([1,0,43,3,16,50,5,69,70,48,7,41,289,42]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0,e.$Rfc=(0,M.$1h)("IExtHostVariableResolverProvider");class k extends m.$KN{constructor(s,i,n,o,a,t,r){function h(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const c=o.tabGroups.all.find(l=>l.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof R.$oM||c.input instanceof R.$tM)return c.input.modified;if(c.input instanceof R.$nM||c.input instanceof R.$sM||c.input instanceof R.$qM)return c.input.uri}}}super({getFolderUri:u=>{const c=t.folders.filter(l=>l.name===u);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,c)=>a.getConfiguration(void 0,u).get(c),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=h();if(u)return g.$hc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=h();if(u){const c=i.getWorkspaceFolder(u);if(c)return g.$hc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(P.env))}}let f=class extends O.$Sc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$Sfc=f,e.$Sfc=f=Ge([We(0,y.$Ofc),We(1,C.$afc),We(2,b.$UM),We(3,v.$dfc),We(4,$.$pfc)],f)}),define(Se[96],ke([1,0,12,4,2,5,6,70,48,20,7,41,140,281,42,58]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0,e.$Tfc=(0,P.$1h)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,h,u,c,l,S){this.E=h,this.F=u,this.G=c,this.H=l,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new O.$Sd,this.n=new O.$Sd,this.o=new O.$Sd,this.u=new O.$Sd,this.k=r.getProxy(M.$FK.MainThreadDebugService),this.y=new O.$Sd,this.A=new O.$Sd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(w=>{this.J(L)}),this.J(L)})}asDebugSourceUri(r,h){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let c=`debug:${encodeURIComponent(u.path||"")}`,l="?";return h&&(c+=`${l}session=${encodeURIComponent(h.id)}`,l="&"),c+=`${l}ref=${u.sourceReference}`,g.URI.parse(c)}else{if(u.path)return g.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const h=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const c=u.contributes.debuggers;if(c&&c.length>0)for(const l of c)(0,v.$oF)(l)&&h.push(l.type)}this.k.$registerDebugTypes(h)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(h=>r.push(h)),r}addBreakpoints(r){const h=r.filter(l=>{const S=l.id;return this.w.has(S)?!1:(this.w.set(S,l),!0)});this.U(h,[],[]);const u=[],c=new Map;for(const l of h)if(l instanceof R.$HL){let S=c.get(l.location.uri.toString());S||(S={type:"sourceMulti",uri:l.location.uri,lines:[]},c.set(l.location.uri.toString(),S),u.push(S)),S.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof R.$IL&&u.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const h=r.filter(S=>this.w.delete(S.id));this.U([],h,[]);const u=h.filter(S=>S instanceof R.$HL).map(S=>S.id),c=h.filter(S=>S instanceof R.$IL).map(S=>S.id),l=h.filter(S=>S instanceof R.$JL).map(S=>S.id);return this.k.$unregisterBreakpoints(u,c,l)}startDebugging(r,h,u){return this.k.$startDebugging(r?r.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,h,u){if(!h)return new R.$HK(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:h}),this.k.$registerDebugConfigurationProvider(r,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,c),new R.$HK(()=>{this.f=this.f.filter(l=>l.provider!==h),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,h,u){if(!u)return new R.$HK(()=>{});if(!this.Q(r,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.N(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:h,handle:c,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(h,c),new R.$HK(()=>{this.h=this.h.filter(l=>l.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,h){if(!h)return new R.$HK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:h}),new R.$HK(()=>{this.j=this.j.filter(c=>c.factory!==h)})}async $runInTerminal(r,h){return Promise.resolve(void 0)}async $substituteVariables(r,h){let u;const c=await this.W(r);return c&&(u={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,h)}K(r,h){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,h){const u=this,c=await this.V(h);return this.S(this.N(c.type),c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const S=this.M(l),L=this.K(S,c);if(!L)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const w=L;return this.B.set(r,w),this.R(c).then(p=>(p&&this.C.set(r,p),w.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const A=E,z={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const N=await this.D.sign(A.arguments.value);z.body={signature:N},w.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,w.sendResponse(z)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(E),E=(0,v.$tF)(E,!0),u.k.$acceptDAMessage(r,E)}),w.onError(E=>{p&&p.onError&&p.onError(E),this.k.$acceptDAError(r,E.name,E.message,E.stack)}),w.onExit(E=>{p&&p.onExit&&p.onExit(E??void 0,void 0),this.k.$acceptDAExit(r,E??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,h){h=(0,v.$sF)(h,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h),this.B.get(r)?.sendMessage(h)}$stopDASession(r){const h=this.C.get(r);this.C.delete(r),h&&h.onWillStopSession&&h.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const h=[],u=[],c=[];if(r.added)for(const l of r.added){const S=l.id;if(S&&!this.w.has(S)){let L;if(l.type==="function")L=new R.$IL(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")L=new R.$JL(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const w=g.URI.revive(l.uri);L=new R.$HL(new R.$TK(w,new R.$IK(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,R.$FL)(L,S),this.w.set(S,L),h.push(L)}}if(r.removed)for(const l of r.removed){const S=this.w.get(l);S&&(this.w.delete(l),u.push(S))}if(r.changed){for(const l of r.changed)if(l.id){const S=this.w.get(l.id);if(S){if(S instanceof R.$IL&&l.type==="function"){const L=S;L.enabled=l.enabled,L.condition=l.condition,L.hitCondition=l.hitCondition,L.logMessage=l.logMessage,L.functionName=l.functionName}else if(S instanceof R.$HL&&l.type==="source"){const L=S;L.enabled=l.enabled,L.condition=l.condition,L.hitCondition=l.hitCondition,L.logMessage=l.logMessage,L.location=new R.$TK(g.URI.revive(l.uri),new R.$IK(l.line,l.character))}c.push(S)}}}this.U(h,u,c)}async $acceptStackFrameFocus(r){let h;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?h=new R.$PL(u,r.threadId):h=new R.$OL(u,r.threadId,r.frameId),this.z=h,this.A.fire(this.z)}$provideDebugConfigurations(r,h,u){return(0,D.$Tg)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(h);return c.provideDebugConfigurations(l,u)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,h,u,c){return(0,D.$Tg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(h);return l.resolveDebugConfiguration(S,u,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,h,u,c){return(0,D.$Tg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(h);return l.resolveDebugConfigurationWithSubstitutedVariables(S,u,c)})}async $provideDebugAdapter(r,h){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(h);return this.S(u,c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(r){const h=await this.V(r);this.m.fire(h)}async $acceptDebugSessionTerminated(r){const h=await this.V(r);h&&(this.n.fire(h),this.l.delete(h.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,h){(await this.V(r))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(r,h){const c={session:await this.V(r),event:h.event,body:h.body};this.u.fire(c)}M(r){if(r instanceof R.$KL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$LL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$ML)return{type:"pipeServer",path:r.path};if(r instanceof R.$NL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const h=this.h.filter(u=>u.type===r);if(h.length>0)return h[0].factory}O(r){const h=this.h.filter(u=>u.handle===r);if(h.length>0)return h[0].factory}P(r){const h=this.f.filter(u=>u.handle===r);if(h.length>0)return h[0].provider}Q(r,h){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const c of u)if(c.label&&c.type&&c.type===h)return!0}}return!1}R(r){const u=r.configuration.type,c=this.j.filter(l=>l.type===u||l.type==="*").map(l=>(0,D.$Tg)(()=>l.factory.createDebugAdapterTracker(r)).then(S=>S,S=>null));return Promise.race([Promise.all(c).then(l=>{const S=l.filter(L=>!!L);if(S.length>0)return new n(S)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(r,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new R.$LL(u));if(r){const l=await this.F.getExtensionRegistry();return(0,D.$Tg)(()=>r.createDebugAdapterDescriptor(h,this.T(h,l))).then(S=>{if(S)return S})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(h,c))}T(r,h){}U(r,h,u){(r.length>0||h.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:h,changed:u}))}async V(r){if(r)if(typeof r=="string"){const h=this.l.get(r);if(h)return h}else{let h=this.l.get(r.id);if(!h){const u=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;h=new s(this.k,r.id,r.type,r.name,u,r.configuration,c),this.l.set(h.id,h),this.k.$sessionCached(h.id)}return h}throw new Error("cannot find session")}W(r){if(r){const h=g.URI.revive(r);return this.E.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};e.$Ufc=d,e.$Ufc=d=Ge([We(0,y.$JM),We(1,C.$afc),We(2,$.$Ofc),We(3,k.$dfc),We(4,b.$pfc),We(5,f.$Rfc)],d);class s{constructor(r,h,u,c,l,S,L){this.d=r,this.f=h,this.g=u,this.h=c,this.i=l,this.j=S,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,h){return this.d.$customDebugAdapterRequest(this.f,r,h)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Vfc=s;class i{constructor(r){this.value=Object.freeze({append(h){r.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$Wfc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(h=>h.onError?h.onError(r):void 0)}onExit(r,h){this.d.forEach(u=>u.onExit?u.onExit(r,h):void 0)}}class o extends m.$glb{constructor(r){super(),this.h=r,r.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(r,h,u,c,l,S){super(r,h,u,c,l,S)}};e.$Xfc=a,e.$Xfc=a=Ge([We(0,y.$JM),We(1,C.$afc),We(2,$.$Ofc),We(3,k.$dfc),We(4,b.$pfc),We(5,f.$Rfc)],a)}),define(Se[364],ke([1,0,8,56,2,6,352,14,106,107,27,247,20,66,48,90]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class d{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(b.$ij),t=n.get(m.$JM).getProxy(P.$FK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const h=D.$3(r);t.$onUnexpectedError(h)})}static async installFullHandler(n){const o=n.get(b.$ij),a=n.get(m.$JM),t=n.get(k.$Ofc),r=n.get(f.$4M),h=a.getProxy(P.$FK.MainThreadExtensionService),u=a.getProxy(P.$FK.MainThreadErrors),c=await t.getExtensionPathIndex(),l=new WeakMap;function S(p,E){if(l.has(p))return l.get(p).stack;let A="",z,N;for(const j of E)A+=`
	at ${j.toString()}`,N=j.getFileName(),!z&&N&&(z=c.findSubstr(g.URI.file(N)));const I=`${p.name||"Error"}: ${p.message||""}${A}`;return l.set(p,{extensionIdentifier:z?.identifier,stack:I}),I}const L=Symbol("prepareStackTrace wrapped");let w=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(p){if(p===S||!p||p[L]){w=p||S;return}w=function(E,A){return S(E,A),p.call(Error,E,A)},Object.assign(w,{[L]:!0})}}),D.setUnexpectedErrorHandler(p=>{o.error(p);const E=D.$3(p),A=l.get(p);if(!A?.extensionIdentifier){u.$onUnexpectedError(E);return}h.$onExtensionRuntimeError(A.extensionIdentifier,E);const z=r.onExtensionError(A.extensionIdentifier,p);o.trace("forwarded error to extension?",z,A)})}}e.$Zgc=d;class s{constructor(n,o,a,t,r){this.a=a,this.b=new M.$86b(n,null,t),o=s.e(o,this.b);const h=new y.$Yh(...(0,$.$Ir)());h.set(R.$ZM,{_serviceBrand:void 0,...o,messagePorts:r}),h.set(m.$JM,new m.$KM(this.b)),h.set(v.$0ec,new v.$$ec(t)),h.set(k.$Mfc,a);const u=new C.$oq(h,!0);u.invokeFunction(d.installEarlyHandler),this.d=u.invokeFunction(c=>c.get(b.$ij)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(c=>c.get(k.$Ofc)),this.c.initialize(),u.invokeFunction(d.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(P.$FK.MainThreadExtensionService);return g.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>g.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$1gc=s}),define(Se[365],ke([1,0,12,11,222,241,138,96,70,48,20,47,7,58,41,282,283,42]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;let i=class extends b.$Ufc{constructor(r,h,u,c,l,S,L){super(r,h,u,c,S,L),this.Z=l,this.X=new a}K(r,h){switch(r.type){case"server":return new f.$6gc(r);case"pipeServer":return new f.$7gc(r);case"executable":return new f.$8gc(r,h.type)}return super.K(r,h)}T(r,h){const u=f.$8gc.platformAdapterExecutable(h.getAllExtensionDescriptions(),r.type);if(u)return new m.$KL(u.command,u.args,u.options)}L(){return new M.$U0b}async $runInTerminal(r,h){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(I=>{this.X.onTerminalClosed(I)}));const u=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),S=r.title||g.localize(0,null),L=JSON.stringify({shell:c,shellArgs:l});let w=await this.X.checkout(L,S),p,E=!1;if(w)p=r.cwd;else{const I={shellPath:c,shellArgs:l,cwd:r.cwd,name:S,iconPath:new m.$CL("debug")};E=!0,w=this.Z.createTerminalFromOptions(I,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(w,L)}w.show(!0);const A=await w.processId;E?await new Promise(I=>setTimeout(I,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?w.sendText("cls"):c.indexOf("bash")>=0?w.sendText("clear"):O.$i?w.sendText("cls"):w.sendText("clear"));const z=(0,d.$0gc)(c,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);w.sendText(z);const N=this.onDidTerminateDebugSession(I=>{I.id===h&&(this.X.free(w),N.dispose())});return A}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,h)}};e.$$gc=i,e.$$gc=i=Ge([We(0,R.$JM),We(1,k.$afc),We(2,y.$Ofc),We(3,s.$dfc),We(4,C.$Bfc),We(5,$.$pfc),We(6,v.$Rfc)],i);let n;function o(t,r){if(!n)if(O.$i)n=new P.$G9b;else if(O.$j)n=new P.$H9b;else if(O.$k)n=new P.$I9b;else throw new Error("external terminals not supported on this platform");const h=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},h.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,h){const c=[...this.b.entries()].map(([l,S])=>(0,D.$Og)(async L=>{if(l.name!==h||S.lastUsedAt!==-1&&await(0,d.$9gc)(await l.processId))return null;const w=Date.now();return S.lastUsedAt+a.a>w||L.isCancellationRequested||S.config!==r?null:(S.lastUsedAt=w,l)}));return await(0,D.$6g)(c,l=>!!l)}insert(r,h){this.b.set(r,{lastUsedAt:Date.now(),config:h})}free(r){const h=this.b.get(r);h&&(h.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Se[366],ke([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;let n=class extends m.$Egc{constructor(a,t,r,h,u,c,l,S,L){super(a,t,r,h,u,c,l,S),this.B=r,this.C=L,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const h=m.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(h);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(u,t);return this.a.$executeTask(h).catch(()=>{}),c}else{const h=m.TaskDTO.from(t,a);if(h===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(h.execution)&&await this.x(h,t,!1);const u=await this.y(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),u}}u(a,t,r,h){const u=[];if(h)for(const c of h){this.z(c,r),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const l=m.TaskDTO.from(c,r.extension);l&&(u.push(l),m.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,c,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=O.URI.file((0,s.homedir)());t=new $.$ii({uri:r,name:d.$zg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=O.URI.revive(a),h={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),S=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const L of t.variables)h.variables[L]=await l.resolveAsync(S,L);if(t.process!==void 0){let L;if(t.process.path!==void 0){L=t.process.path.split(D.$tc);for(let w=0;w<L.length;w++)L[w]=await l.resolveAsync(S,L[w])}h.process=await g.win32.findExecutable(await l.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(S,t.process.cwd):void 0,L)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return g.win32.findExecutable(a,t,r)}};e.$3gc=n,e.$3gc=n=Ge([We(0,R.$JM),We(1,C.$ZM),We(2,P.$afc),We(3,M.$UM),We(4,b.$dfc),We(5,y.$Bfc),We(6,k.$ij),We(7,f.$Uec),We(8,i.$Rfc)],n)}),define(Se[367],ke([1,0,63,58]),function($e,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class g extends O.$Sfc{m(){return(0,D.homedir)()}}e.$Ihc=g}),define(Se[154],ke([1,0,19,12,21,44,17,16,23,2,36]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.$_fc=void 0;class C{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new g.$3d(n);return new Promise((t,r)=>{this.a=new v(i);let h=!1;const u=(c,l)=>{if(!h&&!this.b){const S=this.h(c);f(c)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,h=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const L=this.h(c);this.c+=L,(L>0||!f(c))&&this.a.add(c,l)}};Promise.all(o.map((c,l)=>this.k(c,S=>u(S,l),a.token))).then(c=>{a.dispose(),this.a.flush();const l=c.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||l,messages:(0,D.$Rb)(c.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const l=(0,P.$Li)(c);r(new Error(l))})})}h(i){return f(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new R.$jJ(this.d,i),t=[],r={report:c=>{if(!this.l(c))return;const l=i.folder.scheme===M.Schemas.file?(0,R.$kJ)(()=>this.f.readdir($.$Bg(c.uri))):void 0,S=$.$Eg(i.folder,c.uri);if(S){const L=a.includedInQuery(S,b.$nc(S),l);(0,O.$Ng)(L)?t.push(L.then(w=>{w&&n(c)})):L&&n(c)}}},h=this.n(i),u=await this.e.provideTextSearchResults(m(this.d.contentPattern),h,r,o);return t.length&&await Promise.all(t),u}l(i){if(f(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,R.$iJ)(this.d.includePattern,i.includePattern),o=(0,R.$iJ)(this.d.excludePattern,i.excludePattern),a={folder:y.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$_fc=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new d(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$vg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$agc=v;function k(s){return f(s)?{preview:{matches:(0,D.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function f(s){return!!s.preview}e.$bgc=f;class d{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cgc=d}),define(Se[97],ke([1,0,3,6,5,360,20,66,14,2,154]),function($e,e,D,O,g,P,M,b,$,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=e.$dgc=void 0,e.$dgc=(0,g.$1h)("IExtHostSearch");let C=class{constructor(f,d,s){this.k=f,this.l=d,this.n=s,this.c=this.k.getProxy(O.$FK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$$fc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const s=this.d++;return this.e.set(s,d),this.c.$registerTextSearchProvider(s,this.o(f)),(0,D.$Qc)(()=>{this.g.delete(f),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(f,d){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const s=this.d++;return this.h.set(s,d),this.c.$registerFileSearchProvider(s,this.o(f)),(0,D.$Qc)(()=>{this.i.delete(f),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(f,d,s,i){const n=m(s),o=this.h.get(f);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(f,d,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,d,s){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,s,i){const n=this.e.get(f);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const o=m(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(f,d,t),i)}$enableExtensionHostSearch(){}q(f,d){return new R.$_fc(f,d,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$egc=C,e.$egc=C=Ge([We(0,M.$JM),We(1,b.$0ec),We(2,$.$ij)],C);function m(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(v),extraFileResources:k.extraFileResources&&k.extraFileResources.map(f=>y.URI.revive(f))}}e.$fgc=m;function v(k){return{...k,folder:y.URI.revive(k.folder)}}}),define(Se[368],ke([1,0,21,8,4,3,17,39,2,132,190,171,79,26,32,14,65,87,266,6,304,312,91,305,306,307,308,309,310,311,287,35,313,42,343,96,149,315,316,317,293,318,69,70,319,48,320,71,321,57,27,322,323,324,325,326,327,115,116,328,359,295,272,296,329,330,152,331,297,332,333,20,334,97,117,335,336,337,118,92,95,90,47,338,339,284,340,298,72,15,7,341,66,342,93,344,345,151,41,280,114,25,94]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h,u,c,l,S,L,w,p,E,A,z,N,I,j,T,F,W,Y,le,Q,Z,x,oe,X,ve,ge,H,U,ne,ye,fe,me,ee,ie,G,te,J,ce,be,Ie,Fe,B,_,se,K,ae,de,Ae,Be,Xe,Ye,it,st,Pe,Te,qe,Re,xe,he,ue,Ce,Ve,Je,et,ot,ut,je,St,Ht,zt,wt,qt,Ut,Kt,Gt,Lt,It,tt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;function Vt(lt){const mt=lt.get(H.$ZM),Zt=lt.get(ge.$Rec),Pt=lt.get(X.$ffc),kt=lt.get(x.$Ofc),ft=lt.get(Gt.$afc),Mt=lt.get(xe.$4M),Nt=lt.get(A.$dfc),yt=lt.get(Ht.$0ec),Qe=lt.get(Ae.$JM),Ft=lt.get(Te.$yfc),Bt=lt.get(qe.$gfc),Qt=lt.get(f.$jj),gt=lt.get(f.$ij),Rt=lt.get(ot.$Yxb),Me=lt.get(t.$Uec),Oe=lt.get(Kt.$Tgc),De=lt.get(Ye.$Gfc),re=lt.get(Q.$pfc),Ne=lt.get(G.$Kfc);Qe.set(n.$GK.ExtHostFileSystemInfo,Zt),Qe.set(n.$GK.ExtHostLogLevelServiceShape,Qt),Qe.set(n.$GK.ExtHostWorkspace,ft),Qe.set(n.$GK.ExtHostConfiguration,Nt),Qe.set(n.$GK.ExtHostExtensionService,kt),Qe.set(n.$GK.ExtHostStorage,Ft),Qe.set(n.$GK.ExtHostTunnelService,Rt),Qe.set(n.$GK.ExtHostWindow,Oe),Qe.set(n.$GK.ExtHostSecretState,De),Qe.set(n.$GK.ExtHostTelemetry,Mt),Qe.set(n.$GK.ExtHostEditorTabs,re),Qe.set(n.$GK.ExtHostManagedSockets,Ne);const He=Qe.set(n.$GK.ExtHostDecorations,lt.get(I.$Zfc)),_e=Qe.set(n.$GK.ExtHostDocumentsAndEditors,lt.get(le.$UM)),Ke=Qe.set(n.$GK.ExtHostCommands,lt.get(p.$6M)),rt=Qe.set(n.$GK.ExtHostTerminalService,lt.get(he.$Bfc)),$t=Qe.set(n.$GK.ExtHostDebugService,lt.get(N.$Tfc)),jt=Qe.set(n.$GK.ExtHostSearch,lt.get(Xe.$dgc)),Et=Qe.set(n.$GK.ExtHostTask,lt.get(Re.$Ggc)),Dt=Qe.set(n.$GK.ExtHostOutputService,lt.get(_.$tgc)),vt=Qe.set(n.$GK.ExtHostLocalization,lt.get(ie.$Jfc)),mi=Qe.set(n.$GK.ExtHostUrls,new zt.$Qgc(Qe)),At=Qe.set(n.$GK.ExtHostDocuments,new Y.$Pec(Qe,_e)),ki=Qe.set(n.$GK.ExtHostDocumentContentProviders,new F.$2fc(Qe,_e,gt)),qi=Qe.set(n.$GK.ExtHostDocumentSaveParticipant,new W.$3fc(gt,At,Qe.getProxy(n.$FK.MainThreadBulkEdits))),Ct=Qe.set(n.$GK.ExtHostNotebook,new J.$ggc(Qe,Ke,_e,At,Pt,jt)),ni=Qe.set(n.$GK.ExtHostNotebookDocuments,new be.$ngc(Ct)),$i=Qe.set(n.$GK.ExtHostNotebookEditors,new Ie.$ogc(gt,Ct)),ai=Qe.set(n.$GK.ExtHostNotebookKernels,new Fe.$pgc(Qe,mt,Ct,Ke,gt)),Di=Qe.set(n.$GK.ExtHostNotebookRenderers,new B.$rgc(Qe,Ct)),Ci=Qe.set(n.$GK.ExtHostNotebookDocumentSaveParticipant,new ce.$mgc(gt,Ct,Qe.getProxy(n.$FK.MainThreadBulkEdits))),Tt=Qe.set(n.$GK.ExtHostEditors,new Ce.$7ec(Qe,_e)),bi=Qe.set(n.$GK.ExtHostTreeViews,new et.$Ogc(Qe.getProxy(n.$FK.MainThreadTreeViews),Ke,gt)),Ii=Qe.set(n.$GK.ExtHostEditorInsets,new w.$8ec(Qe.getProxy(n.$FK.MainThreadEditorInsets),Tt,mt.remote)),ci=Qe.set(n.$GK.ExtHostDiagnostics,new j.$Tec(Qe,gt,Zt,_e)),ui=Qe.set(n.$GK.ExtHostLanguages,new ee.$kgc(Qe,At,Ke.converter,yt)),ht=Qe.set(n.$GK.ExtHostLanguageFeatures,new me.$Xec(Qe,yt,At,Ke,ci,gt,Me,Mt)),Vi=Qe.set(n.$GK.ExtHostFileSystem,new oe.$5fc(Qe,ht)),xt=Qe.set(n.$GK.ExtHostFileSystemEventService,new ve.$6fc(Qe,gt,_e)),ri=Qe.set(n.$GK.ExtHostQuickOpen,(0,de.$xgc)(Qe,ft,Ke)),di=Qe.set(n.$GK.ExtHostSCM,new Be.$zgc(Qe,Ke,At,gt)),Pi=Qe.set(n.$GK.ExtHostQuickDiff,new ae.$wgc(Qe,yt)),Hi=Qe.set(n.$GK.ExtHostShare,new it.$Agc(Qe,yt)),Ai=Qe.set(n.$GK.ExtHostComments,(0,E.$9ec)(Qe,Ke,At)),pi=Qe.set(n.$GK.ExtHostProgress,new K.$vgc(Qe.getProxy(n.$FK.MainThreadProgress))),Ki=Qe.set(n.$GK.ExtHosLabelService,new fe.$jgc(Qe)),Li=Qe.set(n.$GK.ExtHostTheming,new Ve.$Lgc(Qe)),li=Qe.set(n.$GK.ExtHostAuthentication,new r.$Zec(Qe)),Gi=Qe.set(n.$GK.ExtHostTimeline,new Je.$Ngc(Qe,Ke)),wi=Qe.set(n.$GK.ExtHostWebviews,new wt.$kfc(Qe,mt.remote,ft,gt,Me)),Ri=Qe.set(n.$GK.ExtHostWebviewPanels,new qt.$nfc(Qe,wi,ft)),cn=Qe.set(n.$GK.ExtHostCustomEditors,new z.$ofc(Qe,At,Bt,wi,Ri)),Mi=Qe.set(n.$GK.ExtHostWebviewViews,new Ut.$Rgc(Qe,wi)),si=Qe.set(n.$GK.ExtHostTesting,new ue.$Hgc(Qe,Ke,_e)),un=Qe.set(n.$GK.ExtHostUriOpeners,new St.$Pgc(Qe)),ln=Qe.set(n.$GK.ExtHostProfileContentHandlers,new se.$ugc(Qe));Qe.set(n.$GK.ExtHostInteractive,new ne.$hgc(Qe,Ct,_e,Ke,gt));const Ji=Qe.set(n.$GK.ExtHostInlineChat,new U.$7fc(Qe,Ke,At,gt)),fi=Qe.set(n.$GK.ExtHostChatProvider,new l.$3ec(Qe,gt)),Qi=Qe.set(n.$GK.ExtHostChatAgents2,new c.$4ec(Qe,fi,gt)),Zi=Qe.set(n.$GK.ExtHostChatVariables,new S.$5ec(Qe)),gi=Qe.set(n.$GK.ExtHostChat,new u.$2ec(Qe)),Yi=Qe.set(n.$GK.ExtHostAiRelatedInformation,new o.$Oec(Qe)),Fi=Qe.set(n.$GK.ExtHostAiEmbeddingVector,new Z.$4fc(Qe)),Ti=Qe.set(n.$GK.ExtHostIssueReporter,new ye.$igc(Qe)),_t=Qe.set(n.$GK.ExtHostStatusBar,new Pe.$Dgc(Qe,Ke.converter)),vi=Qe.set(n.$GK.ExtHostSpeech,new st.$Bgc(Qe)),hn=Object.values(n.$GK);Qe.assertRegistered(hn);const Yt=new h.$1ec(Qe,_e),yi=new L.$6ec(Qe),Ei=new te.$lgc(Qe,gt),Oi=new T.$1fc(Qe);return a.$Yec.register(Ke),function(Ue,ei,Xi){const bt=function(){let pe=!Ue.isUnderDevelopment;function Ee(){pe||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")Ee();else{const pt=at;typeof pt.scheme>"u"&&Ee(),typeof pt.exclusive=="boolean"&&(0,tt.$SF)(Ue,"documentFiltersExclusive")}return at}}(),xi={getSession(pe,Ee,ze){return li.getSession(Ue,pe,Ee,ze)},getSessions(pe,Ee){return(0,tt.$SF)(Ue,"authGetSessions"),li.getSessions(Ue,pe,Ee)},async hasSession(pe,Ee){return(0,tt.$SF)(Ue,"authSession"),!!await li.getSession(Ue,pe,Ee,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(pe,Ee,ze,at){return li.registerAuthenticationProvider(pe,Ee,ze,at)}},dn={registerCommand(pe,Ee,ze){return Ke.registerCommand(!0,pe,Ee,ze,void 0,Ue)},registerTextEditorCommand(pe,Ee,ze){return Ke.registerCommand(!0,pe,(...at)=>{const pt=Tt.getActiveTextEditor();if(!pt){gt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return pt.edit(Ot=>{Ee.apply(ze,[pt,Ot,...at])}).then(Ot=>{Ot||gt.warn("Edits from command "+pe+" were not applied.")},Ot=>{gt.warn("An error occurred while running command "+pe,Ot)})},void 0,void 0,Ue)},registerDiffInformationCommand:(pe,Ee,ze)=>((0,tt.$SF)(Ue,"diffCommand"),Ke.registerCommand(!0,pe,async(...at)=>{const pt=_e.activeEditor(!0);if(!pt){gt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Ot=await Tt.getDiffInformation(pt.id);Ee.apply(ze,[Ot,...at])},void 0,void 0,Ue)),executeCommand(pe,...Ee){return Ke.executeCommand(pe,...Ee)},getCommands(pe=!1){return Ke.getCommands(pe)}},_i={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return rt.getDefaultShell(!1)},get onDidChangeShell(){return rt.onDidChangeShell},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Mt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$SF)(Ue,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$SF)(Ue,"telemetry"),Mt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,xe.$3M)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,Ee){return xe.$2M.validateSender(pe),Mt.instantiateLogger(Ue,pe,Ee)},openExternal(pe,Ee){return Oe.openUri(pe,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===mt.environment.appUriScheme)return mi.createAppUri(pe);try{return await Oe.asExternalUri(pe,{allowTunneling:!!mt.remote.authority})}catch(Ee){if((0,M.$_f)(pe,M.Schemas.http)||(0,M.$_f)(pe,M.Schemas.https))return pe;throw Ee}},get remoteName(){return(0,d.$7k)(mt.remote.authority)},get remoteAuthority(){return(0,tt.$SF)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,tt.$SF)(Ue,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ue,pe)},registerIssueDataProvider(pe){return(0,tt.$SF)(Ue,"handleIssueUri"),Ti.registerIssueDataProvider(Ue,pe)},get appQuality(){return(0,tt.$SF)(Ue,"resolvers"),mt.quality},get appCommit(){return(0,tt.$SF)(Ue,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(pe,Ee,ze){return si.createTestController(Ue,pe,Ee,ze)},createTestObserver(){return(0,tt.$SF)(Ue,"testObserver"),si.createTestObserver()},runTests(pe){return(0,tt.$SF)(Ue,"testObserver"),si.runTests(pe)},get onDidChangeTestResults(){return(0,tt.$SF)(Ue,"testObserver"),si.onResultsChanged},get testResults(){return(0,tt.$SF)(Ue,"testObserver"),si.results}},hi=mt.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,tn={getExtension(pe,Ee){(0,tt.$RF)(Ue,"extensionsAny")||(Ee=!1);const ze=ei.mine.getExtensionDescription(pe);if(ze)return new x.$Pfc(kt,Ue.identifier,ze,hi,!1);if(Ee){const at=ei.all.getExtensionDescription(pe);if(at)return new x.$Pfc(kt,Ue.identifier,at,hi,!0)}},get all(){const pe=[];for(const Ee of ei.mine.getAllExtensionDescriptions())pe.push(new x.$Pfc(kt,Ue.identifier,Ee,hi,!1));return pe},get allAcrossExtensionHosts(){(0,tt.$SF)(Ue,"extensionsAny");const pe=new v.$fm(ei.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of ei.all.getAllExtensionDescriptions()){const at=!pe.has(ze.identifier);Ee.push(new x.$Pfc(kt,Ue.identifier,ze,hi,at))}return Ee},get onDidChange(){return(0,tt.$RF)(Ue,"extensionsAny")?g.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(pe){return ci.createDiagnosticCollection(Ue.identifier,pe)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:pe=>ci.getDiagnostics(pe),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(pe,Ee){return ui.changeLanguage(pe.uri,Ee)},match(pe,Ee){const ze=At.getDocumentData(Ee.uri)?.notebook;return(0,R.$lt)(ut.LanguageSelector.from(pe),Ee.uri,Ee.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(pe,Ee,ze){return ht.registerCodeActionProvider(Ue,bt(pe),Ee,ze)},registerDocumentPasteEditProvider(pe,Ee,ze){return(0,tt.$SF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,bt(pe),Ee,ze)},registerCodeLensProvider(pe,Ee){return ht.registerCodeLensProvider(Ue,bt(pe),Ee)},registerDefinitionProvider(pe,Ee){return ht.registerDefinitionProvider(Ue,bt(pe),Ee)},registerDeclarationProvider(pe,Ee){return ht.registerDeclarationProvider(Ue,bt(pe),Ee)},registerImplementationProvider(pe,Ee){return ht.registerImplementationProvider(Ue,bt(pe),Ee)},registerTypeDefinitionProvider(pe,Ee){return ht.registerTypeDefinitionProvider(Ue,bt(pe),Ee)},registerHoverProvider(pe,Ee){return ht.registerHoverProvider(Ue,bt(pe),Ee,Ue.identifier)},registerEvaluatableExpressionProvider(pe,Ee){return ht.registerEvaluatableExpressionProvider(Ue,bt(pe),Ee,Ue.identifier)},registerInlineValuesProvider(pe,Ee){return ht.registerInlineValuesProvider(Ue,bt(pe),Ee,Ue.identifier)},registerDocumentHighlightProvider(pe,Ee){return ht.registerDocumentHighlightProvider(Ue,bt(pe),Ee)},registerMultiDocumentHighlightProvider(pe,Ee){return ht.registerMultiDocumentHighlightProvider(Ue,bt(pe),Ee)},registerLinkedEditingRangeProvider(pe,Ee){return ht.registerLinkedEditingRangeProvider(Ue,bt(pe),Ee)},registerReferenceProvider(pe,Ee){return ht.registerReferenceProvider(Ue,bt(pe),Ee)},registerRenameProvider(pe,Ee){return ht.registerRenameProvider(Ue,bt(pe),Ee)},registerDocumentSymbolProvider(pe,Ee,ze){return ht.registerDocumentSymbolProvider(Ue,bt(pe),Ee,ze)},registerWorkspaceSymbolProvider(pe){return ht.registerWorkspaceSymbolProvider(Ue,pe)},registerDocumentFormattingEditProvider(pe,Ee){return ht.registerDocumentFormattingEditProvider(Ue,bt(pe),Ee)},registerDocumentRangeFormattingEditProvider(pe,Ee){return ht.registerDocumentRangeFormattingEditProvider(Ue,bt(pe),Ee)},registerOnTypeFormattingEditProvider(pe,Ee,ze,...at){return ht.registerOnTypeFormattingEditProvider(Ue,bt(pe),Ee,[ze].concat(at))},registerDocumentSemanticTokensProvider(pe,Ee,ze){return ht.registerDocumentSemanticTokensProvider(Ue,bt(pe),Ee,ze)},registerDocumentRangeSemanticTokensProvider(pe,Ee,ze){return ht.registerDocumentRangeSemanticTokensProvider(Ue,bt(pe),Ee,ze)},registerSignatureHelpProvider(pe,Ee,ze,...at){return typeof ze=="object"?ht.registerSignatureHelpProvider(Ue,bt(pe),Ee,ze):ht.registerSignatureHelpProvider(Ue,bt(pe),Ee,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(pe,Ee,...ze){return ht.registerCompletionItemProvider(Ue,bt(pe),Ee,ze)},registerInlineCompletionItemProvider(pe,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,tt.$SF)(Ue,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$SF)(Ue,"inlineCompletionsAdditions"),ze&&(0,tt.$SF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,bt(pe),Ee,ze)},registerDocumentLinkProvider(pe,Ee){return ht.registerDocumentLinkProvider(Ue,bt(pe),Ee)},registerColorProvider(pe,Ee){return ht.registerColorProvider(Ue,bt(pe),Ee)},registerFoldingRangeProvider(pe,Ee){return ht.registerFoldingRangeProvider(Ue,bt(pe),Ee)},registerSelectionRangeProvider(pe,Ee){return ht.registerSelectionRangeProvider(Ue,pe,Ee)},registerCallHierarchyProvider(pe,Ee){return ht.registerCallHierarchyProvider(Ue,pe,Ee)},registerTypeHierarchyProvider(pe,Ee){return ht.registerTypeHierarchyProvider(Ue,pe,Ee)},setLanguageConfiguration:(pe,Ee)=>ht.setLanguageConfiguration(Ue,pe,Ee),getTokenInformationAtPosition(pe,Ee){return(0,tt.$SF)(Ue,"tokenInformation"),ui.tokenAtPosition(pe,Ee)},registerInlayHintsProvider(pe,Ee){return ht.registerInlayHintsProvider(Ue,pe,Ee)},createLanguageStatusItem(pe,Ee){return ui.createLanguageStatusItem(Ue,pe,Ee)},registerDocumentDropEditProvider(pe,Ee,ze){return ht.registerDocumentOnDropEditProvider(Ue,pe,Ee,(0,tt.$RF)(Ue,"dropMetadata")?ze:void 0)}},rn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return rt.activeTerminal},get terminals(){return rt.terminals},async showTextDocument(pe,Ee,ze){const at=await($.URI.isUri(pe)?Promise.resolve(sn.openTextDocument(pe)):Promise.resolve(pe));return Tt.showTextDocument(at,Ee,ze)},createTextEditorDecorationType(pe){return Tt.createTextEditorDecorationType(Ue,pe)},onDidChangeActiveTextEditor(pe,Ee,ze){return Tt.onDidChangeActiveTextEditor(pe,Ee,ze)},onDidChangeVisibleTextEditors(pe,Ee,ze){return Tt.onDidChangeVisibleTextEditors(pe,Ee,ze)},onDidChangeTextEditorSelection(pe,Ee,ze){return Tt.onDidChangeTextEditorSelection(pe,Ee,ze)},onDidChangeTextEditorOptions(pe,Ee,ze){return Tt.onDidChangeTextEditorOptions(pe,Ee,ze)},onDidChangeTextEditorVisibleRanges(pe,Ee,ze){return Tt.onDidChangeTextEditorVisibleRanges(pe,Ee,ze)},onDidChangeTextEditorViewColumn(pe,Ee,ze){return Tt.onDidChangeTextEditorViewColumn(pe,Ee,ze)},onDidCloseTerminal(pe,Ee,ze){return rt.onDidCloseTerminal(pe,Ee,ze)},onDidOpenTerminal(pe,Ee,ze){return rt.onDidOpenTerminal(pe,Ee,ze)},onDidChangeActiveTerminal(pe,Ee,ze){return rt.onDidChangeActiveTerminal(pe,Ee,ze)},onDidChangeTerminalDimensions(pe,Ee,ze){return(0,tt.$SF)(Ue,"terminalDimensions"),rt.onDidChangeTerminalDimensions(pe,Ee,ze)},onDidChangeTerminalState(pe,Ee,ze){return rt.onDidChangeTerminalState(pe,Ee,ze)},onDidWriteTerminalData(pe,Ee,ze){return(0,tt.$SF)(Ue,"terminalDataWriteEvent"),rt.onDidWriteTerminalData(pe,Ee,ze)},onDidExecuteTerminalCommand(pe,Ee,ze){return(0,tt.$SF)(Ue,"terminalExecuteCommandEvent"),rt.onDidExecuteTerminalCommand(pe,Ee,ze)},get state(){return Oe.getState(Ue)},onDidChangeWindowState(pe,Ee,ze){return Oe.onDidChangeWindowState(pe,Ee,ze)},showInformationMessage(pe,...Ee){return Ei.showMessage(Ue,b.default.Info,pe,Ee[0],Ee.slice(1))},showWarningMessage(pe,...Ee){return Ei.showMessage(Ue,b.default.Warning,pe,Ee[0],Ee.slice(1))},showErrorMessage(pe,...Ee){return Ei.showMessage(Ue,b.default.Error,pe,Ee[0],Ee.slice(1))},showQuickPick(pe,Ee,ze){return ri.showQuickPick(Ue,pe,Ee,ze)},showWorkspaceFolderPick(pe){return ri.showWorkspaceFolderPick(pe)},showInputBox(pe,Ee){return ri.showInput(pe,Ee)},showOpenDialog(pe){return Oi.showOpenDialog(Ue,pe)},showSaveDialog(pe){return Oi.showSaveDialog(pe)},createStatusBarItem(pe,Ee,ze){let at,pt,Ot;return typeof pe=="string"?(at=pe,pt=Ee,Ot=ze):(pt=pe,Ot=Ee),_t.createStatusBarEntry(Ue,at,pt,Ot)},setStatusBarMessage(pe,Ee){return _t.setStatusBarMessage(pe,Ee)},withScmProgress(pe){return Me.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),pi.withProgress(Ue,{location:je.ProgressLocation.SourceControl},(Ee,ze)=>pe({report(at){}}))},withProgress(pe,Ee){return pi.withProgress(Ue,pe,Ee)},createOutputChannel(pe,Ee){return Dt.createOutputChannel(pe,Ee,Ue)},createWebviewPanel(pe,Ee,ze,at){return Ri.createWebviewPanel(Ue,pe,Ee,ze,at)},createWebviewTextEditorInset(pe,Ee,ze,at){return(0,tt.$SF)(Ue,"editorInsets"),Ii.createWebviewEditorInset(pe,Ee,ze,at,Ue)},createTerminal(pe,Ee,ze){return typeof pe=="object"?"pty"in pe?rt.createExtensionTerminal(pe):rt.createTerminalFromOptions(pe):rt.createTerminal(pe,Ee,ze)},registerTerminalLinkProvider(pe){return rt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,Ee){return rt.registerProfileProvider(Ue,pe,Ee)},registerTerminalQuickFixProvider(pe,Ee){return(0,tt.$SF)(Ue,"terminalQuickFixProvider"),rt.registerTerminalQuickFixProvider(pe,Ue.identifier.value,Ee)},registerTreeDataProvider(pe,Ee){return bi.registerTreeDataProvider(pe,Ee,Ue)},createTreeView(pe,Ee){return bi.createTreeView(pe,Ee,Ue)},registerWebviewPanelSerializer:(pe,Ee)=>Ri.registerWebviewPanelSerializer(Ue,pe,Ee),registerCustomEditorProvider:(pe,Ee,ze={})=>cn.registerCustomEditorProvider(Ue,pe,Ee,ze),registerFileDecorationProvider(pe){return He.registerFileDecorationProvider(pe,Ue)},registerUriHandler(pe){return mi.registerUriHandler(Ue,pe)},createQuickPick(){return ri.createQuickPick(Ue)},createInputBox(){return ri.createInputBox(Ue)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(pe,Ee,ze){return Li.onDidChangeActiveColorTheme(pe,Ee,ze)},registerWebviewViewProvider(pe,Ee,ze){return Mi.registerWebviewViewProvider(Ue,pe,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,Ee,ze){return Ct.onDidChangeActiveNotebookEditor(pe,Ee,ze)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,Ee,ze){return $i.onDidChangeNotebookEditorSelection(pe,Ee,ze)},onDidChangeNotebookEditorVisibleRanges(pe,Ee,ze){return $i.onDidChangeNotebookEditorVisibleRanges(pe,Ee,ze)},showNotebookDocument(pe,Ee){return Ct.showNotebookDocument(pe,Ee)},registerExternalUriOpener(pe,Ee,ze){return(0,tt.$SF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,pe,Ee,ze)},registerProfileContentHandler(pe,Ee){return(0,tt.$SF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,pe,Ee)},registerQuickDiffProvider(pe,Ee,ze,at){return(0,tt.$SF)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt(pe),Ee,ze,at)},get tabGroups(){return re.tabGroups},registerShareProvider(pe,Ee){return(0,tt.$SF)(Ue,"shareProvider"),Hi.registerShareProvider(bt(pe),Ee)}},sn={get rootPath(){return Me.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(pe){throw new O.$9("rootPath")},getWorkspaceFolder(pe){return ft.getWorkspaceFolder(pe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(pe){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(pe){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(pe,Ee,...ze)=>ft.updateWorkspaceFolders(Ue,pe,Ee||0,...ze),onDidChangeWorkspaceFolders:function(pe,Ee,ze){return ft.onDidChangeWorkspace(pe,Ee,ze)},asRelativePath:(pe,Ee)=>ft.getRelativePath(pe,Ee),findFiles:(pe,Ee,ze,at)=>ft.findFiles(pe,Ee,ze,Ue.identifier,at),findTextInFiles:(pe,Ee,ze,at)=>{(0,tt.$SF)(Ue,"findTextInFiles");let pt,Ot;return typeof Ee=="object"?(pt=Ee,Ot=ze):(pt={},Ot=Ee,at=ze),ft.findTextInFiles(pe,pt||{},Ot,Ue.identifier,at)},save:pe=>((0,tt.$SF)(Ue,"saveEditor"),ft.save(pe)),saveAs:pe=>((0,tt.$SF)(Ue,"saveEditor"),ft.saveAs(pe)),saveAll:pe=>ft.saveAll(pe),applyEdit(pe,Ee){return Yt.applyWorkspaceEdit(pe,Ue,Ee)},createFileSystemWatcher:(pe,Ee,ze,at)=>{let pt;return typeof Ee=="boolean"?pt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!at,correlate:!1}:Ee&&((0,tt.$SF)(Ue,"createFileSystemWatcher"),pt={...Ee,correlate:!0}),xt.createFileSystemWatcher(ft,Ue,pe,pt)},get textDocuments(){return At.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new O.$9("textDocuments")},openTextDocument(pe){let Ee;const ze=pe;if(typeof pe=="string")Ee=Promise.resolve($.URI.file(pe));else if($.URI.isUri(pe))Ee=Promise.resolve(pe);else if(!ze||typeof ze=="object")Ee=At.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(at=>At.ensureDocumentData(at).then(pt=>pt.document))},onDidOpenTextDocument:(pe,Ee,ze)=>At.onDidAddDocument(pe,Ee,ze),onDidCloseTextDocument:(pe,Ee,ze)=>At.onDidRemoveDocument(pe,Ee,ze),onDidChangeTextDocument:(pe,Ee,ze)=>At.onDidChangeDocument(pe,Ee,ze),onDidSaveTextDocument:(pe,Ee,ze)=>At.onDidSaveDocument(pe,Ee,ze),onWillSaveTextDocument:(pe,Ee,ze)=>qi.getOnWillSaveTextDocumentEvent(Ue)(pe,Ee,ze),get notebookDocuments(){return Ct.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,Ee){let ze;if($.URI.isUri(pe))ze=pe,await Ct.openNotebookDocument(pe);else if(typeof pe=="string")ze=$.URI.revive(await Ct.createNotebookDocument({viewType:pe,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(pe,Ee,ze){return ni.onDidSaveNotebookDocument(pe,Ee,ze)},onDidChangeNotebookDocument(pe,Ee,ze){return ni.onDidChangeNotebookDocument(pe,Ee,ze)},onWillSaveNotebookDocument(pe,Ee,ze){return Ci.getOnWillSaveNotebookDocumentEvent(Ue)(pe,Ee,ze)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(pe,Ee,ze,at){return Ct.registerNotebookSerializer(Ue,pe,Ee,ze,(0,tt.$RF)(Ue,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(pe,Ee,ze)=>Xi.onDidChangeConfiguration(pe,Ee,ze),getConfiguration(pe,Ee){return Ee=arguments.length===1?void 0:Ee,Xi.getConfiguration(pe,Ee,Ue)},registerTextDocumentContentProvider(pe,Ee){return ki.registerTextDocumentContentProvider(pe,Ee)},registerTaskProvider:(pe,Ee)=>(Me.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ue,pe,Ee)),registerFileSystemProvider(pe,Ee,ze){return(0,P.$Pc)(Vi.registerFileSystemProvider(Ue,pe,Ee,ze),Pt.addFileSystemProvider(pe,Ee,ze))},get fs(){return Pt.value},registerFileSearchProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"fileSearchProvider"),jt.registerFileSearchProvider(pe,Ee)),registerTextSearchProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"textSearchProvider"),jt.registerTextSearchProvider(pe,Ee)),registerRemoteAuthorityResolver:(pe,Ee)=>((0,tt.$SF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(pe,Ee)),registerResourceLabelFormatter:pe=>((0,tt.$SF)(Ue,"resolvers"),Ki.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,tt.$SF)(Ue,"resolvers"),kt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,Ee,ze)=>xt.onDidCreateFile(pe,Ee,ze),onDidDeleteFiles:(pe,Ee,ze)=>xt.onDidDeleteFile(pe,Ee,ze),onDidRenameFiles:(pe,Ee,ze)=>xt.onDidRenameFile(pe,Ee,ze),onWillCreateFiles:(pe,Ee,ze)=>xt.getOnWillCreateFileEvent(Ue)(pe,Ee,ze),onWillDeleteFiles:(pe,Ee,ze)=>xt.getOnWillDeleteFileEvent(Ue)(pe,Ee,ze),onWillRenameFiles:(pe,Ee,ze)=>xt.getOnWillRenameFileEvent(Ue)(pe,Ee,ze),openTunnel:pe=>((0,tt.$SF)(Ue,"tunnels"),Rt.openTunnel(Ue,pe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$SF)(Ue,"tunnels"),Rt.getTunnels()},onDidChangeTunnels:(pe,Ee,ze)=>((0,tt.$SF)(Ue,"tunnels"),Rt.onDidChangeTunnels(pe,Ee,ze)),registerPortAttributesProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"portsAttributes"),Rt.registerPortsAttributesProvider(pe,Ee)),registerTunnelProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"tunnelFactory"),Rt.registerTunnelProvider(pe,Ee)),registerTimelineProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"timeline"),Gi.registerTimelineProvider(pe,Ee,Ue.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:pe=>((0,tt.$SF)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,Ee,ze)=>ft.onDidGrantWorkspaceTrust(pe,Ee,ze),registerEditSessionIdentityProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(pe,Ee)),onWillCreateEditSessionIdentity:(pe,Ee,ze)=>((0,tt.$SF)(Ue,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Ue)(pe,Ee,ze)),registerCanonicalUriProvider:(pe,Ee)=>((0,tt.$SF)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(pe,Ee)),getCanonicalUri:(pe,Ee,ze)=>((0,tt.$SF)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(pe,Ee,ze))},fn={get inputBox(){return Me.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Ue)},createSourceControl(pe,Ee,ze){return di.createSourceControl(Ue,pe,Ee,ze)},registerSourceControlInputBoxValueProvider(pe,Ee){return(0,tt.$SF)(Ue,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Ue,pe,Ee)}},on={createCommentController(pe,Ee){return Ai.createCommentController(Ue,pe,Ee)}},an={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession(pe,Ee,ze){return $t.onDidStartDebugSession(pe,Ee,ze)},onDidTerminateDebugSession(pe,Ee,ze){return $t.onDidTerminateDebugSession(pe,Ee,ze)},onDidChangeActiveDebugSession(pe,Ee,ze){return $t.onDidChangeActiveDebugSession(pe,Ee,ze)},onDidReceiveDebugSessionCustomEvent(pe,Ee,ze){return $t.onDidReceiveDebugSessionCustomEvent(pe,Ee,ze)},onDidChangeBreakpoints(pe,Ee,ze){return $t.onDidChangeBreakpoints(pe,Ee,ze)},onDidChangeStackFrameFocus(pe,Ee,ze){return(0,tt.$SF)(Ue,"debugFocus"),$t.onDidChangeStackFrameFocus(pe,Ee,ze)},registerDebugConfigurationProvider(pe,Ee,ze){return $t.registerDebugConfigurationProvider(pe,Ee,ze||Lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,Ee){return $t.registerDebugAdapterDescriptorFactory(Ue,pe,Ee)},registerDebugAdapterTrackerFactory(pe,Ee){return $t.registerDebugAdapterTrackerFactory(pe,Ee)},startDebugging(pe,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?$t.startDebugging(pe,Ee,{parentSession:ze}):$t.startDebugging(pe,Ee,ze||{})},stopDebugging(pe){return $t.stopDebugging(pe)},addBreakpoints(pe){return $t.addBreakpoints(pe)},removeBreakpoints(pe){return $t.removeBreakpoints(pe)},asDebugSourceUri(pe,Ee){return $t.asDebugSourceUri(pe,Ee)}},Ni={registerTaskProvider:(pe,Ee)=>Et.registerTaskProvider(Ue,pe,Ee),fetchTasks:pe=>Et.fetchTasks(pe),executeTask:pe=>Et.executeTask(Ue,pe),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(pe,Ee,ze)=>Et.onDidStartTask(pe,Ee,ze),onDidEndTask:(pe,Ee,ze)=>Et.onDidEndTask(pe,Ee,ze),onDidStartTaskProcess:(pe,Ee,ze)=>Et.onDidStartTaskProcess(pe,Ee,ze),onDidEndTaskProcess:(pe,Ee,ze)=>Et.onDidEndTaskProcess(pe,Ee,ze)},ji={createNotebookController(pe,Ee,ze,at,pt){return ai.createNotebookController(Ue,pe,Ee,ze,at,(0,tt.$RF)(Ue,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,Ee)=>Ct.registerNotebookCellStatusBarItemProvider(Ue,pe,Ee),createRendererMessaging(pe){return Di.createRendererMessaging(Ue,pe)},createNotebookControllerDetectionTask(pe){return(0,tt.$SF)(Ue,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Ue,pe)},registerKernelSourceActionProvider(pe,Ee){return(0,tt.$SF)(Ue,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Ue,pe,Ee)},onDidChangeNotebookCellExecutionState(pe,Ee,ze){return(0,tt.$SF)(Ue,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(pe,Ee,ze)}},zi={t(...pe){if(typeof pe[0]=="string"){const Ee=pe.shift(),ze=!pe||typeof pe[0]!="object"?pe:pe[0];return vt.getMessage(Ue.identifier.value,{message:Ee,args:ze})}return vt.getMessage(Ue.identifier.value,pe[0])},get bundle(){return vt.getBundle(Ue.identifier.value)},get uri(){return vt.getBundleUri(Ue.identifier.value)}},Si={_version:1,registerInteractiveEditorSessionProvider(pe,Ee){return(0,tt.$SF)(Ue,"interactive"),Ji.registerProvider(Ue,pe,Ee)},registerInteractiveSessionProvider(pe,Ee){return(0,tt.$SF)(Ue,"interactive"),gi.registerChatProvider(Ue,pe,Ee)},sendInteractiveRequestToProvider(pe,Ee){return(0,tt.$SF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(pe,Ee)},get onDidPerformUserAction(){return(0,tt.$SF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(pe,Ee){return(0,tt.$SF)(Ue,"interactive"),gi.transferChatSession(pe,Ee)}},Ui={getRelatedInformation(pe,Ee){return(0,tt.$SF)(Ue,"aiRelatedInformation"),Yi.getRelatedInformation(Ue,pe,Ee)},registerRelatedInformationProvider(pe,Ee){return(0,tt.$SF)(Ue,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ue,pe,Ee)},registerEmbeddingVectorProvider(pe,Ee){return(0,tt.$SF)(Ue,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ue,pe,Ee)}},gn={registerChatResponseProvider(pe,Ee,ze){return(0,tt.$SF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,pe,Ee,ze)},requestChatAccess(pe){return(0,tt.$SF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,pe)},registerVariable(pe,Ee,ze){return(0,tt.$SF)(Ue,"chatVariables"),Zi.registerVariableResolver(Ue,pe,Ee,ze)},registerMappedEditsProvider(pe,Ee){return(0,tt.$SF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,pe,Ee)},createChatAgent(pe,Ee){return(0,tt.$SF)(Ue,"chatAgents2"),Qi.createChatAgent(Ue,pe,Ee)}},mn={registerSpeechProvider(pe,Ee){return(0,tt.$SF)(Ue,"speech"),vi.registerProvider(Ue.identifier,pe,Ee)}};return{version:mt.version,ai:Ui,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:Si,l10n:zi,languages:nn,notebooks:ji,scm:fn,speech:mn,tasks:Ni,tests:en,window:rn,workspace:sn,Breakpoint:je.$GL,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatMessage:je.$yM,ChatMessageRole:je.ChatMessageRole,ChatVariableLevel:je.ChatVariableLevel,ChatAgentCompletionItem:je.$xM,CallHierarchyIncomingCall:je.$6K,CallHierarchyItem:je.$5K,CallHierarchyOutgoingCall:je.$7K,CancellationError:O.$5,CancellationTokenSource:D.$3d,CandidatePortSource:n.CandidatePortSource,CodeAction:je.$2K,CodeActionKind:je.$3K,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$8K,Color:je.$iL,ColorInformation:je.$jL,ColorPresentation:je.$kL,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$cL,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$dL,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$sL,DebugAdapterExecutable:je.$KL,DebugAdapterInlineImplementation:je.$NL,DebugAdapterNamedPipeServer:je.$ML,DebugAdapterServer:je.$LL,DebugConfigurationProviderTriggerKind:Lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$VK,DiagnosticRelatedInformation:je.$UK,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$HK,DocumentHighlight:je.$XK,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$YK,DocumentLink:je.$hL,DocumentSymbol:je.$1K,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$QL,InlineValueText:je.$RL,InlineValueVariableLookup:je.$SL,InlineValueEvaluatableExpression:je.$TL,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:g.$Sd,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$4L,FileDecoration2:je.$4L,FileSystemError:je.$VL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:je.$WL,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$IL,InlineCompletionItem:je.$eL,InlineCompletionList:je.$fL,Hover:je.$WK,IndentAction:C.IndentAction,Location:je.$TK,MarkdownString:je.$9K,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:je.$0K,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$IK,ProcessExecution:je.$qL,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$3L,Range:je.$JK,RelativePattern:je.$EL,Selection:je.$KK,SelectionRange:je.$4K,SemanticTokens:je.$ZL,SemanticTokensBuilder:je.$YL,SemanticTokensEdit:je.$1L,SemanticTokensEdits:je.$2L,SemanticTokensLegend:je.$XL,ShellExecution:je.$rL,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$_K,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$$K,SnippetString:je.$SK,SourceBreakpoint:je.$HL,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$ZK,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$tL,TaskGroup:je.$pL,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$lL,TerminalQuickFixTerminalCommand:je.$nL,TerminalQuickFixOpener:je.$mL,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$oL,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$OK,SnippetTextEdit:je.$QK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$DL,ThemeIcon:je.$CL,TreeItem:je.$uL,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$mM,UIKind:It.UIKind,Uri:$.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$RK,DocumentDropEdit:je.$AL,DocumentPasteEdit:je.$BL,InlayHint:je.$bL,InlayHintLabelPart:je.$aL,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$NK,ResolvedAuthority:je.$LK,ManagedResolvedAuthority:je.$MK,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$bM,NotebookRange:je.$6L,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$7L,NotebookData:je.$8L,NotebookRendererScript:je.$_L,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$0L,NotebookCellOutputItem:je.$9L,NotebookCellStatusBarItem:je.$$L,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$PK,NotebookKernelSourceAction:je.$aM,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$dM,LinkedEditingRanges:je.$cM,TestResultState:je.TestResultState,TestRunRequest:je.$eM,TestMessage:je.$fM,TestMessage2:je.$fM,TestTag:je.$gM,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:je.$zL,DataTransferItem:je.$vL,CoveredCount:je.$hM,FileCoverage:je.$iM,StatementCoverage:je.$jM,BranchCoverage:je.$kM,FunctionCoverage:je.$lM,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$nM,TabInputTextDiff:je.$oM,TabInputTextMerge:je.$pM,TabInputCustom:je.$qM,TabInputNotebook:je.$sM,TabInputNotebookDiff:je.$tM,TabInputWebview:je.$rM,TabInputTerminal:je.$uM,TabInputInteractiveWindow:je.$vM,TabInputChat:je.$wM,TelemetryTrustedValue:s.$uo,LogLevel:f.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:je.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$OL,ThreadFocus:je.$PL,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus}}}e.$Ugc=Vt}),define(Se[369],ke([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,57,117,90,70,150,14,58,115,116]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Hr)(u.$Jfc,u.$Ifc,1),(0,D.$Hr)(r.$jj,t.$Vgc,1),(0,D.$Hr)(f.$Uec,f.$Vec,1),(0,D.$Hr)(b.$6M,b.$5M,0),(0,D.$Hr)(M.$dfc,M.$bfc,0),(0,D.$Hr)(s.$ffc,s.$efc,0),(0,D.$Hr)(C.$Tfc,C.$Xfc,0),(0,D.$Hr)(P.$Zfc,P.$Yfc,0),(0,D.$Hr)($.$UM,$.$TM,0),(0,D.$Hr)(c.$Kfc,c.$Lfc,0),(0,D.$Hr)(i.$Rec,i.$Qec,0),(0,D.$Hr)(O.$tgc,O.$sgc,1),(0,D.$Hr)(m.$dgc,m.$egc,0),(0,D.$Hr)(v.$yfc,v.$xfc,0),(0,D.$Hr)(R.$Ggc,R.$Fgc,0),(0,D.$Hr)(y.$Bfc,y.$Efc,0),(0,D.$Hr)(k.$Yxb,k.$Zxb,0),(0,D.$Hr)(d.$Tgc,d.$Sgc,0),(0,D.$Hr)(g.$afc,g.$_ec,0),(0,D.$Hr)(n.$Gfc,n.$Ffc,0),(0,D.$Hr)(o.$4M,o.$1M,0),(0,D.$Hr)(a.$pfc,a.$qfc,0),(0,D.$Hr)(h.$Rfc,h.$Sfc,0)}),define(Se[119],ke([1,0,19,14,36,94]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=void 0;function M(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$_gc=M;function b(C,m,v,k){const f=(0,D.$2b)(v,$),d=new g.$8I(m,f,k),s=d.preview.matches;return{ranges:(0,D.$2b)(f,y),uri:C,preview:{text:d.preview.text,matches:(0,D.$2b)(s,y)}}}e.$ahc=b;function $(C){return new g.$9I(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new P.$WI(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(m,v){this.a=m,this.b=v}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$bhc=R,e.$bhc=R=Ge([We(1,O.$ij)],R)}),define(Se[370],ke([1,0,51,16,76,33,11,13,119,371]),function($e,e,D,O,g,P,M,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=e.$dhc=e.$chc=void 0;const R=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,o,a,t){const r=m(n,o,a,t),h=o.folder.fsPath;return{cmd:D.spawn(R,r.args,{cwd:h}),rgDiskPath:R,siblingClauses:r.siblingClauses,rgArgs:r,cwd:h}}e.$chc=C;function m(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];k([o],a,!1).forEach(u=>{const c=(0,$.$_gc)(u);if(r.push("-g",c),M.$j){const l=(0,g.$Al)(c);l!==c&&r.push("-g",l)}});const h=v([o],t,void 0,!1);return h.globArgs.forEach(u=>{const c=`!${(0,$.$_gc)(u)}`;if(r.push("-g",c),M.$j){const l=(0,g.$Al)(c);l!==c&&r.push("-g",l)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:h.siblingClauses}}function v(n,o,a,t=!0){const r=[];let h={};return n.forEach(u=>{const c=Object.assign({},u.excludePattern||{},o||{}),l=f(c,t?u.folder.fsPath:void 0,a);r.push(...l.globArgs),l.siblingClauses&&(h=Object.assign(h,l.siblingClauses))}),{globArgs:r,siblingClauses:h}}function k(n,o,a=!0){const t=[];return n.forEach(r=>{const h=Object.assign({},o||{},r.includePattern||{}),u=f(h,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function f(n,o,a){const t=[],r={};return Object.keys(n).forEach(h=>{if(a&&a.has(h)||!h)return;const u=n[h];h=s(o?d(o,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof u=="boolean"&&u?(h.startsWith("\\\\")&&(h+="**"),t.push(i(h))):u&&u.when&&(r[h]=u)}),{globArgs:t,siblingClauses:r}}function d(n,o){return O.$ic(o)?o:O.$jc(n,o)}e.$dhc=d;function s(n){return n=b.$Pe(n,"\\"),b.$Pe(n,"/")}function i(n){return P.$Yf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$ehc=i}),define(Se[372],ke([1,0,51,55,16,373,19,44,34,76,33,11,38,13,18,31,36,370,129]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$Hj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Jq)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$Hj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(c=>{const l=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),S=c.folder.fsPath;u.folderQueries.map(L=>L.folder.fsPath).filter(L=>L!==S).forEach(L=>{(0,R.$3f)(L,S)&&(l[g.$lc(S,L)]=!0)}),this.t.set(S,new t(l,S))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,c,l,S,L){if(this.m=m.$Od.create(!1),this.l)return L(null,this.j);c.forEach(w=>{const p=g.$nc(w.fsPath);this.u&&this.u(w.fsPath,p)||this.J(l,{relativePath:w.fsPath,searchPath:void 0})}),this.r=m.$Od.create(!1),this.w(u,(w,p)=>{this.x(this.y,this,w,l,S,E=>{if(E){const A=(0,b.$Li)(E);console.error(A),this.q.push(A),p(E,void 0)}else p(null,void 0)})},(w,p)=>{this.m.stop();const E=w?M.$Hb(w)[0]:null;L(E,this.j)})}w(u,c,l){const S=new Array(u.length),L=new Array(u.length);let w=!1,p=0;if(u.length===0)return l(null,[]);u.forEach((E,A)=>{c(E,(z,N)=>{if(z?(w=!0,S[A]=null,L[A]=z):(S[A]=N,L[A]=null),++p===u.length)return l(w?L:null,S)})})}x(u,c,...l){try{u.apply(c,l)}catch(S){l[l.length-1](S)}}y(u,c,l,S){const L=u.folder.fsPath,w=C.$j,p=()=>I&&I.kill();n.add(p);let E=W=>{n.delete(p),E=()=>{},S(W)},A="";const z=this.D(),N=(0,s.$chc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),I=N.cmd,j=!Object.keys(N.siblingClauses).length,T=N.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let F=`${N.rgDiskPath} ${T}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),l({message:F}),this.s=0,this.z(I,"utf8",l,(W,Y,le)=>{if(W){E(W);return}if(this.j){E();return}const Z=(A+(w?y.$zl(Y||""):Y)).split(`
`);if(le){const x=Z.length;Z[x-1]=Z[x-1].trim(),Z[x-1]||Z.pop()}else A=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=Z.length,j){for(const x of Z)if(this.J(c,{base:L,relativePath:x,searchPath:this.N(u,x)}),this.j){p();break}(le||this.j)&&E();return}this.G(u,z,L,Z,c),le&&(this.H(z,L,c),E())})}spawnFindCmd(u){const c=this.t.get(u.folder.fsPath),l=c.getBasenameTerms(),S=c.getPathTerms(),L=["-L","."];if(l.length||S.length){L.push("-not","(","(");for(const w of l)L.push("-name",w),L.push("-o");for(const w of S)L.push("-path",w),L.push("-o");L.pop(),L.push(")","-prune",")")}return L.push("-type","f"),D.spawn("find",L,{cwd:u.folder.fsPath})}readStdout(u,c,l){let S="";this.z(u,c,()=>{},(L,w,p)=>{if(L){l(L);return}S+=w,p&&l(null,S)})}z(u,c,l,S){let L=(E,A,z)=>{(E||z)&&(L=()=>{},this.r?.stop()),S(E,A,z)},w=!1;u.stdout?(this.A(u.stdout,c,L),u.stdout.once("data",()=>w=!0)):l({message:"stdout is null"});let p;u.stderr?p=this.B(u.stderr):l({message:"stderr is null"}),u.on("error",E=>{L(E)}),u.on("close",E=>{let A;!w&&(A=this.C(p,c))&&r(A)?L(new Error(`command failed with error code ${E}: ${this.C(p,c)}`)):(this.g&&E===0&&(this.j=!0),L(null,"",!0))})}A(u,c,l){const S=new P.StringDecoder(c);return u.on("data",L=>{l(null,S.write(L))}),S}B(u){const c=[];return u.on("data",l=>{c.push(l)}),c}C(u,c){const l=new P.StringDecoder(c);return u.map(S=>l.write(S)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:c},l,S,L){S.indexOf(this.b)!==-1&&this.J(L,{base:l,relativePath:this.b,searchPath:this.N(u,this.b)});const w=p=>{const E=g.$nc(p),A=g.$mc(p);let z=c[A];z||(z=c[A]=[],w(A)),z.push({base:l,relativePath:p,basename:E,searchPath:this.N(u,p)})};S.forEach(w)}H({rootEntries:u,pathToEntries:c},l,S){const L=this,w=this.t.get(l),p=this.b;function E(A){L.o++;const z=(0,d.$lJ)(()=>A.map(N=>N.basename));for(let N=0,I=A.length;N<I;N++){const j=A[N],{relativePath:T,basename:F}=j;if(w.test(T,F,p!==F?z:void 0))continue;const W=c[T];if(W)E(W);else{if(L.p++,T===p)continue;L.J(S,j)}if(L.j)break}}E(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,c,l,S,L){const w=u.folder,p=(0,d.$lJ)(()=>l);this.w(l,(E,A)=>{if(this.l||this.j)return A(null);const z=c?[c,E].join(g.sep):E;if(this.t.get(u.folder.fsPath).test(z,E,this.a.filePattern!==E?p:void 0))return A(null);const N=[w.fsPath,z].join(g.sep);O.lstat(N,(I,j)=>{if(I||this.l||this.j)return A(null);this.L(N,j,(T,F)=>T||this.l||this.j?A(null):F.isDirectory()?(this.o++,this.M(N,j,(W,Y)=>W||this.l||this.j||(Y=Y||"",this.v[Y])?A(null):(this.v[Y]=!0,f.Promises.readdir(N).then(le=>{if(this.l||this.j)return A(null);this.I(u,z,le,S,Q=>A(Q||null))},le=>{A(null)})))):(this.p++,z===this.b||this.h&&k.$Hf(F.size)&&F.size>this.h||this.J(S,{base:w.fsPath,relativePath:z,searchPath:this.N(u,z)}),A(null,void 0)))})},E=>{const A=E&&M.$Hb(E);return L(A&&A.length>0?A[0]:void 0)})}J(u,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$nc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(c))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.$gJ)(u,this.c)}return!0}L(u,c,l){return c.isSymbolicLink()?O.stat(u,l):l(null,c)}M(u,c,l){return c.isSymbolicLink()?O.realpath(u,(S,L)=>S?l(S):l(null,L)):l(null,u)}N(u,c){return u.folderName?g.$jc(u.folderName,c):c}}e.$fhc=o;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,c,l){this.c.walk(this.a,this.b,u,c,(S,L)=>{l(S,{limitHit:L,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$ghc=a;class t{constructor(u,c){this.expression=u,this.c=c,this.d(u)}d(u){let c,l;Object.keys(u).filter(S=>u[S]).forEach(S=>{g.$ic(S)?(c=c||$.$Cj(),c[S]=u[S]):(l=l||$.$Cj(),l[S]=u[S])}),this.a=c&&$.$Hj(c,{trimForExclusions:!0}),this.b=l&&$.$Hj(l,{trimForExclusions:!0})}test(u,c,l){return this.b&&this.b(u,c,l)||this.a&&this.a(g.$jc(this.c,u),c,l)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Jj(this.a)),this.b&&u.push(...$.$Jj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Kj(this.a)),this.b&&u.push(...$.$Kj(this.b)),u}}function r(h){const u=h.trim().split(`
`),c=u[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return v.$vf(u[u.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Se[374],ke([1,0,98,22,185,21]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.DecodeStreamErrorKind=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=void 0,e.$WC="utf8",e.$XC="utf8bom",e.$YC="utf16be",e.$ZC="utf16le";function M(c){return[e.$WC,e.$XC,e.$YC,e.$ZC].some(l=>l===c)}e.$1C=M,e.$2C=[254,255],e.$3C=[255,254],e.$4C=[239,187,191];const b=512,$=512,y=512*8,R=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(l,S){super(l),this.decodeStreamErrorKind=S}}e.$5C=m;class v{static async create(l){let S;if(l!==e.$WC)S=(await(0,g.$VC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(l));else{const L=new TextDecoder;S={write(w){return L.decode(w,{stream:!0})},end(){return L.decode()}}}return new v(S)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function k(c,l){const S=l.minBytesRequiredForDetection??l.guessEncoding?y:$;return new Promise((L,w)=>{const p=(0,D.$7d)(j=>j.join("")),E=[];let A=0,z;const N=new P.$3d,I=async()=>{try{const j=await u({buffer:O.$ge.concat(E),bytesRead:A},l.guessEncoding);if(j.seemsBinary&&l.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await l.overwriteEncoding(j.encoding),z=await v.create(j.encoding);const T=z.write(O.$ge.concat(E).buffer);p.write(T),E.length=0,A=0,L({stream:p,detected:j})}catch(j){N.cancel(),p.destroy(),w(j)}};(0,D.$$d)(c,{onData:async j=>{z?p.write(z.write(j.buffer)):(E.push(j),A+=j.byteLength,A>=S&&(c.pause(),await I(),setTimeout(()=>c.resume())))},onError:j=>p.error(j),onEnd:async()=>{z||await I(),p.end(z?.end())}},N.token)})}e.$6C=k;async function f(c,l,S){const w=(await(0,g.$VC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(l),S);let p=!1,E=!1;return{read(){if(E)return null;const A=c.read();if(typeof A!="string"){if(E=!0,!p&&S?.addBOM)switch(l){case e.$WC:case e.$XC:return O.$ge.wrap(Uint8Array.from(e.$4C));case e.$YC:return O.$ge.wrap(Uint8Array.from(e.$2C));case e.$ZC:return O.$ge.wrap(Uint8Array.from(e.$3C))}const z=w.end();return z&&z.length>0?(p=!0,O.$ge.wrap(z)):null}return p=!0,O.$ge.wrap(w.write(A))}}}e.$7C=f;async function d(c){return(await(0,g.$VC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.$8C=d;function s(c){return c===e.$XC||c===null?e.$WC:c}e.$9C=s;function i(c,l){if(!c||l<e.$2C.length)return null;const S=c.readUInt8(0),L=c.readUInt8(1);if(S===e.$2C[0]&&L===e.$2C[1])return e.$YC;if(S===e.$3C[0]&&L===e.$3C[1])return e.$ZC;if(l<e.$4C.length)return null;const w=c.readUInt8(2);return S===e.$4C[0]&&L===e.$4C[1]&&w===e.$4C[2]?e.$XC:null}e.$0C=i;const n=["ascii","utf-16","utf-32"];async function o(c){const l=await(0,g.$VC)("jschardet","dist/jschardet.min.js"),S=c.slice(0,R),L=r(S.buffer),w=l.detect(L);if(!w||!w.encoding)return null;const p=w.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(w.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const l=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[l]||l}function r(c){let l="";for(let S=0;S<c.length;S++)l+=String.fromCharCode(c[S]);return l}function h(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=c.match(/windows(\d+)/);return l?"windows-"+l[1]:c}}}e.$$C=h;function u({buffer:c,bytesRead:l},S){let L=i(c,l),w=!1;if(L!==e.$YC&&L!==e.$ZC&&c){let p=!0,E=!0,A=!1;for(let z=0;z<l&&z<b;z++){const N=z%2===1,I=c.readUInt8(z)===0;if(I&&(A=!0),p&&(N&&!I||!N&&I)&&(p=!1),E&&(N&&I||!N&&!I)&&(E=!1),I&&!p&&!E)break}A&&(p?L=e.$ZC:E?L=e.$YC:w=!0)}return S&&!w&&!L&&c?o(c.slice(0,l)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:w,encoding:L}}e.$_C=u,e.$aD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[155],ke([1,0,374,31,154]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class P extends g.$_fc{constructor(b,$,y=O,R="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$$C)(C)},R)}}e.$ohc=P}),define(Se[156],ke([1,0,51,390,373,19,73,34,16,13,2,36,94,391,371,119]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=e.$lhc=e.$khc=e.$jhc=e.$ihc=e.$hhc=void 0;const d=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(E){this.a=E}provideTextSearchResults(E,A,z,N){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...A,folder:A.folder.toString()})}`),new Promise((I,j)=>{N.onCancellationRequested(()=>x());const T=r(E,A),F=A.folder.fsPath,W=T.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${d} ${W}
 - cwd: ${F}`);let Y=D.spawn(d,T,{cwd:F});Y.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),j((0,C.$cJ)(new C.$aJ(H&&H.message,C.SearchErrorCode.rgProcessError)))});let le=!1;const Q=new o(A.maxResults,F,A.previewOptions);Q.on("result",H=>{le=!0,X="",z.report(H)});let Z=!1;const x=()=>{Z=!0,Y?.kill(),Q?.cancel()};let oe=!1;Q.on("hitLimit",()=>{oe=!0,x()});let X="";Y.stdout.on("data",H=>{Q.handleData(H),le||(X+=H)});let ve=!1;Y.stdout.once("data",()=>ve=!0);let ge="";Y.stderr.on("data",H=>{const U=H.toString();this.a.appendLine(U),ge.length+U.length<1e6&&(ge+=U)}),Y.on("close",()=>{if(this.a.appendLine(ve?"Got data from stdout":"No data from stdout"),this.a.appendLine(le?"Got result from parser":"No result from parser"),X&&this.a.appendLine(`Got data without result: ${X}`),this.a.appendLine(""),Z)I({limitHit:oe});else{Q.flush(),Y=null;let H;ge&&!ve&&(H=i(ge))?j((0,C.$cJ)(new C.$aJ(H.message,H.code))):I({limitHit:oe})}})})}}e.$hhc=s;function i(p){const E=p.split(`
`),A=E[0].trim();if(E.some(N=>N.startsWith("regex parse error")))return new C.$aJ(n(E),C.SearchErrorCode.regexParseError);const z=A.match(/grep config error: unknown encoding: (.*)/);if(z)return new C.$aJ(`Unknown encoding: ${z[1]}`,C.SearchErrorCode.unknownEncoding);if(A.startsWith("error parsing glob"))return new C.$aJ(A.charAt(0).toUpperCase()+A.substr(1),C.SearchErrorCode.globParseError);if(A.startsWith("the literal"))return new C.$aJ(A.charAt(0).toUpperCase()+A.substr(1),C.SearchErrorCode.invalidLiteral);if(A.startsWith("PCRE2: error compiling pattern"))return new C.$aJ(A,C.SearchErrorCode.regexParseError)}function n(p){const E=["Regex parse error"],A=p.filter(z=>z.startsWith("PCRE2:"));if(A.length>=1){const z=A[0].replace("PCRE2:","");if(z.indexOf(":")!==-1&&z.split(":").length>=2){const N=z.split(":")[1];E.push(":"+N)}}return E.join("")}class o extends O.EventEmitter{constructor(E,A,z){super(),this.g=E,this.h=A,this.j=z,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,A){return super.on(E,A),this}handleData(E){if(this.b)return;const A=typeof E=="string"?E:this.d.write(E);this.k(A)}k(E){let A=E.indexOf(`
`);const z=this.a+E;if(A>=0)A+=this.a.length;else{this.a=z;return}let N=0;for(;A>=0;)this.m(z.substring(N,A).trim()),N=A+1,A=z.indexOf(`
`,N);this.a=z.substring(N)}m(E){if(this.b||!E)return;let A;try{A=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(A.type==="match"){const z=a(A.data.path),N=R.URI.file($.$jc(this.h,z)),I=this.n(A.data,N);this.p(I),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(A.type==="context"){const z=a(A.data.path),N=R.URI.file($.$jc(this.h,z));this.o(A.data,N).forEach(j=>this.p(j))}}n(E,A){const z=E.line_number-1,N=a(E.lines),I=Buffer.from(N);let j=0,T=0,F=z;E.submatches.length===0&&E.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const W=(0,P.$Hb)(E.submatches.map((Y,le)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Q=a(Y.match),Z=I.slice(j,Y.start).toString(),x=t(Z),oe=x.numLines>0?x.lastLineLength:x.lastLineLength+T,X=t(Q),ve=x.numLines+F,ge=X.numLines+ve,H=X.numLines>0?X.lastLineLength:X.lastLineLength+oe;return j=Y.end,T=H,F=ge,new m.$WI(ve,oe,ge,H)}));return(0,f.$ahc)(A,N,W,this.j)}o(E,A){const z=a(E.lines),N=E.line_number;return z.replace(/\r?\n$/,"").split(`
`).map((I,j)=>({text:I,uri:A,lineNumber:N+j}))}p(E){this.emit("result",E)}}e.$ihc=o;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const E=/\n/g;let A=0,z=-1,N;for(;N=E.exec(p);)A++,z=N.index;const I=z>=0?p.length-z-1:p.length;return{numLines:A,lastLineLength:I}}function r(p,E){const A=["--hidden","--no-require-git"];A.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:z,otherIncludes:N}=(0,M.$K)(E.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(T=>{j.add(T)}),A.push("-g","!*"),j.forEach(T=>{h(T).map(f.$_gc).forEach(F=>{A.push("-g",F)})})}z&&z.length&&z.forEach(j=>{A.push("-g",j)}),E.excludes.map(f.$_gc).forEach(j=>A.push("-g",`!${j}`)),E.maxFileSize&&A.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||A.push("--no-ignore-parent"):A.push("--no-ignore"),E.followSymlinks&&A.push("--follow"),E.encoding&&E.encoding!=="utf8"&&A.push("--encoding",E.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,y.$Ke)(p.pattern),p.isRegExp=!0),E.usePCRE2&&A.push("--pcre2"),A.push("--crlf"),p.isRegExp&&(p.pattern=u(p.pattern),A.push("--engine","auto"));let I;if(p.isWordMatch){const T=(0,y.$Se)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");A.push("--regexp",T)}else if(p.isRegExp){let j=l(p.pattern);j=S(j),A.push("--regexp",j)}else I=p.pattern,A.push("--fixed-strings");return A.push("--no-config"),E.useGlobalIgnoreFiles||A.push("--no-ignore-global"),A.push("--json"),p.isMultiline&&A.push("--multiline"),E.beforeContext&&A.push("--before-context",E.beforeContext+""),E.afterContext&&A.push("--after-context",E.afterContext+""),A.push("--"),I&&A.push(I),A.push("."),A}e.$jhc=r;function h(p){return w(p).flatMap(A=>{const z=(0,b.$Fj)(A,"/");return z.map((N,I)=>z.slice(0,I+1).join("/"))})}function u(p){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");const A=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(A);)p=p.replace(A,"$1\\x{$2}");return p}e.$khc=u;const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function l(p){let E;try{E=new v.RegExpParser().parsePattern(p)}catch{return p}let A="",z=0;const N=(T,F,W)=>{A+=p.slice(z,T)+W,z=F},I=[];return new v.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const F=I[0];if(!F)N(T.start,T.end,"\\r?\\n");else if(!I.some(c))if(F.type==="CharacterClass")if(F.negate){const W=p.slice(F.start+2,T.start)+p.slice(T.end,F.end-1);F.parent?.type==="Quantifier"?N(F.start,F.end,W?`[^${W}]`:"."):N(F.start,F.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(F.start+1,T.start)+p.slice(T.end,F.end-1);N(F.start,F.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else F.type==="Quantifier"&&N(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){I.unshift(T)},onQuantifierLeave(){I.shift()},onCharacterClassRangeEnter(T){I.unshift(T)},onCharacterClassRangeLeave(){I.shift()},onCharacterClassEnter(T){I.unshift(T)},onCharacterClassLeave(){I.shift()},onAssertionEnter(T){c(T)&&I.push(T)},onAssertionLeave(T){I[0]===T&&I.shift()}}).visit(E),A+=p.slice(z),A}e.$lhc=l;function S(p){return p.replace(/\n/g,"\\r?\\n")}e.$mhc=S;function L(p){let E=!1,A=!1,z="",N="";for(let I=0;I<p.length;I++){const j=p[I];switch(j){case"\\":A?(E?N+="\\"+j:z+="\\"+j,A=!1):A=!0;break;case"{":if(A)E?N+=j:z+=j,A=!1;else{if(E)return{strInBraces:z+"{"+N+"{"+p.substring(I+1)};E=!0}break;case"}":if(A)E?N+=j:z+=j,A=!1;else{if(E)return{fixedStart:z,strInBraces:N,fixedEnd:p.substring(I+1)};z+=j}break;default:E?N+=(A?"\\":"")+j:z+=(A?"\\":"")+j,A=!1;break}}return{strInBraces:z+(E?"{"+N:"")}}function w(p){const{fixedStart:E,strInBraces:A,fixedEnd:z}=L(p);if(E===void 0||z===void 0)return[A];let N=(0,b.$Fj)(A,",");N.length||(N=[""]);const I=w(z);return N.flatMap(j=>{const T=E+j;return I.map(F=>T+F)})}e.$nhc=w}),define(Se[375],ke([1,0,21,156,85,17]),function($e,e,D,O,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class M{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,R,C,m){const v=new O.$hhc(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const k={...R,folder:R.folder.with({scheme:P.Schemas.file})},f=new g.$ev(d=>C.report({...d,uri:d.uri.with({scheme:R.folder.scheme})}));return this.c(m,d=>v.provideTextSearchResults(y,k,f,d))}else return this.c(m,k=>v.provideTextSearchResults(y,R,C,k))}async c(y,R){const C=b(y);this.a.add(C);const m=await R(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$rhc=M;function b($){const y=new D.$3d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(Se[376],ke([1,0,31,156,155]),function($e,e,D,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class P{constructor($){this.a=$}search($,y,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){R({message:v})}},m=new g.$ohc(this.a,new O.$hhc(C),D);return new Promise((v,k)=>m.search(f=>{y(f.map(M))},$).then(f=>v({limitHit:f.limitHit,type:"success",stats:f.stats}),k))}}e.$phc=P;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const R=y;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(Se[377],ke([1,0,19,12,8,4,129,16,38,2,32,36,372,376]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class k{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new P.$Sd({onDidAddFirstListener:()=>{a=(0,O.$Og)(h=>this.doFileSearchWithEngine(m.$ghc,t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new P.$Sd({onDidAddFirstListener:()=>{a=(0,O.$Og)(h=>this.f(t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new v.$phc(o).search(t,a,a)}g(){return{maxFileSize:16*R.$Rk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(m.$ghc,o,a,t)}doFileSearchWithEngine(o,a,t,r,h=k.a){let u=0;const c=S=>{Array.isArray(S)?(u+=S.length,t(S.map(L=>this.h(L)))):S.relativePath?(u++,t(this.h(S))):t(S)};if(a.sortByScore){let S=this.l(a,c,r);if(!S){const L=a.maxResults?Object.assign({},a,{maxResults:null}):a,w=new o(L);S=this.j(w,a,t,c,r)}return new Promise((L,w)=>{S.then(([p,E])=>{const A=E.map(z=>this.h(z));this.o(A,t,h),L(p)},w)})}const l=new o(a);return this.r(l,c,h,r).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,b.$jc)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,h){const u=new P.$Sd;let c=(0,O.$Og)(S=>{let L=[];const w=p=>{Array.isArray(p)?L=p:(r(p),u.fire(p))};return this.r(o,w,-1,S).then(p=>[p,L])}),l;if(a.cacheKey){l=this.k(a.cacheKey);const S={promise:c,event:u.event,resolved:!1};l.resultsToSearchCache[a.filePattern||""]=S,c.then(()=>{S.resolved=!0},L=>{delete l.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([S,L])=>{const w=l?l.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$Od.create(!1);return this.n(a,L,w,h).then(E=>{const A=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:A,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:E.length},messages:S.messages,limitHit:S.limitHit||typeof a.maxResults=="number"&&L.length>a.maxResults},E]})})}k(o){const a=this.b[o];return a||(this.b[o]=new f)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const h=this.q(r,o.filePattern||"",a,t);if(h)return h.then(([u,c,l])=>{const S=$.$Od.create(!1);return this.n(o,c,r.scorerCache,t).then(L=>{const w=S.elapsed(),p={fromCache:!0,detailStats:l,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&c.length>o.maxResults,stats:p},L]})})}n(o,a,t,r){const h=(0,M.$Jq)(o.filePattern||""),u=(l,S)=>(0,M.$Iq)(l,S,h,!0,d,t),c=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.$Gb(a,u,c,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const h=$.$Od.create(!1),u=a.indexOf(b.sep)>=0;let c;for(const w in o.resultsToSearchCache)if(a.startsWith(w)){if(u&&w.indexOf(b.sep)<0&&w!=="")continue;const p=o.resultsToSearchCache[w];c={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!c)return null;const l=h.elapsed(),S=$.$Od.create(!1),L=c.event(t);return r&&r.onCancellationRequested(()=>{L.dispose()}),c.promise.then(([w,p])=>{if(r&&r.isCancellationRequested)throw(0,g.$6)();const E=[],A=(0,M.$Jq)(a).normalizedLowercase;for(const z of p)(0,C.$gJ)(z,A)&&E.push(z);return[w,E,{cacheWasResolved:c.resolved,cacheLookupTime:l,cacheFilterTime:S.elapsed(),cacheEntryCount:p.length}]})}r(o,a,t,r){return new Promise((h,u)=>{let c=[];r?.onCancellationRequested(()=>o.cancel()),o.search(l=>{l&&(t?(c.push(l),t>0&&c.length>=t&&(a(c),c=[])):a(l))},l=>{a(l)},(l,S)=>{c.length&&a(c),l?u(l):h(S)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$qhc=k;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(n){return(0,b.$nc)(n.relativePath)}getItemDescription(n){return(0,b.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>y.URI.revive(o))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(Se[378],ke([1,0,3,17,2,31,14,27,20,97,66,36,377,375,119,155]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let d=class extends y.$egc{constructor(i,n,o,a){super(i,o,a),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Rc;const t=new k.$bhc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new v.$rhc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new k.$bhc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.file,new v.$rhc(i))),this.x.add(this.z(O.Schemas.file,new m.$qhc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,D.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,y.$fgc)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,C.$fJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>g.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new f.$ohc(i,n,void 0,"textSearchProvider")}};e.$shc=d,e.$shc=d=Ge([We(0,$.$JM),We(1,b.$ZM),We(2,R.$0ec),We(3,M.$ij)],d)}),define(Se[120],ke([1,0,392,62,63,393,22,8,4,3,16,11,30,81,82]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class f{traceSocketEvent(p,E){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,E)}constructor(p,E=""){this.f=!0,this.debugLabel=E,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,b.$1)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const E=A=>{this.traceSocketEvent("read",A),p(M.$ge.wrap(A))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){const E=A=>{p({type:0,hadError:A,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(p){const E=()=>{p()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$Ph=f;var d;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var s;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(s||(s={}));class i extends y.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,E){this.socket.traceSocketEvent(p,E)}constructor(p,E,A,z){super(),this.f=this.B(new $.$Sd),this.g=this.B(new $.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:A?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new n(this,E,A,z,this.f,(N,I)=>this.m(N,I))),this.B(this.a.onError(N=>{console.error(N),(0,b.$1)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new k.$Kh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let E=0;for(;E<p.byteLength;)this.a.writeMessage(p.slice(E,Math.min(E+262144,p.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(p,{compressed:E,opcode:A}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let z=2;p.byteLength<126?z+=0:p.byteLength<2**16?z+=2:z+=8;const N=M.$ge.alloc(z),I=E?64:0,j=A&15;if(N.writeUInt8(128|I|j,0),p.byteLength<126)N.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){N.writeUInt8(126,1);let T=1;N.writeUInt8(p.byteLength>>>8&255,++T),N.writeUInt8(p.byteLength>>>0&255,++T)}else{N.writeUInt8(127,1);let T=1;N.writeUInt8(0,++T),N.writeUInt8(0,++T),N.writeUInt8(0,++T),N.writeUInt8(0,++T),N.writeUInt8(p.byteLength>>>24&255,++T),N.writeUInt8(p.byteLength>>>16&255,++T),N.writeUInt8(p.byteLength>>>8&255,++T),N.writeUInt8(p.byteLength>>>0&255,++T)}this.socket.write(M.$ge.concat([N,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),A=E.readUInt8(0),z=(A&128)>>>7,N=(A&64)>>>6,I=A&15,j=E.readUInt8(1),T=(j&128)>>>7,F=j&127;this.j.state=2,this.j.readLen=2+(T?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=I,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),A=E.readUInt8(1),z=(A&128)>>>7;let N=A&127,I=1;N===126?N=E.readUInt8(++I)*2**8+E.readUInt8(++I):N===127&&(N=E.readUInt8(++I)*0+E.readUInt8(++I)*0+E.readUInt8(++I)*0+E.readUInt8(++I)*0+E.readUInt8(++I)*2**24+E.readUInt8(++I)*2**16+E.readUInt8(++I)*2**8+E.readUInt8(++I));let j=0;z&&(j=E.readUInt8(++I)*2**24+E.readUInt8(++I)*2**16+E.readUInt8(++I)*2**8+E.readUInt8(++I)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Qh=i;class n extends y.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$ge.alloc(0)}constructor(p,E,A,z,N,I){super(),this.n=p,this.r=N,this.s=I,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,z,A,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(p,E){this.g.push({data:p,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:E}=this.g.shift();if(this.f&&E.compressed){const A=await this.w(this.f,p);this.s(A,E)}else this.s(p,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,E){return new Promise((A,z)=>{p.write(E),p.flush(N=>A(N))})}acceptFrame(p,E,A){this.h.push({data:p,isCompressed:E,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const E=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,E,A){return new Promise((z,N)=>{p.write(E),A&&p.write(M.$ge.fromByteArray([0,0,255,255])),p.flush(I=>z(I))})}}class o extends y.$Sc{get recordedInflateBytes(){return this.j?M.$ge.concat(this.f):M.$ge.alloc(0)}constructor(p,E,A,z){super(),this.h=p,this.j=E,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(z),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(M.$ge.wrap(N))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=M.$ge.concat(this.g);this.g.length=0,p(E)})}}class a extends y.$Sc{constructor(p,E){super(),this.g=p,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(M.$ge.wrap(A))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=M.$ge.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),p(E)})}}function t(w,p){if(p===0)return;const E=w.byteLength>>>2;for(let T=0;T<E;T++){const F=w.readUInt32BE(T*4);w.writeUInt32BE(F^p,T*4)}const A=E*4,z=w.byteLength-A,N=p>>>24&255,I=p>>>16&255,j=p>>>8&255;z>=1&&w.writeUInt8(w.readUInt8(A)^N,A),z>=2&&w.writeUInt8(w.readUInt8(A+1)^I,A+1),z>=3&&w.writeUInt8(w.readUInt8(A+2)^j,A+2)}e.$Rh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function h(){const w=(0,m.$lg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const p=process.platform!=="darwin"&&e.$Rh?e.$Rh:(0,g.tmpdir)(),E=(0,R.$jc)(p,`vscode-ipc-${w}.sock`);return c(E),E}e.$Sh=h;function u(w,p,E){const A=(0,D.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${E}-${p}-sock`;const z=E.substr(0,4),N=p.substr(0,6),I=A.substr(0,8);let j;return process.platform!=="darwin"&&e.$Rh&&!process.env.VSCODE_PORTABLE?j=(0,R.$jc)(e.$Rh,`vscode-${I}-${z}-${N}.sock`):j=(0,R.$jc)(w,`${z}-${N}.sock`),c(j),j}e.$Th=u;function c(w){const p=r[C.$u];typeof p=="number"&&w.length>=p&&console.warn(`WARNING: IPC handle "${w}" is longer than ${p} chars, try a shorter --user-data-dir`)}class l extends v.$Eh{static b(p){const E=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(E,A=>({protocol:new k.$Lh(new f(A,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(A,"close"))}))}constructor(p){super(l.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Uh=l;function S(w){return new Promise((p,E)=>{const A=(0,O.createServer)();A.on("error",E),A.listen(w,()=>{A.removeListener("error",E),p(new l(A))})})}e.$Vh=S;function L(w,p){return new Promise((E,A)=>{const z=(0,O.createConnection)(w,()=>{z.removeListener("error",A),E(k.$Mh.fromSocket(new f(z,`ipc-client${p}`),p))});z.once("error",A)})}e.$Wh=L}),define(Se[379],ke([1,0,62,63,165,120,12,3,11,45,14,136,256,257,109,88,22]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=e.$R0b=e.$Q0b=e.$P0b=void 0;async function s(t,r,h,u,c){let l;for(let S=3;S&&(l?.dispose(),l=await new i(t,r,h,u,c).waitForReady(),!(c&&g.$og[c]||!g.$og[l.tunnelLocalPort]));S--);return l}class i extends b.$Sc{constructor(r,h,u,c,l){super(),this.m=h,this.n=l,this.privacy=f.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new M.$Zg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,h=(0,f.$qv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,g.$pg)(r,2,1e3,h),c=null;return this.b.listen(u,this.m),await this.c.wait(),c=this.b.address(),c||(u=0,this.b.listen(u,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const h=(0,f.$ov)(this.tunnelRemoteHost)||(0,f.$qv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.$el)(this.a,h,this.tunnelRemotePort),c=u.getSocket(),l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&r.write(l.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof P.$Ph?c.socket.destroy():c.end()}),c instanceof P.$Ph?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,h){h.onClose(()=>r.destroy()),h.onEnd(()=>r.end()),h.onData(u=>r.write(u.buffer)),r.on("data",u=>h.write(d.$ge.wrap(u))),r.resume()}t(r,h){const u=h.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$P0b=i;let n=class extends f.$tv{constructor(r,h,u,c,l){super(h,l),this.u=r,this.v=u,this.w=c}isPortPrivileged(r){return(0,f.$rv)(r,this.l,$.OS,O.release())}s(r,h,u,c,l,S,L,w){const p=this.r(h,u);if(p)return++p.refcount,p.value;if((0,f.$lv)(r))return this.t(r,h,u,l,S,L,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${u} on local port ${l}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},A=s(E,c,h,u,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(h,u,A),A}}};e.$Q0b=n,e.$Q0b=n=Ge([We(0,v.$$k),We(1,R.$ij),We(2,k.$bl),We(3,C.$Aj),We(4,y.$ui)],n);let o=class extends n{constructor(r,h,u,c,l){super(r,h,u,c,l)}};e.$R0b=o,e.$R0b=o=Ge([We(0,v.$$k),We(1,R.$ij),We(2,k.$bl),We(3,C.$Aj),We(4,y.$ui)],o);let a=class extends b.$Sc{constructor(r,h,u,c,l){super(),this.b=r,this.c=h,this.f=u,this.g=c,this.h=l,this.a=new Map}async openTunnel(r,h,u,c,l,S,L,w,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${c} on local port ${S}.`),!this.a.has(r)){const E=new o(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(h,u,c,l,S,L,w,p)}};e.$S0b=a,e.$S0b=a=Ge([We(0,v.$$k),We(1,R.$ij),We(2,C.$Aj),We(3,k.$bl),We(4,y.$ui)],a)}),define(Se[380],ke([1,0,120,276,55,35,2,14,40]),function($e,e,D,O,g,P,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=void 0;class y{constructor(m,v,k){this.b=m,this.c=v,this.f=k,this.a=O.createServer((f,d)=>this.h(f,d)),this.g().catch(f=>(v.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,v){const k=(d,s)=>{v.writeHead(d,{"content-type":"application/json"}),v.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},f=[];m.setEncoding("utf8"),m.on("data",d=>f.push(d)),m.on("end",async()=>{try{const d=JSON.parse(f.join(""));let s;switch(d.type){case"open":s=await this.i(d);break;case"openExternal":s=await this.j(d);break;case"status":s=await this.l(d);break;case"extensionManagement":s=await this.k(d);break;default:k(404,`Unknown message type: ${d.type}`);break}k(200,s)}catch(d){const s=d instanceof Error?d.message:JSON.stringify(d);k(500,s),this.c.error("Error while processing pipe request",d)}})}async i(m){const{fileURIs:v,folderURIs:k,forceNewWindow:f,diffMode:d,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=m,r=[];if(Array.isArray(k))for(const l of k)try{r.push({folderUri:M.URI.parse(l)})}catch{}if(Array.isArray(v))for(const l of v)try{(0,$.$ti)(l)?r.push({workspaceUri:M.URI.parse(l)}):r.push({fileUri:M.URI.parse(l)})}catch{}const h=a?M.URI.file(a):void 0,c={forceNewWindow:f,diffMode:d,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!h&&!i,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j(m){for(const v of m.uris){const k=M.URI.parse(v),f=k.scheme==="file"?k:v;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(m){const v=f=>f?.map(d=>/\.vsix$/i.test(d)?M.URI.parse(d):d),k={list:m.list,install:v(m.install),uninstall:v(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$$M=y;let R=class extends y{constructor(m,v){super(m,v,(0,D.$Sh)())}};e.$_M=R,e.$_M=R=Ge([We(0,P.$6M),We(1,b.$ij)],R)}),define(Se[381],ke([1,0,56,368,363,275,48,348,2,17,7,380,103,346,347]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class f extends g.$Ygc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(h,u,c){return h=t(h),i.a.has(h)?i.a.get(h).load(h,$.URI.file((0,m.$gq)(u.filename)),l=>o.apply(this,[l,u,c])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,h)=>a.call(this,t(r),h);const t=r=>{for(const h of i.b){const u=h(r);if(u){r=u;break}}return r}}}class d extends M.$Nfc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$vhc);const i=this.h.invokeFunction(O.$Ugc);if(this.h.createInstance(b.$uhc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$_M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(k.$whc),await this.h.createInstance(f,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,P.$thc)(this.j,o,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=$e.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$xhc=d}),define(Se[382],ke([1,0,51,22,4,3,122,11,23,2,31,14,255,64,109,88,379,27,20,72,357]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;function a(p){const E=p.trim().split(`
`),A=[];return E.forEach(N=>{const I=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);I&&I.length>=3&&A.push({pid:parseInt(I[1],10),socket:parseInt(I[2],10)})}),A.reduce((N,I)=>(N[I.socket]=I,N),{})}e.$yhc=a;function t(...p){const E=[].concat(...p.map(h));return[...new Map(E.filter(A=>A.st==="0A").map(A=>{const z=A.local_address.split(":");return{socket:parseInt(A.inode,10),ip:r(z[0]),port:parseInt(z[1],16)}}).map(A=>[A.ip+":"+A.port,A])).values()]}e.$zhc=t;function r(p){let E="";if(p.length===8)for(let A=p.length-2;A>=0;A-=2)E+=parseInt(p.substr(A,2),16),A!==0&&(E+=".");else for(let A=0;A<p.length;A+=8){const z=p.substring(A,A+8);let N="";for(let I=8;I>=2;I-=2)N+=z.substring(I-2,I),(I===6||I===2)&&(N=parseInt(N,16).toString(16),E+=`${N}`,N="",A+I!==p.length-6&&(E+=":"))}return E}e.$Ahc=r;function h(p){const E=p.trim().split(`
`),A=E.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return E.map(N=>N.trim().split(/\s+/).reduce((I,j,T)=>(I[A[T]||T]=j,I),{}))}e.$Bhc=h;function u(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function c(p){const E=p.trim().split(`
`),A=[];return E.forEach(z=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(z);N&&N.length>=4&&A.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),A}e.$Chc=c;async function l(p,E,A){const z=A.reduce((I,j)=>(I[j.pid]=j,I),{}),N=[];return p.forEach(({socket:I,ip:j,port:T})=>{const F=E[I]?E[I].pid:void 0,W=F?z[F]?.cmd:void 0;F&&W&&!u(W)&&N.push({host:j,port:T,detail:W,pid:F})}),N}e.$Dhc=l;function S(p,E,A){const z=new Map,N=c(E);for(const I of p){const j=A.get(I.port);if(j){z.set(I.port,j);continue}const T=N.find(F=>F.cmd.includes(`${I.port}`));if(T){let F=T,W;do W=N.find(Y=>Y.ppid===F.pid),W&&(F=W);while(W);z.set(I.port,{host:I.ip,port:I.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else z.set(I.port,{host:I.ip,port:I.port,ppid:Number.MAX_VALUE})}return z}e.$Ehc=S;let L=class extends n.$Zxb{constructor(E,A,z,N){super(E,A,z),this.D=A,this.F=N,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&A.remote.isRemote&&A.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let A;this.y&&(A=this.y,await this.a.$onFoundNewCandidates(this.y));const z=new M.$3l;let N=0;for(;this.C;){const I=new Date().getTime(),j=(await this.I()).filter(W=>(0,f.$ov)(W.host)||(0,f.$qv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(W=>W.port).join(", ")}`);const T=new Date().getTime()-I;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${T} ms.`),N++>3&&z.update(T),(!A||JSON.stringify(A)!==JSON.stringify(j))&&(A=j,await this.a.$onFoundNewCandidates(A));const F=this.G(z.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(W=>setTimeout(()=>W(),F))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",A="";try{E=await R.Promises.readFile("/proc/net/tcp","utf8"),A=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const z=t(E,A),N=await new Promise(Q=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,x,oe)=>{Q(x)})}),I=a(N),j=await R.Promises.readdir("/proc"),T=[];for(const Q of j)try{const Z=Number(Q),x=$.$Cg(y.URI.file("/proc"),Q);if((await R.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(Z)){const X=await R.Promises.readlink($.$Cg(x,"cwd").fsPath),ve=await R.Promises.readFile($.$Cg(x,"cmdline").fsPath,"utf8");T.push({pid:Z,cwd:X,cmd:ve})}}catch{}const F=[],W=z.filter(Q=>{const Z=I[Q.socket];return Z||F.push(Q),Z}),Y=l(W,I,T);let le;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const Q=await new Promise(Z=>{(0,D.exec)("ps -F -A -l | grep root",(x,oe,X)=>{Z(oe)})});this.z=S(F,Q,this.z),le=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${le.map(Z=>Z.port).join(", ")}`)}return Y.then(Q=>le?Q.concat(le):Q)}w(E){return async A=>{const z=new d.$P0b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(I,j,T,F){const W=await E.makeConnection();return w.connect(W,j,T,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$2k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",A.remoteAddress.host||"localhost",A.remoteAddress.port,A.localAddressPort);await z.waitForReady();const N=new g.$Sd;return{localAddress:(0,o.$6J)(z.localAddress)??z.localAddress,remoteAddress:{port:z.tunnelRemotePort,host:z.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{z.dispose(),N.fire(),N.dispose()}}}}};e.$Fhc=L,e.$Fhc=L=Ge([We(0,i.$JM),We(1,s.$ZM),We(2,C.$ij),We(3,k.$bl)],L);class w extends m.$5qb{static connect(E,A,z,N){const I=new P.$Rc,j={onClose:I.add(new g.$Sd),onData:I.add(new g.$Sd),onEnd:I.add(new g.$Sd)};I.add(E.onDidReceiveMessage(F=>j.onData.fire(O.$ge.wrap(F)))),I.add(E.onDidEnd(()=>j.onEnd.fire())),I.add(E.onDidClose(F=>j.onClose.fire({type:0,error:F,hadError:!!F})));const T=new w(E,N,j);return T.B(I),(0,m.$4qb)(T,A,z,N,j)}constructor(E,A,z){super(A,z),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[383],ke([1,0,106,351,366,365,378,381,382,96,48,97,95,47,72,92,350,349,14,367,58,270,105,109,138]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Hr)(R.$Ofc,b.$xhc,0),(0,D.$Hr)(i.$jj,s.$Hhc,1),(0,D.$Hr)(i.$ij,new t.$Xh(a.$Xgc,[!1],!0)),(0,D.$Hr)(r.$bl,h.$U0b,1),(0,D.$Hr)(f.$gfc,d.$Ghc,0),(0,D.$Hr)(y.$Tfc,P.$$gc,0),(0,D.$Hr)(C.$dgc,M.$shc,0),(0,D.$Hr)(m.$Ggc,g.$3gc,0),(0,D.$Hr)(v.$Bfc,O.$2gc,0),(0,D.$Hr)(k.$Yxb,$.$Fhc,0),(0,D.$Hr)(o.$Rfc,n.$Ihc,0)}),define(Se[394],ke([1,0,62,395,56,8,82,120,253,114,364,22,31,103,12,132,277,291,369,383]),function($e,e,D,O,g,P,M,b,$,y,R,C,m,v,k,f,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const i=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,l=c._load;c._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const n=process.exit.bind(process);function o(c){process.exit=function(l){if(c)n(l);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,s.$Mm)(process.env);if(c.type===3)return new Promise((l,S)=>{const L=w=>{const p=w[0],E=new M.$Nh;p.on("message",A=>E.fire(C.$ge.wrap(A.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),l({onMessage:E.event,send:A=>p.postMessage(A.buffer)})};process.parentPort.on("message",w=>L(w.ports))});if(c.type===2)return new Promise((l,S)=>{let L=null;const w=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,E=3e5,A=new k.$bh(()=>a("renderer disconnected for too long (1)"),p),z=new k.$bh(()=>a("renderer disconnected for too long (2)"),E);process.on("message",(I,j)=>{if(I&&I.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const T=C.$ge.wrap(Buffer.from(I.initialDataChunk,"base64"));let F;if(I.skipWebSocketFrames)F=new b.$Ph(j,"extHost-socket");else{const W=C.$ge.wrap(Buffer.from(I.inflateBytes,"base64"));F=new b.$Qh(new b.$Ph(j,"extHost-socket"),I.permessageDeflate,W,!1)}L?(A.cancel(),z.cancel(),L.beginAcceptReconnection(F,T),L.endAcceptReconnection(),L.sendResume()):(clearTimeout(w),L=new M.$Oh({socket:F,initialChunk:T}),L.sendResume(),L.onDidDispose(()=>a("renderer disconnected")),l(L),L.onSocketClose(()=>{A.schedule()}))}if(I&&I.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;A.isScheduled()&&z.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const l=c.pipeName;return new Promise((S,L)=>{const w=D.createConnection(l,()=>{w.removeListener("error",L);const p=new M.$Oh({socket:new b.$Ph(w,"extHost-renderer")});p.sendResume(),S(p)});w.once("error",L),w.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new M.$Nh,this.onMessage=this.a.event,this.b=!1,c.onMessage(l=>{(0,y.$nm)(l,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||c.send(l)}async drain(){if(c.drain)return c.drain()}}}function h(c){return new Promise(l=>{const S=c.onMessage(L=>{S.dispose();const w=JSON.parse(L.toString()),p=w.commit,E=$.default.commit;if(p&&E&&p!==E&&n(55),w.parentPid){let A=0;setInterval(function(){try{process.kill(w.parentPid,0),A=0}catch(N){N&&N.code==="EPERM"?(A++,A>=3&&a(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):a(`parent process ${w.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(w.parentPid)}catch(N){(0,P.$1)(N)}}c.send((0,y.$mm)(0)),l({protocol:c,initData:w})});c.send((0,y.$mm)(1))})}async function u(){const c=[];process.on("unhandledRejection",(A,z)=>{c.push(z),setTimeout(()=>{const N=c.indexOf(z);N>=0&&z.catch(I=>{c.splice(N,1),(0,P.$4)(I)||(console.warn(`rejected promise not handled within 1 second: ${I}`),I&&I.stack&&console.warn(`stack trace: ${I.stack}`),A&&(0,P.$1)(A))})},1e3)}),process.on("rejectionHandled",A=>{const z=c.indexOf(A);z>=0&&c.splice(z,1)}),process.on("uncaughtException",function(A){(0,P.$Z)(A)||(0,P.$1)(A)}),g.mark("code/extHost/willConnectToRenderer");const l=await r();g.mark("code/extHost/didConnectToRenderer");const S=await h(l);g.mark("code/extHost/didWaitForInitData");const{initData:L}=S;o(!!L.environment.extensionTestsLocationURI),L.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,L.environment.skipWorkspaceStorageLock=(0,f.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return m.Promises.exists(z)}fsRealpath(z){return(0,v.$fq)(z)}};let p=null;L.remote.authority&&i.transformURIs&&(p=(0,d.$Lr)(L.remote.authority));const E=new R.$1gc(S.protocol,L,w,p);a=A=>E.terminate(A)}u().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f6b7ba78b8850751f083306b8f5d745c8a0ddcf/core/vs/workbench/api/node/extensionHostProcess.js.map
