/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(pe){for(var e=[],E=0,T=pe.length;E<T;E++)e[E]=Pe[pe[E]];return e};define(Pe[66],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=void 0;function E(R){return(m,g,w)=>{let A=null,k=null;if(typeof w.value=="function"?(A="value",k=w.value):typeof w.get=="function"&&(A="get",k=w.get),!k)throw new Error("not supported");w[A]=R(k,g)}}function T(R,m,g){let w=null,A=null;if(typeof g.value=="function"?(w="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",A=g.get),!A)throw new Error("not supported");const k=`$memoize$${m}`;g[w]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$sh=T;function C(R,m,g){return E((w,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...$){this[l]||(this[l]=g?g():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[k]=setTimeout(()=>{w.apply(this,$),this[l]=g?g():void 0},R)}})}e.$th=C;function F(R,m,g){return E((w,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,$=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...a){if(this[l]||(this[l]=g?g():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...a)),this[v])return;const s=this[$]+R;s<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[v]=!0,this[k]=setTimeout(()=>{this[v]=!1,this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},s-Date.now()))}})}e.$uh=F}),define(Pe[89],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0;class E{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$OM=E,e.$PM=new E("id#")}),define(Pe[119],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(i,r=!1){let u=0;const d=i.length;let b="",f=0,D=16,L=0;function p(U){let P=0,I=0;for(;P<U;){const Z=i.charCodeAt(u);if(Z>=48&&Z<=57)I=I*16+Z-48;else if(Z>=65&&Z<=70)I=I*16+Z-65+10;else if(Z>=97&&Z<=102)I=I*16+Z-97+10;else break;u++,P++}return P<U&&(I=-1),I}function y(U){u=U,b="",f=0,D=16,L=0}function S(){const U=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return L=3,i.substring(U,u);let P=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;P=u}else L=3;return i.substring(U,P)}function N(){let U="",P=u;for(;;){if(u>=d){U+=i.substring(P,u),L=2;break}const I=i.charCodeAt(u);if(I===34){U+=i.substring(P,u),u++;break}if(I===92){if(U+=i.substring(P,u),u++,u>=d){L=2;break}switch(i.charCodeAt(u++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ue=p(4);ue>=0?U+=String.fromCharCode(ue):L=4;break}default:L=5}P=u;continue}if(I>=0&&I<=31)if(g(I)){U+=i.substring(P,u),L=2;break}else L=6;u++}return U}function q(){if(b="",L=0,f=u,u>=d)return f=d,D=17;let U=i.charCodeAt(u);if(m(U)){do u++,b+=String.fromCharCode(U),U=i.charCodeAt(u);while(m(U));return D=15}if(g(U))return u++,b+=String.fromCharCode(U),U===13&&i.charCodeAt(u)===10&&(u++,b+=`
`),D=14;switch(U){case 123:return u++,D=1;case 125:return u++,D=2;case 91:return u++,D=3;case 93:return u++,D=4;case 58:return u++,D=6;case 44:return u++,D=5;case 34:return u++,b=N(),D=10;case 47:{const P=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return b=i.substring(P,u),D=12}if(i.charCodeAt(u+1)===42){u+=2;const I=d-1;let Z=!1;for(;u<I;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,Z=!0;break}u++}return Z||(u++,L=1),b=i.substring(P,u),D=13}return b+=String.fromCharCode(U),u++,D=16}case 45:if(b+=String.fromCharCode(U),u++,u===d||!w(i.charCodeAt(u)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=S(),D=11;default:for(;u<d&&j(U);)u++,U=i.charCodeAt(u);if(f!==u){switch(b=i.substring(f,u),b){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return b+=String.fromCharCode(U),u++,D=16}}function j(U){if(m(U)||g(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=q();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>u,scan:r?M:q,getToken:()=>D,getTokenValue:()=>b,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>L}}e.$6m=R;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function k(i,r){const u=[],d=new Object;let b;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function L(p,y,S,N){f.value=p,f.offset=y,f.length=S,f.type=N,f.colonOffset=void 0,b=f}try{o(i,{onObjectBegin:(p,y)=>{if(r<=p)throw d;b=void 0,D=r>p,u.push("")},onObjectProperty:(p,y,S)=>{if(r<y||(L(p,y,S,"property"),u[u.length-1]=p,r<=y+S))throw d},onObjectEnd:(p,y)=>{if(r<=p)throw d;b=void 0,u.pop()},onArrayBegin:(p,y)=>{if(r<=p)throw d;b=void 0,u.push(0)},onArrayEnd:(p,y)=>{if(r<=p)throw d;b=void 0,u.pop()},onLiteralValue:(p,y,S)=>{if(r<y||(L(p,y,S,h(p)),r<=y+S))throw d},onSeparator:(p,y,S)=>{if(r<=y)throw d;if(p===":"&&b&&b.type==="property")b.colonOffset=y,D=!1,b=void 0;else if(p===","){const N=u[u.length-1];typeof N=="number"?u[u.length-1]=N+1:(D=!0,u[u.length-1]=""),b=void 0}}})}catch(p){if(p!==d)throw p}return{path:u,previousNode:b,isAtPropertyKey:D,matches:p=>{let y=0;for(let S=0;y<p.length&&S<u.length;S++)if(p[y]===u[S]||p[y]==="*")y++;else if(p[y]!=="**")return!1;return y===p.length}}}e.$7m=k;function l(i,r=[],u=F.DEFAULT){let d=null,b=[];const f=[];function D(p){Array.isArray(b)?b.push(p):d!==null&&(b[d]=p)}return o(i,{onObjectBegin:()=>{const p={};D(p),f.push(b),b=p,d=null},onObjectProperty:p=>{d=p},onObjectEnd:()=>{b=f.pop()},onArrayBegin:()=>{const p=[];D(p),f.push(b),b=p,d=null},onArrayEnd:()=>{b=f.pop()},onLiteralValue:D,onError:(p,y,S)=>{r.push({error:p,offset:y,length:S})}},u),b[0]}e.$8m=l;function $(i,r=[],u=F.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(p){d.type==="property"&&(d.length=p-d.offset,d=d.parent)}function f(p){return d.children.push(p),p}o(i,{onObjectBegin:p=>{d=f({type:"object",offset:p,length:-1,parent:d,children:[]})},onObjectProperty:(p,y,S)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:p,offset:y,length:S,parent:d})},onObjectEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,b(p+y)},onArrayBegin:(p,y)=>{d=f({type:"array",offset:p,length:-1,parent:d,children:[]})},onArrayEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,b(p+y)},onLiteralValue:(p,y,S)=>{f({type:h(p),offset:y,length:S,parent:d,value:p}),b(y+S)},onSeparator:(p,y,S)=>{d.type==="property"&&(p===":"?d.colonOffset=y:p===","&&b(y))},onError:(p,y,S)=>{r.push({error:p,offset:y,length:S})}},u);const L=d.children[0];return L&&delete L.parent,L}e.$9m=$;function v(i,r){if(!i)return;let u=i;for(const d of r)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let b=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],b=!0;break}if(!b)return}else{const b=d;if(u.type!=="array"||b<0||!Array.isArray(u.children)||b>=u.children.length)return;u=u.children[b]}return u}e.$0m=v;function a(i){if(!i.parent||!i.parent.children)return[];const r=a(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;r.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&r.push(u)}return r}e.$$m=a;function s(i){switch(i.type){case"array":return i.children.map(s);case"object":{const r=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(r[u.children[0].value]=s(d))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$_m=s;function t(i,r,u=!1){return r>=i.offset&&r<i.offset+i.length||u&&r===i.offset+i.length}e.$an=t;function n(i,r,u=!1){if(t(i,r,u)){const d=i.children;if(Array.isArray(d))for(let b=0;b<d.length&&d[b].offset<=r;b++){const f=n(d[b],r,u);if(f)return f}return i}}e.$bn=n;function o(i,r,u=F.DEFAULT){const d=R(i,!1);function b(ne){return ne?()=>ne(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ne){return ne?Se=>ne(Se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const D=b(r.onObjectBegin),L=f(r.onObjectProperty),p=b(r.onObjectEnd),y=b(r.onArrayBegin),S=b(r.onArrayEnd),N=f(r.onLiteralValue),q=f(r.onSeparator),j=b(r.onComment),M=f(r.onError),U=u&&u.disallowComments,P=u&&u.allowTrailingComma;function I(){for(;;){const ne=d.scan();switch(d.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:U||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(ne){case 12:case 13:U?Z(10):j();break;case 16:Z(1);break;case 15:case 14:break;default:return ne}}}function Z(ne,Se=[],ce=[]){if(M(ne),Se.length+ce.length>0){let X=d.getToken();for(;X!==17;){if(Se.indexOf(X)!==-1){I();break}else if(ce.indexOf(X)!==-1)break;X=I()}}}function ue(ne){const Se=d.getTokenValue();return ne?N(Se):L(Se),I(),!0}function ge(){switch(d.getToken()){case 11:{let ne=0;try{ne=JSON.parse(d.getTokenValue()),typeof ne!="number"&&(Z(2),ne=0)}catch{Z(2)}N(ne);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return I(),!0}function be(){return d.getToken()!==10?(Z(3,[],[2,5]),!1):(ue(!1),d.getToken()===6?(q(":"),I(),fe()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function ke(){D(),I();let ne=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ne||Z(4,[],[]),q(","),I(),d.getToken()===2&&P)break}else ne&&Z(6,[],[]);be()||Z(4,[],[2,5]),ne=!0}return p(),d.getToken()!==2?Z(7,[2],[]):I(),!0}function me(){y(),I();let ne=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ne||Z(4,[],[]),q(","),I(),d.getToken()===4&&P)break}else ne&&Z(6,[],[]);fe()||Z(4,[],[4,5]),ne=!0}return S(),d.getToken()!==4?Z(8,[4],[]):I(),!0}function fe(){switch(d.getToken()){case 3:return me();case 1:return ke();case 10:return ue(!0);default:return ge()}}return I(),d.getToken()===17?u.allowEmptyContent?!0:(Z(4,[],[]),!1):fe()?(d.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.$cn=o;function c(i,r){const u=R(i),d=[];let b,f=0,D;do switch(D=u.getPosition(),b=u.scan(),b){case 12:case 13:case 17:f!==D&&d.push(i.substring(f,D)),r!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,r)),f=u.getPosition();break}while(b!==17);return d.join("")}e.$dn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$en=h}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(Ce,le){for(var ie=0;ie<le.length;ie++){var G=le[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(Ce,G.key,G)}}function E(Ce,le,ie){return le&&e(Ce.prototype,le),ie&&e(Ce,ie),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,le){if(Ce){if(typeof Ce=="string")return C(Ce,le);var ie=Object.prototype.toString.call(Ce).slice(8,-1);if(ie==="Object"&&Ce.constructor&&(ie=Ce.constructor.name),ie==="Map"||ie==="Set")return Array.from(Ce);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return C(Ce,le)}}function C(Ce,le){(le==null||le>Ce.length)&&(le=Ce.length);for(var ie=0,G=new Array(le);ie<le;ie++)G[ie]=Ce[ie];return G}function F(Ce,le){var ie=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ie)return(ie=ie.call(Ce)).next.bind(ie);if(Array.isArray(Ce)||(ie=T(Ce))||le&&Ce&&typeof Ce.length=="number"){ie&&(Ce=ie);var G=0;return function(){return G>=Ce.length?{done:!0}:{done:!1,value:Ce[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=R();function m(Ce){pe.defaults=Ce}var g=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(le){return l[le]};function v(Ce,le){if(le){if(g.test(Ce))return Ce.replace(w,$)}else if(A.test(Ce))return Ce.replace(k,$);return Ce}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Ce){return Ce.replace(a,function(le,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,le){Ce=typeof Ce=="string"?Ce:Ce.source,le=le||"";var ie={replace:function(te,x){return x=x.source||x,x=x.replace(t,"$1"),Ce=Ce.replace(te,x),ie},getRegex:function(){return new RegExp(Ce,le)}};return ie}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,le,ie){if(Ce){var G;try{G=decodeURIComponent(s(ie)).replace(o,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}le&&!c.test(ie)&&(ie=b(le,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},r=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Ce,le){i[" "+Ce]||(r.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=p(Ce,"/",!0)),Ce=i[" "+Ce];var ie=Ce.indexOf(":")===-1;return le.substring(0,2)==="//"?ie?le:Ce.replace(u,"$1")+le:le.charAt(0)==="/"?ie?le:Ce.replace(d,"$1")+le:Ce+le}var f={exec:function(){}};function D(Ce){for(var le=1,ie,G;le<arguments.length;le++){ie=arguments[le];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(Ce[G]=ie[G])}return Ce}function L(Ce,le){var ie=Ce.replace(/\|/g,function(x,se,de){for(var De=!1,Le=se;--Le>=0&&de[Le]==="\\";)De=!De;return De?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>le)G.splice(le);else for(;G.length<le;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function p(Ce,le,ie){var G=Ce.length;if(G===0)return"";for(var te=0;te<G;){var x=Ce.charAt(G-te-1);if(x===le&&!ie)te++;else if(x!==le&&ie)te++;else break}return Ce.slice(0,G-te)}function y(Ce,le){if(Ce.indexOf(le[1])===-1)return-1;for(var ie=Ce.length,G=0,te=0;te<ie;te++)if(Ce[te]==="\\")te++;else if(Ce[te]===le[0])G++;else if(Ce[te]===le[1]&&(G--,G<0))return te;return-1}function S(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Ce,le){if(le<1)return"";for(var ie="";le>1;)le&1&&(ie+=Ce),le>>=1,Ce+=Ce;return ie+Ce}function q(Ce,le,ie,G){var te=le.href,x=le.title?v(le.title):null,se=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){G.state.inLink=!0;var de={type:"link",raw:ie,href:te,title:x,text:se,tokens:G.inlineTokens(se)};return G.state.inLink=!1,de}return{type:"image",raw:ie,href:te,title:x,text:v(se)}}function j(Ce,le){var ie=Ce.match(/^(\s+)(?:```)/);if(ie===null)return le;var G=ie[1];return le.split(`
`).map(function(te){var x=te.match(/^\s+/);if(x===null)return te;var se=x[0];return se.length>=G.length?te.slice(G.length):te}).join(`
`)}var M=function(){function Ce(ie){this.options=ie||pe.defaults}var le=Ce.prototype;return le.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},le.code=function(G){var te=this.rules.block.code.exec(G);if(te){var x=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?x:p(x,`
`)}}},le.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var x=te[0],se=j(x,te[3]||"");return{type:"code",raw:x,lang:te[2]?te[2].trim():te[2],text:se}}},le.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var x=te[2].trim();if(/#$/.test(x)){var se=p(x,"#");(this.options.pedantic||!se||/ $/.test(se))&&(x=se.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:x,tokens:this.lexer.inline(x)}}},le.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},le.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var x=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},le.list=function(G){var te=this.rules.block.list.exec(G);if(te){var x,se,de,De,Le,O,K,J,W,Q,_,ye,ze=te[1].trim(),Qe=ze.length>1,Je={type:"list",raw:"",ordered:Qe,start:Qe?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Qe?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Qe?ze:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(ye=!1,!(!(te=Xe.exec(G))||this.rules.block.hr.test(G)));){if(x=te[0],G=G.substring(x.length),J=te[2].split(`
`,1)[0],W=G.split(`
`,1)[0],this.options.pedantic?(De=2,_=J.trimLeft()):(De=te[2].search(/[^ ]/),De=De>4?1:De,_=J.slice(De),De+=te[1].length),O=!1,!J&&/^ *$/.test(W)&&(x+=W+`
`,G=G.substring(W.length+1),ye=!0),!ye)for(var it=new RegExp("^ {0,"+Math.min(3,De-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,De-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),_e=new RegExp("^ {0,"+Math.min(3,De-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,De-1)+"}#");G&&(Q=G.split(`
`,1)[0],J=Q,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(_e.test(J)||rt.test(J)||it.test(J)||nt.test(G)));){if(J.search(/[^ ]/)>=De||!J.trim())_+=`
`+J.slice(De);else if(!O)_+=`
`+J;else break;!O&&!J.trim()&&(O=!0),x+=Q+`
`,G=G.substring(Q.length+1)}Je.loose||(K?Je.loose=!0:/\n *\n *$/.test(x)&&(K=!0)),this.options.gfm&&(se=/^\[[ xX]\] /.exec(_),se&&(de=se[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:x,task:!!se,checked:de,loose:!1,text:_}),Je.raw+=x}Je.items[Je.items.length-1].raw=x.trimRight(),Je.items[Je.items.length-1].text=_.trimRight(),Je.raw=Je.raw.trimRight();var je=Je.items.length;for(Le=0;Le<je;Le++){this.lexer.state.top=!1,Je.items[Le].tokens=this.lexer.blockTokens(Je.items[Le].text,[]);var ct=Je.items[Le].tokens.filter(function(Y){return Y.type==="space"}),ee=ct.every(function(Y){for(var ve=Y.raw.split(""),Be=0,Ke=F(ve),xe;!(xe=Ke()).done;){var ot=xe.value;if(ot===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&ct.length&&ee&&(Je.loose=!0,Je.items[Le].loose=!0)}return Je}},le.html=function(G){var te=this.rules.block.html.exec(G);if(te){var x={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var se=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);x.type="paragraph",x.text=se,x.tokens=this.lexer.inline(se)}return x}},le.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var x=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:te[0],href:te[2],title:te[3]}}},le.table=function(G){var te=this.rules.block.table.exec(G);if(te){var x={type:"table",header:L(te[1]).map(function(K){return{text:K}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=te[0];var se=x.align.length,de,De,Le,O;for(de=0;de<se;de++)/^ *-+: *$/.test(x.align[de])?x.align[de]="right":/^ *:-+: *$/.test(x.align[de])?x.align[de]="center":/^ *:-+ *$/.test(x.align[de])?x.align[de]="left":x.align[de]=null;for(se=x.rows.length,de=0;de<se;de++)x.rows[de]=L(x.rows[de],x.header.length).map(function(K){return{text:K}});for(se=x.header.length,De=0;De<se;De++)x.header[De].tokens=this.lexer.inline(x.header[De].text);for(se=x.rows.length,De=0;De<se;De++)for(O=x.rows[De],Le=0;Le<O.length;Le++)O[Le].tokens=this.lexer.inline(O[Le].text);return x}}},le.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},le.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var x=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:x,tokens:this.lexer.inline(x)}}},le.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},le.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},le.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},le.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var x=te[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var se=p(x.slice(0,-1),"\\");if((x.length-se.length)%2===0)return}else{var de=y(te[2],"()");if(de>-1){var De=te[0].indexOf("!")===0?5:4,Le=De+te[1].length+de;te[2]=te[2].substring(0,de),te[0]=te[0].substring(0,Le).trim(),te[3]=""}}var O=te[2],K="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(O);J&&(O=J[1],K=J[3])}else K=te[3]?te[3].slice(1,-1):"";return O=O.trim(),/^</.test(O)&&(this.options.pedantic&&!/>$/.test(x)?O=O.slice(1):O=O.slice(1,-1)),q(te,{href:O&&O.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},le.reflink=function(G,te){var x;if((x=this.rules.inline.reflink.exec(G))||(x=this.rules.inline.nolink.exec(G))){var se=(x[2]||x[1]).replace(/\s+/g," ");if(se=te[se.toLowerCase()],!se||!se.href){var de=x[0].charAt(0);return{type:"text",raw:de,text:de}}return q(x,se,x[0],this.lexer)}},le.emStrong=function(G,te,x){x===void 0&&(x="");var se=this.rules.inline.emStrong.lDelim.exec(G);if(se&&!(se[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=se[1]||se[2]||"";if(!de||de&&(x===""||this.rules.inline.punctuation.exec(x))){var De=se[0].length-1,Le,O,K=De,J=0,W=se[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,te=te.slice(-1*G.length+De);(se=W.exec(te))!=null;)if(Le=se[1]||se[2]||se[3]||se[4]||se[5]||se[6],!!Le){if(O=Le.length,se[3]||se[4]){K+=O;continue}else if((se[5]||se[6])&&De%3&&!((De+O)%3)){J+=O;continue}if(K-=O,!(K>0)){if(O=Math.min(O,O+K+J),Math.min(De,O)%2){var Q=G.slice(1,De+se.index+O);return{type:"em",raw:G.slice(0,De+se.index+O+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var _=G.slice(2,De+se.index+O-1);return{type:"strong",raw:G.slice(0,De+se.index+O+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},le.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var x=te[2].replace(/\n/g," "),se=/[^ ]/.test(x),de=/^ /.test(x)&&/ $/.test(x);return se&&de&&(x=x.substring(1,x.length-1)),x=v(x,!0),{type:"codespan",raw:te[0],text:x}}},le.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},le.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},le.autolink=function(G,te){var x=this.rules.inline.autolink.exec(G);if(x){var se,de;return x[2]==="@"?(se=v(this.options.mangle?te(x[1]):x[1]),de="mailto:"+se):(se=v(x[1]),de=se),{type:"link",raw:x[0],text:se,href:de,tokens:[{type:"text",raw:se,text:se}]}}},le.url=function(G,te){var x;if(x=this.rules.inline.url.exec(G)){var se,de;if(x[2]==="@")se=v(this.options.mangle?te(x[0]):x[0]),de="mailto:"+se;else{var De;do De=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(De!==x[0]);se=v(x[0]),x[1]==="www."?de="http://"+se:de=se}return{type:"link",raw:x[0],text:se,href:de,tokens:[{type:"text",raw:se,text:se}]}}},le.inlineText=function(G,te){var x=this.rules.inline.text.exec(G);if(x){var se;return this.lexer.state.inRawBlock?se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):v(x[0]):x[0]:se=v(this.options.smartypants?te(x[0]):x[0]),{type:"text",raw:x[0],text:se}}},Ce}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=D({},U),U.gfm=D({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=D({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",U._label).getRegex(),P.nolink=n(P.nolink).replace("ref",U._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=D({},P),P.pedantic=D({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=D({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=D({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function I(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Z(Ce){var le="",ie,G,te=Ce.length;for(ie=0;ie<te;ie++)G=Ce.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),le+="&#"+G+";";return le}var ue=function(){function Ce(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||pe.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:U.normal,inline:P.normal};this.options.pedantic?(G.block=U.pedantic,G.inline=P.pedantic):this.options.gfm&&(G.block=U.gfm,this.options.breaks?G.inline=P.breaks:G.inline=P.gfm),this.tokenizer.rules=G}Ce.lex=function(G,te){var x=new Ce(te);return x.lex(G)},Ce.lexInline=function(G,te){var x=new Ce(te);return x.inlineTokens(G)};var le=Ce.prototype;return le.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},le.blockTokens=function(G,te){var x=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(K,J,W){return J+"    ".repeat(W.length)});for(var se,de,De,Le;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(se=K.call({lexer:x},G,te))?(G=G.substring(se.raw.length),te.push(se),!0):!1}))){if(se=this.tokenizer.space(G)){G=G.substring(se.raw.length),se.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(se);continue}if(se=this.tokenizer.code(G)){G=G.substring(se.raw.length),de=te[te.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+se.raw,de.text+=`
`+se.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):te.push(se);continue}if(se=this.tokenizer.fences(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.heading(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.hr(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.blockquote(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.list(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.html(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.def(G)){G=G.substring(se.raw.length),de=te[te.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+se.raw,de.text+=`
`+se.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[se.tag]||(this.tokens.links[se.tag]={href:se.href,title:se.title});continue}if(se=this.tokenizer.table(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.lheading(G)){G=G.substring(se.raw.length),te.push(se);continue}if(De=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,J=G.slice(1),W=void 0;x.options.extensions.startBlock.forEach(function(Q){W=Q.call({lexer:this},J),typeof W=="number"&&W>=0&&(K=Math.min(K,W))}),K<1/0&&K>=0&&(De=G.substring(0,K+1))}(),this.state.top&&(se=this.tokenizer.paragraph(De))){de=te[te.length-1],Le&&de.type==="paragraph"?(de.raw+=`
`+se.raw,de.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):te.push(se),Le=De.length!==G.length,G=G.substring(se.raw.length);continue}if(se=this.tokenizer.text(G)){G=G.substring(se.raw.length),de=te[te.length-1],de&&de.type==="text"?(de.raw+=`
`+se.raw,de.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):te.push(se);continue}if(G){var O="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(O);break}else throw new Error(O)}}return this.state.top=!0,te},le.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},le.inlineTokens=function(G,te){var x=this;te===void 0&&(te=[]);var se,de,De,Le=G,O,K,J;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(O=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)W.includes(O[0].slice(O[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,O.index)+"["+N("a",O[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(O=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,O.index)+"["+N("a",O[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(O=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,O.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(K||(J=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(se=_.call({lexer:x},G,te))?(G=G.substring(se.raw.length),te.push(se),!0):!1}))){if(se=this.tokenizer.escape(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.tag(G)){G=G.substring(se.raw.length),de=te[te.length-1],de&&se.type==="text"&&de.type==="text"?(de.raw+=se.raw,de.text+=se.text):te.push(se);continue}if(se=this.tokenizer.link(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(se.raw.length),de=te[te.length-1],de&&se.type==="text"&&de.type==="text"?(de.raw+=se.raw,de.text+=se.text):te.push(se);continue}if(se=this.tokenizer.emStrong(G,Le,J)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.codespan(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.br(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.del(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.autolink(G,Z)){G=G.substring(se.raw.length),te.push(se);continue}if(!this.state.inLink&&(se=this.tokenizer.url(G,Z))){G=G.substring(se.raw.length),te.push(se);continue}if(De=G,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,ye=G.slice(1),ze=void 0;x.options.extensions.startInline.forEach(function(Qe){ze=Qe.call({lexer:this},ye),typeof ze=="number"&&ze>=0&&(_=Math.min(_,ze))}),_<1/0&&_>=0&&(De=G.substring(0,_+1))}(),se=this.tokenizer.inlineText(De,I)){G=G.substring(se.raw.length),se.raw.slice(-1)!=="_"&&(J=se.raw.slice(-1)),K=!0,de=te[te.length-1],de&&de.type==="text"?(de.raw+=se.raw,de.text+=se.text):te.push(se);continue}if(G){var Q="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},E(Ce,null,[{key:"rules",get:function(){return{block:U,inline:P}}}]),Ce}(),ge=function(){function Ce(ie){this.options=ie||pe.defaults}var le=Ce.prototype;return le.code=function(G,te,x){var se=(te||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(G,se);de!=null&&de!==G&&(x=!0,G=de)}return G=G.replace(/\n$/,"")+`
`,se?'<pre><code class="'+this.options.langPrefix+v(se,!0)+'">'+(x?G:v(G,!0))+`</code></pre>
`:"<pre><code>"+(x?G:v(G,!0))+`</code></pre>
`},le.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},le.html=function(G){return G},le.heading=function(G,te,x,se){if(this.options.headerIds){var de=this.options.headerPrefix+se.slug(x);return"<h"+te+' id="'+de+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(G,te,x){var se=te?"ol":"ul",de=te&&x!==1?' start="'+x+'"':"";return"<"+se+de+`>
`+G+"</"+se+`>
`},le.listitem=function(G){return"<li>"+G+`</li>
`},le.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(G){return"<p>"+G+`</p>
`},le.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},le.tablerow=function(G){return`<tr>
`+G+`</tr>
`},le.tablecell=function(G,te){var x=te.header?"th":"td",se=te.align?"<"+x+' align="'+te.align+'">':"<"+x+">";return se+G+("</"+x+`>
`)},le.strong=function(G){return"<strong>"+G+"</strong>"},le.em=function(G){return"<em>"+G+"</em>"},le.codespan=function(G){return"<code>"+G+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(G){return"<del>"+G+"</del>"},le.link=function(G,te,x){if(G=h(this.options.sanitize,this.options.baseUrl,G),G===null)return x;var se='<a href="'+v(G)+'"';return te&&(se+=' title="'+te+'"'),se+=">"+x+"</a>",se},le.image=function(G,te,x){if(G=h(this.options.sanitize,this.options.baseUrl,G),G===null)return x;var se='<img src="'+G+'" alt="'+x+'"';return te&&(se+=' title="'+te+'"'),se+=this.options.xhtml?"/>":">",se},le.text=function(G){return G},Ce}(),be=function(){function Ce(){}var le=Ce.prototype;return le.strong=function(G){return G},le.em=function(G){return G},le.codespan=function(G){return G},le.del=function(G){return G},le.html=function(G){return G},le.text=function(G){return G},le.link=function(G,te,x){return""+x},le.image=function(G,te,x){return""+x},le.br=function(){return""},Ce}(),ke=function(){function Ce(){this.seen={}}var le=Ce.prototype;return le.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(G,te){var x=G,se=0;if(this.seen.hasOwnProperty(x)){se=this.seen[G];do se++,x=G+"-"+se;while(this.seen.hasOwnProperty(x))}return te||(this.seen[G]=se,this.seen[x]=0),x},le.slug=function(G,te){te===void 0&&(te={});var x=this.serialize(G);return this.getNextSafeSlug(x,te.dryrun)},Ce}(),me=function(){function Ce(ie){this.options=ie||pe.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ke}Ce.parse=function(G,te){var x=new Ce(te);return x.parse(G)},Ce.parseInline=function(G,te){var x=new Ce(te);return x.parseInline(G)};var le=Ce.prototype;return le.parse=function(G,te){te===void 0&&(te=!0);var x="",se,de,De,Le,O,K,J,W,Q,_,ye,ze,Qe,Je,Xe,it,nt,_e,rt,je=G.length;for(se=0;se<je;se++){if(_=G[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(rt=this.options.extensions.renderers[_.type].call({parser:this},_),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){x+=rt||"";continue}switch(_.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(_.tokens),_.depth,s(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(W="",J="",Le=_.header.length,de=0;de<Le;de++)J+=this.renderer.tablecell(this.parseInline(_.header[de].tokens),{header:!0,align:_.align[de]});for(W+=this.renderer.tablerow(J),Q="",Le=_.rows.length,de=0;de<Le;de++){for(K=_.rows[de],J="",O=K.length,De=0;De<O;De++)J+=this.renderer.tablecell(this.parseInline(K[De].tokens),{header:!1,align:_.align[De]});Q+=this.renderer.tablerow(J)}x+=this.renderer.table(W,Q);continue}case"blockquote":{Q=this.parse(_.tokens),x+=this.renderer.blockquote(Q);continue}case"list":{for(ye=_.ordered,ze=_.start,Qe=_.loose,Le=_.items.length,Q="",de=0;de<Le;de++)Xe=_.items[de],it=Xe.checked,nt=Xe.task,Je="",Xe.task&&(_e=this.renderer.checkbox(it),Qe?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=_e+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=_e+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:_e}):Je+=_e),Je+=this.parse(Xe.tokens,Qe),Q+=this.renderer.listitem(Je,nt,it);x+=this.renderer.list(Q,ye,ze);continue}case"html":{x+=this.renderer.html(_.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Q=_.tokens?this.parseInline(_.tokens):_.text;se+1<je&&G[se+1].type==="text";)_=G[++se],Q+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);x+=te?this.renderer.paragraph(Q):Q;continue}default:{var ct='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return x},le.parseInline=function(G,te){te=te||this.renderer;var x="",se,de,De,Le=G.length;for(se=0;se<Le;se++){if(de=G[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(De=this.options.extensions.renderers[de.type].call({parser:this},de),De!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){x+=De||"";continue}switch(de.type){case"escape":{x+=te.text(de.text);break}case"html":{x+=te.html(de.text);break}case"link":{x+=te.link(de.href,de.title,this.parseInline(de.tokens,te));break}case"image":{x+=te.image(de.href,de.title,de.text);break}case"strong":{x+=te.strong(this.parseInline(de.tokens,te));break}case"em":{x+=te.em(this.parseInline(de.tokens,te));break}case"codespan":{x+=te.codespan(de.text);break}case"br":{x+=te.br();break}case"del":{x+=te.del(this.parseInline(de.tokens,te));break}case"text":{x+=te.text(de.text);break}default:{var O='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(O);return}else throw new Error(O)}}}return x},Ce}();function fe(Ce,le,ie){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof le=="function"&&(ie=le,le=null),le=D({},fe.defaults,le||{}),S(le),ie){var G=le.highlight,te;try{te=ue.lex(Ce,le)}catch(Le){return ie(Le)}var x=function(O){var K;if(!O)try{le.walkTokens&&fe.walkTokens(te,le.walkTokens),K=me.parse(te,le)}catch(J){O=J}return le.highlight=G,O?ie(O):ie(null,K)};if(!G||G.length<3||(delete le.highlight,!te.length))return x();var se=0;fe.walkTokens(te,function(Le){Le.type==="code"&&(se++,setTimeout(function(){G(Le.text,Le.lang,function(O,K){if(O)return x(O);K!=null&&K!==Le.text&&(Le.text=K,Le.escaped=!0),se--,se===0&&x()})},0))}),se===0&&x();return}function de(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+v(Le.message+"",!0)+"</pre>";throw Le}try{var De=ue.lex(Ce,le);if(le.walkTokens){if(le.async)return Promise.all(fe.walkTokens(De,le.walkTokens)).then(function(){return me.parse(De,le)}).catch(de);fe.walkTokens(De,le.walkTokens)}return me.parse(De,le)}catch(Le){de(Le)}}fe.options=fe.setOptions=function(Ce){return D(fe.defaults,Ce),m(fe.defaults),fe},fe.getDefaults=R,fe.defaults=pe.defaults,fe.use=function(){for(var Ce=arguments.length,le=new Array(Ce),ie=0;ie<Ce;ie++)le[ie]=arguments[ie];var G=D.apply(void 0,[{}].concat(le)),te=fe.defaults.extensions||{renderers:{},childTokens:{}},x;le.forEach(function(se){if(se.extensions&&(x=!0,se.extensions.forEach(function(De){if(!De.name)throw new Error("extension name required");if(De.renderer){var Le=te.renderers?te.renderers[De.name]:null;Le?te.renderers[De.name]=function(){for(var O=arguments.length,K=new Array(O),J=0;J<O;J++)K[J]=arguments[J];var W=De.renderer.apply(this,K);return W===!1&&(W=Le.apply(this,K)),W}:te.renderers[De.name]=De.renderer}if(De.tokenizer){if(!De.level||De.level!=="block"&&De.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[De.level]?te[De.level].unshift(De.tokenizer):te[De.level]=[De.tokenizer],De.start&&(De.level==="block"?te.startBlock?te.startBlock.push(De.start):te.startBlock=[De.start]:De.level==="inline"&&(te.startInline?te.startInline.push(De.start):te.startInline=[De.start]))}De.childTokens&&(te.childTokens[De.name]=De.childTokens)})),se.renderer&&function(){var De=fe.defaults.renderer||new ge,Le=function(J){var W=De[J];De[J]=function(){for(var Q=arguments.length,_=new Array(Q),ye=0;ye<Q;ye++)_[ye]=arguments[ye];var ze=se.renderer[J].apply(De,_);return ze===!1&&(ze=W.apply(De,_)),ze}};for(var O in se.renderer)Le(O);G.renderer=De}(),se.tokenizer&&function(){var De=fe.defaults.tokenizer||new M,Le=function(J){var W=De[J];De[J]=function(){for(var Q=arguments.length,_=new Array(Q),ye=0;ye<Q;ye++)_[ye]=arguments[ye];var ze=se.tokenizer[J].apply(De,_);return ze===!1&&(ze=W.apply(De,_)),ze}};for(var O in se.tokenizer)Le(O);G.tokenizer=De}(),se.walkTokens){var de=fe.defaults.walkTokens;G.walkTokens=function(De){var Le=[];return Le.push(se.walkTokens.call(this,De)),de&&(Le=Le.concat(de.call(this,De))),Le}}x&&(G.extensions=te),fe.setOptions(G)})},fe.walkTokens=function(Ce,le){for(var ie=[],G=function(){var de=x.value;switch(ie=ie.concat(le.call(fe,de)),de.type){case"table":{for(var De=F(de.header),Le;!(Le=De()).done;){var O=Le.value;ie=ie.concat(fe.walkTokens(O.tokens,le))}for(var K=F(de.rows),J;!(J=K()).done;)for(var W=J.value,Q=F(W),_;!(_=Q()).done;){var ye=_.value;ie=ie.concat(fe.walkTokens(ye.tokens,le))}break}case"list":{ie=ie.concat(fe.walkTokens(de.items,le));break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[de.type]?fe.defaults.extensions.childTokens[de.type].forEach(function(ze){ie=ie.concat(fe.walkTokens(de[ze],le))}):de.tokens&&(ie=ie.concat(fe.walkTokens(de.tokens,le)))}},te=F(Ce),x;!(x=te()).done;)G();return ie},fe.parseInline=function(Ce,le){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");le=D({},fe.defaults,le||{}),S(le);try{var ie=ue.lexInline(Ce,le);return le.walkTokens&&fe.walkTokens(ie,le.walkTokens),me.parseInline(ie,le)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+v(G.message+"",!0)+"</pre>";throw G}},fe.Parser=me,fe.parser=me.parse,fe.Renderer=ge,fe.TextRenderer=be,fe.Lexer=ue,fe.lexer=ue.lex,fe.Tokenizer=M,fe.Slugger=ke,fe.parse=fe;var ne=fe.options,Se=fe.setOptions,ce=fe.use,X=fe.walkTokens,V=fe.parseInline,re=fe,Ie=me.parse,Re=ue.lex;pe.Lexer=ue,pe.Parser=me,pe.Renderer=ge,pe.Slugger=ke,pe.TextRenderer=be,pe.Tokenizer=M,pe.getDefaults=R,pe.lexer=Re,pe.marked=fe,pe.options=ne,pe.parse=re,pe.parseInline=V,pe.parser=Ie,pe.setOptions=Se,pe.use=ce,pe.walkTokens=X,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.rot=e.$Zl=void 0;function E(m,g,w){return Math.min(Math.max(m,g),w)}e.$Zl=E;function T(m,g){return(g+m%g)%g}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$2l=C;class F{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$3l=F;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$4l=R}),function(){function pe(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function R(g){F.push(g,Date.now())}function m(){const g=[];for(let w=0;w<F.length;w+=2)g.push({name:F[w],startTime:F[w+1]});return g}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(C+R.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:pe)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function E(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return pe[T].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=pe,E.c=e,E.d=function(T,C,F){E.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:F})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,C){if(1&C&&(T=E(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var F=Object.create(null);if(E.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var R in T)E.d(F,R,function(m){return T[m]}.bind(null,R));return F},E.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(C,"a",C),C},E.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},E.p="",E(E.s=0)}([function(pe,e,E){(function(T){var C;e=pe.exports=ce,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],w=0,A=w++;g[A]="0|[1-9]\\d*";var k=w++;g[k]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;g[$]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var v=w++;g[v]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var a=w++;g[a]="(?:"+g[A]+"|"+g[l]+")";var s=w++;g[s]="(?:"+g[k]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[a]+"(?:\\."+g[a]+")*))";var n=w++;g[n]="(?:-?("+g[s]+"(?:\\."+g[s]+")*))";var o=w++;g[o]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[o]+"(?:\\."+g[o]+")*))";var h=w++,i="v?"+g[$]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var r="[v=\\s]*"+g[v]+g[n]+"?"+g[c]+"?",u=w++;g[u]="^"+r+"$";var d=w++;g[d]="((?:<|>)?=?)";var b=w++;g[b]=g[k]+"|x|X|\\*";var f=w++;g[f]=g[A]+"|x|X|\\*";var D=w++;g[D]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var L=w++;g[L]="[v=\\s]*("+g[b]+")(?:\\.("+g[b]+")(?:\\.("+g[b]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var p=w++;g[p]="^"+g[d]+"\\s*"+g[D]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[L]+"$";var S=w++;g[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=w++;g[N]="(?:~>?)";var q=w++;g[q]="(\\s*)"+g[N]+"\\s+",m[q]=new RegExp(g[q],"g");var j=w++;g[j]="^"+g[N]+g[D]+"$";var M=w++;g[M]="^"+g[N]+g[L]+"$";var U=w++;g[U]="(?:\\^)";var P=w++;g[P]="(\\s*)"+g[U]+"\\s+",m[P]=new RegExp(g[P],"g");var I=w++;g[I]="^"+g[U]+g[D]+"$";var Z=w++;g[Z]="^"+g[U]+g[L]+"$";var ue=w++;g[ue]="^"+g[d]+"\\s*("+r+")$|^$";var ge=w++;g[ge]="^"+g[d]+"\\s*("+i+")$|^$";var be=w++;g[be]="(\\s*)"+g[d]+"\\s*("+r+"|"+g[D]+")",m[be]=new RegExp(g[be],"g");var ke=w++;g[ke]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var me=w++;g[me]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var fe=w++;g[fe]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)C(ne,g[ne]),m[ne]||(m[ne]=new RegExp(g[ne]));function Se(W,Q){if(W instanceof ce)return W;if(typeof W!="string"||W.length>F||!(Q?m[u]:m[h]).test(W))return null;try{return new ce(W,Q)}catch{return null}}function ce(W,Q){if(W instanceof ce){if(W.loose===Q)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof ce))return new ce(W,Q);C("SemVer",W,Q),this.loose=Q;var _=W.trim().match(Q?m[u]:m[h]);if(!_)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var ze=+ye;if(ze>=0&&ze<R)return ze}return ye}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=Se,e.valid=function(W,Q){var _=Se(W,Q);return _?_.version:null},e.clean=function(W,Q){var _=Se(W.trim().replace(/^[=v]+/,""),Q);return _?_.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(W){return C("SemVer.compare",this.version,this.loose,W),W instanceof ce||(W=new ce(W,this.loose)),this.compareMain(W)||this.comparePre(W)},ce.prototype.compareMain=function(W){return W instanceof ce||(W=new ce(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},ce.prototype.comparePre=function(W){if(W instanceof ce||(W=new ce(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var Q=0;do{var _=this.prerelease[Q],ye=W.prerelease[Q];if(C("prerelease compare",Q,_,ye),_===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(_===void 0)return-1;if(_!==ye)return V(_,ye)}while(++Q)},ce.prototype.inc=function(W,Q){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,Q,_,ye){typeof _=="string"&&(ye=_,_=void 0);try{return new ce(W,_).inc(Q,ye).version}catch{return null}},e.diff=function(W,Q){if(Ce(W,Q))return null;var _=Se(W),ye=Se(Q);if(_.prerelease.length||ye.prerelease.length){for(var ze in _)if((ze==="major"||ze==="minor"||ze==="patch")&&_[ze]!==ye[ze])return"pre"+ze;return"prerelease"}for(var ze in _)if((ze==="major"||ze==="minor"||ze==="patch")&&_[ze]!==ye[ze])return ze},e.compareIdentifiers=V;var X=/^[0-9]+$/;function V(W,Q){var _=X.test(W),ye=X.test(Q);return _&&ye&&(W=+W,Q=+Q),_&&!ye?-1:ye&&!_?1:W<Q?-1:W>Q?1:0}function re(W,Q,_){return new ce(W,_).compare(new ce(Q,_))}function Ie(W,Q,_){return re(W,Q,_)>0}function Re(W,Q,_){return re(W,Q,_)<0}function Ce(W,Q,_){return re(W,Q,_)===0}function le(W,Q,_){return re(W,Q,_)!==0}function ie(W,Q,_){return re(W,Q,_)>=0}function G(W,Q,_){return re(W,Q,_)<=0}function te(W,Q,_,ye){var ze;switch(Q){case"===":typeof W=="object"&&(W=W.version),typeof _=="object"&&(_=_.version),ze=W===_;break;case"!==":typeof W=="object"&&(W=W.version),typeof _=="object"&&(_=_.version),ze=W!==_;break;case"":case"=":case"==":ze=Ce(W,_,ye);break;case"!=":ze=le(W,_,ye);break;case">":ze=Ie(W,_,ye);break;case">=":ze=ie(W,_,ye);break;case"<":ze=Re(W,_,ye);break;case"<=":ze=G(W,_,ye);break;default:throw new TypeError("Invalid operator: "+Q)}return ze}function x(W,Q){if(W instanceof x){if(W.loose===Q)return W;W=W.value}if(!(this instanceof x))return new x(W,Q);C("comparator",W,Q),this.loose=Q,this.parse(W),this.semver===se?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(W,Q){return V(Q,W)},e.major=function(W,Q){return new ce(W,Q).major},e.minor=function(W,Q){return new ce(W,Q).minor},e.patch=function(W,Q){return new ce(W,Q).patch},e.compare=re,e.compareLoose=function(W,Q){return re(W,Q,!0)},e.rcompare=function(W,Q,_){return re(Q,W,_)},e.sort=function(W,Q){return W.sort(function(_,ye){return e.compare(_,ye,Q)})},e.rsort=function(W,Q){return W.sort(function(_,ye){return e.rcompare(_,ye,Q)})},e.gt=Ie,e.lt=Re,e.eq=Ce,e.neq=le,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=x;var se={};function de(W,Q){if(W instanceof de)return W.loose===Q?W:new de(W.raw,Q);if(W instanceof x)return new de(W.value,Q);if(!(this instanceof de))return new de(W,Q);if(this.loose=Q,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function De(W){return!W||W.toLowerCase()==="x"||W==="*"}function Le(W,Q,_,ye,ze,Qe,Je,Xe,it,nt,_e,rt,je){return((Q=De(_)?"":De(ye)?">="+_+".0.0":De(ze)?">="+_+"."+ye+".0":">="+Q)+" "+(Xe=De(it)?"":De(nt)?"<"+(+it+1)+".0.0":De(_e)?"<"+it+"."+(+nt+1)+".0":rt?"<="+it+"."+nt+"."+_e+"-"+rt:"<="+Xe)).trim()}function O(W,Q){for(var _=0;_<W.length;_++)if(!W[_].test(Q))return!1;if(Q.prerelease.length){for(_=0;_<W.length;_++)if(C(W[_].semver),W[_].semver!==se&&W[_].semver.prerelease.length>0){var ye=W[_].semver;if(ye.major===Q.major&&ye.minor===Q.minor&&ye.patch===Q.patch)return!0}return!1}return!0}function K(W,Q,_){try{Q=new de(Q,_)}catch{return!1}return Q.test(W)}function J(W,Q,_,ye){var ze,Qe,Je,Xe,it;switch(W=new ce(W,ye),Q=new de(Q,ye),_){case">":ze=Ie,Qe=G,Je=Re,Xe=">",it=">=";break;case"<":ze=Re,Qe=ie,Je=Ie,Xe="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(W,Q,ye))return!1;for(var nt=0;nt<Q.set.length;++nt){var _e=Q.set[nt],rt=null,je=null;if(_e.forEach(function(ct){ct.semver===se&&(ct=new x(">=0.0.0")),rt=rt||ct,je=je||ct,ze(ct.semver,rt.semver,ye)?rt=ct:Je(ct.semver,je.semver,ye)&&(je=ct)}),rt.operator===Xe||rt.operator===it||(!je.operator||je.operator===Xe)&&Qe(W,je.semver)||je.operator===it&&Je(W,je.semver))return!1}return!0}x.prototype.parse=function(W){var Q=this.loose?m[ue]:m[ge],_=W.match(Q);if(!_)throw new TypeError("Invalid comparator: "+W);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new ce(_[2],this.loose):this.semver=se},x.prototype.toString=function(){return this.value},x.prototype.test=function(W){return C("Comparator.test",W,this.loose),this.semver===se||(typeof W=="string"&&(W=new ce(W,this.loose)),te(W,this.operator,this.semver,this.loose))},x.prototype.intersects=function(W,Q){if(!(W instanceof x))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new de(W.value,Q),K(this.value,_,Q);if(W.operator==="")return _=new de(this.value,Q),K(W.semver,_,Q);var ye=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Qe=this.semver.version===W.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Xe=te(this.semver,"<",W.semver,Q)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),it=te(this.semver,">",W.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return ye||ze||Qe&&Je||Xe||it},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(W){var Q=this.loose;W=W.trim(),C("range",W,Q);var _=Q?m[me]:m[ke];W=W.replace(_,Le),C("hyphen replace",W),W=W.replace(m[be],"$1$2$3"),C("comparator trim",W,m[be]),W=(W=(W=W.replace(m[q],"$1~")).replace(m[P],"$1^")).split(/\s+/).join(" ");var ye=Q?m[ue]:m[ge],ze=W.split(" ").map(function(Qe){return function(Je,Xe){return C("comp",Je),Je=function(it,nt){return it.trim().split(/\s+/).map(function(_e){return function(rt,je){C("caret",rt,je);var ct=je?m[Z]:m[I];return rt.replace(ct,function(ee,Y,ve,Be,Ke){var xe;return C("caret",rt,ee,Y,ve,Be,Ke),De(Y)?xe="":De(ve)?xe=">="+Y+".0.0 <"+(+Y+1)+".0.0":De(Be)?xe=Y==="0"?">="+Y+"."+ve+".0 <"+Y+"."+(+ve+1)+".0":">="+Y+"."+ve+".0 <"+(+Y+1)+".0.0":Ke?(C("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),xe=Y==="0"?ve==="0"?">="+Y+"."+ve+"."+Be+Ke+" <"+Y+"."+ve+"."+(+Be+1):">="+Y+"."+ve+"."+Be+Ke+" <"+Y+"."+(+ve+1)+".0":">="+Y+"."+ve+"."+Be+Ke+" <"+(+Y+1)+".0.0"):(C("no pr"),xe=Y==="0"?ve==="0"?">="+Y+"."+ve+"."+Be+" <"+Y+"."+ve+"."+(+Be+1):">="+Y+"."+ve+"."+Be+" <"+Y+"."+(+ve+1)+".0":">="+Y+"."+ve+"."+Be+" <"+(+Y+1)+".0.0"),C("caret return",xe),xe})}(_e,nt)}).join(" ")}(Je,Xe),C("caret",Je),Je=function(it,nt){return it.trim().split(/\s+/).map(function(_e){return function(rt,je){var ct=je?m[M]:m[j];return rt.replace(ct,function(ee,Y,ve,Be,Ke){var xe;return C("tilde",rt,ee,Y,ve,Be,Ke),De(Y)?xe="":De(ve)?xe=">="+Y+".0.0 <"+(+Y+1)+".0.0":De(Be)?xe=">="+Y+"."+ve+".0 <"+Y+"."+(+ve+1)+".0":Ke?(C("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),xe=">="+Y+"."+ve+"."+Be+Ke+" <"+Y+"."+(+ve+1)+".0"):xe=">="+Y+"."+ve+"."+Be+" <"+Y+"."+(+ve+1)+".0",C("tilde return",xe),xe})}(_e,nt)}).join(" ")}(Je,Xe),C("tildes",Je),Je=function(it,nt){return C("replaceXRanges",it,nt),it.split(/\s+/).map(function(_e){return function(rt,je){rt=rt.trim();var ct=je?m[y]:m[p];return rt.replace(ct,function(ee,Y,ve,Be,Ke,xe){C("xRange",rt,ee,Y,ve,Be,Ke,xe);var ot=De(ve),pt=ot||De(Be),Oe=pt||De(Ke);return Y==="="&&Oe&&(Y=""),ot?ee=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Oe?(pt&&(Be=0),Oe&&(Ke=0),Y===">"?(Y=">=",pt?(ve=+ve+1,Be=0,Ke=0):Oe&&(Be=+Be+1,Ke=0)):Y==="<="&&(Y="<",pt?ve=+ve+1:Be=+Be+1),ee=Y+ve+"."+Be+"."+Ke):pt?ee=">="+ve+".0.0 <"+(+ve+1)+".0.0":Oe&&(ee=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),C("xRange return",ee),ee})}(_e,nt)}).join(" ")}(Je,Xe),C("xrange",Je),Je=function(it,nt){return C("replaceStars",it,nt),it.trim().replace(m[fe],"")}(Je,Xe),C("stars",Je),Je}(Qe,Q)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Qe){return!!Qe.match(ye)})),ze=ze.map(function(Qe){return new x(Qe,Q)})},de.prototype.intersects=function(W,Q){if(!(W instanceof de))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(ye){return W.set.some(function(ze){return ze.every(function(Qe){return ye.intersects(Qe,Q)})})})})},e.toComparators=function(W,Q){return new de(W,Q).set.map(function(_){return _.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},de.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new ce(W,this.loose));for(var Q=0;Q<this.set.length;Q++)if(O(this.set[Q],W))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(W,Q,_){var ye=null,ze=null;try{var Qe=new de(Q,_)}catch{return null}return W.forEach(function(Je){Qe.test(Je)&&(ye&&ze.compare(Je)!==-1||(ze=new ce(ye=Je,_)))}),ye},e.minSatisfying=function(W,Q,_){var ye=null,ze=null;try{var Qe=new de(Q,_)}catch{return null}return W.forEach(function(Je){Qe.test(Je)&&(ye&&ze.compare(Je)!==1||(ze=new ce(ye=Je,_)))}),ye},e.validRange=function(W,Q){try{return new de(W,Q).range||"*"}catch{return null}},e.ltr=function(W,Q,_){return J(W,Q,"<",_)},e.gtr=function(W,Q,_){return J(W,Q,">",_)},e.outside=J,e.prerelease=function(W,Q){var _=Se(W,Q);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(W,Q,_){return W=new de(W,_),Q=new de(Q,_),W.intersects(Q)},e.coerce=function(W){if(W instanceof ce)return W;if(typeof W!="string")return null;var Q=W.match(m[S]);return Q==null?null:Se((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,E(1))},function(pe,e){var E,T,C=pe.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(s){if(E===setTimeout)return setTimeout(s,0);if((E===F||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:F}catch{E=F}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var g,w=[],A=!1,k=-1;function l(){A&&g&&(A=!1,g.length?w=g.concat(w):k=-1,w.length&&$())}function $(){if(!A){var s=m(l);A=!0;for(var t=w.length;t;){for(g=w,w=[];++k<t;)g&&g[k].run();k=-1,t=w.length}g=null,A=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(s)}}function v(s,t){this.fun=s,this.array=t}function a(){}C.nextTick=function(s){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];w.push(new v(s,t)),w.length!==1||A||m($)},v.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(s){return[]},C.binding=function(s){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(s){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[122],Ae([1,0,11,6]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function C(c){const h=c;return h?typeof h.read=="function":!1}e.$4d=C;function F(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$5d=F;function R(c){const h=c;return h?F(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=R;function m(c,h){return new g(c,h)}e.$7d=m;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let r;switch(h){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const u=r.indexOf(i);u>=0&&r.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let r;for(;(r=c.read())!==null;)i.push(r);return h(i)}e.$8d=w;function A(c,h,i){const r=[];let u;for(;(u=c.read())!==null&&r.length<i;)r.push(u);return u===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$9d=A;function k(c,h){return new Promise((i,r)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?r(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$0d=k;function l(c,h,i){c.on("error",r=>{i?.isCancellationRequested||h.onError(r)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",r=>{i?.isCancellationRequested||h.onData(r)})}e.$$d=l;function $(c,h){return new Promise((i,r)=>{const u=new T.$Rc,d=[],b=L=>{if(d.push(L),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=L=>(u.dispose(),r(L)),D=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Qc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Qc)(()=>c.removeListener("end",D))),c.on("end",D),u.add((0,T.$Qc)(()=>c.removeListener("data",b))),c.on("data",b)})}e.$_d=$;function v(c,h){const i=m(h);return i.end(c),i}e.$ae=v;function a(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$be=a;function s(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ce=s;function t(c,h,i){const r=m(i);return l(c,{onData:u=>r.write(h.data(u)),onError:u=>r.error(h.error?h.error(u):u),onEnd:()=>r.end()}),r}e.$de=t;function n(c,h,i){let r=!1;return{read:()=>{const u=h.read();return r?u:(r=!0,u!==null?i([c,u]):c)}}}e.$ee=n;function o(c,h,i){let r=!1;const u=m(i);return l(h,{onData:d=>r?u.write(d):(r=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{r||(r=!0,u.write(c)),u.end()}}),u}e.$fe=o}),define(Pe[24],Ae([1,0,39,122]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const C=typeof Buffer<"u",F=new E.$V(()=>new Uint8Array(256));let R,m;class g{static alloc(S){return C?new g(Buffer.allocUnsafe(S)):new g(new Uint8Array(S))}static wrap(S){return C&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new g(S)}static fromString(S,N){return!(N?.dontUseNodeBuffer||!1)&&C?new g(Buffer.from(S)):(R||(R=new TextEncoder),new g(R.encode(S)))}static fromByteArray(S){const N=g.alloc(S.length);for(let q=0,j=S.length;q<j;q++)N.buffer[q]=S[q];return N}static concat(S,N){if(typeof N>"u"){N=0;for(let M=0,U=S.length;M<U;M++)N+=S[M].byteLength}const q=g.alloc(N);let j=0;for(let M=0,U=S.length;M<U;M++){const P=S[M];q.set(P,j),j+=P.byteLength}return q}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=g.alloc(this.byteLength);return S.set(this),S}toString(){return C?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(S,N){return new g(this.buffer.subarray(S,N))}set(S,N){if(S instanceof g)this.buffer.set(S.buffer,N);else if(S instanceof Uint8Array)this.buffer.set(S,N);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),N);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return l(this.buffer,S)}writeUInt32BE(S,N){$(this.buffer,S,N)}readUInt32LE(S){return v(this.buffer,S)}writeUInt32LE(S,N){a(this.buffer,S,N)}readUInt8(S){return s(this.buffer,S)}writeUInt8(S,N){t(this.buffer,S,N)}indexOf(S,N=0){return w(this.buffer,S instanceof g?S.buffer:S,N)}}e.$ge=g;function w(y,S,N=0){const q=S.byteLength,j=y.byteLength;if(q===0)return 0;if(q===1)return y.indexOf(S[0]);if(q>j-N)return-1;const M=F.value;M.fill(S.length);for(let Z=0;Z<S.length;Z++)M[S[Z]]=S.length-Z-1;let U=N+S.length-1,P=U,I=-1;for(;U<j;)if(y[U]===S[P]){if(P===0){I=U;break}U--,P--}else U+=Math.max(S.length-P,M[y[U]]),P=S.length-1;return I}e.$he=w;function A(y,S){return y[S+0]<<0>>>0|y[S+1]<<8>>>0}e.$ie=A;function k(y,S,N){y[N+0]=S&255,S=S>>>8,y[N+1]=S&255}e.$je=k;function l(y,S){return y[S]*2**24+y[S+1]*2**16+y[S+2]*2**8+y[S+3]}e.$ke=l;function $(y,S,N){y[N+3]=S,S=S>>>8,y[N+2]=S,S=S>>>8,y[N+1]=S,S=S>>>8,y[N]=S}e.$le=$;function v(y,S){return y[S+0]<<0>>>0|y[S+1]<<8>>>0|y[S+2]<<16>>>0|y[S+3]<<24>>>0}e.$me=v;function a(y,S,N){y[N+0]=S&255,S=S>>>8,y[N+1]=S&255,S=S>>>8,y[N+2]=S&255,S=S>>>8,y[N+3]=S&255}e.$ne=a;function s(y,S){return y[S]}e.$oe=s;function t(y,S,N){y[N]=S}e.$pe=t;function n(y){return T.$8d(y,S=>g.concat(S))}e.$qe=n;function o(y){return T.$ce(y)}e.$re=o;function c(y){return T.$0d(y,S=>g.concat(S))}e.$se=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$te=h;function i(y){return T.$ae(y,S=>g.concat(S))}e.$ue=i;function r(y){return T.$de(y,{data:S=>typeof S=="string"?g.fromString(S):g.wrap(S)},S=>g.concat(S))}e.$ve=r;function u(y){return T.$7d(S=>g.concat(S),y)}e.$we=u;function d(y,S){return T.$ee(y,S,N=>g.concat(N))}e.$xe=d;function b(y,S){return T.$fe(y,S,N=>g.concat(N))}e.$ye=b;function f(y){let S=0,N=0,q=0;const j=new Uint8Array(Math.floor(y.length/4*3)),M=P=>{switch(N){case 3:j[q++]=S|P,N=0;break;case 2:j[q++]=S|P>>>2,S=P<<6,N=3;break;case 1:j[q++]=S|P>>>4,S=P<<4,N=2;break;default:S=P<<2,N=1}};for(let P=0;P<y.length;P++){const I=y.charCodeAt(P);if(I>=65&&I<=90)M(I-65);else if(I>=97&&I<=122)M(I-97+26);else if(I>=48&&I<=57)M(I-48+52);else if(I===43||I===45)M(62);else if(I===47||I===95)M(63);else{if(I===61)break;throw new SyntaxError(`Unexpected base64 character ${y[P]}`)}}const U=q;for(;N>0;)M(0);return g.wrap(j).slice(0,U)}e.$ze=f;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:y},S=!0,N=!1){const q=N?L:D;let j="";const M=y.byteLength%3;let U=0;for(;U<y.byteLength-M;U+=3){const P=y[U+0],I=y[U+1],Z=y[U+2];j+=q[P>>>2],j+=q[(P<<4|I>>>4)&63],j+=q[(I<<2|Z>>>6)&63],j+=q[Z&63]}if(M===1){const P=y[U+0];j+=q[P>>>2],j+=q[P<<4&63],S&&(j+="==")}else if(M===2){const P=y[U+0],I=y[U+1];j+=q[P>>>2],j+=q[(P<<4|I>>>4)&63],j+=q[I<<2&63],S&&(j+="=")}return j}e.$Ae=p}),define(Pe[123],Ae([1,0,28,12]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.FuzzyScore=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.or=void 0;function C(...x){return function(se,de){for(let De=0,Le=x.length;De<Le;De++){const O=x[De](se,de);if(O)return O}return null}}e.or=C,e.$Nj=F.bind(void 0,!1),e.$Oj=F.bind(void 0,!0);function F(x,se,de){if(!de||de.length<se.length)return null;let De;return x?De=T.$8e(de,se):De=de.indexOf(se)===0,De?se.length>0?[{start:0,end:se.length}]:[]:null}function R(x,se){const de=se.toLowerCase().indexOf(x.toLowerCase());return de===-1?null:[{start:de,end:de+x.length}]}e.$Pj=R;function m(x,se){return g(x.toLowerCase(),se.toLowerCase(),0,0)}e.$Qj=m;function g(x,se,de,De){if(de===x.length)return[];if(De===se.length)return null;if(x[de]===se[De]){let Le=null;return(Le=g(x,se,de+1,De+1))?t({start:De,end:De+1},Le):null}return g(x,se,de,De+1)}function w(x){return 97<=x&&x<=122}function A(x){return 65<=x&&x<=90}e.$Rj=A;function k(x){return 48<=x&&x<=57}function l(x){return x===32||x===9||x===10||x===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(x=>$.add(x.charCodeAt(0)));function v(x){return l(x)||$.has(x)}function a(x,se){return x===se||v(x)&&v(se)}function s(x){return w(x)||A(x)||k(x)}function t(x,se){return se.length===0?se=[x]:x.end===se[0].start?se[0].start=x.start:se.unshift(x),se}function n(x,se){for(let de=se;de<x.length;de++){const De=x.charCodeAt(de);if(A(De)||k(De)||de>0&&!s(x.charCodeAt(de-1)))return de}return x.length}function o(x,se,de,De){if(de===x.length)return[];if(De===se.length)return null;if(x[de]!==se[De].toLowerCase())return null;{let Le=null,O=De+1;for(Le=o(x,se,de+1,De+1);!Le&&(O=n(se,O))<se.length;)Le=o(x,se,de+1,O),O++;return Le===null?null:t({start:De,end:De+1},Le)}}function c(x){let se=0,de=0,De=0,Le=0,O=0;for(let _=0;_<x.length;_++)O=x.charCodeAt(_),A(O)&&se++,w(O)&&de++,s(O)&&De++,k(O)&&Le++;const K=se/x.length,J=de/x.length,W=De/x.length,Q=Le/x.length;return{upperPercent:K,lowerPercent:J,alphaPercent:W,numericPercent:Q}}function h(x){const{upperPercent:se,lowerPercent:de}=x;return de===0&&se>.6}function i(x){const{upperPercent:se,lowerPercent:de,alphaPercent:De,numericPercent:Le}=x;return de>.2&&se<.8&&De>.6&&Le<.2}function r(x){let se=0,de=0,De=0,Le=0;for(let O=0;O<x.length;O++)De=x.charCodeAt(O),A(De)&&se++,w(De)&&de++,l(De)&&Le++;return(se===0||de===0)&&Le===0?x.length<=30:se<=5}function u(x,se){if(!se||(se=se.trim(),se.length===0)||!r(x)||se.length>60)return null;const de=c(se);if(!i(de)){if(!h(de))return null;se=se.toLowerCase()}let De=null,Le=0;for(x=x.toLowerCase();Le<se.length&&(De=o(x,se,0,Le))===null;)Le=n(se,Le+1);return De}e.$Sj=u;function d(x,se,de=!1){if(!se||se.length===0)return null;let De=null,Le=0;for(x=x.toLowerCase(),se=se.toLowerCase();Le<se.length&&(De=b(x,se,0,Le,de))===null;)Le=f(se,Le+1);return De}e.$Tj=d;function b(x,se,de,De,Le){if(de===x.length)return[];if(De===se.length)return null;if(a(x.charCodeAt(de),se.charCodeAt(De))){let O=null,K=De+1;if(O=b(x,se,de+1,De+1,Le),!Le)for(;!O&&(K=f(se,K))<se.length;)O=b(x,se,de+1,K,Le),K++;return O?x.charCodeAt(de)!==se.charCodeAt(De)?O:t({start:De,end:De+1},O):null}else return null}function f(x,se){for(let de=se;de<x.length;de++)if(v(x.charCodeAt(de))||de>0&&v(x.charCodeAt(de-1)))return de;return x.length}const D=C(e.$Oj,u,R),L=C(e.$Oj,u,m),p=new E.$Dc(1e4);function y(x,se,de=!1){if(typeof x!="string"||typeof se!="string")return null;let De=p.get(x);De||(De=new RegExp(T.$Qe(x),"i"),p.set(x,De));const Le=De.exec(se);return Le?[{start:Le.index,end:Le.index+Le[0].length}]:de?L(x,se):D(x,se)}e.$Uj=y;function S(x,se){const de=Ie(x,x.toLowerCase(),0,se,se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?q(de):null}e.$Vj=S;function N(x,se,de,De,Le,O){const K=Math.min(13,x.length);for(;de<K;de++){const J=Ie(x,se,de,De,Le,O,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,O]}e.$Wj=N;function q(x){if(typeof x>"u")return[];const se=[],de=x[1];for(let De=x.length-1;De>1;De--){const Le=x[De]+de,O=se[se.length-1];O&&O.end===Le?O.end=Le+1:se.push({start:Le,end:Le+1})}return se}e.$Xj=q;const j=128;function M(){const x=[],se=[];for(let de=0;de<=j;de++)se[de]=0;for(let de=0;de<=j;de++)x.push(se.slice(0));return x}function U(x){const se=[];for(let de=0;de<=x;de++)se[de]=0;return se}const P=U(2*j),I=U(2*j),Z=M(),ue=M(),ge=M(),be=!1;function ke(x,se,de,De,Le){function O(J,W,Q=" "){for(;J.length<W;)J=Q+J;return J}let K=` |   |${De.split("").map(J=>O(J,3)).join("|")}
`;for(let J=0;J<=de;J++)J===0?K+=" |":K+=`${se[J-1]}|`,K+=x[J].slice(0,Le+1).map(W=>O(W.toString(),3)).join("|")+`
`;return K}function me(x,se,de,De){x=x.substr(se),de=de.substr(De),console.log(ke(ue,x,x.length,de,de.length)),console.log(ke(ge,x,x.length,de,de.length)),console.log(ke(Z,x,x.length,de,de.length))}function fe(x,se){if(se<0||se>=x.length)return!1;const de=x.codePointAt(se);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$nf(de)}}function ne(x,se){if(se<0||se>=x.length)return!1;switch(x.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Se(x,se,de){return se[x]!==de[x]}function ce(x,se,de,De,Le,O,K=!1){for(;se<de&&Le<O;)x[se]===De[Le]&&(K&&(P[se]=Le),se+=1),Le+=1;return se===de}e.$Yj=ce;var X;(function(x){x[x.Diag=1]="Diag",x[x.Left=2]="Left",x[x.LeftLeft=3]="LeftLeft"})(X||(X={}));var V;(function(x){x.Default=[-100,0];function se(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}x.isDefault=se})(V||(e.FuzzyScore=V={}));class re{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(se,de){this.firstMatchCanBeWeak=se,this.boostFullMatch=de}}e.$Zj=re;function Ie(x,se,de,De,Le,O,K=re.default){const J=x.length>j?j:x.length,W=De.length>j?j:De.length;if(de>=J||O>=W||J-de>W-O||!ce(se,de,J,Le,O,W,!0))return;Re(J,W,de,O,se,Le);let Q=1,_=1,ye=de,ze=O;const Qe=[!1];for(Q=1,ye=de;ye<J;Q++,ye++){const _e=P[ye],rt=I[ye],je=ye+1<J?I[ye+1]:W;for(_=_e-O+1,ze=_e;ze<je;_++,ze++){let ct=Number.MIN_SAFE_INTEGER,ee=!1;ze<=rt&&(ct=Ce(x,se,ye,de,De,Le,ze,W,O,Z[Q-1][_-1]===0,Qe));let Y=0;ct!==Number.MAX_SAFE_INTEGER&&(ee=!0,Y=ct+ue[Q-1][_-1]);const ve=ze>_e,Be=ve?ue[Q][_-1]+(Z[Q][_-1]>0?-5:0):0,Ke=ze>_e+1&&Z[Q][_-1]>0,xe=Ke?ue[Q][_-2]+(Z[Q][_-2]>0?-5:0):0;if(Ke&&(!ve||xe>=Be)&&(!ee||xe>=Y))ue[Q][_]=xe,ge[Q][_]=3,Z[Q][_]=0;else if(ve&&(!ee||Be>=Y))ue[Q][_]=Be,ge[Q][_]=2,Z[Q][_]=0;else if(ee)ue[Q][_]=Y,ge[Q][_]=1,Z[Q][_]=Z[Q-1][_-1]+1;else throw new Error("not possible")}}if(be&&me(x,de,De,O),!Qe[0]&&!K.firstMatchCanBeWeak)return;Q--,_--;const Je=[ue[Q][_],O];let Xe=0,it=0;for(;Q>=1;){let _e=_;do{const rt=ge[Q][_e];if(rt===3)_e=_e-2;else if(rt===2)_e=_e-1;else break}while(_e>=1);Xe>1&&se[de+Q-1]===Le[O+_-1]&&!Se(_e+O-1,De,Le)&&Xe+1>Z[Q][_e]&&(_e=_),_e===_?Xe++:Xe=1,it||(it=_e),Q--,_=_e-1,Je.push(_)}W===J&&K.boostFullMatch&&(Je[0]+=2);const nt=it-J;return Je[0]-=nt,Je}e.$1j=Ie;function Re(x,se,de,De,Le,O){let K=x-1,J=se-1;for(;K>=de&&J>=De;)Le[K]===O[J]&&(I[K]=J,K--),J--}function Ce(x,se,de,De,Le,O,K,J,W,Q,_){if(se[de]!==O[K])return Number.MIN_SAFE_INTEGER;let ye=1,ze=!1;return K===de-De?ye=x[de]===Le[K]?7:5:Se(K,Le,O)&&(K===0||!Se(K-1,Le,O))?(ye=x[de]===Le[K]?7:5,ze=!0):fe(O,K)&&(K===0||!fe(O,K-1))?ye=5:(fe(O,K-1)||ne(O,K-1))&&(ye=5,ze=!0),ye>1&&de===De&&(_[0]=!0),ze||(ze=Se(K,Le,O)||fe(O,K-1)||ne(O,K-1)),de===De?K>W&&(ye-=ze?3:5):Q?ye+=ze?2:0:ye+=ze?0:1,K+1===J&&(ye-=ze?3:5),ye}function le(x,se,de,De,Le,O,K){return G(x,se,de,De,Le,O,!0,K)}e.$2j=le;function ie(x,se,de,De,Le,O,K){return G(x,se,de,De,Le,O,!1,K)}e.$3j=ie;function G(x,se,de,De,Le,O,K,J){let W=Ie(x,se,de,De,Le,O,J);if(W&&!K)return W;if(x.length>=3){const Q=Math.min(7,x.length-1);for(let _=de+1;_<Q;_++){const ye=te(x,_);if(ye){const ze=Ie(ye,ye.toLowerCase(),de,De,Le,O,J);ze&&(ze[0]-=3,(!W||ze[0]>W[0])&&(W=ze))}}}return W}function te(x,se){if(se+1>=x.length)return;const de=x[se],De=x[se+1];if(de!==De)return x.slice(0,se)+De+de+x.slice(se+2)}}),define(Pe[31],Ae([1,0,12]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const F="error",R="warning",m="warn",g="info",w="ignore";function A(l){return l?E.$7e(F,l)?C.Error:E.$7e(R,l)||E.$7e(m,l)?C.Warning:E.$7e(g,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=A;function k(l){switch(l){case C.Error:return F;case C.Warning:return R;case C.Info:return g;default:return w}}C.toString=k}(T||(T={})),e.default=T}),define(Pe[124],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Pe[50],Ae([1,0,18,12]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=void 0;class C{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const v=$.charCodeAt(0),a=this.b.charCodeAt(this.c);return v-a}value(){return this.b[this.c]}}e.$3h=C;class F{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,T.$1e)($,this.b,0,$.length,this.c,this.d):(0,T.$3e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$4h=F;class R{constructor($=!0,v=!0){this.f=$,this.g=v}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let v=$.length-1;v>=0;v--,this.c--){const a=this.b.charCodeAt(v);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,T.$1e)($,this.b,0,$.length,this.d,this.e):(0,T.$3e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$5h=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor($,v){this.f=$,this.g=v,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,T.$2e)($,this.c.scheme);if(this.d[this.e]===2)return(0,T.$2e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,T.$Ze)($,this.c.query);if(this.d[this.e]===5)return(0,T.$Ze)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$6h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris($=()=>!1,v=()=>!1){return new k(new g($,v))}static forPaths($=!1){return new k(new R(void 0,!$))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new F)}constructor($){this.b=$}clear(){this.c=void 0}fill($,v){if(v){const a=v.slice(0);(0,E.$Xb)(a);for(const s of a)this.set(s,$)}else{const a=$.slice(0);(0,E.$Xb)(a);for(const s of a)this.set(s[0],s[1])}}set($,v){const a=this.b.reset($);let s;this.c||(this.c=new w,this.c.segment=a.value());const t=[];for(s=this.c;;){const o=a.cmp(s.segment);if(o>0)s.left||(s.left=new w,s.left.segment=a.value()),t.push([-1,s]),s=s.left;else if(o<0)s.right||(s.right=new w,s.right.segment=a.value()),t.push([1,s]),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new w,s.mid.segment=a.value()),t.push([0,s]),s=s.mid;else break}const n=s.value;s.value=v,s.key=$;for(let o=t.length-1;o>=0;o--){const c=t[o][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[o][0],r=t[o+1][0];if(i===1&&r===1)t[o][1]=c.rotateLeft();else if(i===-1&&r===-1)t[o][1]=c.rotateRight();else if(i===1&&r===-1)c.right=t[o+1][1]=t[o+1][1].rotateRight(),t[o][1]=c.rotateLeft();else if(i===-1&&r===1)c.left=t[o+1][1]=t[o+1][1].rotateLeft(),t[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this.c=t[0][1]}}return n}get($){return this.d($)?.value}d($){const v=this.b.reset($);let a=this.c;for(;a;){const s=v.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else break}return a}has($){const v=this.d($);return!(v?.value===void 0&&v?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,v){const a=this.b.reset($),s=[];let t=this.c;for(;t;){const n=a.cmp(t.segment);if(n>0)s.push([-1,t]),t=t.left;else if(n<0)s.push([1,t]),t=t.right;else if(a.hasNext())a.next(),s.push([0,t]),t=t.mid;else break}if(t){if(v?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:o,value:c,segment:h}=n;this.e(n.key,!1),t.key=o,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(s.length>0){const[o,c]=s[s.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),s[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),s[n][1]=o.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const v=this.b.reset($);let a=this.c,s;for(;a;){const t=v.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(v.hasNext())v.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr($){return this.g($,!1)}g($,v){const a=this.b.reset($);let s=this.c;for(;s;){const t=a.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this.h(s.mid):v?s.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[v,a]of this)$(a,v)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const v=[];return this.j($,v),v[Symbol.iterator]()}j($,v){$&&($.left&&this.j($.left,v),$.value&&v.push([$.key,$.value]),$.mid&&this.j($.mid,v),$.right&&this.j($.right,v))}_isBalanced(){const $=v=>{if(!v)return!0;const a=v.balanceFactor();return a<-1||a>1?!1:$(v.left)&&$(v.right)};return $(this.c)}}e.$7h=k}),define(Pe[45],Ae([1,0,90]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$7j=e.ThemeColor=void 0;var T;(function(R){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=m})(T||(e.ThemeColor=T={}));function C(R){return{id:R}}e.$7j=C;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const o=m.exec(n.id);if(!o)return g(E.$6j.error);const[,c,h]=o,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function w(n){return g(n).join(" ")}R.asClassName=w;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function $(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}R.fromString=$;function v(n){return{id:n}}R.fromId=v;function a(n,o){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),o&&(c=`${c}~${o}`),{id:c}}R.modify=a;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}R.getModifier=s;function t(n,o){return n.id===o.id&&n.color?.id===o.color?.id}R.isEqual=t})(F||(e.ThemeIcon=F={}))}),define(Pe[125],Ae([1,0,123,12,45]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=void 0;const F="$(",R=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace(m,(n,o)=>o?n:`\\${n}`)}e.$8j=g;const w=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(w,n=>`\\${n}`)}e.$9j=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(F)===-1?t:t.replace(k,(n,o,c,h)=>c?n:o||h||"")}e.$0j=l;function $(t){return t?t.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$$j=$;const v=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(t){v.lastIndex=0;let n="";const o=[];let c=0;for(;;){const h=v.lastIndex,i=v.exec(t),r=t.substring(h,i?.index);if(r.length>0){n+=r;for(let u=0;u<r.length;u++)o.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:o}}e.$_j=a;function s(t,n,o=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Uj)(t,c,o);const i=(0,T.$Oe)(c," "),r=c.length-i.length,u=(0,E.$Uj)(t,i,o);if(u)for(const d of u){const b=h[d.start+r]+r;d.start+=b,d.end+=b}return u}e.$ak=s}),define(Pe[33],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return E.test(C)}e.$kg=T,e.$lg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const F=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let g=0,w="";return w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+="-",w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w+=R[F[g++]],w}}()}),define(Pe[126],Ae([1,0,18,67,33]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=e.$at=e.$_s=e.$$s=e.$0s=void 0;function F(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$0s=F;function R(k,l,$){const v={id:(0,C.$lg)(),name:k,uri:l,data:$};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$$s=R;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return T.Iterable.some(this,([v,a])=>a.asFile())&&$.push("files"),A(g(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const v=this.a.get(l);v?v.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const v of $)yield[l,v]}b(l){return g(l)}}e.$_s=m;function g(k){return k.toLowerCase()}function w(k,l){return A(g(k),l.map(g))}e.$at=w;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const $=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[v,a,s]=$;return s==="*"?l.some(t=>t.startsWith(a+"/")):!1}e.$bt=Object.freeze({create:k=>(0,E.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$bt.split(k).filter(l=>!l.startsWith("#"))})}),define(Pe[127],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.StringEOL=void 0;var E;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(C){let F=0,R=0,m=0,g=0;for(let w=0,A=C.length;w<A;w++){const k=C.charCodeAt(w);k===13?(F===0&&(R=w),F++,w+1<A&&C.charCodeAt(w+1)===10?(g|=2,w++):g|=3,m=w+1):k===10&&(g|=1,F===0&&(R=w),F++,m=w+1)}return F===0&&(R=C.length),[F,R,C.length-m,g]}e.$et=T}),define(Pe[128],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,e.$bs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,w=m.notIn.length;g<w;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(g-2),A=m.getStandardTokenType(w);return this.isOK(A)}g(m,g){for(let w=m;w<=g;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Bt=T;class C{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)F(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),F(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),F(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),F(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&F(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Ct=C;function F(R,m,g){R.has(m)?R.get(m).push(g):R.set(m,[g])}}),define(Pe[130],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.NodeColor=e.$xB=void 0;class E{constructor(s,t){this.piece=s,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$yB)return C(this.right);let s=this;for(;s.parent!==e.$yB&&s.parent.left!==s;)s=s.parent;return s.parent===e.$yB?e.$yB:s.parent}prev(){if(this.left!==e.$yB)return F(this.left);let s=this;for(;s.parent!==e.$yB&&s.parent.right!==s;)s=s.parent;return s.parent===e.$yB?e.$yB:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$xB=E;var T;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$yB=new E(null,0),e.$yB.parent=e.$yB,e.$yB.left=e.$yB,e.$yB.right=e.$yB,e.$yB.color=0;function C(a){for(;a.left!==e.$yB;)a=a.left;return a}e.$zB=C;function F(a){for(;a.right!==e.$yB;)a=a.right;return a}e.$AB=F;function R(a){return a===e.$yB?0:a.size_left+a.piece.length+R(a.right)}function m(a){return a===e.$yB?0:a.lf_left+a.piece.lineFeedCnt+m(a.right)}function g(){e.$yB.parent=e.$yB}function w(a,s){const t=s.right;t.size_left+=s.size_left+(s.piece?s.piece.length:0),t.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=t.left,t.left!==e.$yB&&(t.left.parent=s),t.parent=s.parent,s.parent===e.$yB?a.root=t:s.parent.left===s?s.parent.left=t:s.parent.right=t,t.left=s,s.parent=t}e.$BB=w;function A(a,s){const t=s.left;s.left=t.right,t.right!==e.$yB&&(t.right.parent=s),t.parent=s.parent,s.size_left-=t.size_left+(t.piece?t.piece.length:0),s.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),s.parent===e.$yB?a.root=t:s===s.parent.right?s.parent.right=t:s.parent.left=t,t.right=s,s.parent=t}e.$CB=A;function k(a,s){let t,n;if(s.left===e.$yB?(n=s,t=n.right):s.right===e.$yB?(n=s,t=n.left):(n=C(s.right),t=n.right),n===a.root){a.root=t,t.color=0,s.detach(),g(),a.root.parent=e.$yB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===s?(t.parent=n.parent,v(a,t)):(n.parent===s?t.parent=n:t.parent=n.parent,v(a,t),n.left=s.left,n.right=s.right,n.parent=s.parent,n.color=s.color,s===a.root?a.root=n:s===s.parent.left?s.parent.left=n:s.parent.right=n,n.left!==e.$yB&&(n.left.parent=n),n.right!==e.$yB&&(n.right.parent=n),n.size_left=s.size_left,n.lf_left=s.lf_left,v(a,n)),s.detach(),t.parent.left===t){const h=R(t),i=m(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const r=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,$(a,t.parent,r,u)}}if(v(a,t.parent),o){g();return}let c;for(;t!==a.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(a,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(a,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(a,t.parent),t=a.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(a,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(a,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(a,t.parent),t=a.root));t.color=0,g()}e.$DB=k;function l(a,s){for(v(a,s);s!==a.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const t=s.parent.parent.right;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,w(a,s)),s.parent.color=0,s.parent.parent.color=1,A(a,s.parent.parent))}else{const t=s.parent.parent.left;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,A(a,s)),s.parent.color=0,s.parent.parent.color=1,w(a,s.parent.parent))}a.root.color=0}e.$EB=l;function $(a,s,t,n){for(;s!==a.root&&s!==e.$yB;)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}e.$FB=$;function v(a,s){let t=0,n=0;if(s!==a.root){for(;s!==a.root&&s===s.parent.right;)s=s.parent;if(s!==a.root)for(s=s.parent,t=R(s.left)-s.size_left,n=m(s.left)-s.lf_left,s.size_left+=t,s.lf_left+=n;s!==a.root&&(t!==0||n!==0);)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}}e.$GB=v}),define(Pe[91],Ae([1,0,92,29,93,130,94]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=e.$QB=e.$PB=e.$OB=e.$NB=void 0;const m=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class w{constructor(n,o,c,h,i){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const o=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const r=t.charCodeAt(h);r===13?h+1<i&&t.charCodeAt(h+1)===10?(o[c++]=h+2,h++):o[c++]=h+1:r===10&&(o[c++]=h+1)}return n?g(o):o}e.$NB=A;function k(t,n){t.length=0,t[0]=0;let o=1,c=0,h=0,i=0,r=!0;for(let d=0,b=n.length;d<b;d++){const f=n.charCodeAt(d);f===13?d+1<b&&n.charCodeAt(d+1)===10?(i++,t[o++]=d+2,d++):(c++,t[o++]=d+1):f===10?(h++,t[o++]=d+1):r&&f!==9&&(f<32||f>126)&&(r=!1)}const u=new w(g(t),c,h,i,r);return t.length=0,u}e.$OB=k;class l{constructor(n,o,c,h,i){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$PB=l;class ${constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$QB=$;class v{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==F.$yB&&n.iterate(n.root,c=>(c!==F.$yB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,o=!0;continue}}if(o){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class s{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=F.$yB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let h=null;for(let i=0,r=n.length;i<r;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=m,c=o-Math.floor(o/3),h=c*2;let i="",r=0;const u=[];if(this.iterate(this.root,d=>{const b=this.R(d),f=b.length;if(r<=c||r+f<h)return i+=b,r+=f,!0;const D=i.replace(/\r\n|\r|\n/g,n);return u.push(new $(D,A(D))),i=b,r=f,!0}),r>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new $(d,A(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,h=>{if(h===F.$yB)return!0;const i=this.R(h),r=i.length,u=n.G(o),d=n.G(o+r),b=n.getValueInRange2(u,d);return o+=r,i===b})}getOffsetAt(n,o){let c=0,h=this.root;for(;h!==F.$yB;)if(h.left!==F.$yB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+o-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const h=n;for(;o!==F.$yB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const i=this.A(o,n-o.size_left);if(c+=o.lf_left+i.index,i.index===0){const r=this.getOffsetAt(c+1,1),u=h-r;return new E.$Ds(c+1,u+1)}return new E.$Ds(c+1,i.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===F.$yB){const i=this.getOffsetAt(c+1,1),r=h-n-i;return new E.$Ds(c+1,r+1)}else o=o.right;return new E.$Ds(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return o?o!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,o):i}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,b=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(b+n.remainder,b+o.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let r=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==F.$yB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){r+=u.substring(d,d+o.remainder);break}else r+=u.substr(d,c.piece.length);c=c.next()}return r}getLinesContent(){const n=[];let o=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===F.$yB)return!0;const r=i.piece;let u=r.length;if(u===0)return!0;const d=this.a[r.bufferIndex].buffer,b=this.a[r.bufferIndex].lineStarts,f=r.start.line,D=r.end.line;let L=b[f]+r.start.column;if(h&&(d.charCodeAt(L)===10&&(L++,u--),n[o++]=c,c="",h=!1,u===0))return!0;if(f===D)return!this.f&&d.charCodeAt(L+u-1)===13?(h=!0,c+=d.substr(L,u-1)):c+=d.substr(L,u),!0;c+=this.f?d.substring(L,Math.max(L,b[f+1]-this.e)):d.substring(L,b[f+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let p=f+1;p<D;p++)c=this.f?d.substring(b[p],b[p+1]-this.e):d.substring(b[p],b[p+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&d.charCodeAt(b[D]+r.end.column-1)===13?(h=!0,r.end.column===0?o--:c=d.substr(b[D],r.end.column-1)):c=d.substr(b[D],r.end.column),!0}),h&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],h=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(h)}else{const o=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(h)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,h,i,r,u,d,b,f,D){const L=this.a[n.piece.bufferIndex],p=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),S=this.u(n.piece.bufferIndex,r);let N;const q={line:0,column:0};let j,M;o._wordSeparators?(j=L.buffer.substring(y,S),M=U=>U+y,o.reset(0)):(j=L.buffer,M=U=>U,o.reset(y));do if(N=o.next(j),N){if(M(N.index)>=S)return f;this.s(n,M(N.index)-p,q);const U=this.t(n.piece.bufferIndex,i,q),P=q.line===i.line?q.column-i.column+h:q.column+1,I=P+N[0].length;if(D[f++]=(0,R.$JB)(new T.$Es(c+U,P,c+U,I),N,d),M(N.index)+N[0].length>=S||f>=b)return f}while(N);return f}findMatchesLineByLine(n,o,c,h){const i=[];let r=0;const u=new R.$MB(o.wordSeparators,o.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const b=this.H(n.endLineNumber,n.endColumn);if(b===null)return[];let f=this.s(d.node,d.remainder);const D=this.s(b.node,b.remainder);if(d.node===b.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,D,o,c,h,r,i),i;let L=n.startLineNumber,p=d.node;for(;p!==b.node;){const S=this.t(p.piece.bufferIndex,f,p.piece.end);if(S>=1){const q=this.a[p.piece.bufferIndex].lineStarts,j=this.u(p.piece.bufferIndex,p.piece.start),M=q[f.line+S],U=L===n.startLineNumber?n.startColumn:1;if(r=this.findMatchesInNode(p,u,L,U,f,this.s(p,M-j),o,c,h,r,i),r>=h)return i;L+=S}const N=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const q=this.getLineContent(L).substring(N,n.endColumn-1);return r=this.n(o,u,q,n.endLineNumber,N,r,i,c,h),i}if(r=this.n(o,u,this.getLineContent(L).substr(N),L,N,r,i,c,h),r>=h)return i;L++,d=this.H(L,1),p=d.node,f=this.s(d.node,d.remainder)}if(L===n.endLineNumber){const S=L===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(L).substring(S,n.endColumn-1);return r=this.n(o,u,N,n.endLineNumber,S,r,i,c,h),i}const y=L===n.startLineNumber?n.startColumn:1;return r=this.findMatchesInNode(b.node,u,L,y,f,D,o,c,h,r,i),i}n(n,o,c,h,i,r,u,d,b){const f=n.wordSeparators;if(!d&&n.simpleSearch){const L=n.simpleSearch,p=L.length,y=c.length;let S=-p;for(;(S=c.indexOf(L,S+p))!==-1;)if((!f||(0,R.$LB)(f,c,y,S,p))&&(u[r++]=new C.$Wu(new T.$Es(h,S+1+i,h,S+1+p+i),null),r>=b))return r;return r}let D;o.reset(0);do if(D=o.next(c),D&&(u[r++]=(0,R.$JB)(new T.$Es(h,D.index+1+i,h,D.index+1+D[0].length+i),D,d),r>=b))return r;while(D);return r}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$yB){const{node:h,remainder:i,nodeStartOffset:r}=this.G(n),u=h.piece,d=u.bufferIndex,b=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&r+u.length===n&&o.length<m){this.F(h,o),this.y();return}if(r===n)this.o(o,h),this.h.validate(n);else if(r+h.piece.length>n){const f=[];let D=new l(u.bufferIndex,b,u.end,this.t(u.bufferIndex,b,u.end),this.u(d,u.end)-this.u(d,b));if(this.K()&&this.M(o)&&this.I(h,i)===10){const S={line:D.start.line+1,column:0};D=new l(D.bufferIndex,S,D.end,this.t(D.bufferIndex,S,D.end),D.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(h,i-1)===13){const S=this.s(h,i-1);this.C(h,S),o="\r"+o,h.piece.length===0&&f.push(h)}else this.C(h,b);else this.C(h,b);const L=this.w(o);D.length>0&&this.S(h,D);let p=h;for(let y=0;y<L.length;y++)p=this.S(p,L[y]);this.v(f)}else this.q(o,h)}else{const h=this.w(o);let i=this.T(null,h[0]);for(let r=1;r<h.length;r++)i=this.S(i,h[r])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===F.$yB)return;const c=this.G(n),h=this.G(n+o),i=c.node,r=h.node;if(i===r){const L=this.s(i,c.remainder),p=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(o===i.piece.length){const y=i.next();(0,F.$DB)(this,i),this.N(y),this.y();return}this.D(i,p),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+o){this.C(i,L),this.O(i),this.y();return}this.E(i,L,p),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const b=this.s(r,h.remainder);this.D(r,b),r.piece.length===0&&u.push(r);const f=i.next();for(let L=f;L!==F.$yB&&L!==r;L=L.next())u.push(L);const D=i.piece.length===0?i.prev():i;this.v(u),this.O(D),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const r=o.piece,u={line:r.start.line+1,column:0},d=new l(r.bufferIndex,u,r.end,this.t(r.bufferIndex,u,r.end),r.length-1);o.piece=d,n+=`
`,(0,F.$FB)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const h=this.w(n);let i=this.T(o,h[h.length-1]);for(let r=h.length-2;r>=0;r--)i=this.T(i,h[r]);this.N(i),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),h=this.S(o,c[0]);let i=h;for(let r=1;r<c.length;r++)i=this.S(i,c[r]);this.N(h)}s(n,o,c){const h=n.piece,i=n.piece.bufferIndex,r=this.a[i].lineStarts,d=r[h.start.line]+h.start.column+o;let b=h.start.line,f=h.end.line,D=0,L=0,p=0;for(;b<=f&&(D=b+(f-b)/2|0,p=r[D],D!==f);)if(L=r[D+1],d<p)f=D-1;else if(d>=L)b=D+1;else break;return c?(c.line=D,c.column=d-p,null):{line:D,column:d-p}}t(n,o,c){if(c.column===0)return c.line-o.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-o.line;const i=h[c.line+1],r=h[c.line]+c.column;if(i>r+1)return c.line-o.line;const u=r-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,F.$DB)(this,n[o])}w(n){if(n.length>m){const f=[];for(;n.length>m;){const L=n.charCodeAt(m-1);let p;L===13||L>=55296&&L<=56319?(p=n.substring(0,m-1),n=n.substring(m-1)):(p=n.substring(0,m),n=n.substring(m));const y=A(p);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:p.length-y[y.length-1]},y.length-1,p.length)),this.a.push(new $(p,y))}const D=A(n);return f.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new $(n,D)),f}let o=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let f=0;f<c.length;f++)c[f]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[r],d={line:r,column:u},b=new l(0,h,d,this.t(0,h,d),i-o);return this.g=d,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const r=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+r,d+c.piece.length);else{const b=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+r,d+b-o)}}else{let r=0;const u=n;for(;c!==F.$yB;)if(c.left!==F.$yB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),b=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,D=this.u(c.piece.bufferIndex,c.piece.start);return r+=c.size_left,this.h.set({node:c,nodeStartOffset:r,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(D+d,D+b-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),b=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=b.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,r+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$yB;){const r=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=r.substring(d,d+u-o),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=r.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,o=1,c=0;for(;n!==F.$yB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,h=this.s(n,o),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const r=this.t(n.piece.bufferIndex,c.start,h);if(r!==i)return{index:r,remainder:0}}return{index:i,remainder:h.column}}B(n,o){if(o<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+o+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),r=o,u=this.u(c.bufferIndex,r),d=this.t(c.bufferIndex,c.start,r),b=d-h,f=u-i,D=c.length+f;n.piece=new l(c.bufferIndex,c.start,r,d,D),(0,F.$FB)(this,n,f,b)}D(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),r=o,u=this.t(c.bufferIndex,r,c.end),d=this.u(c.bufferIndex,r),b=u-h,f=i-d,D=c.length+f;n.piece=new l(c.bufferIndex,r,c.end,u,D),(0,F.$FB)(this,n,f,b)}E(n,o,c){const h=n.piece,i=h.start,r=h.end,u=h.length,d=h.lineFeedCnt,b=o,f=this.t(h.bufferIndex,h.start,b),D=this.u(h.bufferIndex,o)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,b,f,D),(0,F.$FB)(this,n,D-u,f-d);const L=new l(h.bufferIndex,c,r,this.t(h.bufferIndex,c,r),this.u(h.bufferIndex,r)-this.u(h.bufferIndex,c)),p=this.S(n,L);this.N(p)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=o;const i=A(o,!1);for(let p=0;p<i.length;p++)i[p]+=h;if(c){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const r=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[r],d={line:r,column:u},b=n.piece.length+o.length,f=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,d),L=D-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,D,b),this.g=d,(0,F.$FB)(this,n,o.length,L)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;o!==F.$yB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){h+=o.size_left;const i={node:o,remainder:n-o.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=o.size_left+o.piece.length,h+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,h=0;for(;c!==F.$yB;)if(c.left!==F.$yB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),r=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+o-1,r),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+o-1<=c.piece.length)return{node:c,remainder:i+o-1,nodeStartOffset:h};o-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$yB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),r=this.J(c);return{node:c,remainder:Math.min(o-1,i),nodeStartOffset:r}}else if(c.piece.length>=o-1){const i=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:i}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$yB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,h=o.start.line,i=c[h]+o.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$yB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const r=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,r),(0,F.$FB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:o.piece.start.line+1,column:0},b=o.piece.length-1,f=this.t(o.piece.bufferIndex,d,o.piece.end);o.piece=new l(o.piece.bufferIndex,d,o.piece.end,f,b),(0,F.$FB)(this,o,-1,-1),o.piece.length===0&&c.push(o);const D=this.w(`\r
`);this.S(n,D[0]);for(let L=0;L<c.length;L++)(0,F.$DB)(this,c[L])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,F.$DB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},r=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,r),(0,F.$FB)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===F.$yB)return o(F.$yB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===F.$yB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return o.buffer.substring(h,i)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,h)}S(n,o){const c=new F.$xB(o,1);if(c.left=F.$yB,c.right=F.$yB,c.parent=F.$yB,c.size_left=0,c.lf_left=0,this.root===F.$yB)this.root=c,c.color=0;else if(n.right===F.$yB)n.right=c,c.parent=n;else{const i=(0,F.$zB)(n.right);i.left=c,c.parent=i}return(0,F.$EB)(this,c),c}T(n,o){const c=new F.$xB(o,1);if(c.left=F.$yB,c.right=F.$yB,c.parent=F.$yB,c.size_left=0,c.lf_left=0,this.root===F.$yB)this.root=c,c.color=0;else if(n.left===F.$yB)n.left=c,c.parent=n;else{const h=(0,F.$AB)(n.left);h.right=c,c.parent=h}return(0,F.$EB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$RB=s}),define(Pe[131],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47=e.$37=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$37=E;class T{constructor(F){this.identifier=F}}e.$47=T}),define(Pe[132],Ae([9,10]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[133],Ae([1,0,5,6,132]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=void 0;class F extends T.$Sc{constructor(l,$="",v="",a=!0,s){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.z=!0,this.m=l,this.n=$,this.w=v,this.z=a,this.D=s}get id(){return this.m}get label(){return this.n}set label(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({label:l}))}get tooltip(){return this.u||""}set tooltip(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({tooltip:l}))}get class(){return this.w}set class(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({class:l}))}get enabled(){return this.z}set enabled(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({enabled:l}))}get checked(){return this.C}set checked(l){this.J(l)}J(l){this.C!==l&&(this.C=l,this.h.fire({checked:l}))}async run(l,$){this.D&&await this.D(l)}}e.$Fi=F;class R extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let v;try{await this.u(l,$)}catch(a){v=a}this.m.fire({action:l,error:v})}async u(l,$){await l.run($)}}e.$Gi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const v of l)v.length&&($.length?$=[...$,new m,...v]:$=v);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Hi=m;class g{get actions(){return this.a}constructor(l,$,v,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=a,this.a=v}async run(){}}e.$Ii=g;class w extends F{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,C.localize(0,null),void 0,!1)}}e.$Ji=w;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Ki=A}),define(Pe[134],Ae([9,10]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[135],Ae([1,0,134]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=void 0;const T=60,C=T*60,F=C*24,R=F*7,m=F*30,g=F*365;function w(k,l,$,v){typeof k!="number"&&(k=k.getTime());const a=Math.round((new Date().getTime()-k)/1e3);if(a<-30)return(0,E.localize)(0,null,w(new Date().getTime()+a*1e3,!1));if(!v&&a<30)return(0,E.localize)(1,null);let s;return a<T?(s=a,l?s===1?$?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):$?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?$?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):$?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):a<C?(s=Math.floor(a/T),l?s===1?$?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):$?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?$?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):$?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):a<F?(s=Math.floor(a/C),l?s===1?$?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):$?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?$?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):$?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):a<R?(s=Math.floor(a/F),l?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):a<m?(s=Math.floor(a/R),l?s===1?$?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):$?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?$?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):$?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):a<g?(s=Math.floor(a/m),l?s===1?$?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):$?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?$?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):$?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(a/g),l?s===1?$?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):$?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?$?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):$?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.$om=w;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$pm=A}),define(Pe[136],Ae([9,10]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[40],Ae([1,0,18,16,136]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=e.$Li=void 0;function F(k,l){return l&&(k.stack||k.stacktrace)?C.localize(0,null,m(k),R(k.stack)||R(k.stacktrace)):m(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function g(k=null,l=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const $=E.$Hb(k),v=g($[0],l);return $.length>1?C.localize(4,null,v,$.length):v}if(T.$Df(k))return k;if(k.detail){const $=k.detail;if($.error)return F($.error,l);if($.exception)return F($.exception,l)}return k.stack?F(k,l):k.message?k.message:C.localize(5,null)}e.$Li=g;function w(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Mi=w;function A(k,l){let $;return typeof k=="string"?$=new Error(k):$=k,$.actions=l,$}e.$Ni=A}),define(Pe[137],Ae([1,0,39,19]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=void 0;const C=new E.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),F=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(L,p,y=!1){const S=L||"",N=p||"",q=C.value.collator.compare(S,N);return C.value.collatorIsNumeric&&q===0&&S!==N?S<N?-1:1:q}e.$sq=m;function g(L,p){const y=F.value.collator;return L=L||"",p=p||"",c(y,L,p)}e.$tq=g;function w(L,p){const y=F.value.collator;return L=L||"",p=p||"",u(L,p)||c(y,L,p)}e.$uq=w;function A(L,p){const y=F.value.collator;return L=L||"",p=p||"",r(L,p)||c(y,L,p)}e.$vq=A;function k(L,p){return L=L||"",p=p||"",L===p?0:L<p?-1:1}e.$wq=k;function l(L,p){const[y,S]=n(L),[N,q]=n(p);let j=C.value.collator.compare(S,q);if(j===0){if(C.value.collatorIsNumeric&&S!==q)return S<q?-1:1;if(j=C.value.collator.compare(y,N),C.value.collatorIsNumeric&&j===0&&y!==N)return y<N?-1:1}return j}e.$xq=l;function $(L,p){L=L||"",p=p||"";const y=o(L),S=o(p),N=F.value.collator,q=R.value.collator;return c(q,y,S)||c(N,L,p)}e.$yq=$;function v(L,p){L=L||"",p=p||"";const y=o(L),S=o(p),N=F.value.collator,q=R.value.collator;return c(q,y,S)||u(L,p)||c(N,L,p)}e.$zq=v;function a(L,p){L=L||"",p=p||"";const y=o(L),S=o(p),N=F.value.collator,q=R.value.collator;return c(q,y,S)||r(L,p)||c(N,L,p)}e.$Aq=a;function s(L,p){L=L||"",p=p||"";const y=o(L).toLowerCase(),S=o(p).toLowerCase();return y!==S?y<S?-1:1:L!==p?L<p?-1:1:0}e.$Bq=s;const t=/^(.*?)(\.([^.]*))?$/;function n(L,p=!1){const y=L?t.exec(L):[];let S=[y&&y[1]||"",y&&y[3]||""];return p&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function o(L){const p=L?t.exec(L):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function c(L,p,y){const S=L.compare(p,y);return S!==0?S:p.length!==y.length?p.length<y.length?-1:1:0}function h(L){const p=L.charAt(0);return p.toLocaleUpperCase()!==p}function i(L){const p=L.charAt(0);return p.toLocaleLowerCase()!==p}function r(L,p){return h(L)&&i(p)?-1:i(L)&&h(p)?1:0}function u(L,p){return i(L)&&h(p)?-1:h(L)&&i(p)?1:0}function d(L,p,y=!1){return y||(L=L&&L.toLowerCase(),p=p&&p.toLowerCase()),L===p?0:L<p?-1:1}function b(L,p,y=!1){const S=L.split(T.sep),N=p.split(T.sep),q=S.length-1,j=N.length-1;let M,U;for(let P=0;;P++){if(M=q===P,U=j===P,M&&U)return m(S[P],N[P],y);if(M)return-1;if(U)return 1;const I=d(S[P],N[P],y);if(I!==0)return I}}e.$Cq=b;function f(L,p,y){const S=L.toLowerCase(),N=p.toLowerCase(),q=D(L,p,y);if(q)return q;const j=S.endsWith(y),M=N.endsWith(y);if(j!==M)return j?-1:1;const U=m(S,N);return U!==0?U:S.localeCompare(N)}e.$Dq=f;function D(L,p,y){const S=L.toLowerCase(),N=p.toLowerCase(),q=S.startsWith(y),j=N.startsWith(y);if(q!==j)return q?-1:1;if(q&&j){if(S.length<N.length)return-1;if(S.length>N.length)return 1}return 0}e.$Eq=D}),define(Pe[46],Ae([1,0,19,21,12,16]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function R(f){return f===47||f===92}e.$Vf=R;function m(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$Wf=m;function g(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Xf=g;function w(f,D=E.$gc.sep){if(!f)return"";const L=f.length,p=f.charCodeAt(0);if(R(p)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let S=3;const N=S;for(;S<L&&!R(f.charCodeAt(S));S++);if(N!==S&&!R(f.charCodeAt(S+1))){for(S+=1;S<L;S++)if(R(f.charCodeAt(S)))return f.slice(0,S+1).replace(/[\\/]/g,D)}}return D}else if(t(p)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+D:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$Yf=w;function A(f){if(!T.$i||!f||f.length<5)return!1;let D=f.charCodeAt(0);if(D!==92||(D=f.charCodeAt(1),D!==92))return!1;let L=2;const p=L;for(;L<f.length&&(D=f.charCodeAt(L),D!==92);L++);return!(p===L||(D=f.charCodeAt(L+1),isNaN(D)||D===92))}e.$Zf=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(f,D=T.$i){const L=D?k:l;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||D&&$.test(f)||f==="."||f===".."||D&&f[f.length-1]==="."||D&&f.length!==f.trim().length||f.length>255)}e.$1f=v;function a(f,D,L){const p=f===D;return!L||p?p:!f||!D?!1:(0,C.$7e)(f,D)}e.$2f=a;function s(f,D,L,p=E.sep){if(f===D)return!0;if(!f||!D||D.length>f.length)return!1;if(L){if(!(0,C.$8e)(f,D))return!1;if(D.length===f.length)return!0;let S=D.length;return D.charAt(D.length-1)===p&&S--,f.charAt(S)===p}return D.charAt(D.length-1)!==p&&(D+=p),f.indexOf(D)===0}e.$3f=s;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$4f=t;function n(f,D){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(D,f)),f=(0,E.$hc)(f),T.$i?(f=(0,C.$Pe)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,C.$Pe)(f,E.sep),f||(f=E.sep)),f}e.$5f=n;function o(f){const D=(0,E.$hc)(f);return T.$i?f.length>3?!1:c(D)&&(f.length===2||D.charCodeAt(2)===92):D===E.$gc.sep}e.$6f=o;function c(f,D=T.$i){return D?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$7f=c;function h(f,D=T.$i){return c(f,D)?f[0]:void 0}e.$8f=h;function i(f,D,L){return D.length>f.length?-1:f===D?0:(L&&(f=f.toLowerCase(),D=D.toLowerCase()),f.indexOf(D))}e.$9f=i;function r(f){const D=f.split(":");let L,p,y;for(const S of D){const N=Number(S);(0,F.$Hf)(N)?p===void 0?p=N:y===void 0&&(y=N):L=L?[L,S].join(":"):S}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:p!==void 0?p:void 0,column:y!==void 0?y:p!==void 0?1:void 0}}e.$0f=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(f,D,L=8){let p="";for(let S=0;S<L;S++){let N;S===0&&T.$i&&!D&&(L===3||L===4)?N=d:N=u,p+=N.charAt(Math.floor(Math.random()*N.length))}let y;return D?y=`${D}-${p}`:y=p,f?(0,E.$jc)(f,y):y}e.$$f=b}),define(Pe[68],Ae([1,0,19]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.$3r=e.$2r=e.$1r=void 0,e.$1r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(A){const k=(0,E.$oc)(A),l=T[k.toLowerCase()];return l!==void 0?l:R(A)}e.$2r=F;function R(A){const k=(0,E.$oc)(A);return C[k.toLowerCase()]}e.$3r=R;function m(A){for(const k in C)if(C[k]===A)return k}e.$4r=m;const g=/^(.+)\/(.+?)(;.+)?$/;function w(A,k){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$5r=w}),define(Pe[51],Ae([1,0,24,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function C(g){return JSON.stringify(g,R)}e.$vh=C;function F(g){let w=JSON.parse(g);return w=m(w),w}e.$wh=F;function R(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=m(g[A],w+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=m(g[A],w+1))}return g}e.$xh=m}),define(Pe[13],Ae([1,0,11,21,12,2]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function m(l,$){return F.URI.isUri(l)?(0,C.$7e)(l.scheme,$):(0,C.$8e)(l,$+":")}e.$_f=m;function g(l,...$){return $.some(v=>m(l,v))}e.$ag=g,e.$bg="vscode-tkn",e.$cg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${R.vscodeRemoteResource}`}set($,v,a){this.a[$]=v,this.b[$]=a}setConnectionToken($,v){this.c[$]=v}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return E.$1(o),$}const v=$.authority;let a=this.a[v];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const s=this.b[v],t=this.c[v];let n=`path=${encodeURIComponent($.path)}`;return typeof t=="string"&&(n+=`&${e.$cg}=${encodeURIComponent(t)}`),F.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${a}:${s}`,path:this.f,query:n})}}e.$dg=new w,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class A{static{this.a=e.$ig}asBrowserUri($){const v=this.b($,pe);return this.uriToBrowserUri(v)}uriToBrowserUri($){return $.scheme===R.vscodeRemote?e.$dg.rewrite($):$.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${A.a}`)?$.with({scheme:R.vscodeFileResource,authority:$.authority||A.a,query:null,fragment:null}):$}asFileUri($){const v=this.b($,pe);return this.uriToFileUri(v)}uriToFileUri($){return $.scheme===R.vscodeFileResource?$.with({scheme:R.file,authority:$.authority!==A.a?$.authority:null,query:null,fragment:null}):$}b($,v){return F.URI.isUri($)?$:F.URI.parse(v.toUrl($))}}e.$jg=new A;var k;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const v="vscode-coi";function a(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:F.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const o=n?.get(v);if(o)return $.get(o)}l.getHeadersFromQuery=a;function s(t,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";t instanceof URLSearchParams?t.set(v,c):t[v]=c}l.addSearchParam=s})(k||(e.COI=k={}))}),define(Pe[25],Ae([1,0,46,13,19,21,12,2]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function g($){return(0,m.$wc)($,!0)}e.$qg=g;class w{constructor(v){this.a=v}compare(v,a,s=!1){return v===a?0:(0,R.$Ze)(this.getComparisonKey(v,s),this.getComparisonKey(a,s))}isEqual(v,a,s=!1){return v===a?!0:!v||!a?!1:this.getComparisonKey(v,s)===this.getComparisonKey(a,s)}getComparisonKey(v,a=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,a,s=!1){if(v.scheme===a.scheme){if(v.scheme===T.Schemas.file)return E.$3f(g(v),g(a),this.a(v))&&v.query===a.query&&(s||v.fragment===a.fragment);if((0,e.$Hg)(v.authority,a.authority))return E.$3f(v.path,a.path,this.a(v),"/")&&v.query===a.query&&(s||v.fragment===a.fragment)}return!1}joinPath(v,...a){return m.URI.joinPath(v,...a)}basenameOrAuthority(v){return(0,e.$zg)(v)||v.authority}basename(v){return C.$gc.basename(v.path)}extname(v){return C.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let a;return v.scheme===T.Schemas.file?a=m.URI.file(C.$mc(g(v))).path:(a=C.$gc.dirname(v.path),v.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),a="/")),v.with({path:a})}normalizePath(v){if(!v.path.length)return v;let a;return v.scheme===T.Schemas.file?a=m.URI.file(C.$hc(g(v))).path:a=C.$gc.normalize(v.path),v.with({path:a})}relativePath(v,a){if(v.scheme!==a.scheme||!(0,e.$Hg)(v.authority,a.authority))return;if(v.scheme===T.Schemas.file){const n=C.$lc(g(v),g(a));return F.$i?E.$Wf(n):n}let s=v.path||"/";const t=a.path||"/";if(this.a(v)){let n=0;for(const o=Math.min(s.length,t.length);n<o&&!(s.charCodeAt(n)!==t.charCodeAt(n)&&s.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);s=t.substr(0,n)+s.substr(n)}return C.$gc.relative(s,t)}resolvePath(v,a){if(v.scheme===T.Schemas.file){const s=m.URI.file(C.$kc(g(v),a));return v.with({authority:s.authority,path:s.path})}return a=E.$Xf(a),v.with({path:C.$gc.resolve(v.path,a)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,a){return v===a||v!==void 0&&a!==void 0&&(0,R.$7e)(v,a)}hasTrailingPathSeparator(v,a=C.sep){if(v.scheme===T.Schemas.file){const s=g(v);return s.length>E.$Yf(s).length&&s[s.length-1]===a}else{const s=v.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,a=C.sep){return(0,e.$Ig)(v,a)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,a=C.sep){let s=!1;if(v.scheme===T.Schemas.file){const t=g(v);s=t!==void 0&&t.length===E.$Yf(t).length&&t[t.length-1]===a}else{a="/";const t=v.path;s=t.length===1&&t.charCodeAt(t.length-1)===47}return!s&&!(0,e.$Ig)(v,a)?v.with({path:v.path+"/"}):v}}e.$rg=w,e.$sg=new w(()=>!1),e.$tg=new w($=>$.scheme===T.Schemas.file?!F.$k:!0),e.$ug=new w($=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function A($,v){const a=[];for(let s=0;s<$.length;s++){const t=v($[s]);$.some((n,o)=>o===s?!1:(0,e.$wg)(t,v(n)))||a.push($[s])}return a}e.$Lg=A;var k;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function v(a){const s=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,h]=o.split(":");c&&h&&s.set(c,h)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&s.set($.META_DATA_MIME,n),s}$.parseMetaData=v})(k||(e.DataUri=k={}));function l($,v,a){if(v){let s=$.path;return s&&s[0]!==C.$gc.sep&&(s=C.$gc.sep+s),$.with({scheme:a,authority:v,path:s})}return $.with({scheme:a})}e.$Mg=l}),define(Pe[14],Ae([1,0,20,11,5,6,25,21,124,39]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function A(le){return!!le&&typeof le.then=="function"}e.$Ng=A;function k(le){const ie=new E.$3d,G=le(ie.token),te=new Promise((x,se)=>{const de=ie.token.onCancellationRequested(()=>{de.dispose(),ie.dispose(),se(new T.$5)});Promise.resolve(G).then(De=>{de.dispose(),ie.dispose(),x(De)},De=>{de.dispose(),ie.dispose(),se(De)})});return new class{cancel(){ie.cancel()}then(x,se){return te.then(x,se)}catch(x){return this.then(void 0,x)}finally(x){return te.finally(x)}}}e.$Og=k;function l(le,ie,G){return new Promise((te,x)=>{const se=ie.onCancellationRequested(()=>{se.dispose(),te(G)});le.then(te,x).finally(()=>se.dispose())})}e.$Pg=l;function $(le,ie){return new Promise((G,te)=>{const x=ie.onCancellationRequested(()=>{x.dispose(),te(new T.$5)});le.then(G,te).finally(()=>x.dispose())})}e.$Qg=$;async function v(le){let ie=-1;const G=le.map((te,x)=>te.then(se=>(ie=x,se)));try{return await Promise.race(G)}finally{le.forEach((te,x)=>{x!==ie&&te.cancel()})}}e.$Rg=v;function a(le,ie,G){let te;const x=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([le.finally(()=>clearTimeout(x)),new Promise(se=>te=se)])}e.$Sg=a;function s(le){return new Promise((ie,G)=>{const te=le();A(te)?te.then(ie,G):ie(te)})}e.$Tg=s;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(x=>{this.a=null,G(x)},x=>{this.a=null,te(x)})})}dispose(){this.f=!0}}e.$Ug=t;class n{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Vg=n;class o{constructor(){this.a=new Map}queue(ie,G){const x=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===x&&this.a.delete(ie)});return this.a.set(ie,x),x}}e.$Wg=o;const c=(le,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},le);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},h=le=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,le())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((x,se)=>{this.d=x,this.f=se}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===g.$Pd?h(te):c(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=i;class r{constructor(ie){this.a=new i(ie),this.b=new t}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=r;class u{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=u;class d extends u{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$1g=d;function b(le,ie){return ie?new Promise((G,te)=>{const x=setTimeout(()=>{se.dispose(),G()},le),se=ie.onCancellationRequested(()=>{clearTimeout(x),se.dispose(),te(new T.$5)})}):k(G=>b(le,G))}e.$2g=b;function f(le,ie=0,G){const te=setTimeout(()=>{le(),G&&x.dispose()},ie),x=(0,F.$Qc)(()=>{clearTimeout(te),G?.deleteAndLeak(x)});return G?.add(x),x}e.$3g=f;function D(le){const ie=[];let G=0;const te=le.length;function x(){return G<te?le[G++]():null}function se(de){de!=null&&ie.push(de);const De=x();return De?De.then(se):Promise.resolve(ie)}return Promise.resolve(null).then(se)}e.$4g=D;function L(le,ie=te=>!!te,G=null){let te=0;const x=le.length,se=()=>{if(te>=x)return Promise.resolve(G);const de=le[te++];return Promise.resolve(de()).then(Le=>ie(Le)?Promise.resolve(Le):se())};return se()}e.$5g=L;function p(le,ie=te=>!!te,G=null){if(le.length===0)return Promise.resolve(G);let te=le.length;const x=()=>{te=-1;for(const se of le)se.cancel?.()};return new Promise((se,de)=>{for(const De of le)De.then(Le=>{--te>=0&&ie(Le)?(x(),se(Le)):te===0&&se(G)}).catch(Le=>{--te>=0&&(x(),de(Le))})})}e.$6g=p;class y{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new C.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=y;class S extends y{constructor(){super(1)}}e.$8g=S;class N{constructor(){this.a=new ke,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$9g=N;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new ne;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=R.$sg){const te=G.getComparisonKey(ie);let x=this.a.get(te);if(!x){x=new S;const se=this.f++,de=C.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(se),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$2c),this.d.set(se,de),this.a.set(te,x)}return x}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=q;class j{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$$g=j;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const x=te.setInterval(()=>{ie()},G);this.d=(0,F.$Qc)(()=>{te.clearInterval(x),this.d=void 0})}dispose(){this.cancel()}}e.$_g=M;class U{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=U;class P{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=P;class I extends U{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$ch=I;class Z extends F.$Sc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new F.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(le,ie)=>{(0,m.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$fh=(le,ie,G)=>{const te=le.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let x=!1;return{dispose(){x||(x=!0,le.cancelIdleCallback(te))}}},e.$eh=le=>(0,e.$fh)(globalThis,le)}();class ue{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$fh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=ue;class ge extends ue{constructor(ie){super(globalThis,ie)}}e.$hh=ge;async function be(le,ie,G){let te;for(let x=0;x<G;x++)try{return await le()}catch(se){te=se,await b(ie)}throw te}e.$ih=be;class ke{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const x=new Promise((se,de)=>{G=se,te=de});this.b={run:ie,promise:x,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=ke;class me{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$kh=me;var fe;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(fe||(fe={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new T.$5)}}e.$lh=ne;var Se;(function(le){async function ie(te){let x;const se=await Promise.all(te.map(de=>de.then(De=>De,De=>{x||(x=De)})));if(typeof x<"u")throw x;return se}le.settled=ie;function G(te){return new Promise(async(x,se)=>{try{await te(x,se)}catch(de){se(de)}})}le.withAsyncBody=G})(Se||(e.Promises=Se={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=ce;class X{constructor(ie){this.b=ie,this.a=new w.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=X;var V;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(V||(V={}));class re{static fromArray(ie){return new re(G=>{G.emitMany(ie)})}static fromPromise(ie){return new re(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new re(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new re(async G=>{await Promise.all(ie.map(async te=>{for await(const x of te)G.emitOne(x)}))})}static{this.EMPTY=re.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new C.$Sd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new re(async te=>{for await(const x of ie)te.emitOne(G(x))})}map(ie){return re.map(this,ie)}static filter(ie,G){return new re(async te=>{for await(const x of ie)G(x)&&te.emitOne(x)})}filter(ie){return re.filter(this,ie)}static coalesce(ie){return re.filter(ie,G=>!!G)}coalesce(){return re.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return re.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$oh=re;class Ie extends re{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$ph=Ie;function Re(le){const ie=new E.$3d,G=le(ie.token);return new Ie(ie,async te=>{const x=ie.token.onCancellationRequested(()=>{x.dispose(),ie.dispose(),te.reject(new T.$5)});try{for await(const se of G){if(ie.token.isCancellationRequested)return;te.emitOne(se)}x.dispose(),ie.dispose()}catch(se){x.dispose(),ie.dispose(),te.reject(se)}})}e.$qh=Re;class Ce{constructor(){this.a=new ne,this.b=new re(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=x=>te.reject(x),this.f=x=>te.emitOne(x),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$rh=Ce}),define(Pe[34],Ae([1,0,18,14,46,28,19,21,12]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;function w(){return Object.create(null)}e.$Cj=w,e.$Dj="**",e.$Ej="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function $(ge,be){switch(ge){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${be?`|${A}${k}+`:""})*?`}}function v(ge,be){if(!ge)return[];const ke=[];let me=!1,fe=!1,ne="";for(const Se of ge){switch(Se){case be:if(!me&&!fe){ke.push(ne),ne="";continue}break;case"{":me=!0;break;case"}":me=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ne+=Se}return ne&&ke.push(ne),ke}e.$Fj=v;function a(ge){if(!ge)return"";let be="";const ke=v(ge,e.$Ej);if(ke.every(me=>me===e.$Dj))be=".*";else{let me=!1;ke.forEach((fe,ne)=>{if(fe===e.$Dj){if(me)return;be+=$(2,ne===ke.length-1)}else{let Se=!1,ce="",X=!1,V="";for(const re of fe){if(re!=="}"&&Se){ce+=re;continue}if(X&&(re!=="]"||!V)){let Ie;re==="-"?Ie=re:(re==="^"||re==="!")&&!V?Ie="^":re===e.$Ej?Ie="":Ie=(0,g.$Ke)(re),V+=Ie;continue}switch(re){case"{":Se=!0;continue;case"[":X=!0;continue;case"}":{const Re=`(?:${v(ce,",").map(Ce=>a(Ce)).join("|")})`;be+=Re,Se=!1,ce="";break}case"]":{be+="["+V+"]",X=!1,V="";break}case"?":be+=k;continue;case"*":be+=$(1);continue;default:be+=(0,g.$Ke)(re)}}ne<ke.length-1&&(ke[ne+1]!==e.$Dj||ne+2<ke.length)&&(be+=A)}me=fe===e.$Dj})}return be}const s=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.$Dc(1e4),r=function(){return!1},u=function(){return null};function d(ge,be){if(!ge)return u;let ke;typeof ge!="string"?ke=ge.pattern:ke=ge,ke=ke.trim();const me=`${ke}_${!!be.trimForExclusions}`;let fe=i.get(me);if(fe)return b(fe,ge);let ne;return s.test(ke)?fe=D(ke.substr(4),ke):(ne=t.exec(f(ke,be)))?fe=L(ne[1],ke):(be.trimForExclusions?o:n).test(ke)?fe=p(ke,be):(ne=c.exec(f(ke,be)))?fe=y(ne[1].substr(1),ke,!0):(ne=h.exec(f(ke,be)))?fe=y(ne[1],ke,!1):fe=S(ke),i.set(me,fe),b(fe,ge)}function b(ge,be){if(typeof be=="string")return ge;const ke=function(me,fe){return(0,C.$3f)(me,be.base,!m.$k)?ge((0,g.$Oe)(me.substr(be.base.length),R.sep),fe):null};return ke.allBasenames=ge.allBasenames,ke.allPaths=ge.allPaths,ke.basenames=ge.basenames,ke.patterns=ge.patterns,ke}function f(ge,be){return be.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function D(ge,be){return function(ke,me){return typeof ke=="string"&&ke.endsWith(ge)?be:null}}function L(ge,be){const ke=`/${ge}`,me=`\\${ge}`,fe=function(Se,ce){return typeof Se!="string"?null:ce?ce===ge?be:null:Se===ge||Se.endsWith(ke)||Se.endsWith(me)?be:null},ne=[ge];return fe.basenames=ne,fe.patterns=[be],fe.allBasenames=ne,fe}function p(ge,be){const ke=Z(ge.slice(1,-1).split(",").map(ce=>d(ce,be)).filter(ce=>ce!==u),ge),me=ke.length;if(!me)return u;if(me===1)return ke[0];const fe=function(ce,X){for(let V=0,re=ke.length;V<re;V++)if(ke[V](ce,X))return ge;return null},ne=ke.find(ce=>!!ce.allBasenames);ne&&(fe.allBasenames=ne.allBasenames);const Se=ke.reduce((ce,X)=>X.allPaths?ce.concat(X.allPaths):ce,[]);return Se.length&&(fe.allPaths=Se),fe}function y(ge,be,ke){const me=R.sep===R.$gc.sep,fe=me?ge:ge.replace(l,R.sep),ne=R.sep+fe,Se=R.$gc.sep+ge;let ce;return ke?ce=function(X,V){return typeof X=="string"&&(X===fe||X.endsWith(ne)||!me&&(X===ge||X.endsWith(Se)))?be:null}:ce=function(X,V){return typeof X=="string"&&(X===fe||!me&&X===ge)?be:null},ce.allPaths=[(ke?"*/":"./")+ge],ce}function S(ge){try{const be=new RegExp(`^${a(ge)}$`);return function(ke){return be.lastIndex=0,typeof ke=="string"&&be.test(ke)?ge:null}}catch{return u}}function N(ge,be,ke){return!ge||typeof be!="string"?!1:q(ge)(be,void 0,ke)}e.$Gj=N;function q(ge,be={}){if(!ge)return r;if(typeof ge=="string"||j(ge)){const ke=d(ge,be);if(ke===u)return r;const me=function(fe,ne){return!!ke(fe,ne)};return ke.allBasenames&&(me.allBasenames=ke.allBasenames),ke.allPaths&&(me.allPaths=ke.allPaths),me}return P(ge,be)}e.$Hj=q;function j(ge){const be=ge;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}e.$Ij=j;function M(ge){return ge.allBasenames||[]}e.$Jj=M;function U(ge){return ge.allPaths||[]}e.$Kj=U;function P(ge,be){const ke=Z(Object.getOwnPropertyNames(ge).map(ce=>I(ce,ge[ce],be)).filter(ce=>ce!==u)),me=ke.length;if(!me)return u;if(!ke.some(ce=>!!ce.requiresSiblings)){if(me===1)return ke[0];const ce=function(re,Ie){let Re;for(let Ce=0,le=ke.length;Ce<le;Ce++){const ie=ke[Ce](re,Ie);if(typeof ie=="string")return ie;(0,T.$Ng)(ie)&&(Re||(Re=[]),Re.push(ie))}return Re?(async()=>{for(const Ce of Re){const le=await Ce;if(typeof le=="string")return le}return null})():null},X=ke.find(re=>!!re.allBasenames);X&&(ce.allBasenames=X.allBasenames);const V=ke.reduce((re,Ie)=>Ie.allPaths?re.concat(Ie.allPaths):re,[]);return V.length&&(ce.allPaths=V),ce}const fe=function(ce,X,V){let re,Ie;for(let Re=0,Ce=ke.length;Re<Ce;Re++){const le=ke[Re];le.requiresSiblings&&V&&(X||(X=(0,R.$nc)(ce)),re||(re=X.substr(0,X.length-(0,R.$oc)(ce).length)));const ie=le(ce,X,re,V);if(typeof ie=="string")return ie;(0,T.$Ng)(ie)&&(Ie||(Ie=[]),Ie.push(ie))}return Ie?(async()=>{for(const Re of Ie){const Ce=await Re;if(typeof Ce=="string")return Ce}return null})():null},ne=ke.find(ce=>!!ce.allBasenames);ne&&(fe.allBasenames=ne.allBasenames);const Se=ke.reduce((ce,X)=>X.allPaths?ce.concat(X.allPaths):ce,[]);return Se.length&&(fe.allPaths=Se),fe}function I(ge,be,ke){if(be===!1)return u;const me=d(ge,ke);if(me===u)return u;if(typeof be=="boolean")return me;if(be){const fe=be.when;if(typeof fe=="string"){const ne=(Se,ce,X,V)=>{if(!V||!me(Se,ce))return null;const re=fe.replace("$(basename)",()=>X),Ie=V(re);return(0,T.$Ng)(Ie)?Ie.then(Re=>Re?ge:null):Ie?ge:null};return ne.requiresSiblings=!0,ne}}return me}function Z(ge,be){const ke=ge.filter(ce=>!!ce.basenames);if(ke.length<2)return ge;const me=ke.reduce((ce,X)=>{const V=X.basenames;return V?ce.concat(V):ce},[]);let fe;if(be){fe=[];for(let ce=0,X=me.length;ce<X;ce++)fe.push(be)}else fe=ke.reduce((ce,X)=>{const V=X.patterns;return V?ce.concat(V):ce},[]);const ne=function(ce,X){if(typeof ce!="string")return null;if(!X){let re;for(re=ce.length;re>0;re--){const Ie=ce.charCodeAt(re-1);if(Ie===47||Ie===92)break}X=ce.substr(re)}const V=me.indexOf(X);return V!==-1?fe[V]:null};ne.basenames=me,ne.patterns=fe,ne.allBasenames=me;const Se=ge.filter(ce=>!ce.basenames);return Se.push(ne),Se}function ue(ge,be){return(0,E.$ub)(ge,be,(ke,me)=>typeof ke=="string"&&typeof me=="string"?ke===me:typeof ke!="string"&&typeof me!="string"?ke.base===me.base&&ke.pattern===me.pattern:!1)}e.$Lj=ue}),define(Pe[52],Ae([1,0,11,125,25,12,2]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(t="",n=!1){if(this.value=t,typeof this.value!="string")throw(0,E.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(t,n=0){return this.value+=l(this.supportThemeIcons?(0,T.$8j)(t):t).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,n){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(t,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(t),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(t,n){const o=new RegExp((0,F.$Ke)(n),"g");return t.replace(o,(c,h)=>t.charAt(h-1)!=="\\"?`\\${c}`:c)}}e.$bk=g;function w(s){return A(s)?!s.value:Array.isArray(s)?s.every(w):!0}e.$ck=w;function A(s){return s instanceof g?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$dk=A;function k(s,t){return s===t?!0:!s||!t?!1:s.value===t.value&&s.isTrusted===t.isTrusted&&s.supportThemeIcons===t.supportThemeIcons&&s.supportHtml===t.supportHtml&&(s.baseUri===t.baseUri||!!s.baseUri&&!!t.baseUri&&(0,C.$vg)(R.URI.from(s.baseUri),R.URI.from(t.baseUri)))}e.$ek=k;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$fk=l;function $(s){return s.replace(/"/g,"&quot;")}e.$gk=$;function v(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$hk=v;function a(s){const t=[],n=s.split("|").map(c=>c.trim());s=n[0];const o=n[1];if(o){const c=/height=(\d+)/.exec(o),h=/width=(\d+)/.exec(o),i=c?c[1]:"",r=h?h[1]:"",u=isFinite(parseInt(r)),d=isFinite(parseInt(i));u&&t.push(`width="${r}"`),d&&t.push(`height="${i}"`)}return{href:s,dimensions:t}}e.$ik=a}),define(Pe[95],Ae([1,0,18,46,19,21,25,12]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=void 0;function g(d,b){const{os:f,tildify:D,relative:L}=b;if(L){const S=w(d,L,f);if(typeof S=="string")return S}let p=d.fsPath;if(f===1&&!F.$i?p=p.replace(/\//g,"\\"):f!==1&&F.$i&&(p=p.replace(/\\/g,"/")),f!==1&&D?.userHome){const S=D.userHome.fsPath;let N;d.scheme!==D.userHome.scheme&&d.path[0]===C.$gc.sep&&d.path[1]!==C.$gc.sep?N=D.userHome.with({path:d.path}).fsPath:N=p,p=l(N,S,f)}return(f===1?C.$fc:C.$gc).normalize(A(p,f===1))}e.$Ev=g;function w(d,b,f){const D=f===1?C.$fc:C.$gc,L=f===3?R.$sg:R.$ug,p=b.getWorkspace(),y=(0,E.$Ob)(p.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===C.$gc.sep&&d.path[1]!==C.$gc.sep&&(d=y.uri.with({path:d.path}));const S=b.getWorkspaceFolder(d);if(!S)return;let N;if(L.isEqual(S.uri,d)?N="":N=L.relativePath(S.uri,d)??"",N&&(N=D.normalize(N)),p.folders.length>1&&!b.noPrefix){const q=S.name?S.name:L.basenameOrAuthority(S.uri);N=N?`${q} \u2022 ${N}`:q}return N}function A(d,b=F.$i){return(0,T.$7f)(d,b)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Fv=A;let k=Object.create(null);function l(d,b,f=F.OS){if(f===1||!d||!b)return d;let D=k.original===b?k.normalized:void 0;D||(D=b,F.$i&&(D=(0,T.$Wf)(D)),D=`${(0,m.$Pe)(D,C.$gc.sep)}${C.$gc.sep}`,k={original:b,normalized:D});let L=d;return F.$i&&(L=(0,T.$Wf)(L)),(f===3?L.startsWith(D):(0,m.$8e)(L,D))?`~/${L.substr(D.length)}`:d}e.$Gv=l;function $(d,b){return d.replace(/^~($|\/|\\)/,`${b}$1`)}e.$Hv=$;const v="\u2026",a="\\\\",s="~";function t(d,b=C.sep){const f=new Array(d.length);let D=!1;for(let L=0;L<d.length;L++){const p=d[L];if(p===""){f[L]=`.${b}`;continue}if(!p){f[L]=p;continue}D=!0;let y="",S=p;S.indexOf(a)===0?(y=S.substr(0,S.indexOf(a)+a.length),S=S.substr(S.indexOf(a)+a.length)):S.indexOf(b)===0?(y=S.substr(0,S.indexOf(b)+b.length),S=S.substr(S.indexOf(b)+b.length)):S.indexOf(s)===0&&(y=S.substr(0,S.indexOf(s)+s.length),S=S.substr(S.indexOf(s)+s.length));const N=S.split(b);for(let q=1;D&&q<=N.length;q++)for(let j=N.length-q;D&&j>=0;j--){D=!1;let M=N.slice(j,j+q).join(b);for(let U=0;!D&&U<d.length;U++)if(U!==L&&d[U]&&d[U].indexOf(M)>-1){const P=j+q===N.length,I=j>0&&d[U].indexOf(b)>-1?b+M:M,Z=d[U].endsWith(I);D=!P||Z}if(!D){let U="";(N[0].endsWith(":")||y!=="")&&(j===1&&(j=0,q++,M=N[0]+b+M),j>0&&(U=N[0]+b),U=y+U),j>0&&(U=U+v+b),U=U+M,j+q<N.length&&(U=U+b+v),f[L]=U}}D&&(f[L]=p)}return f}e.$Iv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(d,b=Object.create(null)){const f=[];let D=!1,L="";for(const p of d)if(p==="$"||D&&p==="{")L&&f.push({value:L,type:n.TEXT}),L="",D=!0;else if(p==="}"&&D){const y=b[L];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const S=f[f.length-1];(!S||S.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}L="",D=!1}else L+=p;return L&&!D&&f.push({value:L,type:n.TEXT}),f.filter((p,y)=>{if(p.type===n.SEPARATOR){const S=f[y-1],N=f[y+1];return[S,N].every(q=>q&&(q.type===n.VARIABLE||q.type===n.TEXT)&&q.value.length>0)}return!0}).map(p=>p.value).join("")}e.$Jv=o;function c(d,b){return F.$j||b?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Kv=c;function h(d,b){return F.$j||b?d.replace(/\(&&\w\)|&&/g,""):F.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Lv=h;function i(d){return d.replace(/&/g,"&&")}e.$Mv=i;function r(d){if(d.endsWith("]")){const b=d.lastIndexOf(" [",d.length-2);if(b!==-1){const f=u(d.substring(0,b));return{name:f.name,parentPath:f.parentPath+d.substring(b)}}}return u(d)}e.$Nv=r;function u(d){const b=d.indexOf("/")!==-1?C.$gc:C.$fc,f=b.basename(d),D=b.dirname(d);return f.length?{name:f,parentPath:D}:{name:D,parentPath:""}}}),define(Pe[138],Ae([1,0,24,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=void 0;function C(k){return k.toJSON()}class F{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:C(T.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:C(T.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:T.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Wm=F,e.$Xm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,$){if(!k||$>200)return null;if(typeof k=="object"){if(k instanceof T.URI)return l.transformOutgoing(k);for(const v in k)if(Object.hasOwnProperty.call(k,v)){const a=R(k[v],l,$+1);a!==null&&(k[v]=a)}}return null}function m(k,l){const $=R(k,l,0);return $===null?k:$}e.$Ym=m;function g(k,l,$,v){if(!k||v>200)return null;if(typeof k=="object"){if(k.$mid===1)return $?T.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof E.$ge)return null;for(const a in k)if(Object.hasOwnProperty.call(k,a)){const s=g(k[a],l,$,v+1);s!==null&&(k[a]=s)}}return null}function w(k,l){const $=g(k,l,!1,0);return $===null?k:$}e.$Zm=w;function A(k,l){const $=g(k,l,!0,0);return $===null?k:$}e.$1m=A}),define(Pe[139],Ae([1,0,12,21,24]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.$Ws=void 0;let F;function R(){return F||(F=new TextDecoder("UTF-16LE")),F}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function A(){return w||(w=T.$D()?R():g()),w}e.$Ws=A;function k(v,a,s){const t=new Uint16Array(v.buffer,a,s);return s>0&&(t[0]===65279||t[0]===65534)?l(v,a,s):R().decode(t)}e.$Xs=k;function l(v,a,s){const t=[];let n=0;for(let o=0;o<s;o++){const c=C.$ie(v,a);a+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class ${constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const s=this.a-this.d;s<=1&&(s===0||E.$$e(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const s=a.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=a;return}for(let t=0;t<s;t++)this.b[this.d++]=a.charCodeAt(t)}}e.$Ys=$}),define(Pe[140],Ae([1,0,24,139]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=void 0;function C(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,k,l){this.oldPosition=w,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,k){const l=A.length;E.$le(w,l,k),k+=4;for(let $=0;$<l;$++)E.$je(w,A.charCodeAt($),k),k+=2;return k}static d(w,A){const k=E.$ke(w,A);return A+=4,(0,T.$Xs)(w,A,k)}writeSize(){return 4+4+F.a(this.oldText)+F.a(this.newText)}write(w,A){return E.$le(w,this.oldPosition,A),A+=4,E.$le(w,this.newPosition,A),A+=4,A=F.c(w,this.oldText,A),A=F.c(w,this.newText,A),A}static read(w,A,k){const l=E.$ke(w,A);A+=4;const $=E.$ke(w,A);A+=4;const v=F.d(w,A);A+=F.a(v);const a=F.d(w,A);return A+=F.a(a),k.push(new F(l,v,$,a)),A}}e.$Zs=F;function R(g,w){return g===null||g.length===0?w:new m(g,w).compress()}e.$1s=R;class m{constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,k=this.n(w),l=this.l(A);for(;w<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++w);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++w);continue}if(l.oldPosition<k.newPosition){const[t,n]=m.r(l,k.newPosition-l.oldPosition);this.k(t),l=n;continue}if(k.newPosition<l.oldPosition){const[t,n]=m.q(k,l.oldPosition-k.newPosition);this.m(t),k=n;continue}let a,s;if(l.oldEnd===k.newEnd)a=k,s=l,k=this.n(++w),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[t,n]=m.q(k,l.oldLength);a=t,s=l,k=n,l=this.l(++A)}else{const[t,n]=m.r(l,k.newLength);a=k,s=t,k=this.n(++w),l=n}this.d[this.e++]=new F(a.oldPosition,a.oldText,s.newPosition,s.newText),this.g+=a.newLength-a.oldLength,this.j+=s.newLength-s.oldLength}const $=m.s(this.d);return m.t($)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new F(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new F(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const k=w.newText.substr(0,A),l=w.newText.substr(A);return[new F(w.oldPosition,w.oldText,w.newPosition,k),new F(w.oldEnd,"",w.newPosition+A,l)]}static r(w,A){const k=w.oldText.substr(0,A),l=w.oldText.substr(A);return[new F(w.oldPosition,k,w.newPosition,w.newText),new F(w.oldPosition+A,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let k=0,l=w[0];for(let $=1;$<w.length;$++){const v=w[$];l.oldEnd===v.oldPosition?l=new F(l.oldPosition,l.oldText+v.oldText,l.newPosition,l.newText+v.newText):(A[k++]=l,l=v)}return A[k++]=l,A}static t(w){if(w.length===0)return w;const A=[];let k=0;for(let l=0;l<w.length;l++){const $=w[l];$.oldText!==$.newText&&(A[k++]=$)}return A}}}),define(Pe[141],Ae([1,0,34,19]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0;function C(F,R,m,g,w,A){if(Array.isArray(F)){let k=0;for(const l of F){const $=C(l,R,m,g,w,A);if($===10)return $;$>k&&(k=$)}return k}else{if(typeof F=="string")return g?F==="*"?5:F===m?10:0:0;if(F){const{language:k,pattern:l,scheme:$,hasAccessToAllModels:v,notebookType:a}=F;if(!g&&!v)return 0;a&&w&&(R=w);let s=0;if($)if($===R.scheme)s=10;else if($==="*")s=5;else return 0;if(k)if(k===m)s=10;else if(k==="*")s=Math.max(s,5);else return 0;if(a)if(a===A)s=10;else if(a==="*"&&A!==void 0)s=Math.max(s,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$hc)(l.base)},t===R.fsPath||(0,E.$Gj)(t,R.fsPath))s=10;else return 0}return s}else return 0}}e.$lt=C}),define(Pe[142],Ae([1,0,5,12,29,93,91,127,140,6]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=void 0;class A extends w.$Sc{constructor(l,$,v,a,s,t,n){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!t,this.g=a,this.h=s,this.c=new R.$RB(l,v,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const v=l+$,a=this.getPositionAt(l),s=this.getPositionAt(v);return new C.$Es(a.lineNumber,a.column,s.lineNumber,s.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const v=this.n($);return this.c.getValueInRange(l,v)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const v=this.getOffsetAt(l.startLineNumber,l.startColumn),a=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const t=this.n($),n=this.getEOL();if(t.length!==n.length){const o=t.length-n.length,c=l.endLineNumber-l.startLineNumber;s=o*c}return a-v+s}getCharacterCountInRange(l,$=0){if(this.j){let v=0;const a=l.startLineNumber,s=l.endLineNumber;for(let t=a;t<=s;t++){const n=this.getLineContent(t),o=t===a?l.startColumn-1:0,c=t===s?l.endColumn-1:n.length;for(let h=o;h<c;h++)T.$$e(n.charCodeAt(h))?(v=v+1,h=h+1):v=v+1}return v+=this.n($).length*(s-a),v}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=T.$Ve(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=T.$Xe(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,v){let a=this.g,s=this.h,t=this.j,n=!0,o=[];for(let b=0;b<l.length;b++){const f=l[b];n&&f._isTracked&&(n=!1);const D=f.range;if(f.text){let N=!0;t||(N=!T.$jf(f.text),t=N),!a&&N&&(a=T.$if(f.text)),!s&&N&&(s=T.$lf(f.text))}let L="",p=0,y=0,S=0;if(f.text){let N;[p,y,S,N]=(0,m.$et)(f.text);const q=this.getEOL();N===0||N===(q===`\r
`?2:1)?L=f.text:L=f.text.replace(/\r\n|\r|\n/g,q)}o[b]={sortIndex:b,identifier:f.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:L,eolCount:p,firstLineLength:y,lastLineLength:S,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}o.sort(A.u);let c=!1;for(let b=0,f=o.length-1;b<f;b++){const D=o[b].range.getEndPosition(),L=o[b+1].range.getStartPosition();if(L.isBeforeOrEqual(D)){if(L.isBefore(D))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const h=v||$?A._getInverseEditRanges(o):[],i=[];if($)for(let b=0;b<o.length;b++){const f=o[b],D=h[b];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let L=D.startLineNumber;L<=D.endLineNumber;L++){let p="";L===D.startLineNumber&&(p=this.getLineContent(f.range.startLineNumber),T.$Ve(p)!==-1)||i.push({lineNumber:L,oldContent:p})}}let r=null;if(v){let b=0;r=[];for(let f=0;f<o.length;f++){const D=o[f],L=h[f],p=this.getValueInRange(D.range),y=D.rangeOffset+b;b+=D.text.length-p.length,r[f]={sortIndex:D.sortIndex,identifier:D.identifier,range:L,text:p,textChange:new g.$Zs(D.rangeOffset,p,y,D.text)}}c||r.sort((f,D)=>f.sortIndex-D.sortIndex)}this.g=a,this.h=s,this.j=t;const u=this.t(o);let d=null;if($&&i.length>0){i.sort((b,f)=>f.lineNumber-b.lineNumber),d=[];for(let b=0,f=i.length;b<f;b++){const D=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===D)continue;const L=i[b].oldContent,p=this.getLineContent(D);p.length===0||p===L||T.$Ve(p)!==-1||d.push(D)}}return this.m.fire(),new F.$1u(r,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const v=l[0].range,a=l[l.length-1].range,s=new C.$Es(v.startLineNumber,v.startColumn,a.endLineNumber,a.endColumn);let t=v.startLineNumber,n=v.startColumn;const o=[];for(let u=0,d=l.length;u<d;u++){const b=l[u],f=b.range;$=$||b.forceMoveMarkers,o.push(this.getValueInRange(new C.$Es(t,n,f.startLineNumber,f.startColumn))),b.text.length>0&&o.push(b.text),t=f.endLineNumber,n=f.endColumn}const c=o.join(""),[h,i,r]=(0,m.$et)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:r,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const $=[];for(let v=0;v<l.length;v++){const a=l[v],s=a.range.startLineNumber,t=a.range.startColumn,n=a.range.endLineNumber,o=a.range.endColumn;if(s===n&&t===o&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const c=new C.$Es(s,t,n,o);$.push({range:c,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,v,a){return this.c.findMatchesLineByLine(l,$,v,a)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const v=l.startLineNumber,a=l.startColumn,[s,t,n]=(0,m.$et)($);let o;if($.length>0){const c=s+1;c===1?o=new C.$Es(v,a,v,a+t):o=new C.$Es(v,a,v+c-1,n+1)}else o=new C.$Es(v,a,v,a);return o}static _getInverseEditRanges(l){const $=[];let v=0,a=0,s=null;for(let t=0,n=l.length;t<n;t++){const o=l[t];let c,h;s?s.range.endLineNumber===o.range.startLineNumber?(c=v,h=a+(o.range.startColumn-s.range.endColumn)):(c=v+(o.range.startLineNumber-s.range.endLineNumber),h=o.range.startColumn):(c=o.range.startLineNumber,h=o.range.startColumn);let i;if(o.text.length>0){const r=o.eolCount+1;r===1?i=new C.$Es(c,h,c,h+o.firstLineLength):i=new C.$Es(c,h,c+r-1,o.lastLineLength+1)}else i=new C.$Es(c,h,c,h);v=i.endLineNumber,a=i.endColumn,$.push(i),s=o}return $}static u(l,$){const v=C.$Es.compareRangesUsingEnds(l.range,$.range);return v===0?l.sortIndex-$.sortIndex:v}static w(l,$){const v=C.$Es.compareRangesUsingEnds(l.range,$.range);return v===0?$.sortIndex-l.sortIndex:-v}}e.$SB=A}),define(Pe[143],Ae([1,0,12,91,142]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TB=void 0;class F{constructor(g,w,A,k,l,$,v,a,s){this.a=g,this.b=w,this.c=A,this.d=k,this.e=l,this.f=$,this.g=v,this.h=a,this.j=s}k(g){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?g===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(g){const w=this.k(g),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,$=A.length;l<$;l++){const v=A[l].buffer.replace(/\r\n|\r|\n/g,w),a=(0,T.$NB)(v);A[l]=new T.$QB(v,a)}const k=new C.$SB(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$rf(g)&&(this.b=E.$qf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$OB)(this.e,g);this.a.push(new T.$QB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$if(g)),this.k||(this.k=E.$lf(g)))}finish(g=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$NB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$TB=R}),define(Pe[96],Ae([1,0,24,21]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$=e.$_0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function F(k){for(let l=0,$=k.length;l<$;l+=4){const v=k[l+0],a=k[l+1],s=k[l+2],t=k[l+3];k[l+0]=t,k[l+1]=s,k[l+2]=a,k[l+3]=v}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return T.$D()||F(l),E.$ge.wrap(l)}function m(k){const l=k.buffer;if(T.$D()||F(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function g(k){const l=new Uint32Array(w(k));let $=0;if(l[$++]=k.id,k.type==="full")l[$++]=1,l[$++]=k.data.length,l.set(k.data,$),$+=k.data.length;else{l[$++]=2,l[$++]=k.deltas.length;for(const v of k.deltas)l[$++]=v.start,l[$++]=v.deleteCount,v.data?(l[$++]=v.data.length,l.set(v.data,$),$+=v.data.length):l[$++]=0}return R(l)}e.$_0=g;function w(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const $ of k.deltas)$.data&&(l+=$.data.length)}return l}function A(k){const l=m(k);let $=0;const v=l[$++];if(l[$++]===1){const n=l[$++],o=l.subarray($,$+n);return $+=n,{id:v,type:"full",data:o}}const s=l[$++],t=[];for(let n=0;n<s;n++){const o=l[$++],c=l[$++],h=l[$++];let i;h>0&&(i=l.subarray($,$+h),$+=h),t[n]={start:o,deleteCount:c,data:i}}return{id:v,type:"delta",deltas:t}}e.$a$=A}),define(Pe[144],Ae([9,10]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[145],Ae([1,0,18,26,21,128,146,144]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(Y,ve,Be,Ke){this.id=Y,this.name=ve,this.defaultValue=Be,this.schema=Ke}applyUpdate(Y,ve){return $(Y,ve)}compute(Y,ve,Be){return Be}}class l{constructor(Y,ve){this.newValue=Y,this.didChange=ve}}e.ApplyUpdateResult=l;function $(ee,Y){if(typeof ee!="object"||typeof Y!="object"||!ee||!Y)return new l(Y,ee!==Y);if(Array.isArray(ee)||Array.isArray(Y)){const Be=Array.isArray(ee)&&Array.isArray(Y)&&E.$ub(ee,Y);return new l(Y,!Be)}let ve=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const Ke=$(ee[Be],Y[Be]);Ke.didChange&&(ee[Be]=Ke.newValue,ve=!0)}return new l(ee,ve)}class v{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,ve){return $(Y,ve)}validate(Y){return this.defaultValue}}class a{constructor(Y,ve,Be,Ke){this.id=Y,this.name=ve,this.defaultValue=Be,this.schema=Ke}applyUpdate(Y,ve){return $(Y,ve)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,ve,Be){return Be}}function s(ee,Y){return typeof ee>"u"?Y:ee==="false"?!1:!!ee}e.boolean=s;class t extends a{constructor(Y,ve,Be,Ke=void 0){typeof Ke<"u"&&(Ke.type="boolean",Ke.default=Be),super(Y,ve,Be,Ke)}validate(Y){return s(Y,this.defaultValue)}}function n(ee,Y,ve,Be){if(typeof ee>"u")return Y;let Ke=parseInt(ee,10);return isNaN(Ke)?Y:(Ke=Math.max(ve,Ke),Ke=Math.min(Be,Ke),Ke|0)}e.clampedInt=n;class o extends a{static clampedInt(Y,ve,Be,Ke){return n(Y,ve,Be,Ke)}constructor(Y,ve,Be,Ke,xe,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Be,ot.minimum=Ke,ot.maximum=xe),super(Y,ve,Be,ot),this.minimum=Ke,this.maximum=xe}validate(Y){return o.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function c(ee,Y,ve,Be){if(typeof ee>"u")return Y;const Ke=h.float(ee,Y);return h.clamp(Ke,ve,Be)}e.clampedFloat=c;class h extends a{static clamp(Y,ve,Be){return Y<ve?ve:Y>Be?Be:Y}static float(Y,ve){if(typeof Y=="number")return Y;if(typeof Y>"u")return ve;const Be=parseFloat(Y);return isNaN(Be)?ve:Be}constructor(Y,ve,Be,Ke,xe){typeof xe<"u"&&(xe.type="number",xe.default=Be),super(Y,ve,Be,xe),this.validationFn=Ke}validate(Y){return this.validationFn(h.float(Y,this.defaultValue))}}class i extends a{static string(Y,ve){return typeof Y!="string"?ve:Y}constructor(Y,ve,Be,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.default=Be),super(Y,ve,Be,Ke)}validate(Y){return i.string(Y,this.defaultValue)}}function r(ee,Y,ve,Be){return typeof ee!="string"?Y:Be&&ee in Be?Be[ee]:ve.indexOf(ee)===-1?Y:ee}e.stringSet=r;class u extends a{constructor(Y,ve,Be,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ke,xe.default=Be),super(Y,ve,Be,xe),this.c=Ke}validate(Y){return r(Y,this.defaultValue,this.c)}}class d extends k{constructor(Y,ve,Be,Ke,xe,ot,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=xe,pt.default=Ke),super(Y,ve,Be,pt),this.c=xe,this.d=ot}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function b(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ve,Be){return Be===0?Y.accessibilitySupport:Be}}class D extends k{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{insertSpace:s(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function p(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function S(ee){switch(ee){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function N(ee){switch(ee){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class q extends v{constructor(){super(140)}compute(Y,ve,Be){const Ke=["monaco-editor"];return ve.get(39)&&Ke.push(ve.get(39)),Y.extraEditorClassName&&Ke.push(Y.extraEditorClassName),ve.get(73)==="default"?Ke.push("mouse-default"):ve.get(73)==="copy"&&Ke.push("mouse-copy"),ve.get(110)&&Ke.push("showUnused"),ve.get(138)&&Ke.push("showDeprecated"),Ke.join(" ")}}class j extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Y,ve,Be){return Be&&Y.emptySelectionClipboard}}class M extends k{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:m.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:m.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{cursorMoveOnType:s(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":r(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":r(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(ve.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?U.OFF:Y==="true"?U.ON:Y:Y?U.ON:U.OFF}}e.EditorFontLigatures=U;class P extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?P.OFF:Y==="true"?P.TRANSLATE:Y:Y?P.TRANSLATE:P.OFF}compute(Y,ve,Be){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class I extends v{constructor(){super(50)}compute(Y,ve,Be){return Y.fontInfo}}class Z extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Y){const ve=h.float(Y,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ve,6,100)}compute(Y,ve,Be){return Y.fontInfo.fontSize}}class ue extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ue.d,maximum:ue.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ue.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(o.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,ue.d,ue.e))}}class ge extends k{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{multiple:r(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??r(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??r(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??r(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??r(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??r(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends k{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:m.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),delay:o.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:s(ve.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(ve.above,this.defaultValue.above)}}}var ke;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class me extends v{constructor(){super(143)}compute(Y,ve,Be){return me.computeLayout(ve,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const ve=Y.height/Y.lineHeight,Be=Math.floor(Y.paddingTop/Y.lineHeight);let Ke=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Ke=Math.max(Ke,ve-1));const xe=(Be+Y.viewLineCount+Ke)/(Y.pixelRatio*Y.height),ot=Math.floor(Y.viewLineCount/xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ke,desiredRatio:xe,minimapLineCount:ot}}static c(Y,ve){const Be=Y.outerWidth,Ke=Y.outerHeight,xe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const ot=ve.stableMinimapLayoutInput,pt=ot&&Y.outerHeight===ot.outerHeight&&Y.lineHeight===ot.lineHeight&&Y.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&Y.pixelRatio===ot.pixelRatio&&Y.scrollBeyondLastLine===ot.scrollBeyondLastLine&&Y.paddingTop===ot.paddingTop&&Y.paddingBottom===ot.paddingBottom&&Y.minimap.enabled===ot.minimap.enabled&&Y.minimap.side===ot.minimap.side&&Y.minimap.size===ot.minimap.size&&Y.minimap.showSlider===ot.minimap.showSlider&&Y.minimap.renderCharacters===ot.minimap.renderCharacters&&Y.minimap.maxColumn===ot.minimap.maxColumn&&Y.minimap.scale===ot.minimap.scale&&Y.verticalScrollbarWidth===ot.verticalScrollbarWidth&&Y.isViewportWrapping===ot.isViewportWrapping,Oe=Y.lineHeight,At=Y.typicalHalfwidthCharacterWidth,Kt=Y.scrollBeyondLastLine,jt=Y.minimap.renderCharacters;let bt=xe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Vt=Y.minimap.maxColumn,Ut=Y.minimap.size,Ht=Y.minimap.side,Gt=Y.verticalScrollbarWidth,Rt=Y.viewLineCount,It=Y.remainingWidth,Ye=Y.isViewportWrapping,Jt=jt?2:3;let qt=Math.floor(xe*Ke);const ut=qt/xe;let gt=!1,Zt=!1,Ct=Jt*bt,St=bt/xe,dt=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:ft,extraLinesBeyondLastLine:Mt,desiredRatio:Ee,minimapLineCount:Me}=me.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Kt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Ke,lineHeight:Oe,pixelRatio:xe});if(Rt/Me>1)gt=!0,Zt=!0,bt=1,Ct=1,St=bt/xe;else{let H=!1,Fe=bt+1;if(Ut==="fit"){const Ue=Math.ceil((ft+Rt+Mt)*Ct);Ye&&pt&&It<=ve.stableFitRemainingWidth?(H=!0,Fe=ve.stableFitMaxMinimapScale):H=Ue>qt}if(Ut==="fill"||H){gt=!0;const Ue=bt;Ct=Math.min(Oe*xe,Math.max(1,Math.floor(1/Ee))),Ye&&pt&&It<=ve.stableFitRemainingWidth&&(Fe=ve.stableFitMaxMinimapScale),bt=Math.min(Fe,Math.max(1,Math.floor(Ct/Jt))),bt>Ue&&(dt=Math.min(2,bt/Ue)),St=bt/xe/dt,qt=Math.ceil(Math.max(Qt,ft+Rt+Mt)*Ct),Ye?(ve.stableMinimapLayoutInput=Y,ve.stableFitRemainingWidth=It,ve.stableFitMaxMinimapScale=bt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Ft=Math.floor(Vt*St),Nt=Math.min(Ft,Math.max(0,Math.floor((It-Gt-2)*St/(At+St)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(xe*Nt);const qe=yt/xe;yt=Math.floor(yt*dt);const Lt=jt?1:2,Bt=Ht==="left"?0:Be-Nt-Gt;return{renderMinimap:Lt,minimapLeft:Bt,minimapWidth:Nt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Zt,minimapScale:bt,minimapLineHeight:Ct,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:ut}}static computeLayout(Y,ve){const Be=ve.outerWidth|0,Ke=ve.outerHeight|0,xe=ve.lineHeight|0,ot=ve.lineNumbersDigitCount|0,pt=ve.typicalHalfwidthCharacterWidth,Oe=ve.maxDigitWidth,At=ve.pixelRatio,Kt=ve.viewLineCount,jt=Y.get(135),bt=jt==="inherit"?Y.get(134):jt,Vt=bt==="inherit"?Y.get(130):bt,Ut=Y.get(133),Ht=ve.isDominatedByLongLines,Gt=Y.get(57),Rt=Y.get(67).renderType!==0,It=Y.get(68),Ye=Y.get(104),Jt=Y.get(83),qt=Y.get(72),ut=Y.get(102),gt=ut.verticalScrollbarSize,Zt=ut.verticalHasArrows,Ct=ut.arrowSize,St=ut.horizontalScrollbarSize,dt=Y.get(43),Ft=Y.get(109)!=="never";let Nt=Y.get(65);dt&&Ft&&(Nt+=16);let yt=0;if(Rt){const We=Math.max(ot,It);yt=Math.round(We*Oe)}let qe=0;Gt&&(qe=xe*ve.glyphMarginDecorationLaneCount);let Lt=0,Bt=Lt+qe,Qt=Bt+yt,ft=Qt+Nt;const Mt=Be-qe-yt-Nt;let Ee=!1,Me=!1,$e=-1;bt==="inherit"&&Ht?(Ee=!0,Me=!0):Vt==="on"||Vt==="bounded"?Me=!0:Vt==="wordWrapColumn"&&($e=Ut);const H=me.c({outerWidth:Be,outerHeight:Ke,lineHeight:xe,typicalHalfwidthCharacterWidth:pt,pixelRatio:At,scrollBeyondLastLine:Ye,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:qt,verticalScrollbarWidth:gt,viewLineCount:Kt,remainingWidth:Mt,isViewportWrapping:Me},ve.memory||new A);H.renderMinimap!==0&&H.minimapLeft===0&&(Lt+=H.minimapWidth,Bt+=H.minimapWidth,Qt+=H.minimapWidth,ft+=H.minimapWidth);const Fe=Mt-H.minimapWidth,Ue=Math.max(1,Math.floor((Fe-gt-2)/pt)),Ze=Zt?Ct:0;return Me&&($e=Math.max(1,Ue),Vt==="bounded"&&($e=Math.min($e,Ut))),{width:Be,height:Ke,glyphMarginLeft:Lt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:Bt,lineNumbersWidth:yt,decorationsLeft:Qt,decorationsWidth:Nt,contentLeft:ft,contentWidth:Fe,minimap:H,viewportColumn:Ue,isWordWrapMinified:Ee,isViewportWrapping:Me,wrappingColumn:$e,verticalScrollbarWidth:gt,horizontalScrollbarHeight:St,overviewRuler:{top:Ze,width:gt,height:Ke-2*Ze,right:0}}}}e.EditorLayoutInfoComputer=me;class fe extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Y){return r(Y,"simple",["simple","advanced"])}compute(Y,ve,Be){return ve.get(2)===2?"advanced":Be}}class ne extends k{constructor(){const Y={enabled:!0};super(64,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:m.localize(50,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:s(Y.enabled,this.defaultValue.enabled)}}}class Se extends k{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:m.localize(54,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ce extends k{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:m.localize(62,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:r(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:s(ve.padding,this.defaultValue.padding)}}}class X extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):o.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,ve,Be){return Be<0?o.clampedInt(-Be*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class V extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>h.clamp(Y,0,150),{markdownDescription:m.localize(63,null)})}compute(Y,ve,Be){return Y.fontInfo.lineHeight}}class re extends k{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:Y.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:m.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),autohide:s(ve.autohide,this.defaultValue.autohide),size:r(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ve.side,this.defaultValue.side,["right","left"]),showSlider:r(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(ve.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ve.scale,1,1,3),maxColumn:o.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ie(ee){return ee==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Re extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{top:o.clampedInt(ve.top,0,0,1e3),bottom:o.clampedInt(ve.bottom,0,0,1e3)}}}class Ce extends k{constructor(){const Y={enabled:!0,cycle:!0};super(85,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:m.localize(78,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),cycle:s(ve.cycle,this.defaultValue.cycle)}}}class le extends v{constructor(){super(141)}compute(Y,ve,Be){return Y.pixelRatio}}class ie extends k{constructor(){const Y={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Y.strings,description:m.localize(82,null)},comments:{anyOf:ve,default:Y.comments,description:m.localize(83,null)},other:{anyOf:ve,default:Y.other,description:m.localize(84,null)}},default:Y,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const At=Y?"on":"off";return{comments:At,strings:At,other:At}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Ke}=Y,xe=["on","inline","off"];let ot,pt,Oe;return typeof ve=="boolean"?ot=ve?"on":"off":ot=r(ve,this.defaultValue.other,xe),typeof Be=="boolean"?pt=Be?"on":"off":pt=r(Be,this.defaultValue.comments,xe),typeof Ke=="boolean"?Oe=Ke?"on":"off":Oe=r(Ke,this.defaultValue.strings,xe),{other:ot,comments:pt,strings:Oe}}}var G;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(G||(e.RenderLineNumbersType=G={}));class te extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(Y){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(ve=4,Be=Y):Y==="interval"?ve=3:Y==="relative"?ve=2:Y==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function x(ee){const Y=ee.get(97);return Y==="editable"?ee.get(90):Y!=="on"}e.filterValidationDecorations=x;class se extends k{constructor(){const Y=[],ve={type:"number",description:m.localize(91,null)};super(101,"rulers",Y,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:Y,description:m.localize(93,null)})}validate(Y){if(Array.isArray(Y)){const ve=[];for(const Be of Y)if(typeof Be=="number")ve.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ke=Be;ve.push({column:o.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return ve.sort((Be,Ke)=>Be.column-Ke.column),ve}return this.defaultValue}}class de extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function De(ee,Y){if(typeof ee!="string")return Y;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class Le extends k{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:m.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:m.localize(105,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y,Be=o.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=o.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(ve.vertical,this.defaultValue.vertical),horizontal:De(ve.horizontal,this.defaultValue.horizontal),useShadows:s(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:o.clampedInt(ve.verticalSliderSize,Ke,0,1e3),scrollByPage:s(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends k{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:m.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:m.localize(112,null)}})}applyUpdate(Y,ve){let Be=!1;ve.allowedCharacters&&Y&&(T.$jn(Y.allowedCharacters,ve.allowedCharacters)||(Y={...Y,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&Y&&(T.$jn(Y.allowedLocales,ve.allowedLocales)||(Y={...Y,allowedLocales:ve.allowedLocales},Be=!0));const Ke=super.applyUpdate(Y,ve);return Be?new l(Ke.newValue,!0):Ke}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{nonBasicASCII:Q(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Q(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Q(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,ve){if(typeof Y!="object"||!Y)return ve;const Be={};for(const[Ke,xe]of Object.entries(Y))xe===!0&&(Be[Ke]=!0);return Be}}class K extends k{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:m.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(114,null),m.localize(115,null),m.localize(116,null)],description:m.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:m.localize(118,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),mode:r(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends k{constructor(){const Y={enabled:F.$bs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$bs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:m.localize(120,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class W extends k{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(121,null),m.localize(122,null),m.localize(123,null)],default:Y.bracketPairs,description:m.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:Y.bracketPairsHorizontal,description:m.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:m.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:m.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(131,null),m.localize(132,null),m.localize(133,null)],default:Y.highlightActiveIndentation,description:m.localize(134,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{bracketPairs:Q(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Q(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:Q(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Q(ee,Y,ve){const Be=ve.indexOf(ee);return Be===-1?Y:ve[Be]}class _ extends k{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(135,null),m.localize(136,null)],default:Y.insertMode,description:m.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:m.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:m.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:m.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(141,null),m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Y.selectionMode,markdownDescription:m.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:m.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:m.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:m.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:m.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:m.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{insertMode:r(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(ve.showIcons,this.defaultValue.showIcons),showStatusBar:s(ve.showStatusBar,this.defaultValue.showStatusBar),preview:s(ve.preview,this.defaultValue.preview),previewMode:r(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(ve.showMethods,this.defaultValue.showMethods),showFunctions:s(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:s(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(ve.showFields,this.defaultValue.showFields),showVariables:s(ve.showVariables,this.defaultValue.showVariables),showClasses:s(ve.showClasses,this.defaultValue.showClasses),showStructs:s(ve.showStructs,this.defaultValue.showStructs),showInterfaces:s(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:s(ve.showModules,this.defaultValue.showModules),showProperties:s(ve.showProperties,this.defaultValue.showProperties),showEvents:s(ve.showEvents,this.defaultValue.showEvents),showOperators:s(ve.showOperators,this.defaultValue.showOperators),showUnits:s(ve.showUnits,this.defaultValue.showUnits),showValues:s(ve.showValues,this.defaultValue.showValues),showConstants:s(ve.showConstants,this.defaultValue.showConstants),showEnums:s(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:s(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(ve.showKeywords,this.defaultValue.showKeywords),showWords:s(ve.showWords,this.defaultValue.showWords),showColors:s(ve.showColors,this.defaultValue.showColors),showFiles:s(ve.showFiles,this.defaultValue.showFiles),showReferences:s(ve.showReferences,this.defaultValue.showReferences),showFolders:s(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:s(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(ve.showSnippets,this.defaultValue.showSnippets),showUsers:s(ve.showUsers,this.defaultValue.showUsers),showIssues:s(ve.showIssues,this.defaultValue.showIssues)}}}class ye extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(184,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var ze;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(ze||(e.WrappingIndent=ze={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(185,null),m.localize(186,null),m.localize(187,null),m.localize(188,null)],description:m.localize(189,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,ve,Be){return ve.get(2)===2?0:Be}}class Je extends v{constructor(){super(144)}compute(Y,ve,Be){const Ke=ve.get(143);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}class Xe extends k{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(192,null),m.localize(193,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),showDropSelector:r(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends k{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:m.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:s(ve.enabled,this.defaultValue.enabled),showPasteSelector:r(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",_e="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?_e:C.$k?rt:nt,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var ct;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.letterSpacing=63]="letterSpacing",ee[ee.lightbulb=64]="lightbulb",ee[ee.lineDecorationsWidth=65]="lineDecorationsWidth",ee[ee.lineHeight=66]="lineHeight",ee[ee.lineNumbers=67]="lineNumbers",ee[ee.lineNumbersMinChars=68]="lineNumbersMinChars",ee[ee.linkedEditing=69]="linkedEditing",ee[ee.links=70]="links",ee[ee.matchBrackets=71]="matchBrackets",ee[ee.minimap=72]="minimap",ee[ee.mouseStyle=73]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=75]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=77]="multiCursorModifier",ee[ee.multiCursorPaste=78]="multiCursorPaste",ee[ee.multiCursorLimit=79]="multiCursorLimit",ee[ee.occurrencesHighlight=80]="occurrencesHighlight",ee[ee.overviewRulerBorder=81]="overviewRulerBorder",ee[ee.overviewRulerLanes=82]="overviewRulerLanes",ee[ee.padding=83]="padding",ee[ee.pasteAs=84]="pasteAs",ee[ee.parameterHints=85]="parameterHints",ee[ee.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=88]="quickSuggestions",ee[ee.quickSuggestionsDelay=89]="quickSuggestionsDelay",ee[ee.readOnly=90]="readOnly",ee[ee.readOnlyMessage=91]="readOnlyMessage",ee[ee.renameOnType=92]="renameOnType",ee[ee.renderControlCharacters=93]="renderControlCharacters",ee[ee.renderFinalNewline=94]="renderFinalNewline",ee[ee.renderLineHighlight=95]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=97]="renderValidationDecorations",ee[ee.renderWhitespace=98]="renderWhitespace",ee[ee.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ee[ee.roundedSelection=100]="roundedSelection",ee[ee.rulers=101]="rulers",ee[ee.scrollbar=102]="scrollbar",ee[ee.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=104]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=105]="scrollPredominantAxis",ee[ee.selectionClipboard=106]="selectionClipboard",ee[ee.selectionHighlight=107]="selectionHighlight",ee[ee.selectOnLineNumbers=108]="selectOnLineNumbers",ee[ee.showFoldingControls=109]="showFoldingControls",ee[ee.showUnused=110]="showUnused",ee[ee.snippetSuggestions=111]="snippetSuggestions",ee[ee.smartSelect=112]="smartSelect",ee[ee.smoothScrolling=113]="smoothScrolling",ee[ee.stickyScroll=114]="stickyScroll",ee[ee.stickyTabStops=115]="stickyTabStops",ee[ee.stopRenderingLineAfter=116]="stopRenderingLineAfter",ee[ee.suggest=117]="suggest",ee[ee.suggestFontSize=118]="suggestFontSize",ee[ee.suggestLineHeight=119]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ee[ee.suggestSelection=121]="suggestSelection",ee[ee.tabCompletion=122]="tabCompletion",ee[ee.tabIndex=123]="tabIndex",ee[ee.unicodeHighlighting=124]="unicodeHighlighting",ee[ee.unusualLineTerminators=125]="unusualLineTerminators",ee[ee.useShadowDOM=126]="useShadowDOM",ee[ee.useTabStops=127]="useTabStops",ee[ee.wordBreak=128]="wordBreak",ee[ee.wordSeparators=129]="wordSeparators",ee[ee.wordWrap=130]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=133]="wordWrapColumn",ee[ee.wordWrapOverride1=134]="wordWrapOverride1",ee[ee.wordWrapOverride2=135]="wordWrapOverride2",ee[ee.wrappingIndent=136]="wrappingIndent",ee[ee.wrappingStrategy=137]="wrappingStrategy",ee[ee.showDeprecated=138]="showDeprecated",ee[ee.inlayHints=139]="inlayHints",ee[ee.editorClassName=140]="editorClassName",ee[ee.pixelRatio=141]="pixelRatio",ee[ee.tabFocusMode=142]="tabFocusMode",ee[ee.layoutInfo=143]="layoutInfo",ee[ee.wrappingInfo=144]="wrappingInfo",ee[ee.defaultColorDecorators=145]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(ct||(e.EditorOption=ct={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(198,null)})),acceptSuggestionOnEnter:je(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(199,null),""],markdownDescription:m.localize(200,null)})),accessibilitySupport:je(new f),accessibilityPageSize:je(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(201,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",m.localize(202,null))),ariaRequired:je(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:je(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(204,null),m.localize(205,null),""],description:m.localize(206,null)})),autoClosingComments:je(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoClosingDelete:je(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(210,null),""],description:m.localize(211,null)})),autoClosingOvertype:je(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(212,null),""],description:m.localize(213,null)})),autoClosingQuotes:je(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(214,null),m.localize(215,null),""],description:m.localize(216,null)})),autoIndent:je(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[m.localize(217,null),m.localize(218,null),m.localize(219,null),m.localize(220,null),m.localize(221,null)],description:m.localize(222,null)})),automaticLayout:je(new t(13,"automaticLayout",!1)),autoSurround:je(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(223,null),m.localize(224,null),m.localize(225,null),""],description:m.localize(226,null)})),bracketPairColorization:je(new J),bracketPairGuides:je(new W),stickyTabStops:je(new t(115,"stickyTabStops",!1,{description:m.localize(227,null)})),codeLens:je(new t(17,"codeLens",!0,{description:m.localize(228,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:m.localize(229,null)})),codeLensFontSize:je(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(230,null)})),colorDecorators:je(new t(20,"colorDecorators",!0,{description:m.localize(231,null)})),colorDecoratorActivatedOn:je(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(232,null),m.localize(233,null),m.localize(234,null)],description:m.localize(235,null)})),colorDecoratorsLimit:je(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(236,null)})),columnSelection:je(new t(22,"columnSelection",!1,{description:m.localize(237,null)})),comments:je(new D),contextmenu:je(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new t(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(238,null)})),cursorBlinking:je(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:m.localize(239,null)})),cursorSmoothCaretAnimation:je(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null)],description:m.localize(243,null)})),cursorStyle:je(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:m.localize(244,null)})),cursorSurroundingLines:je(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(245,null)})),cursorSurroundingLinesStyle:je(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(246,null),m.localize(247,null)],markdownDescription:m.localize(248,null)})),cursorWidth:je(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(249,null)})),disableLayerHinting:je(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new t(34,"domReadOnly",!1)),dragAndDrop:je(new t(35,"dragAndDrop",!0,{description:m.localize(250,null)})),emptySelectionClipboard:je(new j),dropIntoEditor:je(new Xe),stickyScroll:je(new Se),experimentalWhitespaceRendering:je(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(255,null)})),find:je(new M),fixedOverflowWidgets:je(new t(42,"fixedOverflowWidgets",!1)),folding:je(new t(43,"folding",!0,{description:m.localize(256,null)})),foldingStrategy:je(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),foldingHighlight:je(new t(45,"foldingHighlight",!0,{description:m.localize(260,null)})),foldingImportsByDefault:je(new t(46,"foldingImportsByDefault",!1,{description:m.localize(261,null)})),foldingMaximumRegions:je(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(262,null)})),unfoldOnClickAfterEndOfLine:je(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(263,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(264,null)})),fontInfo:je(new I),fontLigatures2:je(new U),fontSize:je(new Z),fontWeight:je(new ue),fontVariations:je(new P),formatOnPaste:je(new t(55,"formatOnPaste",!1,{description:m.localize(265,null)})),formatOnType:je(new t(56,"formatOnType",!1,{description:m.localize(266,null)})),glyphMargin:je(new t(57,"glyphMargin",!0,{description:m.localize(267,null)})),gotoLocation:je(new ge),hideCursorInOverviewRuler:je(new t(59,"hideCursorInOverviewRuler",!1,{description:m.localize(268,null)})),hover:je(new be),inDiffEditor:je(new t(61,"inDiffEditor",!1)),letterSpacing:je(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>h.clamp(ee,-5,20),{description:m.localize(269,null)})),lightbulb:je(new ne),lineDecorationsWidth:je(new X),lineHeight:je(new V),lineNumbers:je(new te),lineNumbersMinChars:je(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new t(69,"linkedEditing",!1,{description:m.localize(270,null)})),links:je(new t(70,"links",!0,{description:m.localize(271,null)})),matchBrackets:je(new u(71,"matchBrackets","always",["always","near","never"],{description:m.localize(272,null)})),minimap:je(new re),mouseStyle:je(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(74,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(273,null)})),mouseWheelZoom:je(new t(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(274,null)})),multiCursorMergeOverlapping:je(new t(76,"multiCursorMergeOverlapping",!0,{description:m.localize(275,null)})),multiCursorModifier:je(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ie,{markdownEnumDescriptions:[m.localize(276,null),m.localize(277,null)],markdownDescription:m.localize(278,null)})),multiCursorPaste:je(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(279,null),m.localize(280,null)],markdownDescription:m.localize(281,null)})),multiCursorLimit:je(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(282,null)})),occurrencesHighlight:je(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null),m.localize(285,null)],markdownDescription:m.localize(286,null)})),overviewRulerBorder:je(new t(81,"overviewRulerBorder",!0,{description:m.localize(287,null)})),overviewRulerLanes:je(new o(82,"overviewRulerLanes",3,0,3)),padding:je(new Re),pasteAs:je(new it),parameterHints:je(new Ce),peekWidgetDefaultFocus:je(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(288,null),m.localize(289,null)],description:m.localize(290,null)})),definitionLinkOpensInPeek:je(new t(87,"definitionLinkOpensInPeek",!1,{description:m.localize(291,null)})),quickSuggestions:je(new ie),quickSuggestionsDelay:je(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(292,null)})),readOnly:je(new t(90,"readOnly",!1)),readOnlyMessage:je(new de),renameOnType:je(new t(92,"renameOnType",!1,{description:m.localize(293,null),markdownDeprecationMessage:m.localize(294,null)})),renderControlCharacters:je(new t(93,"renderControlCharacters",!0,{description:m.localize(295,null),restricted:!0})),renderFinalNewline:je(new u(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(296,null)})),renderLineHighlight:je(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(297,null)],description:m.localize(298,null)})),renderLineHighlightOnlyWhenFocus:je(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(299,null)})),renderValidationDecorations:je(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(300,null),m.localize(301,null),m.localize(302,null),""],description:m.localize(303,null)})),revealHorizontalRightPadding:je(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new t(100,"roundedSelection",!0,{description:m.localize(304,null)})),rulers:je(new se),scrollbar:je(new Le),scrollBeyondLastColumn:je(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(305,null)})),scrollBeyondLastLine:je(new t(104,"scrollBeyondLastLine",!0,{description:m.localize(306,null)})),scrollPredominantAxis:je(new t(105,"scrollPredominantAxis",!0,{description:m.localize(307,null)})),selectionClipboard:je(new t(106,"selectionClipboard",!0,{description:m.localize(308,null),included:C.$k})),selectionHighlight:je(new t(107,"selectionHighlight",!0,{description:m.localize(309,null)})),selectOnLineNumbers:je(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(310,null),m.localize(311,null),m.localize(312,null)],description:m.localize(313,null)})),showUnused:je(new t(110,"showUnused",!0,{description:m.localize(314,null)})),showDeprecated:je(new t(138,"showDeprecated",!0,{description:m.localize(315,null)})),inlayHints:je(new ce),snippetSuggestions:je(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(316,null),m.localize(317,null),m.localize(318,null),m.localize(319,null)],description:m.localize(320,null)})),smartSelect:je(new ye),smoothScrolling:je(new t(113,"smoothScrolling",!1,{description:m.localize(321,null)})),stopRenderingLineAfter:je(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new _),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(322,null)})),suggestFontSize:je(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new t(120,"suggestOnTriggerCharacters",!0,{description:m.localize(325,null)})),suggestSelection:je(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(326,null),m.localize(327,null),m.localize(328,null)],description:m.localize(329,null)})),tabCompletion:je(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabIndex:je(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new O),unusualLineTerminators:je(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),useShadowDOM:je(new t(126,"useShadowDOM",!0)),useTabStops:je(new t(127,"useTabStops",!0,{description:m.localize(338,null)})),wordBreak:je(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),wordSeparators:je(new i(129,"wordSeparators",R.$cs,{description:m.localize(342,null)})),wordWrap:je(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null),m.localize(346,null)],description:m.localize(347,null)})),wordWrapBreakAfterCharacters:je(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(348,null)})),wordWrapOverride1:je(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new q),defaultColorDecorators:je(new t(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(349,null)})),pixelRatio:je(new le),tabFocusMode:je(new t(142,"tabFocusMode",!1,{markdownDescription:m.localize(350,null)})),layoutInfo:je(new me),wrappingInfo:je(new Je),wrappingIndent:je(new Qe),wrappingStrategy:je(new fe)}}),define(Pe[147],Ae([9,10]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[148],Ae([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[149],Ae([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[150],Ae([9,10]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[151],Ae([9,10]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[152],Ae([9,10]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[153],Ae([9,10]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[154],Ae([9,10]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[155],Ae([9,10]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[156],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[157],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[158],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[159],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[160],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[161],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[162],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[163],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/common/configuration",e)}),define(Pe[170],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[171],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[172],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Ae([9,10]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Ae([1,0,11,149]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.TokenType=void 0;var C;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(C||(e.TokenType=C={}));function F(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,T.localize)(3,null),m=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push($)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=g.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(m);return}const v=this.c.charCodeAt(A);if(k)k=!1;else if(v===47&&!l){A++;break}else v===91?l=!0:v===92?k=!0:v===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$Vi=g}),define(Pe[181],Ae([1,0,25,31,151,293]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$Wo=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Xo=w;function A(t){if(!t)return null;const n=t.majorBase,o=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let r=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),r=!1);let u=0;if(t.preRelease){const d=m.exec(t.preRelease);if(d){const[,b,f,D]=d;u=Date.UTC(Number(b),Number(f)-1,Number(D))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:r,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$Yo=A;function k(t,n,o){let c;typeof t=="string"?c=A(w(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof o=="string"?i=A(w(o)):i=o,!c||!i)return!1;const r=c.majorBase,u=c.minorBase,d=c.patchBase;let b=i.majorBase,f=i.minorBase,D=i.patchBase;const L=i.notBefore;let p=i.majorMustEqual,y=i.minorMustEqual,S=i.patchMustEqual;return i.isMinimum?r>b?!0:r<b?!1:u>f?!0:u<f||h&&h<L?!1:d>=D:(r===1&&b===0&&(!p||!y||!S)&&(b=1,f=0,D=0,p=!0,y=!1,S=!1),r<b?!1:r>b?!p:u<f?!1:u>f?!y:d<D?!1:d>D?!S:!(h&&h<L))}e.$Zo=k;function l(t,n,o,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return i.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return i.push([T.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,C.localize(9,null,"main")]),i;{const d=(0,E.$Cg)(o,c.main);(0,E.$wg)(d,o)||i.push([T.default.Warning,C.localize(10,null,d.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,C.localize(11,null,"browser")]),i;{const d=(0,E.$Cg)(o,c.browser);(0,E.$wg)(d,o)||i.push([T.default.Warning,C.localize(12,null,d.path,o.path)])}}if(!F.valid(c.version))return i.push([T.default.Error,C.localize(13,null)]),i;const r=[];if(!$(t,n,c,h,r))for(const d of r)i.push([T.default.Error,d]);return i}e.$1o=l;function $(t,n,o,c,h){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:a(t,n,o.engines.vscode,h)}e.$2o=$;function v(t,n,o){return t==="*"||a(n,o,t)}e.$3o=v;function a(t,n,o,c=[]){const h=A(w(o));if(!h)return c.push(C.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(C.localize(15,null,o)),!1}else if(!h.majorMustEqual)return c.push(C.localize(16,null,o)),!1;return k(t,n,h)?!0:(c.push(C.localize(17,null,t,o)),!1)}function s(t){if(!Array.isArray(t))return!1;for(let n=0,o=t.length;n<o;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class E{constructor(C,F=[],R=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$Xh=E}),define(Pe[70],Ae([1,0,69]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.InstantiationType=void 0;const T=[];var C;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function F(m,g,w){g instanceof E.$Xh||(g=new E.$Xh(g,[],!!w)),T.push([m,g])}e.$Hr=F;function R(){return T}e.$Ir=R}),define(Pe[182],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0;class E{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$mq=E;class T{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const m=this.lookupOrInsertNode(F),g=this.lookupOrInsertNode(R);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let m=this.a.get(R);return m||(m=new E(R,F),this.a.set(R,m)),m}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,m]of this.a)F.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const m=new Set([F]),g=this.c(R,m);if(g)return g}}c(F,R){for(const[m,g]of F.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const w=this.c(g,R);if(w)return w;R.delete(m)}}}e.$nq=T}),define(Pe[4],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(E||(e._util=E={})),e.$Zh=C("instantiationService");function T(R,m,g){m[E.DI_TARGET]===m?m[E.DI_DEPENDENCIES].push({id:R,index:g}):(m[E.DI_DEPENDENCIES]=[{id:R,index:g}],m[E.DI_TARGET]=m)}function C(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const m=function(g,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,g,A)};return m.toString=()=>R,E.serviceIds.set(R,m),m}e.$1h=C;function F(R){return R}e.$2h=F}),define(Pe[41],Ae([1,0,16,2,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.ConfigurationTarget=e.$wi=e.$vi=e.$ui=void 0,e.$ui=(0,C.$1h)("configurationService");function F(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$vi=F;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$wi=R;var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$xi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$yi=w;function A(t,n){const o=Object.create(null);for(const c in t)k(o,c,t[c],n);return o}e.$zi=A;function k(t,n,o,c){const h=n.split("."),i=h.pop();let r=t;for(let u=0;u<h.length;u++){const d=h[u];let b=r[d];switch(typeof b){case"undefined":b=r[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(b)}`);return}r=b}if(typeof r=="object"&&r!==null)try{r[i]=o}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(r)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.$Ai=k;function l(t,n){const o=n.split(".");$(t,o)}e.$Bi=l;function $(t,n){const o=n.shift();if(n.length===0){delete t[o];return}if(Object.keys(t).indexOf(o)!==-1){const c=t[o];typeof c=="object"&&!Array.isArray(c)&&($(c,n),Object.keys(c).length===0&&delete t[o])}}function v(t,n,o){function c(r,u){let d=r;for(const b of u){if(typeof d!="object"||d===null)return;d=d[b]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?o:i}e.$Ci=v;function a(t,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Ff(t[c])&&E.$Ff(n[c])?a(t[c],n[c],o):o&&(t[c]=n[c]):t[c]=n[c])})}e.$Di=a;function s(t){return t.replace(/[\[\]]/g,"")}e.$Ei=s}),define(Pe[35],Ae([1,0,21,12,180,4,148,11]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.ContextKeyExprType=e.$Wi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(X,V){if(g.get(X)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(X,V)}e.$Wi=w;const A=Object.prototype.hasOwnProperty;var k;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},$=(0,R.localize)(0,null),v=(0,R.localize)(1,null),a=(0,R.localize)(2,null),s=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new C.$Vi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const Ie=this.D(),Re=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:C.$Vi.getLexeme(Ie),additionalInfo:Re}),h.c}return re}catch(re){if(re!==h.c)throw re;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const re=this.o();V.push(re)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const re=this.s();V.push(re)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,s),re?.negate()}case 17:return this.z(),N.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const re=this.l();return this.A(1,s),re}case 17:{const re=V.lexeme;if(this.z(),this.y(9)){const Re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Re.type!==10)throw this.B("REGEX",Re);const Ce=Re.lexeme,le=Ce.lastIndexOf("/"),ie=le===Ce.length-1?void 0:this.w(Ce.substring(le+1));let G;try{G=new RegExp(Ce.substring(1,le),ie)}catch{throw this.B("REGEX",Re)}return I.create(re,G)}switch(Re.type){case 10:case 19:{const Ce=[Re.lexeme];this.z();let le=this.D(),ie=0;for(let de=0;de<Re.lexeme.length;de++)Re.lexeme.charCodeAt(de)===40?ie++:Re.lexeme.charCodeAt(de)===41&&ie--;for(;!this.E()&&le.type!==15&&le.type!==16;){switch(le.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let de=0;de<le.lexeme.length;de++)le.lexeme.charCodeAt(de)===40?ie++:Re.lexeme.charCodeAt(de)===41&&ie--}if(ie<0)break;Ce.push(C.$Vi.getLexeme(le)),this.z(),le=this.D()}const G=Ce.join(""),te=G.lastIndexOf("/"),x=te===G.length-1?void 0:this.w(G.substring(te+1));let se;try{se=new RegExp(G.substring(1,te),x)}catch{throw this.B("REGEX",Re)}return i.regex(re,se)}case 18:{const Ce=Re.lexeme;this.z();let le=null;if(!(0,T.$Ge)(Ce)){const ie=Ce.indexOf("/"),G=Ce.lastIndexOf("/");if(ie!==G&&ie>=0){const te=Ce.slice(ie+1,G),x=Ce[G+1]==="i"?"i":"";try{le=new RegExp(te,x)}catch{throw this.B("REGEX",Re)}}}if(le===null)throw this.B("REGEX",Re);return I.create(re,le)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const Re=this.u();return i.notIn(re,Re)}switch(this.D().type){case 3:{this.z();const Re=this.u();if(this.x().type===18)return i.equals(re,Re);switch(Re){case"true":return i.has(re);case"false":return i.not(re);default:return i.equals(re,Re)}}case 4:{this.z();const Re=this.u();if(this.x().type===18)return i.notEquals(re,Re);switch(Re){case"true":return i.not(re);case"false":return i.has(re);default:return i.notEquals(re,Re)}}case 5:return this.z(),U.create(re,this.u());case 6:return this.z(),P.create(re,this.u());case 7:return this.z(),j.create(re,this.u());case 8:return this.z(),M.create(re,this.u());case 13:return this.z(),i.in(re,this.u());default:return i.has(re)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,re){if(this.C(V))return this.z();throw this.B(re,this.D())}B(V,re,Ie){const Re=(0,R.localize)(8,null,V,C.$Vi.getLexeme(re)),Ce=re.offset,le=C.$Vi.getLexeme(re);return this.h.push({message:Re,offset:Ce,lexeme:le,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Xi=h;class i{static false(){return b.INSTANCE}static true(){return f.INSTANCE}static has(V){return D.create(V)}static equals(V,re){return L.create(V,re)}static notEquals(V,re){return S.create(V,re)}static regex(V,re){return I.create(V,re)}static in(V,re){return p.create(V,re)}static notIn(V,re){return y.create(V,re)}static not(V){return N.create(V)}static and(...V){return ge.create(V,null,!0)}static or(...V){return be.create(V,null,!0)}static greater(V,re){return j.create(V,re)}static greaterEquals(V,re){return M.create(V,re)}static smaller(V,re){return U.create(V,re)}static smallerEquals(V,re){return P.create(V,re)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Yi=i;function r(X){const V=new h({regexParsingWithErrorRecovery:!1});return X.map(re=>(V.parse(re),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$Zi=r;function u(X,V){const re=X?X.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!re&&!Ie?!0:!re||!Ie?!1:re.equals(Ie)}e.$1i=u;function d(X,V){return X.cmp(V)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$2i=b;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return b.INSTANCE}}e.$3i=f;class D{static create(V,re=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:b.INSTANCE:new D(V,re)}constructor(V,re){this.key=V,this.c=re,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:me(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:b.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$4i=D;class L{static create(V,re,Ie=null){if(typeof re=="boolean")return re?D.create(V,Ie):N.create(V,Ie);const Re=g.get(V);return typeof Re=="boolean"?re===(Re?"true":"false")?f.INSTANCE:b.INSTANCE:new L(V,re,Ie)}constructor(V,re,Ie){this.c=V,this.d=re,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?f.INSTANCE:b.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$5i=L;class p{static create(V,re){return new p(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(re)?re.includes(Ie):typeof Ie=="string"&&typeof re=="object"&&re!==null?A.call(re,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$6i=p;class y{static create(V,re){return new y(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=11,this.c=p.create(V,re)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$7i=y;class S{static create(V,re,Ie=null){if(typeof re=="boolean")return re?N.create(V,Ie):D.create(V,Ie);const Re=g.get(V);return typeof Re=="boolean"?re===(Re?"true":"false")?b.INSTANCE:f.INSTANCE:new S(V,re,Ie)}constructor(V,re,Ie){this.c=V,this.d=re,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?b.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$8i=S;class N{static create(V,re=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?b.INSTANCE:f.INSTANCE:new N(V,re)}constructor(V,re){this.c=V,this.d=re,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:me(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?b.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$9i=N;function q(X,V){if(typeof X=="string"){const re=parseFloat(X);isNaN(re)||(X=re)}return typeof X=="string"||typeof X=="number"?V(X):b.INSTANCE}class j{static create(V,re,Ie=null){return q(re,Re=>new j(V,Re,Ie))}constructor(V,re,Ie){this.c=V,this.d=re,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$0i=j;class M{static create(V,re,Ie=null){return q(re,Re=>new M(V,Re,Ie))}constructor(V,re,Ie){this.c=V,this.d=re,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$$i=M;class U{static create(V,re,Ie=null){return q(re,Re=>new U(V,Re,Ie))}constructor(V,re,Ie){this.c=V,this.d=re,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$_i=U;class P{static create(V,re,Ie=null){return q(re,Re=>new P(V,Re,Ie))}constructor(V,re,Ie){this.c=V,this.d=re,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$aj=P;class I{static create(V,re){return new I(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const re=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return re<Ie?-1:re>Ie?1:0}equals(V){if(V.type===this.type){const re=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&re===Ie}return!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$bj=I;class Z{static create(V){return new Z(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new Z(this.c.map(V))}negate(){return this.c}}e.$cj=Z;function ue(X){let V=null;for(let re=0,Ie=X.length;re<Ie;re++){const Re=X[re].substituteConstants();if(X[re]!==Re&&V===null){V=[];for(let Ce=0;Ce<re;Ce++)V[Ce]=X[Ce]}V!==null&&(V[re]=Re)}return V===null?X:V}class ge{static create(V,re,Ie){return ge.d(V,re,Ie)}constructor(V,re){this.expr=V,this.c=re,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,Ie=this.expr.length;re<Ie;re++){const Re=d(this.expr[re],V.expr[re]);if(Re!==0)return Re}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,Ie=this.expr.length;re<Ie;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=ue(this.expr);return V===this.expr?this:ge.create(V,this.c,!1)}evaluate(V){for(let re=0,Ie=this.expr.length;re<Ie;re++)if(!this.expr[re].evaluate(V))return!1;return!0}static d(V,re,Ie){const Re=[];let Ce=!1;for(const le of V)if(le){if(le.type===1){Ce=!0;continue}if(le.type===0)return b.INSTANCE;if(le.type===6){Re.push(...le.expr);continue}Re.push(le)}if(Re.length===0&&Ce)return f.INSTANCE;if(Re.length!==0){if(Re.length===1)return Re[0];Re.sort(d);for(let le=1;le<Re.length;le++)Re[le-1].equals(Re[le])&&(Re.splice(le,1),le--);if(Re.length===1)return Re[0];for(;Re.length>1;){const le=Re[Re.length-1];if(le.type!==9)break;Re.pop();const ie=Re.pop(),G=Re.length===0,te=be.create(le.expr.map(x=>ge.create([x,ie],null,Ie)),null,G);te&&(Re.push(te),Re.sort(d))}if(Re.length===1)return Re[0];if(Ie){for(let le=0;le<Re.length;le++)for(let ie=le+1;ie<Re.length;ie++)if(Re[le].negate().equals(Re[ie]))return b.INSTANCE;if(Re.length===1)return Re[0]}return new ge(Re,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ge(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());this.c=be.create(V,this,!0)}return this.c}}e.$dj=ge;class be{static create(V,re,Ie){return be.d(V,re,Ie)}constructor(V,re){this.expr=V,this.c=re,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,Ie=this.expr.length;re<Ie;re++){const Re=d(this.expr[re],V.expr[re]);if(Re!==0)return Re}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,Ie=this.expr.length;re<Ie;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=ue(this.expr);return V===this.expr?this:be.create(V,this.c,!1)}evaluate(V){for(let re=0,Ie=this.expr.length;re<Ie;re++)if(this.expr[re].evaluate(V))return!0;return!1}static d(V,re,Ie){let Re=[],Ce=!1;if(V){for(let le=0,ie=V.length;le<ie;le++){const G=V[le];if(G){if(G.type===0){Ce=!0;continue}if(G.type===1)return f.INSTANCE;if(G.type===9){Re=Re.concat(G.expr);continue}Re.push(G)}}if(Re.length===0&&Ce)return b.INSTANCE;Re.sort(d)}if(Re.length!==0){if(Re.length===1)return Re[0];for(let le=1;le<Re.length;le++)Re[le-1].equals(Re[le])&&(Re.splice(le,1),le--);if(Re.length===1)return Re[0];if(Ie){for(let le=0;le<Re.length;le++)for(let ie=le+1;ie<Re.length;ie++)if(Re[le].negate().equals(Re[ie]))return f.INSTANCE;if(Re.length===1)return Re[0]}return new be(Re,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new be(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());for(;V.length>1;){const re=V.shift(),Ie=V.shift(),Re=[];for(const Ce of ce(re))for(const le of ce(Ie))Re.push(ge.create([Ce,le],null,!1));V.unshift(be.create(Re,null,!1))}this.c=be.create(V,this,!0)}return this.c}}e.$ej=be;class ke extends D{static{this.d=[]}static all(){return ke.d.values()}constructor(V,re,Ie){super(V,null),this.f=re,typeof Ie=="object"?ke.d.push({...Ie,key:V}):Ie!==!0&&ke.d.push({key:V,description:Ie,type:re!=null?typeof re:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return L.create(this.key,V)}notEqualsTo(V){return S.create(this.key,V)}}e.$fj=ke,e.$gj=(0,F.$1h)("contextKeyService");function me(X,V){return X<V?-1:X>V?1:0}function fe(X,V,re,Ie){return X<re?-1:X>re?1:V<Ie?-1:V>Ie?1:0}function ne(X,V){if(X.type===0||V.type===1)return!0;if(X.type===9)return V.type===9?Se(X.expr,V.expr):!1;if(V.type===9){for(const re of V.expr)if(ne(X,re))return!0;return!1}if(X.type===6){if(V.type===6)return Se(V.expr,X.expr);for(const re of X.expr)if(ne(re,V))return!0;return!1}return X.equals(V)}e.$hj=ne;function Se(X,V){let re=0,Ie=0;for(;re<X.length&&Ie<V.length;){const Re=X[re].cmp(V[Ie]);if(Re<0)return!1;Re===0&&re++,Ie++}return re===X.length}function ce(X){return X.type===9?X.expr:[X]}}),define(Pe[183],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=void 0,e.$8h=(0,E.$1h)("environmentService"),e.$9h=(0,E.$2h)(e.$8h)}),define(Pe[97],Ae([1,0,150,4]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$io=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=void 0,e.$9n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0n=new RegExp(e.$9n),e.$$n="__web_extension",e.$_n="skipWalkthrough",e.$ao="extensionsSync",e.$bo="dependecyOrPackExtensionInstall";function C(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$co=C;function F(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$do=F;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$eo=R;function m(t,n){return n==="web"&&!t.includes("web")}e.$fo=m;function g(t,n,o){return m(n,o)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===o}e.$go=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$ho=w;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$io=(0,T.$1h)("extensionGalleryService");var v;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var a;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class s extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$jo=s,e.$ko=(0,T.$1h)("extensionManagementService"),e.$lo="extensionsIdentifiers/disabled",e.$mo="extensionsIdentifiers/enabled",e.$no=(0,T.$1h)("IGlobalExtensionEnablementService"),e.$oo=(0,T.$1h)("IExtensionTipsService"),e.$po=(0,E.localize)(0,null),e.$qo={value:e.$po,original:"Extensions"},e.$ro={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[42],Ae([1,0,50,19,12,16,2,152,4,21,13,39]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileKind=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileOperationResult=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileChangeType=e.$Bk=e.FileOperation=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderErrorCode=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileSystemProviderCapabilities=e.$lk=e.FilePermission=e.FileType=e.$kk=e.$jk=void 0,e.$jk=(0,g.$1h)("fileService");function l(ne){return ne.create===!0}e.$kk=l;var $;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var v;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function a(ne){const Se=ne;return!!Se&&typeof Se.onDidChange=="function"}e.$lk=a;var s;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function t(ne){return!!(ne.capabilities&2)}e.$mk=t;function n(ne){return!!(ne.capabilities&8)}e.$nk=n;function o(ne){return!!(ne.capabilities&131072)}e.$ok=o;function c(ne){return!!(ne.capabilities&4)}e.$pk=c;function h(ne){return!!(ne.capabilities&16)}e.$qk=h;function i(ne){return t(ne)?!!(ne.capabilities&16384):!1}e.$rk=i;function r(ne){return t(ne)?!!(ne.capabilities&32768):!1}e.$sk=r;function u(ne){return!!(ne.capabilities&65536)}e.$tk=u;function d(ne){return!!(ne.capabilities&2048)}e.$uk=d;var b;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class f extends Error{static create(Se,ce){const X=new f(Se.toString(),ce);return p(X,ce),X}constructor(Se,ce){super(Se),this.code=ce}}e.$vk=f;function D(ne,Se){return f.create(ne,Se)}e.$wk=D;function L(ne){return ne||D((0,m.localize)(0,null),b.Unknown)}e.$xk=L;function p(ne,Se){return ne.name=Se?`${Se} (FileSystemError)`:"FileSystemError",ne}e.$yk=p;function y(ne){if(!ne)return b.Unknown;if(ne instanceof f)return ne.code;const Se=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Se)return b.Unknown;switch(Se[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$zk=y;function S(ne){if(ne instanceof P)return ne.fileOperationResult;switch(y(ne)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$Ak=S;var N;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class q{constructor(Se,ce,X){this.resource=Se,this.operation=ce,this.target=X}isOperation(Se){return this.operation===Se}}e.$Bk=q;var j;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class M{static{this.a=null}constructor(Se,ce){this.c=ce,this.b=void 0,this.d=new k.$V(()=>{const X=E.$7h.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new k.$V(()=>{const X=E.$7h.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new k.$V(()=>{const X=E.$7h.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Se){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==M.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Se,...ce){return this.h(Se,{includeChildren:!1},...ce)}affects(Se,...ce){return this.h(Se,{includeChildren:!0},...ce)}h(Se,ce,...X){if(!Se)return!1;const V=X.length>0;return!!((!V||X.includes(1))&&(this.d.value.get(Se)||ce.includeChildren&&this.d.value.findSuperstr(Se))||(!V||X.includes(0))&&(this.f.value.get(Se)||ce.includeChildren&&this.f.value.findSuperstr(Se))||(!V||X.includes(2))&&(this.g.value.findSubstr(Se)||ce.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$Ck=M;function U(ne,Se,ce){return!ne||!Se||ne===Se||Se.length>ne.length?!1:(Se.charAt(Se.length-1)!==T.sep&&(Se+=T.sep),ce?(0,C.$8e)(ne,Se):ne.indexOf(Se)===0)}e.$Dk=U;class P extends Error{constructor(Se,ce,X){super(Se),this.fileOperationResult=ce,this.options=X}}e.$Ek=P;class I extends P{constructor(Se,ce,X,V){super(Se,ce,V),this.fileOperationResult=ce,this.size=X}}e.$Fk=I;class Z extends P{constructor(Se,ce,X){super(Se,2,X),this.stat=ce}}e.$Gk=Z;var ue;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$Hk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ik={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Jk="files.associations",e.$Kk="files.exclude",e.$Lk="files.readonlyInclude",e.$Mk="files.readonlyExclude",e.$Nk="files.readonlyFromPermissions";var ge;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge||(e.FileKind=ge={})),e.$Ok="";function be(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$Pk=be;async function ke(ne,Se){if(!Se.hasProvider(R.URI.from({scheme:ne.scheme})))return new Promise(ce=>{const X=Se.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ne.scheme&&V.added&&(X.dispose(),ce())})})}e.$Qk=ke;class me{static{this.KB=1024}static{this.MB=me.KB*me.KB}static{this.GB=me.MB*me.KB}static{this.TB=me.GB*me.KB}static formatSize(Se){return(0,F.$Hf)(Se)||(Se=0),Se<me.KB?(0,m.localize)(1,null,Se.toFixed(0)):Se<me.MB?(0,m.localize)(2,null,(Se/me.KB).toFixed(2)):Se<me.GB?(0,m.localize)(3,null,(Se/me.MB).toFixed(2)):Se<me.TB?(0,m.localize)(4,null,(Se/me.GB).toFixed(2)):(0,m.localize)(5,null,(Se/me.TB).toFixed(2))}}e.$Rk=me;function fe(ne){const Se=typeof ne=="string"||ne?.scheme===A.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===A.Schemas.file?1024*me.MB:Se?10*me.MB:w.$o?50*me.MB:1024*me.MB}e.$Sk=fe}),define(Pe[71],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(...C){this.a=new Map;for(const[F,R]of C)this.set(F,R)}set(C,F){const R=this.a.get(C);return this.a.set(C,F),R}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Yh=E}),define(Pe[184],Ae([1,0,14,11,6,69,182,4,71,185]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;const A=!1;class k extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new g.$Yh,t=!1,n,o=A){this.f=s,this.g=t,this.h=n,this.i=o,this.o=new Set,this.f.set(m.$Zh,this),this._globalGraph=o?n?._globalGraph??new R.$nq(c=>c):void 0}createChild(s){return new l(s,this.g,this,this.i)}invokeFunction(s,...t){const n=v.traceInvocation(this.i,s);let o=!1;try{return s({get:h=>{if(o)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{o=!0,n.stop()}}createInstance(s,...t){let n,o;return s instanceof F.$Xh?(n=v.traceCreation(this.i,s.ctor),o=this.j(s.ctor,s.staticArguments.concat(t),n)):(n=v.traceCreation(this.i,s),o=this.j(s,t,n)),n.stop(),o}j(s,t=[],n){const o=m._util.getServiceDependencies(s).sort((i,r)=>i.index-r.index),c=[];for(const i of o){const r=this.m(i.id,n);r||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(r)}const h=o.length>0?o[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${s.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(s,t.concat(c))}k(s,t){if(this.f.get(s)instanceof F.$Xh)this.f.set(s,t);else if(this.h)this.h.k(s,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const t=this.f.get(s);return!t&&this.h?this.h.l(s):t}m(s,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const n=this.l(s);return n instanceof F.$Xh?this.q(s,n,t.branch(s,!0)):(t.branch(s,!1),n)}q(s,t,n){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,t,n)}finally{this.o.delete(s)}}r(s,t,n){const o=new R.$nq(i=>i.id.toString());let c=0;const h=[{id:s,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(o.lookupOrInsertNode(i),c++>1e3)throw new k(o);for(const r of m._util.getServiceDependencies(i.desc.ctor)){const u=this.l(r.id);if(u||this.u(`[createInstance] ${s} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),u instanceof F.$Xh){const d={id:r.id,desc:u,_trace:i._trace.branch(r.id,!0)};o.insertEdge(i,d),h.push(d)}}}for(;;){const i=o.roots();if(i.length===0){if(!o.isEmpty())throw new k(o);break}for(const{data:r}of i){if(this.l(r.id)instanceof F.$Xh){const d=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,d)}o.removeNode(r)}}return this.l(s)}s(s,t,n=[],o,c){if(this.f.get(s)instanceof F.$Xh)return this.t(s,t,n,o,c);if(this.h)return this.h.s(s,t,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(s,t,n=[],o,c){if(o){const h=new l(void 0,this.g,this,this.i);h.c=String(s);const i=new Map,r=new E.$hh(()=>{const u=h.j(t,n,c);for(const[d,b]of i){const f=u[d];if(typeof f=="function")for(const D of b)f.apply(u,D)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!r.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let D=i.get(d);return D||(D=new w.$3c,i.set(d,D)),(p,y,S)=>{const N=D.push([p,y,S]);return(0,C.$Qc)(N)}}if(d in u)return u[d];const b=r.value;let f=b[d];return typeof f!="function"||(f=f.bind(b),u[d]=f),f},set(u,d,b){return r.value[d]=b,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(s,t){if(t&&console.warn(s),this.g)throw new Error(s)}}e.$oq=l;var $;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})($||($={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,t){return s?new v(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(s,t){return s?new v(1,t.name):v.c}static{this.f=0}constructor(s,t){this.type=s,this.name=t,this.g=Date.now(),this.h=[]}branch(s,t){const n=new v(3,s.toString());return this.h.push([s,t,n]),n}stop(){const s=Date.now()-this.g;v.f+=s;let t=!1;function n(c,h){const i=[],r=new Array(c+1).join("	");for(const[u,d,b]of h.h)if(d&&b){t=!0,i.push(`${r}CREATES -> ${u}`);const f=n(c+1,b);f&&i.push(f)}else i.push(`${r}uses -> ${u}`);return i.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(s>2||t)&&v.all.add(o.join(`
`))}}e.$pq=v}),define(Pe[15],Ae([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.log=e.$lj=e.LogLevel=e.$kj=e.$jj=e.$ij=void 0,e.$ij=(0,l.$1h)("logService"),e.$jj=(0,l.$1h)("loggerService");function $(){return new Date().toISOString()}function v(p){return(0,w.$Hf)(p)}e.$kj=v;var a;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$lj=a.Info;function s(p,y,S){switch(y){case a.Trace:p.trace(S);break;case a.Debug:p.debug(S);break;case a.Info:p.info(S);break;case a.Warning:p.warn(S);break;case a.Error:p.error(S);break;case a.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=s;function t(p,y=!1){let S="";for(let N=0;N<p.length;N++){let q=p[N];if(q instanceof Error&&(q=(0,E.$Li)(q,y)),typeof q=="object")try{q=JSON.stringify(q)}catch{}S+=(N>0?" ":"")+q}return S}class n extends F.$Sc{constructor(){super(...arguments),this.b=e.$lj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==a.Off&&this.b<=y}}e.$nj=n;class o extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...S){this.f(a.Trace)&&this.g(a.Trace,t([y,...S],!0))}debug(y,...S){this.f(a.Debug)&&this.g(a.Debug,t([y,...S]))}info(y,...S){this.f(a.Info)&&this.g(a.Info,t([y,...S]))}warn(y,...S){this.f(a.Warning)&&this.g(a.Warning,t([y,...S]))}error(y,...S){if(this.f(a.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(a.Error,t(N))}else this.g(a.Error,t([y,...S]))}flush(){}}e.$oj=o;class c extends n{constructor(y=e.$lj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...S){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...S):console.log(`[main ${$()}]`,y,...S))}debug(y,...S){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...S):console.log(`[main ${$()}]`,y,...S))}info(y,...S){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...S):console.log(`[main ${$()}]`,y,...S))}warn(y,...S){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,y,...S):console.warn(`[main ${$()}]`,y,...S))}error(y,...S){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,y,...S):console.error(`[main ${$()}]`,y,...S))}dispose(){}flush(){}}e.$pj=c;class h extends n{constructor(y=e.$lj,S=!0){super(),this.g=S,this.setLevel(y)}trace(y,...S){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...S):console.log(y,...S))}debug(y,...S){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...S):console.log(y,...S))}info(y,...S){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...S):console.log(y,...S))}warn(y,...S){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...S):console.log(y,...S))}error(y,...S){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...S):console.error(y,...S))}dispose(){}flush(){}}e.$qj=h;class i extends n{constructor(y,S=e.$lj){super(),this.g=y,this.setLevel(S)}trace(y,...S){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(y),...S])}debug(y,...S){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(y),...S])}info(y,...S){this.f(a.Info)&&this.g.log(a.Info,[this.h(y),...S])}warn(y,...S){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(y),...S])}error(y,...S){this.f(a.Error)&&this.g.log(a.Error,[this.h(y),...S])}h(y){return typeof y=="string"?y:(0,E.$Li)(y,this.f(a.Trace))}dispose(){}flush(){}}e.$rj=i;class r extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const S of this.g)S.setLevel(y);super.setLevel(y)}trace(y,...S){for(const N of this.g)N.trace(y,...S)}debug(y,...S){for(const N of this.g)N.debug(y,...S)}info(y,...S){for(const N of this.g)N.info(y,...S)}warn(y,...S){for(const N of this.g)N.warn(y,...S)}error(y,...S){for(const N of this.g)N.error(y,...S)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$sj=r;class u extends F.$Sc{constructor(y,S,N){if(super(),this.h=y,this.j=S,this.b=new R.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,N)for(const q of N)this.b.set(q.resource,{logger:void 0,info:q})}m(y){return(0,w.$Df)(y)?[...this.b.values()].find(S=>S.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,S){const N=this.n(y),q=(0,w.$Df)(y)?y:S?.id??(0,C.$Oi)(N.toString()).toString(16);let j=this.b.get(N)?.logger;const M=S?.logLevel==="always"?a.Trace:S?.logLevel;j||(j=this.s(N,M??this.getLogLevel(N)??this.h,{...S,id:q}));const U={logger:j,info:{resource:N,id:q,logLevel:M,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(U.info),this.b.set(N,U),j}n(y){return(0,w.$Df)(y)?(0,g.$Cg)(this.j,`${y}.log`):y}setLogLevel(y,S){if(A.URI.isUri(y)){const N=y,q=S,j=this.b.get(N);j&&q!==j.info.logLevel&&(j.info.logLevel=q===this.h?void 0:q,j.logger?.setLevel(q),this.b.set(j.info.resource,j),this.f.fire([N,q]))}else{this.h=y;for(const[N,q]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,S){const N=this.m(y);N&&S!==!N.info.hidden&&(N.info.hidden=!S,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,S]))}getLogLevel(y){let S;return y&&(S=this.b.get(y)?.info.logLevel),S??this.h}registerLogger(y){const S=this.b.get(y.resource);S?S.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const S=this.b.get(y);S&&(S.logger&&S.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$tj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(y){}getLevel(){return a.Info}trace(y,...S){}debug(y,...S){}info(y,...S){}warn(y,...S){}error(y,...S){}critical(y,...S){}dispose(){}flush(){}}e.$uj=d;class b extends d{}e.$vj=b;function f(p){if(p.verbose)return a.Trace;if(typeof p.logLevel=="string"){const y=L(p.logLevel.toLowerCase());if(y!==void 0)return y}return e.$lj}e.$wj=f;function D(p){switch(p){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}e.$xj=D;function L(p){switch(p){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$yj=L,e.$zj=new k.$fj("logLevel",D(a.Info))}),define(Pe[186],Ae([1,0,6,15]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;class C extends E.$Sc{constructor(R,m=[]){super(),this.a=new T.$sj([R,...m]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$7N=C}),define(Pe[99],Ae([1,0,31,153,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function w(v,a){return a-v}g.compare=w;const A=Object.create(null);A[g.Error]=(0,T.localize)(0,null),A[g.Warning]=(0,T.localize)(1,null),A[g.Info]=(0,T.localize)(2,null);function k(v){return A[v]||""}g.toString=k;function l(v){switch(v){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function $(v){switch(v){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=$}(R||(e.MarkerSeverity=R={}));var m;(function(g){const w="";function A(l){return k(l,!0)}g.makeKey=A;function k(l,$){const v=[w];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(w),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(w),l.severity!==void 0&&l.severity!==null?v.push(R.toString(l.severity)):v.push(w),l.message&&$?v.push(l.message.replace("\xA6","\\\xA6")):v.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(w),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(w),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(w),v.push(w),v.join("\xA6")}g.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$kt=(0,C.$1h)("markerService")}),define(Pe[187],Ae([1,0,5,31,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$_u=e.Severity=void 0,e.Severity=T.default,e.$_u=(0,C.$1h)("notificationService");var F;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var m;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$av=g;class w{infinite(){}done(){}total(k){}worked(k){}}e.$bv=w}),define(Pe[188],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=void 0,e.$Aj=(0,E.$1h)("productService"),e.$Bj="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(pe,e,E,T){var C=arguments.length,F=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(pe,e,E,T);else for(var m=pe.length-1;m>=0;m--)(R=pe[m])&&(F=(C<3?R(F):C>3?R(e,E,F):R(e,E))||F);return C>3&&F&&Object.defineProperty(e,E,F),F},Ve=this&&this.__param||function(pe,e){return function(E,T){e(E,T,pe)}};define(Pe[72],Ae([1,0,14,20,6,4]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.ProgressLocation=e.$cv=void 0,e.$cv=(0,F.$1h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$dv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$ev=m;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$fv=g;let w=class extends C.$Sc{constructor(l,$){super(),this.a=new E.$lh,$.withProgress(l,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,C.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$gv=w,e.$gv=w=He([Ve(1,e.$cv)],w);class A extends C.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Rc)}start(l){this.stop();const $=++this.a,v=new T.$3d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Qc)(()=>v.cancel())),this.b.add((0,C.$Qc)(()=>this.c?this.c.done():void 0)),{id:$,token:v.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$hv=A,e.$iv=(0,F.$1h)("editorProgressService")}),define(Pe[30],Ae([1,0,53,16]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0;class C{constructor(){this.a=new Map}add(R,m){E.ok(T.$Df(R)),E.ok(T.$Ff(m)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$rn=new C}),define(Pe[73],Ae([1,0,5,30]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0,e.$sn={JSONContribution:"base.contributions.json"};function C(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class F{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[C(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;T.$rn.add(e.$sn.JSONContribution,R)}),define(Pe[54],Ae([1,0,18,5,16,147,41,73,30]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.ConfigurationScope=e.$wn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$wn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn="vscode://schemas/settings/resourceLanguage",e.$En="vscode://schemas/settings/configurationDefaults";const k=g.$rn.as(m.$sn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Dn,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const u=new Set;this.n(i,r,u),k.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const r=new Set;this.o(i,r),k.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const u=new Set;this.o(r,u),this.n(i,!1,u),k.registerSchema(e.$Dn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const u=[];for(const{overrides:d,source:b}of i)for(const f in d)if(r.add(f),e.$Gn.test(f)){const D=this.a.get(f),L=D?.valuesSources??new Map;if(b)for(const N of Object.keys(d[f]))L.set(N,b);const p={...D?.value||{},...d[f]};this.a.set(f,{source:b,value:p,valuesSources:L});const y=(0,R.$Ei)(f),S={type:"object",default:p,description:F.localize(1,null,y),$ref:e.$Dn,defaultDefaultValue:p,source:C.$Df(b)?void 0:b,defaultValueSource:b};u.push(...a(f)),this.d[f]=S,this.b.properties[f]=S}else{this.a.set(f,{value:d[f],source:b});const D=this.d[f];D&&(this.w(f,D),this.r(f,D))}this.m(u)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:u,source:d}of i)for(const b in u){const f=this.a.get(b),D=C.$Df(d)?d:d?.id,L=C.$Df(f?.source)?f?.source:f?.source?.id;if(D===L)if(r.add(b),this.a.delete(b),e.$Gn.test(b))delete this.d[b],delete this.b.properties[b];else{const p=this.d[b];p&&(this.w(b,p),this.r(b,p))}}this.u()}deltaConfiguration(i){let r=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,u){i.forEach(d=>{this.p(d,r,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,r){const u=d=>{if(d.properties)for(const b in d.properties){r.add(b);const f=this.d[b];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[b],this.s(b,d.properties[b])}d.allOf?.forEach(b=>u(b))};for(const d of i){u(d);const b=this.c.indexOf(d);b!==-1&&this.c.splice(b,1)}}p(i,r=!0,u,d,b=3,f){b=C.$Mf(i.scope)?b:i.scope;const D=i.properties;if(D)for(const p in D){const y=D[p];if(r&&o(p,y)){delete D[p];continue}if(y.source=u,y.defaultDefaultValue=D[p].default,this.w(p,y),e.$Gn.test(p)?y.scope=void 0:(y.scope=C.$Mf(y.scope)?b:y.scope,y.restricted=C.$Mf(y.restricted)?!!d?.includes(p):y.restricted),D[p].hasOwnProperty("included")&&!D[p].included){this.f[p]=D[p],delete D[p];continue}else this.d[p]=D[p],D[p].policy?.name&&this.e.set(D[p].policy.name,p);!D[p].deprecationMessage&&D[p].markdownDeprecationMessage&&(D[p].deprecationMessage=D[p].markdownDeprecationMessage),f.add(p)}const L=i.allOf;if(L)for(const p of L)this.p(p,r,u,d,b,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$xn.properties[i]=r,r.scope){case 1:e.$yn.properties[i]=r;break;case 2:e.$zn.properties[i]=r;break;case 6:e.$An.properties[i]=r;break;case 3:e.$Bn.properties[i]=r;break;case 4:e.$Cn.properties[i]=r;break;case 5:e.$Cn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$xn.properties[i],r.scope){case 1:delete e.$yn.properties[i];break;case 2:delete e.$zn.properties[i];break;case 6:delete e.$An.properties[i];break;case 3:delete e.$Bn.properties[i];break;case 4:case 5:delete e.$Cn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,u={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$Dn};this.w(r,u),e.$xn.properties[r]=u,e.$yn.properties[r]=u,e.$zn.properties[r]=u,e.$An.properties[r]=u,e.$Bn.properties[r]=u,e.$Cn.properties[r]=u}}v(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$Dn};e.$xn.patternProperties[e.$Fn]=i,e.$yn.patternProperties[e.$Fn]=i,e.$zn.patternProperties[e.$Fn]=i,e.$An.patternProperties[e.$Fn]=i,e.$Bn.patternProperties[e.$Fn]=i,e.$Cn.patternProperties[e.$Fn]=i,this.i.fire()}w(i,r){const u=this.a.get(i);let d=u?.value,b=u?.source;C.$Kf(d)&&(d=r.defaultDefaultValue,b=void 0),C.$Kf(d)&&(d=t(r.type)),r.default=d,r.defaultValueSource=b}}const $="\\[([^\\]]+)\\]",v=new RegExp($,"g");e.$Fn=`^(${$})+$`,e.$Gn=new RegExp(e.$Fn);function a(h){const i=[];if(e.$Gn.test(h)){let r=v.exec(h);for(;r?.length;){const u=r[1].trim();u&&i.push(u),r=v.exec(h)}}return(0,E.$Mb)(i)}e.$Hn=a;function s(h){return h.reduce((i,r)=>`${i}[${r}]`,"")}e.$In=s;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Jn=t;const n=new l;g.$rn.add(e.$wn.Configuration,n);function o(h,i){return h.trim()?e.$Gn.test(h)?F.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?F.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}e.$Kn=o;function c(){const h=[],i=n.getConfigurationProperties();for(const r of Object.keys(i))h.push([r,i[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Ln=c}),define(Pe[189],Ae([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0;function $(r){return Object.isFrozen(r)?r:m.$gn(r)}class v{constructor(u={},d=[],b=[],f){this.b=u,this.c=d,this.d=b,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof v)return d;const b=new a("");return b.parseRaw(d),b.configurationModel});this.f=u.reduce((d,b)=>b===d?b:d.merge(b),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$Ci)(this.contents,u):this.contents}inspect(u,d){const b=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,D=d?this.rawConfiguration.override(d).getValue(u):b;return{value:b,override:f,merged:D}}getOverrideValue(u,d){const b=this.i(d);return b?u?(0,A.$Ci)(b,u):b:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const b of this.overrides)b.identifiers.includes(u)&&d.push(...b.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=m.$fn(this.contents),b=m.$fn(this.overrides),f=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const L of u)if(D.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(d,L.contents);for(const p of L.overrides){const[y]=b.filter(S=>E.$ub(S.identifiers,p.identifiers));y?(this.h(y.contents,p.contents),y.keys.push(...p.keys),y.keys=E.$Mb(y.keys)):b.push(m.$fn(p))}for(const p of L.keys)f.indexOf(p)===-1&&f.push(p)}return new v(d,f,b,D.every(L=>L instanceof v)?void 0:D)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const b={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let D=this.contents[f];const L=d[f];L&&(typeof D=="object"&&typeof L=="object"?(D=m.$fn(D),this.h(D,L)):D=L),b[f]=D}return new v(b,this.keys,this.overrides)}h(u,d){for(const b of Object.keys(d)){if(b in u&&g.$Ff(u[b])&&g.$Ff(d[b])){this.h(u[b],d[b]);continue}u[b]=m.$fn(d[b])}}i(u){let d=null,b=null;const f=D=>{D&&(b?this.h(b,D):b=m.$fn(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===u?d=D.contents:D.identifiers.includes(u)&&f(D.contents);return f(d),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,A.$Bi)(this.contents,u),k.$Gn.test(u)&&this.overrides.splice(this.overrides.findIndex(b=>E.$ub(b.identifiers,(0,k.$Hn)(u))),1))}j(u,d,b){(0,A.$Ai)(this.contents,u,d,f=>console.error(f)),b=b||this.keys.indexOf(u)===-1,b&&this.keys.push(u),k.$Gn.test(u)&&this.overrides.push({identifiers:(0,k.$Hn)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$zi)(this.contents[u],f=>console.error(f))})}}e.$Mn=v;class a{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Mf(u)){const b=this.g(u);this.parseRaw(b,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:b,keys:f,overrides:D,restricted:L,hasExcludedProperties:p}=this.h(u,d);this.b=new v(b,f,D,p?[u]:void 0),this.c=L||[]}g(u){let d={},b=null,f=[];const D=[],L=[];function p(S){Array.isArray(f)?f.push(S):b!==null&&(f[b]=S)}const y={onObjectBegin:()=>{const S={};p(S),D.push(f),f=S,b=null},onObjectProperty:S=>{b=S},onObjectEnd:()=>{f=D.pop()},onArrayBegin:()=>{const S=[];p(S),D.push(f),f=S,b=null},onArrayEnd:()=>{f=D.pop()},onLiteralValue:p,onError:(S,N,q)=>{L.push({error:S,offset:N,length:q})}};if(u)try{C.$cn(u,y),d=f[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return d}h(u,d){const b=l.$rn.as(k.$wn.Configuration).getConfigurationProperties(),f=this.i(u,b,!0,d);u=f.raw;const D=(0,A.$zi)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(u),p=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:D,keys:L,overrides:p,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,b,f){let D=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:D};const L={},p=[];for(const y in u)if(k.$Gn.test(y)&&b){const S=this.i(u[y],d,!1,f);L[y]=S.raw,D=D||S.hasExcludedProperties,p.push(...S.restricted)}else{const S=d[y],N=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&p.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&S?.restricted))?L[y]=u[y]:D=!0}return{raw:L,restricted:p,hasExcludedProperties:D}}j(u,d){const b=[];for(const f of Object.keys(u))if(k.$Gn.test(f)){const D={};for(const L in u[f])D[L]=u[f][L];b.push({identifiers:(0,k.$Hn)(f),keys:Object.keys(D),contents:(0,A.$zi)(D,d)})}return b}}e.$Nn=a;class s extends F.$Sc{constructor(u,d,b,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&b.isEqual(D.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$On=s;class t{constructor(u,d,b,f,D,L,p,y,S,N,q,j,M){this.a=u,this.b=d,this.c=b,this.overrideIdentifiers=f,this.d=D,this.f=L,this.g=p,this.h=y,this.i=S,this.j=N,this.k=q,this.l=j,this.m=M}get value(){return $(this.c)}n(u,d,b){const f=u.inspect(d,b);return{get value(){return $(f.value)},get override(){return $(f.override)},get merged(){return $(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,b,f,D=new v,L=new v,p=new R.$Ac,y=new v,S=new R.$Ac){this.c=u,this.d=d,this.f=b,this.g=f,this.h=D,this.i=L,this.j=p,this.l=y,this.m=S,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,d,b){return this.p(u,d,b).getValue(u)}updateValue(u,d,b={}){let f;b.resource?(f=this.m.get(b.resource),f||(f=new v,this.m.set(b.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),b.resource||(this.a=null)}inspect(u,d,b){const f=this.p(u,d,b),D=this.t(d.resource,b),L=d.resource?this.m.get(d.resource)||this.l:this.l,p=new Set;for(const y of f.overrides)for(const S of y.identifiers)f.getOverrideValue(u,S)!==void 0&&p.add(S);return new t(u,d,f.getValue(u),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,D||void 0,L)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const b=[];if(!d){const{added:f,updated:D,removed:L}=h(this.c,u);d=[...f,...D,...L]}for(const f of d)for(const D of(0,k.$Hn)(f)){const L=this.c.getKeysForOverrideIdentifier(D),p=u.getKeysForOverrideIdentifier(D),y=[...p.filter(S=>L.indexOf(S)===-1),...L.filter(S=>p.indexOf(S)===-1),...L.filter(S=>!m.$jn(this.c.override(D).getValue(S),u.override(D).getValue(S)))];b.push([D,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:b}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:b,removed:f}=h(this.d,u),D=[...d,...b,...f];return D.length&&this.updatePolicyConfiguration(u),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.applicationConfiguration,u),L=[...d,...b,...f];return L.length&&this.updateApplicationConfiguration(u),{keys:L,overrides:D}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.localUserConfiguration,u),L=[...d,...b,...f];return L.length&&this.updateLocalUserConfiguration(u),{keys:L,overrides:D}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.remoteUserConfiguration,u),L=[...d,...b,...f];return L.length&&this.updateRemoteUserConfiguration(u),{keys:L,overrides:D}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:b,removed:f,overrides:D}=h(this.workspaceConfiguration,u),L=[...d,...b,...f];return L.length&&this.updateWorkspaceConfiguration(u),{keys:L,overrides:D}}compareAndUpdateFolderConfiguration(u,d){const b=this.folderConfigurations.get(u),{added:f,updated:D,removed:L,overrides:p}=h(b,d),y=[...f,...D,...L];return(y.length||!b)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:p}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:b,updated:f,removed:D,overrides:L}=h(d,void 0);return{keys:[...b,...f,...D],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,b){let f=this.q(d,b);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let b=this.r();if(d&&u){const f=d.getFolder(u);f&&(b=this.s(f.uri)||b);const D=this.m.get(u);D&&(b=b.merge(D))}return b}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const b=this.r(),f=this.j.get(u);f?(d=b.merge(f),this.b.set(u,d)):d=b}return d}t(u,d){if(d&&u){const b=d.getFolder(u);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:b,overrides:f,keys:D}=this.j.get(d);return u.push([d,{contents:b,overrides:f,keys:D}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(b=>u.add(b))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(b=>u.add(b))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.i.getKeysForOverrideIdentifier(u).forEach(b=>d.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),b=this.w(u.policy),f=this.w(u.application),D=this.w(u.user),L=this.w(u.workspace),p=u.folders.reduce((y,S)=>(y.set(w.URI.revive(S[0]),this.w(S[1])),y),new R.$Ac);return new n(d,b,f,D,new v,L,p,new v,new R.$Ac)}static w(u){return new v(u.contents,u.keys,u.overrides)}}e.$Pn=n;function o(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const u=new Set,d=new Map;for(const f of r)f.keys.forEach(D=>u.add(D)),f.overrides.forEach(([D,L])=>{const p=(0,R.$xc)(d,D,new Set);L.forEach(y=>p.add(y))});const b=[];return d.forEach((f,D)=>b.push([D,[...f.values()]])),{keys:[...u.values()],overrides:b}}e.$Qn=o;class c{constructor(u,d,b,f){this.change=u,this.f=d,this.g=b,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of u.keys)this.affectedKeys.add(D);for(const[,D]of u.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const b=this.a+u,f=this.d.indexOf(b);if(f<0)return!1;const D=f+b.length;if(D>=this.d.length)return!1;const L=this.d.charCodeAt(D);if(L!==this.b&&L!==this.c)return!1;if(d){const p=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!m.$jn(p,y)}return!0}}e.$Rn=c;function h(r,u){const{added:d,removed:b,updated:f}=i(u?.rawConfiguration,r?.rawConfiguration),D=[],L=r?.getAllOverrideIdentifiers()||[],p=u?.getAllOverrideIdentifiers()||[];if(u){const y=p.filter(S=>!L.includes(S));for(const S of y)D.push([S,u.getKeysForOverrideIdentifier(S)])}if(r){const y=L.filter(S=>!p.includes(S));for(const S of y)D.push([S,r.getKeysForOverrideIdentifier(S)])}if(u&&r){for(const y of L)if(p.includes(y)){const S=i({contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});D.push([y,[...S.added,...S.removed,...S.updated]])}}return{added:d,removed:b,updated:f,overrides:D}}function i(r,u){const d=r?u?r.keys.filter(D=>u.keys.indexOf(D)===-1):[...r.keys]:[],b=u?r?u.keys.filter(D=>r.keys.indexOf(D)===-1):[...u.keys]:[],f=[];if(r&&u){for(const D of u.keys)if(r.keys.indexOf(D)!==-1){const L=(0,A.$Ci)(u.contents,D),p=(0,A.$Ci)(r.contents,D);m.$jn(L,p)||f.push(D)}}return{added:d,removed:b,updated:f}}}),define(Pe[100],Ae([1,0,11,4]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.RemoteAuthorityResolverErrorCode=e.$3k=e.$2k=e.RemoteConnectionType=e.$1k=void 0,e.$1k=(0,T.$1h)("remoteAuthorityResolverService");var C;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class F{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$2k=F;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$3k=R;var m;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends E.$bb{static isNotAvailable(k){return k instanceof g&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,l=m.Unknown,$){super(k),this._message=k,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,g.prototype)}}e.$4k=g;function w(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$5k=w}),define(Pe[55],Ae([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$6k=T;function C(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$7k=C;function F(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$8k=F;function R(w){const{host:A,port:k}=g(w);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.$9k=R;function m(w,A){let{host:k,port:l}=g(w);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$0k=m;function g(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[22],Ae([1,0,12,4,55]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.TargetPlatform=e.ExtensionType=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l="extensions.user.cache",e.$_l="extensions.builtin.cache",e.$am="undefined_publisher",e.$bm=["ui","workspace","web"];function F(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$cm=F,e.$dm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,t){if(typeof s>"u"||s===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof s=="string"||typeof t=="string"){const n=typeof s=="string"?s:s.value,o=typeof t=="string"?t:t.value;return E.$7e(n,o)}return s._lower===t._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$em=g;class w{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const t of s)this.add(t)}add(s){this.c.add(g.toKey(s))}delete(s){return this.c.delete(g.toKey(s))}has(s){return this.c.has(g.toKey(s))}}e.$fm=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(g.toKey(s))}get(s){return this.c.get(g.toKey(s))}has(s){return this.c.has(g.toKey(s))}set(s,t){this.c.set(g.toKey(s),t)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$gm=A;function k(a){return l(a)}e.$hm=k;function l(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.$im=l;function $(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.$jm=$;function v(a,s){if(s){const t=`onResolveRemoteAuthority:${(0,C.$7k)(s)}`;return!!a.activationEvents?.includes(t)}return!1}e.$km=v,e.$lm=(0,T.$1h)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const g of R){const w=this.readActivationEvents(g);w.length>0&&(m[T.$em.toKey(g.identifier)]=w)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${T.$em.toKey(R.identifier)}`);if(!R.contributes)return m;for(const g in R.contributes){const w=this.a.get(g);if(!w)continue;const A=R.contributes[g],k=Array.isArray(A)?A:[A];try{w(k,m)}catch(l){(0,E.$1)(l)}}return m}}e.$CF=C,e.$DF=new C}),define(Pe[190],Ae([1,0,21,74,33]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=void 0;function F(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,w,A,k,l,$,v,a,s){const t=Object.create(null);t["common.machineId"]=$,t["common.sqmId"]=v,t.sessionID=(0,C.$lg)()+Date.now(),t.commitHash=k,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$dc,t["common.nodeArch"]=A,t["common.product"]=s||"desktop",a&&(t["common.msftInternal"]=a);let n=0;const o=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=F(w);return c&&(t["common.platformDetail"]=c),t}e.$so=R;function m(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return g.some(k=>A===k)}e.$to=m}),define(Pe[191],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=void 0,e.$nl=(0,E.$1h)("telemetryService"),e.$ol=(0,E.$1h)("customEndpointTelemetryService"),e.$pl="telemetry.currentSessionDate",e.$ql="telemetry.firstSessionDate",e.$rl="telemetry.lastSessionDate",e.$sl="telemetry.machineId",e.$tl="telemetry.sqmId",e.$ul="telemetry",e.$vl="telemetry.telemetryLevel",e.$wl="telemetry.enableCrashReporter",e.$xl="telemetry.enableTelemetry";var T;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[56],Ae([1,0,26,16,5,41,55,190,191]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0;class w{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$uo=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vo=A,e.$wo=new A;class k{async publicLog(b,f,D){}async publicLogError(b,f,D){}}e.$xo=k,e.$yo="telemetry",e.$zo="extensionTelemetryLog",e.$Ao={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,b){return C.Event.debounce(b.onDidChangeConfiguration,(D,L)=>{const p=D?new Set([...D.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:p}},1e3,!0)(D=>{D.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,F.$xi)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$Bo=l;function $(d,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!d.enableTelemetry)}e.$Co=$;function v(d,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Do=v;function a(d){const b=d.getValue(g.$vl),f=d.getValue(g.$wl);if(d.getValue(g.$xl)===!1||f===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Eo=a;function s(d){const b={},f={},D={};o(d,D);for(let L in D){L=L.length>150?L.substr(L.length-149):L;const p=D[L];typeof p=="number"?f[L]=p:typeof p=="boolean"?f[L]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${p.length}`),b[L]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(b[L]=p)}return{properties:b,measurements:f}}e.$Fo=s;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const b=(0,R.$7k)(d);return t.has(b)?b:"other"}e.$Go=n;function o(d,b,f=0,D){if(d)for(const L of Object.getOwnPropertyNames(d)){const p=d[L],y=D?D+L:L;Array.isArray(p)?b[y]=(0,E.$kn)(p):p instanceof Date?b[y]=p.toISOString():(0,T.$Ff)(p)?f<2?o(p,b,f+1,y+"."):b[y]=(0,E.$kn)(p):b[y]=p}}function c(d,b){const f=d.msftInternalDomains||[],D=b.getValue("telemetry.internalTesting");return(0,m.$to)(f)||D}e.$Ho=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Io=h;function i(d,b){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const D=[];for(const S of b)for(;;){const N=S.exec(d);if(!N)break;D.push([N.index,S.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const S=p.exec(d);if(!S)break;const N=D.some(([q,j])=>S.index<j&&q<p.lastIndex);!L.test(S[0])&&!N&&(f+=d.substring(y,S.index)+"<REDACTED: user-file-path>",y=p.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function r(d){if(!d)return d;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of b)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,b){return(0,E.$hn)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let D=f.replaceAll("%20"," ");D=i(D,b);for(const L of b)D=D.replace(L,"");return D=r(D),D}})}e.$Jo=u}),define(Pe[192],Ae([1,0,12,97,22,21,2,11,74,56]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0;function A(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$2e)(u.id,d.id)===0}e.$Ko=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const b=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,b,f)}static parse(d){const b=k.exec(d);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(d,b,f="undefined"){this.version=b,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Lo=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(u){const d=$.exec(u);return d&&d[1]?[s(d[1]),d[2]]:[s(u),void 0]}e.$Mo=v;function a(u,d){return`${u}.${d}`}e.$No=a;function s(u){return u.toLowerCase()}e.$Oo=s;function t(u,d){return s(a(u??C.$am,d))}e.$Po=t;function n(u,d){const b=[],f=D=>{for(const L of b)if(L.some(p=>A(d(p),d(D))))return L;return null};for(const D of u){const L=f(D);L?L.push(D):b.push([D])}return b}e.$Qo=n;function o(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Ro=o;function c(u){return{id:new w.$uo(u.identifier.id),name:new w.$uo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$So=c,e.$To=new C.$em("pprice.better-merge");function h(u,d){const b=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const D=f.shift();if(D&&b.every(L=>!A(L.identifier,{id:D}))){const L=u.filter(p=>A(p.identifier,{id:D}));L.length===1&&(b.push(L[0]),f.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$Uo=h;async function i(u,d){if(!F.$k)return!1;let b;try{b=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){d.debug("Error while getting the os-release file.",(0,m.$0)(D))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(u,d){const b=await i(u,d),f=(0,T.$eo)(b?"alpine":F.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$Vo=r}),define(Pe[193],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.$yr=e.$xr=e.$wr=e.$vr=void 0;function E(g){return[...g.entries()]}e.$vr=E;function T(g){return g?[...g.entries()]:[]}e.$wr=T;function C(g){return new Map(g)}e.$xr=C;function F(g){return new Map(g??[])}e.$yr=F;function R(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$zr=R;function m(g){return new Map(g.map(w=>[w[0],{map:C(w[1]),descriptionMap:F(w[2])}]))}e.$Ar=m}),define(Pe[194],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrb=void 0;class E{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,R=5){const m=F(g=>{const w=typeof g=="string"?g:g.data;let A=this.a.get(C);if(A){A.data.push(w);return}const k=setTimeout(()=>this.flushBuffer(C),R);A={data:[w],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),m.dispose()}},this.a.set(C,A)});return m}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.$jrb=E}),define(Pe[195],Ae([1,0,14,90,45,5,16,2,154,73,30]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.IconFontDefinition=e.IconContribution=e.$fw=void 0,e.$fw={IconContribution:"base.contributions.icons"};var k;(function(c){function h(i,r){let u=i.defaults;for(;C.ThemeIcon.isThemeIcon(u);){const d=v.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(r){return{weight:r.weight,style:r.style,src:r.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(r){const u=d=>(0,R.$Df)(d)?d:void 0;if(r&&Array.isArray(r.src)&&r.src.every(d=>(0,R.$Df)(d.format)&&(0,R.$Df)(d.location)))return{weight:u(r.weight),style:u(r.style),src:r.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new F.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,r,u){const d=this.b[h];if(d){if(r&&!d.description){d.description=r,this.d.properties[h].markdownDescription=`${r} $(${h})`;const D=this.e.enum.indexOf(h);D!==-1&&(this.e.enumDescriptions[D]=r),this.a.fire()}return d}const b={id:h,description:r,defaults:i,deprecationMessage:u};this.b[h]=b;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),r&&(f.markdownDescription=`${r}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const r=this.f[h];return r||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,b)=>d.id.localeCompare(b.id),i=d=>{for(;C.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(b=>!!b.description).sort(h))r.push(`|<i class="${i(d)}"></i>|${d.id}|${C.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const d of u.filter(b=>!C.ThemeIcon.isThemeIcon(b.defaults)).sort(h))r.push(`|<i class="${i(d)}"></i>|${d.id}|`);return r.join(`
`)}}const v=new $;A.$rn.add(e.$fw.IconContribution,v);function a(c,h,i,r){return v.registerIcon(c,h,i,r)}e.$gw=a;function s(){return v}e.$hw=s;function t(){const c=(0,T.$4j)();for(const h in c){const i="\\"+c[h].toString(16);v.registerIcon(h,{fontCharacter:i})}}t(),e.$iw="vscode://schemas/icons";const n=A.$rn.as(w.$sn.JSONContribution);n.registerSchema(e.$iw,v.getIconSchema());const o=new E.$ah(()=>n.notifySchemaChanged(e.$iw),200);v.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$jw=a("widget-close",T.$6j.close,(0,g.localize)(2,null)),e.$kw=a("goto-previous-location",T.$6j.arrowUp,(0,g.localize)(3,null)),e.$lw=a("goto-next-location",T.$6j.arrowDown,(0,g.localize)(4,null)),e.$mw=C.ThemeIcon.modify(T.$6j.sync,"spin"),e.$nw=C.ThemeIcon.modify(T.$6j.loading,"spin")}),define(Pe[196],Ae([1,0,5,41,4,15]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.ProvidedOnAutoForward=e.$lv=e.TunnelPrivacyId=e.TunnelProtocol=e.$kv=e.$jv=void 0,e.$jv=(0,C.$1h)("tunnelService"),e.$kv=(0,C.$1h)("sharedTunnelsService");var R;(function(s){s.Http="http",s.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(m||(e.TunnelPrivacyId=m={}));function g(s){return!!s.forwardPort}e.$lv=g;var w;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}e.$mv=A,e.$nv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(s){return e.$nv.indexOf(s)>=0}e.$ov=k,e.$pv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(s){return e.$pv.indexOf(s)>=0}e.$qv=l;function $(s,t,n,o){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return s<1024}e.$rv=$;class v{constructor(t,n,o){this.remoteAddress=t,this.localAddress=n,this.b=o,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$sv=v;let a=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,o,c,h){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||k(t))&&(t=e.$nv[0]);const o=this.r(t,n);if(o)return++o.refcount,o.value}openTunnel(t,n,o,c,h,i=!1,r,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.s(d,n,o,c,h,i,r,u);return b?b.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,o),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&f.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const o=n.get(t.tunnelRemotePort);o&&(o.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,o))}}}}async o(t,n,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const o=this.e.get(t);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,o){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:o})}async q(t,n){const o=this.e.get(t);if(o){const c=o.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&o.delete(n),o.size===0&&this.e.delete(t)}}r(t,n){const o=[t];k(t)?(o.push(...e.$nv),o.push(...e.$pv)):l(t)&&o.push(...e.$pv);const c=o.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}t(t,n,o,c,h,i,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const u=o;this.i.add(u);const d=c===void 0?o:c,b={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:i,public:i?i!==m.Private:void 0,protocol:r},D=t.forwardPort(f,b);return D?(this.p(n,o,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),D}};e.$tv=a,e.$tv=a=He([Ve(0,F.$ij),Ve(1,T.$ui)],a)}),define(Pe[197],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$uv=void 0,e.$uv=(0,E.$1h)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Ae([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$cK=T;function C(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$dK=C;function F(g){return C(g)?.scheme}e.$eK=F;function R(g){return C(g)?.authority}e.$fK=R;function m(g){return C(g)!==void 0}e.$gK=m}),define(Pe[47],Ae([1,0,155,19,50,25,2,4,13]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.WorkbenchState=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0,e.$0h=(0,m.$1h)("contextService");function w(d){const b=d;return typeof b?.id=="string"&&R.URI.isUri(b.uri)}e.$$h=w;function A(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$_h=A,e.$ai={id:"ext-dev"},e.$bi={id:"empty-window"};function k(d,b){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$nc)(d)}:b?e.$ai:e.$bi;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$ci=k;function l(d){const b=d;return typeof b?.id=="string"&&R.URI.isUri(b.configPath)}e.$di=l;function $(d){const b=d;if(b?.uri)return{id:b.id,uri:R.URI.revive(b.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$ei=$;var v;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function a(d){const b=d;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$fi=a;function s(d){const b=d;return!!(b&&typeof b=="object"&&R.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$gi=s;class t{constructor(b,f,D,L,p){this.h=b,this.j=D,this.k=L,this.l=p,this.c=C.$7h.forUris(this.l,()=>!0),this.folders=f}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=C.$7h.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$hi=t;class n{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,F.$Cg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ii=n;function o(d){return new n({uri:d,index:0,name:(0,F.$yg)(d)},{uri:d.toString()})}e.$ji=o,e.$ki="code-workspace",e.$li=`.${e.$ki}`,e.$mi=[{name:(0,E.localize)(0,null),extensions:[e.$ki]}],e.$ni="workspace.json";function c(d,b){return F.$tg.isEqualOrParent(d,b.untitledWorkspacesHome)}e.$oi=c;function h(d){let b;return R.URI.isUri(d)?b=d:b=d.configuration,b?.scheme===g.Schemas.tmp}e.$pi=h,e.$qi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$qi}e.$ri=i;function r(d,b){return!c(d,b)&&!h(d)}e.$si=r;function u(d){return(typeof d=="string"?(0,T.$oc)(d):(0,F.$Ag)(d))===e.$li}e.$ti=u}),define(Pe[75],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class E{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Nec=E}),define(Pe[43],Ae([1,0,13,25,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=void 0;class F{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$rg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Qec=F,e.$Rec=(0,C.$1h)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0,e.$ZM=(0,E.$1h)("IExtHostInitDataService")}),define(Pe[199],Ae([1,0,160,15,186,27]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;let R=class extends C.$7N{constructor(g,w,A){const k=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(k,{name:l}))}};e.$Xgc=R,e.$Xgc=R=He([Ve(1,T.$jj),Ve(2,F.$ZM)],R)}),define(Pe[200],Ae([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0;class T{constructor(R,m,g){this.h=new Map,this.a=R,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$ah(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const k of w.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let g=this.f[R];return typeof g>"u"&&(g=m),g}update(R,m){this.f[R]=m;const g=this.h.get(R);if(g!==void 0)return g.p;const w=new E.$lh;return this.h.set(R,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$zfc=T;class C extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$Afc=C}),define(Pe[201],Ae([1,0,5,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class C{constructor(R){this.c=R,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,g,w){const k=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(m.value,g,w);this.b.fire(k)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$ngc=C}),define(Pe[17],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0,e.$JM=(0,E.$1h)("IExtHostRpcService");class T{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$KM=T}),define(Pe[202],Ae([1,0,22,5]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class C{#e;constructor(R,m){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=E.$em.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$Hfc=C}),define(Pe[57],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0,e.$0ec=(0,E.$1h)("IURITransformerService");class T{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$$ec=T}),define(Pe[203],Ae([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkb=e.$Mkb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function C(m,g){if(g.serializeBuffersForPostMessage){const w=new T,k=JSON.stringify(m,($,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v)};if(ArrayBuffer.isView(v)){const a=F(v);if(a)return{$$vscode_array_buffer_reference$$:!0,index:w.add(v.buffer),view:{type:a,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=w.buffers.map($=>{const v=new Uint8Array($);return E.$ge.wrap(v)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$Mkb=C;function F(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,g){const w=g.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),A=g.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const v=$,{index:a}=v,s=w[a];if(v.view)switch(v.view.type){case 1:return new Int8Array(s,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return $}:void 0;return{message:JSON.parse(m,A),arrayBuffers:w}}e.$Nkb=R}),define(Pe[102],Ae([1,0,170,16,2,6,4,30,42,13,40,133,31]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IE=e.$HE=e.$GE=e.EditorsOrder=e.$FE=e.CloseDirection=e.$EE=e.$DE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.EditorInputCapabilities=e.$uE=e.SaveReason=e.Verbosity=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=void 0,e.$hE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$iE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$jE="workbench.editor.sidebysideEditor",e.$kE="workbench.editors.textDiffEditor",e.$lE="workbench.editors.binaryResourceDiffEditor";var $;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var v;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function a(ce){const X=ce;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$mE=a;function s(ce,X,V){for(const re of V.visibleEditorPanes)if(re.group.id===X&&ce.matches(re.input))return re.getViewState()}e.$nE=s;function t(ce){if(D(ce))return!1;const X=ce;return C.URI.isUri(X?.resource)}e.$oE=t;function n(ce){if(D(ce))return!1;const X=ce;return X?.original!==void 0&&X.modified!==void 0}e.$pE=n;function o(ce){if(D(ce))return!1;const X=ce;return Array.isArray(X?.resources)}e.$qE=o;function c(ce){if(D(ce)||n(ce))return!1;const X=ce;return X?.primary!==void 0&&X.secondary!==void 0}e.$rE=c;function h(ce){if(D(ce))return!1;const X=ce;return X?X.resource===void 0||X.resource.scheme===w.Schemas.untitled||X.forceUntitled===!0:!1}e.$sE=h;function i(ce){if(D(ce))return!1;const X=ce;return C.URI.isUri(X?.base?.resource)&&C.URI.isUri(X?.input1?.resource)&&C.URI.isUri(X?.input2?.resource)&&C.URI.isUri(X?.result?.resource)}e.$tE=i;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var u;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(X,V){let re=this.a.get(X);return re||(re={source:X,label:V},this.a.set(X,re)),re.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$uE=new d;var b;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class f extends F.$Sc{}e.$vE=f;function D(ce){return ce instanceof f}e.$wE=D;function L(ce){const X=ce;return C.URI.isUri(X?.preferredResource)}function p(ce){const X=ce;return D(X?.primary)&&D(X?.secondary)}e.$xE=p;function y(ce){const X=ce;return D(X?.modified)&&D(X?.original)}e.$yE=y;function S(ce,X,V,re,Ie){return Se(re,[(0,k.$Ki)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Re={...V,limits:{size:Number.MAX_VALUE}};ce.openEditor(X,Re)}}),(0,k.$Ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$zE=S;function N(ce){return D(ce?.editor)}e.$AE=N;function q(ce){const X=ce;return N(ce)&&X?.group!==void 0}e.$BE=q;function j(ce){const X=ce;return typeof X?.groupId=="number"&&D(X.editor)}e.$CE=j;var M;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var P;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class I{getOriginalUri(X,V){if(!X)return;if(i(X))return e.$EE.getOriginalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Re}=this.a(X);if(Ie&&Re){if(V?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Re,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Re,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===P.PRIMARY?Ie:Re}}if(n(X)||o(X)||c(X)||i(X))return;const re=L(X)?X.preferredResource:X.resource;return!re||!V||!V.filterByScheme?re:this.b(re,V.filterByScheme)}a(X){return p(X)||c(X)?{primary:X.primary,secondary:X.secondary}:y(X)||n(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,V){if(!X)return;if(i(X))return e.$EE.getCanonicalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Re}=this.a(X);if(Ie&&Re){if(V?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Re,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Re,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===P.PRIMARY?Ie:Re}}if(n(X)||o(X)||c(X)||i(X))return;const re=X.resource;return!re||!V||!V.filterByScheme?re:this.b(re,V.filterByScheme)}b(X,V){if(Array.isArray(V)){if(V.some(re=>X.scheme===re))return X}else if(V===X.scheme)return X}}var Z;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function ue(ce,X,V,re){if(!ce.isSticky(X))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return V===Z.MOUSE||V===Z.KEYBOARD;case"mouse":return V===Z.MOUSE;case"keyboard":return V===Z.KEYBOARD}return!1}e.$DE=ue,e.$EE=new I;var ge;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(ge||(e.CloseDirection=ge={}));class be{constructor(){this.c=new Map,this.d=new Map}start(X){const V=this.a=X.get(R.$Zh);for(const[re,Ie]of this.c)this.e(re,Ie,V);this.c.clear()}e(X,V,re){const Ie=re.createInstance(V);this.d.set(X,Ie)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,T.$Of)(this.b)}registerEditorSerializer(X,V){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,V,this.a):this.c.set(X,V),(0,F.$Qc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}m.$rn.add(e.$hE.EditorFactory,new be);async function ke(ce,X,V){return!ce||!ce.length?[]:await Promise.all(ce.map(async re=>{const Ie=C.URI.revive(re.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",re);return}if(!await X.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",re);return}let Ce=re.exists,le=re.type;if(typeof Ce!="boolean"||typeof le!="number")try{le=(await X.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(G){V.error(G),Ce=!1}if(!Ce&&re.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",re);return}if(le===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",re);return}const ie={...re.options,pinned:!0};return Ce?{resource:Ie,options:ie}:{resource:Ie,options:ie,forceUntitled:!0}}))}e.$FE=ke;var me;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function fe(ce){const X=ce;if(!X)return!1;const V=X;if(V.modified)return fe(V.modified);const re=X;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$GE=fe;function ne(ce){return(0,A.$Mi)(ce)}e.$HE=ne;function Se(ce,X,V){const re=(0,A.$Ni)(ce,X);return re.forceMessage=V?.forceMessage,re.forceSeverity=V?.forceSeverity,re.allowDialog=V?.allowDialog,re}e.$IE=Se}),define(Pe[204],Ae([1,0,5,171,4,6,28,30,18,26,90,195]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$PE=e.$OE=e.ViewContentGroups=e.$NE=e.$ME=e.ViewContainerLocation=e.Extensions=e.$LE=e.$KE=e.$JE=void 0,e.$JE="views",e.$KE=(0,T.localize)(0,null),e.$LE=(0,k.$gw)("default-view-icon",A.$6j.window,(0,T.localize)(1,null));var l;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$ME=[0,1,2];function v(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$NE=v;class a extends F.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,b){const f=this.get(u.id);if(f)return f;const D=u;return D.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,R.$xc)(this.g,d,[]).push(D),b?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:d}),D}deregisterViewContainer(u){for(const d of this.g.keys()){const b=this.g.get(d),f=b?.indexOf(u);if(f!==-1){b?.splice(f,1),b.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(b=>b?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}m.$rn.add(l.ViewContainersRegistry,new a);var s;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(s||(e.ViewContentGroups=s={}));function t(r,u){const d=r.group??s.More,b=u.group??s.More;return d!==b?d.localeCompare(b):(r.order??5)-(u.order??5)}class n extends F.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:b})=>this.r(d,b)),this.c.fire(u)}deregisterViews(u,d){const b=this.s(u,d);b.length&&this.f.fire({views:b,viewContainer:d})}moveViews(u,d){for(const b of this.m.keys())if(b!==d){const f=this.s(u,b);f.length&&(this.r(f,d),this.g.fire({views:f,from:b,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const b=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(b)return b}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,F.$Qc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const b=new Map;for(const[f,D]of d)this.n.add(u,D),b.set(f,(0,F.$Qc)(()=>{this.n.delete(u,D),this.h.fire(u)}));return this.h.fire(u),b}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,b=>d.push(b)),d.sort(t)}r(u,d){let b=this.m.get(d);b||(b=[],this.m.set(d,b),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));b.push(f)}}s(u,d){const b=this.m.get(d);if(!b)return[];const f=[],D=[];for(const L of b)u.includes(L)?f.push(L):D.push(L);return f.length&&(D.length?this.m.set(d,D):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}m.$rn.add(l.ViewsRegistry,new n),e.$OE=(0,C.$1h)("viewsService"),e.$PE=(0,C.$1h)("viewDescriptorService");var o;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$in)(this,u),this.d=!!d,this.resolve=async b=>{if(d&&!this.c){const f=await d(b);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$QE=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$RE=i}),define(Pe[205],Ae([1,0,2,29,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$eF=e.$dF=void 0;function F(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Es.isIRange)}e.$dF=F;function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(F)}e.$eF=R;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.InteractiveSessionCopyKind=g={})),e.$fF=(0,C.$1h)("IChatService")}),define(Pe[206],Ae([1,0,5,14,172]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,g,w,A){const k={command:m};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.s("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(k.seq);if($){this.f.delete(k.seq);const v={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,C.localize)(0,null,A,m)};$(v)}},A)}return w&&this.f.set(k.seq,w),k.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,g){return m.type!=="event"||g.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,T.$2g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,w)=>m.set(w,g)),await(0,T.$2g)(500),m.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$glb=F}),define(Pe[207],Ae([1,0,173,35,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$qH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$pH=e.MemoryRangeType=e.$oH=e.State=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=void 0,e.$lG="workbench.view.debug",e.$mG="workbench.debug.variablesView",e.$nG="workbench.debug.watchExpressionsView",e.$oG="workbench.debug.callStackView",e.$pG="workbench.debug.loadedScriptsView",e.$qG="workbench.debug.breakPointsView",e.$rG="workbench.debug.disassemblyView",e.$sG="workbench.panel.repl",e.$tG="workbench.panel.repl.view",e.$uG=new T.$fj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$vG=new T.$fj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$wG=new T.$fj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$xG="debugUx",e.$yG=new T.$fj(e.$xG,"default",{type:"string",description:E.localize(3,null)}),e.$zG=new T.$fj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$AG=new T.$fj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$BG=new T.$fj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$CG=new T.$fj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$DG=new T.$fj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$EG=new T.$fj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$FG=new T.$fj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$GG=new T.$fj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$HG=new T.$fj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$IG=new T.$fj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$JG=new T.$fj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$KG=new T.$fj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$LG=new T.$fj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$MG=new T.$fj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$NG=new T.$fj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$OG=new T.$fj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$PG=new T.$fj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$QG=new T.$fj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$RG=new T.$fj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$SG=new T.$fj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$TG=new T.$fj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$UG=new T.$fj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$VG=new T.$fj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$WG=new T.$fj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$XG=new T.$fj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$YG=new T.$fj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$ZG=new T.$fj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$1G=new T.$fj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$2G=new T.$fj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$3G=new T.$fj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$4G=new T.$fj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$5G=new T.$fj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$6G=new T.$fj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$7G=new T.$fj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$8G=new T.$fj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$9G=new T.$fj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$0G=new T.$fj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$$G=new T.$fj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$_G=new T.$fj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$aH=new T.$fj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$bH=new T.$fj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$cH=new T.$fj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$dH=new T.$fj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$eH=new T.$fj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$fH=new T.$fj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$gH=new T.$fj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$hH=new T.$fj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$iH=new T.$fj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const F=l=>E.localize(52,null,l);e.$jH=F,e.$kH="editor.contrib.debug",e.$lH="editor.contrib.breakpoint",e.$mH="debug",e.$nH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$oH=m;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$pH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$qH=(0,C.$1h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[208],Ae([1,0,12,2,19,26,13,29,20,18]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=void 0;const A=/{([^}]+)}/g;function k(L,p,y){return L.replace(A,function(S,N){return p&&N.length>0&&N[0]!=="_"?S:y&&y.hasOwnProperty(N)?y[N]:S})}e.$kF=k;function l(L){const p={};for(const y of Object.keys(L))y.startsWith("!")||(p[y]=L[y]);return p}e.$lF=l;function $(L){return L.configuration.request==="attach"&&!v(L)&&(!L.parentSession||$(L.parentSession))}e.$mF=$;function v(L){let p=L.configuration.type;if(p)return p==="vslsShare"&&(p=L.configuration.adapterProxy.configuration.type),(0,E.$7e)(p,"extensionhost")||(0,E.$7e)(p,"pwa-extensionhost")?L:L.parentSession?v(L.parentSession):void 0}e.$nF=v;function a(L){return L.type&&(L.label||L.program||L.runtime)}e.$oF=a;function s(L,p,y){let S,N=0;const q=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=q.exec(L);){const M=j.index+1,U=M+j[0].length;if(M<=p&&U>=y){S=j[0],N=M;break}}if(S){const M=/\w+/g;let U=null;for(;(U=M.exec(S))&&!(U.index+1+N+U[0].length>=y););U&&(S=S.substring(0,M.lastIndex))}return S?{start:N,end:N+S.length-1}:{start:0,end:0}}e.$pF=s;async function t(L,p,y,S){if(L.evaluatableExpressionProvider.has(p)){const N=L.evaluatableExpressionProvider.ordered(p),q=(0,w.$Hb)(await Promise.all(N.map(async j=>{try{return await j.provideEvaluatableExpression(p,y,S??g.CancellationToken.None)}catch{return}})));if(q.length>0){let j=q[0].expression;const M=q[0].range;return j||(j=p.getLineContent(y.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:j}}}else{const N=p.getLineContent(y.lineNumber),{start:q,end:j}=s(N,y.column,y.column),M=N.substring(q-1,j);return{matchingExpression:M,range:new m.$Es(y.lineNumber,q,y.lineNumber,q+M.length)}}return null}e.$qF=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(L){return!!(L&&L.match(n))}e.$rF=o;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(o(L.path))return T.URI.parse(L.path);if((0,C.$ic)(L.path))return T.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const p=T.URI.revive(L.path);if(p)return p.scheme===R.Schemas.file?p.fsPath:p.toString()}return L.path}function i(L,p){const y=p?c:h,S=(0,F.$fn)(L);return u(S,(N,q)=>{N&&q&&(q.path=y(q))}),S}e.$sF=i;function r(L,p){const y=p?c:h,S=(0,F.$fn)(L);return u(S,(N,q)=>{!N&&q&&(q.path=y(q))}),S}e.$tF=r;function u(L,p){switch(L.type){case"event":{const y=L;switch(y.event){case"output":p(!1,y.body.source);break;case"loadedSource":p(!1,y.body.source);break;case"breakpoint":p(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=L;switch(y.command){case"setBreakpoints":p(!0,y.arguments.source);break;case"breakpointLocations":p(!0,y.arguments.source);break;case"source":p(!0,y.arguments.source);break;case"gotoTargets":p(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(S=>p(!1,S));break;default:break}break}case"response":{const y=L;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(S=>p(!1,S.source));break;case"loadedSources":y.body.sources.forEach(S=>p(!1,S));break;case"scopes":y.body.scopes.forEach(S=>p(!1,S.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(S=>p(!1,S.source));break;case"setBreakpoints":y.body.breakpoints.forEach(S=>p(!1,S.source));break;case"disassemble":y.body?.instructions.forEach(N=>p(!1,N.location));break;default:break}break}}}function d(L){return L.filter(p=>!p.presentation?.hidden).sort((p,y)=>p.presentation?y.presentation?p.presentation.group?y.presentation.group?p.presentation.group!==y.presentation.group?p.presentation.group.localeCompare(y.presentation.group):b(p.presentation.order,y.presentation.order):-1:y.presentation.group?1:b(p.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$uF=d;function b(L,p){return typeof L!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:L-p}async function f(L,p){const y=L.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(y!=="none"&&(await p.saveAll(),y==="allEditorsInActiveGroup")){const S=p.activeEditorPane;S&&S.input.resource?.scheme===R.Schemas.untitled&&await p.save({editor:S.input,groupId:S.group.id})}await L.reloadConfiguration()}e.$vF=f;const D=(L,p)=>!L||!p?L===p:L.name===p.name&&L.path===p.path&&L.sourceReference===p.sourceReference;e.$wF=D}),define(Pe[76],Ae([1,0,24,34,67,68,13,19,21,35]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=e.$KI=e.$JI=e.$II=e.CellStatusbarAlignment=e.$HI=e.$GI=e.$FI=e.NotebookEditorPriority=e.$EI=e.$DI=e.$CI=e.$BI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$AI=e.$zI=e.$yI=e.$xI=e.CellKind=e.$wI=e.$vI=e.$uI=void 0,e.$uI="workbench.editor.notebook",e.$vI="workbench.editor.notebookTextDiffEditor",e.$wI="workbench.editor.interactive";var A;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(A||(e.CellKind=A={})),e.$xI=["application/json","application/javascript","text/html","image/svg+xml",F.$1r.latex,F.$1r.markdown,"image/png","image/jpeg",F.$1r.text],e.$yI=[F.$1r.latex,F.$1r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$1r.text],e.$zI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$AI="_notAvailable";var k;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var l;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var $;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var v;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var a;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeCellLanguage=5]="ChangeCellLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var t;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(I){I.scheme=R.Schemas.vscodeNotebookCell;const Z=["W","X","Y","Z","a","b","c","d","e","f"],ue=new RegExp(`^[${Z.join("")}]+`),ge=7;function be(ce,X){const V=X.toString(ge),Ie=`${V.length<Z.length?Z[V.length-1]:"z"}${V}s${(0,E.$Ae)(E.$ge.fromString(ce.scheme),!0,!0)}`;return ce.with({scheme:I.scheme,fragment:Ie})}I.generate=be;function ke(ce){if(ce.scheme!==I.scheme)return;const X=ce.fragment.indexOf("s");if(X<0)return;const V=parseInt(ce.fragment.substring(0,X).replace(ue,""),ge),re=(0,E.$ze)(ce.fragment.substring(X+1)).toString();if(!isNaN(V))return{handle:V,notebook:ce.with({scheme:re,fragment:null})}}I.parse=ke;function me(ce,X){return ce.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${ce.scheme!==R.Schemas.file?ce.scheme:""}`})}I.generateCellOutputUri=me;function fe(ce){if(ce.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ce.fragment);if(!X)return;const V=X[1]&&X[1]!==""?X[1]:void 0,re=X[2];return{outputId:V,notebook:ce.with({scheme:re||R.Schemas.file,fragment:null})}}I.parseCellOutputUri=fe;function ne(ce,X,V){return I.generate(ce,X).with({scheme:V})}I.generateCellPropertyUri=ne;function Se(ce,X){if(ce.scheme===X)return I.parse(ce.with({scheme:I.scheme}))}I.parseCellPropertyUri=Se})(o||(e.CellUri=o={}));const c=I=>g.$i?I.replace(/\//g,"\\"):I;class h{constructor(Z=[],ue=e.$xI){this.e=ue,this.d=[...new Set(Z)].map(ge=>({pattern:ge,matches:T.$Hj(c(ge))}))}sort(Z){const ue=new Map(C.Iterable.map(Z,be=>[be,c(be)]));let ge=[];for(const{matches:be}of this.d)for(const[ke,me]of ue)if(be(me)){ge.push(ke),ue.delete(ke);break}return ue.size&&(ge=ge.concat([...ue.keys()].sort((be,ke)=>this.e.indexOf(be)-this.e.indexOf(ke)))),ge}prioritize(Z,ue){const ge=this.f(Z);if(ge===-1){this.d.unshift({pattern:Z,matches:T.$Hj(c(Z))});return}const be=new Set(ue.map(me=>this.f(me,ge)));be.delete(-1);const ke=Array.from(be).sort();this.d.splice(ge+1,0,...ke.map(me=>this.d[me]));for(let me=ke.length-1;me>=0;me--)this.d.splice(ke[me],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,ue=this.d.length){const ge=c(Z);for(let be=0;be<ue;be++)if(this.d[be].matches(ge))return be;return-1}}e.$BI=h;function i(I,Z,ue,ge=(be,ke)=>be===ke){const be=[];function ke(ne,Se,ce){if(Se===0&&ce.length===0)return;const X=be[be.length-1];X&&X.start+X.deleteCount===ne?(X.deleteCount+=Se,X.toInsert.push(...ce)):be.push({start:ne,deleteCount:Se,toInsert:ce})}let me=0,fe=0;for(;;){if(me===I.length){ke(me,0,Z.slice(fe));break}if(fe===Z.length){ke(me,I.length-me,[]);break}const ne=I[me],Se=Z[fe];if(ge(ne,Se)){me+=1,fe+=1;continue}ue(Se)?(ke(me,1,[]),me+=1):(ke(me,0,[Se]),fe+=1)}return be}e.$CI=i,e.$DI=new w.$fj("notebookEditorCursorAtBoundary","none"),e.$EI=new w.$fj("notebookEditorCursorAtLineBoundary","none");var r;(function(I){I.default="default",I.option="option"})(r||(e.NotebookEditorPriority=r={}));function u(I){const Z=I;return!!((typeof Z.include=="string"||T.$Ij(Z.include))&&(typeof Z.exclude=="string"||T.$Ij(Z.exclude)))}e.$FI=u;function d(I,Z,ue){if(Array.isArray(I.viewType)&&I.viewType.indexOf(Z)>=0||I.viewType===Z)return!0;if(I.filenamePattern){const ge=u(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,be=u(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(T.$Gj(ge,(0,m.$nc)(ue.fsPath).toLowerCase()))return!(be&&T.$Gj(be,(0,m.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$GI=d,e.$HI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var b;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class f{static{this.d="notebook/"}static create(Z){return`${f.d}${Z}`}static parse(Z){if(Z.startsWith(f.d))return Z.substring(f.d.length)}}e.$II=f;function D(I){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(I)}e.$JI=D;const L=new TextDecoder;function p(I){const Z=[];let ue=!1;for(const me of I)(Z.length===0||ue)&&(Z.push(me),ue=!0);let ge=N(Z);const be=E.$ge.concat(Z.map(me=>E.$ge.wrap(me))),ke=P(be);return ge=ge||ke.byteLength!==be.byteLength,{data:ke,didCompression:ge}}e.$KI=p,e.$LI=`${String.fromCharCode(27)}[A`;const y=e.$LI.split("").map(I=>I.charCodeAt(0)),S=10;function N(I){let Z=!1;return I.forEach((ue,ge)=>{if(ge===0||ue.length<e.$LI.length)return;const be=I[ge-1],ke=ue.subarray(0,e.$LI.length);if(ke[0]===y[0]&&ke[1]===y[1]&&ke[2]===y[2]){const me=be.lastIndexOf(S);if(me===-1)return;Z=!0,I[ge-1]=be.subarray(0,me),I[ge]=ue.subarray(e.$LI.length)}}),Z}function q(I){let Z=I;do I=Z,Z=I.replace(/[^\n]\x08/gm,"");while(Z.length<I.length);return I}function j(I){for(I=I.replace(/\r+\n/gm,`
`);I.search(/\r[^$]/g)>-1;){const Z=I.match(/^(.*)\r+/m)[1];let ue=I.match(/\r+(.*)$/m)[1];ue=ue+Z.slice(ue.length,Z.length),I=I.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return I}const M="\b".charCodeAt(0),U="\r".charCodeAt(0);function P(I){return!I.buffer.includes(M)&&!I.buffer.includes(U)?I:E.$ge.fromString(j(q(L.decode(I.buffer))))}}),define(Pe[7],Ae([1,0,18,11,52,28,68,12,16,2,33,22,42,100,76]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v){"use strict";var a,s,t,n,o,c,h,i,r,u,d,b,f,D,L,p,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$yM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$xM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.TestRunProfileKind=e.TestResultState=e.$dM=e.$cM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$bM=e.NotebookVariablesRequestKind=e.$aM=e.$_L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$$L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.ColorThemeKind=e.$5L=e.$4L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$3L=e.DebugConsoleMode=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$WL=e.$VL=e.FileChangeType=e.$UL=e.$TL=e.$SL=e.$RL=e.InlineCompletionTriggerKind=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.ConfigurationTarget=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$uL=e.ViewBadge=e.ProgressLocation=e.$tL=e.$sL=e.TaskScope=e.ShellQuoting=e.$rL=e.$qL=e.$pL=e.TaskPanelKind=e.TaskRevealKind=e.$oL=e.TerminalLocation=e.$nL=e.$mL=e.$lL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$kL=e.$jL=e.$iL=e.$hL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$gL=e.StatusBarAlignment=e.ViewColumn=e.$fL=e.$eL=e.$dL=e.$cL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$bL=e.$aL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.LanguageStatusSeverity=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.CodeActionTriggerKind=e.$1K=e.$ZK=e.SymbolTag=e.SymbolKind=e.$YK=e.$XK=e.DocumentHighlightKind=e.$WK=e.$VK=e.$UK=e.$TK=e.DiagnosticSeverity=e.DiagnosticTag=e.$SK=e.$RK=e.FileEditType=e.$QK=e.$PK=e.$OK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function S(B){return Object.assign(B,{apply:function(...ae){if(ae.length===0)return Reflect.construct(B,[]);{const we=ae.length===1?[]:ae[1];return Reflect.construct(B,we,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(B,[]);{const[we,...Ge]=ae;return Reflect.construct(B,Ge,we.constructor)}}})}var N;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var q;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(q||(e.TerminalQuickFixType=q={}));let j=a=class{static from(...z){let ae=z;return new a(function(){if(ae){for(const we of ae)we&&typeof we.dispose=="function"&&we.dispose();ae=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$HK=j,e.$HK=j=a=He([S],j);let M=s=class{static Min(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let we=1;we<z.length;we++){const Ge=z[we];Ge.isBefore(ae)&&(ae=Ge)}return ae}static Max(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let we=1;we<z.length;we++){const Ge=z[we];Ge.isAfter(ae)&&(ae=Ge)}return ae}static isPosition(z){if(!z)return!1;if(z instanceof s)return!0;const{line:ae,character:we}=z;return typeof ae=="number"&&typeof we=="number"}static of(z){if(z instanceof s)return z;if(this.isPosition(z))return new s(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ae){if(z<0)throw(0,T.$7)("line must be non-negative");if(ae<0)throw(0,T.$7)("character must be non-negative");this.c=z,this.e=ae}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ae=0){if(z===null||ae===null)throw(0,T.$7)();let we;return typeof z>"u"?we=0:typeof z=="number"?we=z:(we=typeof z.lineDelta=="number"?z.lineDelta:0,ae=typeof z.characterDelta=="number"?z.characterDelta:0),we===0&&ae===0?this:new s(this.line+we,this.character+ae)}with(z,ae=this.character){if(z===null||ae===null)throw(0,T.$7)();let we;return typeof z>"u"?we=this.line:typeof z=="number"?we=z:(we=typeof z.line=="number"?z.line:this.line,ae=typeof z.character=="number"?z.character:this.character),we===this.line&&ae===this.character?this:new s(we,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$IK=M,e.$IK=M=s=He([S],M);let U=t=class{static isRange(z){return z instanceof t?!0:z?M.isPosition(z.start)&&M.isPosition(z.end):!1}static of(z){if(z instanceof t)return z;if(this.isRange(z))return new t(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ae,we,Ge){let et,at;if(typeof z=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof Ge=="number"?(et=new M(z,ae),at=new M(we,Ge)):M.isPosition(z)&&M.isPosition(ae)&&(et=M.of(z),at=M.of(ae)),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this.c=et,this.e=at):(this.c=at,this.e=et)}contains(z){return t.isRange(z)?this.contains(z.start)&&this.contains(z.end):M.isPosition(z)?!(M.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ae=M.Max(z.start,this.c),we=M.Min(z.end,this.e);if(!ae.isAfter(we))return new t(ae,we)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ae=M.Min(z.start,this.c),we=M.Max(z.end,this.end);return new t(ae,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ae=this.end){if(z===null||ae===null)throw(0,T.$7)();let we;return z?M.isPosition(z)?we=z:(we=z.start||this.start,ae=z.end||this.end):we=this.start,we.isEqual(this.c)&&ae.isEqual(this.end)?this:new t(we,ae)}toJSON(){return[this.start,this.end]}};e.$JK=U,e.$JK=U=t=He([S],U);let P=n=class extends U{static isSelection(z){return z instanceof n?!0:z?U.isRange(z)&&M.isPosition(z.anchor)&&M.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ae,we,Ge){let et,at;if(typeof z=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof Ge=="number"?(et=new M(z,ae),at=new M(we,Ge)):M.isPosition(z)&&M.isPosition(ae)&&(et=M.of(z),at=M.of(ae)),!et||!at)throw new Error("Invalid arguments");super(et,at),this.f=et,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$KK=P,e.$KK=P=n=He([S],P);const I=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,T.$7)("connectionToken")};class Z{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ae,we){if(typeof z!="string"||z.length===0)throw(0,T.$7)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,T.$7)("port");typeof we<"u"&&I(we),this.host=z,this.port=Math.round(ae),this.connectionToken=we}}e.$LK=Z;class ue{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ae){this.makeConnection=z,this.connectionToken=ae,typeof ae<"u"&&I(ae)}}e.$MK=ue;class ge extends Error{static NotAvailable(z,ae){return new ge(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(z){return new ge(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ae=$.RemoteAuthorityResolverErrorCode.Unknown,we){super(z),this._message=z,this._code=ae,this._detail=we,Object.setPrototypeOf(this,ge.prototype)}}e.$NK=ge;var be;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let me=o=class{static isTextEdit(z){return z instanceof o?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ae){return new o(z,ae)}static insert(z,ae){return o.replace(new U(z,z),ae)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const ae=new o(new U(new M(0,0),new M(0,0)),"");return ae.newEol=z,ae}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,T.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,T.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,T.$7)("newEol");this.f=z}constructor(z,ae){this.c=z,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$OK=me,e.$OK=me=o=He([S],me);let fe=c=class{static isNotebookCellEdit(z){return z instanceof c?!0:z?_t.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ae){return new c(z,ae)}static insertCells(z,ae){return new c(new _t(z,z),ae)}static deleteCells(z){return new c(z,[])}static updateCellMetadata(z,ae){const we=new c(new _t(z,z),[]);return we.newCellMetadata=ae,we}static updateNotebookMetadata(z){const ae=new c(new _t(0,0),[]);return ae.newNotebookMetadata=z,ae}constructor(z,ae){this.range=z,this.newCells=ae}};e.$PK=fe,e.$PK=fe=c=He([S],fe);class ne{static isSnippetTextEdit(z){return z instanceof ne?!0:z?U.isRange(z.range)&&X.isSnippetString(z.snippet):!1}static replace(z,ae){return new ne(z,ae)}static insert(z,ae){return ne.replace(new U(z,z),ae)}constructor(z,ae){this.range=z,this.snippet=ae}}e.$QK=ne;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ae,we,Ge){this.c.push({_type:1,from:z,to:ae,options:we,metadata:Ge})}createFile(z,ae,we){this.c.push({_type:1,from:void 0,to:z,options:ae,metadata:we})}deleteFile(z,ae,we){this.c.push({_type:1,from:z,to:void 0,options:ae,metadata:we})}e(z,ae,we){this.c.push({_type:3,metadata:we,uri:z,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(z,ae,we,Ge){const et=ae.start,at=ae.end;(et!==at||we.length>0)&&this.c.push({_type:5,uri:z,index:et,count:at-et,cells:we,metadata:Ge})}g(z,ae,we,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:ae,metadata:we}})}replace(z,ae,we,Ge){this.c.push({_type:2,uri:z,edit:new me(ae,we),metadata:Ge})}insert(z,ae,we,Ge){this.replace(z,new U(ae,ae),we,Ge)}delete(z,ae,we){this.replace(z,ae,"",we)}has(z){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===z.toString())}set(z,ae){if(ae)for(const we of ae){if(!we)continue;let Ge,et;Array.isArray(we)?(Ge=we[0],et=we[1]):Ge=we,fe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,et):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,et):this.f(z,Ge.range,Ge.newCells,et):ne.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:et}):this.c.push({_type:2,uri:z,edit:Ge,metadata:et})}else{for(let we=0;we<this.c.length;we++){const Ge=this.c[we];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[we]=void 0);break}}(0,E.$Ib)(this.c)}}get(z){const ae=[];for(const we of this.c)we._type===2&&we.uri.toString()===z.toString()&&ae.push(we.edit);return ae}entries(){const z=new F.$Ac;for(const ae of this.c)if(ae._type===2){let we=z.get(ae.uri);we||(we=[ae.uri,[]],z.set(ae.uri,we)),we[1].push(ae.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$RK=ce,e.$RK=ce=He([S],ce);let X=h=class{static isSnippetString(z){return z instanceof h?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=h.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ae=this.e++){if(typeof z=="function"){const we=new h;we.e=this.e,z(we),this.e=we.e,z=we.value}else z=h.c(z);return this.value+="${",this.value+=ae,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ae=this.e++){const we=z.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(z,ae){if(typeof ae=="function"){const we=new h;we.e=this.e,ae(we),this.e=we.e,ae=we.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$SK=X,e.$SK=X=h=He([S],X);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var re;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Ie=i=class{static isLocation(z){return z instanceof i?!0:z?U.isRange(z.range)&&w.URI.isUri(z.uri):!1}constructor(z,ae){if(this.uri=z,ae)if(U.isRange(ae))this.range=U.of(ae);else if(M.isPosition(ae))this.range=new U(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$TK=Ie,e.$TK=Ie=i=He([S],Ie);let Re=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&w.URI.isUri(z.location.uri):!1}constructor(z,ae){this.location=z,this.message=ae}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.location.range.isEqual(ae.location.range)&&z.location.uri.toString()===ae.location.uri.toString()}};e.$UK=Re,e.$UK=Re=He([S],Re);let Ce=class{constructor(z,ae,we=re.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=z,this.message=ae,this.severity=we}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.severity===ae.severity&&z.code===ae.code&&z.severity===ae.severity&&z.source===ae.source&&z.range.isEqual(ae.range)&&(0,E.$ub)(z.tags,ae.tags)&&(0,E.$ub)(z.relatedInformation,ae.relatedInformation,Re.isEqual)}};e.$VK=Ce,e.$VK=Ce=He([S],Ce);let le=class{constructor(z,ae){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ae}};e.$WK=le,e.$WK=le=He([S],le);var ie;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(z,ae=ie.Text){this.range=z,this.kind=ae}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$XK=G,e.$XK=G=He([S],G);let te=class{constructor(z,ae){this.uri=z,this.highlights=ae}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$YK=te,e.$YK=te=He([S],te);var x;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(x||(e.SymbolKind=x={}));var se;(function(B){B[B.Deprecated=1]="Deprecated"})(se||(e.SymbolTag=se={}));let de=r=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ae,we,Ge,et){this.name=z,this.kind=ae,this.containerName=et,typeof we=="string"&&(this.containerName=we),Ge instanceof Ie?this.location=Ge:we instanceof U&&(this.location=new Ie(Ge,we)),r.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};e.$ZK=de,e.$ZK=de=r=He([S],de);let De=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(u.validate)}constructor(z,ae,we,Ge,et){this.name=z,this.detail=ae,this.kind=we,this.range=Ge,this.selectionRange=et,this.children=[],u.validate(this)}};e.$1K=De,e.$1K=De=u=He([S],De);var Le;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Le||(e.CodeActionTriggerKind=Le={}));let O=class{constructor(z,ae){this.title=z,this.kind=ae}};e.$2K=O,e.$2K=O=He([S],O);let K=class{static{d=this}static{this.c="."}constructor(z){this.value=z}append(z){return new d(this.value?this.value+d.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+d.c)}};e.$3K=K,e.$3K=K=d=He([S],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let J=class{constructor(z,ae){if(this.range=z,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$4K=J,e.$4K=J=He([S],J);class W{constructor(z,ae,we,Ge,et,at){this.kind=z,this.name=ae,this.detail=we,this.uri=Ge,this.range=et,this.selectionRange=at}}e.$5K=W;class Q{constructor(z,ae){this.fromRanges=ae,this.from=z}}e.$6K=Q;class _{constructor(z,ae){this.fromRanges=ae,this.to=z}}e.$7K=_;var ye;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ye||(e.LanguageStatusSeverity=ye={}));let ze=class{constructor(z,ae){this.range=z,this.command=ae}get isResolved(){return!!this.command}};e.$8K=ze,e.$8K=ze=He([S],ze);let Qe=b=class{#e;static isMarkdownString(z){return z instanceof b?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ae=!1){this.#e=new C.$bk(z,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ae){return this.#e.appendCodeblock(ae??"",z),this}};e.$9K=Qe,e.$9K=Qe=b=He([S],Qe);let Je=class{constructor(z,ae){this.label=z,this.documentation=ae}};e.$0K=Je,e.$0K=Je=He([S],Je);let Xe=class{constructor(z,ae){this.label=z,this.documentation=ae,this.parameters=[]}};e.$$K=Xe,e.$$K=Xe=He([S],Xe);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$_K=it,e.$_K=it=He([S],it);var nt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var _e;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(_e||(e.InlayHintKind=_e={}));let rt=class{constructor(z){this.value=z}};e.$aL=rt,e.$aL=rt=He([S],rt);let je=class{constructor(z,ae,we){this.position=z,this.label=ae,this.kind=we}};e.$bL=je,e.$bL=je=He([S],je);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ee;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ee||(e.CompletionItemKind=ee={}));var Y;(function(B){B[B.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let ve=class{constructor(z,ae){this.label=z,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$cL=ve,e.$cL=ve=He([S],ve);let Be=class{constructor(z=[],ae=!1){this.items=z,this.isIncomplete=ae}};e.$dL=Be,e.$dL=Be=He([S],Be);let Ke=class{constructor(z,ae,we){this.insertText=z,this.range=ae,this.command=we}};e.$eL=Ke,e.$eL=Ke=He([S],Ke);let xe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$fL=xe,e.$fL=xe=He([S],xe);var ot;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(pt||(e.StatusBarAlignment=pt={}));function Oe(B,z){return`${k.$em.toKey(B)}.${z}`}e.$gL=Oe;var At;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(At||(e.TextEditorLineNumbersStyle=At={}));var Kt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var jt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var bt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var Vt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Vt||(e.TextDocumentChangeReason=Vt={}));var Ut;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ut||(e.DecorationRangeBehavior=Ut={})),function(B){function z(ae){switch(ae){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(bt||(e.TextEditorSelectionChangeKind=bt={}));var Ht;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ht||(e.SyntaxTokenType=Ht={})),function(B){function z(ae){switch(ae){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Ht||(e.SyntaxTokenType=Ht={}));let Gt=class{constructor(z,ae){if(ae&&!w.URI.isUri(ae))throw(0,T.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,T.$7)("range");this.range=z,this.target=ae}};e.$hL=Gt,e.$hL=Gt=He([S],Gt);let Rt=class{constructor(z,ae,we,Ge){this.red=z,this.green=ae,this.blue=we,this.alpha=Ge}};e.$iL=Rt,e.$iL=Rt=He([S],Rt);let It=class{constructor(z,ae){if(ae&&!(ae instanceof Rt))throw(0,T.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,T.$7)("range");this.range=z,this.color=ae}};e.$jL=It,e.$jL=It=He([S],It);let Ye=class{constructor(z){if(!z||typeof z!="string")throw(0,T.$7)("label");this.label=z}};e.$kL=Ye,e.$kL=Ye=He([S],Ye);var Jt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var qt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var ut;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class gt{constructor(z,ae,we){if(this.startIndex=z,this.length=ae,this.tooltip=we,typeof z!="number"||z<0)throw(0,T.$7)("startIndex");if(typeof ae!="number"||ae<1)throw(0,T.$7)("length");if(we!==void 0&&typeof we!="string")throw(0,T.$7)("tooltip")}}e.$lL=gt;class Zt{constructor(z){this.uri=z}}e.$mL=Zt;class Ct{constructor(z){this.terminalCommand=z}}e.$nL=Ct;var St;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(St||(e.TerminalLocation=St={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,T.$7)("options")}}e.$oL=dt;var Ft;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ft||(e.TaskRevealKind=Ft={}));var Nt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Nt||(e.TaskPanelKind=Nt={}));let yt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(z){switch(z){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(z,ae){if(this.label=ae,typeof z!="string"||typeof ae!="string")throw(0,T.$7)("name");this.c=z}get id(){return this.c}};e.$pL=yt,e.$pL=yt=f=He([S],yt);function qe(B){let z="";for(let ae=0;ae<B.length;ae++)z+=B[ae].replace(/,/g,",,")+",";return z}let Lt=class{constructor(z,ae,we){if(typeof z!="string")throw(0,T.$7)("process");this.e=[],this.c=z,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=we):this.f=ae)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,T.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)z.push(ae);return qe(z)}};e.$qL=Lt,e.$qL=Lt=He([S],Lt);let Bt=class{constructor(z,ae,we){if(this.f=[],Array.isArray(ae)){if(!z)throw(0,T.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$7)("command");this.e=z,this.f=ae,this.g=we}else{if(typeof z!="string")throw(0,T.$7)("commandLine");this.c=z,this.g=ae}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,T.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)z.push(typeof ae=="string"?ae:ae.value);return qe(z)}};e.$rL=Bt,e.$rL=Bt=He([S],Bt);var Qt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Mt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$lg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$sL=Mt;let Ee=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ae,we,Ge,et,at){this.k=!1,this.l=this.definition=z;let ht;typeof ae=="string"?(this.n=this.name=ae,this.u=this.source=we,this.execution=Ge,ht=et,this.k=!0):ae===ft.Global||ae===ft.Workspace?(this.target=ae,this.n=this.name=we,this.u=this.source=Ge,this.execution=et,ht=at):(this.target=ae,this.n=this.name=we,this.u=this.source=Ge,this.execution=et,ht=at),typeof ht=="string"?(this.q=[ht],this.r=!0):Array.isArray(ht)?(this.q=ht,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Lt?this.l={type:D.e,id:this.o.computeId()}:this.o instanceof Bt?this.l={type:D.f,id:this.o.computeId()}:this.o instanceof Mt?this.l={type:D.c,id:this.o.computeId()}:this.l={type:D.g,id:(0,A.$lg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=z}get scope(){return this.m}set target(z){this.A(),this.m=z}get name(){return this.n}set name(z){if(typeof z!="string")throw(0,T.$7)("name");this.A(),this.n=z}get execution(){return this.o}set execution(z){z===null&&(z=void 0),this.A(),this.o=z;const ae=this.l.type;(D.g===ae||D.e===ae||D.f===ae||D.c===ae)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(z){if(Array.isArray(z))this.A(),this.q=z,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.A(),this.t=z}get source(){return this.u}set source(z){if(typeof z!="string"||z.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=z}get group(){return this.w}set group(z){z===null&&(z=void 0),this.A(),this.w=z}get detail(){return this.z}set detail(z){z===null&&(z=void 0),this.z=z}get presentationOptions(){return this.x}set presentationOptions(z){z==null&&(z=Object.create(null)),this.A(),this.x=z}get runOptions(){return this.y}set runOptions(z){z==null&&(z=Object.create(null)),this.A(),this.y=z}};e.$tL=Ee,e.$tL=Ee=D=He([S],Ee);var Me;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var $e;(function(B){function z(ae){const we=ae;return(0,g.$Hf)(we.value)?we.tooltip&&!(0,g.$Df)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}B.isViewBadge=z})($e||(e.ViewBadge=$e={}));let H=L=class{static isTreeItem(z,ae){const we=z;if(we.checkboxState!==void 0){const Ge=(0,g.$Hf)(we.checkboxState)?we.checkboxState:(0,g.$Ff)(we.checkboxState)&&(0,g.$Hf)(we.checkboxState.state)?we.checkboxState.state:void 0,et=!(0,g.$Hf)(we.checkboxState)&&(0,g.$Ff)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ue.Checked&&Ge!==Ue.Unchecked||et!==void 0&&!(0,g.$Df)(et))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}if(z instanceof L)return!0;if(we.label!==void 0&&!(0,g.$Df)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,g.$Df)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,g.$Df)(we.iconPath)&&!w.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,g.$Df)(we.iconPath.id))){const Ge=we.iconPath;if(!Ge||!(0,g.$Df)(Ge.light)&&!w.URI.isUri(Ge.light)&&!(0,g.$Df)(Ge.dark)&&!w.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,g.$Df)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!w.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,g.$Df)(we.tooltip)&&!(we.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<Fe.None&&we.collapsibleState>Fe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,g.$Df)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):!0}constructor(z,ae=Fe.None){this.collapsibleState=ae,w.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$uL=H,e.$uL=H=L=He([S],H);var Fe;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Fe||(e.TreeItemCollapsibleState=Fe={}));var Ue;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ue||(e.TreeItemCheckboxState=Ue={}));let Ze=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$vL=Ze,e.$vL=Ze=He([S],Ze);class We extends Ze{}e.$wL=We;class tt extends We{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$xL=tt;class mt{constructor(z,ae,we,Ge){this.name=z,this.uri=ae,this._itemId=we,this.c=Ge}data(){return this.c()}}e.$yL=mt;let zt=class{#e=new Map;constructor(z){for(const[ae,we]of z??[]){const Ge=this.#e.get(this.#t(ae));Ge?Ge.push(we):this.#e.set(this.#t(ae),[we])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ae){this.#e.set(this.#t(z),[ae])}forEach(z,ae){for(const[we,Ge]of this.#e)for(const et of Ge)z.call(ae,et,we,this)}*[Symbol.iterator](){for(const[z,ae]of this.#e)for(const we of ae)yield[z,we]}#t(z){return z.toLowerCase()}};e.$zL=zt,e.$zL=zt=He([S],zt);let Et=class{constructor(z){this.insertText=z}};e.$AL=Et,e.$AL=Et=He([S],Et);let Dt=class{constructor(z,ae){this.label=ae,this.insertText=z}};e.$BL=Dt,e.$BL=Dt=He([S],Dt);let wt=class{constructor(z,ae){this.id=z,this.color=ae}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$CL=wt,e.$CL=wt=He([S],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let mi=class{constructor(z){this.id=z}};e.$DL=mi,e.$DL=mi=He([S],mi);var Pt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Pt||(e.ConfigurationTarget=Pt={}));let Di=class{get base(){return this.c}set base(z){this.c=z,this.e=w.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ae){if(typeof z!="string"&&(!z||!w.URI.isUri(z)&&!w.URI.isUri(z.uri)))throw(0,T.$7)("base");if(typeof ae!="string")throw(0,T.$7)("pattern");typeof z=="string"?this.baseUri=w.URI.file(z):w.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$EL=Di,e.$EL=Di=He([S],Di);const Vi=new WeakMap;function kt(B,z){Vi.set(B,z)}e.$FL=kt;let ni=class{constructor(z,ae,we,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof ae=="string"&&(this.condition=ae),typeof we=="string"&&(this.hitCondition=we),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Vi.get(this)??(0,A.$lg)()),this.c}};e.$GL=ni,e.$GL=ni=He([S],ni);let $i=class extends ni{constructor(z,ae,we,Ge,et){if(super(ae,we,Ge,et),z===null)throw(0,T.$7)("location");this.location=z}};e.$HL=$i,e.$HL=$i=He([S],$i);let ai=class extends ni{constructor(z,ae,we,Ge,et){super(ae,we,Ge,et),this.functionName=z}};e.$IL=ai,e.$IL=ai=He([S],ai);let ki=class extends ni{constructor(z,ae,we,Ge,et,at,ht){if(super(Ge,et,at,ht),!ae)throw(0,T.$7)("dataId");this.label=z,this.dataId=ae,this.canPersist=we}};e.$JL=ki,e.$JL=ki=He([S],ki);let Ii=class{constructor(z,ae,we){this.command=z,this.args=ae||[],this.options=we}};e.$KL=Ii,e.$KL=Ii=He([S],Ii);let Tt=class{constructor(z,ae){this.port=z,this.host=ae}};e.$LL=Tt,e.$LL=Tt=He([S],Tt);let pi=class{constructor(z){this.path=z}};e.$ML=pi,e.$ML=pi=He([S],pi);let Ci=class{constructor(z){this.implementation=z}};e.$NL=Ci,e.$NL=Ci=He([S],Ci);let ci=class{constructor(z,ae,we){this.session=z,this.threadId=ae,this.frameId=we}};e.$OL=ci,e.$OL=ci=He([S],ci);let ui=class{constructor(z,ae){this.session=z,this.threadId=ae}};e.$PL=ui,e.$PL=ui=He([S],ui);let lt=class{constructor(z,ae){this.range=z,this.expression=ae}};e.$QL=lt,e.$QL=lt=He([S],lt);var qi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let xt=class{constructor(z,ae){this.range=z,this.text=ae}};e.$RL=xt,e.$RL=xt=He([S],xt);let ri=class{constructor(z,ae,we=!0){this.range=z,this.variableName=ae,this.caseSensitiveLookup=we}};e.$SL=ri,e.$SL=ri=He([S],ri);let di=class{constructor(z,ae){this.range=z,this.expression=ae}};e.$TL=di,e.$TL=di=He([S],di);let Pi=class{constructor(z,ae){this.frameId=z,this.stoppedLocation=ae}};e.$UL=Pi,e.$UL=Pi=He([S],Pi);var Ki;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ai=p=class extends Error{static FileExists(z){return new p(z,l.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(z){return new p(z,l.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(z){return new p(z,l.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(z){return new p(z,l.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(z,ae=l.FileSystemProviderErrorCode.Unknown,we){super(w.URI.isUri(z)?z.toString(!0):z),this.code=we?.name??"Unknown",(0,l.$yk)(this,ae),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};e.$VL=Ai,e.$VL=Ai=p=He([S],Ai);let vi=class{constructor(z,ae,we){this.start=z,this.end=ae,this.kind=we}};e.$WL=vi,e.$WL=vi=He([S],vi);var Hi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ri;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var li;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(z,ae=[]){this.tokenTypes=z,this.tokenModifiers=ae}}e.$XL=Mi;function cn(B){return typeof B>"u"||(0,g.$Ef)(B)}class Fi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ae=0,we=z.tokenTypes.length;ae<we;ae++)this.k.set(z.tokenTypes[ae],ae);for(let ae=0,we=z.tokenModifiers.length;ae<we;ae++)this.l.set(z.tokenModifiers[ae],ae)}}push(z,ae,we,Ge,et){if(typeof z=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof Ge=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.o(z,ae,we,Ge,et);if(U.isRange(z)&&typeof ae=="string"&&cn(we))return this.n(z,ae,we);throw(0,T.$7)()}n(z,ae,we){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,et=z.start.character,at=z.end.character-z.start.character,ht=this.k.get(ae);let Wt=0;if(we)for(const Xt of we){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Xt);Wt|=1<<ti>>>0}this.o(Ge,et,at,ht,Wt)}o(z,ae,we,Ge,et){if(this.f&&(z<this.c||z===this.c&&ae<this.e)){this.f=!1;const Wt=this.g.length/5|0;let Xt=0,ti=0;for(let ii=0;ii<Wt;ii++){let oi=this.g[5*ii],Bi=this.g[5*ii+1];oi===0?(oi=Xt,Bi+=ti):oi+=Xt,this.g[5*ii]=oi,this.g[5*ii+1]=Bi,Xt=oi,ti=Bi}}let at=z,ht=ae;this.f&&this.j>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.j++]=at,this.g[this.j++]=ht,this.g[this.j++]=we,this.g[this.j++]=Ge,this.g[this.j++]=et,this.c=z,this.e=ae}static q(z){const ae=[],we=z.length/5|0;for(let ht=0;ht<we;ht++)ae[ht]=ht;ae.sort((ht,Wt)=>{const Xt=z[5*ht],ti=z[5*Wt];if(Xt===ti){const ii=z[5*ht+1],oi=z[5*Wt+1];return ii-oi}return Xt-ti});const Ge=new Uint32Array(z.length);let et=0,at=0;for(let ht=0;ht<we;ht++){const Wt=5*ae[ht],Xt=z[Wt+0],ti=z[Wt+1],ii=z[Wt+2],oi=z[Wt+3],Bi=z[Wt+4],Dn=Xt-et,Nn=Dn===0?ti-at:ti,Wi=5*ht;Ge[Wi+0]=Dn,Ge[Wi+1]=Nn,Ge[Wi+2]=ii,Ge[Wi+3]=oi,Ge[Wi+4]=Bi,et=Xt,at=ti}return Ge}build(z){return this.f?new si(new Uint32Array(this.g),z):new si(Fi.q(this.g),z)}}e.$YL=Fi;class si{constructor(z,ae){this.resultId=ae,this.data=z}}e.$ZL=si;class un{constructor(z,ae,we){this.start=z,this.deleteCount=ae,this.data=we}}e.$1L=un;class ln{constructor(z,ae){this.resultId=ae,this.edits=z}}e.$2L=ln;var Ji;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$3L=fi,e.$3L=fi=He([S],fi);var Qi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(z){if(typeof z.badge=="string"){let ae=(0,m.$ef)(z.badge,0);if(ae<z.badge.length&&(ae+=(0,m.$ef)(z.badge,ae)),z.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!wt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ae,we){this.badge=z,this.tooltip=ae,this.color=we}}e.$4L=Yi;let Li=class{constructor(z){this.kind=z}};e.$5L=Li,e.$5L=Li=He([S],Li);var Ti;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(z){return z instanceof _t?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ae){if(z<0)throw(0,T.$7)("start must be positive");if(ae<0)throw(0,T.$7)("end must be positive");z<=ae?(this.c=z,this.e=ae):(this.c=ae,this.e=z)}with(z){let ae=this.c,we=this.e;return z.start!==void 0&&(ae=z.start),z.end!==void 0&&(we=z.end),ae===this.c&&we===this.e?this:new _t(ae,we)}}e.$6L=_t;class wi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ae=>wi.isNotebookCellData(ae))}static isNotebookCellData(z){return!0}constructor(z,ae,we,Ge,et,at,ht){this.kind=z,this.value=ae,this.languageId=we,this.mime=Ge,this.outputs=et??[],this.metadata=at,this.executionSummary=ht,wi.validate(this)}}e.$7L=wi;class hn{constructor(z){this.cells=z}}e.$8L=hn;class Yt{static isNotebookCellOutputItem(z){return z instanceof Yt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ae={name:z.name,message:z.message,stack:z.stack};return Yt.json(ae,"application/vnd.code.notebook.error")}static stdout(z){return Yt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Yt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ae="application/octet-stream"){return new Yt(z,ae)}static#e=new TextEncoder;static text(z,ae=R.$1r.text){const we=Yt.#e.encode(String(z));return new Yt(we,ae)}static json(z,ae="text/x-json"){const we=JSON.stringify(z,void 0,"	");return Yt.text(we,ae)}constructor(z,ae){this.data=z,this.mime=ae;const we=(0,R.$5r)(ae,!0);if(!we)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.$9L=Yt;class yi{static isNotebookCellOutput(z){return z instanceof yi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ae=!1){const we=new Set,Ge=new Set;for(let et=0;et<z.length;et++){const at=z[et],ht=(0,R.$5r)(at.mime);if(!we.has(ht)||(0,v.$JI)(ht)){we.add(ht);continue}Ge.add(et),ae&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?z:z.filter((et,at)=>!Ge.has(at))}constructor(z,ae,we){this.items=yi.ensureUniqueMimeTypes(z,!0),typeof ae=="string"?(this.id=ae,this.metadata=we):(this.id=(0,A.$lg)(),this.metadata=ae??we)}}e.$0L=yi;var Ei;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ne;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ne||(e.NotebookCellStatusBarAlignment=Ne={}));var ei;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Xi{constructor(z,ae){this.text=z,this.alignment=ae}}e.$$L=Xi;var $t;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var xi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(z,ae=[]){this.uri=z,this.provides=(0,E.$3b)(ae)}}e.$_L=dn;class _i{constructor(z){this.label=z}}e.$aM=_i;var en;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(z,ae){this.label=z,this.timestamp=ae}};e.$bM=hi,e.$bM=hi=He([S],hi);var tn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(z,ae){this.ranges=z,this.wordPattern=ae}}e.$cM=sn;class fn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$dM=fn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(z=void 0,ae=void 0,we=void 0,Ge=!1){this.include=z,this.exclude=ae,this.profile=we,this.continuous=Ge}};e.$eM=Ni,e.$eM=Ni=He([S],Ni);let zi=y=class{static diff(z,ae,we){const Ge=new y(z);return Ge.expectedOutput=ae,Ge.actualOutput=we,Ge}constructor(z){this.message=z}};e.$fM=zi,e.$fM=zi=y=He([S],zi);let ji=class{constructor(z){this.id=z}};e.$gM=ji,e.$gM=ji=He([S],ji);class Si{constructor(z,ae){this.covered=z,this.total=ae}}e.$hM=Si;class Ui{static fromDetails(z,ae){const we=new Si(0,0),Ge=new Si(0,0),et=new Si(0,0);for(const ht of ae)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const Wt of ht.branches)Ge.total+=1,Ge.covered+=Wt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const at=new Ui(z,we,Ge.total>0?Ge:void 0,et.total>0?et:void 0);return at.detailedCoverage=ae,at}constructor(z,ae,we,Ge){this.uri=z,this.statementCoverage=ae,this.branchCoverage=we,this.functionCoverage=Ge}}e.$iM=Ui;class gn{constructor(z,ae,we=[]){this.executionCount=z,this.location=ae,this.branches=we}}e.$jM=gn;class mn{constructor(z,ae){this.executionCount=z,this.location=ae}}e.$kM=mn;class oe{constructor(z,ae,we){this.name=z,this.executionCount=ae,this.location=we}}e.$lM=oe;var he;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(he||(e.ExternalUriOpenerPriority=he={}));var Te;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Te||(e.WorkspaceTrustState=Te={}));var st;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(st||(e.PortAutoForwardAction=st={}));class vt{constructor(z,ae,we,Ge,et,at){this.kind=z,this.name=ae,this.detail=we,this.uri=Ge,this.range=et,this.selectionRange=at}}e.$mM=vt;class Ot{constructor(z){this.uri=z}}e.$nM=Ot;class kn{constructor(z,ae){this.original=z,this.modified=ae}}e.$oM=kn;class In{constructor(z,ae,we,Ge){this.base=z,this.input1=ae,this.input2=we,this.result=Ge}}e.$pM=In;class Cn{constructor(z,ae){this.uri=z,this.viewType=ae}}e.$qM=Cn;class Pn{constructor(z){this.viewType=z}}e.$rM=Pn;class An{constructor(z,ae){this.uri=z,this.notebookType=ae}}e.$sM=An;class Rn{constructor(z,ae,we){this.original=z,this.modified=ae,this.notebookType=we}}e.$tM=Rn;class Mn{constructor(){}}e.$uM=Mn;class Fn{constructor(z,ae){this.uri=z,this.inputBoxUri=ae}}e.$vM=Fn;class Ln{constructor(z){this.providerId=z}}e.$wM=Ln;var $n;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Tn{constructor(z,ae){this.label=z,this.values=ae}}e.$xM=Tn;var bn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class On{constructor(z,ae){this.role=z,this.content=ae}}e.$yM=On;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Pe[103],Ae([1,0,53,13,12,294,146,7,18]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.$LM=void 0;const w=new Map;function A(v,a){a?w.set(v,a):w.delete(v)}e.$LM=A;function k(v){return w.get(v)}class l extends F.$8u{constructor(a,s,t,n,o,c,h,i){super(s,t,n,o),this.c=a,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,g.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===T.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(s){return s?a.s(s):a.getText()},get eol(){return a.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(s){return a.t(s)},offsetAt(s){return a.u(s)},positionAt(s){return a.v(s)},validateRange(s){return a.w(s)},validatePosition(s){return a.x(s)},getWordRangeAtPosition(s,t){return a.y(s,t)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,E.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,E.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const s=this.w(a);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const t=this.g,n=s.start.line,o=s.end.line,c=[];c.push(this.f[n].substring(s.start.character));for(let h=n+1;h<o;h++)c.push(this.f[h]);return c.push(this.f[o].substring(0,s.end.character)),c.join(t)}t(a){let s;if(a instanceof m.$IK?s=a.line:typeof a=="number"&&(s=a),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new $(s,this.f[s],s===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const s=this.j.getIndexOf(a),t=this.f[s.index].length;return new m.$IK(s.index,Math.min(s.remainder,t))}w(a){if(!(a instanceof m.$JK))throw new Error("Invalid argument");const s=this.x(a.start),t=this.x(a.end);return s===a.start&&t===a.end?a:new m.$JK(s.line,s.character,t.line,t.character)}x(a){if(!(a instanceof m.$IK))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:s,character:t}=a,n=!1;if(s<0)s=0,t=0,n=!0;else if(s>=this.f.length)s=this.f.length-1,t=this.f[s].length,n=!0;else{const o=this.f[s].length;t<0?(t=0,n=!0):t>o&&(t=o,n=!0)}return n?new m.$IK(s,t):a}y(a,s){const t=this.x(a);if(!s)s=k(this.m);else if((0,C.$Te)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const n=(0,R.$gs)(t.character+1,(0,R.$es)(s),this.f[t.line],0);if(n)return new m.$JK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$MM=l;class ${constructor(a,s,t){this.a=a,this.b=s,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$JK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$JK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$NM=$}),define(Pe[209],Ae([1,0,7,17,5]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let F=class{constructor(m){this.a=new E.$5L(E.ColorThemeKind.Dark),this.b=new C.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$5L(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Lgc=F,e.$Lgc=F=He([Ve(0,T.$JM)],F)}),define(Pe[210],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$NI=(0,E.$1h)("INotebookExecutionService")}),define(Pe[211],Ae([1,0,6,29,143,94]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QPb=void 0;class R extends E.$Sc{constructor(g,w,A){super(),this._source=g,this.b=w,this.c=A,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Es(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new C.$TB;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:A,disposable:k}=w.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new C.$TB;w.acceptChunk(g);const A=w.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(g){const A=new F.$HB(g,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(g){const A=new F.$HB(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$QPb=R}),define(Pe[48],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(F){F.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(R,m,g=R.parent){if(R._isRoot)return new C([m]);const w=[R.id];for(let A=g;A&&A.id!==m;A=A.parent)w.push(A.id);return w.push(m),new C(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new C(R.split("\0"))}static join(R,m){return new C([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:C.isChild(R,m)?2:C.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new C(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new C(this.path,R)}compare(R){if(typeof R=="string")return C.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$xJ=C}),define(Pe[58],Ae([1,0,2,92,29,48]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$EJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$DJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$CJ=e.$BJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$AJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$zJ=e.$yJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var m;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$yJ=[2,4,8,16,32,64];const w=P=>"runId"in P;e.$zJ=w;var A;(function(P){P.serialize=I=>({range:I.range.toJSON(),uri:I.uri.toJSON()}),P.deserialize=I=>({range:C.$Es.lift(I.range),uri:E.URI.revive(I.uri)})})(A||(e.IRichLocation=A={}));var k;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(P){P.serialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&A.serialize(I.location)}),P.deserialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&A.deserialize(I.location)})})(l||(e.ITestErrorMessage=l={}));const $=(P,I)=>`${I?"s":"e"}${P}`;e.$AJ=$;var v;(function(P){P.serialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&A.serialize(I.location)}),P.deserialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&A.deserialize(I.location)})})(v||(e.ITestOutputMessage=v={}));var a;(function(P){P.serialize=I=>I.type===0?l.serialize(I):v.serialize(I),P.deserialize=I=>I.type===0?l.deserialize(I):v.deserialize(I)})(a||(e.ITestMessage=a={}));var s;(function(P){P.serializeWithoutMessages=I=>({state:I.state,duration:I.duration,messages:[]}),P.serialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(a.serialize)}),P.deserialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(a.deserialize)})})(s||(e.ITestTaskState=s={}));const t="\0",n=(P,I)=>P+t+I;e.$BJ=n;const o=P=>{const I=P.indexOf(t);return{ctrlId:P.slice(0,I),tagId:P.slice(I+1)}};e.$CJ=o;var c;(function(P){P.serialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?.toJSON(),range:I.range?.toJSON()||null,description:I.description,error:I.error,sortText:I.sortText}),P.deserialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?E.URI.revive(I.uri):void 0,range:I.range?C.$Es.lift(I.range):null,description:I.description,error:I.error,sortText:I.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(P){P.serialize=I=>({expand:I.expand,item:c.serialize(I.item)}),P.deserialize=I=>({controllerId:F.$xJ.root(I.item.extId),expand:I.expand,item:c.deserialize(I.item)})})(i||(e.InternalTestItem=i={}));var r;(function(P){P.serialize=I=>{let Z;return I.item&&(Z={},I.item.label!==void 0&&(Z.label=I.item.label),I.item.tags!==void 0&&(Z.tags=I.item.tags),I.item.busy!==void 0&&(Z.busy=I.item.busy),I.item.uri!==void 0&&(Z.uri=I.item.uri?.toJSON()),I.item.range!==void 0&&(Z.range=I.item.range?.toJSON()),I.item.description!==void 0&&(Z.description=I.item.description),I.item.error!==void 0&&(Z.error=I.item.error),I.item.sortText!==void 0&&(Z.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:Z}},P.deserialize=I=>{let Z;return I.item&&(Z={},I.item.label!==void 0&&(Z.label=I.item.label),I.item.tags!==void 0&&(Z.tags=I.item.tags),I.item.busy!==void 0&&(Z.busy=I.item.busy),I.item.range!==void 0&&(Z.range=I.item.range?C.$Es.lift(I.item.range):null),I.item.description!==void 0&&(Z.description=I.item.description),I.item.error!==void 0&&(Z.error=I.item.error),I.item.sortText!==void 0&&(Z.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:Z}}})(r||(e.ITestItemUpdate=r={}));const u=(P,I)=>{I.expand!==void 0&&(P.expand=I.expand),I.item!==void 0&&(P.item=P.item?Object.assign(P.item,I.item):I.item)};e.$DJ=u;var d;(function(P){P.serializeWithoutMessages=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(s.serializeWithoutMessages)}),P.serialize=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(s.serialize)}),P.deserialize=I=>({...i.deserialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(s.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var b;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(I,Z)=>{I.covered+=Z.covered,I.total+=Z.total}})(b||(e.ICoveredCount=b={}));var f;(function(P){P.serialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(y.serialize),uri:I.uri.toJSON()}),P.deserialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(y.deserialize),uri:E.URI.from(I.uri)})})(f||(e.IFileCoverage=f={}));function D(P){return{...P,location:P.location?.toJSON()}}function L(P){return P.location=P.location?T.$Ds.isIPosition(P.location)?T.$Ds.lift(P.location):C.$Es.lift(P.location):void 0,P}e.$EJ=3;var p;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(p||(e.DetailType=p={}));var y;(function(P){P.serialize=I=>I.type===0?N.serialize(I):q.serialize(I),P.deserialize=I=>I.type===0?N.deserialize(I):q.deserialize(I)})(y||(e.CoverageDetails=y={}));var S;(function(P){P.serialize=D,P.deserialize=L})(S||(e.IBranchCoverage=S={}));var N;(function(P){P.serialize=D,P.deserialize=L})(N||(e.IFunctionCoverage=N={}));var q;(function(P){P.serialize=I=>({...D(I),branches:I.branches?.map(S.serialize)}),P.deserialize=I=>({...L(I),branches:I.branches?.map(S.deserialize)})})(q||(e.IStatementCoverage=q={}));var j;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var M;(function(P){P.deserialize=I=>I.op===0?{op:I.op,item:i.deserialize(I.item)}:I.op===1?{op:I.op,item:r.deserialize(I.item)}:I.op===2?{op:I.op,uri:E.URI.revive(I.uri),docv:I.docv}:I,P.serialize=I=>I.op===0?{op:I.op,item:i.serialize(I.item)}:I.op===1?{op:I.op,item:r.serialize(I.item)}:I})(M||(e.TestsDiffOp=M={}));class U{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(I){const Z=this.o();for(const ue of I)switch(ue.op){case 0:this.j(i.deserialize(ue.item),Z);break;case 1:this.k(r.deserialize(ue.item),Z);break;case 3:this.l(ue.itemId,Z);break;case 5:this.m(ue.itemId);break;case 4:this.updatePendingRoots(ue.amount);break;case 6:this.c.set(ue.tag.id,ue.tag);break;case 7:this.c.delete(ue.id);break}Z.complete?.()}j(I,Z){const ue=F.$xJ.parentId(I.item.extId)?.toString();let ge;if(!ue)ge=this.p(I),this.f.add(ge),this.d.set(I.item.extId,ge);else if(this.d.has(ue)){const be=this.d.get(ue);be.children.add(I.item.extId),ge=this.p(I,be),this.d.set(I.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(I)}`);return}return Z.add?.(ge),I.expand===2&&this.g++,ge}k(I,Z){const ue=this.d.get(I.extId);if(ue)return I.expand!==void 0&&(ue.expand===2&&this.g--,I.expand===2&&this.g++),(0,e.$DJ)(ue,I),Z.update?.(ue),ue}l(I,Z){const ue=this.d.get(I);if(!ue)return;const ge=F.$xJ.parentId(ue.item.extId)?.toString();ge?this.d.get(ge).children.delete(ue.item.extId):this.f.delete(ue);const be=[[I]];for(;be.length;)for(const ke of be.pop()){const me=this.d.get(ke);me&&(be.push(me.children),this.d.delete(ke),Z.remove?.(me,me!==ue),me.expand===2&&this.g--)}}m(I){}updatePendingRoots(I){this.h+=I}o(){return{}}}e.$FJ=U}),define(Pe[77],Ae([1,0,14,5,6,53,58,48]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(n,o)=>n===o,k=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[h,i]of k)i(n[h],o[h])||(c?c[h]=o[h]:c={[h]:o[h]});return c};class $ extends C.$Sc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new E.$ah(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.I(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,R.$DJ)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,R.$DJ)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.L(h);return i.isOpen()?this.J(h,c-1):i.wait().then(()=>this.J(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,c-1)):this.J(h,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,c){switch(c.op){case 3:this.N(m.$xJ.joinToString(o.fullId,c.id));break;case 0:this.y(c.item,o);break;case 5:for(const h of c.ops)this.u(o,h);break;case 1:this.z(c.new,c.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.w(o.actual.uri);break;default:(0,F.$5c)(c)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,c){const h=m.$xJ.fromExtHostTestItem(o,this.root.id,c?.actual),i=this.s.getApiFor(o);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(o.id);let r=this.tree.get(h.toString());if(!r){r={fullId:h,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(o)}}),this.H(o,r,c);return}if(r.actual===o){this.G(o,r,c);return}if(r.actual.uri?.toString()!==o.uri?.toString())return this.N(h.toString()),this.y(o,c);const u=this.s.getChildren(r.actual),d=r.actual,b=l(this.s.toITestItem(d),this.s.toITestItem(o));this.s.getApiFor(d).listener=void 0,r.actual=o,r.expand=0,b&&(b.hasOwnProperty("tags")&&(this.z(o.tags,d.tags,h.toString()),delete b.tags),this.u(r,{op:4,update:b})),this.H(o,r,c);for(const[f,D]of u)this.s.getChildren(o).get(D.id)||this.N(m.$xJ.joinToString(h,D.id));this.w(r.actual.uri)}z(o,c,h){const i=new Set(c.map(r=>r.id));for(const r of o)i.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(r=>(0,R.$BJ)(this.s.controllerId,r.id))}}}),i.forEach(this.D,this)}C(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$BJ)(this.s.controllerId,o.id)}}))}D(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,R.$BJ)(this.s.controllerId,o)}))}F(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}G(o,c,h){this.F(o,h);const i=this.s.getApiFor(o);i.parent=h?.actual,i.listener=r=>this.u(c,r),this.I(c)}H(o,c,h){this.G(o,c,h);for(const[i,r]of this.s.getChildren(o))this.y(r,c)}I(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.L(o))}J(o,c){if(c<0)return;const h=[];for(const[i,r]of this.s.getChildren(o.actual)){const u=this.expand(m.$xJ.joinToString(o.fullId,r.id),c);(0,E.$Ng)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const r=new E.$Zg;return r.open(),r}o.expand=2,this.M(o);const c=o.resolveBarrier=new E.$Zg,h=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let i;try{i=this.h(o.actual===this.root?void 0:o.actual)}catch(r){h(r)}return(0,E.$Ng)(i)?i.catch(h).then(()=>{c.open(),this.I(o)}):(c.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const r of i.actual.tags)this.D(r.id);this.tree.delete(i.fullId.toString());for(const[r,u]of this.s.getChildren(i.actual))h.push(this.tree.get(m.$xJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$zM=$;class v extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$AM=v;class a extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$BM=a;class s extends Error{constructor(o,c,h){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$CM=s;const t=(n,o,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,r){for(const u of h.values())i.call(r,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const r=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const b of i){if(!(b instanceof c))throw new a(b.id);const f=o(b).controllerId;if(f!==n.controllerId)throw new s(b.id,f,n.controllerId);if(r.has(b.id))throw new v(b.id);r.set(b.id,b),u.delete(b.id),d.ops.push({op:0,item:b})}for(const b of u.keys())d.ops.push({op:3,id:b});n.listener?.(d),h=r},add(i){if(!(i instanceof c))throw new a(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$DM=t}),define(Pe[104],Ae([1,0,77]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;const T=new WeakMap,C=(R,m)=>{const g={controllerId:m};return T.set(R,g),g};e.$EM=C;const F=R=>{const m=T.get(R);if(!m)throw new E.$BM(R?.id||"<unknown>");return m};e.$FM=F}),define(Pe[78],Ae([1,0,13,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ub=e.$8ub=e.$7ub=e.$6ub=e.$5ub=void 0,e.$5ub="vscode-cdn.net",e.$6ub=`vscode-resource.${e.$5ub}`,e.$7ub=`'self' https://*.${e.$5ub}`;function C(m,g){return m.scheme===E.Schemas.http||m.scheme===E.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===E.Schemas.file&&(m=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:m.path})),T.URI.from({scheme:E.Schemas.https,authority:`${m.scheme}+${F(m.authority)}.${e.$6ub}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$8ub=C;function F(m){return m.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$9ub=R}),define(Pe[212],Ae([1,0,5,6,78]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class F{constructor(m,g,w){this.d=m,this.e=g,this.f=w,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,w,A,k){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const $=this,v=this.a++,a=new E.$Sd,s=new E.$Sd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,C.$8ub)(o,$.f)}get cspSource(){return C.$7ub}set options(o){this.b=o,$.d.$setOptions(v,o)}get options(){return this.b}set html(o){this.a=o,$.d.$setHtml(v,o)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(o){return $.d.$postMessage(v,o)}},n=new class{constructor(){this.editor=m,this.line=g,this.height=w,this.webview=t,this.onDidDispose=s.event}dispose(){$.c.has(v)&&($.c.delete(v),$.d.$disposeEditorInset(v),s.fire(),s.dispose(),a.dispose())}};return this.d.$createEditorInset(v,l.id,l.value.document.uri,g+1,w,A||{},k.identifier,k.extensionLocation),this.c.set(v,{editor:m,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$8ec=F}),define(Pe[213],Ae([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.VariableKind=e.$vN=void 0,e.$vN=(0,E.$1h)("configurationResolverService");var T;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class C extends Error{constructor(R,m){super(m),this.variable=R}}e.$wN=C}),define(Pe[214],Ae([1,0,19,74,16,26,21,95,176,213,12]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,v,a,s){this.h=new Map,this.a=$,this.b=v,this.g=a,s&&(this.c=s.then(t=>this.i(t)))}i($){if(R.$i){const v=Object.create(null);return Object.keys($).forEach(a=>{v[a.toLowerCase()]=$[a]}),v}return $}resolveWithEnvironment($,v,a){return this.l({env:this.i($),userHome:void 0},v?v.uri:void 0,a)}async resolveAsync($,v){const a={env:await this.c,userHome:await this.g};return this.l(a,$?$.uri:void 0,v)}async j($,v,a,s){const t=F.$fn(v);R.$i&&t.windows?Object.keys(t.windows).forEach(o=>t[o]=t.windows[o]):R.$j&&t.osx?Object.keys(t.osx).forEach(o=>t[o]=t.osx[o]):R.$k&&t.linux&&Object.keys(t.linux).forEach(o=>t[o]=t.linux[o]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,$?$.uri:void 0,t,a,s)}async resolveAnyAsync($,v,a){return this.j($,v,a)}async resolveAnyMap($,v,a){const s=new Map;return{newConfig:await this.j($,v,a,s),resolvedVariables:s}}resolveWithInteractionReplace($,v,a,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,v,a,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,v){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,v)}async l($,v,a,s,t){if(C.$Df(a))return this.m($,v,a,s,t);if(Array.isArray(a))return Promise.all(a.map(n=>this.l($,v,n,s,t)));if(C.$Ff(a)){const n=Object.create(null),o=await Promise.all(Object.keys(a).map(async c=>[await this.m($,v,c,s,t),await this.l($,v,a[c],s,t)]));for(const[c,h]of o)n[c]=h;return n}return a}m($,v,a,s,t){return(0,A.$Ye)(a,k.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(k.VARIABLE_LHS))return n;let c=await this.o($,n,o,v,s);return t?.set(o,c),c!==n&&C.$Df(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m($,v,c,s,t)),c})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,v,a,s,t){let n;const o=a.split(":");o.length>1&&(a=o[0],n=o[1]);const c=r=>{const u=this.a.getFilePath();if(u)return(0,m.$Fv)(u);throw new w.$wN(r,(0,g.localize)(0,null,v))},h=r=>{const u=c(r);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,m.$Fv)(d)}throw new w.$wN(r,(0,g.localize)(1,null,v,E.$nc(u)))},i=r=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new w.$wN(r,(0,g.localize)(2,null,v,n))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new w.$wN(r,(0,g.localize)(3,null,v)):new w.$wN(r,(0,g.localize)(4,null,v))};switch(a){case"env":if(n){if($.env){const r=$.env[R.$i?n.toLowerCase():n];if(C.$Df(r))return r}return""}throw new w.$wN(w.VariableKind.Env,(0,g.localize)(5,null,v));case"config":if(n){const r=this.a.getConfigurationValue(s,n);if(C.$Mf(r))throw new w.$wN(w.VariableKind.Config,(0,g.localize)(6,null,v,n));if(C.$Ff(r))throw new w.$wN(w.VariableKind.Config,(0,g.localize)(7,null,v,n));return r}throw new w.$wN(w.VariableKind.Config,(0,g.localize)(8,null,v));case"command":return this.p(w.VariableKind.Command,v,n,t,"command");case"input":return this.p(w.VariableKind.Input,v,n,t,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new w.$wN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,v,n));return this.n(r.extensionLocation)}throw new w.$wN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,v));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,m.$Fv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return s||n?(0,m.$Fv)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Fv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new w.$wN(w.VariableKind.UserHome,(0,g.localize)(11,null,v))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new w.$wN(w.VariableKind.LineNumber,(0,g.localize)(12,null,v))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new w.$wN(w.VariableKind.SelectedText,(0,g.localize)(13,null,v))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||n?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.$mc(c(w.VariableKind.RelativeFileDirname));if(s||n){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),r);return u.length===0?".":u}return r}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.$oc(r).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||v}case"execInstallFolder":{const r=this.a.getAppRoot();return r||v}case"pathSeparator":return E.sep;default:try{const r=n?`${a}:${n}`:a;return this.p(w.VariableKind.Unknown,v,r,t,void 0)}catch{return v}}}}p($,v,a,s,t){if(a&&s){const n=t===void 0?s[a]:s[t+":"+a];if(typeof n=="string")return n;throw new w.$wN($,(0,g.localize)(14,null,v))}return v}}e.$KN=k}),define(Pe[105],Ae([1,0,4,102]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=e.$PC=e.OpenEditorContext=e.GroupsOrder=e.$OC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$NC=void 0,e.$NC=(0,E.$1h)("editorGroupsService");var C;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var F;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(v){const a=v;return(0,T.$wE)(a?.editor)&&(0,T.$wE)(a?.replacement)}e.$OC=w;var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(v){const a=v;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.$PC=l;function $(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$QC=$}),define(Pe[215],Ae([1,0,4,105]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.$SC=e.$RC=void 0,e.$RC=(0,E.$1h)("editorService"),e.$SC=-1,e.$TC=-2;function C(F){const R=F;return typeof F=="number"||(0,T.$PC)(R)}e.$UC=C}),define(Pe[216],Ae([1,0,4,183]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=void 0,e.$3J=(0,E.$2h)(T.$8h)}),define(Pe[106],Ae([1,0,22,5,19,6]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=e.$Z6b=e.$Y6b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$Y6b=R;class m{static isHostExtension(t,n,o){if(n.getExtensionDescription(t))return!1;const c=o.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(v),this.f=new E.$gm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=a(this.e,n),this.e=this.e.concat(t);const o=m.l(this.e);return this.e=a(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,u){this.addNode(r),this.addNode(u),this.c.has(r)?this.c.get(r).push(u):this.c.set(r,[u])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,u){const d=n.getArcs(r);for(let b=0;b<d.length;b++)if(!u.has(d[b]))return!1;return!0}getNodes(){return this.e}},o=new E.$gm;for(const r of t)if(o.set(r.identifier,r),r.extensionDependencies)for(const u of r.extensionDependencies)n.addArc(E.$em.toKey(r.identifier),E.$em.toKey(u));const c=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>c.add(r));const h=n.getNodes().filter(r=>!c.has(r));let i;do{i=!1;for(let r=0;r<h.length;r++){const u=h[r];n.hasOnlyGoodArcs(u,c)&&(h.splice(r,1),r--,c.add(u),i=!0)}}while(i);return h.map(r=>o.get(r))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Z6b=m;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$16b=g;class w{constructor(t){this.d=new l,this.c=new m(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,o){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$26b=w;class A extends F.$Sc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$36b=A;class k{constructor(t){this.name=t,this.promise=new Promise((n,o)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new k(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};t.resolve((0,F.$Qc)(c))}}var $;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})($||($={}));function v(s,t){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,o=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=C.$gc.basename(s.extensionLocation.path),h=C.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function a(s,t){const n=new E.$fm(t);return s.filter(o=>!n.has(o.identifier))}}),define(Pe[79],Ae([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$nm=e.$mm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var F;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(w){const A=E.$ge.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$mm=R;function m(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$nm=m;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,164]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.$2M=e.$1M=void 0;let $=class extends k.$Sc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$zo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(o=>{(0,C.$kj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,o){const c=this.getTelemetryDetails(),h=new v(n,o,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,o){this.f=t,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$7k)((0,g.$Go)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const h=o.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$1M=$,e.$1M=$=He([Ve(0,F.$ZM),Ve(1,C.$jj)],$);class v{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,o,c,h,i,r){this.g=o,this.h=c,this.i=h,this.j=i,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Jo)(n,[]),this.c&&(n=(0,w.$in)(n,this.c)),this.b||(n=(0,w.$in)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const o={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Jo)(o,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$2M=v;function a(s){const t=Date.now()-new Date(s).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$3M=a,e.$4M=(0,E.$1h)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,192,101,22,4]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.ActivationKind=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.ExtensionHostStartup=e.$PF=e.$OF=e.$NF=e.$MF=void 0,e.$MF=Object.freeze({identifier:new R.$em("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$NF="extensions.webWorker",e.$OF=(0,m.$1h)("extensionService");class g{constructor(h){this.dependency=h}}e.$PF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,r){this.c=h,this.d=i.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$DF.createActivationEventsMap(this.d)}}set(h,i,r){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],b=[],f=[],D=k(this.d),L=k(i),p=(j,M)=>j.extensionLocation.toString()===M.extensionLocation.toString()||j.isBuiltin===M.isBuiltin||j.isUserBuiltin===M.isUserBuiltin||j.isUnderDevelopment===M.isUnderDevelopment;for(const j of this.d){const M=L.get(j.identifier);if(!M){u.push(j.identifier),D.delete(j.identifier);continue}if(!p(j,M)){u.push(j.identifier),D.delete(j.identifier);continue}}for(const j of i){const M=D.get(j.identifier);if(!M){d.push(j);continue}if(!p(M,j)){u.push(M.identifier),D.delete(M.identifier);continue}}const y=new R.$fm(this.e),S=new R.$fm(r);for(const j of this.e)S.has(j)||b.push(j);for(const j of r)y.has(j)||f.push(j);const N=F.$DF.createActivationEventsMap(d),q={versionId:h,toRemove:u,toAdd:d,addActivationEvents:N,myToRemove:b,myToAdd:f};return this.delta(q),q}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:r,myToRemove:u,myToAdd:d}=h,b=new R.$fm(i),f=new R.$fm(u);for(let D=0;D<this.d.length;D++)b.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)f.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of r)this.d.push(D);for(const D of d)this.e.push(D);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$em.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const r=F.$DF.readActivationEvents(i);for(const u of r)h.add(u)}return h}}e.$QF=A;function k(c){const h=new R.$gm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$RF=l;function $(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$SF=$;class v{constructor(h,i,r,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r,this.activationReason=u}}e.$TF=v;class a{constructor(h,i){this.description=h,this.value=i}}e.$UF=a;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$Po)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$VF=t;function n(c,h){return{identifier:new R.$em((0,C.$No)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$WF=n;class o{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$XF=o}),define(Pe[217],Ae([1,0,11,106,22,23,15,14]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=e.$ufc=e.$tfc=e.$sfc=e.$rfc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,o,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$rfc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$sfc=w;class A{constructor(t,n,o,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=h,this.subscriptions=i}}e.$tfc=A;class k extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ufc=k;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$vfc=l;class $ extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(t,n,o,c){this.g=c,this.a=t,this.b=n,this.c=o,this.d=new C.$gm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,o]of this.d)t.push(o.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const o=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const o=this.a.getExtensionDescription(t);if(!o)throw new Error(`Extension '${t}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(t){const n=t.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new $(h));return this.c.onExtensionActivationError(t.id,h,new F.$PF(t.id.value)),i}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){o.push(i);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const r=this.a.getExtensionDescription(h);if(r){if(!r.main&&!r.browser)continue;o.push(this.j({id:r.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),b=this.k(t,n.displayName,[],new $(d));return this.c.onExtensionActivationError(n.identifier,d,new F.$PF(h)),b}return this.k(t,n.displayName,o,null)}k(t,n,o,c){const h=new a(t.id,n,t.reason,o,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$Z6b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$wfc=v,e.$wfc=v=He([Ve(3,R.$ij)],v);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,o,c,h,i,r){this.c=t,this.d=n,this.f=o,this.g=c,this.h=h,this.j=i,this.k=r,this.a=new m.$Zg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new $(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new $(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};a=He([Ve(6,R.$ij)],a)}),define(Pe[8],Ae([1,0,18,24,126,218,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,215,7,23]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$IM=e.$HM=e.MarkdownString=e.$GM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ee){function Me(H){const{selectionStartLineNumber:Fe,selectionStartColumn:Ue,positionLineNumber:Ze,positionColumn:We}=H,tt=new r.$IK(Fe-1,Ue-1),mt=new r.$IK(Ze-1,We-1);return new r.$KK(tt,mt)}Ee.to=Me;function $e(H){const{anchor:Fe,active:Ue}=H;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ee.from=$e})(d||(e.Selection=d={}));var b;(function(Ee){function Me(H){if(!H)return;const{start:Fe,end:Ue}=H;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ee.from=Me;function $e(H){if(!H)return;const{startLineNumber:Fe,startColumn:Ue,endLineNumber:Ze,endColumn:We}=H;return new r.$JK(Fe-1,Ue-1,Ze-1,We-1)}Ee.to=$e})(b||(e.Range=b={}));var f;(function(Ee){function Me($e){switch($e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ee.to=Me})(f||(e.TokenType=f={}));var D;(function(Ee){function Me(H){return new r.$IK(H.lineNumber-1,H.column-1)}Ee.to=Me;function $e(H){return{lineNumber:H.line+1,column:H.character+1}}Ee.from=$e})(D||(e.Position=D={}));var L;(function(Ee){function Me(Fe,Ue,Ze){return(0,E.$Hb)((0,E.$3b)(Fe).map(We=>$e(We,Ue,Ze)))}Ee.from=Me;function $e(Fe,Ue,Ze){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ze?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:H(Fe.scheme,Ue),pattern:Y.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ze?.isBuiltin}}function H(Fe,Ue){return Ue&&typeof Fe=="string"?Ue.transformOutgoingScheme(Fe):Fe}})(L||(e.DocumentSelector=L={}));var p;(function(Ee){function Me(H){switch(H){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ee.from=Me;function $e(H){switch(H){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ee.to=$e})(p||(e.DiagnosticTag=p={}));var y;(function(Ee){function Me(H){let Fe;return H.code&&((0,l.$Df)(H.code)||(0,l.$Hf)(H.code)?Fe=String(H.code):Fe={value:String(H.code.value),target:H.code.target}),{...b.from(H.range),message:H.message,source:H.source,code:Fe,severity:N.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(S.from),tags:Array.isArray(H.tags)?(0,E.$Hb)(H.tags.map(p.from)):void 0}}Ee.from=Me;function $e(H){const Fe=new r.$VK(b.to(H),H.message,N.to(H.severity));return Fe.source=H.source,Fe.code=(0,l.$Df)(H.code)?H.code:H.code?.value,Fe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(S.to),Fe.tags=H.tags&&(0,E.$Hb)(H.tags.map(p.to)),Fe}Ee.to=$e})(y||(e.Diagnostic=y={}));var S;(function(Ee){function Me(H){return{...b.from(H.location.range),message:H.message,resource:H.location.uri}}Ee.from=Me;function $e(H){return new r.$UK(new r.$TK(H.resource,b.to(H)),H.message)}Ee.to=$e})(S||(e.DiagnosticRelatedInformation=S={}));var N;(function(Ee){function Me(H){switch(H){case r.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Ee.from=Me;function $e(H){switch(H){case s.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ee.to=$e})(N||(e.DiagnosticSeverity=N={}));var q;(function(Ee){function Me(H){return typeof H=="number"&&H>=r.ViewColumn.One?H-1:H===r.ViewColumn.Beside?i.$TC:i.$SC}Ee.from=Me;function $e(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=$e})(q||(e.ViewColumn=q={}));function j(Ee){return typeof Ee.range<"u"}function M(Ee){return Ee.length===0?!0:!!j(Ee[0])}e.$GM=M;var U;(function(Ee){function Me(We){return We.map(Ee.from)}Ee.fromMany=Me;function $e(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let tt;if($e(We)){const{language:Dt,value:wt}=We;tt={value:"```"+Dt+`
`+wt+"\n```\n"}}else r.$9K.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const mt=Object.create(null);tt.uris=mt;const zt=Dt=>{try{let wt=$.URI.parse(Dt,!0);wt=wt.with({query:Fe(wt.query,mt)}),mt[Dt]=wt}catch{}return""},Et=new g.marked.Renderer;return Et.link=zt,Et.image=Dt=>typeof Dt=="string"?zt(R.$ik(Dt).href):"",(0,g.marked)(tt.value,{renderer:Et}),tt}Ee.from=H;function Fe(We,tt){if(!We)return We;let mt;try{mt=(0,w.$wh)(We)}catch{}if(!mt)return We;let zt=!1;return mt=(0,k.$hn)(mt,Et=>{if($.URI.isUri(Et)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Dt]=Et,zt=!0,Dt}else return}),zt?JSON.stringify(mt):We}function Ue(We){const tt=new r.$9K(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?$.URI.from(We.baseUri):void 0,tt}Ee.to=Ue;function Ze(We){if(We)return typeof We=="string"?We:Ee.from(We)}Ee.fromStrict=Ze})(U||(e.MarkdownString=U={}));function P(Ee){return M(Ee)?Ee.map(Me=>({range:b.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?U.fromMany(Me.hoverMessage):Me.hoverMessage?U.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ee.map(Me=>({range:b.from(Me)}))}e.$HM=P;function I(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?$.URI.file(Ee):Ee}e.$IM=I;var Z;(function(Ee){function Me($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?I($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Ee.from=Me})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var ue;(function(Ee){function Me($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?I($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?Z.from($e.before):void 0,after:$e.after?Z.from($e.after):void 0}}Ee.from=Me})(ue||(e.ThemableDecorationRenderOptions=ue={}));var ge;(function(Ee){function Me($e){if(typeof $e>"u")return $e;switch($e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Me})(ge||(e.DecorationRangeBehavior=ge={}));var be;(function(Ee){function Me($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?ge.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?ue.from($e.light):void 0,dark:$e.dark?ue.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?I($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?Z.from($e.before):void 0,after:$e.after?Z.from($e.after):void 0}}Ee.from=Me})(be||(e.DecorationRenderOptions=be={}));var ke;(function(Ee){function Me(H){return{text:H.newText,eol:H.newEol&&_e.from(H.newEol),range:b.from(H.range)}}Ee.from=Me;function $e(H){const Fe=new r.$OK(b.to(H.range),H.text);return Fe.newEol=typeof H.eol>"u"?void 0:_e.to(H.eol),Fe}Ee.to=$e})(ke||(e.TextEdit=ke={}));var me;(function(Ee){function Me(H,Fe){const Ue={edits:[]};if(H instanceof r.$RK){const Ze=new m.$Bc;for(const We of H._allEntries())We._type===1&&$.URI.isUri(We.to)&&We.from===void 0&&Ze.add(We.to);for(const We of H._allEntries())if(We._type===1){let tt;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?tt={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(We.options.contents))}:tt={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:tt},metadata:We.metadata})}else We._type===2?Ue.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Ze.has(We.uri)?void 0:Fe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ue.edits.push({resource:We.uri,textEdit:{range:b.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ze.has(We.uri)?void 0:Fe?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(At.from)}})}return Ue}Ee.from=Me;function $e(H){const Fe=new r.$RK,Ue=new m.$Ac;for(const Ze of H.edits)if(Ze.textEdit){const We=Ze,tt=$.URI.revive(We.resource),mt=b.to(We.textEdit.range),zt=We.textEdit.text,Et=We.textEdit.insertAsSnippet;let Dt;Et?Dt=r.$QK.replace(mt,new r.$SK(zt)):Dt=r.$OK.replace(mt,zt);const wt=Ue.get(tt);wt?wt.push(Dt):Ue.set(tt,[Dt])}else Fe.renameFile($.URI.revive(Ze.oldResource),$.URI.revive(Ze.newResource),Ze.options);for(const[Ze,We]of Ue)Fe.set(Ze,We);return Fe}Ee.to=$e})(me||(e.WorkspaceEdit=me={}));var fe;(function(Ee){const Me=Object.create(null);Me[r.SymbolKind.File]=0,Me[r.SymbolKind.Module]=1,Me[r.SymbolKind.Namespace]=2,Me[r.SymbolKind.Package]=3,Me[r.SymbolKind.Class]=4,Me[r.SymbolKind.Method]=5,Me[r.SymbolKind.Property]=6,Me[r.SymbolKind.Field]=7,Me[r.SymbolKind.Constructor]=8,Me[r.SymbolKind.Enum]=9,Me[r.SymbolKind.Interface]=10,Me[r.SymbolKind.Function]=11,Me[r.SymbolKind.Variable]=12,Me[r.SymbolKind.Constant]=13,Me[r.SymbolKind.String]=14,Me[r.SymbolKind.Number]=15,Me[r.SymbolKind.Boolean]=16,Me[r.SymbolKind.Array]=17,Me[r.SymbolKind.Object]=18,Me[r.SymbolKind.Key]=19,Me[r.SymbolKind.Null]=20,Me[r.SymbolKind.EnumMember]=21,Me[r.SymbolKind.Struct]=22,Me[r.SymbolKind.Event]=23,Me[r.SymbolKind.Operator]=24,Me[r.SymbolKind.TypeParameter]=25;function $e(Fe){return typeof Me[Fe]=="number"?Me[Fe]:6}Ee.from=$e;function H(Fe){for(const Ue in Me)if(Me[Ue]===Fe)return Number(Ue);return r.SymbolKind.Property}Ee.to=H})(fe||(e.SymbolKind=fe={}));var ne;(function(Ee){function Me(H){switch(H){case r.SymbolTag.Deprecated:return 1}}Ee.from=Me;function $e(H){switch(H){case 1:return r.SymbolTag.Deprecated}}Ee.to=$e})(ne||(e.SymbolTag=ne={}));var Se;(function(Ee){function Me(H){return{name:H.name,kind:fe.from(H.kind),tags:H.tags&&H.tags.map(ne.from),containerName:H.containerName,location:Ie.from(H.location)}}Ee.from=Me;function $e(H){const Fe=new r.$ZK(H.name,fe.to(H.kind),H.containerName,Ie.to(H.location));return Fe.tags=H.tags&&H.tags.map(ne.to),Fe}Ee.to=$e})(Se||(e.WorkspaceSymbol=Se={}));var ce;(function(Ee){function Me(H){const Fe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:b.from(H.range),selectionRange:b.from(H.selectionRange),kind:fe.from(H.kind),tags:H.tags?.map(ne.from)??[]};return H.children&&(Fe.children=H.children.map(Me)),Fe}Ee.from=Me;function $e(H){const Fe=new r.$1K(H.name,H.detail,fe.to(H.kind),b.to(H.range),b.to(H.selectionRange));return(0,E.$Lb)(H.tags)&&(Fe.tags=H.tags.map(ne.to)),H.children&&(Fe.children=H.children.map($e)),Fe}Ee.to=$e})(ce||(e.DocumentSymbol=ce={}));var X;(function(Ee){function Me(H){const Fe=new r.$5K(fe.to(H.kind),H.name,H.detail||"",$.URI.revive(H.uri),b.to(H.range),b.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}Ee.to=Me;function $e(H,Fe,Ue){if(Fe=Fe??H._sessionId,Ue=Ue??H._itemId,Fe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ue,name:H.name,detail:H.detail,kind:fe.from(H.kind),uri:H.uri,range:b.from(H.range),selectionRange:b.from(H.selectionRange),tags:H.tags?.map(ne.from)}}Ee.from=$e})(X||(e.CallHierarchyItem=X={}));var V;(function(Ee){function Me($e){return new r.$6K(X.to($e.from),$e.fromRanges.map(H=>b.to(H)))}Ee.to=Me})(V||(e.CallHierarchyIncomingCall=V={}));var re;(function(Ee){function Me($e){return new r.$7K(X.to($e.to),$e.fromRanges.map(H=>b.to(H)))}Ee.to=Me})(re||(e.CallHierarchyOutgoingCall=re={}));var Ie;(function(Ee){function Me(H){return{range:H.range&&b.from(H.range),uri:H.uri}}Ee.from=Me;function $e(H){return new r.$TK($.URI.revive(H.uri),b.to(H.range))}Ee.to=$e})(Ie||(e.location=Ie={}));var Re;(function(Ee){function Me(H){const Fe=H,Ue=H;return{originSelectionRange:Fe.originSelectionRange?b.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ue.uri,range:b.from(Fe.targetRange?Fe.targetRange:Ue.range),targetSelectionRange:Fe.targetSelectionRange?b.from(Fe.targetSelectionRange):void 0}}Ee.from=Me;function $e(H){return{targetUri:$.URI.revive(H.uri),targetRange:b.to(H.range),targetSelectionRange:H.targetSelectionRange?b.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?b.to(H.originSelectionRange):void 0}}Ee.to=$e})(Re||(e.DefinitionLink=Re={}));var Ce;(function(Ee){function Me(H){return{range:b.from(H.range),contents:U.fromMany(H.contents)}}Ee.from=Me;function $e(H){return new r.$WK(H.contents.map(U.to),b.to(H.range))}Ee.to=$e})(Ce||(e.Hover=Ce={}));var le;(function(Ee){function Me(H){return{range:b.from(H.range),expression:H.expression}}Ee.from=Me;function $e(H){return new r.$QL(b.to(H.range),H.expression)}Ee.to=$e})(le||(e.EvaluatableExpression=le={}));var ie;(function(Ee){function Me(H){if(H instanceof r.$RL)return{type:"text",range:b.from(H.range),text:H.text};if(H instanceof r.$SL)return{type:"variable",range:b.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof r.$TL)return{type:"expression",range:b.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Me;function $e(H){switch(H.type){case"text":return{range:b.to(H.range),text:H.text};case"variable":return{range:b.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:b.to(H.range),expression:H.expression}}}Ee.to=$e})(ie||(e.InlineValue=ie={}));var G;(function(Ee){function Me(H){return{frameId:H.frameId,stoppedLocation:b.from(H.stoppedLocation)}}Ee.from=Me;function $e(H){return new r.$UL(H.frameId,b.to(H.stoppedLocation))}Ee.to=$e})(G||(e.InlineValueContext=G={}));var te;(function(Ee){function Me(H){return{range:b.from(H.range),kind:H.kind}}Ee.from=Me;function $e(H){return new r.$XK(b.to(H.range),H.kind)}Ee.to=$e})(te||(e.DocumentHighlight=te={}));var x;(function(Ee){function Me(H){return{uri:H.uri,highlights:H.highlights.map(te.from)}}Ee.from=Me;function $e(H){return new r.$YK($.URI.revive(H.uri),H.highlights.map(te.to))}Ee.to=$e})(x||(e.MultiDocumentHighlight=x={}));var se;(function(Ee){function Me($e){switch($e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ee.to=Me})(se||(e.CompletionTriggerKind=se={}));var de;(function(Ee){function Me($e){return{triggerKind:se.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Ee.to=Me})(de||(e.CompletionContext=de={}));var De;(function(Ee){function Me(H){switch(H){case r.CompletionItemTag.Deprecated:return 1}}Ee.from=Me;function $e(H){switch(H){case 1:return r.CompletionItemTag.Deprecated}}Ee.to=$e})(De||(e.CompletionItemTag=De={}));var Le;(function(Ee){const Me=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function $e(Ue){return Me.get(Ue)??9}Ee.from=$e;const H=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(Ue){return H.get(Ue)??r.CompletionItemKind.Property}Ee.to=Fe})(Le||(e.CompletionItemKind=Le={}));var O;(function(Ee){function Me($e,H){const Fe=new r.$cL($e.label);return Fe.insertText=$e.insertText,Fe.kind=Le.to($e.kind),Fe.tags=$e.tags?.map(De.to),Fe.detail=$e.detail,Fe.documentation=R.$dk($e.documentation)?U.to($e.documentation):$e.documentation,Fe.sortText=$e.sortText,Fe.filterText=$e.filterText,Fe.preselect=$e.preselect,Fe.commitCharacters=$e.commitCharacters,v.$Es.isIRange($e.range)?Fe.range=b.to($e.range):typeof $e.range=="object"&&(Fe.range={inserting:b.to($e.range.insert),replacing:b.to($e.range.replace)}),Fe.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Fe.insertText=new r.$SK($e.insertText):(Fe.insertText=$e.insertText,Fe.textEdit=Fe.range instanceof r.$JK?new r.$OK(Fe.range,Fe.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=$e.additionalTextEdits.map(Ue=>ke.to(Ue))),Fe.command=H&&$e.command?H.fromInternal($e.command):void 0,Fe}Ee.to=Me})(O||(e.CompletionItem=O={}));var K;(function(Ee){function Me(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:U.fromStrict(H.documentation)}}Ee.from=Me;function $e(H){return{label:H.label,documentation:R.$dk(H.documentation)?U.to(H.documentation):H.documentation}}Ee.to=$e})(K||(e.ParameterInformation=K={}));var J;(function(Ee){function Me(H){return{label:H.label,documentation:U.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(K.from):[],activeParameter:H.activeParameter}}Ee.from=Me;function $e(H){return{label:H.label,documentation:R.$dk(H.documentation)?U.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(K.to):[],activeParameter:H.activeParameter}}Ee.to=$e})(J||(e.SignatureInformation=J={}));var W;(function(Ee){function Me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(J.from):[]}}Ee.from=Me;function $e(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(J.to):[]}}Ee.to=$e})(W||(e.SignatureHelp=W={}));var Q;(function(Ee){function Me($e,H){const Fe=new r.$bL(D.to(H.position),typeof H.label=="string"?H.label:H.label.map(_.to.bind(void 0,$e)),H.kind&&ye.to(H.kind));return Fe.textEdits=H.textEdits&&H.textEdits.map(ke.to),Fe.tooltip=R.$dk(H.tooltip)?U.to(H.tooltip):H.tooltip,Fe.paddingLeft=H.paddingLeft,Fe.paddingRight=H.paddingRight,Fe}Ee.to=Me})(Q||(e.InlayHint=Q={}));var _;(function(Ee){function Me($e,H){const Fe=new r.$aL(H.label);return Fe.tooltip=R.$dk(H.tooltip)?U.to(H.tooltip):H.tooltip,a.Command.is(H.command)&&(Fe.command=$e.fromInternal(H.command)),H.location&&(Fe.location=Ie.to(H.location)),Fe}Ee.to=Me})(_||(e.InlayHintLabelPart=_={}));var ye;(function(Ee){function Me(H){return H}Ee.from=Me;function $e(H){return H}Ee.to=$e})(ye||(e.InlayHintKind=ye={}));var ze;(function(Ee){function Me(H){return{range:b.from(H.range),url:H.target,tooltip:H.tooltip}}Ee.from=Me;function $e(H){let Fe;if(H.url)try{Fe=typeof H.url=="string"?$.URI.parse(H.url,!0):$.URI.revive(H.url)}catch{}return new r.$hL(b.to(H.range),Fe)}Ee.to=$e})(ze||(e.DocumentLink=ze={}));var Qe;(function(Ee){function Me(H){const Fe=new r.$kL(H.label);return H.textEdit&&(Fe.textEdit=ke.to(H.textEdit)),H.additionalTextEdits&&(Fe.additionalTextEdits=H.additionalTextEdits.map(Ue=>ke.to(Ue))),Fe}Ee.to=Me;function $e(H){return{label:H.label,textEdit:H.textEdit?ke.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Fe=>ke.from(Fe)):void 0}}Ee.from=$e})(Qe||(e.ColorPresentation=Qe={}));var Je;(function(Ee){function Me(H){return new r.$iL(H[0],H[1],H[2],H[3])}Ee.to=Me;function $e(H){return[H.red,H.green,H.blue,H.alpha]}Ee.from=$e})(Je||(e.Color=Je={}));var Xe;(function(Ee){function Me(H){return{range:b.from(H.range)}}Ee.from=Me;function $e(H){return new r.$4K(b.to(H.range))}Ee.to=$e})(Xe||(e.SelectionRange=Xe={}));var it;(function(Ee){function Me($e){switch($e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ee.to=Me})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(Ee){function Me(H){switch(H){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Me;function $e(H){switch(H){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ee.to=$e})(nt||(e.TextEditorLineNumbersStyle=nt={}));var _e;(function(Ee){function Me(H){if(H===r.EndOfLine.CRLF)return 1;if(H===r.EndOfLine.LF)return 0}Ee.from=Me;function $e(H){if(H===1)return r.EndOfLine.CRLF;if(H===0)return r.EndOfLine.LF}Ee.to=$e})(_e||(e.EndOfLine=_e={}));var rt;(function(Ee){function Me($e){if(typeof $e=="object")return $e.viewId;switch($e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Me})(rt||(e.ProgressLocation=rt={}));var je;(function(Ee){function Me(H){const Fe={start:H.start+1,end:H.end+1};return H.kind&&(Fe.kind=ct.from(H.kind)),Fe}Ee.from=Me;function $e(H){const Fe={start:H.start-1,end:H.end-1};return H.kind&&(Fe.kind=ct.to(H.kind)),Fe}Ee.to=$e})(je||(e.FoldingRange=je={}));var ct;(function(Ee){function Me(H){if(H)switch(H){case r.FoldingRangeKind.Comment:return a.$ut.Comment;case r.FoldingRangeKind.Imports:return a.$ut.Imports;case r.FoldingRangeKind.Region:return a.$ut.Region}}Ee.from=Me;function $e(H){if(H)switch(H.value){case a.$ut.Comment.value:return r.FoldingRangeKind.Comment;case a.$ut.Imports.value:return r.FoldingRangeKind.Imports;case a.$ut.Region.value:return r.FoldingRangeKind.Region}}Ee.to=$e})(ct||(e.FoldingRangeKind=ct={}));var ee;(function(Ee){function Me($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?b.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$iE.id:void 0}}Ee.from=Me})(ee||(e.TextEditorOpenOptions=ee={}));var Y;(function(Ee){function Me(Ue){return Ue instanceof r.$EL?Ue.toJSON():typeof Ue=="string"?Ue:$e(Ue)||H(Ue)?new r.$EL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ee.from=Me;function $e(Ue){const Ze=Ue;return Ze?$.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function H(Ue){const Ze=Ue;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(Ue){return typeof Ue=="string"?Ue:new r.$EL($.URI.revive(Ue.baseUri),Ue.pattern)}Ee.to=Fe})(Y||(e.GlobPattern=Y={}));var ve;(function(Ee){function Me($e){if($e){if(Array.isArray($e))return $e.map(Me);if(typeof $e=="string")return $e;{const H=$e;return{language:H.language,scheme:H.scheme,pattern:Y.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ee.from=Me})(ve||(e.LanguageSelector=ve={}));var Be;(function(Ee){function Me(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&$.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ze=>Ze instanceof r.$JK)))}Ee.is=Me;function $e(H){return{documents:H.documents.map(Fe=>Fe.map(Ue=>({uri:$.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>b.from(Ze))})))}}Ee.from=$e})(Be||(e.MappedEditsContext=Be={}));var Ke;(function(Ee){function Me(H){return{start:H.start,end:H.end}}Ee.from=Me;function $e(H){return new r.$6L(H.start,H.end)}Ee.to=$e})(Ke||(e.NotebookRange=Ke={}));var xe;(function(Ee){function Me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ee.to=Me;function $e(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ee.from=$e})(xe||(e.NotebookCellExecutionSummary=xe={}));var ot;(function(Ee){function Me($e){if($e===o.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if($e===o.NotebookCellExecutionState.Pending)return;if($e===o.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Ee.to=Me})(ot||(e.NotebookCellExecutionState=ot={}));var pt;(function(Ee){function Me(H){switch(H){case r.NotebookCellKind.Markup:return o.CellKind.Markup;case r.NotebookCellKind.Code:default:return o.CellKind.Code}}Ee.from=Me;function $e(H){switch(H){case o.CellKind.Markup:return r.NotebookCellKind.Markup;case o.CellKind.Code:default:return r.NotebookCellKind.Code}}Ee.to=$e})(pt||(e.NotebookCellKind=pt={}));var Oe;(function(Ee){function Me(H){const Fe={metadata:H.metadata??Object.create(null),cells:[]};for(const Ue of H.cells)r.$7L.validate(Ue),Fe.cells.push(At.from(Ue));return Fe}Ee.from=Me;function $e(H){const Fe=new r.$8L(H.cells.map(At.to));return(0,l.$Qf)(H.metadata)||(Fe.metadata=H.metadata),Fe}Ee.to=$e})(Oe||(e.NotebookData=Oe={}));var At;(function(Ee){function Me(H){return{cellKind:pt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:xe.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(jt.from):[]}}Ee.from=Me;function $e(H){return new r.$7L(pt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(jt.to):void 0,H.metadata,H.internalMetadata?xe.to(H.internalMetadata):void 0)}Ee.to=$e})(At||(e.NotebookCellData=At={}));var Kt;(function(Ee){function Me(H){return{mime:H.mime,valueBytes:T.$ge.wrap(H.data)}}Ee.from=Me;function $e(H){return new r.$9L(H.valueBytes.buffer,H.mime)}Ee.to=$e})(Kt||(e.NotebookCellOutputItem=Kt={}));var jt;(function(Ee){function Me(H){return{outputId:H.id,items:H.items.map(Kt.from),metadata:H.metadata}}Ee.from=Me;function $e(H){const Fe=H.items.map(Kt.to);return new r.$0L(Fe,H.outputId,H.metadata)}Ee.to=$e})(jt||(e.NotebookCellOutput=jt={}));var bt;(function(Ee){function Me(Fe){return H(Fe)?{include:Y.from(Fe.include)??void 0,exclude:Y.from(Fe.exclude)??void 0}:Y.from(Fe)??void 0}Ee.from=Me;function $e(Fe){return H(Fe)?{include:Y.to(Fe.include),exclude:Y.to(Fe.exclude)}:Y.to(Fe)}Ee.to=$e;function H(Fe){const Ue=Fe;return Ue?!(0,l.$Mf)(Ue.include)&&!(0,l.$Mf)(Ue.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var Vt;(function(Ee){function Me($e,H,Fe){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ue,Fe),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Ee.from=Me})(Vt||(e.NotebookStatusBarItem=Vt={}));var Ut;(function(Ee){function Me($e,H,Fe){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:H.toInternal(Ue,Fe),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Ee.from=Me})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ht;(function(Ee){function Me($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Ee.from=Me})(Ht||(e.NotebookDocumentContentOptions=Ht={}));var Gt;(function(Ee){function Me(H){return{uri:H.uri,provides:H.provides}}Ee.from=Me;function $e(H){return new r.$_L($.URI.revive(H.uri),H.provides)}Ee.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var Rt;(function(Ee){function Me(H){return{message:U.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:b.from(H.location.range),uri:H.location.uri}}}Ee.from=Me;function $e(H){const Fe=new r.$fM(typeof H.message=="string"?H.message:U.to(H.message));return Fe.actualOutput=H.actual,Fe.expectedOutput=H.expected,Fe.contextValue=H.contextValue,Fe.location=H.location?Ie.to(H.location):void 0,Fe}Ee.to=$e})(Rt||(e.TestMessage=Rt={}));var It;(function(Ee){Ee.namespace=h.$BJ,Ee.denamespace=h.$CJ})(It||(e.TestTag=It={}));var Ye;(function(Ee){function Me(H){const Fe=(0,t.$FM)(H).controllerId;return{extId:c.$xJ.fromExtHostTestItem(H,Fe).toString(),label:H.label,uri:$.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Ue=>It.namespace(Fe,Ue.id)),range:v.$Es.lift(b.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&U.fromStrict(H.error)||null}}Ee.from=Me;function $e(H){return{parent:void 0,error:void 0,id:c.$xJ.fromString(H.extId).localId,label:H.label,uri:$.URI.revive(H.uri),tags:(H.tags||[]).map(Fe=>{const{tagId:Ue}=It.denamespace(Fe);return new r.$gM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ee.toPlain=$e})(Ye||(e.TestItem=Ye={})),function(Ee){function Me(H){return{id:H.id}}Ee.from=Me;function $e(H){return new r.$gM(H.id)}Ee.to=$e}(It||(e.TestTag=It={}));var Jt;(function(Ee){const Me=(H,Fe)=>{const Ue=[];for(const[We,tt]of Fe)c.$xJ.compare(tt.item.extId,We)===2&&(Fe.delete(We),Ue.push(tt));const Ze={...Ye.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(Rt.to)})),children:Ue.map(We=>Me(We,Fe))};for(const We of Ze.children)We.parent=Ze;return Ze};function $e(H){const Fe=[],Ue=new Map;for(const Ze of H.items){Ue.set(Ze.item.extId,Ze);const We=c.$xJ.root(Ze.item.extId);H.request.targets.some(tt=>tt.controllerId===We&&tt.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:H.completedAt,results:Fe.map(Ze=>Me(Ze,Ue))}}Ee.to=$e})(Jt||(e.TestResults=Jt={}));var qt;(function(Ee){function Me(Ue){return{covered:Ue.covered,total:Ue.total}}function $e(Ue){return"line"in Ue?D.from(Ue):b.from(Ue)}function H(Ue){return"branches"in Ue?{count:Ue.executionCount,location:$e(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&$e(Ze.location)})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:$e(Ue.location)}}Ee.fromDetailed=H;function Fe(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(H)}}Ee.fromFile=Fe})(qt||(e.TestCoverage=qt={}));var ut;(function(Ee){function Me($e){switch($e){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ee.to=Me})(ut||(e.CodeActionTriggerKind=ut={}));var gt;(function(Ee){function Me(H){const Fe=new r.$mM(fe.to(H.kind),H.name,H.detail||"",$.URI.revive(H.uri),b.to(H.range),b.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}Ee.to=Me;function $e(H,Fe,Ue){if(Fe=Fe??H._sessionId,Ue=Ue??H._itemId,Fe===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ue,kind:fe.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:b.from(H.range),selectionRange:b.from(H.selectionRange),tags:H.tags?.map(ne.from)}}Ee.from=$e})(gt||(e.TypeHierarchyItem=gt={}));var Zt;(function(Ee){function Me($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Ee.from=Me})(Zt||(e.ViewBadge=Zt={}));var Ct;(function(Ee){function Me(Ue,Ze,We){const tt=Ze.fileData;return tt?new r.$xL(new r.$yL(tt.name,$.URI.revive(tt.uri),tt.id,(0,F.$db)(()=>We(tt.id)))):Ue===A.$1r.uriList&&Ze.uriListData?new r.$wL(Fe(Ze.uriListData)):new r.$wL(Ze.asString)}Ee.to=Me;async function $e(Ue,Ze){const We=await Ze.asString();if(Ue===A.$1r.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const tt=Ze.asFile();return{asString:We,fileData:tt?{name:tt.name,uri:tt.uri,id:tt._itemId??tt.id}:void 0}}Ee.from=$e;function H(Ue){return C.$bt.split(Ue).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return $.URI.parse(Ze)}catch{}return Ze})}function Fe(Ue){return C.$bt.create(Ue.map(Ze=>typeof Ze=="string"?Ze:$.URI.revive(Ze)))}})(Ct||(e.DataTransferItem=Ct={}));var St;(function(Ee){function Me(H,Fe){const Ue=H.items.map(([Ze,We])=>[Ze,Ct.to(Ze,We,Fe)]);return new r.$zL(Ue)}Ee.toDataTransfer=Me;async function $e(H){const Fe={items:[]},Ue=[];for(const[Ze,We]of H)Ue.push((async()=>{Fe.items.push([Ze,await Ct.from(Ze,We)])})());return await Promise.all(Ue),Fe}Ee.from=$e})(St||(e.DataTransfer=St={}));var dt;(function(Ee){function Me($e){return{kind:"reply",message:$e.message,title:$e.title,tooltip:$e.tooltip}}Ee.from=Me})(dt||(e.ChatReplyFollowup=dt={}));var Ft;(function(Ee){function Me($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:dt.from($e)}Ee.from=Me})(Ft||(e.ChatFollowup=Ft={}));var Nt;(function(Ee){function Me(H){const Fe=new r.$yM(yt.to(H.role),H.content);return Fe.name=H.name,Fe}Ee.to=Me;function $e(H){return{role:yt.from(H.role),content:H.content,name:H.name}}Ee.from=$e})(Nt||(e.ChatMessage=Nt={}));var yt;(function(Ee){function Me(H){switch(H){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ee.to=Me;function $e(H){switch(H){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ee.from=$e})(yt||(e.ChatMessageRole=yt={}));var qe;(function(Ee){function Me(Fe){const Ue={};for(const Ze of Object.keys(Fe))Ue[Ze]=Fe[Ze].map(Ee.to);return Ue}Ee.objectTo=Me;function $e(Fe){return{level:Lt.to(Fe.level),kind:Fe.kind,value:(0,w.$xh)(Fe.value),description:Fe.description}}Ee.to=$e;function H(Fe){return{level:Lt.from(Fe.level),kind:Fe.kind,value:Fe.value,description:Fe.description}}Ee.from=H})(qe||(e.ChatVariable=qe={}));var Lt;(function(Ee){function Me(H){switch(H){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ee.to=Me;function $e(H){switch(H){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ee.from=$e})(Lt||(e.ChatVariableLevel=Lt={}));var Bt;(function(Ee){function Me($e){switch($e){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Me})(Bt||(e.InteractiveEditorResponseFeedbackKind=Bt={}));var Qt;(function(Ee){function Me($e,H){return"placeholder"in H&&"resolvedContent"in H?{content:H.placeholder,kind:"asyncContent"}:"markdownContent"in H?((0,u.$SF)($e,"chatAgents2Additions"),{content:U.from(H.markdownContent),kind:"markdownContent"}):"content"in H?"vulnerabilities"in H&&H.vulnerabilities?((0,u.$SF)($e,"chatAgents2Additions"),{content:H.content,vulnerabilities:H.vulnerabilities,kind:"vulnerability"}):typeof H.content=="string"?{content:H.content,kind:"content"}:((0,u.$SF)($e,"chatAgents2Additions"),{content:U.from(H.content),kind:"markdownContent"}):"documents"in H?{documents:H.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ue=>b.from(Ue))})),kind:"usedContext"}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:b.from(H.reference.range)}:H.reference,kind:"reference"}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:b.from(H.inlineReference.range)}:H.inlineReference,name:H.title,kind:"inlineReference"}:"agentName"in H?((0,u.$SF)($e,"chatAgents2Additions"),{agentName:H.agentName,command:H.command,kind:"agentDetection"}):"treeData"in H?{treeData:H.treeData,kind:"treeData"}:"message"in H?{content:H.message,kind:"progressMessage"}:void 0}Ee.from=Me})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(Ee){function Me($e){return{label:$e.label,values:$e.values.map(qe.from),insertText:$e.insertText,detail:$e.detail,documentation:$e.documentation}}Ee.from=Me})(ft||(e.ChatAgentCompletionItem=ft={}));var Mt;(function(Ee){function Me($e,H,Fe){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand,shouldExecute:$e.shouldExecute}:"uri"in $e?{uri:$e.uri}:H.toInternal($e,Fe)}Ee.from=Me})(Mt||(e.TerminalQuickFix=Mt={}))}),define(Pe[219],Ae([1,0,2,11,7,8,185]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class m{constructor(w,A,k,l={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=k,this.g=l,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,k,l)=>{const v={dispose:this.a.push([A,k,w])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(w,A){const k=E.URI.revive(w);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),v=[];try{for(const a of[...this.a]){if(l)break;const s=this.d.getDocument(k),t=await this.h(a,{document:s,reason:F.TextDocumentSaveReason.to(A)});v.push(t)}}finally{clearTimeout($)}return v}h([w,A,k],l){const $=this.b.get(w);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(k,w,A,l).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const a=this.b.get(w);this.b.set(w,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,k,l){const $=[],v=Date.now(),{document:a,reason:s}=l,{version:t}=a,n=Object.freeze({document:a,reason:s,waitUntil(o){if(Object.isFrozen($))throw(0,T.$8)("waitUntil can not be called async");$.push(Promise.resolve(o))}});try{A.apply(k,[n])}catch(o){return Promise.reject(o)}return Object.freeze($),new Promise((o,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all($).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(h),o(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(o=>{const c={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(i=>i instanceof C.$OK))for(const{newText:i,newEol:r,range:u}of h)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:u&&F.Range.from(u),text:i,eol:r&&F.EndOfLine.from(r)}});if(c.edits.length!==0)return t===a.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$3fc=m}),define(Pe[220],Ae([1,0,13,2,8,7,76]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=e.$8fc=void 0;class m{constructor(k,l,$,v){this.start=k,this.deletedCount=l,this.deletedItems=$,this.items=v}asApiEvent(){return{range:new F.$6L(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,$){this.notebook=k,this.h=l,this.j=$,this.handle=$.handle,this.uri=T.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(C.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(v){k.g=v},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze($)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,l,$){const v=$.map(C.NotebookCellOutputItem.to),a=this.a.find(s=>s.id===k);if(a&&(l||(a.items.length=0),a.items.push(...v),a.items.length>1&&a.items.every(s=>R.$JI(s.mime)))){const s=new Map,t=[];a.items.forEach(n=>{let o;s.has(n.mime)?o=s.get(n.mime):(o=[],s.set(n.mime,o),t.push(n.mime)),o.push(n.data)}),a.items.length=0,t.forEach(n=>{const o=R.$KI(s.get(n));a.items.push({mime:n,data:o.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$8fc=g;class w{static{this.a=0}constructor(k,l,$,v,a){this.k=k,this.l=l,this.m=$,this.uri=v,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===E.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt($){return $=k.n($),k.b[$].apiCell},getCells($){return($?k.p($):k.b).map(a=>a.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,$){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const v={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},a=[];for(const t of k.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,v.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,v.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),a.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),a.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const s=new Map;for(let t=0;t<a.length;t++){const n=a[t],o=s.get(n.cell);if(o===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});s.set(n.cell,c-1)}else v.cellChanges[o]={...v.cellChanges[o],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,$=k.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),k.with({start:l,end:$})}p(k){k=this.o(k);const l=[];for(let $=k.start;$<k.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,$){if(this.j)return;const v=[],a=[],s=[];if(k.reverse().forEach(t=>{const o=t[2].map(i=>{const r=new g(this,this.l,i);return l||a.push(g.asModelAddData(this.apiNotebook,i)),r}),c=new m(t[0],t[1],[],o),h=this.b.splice(t[0],t[1],...o);for(const i of h)s.push(i.uri),c.deletedItems.push(i.apiCell);v.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:s}),$)for(const t of v)$.push(t.asApiEvent())}s(k,l,$,v){const a=this.b.splice(k,l);this.b.splice($,0,...a);const s=[new m(k,l,a.map(t=>t.apiCell),[]),new m($,0,[],a)];for(const t of s)v.push(t.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,$,v){this.b[k].setOutputItems(l,$,v)}v(k,l){const $=this.b[k];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(k,l){const $=this.b[k];$.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$9fc=w}),define(Pe[221],Ae([1,0,5,2,8,7]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class R{constructor(g,w,A,k={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=A,this.f=k,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,A,k)=>{const l=function(v){w.call(A,v)};return l.extension=g,this.a.event(l,void 0,k)}}async $participateInSave(g,w,A){const k=T.URI.revive(g),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(w)},A,async(a,s)=>{const t=Date.now(),n=await await Promise.resolve(a);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof F.$RK?$.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if($.length===0)return!0;const v={edits:[]};for(const a of $){const{edits:s}=C.WorkspaceEdit.from(a);v.edits=v.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$mgc=R}),define(Pe[107],Ae([1,0,11,8,7]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,w,A,k,l){this.id=m,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(C.$6L.isNotebookRange))throw(0,E.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,w){m.f.$tryRevealRange(m.id,T.NotebookRange.from(g),w??C.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(T.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$0fc=F}),define(Pe[222],Ae([1,0,11,5,15,8]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;let R=class{constructor(g,w){this.c=g,this.d=w,this.a=new T.$Sd({onListenerError:E.$2}),this.b=new T.$Sd({onListenerError:E.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,w);const A=this.d.getEditorById(g);w.visibleRanges&&A._acceptVisibleRanges(w.visibleRanges.ranges.map(F.NotebookRange.to)),w.selections&&A._acceptSelections(w.selections.selections.map(F.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const w in g)this.d.getEditorById(w)._acceptViewColumn(F.ViewColumn.to(g[w]))}};e.$ogc=R,e.$ogc=R=He([Ve(0,C.$ij)],R)}),define(Pe[223],Ae([1,0,8,72,162,20,66,11]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,$,v){const a=this.b++,{title:s,location:t,cancellable:n}=$,o={label:(0,C.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(a,{location:E.ProgressLocation.from(t),title:s,source:o,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch(m.$2),this.d(a,v,!!n)}d(l,$,v){let a;v&&(a=new F.$3d,this.c.set(l,a));const s=n=>{this.a.$progressEnd(n),this.c.delete(n),a?.dispose()};let t;try{t=$(new A(this.a,l),v&&a?a.token:F.CancellationToken.None)}catch(n){throw s(l),n}return t.then(n=>s(l),n=>s(l)),t}$acceptProgressCanceled(l){const $=this.c.get(l);$&&($.cancel(),this.c.delete(l))}}e.$vgc=g;function w(k,l){return k.message=l.message,typeof l.increment=="number"&&(typeof k.increment=="number"?k.increment+=l.increment:k.increment=l.increment),k}class A extends T.$ev{constructor(l,$){super(v=>this.throttledReport(v)),this.c=l,this.d=$}throttledReport(l){this.c.$progressReport(this.d,l)}}He([(0,R.$uh)(100,(k,l)=>w(k,l),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,58,8,2]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=e.$VM=void 0;const w=(o,c,h,i)=>{let r=c;return{enumerable:!0,configurable:!1,get(){return r},set(u){if(!h(r,u)){const d=r;r=u,o.listener?.(i(u,d))}}}},A=(o,c)=>o===c,k={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(o,c)=>!(o.length!==c.length||o.some(h=>!c.find(i=>h.id===i.id)))},l=o=>c=>({op:4,update:o(c)}),$=(o,c)=>({range:(()=>{let h;const i=l(r=>({range:E.$Es.lift(m.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return h},set(r){o.listener?.({op:6}),k.range(h,r)||(h=r,o.listener?.(i(r)))}}})(),label:w(o,c,k.label,l(h=>({label:h}))),description:w(o,void 0,k.description,l(h=>({description:h}))),sortText:w(o,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:w(o,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:w(o,!1,k.busy,l(h=>({busy:h}))),error:w(o,void 0,k.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(o,[],k.tags,(h,i)=>({op:1,new:h.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),v=o=>{const c=C.$xJ.fromString(o.extId),h=new s(c.controllerId,c.localId,o.label,g.URI.revive(o.uri)||void 0);return h.range=m.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(i=>m.TestTag.to({id:(0,R.$CJ)(i).tagId})),h},a=o=>{let c;for(const h of o.tests){const i=v(h.item);(0,T.$FM)(i).parent=c,c=i}return c};e.$VM=a;class s{constructor(c,h,i,r){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$EM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,F.$DM)(u,T.$FM,s),enumerable:!0,writable:!1},...$(u,i)})}}e.$WM=s;class t extends s{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$XM=t;class n extends F.$zM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:T.$FM,getChildren:r=>r.children,root:new t(c,h),toITestItem:m.TestItem.from})}}e.$YM=n}),define(Pe[109],Ae([1,0,53,11,89,8,7]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=e.$QM=void 0;class m{static{this.c=new C.$OM("TextEditorDecorationType")}constructor(l,$,v){const a=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,a,F.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:a,dispose(){l.$removeTextEditorDecorationType(a)}})}}e.$QM=m;class g{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let v=null;if(l instanceof R.$IK)v=new R.$JK(l,l);else if(l instanceof R.$JK)v=l;else throw new Error("Unrecognized location");this.l(v,$,!1)}insert(l,$){this.k(),this.l(new R.$JK(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof R.$JK)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,v){const a=this.c.validateRange(l);this.g.push({range:a,text:$,forceMoveMarkers:v})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=l}}class w{constructor(l,$,v,a){this.c=l,this.d=$,this._accept(v),this.e=a;const s=this;this.value={get tabSize(){return s.f},set tabSize(t){s.m(t)},get indentSize(){return s.g},set indentSize(t){s.o(t)},get insertSpaces(){return s.h},set insertSpaces(t){s.q(t)},get cursorStyle(){return s.j},set cursorStyle(t){s.s(t)},get lineNumbers(){return s.k},set lineNumbers(t){s.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}m(l){const $=this.l(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}o(l){const $=this.n(l);if($!==null){if(typeof $=="number"){if(this.g===$)return;this.g=$}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const $=this.p(l);if(typeof $=="boolean"){if(this.h===$)return;this.h=$}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let v=!1;if(typeof l.tabSize<"u"){const a=this.l(l.tabSize);a==="auto"?(v=!0,$.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,v=!0,$.tabSize=a)}if(typeof l.indentSize<"u"){const a=this.n(l.indentSize);a==="tabSize"?(v=!0,$.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,v=!0,$.indentSize=a)}if(typeof l.insertSpaces<"u"){const a=this.p(l.insertSpaces);a==="auto"?(v=!0,$.insertSpaces=a):this.h!==a&&(this.h=a,v=!0,$.insertSpaces=a)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,v=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,v=!0,$.lineNumbers=F.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,$))}u(l,$){$.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(v)})}}e.$RM=w;class A{constructor(l,$,v,a,s,t,n,o){this.id=l,this.j=$,this.k=v,this.g=!1,this.h=new Set,this.c=s,this.d=new w(this.j,this.id,t,v),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return a.value},set document(h){throw new T.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$KK))throw(0,T.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$KK)))throw(0,T.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new g(a.value,i);return h(r),c.m(r)},insertSnippet(h,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>F.Range.from(d));else if(i instanceof R.$IK){const{lineNumber:d,column:b}=F.Position.from(i);u=[{startLineNumber:d,startColumn:b,endLineNumber:d,endColumn:b}]}else if(i instanceof R.$JK)u=[F.Range.from(i)];else{u=[];for(const d of i)if(d instanceof R.$JK)u.push(F.Range.from(d));else{const{lineNumber:b,column:f}=F.Position.from(d);u.push({startLineNumber:b,startColumn:f,endLineNumber:b,endColumn:f})}}return $.$tryInsertSnippet(l,a.value.version,h.value,u,r)},setDecorations(h,i){const r=i.length===0;r&&!c.h.has(h.key)||(r?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(F.$GM(i))return $.$trySetDecorations(l,h.key,F.$HM(i));{const u=new Array(4*i.length);for(let d=0,b=i.length;d<b;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return $.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>$.$tryRevealRange(l,F.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){$.$tryShowEditor(l,F.ViewColumn.from(h))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const v=$.edits.map(s=>s.range);v.sort((s,t)=>s.end.line===t.end.line?s.end.character===t.end.character?s.start.line===t.start.line?s.start.character-t.start.character:s.start.line-t.start.line:s.end.character-t.end.character:s.end.line-t.end.line);for(let s=0,t=v.length-1;s<t;s++){const n=v[s].end;if(v[s+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=$.edits.map(s=>({range:F.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,a,{setEndOfLine:typeof $.setEndOfLine=="number"?F.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$SM=A}),define(Pe[224],Ae([1,0,166,25,2,5,6,204,14,7,16,18,8,52,20,131,23]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;function t(c,h){if((0,A.$Df)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Sc{constructor(h,i,r){super(),this.f=h,this.g=i,this.h=r,this.a=new Map,this.b=new a.$37;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(b=>u(b)?this.r(b):b):d})}registerTreeDataProvider(h,i,r){const u=this.createTreeView(h,{treeDataProvider:i},r);return{dispose:()=>u.dispose()}}createTreeView(h,i,r){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,D=this.m(h,i,r),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:b,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(h,L),y={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$SF)(r,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$SF)(r,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(S){(0,$.$dk)(S)&&(0,s.$SF)(r,"treeViewMarkdownMessage"),D.message=S},get title(){return D.title},set title(S){D.title=S},get description(){return D.description},set description(S){D.description=S},get badge(){return D.badge},set badge(S){S!==void 0&&w.ViewBadge.isViewBadge(S)?D.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(D.badge=void 0)},reveal:(S,N)=>D.reveal(S,N),dispose:async()=>{await p,this.a.delete(h),D.dispose()}};return this.B(y),y}$getChildren(h,i){const r=this.a.get(h);return r?r.getChildren(i):Promise.reject(new m.$RE(h))}async $handleDrop(h,i,r,u,d,b,f,D){const L=this.a.get(h);if(!L)return Promise.reject(new m.$RE(h));const p=l.DataTransfer.toDataTransfer(r,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&D&&await this.j(p,L,D,d,b),L.onDrop(p,u,d)}async j(h,i,r,u,d){const b=this.b.removeDragOperationTransfer(d);if(b)(await b)?.forEach((f,D)=>{f&&h.set(D,f)});else if(d&&i.handleDrag){const f=i.handleDrag(r,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,r,u){const d=this.a.get(h);if(!d)return Promise.reject(new m.$RE(h));const b=await this.j(new w.$zL,d,i,u,r);if(!(!b||u.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new m.$RE(h);return i.hasResolve}$resolve(h,i,r){const u=this.a.get(h);if(!u)throw new m.$RE(h);return u.resolveTreeItem(i,r)}$setExpanded(h,i,r){const u=this.a.get(h);if(!u)throw new m.$RE(h);u.setExpanded(i,r)}$setSelectionAndFocus(h,i,r){const u=this.a.get(h);if(!u)throw new m.$RE(h);u.setSelectionAndFocus(i,r)}$setVisible(h,i){const r=this.a.get(h);if(!r){if(!i)return;throw new m.$RE(h)}r.setVisible(i)}$changeCheckboxState(h,i){const r=this.a.get(h);if(!r)throw new m.$RE(h);r.setCheckboxState(i)}m(h,i,r){const u=this.B(new o(h,i,this.f,this.g.converter,this.h,r));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Ogc=n;class o extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Mf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,r,u,d,b){if(super(),this.I=h,this.J=r,this.L=u,this.M=d,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$3d,b.contributes&&b.contributes.views)for(const p in b.contributes.views)for(const y of b.contributes.views[p])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let f,D;const L=F.Event.debounce(this.F.event,(p,y)=>(p||(p={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(S=>D=S),this.G=this.G.then(()=>f)),Array.isArray(y.element)?p.elements.push(...y.element):p.elements.push(y.element)),y.message&&(p.message=!0),p),200,!0);this.B(L(({message:p,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const S=D;return f=null,this.$(y).then(()=>S())})),p&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let r=this.X(h);return r||(r=await this.Y(i)),r?r.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const r=(0,A.$Mf)(i.select)?!0:i.select,u=(0,A.$Mf)(i.focus)?!1:i.focus,d=(0,A.$Mf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(b=>this.W(h,b[b.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:b.map(D=>D.item)},{select:r,focus:u,expand:d})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:r,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const r=this.getExtensionElement(h);r&&(i?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(h,i){const r=!(0,k.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async r=>{const u=this.getExtensionElement(r.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:r.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);i.forEach(r=>{r.treeItem.checkboxState=r.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(r=>[r.extensionItem,r.newState])})}async handleDrag(h,i,r){const u=[];for(const d of h){const b=this.getExtensionElement(d);b&&u.push(b)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,r),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,r){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Tg)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const r=this.j.get(h);if(r){const u=this.m.get(r);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,r,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(r=>this.W(i,r[r.length-1]).then(u=>(r.push(u),r))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Tg)(()=>this.f.getParent(h))}W(h,i){const r=this.m.get(h);return r?Promise.resolve(r):(0,g.$Tg)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const b=this.m.get(d);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const r=this.getExtensionElement(h);i=r?this.m.get(r):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new v.$3d(this.Z.token);try{const r=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=await Promise.all((0,k.$Hb)(u||[]).map(async b=>{const f=await this.f.getTreeItem(b);return f&&!i.token.isCancellationRequested?this.db(b,f,r):null}));return i.token.isCancellationRequested?void 0:(0,k.$Hb)(d)}finally{i.dispose()}}$(h){if(h.some(r=>!r))return this.Z.dispose(!0),this.Z=new v.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(h);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(h){const i=new Set,r=h.map(d=>this.m.get(d));for(const d of r)if(d&&!i.has(d.item.handle)){let b=d;for(;b&&b.parent&&r.findIndex(f=>b&&b.parent&&f&&f.item.handle===b.parent.item.handle)===-1;){const f=this.j.get(b.parent.item.handle);b=f?this.m.get(f):void 0}b&&!b.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const b=this.j.get(d);if(b){const f=this.m.get(b);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(r=>this.cb(r).then(u=>{u&&(i[r]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const r=this.m.get(i);if(r)return this.rb(i),(0,g.$Tg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,r.parent);return this.pb(i,d,r,r.parent),r.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,r){const u=this.ib(h,i,r);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,r),u}eb(h){return w.$9K.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,r,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,r=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:u}}hb(h){if(!w.$uL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,r){this.hb(i);const u=this.B(new R.$Rc),d=this.kb(h,i,r),b=this.lb(i);return{item:{handle:d,parentHandle:r?r.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:b,iconDark:this.mb(i)||b,themeIcon:this.jb(i),collapsibleState:(0,A.$Mf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:r,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$CL?h.iconPath:void 0}kb(h,{id:i,label:r,resourceUri:u},d,b){if(i)return`${o.b}/${i}`;const f=t(r,this.N),D=d?d.item.handle:o.a;let L=f?f.label:u?(0,T.$zg)(u):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const p=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let S,N=0;do{if(S=`${D}/${N}:${L}`,b||!this.j.has(S)||p===S)break;N++}while(N<=y.length);return S}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$CL))return typeof h.iconPath=="string"||C.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$CL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return C.URI.isUri(h)?h:C.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,r,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(h,i);const d=this.X(u)||[],b=d.filter(f=>f.item.handle===r.item.handle)[0];b&&d.splice(d.indexOf(b),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Ae([1,0,178,11,31,97,73,30,22,225,188,101]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=void 0;const l=m.$rn.as(R.$sn.JSONContribution);class ${constructor(h,i,r){this.a=h,this.b=i,this.c=r}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(C.default.Error,h)}warn(h){this.d(C.default.Warning,h)}info(h){this.d(C.default.Info,h)}}e.$YF=$;class v{static a(h){const i=new g.$fm;for(let r=0,u=h.length;r<u;r++)i.add(h[r].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new v(i,[]);if(!i||!i.length)return new v([],h);const r=this.a(h),u=this.a(i),d=i.filter(f=>!r.has(f.description.identifier)),b=h.filter(f=>!u.has(f.description.identifier));return new v(d,b)}constructor(h,i){this.added=h,this.removed=i}}e.$ZF=v;class a{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=v.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$1F=a;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$2F={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$dm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$9n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$9n}},extensionKind:{description:E.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new a(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&k.$DF.register(h.extensionPoint,h.activationEventsGenerator),e.$2F.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$2F),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$3F=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$rn.add(o.ExtensionsRegistry,new n),e.$4F=m.$rn.as(o.ExtensionsRegistry),l.registerSchema(t,e.$2F),l.registerSchema(A.$Bj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[227],Ae([1,0,174,16,26,226,35,5]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function $(v,a,s){if(!v)return;const t=T.$Df(v.type)?v.type:void 0;if(!t||t.length===0){s.error(E.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const o of v.required)T.$Df(o)&&n.push(o);return{extensionId:a.value,taskType:t,required:n,properties:v.properties?C.$fn(v.properties):{},when:v.when?R.$Yi.deserialize(v.when):void 0}}l.from=$})(w||(w={}));const A=F.$4F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const v of l)v.type&&$.push(`onTaskType:${v.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new m.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,v)=>{A.setHandler((a,s)=>{this.c=void 0;try{for(const t of s.removed){const n=t.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const t of s.added){const n=t.value;for(const o of n){const c=w.from(o,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const v of this.all()){const a={type:"object",additionalProperties:!1};v.required.length>0&&(a.required=v.required.slice(0)),v.properties!==void 0?a.properties=C.$fn(v.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[v.taskType]},$.push(a)}this.c={oneOf:$}}return this.c}}e.$aG=new k}),define(Pe[228],Ae([1,0,175,16,25,26,35,227]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$kG=e.JsonSchemaVersion=e.ExecutionEngine=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$eG=e.ShellQuoting=e.$dG=e.$cG=e.$bG=void 0,e.$bG="settings",e.$cG=new R.$fj("taskRunning",!1,E.localize(0,null)),e.$dG={value:E.localize(1,null),original:"Tasks"};var g;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$eG="$customized",function(P){function I(Z){if(!Z)return P.Strong;switch(Z.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=I}(g||(e.ShellQuoting=g={}));var w;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(A||(e.RevealKind=A={})),function(P){function I(Z){switch(Z.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=I}(A||(e.RevealKind=A={}));var k;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(P){function I(Z){switch(Z.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=I}(k||(e.RevealProblemKind=k={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function I(Z){switch(Z.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=I}(l||(e.PanelKind=l={}));var $;(function(P){P.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var v;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(P){function I(ue){switch(ue.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=I;function Z(ue){switch(ue){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=Z}(v||(e.RuntimeType=v={}));var a;(function(P){function I(Z){return T.$Df(Z)?Z:Z.value}P.value=I})(a||(e.CommandString=a={}));var s;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function I(ue){return ue===P.Clean._id||ue===P.Build._id||ue===P.Rebuild._id||ue===P.Test._id}P.is=I;function Z(ue){if(ue!==void 0)return T.$Df(ue)?I(ue)?{_id:ue,isDefault:!1}:void 0:ue}P.from=Z})(s||(e.TaskGroup=s={}));var t;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function I(Z){switch(Z){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=I})(n||(e.TaskSourceKind=n={}));var o;(function(P){P.parallel="parallel",P.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(I,Z,ue,ge,be,ke){this._label="",this._id=I,Z&&(this._label=Z),ue&&(this.type=ue),this.runOptions=ge,this.configurationProperties=be,this._source=ke}getDefinition(I){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const I={folder:this.d(),id:this._id};return JSON.stringify(I)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(I,Z=!1){if(I===void 0)return!1;if(T.$Df(I))return I===this._label||I===this.configurationProperties.identifier||Z&&I===this._id;const ue=this.getDefinition(!0);return ue!==void 0&&ue._key===I._key}getQualifiedLabel(){const I=this.getWorkspaceFolder();return I?`${this._label} (${I.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(I){this.c===void 0&&(this.c=[]),I&&(this.c=this.c.concat(I))}get taskLoadMessages(){return this.c}}e.$fG=i;class r extends i{constructor(I,Z,ue,ge,be,ke,me,fe){super(I,ue,void 0,me,fe,Z),this.command={},this._source=Z,this.hasDefinedMatchers=ke,be&&(this.command=be)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(I=!1){if(I&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case v.Shell:Z="shell";break;case v.Process:Z="process";break;case v.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(I){return I instanceof r}getMapKey(){const I=this._source.config.workspaceFolder;return I?`${I.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$bG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const I=this.d();if(!I)return;let Z=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(Z+=this._source.kind);const ue={type:e.$eG,folder:I,id:Z};return JSON.stringify(ue)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$zg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(I){return new r(I._id,I._source,I._label,I.type,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$gG=r;class u extends i{constructor(I,Z,ue,ge,be,ke,me){super(I,ue,ge,ke,me,Z),this._source=Z,this.configures=be}static is(I){return I instanceof u}f(I){return I}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$zg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$bG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const I=this.d();if(!I)return;let Z=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(Z+=this._source.kind);const ue={type:e.$eG,folder:I,id:Z};return JSON.stringify(ue)}}e.$hG=u;class d extends i{constructor(I,Z,ue,ge,be,ke,me,fe,ne){super(I,ue,ge,fe,ne,Z),this.defines=be,this.hasDefinedMatchers=me,this.command=ke,this.icon=ne.icon,this.hide=ne.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(I){return I instanceof d}getMapKey(){const I=this._source.workspaceFolder;return I?`${this._source.scope.toString()}|${I.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const I={type:"contributed",scope:this._source.scope,id:this._id};return I.folder=this.d(),JSON.stringify(I)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(I){return new d(I._id,I._source,I._label,I.type,I.defines,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$iG=d;class b extends i{constructor(I,Z,ue,ge,be,ke){super(I,ue,ge,be,ke,Z),this._source=Z}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(I){return I instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(I){return new b(I._id,I._source,I._label,I.type,I.runOptions,I.configurationProperties)}}e.$jG=b;var f;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(P){P._default=P.Terminal}(f||(e.ExecutionEngine=f={}));var D;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class L{constructor(I){this.c=new Map;for(let Z=0;Z<I.length;Z++)this.c.set(I[Z].uri.toString(),Z)}compare(I,Z){const ue=I.getWorkspaceFolder(),ge=Z.getWorkspaceFolder();if(ue&&ge){let be=this.c.get(ue.uri.toString());be=be===void 0?0:be+1;let ke=this.c.get(ge.uri.toString());return ke=ke===void 0?0:ke+1,be===ke?I._label.localeCompare(Z._label):be-ke}else return!ue&&ge?-1:ue&&!ge?1:0}}e.$kG=L;var p;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(p||(e.TaskEventKind=p={}));var y;(function(P){P.SingleRun="singleRun",P.Background="background"})(y||(e.TaskRunType=y={}));var S;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var N;(function(P){function I(fe){return{taskId:fe._id,taskName:fe.configurationProperties.name,runType:fe.configurationProperties.isBackground?"background":"singleRun",group:fe.configurationProperties.group,__task:fe}}function Z(fe,ne,Se){return{...I(fe),kind:"start",terminalId:ne,resolvedVariables:Se}}P.start=Z;function ue(fe,ne,Se){return{...I(fe),kind:"processStarted",terminalId:ne,processId:Se}}P.processStarted=ue;function ge(fe,ne,Se){return{...I(fe),kind:"processEnded",terminalId:ne,exitCode:Se}}P.processEnded=ge;function be(fe,ne,Se){return{...I(fe),kind:"terminated",exitReason:Se,terminalId:ne}}P.terminated=be;function ke(fe,ne,Se){return{...I(ne),kind:fe,terminalId:Se}}P.general=ke;function me(){return{kind:"changed"}}P.changed=me})(N||(e.TaskEvent=N={}));var q;(function(P){function I(ue){const ge=Object.keys(ue).sort();let be="";for(const ke of ge){let me=ue[ke];me instanceof Object?me=I(me):typeof me=="string"&&(me=me.replace(/,/g,",,")),be+=ke+","+me+","}return be}function Z(ue){const be={_key:I(ue),type:ue.taskType};return Object.assign(be,ue),be}P.create=Z})(q||(e.KeyedTaskIdentifier=q={}));var j;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var M;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var U;(function(P){function I(Z,ue){const ge=m.$aG.get(Z.type);if(ge===void 0){const fe=F.$fn(Z);return delete fe._key,q.create(fe)}const be=Object.create(null);be.type=ge.taskType;const ke=new Set;ge.required.forEach(fe=>ke.add(fe));const me=ge.properties;for(const fe of Object.keys(me)){const ne=Z[fe];if(ne!=null)be[fe]=ne;else if(ke.has(fe)){const Se=me[fe];if(Se.default!==void 0)be[fe]=F.$fn(Se.default);else switch(Se.type){case"boolean":be[fe]=!1;break;case"number":case"integer":be[fe]=0;break;case"string":be[fe]="";break;default:ue.error(E.localize(2,null,JSON.stringify(Z,void 0,0),fe));return}}}return q.create(be)}P.createTaskIdentifier=I})(U||(e.TaskDefinition=U={}))}),define(Pe[229],Ae([1,0,11]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$46b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$56b=C}),define(Pe[49],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cv=e.$Bv=e.$Av=e.$zv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$zv=E;const T=[];function C(m){const g=new E(m);return T[g.nid]=g,g}e.$Av=C;function F(m){return T[m].sid}e.$Bv=F;class R{constructor(g){this.value=g}}e.$Cv=R}),define(Pe[3],Ae([1,0,49]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$EK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var F;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(s){return s._id=k.a++,s}}e.$EK=k;var l;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})($||(e.ISuggestResultDtoField=$={}));var v;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$FK={MainThreadAuthentication:(0,E.$Av)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Av)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Av)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Av)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Av)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Av)("MainThreadClipboard"),MainThreadCommands:(0,E.$Av)("MainThreadCommands"),MainThreadComments:(0,E.$Av)("MainThreadComments"),MainThreadConfiguration:(0,E.$Av)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Av)("MainThreadConsole"),MainThreadDebugService:(0,E.$Av)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Av)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Av)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Av)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Av)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Av)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Av)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Av)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Av)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Av)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Av)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Av)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Av)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Av)("MainThreadLanguages"),MainThreadLogger:(0,E.$Av)("MainThreadLogger"),MainThreadMessageService:(0,E.$Av)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Av)("MainThreadOutputService"),MainThreadProgress:(0,E.$Av)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Av)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Av)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Av)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Av)("MainThreadSecretState"),MainThreadStorage:(0,E.$Av)("MainThreadStorage"),MainThreadSpeech:(0,E.$Av)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Av)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Av)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Av)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Av)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Av)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Av)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Av)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Av)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Av)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Av)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Av)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Av)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Av)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Av)("MainThreadSCM"),MainThreadSearch:(0,E.$Av)("MainThreadSearch"),MainThreadShare:(0,E.$Av)("MainThreadShare"),MainThreadTask:(0,E.$Av)("MainThreadTask"),MainThreadWindow:(0,E.$Av)("MainThreadWindow"),MainThreadLabelService:(0,E.$Av)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Av)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Av)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Av)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Av)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Av)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Av)("MainThreadInteractive"),MainThreadChat:(0,E.$Av)("MainThreadChat"),MainThreadInlineChat:(0,E.$Av)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Av)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Av)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Av)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Av)("MainThreadTimeline"),MainThreadTesting:(0,E.$Av)("MainThreadTesting"),MainThreadLocalization:(0,E.$Av)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Av)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Av)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Av)("MainThreadIssueReporter")},e.$GK={ExtHostCommands:(0,E.$Av)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Av)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Av)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Av)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Av)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Av)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Av)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Av)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Av)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Av)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Av)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Av)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Av)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Av)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Av)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Av)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Av)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Av)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Av)("ExtHostStatusBar"),ExtHostShare:(0,E.$Av)("ExtHostShare"),ExtHostExtensionService:(0,E.$Av)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Av)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Av)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Av)("ExtHostSCM"),ExtHostSearch:(0,E.$Av)("ExtHostSearch"),ExtHostTask:(0,E.$Av)("ExtHostTask"),ExtHostWorkspace:(0,E.$Av)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Av)("ExtHostWindow"),ExtHostWebviews:(0,E.$Av)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Av)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Av)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Av)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Av)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Av)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Av)("ExtHostProgress"),ExtHostComments:(0,E.$Av)("ExtHostComments"),ExtHostSecretState:(0,E.$Av)("ExtHostSecretState"),ExtHostStorage:(0,E.$Av)("ExtHostStorage"),ExtHostUrls:(0,E.$Av)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Av)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Av)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Av)("ExtHostOutputService"),ExtHosLabelService:(0,E.$Av)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Av)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Av)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Av)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Av)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Av)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Av)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Av)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Av)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Av)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Av)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Av)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Av)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Av)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Av)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Av)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Av)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Av)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Av)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Av)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Av)("ExtHostTimeline"),ExtHostTesting:(0,E.$Av)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Av)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Av)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Av)("ExtHostIssueReporter")}}),define(Pe[230],Ae([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$FK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,g)??[]}getRelatedInformation(R,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(R,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,m),new T.$HK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$Oec=C}),define(Pe[81],Ae([1,0,4,15,3,17]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=e.$Uec=void 0,e.$Uec=(0,E.$1h)("IExtHostApiDeprecationService");let R=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(C.$FK.MainThreadTelemetry)}report(g,w,A){const k=this.d(g,w);this.a.has(k)||(this.a.add(k),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$Vec=R,e.$Vec=R=He([Ve(0,F.$JM),Ve(1,T.$ij)],R),e.$Wec=Object.freeze(new class{report(m,g,w){}})}),define(Pe[231],Ae([1,0,5,3,7,22]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=w.getProxy(T.$FK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,A,k,l={}){const $=F.$em.toKey(w.identifier),v=[...k].sort().join(" ");return await this.f.getOrCreate(`${$} ${A} ${v}`,async()=>{await this.a.$ensureProvider(A);const a=w.displayName||w.name;return this.a.$getSession(A,k,$,a,l)})}async getSessions(w,A,k){const l=F.$em.toKey(w.identifier),$=[...k].sort().join(" ");return await this.g.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(A);const v=w.displayName||w.name;return this.a.$getSessions(A,k,l,v)})}async removeSession(w,A){const k=this.b.get(w);return k?k.provider.removeSession(A):this.a.$removeSession(w,A)}registerAuthenticationProvider(w,A,k,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:A,provider:k,options:l??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===w)||this.c.push({id:w,label:A});const $=k.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(w,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(w,A,l?.supportsMultipleAccounts??!1),new C.$HK(()=>{$.dispose(),this.b.delete(w);const v=this.c.findIndex(a=>a.id===w);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,A,k){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this.d.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.$Zec=R;class m{constructor(){this.a=new Map}getOrCreate(w,A){const k=this.a.get(w);if(k)return k;const l=A().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[232],Ae([1,0,3,17,8]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let F=class{constructor(m,g){this.a=m.getProxy(E.$FK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,w){const A=C.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$1ec=F,e.$1ec=F=He([Ve(0,T.$JM)],F)}),define(Pe[233],Ae([1,0,5,67,6,3,8]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;class m{static{this.a=0}constructor(A,k){this.extension=A,this.provider=k,this.handle=m.a++}}class g{static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new E.$Sd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(F.$FK.MainThreadChat)}registerChatProvider(A,k,l){const $=new m(A,l);return this.b.set($.handle,$),this.e.$registerChatProvider($.handle,k),(0,C.$Qc)(()=>{this.e.$unregisterChatProvider($.handle),this.b.delete($.handle)})}transferChatSession(A,k){const l=T.Iterable.find(this.c.keys(),$=>this.c.get($)===A)??0;typeof l=="number"&&this.e.$transferChatSession(l,k)}sendInteractiveRequestToProvider(A,k){this.e.$sendRequestToProvider(A,k)}async $prepareChat(A,k){const l=this.b.get(A);if(!l)return;const $=await l.provider.prepareSession(k);if(!$)return;const v=g.a++;return this.c.set(v,$),{id:v,requesterUsername:$.requester?.name,requesterAvatarIconUri:$.requester?.icon,responderUsername:$.responder?.name,responderAvatarIconUri:$.responder?.icon,inputPlaceholder:$.inputPlaceholder}}async $provideWelcomeMessage(A,k){const l=this.b.get(A);if(!l||!l.provider.provideWelcomeMessage)return;const $=await l.provider.provideWelcomeMessage(k);if($)return $.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(a=>R.ChatReplyFollowup.from(a)):R.MarkdownString.from(v))}async $provideSampleQuestions(A,k){const l=this.b.get(A);if(!l||!l.provider.provideSampleQuestions)return;const $=await l.provider.provideSampleQuestions(k);if($)return $?.map(v=>R.ChatReplyFollowup.from(v))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$2ec=g}),define(Pe[234],Ae([1,0,14,20,40,5,60,16,2,156,72,3,8,7,205,23]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class s{static{this.a=0}constructor(o,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(k.$FK.MainThreadChatAgents2)}createChatAgent(o,c,h){const i=s.a++,r=new t(o,c,this.d,i,h);return this.b.set(i,r),this.d.$registerAgent(i,c,{}),r.apiAgent}async $invokeAgent(o,c,h,i,r,u){this.g.delete(c);const d=this.b.get(o);if(!d)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let b=!1;function f(){if(b)throw new Error("Only valid while executing the command")}const D=new E.$lh;u.onCancellationRequested(()=>D.complete()),setTimeout(()=>D.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,D.p);const L=i.command?await d.validateSlashCommand(i.command):void 0,p=R.$Od.create(!1);let y;try{const S=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:L},{history:r.history.map(l.ChatMessage.to)},new A.$ev(N=>{f(),typeof y>"u"&&"content"in N&&(y=p.elapsed());const q=l.ChatResponseProgress.from(d.extension,N);if(!q){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const j=Promise.all([this.d.$handleProgressChunk(h,q),N.resolvedContent]);(0,E.$Pg)(j,u).then(M=>{if(!M)return;const[U,P]=M,I=l.ChatResponseProgress.from(d.extension,P);if(!I){this.j.error("Unknown progress type: "+JSON.stringify(P));return}this.d.$handleProgressChunk(h,I,U??void 0)})}else this.d.$handleProgressChunk(h,q)}),u);return await(0,E.$Pg)(Promise.resolve(S).then(N=>{if(N){this.g.set(c,N);let q=this.h.get(c);q||(q=new Map,this.h.set(c,q)),q.set(h,N);const j={firstProgress:y,totalElapsed:p.elapsed()};return{errorDetails:N.errorDetails,timings:j}}else this.g.delete(c)}),u)}catch(S){return this.j.error(S,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,C.$Li)(S)),responseIsIncomplete:!0}}}finally{b=!0,D.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const h=this.b.get(o);return h?h.provideSlashCommand(c):[]}$provideFollowups(o,c,h){const i=this.b.get(o);if(!i)return Promise.resolve([]);const r=this.g.get(c);return r?i.provideFollowups(r,h):Promise.resolve([])}$acceptFeedback(o,c,h,i,r){const u=this.b.get(o);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let b;switch(i){case v.InteractiveSessionVoteDirection.Down:b=$.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:b=$.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(r?{result:d,kind:b,reportIssue:r}:{result:d,kind:b}))}$acceptAction(o,c,h,i){const r=this.b.get(o);if(!r)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(o,c,h){const i=this.b.get(o);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$4ec=s;class t{constructor(o,c,h,i,r){this.extension=o,this.t=c,this.u=h,this.w=i,this.x=r,this.o=new F.$Sd,this.q=new F.$Sd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async invokeCompletionProvider(o,c){return this.s?await this.s.provider.provideCompletionItems(o,c)??[]:[]}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,m.$Nf)(this.b));const c=this.b.find(h=>h.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const h=await this.d.provideFollowups(o,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let o=!1,c=!1;const h=()=>{o||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$CL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(r){i.g=r,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(r){i.h=r,h()},get iconPath(){return i.i},set iconPath(r){i.i=r,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(r){i.a=r,h()},get followupProvider(){return i.d},set followupProvider(r){i.d=r,h()},get isDefault(){return(0,a.$SF)(i.extension,"defaultChatAgent"),i.j},set isDefault(r){(0,a.$SF)(i.extension,"defaultChatAgent"),i.j=r,h()},get helpTextPrefix(){return(0,a.$SF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(r){if((0,a.$SF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=r,h()},get helpTextPostfix(){return(0,a.$SF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(r){if((0,a.$SF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=r,h()},get isSecondary(){return(0,a.$SF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(r){(0,a.$SF)(i.extension,"defaultChatAgent"),i.n=r,h()},get sampleRequest(){return i.m},set sampleRequest(r){i.m=r,h()},get supportIssueReporting(){return(0,a.$SF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(r){(0,a.$SF)(i.extension,"chatAgents2Additions"),i.r=r,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(r){if(i.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,r.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,a.$RF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(o,c,h,i){return this.x(o,c,h,i)}}}),define(Pe[235],Ae([1,0,20,6,3,8,72,22,14,5]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;class A{constructor(v,a){this.stream=new g.$rh,this.stream=a??new g.$rh;const s=this;this.apiObj={option:v,response:s.stream.asyncIterable}}}class k{constructor(v,a){this.a=new w.$Sd,this.b=new Map,this.c=new g.$rh,this.d=!1;const s=this;this.apiObject={result:v,response:s.c.asyncIterable,onDidStartResponseStream:s.a.event,cancel(){a.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let a=this.b.get(v.index);a||(this.b.size===0?a=new A(v.index,this.c):a=new A(v.index),this.b.set(v.index,a),this.a.fire(a.apiObj)),a.stream.emitOne(v.part)}}class l{static{this.a=1}constructor(v,a){this.d=a,this.c=new Map,this.e=new Map,this.f=new m.$gm,this.b=v.getProxy(C.$FK.MainThreadChatProvider)}registerProvider(v,a,s,t){const n=l.a++;return this.c.set(n,{extension:v,provider:s}),this.b.$registerProvider(n,a,{extension:v,displayName:t.name??v.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(v,a,s,t,n){const o=this.c.get(v);if(!o)return;const c=new R.$ev(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:h.index,part:h.part})});return o.provider.provideChatResponse(s.map(F.ChatMessage.to),t,c,n)}allowListExtensionWhile(v,a){this.f.set(v,a),a.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,a){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const s=this;return{get isRevoked(){return!s.f.has(v)},makeRequest(t,n,o){if(!s.f.has(v))throw new Error("Access to chat has been revoked");const c=new E.$3d(o),h=Math.random()*1e6|0,i=s.b.$fetchResponse(v,a,h,t.map(F.ChatMessage.from),n??{},c.token),r=new k(i,c);return s.e.set(h,{res:r}),i.finally(()=>{s.e.delete(h)}),r.apiObject}}}async $handleResponseFragment(v,a){const s=this.e.get(v);s&&s.res.handleFragment(a)}}e.$3ec=l}),define(Pe[236],Ae([1,0,6,3,11,8]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$FK.MainThreadChatVariables)}async $resolveVariable(g,w,A){const k=this.b.get(g);if(k)try{const l=await k.resolver.resolve(k.data.name,{message:w},A);if(l)return l.map(F.ChatVariable.from)}catch(l){(0,C.$2)(l)}}registerVariableResolver(g,w,A,k){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:A},resolver:k}),this.c.$registerVariable(l,{name:w,description:A}),(0,E.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$5ec=R}),define(Pe[237],Ae([1,0,3]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class T{constructor(F){const R=F.getProxy(E.$FK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$6ec=T}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=void 0;let u=class{#e;#t;#i;constructor(p,y,S){this.b=new Map,this.c=new Map,this.#e=p.getProxy(R.$FK.MainThreadCommands),this.d=y,this.#i=S,this.#t=p.getProxy(R.$FK.MainThreadTelemetry),this.converter=new d(this,N=>{const q=this.c.get(N);return q?.result===f.Void?q:void 0},y),this.f=[{processArgument(N){return(0,w.$xh)(N)}},{processArgument(N){return(0,F.$hn)(N,function(q){if(A.$Es.isIRange(q))return C.Range.to(q);if(k.$Ds.isIPosition(q))return C.Position.to(q);if(A.$Es.isIRange(q.range)&&l.URI.isUri(q.uri))return C.location.to(q);if(q instanceof t.$ge)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const y=this.registerCommand(!1,p.id,async(...S)=>{const N=p.args.map((j,M)=>{if(!j.validate(S[M]))throw new Error(`Invalid argument '${j.name}' when running '${p.id}', received: ${typeof S[M]=="object"?JSON.stringify(S[M],null,"	"):S[M]} `);return j.convert(S[M])}),q=await this.executeCommand(p.internalId,...N);return p.result.convert(q,S,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new T.$HK(()=>{y.dispose(),this.c.delete(p.id)})}registerCommand(p,y,S,N,q,j){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:S,thisArg:N,metadata:q,extension:j}),p&&this.#e.$registerCommand(y),new T.$HK(()=>{this.b.delete(y)&&p&&this.#e.$unregisterCommand(y)})}executeCommand(p,...y){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,y,!0)}async g(p,y,S){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,y,!1);{let N=!1;const q=(0,F.$hn)(y,function(j){if(j instanceof T.$IK)return C.Position.from(j);if(j instanceof T.$JK)return C.Range.from(j);if(j instanceof T.$TK)return C.location.from(j);if(T.$6L.isNotebookRange(j))return C.NotebookRange.from(j);if(j instanceof ArrayBuffer)return N=!0,t.$ge.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return N=!0,t.$ge.wrap(j);if(j instanceof t.$ge)return N=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(p,N?new n.$Cv(q):q,S);return(0,w.$xh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(p,y,!1);throw j}}}async h(p,y,S){const N=this.b.get(p);if(!N)throw new Error("Unknown command");const{callback:q,thisArg:j,metadata:M}=N;if(M?.args)for(let P=0;P<M.args.length;P++)try{(0,E.$Uf)(y[P],M.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${M.args[P].name}' - ${M.args[P].description}`)}const U=c.$Od.create();try{return await q.apply(j,y)}catch(P){if(p===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...y);I&&(p=I.command)}if(this.d.error(P,p,N.extension?.identifier),!S)throw P;if(N.extension?.identifier){const I=this.#i.onExtensionError(N.extension.identifier,P);this.d.trace("forwarded error to extension?",I,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Li)(P)),this.id=p,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,p,U.elapsed())}}j(p,y,S){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new h.$uo(y),duration:S})}$executeContributedCommand(p,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const S=this.b.get(p);return S?(y=y.map(N=>this.f.reduce((q,j)=>j.processArgument(q,S.extension?.identifier),N)),this.h(p,y,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(y=>(p&&(y=y.filter(S=>S[0]!=="_")),y))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[y,S]of this.b){const{metadata:N}=S;N&&(p[y]=N)}return Promise.resolve(p)}};e.$5M=u,e.$5M=u=He([Ve(0,a.$JM),Ve(1,g.$ij),Ve(2,i.$4M)],u),e.$6M=(0,v.$1h)("IExtHostCommands");class d{constructor(p,y,S){this.d=p,this.f=y,this.g=S,this.delegatingCommandId=`__vsc${(0,r.$lg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,y){if(!p)return;const S={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return S;const N=this.f(p.command);if(N)S.id=N.internalId,S.arguments=N.args.map((q,j)=>q.convert(p.arguments&&p.arguments[j]));else if((0,m.$Lb)(p.arguments)){const q=`${p.command} /${++this.c}`;this.b.set(q,p),y.add((0,$.$Qc)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),S.$ident=q,S.id=this.delegatingCommandId,S.arguments=[q],this.g.trace("CommandsConverter#CREATE",p.command,q)}return S}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const y=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$7M=d;class b{static{this.Uri=new b("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p)}static{this.Position=new b("position","A position in a text document",p=>T.$IK.isPosition(p),C.Position.from)}static{this.Range=new b("range","A range in a text document",p=>T.$JK.isRange(p),C.Range.from)}static{this.Selection=new b("selection","A selection in a text document",p=>T.$KK.isSelection(p),C.Selection.from)}static{this.Number=new b("number","",p=>typeof p=="number",p=>p)}static{this.String=new b("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=b.Arr(b.String)}static Arr(p){return new b(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,y=>Array.isArray(y)&&y.every(S=>p.validate(S)),y=>y.map(S=>p.convert(S)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof T.$5K,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",p=>p instanceof T.$mM,C.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VS Code TestItem",p=>p instanceof s.$WM,C.TestItem.from)}constructor(p,y,S,N){this.name=p,this.description=y,this.validate=S,this.convert=N}optional(){return new b(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,y){return new b(p??this.name,y??this.description,this.validate,this.convert)}}e.$8M=b;class f{static{this.Void=new f("no result",p=>p)}constructor(p,y){this.description=p,this.convert=y}}e.$9M=f;class D{constructor(p,y,S,N,q){this.id=p,this.internalId=y,this.description=S,this.args=N,this.result=q}}e.$0M=D}),define(Pe[238],Ae([1,0,18,13,2,80,96,35,32,8,7]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;const k=[new g.$0M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of DocumentHighlight-instances.",$(w.DocumentHighlight.to))),new g.$0M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$8M.Uri],new g.$9M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,s)=>{if((0,E.$Kb)(a))return;class t extends A.$ZK{static to(o){const c=new t(o.name,w.SymbolKind.to(o.kind),o.containerName||"",new A.$TK(s[0],w.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=w.Range.to(o.selectionRange),c.children=o.children?o.children.map(t.to):[],c}}return a.map(t.to)})),new g.$0M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$8M.Uri,new g.$8M("options","Formatting options",a=>!0,a=>a)],new g.$9M("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$0M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$8M.Uri,g.$8M.Range,new g.$8M("options","Formatting options",a=>!0,a=>a)],new g.$9M("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$0M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$8M.Uri,g.$8M.Position,new g.$8M("ch","Trigger character",a=>typeof a=="string",a=>a),new g.$8M("options","Formatting options",a=>!0,a=>a)],new g.$9M("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$0M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$0M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$0M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$0M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of Location or LocationLink instances.",v)),new g.$0M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of Location-instances.",$(w.location.to))),new g.$0M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of Hover-instances.",$(w.Hover.to))),new g.$0M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$8M.Uri,new g.$8M("position","A position in a text document",a=>Array.isArray(a)&&a.every(s=>A.$IK.isPosition(s)),a=>a.map(w.Position.from))],new g.$9M("A promise that resolves to an array of ranges.",a=>a.map(s=>{let t;for(const n of s.reverse())t=new A.$4K(w.Range.to(n),t);return t}))),new g.$0M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$8M.String.with("query","Search string")],new g.$9M("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(w.WorkspaceSymbol.to))),new g.$0M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(w.CallHierarchyItem.to))),new g.$0M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$8M.CallHierarchyItem],new g.$9M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(w.CallHierarchyIncomingCall.to))),new g.$0M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$8M.CallHierarchyItem],new g.$9M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(w.CallHierarchyOutgoingCall.to))),new g.$0M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:w.Range.to(a.range),placeholder:a.text}})),new g.$0M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$8M.Uri,g.$8M.Position,g.$8M.String.with("newName","The new symbol name")],new g.$9M("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return w.WorkspaceEdit.to(a)}})),new g.$0M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$8M.Uri,g.$8M.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$9M("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(w.DocumentLink.to))),new g.$0M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$8M.Uri],new g.$9M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$XL(a.tokenTypes,a.tokenModifiers)})),new g.$0M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$8M.Uri],new g.$9M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,R.$a$)(a);if(s.type==="full")return new A.$ZL(s.data,void 0)})),new g.$0M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$8M.Uri,g.$8M.Range.optional()],new g.$9M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$XL(a.tokenTypes,a.tokenModifiers)})),new g.$0M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$8M.Uri,g.$8M.Range],new g.$9M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,R.$a$)(a);if(s.type==="full")return new A.$ZL(s.data,void 0)})),new g.$0M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$8M.Uri,g.$8M.Position,g.$8M.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$8M.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$9M("A promise that resolves to a CompletionList-instance.",(a,s,t)=>{if(!a)return new A.$dL([]);const n=a.suggestions.map(o=>w.CompletionItem.to(o,t));return new A.$dL(n,a.incomplete)})),new g.$0M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$8M.Uri,g.$8M.Position,g.$8M.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$9M("A promise that resolves to SignatureHelp.",a=>{if(a)return w.SignatureHelp.to(a)})),new g.$0M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$8M.Uri,g.$8M.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$9M("A promise that resolves to an array of CodeLens-instances.",(a,s,t)=>$(n=>new A.$8K(w.Range.to(n.range),n.command&&t.fromInternal(n.command)))(a))),new g.$0M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$8M.Uri,new g.$8M("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$JK.isRange(a),a=>A.$KK.isSelection(a)?w.Selection.from(a):w.Range.from(a)),g.$8M.String.with("kind","Code action kind to return code actions for").optional(),g.$8M.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$9M("A promise that resolves to an array of Command-instances.",(a,s,t)=>$(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const o=new A.$2K(n.title,n.kind?new A.$3K(n.kind):void 0);return n.edit&&(o.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(o.command=t.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(a))),new g.$0M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$8M.Uri],new g.$9M("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(s=>new A.$jL(w.Range.to(s.range),w.Color.to(s.color))):[])),new g.$0M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$8M("color","The color to show and insert",a=>a instanceof A.$iL,w.Color.from),new g.$8M("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:w.Range.from(a.range)}))],new g.$9M("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(w.ColorPresentation.to):[])),new g.$0M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$8M.Uri,g.$8M.Range],new g.$9M("A promise that resolves to an array of Inlay objects",(a,s,t)=>a.map(w.InlayHint.to.bind(void 0,t)))),new g.$0M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$8M.Uri],new g.$9M("A promise that resolves to an array of FoldingRange objects",(a,s)=>{if(a)return a.map(w.FoldingRange.to)})),new g.$0M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$9M("A promise that resolves to an array of NotebookContentProvider static info objects.",$(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(s=>w.NotebookExclusiveDocumentPattern.to(s))})))),new g.$0M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$8M.Uri,g.$8M.Range,new g.$8M("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$JK,a=>w.InlineValueContext.from(a))],new g.$9M("A promise that resolves to an array of InlineValue objects",a=>a.map(w.InlineValue.to))),new g.$0M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$8M("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,T.$ag)(a,T.Schemas.http,T.Schemas.https),a=>a),new g.$8M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional(),g.$8M.String.with("label","").optional()],g.$9M.Void),new g.$0M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$8M.Uri.with("resource","Resource to open"),g.$8M.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$8M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional()],g.$9M.Void),new g.$0M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$8M.Uri.with("left","Left-hand side resource of the diff editor"),g.$8M.Uri.with("right","Right-hand side resource of the diff editor"),g.$8M.String.with("title","Human readable title for the diff editor").optional(),new g.$8M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)]).optional()],g.$9M.Void),new g.$0M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$8M.String.with("title","Human readable title for the changes editor"),new g.$8M("resourceList","List of resources to compare",a=>{for(const s of a){if(s.length!==3)return!1;const[t,n,o]=s;if(!C.URI.isUri(t)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},a=>a)],g.$9M.Void),new g.$0M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$8M.Uri,g.$8M.Position],new g.$9M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new g.$0M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$8M.TypeHierarchyItem],new g.$9M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new g.$0M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$8M.TypeHierarchyItem],new g.$9M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new g.$0M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$8M.TestItem],g.$9M.Void),new g.$0M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$8M.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$9M.Void),new g.$0M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$8M.String.with("name","The context key name"),new g.$8M("value","The context key value",()=>!0,a=>a)],g.$9M.Void),new g.$0M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$8M.Uri,g.$8M.StringArray,new g.$8M("MappedEditsContext","Mapped Edits Context",a=>w.MappedEditsContext.is(a),a=>w.MappedEditsContext.from(a))],new g.$9M("A promise that resolves to a workspace edit or null",a=>a?w.WorkspaceEdit.to(a):null))];class l{static register(s){k.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",m.$Zi)}}e.$Yec=l;function $(a){return s=>{if(Array.isArray(s))return s.map(a)}}function v(a){if(!Array.isArray(a))return;const s=[];for(const t of a)F.$qt(t)?s.push(w.DefinitionLink.to(t)):s.push(w.location.to(t));return s}}),define(Pe[239],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;function $(v,a,s){const t=v.getProxy(k.$FK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$gm,a.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const D=this.b.get(f.handle);return D?D.value:f}else if(f&&f.$mid===7){const D=this.b.get(f.commentControlHandle);if(!D)return f;const L=D.getCommentThread(f.commentThreadHandle);return L?L.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const L=D.getCommentThread(f.thread.commentThreadHandle);return L?f.$mid===8?L.value:{thread:L.value,text:f.text}:f}else if(f&&f.$mid===10){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const L=D.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const p=f.commentUniqueId,y=L.getCommentByUniqueId(p);return y||f}else if(f&&f.$mid===11){const D=this.b.get(f.thread.commentControlHandle);if(!D)return f;const L=D.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const p=f.text,y=f.commentUniqueId,S=L.getCommentByUniqueId(y);return S?(typeof S.body=="string"?S.body=p:S.body=new A.$9K(p),S):f}return f}})}createCommentController(f,D,L){const p=n.a++,y=new c(f,p,D,L);this.b.set(y.handle,y);const S=this.c.get(f.identifier)||[];return S.push(y),this.c.set(f.identifier,S),y.value}async $createCommentThreadTemplate(f,D,L){const p=this.b.get(f);p&&p.$createCommentThreadTemplate(D,L)}async $updateCommentThreadTemplate(f,D,L){const p=this.b.get(f);p&&p.$updateCommentThreadTemplate(D,L)}$deleteCommentThread(f,D){this.b.get(f)?.$deleteCommentThread(D)}$provideCommentingRanges(f,D,L){const p=this.b.get(f);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const y=s.getDocument(R.URI.revive(D));return(0,E.$Tg)(async()=>{const S=await p.commentingRangeProvider.provideCommentingRanges(y,L);let N;return Array.isArray(S)?N={ranges:S,fileComments:!1}:S?N={ranges:S.ranges||[],fileComments:S.fileComments||!1}:N=S??void 0,N}).then(S=>{let N;return S&&(N={ranges:S.ranges.map(q=>w.Range.from(q)),fileComments:S.fileComments}),N})}$toggleReaction(f,D,L,p,y){const S=this.b.get(f);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,E.$Tg)(()=>{const N=S.getCommentThread(D);if(N){const q=N.getCommentByUniqueId(p.uniqueIdInThread);if(S!==void 0&&q&&S.reactionHandler)return S.reactionHandler(q,r(y))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,D,L,p,y,S,N,q){this.m=D,this.n=L,this.o=p,this.p=y,this.q=S,this.extensionDescription=N,this.r=q,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Tc,this.l.value=new F.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(D,this.handle,this.n,this.o,w.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{t.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(M){j.range=M},get comments(){return j.comments},set comments(M){j.comments=M},get collapsibleState(){return j.collapsibleState},set collapsibleState(M){j.collapsibleState=M},get canReply(){return j.canReply},set canReply(M){j.canReply=M},get contextValue(){return j.contextValue},set contextValue(M){j.contextValue=M},get label(){return j.label},set label(M){j.label=M},get state(){return j.state},set state(M){j.state=M},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Rc);const f=L=>Object.prototype.hasOwnProperty.call(this.b,L),D={};f("range")&&(D.range=w.Range.from(this.p)),f("label")&&(D.label=this.label),f("contextValue")&&(D.contextValue=this.contextValue??null),f("comments")&&(D.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),f("collapsibleState")&&(D.collapseState=u(this.g)),f("canReply")&&(D.canReply=this.canReply),f("state")&&(D.state=d(this.h)),f("isTemplate")&&(D.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(f){for(const D of this.k){const L=D[0],p=D[1];if(f===p)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}He([(0,T.$th)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,D,L,p){this.f=f,this.g=D,this.h=L,this.i=p,this.a=new Map,t.$registerCommentController(this.handle,L,p,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(S){y.options=S},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(S){y.commentingRangeProvider=S},get reactionHandler(){return y.reactionHandler},set reactionHandler(S){y.reactionHandler=S},createCommentThread(S,N,q){return y.createCommentThread(S,N,q).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,D,L){D===void 0&&(0,l.$SF)(this.f,"fileComments");const p=new o(this.id,this.handle,void 0,f,D,L,this.f,!1);return this.a.set(p.handle,p),p}$createCommentThreadTemplate(f,D){const L=new o(this.id,this.handle,void 0,R.URI.revive(f),w.Range.to(D),[],this.f,!0);return L.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(f,D){const L=this.a.get(f);L&&(L.range=w.Range.to(D))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(b,f,D,L){let p=D.get(f);return p||(p=++b.commentHandle,D.set(f,p)),f.state!==void 0&&(0,l.$SF)(L,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:p,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(b){return{label:b.label,iconPath:b.iconPath?w.$IM(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function r(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?R.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function u(b){if(b!==void 0)switch(b){case A.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(b){if(b!==void 0)switch(b){case A.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$9ec=$}),define(Pe[240],Ae([1,0,26,3,27,17]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;let R=class{constructor(A,k){this.a=A.getProxy(T.$FK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,k){const l=this,$=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,$,arguments)}})}e(A,k,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g($,this.b)}),this.c&&this.f(A,l,$)}};e.$Wgc=R,e.$Wgc=R=He([Ve(0,F.$JM),Ve(1,C.$ZM)],R);const m=1e5;function g(w,A){const k=[];if(w.length)for(let l=0;l<w.length;l++){let $=w[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const v=$;v.stack?$=v.stack:$=v.toString()}k.push($)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$kn)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,12,19,23]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(a,s){this.h=s,this.f=new Map,this.g=a.getProxy(T.$FK.MainThreadDecorations)}registerFileDecorationProvider(a,s){const t=l.c++;this.f.set(t,{provider:a,extensionDescription:s}),this.g.$registerDecorationProvider(t,s.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(o);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Le)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$Ze)(u.uri.path,d.uri.path)),r=[];e:for(const u of i){let d;for(const b of u){const f=(0,A.$mc)(b.uri.path);if(d!==f&&(d=f,r.push(b.uri)>=l.d))break e}}this.g.$onDidChange(t,r)});return new C.$HK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(a,s,t){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(a);return await Promise.all(s.map(async h=>{try{const{uri:i,id:r}=h,u=await Promise.resolve(o.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{C.$4L.validate(u),u.badge&&typeof u.badge!="string"&&(0,k.$SF)(c,"codiconDecoration"),n[r]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$Yfc=$,e.$Yfc=$=l=He([Ve(0,R.$JM),Ve(1,m.$ij)],$),e.$Zfc=(0,F.$1h)("IExtHostDecorations")}),define(Pe[241],Ae([1,0,157,99,2,3,7,8,5,15,28,43]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;class ${#e;#t;#i;constructor(s,t,n,o,c,h,i,r){this.d=s,this.e=t,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new A.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,t){if(!s){this.clear();return}this.j();let n=[];if(C.URI.isUri(s)){if(!t){this.delete(s);return}this.#i.set(s,t.slice()),n=[s]}else if(Array.isArray(s)){n=[];let h;s=[...s].sort($.k);for(const i of s){const[r,u]=i;if((!h||r.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=r,n.push(r),this.#i.set(r,[])),u)this.#i.get(r)?.push(...u);else{const d=this.#i.get(r);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const h of n){let i=[];const r=this.#i.get(h);if(r)if(r.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const b of r)if(b.severity===u[d]&&i.push({...m.Diagnostic.from(b),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,r.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=r.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(o.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,t){this.j();for(const[n,o]of this)s.call(t,n,o,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const t=this.#i.get(s);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,t){return s[0].toString()<t[0].toString()?-1:s[0].toString()>t[0].toString()?1:0}}e.$Sec=$;let v=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const t=new A.$Ac;for(const n of s)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(s,t,n,o){this.j=t,this.k=n,this.l=o,this.g=new Map,this.h=new g.$Wd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=s.getProxy(F.$FK.MainThreadDiagnostics)}createDiagnosticCollection(s,t){const{g:n,f:o,h:c,j:h,k:i,l:r}=this,u=new class{$changeMany(f,D){o.$changeMany(f,D),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,f,D.length===0?"CLEARING":D)}$clear(f){o.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,f)}dispose(){o.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends ${constructor(){super(t,d,l.e,l.d,f=>r.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(s){if(s)return this.m(s);{const t=new Map,n=[];for(const o of this.g.values())o.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(s){let t=[];for(const n of this.g.values())n.has(s)&&(t=t.concat(n.get(s)));return t}$acceptMarkersChange(s){if(!this.n){const t="_generated_mirror",n=new $(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of s)this.n.set(C.URI.revive(t),n.map(m.Diagnostic.to))}};e.$Tec=v,e.$Tec=v=l=He([Ve(1,w.$ij),Ve(2,k.$Rec)],v)}),define(Pe[242],Ae([1,0,2,3,23]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class F{constructor(m){this.a=m.getProxy(T.$FK.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,C.$SF)(m,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(A=>E.URI.revive(A)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?E.URI.revive(g):void 0)}}e.$1fc=F}),define(Pe[243],Ae([1,0,11,2,7,3,13,20,12]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class w{static{this.a=0}constructor(k,l,$){this.d=l,this.e=$,this.b=new Map,this.c=k.getProxy(F.$FK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const $=w.a++;this.b.set($,l),this.c.$registerTextContentProvider($,k);let v;return typeof l.onDidChange=="function"&&(v=l.onDidChange(a=>{if(a.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent($,a).then(s=>{if(!s&&typeof s!="string")return;const t=this.d.getDocument(a);if(!t)return;const n=(0,g.$Ue)(s);if(!t.equalLines(n))return this.c.$onVirtualDocumentChange(a,s)},E.$1)})),new C.$HK(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(k,l){const $=this.b.get(k);return $?Promise.resolve($.provideTextDocumentContent(T.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$2fc=w}),define(Pe[244],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class l{constructor(v,a){this.a=new E.$Sd({onListenerError:k.$2}),this.b=new E.$Sd({onListenerError:k.$2}),this.c=new E.$Sd({onListenerError:k.$2}),this.d=new E.$Sd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=v.getProxy(F.$FK.MainThreadDocuments),this.g=a,this.g.onDidRemoveDocuments(s=>{for(const t of s)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const t of s)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const a=this.g.getDocument(v);if(a)return a}getDocument(v){const a=this.getDocumentData(v);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return a.document}ensureDocumentData(v){const a=this.g.getDocument(v);if(a)return Promise.resolve(a);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(t=>{this.h.delete(v.toString());const n=C.URI.revive(t);return(0,g.$Of)(this.g.getDocument(n))},t=>(this.h.delete(v.toString()),Promise.reject(t))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(a=>C.URI.revive(a))}$acceptModelLanguageChanged(v,a){const s=C.URI.revive(v),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(a),this.a.fire(t.document)}$acceptModelSaved(v){const a=C.URI.revive(v),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,a){const s=C.URI.revive(v),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");t._acceptIsDirty(a),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,a,s){const t=C.URI.revive(v),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(s),n.onEvents(a);let o;a.isUndoing?o=A.TextDocumentChangeReason.Undo:a.isRedoing&&(o=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$gn)({document:n.document,contentChanges:a.changes.map(c=>({range:m.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:o}))}setWordDefinitionFor(v,a){(0,R.$LM)(v,a)}}e.$Pec=l}),define(Pe[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,39]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],r=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=F.URI.revive(u),b=this.c.get(d);b?.unref()&&(this.c.delete(d),h.push(b.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=F.URI.revive(u.uri);let b=this.c.get(d);if(b&&d.scheme!==v.Schemas.vscodeNotebookCell&&d.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);b||(b=new t(new g.$MM(this.h.getProxy(m.$FK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,b),i.push(b.value)),b.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&r.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=F.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const b=this.c.get(d).value,f=new A.$SM(u.id,this.h.getProxy(m.$FK.MainThreadTextEditors),this.i,new s.$V(()=>b.document),u.selections.map(k.Selection.to),u.options,u.visibleRanges.map(D=>k.Range.to(D)),typeof u.editorPosition=="number"?k.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Nc)(h),(0,C.$Nc)(r),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return a.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$TM=n,e.$TM=n=He([Ve(0,w.$JM),Ve(1,l.$ij)],n),e.$UM=(0,R.$1h)("IExtHostDocumentsAndEditors")}),define(Pe[62],Ae([1,0,245,5,16,2,4,3,17,8,7]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0,e.$pfc=(0,R.$1h)("IExtHostEditorTabs");class k{constructor(s,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$nM(F.URI.revive(this.b.input.uri));case 2:return new A.$oM(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new A.$pM(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new A.$qM(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$rM(this.b.input.viewType);case 4:return new A.$sM(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$tM(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$uM;case 9:return new A.$vM(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$wM(this.b.input.providerId);default:return}}}class l{constructor(s,t){this.c=[],this.d="",this.b=s,this.e=t;for(const n of s.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return w.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(n=>n.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const n=new k(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,n),s.tabDto.isActive&&(this.d=n.tabId),n}else if(s.kind===1){const n=this.c.splice(s.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(s.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,n),n}const t=this.c.find(n=>n.tabId===s.tabDto.id);if(!t)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(s.tabDto),t}activeTabId(){return this.d}}let $=class{constructor(s){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=s.getProxy(m.$FK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,t={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(n=>n.apiObject))},get activeTabGroup(){const n=s.d;return(0,C.$Of)(s.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?v(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(s){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(s.map(u=>u.groupId)),o=(0,E.$L)(t,n),c=this.e.filter(u=>o.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=s.map(u=>{const d=new l(u,()=>this.d);return o.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const r=(0,C.$Of)(s.find(u=>u.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(s){const t=this.e.find(n=>n.groupId===s.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const t=this.e.find(o=>o.groupId===s.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(s){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===s)return n}h(s){return this.e.find(t=>t.apiObject===s)}async i(s,t){const n=[];for(const o of s){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(s,t){const n=[];for(const o of s){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$qfc=$,e.$qfc=$=He([Ve(0,g.$JM)],$);function v(a){return a.tabs!==void 0}}),define(Pe[246],Ae([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class C{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$FK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(m,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider(m,w),new T.$HK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$4fc=C}),define(Pe[247],Ae([1,0,2,3,6,7,8,295,12,24,23,52]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class l{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const s=this.a.indexOf(a);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),s=[];let t,n,o=14,c=14;for(const h of a){let i=t?(0,g.$9e)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(o=c,c=9):c+=1,s.push([n,h.toUpperCase().charCodeAt(i),c]),s.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=o}s.push([9,58,10]),s.push([10,47,12]),this.b=new m.$cZ(s)}}provideDocumentLinks(a){this.c();const s=[],t=m.$dZ.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of t){const o=R.DocumentLink.to(n);o.target&&s.push(o)}return s}}class ${constructor(a,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(T.$FK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,s,t,n={}){if($.j(t),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const o=this.h++;this.b.add(s),this.d.add(s),this.c.set(o,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$SF)(a,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$dk)(n.isReadonly)&&((0,A.$SF)(a,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,s,c,h).catch(r=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${s}`),console.error(r)});const i=t.onDidChangeFile(r=>{const u=[];for(const d of r){const{uri:b,type:f}=d;if(b.scheme!==s)continue;let D;switch(f){case F.FileChangeType.Changed:D=0;break;case F.FileChangeType.Created:D=1;break;case F.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:b,type:D})}this.a.$onFileSystemChange(o,u)});return(0,C.$Qc)(()=>{i.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:s,ctime:t,mtime:n,size:o,permissions:c}=a;return{type:s,ctime:t,mtime:n,size:o,permissions:c}}$stat(a,s){return Promise.resolve(this.l(a).stat(E.URI.revive(s))).then(t=>$.k(t))}$readdir(a,s){return Promise.resolve(this.l(a).readDirectory(E.URI.revive(s)))}$readFile(a,s){return Promise.resolve(this.l(a).readFile(E.URI.revive(s))).then(t=>w.$ge.wrap(t))}$writeFile(a,s,t,n){return Promise.resolve(this.l(a).writeFile(E.URI.revive(s),t.buffer,n))}$delete(a,s,t){return Promise.resolve(this.l(a).delete(E.URI.revive(s),t))}$rename(a,s,t,n){return Promise.resolve(this.l(a).rename(E.URI.revive(s),E.URI.revive(t),n))}$copy(a,s,t,n){const o=this.l(a);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(E.URI.revive(s),E.URI.revive(t),n))}$mkdir(a,s){return Promise.resolve(this.l(a).createDirectory(E.URI.revive(s)))}$watch(a,s,t,n){const o=this.l(a).watch(E.URI.revive(t),n);this.f.set(s,o)}$unwatch(a,s){const t=this.f.get(s);t&&(t.dispose(),this.f.delete(s))}$open(a,s,t){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(s),t))}$close(a,s){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(s))}$read(a,s,t,n){const o=this.l(a);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ge.alloc(n);return Promise.resolve(o.read(s,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(a,s,t,n){const o=this.l(a);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(s,t,n.buffer,0,n.byteLength))}l(a){const s=this.c.get(a);if(!s){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return s}}e.$5fc=$}),define(Pe[63],Ae([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;let v=$=class{constructor(s,t){this.b=new Map,this.c=new A.$0g,this.a=s.getProxy(E.$FK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const h=n.b.get(o.scheme);return h?(await n.a.$ensureActivation(o.scheme),c=await h.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){$.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return $.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return $.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return $.e(c)}},async writeFile(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(o)),await n.c.queueFor(o).queue(()=>Promise.resolve(h.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,F.$ge.wrap(c))}catch(h){return $.e(h)}},async delete(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return $.e(h)}},async rename(o,c,h){try{return await n.a.$rename(o,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},async copy(o,c,h){try{return await n.a.$copy(o,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},isWritableFileSystem(o){const c=t.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(s,t,n){const o=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await s.stat(n)).type&T.FileType.Directory))throw C.$VL.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$zk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(t.basename(n)),n=t.dirname(n)}for(let c=o.length-1;c>=0;c--){n=t.joinPath(n,o[c]);try{await s.createDirectory(n)}catch(h){if(T.$zk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(s){if(s instanceof C.$VL)throw s;if(s instanceof T.$vk)switch(s.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$VL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$VL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$VL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$VL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$VL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$VL.Unavailable(s.message);default:throw new C.$VL(s.message,s.name)}if(!(s instanceof Error))throw new C.$VL(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw C.$VL.Unavailable(s.message);switch(s.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$VL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$VL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$VL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$VL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$VL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$VL.Unavailable(s.message);default:throw new C.$VL(s.message,s.name)}}addFileSystemProvider(s,t,n){return this.b.set(s,{impl:t,extUri:n?.isCaseSensitive?k.$sg:k.$ug,isReadonly:!!n?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??k.$sg}};e.$efc=v,e.$efc=v=$=He([Ve(0,m.$JM),Ve(1,g.$Rec)],v),e.$ffc=(0,R.$1h)("IExtHostConsumerFileSystem")}),define(Pe[248],Ae([1,0,5,34,2,3,8,7,39]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,v,a,s,t,n){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$Hj)(t),c=typeof t=="string",h=n?.correlate,i=s(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(h&&typeof r.session>"u")){if(!n?.ignoreCreateEvents)for(const u of r.created){const d=C.URI.revive(u);o(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of r.changed){const d=C.URI.revive(u);o(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of r.deleted){const d=C.URI.revive(u);o(d.fsPath)&&(!c||v.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=m.$HK.from(this.i($,a,t,n,n?.correlate),this.b,this.c,this.d,i)}i($,v,a,s,t){const n=m.$HK.from();if(typeof a=="string")return n;const o=$.getProxy(F.$FK.MainThreadFileSystemEventService);let c=!1;return(a.pattern.includes(T.$Dj)||a.pattern.includes(T.$Ej))&&(c=!0),o.$watch(v.identifier.value,this.a,a.baseUri,{recursive:c,excludes:s?.excludes??[]},!!t),m.$HK.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor($){this.a=$,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(C.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor($,v,a){this.j=$,this.k=v,this.l=a,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,v,a,s){return new w(this.j,$,v,this.a.event,R.GlobPattern.from(a),s)}$onFileEvent($){this.a.fire(new A($))}$onDidRunFileOperation($,v){switch($){case 2:this.b.fire(Object.freeze({files:v.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(a=>C.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,v){return(a,s,t)=>{const n=function(c){a.call(s,c)};return n.extension=$,v.event(n,void 0,t)}}async $onWillRunFileOperation($,v,a,s){switch($){case 2:return await this.n(this.g,{files:v.map(t=>({oldUri:C.URI.revive(t.source),newUri:C.URI.revive(t.target)}))},a,s);case 1:return await this.n(this.i,{files:v.map(t=>C.URI.revive(t.target))},a,s);case 0:case 3:return await this.n(this.h,{files:v.map(t=>C.URI.revive(t.target))},a,s)}}async n($,v,a,s){const t=new Set,n=[];if(await $.fireAsync(v,s,async(c,h)=>{const i=Date.now(),r=await Promise.resolve(c);r instanceof m.$RK&&(n.push([h.extension,r]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>a&&this.k.warn("SLOW file-participant",h.extension.identifier)}),s.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(t)}}}e.$6fc=k}),define(Pe[249],Ae([1,0,6,2,3,8,7,32,14]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class w{static{this.a=0}constructor($,v){this.extension=$,this.provider=v,this.handle=w.a++}}class A{constructor($){this.session=$,this.responses=[]}}class k{static{this.a=0}constructor($,v,a,s){this.f=a,this.g=s,this.b=new Map,this.d=new Map,this.e=$.getProxy(C.$FK.MainThreadInlineChat),v.registerApiCommand(new m.$0M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$8M("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?F.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?F.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?F.Position.from(t.position):void 0}})],m.$9M.Void))}registerProvider($,v,a){const s=new w($,v);return this.b.set(s.handle,s),this.e.$registerInteractiveEditorProvider(s.handle,a?.label??$.displayName??$.name,$.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",a?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(s.handle),this.b.delete(s.handle)})}async $prepareSession($,v,a,s){const t=this.b.get($);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(v)),o=F.Selection.to(a),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:o},s);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:F.Range.from(c.wholeRange),message:c.message}}async $provideResponse($,v,a,s){const t=this.b.get($);if(!t)return;const n=this.d.get(v.id);if(!n)return;const o={prompt:a.prompt,selection:F.Selection.to(a.selection),wholeRange:F.Range.to(a.wholeRange),attempt:a.attempt,live:a.live};let c=!1;const h={report:async b=>{if(!a.live&&b.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||s.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:b.message,edits:b.edits?.map(F.TextEdit.from),editsShouldBeInstant:b.editsShouldBeInstant,slashCommand:b.slashCommand?.command,markdownFragment:R.$9K.isMarkdownString(b.content)?b.content.value:b.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,o,h,s));let r;try{r=await(0,g.$Pg)(i,s)}finally{c=!0}if(!r)return;const u=n.responses.push(r)-1,d={wholeRange:F.Range.from(r.wholeRange),placeholder:r.placeholder};if(k.h(r)){const{edits:b,contents:f}=r,D=f!==void 0?F.MarkdownString.from(f):void 0;return b instanceof R.$RK?{...d,id:u,type:"bulkEdit",edits:F.WorkspaceEdit.from(b),message:D}:{...d,id:u,type:"editorEdit",edits:b.map(F.TextEdit.from),message:D}}return{...d,id:u,type:"message",message:F.MarkdownString.from(r.contents)}}async $provideFollowups($,v,a,s){const t=this.b.get($),n=this.d.get(v),o=n?.responses[a];if(t&&o&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,o,s));return(await(0,g.$Pg)(c,s))?.map(F.ChatReplyFollowup.from)}}$handleFeedback($,v,a,s){const t=this.b.get($),n=this.d.get(v),o=n?.responses[a];if(t&&o){const c=F.InteractiveEditorResponseFeedbackKind.to(s);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession($,v){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$7fc=k}),define(Pe[250],Ae([1,0,2,32]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class C{constructor(R,m,g,w,A){this.a=m,this.b=g,this.c=w;const k=new T.$0M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$8M("showOptions","Show Options",l=>!0,l=>l),new T.$8M("resource","Interactive resource Uri",l=>!0,l=>l),new T.$8M("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$8M("title","Interactive editor title",l=>!0,l=>l)],new T.$9M("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,m,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$hgc=C}),define(Pe[251],Ae([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class C{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$FK.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(R,m){const g=R.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new T.$HK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,m){const g=R.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new T.$HK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$igc=C}),define(Pe[252],Ae([1,0,6,3]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class C{constructor(R){this.b=0,this.a=R.getProxy(T.$FK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$jgc=C}),define(Pe[253],Ae([1,0,2,26,8,7,80,3,12,29,18,16,296,20,22,6,96,89,75,60,11,14,23,159]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class u{constructor(O,K){this.d=O,this.e=K}async provideDocumentSymbols(O,K){const J=this.d.getDocument(O),W=await this.e.provideDocumentSymbols(J,K);if(!(0,A.$Kb)(W))return W[0]instanceof F.$1K?W.map(C.DocumentSymbol.from):u.f(W)}static f(O){O=O.slice(0).sort((W,Q)=>{let _=W.location.range.start.compareTo(Q.location.range.start);return _===0&&(_=Q.location.range.end.compareTo(W.location.range.end)),_});const K=[],J=[];for(const W of O){const Q={name:W.name||"!!MISSING: name!!",kind:C.SymbolKind.from(W.kind),tags:W.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:C.Range.from(W.location.range),selectionRange:C.Range.from(W.location.range),children:[]};for(;;){if(J.length===0){J.push(Q),K.push(Q);break}const _=J[J.length-1];if(w.$Es.containsRange(_.range,Q.range)&&!w.$Es.equalsRange(_.range,Q.range)){_.children?.push(Q),J.push(Q);break}J.pop()}}return K}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(O,K,J){this.g=O,this.h=K,this.j=J,this.e=new n.$Nec("CodeLens"),this.f=new Map}async provideCodeLenses(O,K){const J=this.g.getDocument(O),W=await this.j.provideCodeLenses(J,K);if(!W||K.isCancellationRequested)return;const Q=this.e.add(W),_=new a.$Rc;this.f.set(Q,_);const ye={cacheId:Q,lenses:[]};for(let ze=0;ze<W.length;ze++)ye.lenses.push({cacheId:[Q,ze],range:C.Range.from(W[ze].range),command:this.h.toInternal(W[ze].command,_)});return ye}async resolveCodeLens(O,K){const J=O.cacheId&&this.e.get(...O.cacheId);if(!J)return;let W;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?W=J:W=await this.j.resolveCodeLens(J,K),W||(W=J),K.isCancellationRequested)return;const Q=O.cacheId&&this.f.get(O.cacheId[0]);if(Q)return O.command=this.h.toInternal(W.command??d.d,Q),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}function b(Le){return Array.isArray(Le)?Le.map(C.DefinitionLink.from):Le?[C.DefinitionLink.from(Le)]:[]}class f{constructor(O,K){this.d=O,this.e=K}async provideDefinition(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideDefinition(W,Q,J);return b(_)}}class D{constructor(O,K){this.d=O,this.e=K}async provideDeclaration(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideDeclaration(W,Q,J);return b(_)}}class L{constructor(O,K){this.d=O,this.e=K}async provideImplementation(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideImplementation(W,Q,J);return b(_)}}class p{constructor(O,K){this.d=O,this.e=K}async provideTypeDefinition(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideTypeDefinition(W,Q,J);return b(_)}}class y{constructor(O,K){this.d=O,this.e=K}async provideHover(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideHover(W,Q,J);if(!(!_||(0,A.$Kb)(_.contents)))return _.range||(_.range=W.getWordRangeAtPosition(Q)),_.range||(_.range=new F.$JK(Q,Q)),C.Hover.from(_)}}class S{constructor(O,K){this.d=O,this.e=K}async provideEvaluatableExpression(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideEvaluatableExpression(W,Q,J);if(_)return C.EvaluatableExpression.from(_)}}class N{constructor(O,K){this.d=O,this.e=K}async provideInlineValues(O,K,J,W){const Q=this.d.getDocument(O),_=await this.e.provideInlineValues(Q,C.Range.to(K),C.InlineValueContext.to(J),W);if(Array.isArray(_))return _.map(ye=>C.InlineValue.from(ye))}}class q{constructor(O,K){this.d=O,this.e=K}async provideDocumentHighlights(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideDocumentHighlights(W,Q,J);if(Array.isArray(_))return _.map(C.DocumentHighlight.from)}}class j{constructor(O,K){this.d=O,this.e=K}async provideMultiDocumentHighlights(O,K,J,W){const Q=this.d.getDocument(O),_=J.map(Qe=>this.d.getDocument(Qe)),ye=C.Position.to(K),ze=await this.e.provideMultiDocumentHighlights(Q,ye,_,W);if(Array.isArray(ze))return ze.map(C.MultiDocumentHighlight.from)}}class M{constructor(O,K){this.d=O,this.e=K}async provideLinkedEditingRanges(O,K,J){const W=this.d.getDocument(O),Q=C.Position.to(K),_=await this.e.provideLinkedEditingRanges(W,Q,J);if(_&&Array.isArray(_.ranges))return{ranges:(0,A.$Hb)(_.ranges.map(C.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(O,K){this.d=O,this.e=K}async provideReferences(O,K,J,W){const Q=this.d.getDocument(O),_=C.Position.to(K),ye=await this.e.provideReferences(Q,_,J,W);if(Array.isArray(ye))return ye.map(C.location.from)}}class P{static{this.d=1e3}constructor(O,K,J,W,Q,_,ye){this.g=O,this.h=K,this.j=J,this.k=W,this.l=Q,this.m=_,this.n=ye,this.e=new n.$Nec("CodeAction"),this.f=new Map}async provideCodeActions(O,K,J,W){const Q=this.g.getDocument(O),_=l.$Gs.isISelection(K)?C.Selection.to(K):C.Range.to(K),ye=[];for(const nt of this.j.getDiagnostics(O))if(_.intersection(nt.range)&&ye.push(nt)>P.d)break;const ze={diagnostics:ye,only:J.only?new F.$3K(J.only):void 0,triggerKind:C.CodeActionTriggerKind.to(J.trigger)},Qe=await this.k.provideCodeActions(Q,_,ze,W);if(!(0,A.$Lb)(Qe)||W.isCancellationRequested)return;const Je=this.e.add(Qe),Xe=new a.$Rc;this.f.set(Je,Xe);const it=[];for(let nt=0;nt<Qe.length;nt++){const _e=Qe[nt];_e&&(P.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Xe)})):(ze.only&&(_e.kind?ze.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Je,nt],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Xe),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,i.$RF)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Je,actions:it}}async resolveCodeAction(O,K){const[J,W]=O,Q=this.e.get(J,W);if(!Q||P.o(Q))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(Q,K)??Q;let ye;_.edit&&(ye=C.WorkspaceEdit.from(_.edit,void 0));let ze;if(_.command){const Qe=this.f.get(J);Qe&&(ze=this.h.toInternal(_.command,Qe))}return{edit:ye,command:ze}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class I{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,J,W,Q){this.d=O,this.e=K,this.f=J,this.g=W,this.h=Q}async prepareDocumentPaste(O,K,J,W){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(O),_=K.map(Qe=>C.Range.to(Qe)),ye=C.DataTransfer.toDataTransfer(J,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Q,_,ye,W),W.isCancellationRequested)return;const ze=Array.from(ye).filter(([,Qe])=>!(Qe instanceof F.$wL));return C.DataTransfer.from(ze)}async providePasteEdits(O,K,J,W,Q){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(K),ye=J.map(Je=>C.Range.to(Je)),ze=C.DataTransfer.toDataTransfer(W,async Je=>(await this.d.$resolvePasteFileData(this.g,O,Je)).buffer),Qe=await this.f.provideDocumentPasteEdits(_,ye,ze,Q);if(Qe)return{label:Qe.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Qe.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:I.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?C.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class Z{constructor(O,K){this.d=O,this.e=K}async provideDocumentFormattingEdits(O,K,J){const W=this.d.getDocument(O),Q=await this.e.provideDocumentFormattingEdits(W,K,J);if(Array.isArray(Q))return Q.map(C.TextEdit.from)}}class ue{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeFormattingEdits(O,K,J,W){const Q=this.d.getDocument(O),_=C.Range.to(K),ye=await this.e.provideDocumentRangeFormattingEdits(Q,_,J,W);if(Array.isArray(ye))return ye.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,K,J,W){(0,k.$Nf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(O),_=K.map(C.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Q,_,J,W);if(Array.isArray(ye))return ye.map(C.TextEdit.from)}}class ge{constructor(O,K){this.d=O,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,J,W,Q){const _=this.d.getDocument(O),ye=C.Position.to(K),ze=await this.e.provideOnTypeFormattingEdits(_,ye,J,W,Q);if(Array.isArray(ze))return ze.map(C.TextEdit.from)}}class be{constructor(O,K){this.e=O,this.f=K,this.d=new n.$Nec("WorkspaceSymbols")}async provideWorkspaceSymbols(O,K){const J=await this.e.provideWorkspaceSymbols(O,K);if(!(0,A.$Lb)(J))return{symbols:[]};const W=this.d.add(J),Q={cacheId:W,symbols:[]};for(let _=0;_<J.length;_++){const ye=J[_];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Q.symbols.push({...C.WorkspaceSymbol.from(ye),cacheId:[W,_]})}return Q}async resolveWorkspaceSymbol(O,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const J=this.d.get(...O.cacheId);if(J){const W=await this.e.resolveWorkspaceSymbol(J,K);return W&&(0,T.$in)(O,C.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class ke{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,K,J){this.d=O,this.e=K,this.f=J}async provideRenameEdits(O,K,J,W){const Q=this.d.getDocument(O),_=C.Position.to(K);try{const ye=await this.e.provideRenameEdits(Q,_,J,W);return ye?C.WorkspaceEdit.from(ye):void 0}catch(ye){const ze=ke.g(ye);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(O,K,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const W=this.d.getDocument(O),Q=C.Position.to(K);try{const _=await this.e.prepareRename(W,Q,J);let ye,ze;if(F.$JK.isRange(_)?(ye=_,ze=W.getText(_)):(0,k.$Ff)(_)&&(ye=_.range,ze=_.placeholder),!ye||!ze)return;if(ye.start.line>Q.line||ye.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ye),text:ze}}catch(_){const ye=ke.g(_);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(_)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class me{constructor(O,K){this.resultId=O,this.tokens=K}}class fe{constructor(O,K){this.f=O,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,K,J){const W=this.f.getDocument(O),Q=K!==0?this.d.get(K):null;let _=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(W,Q.resultId,J):await this.g.provideDocumentSemanticTokens(W,J);return Q&&this.d.delete(K),_?(_=fe.h(_),this.o(fe.n(Q,_),_)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return fe.j(O)?fe.k(O)?O:new F.$ZL(new Uint32Array(O.data),O.resultId):fe.l(O)?fe.m(O)?O:new F.$2L(O.edits.map(K=>new F.$1L(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(O,K){if(!fe.j(K)||!O||!O.tokens)return K;const J=O.tokens,W=J.length,Q=K.data,_=Q.length;let ye=0;const ze=Math.min(W,_);for(;ye<ze&&J[ye]===Q[ye];)ye++;if(ye===W&&ye===_)return new F.$2L([],K.resultId);let Qe=0;const Je=ze-ye;for(;Qe<Je&&J[W-Qe-1]===Q[_-Qe-1];)Qe++;return new F.$2L([{start:ye,deleteCount:W-ye-Qe,data:Q.subarray(ye,_-Qe)}],K.resultId)}o(O,K){if(fe.j(O)){const J=this.e++;return this.d.set(J,new me(O.resultId,O.data)),(0,s.$_0)({id:J,type:"full",data:O.data})}if(fe.l(O)){const J=this.e++;return fe.j(K)?this.d.set(J,new me(K.resultId,K.data)):this.d.set(J,new me(O.resultId)),(0,s.$_0)({id:J,type:"delta",deltas:(O.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}class ne{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeSemanticTokens(O,K,J){const W=this.d.getDocument(O),Q=await this.e.provideDocumentRangeSemanticTokens(W,C.Range.to(K),J);return Q?this.f(Q):null}f(O){return(0,s.$_0)({id:0,type:"full",data:O.data})}}class Se{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,K,J,W,Q){this.f=O,this.g=K,this.h=J,this.j=W,this.k=Q,this.d=new n.$Nec("CompletionItem"),this.e=new Map}async provideCompletionItems(O,K,J,W){const Q=this.f.getDocument(O),_=C.Position.to(K),ye=Q.getWordRangeAtPosition(_)||new F.$JK(_,_),ze=ye.with({end:_}),Qe=new o.$Od,Je=await this.h.provideCompletionItems(Q,_,W,C.CompletionContext.to(J));if(!Je||W.isCancellationRequested)return;const Xe=Array.isArray(Je)?new F.$dL(Je):Je,it=Se.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),nt=new a.$Rc;this.e.set(it,nt);const _e=[],rt={x:it,b:_e,a:{replace:C.Range.from(ye),insert:C.Range.from(ze)},c:Xe.isIncomplete||void 0,d:Qe.elapsed()};for(let je=0;je<Xe.items.length;je++){const ct=Xe.items[je],ee=this.l(ct,[it,je],ze,ye);_e.push(ee)}return rt}async resolveCompletionItem(O,K){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...O);if(!J)return;const W=this.l(J,O),Q=await this.h.resolveCompletionItem(J,K);if(!Q)return;const _=this.l(Q,O);return(W.h!==_.h||W.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(W.n!==_.n||W.o!==_.o||!(0,T.$jn)(W.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...W,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K,J,W){const Q=this.e.get(K[0]);if(!Q)throw Error("DisposableStore is missing...");const _=this.g.toInternal(O.command,Q),ye={x:K,a:O.label,b:O.kind!==void 0?C.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(C.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:C.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(C.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=O.textEdit.newText):typeof O.insertText=="string"?ye.h=O.insertText:O.insertText instanceof F.$SK&&(ye.h=O.insertText.value,ye.i|=4);let ze;return O.textEdit?ze=O.textEdit.range:O.range&&(ze=O.range),F.$JK.isRange(ze)?ye.j=C.Range.from(ze):ze&&(!J?.isEqual(ze.inserting)||!W?.isEqual(ze.replacing))&&(ye.j={insert:C.Range.from(ze.inserting),replace:C.Range.from(ze.replacing)}),ye}}class ce{async provideInlineCompletions(O,K,J,W){}disposeCompletions(O){}handleDidShowCompletionItem(O,K,J){}handlePartialAccept(O,K,J){}}class X extends ce{constructor(O,K,J,W){super(),this.f=O,this.g=K,this.h=J,this.j=W,this.d=new V,this.e=(0,i.$RF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$RF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,K,J,W){const Q=this.g.getDocument(O),_=C.Position.to(K),ye=await this.h.provideInlineCompletionItems(Q,_,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:C.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},W);if(!ye||W.isCancellationRequested)return;const ze=Array.isArray(ye)?ye:ye.items,Qe=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],Je=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:ze}),items:ze.map((nt,_e)=>{let rt;nt.command&&(Xe||(Xe=new a.$Rc),rt=this.j.toInternal(nt.command,Xe));const je=nt.insertText;return{insertText:typeof je=="string"?je:{snippet:je.value},filterText:nt.filterText,range:nt.range?C.Range.from(nt.range):void 0,command:rt,idx:_e,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Qe.map(nt=>(Xe||(Xe=new a.$Rc),this.j.toInternal(nt,Xe))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,K,J){const W=this.d.get(O)?.items[K];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W,J)}handlePartialAccept(O,K,J){const W=this.d.get(O)?.items[K];W&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(W,J)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const K=this.e++;return this.d.set(K,O),K}disposeReferenceId(O){const K=this.d.get(O);return this.d.delete(O),K}get(O){return this.d.get(O)}}class re{constructor(O,K){this.e=O,this.f=K,this.d=new n.$Nec("SignatureHelp")}async provideSignatureHelp(O,K,J,W){const Q=this.e.getDocument(O),_=C.Position.to(K),ye=this.g(J),ze=await this.f.provideSignatureHelp(Q,_,W,ye);if(ze){const Qe=this.d.add([ze]);return{...C.SignatureHelp.from(ze),id:Qe}}}g(O){let K;if(O.activeSignatureHelp){const J=C.SignatureHelp.to(O.activeSignatureHelp),W=this.d.get(O.activeSignatureHelp.id,0);W?(K=W,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this.d.delete(O)}}class Ie{constructor(O,K,J,W,Q){this.f=O,this.g=K,this.h=J,this.j=W,this.k=Q,this.d=new n.$Nec("InlayHints"),this.e=new Map}async provideInlayHints(O,K,J){const W=this.f.getDocument(O),Q=C.Range.to(K),_=await this.h.provideInlayHints(W,Q,J);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(J.isCancellationRequested)return;const ye=this.d.add(_);this.e.set(ye,new a.$Rc);const ze={hints:[],cacheId:ye};for(let Qe=0;Qe<_.length;Qe++)this.l(_[Qe],Q)&&ze.hints.push(this.m(_[Qe],[ye,Qe]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),ze}async resolveInlayHint(O,K){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...O);if(!J)return;const W=await this.h.resolveInlayHint(J,K);if(W&&this.l(W))return this.m(W,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K){return O.label.length===0||Array.isArray(O.label)&&O.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(K&&!K.contains(O.position))}m(O,K){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const W={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(O.tooltip),position:C.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(C.TextEdit.from),kind:O.kind&&C.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?W.label=O.label:W.label=O.label.map(Q=>{const _={label:Q.value};return _.tooltip=C.MarkdownString.fromStrict(Q.tooltip),F.$TK.isLocation(Q.location)&&(_.location=C.location.from(Q.location)),Q.command&&(_.command=this.g.toInternal(Q.command,J)),_}),W}}class Re{constructor(O,K){this.e=O,this.f=K,this.d=new n.$Nec("DocumentLink")}async provideLinks(O,K){const J=this.e.getDocument(O),W=await this.f.provideDocumentLinks(J,K);if(!(!Array.isArray(W)||W.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:W.filter(Re.g).map(C.DocumentLink.from)};{const Q=this.d.add(W),_={links:[],cacheId:Q};for(let ye=0;ye<W.length;ye++){if(!Re.g(W[ye]))continue;const ze=C.DocumentLink.from(W[ye]);ze.cacheId=[Q,ye],_.links.push(ze)}return _}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...O);if(!J)return;const W=await this.f.resolveDocumentLink(J,K);if(!(!W||!Re.g(W)))return C.DocumentLink.from(W)}releaseLinks(O){this.d.delete(O)}}class Ce{constructor(O,K){this.d=O,this.e=K}async provideColors(O,K){const J=this.d.getDocument(O),W=await this.e.provideDocumentColors(J,K);return Array.isArray(W)?W.map(_=>({color:C.Color.from(_.color),range:C.Range.from(_.range)})):[]}async provideColorPresentations(O,K,J){const W=this.d.getDocument(O),Q=C.Range.to(K.range),_=C.Color.to(K.color),ye=await this.e.provideColorPresentations(_,{document:W,range:Q},J);if(Array.isArray(ye))return ye.map(C.ColorPresentation.from)}}class le{constructor(O,K){this.d=O,this.e=K}async provideFoldingRanges(O,K,J){const W=this.d.getDocument(O),Q=await this.e.provideFoldingRanges(W,K,J);if(Array.isArray(Q))return Q.map(C.FoldingRange.from)}}class ie{constructor(O,K,J){this.d=O,this.e=K,this.f=J}async provideSelectionRanges(O,K,J){const W=this.d.getDocument(O),Q=K.map(C.Position.to),_=await this.e.provideSelectionRanges(W,Q,J);if(!(0,A.$Lb)(_))return[];if(_.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ze=0;ze<Q.length;ze++){const Qe=[];ye.push(Qe);let Je=Q[ze],Xe=_[ze];for(;;){if(!Xe.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(C.SelectionRange.from(Xe)),!Xe.parent)break;Je=Xe.range,Xe=Xe.parent}}return ye}}class G{constructor(O,K){this.f=O,this.g=K,this.d=new t.$OM(""),this.e=new Map}async prepareSession(O,K,J){const W=this.f.getDocument(O),Q=C.Position.to(K),_=await this.g.prepareCallHierarchy(W,Q,J);if(!_)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(_)?_.map(ze=>this.h(ye,ze)):[this.h(ye,_)]}async provideCallsTo(O,K,J){const W=this.j(O,K);if(!W)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(W,J);if(Q)return Q.map(_=>({from:this.h(O,_.from),fromRanges:_.fromRanges.map(ye=>C.Range.from(ye))}))}async provideCallsFrom(O,K,J){const W=this.j(O,K);if(!W)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(W,J);if(Q)return Q.map(_=>({to:this.h(O,_.to),fromRanges:_.fromRanges.map(ye=>C.Range.from(ye))}))}releaseSession(O){this.e.delete(O)}h(O,K){const J=this.e.get(O),W=C.CallHierarchyItem.from(K,O,J.size.toString(36));return J.set(W._itemId,K),W}j(O,K){return this.e.get(O)?.get(K)}}class te{constructor(O,K){this.f=O,this.g=K,this.d=new t.$OM(""),this.e=new Map}async prepareSession(O,K,J){const W=this.f.getDocument(O),Q=C.Position.to(K),_=await this.g.prepareTypeHierarchy(W,Q,J);if(!_)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(_)?_.map(ze=>this.h(ye,ze)):[this.h(ye,_)]}async provideSupertypes(O,K,J){const W=this.j(O,K);if(!W)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(W,J);if(Q)return Q.map(_=>this.h(O,_))}async provideSubtypes(O,K,J){const W=this.j(O,K);if(!W)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(W,J);if(Q)return Q.map(_=>this.h(O,_))}releaseSession(O){this.e.delete(O)}h(O,K){const J=this.e.get(O),W=C.TypeHierarchyItem.from(K,O,J.size.toString(36));return J.set(W._itemId,K),W}j(O,K){return this.e.get(O)?.get(K)}}class x{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,J,W,Q){this.d=O,this.e=K,this.f=J,this.g=W,this.h=Q}async provideDocumentOnDropEdits(O,K,J,W,Q){const _=this.e.getDocument(K),ye=C.Position.to(J),ze=C.DataTransfer.toDataTransfer(W,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Je)).buffer),Qe=await this.f.provideDocumentDropEdits(_,ye,ze,Q);if(Qe)return{label:Qe.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Qe.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:x.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?C.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class se{constructor(O,K){this.d=O,this.e=K}async provideMappedEdits(O,K,J,W){const Q=E.URI.revive(O),_=this.d.getDocument(Q),ye=J.documents.map(Je=>Je.map(Xe=>({uri:E.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(it=>C.Range.to(it))}))),ze={documents:ye,selections:ye[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(_,K,ze,W);return Qe?C.WorkspaceEdit.from(Qe):null}}class de{constructor(O,K){this.adapter=O,this.extension=K}}class De{static{this.d=0}constructor(O,K,J,W,Q,_,ye,ze){this.g=K,this.h=J,this.j=W,this.k=Q,this.l=_,this.m=ye,this.n=ze,this.f=new Map,this.e=O.getProxy(m.$FK.MainThreadLanguageFeatures)}o(O,K){return C.DocumentSelector.from(O,this.g,K)}p(O){return new F.$HK(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return De.d++}async s(O,K,J,W,Q,_=!1){const ye=this.f.get(O);if(!ye||!(ye.adapter instanceof K))return W;const ze=Date.now();_||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Qe=J(ye.adapter,ye.extension);return Promise.resolve(Qe).catch(Je=>{(0,c.$4)(Je)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(ye.extension.identifier,Je))}).finally(()=>{_||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),$.CancellationToken.isCancellationToken(Q)?(0,h.$Qg)(Qe,Q):Qe}t(O,K){const J=this.q();return this.f.set(J,new de(O,K)),J}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,J,W){const Q=this.t(new u(this.h,J),O),_=W&&W.label||De.u(O);return this.e.$registerDocumentSymbolProvider(Q,this.o(K,O),_),this.p(Q)}$provideDocumentSymbols(O,K,J){return this.s(O,u,W=>W.provideDocumentSymbols(E.URI.revive(K),J),void 0,J)}registerCodeLensProvider(O,K,J){const W=this.q(),Q=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(W,new de(new d(this.h,this.j.converter,J),O)),this.e.$registerCodeLensSupport(W,this.o(K,O),Q);let _=this.p(W);if(Q!==void 0){const ye=J.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(Q));_=F.$HK.from(_,ye)}return _}$provideCodeLenses(O,K,J){return this.s(O,d,W=>W.provideCodeLenses(E.URI.revive(K),J),void 0,J)}$resolveCodeLens(O,K,J){return this.s(O,d,W=>W.resolveCodeLens(K,J),void 0,void 0)}$releaseCodeLenses(O,K){this.s(O,d,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(O,K,J){const W=this.t(new f(this.h,J),O);return this.e.$registerDefinitionSupport(W,this.o(K,O)),this.p(W)}$provideDefinition(O,K,J,W){return this.s(O,f,Q=>Q.provideDefinition(E.URI.revive(K),J,W),[],W)}registerDeclarationProvider(O,K,J){const W=this.t(new D(this.h,J),O);return this.e.$registerDeclarationSupport(W,this.o(K,O)),this.p(W)}$provideDeclaration(O,K,J,W){return this.s(O,D,Q=>Q.provideDeclaration(E.URI.revive(K),J,W),[],W)}registerImplementationProvider(O,K,J){const W=this.t(new L(this.h,J),O);return this.e.$registerImplementationSupport(W,this.o(K,O)),this.p(W)}$provideImplementation(O,K,J,W){return this.s(O,L,Q=>Q.provideImplementation(E.URI.revive(K),J,W),[],W)}registerTypeDefinitionProvider(O,K,J){const W=this.t(new p(this.h,J),O);return this.e.$registerTypeDefinitionSupport(W,this.o(K,O)),this.p(W)}$provideTypeDefinition(O,K,J,W){return this.s(O,p,Q=>Q.provideTypeDefinition(E.URI.revive(K),J,W),[],W)}registerHoverProvider(O,K,J,W){const Q=this.t(new y(this.h,J),O);return this.e.$registerHoverProvider(Q,this.o(K,O)),this.p(Q)}$provideHover(O,K,J,W){return this.s(O,y,Q=>Q.provideHover(E.URI.revive(K),J,W),void 0,W)}registerEvaluatableExpressionProvider(O,K,J,W){const Q=this.t(new S(this.h,J),O);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(K,O)),this.p(Q)}$provideEvaluatableExpression(O,K,J,W){return this.s(O,S,Q=>Q.provideEvaluatableExpression(E.URI.revive(K),J,W),void 0,W)}registerInlineValuesProvider(O,K,J,W){const Q=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new N(this.h,J),O);this.e.$registerInlineValuesProvider(_,this.o(K,O),Q);let ye=this.p(_);if(Q!==void 0){const ze=J.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(Q));ye=F.$HK.from(ye,ze)}return ye}$provideInlineValues(O,K,J,W,Q){return this.s(O,N,_=>_.provideInlineValues(E.URI.revive(K),J,W,Q),void 0,Q)}registerDocumentHighlightProvider(O,K,J){const W=this.t(new q(this.h,J),O);return this.e.$registerDocumentHighlightProvider(W,this.o(K,O)),this.p(W)}registerMultiDocumentHighlightProvider(O,K,J){const W=this.t(new j(this.h,J),O);return this.e.$registerMultiDocumentHighlightProvider(W,this.o(K,O)),this.p(W)}$provideDocumentHighlights(O,K,J,W){return this.s(O,q,Q=>Q.provideDocumentHighlights(E.URI.revive(K),J,W),void 0,W)}$provideMultiDocumentHighlights(O,K,J,W,Q){return this.s(O,j,_=>_.provideMultiDocumentHighlights(E.URI.revive(K),J,W.map(ye=>E.URI.revive(ye)),Q),void 0,Q)}registerLinkedEditingRangeProvider(O,K,J){const W=this.t(new M(this.h,J),O);return this.e.$registerLinkedEditingRangeProvider(W,this.o(K,O)),this.p(W)}$provideLinkedEditingRanges(O,K,J,W){return this.s(O,M,async Q=>{const _=await Q.provideLinkedEditingRanges(E.URI.revive(K),J,W);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?De.w(_.wordPattern):void 0}},void 0,W)}registerReferenceProvider(O,K,J){const W=this.t(new U(this.h,J),O);return this.e.$registerReferenceSupport(W,this.o(K,O)),this.p(W)}$provideReferences(O,K,J,W,Q){return this.s(O,U,_=>_.provideReferences(E.URI.revive(K),J,W,Q),void 0,Q)}registerCodeActionProvider(O,K,J,W){const Q=new a.$Rc,_=this.t(new P(this.h,this.j.converter,this.k,J,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(_,this.o(K,O),{providedKinds:W?.providedCodeActionKinds?.map(ye=>ye.value),documentation:W?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Q)}))},De.u(O),!!J.resolveCodeAction),Q.add(this.p(_)),Q}$provideCodeActions(O,K,J,W,Q){return this.s(O,P,_=>_.provideCodeActions(E.URI.revive(K),J,W,Q),void 0,Q)}$resolveCodeAction(O,K,J){return this.s(O,P,W=>W.resolveCodeAction(K,J),{},void 0)}$releaseCodeActions(O,K){this.s(O,P,J=>Promise.resolve(J.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(O,K,J){const W=this.t(new Z(this.h,J),O);return this.e.$registerDocumentFormattingSupport(W,this.o(K,O),O.identifier,O.displayName||O.name),this.p(W)}$provideDocumentFormattingEdits(O,K,J,W){return this.s(O,Z,Q=>Q.provideDocumentFormattingEdits(E.URI.revive(K),J,W),void 0,W)}registerDocumentRangeFormattingEditProvider(O,K,J){const W=typeof J.provideDocumentRangesFormattingEdits=="function",Q=this.t(new ue(this.h,J),O);return this.e.$registerRangeFormattingSupport(Q,this.o(K,O),O.identifier,O.displayName||O.name,W),this.p(Q)}$provideDocumentRangeFormattingEdits(O,K,J,W,Q){return this.s(O,ue,_=>_.provideDocumentRangeFormattingEdits(E.URI.revive(K),J,W,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(O,K,J,W,Q){return this.s(O,ue,_=>_.provideDocumentRangesFormattingEdits(E.URI.revive(K),J,W,Q),void 0,Q)}registerOnTypeFormattingEditProvider(O,K,J,W){const Q=this.t(new ge(this.h,J),O);return this.e.$registerOnTypeFormattingSupport(Q,this.o(K,O),W,O.identifier),this.p(Q)}$provideOnTypeFormattingEdits(O,K,J,W,Q,_){return this.s(O,ge,ye=>ye.provideOnTypeFormattingEdits(E.URI.revive(K),J,W,Q,_),void 0,_)}registerWorkspaceSymbolProvider(O,K){const J=this.t(new be(K,this.l),O);return this.e.$registerNavigateTypeSupport(J,typeof K.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(O,K,J){return this.s(O,be,W=>W.provideWorkspaceSymbols(K,J),{symbols:[]},J)}$resolveWorkspaceSymbol(O,K,J){return this.s(O,be,W=>W.resolveWorkspaceSymbol(K,J),void 0,void 0)}$releaseWorkspaceSymbols(O,K){this.s(O,be,J=>J.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(O,K,J){const W=this.t(new ke(this.h,J,this.l),O);return this.e.$registerRenameSupport(W,this.o(K,O),ke.supportsResolving(J)),this.p(W)}$provideRenameEdits(O,K,J,W,Q){return this.s(O,ke,_=>_.provideRenameEdits(E.URI.revive(K),J,W,Q),void 0,Q)}$resolveRenameLocation(O,K,J,W){return this.s(O,ke,Q=>Q.resolveRenameLocation(E.URI.revive(K),J,W),void 0,W)}registerDocumentSemanticTokensProvider(O,K,J,W){const Q=this.t(new fe(this.h,J),O),_=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(K,O),W,_);let ye=this.p(Q);if(_){const ze=J.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(_));ye=F.$HK.from(ye,ze)}return ye}$provideDocumentSemanticTokens(O,K,J,W){return this.s(O,fe,Q=>Q.provideDocumentSemanticTokens(E.URI.revive(K),J,W),null,W)}$releaseDocumentSemanticTokens(O,K){this.s(O,fe,J=>J.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,K,J,W){const Q=this.t(new ne(this.h,J),O);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(K,O),W),this.p(Q)}$provideDocumentRangeSemanticTokens(O,K,J,W){return this.s(O,ne,Q=>Q.provideDocumentRangeSemanticTokens(E.URI.revive(K),J,W),null,W)}registerCompletionItemProvider(O,K,J,W){const Q=this.t(new Se(this.h,this.j.converter,J,this.m,O),O);return this.e.$registerCompletionsProvider(Q,this.o(K,O),W,Se.supportsResolving(J),O.identifier),this.p(Q)}$provideCompletionItems(O,K,J,W,Q){return this.s(O,Se,_=>_.provideCompletionItems(E.URI.revive(K),J,W,Q),void 0,Q)}$resolveCompletionItem(O,K,J){return this.s(O,Se,W=>W.resolveCompletionItem(K,J),void 0,J)}$releaseCompletionItems(O,K){this.s(O,Se,J=>J.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(O,K,J,W){const Q=new X(O,this.h,J,this.j.converter),_=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(_,this.o(K,O),Q.supportsHandleEvents,v.$em.toKey(O.identifier.value),W?.yieldTo?.map(ye=>v.$em.toKey(ye))||[]),this.p(_)}$provideInlineCompletions(O,K,J,W,Q){return this.s(O,ce,_=>_.provideInlineCompletions(E.URI.revive(K),J,W,Q),void 0,Q)}$handleInlineCompletionDidShow(O,K,J,W){this.s(O,ce,async Q=>{Q.handleDidShowCompletionItem(K,J,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,K,J,W){this.s(O,ce,async Q=>{Q.handlePartialAccept(K,J,W)},void 0,void 0)}$freeInlineCompletionsList(O,K){this.s(O,ce,async J=>{J.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(O,K,J,W){const Q=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,_=this.t(new re(this.h,J),O);return this.e.$registerSignatureHelpProvider(_,this.o(K,O),Q),this.p(_)}$provideSignatureHelp(O,K,J,W,Q){return this.s(O,re,_=>_.provideSignatureHelp(E.URI.revive(K),J,W,Q),void 0,Q)}$releaseSignatureHelp(O,K){this.s(O,re,J=>J.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(O,K,J){const W=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new Ie(this.h,this.j.converter,J,this.l,O),O);this.e.$registerInlayHintsProvider(Q,this.o(K,O),typeof J.resolveInlayHint=="function",W,De.u(O));let _=this.p(Q);if(W!==void 0){const ye=J.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(W));_=F.$HK.from(_,ye)}return _}$provideInlayHints(O,K,J,W){return this.s(O,Ie,Q=>Q.provideInlayHints(E.URI.revive(K),J,W),void 0,W)}$resolveInlayHint(O,K,J){return this.s(O,Ie,W=>W.resolveInlayHint(K,J),void 0,J)}$releaseInlayHints(O,K){this.s(O,Ie,J=>J.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(O,K,J){const W=this.t(new Re(this.h,J),O);return this.e.$registerDocumentLinkProvider(W,this.o(K,O),typeof J.resolveDocumentLink=="function"),this.p(W)}$provideDocumentLinks(O,K,J){return this.s(O,Re,W=>W.provideLinks(E.URI.revive(K),J),void 0,J,K.scheme==="output")}$resolveDocumentLink(O,K,J){return this.s(O,Re,W=>W.resolveLink(K,J),void 0,void 0,!0)}$releaseDocumentLinks(O,K){this.s(O,Re,J=>J.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(O,K,J){const W=this.t(new Ce(this.h,J),O);return this.e.$registerDocumentColorProvider(W,this.o(K,O)),this.p(W)}$provideDocumentColors(O,K,J){return this.s(O,Ce,W=>W.provideColors(E.URI.revive(K),J),[],J)}$provideColorPresentations(O,K,J,W){return this.s(O,Ce,Q=>Q.provideColorPresentations(E.URI.revive(K),J,W),void 0,W)}registerFoldingRangeProvider(O,K,J){const W=this.q(),Q=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(W,new de(new le(this.h,J),O)),this.e.$registerFoldingRangeProvider(W,this.o(K,O),O.identifier,Q);let _=this.p(W);if(Q!==void 0){const ye=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));_=F.$HK.from(_,ye)}return _}$provideFoldingRanges(O,K,J,W){return this.s(O,le,Q=>Q.provideFoldingRanges(E.URI.revive(K),J,W),void 0,W)}registerSelectionRangeProvider(O,K,J){const W=this.t(new ie(this.h,J,this.l),O);return this.e.$registerSelectionRangeProvider(W,this.o(K,O)),this.p(W)}$provideSelectionRanges(O,K,J,W){return this.s(O,ie,Q=>Q.provideSelectionRanges(E.URI.revive(K),J,W),[],W)}registerCallHierarchyProvider(O,K,J){const W=this.t(new G(this.h,J),O);return this.e.$registerCallHierarchyProvider(W,this.o(K,O)),this.p(W)}$prepareCallHierarchy(O,K,J,W){return this.s(O,G,Q=>Promise.resolve(Q.prepareSession(E.URI.revive(K),J,W)),void 0,W)}$provideCallHierarchyIncomingCalls(O,K,J,W){return this.s(O,G,Q=>Q.provideCallsTo(K,J,W),void 0,W)}$provideCallHierarchyOutgoingCalls(O,K,J,W){return this.s(O,G,Q=>Q.provideCallsFrom(K,J,W),void 0,W)}$releaseCallHierarchy(O,K){this.s(O,G,J=>Promise.resolve(J.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(O,K,J){const W=this.t(new te(this.h,J),O);return this.e.$registerTypeHierarchyProvider(W,this.o(K,O)),this.p(W)}$prepareTypeHierarchy(O,K,J,W){return this.s(O,te,Q=>Promise.resolve(Q.prepareSession(E.URI.revive(K),J,W)),void 0,W)}$provideTypeHierarchySupertypes(O,K,J,W){return this.s(O,te,Q=>Q.provideSupertypes(K,J,W),void 0,W)}$provideTypeHierarchySubtypes(O,K,J,W){return this.s(O,te,Q=>Q.provideSubtypes(K,J,W),void 0,W)}$releaseTypeHierarchy(O,K){this.s(O,te,J=>Promise.resolve(J.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(O,K,J,W){const Q=this.q();this.f.set(Q,new de(new x(this.e,this.h,J,Q,O),O));const _=(0,i.$RF)(O,"dropMetadata")&&W?x.toInternalProviderId(O.identifier.value,W.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(K,O),_,(0,i.$RF)(O,"dropMetadata")?W:void 0),this.p(Q)}$provideDocumentOnDropEdits(O,K,J,W,Q,_){return this.s(O,x,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(K,E.URI.revive(J),W,Q,_)),void 0,void 0)}registerMappedEditsProvider(O,K,J){const W=this.t(new se(this.h,J),O);return this.e.$registerMappedEditsProvider(W,this.o(K,O)),this.p(W)}$provideMappedEdits(O,K,J,W,Q){return this.s(O,se,_=>Promise.resolve(_.provideMappedEdits(K,J,W,Q)),null,Q)}registerDocumentPasteEditProvider(O,K,J,W){const Q=this.q();this.f.set(Q,new de(new I(this.e,this.h,J,Q,O),O));const _=I.toInternalProviderId(O.identifier.value,W.id);return this.e.$registerPasteEditProvider(Q,this.o(K,O),_,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:W.copyMimeTypes,pasteMimeTypes:W.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(O,K,J,W,Q){return this.s(O,I,_=>_.prepareDocumentPaste(E.URI.revive(K),J,W,Q),void 0,Q)}$providePasteEdits(O,K,J,W,Q,_){return this.s(O,I,ye=>ye.providePasteEdits(K,E.URI.revive(J),W,Q,_),void 0,_)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:De.w(O.decreaseIndentPattern),increaseIndentPattern:De.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?De.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?De.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:De.w(O.beforeText),afterText:O.afterText?De.w(O.afterText):void 0,previousLineText:O.previousLineText?De.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(De.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(K=>F.SyntaxTokenType.toString(K)):void 0}}static D(O){return O.map(De.C)}setLanguageConfiguration(O,K,J){const{wordPattern:W}=J;if(W&&(0,g.$Te)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this.h.setWordDefinitionFor(K,W):this.h.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const Q=this.q(),_={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?De.w(J.wordPattern):void 0,indentationRules:J.indentationRules?De.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?De.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?De.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,K,_),this.p(Q)}$setWordDefinitions(O){for(const K of O)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Xec=De}),define(Pe[254],Ae([1,0,3,8,7,31,14,6,23]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class w{constructor(k,l,$,v){this.c=l,this.d=$,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(E.$FK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const $=this.c.getDocumentData(k);if(!$)throw new Error(`document '${k.toString()}' NOT found`);return $.document}async tokenAtPosition(k,l){const $=k.version,v=T.Position.from(l),a=await this.a.$tokensAtPosition(k.uri,v),s={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new C.$JK(l.line,l.character,l.line,l.character)};if(!a)return s;const t={range:T.Range.to(a.range),type:T.TokenType.to(a.type)};return!t.range.contains(l)||$!==k.version?s:t}createLanguageStatusItem(k,l,$){const v=this.f++,a=this.a,s=this.g,t=`${k.identifier.value}/${l}`;if(s.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(t);const n={selector:$,id:l,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new m.$Rc,h=()=>{if(o?.dispose(),!s.has(t)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,R.$3g)(()=>{c.clear(),this.a.$setLanguageStatus(v,{id:t,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?F.default.Error:n.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),o?.dispose(),a.$removeLanguageStatus(v),s.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,h()},get selector(){return n.selector},set selector(r){n.selector=r,h()},get text(){return n.text},set text(r){n.text=r,h()},set text2(r){(0,g.$SF)(k,"languageStatusText"),n.text=r,h()},get text2(){return(0,g.$SF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(r){n.detail=r,h()},get severity(){return n.severity},set severity(r){n.severity=r,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,h()},get command(){return n.command},set command(r){n.command=r,h()},get busy(){return n.busy},set busy(r){n.busy=r,h()}};return h(),i}}e.$kgc=w}),define(Pe[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;let A=class{constructor(l,$,v){this.f=v,this.d=new Map,this.a=$.getProxy(m.$FK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,$){const{message:v,args:a,comment:s}=$;if(this.c)return(0,T.$Ie)(v,a??{});let t=v;s&&s.length>0&&(t+=`/${Array.isArray(s)?s.join(""):s}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$Ie)(n??v,a??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const v=await this.g(l);if(!v){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(v),s=JSON.parse(a);$=l.isBuiltin?s.contents?.bundle:s}catch(a){this.f.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${a.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:v})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive($)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ifc=A,e.$Ifc=A=He([Ve(0,g.$ZM),Ve(1,w.$JM),Ve(2,R.$ij)],A),e.$Jfc=(0,F.$1h)("IExtHostLocalizationService")}),define(Pe[255],Ae([1,0,15,3,27,17,2,51]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;let g=class extends E.$tj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$xh)($))),this.r=k.getProxy(T.$FK.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,$){return new w(this.r,k,l,$)}};e.$Vgc=g,e.$Vgc=g=He([Ve(0,F.$JM),Ve(1,C.$ZM)],g);class w extends E.$oj{constructor(k,l,$,v){super(v?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,v).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const $=[[k,l]];this.m?this.u($):this.n.push(...$)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=e.$Kfc=void 0,e.$Kfc=(0,T.$1h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(E.$FK.MainThreadManagedSockets)}setFactory(k,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,$=await this.c.makeConnection(),v=new C.$Rc;return this.d.set(l,new w(l,$,v)),v.add((0,C.$Qc)(()=>this.d.delete(l))),v.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),v.dispose()})),v.add($.onDidClose(a=>{this.a.$onDidManagedSocketClose(l,a?.stack??a?.message),v.dispose()})),v.add($.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(l,R.$ge.wrap(a)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Lfc=m,e.$Lfc=m=He([Ve(0,F.$JM)],m);class g{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class w extends C.$Sc{constructor(k,l,$){super(),this.socketId=k,this.actual=l,this.B($)}}}),define(Pe[256],Ae([1,0,3,15,23]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;function F(m){return m&&m.title}let R=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$FK.MainThreadMessageService)}showMessage(g,w,A,k,l){const $={source:{identifier:g.identifier,label:g.displayName||g.name}};let v;typeof k=="string"||F(k)?v=[k,...l]:($.modal=k?.modal,$.useCustom=k?.useCustom,$.detail=k?.detail,v=l),$.useCustom&&(0,C.$SF)(g,"resolvers");const a=[];for(let s=0;s<v.length;s++){const t=v[s];if(typeof t=="string")a.push({title:t,handle:s,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:o}=t;a.push({title:n,isCloseAffordance:!!o,handle:s})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(w,A,$,a).then(s=>{if(typeof s=="number")return v[s]})}};e.$lgc=R,e.$lgc=R=He([Ve(1,T.$ij)],R)}),define(Pe[257],Ae([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,210,23,49]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;let o=class{constructor(f,D,L,p,y){this.m=D,this.n=L,this.o=p,this.q=y,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(k.$FK.MainThreadNotebookKernels);const S=new l.$0M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$8M("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const q=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:q}}else if(N&&"notebookEditor"in N){const q=this.n.getIdByEditor(N.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return N})],l.$9M.Void);this.o.registerApiCommand(S)}createNotebookController(f,D,L,p,y,S){for(const ne of this.j.values())if(ne.controller.id===D&&w.$em.equals(f.identifier,ne.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const N=this.k++,q=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${I.id}' of extension: '${f.identifier}'`);let M=!1;const U=new F.$Sd,P=new F.$Sd,I={id:d(f.identifier,D),notebookType:L,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:p||f.identifier.value,preloads:S?S.map($.NotebookRendererScript.from):[]};let Z=y??j,ue,ge;this.a.$addKernel(N,I).catch(ne=>{console.log(ne),M=!0});let be=0;const ke=()=>{if(M)return;const ne=++be;Promise.resolve().then(()=>{ne===be&&this.a.$updateKernel(N,I)})},me=new m.$Ac,fe={get id(){return D},get notebookType(){return I.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return I.label},set label(ne){I.label=ne??f.displayName??f.name,ke()},get detail(){return I.detail??""},set detail(ne){I.detail=ne,ke()},get description(){return I.description??""},set description(ne){I.description=ne,ke()},get supportedLanguages(){return I.supportedLanguages},set supportedLanguages(ne){I.supportedLanguages=ne,ke()},get supportsExecutionOrder(){return I.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){I.supportsExecutionOrder=ne,ke()},get rendererScripts(){return I.preloads?I.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ne){Z=ne??j},get interruptHandler(){return ue},set interruptHandler(ne){ue=ne,I.supportsInterrupt=!!ne,ke()},set variableProvider(ne){(0,t.$SF)(f,"notebookVariableProvider"),ge=ne,I.hasVariableProvider=!!ne,ne?.onDidChangeVariables(Se=>q.a.$variablesUpdated(Se.uri)),ke()},get variableProvider(){return ge},createNotebookCellExecution(ne){if(M)throw new Error("notebook controller is DISPOSED");if(!me.has(ne.notebook.uri))throw q.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return q._createNotebookCellExecution(ne,d(f.identifier,this.id))},createNotebookExecution(ne){if((0,t.$SF)(f,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!me.has(ne.uri))throw q.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Se=>Se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return q._createNotebookExecution(ne,d(f.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${N}], DISPOSED`),M=!0,this.j.delete(N),U.dispose(),P.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ne,Se){Se===v.NotebookControllerAffinity2.Hidden&&(0,t.$SF)(f,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(N,ne.uri,Se)},onDidReceiveMessage:P.event,postMessage(ne,Se){return(0,t.$SF)(f,"notebookMessaging"),q.a.$postMessage(N,Se&&q.n.getIdByEditor(Se),ne)},asWebviewUri(ne){return(0,t.$SF)(f,"notebookMessaging"),(0,a.$8ub)(ne,q.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:fe,onDidReceiveMessage:P,onDidChangeSelection:U,associatedNotebooks:me}),fe}getIdByController(f){for(const[D,L]of this.j)if(L.controller===f)return d(L.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,D){const L=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(L,D);const y={dispose:()=>{this.f.delete(L),p.a.$removeKernelDetectionTask(L)}};return this.f.set(L,y),y}registerKernelSourceActionProvider(f,D,L){const p=this.i++,y=typeof L.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,S=this;this.h.set(p,L),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,D);let N;return y!==void 0&&(N=L.onDidChangeNotebookKernelSourceActions(q=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(p),S.a.$removeKernelSourceActionProvider(p,p),N?.dispose()}}}async $provideKernelSourceActions(f,D){const L=this.h.get(f);if(L){const p=new R.$Rc;return(await L.provideNotebookKernelSourceActions(D)??[]).map(S=>$.NotebookKernelSourceAction.from(S,this.o.converter,p))}return[]}$acceptNotebookAssociation(f,D,L){const p=this.j.get(f);if(p){const y=this.n.getNotebookDocument(g.URI.revive(D));L?p.associatedNotebooks.set(y.uri,!0):p.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),L),p.onDidChangeSelection.fire({selected:L,notebook:y.apiNotebook})}}async $executeCells(f,D,L){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(D)),S=[];for(const N of L){const q=y.getCell(N);q&&S.push(q.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),S.length),await p.controller.executeHandler.call(p.controller,S,y.apiNotebook,p.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,D,L){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(D));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,y.apiNotebook);else for(const S of L){const N=y.getCell(S);N&&this.b.get(N.uri)?.cancel()}if(p.controller.interruptHandler){const S=this.c.get(y.uri);L.length&&Array.isArray(S)&&S.length&&S.forEach(N=>N.dispose())}}async $provideVariables(f,D,L,p,y,S,N){const q=this.j.get(f);if(!q)return;const j=this.n.getNotebookDocument(g.URI.revive(L)),M=q.controller.variableProvider;if(!M)return;const U=p?{name:p,value:""}:void 0,P=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,I=M.provideVariables(j.apiNotebook,U,P,S,N);for await(const Z of I){if(N.isCancellationRequested)return;this.a.$receiveVariable(D,Z)}}$acceptKernelMessageFromRenderer(f,D,L){const p=this.j.get(f);if(!p)return;const y=this.n.getEditorById(D);p.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:L}))}$cellExecutionChanged(f,D,L){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(D);if(y){const S=L?$.NotebookCellExecutionState.to(L):v.NotebookCellExecutionState.Idle;S!==void 0&&this.l.fire({cell:y.apiCell,state:S})}}_createNotebookCellExecution(f,D){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const y=new h(D,p,this.a);this.b.set(p.uri,y);const S=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),S.dispose(),this.b.delete(p.uri))});return y.asApiObject()}_createNotebookExecution(f,D){const L=this.n.getNotebookDocument(f.uri),p=f.getCells().find(N=>{const q=L.getCellFromApiCell(N);return q&&this.b.has(q.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const y=new r(D,L,this.a),S=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),S.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[y,S]),y.asApiObject()}};e.$pgc=o,e.$pgc=o=He([Ve(4,A.$ij)],o);var c;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,D,L){super(),this.m=D,this.n=L,this.b=h.a++,this.c=new F.$Sd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$3d),this.h=new u(10,p=>this.s(p)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const D=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Cv(D))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let D=this.m;if(f&&(D=this.m.notebook.getCellFromApiCell(f)),!D)throw new Error("INVALID cell");return D.handle}y(f){return f.map(D=>{const L=v.$0L.ensureUniqueMimeTypes(D.items,!0);return L===D.items?$.NotebookCellOutput.from(D):$.NotebookCellOutput.from({items:L,id:D.id,metadata:D.metadata})})}async z(f,D,L){const p=this.w(D),y=this.y((0,E.$3b)(f));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:p,append:L,outputs:y})}async C(f,D,L){return f=v.$0L.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:f.map($.NotebookCellOutputItem.from),outputId:D.id,append:L})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(L){f.j=L,f.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(L){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,p){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Cv({runEndTime:p,lastRunSuccess:L}))},clearOutput(L){return f.t(),f.z([],L,!1)},appendOutput(L,p){return f.t(),f.z(L,p,!0)},replaceOutput(L,p){return f.t(),f.z(L,p,!1)},appendOutputItems(L,p){return f.t(),f.C(L,p,!0)},replaceOutputItems(L,p){return f.t(),f.C(L,p,!1)}})}}var i;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(i||(i={}));class r extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,D,L){super(),this.h=D,this.j=L,this.b=r.a++,this.c=new F.$Sd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new C.$3d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,D){this.f=f,this.g=D,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$lh,this.b=Date.now(),(0,T.$2g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>f.complete())}}function d(b,f){return`${b.value}/${f}`}e.$qgc=d}),define(Pe[258],Ae([1,0,5,3,107]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class F{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(T.$FK.MainThreadNotebookRenderers)}$postRendererMessage(m,g,w){const A=this.c.getEditorById(m);this.a.get(g)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,k,l)=>this.d(g).event(A,k,l),postMessage:(A,k)=>{C.$0fc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&C.$0fc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,g,A)}}}d(m){let g=this.a.get(m);return g||(g=new E.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$rgc=F}),define(Pe[259],Ae([1,0,6,16,2,23,3]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(R.$FK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,A,k){if((0,F.$SF)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,k,l){const $=this.b.get(w);if(!$)throw new Error(`Unknown handler with id: ${w}`);return $.saveProfile(A,k,l)}async $readProfile(w,A,k){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Df)(A)?A:C.URI.revive(A),k)}}e.$ugc=m}),define(Pe[260],Ae([1,0,2,3,14,8]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class R{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$FK.MainThreadQuickDiff)}$provideOriginalResource(g,w,A){const k=E.URI.revive(w),l=this.c.get(g);return l?(0,C.$Tg)(()=>l.provideOriginalResource(k,A)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,A,k){const l=R.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,F.DocumentSelector.from(g,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$wgc=R}),define(Pe[261],Ae([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;function v(a,s,t){const n=a.getProxy(F.$FK.MainThreadQuickOpen);class o{constructor(D,L){this.e=new Map,this.f=0,this.a=D,this.b=L}showQuickPick(D,L,p,y=E.CancellationToken.None){this.c=void 0;const S=Promise.resolve(L),N=++this.f,q=n.$show(N,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},y),j={},M=q.then(()=>j);return Promise.race([M,S]).then(U=>{if(U===j)return;const P=(0,l.$RF)(D,"quickPickItemTooltip");return S.then(I=>{const Z=[];for(let ue=0;ue<I.length;ue++){const ge=I[ue];if(typeof ge=="string")Z.push({label:ge,handle:ue});else if(ge.kind===m.QuickPickItemKind.Separator)Z.push({type:"separator",label:ge.label});else{ge.tooltip&&!P&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const be=ge.iconPath?u(ge.iconPath):void 0;Z.push({label:ge.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:P?$.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ue})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=ue=>{p.onDidSelectItem(I[ue])}),n.$setItems(N,Z),q.then(ue=>{if(typeof ue=="number")return I[ue];if(Array.isArray(ue))return ue.map(ge=>I[ge])})})}).then(void 0,U=>{if(!(0,g.$4)(U))return n.$setError(N,U),Promise.reject(U)})}$onItemSelected(D){this.c?.(D)}showInput(D,L=E.CancellationToken.None){return this.d=D?.validateInput,n.$input(D,typeof this.d=="function",L).then(void 0,p=>{if(!(0,g.$4)(p))return Promise.reject(p)})}async $validateInput(D){if(!this.d)return;const L=await this.d(D);if(!L||typeof L=="string")return L;let p;switch(L.severity){case m.InputBoxValidationSeverity.Info:p=A.default.Info;break;case m.InputBoxValidationSeverity.Warning:p=A.default.Warning;break;case m.InputBoxValidationSeverity.Error:p=A.default.Error;break;default:p=L.message?A.default.Error:A.default.Ignore;break}return{content:L.message,severity:p}}async showWorkspaceFolderPick(D,L=E.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!p)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(S=>S.uri.toString()===p.uri.toString())}createQuickPick(D){const L=new d(D,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(D){const L=new b(D,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(D,L){this.e.get(D)?._fireDidChangeValue(L)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,L){const p=this.e.get(D);p instanceof d&&p._fireDidChangeActive(L)}$onDidChangeSelection(D,L){const p=this.e.get(D);p instanceof d&&p._fireDidChangeSelection(L)}$onDidTriggerButton(D,L){this.e.get(D)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(D,L,p){const y=this.e.get(D);y instanceof d&&y._fireDidTriggerItemButton(L,p)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class c{static{this.a=1}constructor(D,L){this.x=D,this.y=L,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((L,p)=>{const y=L===m.$3L.Back?-1:p;this.o.set(y,L)}),this.z({buttons:D.map((L,p)=>({...u(L.iconPath),tooltip:L.tooltip,handle:L===m.$3L.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const L=this.o.get(D);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(D){if(!this.v){for(const L of Object.keys(D)){const p=D[L];this.u[L]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof m.$CL)return{id:f.id};const D=r(f),L=i(f);return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof L=="string"?R.URI.file(L):L}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function r(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const D=h(f);let L,p;return"id"in D?p=k.ThemeIcon.asClassName(D):L=D,{iconPath:L,iconClass:p}}class d extends c{constructor(D,L){super(D.identifier,L),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((y,S)=>{this.C.set(S,y),this.D.set(y,S)});const L=(0,l.$RF)(this.O,"quickPickItemTooltip"),p=[];for(let y=0;y<D.length;y++){const S=D[y];if(S.kind===m.QuickPickItemKind.Separator)p.push({type:"separator",label:S.label});else{S.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=S.iconPath?u(S.iconPath):void 0;p.push({handle:y,label:S.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:L?$.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((q,j)=>({...u(q.iconPath),tooltip:q.tooltip,handle:j}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(D){const L=(0,w.$Hb)(D.map(p=>this.C.get(p)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(D){const L=(0,w.$Hb)(D.map(p=>this.C.get(p)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(D,L){const p=this.C.get(D);if(!p||!p.buttons||!p.buttons.length)return;const y=p.buttons[L];y&&this.N.fire({button:y,item:p})}}class b extends c{constructor(D,L){super(D.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:A.default.Error}):this.z({validationMessage:D.message,severity:D.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new o(s,t)}e.$xgc=v}),define(Pe[262],Ae([1,0,2,5,66,6,14,3,18,137,15,22,45,8,23,13,21]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;function n(j){return j instanceof E.URI}function o(j,M){return j.scheme===a.Schemas.file&&M.scheme===a.Schemas.file&&s.$k?j.toString()===M.toString():j.toString().toLowerCase()===M.toString().toLowerCase()}function c(j){if(j)return typeof j.iconPath=="string"?E.URI.file(j.iconPath):E.URI.isUri(j.iconPath)||l.ThemeIcon.isThemeIcon(j.iconPath)?j.iconPath:void 0}function h(j){if(j?.icon){if(E.URI.isUri(j.icon))return j.icon;if(l.ThemeIcon.isThemeIcon(j.icon))return j.icon;{const M=j.icon;return{light:M.light,dark:M.dark}}}else return}function i(j){if(j.icon){if(E.URI.isUri(j.icon))return j.icon;if(l.ThemeIcon.isThemeIcon(j.icon))return j.icon;{const M=j.icon;return{light:M.light,dark:M.dark}}}else return}function r(j){if(j.icon){if(E.URI.isUri(j.icon))return j.icon;if(l.ThemeIcon.isThemeIcon(j.icon))return j.icon;{const M=j.icon;return{light:M.light,dark:M.dark}}}else return}function u(j,M){if(!j.iconPath&&!M.iconPath)return 0;if(j.iconPath){if(!M.iconPath)return 1}else return-1;const U=typeof j.iconPath=="string"?j.iconPath:E.URI.isUri(j.iconPath)?j.iconPath.fsPath:j.iconPath.id,P=typeof M.iconPath=="string"?M.iconPath:E.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,w.$Cq)(U,P)}function d(j,M){let U=0;if(j.strikeThrough!==M.strikeThrough)return j.strikeThrough?1:-1;if(j.faded!==M.faded)return j.faded?1:-1;if(j.tooltip!==M.tooltip)return(j.tooltip||"").localeCompare(M.tooltip||"");if(U=u(j,M),U!==0)return U;if(j.light&&M.light)U=u(j.light,M.light);else{if(j.light)return 1;if(M.light)return-1}if(U!==0)return U;if(j.dark&&M.dark)U=u(j.dark,M.dark);else{if(j.dark)return 1;if(M.dark)return-1}return U}function b(j,M){if(j.command!==M.command)return j.command<M.command?-1:1;if(j.title!==M.title)return j.title<M.title?-1:1;if(j.tooltip!==M.tooltip){if(j.tooltip!==void 0&&M.tooltip!==void 0)return j.tooltip<M.tooltip?-1:1;if(j.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(j.arguments===M.arguments)return 0;if(j.arguments)if(M.arguments){if(j.arguments.length!==M.arguments.length)return j.arguments.length-M.arguments.length}else return 1;else return-1;for(let U=0;U<j.arguments.length;U++){const P=j.arguments[U],I=M.arguments[U];if(P!==I&&!(n(P)&&n(I)&&o(P,I)))return P<I?-1:1}return 0}function f(j,M){let U=(0,w.$Cq)(j.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(U!==0)return U;if(j.command&&M.command)U=b(j.command,M.command);else{if(j.command)return 1;if(M.command)return-1}if(U!==0)return U;if(j.decorations&&M.decorations)U=d(j.decorations,M.decorations);else{if(j.decorations)return 1;if(M.decorations)return-1}return U}function D(j,M){for(let U=0;U<j.length;U++)if(j[U]!==M[U])return!1;return!0}function L(j,M){return j.command===M.command&&j.title===M.title&&j.tooltip===M.tooltip&&(j.arguments&&M.arguments?D(j.arguments,M.arguments):j.arguments===M.arguments)}function p(j,M){return(0,g.$ub)(j,M,L)}class y{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.o,M),this.q(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.o,M),this.f=M}get validateInput(){return(0,v.$SF)(this.m,"scmValidation"),this.g}set validateInput(M){if((0,v.$SF)(this.m,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.o,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.o,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.o,M))}get actionButton(){return(0,v.$SF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(M){(0,v.$SF)(this.m,"scmInputBoxActionButton"),this.l.value=new F.$Rc,this.k=M;const U=M!==void 0?{command:this.n.converter.toInternal(M.command,this.l.value),icon:h(M),enabled:M.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,U??null)}get document(){return(0,v.$SF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(M,U,P,I,Z,ue){this.m=M,this.n=U,this.o=Z,this.p=ue,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new F.$Tc,this.#t=P,this.#e=I}showValidationMessage(M,U){(0,v.$SF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,M,U)}$onInputBoxValueChange(M){this.q(M)}q(M){this.d=M,this.e.fire(M)}}e.$ygc=y;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(M){this.v=M,this.q.$updateGroupLabel(this.t,this.handle,M)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(M){this.p=M,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,U,P,I,Z){this.q=M,this.s=U,this.t=P,this.u=I,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,U){const P=this.h.get(M);return P?(0,R.$Tg)(()=>this.s.executeCommand(P.command,...P.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(f),P=(0,g.$Db)(this.o,M,f).map(ue=>{const ge=ue.toInsert.map(be=>{const ke=this.e++;this.g.set(ke,be);const me=be.resourceUri;let fe;if(be.command)if(be.command.command==="vscode.open"||be.command.command==="vscode.diff"||be.command.command==="vscode.changes"){const le=new F.$Rc;fe=this.s.converter.toInternal(be.command,le),this.j.set(ke,le)}else this.h.set(ke,be.command);const ne=c(be.decorations),Se=be.decorations&&c(be.decorations.light)||ne,ce=be.decorations&&c(be.decorations.dark)||ne,X=[Se,ce],V=be.decorations&&be.decorations.tooltip||"",re=be.decorations&&!!be.decorations.strikeThrough,Ie=be.decorations&&!!be.decorations.faded,Re=be.contextValue||"";return{rawResource:[ke,me,X,V,re,Ie,Re,fe],handle:ke}});return{start:ue.start,deleteCount:ue.deleteCount,toInsert:ge}}),I=P.map(({start:ue,deleteCount:ge,toInsert:be})=>[ue,ge,be.map(ke=>ke.rawResource)]),Z=P.reverse();for(const{start:ue,deleteCount:ge,toInsert:be}of Z){const ke=be.map(fe=>fe.handle),me=this.n.splice(ue,ge,...ke);for(const fe of me)this.g.delete(fe),this.h.delete(fe),this.j.get(fe)?.dispose(),this.j.delete(fe)}return this.o=M,I}dispose(){this.l=!0,this.m.fire()}}class N{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.x,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let U;(0,v.$RF)(this.y,"quickDiffProvider")&&(U=M?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:U})}get historyProvider(){return(0,v.$SF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(M){(0,v.$SF)(this.y,"scmHistoryProvider"),this.j=M,this.k.value=new F.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!M}),M&&(this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.l=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(M.onDidChangeActionButton(()=>{(0,v.$SF)(this.y,"scmActionButton"),this.m.value=new F.$Rc;const U=M.actionButton!==void 0?{command:this.z.converter.toInternal(M.actionButton.command,this.m.value),description:M.actionButton.description,enabled:M.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,U??null)})))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.#e.$updateSourceControl(this.x,{commitTemplate:M}))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new F.$Rc,this.p=M;const U=this.z.converter.toInternal(M,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:U})}get actionButton(){return(0,v.$SF)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,v.$SF)(this.y,"scmActionButton"),this.q.value=new F.$Rc,this.s=M;const U=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(P=>P.map(I=>this.z.converter.toInternal(I,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:U??null})}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&p(this.u,M))return;this.t.value=new F.$Rc,this.u=M;const U=(M||[]).map(P=>this.z.converter.toInternal(P,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:U})}get selected(){return this.v}constructor(M,U,P,I,Z,ue,ge){this.y=M,this.z=I,this.A=Z,this.B=ue,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Tc,this.m=new F.$Tc,this.n=void 0,this.o=new F.$Tc,this.p=void 0,this.q=new F.$Tc,this.t=new F.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Sd,this.onDidChangeSelection=this.w.event,this.x=N.d++,this.D=new Map,this.E=new Set,this.#e=P;const be=E.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${Z}/scm${this.x}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new y(M,I,U,this.#e,this.x,be),this.#e.$registerSourceControl(this.x,Z,ue,ge,be)}createResourceGroup(M,U){const P=new S(this.#e,this.z,this.x,M,U),I=T.Event.once(P.onDidDispose)(()=>this.D.delete(P));return this.D.set(P,I),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const M=[],U=[];for(const[P,I]of this.D){I.dispose();const Z=P.onDidUpdateResourceStates(()=>{this.E.add(P),this.eventuallyUpdateResourceStates()});T.Event.once(P.onDidDispose)(()=>{this.E.delete(P),Z.dispose(),this.e.delete(P.handle),this.#e.$unregisterGroup(this.x,P.handle)}),M.push([P.handle,P.id,P.label,P.features]);const ue=P._takeResourceStateSnapshot();ue.length>0&&U.push([P.handle,ue]),this.e.set(P.handle,P)}this.#e.$registerGroups(this.x,M,U),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(U=>{const P=U._takeResourceStateSnapshot();P.length!==0&&M.push([U.handle,P])}),M.length>0&&this.#e.$spliceResourceStates(this.x,M),this.E.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,C.$th)(100)],N.prototype,"eventuallyAddResourceGroups",null),He([(0,C.$th)(100)],N.prototype,"eventuallyUpdateResourceStates",null);let q=class{static{t=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(M,U,P,I){this.n=U,this.o=P,this.p=I,this.h=new Map,this.j=new k.$gm,this.k=new T.$Sd,this.l=new Map,this.f=M.getProxy(m.$FK.MainThreadSCM),this.g=M.getProxy(m.$FK.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:Z=>{if(Z&&Z.$mid===3){const ue=this.h.get(Z.sourceControlHandle);if(!ue)return Z;const ge=ue.getResourceGroup(Z.groupHandle);return ge?ge.getResourceState(Z.handle):Z}else if(Z&&Z.$mid===4){const ue=this.h.get(Z.sourceControlHandle);return ue?ue.getResourceGroup(Z.groupHandle):Z}else if(Z&&Z.$mid===5){const ue=this.h.get(Z.handle);return ue||Z}return Z}})}createSourceControl(M,U,P,I){this.p.trace("ExtHostSCM#createSourceControl",M.identifier.value,U,P,I),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const Z=t.d++,ue=new N(M,this.o,this.f,this.n,U,P,I);this.h.set(Z,ue);const ge=this.j.get(M.identifier)||[];return ge.push(ue),this.j.set(M.identifier,ge),ue}registerSourceControlInputBoxValueProvider(M,U,P){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",M.identifier.value,P.label);const I=t.e++;return this.l.set(I,P),this.f.$registerSourceControlInputBoxValueProvider(I,U,P.label,r(P)),(0,F.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(I),this.l.delete(I)})}async $provideInputBoxValue(M,U,P,I){const Z=this.l.get(M);if(Z)return await Z.provideValue(E.URI.revive(U),P,I)??void 0}getLastInputBox(M){this.p.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const U=this.j.get(M.identifier),P=U&&U[U.length-1];return P&&P.inputBox}$provideOriginalResource(M,U,P){const I=E.URI.revive(U);this.p.trace("ExtHostSCM#$provideOriginalResource",M,I.toString());const Z=this.h.get(M);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Tg)(()=>Z.quickDiffProvider.provideOriginalResource(I,P)).then(ue=>ue||null)}$onInputBoxValueChange(M,U){this.p.trace("ExtHostSCM#$onInputBoxValueChange",M);const P=this.h.get(M);return P&&P.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(M,U,P,I){this.p.trace("ExtHostSCM#$executeResourceCommand",M,U,P);const Z=this.h.get(M);if(!Z)return Promise.resolve(void 0);const ue=Z.getResourceGroup(U);return ue?ue.$executeResourceCommand(P,I):Promise.resolve(void 0)}$validateInput(M,U,P){this.p.trace("ExtHostSCM#$validateInput",M);const I=this.h.get(M);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Tg)(()=>I.inputBox.validateInput(U,P)).then(Z=>{if(!Z)return Promise.resolve(void 0);const ue=$.MarkdownString.fromStrict(Z.message);return ue?Promise.resolve([ue,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.h.get(M)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(M,U,P){return await this.h.get(M)?.historyProvider?.resolveHistoryItemGroupBase(U,P)??void 0}async $resolveHistoryItemGroupCommonAncestor(M,U,P,I){return await this.h.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,P,I)??void 0}async $provideHistoryItems(M,U,P,I){return(await this.h.get(M)?.historyProvider?.provideHistoryItems(U,P,I))?.map(ge=>({...ge,icon:i(ge)}))??void 0}async $provideHistoryItemChanges(M,U,P){return await this.h.get(M)?.historyProvider?.provideHistoryItemChanges(U,P)??void 0}};e.$zgc=q,e.$zgc=q=t=He([Ve(3,A.$ij)],q)}),define(Pe[84],Ae([1,0,3,5,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0;class F{constructor(m){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(E.$FK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,w){return this.a.$setPassword(m,g,w)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$Ffc=F,e.$Gfc=(0,C.$1h)("IExtHostSecretState")}),define(Pe[263],Ae([1,0,3,8,2]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class F{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(E.$FK.MainThreadShare)}async $provideShare(m,g,w){return await this.c.get(m)?.provideShare({selection:T.Range.to(g.selection),resourceUri:C.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider(m,g){const w=F.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Agc=F}),define(Pe[264],Ae([1,0,20,6,3]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class F{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(C.$FK.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const w=this.c.get(m);if(!w)return;const A=new T.$Rc,k=new E.$3d;this.d.set(g,k);const l=A.add(w.provideSpeechToTextSession(k.token));A.add(l.onDidChange($=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,$)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,w){const A=F.a++;return this.c.set(A,w),this.b.$registerProvider(A,g,{extension:m,displayName:m.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Bgc=F}),define(Pe[265],Ae([1,0,7,3,163,6,8,16]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$DL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$DL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,v,a,s,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new F.$Rc,this.#e=l,this.#t=$,s&&a){this.c=(0,E.$gL)(a.identifier,s);const o=v.get(this.c);o&&(t=o.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(g.a++);this.e=a,this.f=s,this.g=t,this.h=this.u(n)}u(l){if((0,m.$Hf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new F.$Rc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,C.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=g.b.get(this.o.id));const a=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,a,this.r?.internal,v,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Cgc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new E.$HK(()=>{const v=this.b.indexOf($);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,$){this.e=new Map,this.a=l.getProxy(T.$FK.MainThreadStatusBar),this.b=$,this.c=new w(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,v,a){return new g(this.a,this.b,this.e,l,$,v,a)}setStatusBarMessage(l,$){const v=this.c.setMessage(l);let a;return typeof $=="number"?a=setTimeout(()=>v.dispose(),$):typeof $<"u"&&$.then(()=>v.dispose(),()=>v.dispose()),new E.$HK(()=>{v.dispose(),clearTimeout(a)})}}e.$Dgc=A}),define(Pe[85],Ae([1,0,3,5,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=void 0;class F{constructor(m,g){this.c=g,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(E.$FK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,w){const A=await this.a.$initializeExtensionStorage(m,g);let k;return A&&(k=this.d(m,g,A)),k||w}setValue(m,g,w){return this.a.$setValue(m,g,w)}$acceptValue(m,g,w){const A=this.d(m,g,w);A&&this.b.fire({shared:m,key:g,value:A})}d(m,g,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${A}`)}}}e.$xfc=F,e.$yfc=(0,C.$1h)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,63,2]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0,e.$gfc=(0,E.$1h)("IExtensionStoragePaths");let m=class{constructor(w,A,k){this.d=A,this.f=k,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return R.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(w){if(this.c)return R.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return R.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$hfc=m,e.$hfc=m=He([Ve(0,T.$ZM),Ve(1,C.$ij),Ve(2,F.$ffc)],m)}),define(Pe[64],Ae([1,0,5,3,4,2,17,6,7,165,11,193,20,33,194,45,14,8,32]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,C.$1h)("IExtHostTerminalService");class o{constructor(p,y,S,N){this.l=p,this._id=y,this.m=S,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const q=this;this.value={get name(){return q.n||""},get processId(){return q.b},get creationOptions(){return q.m},get exitStatus(){return q.h},get state(){return q.j},get selection(){return q.k},sendText(j,M=!0){q.q(),q.l.$sendText(q._id,j,M)},show(j){q.q(),q.l.$show(q._id,j)},hide(){q.q(),q.l.$hide(q._id)},dispose(){q.a||(q.a=!0,q.l.$dispose(q._id))},get dimensions(){if(!(q.d===void 0||q.g===void 0))return{columns:q.d,rows:q.g}}}}async create(p,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??y?.cwd??void 0,env:p.env??void 0,icon:b(p.iconPath)??void 0,color:a.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(p.location,y?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,y,S,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:S,color:a.ThemeColor.isThemeColor(N)?N.id:void 0,location:this.o(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,y){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in p?{viewColumn:t.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,y){this.h=Object.freeze({code:p,reason:y})}setDimensions(p,y){return p===this.d&&y===this.g||p===0||y===0?!1:(this.d=p,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(y=>{y!==p&&(this.b=Promise.resolve(p))})}}e.$Cfc=o;class c{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,y){this.g.setDimensions?.({columns:p,rows:y})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,y,S){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(T.$FK.MainThreadTerminalService),this.y=new v.$jrb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const q=j=>{const M=j;return this.W(M.instanceId)?.value};switch(N?.$mid){case 15:return q(N);default:{if(Array.isArray(N))for(let j=0;j<N.length&&N[j].$mid===15;j++)N[j]=q(N[j]);return N}}}}),this.B({dispose:()=>{for(const[N,q]of this.g)q.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,y){const S=new o(this.a,(0,$.$lg)(),p,p.name),N=new c(p.pty);return S.createExtensionTerminal(p.location,this.R(p,y).resolvedExtHostIdentifier,b(p.iconPath),f(p.color)).then(q=>{const j=this.S(q,N);this.h[q]=j}),this.f.push(S),S.value}R(p,y){if(y=y||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const S=p.location.parentTerminal;if(S){const N=this.f.find(q=>q.value===S);N&&(y.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?y.location=p.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(p,y){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new c(y),q=this.S(p,N);this.h[p]=q}async $acceptActiveTerminalChanged(p){const y=this.b;if(p===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const S=this.W(p);S&&(this.b=S,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,y){const S=this.W(p);S&&this.O.fire({terminal:S.value,data:y})}async $acceptTerminalDimensions(p,y,S){const N=this.W(p);N&&N.setDimensions(y,S)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,y){const S=this.W(p);S&&this.P.fire({terminal:S.value,...y})}async $acceptTerminalMaximumDimensions(p,y,S){this.g.get(p)?.resize(y,S)}async $acceptTerminalTitleChange(p,y){const S=this.W(p);S&&(S.name=y)}async $acceptTerminalClosed(p,y,S){const N=this.Y(this.f,p);if(N!==null){const q=this.f.splice(N,1)[0];q.setExitStatus(y,S),this.H.fire(q.value)}}$acceptTerminalOpened(p,y,S,N){if(y){const M=this.Y(this.f,y);if(M!==null){this.f[M]._id=p,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const q={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:F.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},j=new o(this.a,p,q,S);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,y){this.W(p)?._setProcessId(y)}async $startExtensionTerminal(p,y){const S=this.W(p);if(!S)return{message:(0,w.localize)(0,null,p)};S.isOpen||await new Promise(q=>{const j=this.onDidOpenTerminal(async M=>{M===S.value&&(j.dispose(),q())})});const N=this.g.get(p);N?N.startSendingEvents(y):this.j[p]={initialDimensions:y}}S(p,y){const S=new m.$Rc;S.add(y.onProcessReady(q=>this.a.$sendProcessReady(p,q.pid,q.cwd,q.windowsPty))),S.add(y.onDidChangeProperty(q=>this.a.$sendProcessProperty(p,q))),this.y.startBuffering(p,y.onProcessData),S.add(y.onProcessExit(q=>this.U(p,q))),this.g.set(p,y);const N=this.j[p];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[p]),S}$acceptProcessAckDataEvent(p,y){this.g.get(p)?.acknowledgeDataEvent(y)}$acceptProcessInput(p,y){this.g.get(p)?.input(y)}$acceptTerminalInteraction(p){const y=this.W(p);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(p,y){this.W(p)?.setSelection(y)}$acceptProcessResize(p,y,S){try{this.g.get(p)?.resize(y,S)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,y){this.g.get(p)?.shutdown(y)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(y=>this.a.$sendProcessProperty(p,{type:"cwd",value:y}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new g.$HK(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,y,S){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,S),this.a.$registerProfileProvider(y,p.identifier.value),new g.$HK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(p,y,S){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,S),this.a.$registerQuickFixProvider(p,y),new g.$HK(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,y){const S=new l.$3d().token;if(S.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const q=await N.provideTerminalQuickFixes(y,S);if(q===null||Array.isArray(q)&&q.length===0)return;const j=new m.$Rc;if(this.w.value=j,!Array.isArray(q))return q?t.TerminalQuickFix.from(q,this.Q.converter,j):void 0;const M=[];for(const U of q){const P=t.TerminalQuickFix.from(U,this.Q.converter,j);P&&M.push(P)}return M}async $createContributedProfileTerminal(p,y){const S=new l.$3d().token;let N=await this.C.get(p)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(p,y){const S=this.W(p);if(!S)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const q=new l.$3d;this.G.set(p,q);const j=[],M={terminal:S.value,line:y},U=[];for(const Z of this.z)U.push(s.Promises.withAsyncBody(async ue=>{q.token.onCancellationRequested(()=>ue({provider:Z,links:[]}));const ge=await Z.provideTerminalLinks(M,q.token)||[];q.token.isCancellationRequested||ue({provider:Z,links:ge})}));const P=await Promise.all(U);if(q.token.isCancellationRequested)return[];const I=new Map;for(const Z of P)Z&&Z.links.length>0&&j.push(...Z.links.map(ue=>{const ge={id:h++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return I.set(ge.id,{provider:Z.provider,link:ue}),ge}));return this.F.set(p,I),j}$activateLink(p,y){const S=this.F.get(p)?.get(y);S&&S.provider.handleTerminalLink(S.link)}U(p,y){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const S=this.h[p];S&&(S.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,y)}W(p){return this.X(this.f,p)}X(p,y){const S=this.Y(p,y);return S!==null?p[S]:null}Y(p,y){const S=p.findIndex(N=>N._id===y);return S===-1?null:S}getEnvironmentVariableCollection(p){let y=this.n.get(p.identifier.value);return y||(y=new r,this.$(p.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(p,y){const S=(0,k.$vr)(y.map),N=(0,k.$wr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(p,y.persistent,S.length===0?void 0:S,N)}$initEnvironmentVariableCollections(p){p.forEach(y=>{const S=y[0],N=new r(y[1]);this.$(S,N)})}$acceptDefaultProfile(p,y){const S=this.s;this.s=p,this.u=y,S?.path!==p.path&&this.N.fire(p.path)}$(p,y){this.n.set(p,y),y.onDidChangeCollection(()=>{this.Z(p,y)})}};e.$Dfc=i,e.$Dfc=i=He([Ve(1,n.$6M),Ve(2,R.$JM)],i);class r{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const y=this.h(p);let S=this.a.get(y);return S||(S=new u(this,p),this.a.set(y,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(p,y,S,N){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:N})}append(p,y,S,N){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:N})}prepend(p,y,S,N){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:N})}f(p,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(p,y.scope),N=this.map.get(S),q=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==q.applyAtProcessCreation||N.options?.applyAtShellIntegration!==q.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const j=this.g(p,y.scope),M={variable:p,...y,options:q};this.map.set(j,M),this.d.fire()}}get(p,y){const S=this.g(p,y),N=this.map.get(S);return N?D(N):void 0}g(p,y){const S=this.h(y);return S.length?`${p}:::${S}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const y=new Map;for(const[S,N]of this.map)this.h(N.scope)===this.h(p)&&y.set(N.variable,D(N));return y}delete(p,y){const S=this.g(p,y);this.map.delete(S),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[y,S]of this.map)S.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(y);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,y){const S=this.h(y),N=this.descriptionMap.get(S);if(!N||N.description!==p){let q;typeof p=="string"?q=p:q=p?.value.split(`

`)[0];const j={description:q,scope:y};this.descriptionMap.set(S,j),this.d.fire()}}getDescription(p){const y=this.h(p);return this.descriptionMap.get(y)?.description}k(p){const y=this.h(p);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,y){this.b=p,this.d=y,this.a=new E.$Sd}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,y,S){this.b.replace(p,y,S,this.d)}append(p,y,S){this.b.append(p,y,S,this.d)}prepend(p,y,S){this.b.prepend(p,y,S,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,y){this.b.getVariableMap(this.d).forEach((S,N)=>p.call(y,N,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(p,y){super(!1,p,y)}createTerminal(p,y,S){throw new A.$_}createTerminalFromOptions(p,y){throw new A.$_}};e.$Efc=d,e.$Efc=d=He([Ve(0,n.$6M),Ve(1,R.$JM)],d);function b(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function f(L){return a.ThemeColor.isThemeColor(L)?L:void 0}function D(L){const p={...L};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Pe[266],Ae([1,0,14,24,20,5,218,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;let h=class extends g.$Sc{constructor(j,M,U){super(),this.u=U,this.f=this.B(new F.$Sd),this.g=new Map,this.s=this.B(new F.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(l.$FK.MainThreadTesting),this.m=new y(this.h),this.j=new d(this.h),M.registerArgumentProcessor({processArgument:P=>{switch(P?.$mid){case 16:{const I=P,Z=I.tests[I.tests.length-1].item.extId;return this.g.get(t.$xJ.root(Z))?.collection.tree.get(Z)?.actual??(0,v.$VM)(P)}case 18:{const{extId:I,message:Z}=P;return{test:this.g.get(t.$xJ.root(I))?.collection.tree.get(I)?.actual,message:a.TestMessage.to(Z)}}default:return P}}}),M.registerCommand(!1,"testing.getExplorerSelection",async()=>{const P=await M.executeCommand("_testing.getExplorerSelection"),I=Z=>{const ue=this.g.get(t.$xJ.root(Z));if(ue)return t.$xJ.isRoot(Z)?ue.controller:ue.collection.tree.get(Z)?.actual};return{include:P?.include.map(I).filter(A.$Lf)||[],exclude:P?.exclude.map(I).filter(A.$Lf)||[]}})}createTestController(j,M,U,P){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const I=new g.$Rc,Z=I.add(new v.$YM(M,U,this.u));Z.root.label=U;const ue=new Map,ge=new Set,be=this.h,ke={items:Z.root.children,get label(){return U},set label(fe){U=fe,Z.root.label=fe,be.$updateController(M,{label:U})},get refreshHandler(){return P},set refreshHandler(fe){P=fe,be.$updateController(M,{canRefresh:!!fe})},get id(){return M},createRunProfile:(fe,ne,Se,ce,X,V)=>{let re=(0,m.$Oi)(fe);for(;ue.has(re);)re++;return new S(this.h,ue,j,ge,this.s.event,M,re,fe,ne,Se,ce,X,V)},createTestItem(fe,ne,Se){return new v.$WM(M,fe,ne,Se)},createTestRun:(fe,ne,Se=!0)=>this.j.createTestRun(j,M,Z,fe,ne,Se),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const ne=fe instanceof Array?fe:[fe];this.h.$markTestRetired(ne.map(Se=>t.$xJ.fromExtHostTestItem(Se,M).toString()))}},set resolveHandler(fe){Z.resolveHandler=fe},get resolveHandler(){return Z.resolveHandler},dispose:()=>{I.dispose()}};be.$registerTestController(M,U,!!P),I.add((0,g.$Qc)(()=>be.$unregisterTestController(M)));const me={controller:ke,collection:Z,profiles:ue,extension:j,activeProfiles:ge};return this.g.set(M,me),I.add((0,g.$Qc)(()=>this.g.delete(M))),I.add(Z.onDidGenerateDiff(fe=>be.$publishDiff(M,fe.map(o.TestsDiffOp.serialize)))),ke}createTestObserver(){return this.m.checkout()}async runTests(j,M=C.CancellationToken.None){const U=b(j);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const P=this.g.get(U.controllerId);if(!P)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(I=>t.$xJ.fromExtHostTestItem(I,P.collection.root.id).toString())??[P.collection.root.id],profileGroup:N[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:j.exclude?.map(I=>I.id)},M)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,M,U){return await this.j.getCoverageReport(j,M)?.provideFileCoverage(U)??[]}async $resolveFileCoverage(j,M,U,P){return await this.j.getCoverageReport(j,M)?.resolveFileCoverage(U,P)??[]}$configureRunProfile(j,M){this.g.get(j)?.profiles.get(M)?.configureHandler?.()}$setActiveRunProfiles(j){const M=new Map;for(const[U,P]of Object.entries(j)){const I=this.g.get(U);if(!I)continue;const Z=new Map,ue=P.filter(be=>!I.activeProfiles.has(be)),ge=[...I.activeProfiles].filter(be=>!P.includes(be));for(const be of ue)Z.set(be,!0),I.activeProfiles.add(be);for(const be of ge)Z.set(be,!1),I.activeProfiles.delete(be);Z.size&&M.set(U,Z)}this.s.fire(M)}async $refreshTests(j,M){await this.g.get(j)?.controller.refreshHandler?.(M)}$publishTestResults(j){this.results=Object.freeze(j.map(M=>(0,w.$gn)(a.TestResults.to(M))).concat(this.results).sort((M,U)=>U.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,M){const U=this.g.get(t.$xJ.fromString(j).controllerId)?.collection;U&&(await U.expand(j,M<0?1/0:M),U.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(o.TestsDiffOp.deserialize))}async $runControllerTests(j,M){return Promise.all(j.map(U=>this.w(U,!1,M)))}async $startContinuousRun(j,M){const U=new C.$3d(M),P=await Promise.all(j.map(I=>this.w(I,!0,U.token)));return!M.isCancellationRequested&&!P.some(I=>I.error)&&await new Promise(I=>M.onCancellationRequested(I)),U.dispose(!0),P}async w(j,M,U){const P=this.g.get(j.controllerId);if(!P)return{};const{collection:I,profiles:Z,extension:ue}=P,ge=Z.get(j.profileId);if(!ge)return{};const be=j.testIds.map(ne=>I.tree.get(ne)).filter(A.$Lf),ke=j.excludeExtIds.map(ne=>P.collection.tree.get(ne)).filter(A.$Lf).filter(ne=>be.some(Se=>Se.fullId.compare(ne.fullId)===2));if(!be.length)return{};const me=new s.$eM(be.some(ne=>ne.actual instanceof v.$XM)?void 0:be.map(ne=>ne.actual),ke.map(ne=>ne.actual),ge,M),fe=(0,o.$zJ)(j)&&this.j.prepareForMainThreadTestRun(me,f.fromInternal(j,P.collection),ue,U);try{return await ge.runHandler(me,U),{}}catch(ne){return{error:String(ne)}}finally{fe&&(fe.hasRunningTasks&&!U.isCancellationRequested&&await F.Event.toPromise(fe.onEnd),fe.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$Hgc=h,e.$Hgc=h=He([Ve(0,$.$JM)],h);const i=1e4;var r;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(r||(r={}));class u extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,M,U,P){super(),this.s=j,this.u=M,this.w=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.$Sd),this.m=this.B(new F.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new C.$3d(P));const I=this.B(new E.$ah(()=>this.y(),i));this.B(this.h.token.onCancellationRequested(()=>I.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(j){const M=this.s.id,U=this.s.controllerId,P=(0,k.$lg)(),I=this.w,Z=this.m;let ue;const ge=fe=>(ne,...Se)=>{if(ke){console.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.C(ne),fe(ne,...Se))},be=(fe,ne)=>{const Se=ne instanceof Array?ne.map(a.TestMessage.from):[a.TestMessage.from(ne)];if(fe.uri&&fe.range){const ce={range:a.Range.from(fe.range),uri:fe.uri};for(const X of Se)X.location=X.location||ce}this.u.$appendTestMessagesInRun(M,P,t.$xJ.fromExtHostTestItem(fe,U).toString(),Se)};let ke=!1;const me={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return ue?.provider},set coverageProvider(fe){(0,c.$SF)(I,"testCoverage"),ue=fe&&new D(fe),Z.fire({taskId:P,runId:M,coverage:ue})},enqueued:ge(fe=>{this.u.$updateTestStateInRun(M,P,t.$xJ.fromExtHostTestItem(fe,U).toString(),1)}),skipped:ge(fe=>{this.u.$updateTestStateInRun(M,P,t.$xJ.fromExtHostTestItem(fe,U).toString(),5)}),started:ge(fe=>{this.u.$updateTestStateInRun(M,P,t.$xJ.fromExtHostTestItem(fe,U).toString(),2)}),errored:ge((fe,ne,Se)=>{be(fe,ne),this.u.$updateTestStateInRun(M,P,t.$xJ.fromExtHostTestItem(fe,U).toString(),6,Se)}),failed:ge((fe,ne,Se)=>{be(fe,ne),this.u.$updateTestStateInRun(M,P,t.$xJ.fromExtHostTestItem(fe,U).toString(),4,Se)}),passed:ge((fe,ne)=>{this.u.$updateTestStateInRun(M,P,t.$xJ.fromExtHostTestItem(fe,this.s.controllerId).toString(),3,ne)}),appendOutput:(fe,ne,Se)=>{ke||(Se&&(this.s.isIncluded(Se)?this.C(Se):Se=void 0),this.u.$appendOutputToRun(M,P,T.$ge.fromString(fe),ne&&a.location.from(ne),Se&&t.$xJ.fromExtHostTestItem(Se,U).toString()))},end:()=>{ke||(ke=!0,this.u.$finishedTestRunTask(M,P),this.f.delete(P),this.f.size||this.z())}};return this.f.set(P,{run:me}),this.u.$startedTestRunTask(M,{id:P,name:j,running:!0}),me}y(){for(const{run:j}of this.f.values())j.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(j){if(!(j instanceof v.$WM))throw new n.$BM(j.id);if(this.g.has(t.$xJ.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const M=[],U=this.s.colllection.root;for(;;){const P=a.TestItem.from(j);if(M.unshift(P),this.g.has(P.extId)||(this.g.add(P.extId),j===U))break;j=j.parent||U}this.u.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.z(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(j){this.f=j,this.c=new Map,this.d=[]}getCoverageReport(j,M){return this.d.find(U=>U.runId===j)?.coverage.get(M)}prepareForMainThreadTestRun(j,M,U,P){return this.g(j,M,U,P)}cancelRunById(j){for(const M of this.c.values())if(M.id===j){M.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,M,U,P,I,Z){const ue=this.c.get(P);if(ue)return ue.createRun(I);const ge=f.fromPublic(M,U,P,Z),be=b(P);this.f.$startedExtensionTestRun({controllerId:M,continuous:!!P.continuous,profile:be&&{group:N[be.kind],id:be.profileId},exclude:P.exclude?.map(me=>t.$xJ.fromExtHostTestItem(me,U.root.id).toString())??[],id:ge.id,include:P.include?.map(me=>t.$xJ.fromExtHostTestItem(me,U.root.id).toString())??[U.root.id],persist:Z});const ke=this.g(P,ge,j);return F.Event.once(ke.onEnd)(()=>{this.f.$finishedExtensionTestRun(ge.id),ke.dispose()}),ke.createRun(I)}g(j,M,U,P){const I=new u(M,this.f,U,P);this.c.set(j,I);let Z;const ue=I.onDidCoverage(({runId:ge,taskId:be,coverage:ke})=>{Z||(Z={runId:ge,coverage:new Map},this.d.unshift(Z),this.d.length>o.$EJ&&this.d.pop()),Z.coverage.set(be,ke),this.f.$signalCoverageAvailable(ge,be,!!ke)});return F.Event.once(I.onEnd)(()=>{this.c.delete(j),ue.dispose()}),I}}e.$Igc=d;const b=q=>{if(q.profile){if(!(q.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class f{static fromPublic(j,M,U,P){return new f(j,(0,k.$lg)(),U.include?.map(I=>t.$xJ.fromExtHostTestItem(I,j).toString())??[j],U.exclude?.map(I=>t.$xJ.fromExtHostTestItem(I,j).toString())??[],P,M)}static fromInternal(j,M){return new f(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,M)}constructor(j,M,U,P,I,Z){this.controllerId=j,this.id=M,this.isPersisted=I,this.colllection=Z,this.c=U.map(ue=>ue+"\0"),this.d=P.map(ue=>ue+"\0")}isIncluded(j){const M=t.$xJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const U of this.d)if(M===U||M.startsWith(U))return!1;for(const U of this.c)if(M===U||M.startsWith(U))return!0;return!1}}e.$Jgc=f;class D{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(j,M){const U=await this.c;let P=U?.[j];return!this.provider||!U||!P?[]:(P.detailedCoverage||(P=U[j]=await this.provider.resolveFileCoverage?.(P,M)??P),P.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class L{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(j){this.h=j,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,a.TestItem.toPlain(j.item)),this.c.has(j)||this.d.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.d.delete(j);const M=t.$xJ.parentId(j.item.extId);if(M&&this.g.has(M.toString())){this.g.add(j.item.extId);return}this.f.add(j)}getChangeEvent(){const{c:j,d:M,f:U}=this;return{get added(){return[...j].map(P=>P.revived)},get updated(){return[...M].map(P=>P.revived)},get removed(){return[...U].map(P=>P.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends o.$FJ{constructor(){super(...arguments),this.q=new F.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(j){return this.d.get(j)}getMirroredTestDataByReference(j){return this.d.get(j.id)}p(j,M){return{...j,revived:a.TestItem.toPlain(j.item),depth:M?M.depth+1:0,children:new Set}}o(){return new L(this.q)}}class y{constructor(j){this.d=j}checkout(){this.c||(this.c=this.f());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(M=>M.revived)},dispose:(0,R.$db)(()=>{--j.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}f(){const j=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:j}}}class S{#e;#t;#i;#o;#r;get label(){return this.d}set label(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.f}set isDefault(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?a.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}get isSelected(){return(0,c.$SF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$SF)(this.#t,"testingActiveProfile"),F.Event.chain(this.#o,j=>j.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(A.$Lf))}constructor(j,M,U,P,I,Z,ue,ge,be,ke,me=!1,fe=void 0,ne=!1){this.controllerId=Z,this.profileId=ue,this.d=ge,this.kind=be,this.runHandler=ke,this.f=me,this._tag=fe,this.g=ne,this.#e=j,this.#r=M,this.#t=U,this.#i=P,this.#o=I,M.set(ue,this);const Se=N[be];if(typeof Se!="number")throw new Error(`Unknown TestRunProfile.group ${be}`);this.#e.$publishTestRunProfile({profileId:ue,controllerId:Z,tag:fe?a.TestTag.namespace(this.controllerId,fe.id):null,label:ge,group:Se,isDefault:me,hasConfigurationHandler:!1,supportsContinuousRun:ne})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Kgc=S;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Pe[267],Ae([1,0,18,11,5,3,109,8,7]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class w{constructor(k,l){this.i=l,this.a=new C.$Sd({onListenerError:T.$2}),this.b=new C.$Sd({onListenerError:T.$2}),this.c=new C.$Sd({onListenerError:T.$2}),this.d=new C.$Sd({onListenerError:T.$2}),this.f=new C.$Sd({onListenerError:T.$2}),this.g=new C.$Sd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(F.$FK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const l=this.i.allEditors();return k?l:l.map($=>$.value)}async showTextDocument(k,l,$){let v;typeof l=="number"?v={position:m.ViewColumn.from(l),preserveFocus:$}:typeof l=="object"?v={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?m.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const a=await this.h.$tryShowTextDocument(k.uri,v),s=a&&this.i.getEditor(a);if(s)return s.value;throw a?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,l){return new R.$QM(this.h,k,l).value}$acceptEditorPropertiesChanged(k,l){const $=this.i.getEditor(k);if(!$)throw new Error("unknown text editor");if(l.options&&$._acceptOptions(l.options),l.selections){const v=l.selections.selections.map(m.Selection.to);$._acceptSelections(v)}if(l.visibleRanges){const v=E.$Hb(l.visibleRanges.map(m.Range.to));$._acceptVisibleRanges(v)}if(l.options&&this.b.fire({textEditor:$.value,options:{...l.options,lineNumbers:m.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const v=g.TextEditorSelectionChangeKind.fromValue(l.selections.source),a=l.selections.selections.map(m.Selection.to);this.a.fire({textEditor:$.value,selections:a,kind:v})}if(l.visibleRanges){const v=E.$Hb(l.visibleRanges.map(m.Range.to));this.c.fire({textEditor:$.value,visibleRanges:v})}}$acceptEditorPositionData(k){for(const l in k){const $=this.i.getEditor(l);if(!$)throw new Error("Unknown text editor");const v=m.ViewColumn.to(k[l]);$.value.viewColumn!==v&&($._acceptViewColumn(v),this.d.fire({textEditor:$.value,viewColumn:v}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$7ec=w}),define(Pe[268],Ae([1,0,2,4,3,6,7,8,22,16]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=void 0,e.$Mgc=(0,T.$1h)("IExtHostTimeline");class A{constructor($,v){this.b=new Map,this.c=new Map,this.a=$.getProxy(C.$FK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(a,s)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&g.$em.equals(s,this.b.get(a.source)?.extension)){const t=a.uri===void 0?void 0:E.URI.revive(a.uri);return this.c.get(a.source)?.get(k(t))?.get(a.handle)}else return;return a}})}async $getTimeline($,v,a,s){return this.b.get($)?.provider.provideTimeline(E.URI.revive(v),a,s)}registerTimelineProvider($,v,a,s){const t=new F.$Rc,n=this.d(v.id,s,t).bind(this);let o;v.onDidChange&&(o=v.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:v.id}),this));const c=this.c;return this.f({...v,scheme:$,onDidChange:void 0,async provideTimeline(h,i,r){i?.resetCache&&(t.clear(),c.get(v.id)?.clear());const u=await v.provideTimeline(h,i,r);if(u==null)return;const d=n(h,i);return{...u,source:v.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(v.id)?.clear();o?.dispose(),t.dispose()}},a)}d($,v,a){return(s,t)=>{let n;if(t?.cacheResults){let o=this.c.get($);o===void 0&&(o=new Map,this.c.set($,o));const c=k(s);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...h}=o,i=`${$}|${o.id??o.timestamp}`;n?.set(i,o);let r,u,d;o.iconPath&&(c instanceof R.$CL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(r=c,u=c):{light:r,dark:u}=c);let b;return R.$9K.isMarkdownString(h.tooltip)?b=m.MarkdownString.from(h.tooltip):(0,w.$Df)(h.tooltip)?b=h.tooltip:R.$9K.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=m.MarkdownString.from(h.detail)):(0,w.$Df)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=h.detail),{...h,id:h.id??void 0,handle:i,source:$,command:o.command?v.toInternal(o.command,a):void 0,icon:r,iconDark:u,themeIcon:d,tooltip:b,accessibilityInformation:o.accessibilityInformation}}}}f($,v){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:v}),(0,F.$Qc)(()=>{for(const s of this.c.values())s.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$Ngc=A;function k(l){return l?.toString()}}),define(Pe[87],Ae([1,0,20,5,6,167,4,15,196,3,27,17,7]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zxb=e.$Yxb=e.TunnelDtoConverter=void 0;class $ extends g.$sv{}var v;(function(s){function t(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:o.protocol}}s.fromApiTunnel=t;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==g.TunnelPrivacyId.ConstantPrivate&&o.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}s.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$Yxb=(0,R.$1h)("IExtHostTunnelService");let a=class extends C.$Sc{constructor(t,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$FK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,t.displayName);if(o){const c=new $(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const o=this.u();return this.r.set(o,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,o),new l.$HK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(t,n,o,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async b=>{let f;try{f=await d.provider.providePortAttributes({port:b,pid:o,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(b,o,c,h)}return{providedAttributes:f,port:b}})))}const r=i.filter(u=>!!u.providedAttributes);return r.length>0?r.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$3d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,C.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const o=t.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,C.$Qc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const o=this.g.get(t.host);o.has(t.port)&&(n&&o.get(t.port).disposeListener.dispose(),await o.get(t.port).tunnel.dispose(),o.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),v.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),o=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$Zxb=a,e.$Zxb=a=He([Ve(0,k.$JM),Ve(1,A.$ZM),Ve(2,m.$ij)],a)}),define(Pe[269],Ae([1,0,6,13,2,3]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(F.$FK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,A,k){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=k.schemes.find($=>!R.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,k.schemes,g,k.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const l=C.URI.revive(w);return k.canOpenExternalUri(l,A)}async $openUri(g,w,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(C.URI.revive(w.resolvedUri),{sourceUri:C.URI.revive(w.sourceUri)},A)}}e.$Pgc=R}),define(Pe[270],Ae([1,0,3,2,6,11,22]),function(pe,e,E,T,C,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class m{static{this.a=0}constructor(w){this.c=new R.$fm,this.d=new Map,this.b=w.getProxy(E.$FK.MainThreadUrls)}registerUriHandler(w,A){const k=w.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,w.displayName||w.name),(0,C.$Qc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,A){const k=this.d.get(w);if(!k)return Promise.resolve(void 0);try{k.handleUri(T.URI.revive(A))}catch(l){(0,F.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$Qgc=m}),define(Pe[65],Ae([1,0,5,6,13,26,2,181,203,78,3]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=e.$ifc=void 0;class k{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,r,u,d,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Sd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=r,this.#r=u,this.#n=d,this.#l=l(d),this.#d=$(d),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$8ub)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$7ub}return w.$7ub}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),F.$jn(this.#s,c)||this.#t.$setOptions(this.#e,s(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$Mkb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,d,b,f,D)=>{const L=R.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),p=(0,w.$8ub)(L,{isRemote:h,authority:i}).toString();return`${u}${p}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,d,b,f,D)=>{const L=R.URI.from({scheme:b||"file",path:decodeURIComponent(f)}),p=(0,w.$8ub)(L,{isRemote:h,authority:i}).toString();return`${u}${p}${D}`})}}e.$ifc=k;function l(o){try{const c=(0,m.$Yo)((0,m.$Xo)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$jfc=l;function $(o){try{const c=(0,m.$Yo)((0,m.$Xo)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class v extends T.$Sc{constructor(c,h,i,r,u){super(),this.c=h,this.f=i,this.g=r,this.h=u,this.b=new Map,this.a=c.getProxy(A.$FK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const r=this.j(c);if(r){const{message:u}=(0,g.$Nkb)(h,i.value);r._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const r=new k(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,r);const u=r._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return r}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$kfc=v;function a(o){return{id:o.identifier,location:o.extensionLocation}}e.$lfc=a;function s(o,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,c)}}e.$mfc=s;function t(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>R.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Pe[271],Ae([1,0,20,98,6,13,25,2,8,65,75,3,7]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class ${constructor(r,u){this.document=r,this.b=u,this.a=1,this.c=new A.$Nec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,u){await this.f(r).undo(),u||this.disposeBackup()}async redo(r,u){await this.f(r).redo(),u||this.disposeBackup()}disposeEdits(r){for(const u of r)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=h(this.document.uri)+this.a++;return(0,R.$Cg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const u=this.c.get(r,0);if(!u)throw new Error("No edit found");return u}}class v{constructor(){this.a=new Map}get(r,u){return this.a.get(this.b(r,u))}add(r,u,d){const b=this.b(r,u.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${r} resource:${u.uri}`);const f=new $(u,d);return this.a.set(b,f),f}delete(r,u){const d=this.b(r,u.uri);this.a.delete(d)}b(r,u){return`${r}@@@${u}`}}var a;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(a||(a={}));class s{constructor(){this.a=new Map}addTextProvider(r,u,d){return this.b(0,r,u,d)}addCustomProvider(r,u,d){return this.b(1,r,u,d)}get(r){return this.a.get(r)}b(r,u,d,b){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:r,extension:d,provider:b}),new l.$HK(()=>this.a.delete(u))}}class t{constructor(r,u,d,b,f){this.d=u,this.f=d,this.g=b,this.h=f,this.b=new s,this.c=new v,this.a=r.getProxy(k.$FK.MainThreadCustomEditors)}registerCustomEditorProvider(r,u,d,b){const f=new C.$Rc;return o(d)?(f.add(this.b.addTextProvider(u,r,d)),this.a.$registerTextEditorProvider((0,w.$lfc)(r),u,b.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$jfc)(r))):(f.add(this.b.addCustomProvider(u,r,d)),n(d)&&f.add(d.onDidChangeCustomDocument(D=>{const L=this.i(u,D.document.uri);if(c(D)){const p=L.addEdit(D);this.a.$onDidEdit(D.document.uri,u,p,D.label)}else this.a.$onContentChange(D.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$lfc)(r),u,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,w.$jfc)(r))),l.$HK.from(f,new l.$HK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(r,u,d,b,f){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${u}'`);const L=m.URI.revive(r),p=await D.provider.openCustomDocument(L,{backupId:d,untitledDocumentData:b?.buffer},f);let y;return n(D.provider)&&this.f&&(y=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(u,p,y),{editable:n(D.provider)}}async $disposeCustomDocument(r,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const b=m.URI.revive(r),{document:f}=this.i(u,b);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(r,u,d,b,f,D){const L=this.b.get(d);if(!L)throw new Error(`No provider found for '${d}'`);const p=g.ViewColumn.to(f),y=this.g.createNewWebview(u,b.contentOptions,L.extension),S=this.h.createNewWebviewPanel(u,d,b.title,p,b.options,y,b.active),N=m.URI.revive(r);switch(L.type){case 1:{const{document:q}=this.i(d,N);return L.provider.resolveCustomEditor(q,S,D)}case 0:{const q=this.d.getDocument(N);return L.provider.resolveCustomTextEditor(q,S,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,u,d){this.i(u,r).disposeEdits(d)}async $onMoveCustomEditor(r,u,d){const b=this.b.get(d);if(!b)throw new Error(`No provider found for '${d}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(r);if(!f)throw new Error("No webview found");const D=m.URI.revive(u),L=this.d.getDocument(D);await b.provider.moveCustomTextEditor(L,f,E.CancellationToken.None)}async $undo(r,u,d,b){return this.i(u,r).undo(d,b)}async $redo(r,u,d,b){return this.i(u,r).redo(d,b)}async $revert(r,u,d){const b=this.i(u,r);await this.j(u).revertCustomDocument(b.document,d),b.disposeBackup()}async $onSave(r,u,d){const b=this.i(u,r);await this.j(u).saveCustomDocument(b.document,d),b.disposeBackup()}async $onSaveAs(r,u,d,b){const f=this.i(u,r);return this.j(u).saveCustomDocumentAs(f.document,m.URI.revive(d),b)}async $backup(r,u,d){const b=this.i(u,r),D=await this.j(u).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},d);return b.updateBackup(D),D.id}i(r,u){const d=this.c.get(r,m.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(r){const d=this.b.get(r)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$ofc=t;function n(i){return!!i.onDidChangeCustomDocument}function o(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const r=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Oi)(r)+""}}),define(Pe[272],Ae([1,0,5,6,2,33,8,65,3,7]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class A extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(v,a,s,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=a,this.#o=s,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,C.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends T.$Sc{static c(){return(0,F.$lg)()}constructor(v,a,s){super(),this.j=a,this.m=s,this.g=new Map,this.h=new Map,this.f=v.getProxy(g.$FK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,a,s,t,n={}){const o=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(o),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,m.$jfc)(v),i=k.c();this.f.$createWebviewPanel((0,m.$lfc)(v),i,a,{title:s,panelOptions:l(n),webviewOptions:(0,m.$mfc)(v,this.m,n),serializeBuffersForPostMessage:h},c);const r=this.j.createNewWebview(i,n,v);return this.createNewWebviewPanel(i,a,s,o,n,r,!0)}$onDidChangeWebviewPanelViewStates(v){const a=Object.keys(v);a.sort((s,t)=>{const n=v[s],o=v[t];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const s of a){const t=this.getWebviewPanel(s);if(!t)continue;const n=v[s];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,a,s){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:s,extension:v}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,m.$jfc)(v)}),new w.$HK(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(v,a,s,t){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:o,extension:c}=n,h=this.j.createNewWebview(v,s.webviewOptions,c),i=this.createNewWebviewPanel(v,a,s.title,t,s.panelOptions,h,s.active);await o.deserializeWebviewPanel(i,s.state)}createNewWebviewPanel(v,a,s,t,n,o,c){const h=new A(v,this.f,o,{viewType:a,title:s,viewColumn:t,panelOptions:n,active:c});return this.g.set(v,h),h}getWebviewPanel(v){return this.g.get(v)}}e.$nfc=k;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Pe[273],Ae([1,0,5,6,65,8,3,7]),function(pe,e,E,T,C,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class g extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(k,l,$,v,a,s){super(),this.#r=!1,this.#u=this.B(new E.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Sd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=v,this.#e=k,this.#t=l,this.#o=a,this.#n=s}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#r||(this.#n=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$FK.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,$,v){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:k}),this.a.$registerWebviewViewProvider((0,C.$lfc)(k),l,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$jfc)(k)}),new m.$HK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,$,v,a){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=s,o=this.d.createNewWebview(k,{},n),c=new g(k,this.a,l,$,o,!0);this.c.set(k,c),await t.resolveWebviewView(c,{state:v},a)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$Rgc=w}),define(Pe[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState($){const v=this.d;return{get focused(){return v.focused},get active(){return(0,w.$SF)($,"windowActivity"),v.active}}}constructor($){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=$.getProxy(T.$FK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:a})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,v){v!==this.d[$]&&(this.d={...this.d,[$]:v},this.c.fire(this.d))}openUri($,v){let a;if(typeof $=="string"){a=$;try{$=C.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,R.$Ge)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,a,v)}async asExternalUri($,v){if((0,R.$Ge)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri($,v);return C.URI.from(a)}};e.$Sgc=k,e.$Sgc=k=A=He([Ve(0,g.$JM)],k),e.$Tgc=(0,m.$1h)("IExtHostWindow")}),define(Pe[274],Ae([1,0,240,27,17]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;let F=class extends E.$Wgc{constructor(m,g){super(m,g)}f(m,g,w){g.apply(console,w)}};e.$5ic=F,e.$5ic=F=He([Ve(0,C.$JM),Ve(1,T.$ZM)],F)}),define(Pe[275],Ae([1,0,14,24,20,11,5,6,138,229,49]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=e.ResponsiveState=e.RequestInitiator=e.$76b=e.$66b=void 0;function l(S,N){try{return JSON.stringify(S,N)}catch{return"null"}}const $="$$ref$$",v={[$]:-1};class a{constructor(N,q){this.jsonString=N,this.referencedBuffers=q}}function s(S,N=null,q=!1){const j=[];return{jsonString:(q?l:JSON.stringify)(S,(U,P)=>{if(typeof P>"u")return v;if(typeof P=="object"){if(P instanceof T.$ge){const I=j.push(P)-1;return{[$]:I}}if(N)return N(U,P)}return P}),referencedBuffers:j}}e.$66b=s;function t(S,N,q){return JSON.parse(S,(j,M)=>{if(M){const U=M[$];if(typeof U=="number")return N[U];if(q&&M.$mid===1)return q.transformIncoming(M)}return M})}e.$76b=t;function n(S,N){return JSON.stringify(S,N)}function o(S){return S?(N,q)=>q&&q.$mid===1?S.transformOutgoing(q):q:null}var c;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},r=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends m.$Sc{static{k=r}static{this.a=3*1e3}constructor(N,q=null,j=null){super(),this[k]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=q,this.g=j,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,U=A.$zv.count;M<U;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$ah(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const q=this.w[N];delete this.w[N],q.resolveErr(F.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$Zm)(N,this.g):N}getProxy(N){const{nid:q,sid:j}=N;return this.s[q]||(this.s[q]=this.J(q,j)),this.s[q]}J(N,q){const j={get:(M,U)=>(typeof U=="string"&&!M[U]&&U.charCodeAt(0)===36&&(M[U]=(...P)=>this.U(N,U,P)),U===u?q:M[U])};return new Proxy(Object.create(null),j)}set(N,q){return this.m[N.nid]=q,q}assertRegistered(N){for(let q=0,j=N.length;q<j;q++){const M=N[q];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(N){if(this.j)return;const q=N.byteLength,j=f.read(N,0),M=j.readUInt8(),U=j.readUInt32();switch(M){case 1:case 2:{let{rpcId:P,method:I,args:Z}=L.deserializeRequestJSONArgs(j);this.g&&(Z=(0,g.$Zm)(Z,this.g)),this.M(q,U,P,I,Z,M===2);break}case 3:case 4:{let{rpcId:P,method:I,args:Z}=L.deserializeRequestMixedArgs(j);this.g&&(Z=(0,g.$Zm)(Z,this.g)),this.M(q,U,P,I,Z,M===4);break}case 5:{this.f?.logIncoming(q,U,0,"ack"),this.G(U);break}case 6:{this.N(q,U);break}case 7:{this.O(q,U,void 0);break}case 9:{let P=L.deserializeReplyOKJSON(j);this.g&&(P=(0,g.$Zm)(P,this.g)),this.O(q,U,P);break}case 10:{const P=L.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(q,U,P);break}case 8:{const P=L.deserializeReplyOKVSBuffer(j);this.O(q,U,P);break}case 11:{let P=L.deserializeReplyErrError(j);this.g&&(P=(0,g.$Zm)(P,this.g)),this.P(q,U,P);break}case 12:{this.P(q,U,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,q,j,M,U,P){this.f?.logIncoming(N,q,1,`receiveRequest ${(0,A.$Bv)(j)}.${M}(`,U);const I=String(q);let Z,ue;if(P){const be=new C.$3d;U.push(be.token),Z=this.Q(j,M,U),ue=()=>be.cancel()}else Z=this.Q(j,M,U),ue=i;this.u[I]=ue;const ge=L.serializeAcknowledged(q);this.f?.logOutgoing(ge.byteLength,q,1,"ack"),this.c.send(ge),Z.then(be=>{delete this.u[I];const ke=L.serializeReplyOK(q,be,this.h);this.f?.logOutgoing(ke.byteLength,q,1,"reply:",be),this.c.send(ke)},be=>{delete this.u[I];const ke=L.serializeReplyErr(q,be);this.f?.logOutgoing(ke.byteLength,q,1,"replyErr:",be),this.c.send(ke)})}N(N,q){this.f?.logIncoming(N,q,1,"receiveCancel");const j=String(q);this.u[j]?.()}O(N,q,j){this.f?.logIncoming(N,q,0,"receiveReply:",j);const M=String(q);if(!this.w.hasOwnProperty(M))return;const U=this.w[M];delete this.w[M],U.resolveOk(j)}P(N,q,j){this.f?.logIncoming(N,q,0,"receiveReplyErr:",j);const M=String(q);if(!this.w.hasOwnProperty(M))return;const U=this.w[M];delete this.w[M];let P;j&&(j.$isError?(P=new Error,P.name=j.name,P.message=j.message,P.stack=j.stack):P=j),U.resolveErr(P)}Q(N,q,j){try{return Promise.resolve(this.S(N,q,j))}catch(M){return Promise.reject(M)}}S(N,q,j){const M=this.m[N];if(!M)throw new Error("Unknown actor "+(0,A.$Bv)(N));const U=M[q];if(typeof U!="function")throw new Error("Unknown method "+q+" on actor "+(0,A.$Bv)(N));return U.apply(M,j)}U(N,q,j){if(this.j)return new w.$56b;let M=null;if(j.length>0&&C.CancellationToken.isCancellationToken(j[j.length-1])&&(M=j.pop()),M&&M.isCancellationRequested)return Promise.reject(F.$6());const U=L.serializeRequestArguments(j,this.h),P=++this.t,I=String(P),Z=new w.$46b,ue=new m.$Rc;M&&ue.add(M.onCancellationRequested(()=>{const be=L.serializeCancel(P);this.f?.logOutgoing(be.byteLength,P,0,"cancel"),this.c.send(L.serializeCancel(P))})),this.w[I]=new b(Z,ue),this.F(P);const ge=L.serializeRequest(P,N,q,U,!!M);return this.f?.logOutgoing(ge.byteLength,P,0,`request: ${(0,A.$Bv)(N)}.${q}(`,j),this.c.send(ge),Z}}e.$86b=d;class b{constructor(N,q){this.a=N,this.b=q}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,q,j){const M=new f(T.$ge.alloc(j+1+4),0);return M.writeUInt8(N),M.writeUInt32(q),M}static read(N,q){return new f(N,q)}get buffer(){return this.a}constructor(N,q){this.a=N,this.b=q}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N).toString();return this.b+=N,j}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+N);return this.b+=N,q}static sizeMixedArray(N){let q=0;q+=1;for(let j=0,M=N.length;j<M;j++){const U=N[j];switch(q+=1,U.type){case 1:q+=this.sizeLongString(U.value);break;case 2:q+=this.sizeVSBuffer(U.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(U.value);for(let P=0;P<U.buffers.length;++P)q+=this.sizeVSBuffer(U.buffers[P]);break;case 4:break}}return q}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let q=0,j=N.length;q<j;q++){const M=N[q];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let U=0;U<M.buffers.length;++U)this.writeBuffer(M.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const q=new Array(N);for(let j=0;j<N;j++)switch(this.readUInt8()){case 1:q[j]=this.readLongString();break;case 2:q[j]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),P=this.readLongString(),I=[];for(let Z=0;Z<U;++Z)I.push(this.readVSBuffer());q[j]=new A.$Cv(t(P,I,null));break}case 4:q[j]=void 0;break}return q}}var D;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(D||(D={}));class L{static a(N){for(let q=0,j=N.length;q<j;q++)if(N[q]instanceof T.$ge||N[q]instanceof A.$Cv||typeof N[q]>"u")return!0;return!1}static serializeRequestArguments(N,q){if(this.a(N)){const j=[];for(let M=0,U=N.length;M<U;M++){const P=N[M];if(P instanceof T.$ge)j[M]={type:2,value:P};else if(typeof P>"u")j[M]={type:4};else if(P instanceof A.$Cv){const{jsonString:I,referencedBuffers:Z}=s(P.value,q);j[M]={type:3,value:T.$ge.fromString(I),buffers:Z}}else j[M]={type:1,value:T.$ge.fromString(n(P,q))}}return{type:1,args:j}}return{type:0,args:n(N,q)}}static serializeRequest(N,q,j,M,U){switch(M.type){case 0:return this.b(N,q,j,M.args,U);case 1:return this.c(N,q,j,M.args,U)}}static b(N,q,j,M,U){const P=T.$ge.fromString(j),I=T.$ge.fromString(M);let Z=0;Z+=f.sizeUInt8(),Z+=f.sizeShortString(P),Z+=f.sizeLongString(I);const ue=f.alloc(U?2:1,N,Z);return ue.writeUInt8(q),ue.writeShortString(P),ue.writeLongString(I),ue.buffer}static deserializeRequestJSONArgs(N){const q=N.readUInt8(),j=N.readShortString(),M=N.readLongString();return{rpcId:q,method:j,args:JSON.parse(M)}}static c(N,q,j,M,U){const P=T.$ge.fromString(j);let I=0;I+=f.sizeUInt8(),I+=f.sizeShortString(P),I+=f.sizeMixedArray(M);const Z=f.alloc(U?4:3,N,I);return Z.writeUInt8(q),Z.writeShortString(P),Z.writeMixedArray(M),Z.buffer}static deserializeRequestMixedArgs(N){const q=N.readUInt8(),j=N.readShortString(),M=N.readMixedArray(),U=new Array(M.length);for(let P=0,I=M.length;P<I;P++){const Z=M[P];typeof Z=="string"?U[P]=JSON.parse(Z):U[P]=Z}return{rpcId:q,method:j,args:U}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,q,j){if(typeof q>"u")return this.d(N);if(q instanceof T.$ge)return this.e(N,q);if(q instanceof A.$Cv){const{jsonString:M,referencedBuffers:U}=s(q.value,j,!0);return this.g(N,M,U)}else return this.f(N,l(q,j))}static d(N){return f.alloc(7,N,0).buffer}static e(N,q){let j=0;j+=f.sizeVSBuffer(q);const M=f.alloc(8,N,j);return M.writeVSBuffer(q),M.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,q){const j=T.$ge.fromString(q);let M=0;M+=f.sizeLongString(j);const U=f.alloc(9,N,M);return U.writeLongString(j),U.buffer}static g(N,q,j){const M=T.$ge.fromString(q);let U=0;U+=f.sizeUInt32,U+=f.sizeLongString(M);for(const I of j)U+=f.sizeVSBuffer(I);const P=f.alloc(10,N,U);P.writeUInt32(j.length),P.writeLongString(M);for(const I of j)P.writeBuffer(I);return P.buffer}static deserializeReplyOKJSON(N){const q=N.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(N,q){const j=N.readUInt32(),M=N.readLongString(),U=[];for(let P=0;P<j;++P)U.push(N.readVSBuffer());return new A.$Cv(t(M,U,q))}static serializeReplyErr(N,q){const j=q?l(F.$3(q),null):void 0;if(typeof j!="string")return this.h(N);const M=T.$ge.fromString(j);let U=0;U+=f.sizeLongString(M);const P=f.alloc(11,N,U);return P.writeLongString(M),P.buffer}static deserializeReplyErrError(N){const q=N.readLongString();return JSON.parse(q)}static h(N){return f.alloc(12,N,0).buffer}}var p;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var y;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[276],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;const E=function(F){const R=m=>{globalThis.removeEventListener("message",R);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,A){g.postMessage(w,A)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class T extends EventTarget{constructor(F,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,w=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(w),k=new MessageChannel,l=A,$={type:"_newWorker",id:l,port:k.port2,url:A,options:m};F($,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{F({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(v){k.port1.onmessage=v}},onmessageerror:{get(){return k.port1.onmessageerror},set(v){k.port1.onmessageerror=v}}}),k.port1.addEventListener("messageerror",v=>{const a=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(a)}),k.port1.addEventListener("message",v=>{const a=new MessageEvent("message",{data:v.data});this.dispatchEvent(a)}),k.port1.start()}}e.$7ic=T}),define(Pe[277],Ae([1,0,5,30,35,4]),function(pe,e,E,T,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$1J=e.OutputChannelUpdateMode=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=void 0,e.$QJ="text/x-code-output",e.$RJ="output",e.$SJ="Log",e.$TJ="text/x-code-log-output",e.$UJ="log",e.$VJ="workbench.panel.output",e.$WJ=new C.$fj("inOutput",!1),e.$XJ=new C.$fj("activeLogOutput",!1),e.$YJ=new C.$fj("outputView.scrollLock",!1),e.$ZJ=(0,F.$1h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$1J={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$rn.add(e.$1J.OutputChannels,new m),e.$2J=new C.$fj("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,277,63,27,43,135,24,16,42,5,6]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=void 0;class t extends R.$oj{get disposed(){return this.n}constructor(h,i,r,u,d){super(),this.id=h,this.name=i,this.r=r,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ge.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let o=class{constructor(h,i,r,u,d,b){this.i=i,this.j=r,this.k=u,this.l=d,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$FK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,r]of this.g)r.visible=i===this.h}createOutputChannel(h,i,r){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,$.$Df)(i)?i:void 0;if((0,$.$Df)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const f=this.i.environment.extensionLogLevel?.find(([L])=>F.$em.equals(r.identifier,L))?.[1];f&&(b=(0,R.$yj)(f));const D=u?this.o(h,b,r):this.n(h,d,r);return D.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),u?this.r(h,b??this.m.getLevel(),D):this.q(h,D)}async n(h,i,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,r.identifier.value);return new t(f,h,b,this.a,r)}async o(h,i,r){const u=await this.p(r),d=h.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(u,`${d}.log`),f=`${r.identifier.value}.${d}`,D=this.l.createLogger(b,{id:f,name:h,logLevel:i,extensionId:r.identifier.value});return new n(f,h,D,this.a,r)}p(h){let i=this.d.get(h.identifier.value);if(!i){const r=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(r)}catch(u){if((0,v.$zk)(u)!==v.FileSystemProviderErrorCode.FileExists)throw u}return r})())}return i}q(h,i){let r=!1;const u=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(b=>b.append(d))},appendLine(d){u(),i.then(b=>b.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(b=>b.replace(d))},show(d,b){u(),i.then(f=>f.show(d,b))},hide(){u(),i.then(d=>d.hide())},dispose(){r=!0,i.then(d=>d.dispose())}}}r(h,i,r){const u=new s.$Rc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},b=u.add(new a.$Sd);function f(D){i=D,b.fire(D)}return r.then(D=>{u.add(D),D.logLevel!==i&&f(D.logLevel),u.add(D.onDidChangeLogLevel(L=>f(L)))}),{...this.q(h,r),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(D,...L){d(),r.then(p=>p.trace(D,...L))},debug(D,...L){d(),r.then(p=>p.debug(D,...L))},info(D,...L){d(),r.then(p=>p.info(D,...L))},warn(D,...L){d(),r.then(p=>p.warn(D,...L))},error(D,...L){d(),r.then(p=>p.error(D,...L))},dispose(){u.dispose()}}}};e.$sgc=o,e.$sgc=o=He([Ve(0,C.$JM),Ve(1,w.$ZM),Ve(2,g.$ffc),Ve(3,A.$Rec),Ve(4,R.$jj),Ve(5,R.$ij)],o),e.$tgc=(0,T.$1h)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,14]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=void 0,e.$Em=(0,E.$1h)("remoteAgentService"),e.$Fm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let F=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await C.getRoundTripTime();if(g===void 0)return;F=Math.min(F,g/2),await(0,T.$2g)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Ae([1,0,169,54,30,47,41,6,5,113,21,26]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=void 0,e.$uH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$vH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$wH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$xH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const $=new l;C.$rn.add(e.$xH.ConfigurationMigration,$);let v=class extends m.$Sc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(o=>this.g(o,t?.uri))])}async g(t,n){const o=this.a.inspect(t.key,{resource:n}),c=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[h,i]of c){const r=[];for(const d of o.overrideIdentifiers??[]){const b=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of b??[]){let D=r.find(([[L,p]])=>L===f[0]&&(0,k.$jn)(p.value,f[1].value));D||r.push(D=[f,[]]),D[1].push(d)}}const u=await this.h(t,{resource:n},h,o);for(const d of u??[])r.push([d,[]]);r.length&&await Promise.allSettled(r.map(async([[d,b],f])=>this.a.updateValue(d,b.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,o,c){const h=(c??this.a.inspect(t.key,n))[o];if(h===void 0)return;const i=u=>this.a.inspect(u,n)[o],r=await t.migrateFn(h,i);return Array.isArray(r)?r:[[t.key,r]]}};e.$yH=v,e.$yH=v=He([Ve(0,R.$ui),Ve(1,F.$0h)],v);let a=class extends m.$Sc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;C.$rn.as(T.$wn.Configuration).registerConfiguration({...e.$wH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$zH=a,e.$zH=a=He([Ve(0,w.$Em)],a)}),define(Pe[279],Ae([1,0,34,13,19,25,177,278,54,4,30]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcb=e.$Wcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Vcb=e.$Ucb=void 0,e.$Ucb=(0,w.$1h)("editorResolverService"),e.$Vcb="workbench.editorAssociations";const k=A.$rn.as(g.$wn.Configuration),l={...m.$vH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var $;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})($||(e.RegisteredEditorPriority=$={}));var v;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function a(t){switch(t){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$Wcb=a;function s(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(C.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$zg)(n);return E.$Gj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$Xcb=s}),define(Pe[280],Ae([1,0,46,13,19,21,25,2,4,198,47,216,113]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$iK=e.$hK=void 0,e.$hK=(0,g.$1h)("pathService");let v=$=class{constructor(s,t,n,o){this.d=s,this.e=t,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(o=>this.h(s,o,t)):this.h(s,t,n)}h(s,t,n){return s.scheme===T.Schemas.file||s.scheme===T.Schemas.vscodeRemote?(0,E.$1f)(n??(0,R.$zg)(s),t===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,t){if(s.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,w.$eK)(t.getWorkspace());if(n)return n;const o=t.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?C.$fc:C.$gc)}async fileURI(s){let t="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const o=s.indexOf("/",2);o===-1?(t=s.substring(2),s="/"):(t=s.substring(2,o),s=s.substring(o)||"/")}return m.URI.from({scheme:T.Schemas.file,authority:t,path:s,query:"",fragment:""})}};e.$iK=v,e.$iK=v=$=He([Ve(1,l.$Em),Ve(2,k.$3J),Ve(3,A.$0h)],v)}),define(Pe[114],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$WI=e.$VI=void 0;class E{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new E(0,0)}with(R){return new E(0,0)}}e.$VI=E;class T{constructor(R,m,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,m),this.end=new E(g,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$WI=T;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[44],Ae([1,0,18,34,26,46,12,4,19,11,114,14]),function(pe,e,E,T,C,F,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.SearchErrorCode=e.$_I=e.$$I=e.SearchSortOrder=e.ViewMode=e.$0I=e.$9I=e.$8I=e.$7I=e.SearchCompletionExitCode=e.$6I=e.$5I=e.$4I=e.QueryType=e.SearchProviderType=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$XI="workbench.view.search",e.$YI="workbench.panel.search",e.$ZI="workbench.view.search",e.$1I="search-result",e.$2I="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",v=(l.length+$.length+5)*2;e.$3I=(0,m.$1h)("searchService");var a;(function(me){me[me.file=0]="file",me[me.text=1]="text"})(a||(e.SearchProviderType=a={}));var s;(function(me){me[me.File=1]="File",me[me.Text=2]="Text"})(s||(e.QueryType=s={}));function t(me){return!!me.preview}e.$4I=t;function n(me){return!!me.resource}e.$5I=n;function o(me){return!!me.message}e.$6I=o;var c;(function(me){me[me.Normal=0]="Normal",me[me.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(fe){this.resource=fe,this.results=[]}}e.$7I=h;class i{constructor(fe,ne,Se,ce){this.ranges=ne,this.webviewIndex=ce;const X=Array.isArray(ne)?ne:[ne];if(Se&&Se.matchLines===1&&r(X)){fe=(0,R.$wf)(fe,Se.matchLines);let V="",re=0,Ie=0;const Re=Math.floor(Se.charsPerLine/5),Ce=[];for(const le of X){const ie=Math.max(le.startColumn-Re,0),G=le.startColumn+Se.charsPerLine;if(ie>Ie+Re+v){const te=l+(ie-Ie)+$;V+=te+fe.slice(ie,G),re+=ie-(Ie+te.length)}else V+=fe.slice(Ie,G);Ce.push(new d(0,le.startColumn-re,le.endColumn-re)),Ie=G}this.preview={text:V,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const V=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:fe,matches:(0,E.$2b)(ne,re=>new u(re.startLineNumber-V,re.startColumn,re.endLineNumber-V,re.endColumn))}}}}e.$8I=i;function r(me){const fe=me[0].startLineNumber;for(const ne of me)if(ne.startLineNumber!==fe||ne.endLineNumber!==fe)return!1;return!0}class u{constructor(fe,ne,Se,ce){this.startLineNumber=fe,this.startColumn=ne,this.endLineNumber=Se,this.endColumn=ce}}e.$9I=u;class d extends u{constructor(fe,ne,Se){super(fe,ne,fe,Se)}}e.$0I=d;var b;(function(me){me.List="list",me.Tree="tree"})(b||(e.ViewMode=b={}));var f;(function(me){me.Default="default",me.FileNames="fileNames",me.Type="type",me.Modified="modified",me.CountDescending="countDescending",me.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function D(me,fe=!0){const ne=me&&me.files&&me.files.exclude,Se=fe&&me&&me.search&&me.search.exclude;if(!ne&&!Se)return;if(!ne||!Se)return ne||Se;let ce=Object.create(null);return ce=C.$in(ce,C.$fn(ne)),ce=C.$in(ce,C.$fn(Se),!0),ce}e.$$I=D;function L(me,fe){return me.excludePattern&&T.$Gj(me.excludePattern,fe)?!1:me.includePattern||me.usingSearchPaths?me.includePattern&&T.$Gj(me.includePattern,fe)?!0:me.usingSearchPaths?!!me.folderQueries&&me.folderQueries.some(ne=>{const Se=ne.folder.fsPath;if(F.$3f(fe,Se)){const ce=g.$lc(Se,fe);return!ne.includePattern||!!T.$Gj(ne.includePattern,ce)}else return!1}):!1:!0}e.$_I=L;var p;(function(me){me[me.unknownEncoding=1]="unknownEncoding",me[me.regexParseError=2]="regexParseError",me[me.globParseError=3]="globParseError",me[me.invalidLiteral=4]="invalidLiteral",me[me.rgProcessError=5]="rgProcessError",me[me.other=6]="other",me[me.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class y extends Error{constructor(fe,ne){super(fe),this.code=ne}}e.$aJ=y;function S(me){const fe=me.message;if((0,w.$4)(me))return new y(fe,p.canceled);try{const ne=JSON.parse(fe);return new y(ne.message,ne.code)}catch{return new y(fe,p.other)}}e.$bJ=S;function N(me){const fe={message:me.message,code:me.code};return new Error(JSON.stringify(fe))}e.$cJ=N;function q(me){return me.type==="error"?!0:me.type==="success"}e.$dJ=q;function j(me){return me.type==="success"}e.$eJ=j;function M(me){return!!me.path}e.$fJ=M;function U(me,fe){const ne=me.searchPath?me.searchPath:me.relativePath;return(0,R.$tf)(ne,fe)}e.$gJ=U;class P{constructor(fe){this.path=fe,this.results=[]}addMatch(fe){this.results.push(fe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$hJ=P;function I(me,fe){const ne={...me||{},...fe||{}};return Object.keys(ne).filter(Se=>{const ce=ne[Se];return typeof ce=="boolean"&&ce})}e.$iJ=I;class Z{constructor(fe,ne){this.c=null,this.a={...fe.excludePattern||{},...ne.excludePattern||{}},this.b=T.$Hj(this.a);let Se=fe.includePattern;ne.includePattern&&(Se?Se={...Se,...ne.includePattern}:Se=ne.includePattern),Se&&(this.c=T.$Hj(Se))}matchesExcludesSync(fe,ne,Se){return!!(this.b&&this.b(fe,ne,Se))}includedInQuerySync(fe,ne,Se){return!(this.b&&this.b(fe,ne,Se)||this.c&&!this.c(fe,ne,Se))}includedInQuery(fe,ne,Se){const ce=this.b(fe,ne,Se),X=()=>this.c?!!this.c(fe,ne,Se):!0;return(0,k.$Ng)(ce)?ce.then(V=>V?!1:X()):X()}hasSiblingExcludeClauses(){return ue(this.a)}}e.$jJ=Z;function ue(me){for(const fe in me)if(typeof me[fe]!="boolean")return!0;return!1}function ge(me){if(!me)return;let fe;return ne=>(fe||(fe=(me()||Promise.resolve([])).then(Se=>Se?ke(Se):{})),fe.then(Se=>!!Se[ne]))}e.$kJ=ge;function be(me){if(!me)return;let fe;return ne=>{if(!fe){const Se=me();fe=Se?ke(Se):{}}return!!fe[ne]}}e.$lJ=be;function ke(me){const fe={};for(const ne of me)fe[ne]=!0;return fe}}),define(Pe[36],Ae([1,0,18,14,20,5,6,50,13,121,25,12,2,168,4,15,187,47,43,27,17,8,7,57,44,3,51]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r,u,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=void 0;function f(j,M,U){return new A.$rg(P=>y(P,U)).isEqual(j,M)}function D(j,M,U){return f(j.uri,M.uri,U)?0:(0,k.$Ze)(j.uri.toString(),M.uri.toString())}function L(j,M,U){return j.index!==M.index?j.index<M.index?-1:1:f(j.uri,M.uri,U)?(0,k.$Ze)(j.name,M.name):(0,k.$Ze)(j.uri.toString(),M.uri.toString())}function p(j,M,U,P){const I=j.slice(0).sort((ue,ge)=>U(ue,ge,P)),Z=M.slice(0).sort((ue,ge)=>U(ue,ge,P));return(0,E.$Eb)(I,Z,(ue,ge)=>U(ue,ge,P))}function y(j,M){const U=M.getCapabilities(j.scheme);return!(U&&U&1024)}class S extends t.$hi{static toExtHostWorkspace(M,U,P,I){if(!M)return{workspace:null,added:[],removed:[]};const{id:Z,name:ue,folders:ge,configuration:be,transient:ke,isUntitled:me}=M,fe=[],ne=U;U?ge.forEach((V,re)=>{const Ie=l.URI.revive(V.uri),Re=S.o(P||U,Ie,I);Re?(Re.name=V.name,Re.index=V.index,fe.push(Re)):fe.push({uri:Ie,name:V.name,index:re})}):fe.push(...ge.map(({uri:V,name:re,index:Ie})=>({uri:l.URI.revive(V),name:re,index:Ie}))),fe.sort((V,re)=>V.index<re.index?-1:1);const Se=new S(Z,ue,fe,!!ke,be?l.URI.revive(be):null,!!me,V=>y(V,I)),{added:ce,removed:X}=p(ne?ne.workspaceFolders:[],Se.workspaceFolders,D,I);return{workspace:Se,added:ce,removed:X}}static o(M,U,P){for(let I=0;I<M.folders.length;I++){const Z=M.workspaceFolders[I];if(f(Z.uri,U,P))return Z}}constructor(M,U,P,I,Z,ue,ge){super(M,P.map(be=>new t.$ii(be)),I,Z,ge),this.t=U,this.u=ue,this.q=[],this.s=m.$7h.forUris(ge),P.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,U){return U&&this.s.get(M)&&(M=(0,A.$Bg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let N=class{constructor(M,U,P,I,Z){this.c=new F.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Ud,this.B=new Map,this.h=I,this.s=P,this.t=Z,this.j=new w.$2l,this.k=new T.$Zg,this.o=M.getProxy(d.$FK.MainThreadWorkspace),this.q=M.getProxy(d.$FK.MainThreadMessageService);const ue=U.workspace;this.l=ue?new S(ue.id,ue.name,[],!!ue.transient,ue.configuration?l.URI.revive(ue.configuration):null,!!ue.isUntitled,ge=>y(ge,P)):void 0}$initializeWorkspace(M,U){this.v=U,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$zg)((0,A.$Bg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,U,P,...I){const Z=[];if(Array.isArray(I)&&I.forEach(me=>{l.URI.isUri(me.uri)&&!Z.some(fe=>f(fe.uri,me.uri,this.s))&&Z.push({uri:me.uri,name:me.name||(0,A.$yg)(me.uri)})}),this.n||[U,P].some(me=>typeof me!="number"||me<0)||P===0&&Z.length===0)return!1;const ue=this.x?this.x.workspaceFolders:[];if(U+P>ue.length)return!1;const ge=ue.slice(0);ge.splice(U,P,...Z.map(me=>({uri:me.uri,name:me.name||(0,A.$yg)(me.uri),index:void 0})));for(let me=0;me<ge.length;me++){const fe=ge[me];if(ge.some((ne,Se)=>Se!==me&&f(fe.uri,ne.uri,this.s)))return!1}ge.forEach((me,fe)=>me.index=fe);const{added:be,removed:ke}=p(ue,ge,L,this.s);if(be.length===0&&ke.length===0)return!1;if(this.o){const me=M.displayName||M.name;this.o.$updateWorkspaceFolders(me,U,P,Z).then(void 0,fe=>{this.n=void 0;const ne={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(s.Severity.Error,(0,$.localize)(0,null,me,fe.toString()),ne,[])})}return this.y(ge),!0}getWorkspaceFolder(M,U){if(this.x)return this.x.getWorkspaceFolder(M,U)}async getWorkspaceFolder2(M,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,U)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,U){let P,I="";if(typeof M=="string"?(P=l.URI.file(M),I=M):typeof M<"u"&&(P=M,I=M.fsPath),!P)return I;const Z=this.getWorkspaceFolder(P,!0);if(!Z)return I;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ue=(0,A.$Eg)(Z.uri,P);return U&&Z.name&&(ue=`${Z.name}/${ue}`),ue}y(M){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:U,added:P,removed:I}=S.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:I}))}findFiles(M,U,P,I,Z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${I.value}, entryPoint: findFiles`);let ue;if(U===null?ue=!1:U&&(typeof U=="string"?ue=U:ue=U.pattern),Z&&Z.isCancellationRequested)return Promise.resolve([]);const{includePattern:ge,folder:be}=q(h.GlobPattern.from(M));return this.o.$startFileSearch(ge??null,be??null,ue??null,P??null,Z).then(ke=>Array.isArray(ke)?ke.map(me=>l.URI.revive(me)):[])}async findTextInFiles(M,U,P,I,Z=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${I.value}, entryPoint: findTextInFiles`);const ue=this.j.getNext(),ge=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:be,folder:ke}=q(h.GlobPattern.from(U.include)),me=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,fe={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ge,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:be,excludePattern:me},ne=!1;if(this.u[ue]=Se=>{if(ne)return;const ce=l.URI.revive(Se.resource);Se.results.forEach(X=>{const V=(0,b.$xh)(X);(0,u.$4I)(V)?P({uri:ce,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,re=>new i.$JK(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,E.$2b)(V.ranges,re=>new i.$JK(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):P({uri:ce,text:V.text,lineNumber:V.lineNumber})})},Z.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(M,ke??null,fe,ue,Z);return delete this.u[ue],Se||{}}catch(Se){throw delete this.u[ue],Se}}$handleTextSearchResult(M,U){this.u[U]?.(M)}async save(M){const U=await this.o.$save(M,{saveAs:!1});return l.URI.revive(U)}async saveAs(M){const U=await this.o.$save(M,{saveAs:!0});return l.URI.revive(U)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,U){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,U);const P=this.t.transformOutgoingScheme(M),I=this.z++;return this.o.$registerEditSessionIdentityProvider(I,P),(0,R.$Qc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(I)})}async $getEditSessionIdentifier(M,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const P=await this.resolveWorkspaceFolder(l.URI.revive(M));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const I=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!I),!I)return;const Z=await I.provideEditSessionIdentity(P,U);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(M,U,P,I){this.h.info("Getting edit session identifier for workspaceFolder",M);const Z=await this.resolveWorkspaceFolder(l.URI.revive(M));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const ue=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!ue),!ue)return;const ge=await ue.provideEditSessionIdentityMatch?.(U,P,I);if(this.h.info("Provider returned edit session identifier match result: ",ge),!!ge)return ge}getOnWillCreateEditSessionIdentityEvent(M){return(U,P,I)=>{const Z=function(ge){U.call(P,ge)};return Z.extension=M,this.A.event(Z,void 0,I)}}async $onWillCreateEditSessionIdentity(M,U,P){const I=await this.resolveWorkspaceFolder(l.URI.revive(M));if(I===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:I},U,async(Z,ue)=>{const ge=Date.now();await Promise.resolve(Z),Date.now()-ge>P&&this.h.warn("SLOW edit session create-participant",ue.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(M,U){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,U);const P=this.t.transformOutgoingScheme(M),I=this.z++;return this.o.$registerCanonicalUriProvider(I,P),(0,R.$Qc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(I)})}async provideCanonicalUri(M,U,P){const I=this.B.get(M.scheme);if(!I)return;const Z=await I.provideCanonicalUri?.(l.URI.revive(M),U,P);if(Z)return Z}async $provideCanonicalUri(M,U,P){return this.provideCanonicalUri(l.URI.revive(M),{targetScheme:U},P)}};e.$_ec=N,e.$_ec=N=He([Ve(0,c.$JM),Ve(1,o.$ZM),Ve(2,n.$Rec),Ve(3,a.$ij),Ve(4,r.$0ec)],N),e.$afc=(0,v.$1h)("IExtHostWorkspace");function q(j){let M,U;return j&&(typeof j=="string"?M=j:(M=j.pattern,U=l.URI.revive(j.baseUri))),{includePattern:M,folder:U}}}),define(Pe[37],Ae([1,0,26,5,36,3,7,189,54,16,14,4,17,15,2]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=e.$bfc=void 0;function a(r,u){if(u){const d=u.split(".");let b=r;for(let f=0;b&&f<d.length;f++)b=b[d[f]];return b}}function s(r){return r instanceof v.URI}function t(r){return r&&r.uri instanceof v.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof v.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function c(r){if(s(r))return{resource:r};if(t(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let h=class{constructor(u,d,b){this.a=u.getProxy(F.$FK.MainThreadConfiguration),this.c=d,this.b=b,this.d=new A.$Zg,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(u,d))}};e.$bfc=h,e.$bfc=h=He([Ve(0,l.$JM),Ve(1,C.$afc),Ve(2,$.$ij)],h);class i{constructor(u,d,b,f){this.a=new T.$Sd,this.b=u,this.f=f,this.c=d,this.e=m.$Pn.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Pn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,b))}getConfiguration(u,d,b){const f=c(d)||{},D=this.g(u?a(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,b?.identifier);function L(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(y){return typeof a(D,y)<"u"},get:(y,S)=>{this.h(u?`${u}.${y}`:y,f,b?.identifier);let N=a(D,y);if(typeof N>"u")N=S;else{let q;const j=(M,U)=>{if((0,w.$Ff)(M)){let P;const I=()=>{q=q||(0,E.$fn)(D),P=P||a(q,U)};return new Proxy(M,{get:(Z,ue)=>{if(typeof ue=="string"&&ue.toLowerCase()==="tojson")return I(),()=>P;if(q)return P=P||a(q,U),P[ue];const ge=Z[ue];return typeof ue=="string"?j(ge,`${U}.${ue}`):ge},set:(Z,ue,ge)=>(I(),P&&(P[ue]=ge),!0),deleteProperty:(Z,ue)=>(I(),P&&delete P[ue],!0),defineProperty:(Z,ue,ge)=>(I(),P&&Object.defineProperty(P,ue,ge),!0)})}return Array.isArray(M)?(0,E.$fn)(M):M};N=j(N,y)}return N},update:(y,S,N,q)=>{y=u?`${u}.${y}`:y;const j=L(N);return S!==void 0?this.b.$updateConfigurationOption(j,y,S,f,q):this.b.$removeConfigurationOption(j,y,f,q)},inspect:y=>{y=u?`${u}.${y}`:y;const S=this.e.inspect(y,f,this.c.workspace);if(S)return{key:y,defaultValue:(0,E.$fn)(S.policy?.value??S.default?.value),globalValue:(0,E.$fn)(S.user?.value??S.application?.value),workspaceValue:(0,E.$fn)(S.workspace?.value),workspaceFolderValue:(0,E.$fn)(S.workspaceFolder?.value),defaultLanguageValue:(0,E.$fn)(S.default?.override),globalLanguageValue:(0,E.$fn)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,E.$fn)(S.workspace?.override),workspaceFolderLanguageValue:(0,E.$fn)(S.workspaceFolder?.override),languageIds:(0,E.$fn)(S.overrideIdentifiers)}}};return typeof D=="object"&&(0,E.$in)(p,D,!1),Object.freeze(p)}g(u){const d=b=>(0,w.$Ff)(b)?new Proxy(b,{get:(f,D)=>d(f[D]),set:(f,D,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(f,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(f,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return d(u)}h(u,d,b){const f=g.$Gn.test(u)?4:this.d.get(u),D=b?`[${b.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const b=new m.$Rn(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,D)=>b.affectsConfiguration(f,c(D))})}k(u){return u.reduce((d,b)=>(d.set(b[0],b[1]),d),new Map)}}e.$cfc=i,e.$dfc=(0,k.$1h)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,14,5,3,7,36,61,37,20,64,17,27,4,13,21,15,81,228,11]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=e.$Egc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(j){function M(P){if(P!=null)return P}j.from=M;function U(P){if(P!=null)return P}j.to=U})(h||(h={}));var i;(function(j){function M(P){if(P!=null)return P}j.from=M;function U(P){if(P!=null)return P}j.to=U})(i||(i={}));var r;(function(j){function M(P){if(P!=null)return P}j.from=M;function U(P){if(P!=null)return P}j.to=U})(r||(r={}));var u;(function(j){function M(I){if(I){const Z=I;return Z&&!!Z.process}else return!1}j.is=M;function U(I){if(I==null)return;const Z={process:I.process,args:I.args};return I.options&&(Z.options=r.from(I.options)),Z}j.from=U;function P(I){if(I!=null)return new R.$qL(I.process,I.args,I.options)}j.to=P})(u||(u={}));var d;(function(j){function M(P){if(P!=null)return P}j.from=M;function U(P){if(P!=null)return P}j.to=U})(d||(d={}));var b;(function(j){function M(I){if(I){const Z=I;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}j.is=M;function U(I){if(I==null)return;const Z={};return I.commandLine!==void 0?Z.commandLine=I.commandLine:(Z.command=I.command,Z.args=I.args),I.options&&(Z.options=d.from(I.options)),Z}j.from=U;function P(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new R.$rL(I.commandLine,I.options):new R.$rL(I.command,I.args?I.args:[],I.options)}j.to=P})(b||(b={}));var f;(function(j){function M(I){if(I){const Z=I;return Z&&Z.customExecution==="customExecution"}else return!1}j.is=M;function U(I){return{customExecution:"customExecution"}}j.from=U;function P(I,Z){return Z.get(I)}j.to=P})(f||(e.CustomExecutionDTO=f={}));var D;(function(j){function M(U,P){let I;return U.scope!==void 0&&typeof U.scope!="number"?I=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?I=P.workspaceFile:I=o.$bG),{id:U._id,workspaceFolder:I}}j.from=M})(D||(e.TaskHandleDTO=D={}));var L;(function(j){function M(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}j.from=M})(L||(L={}));var p;(function(j){function M(I,Z){if(I==null)return[];const ue=[];for(const ge of I){const be=U(ge,Z);be&&ue.push(be)}return ue}j.fromMany=M;function U(I,Z){if(I==null)return;let ue;I.execution instanceof R.$qL?ue=u.from(I.execution):I.execution instanceof R.$rL?ue=b.from(I.execution):I.execution&&I.execution instanceof R.$sL&&(ue=f.from(I.execution));const ge=h.from(I.definition);let be;return I.scope?typeof I.scope=="number"?be=I.scope:be=I.scope.uri:be=R.TaskScope.Workspace,!ge||!be?void 0:{_id:I._id,definition:ge,name:I.name,source:{extensionId:Z.identifier.value,label:I.source,scope:be},execution:ue,isBackground:I.isBackground,group:L.from(I.group),presentationOptions:i.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}j.from=U;async function P(I,Z,ue){if(I==null)return;let ge;u.is(I.execution)?ge=u.to(I.execution):b.is(I.execution)?ge=b.to(I.execution):f.is(I.execution)&&(ge=f.to(I._id,ue));const be=h.to(I.definition);let ke;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?ke=I.source.scope:ke=await Z.resolveWorkspaceFolder(E.URI.revive(I.source.scope)):ke=R.TaskScope.Workspace),!be||!ke)return;const me=new R.$tL(be,ke,I.name,I.source.label,ge,I.problemMatchers);return I.isBackground!==void 0&&(me.isBackground=I.isBackground),I.group!==void 0&&(me.group=R.$pL.from(I.group._id),me.group&&I.group.isDefault&&(me.group=new R.$pL(me.group.id,me.group.label),I.group.isDefault===!0&&(me.group.isDefault=I.group.isDefault))),I.presentationOptions&&(me.presentationOptions=i.to(I.presentationOptions)),I._id&&(me._id=I._id),I.detail&&(me.detail=I.detail),me}j.to=P})(p||(e.TaskDTO=p={}));var y;(function(j){function M(P){return P}j.from=M;function U(P){if(P)return Object.assign(Object.create(null),P)}j.to=U})(y||(y={}));class S{#e;constructor(M,U,P){this._id=U,this.a=P,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let N=class{constructor(M,U,P,I,Z,ue,ge,be){this.q=new C.$Sd,this.r=new C.$Sd,this.s=new C.$Sd,this.t=new C.$Sd,this.a=M.getProxy(F.$FK.MainThreadTask),this.b=P,this.c=I,this.d=Z,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,U,P){if(!P)return new R.$HK(()=>{});const I=this.w();return this.j.set(I,{type:U,provider:P,extension:M}),this.a.$registerTaskProvider(I,U),new R.$HK(()=>{this.j.delete(I),this.a.$unregisterTaskProvider(I)})}registerTaskSystem(M,U){this.a.$registerTaskSystem(M,U)}fetchTasks(M){return this.a.$fetchTasks(y.from(M)).then(async U=>{const P=[];for(const I of U){const Z=await p.to(I,this.b,this.m);Z&&P.push(Z)}return P})}get taskExecutions(){const M=[];return this.k.forEach(U=>M.push(U)),M}terminateTask(M){if(!(M instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,U,P){const I=this.m.get(M.id);I&&(this.o.set(M.id,I),this.e.attachPtyToTerminal(U,await I.callback(P))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const U=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const U=await this.y(M.id);this.s.fire({execution:U,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const U=await this.y(M.id);this.t.fire({execution:U,exitCode:M.exitCode})}$provideTasks(M,U){const P=this.j.get(M);if(!P)return Promise.reject(new Error("no handler found"));const I=[],Z=(0,T.$Tg)(()=>P.provider.provideTasks(A.CancellationToken.None)).then(ue=>this.u(U,I,P,ue));return new Promise(ue=>{Z.then(ge=>{Promise.all(I).then(()=>{ue(ge)})})})}async $resolveTask(M,U){const P=this.j.get(M);if(!P)return Promise.reject(new Error("no handler found"));if(U.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${P.type}].`);const I=await p.to(U,this.b,this.m);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const Z=await P.provider.resolveTask(I,A.CancellationToken.None);if(!Z)return;this.z(Z,P);const ue=p.from(Z,P.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ue.execution)&&await this.x(ue,Z,!0),await this.v(ue)}w(){return this.h++}async x(M,U,P){const I=await this.a.$createTaskId(M);!P&&!this.m.has(I)&&(this.n.add(I),this.o.set(I,U.execution)),this.m.set(I,U.execution)}async y(M,U){if(typeof M=="string"){const Z=this.l.get(M);if(!Z)throw new c.$bb("Unexpected: The specified task is missing an execution");return Z}const P=this.l.get(M.id);if(P)return P;const I=new Promise((Z,ue)=>{function ge(be,ke,me){me?Z(new S(be,ke.id,me)):ue("Unexpected: Task does not exist.")}U?ge(this,M,U):p.to(M.task,this.b,this.m).then(be=>ge(this,M,be))});return this.l.set(M.id,I),I.then(Z=>(this.k.set(M.id,Z),Z),Z=>Promise.reject(Z))}z(M,U){M._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const P=this.n.values();let I=P.next();for(;!I.done;)!this.o.has(I.value)&&this.p!==I.value&&(this.m.delete(I.value),this.n.delete(I.value)),I=P.next()}};e.$Egc=N,e.$Egc=N=He([Ve(0,l.$JM),Ve(1,$.$ZM),Ve(2,m.$afc),Ve(3,g.$UM),Ve(4,w.$dfc),Ve(5,k.$Bfc),Ve(6,t.$ij),Ve(7,n.$Uec)],N);let q=class extends N{constructor(M,U,P,I,Z,ue,ge,be){super(M,U,P,I,Z,ue,ge,be),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(M,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const P=p.from(U,M);if(P===void 0)throw new Error("Task is not valid");if(f.is(P.execution))await this.x(P,U,!1);else throw new c.$_;const I=await this.y(await this.a.$getTaskExecution(P),U);return this.a.$executeTask(P).catch(Z=>{throw new Error(Z)}),I}u(M,U,P,I){const Z=[];if(I)for(const ue of I){if(this.z(ue,P),!ue.definition||!M[ue.definition.type]){const be=ue.source?ue.source:"No task source";this.f.warn(`The task [${be}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=p.from(ue,P.extension);ge&&f.is(ge.execution)?(Z.push(ge),U.push(this.x(ge,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:P.extension}}async v(M){if(f.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,U,P){}};e.$Fgc=q,e.$Fgc=q=He([Ve(0,l.$JM),Ve(1,$.$ZM),Ve(2,m.$afc),Ve(3,g.$UM),Ve(4,w.$dfc),Ve(5,k.$Bfc),Ve(6,t.$ij),Ve(7,n.$Uec)],q),e.$Ggc=(0,v.$1h)("IExtHostTask")}),define(Pe[281],Ae([1,0,44,29]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=void 0;function C(R){return"cellResults"in R}e.$rJ=C,e.$sJ="rawCell#";function F(R,m){let g=-1;const w=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(w.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(l=>{const $=[],v=l[0].range.startLineNumber,a=l[l.length-1].range.endLineNumber;for(let s=v;s<=a;s++)$.push(m.getLineContent(s));return new E.$8I($.join(`
`)+`
`,l.map(s=>new T.$Es(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}e.$tJ=F}),define(Pe[282],Ae([1,0,161,24,5,6,28,12,16,2,42,75,3,32,8,7,49,220,107,11,26,13,211,281,279]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,D,L,p,y,S){this.q=L,this.r=p,this.s=y,this.t=S,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new C.$Sd({onListenerError:o.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Sd({onListenerError:o.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Sd({onListenerError:o.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Sd({onListenerError:o.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Nec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(l.$FK.MainThreadNotebook),this.c=f.getProxy(l.$FK.MainThreadNotebookDocuments),this.d=f.getProxy(l.$FK.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===13){const q=N.notebookEditor?.notebookUri,j=N.cell.handle,U=this.g.get(q)?.getCell(j);if(U)return U.apiCell}if(N&&N.$mid===14){const q=N.uri,j=this.g.get(q);if(j)return j.apiNotebook}return N}}),d.B(D)}getEditorById(f){const D=this.h.get(f);if(!D)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(f){for(const[D,L]of this.h)if(L.apiEditor===f)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,D){const L=this.g.get(f);if(!L&&!D)throw new Error(`NO notebook document for '${f}'`);return L}static u(f,D){if(!D)return;const L=D.filenamePattern.map(p=>v.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(D.filenamePattern&&!L){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:D.displayName,filenamePattern:L,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,D,L){const p=d.a++,y=typeof L.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(p,L),this.b.$registerNotebookCellStatusBarItemProvider(p,y,D);let S;return y!==void 0&&(S=L.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(y))),new a.$HK(()=>{this.f.delete(p),this.b.$unregisterNotebookCellStatusBarItemProvider(p,y),S?.dispose()})}async createNotebookDocument(f){const D=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&v.NotebookData.from(f.content)});return w.URI.revive(D)}async openNotebookDocument(f){const D=this.g.get(f);if(D)return D.apiNotebook;const L=await this.c.$tryOpenNotebook(f),p=this.g.get(w.URI.revive(L));return(0,g.$Of)(p?.apiNotebook)}async showNotebookDocument(f,D){w.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let L;typeof D=="object"?L={position:v.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(v.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:L={preserveFocus:!1};const p=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,L),y=p&&this.h.get(p)?.apiEditor;if(y)return y;throw p?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,D,L,p){const y=this.f.get(f),S=w.URI.revive(D),N=this.g.get(S);if(!N||!y)return;const q=N.getCellFromIndex(L);if(!q)return;const j=await y.provideCellStatusBarItems(q.apiCell,p);if(!j)return;const M=new F.$Rc,U=this.p.add([M]),I=(Array.isArray(j)?j:[j]).map(Z=>v.NotebookStatusBarItem.from(Z,this.i,M));return{cacheId:U,items:I}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,D,L,p,y){if((0,m.$Ge)(D))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:D,serializer:L,options:p}),this.b.$registerNotebookSerializer(S,{id:f.identifier,location:f.extensionLocation},D,v.NotebookDocumentContentOptions.from(p),d.u(f,y)),(0,F.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(f,D,L){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.deserializeNotebook(D.buffer,L);return new s.$Cv(v.NotebookData.from(y))}async $notebookToData(f,D,L){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.serializeNotebook(v.NotebookData.to(D.value),L);return T.$ge.wrap(y)}async $saveNotebook(f,D,L,p,y){const S=w.URI.revive(D),N=this.x.get(f);if(!N)throw new Error("NO serializer found");const q=this.g.get(S);if(!q)throw new Error("Document NOT found");if(q.versionId!==L)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new A.$Ek((0,E.localize)(0,null,this.z(S)),6);await this.y(S,p);const j={metadata:(0,c.$nn)(q.apiNotebook.metadata,Z=>!(N.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of q.apiNotebook.getCells()){const ue=new a.$7L(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,N.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);ue.metadata=(0,c.$nn)(Z.metadata,ge=>!(N.options?.transientCellMetadata??{})[ge]),j.cells.push(ue)}const M=await N.serializer.serializeNotebook(j,y);await this.s.value.writeFile(S,M);const U=this.s.getFileSystemProviderExtUri(S.scheme),P=await this.s.value.stat(S);return{name:U.basename(S),isFile:(P.type&A.FileType.File)!==0,isDirectory:(P.type&A.FileType.Directory)!==0,isSymbolicLink:(P.type&A.FileType.SymbolicLink)!==0,mtime:P.mtime,ctime:P.ctime,size:P.size,readonly:!!((P.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((P.permissions??0)&A.FilePermission.Locked),etag:A.$Pk({mtime:P.mtime,size:P.size}),children:void 0}}async $searchInNotebooks(f,D,L,p,y){const S=this.x.get(f)?.serializer;if(!S)return{limitHit:!1,results:[]};const N=new R.$Bc;await(async(P,I,Z)=>{await Promise.all(P.map(async ue=>await Promise.all(ue.filenamePatterns.map(ge=>{const be={...Z,type:1,filePattern:ge};return this.t.doInternalFileSearchWithCustomCallback(be,I,ke=>{ke.forEach(me=>{N.has(me)||p.some(ne=>ue.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(Se=>(0,u.$Xcb)(Se,me)))||N.add(me)})})}))))})(L,y,D);const j=new R.$Ac;let M=!1;const U=Array.from(N).map(async P=>{const I=[];try{if(y.isCancellationRequested)return;if(D.maxResults&&[...j.values()].reduce((be,ke)=>be+ke.cellResults.length,0)>D.maxResults){M=!0;return}const Z=[],ue=this.g.get(P);if(ue)ue.apiNotebook.getCells().forEach(ke=>Z.push({input:ke.document.getText(),outputs:ke.outputs.flatMap(me=>me.items.map(fe=>fe.data.toString()))}));else{const be=await this.s.value.readFile(P),ke=T.$ge.fromString(be.toString()),me=await S.deserializeNotebook(ke.buffer,y);if(y.isCancellationRequested)return;v.NotebookData.from(me).cells.forEach(ne=>Z.push({input:ne.source,outputs:ne.outputs.flatMap(Se=>Se.items.map(ce=>ce.valueBytes.toString()))}))}if(y.isCancellationRequested)return;Z.forEach((be,ke)=>{const me=D.contentPattern.pattern,fe=new i.$QPb(be.input,void 0,be.outputs),ne=fe.findInInputs(me),Se=fe.findInOutputs(me),ce=Se.flatMap(X=>(0,r.$tJ)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(ne.length>0||Se.length>0){const X={index:ke,contentResults:(0,r.$tJ)(ne,fe.inputTextBuffer),webviewResults:ce};I.push(X)}});const ge={resource:P,cellResults:I};j.set(P,ge);return}catch{return}});return await Promise.all(U),{limitHit:M,results:[...j.values()]}}async y(f,D){const L=await this.s.value.stat(f);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==A.$Ok&&typeof L.mtime=="number"&&typeof L.size=="number"&&D.mtime<L.mtime&&D.etag!==A.$Pk({mtime:D.mtime,size:L.size}))throw new A.$Ek((0,E.localize)(1,null),3,D)}z(f){return f.scheme===h.Schemas.file?f.fsPath:f.toString()}A(f,D,L){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const p=new n.$0fc(D,this.d,f,L.visibleRanges.map(v.NotebookRange.to),L.selections.map(v.NotebookRange.to),typeof L.viewColumn=="number"?v.ViewColumn.to(L.viewColumn):void 0);this.h.set(D,p)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const L of f.value.removedDocuments){const p=w.URI.revive(L),y=this.g.get(p);y&&(y.dispose(),this.g.delete(p),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(y.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===p.toString()&&this.h.delete(S.id)}if(f.value.addedDocuments){const L=[];for(const p of f.value.addedDocuments){const y=w.URI.revive(p.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const S=new t.$9fc(this.c,this.q,this.r,y,p);L.push(...p.cells.map(N=>t.$8fc.asModelAddData(S.apiNotebook,N))),this.g.get(y)?.dispose(),this.g.set(y,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this.m.fire(S.apiNotebook)}}if(f.value.addedEditors)for(const L of f.value.addedEditors){if(this.h.has(L.id))return;const p=w.URI.revive(L.documentUri),y=this.g.get(p);y&&this.A(y,L.id,L)}const D=[];if(f.value.removedEditors)for(const L of f.value.removedEditors){const p=this.h.get(L);p&&(this.h.delete(L),this.k?.id===p.id&&(this.k=void 0),D.push(p))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(p=>this.h.get(p)).filter(p=>!!p);const L=new Set;this.l.forEach(p=>L.add(p.id));for(const p of this.h.values()){const y=L.has(p.id);p._acceptVisibility(y)}this.l=[...this.h.values()].map(p=>p).filter(p=>p.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const D=$.$8M.String.with("notebookType","A notebook type"),L=new $.$0M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new $.$8M("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>T.$ge.wrap(y))],new $.$9M("Notebook Data",y=>v.NotebookData.to(y.value))),p=new $.$0M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new $.$8M("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new s.$Cv(v.NotebookData.from(y)))],new $.$9M("Bytes",y=>y.buffer));f.registerApiCommand(L),f.registerApiCommand(p)}}e.$ggc=d}),define(Pe[283],Ae([1,0,19,20,40,34,25,60,44]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class w{constructor(l,$,v){this.k=l,this.l=$,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&F.$Hj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&F.$Hj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((v,a)=>{const s=t=>{this.f++,l(t)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),o=E.$nc(n);this.j&&this.j(n,o)||this.v(s,{base:t,basename:o})}),Promise.all($.map(t=>this.p(t,s))).then(t=>{v({limitHit:this.e,stats:t[0]||void 0})},t=>{a(new Error((0,C.$Li)(t)))})})}async p(l,$){const v=new T.$3d,a=this.q(l),s=this.r(),t=new g.$jJ(this.k,l),n=!t.hasSiblingExcludeClauses();let o;try{this.h.add(v),o=m.$Od.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,v.token),h=o.elapsed(),i=m.$Od.create();return this.g&&!this.e||(c&&c.forEach(r=>{const u=E.$gc.relative(l.folder.path,r.path);if(n){const d=E.$nc(r.path);this.v($,{base:l.folder,relativePath:u,basename:d});return}this.s(s,l.folder,u,$)}),this.g&&!this.e)?null:(this.u(s,t,$),{providerTime:h,postProcessTime:i.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(l){const $=(0,g.$iJ)(this.k.includePattern,l.includePattern),v=(0,g.$iJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,v,a){if(v===this.a){const t=E.$nc(this.a);this.v(a,{base:$,relativePath:this.a,basename:t})}function s(t){const n=E.$nc(t),o=E.$mc(t);let c=l[o];c||(c=l[o]=[],s(o)),c.push({base:$,relativePath:t,basename:n})}s(v)}u({rootEntries:l,pathToEntries:$},v,a){const s=this,t=this.a;function n(o){const c=(0,g.$lJ)(()=>o.map(h=>h.basename));for(let h=0,i=o.length;h<i;h++){const r=o[h],{relativePath:u,basename:d}=r;if(v.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const b=$[u];if(b)n(b);else{if(u===t)continue;s.v(a,r)}if(s.e)break}}n(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,v,a){const s=this.c(l.cacheKey),t=new w(l,$,s&&s.token);let n=0;const o=c=>{n+=c.length,v(c.map(h=>this.d(h)))};return this.e(t,A.a,o,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Cg(l.base,l.relativePath)}:{resource:l.base}}e(l,$,v,a){const s=a.onCancellationRequested(()=>{l.cancel()}),t=o=>{o&&(n.push(o),$>0&&n.length>=$&&(v(n),n=[]))};let n=[];return l.search(t).then(o=>(n.length&&v(n),s.dispose(),o),o=>(n.length&&v(n),s.dispose(),Promise.reject(o)))}}e.$$fc=A}),define(Pe[284],Ae([1,0,18,245,34,95,28,13,19,25,12,16,2,94,179,41,15,47,105,280,44]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kK=e.$jK=void 0;let h=class{constructor(y,S,N,q,j){this.a=y,this.b=S,this.c=N,this.d=q,this.e=j}text(y,S,N={}){y=this.f(y,N);const q=this.a.getValue(),j=S&&S.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(S?.map(t.$ji),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:q.search.usePCRE2||j||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,S){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const q={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,S)&&(q.isCaseSensitive=!0),this.k(y)&&(q.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),q}file(y,S={}){return{...this.h(y,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(y,S){return y?(y=Array.isArray(y)?y.map(b):b(y),S?this.parseSearchPaths(y):{pattern:r(...Array.isArray(y)?y:[y])}):{}}h(y=[],S={}){const N=this.g(S.includePattern,S.expandPatterns),q=this.g(S.excludePattern,S.expandPatterns),j=y.length>1,M=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(I=>this.q(I,S,q)):y.map(I=>this.r(I,S,q,j))).filter(I=>!!I),U={_reason:S._reason,folderQueries:M,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:q.pattern,includePattern:N.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const I=E.$Hb(E.$Rb(this.c.groups.map(ge=>ge.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(I));const Z=I.filter(ge=>(0,c.$_I)(U,ge.fsPath)),ue=this.i(Z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ue)),{...U,...ue}}const P=S.extraFileResources&&S.extraFileResources.filter(I=>(0,c.$_I)(U,I.fsPath));return U.extraFileResources=P&&P.length?P:void 0,U}i(y){const S=[],N=new R.$Ac,q={};let j=!1;return y.forEach(M=>{if(M.scheme===m.Schemas.walkThrough)return;if((0,w.$Gg)(M)){const P=this.b.getWorkspaceFolder(M)?.uri??M.with({path:g.$mc(M.fsPath)});let I=N.get(P);I||(j=!0,I={folder:P,includePattern:{}},S.push(I),N.set(P,I));const Z=g.$lc(P.fsPath,M.fsPath);(0,k.$Of)(I.includePattern)[Z.replace(/\\/g,"/")]=!0}else M.fsPath&&(j=!0,q[M.fsPath]=!0)}),{folderQueries:S,includePattern:q,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(y,S){if(S.isSmartCase){if(y.isRegExp){if(A.$uf(y.pattern,!0))return!0}else if(A.$uf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,$.$IB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const S=ue=>g.$ic(ue)||/^\.\.?([\/\\]|$)/.test(ue),q=(Array.isArray(y)?y:u(y)).map(ue=>{const ge=this.e.resolvedUserHome;return ge?(0,F.$Hv)(ue,ge.scheme===m.Schemas.file?ge.fsPath:ge.path):ue}),j=T.$K(q,ue=>S(ue)?"searchPaths":"exprSegments"),M=(j.exprSegments||[]).map(ue=>A.$Pe(ue,"/")).map(ue=>A.$Pe(ue,"\\")).map(ue=>(ue[0]==="."&&(ue="*"+ue),d(ue))),U={},P=this.m(j.searchPaths||[]);P&&P.length&&(U.searchPaths=P);const I=E.$Rb(M),Z=r(...I);return Z&&(U.pattern=Z),U}l(y,S){return S.disregardExcludeSettings?void 0:(0,c.$$I)(y,!S.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const S=y.flatMap(q=>{let{pathPortion:j,globPortion:M}=i(q);return M&&(M=f(M)),this.n(j).flatMap(P=>this.o(P,M))}),N=new Map;return S.forEach(q=>{const j=q.searchPath.toString(),M=N.get(j);M?q.pattern&&(M.pattern=M.pattern||{},M.pattern[q.pattern]=!0):N.set(j,{searchPath:q.searchPath,pattern:q.pattern?r(q.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$ic(y)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==m.Schemas.file?[{searchPath:S[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(y=b(y),y.startsWith("../")||y===".."){const q=g.$gc.resolve(S.path,y);return[{searchPath:S.with({path:q})}]}const N=f(y);return[{searchPath:S,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const S=y.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(j=>{const M=S.match(new RegExp(`^${A.$Ke(j.name)}(?:/(.*)|$)`));return M?{match:M,folder:j}:null}).filter(k.$Lf);if(q.length)return q.map(j=>{const M=j.match[1];return{searchPath:j.folder.uri,pattern:M&&f(M)}});{const j=y.match(/\.[\/\\](.+)[\/\\]?/),M=j?j[1]:y,U=v.localize(0,null,M);throw new Error(U)}}}}o(y,S){const N=y.pattern&&S?`${y.pattern}/${S}`:y.pattern||S,q=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&q.push({searchPath:y.searchPath,pattern:N+"/**"}),q}q(y,S,N){const q=this.r((0,t.$ji)(y.searchPath),S,N,!1);return q?{...q,includePattern:y.pattern}:null}r(y,S,N,q){let j;const M=l.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ue=N.searchPaths.filter(ge=>(0,w.$vg)(ge.searchPath,M))[0];if(ue&&!ue.pattern)return null;ue&&(j=ue.pattern)}const U=this.a.getValue({resource:M}),I={...this.l(U,S)||{},...j||{}},Z=l.URI.isUri(y)?(0,w.$zg)(y):y.name;return{folder:M,folderName:q?Z:void 0,excludePattern:Object.keys(I).length>0?I:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!U.search.followSymlinks}}};e.$jK=h,e.$jK=h=He([Ve(0,a.$ui),Ve(1,t.$0h),Ve(2,n.$NC),Ve(3,s.$ij),Ve(4,o.$hK)],h);function i(p){const y=p.match(/[\*\{\}\(\)\[\]\?]/);if(y){const S=y.index,N=p.substr(0,S).match(/[/|\\][^/\\]*$/);if(N){let q=p.substr(0,N.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:p.substr((N.index||0)+1)}}}return{pathPortion:p}}function r(...p){return p.length?p.reduce((y,S)=>(y[S]=!0,y),Object.create(null)):void 0}function u(p){return C.$Fj(p,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(p){return[`**/${p}/**`,`**/${p}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function b(p){return p.replace(/\\/g,"/")}function f(p){return b(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(p){return p.replace(/([?*[\]])/g,"[$1]")}function L(p,y){p=E.$Mb(p,q=>q.toString());const S=[],N=y.getWorkspace();return p&&p.forEach(q=>{let j;if(y.getWorkbenchState()===2)j=(0,w.$Eg)(N.folders[0].uri,q),j&&j!=="."&&(j="./"+j);else{const M=y.getWorkspaceFolder(q);if(M){const U=M.name;if(N.folders.filter(I=>I.name===U).length===1){const I=(0,w.$Eg)(M.uri,q);I===""?j=`./${M.name}`:j=`./${M.name}/${I}`}else j=q.fsPath}}j&&S.push(D(j))}),S}e.$kK=L}),define(Pe[285],Ae([1,0,25,2,20,11,4,284,44,47]),function(pe,e,E,T,C,F,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3rb=e.$2rb=void 0;const A=7e3;function k(a,s){const t=s.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],o=[];for(const d of t)if(/^workspaceContains:/.test(d)){const b=d.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||a.forceUsingSearch?o.push(b):n.push(b)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,b)=>{c=d}),i=d=>c({activationEvent:d}),r=Promise.all(n.map(d=>l(a,d,i))).then(()=>{}),u=$(a,s.identifier,o,i);return Promise.all([r,u]).then(()=>{c(void 0)}),h}e.$2rb=k;async function l(a,s,t){for(const n of a.folders)if(await a.exists(E.$Cg(T.URI.revive(n),s))){t(`workspaceContains:${s}`);return}}async function $(a,s,t,n){if(t.length===0)return Promise.resolve(void 0);const o=new C.$3d,c=a.checkExists(a.folders,t,o.token),h=setTimeout(async()=>{o.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(r){F.$4(r)||F.$1(r)}o.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function v(a,s,t,n){const o=a.get(R.$Zh),c=a.get(g.$3I),i=o.createInstance(m.$jK).file(s.map(r=>(0,w.$ji)(T.URI.revive(r))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(r=>!!r.limitHit,r=>F.$4(r)?!1:Promise.reject(r))}e.$3rb=v}),define(Pe[38],Ae([1,0,158,19,88,25,14,6,50,2,15,3,37,217,85,36,23,106,11,22,24,200,7,100,4,27,86,17,71,87,64,5,285,84,202,13,82,60,21,83]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r,u,d,b,f,D,L,p,y,S,N,q,j,M,U,P,I){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=e.$Ofc=e.$Nfc=e.$Mfc=void 0,e.$Mfc=(0,u.$1h)("IHostUtils");let ue=Z=class extends m.$Sc{constructor(X,V,re,Ie,Re,Ce,le,ie,G,te,x,se){super(),this.X=se,this.a=this.B(new y.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=re,this.f=le,this.j=Ie,this.m=Re,this.s=Ce,this.t=G,this.u=te,this.w=x,this.y=this.g.getProxy(k.$FK.MainThreadWorkspace),this.z=this.g.getProxy(k.$FK.MainThreadTelemetry),this.C=this.g.getProxy(k.$FK.MainThreadExtensionService),this.D=new R.$Zg,this.F=new R.$Zg,this.G=new R.$Zg,this.H=new R.$Zg,this.I=new Se(this.f.extensions.activationEvents),this.L=new t.$Z6b(this.I,this.f.extensions.allExtensions);const de=new o.$fm(this.f.extensions.myExtensions);this.J=new t.$Z6b(this.I,fe(this.L,de)),P.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new v.$xfc(this.g,this.s),this.N=new N.$Ffc(this.g),this.O=ie,this.h=X.createChild(new D.$Yh([v.$yfc,this.M],[N.$Gfc,this.N])),this.P=this.B(new $.$wfc(this.J,this.L,{onExtensionActivationError:(De,Le,O)=>{this.C.$onExtensionActivationError(De,n.$3(Le),O)},actualActivateExtension:async(De,Le)=>{if(t.$Z6b.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,Le),new $.$vfc;const O=this.J.getExtensionDescription(De);return this.db(O,Le)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){n.$1(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Re=>Re.identifier).filter(Re=>this.isActivated(Re)).map(Re=>this.cb(Re))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const re=this.Y();Promise.race([(0,R.$2g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new o.$em(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(X,V){return this.P.activateByEvent(X,V)}$(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.$(X,V).then(()=>{const re=this.P.getActivatedExtension(X);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===j.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(X.fsPath);return w.URI.file(V)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new ne(X))),this.Q}async bb(X){const V=g.$7h.forUris(re=>F.$tg.ignorePathCasing(re));return await Promise.all(X.map(async re=>{if(this.ub(re)){const Ie=await this.ab(re.extensionLocation);V.set(Ie,re)}})),V}cb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const re=this.P.getActivatedExtension(X);if(!re)return V;try{typeof re.module.deactivate=="function"&&(V=Promise.resolve(re.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(Ie)}try{(0,m.$Nc)(re.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(Ie)}return V}async db(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,V).then(re=>{const Ie=re.activationTimes;return this.C.$onDidActivateExtension(X.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(X,V,"success",Ie),re},re=>{throw this.eb(X,V,"failure"),re})}eb(X,V,re,Ie){const Re=be(X,V);this.z.$publicLog2("extensionActivationTimes",{...Re,...Ie||{},outcome:re})}fb(X,V){const re=be(X,V);this.z.$publicLog2("activatePlugin",re);const Ie=this.ub(X);if(!Ie)return Promise.resolve(new $.$ufc($.$rfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Re=new $.$sfc(V.startup);return Promise.all([this.vb(X,(0,F.$Cg)(X.extensionLocation,Ie),Re),this.gb(X)]).then(Ce=>(C.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Z.hb(this.s,X.identifier,Ce[0],Ce[1],Re))).then(Ce=>(C.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Ce))}gb(X){const V=new h.$Afc(X,this.M),re=new h.$zfc(X.identifier.value,!1,this.M),Ie=new q.$Hfc(X,this.N),Re=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([V.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const le=this;let ie,G;const te=(0,s.$RF)(X,"ipc")?this.f.messagePorts?.get(o.$em.toKey(X.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:re,secrets:Ie,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(x){return T.$jc(X.extensionLocation.fsPath,x)},get storagePath(){return le.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return le.O.globalValue(X).fsPath},get logPath(){return T.$jc(le.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return w.URI.joinPath(le.f.logsLocation,X.identifier.value)},get storageUri(){return le.O.workspaceValue(X)},get globalStorageUri(){return le.O.globalValue(X)},get extensionMode(){return Re},get extension(){return ie===void 0&&(ie=new me(le,X.identifier,X,Ce,!1)),ie},get extensionRuntime(){return(0,s.$SF)(X,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!G){if(!te)return;const x=y.Event.buffer(y.Event.fromDOMEventEmitter(te,"message",se=>se.data));te.start(),G={onDidReceiveMessage:x,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(X,V,re,Ie,Re){return re=re||{activate:void 0,deactivate:void 0},this.ib(X,V,re,Ie,Re).then(Ce=>new $.$tfc(!1,null,Re.build(),re,Ce,Ie.subscriptions))}static ib(X,V,re,Ie,Re){if(typeof re.activate=="function")try{Re.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Ce=typeof global=="object"?global:self,le=re.activate.apply(Ce,[Ie]);return Re.activateCallStop(),Re.activateResolveStart(),Promise.resolve(le).then(ie=>(Re.activateResolveStop(),ie))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(re)}jb(X,V){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,re=>{this.s.error(re)})}kb(X,V=0){const Ie=Date.now();(0,P.$B)(()=>{for(let Re=V;Re<X.length;Re+=1){const Ce=X[Re];for(const le of Ce.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-Ie>50){this.kb(X,Re);break}else this.jb(Ce,le)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(V)this.kb(re);else for(const Ie of re)if(Ie.activationEvents)for(const Re of Ie.activationEvents)Re==="onStartupFinished"&&this.jb(Ie,Re)})}mb(){const X=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const V=this.j.workspace?this.j.workspace.folders:[],re=this.nb(V),Ie=this.pb(),Re=Promise.all([Ie,X,re]).then(()=>{});return Promise.race([Re,(0,R.$2g)(1e4)]).then(()=>{this.lb()}),Re}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(X,V))).then(()=>{})}async ob(X,V){if(this.isActivated(V.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:X.map(Ce=>Ce.uri),forceUsingSearch:re||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,le,ie)=>this.y.$checkExists(Ce,le,ie)},Re=await(0,S.$2rb)(Ie,V);if(Re)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Re.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(E.localize(0,null));const re=await this.vb(null,V,new $.$sfc(!1));if(!re||typeof re.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Re)=>{const Ce=(G,te)=>{G?(P.$t&&this.s.error("Test runner called back with error",G),Re(G)):(P.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof te=="number"&&te>0?1:0))},le=(0,F.$qg)(V),ie=re.run(le,Ce);ie&&ie.then&&ie.then(()=>{P.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(G=>{P.$t&&this.s.error("Test runner finished with error",G),Re(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$2g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.R[X]=V,(0,m.$Qc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.sb(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const V=X.indexOf("+");if(V===-1)throw new i.$NK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=X.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(X,V){const re=U.$Od.create(!1),Ie=()=>`[resolveAuthority(${(0,r.$5k)(X)},${V})][${re.elapsed()}ms] `,Re=J=>this.s.info(`${Ie()}${J}`),Ce=J=>this.s.warn(`${Ie()}${J}`),le=(J,W=void 0)=>this.s.error(`${Ie()}${J}`,W),ie=J=>{if(J instanceof i.$NK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},G=async J=>{Re(`activating resolver for ${J}...`);const{resolver:W,authorityPrefix:Q}=await this.sb(J);if(!W)throw le(`no resolver for ${Q}`),new i.$NK(`No remote extension installed to resolve ${Q}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:W,authorityPrefix:Q,remoteAuthority:J}},te=X.split(/@|%40/g).reverse();Re(`activating remote resolvers ${te.join(" -> ")}`);let x;try{x=await Promise.all(te.map(G)).catch(async J=>{if(!(J instanceof i.$NK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return Ce(`resolving nested authorities failed: ${J.message}`),[await G(X)]})}catch(J){return ie(J)}const se=new R.$_g;se.cancelAndSet(()=>Re("waiting..."),1e3);let de,De;for(const[J,{authorityPrefix:W,resolver:Q,remoteAuthority:_}]of x.entries())try{if(J===x.length-1)Re("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${W}`),de=await Q.resolve(_,{resolveAttempt:V,execServer:De}),C.mark(`code/extHost/didResolveAuthorityOK/${W}`),Re("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,i.$MK.isManagedResolvedAuthority(de)?de:void 0));else{if(Re(`invoking resolveExecServer() for ${_}`),C.mark(`code/extHost/willResolveExecServer/${W}`),De=await Q.resolveExecServer?.(_,{resolveAttempt:V,execServer:De}),!De)throw new i.$NK(`Exec server was not available for ${_}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${W}`)}}catch(ye){return C.mark(`code/extHost/didResolveAuthorityError/${W}`),le("returned an error",ye),se.dispose(),ie(ye)}se.dispose();const Le={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},O={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};Re(`returned ${i.$MK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let K;if(i.$MK.isManagedResolvedAuthority(de)){const J=V;this.X.setFactory(J,de.makeConnection),K={authority:X,connectTo:new r.$2k(J),connectionToken:de.connectionToken}}else K={authority:X,connectTo:new r.$3k(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:K,options:O,tunnelInformation:Le}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$5k)(X)})`);const{resolver:re}=await this.sb(X);if(!re)return null;const Ie=w.URI.revive(V);if(typeof re.getCanonicalURI>"u")return Ie;const Re=await(0,R.$Tg)(()=>re.getCanonicalURI(Ie));return Re||Ie}$startExtensionHost(X){X.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:re}=ge(this.I,this.L,this.J,X);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),P.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(X,V){return V===1?this.D.wait().then(re=>this.Z(X,!1)):this.G.wait().then(re=>this.Z(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:re}=ge(this.I,this.L,this.J,X),Ie=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),P.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=c.$ge.alloc(X),re=Math.random()%256;for(let Ie=0;Ie<X;Ie++)V.writeUInt8(re,Ie);return V}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$Nfc=ue,e.$Nfc=ue=Z=He([Ve(0,u.$Zh),Ve(1,e.$Mfc),Ve(2,f.$JM),Ve(3,a.$afc),Ve(4,l.$dfc),Ve(5,A.$ij),Ve(6,d.$ZM),Ve(7,b.$gfc),Ve(8,L.$Yxb),Ve(9,p.$Bfc),Ve(10,M.$Jfc),Ve(11,I.$Kfc)],ue);function ge(ce,X,V,re){ce.addActivationEvents(re.addActivationEvents);const Ie=new t.$Z6b(ce,X.getAllExtensionDescriptions());Ie.deltaExtensions(re.toAdd,re.toRemove);const Re=new o.$fm(V.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of re.myToRemove)Re.delete(le);for(const le of re.myToAdd)Re.add(le);const Ce=fe(Ie,Re);return{globalRegistry:Ie,myExtensions:Ce}}function be(ce,X){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function ke(ce){return ce.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Ofc=(0,u.$1h)("IExtHostExtensionService");class me{#e;#t;#i;constructor(X,V,re,Ie,Re){this.#e=X,this.#t=V,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=T.$hc((0,F.$qg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Pfc=me;function fe(ce,X){return ce.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class ne{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Qfc=ne;class Se{constructor(X){this.a=new o.$gm,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Pe[286],Ae([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;let a=class{constructor(c,h,i,r,u,d,b){this.c=c,this.d=h,this.e=i,this.f=r,this.g=u,this.h=d,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Ygc=a,e.$Ygc=a=He([Ve(2,A.$Zh),Ve(3,F.$dfc),Ve(4,k.$Ofc),Ve(5,w.$ZM),Ve(6,l.$ij)],a);let s=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&v.a.size){const h=(0,$.$Ke)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",r=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,r,u]=h,d=v.a.get(r);if(d!==void 0)return console.warn(`${r} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};s=v=He([Ve(0,w.$ZM)],s);class t{constructor(c,h,i,r,u){this.c=c,this.d=h,this.e=i,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new m.$gm}load(c,h){const i=this.d.findSubstr(h);if(i){let r=this.a.get(i.identifier);return r||(r=this.c(i,this.e,this.f),this.a.set(i.identifier,r)),r}if(!this.b){let r="";this.d.forEach((u,d)=>r+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$MF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(C.$FK.MainThreadTelemetry);const r=i.getProxy(C.$FK.MainThreadWindow);this.c=(u,d)=>{const b=T.URI.parse(u);return d?this.g(u,d):b.scheme==="http"||b.scheme==="https"?r.$openUri(b,u,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?r.$openUri(b,u,{}):this.g(u,d)}}load(c,h,i){const r=this.e.findSubstr(h);return r&&(this.a=r.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=He([Ve(2,g.$JM)],n)}),define(Pe[116],Ae([1,0,39,6,19,74,4,61,62,38,7,36,214,37]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=e.$Rfc=void 0,e.$Rfc=(0,R.$1h)("IExtHostVariableResolverProvider");class v extends l.$KN{constructor(t,n,o,c,h,i,r){function u(){if(o){const d=o.activeEditor();if(d)return d.document.uri;const b=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof A.$oM||b.input instanceof A.$tM)return b.input.modified;if(b.input instanceof A.$nM||b.input instanceof A.$sM||b.input instanceof A.$qM)return b.input.uri}}}super({getFolderUri:d=>{const b=i.folders.filter(f=>f.name===d);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,b)=>h.getConfiguration(void 0,d).get(b),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return C.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const b=n.getWorkspaceFolder(d);if(b)return C.$hc(b.uri.fsPath)}}},getSelectedText:()=>{if(o){const d=o.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(o){const d=o.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(F.env))}}let a=class extends T.$Sc{constructor(t,n,o,c,h){super(),this.b=t,this.c=n,this.g=o,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Sfc=a,e.$Sfc=a=He([Ve(0,w.$Ofc),Ve(1,k.$afc),Ve(2,m.$UM),Ve(3,$.$dfc),Ve(4,g.$pfc)],a)}),define(Pe[117],Ae([1,0,14,5,2,4,3,62,38,17,7,36,206,208,37,116]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0,e.$Tfc=(0,F.$1h)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,d,b,f,D){this.E=u,this.F=d,this.G=b,this.H=f,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=r.getProxy(R.$FK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(p=>{this.J(L)}),this.J(L)})}asDebugSourceUri(r,u){const d=r;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let b=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(b+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),b+=`${f}ref=${d.sourceReference}`,C.URI.parse(b)}else{if(d.path)return C.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const u=[];for(const d of r.getAllExtensionDescriptions())if(d.contributes){const b=d.contributes.debuggers;if(b&&b.length>0)for(const f of b)(0,$.$oF)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){const u=r.filter(f=>{const D=f.id;return this.w.has(D)?!1:(this.w.set(D,f),!0)});this.U(u,[],[]);const d=[],b=new Map;for(const f of u)if(f instanceof A.$HL){let D=b.get(f.location.uri.toString());D||(D={type:"sourceMulti",uri:f.location.uri,lines:[]},b.set(f.location.uri.toString(),D),d.push(D)),D.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$IL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(r){const u=r.filter(D=>this.w.delete(D.id));this.U([],u,[]);const d=u.filter(D=>D instanceof A.$HL).map(D=>D.id),b=u.filter(D=>D instanceof A.$IL).map(D=>D.id),f=u.filter(D=>D instanceof A.$JL).map(D=>D.id);return this.k.$unregisterBreakpoints(d,b,f)}startDebugging(r,u,d){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,d){if(!u)return new A.$HK(()=>{});const b=this.d++;return this.f.push({type:r,handle:b,provider:u}),this.k.$registerDebugConfigurationProvider(r,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,b),new A.$HK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(r,u,d){if(!d)return new A.$HK(()=>{});if(!this.Q(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:u,handle:b,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,b),new A.$HK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new A.$HK(()=>{});const d=this.i++;return this.j.push({type:r,handle:d,factory:u}),new A.$HK(()=>{this.j=this.j.filter(b=>b.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let d;const b=await this.W(r);return b&&(d={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(r,u){if(r.type==="implementation")return new c(r.implementation)}L(){}async $startDASession(r,u){const d=this,b=await this.V(u);return this.S(this.N(b.type),b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const D=this.M(f),L=this.K(D,b);if(!L)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const p=L;return this.B.set(r,p),this.R(b).then(y=>(y&&this.C.set(r,y),p.onMessage(async S=>{if(S.type==="request"&&S.command==="handshake"){const N=S,q={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(N.arguments.value);q.body={signature:j},p.sendResponse(q)}else throw new Error("no signer")}catch(j){q.success=!1,q.message=j.message,p.sendResponse(q)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(S),S=(0,$.$tF)(S,!0),d.k.$acceptDAMessage(r,S)}),p.onError(S=>{y&&y.onError&&y.onError(S),this.k.$acceptDAError(r,S.name,S.message,S.stack)}),p.onExit(S=>{y&&y.onExit&&y.onExit(S??void 0,void 0),this.k.$acceptDAExit(r,S??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),p.startSession()))})}$sendDAMessage(r,u){u=(0,$.$sF)(u,!1);const d=this.C.get(r);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.C.get(r);this.C.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(r);return this.B.delete(r),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],d=[],b=[];if(r.added)for(const f of r.added){const D=f.id;if(D&&!this.w.has(D)){let L;if(f.type==="function")L=new A.$IL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new A.$JL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const p=C.URI.revive(f.uri);L=new A.$HL(new A.$TK(p,new A.$IK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$FL)(L,D),this.w.set(D,L),u.push(L)}}if(r.removed)for(const f of r.removed){const D=this.w.get(f);D&&(this.w.delete(f),d.push(D))}if(r.changed){for(const f of r.changed)if(f.id){const D=this.w.get(f.id);if(D){if(D instanceof A.$IL&&f.type==="function"){const L=D;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(D instanceof A.$HL&&f.type==="source"){const L=D;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new A.$TK(C.URI.revive(f.uri),new A.$IK(f.line,f.character))}b.push(D)}}}this.U(u,d,b)}async $acceptStackFrameFocus(r){let u;const d=r.sessionId?await this.V(r.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?u=new A.$PL(d,r.threadId):u=new A.$OL(d,r.threadId,r.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(r,u,d){return(0,E.$Tg)(async()=>{const b=this.P(r);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return b.provideDebugConfigurations(f,d)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(r,u,d,b){return(0,E.$Tg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(u);return f.resolveDebugConfiguration(D,d,b)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,d,b){return(0,E.$Tg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(D,d,b)})}async $provideDebugAdapter(r,u){const d=this.O(r);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(u);return this.S(d,b).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const b={session:await this.V(r),event:u.event,body:u.body};this.u.fire(b)}M(r){if(r instanceof A.$KL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$LL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$ML)return{type:"pipeServer",path:r.path};if(r instanceof A.$NL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const u=this.h.filter(d=>d.type===r);if(u.length>0)return u[0].factory}O(r){const u=this.h.filter(d=>d.handle===r);if(u.length>0)return u[0].factory}P(r){const u=this.f.filter(d=>d.handle===r);if(u.length>0)return u[0].provider}Q(r,u){if(r.contributes){const d=r.contributes.debuggers;if(d&&d.length>0){for(const b of d)if(b.label&&b.type&&b.type===u)return!0}}return!1}R(r){const d=r.configuration.type,b=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Tg)(()=>f.factory.createDebugAdapterTracker(r)).then(D=>D,D=>null));return Promise.race([Promise.all(b).then(f=>{const D=f.filter(L=>!!L);if(D.length>0)return new o(D)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(r,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$LL(d));if(r){const f=await this.F.getExtensionRegistry();return(0,E.$Tg)(()=>r.createDebugAdapterDescriptor(u,this.T(u,f))).then(D=>{if(D)return D})}const b=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,b))}T(r,u){}U(r,u,d){(r.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:r,removed:u,changed:d}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const d=await this.W(r.folderUri),b=r.parent?this.l.get(r.parent):void 0;u=new t(this.k,r.id,r.type,r.name,d,r.configuration,b),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=C.URI.revive(r);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$Ufc=s,e.$Ufc=s=He([Ve(0,w.$JM),Ve(1,k.$afc),Ve(2,g.$Ofc),Ve(3,v.$dfc),Ve(4,m.$pfc),Ve(5,a.$Rfc)],s);class t{constructor(r,u,d,b,f,D,L){this.d=r,this.f=u,this.g=d,this.h=b,this.i=f,this.j=D,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Vfc=t;class n{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$Wfc=n;class o{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(d=>d.onExit?d.onExit(r,u):void 0)}}class c extends l.$glb{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends s{constructor(r,u,d,b,f,D){super(r,u,d,b,f,D)}};e.$Xfc=h,e.$Xfc=h=He([Ve(0,w.$JM),Ve(1,k.$afc),Ve(2,g.$Ofc),Ve(3,v.$dfc),Ve(4,m.$pfc),Ve(5,a.$Rfc)],h)}),define(Pe[287],Ae([1,0,11,88,2,3,275,15,70,71,27,184,17,57,38,59]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class s{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get(m.$ij),i=o.get(l.$JM).getProxy(F.$FK.MainThreadErrors);E.setUnexpectedErrorHandler(r=>{c.error(r);const u=E.$3(r);i.$onUnexpectedError(u)})}static async installFullHandler(o){const c=o.get(m.$ij),h=o.get(l.$JM),i=o.get(v.$Ofc),r=o.get(a.$4M),u=h.getProxy(F.$FK.MainThreadExtensionService),d=h.getProxy(F.$FK.MainThreadErrors),b=await i.getExtensionPathIndex(),f=new WeakMap;function D(y,S){if(f.has(y))return f.get(y).stack;let N="",q,j;for(const U of S)N+=`
	at ${U.toString()}`,j=U.getFileName(),!q&&j&&(q=b.findSubstr(C.URI.file(j)));const M=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:q?.identifier,stack:M}),M}const L=Symbol("prepareStackTrace wrapped");let p=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(y){if(y===D||!y||y[L]){p=y||D;return}p=function(S,N){return D(S,N),y.call(Error,S,N)},Object.assign(p,{[L]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const S=E.$3(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(S);return}u.$onExtensionRuntimeError(N.extensionIdentifier,S);const q=r.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",q,N)})}}e.$Zgc=s;class t{constructor(o,c,h,i,r){this.a=h,this.b=new R.$86b(o,null,i),c=t.e(c,this.b);const u=new w.$Yh(...(0,g.$Ir)());u.set(A.$ZM,{_serviceBrand:void 0,...c,messagePorts:r}),u.set(l.$JM,new l.$KM(this.b)),u.set($.$0ec,new $.$$ec(i)),u.set(v.$Mfc,h);const d=new k.$oq(u,!0);d.invokeFunction(s.installEarlyHandler),this.d=d.invokeFunction(b=>b.get(m.$ij)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(b=>b.get(v.$Ofc)),this.c.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(F.$FK.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),o.environment.appRoot=C.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),o.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=C.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$1gc=t}),define(Pe[288],Ae([1,0,18,14,20,40,13,19,25,2,44]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.$_fc=void 0;class k{constructor(n,o,c,h){this.d=n,this.e=o,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],h=new C.$3d(o);return new Promise((i,r)=>{this.a=new $(n);let u=!1;const d=(b,f)=>{if(!u&&!this.b){const D=this.h(b);a(b)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),b=this.j(b,this.d.maxResults-this.c));const L=this.h(b);this.c+=L,(L>0||!a(b))&&this.a.add(b,f)}};Promise.all(c.map((b,f)=>this.k(b,D=>d(D,f),h.token))).then(b=>{h.dispose(),this.a.flush();const f=b.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(b.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},b=>{h.dispose();const f=(0,F.$Li)(b);r(new Error(f))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:h.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const h=new A.$jJ(this.d,n),i=[],r={report:b=>{if(!this.l(b))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$kJ)(()=>this.f.readdir(g.$Bg(b.uri))):void 0,D=g.$Eg(n.folder,b.uri);if(D){const L=h.includedInQuery(D,m.$nc(D),f);(0,T.$Ng)(L)?i.push(L.then(p=>{p&&o(b)})):L&&o(b)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,r,c);return i.length&&await Promise.all(i),d}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,A.$iJ)(this.d.includePattern,n.includePattern),c=(0,A.$iJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$_fc=k;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class ${constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new s(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!g.$vg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$agc=$;function v(t){return a(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function a(t){return!!t.preview}e.$bgc=a;class s{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cgc=s}),define(Pe[118],Ae([1,0,6,3,4,283,17,57,15,2,288]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=e.$egc=e.$dgc=void 0,e.$dgc=(0,C.$1h)("IExtHostSearch");let k=class{constructor(a,s,t){this.k=a,this.l=s,this.n=t,this.c=this.k.getProxy(T.$FK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$$fc}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,s){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const t=this.d++;return this.e.set(t,s),this.c.$registerTextSearchProvider(t,this.o(a)),(0,E.$Qc)(()=>{this.g.delete(a),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(a,s){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const t=this.d++;return this.h.set(t,s),this.c.$registerFileSearchProvider(t,this.o(a)),(0,E.$Qc)(()=>{this.i.delete(a),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(a,s,t,n){const o=l(t),c=this.h.get(a);if(c)return this.j.fileSearch(o,c,h=>{this.c.$handleFileMatch(a,s,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,s,t){return{messages:[]}}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,s,t,n){const o=this.e.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=l(t);return this.q(c,o).search(i=>this.c.$handleTextMatch(a,s,i),n)}$enableExtensionHostSearch(){}q(a,s){return new A.$_fc(a,s,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$egc=k,e.$egc=k=He([Ve(0,R.$JM),Ve(1,m.$0ec),Ve(2,g.$ij)],k);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map($),extraFileResources:v.extraFileResources&&v.extraFileResources.map(a=>w.URI.revive(a))}}e.$fgc=l;function $(v){return{...v,folder:w.URI.revive(v.folder)}}}),define(Pe[289],Ae([1,0,20,11,5,6,13,31,2,145,141,129,93,22,42,15,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,117,110,241,242,243,219,244,61,62,246,38,247,63,248,43,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,112,259,223,260,261,17,262,118,84,263,264,265,85,86,115,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,111,36,207,79,23,114]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r,u,d,b,f,D,L,p,y,S,N,q,j,M,U,P,I,Z,ue,ge,be,ke,me,fe,ne,Se,ce,X,V,re,Ie,Re,Ce,le,ie,G,te,x,se,de,De,Le,O,K,J,W,Q,_,ye,ze,Qe,Je,Xe,it,nt,_e,rt,je,ct,ee,Y,ve,Be,Ke,xe,ot,pt,Oe,At,Kt,jt,bt,Vt,Ut,Ht,Gt,Rt,It,Ye,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;function qt(ut){const gt=ut.get(X.$ZM),Zt=ut.get(ce.$Rec),Ct=ut.get(ne.$ffc),St=ut.get(me.$Ofc),dt=ut.get(Gt.$afc),Ft=ut.get(ct.$4M),Nt=ut.get(N.$dfc),yt=ut.get(Kt.$0ec),qe=ut.get(ye.$JM),Lt=ut.get(_e.$yfc),Bt=ut.get(rt.$gfc),Qt=ut.get(a.$jj),ft=ut.get(a.$ij),Mt=ut.get(ot.$Yxb),Ee=ut.get(i.$Uec),Me=ut.get(Ht.$Tgc),$e=ut.get(Je.$Gfc),H=ut.get(be.$pfc),Fe=ut.get(G.$Kfc);qe.set(o.$GK.ExtHostFileSystemInfo,Zt),qe.set(o.$GK.ExtHostLogLevelServiceShape,Qt),qe.set(o.$GK.ExtHostWorkspace,dt),qe.set(o.$GK.ExtHostConfiguration,Nt),qe.set(o.$GK.ExtHostExtensionService,St),qe.set(o.$GK.ExtHostStorage,Lt),qe.set(o.$GK.ExtHostTunnelService,Mt),qe.set(o.$GK.ExtHostWindow,Me),qe.set(o.$GK.ExtHostSecretState,$e),qe.set(o.$GK.ExtHostTelemetry,Ft),qe.set(o.$GK.ExtHostEditorTabs,H),qe.set(o.$GK.ExtHostManagedSockets,Fe);const Ue=qe.set(o.$GK.ExtHostDecorations,ut.get(M.$Zfc)),Ze=qe.set(o.$GK.ExtHostDocumentsAndEditors,ut.get(ge.$UM)),We=qe.set(o.$GK.ExtHostCommands,ut.get(y.$6M)),tt=qe.set(o.$GK.ExtHostTerminalService,ut.get(ee.$Bfc)),mt=qe.set(o.$GK.ExtHostDebugService,ut.get(j.$Tfc)),zt=qe.set(o.$GK.ExtHostSearch,ut.get(Qe.$dgc)),Et=qe.set(o.$GK.ExtHostTask,ut.get(je.$Ggc)),Dt=qe.set(o.$GK.ExtHostOutputService,ut.get(K.$tgc)),wt=qe.set(o.$GK.ExtHostLocalization,ut.get(ie.$Jfc)),mi=qe.set(o.$GK.ExtHostUrls,new jt.$Qgc(qe)),Pt=qe.set(o.$GK.ExtHostDocuments,new ue.$Pec(qe,Ze)),Di=qe.set(o.$GK.ExtHostDocumentContentProviders,new I.$2fc(qe,Ze,ft)),Vi=qe.set(o.$GK.ExtHostDocumentSaveParticipant,new Z.$3fc(ft,Pt,qe.getProxy(o.$FK.MainThreadBulkEdits))),kt=qe.set(o.$GK.ExtHostNotebook,new x.$ggc(qe,We,Ze,Pt,Ct,zt)),ni=qe.set(o.$GK.ExtHostNotebookDocuments,new de.$ngc(kt)),$i=qe.set(o.$GK.ExtHostNotebookEditors,new De.$ogc(ft,kt)),ai=qe.set(o.$GK.ExtHostNotebookKernels,new Le.$pgc(qe,gt,kt,We,ft)),ki=qe.set(o.$GK.ExtHostNotebookRenderers,new O.$rgc(qe,kt)),Ii=qe.set(o.$GK.ExtHostNotebookDocumentSaveParticipant,new se.$mgc(ft,kt,qe.getProxy(o.$FK.MainThreadBulkEdits))),Tt=qe.set(o.$GK.ExtHostEditors,new ve.$7ec(qe,Ze)),pi=qe.set(o.$GK.ExtHostTreeViews,new xe.$Ogc(qe.getProxy(o.$FK.MainThreadTreeViews),We,ft)),Ci=qe.set(o.$GK.ExtHostEditorInsets,new p.$8ec(qe.getProxy(o.$FK.MainThreadEditorInsets),Tt,gt.remote)),ci=qe.set(o.$GK.ExtHostDiagnostics,new U.$Tec(qe,ft,Zt,Ze)),ui=qe.set(o.$GK.ExtHostLanguages,new le.$kgc(qe,Pt,We.converter,yt)),lt=qe.set(o.$GK.ExtHostLanguageFeatures,new Ce.$Xec(qe,yt,Pt,We,ci,ft,Ee,Ft)),qi=qe.set(o.$GK.ExtHostFileSystem,new fe.$5fc(qe,lt)),xt=qe.set(o.$GK.ExtHostFileSystemEventService,new Se.$6fc(qe,ft,Ze)),ri=qe.set(o.$GK.ExtHostQuickOpen,(0,_.$xgc)(qe,dt,We)),di=qe.set(o.$GK.ExtHostSCM,new ze.$zgc(qe,We,Pt,ft)),Pi=qe.set(o.$GK.ExtHostQuickDiff,new Q.$wgc(qe,yt)),Ki=qe.set(o.$GK.ExtHostShare,new Xe.$Agc(qe,yt)),Ai=qe.set(o.$GK.ExtHostComments,(0,S.$9ec)(qe,We,Pt)),vi=qe.set(o.$GK.ExtHostProgress,new W.$vgc(qe.getProxy(o.$FK.MainThreadProgress))),Hi=qe.set(o.$GK.ExtHosLabelService,new Re.$jgc(qe)),Ri=qe.set(o.$GK.ExtHostTheming,new Be.$Lgc(qe)),li=qe.set(o.$GK.ExtHostAuthentication,new r.$Zec(qe)),Gi=qe.set(o.$GK.ExtHostTimeline,new Ke.$Ngc(qe,We)),bi=qe.set(o.$GK.ExtHostWebviews,new bt.$kfc(qe,gt.remote,dt,ft,Ee)),Mi=qe.set(o.$GK.ExtHostWebviewPanels,new Vt.$nfc(qe,bi,dt)),cn=qe.set(o.$GK.ExtHostCustomEditors,new q.$ofc(qe,Pt,Bt,bi,Mi)),Fi=qe.set(o.$GK.ExtHostWebviewViews,new Ut.$Rgc(qe,bi)),si=qe.set(o.$GK.ExtHostTesting,new Y.$Hgc(qe,We,Ze)),un=qe.set(o.$GK.ExtHostUriOpeners,new At.$Pgc(qe)),ln=qe.set(o.$GK.ExtHostProfileContentHandlers,new J.$ugc(qe));qe.set(o.$GK.ExtHostInteractive,new re.$hgc(qe,kt,Ze,We,ft));const Ji=qe.set(o.$GK.ExtHostInlineChat,new V.$7fc(qe,We,Pt,ft)),fi=qe.set(o.$GK.ExtHostChatProvider,new f.$3ec(qe,ft)),Qi=qe.set(o.$GK.ExtHostChatAgents2,new b.$4ec(qe,fi,ft)),Zi=qe.set(o.$GK.ExtHostChatVariables,new D.$5ec(qe)),gi=qe.set(o.$GK.ExtHostChat,new d.$2ec(qe)),Yi=qe.set(o.$GK.ExtHostAiRelatedInformation,new c.$Oec(qe)),Li=qe.set(o.$GK.ExtHostAiEmbeddingVector,new ke.$4fc(qe)),Ti=qe.set(o.$GK.ExtHostIssueReporter,new Ie.$igc(qe)),_t=qe.set(o.$GK.ExtHostStatusBar,new nt.$Dgc(qe,We.converter)),wi=qe.set(o.$GK.ExtHostSpeech,new it.$Bgc(qe)),hn=Object.values(o.$GK);qe.assertRegistered(hn);const Yt=new u.$1ec(qe,Ze),yi=new L.$6ec(qe),Ei=new te.$lgc(qe,ft),Oi=new P.$1fc(qe);return h.$Yec.register(We),function(Ne,ei,Xi){const $t=function(){let oe=!Ne.isUnderDevelopment;function he(){oe||(ft.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")he();else{const vt=st;typeof vt.scheme>"u"&&he(),typeof vt.exclusive=="boolean"&&(0,Ye.$SF)(Ne,"documentFiltersExclusive")}return st}}(),xi={getSession(oe,he,Te){return li.getSession(Ne,oe,he,Te)},getSessions(oe,he){return(0,Ye.$SF)(Ne,"authGetSessions"),li.getSessions(Ne,oe,he)},async hasSession(oe,he){return(0,Ye.$SF)(Ne,"authSession"),!!await li.getSession(Ne,oe,he,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(oe,he,Te,st){return li.registerAuthenticationProvider(oe,he,Te,st)}},dn={registerCommand(oe,he,Te){return We.registerCommand(!0,oe,he,Te,void 0,Ne)},registerTextEditorCommand(oe,he,Te){return We.registerCommand(!0,oe,(...st)=>{const vt=Tt.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+oe+" because there is no active text editor.");return}return vt.edit(Ot=>{he.apply(Te,[vt,Ot,...st])}).then(Ot=>{Ot||ft.warn("Edits from command "+oe+" were not applied.")},Ot=>{ft.warn("An error occurred while running command "+oe,Ot)})},void 0,void 0,Ne)},registerDiffInformationCommand:(oe,he,Te)=>((0,Ye.$SF)(Ne,"diffCommand"),We.registerCommand(!0,oe,async(...st)=>{const vt=Ze.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+oe+" because there is no active text editor.");return}const Ot=await Tt.getDiffInformation(vt.id);he.apply(Te,[Ot,...st])},void 0,void 0,Ne)),executeCommand(oe,...he){return We.executeCommand(oe,...he)},getCommands(oe=!1){return We.getCommands(oe)}},_i={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return tt.getDefaultShell(!1)},get onDidChangeShell(){return tt.onDidChangeShell},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ft.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.$SF)(Ne,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$SF)(Ne,"telemetry"),Ft.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ct.$3M)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(oe,he){return ct.$2M.validateSender(oe),Ft.instantiateLogger(Ne,oe,he)},openExternal(oe,he){return Me.openUri(oe,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===gt.environment.appUriScheme)return mi.createAppUri(oe);try{return await Me.asExternalUri(oe,{allowTunneling:!!gt.remote.authority})}catch(he){if((0,R.$_f)(oe,R.Schemas.http)||(0,R.$_f)(oe,R.Schemas.https))return oe;throw he}},get remoteName(){return(0,s.$7k)(gt.remote.authority)},get remoteAuthority(){return(0,Ye.$SF)(Ne,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel},registerIssueUriRequestHandler(oe){return(0,Ye.$SF)(Ne,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ne,oe)},registerIssueDataProvider(oe){return(0,Ye.$SF)(Ne,"handleIssueUri"),Ti.registerIssueDataProvider(Ne,oe)},get appQuality(){return(0,Ye.$SF)(Ne,"resolvers"),gt.quality},get appCommit(){return(0,Ye.$SF)(Ne,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(oe,he,Te){return si.createTestController(Ne,oe,he,Te)},createTestObserver(){return(0,Ye.$SF)(Ne,"testObserver"),si.createTestObserver()},runTests(oe){return(0,Ye.$SF)(Ne,"testObserver"),si.runTests(oe)},get onDidChangeTestResults(){return(0,Ye.$SF)(Ne,"testObserver"),si.onResultsChanged},get testResults(){return(0,Ye.$SF)(Ne,"testObserver"),si.results}},hi=gt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,tn={getExtension(oe,he){(0,Ye.$RF)(Ne,"extensionsAny")||(he=!1);const Te=ei.mine.getExtensionDescription(oe);if(Te)return new me.$Pfc(St,Ne.identifier,Te,hi,!1);if(he){const st=ei.all.getExtensionDescription(oe);if(st)return new me.$Pfc(St,Ne.identifier,st,hi,!0)}},get all(){const oe=[];for(const he of ei.mine.getAllExtensionDescriptions())oe.push(new me.$Pfc(St,Ne.identifier,he,hi,!1));return oe},get allAcrossExtensionHosts(){(0,Ye.$SF)(Ne,"extensionsAny");const oe=new $.$fm(ei.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),he=[];for(const Te of ei.all.getAllExtensionDescriptions()){const st=!oe.has(Te.identifier);he.push(new me.$Pfc(St,Ne.identifier,Te,hi,st))}return he},get onDidChange(){return(0,Ye.$RF)(Ne,"extensionsAny")?C.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(oe){return ci.createDiagnosticCollection(Ne.identifier,oe)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:oe=>ci.getDiagnostics(oe),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(oe,he){return ui.changeLanguage(oe.uri,he)},match(oe,he){const Te=Pt.getDocumentData(he.uri)?.notebook;return(0,A.$lt)(pt.LanguageSelector.from(oe),he.uri,he.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(oe,he,Te){return lt.registerCodeActionProvider(Ne,$t(oe),he,Te)},registerDocumentPasteEditProvider(oe,he,Te){return(0,Ye.$SF)(Ne,"documentPaste"),lt.registerDocumentPasteEditProvider(Ne,$t(oe),he,Te)},registerCodeLensProvider(oe,he){return lt.registerCodeLensProvider(Ne,$t(oe),he)},registerDefinitionProvider(oe,he){return lt.registerDefinitionProvider(Ne,$t(oe),he)},registerDeclarationProvider(oe,he){return lt.registerDeclarationProvider(Ne,$t(oe),he)},registerImplementationProvider(oe,he){return lt.registerImplementationProvider(Ne,$t(oe),he)},registerTypeDefinitionProvider(oe,he){return lt.registerTypeDefinitionProvider(Ne,$t(oe),he)},registerHoverProvider(oe,he){return lt.registerHoverProvider(Ne,$t(oe),he,Ne.identifier)},registerEvaluatableExpressionProvider(oe,he){return lt.registerEvaluatableExpressionProvider(Ne,$t(oe),he,Ne.identifier)},registerInlineValuesProvider(oe,he){return lt.registerInlineValuesProvider(Ne,$t(oe),he,Ne.identifier)},registerDocumentHighlightProvider(oe,he){return lt.registerDocumentHighlightProvider(Ne,$t(oe),he)},registerMultiDocumentHighlightProvider(oe,he){return lt.registerMultiDocumentHighlightProvider(Ne,$t(oe),he)},registerLinkedEditingRangeProvider(oe,he){return lt.registerLinkedEditingRangeProvider(Ne,$t(oe),he)},registerReferenceProvider(oe,he){return lt.registerReferenceProvider(Ne,$t(oe),he)},registerRenameProvider(oe,he){return lt.registerRenameProvider(Ne,$t(oe),he)},registerDocumentSymbolProvider(oe,he,Te){return lt.registerDocumentSymbolProvider(Ne,$t(oe),he,Te)},registerWorkspaceSymbolProvider(oe){return lt.registerWorkspaceSymbolProvider(Ne,oe)},registerDocumentFormattingEditProvider(oe,he){return lt.registerDocumentFormattingEditProvider(Ne,$t(oe),he)},registerDocumentRangeFormattingEditProvider(oe,he){return lt.registerDocumentRangeFormattingEditProvider(Ne,$t(oe),he)},registerOnTypeFormattingEditProvider(oe,he,Te,...st){return lt.registerOnTypeFormattingEditProvider(Ne,$t(oe),he,[Te].concat(st))},registerDocumentSemanticTokensProvider(oe,he,Te){return lt.registerDocumentSemanticTokensProvider(Ne,$t(oe),he,Te)},registerDocumentRangeSemanticTokensProvider(oe,he,Te){return lt.registerDocumentRangeSemanticTokensProvider(Ne,$t(oe),he,Te)},registerSignatureHelpProvider(oe,he,Te,...st){return typeof Te=="object"?lt.registerSignatureHelpProvider(Ne,$t(oe),he,Te):lt.registerSignatureHelpProvider(Ne,$t(oe),he,typeof Te>"u"?[]:[Te,...st])},registerCompletionItemProvider(oe,he,...Te){return lt.registerCompletionItemProvider(Ne,$t(oe),he,Te)},registerInlineCompletionItemProvider(oe,he,Te){return he.handleDidShowCompletionItem&&(0,Ye.$SF)(Ne,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$SF)(Ne,"inlineCompletionsAdditions"),Te&&(0,Ye.$SF)(Ne,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ne,$t(oe),he,Te)},registerDocumentLinkProvider(oe,he){return lt.registerDocumentLinkProvider(Ne,$t(oe),he)},registerColorProvider(oe,he){return lt.registerColorProvider(Ne,$t(oe),he)},registerFoldingRangeProvider(oe,he){return lt.registerFoldingRangeProvider(Ne,$t(oe),he)},registerSelectionRangeProvider(oe,he){return lt.registerSelectionRangeProvider(Ne,oe,he)},registerCallHierarchyProvider(oe,he){return lt.registerCallHierarchyProvider(Ne,oe,he)},registerTypeHierarchyProvider(oe,he){return lt.registerTypeHierarchyProvider(Ne,oe,he)},setLanguageConfiguration:(oe,he)=>lt.setLanguageConfiguration(Ne,oe,he),getTokenInformationAtPosition(oe,he){return(0,Ye.$SF)(Ne,"tokenInformation"),ui.tokenAtPosition(oe,he)},registerInlayHintsProvider(oe,he){return lt.registerInlayHintsProvider(Ne,oe,he)},createLanguageStatusItem(oe,he){return ui.createLanguageStatusItem(Ne,oe,he)},registerDocumentDropEditProvider(oe,he,Te){return lt.registerDocumentOnDropEditProvider(Ne,oe,he,(0,Ye.$RF)(Ne,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return tt.activeTerminal},get terminals(){return tt.terminals},async showTextDocument(oe,he,Te){const st=await(g.URI.isUri(oe)?Promise.resolve(sn.openTextDocument(oe)):Promise.resolve(oe));return Tt.showTextDocument(st,he,Te)},createTextEditorDecorationType(oe){return Tt.createTextEditorDecorationType(Ne,oe)},onDidChangeActiveTextEditor(oe,he,Te){return Tt.onDidChangeActiveTextEditor(oe,he,Te)},onDidChangeVisibleTextEditors(oe,he,Te){return Tt.onDidChangeVisibleTextEditors(oe,he,Te)},onDidChangeTextEditorSelection(oe,he,Te){return Tt.onDidChangeTextEditorSelection(oe,he,Te)},onDidChangeTextEditorOptions(oe,he,Te){return Tt.onDidChangeTextEditorOptions(oe,he,Te)},onDidChangeTextEditorVisibleRanges(oe,he,Te){return Tt.onDidChangeTextEditorVisibleRanges(oe,he,Te)},onDidChangeTextEditorViewColumn(oe,he,Te){return Tt.onDidChangeTextEditorViewColumn(oe,he,Te)},onDidCloseTerminal(oe,he,Te){return tt.onDidCloseTerminal(oe,he,Te)},onDidOpenTerminal(oe,he,Te){return tt.onDidOpenTerminal(oe,he,Te)},onDidChangeActiveTerminal(oe,he,Te){return tt.onDidChangeActiveTerminal(oe,he,Te)},onDidChangeTerminalDimensions(oe,he,Te){return(0,Ye.$SF)(Ne,"terminalDimensions"),tt.onDidChangeTerminalDimensions(oe,he,Te)},onDidChangeTerminalState(oe,he,Te){return tt.onDidChangeTerminalState(oe,he,Te)},onDidWriteTerminalData(oe,he,Te){return(0,Ye.$SF)(Ne,"terminalDataWriteEvent"),tt.onDidWriteTerminalData(oe,he,Te)},onDidExecuteTerminalCommand(oe,he,Te){return(0,Ye.$SF)(Ne,"terminalExecuteCommandEvent"),tt.onDidExecuteTerminalCommand(oe,he,Te)},get state(){return Me.getState(Ne)},onDidChangeWindowState(oe,he,Te){return Me.onDidChangeWindowState(oe,he,Te)},showInformationMessage(oe,...he){return Ei.showMessage(Ne,m.default.Info,oe,he[0],he.slice(1))},showWarningMessage(oe,...he){return Ei.showMessage(Ne,m.default.Warning,oe,he[0],he.slice(1))},showErrorMessage(oe,...he){return Ei.showMessage(Ne,m.default.Error,oe,he[0],he.slice(1))},showQuickPick(oe,he,Te){return ri.showQuickPick(Ne,oe,he,Te)},showWorkspaceFolderPick(oe){return ri.showWorkspaceFolderPick(oe)},showInputBox(oe,he){return ri.showInput(oe,he)},showOpenDialog(oe){return Oi.showOpenDialog(Ne,oe)},showSaveDialog(oe){return Oi.showSaveDialog(oe)},createStatusBarItem(oe,he,Te){let st,vt,Ot;return typeof oe=="string"?(st=oe,vt=he,Ot=Te):(vt=oe,Ot=he),_t.createStatusBarEntry(Ne,st,vt,Ot)},setStatusBarMessage(oe,he){return _t.setStatusBarMessage(oe,he)},withScmProgress(oe){return Ee.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),vi.withProgress(Ne,{location:Oe.ProgressLocation.SourceControl},(he,Te)=>oe({report(st){}}))},withProgress(oe,he){return vi.withProgress(Ne,oe,he)},createOutputChannel(oe,he){return Dt.createOutputChannel(oe,he,Ne)},createWebviewPanel(oe,he,Te,st){return Mi.createWebviewPanel(Ne,oe,he,Te,st)},createWebviewTextEditorInset(oe,he,Te,st){return(0,Ye.$SF)(Ne,"editorInsets"),Ci.createWebviewEditorInset(oe,he,Te,st,Ne)},createTerminal(oe,he,Te){return typeof oe=="object"?"pty"in oe?tt.createExtensionTerminal(oe):tt.createTerminalFromOptions(oe):tt.createTerminal(oe,he,Te)},registerTerminalLinkProvider(oe){return tt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,he){return tt.registerProfileProvider(Ne,oe,he)},registerTerminalQuickFixProvider(oe,he){return(0,Ye.$SF)(Ne,"terminalQuickFixProvider"),tt.registerTerminalQuickFixProvider(oe,Ne.identifier.value,he)},registerTreeDataProvider(oe,he){return pi.registerTreeDataProvider(oe,he,Ne)},createTreeView(oe,he){return pi.createTreeView(oe,he,Ne)},registerWebviewPanelSerializer:(oe,he)=>Mi.registerWebviewPanelSerializer(Ne,oe,he),registerCustomEditorProvider:(oe,he,Te={})=>cn.registerCustomEditorProvider(Ne,oe,he,Te),registerFileDecorationProvider(oe){return Ue.registerFileDecorationProvider(oe,Ne)},registerUriHandler(oe){return mi.registerUriHandler(Ne,oe)},createQuickPick(){return ri.createQuickPick(Ne)},createInputBox(){return ri.createInputBox(Ne)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(oe,he,Te){return Ri.onDidChangeActiveColorTheme(oe,he,Te)},registerWebviewViewProvider(oe,he,Te){return Fi.registerWebviewViewProvider(Ne,oe,he,Te?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,he,Te){return kt.onDidChangeActiveNotebookEditor(oe,he,Te)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,he,Te){return $i.onDidChangeNotebookEditorSelection(oe,he,Te)},onDidChangeNotebookEditorVisibleRanges(oe,he,Te){return $i.onDidChangeNotebookEditorVisibleRanges(oe,he,Te)},showNotebookDocument(oe,he){return kt.showNotebookDocument(oe,he)},registerExternalUriOpener(oe,he,Te){return(0,Ye.$SF)(Ne,"externalUriOpener"),un.registerExternalUriOpener(Ne.identifier,oe,he,Te)},registerProfileContentHandler(oe,he){return(0,Ye.$SF)(Ne,"profileContentHandlers"),ln.registrProfileContentHandler(Ne,oe,he)},registerQuickDiffProvider(oe,he,Te,st){return(0,Ye.$SF)(Ne,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(oe),he,Te,st)},get tabGroups(){return H.tabGroups},registerShareProvider(oe,he){return(0,Ye.$SF)(Ne,"shareProvider"),Ki.registerShareProvider($t(oe),he)}},sn={get rootPath(){return Ee.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(oe){throw new T.$9("rootPath")},getWorkspaceFolder(oe){return dt.getWorkspaceFolder(oe)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(oe){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(oe){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(oe,he,...Te)=>dt.updateWorkspaceFolders(Ne,oe,he||0,...Te),onDidChangeWorkspaceFolders:function(oe,he,Te){return dt.onDidChangeWorkspace(oe,he,Te)},asRelativePath:(oe,he)=>dt.getRelativePath(oe,he),findFiles:(oe,he,Te,st)=>dt.findFiles(oe,he,Te,Ne.identifier,st),findTextInFiles:(oe,he,Te,st)=>{(0,Ye.$SF)(Ne,"findTextInFiles");let vt,Ot;return typeof he=="object"?(vt=he,Ot=Te):(vt={},Ot=he,st=Te),dt.findTextInFiles(oe,vt||{},Ot,Ne.identifier,st)},save:oe=>((0,Ye.$SF)(Ne,"saveEditor"),dt.save(oe)),saveAs:oe=>((0,Ye.$SF)(Ne,"saveEditor"),dt.saveAs(oe)),saveAll:oe=>dt.saveAll(oe),applyEdit(oe,he){return Yt.applyWorkspaceEdit(oe,Ne,he)},createFileSystemWatcher:(oe,he,Te,st)=>{let vt;return typeof he=="boolean"?vt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!st,correlate:!1}:he&&((0,Ye.$SF)(Ne,"createFileSystemWatcher"),vt={...he,correlate:!0}),xt.createFileSystemWatcher(dt,Ne,oe,vt)},get textDocuments(){return Pt.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw new T.$9("textDocuments")},openTextDocument(oe){let he;const Te=oe;if(typeof oe=="string")he=Promise.resolve(g.URI.file(oe));else if(g.URI.isUri(oe))he=Promise.resolve(oe);else if(!Te||typeof Te=="object")he=Pt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>Pt.ensureDocumentData(st).then(vt=>vt.document))},onDidOpenTextDocument:(oe,he,Te)=>Pt.onDidAddDocument(oe,he,Te),onDidCloseTextDocument:(oe,he,Te)=>Pt.onDidRemoveDocument(oe,he,Te),onDidChangeTextDocument:(oe,he,Te)=>Pt.onDidChangeDocument(oe,he,Te),onDidSaveTextDocument:(oe,he,Te)=>Pt.onDidSaveDocument(oe,he,Te),onWillSaveTextDocument:(oe,he,Te)=>Vi.getOnWillSaveTextDocumentEvent(Ne)(oe,he,Te),get notebookDocuments(){return kt.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,he){let Te;if(g.URI.isUri(oe))Te=oe,await kt.openNotebookDocument(oe);else if(typeof oe=="string")Te=g.URI.revive(await kt.createNotebookDocument({viewType:oe,content:he}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(oe,he,Te){return ni.onDidSaveNotebookDocument(oe,he,Te)},onDidChangeNotebookDocument(oe,he,Te){return ni.onDidChangeNotebookDocument(oe,he,Te)},onWillSaveNotebookDocument(oe,he,Te){return Ii.getOnWillSaveNotebookDocumentEvent(Ne)(oe,he,Te)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(oe,he,Te,st){return kt.registerNotebookSerializer(Ne,oe,he,Te,(0,Ye.$RF)(Ne,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(oe,he,Te)=>Xi.onDidChangeConfiguration(oe,he,Te),getConfiguration(oe,he){return he=arguments.length===1?void 0:he,Xi.getConfiguration(oe,he,Ne)},registerTextDocumentContentProvider(oe,he){return Di.registerTextDocumentContentProvider(oe,he)},registerTaskProvider:(oe,he)=>(Ee.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ne,oe,he)),registerFileSystemProvider(oe,he,Te){return(0,F.$Pc)(qi.registerFileSystemProvider(Ne,oe,he,Te),Ct.addFileSystemProvider(oe,he,Te))},get fs(){return Ct.value},registerFileSearchProvider:(oe,he)=>((0,Ye.$SF)(Ne,"fileSearchProvider"),zt.registerFileSearchProvider(oe,he)),registerTextSearchProvider:(oe,he)=>((0,Ye.$SF)(Ne,"textSearchProvider"),zt.registerTextSearchProvider(oe,he)),registerRemoteAuthorityResolver:(oe,he)=>((0,Ye.$SF)(Ne,"resolvers"),St.registerRemoteAuthorityResolver(oe,he)),registerResourceLabelFormatter:oe=>((0,Ye.$SF)(Ne,"resolvers"),Hi.$registerResourceLabelFormatter(oe)),getRemoteExecServer:oe=>((0,Ye.$SF)(Ne,"resolvers"),St.getRemoteExecServer(oe)),onDidCreateFiles:(oe,he,Te)=>xt.onDidCreateFile(oe,he,Te),onDidDeleteFiles:(oe,he,Te)=>xt.onDidDeleteFile(oe,he,Te),onDidRenameFiles:(oe,he,Te)=>xt.onDidRenameFile(oe,he,Te),onWillCreateFiles:(oe,he,Te)=>xt.getOnWillCreateFileEvent(Ne)(oe,he,Te),onWillDeleteFiles:(oe,he,Te)=>xt.getOnWillDeleteFileEvent(Ne)(oe,he,Te),onWillRenameFiles:(oe,he,Te)=>xt.getOnWillRenameFileEvent(Ne)(oe,he,Te),openTunnel:oe=>((0,Ye.$SF)(Ne,"tunnels"),Mt.openTunnel(Ne,oe).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Ye.$SF)(Ne,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(oe,he,Te)=>((0,Ye.$SF)(Ne,"tunnels"),Mt.onDidChangeTunnels(oe,he,Te)),registerPortAttributesProvider:(oe,he)=>((0,Ye.$SF)(Ne,"portsAttributes"),Mt.registerPortsAttributesProvider(oe,he)),registerTunnelProvider:(oe,he)=>((0,Ye.$SF)(Ne,"tunnelFactory"),Mt.registerTunnelProvider(oe,he)),registerTimelineProvider:(oe,he)=>((0,Ye.$SF)(Ne,"timeline"),Gi.registerTimelineProvider(oe,he,Ne.identifier,We.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:oe=>((0,Ye.$SF)(Ne,"workspaceTrust"),dt.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,he,Te)=>dt.onDidGrantWorkspaceTrust(oe,he,Te),registerEditSessionIdentityProvider:(oe,he)=>((0,Ye.$SF)(Ne,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(oe,he)),onWillCreateEditSessionIdentity:(oe,he,Te)=>((0,Ye.$SF)(Ne,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ne)(oe,he,Te)),registerCanonicalUriProvider:(oe,he)=>((0,Ye.$SF)(Ne,"canonicalUriProvider"),dt.registerCanonicalUriProvider(oe,he)),getCanonicalUri:(oe,he,Te)=>((0,Ye.$SF)(Ne,"canonicalUriProvider"),dt.provideCanonicalUri(oe,he,Te))},fn={get inputBox(){return Ee.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Ne)},createSourceControl(oe,he,Te){return di.createSourceControl(Ne,oe,he,Te)},registerSourceControlInputBoxValueProvider(oe,he){return(0,Ye.$SF)(Ne,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Ne,oe,he)}},on={createCommentController(oe,he){return Ai.createCommentController(Ne,oe,he)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(oe,he,Te){return mt.onDidStartDebugSession(oe,he,Te)},onDidTerminateDebugSession(oe,he,Te){return mt.onDidTerminateDebugSession(oe,he,Te)},onDidChangeActiveDebugSession(oe,he,Te){return mt.onDidChangeActiveDebugSession(oe,he,Te)},onDidReceiveDebugSessionCustomEvent(oe,he,Te){return mt.onDidReceiveDebugSessionCustomEvent(oe,he,Te)},onDidChangeBreakpoints(oe,he,Te){return mt.onDidChangeBreakpoints(oe,he,Te)},onDidChangeStackFrameFocus(oe,he,Te){return(0,Ye.$SF)(Ne,"debugFocus"),mt.onDidChangeStackFrameFocus(oe,he,Te)},registerDebugConfigurationProvider(oe,he,Te){return mt.registerDebugConfigurationProvider(oe,he,Te||Rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,he){return mt.registerDebugAdapterDescriptorFactory(Ne,oe,he)},registerDebugAdapterTrackerFactory(oe,he){return mt.registerDebugAdapterTrackerFactory(oe,he)},startDebugging(oe,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(oe,he,{parentSession:Te}):mt.startDebugging(oe,he,Te||{})},stopDebugging(oe){return mt.stopDebugging(oe)},addBreakpoints(oe){return mt.addBreakpoints(oe)},removeBreakpoints(oe){return mt.removeBreakpoints(oe)},asDebugSourceUri(oe,he){return mt.asDebugSourceUri(oe,he)}},Ni={registerTaskProvider:(oe,he)=>Et.registerTaskProvider(Ne,oe,he),fetchTasks:oe=>Et.fetchTasks(oe),executeTask:oe=>Et.executeTask(Ne,oe),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(oe,he,Te)=>Et.onDidStartTask(oe,he,Te),onDidEndTask:(oe,he,Te)=>Et.onDidEndTask(oe,he,Te),onDidStartTaskProcess:(oe,he,Te)=>Et.onDidStartTaskProcess(oe,he,Te),onDidEndTaskProcess:(oe,he,Te)=>Et.onDidEndTaskProcess(oe,he,Te)},zi={createNotebookController(oe,he,Te,st,vt){return ai.createNotebookController(Ne,oe,he,Te,st,(0,Ye.$RF)(Ne,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(oe,he)=>kt.registerNotebookCellStatusBarItemProvider(Ne,oe,he),createRendererMessaging(oe){return ki.createRendererMessaging(Ne,oe)},createNotebookControllerDetectionTask(oe){return(0,Ye.$SF)(Ne,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Ne,oe)},registerKernelSourceActionProvider(oe,he){return(0,Ye.$SF)(Ne,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Ne,oe,he)},onDidChangeNotebookCellExecutionState(oe,he,Te){return(0,Ye.$SF)(Ne,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(oe,he,Te)}},ji={t(...oe){if(typeof oe[0]=="string"){const he=oe.shift(),Te=!oe||typeof oe[0]!="object"?oe:oe[0];return wt.getMessage(Ne.identifier.value,{message:he,args:Te})}return wt.getMessage(Ne.identifier.value,oe[0])},get bundle(){return wt.getBundle(Ne.identifier.value)},get uri(){return wt.getBundleUri(Ne.identifier.value)}},Si={_version:1,registerInteractiveEditorSessionProvider(oe,he){return(0,Ye.$SF)(Ne,"interactive"),Ji.registerProvider(Ne,oe,he)},registerInteractiveSessionProvider(oe,he){return(0,Ye.$SF)(Ne,"interactive"),gi.registerChatProvider(Ne,oe,he)},sendInteractiveRequestToProvider(oe,he){return(0,Ye.$SF)(Ne,"interactive"),gi.sendInteractiveRequestToProvider(oe,he)},get onDidPerformUserAction(){return(0,Ye.$SF)(Ne,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(oe,he){return(0,Ye.$SF)(Ne,"interactive"),gi.transferChatSession(oe,he)}},Ui={getRelatedInformation(oe,he){return(0,Ye.$SF)(Ne,"aiRelatedInformation"),Yi.getRelatedInformation(Ne,oe,he)},registerRelatedInformationProvider(oe,he){return(0,Ye.$SF)(Ne,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ne,oe,he)},registerEmbeddingVectorProvider(oe,he){return(0,Ye.$SF)(Ne,"aiRelatedInformation"),Li.registerEmbeddingVectorProvider(Ne,oe,he)}},gn={registerChatResponseProvider(oe,he,Te){return(0,Ye.$SF)(Ne,"chatProvider"),fi.registerProvider(Ne.identifier,oe,he,Te)},requestChatAccess(oe){return(0,Ye.$SF)(Ne,"chatRequestAccess"),fi.requestChatResponseProvider(Ne.identifier,oe)},registerVariable(oe,he,Te){return(0,Ye.$SF)(Ne,"chatVariables"),Zi.registerVariableResolver(Ne,oe,he,Te)},registerMappedEditsProvider(oe,he){return(0,Ye.$SF)(Ne,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ne,oe,he)},createChatAgent(oe,he){return(0,Ye.$SF)(Ne,"chatAgents2"),Qi.createChatAgent(Ne,oe,he)}},mn={registerSpeechProvider(oe,he){return(0,Ye.$SF)(Ne,"speech"),wi.registerProvider(Ne.identifier,oe,he)}};return{version:gt.version,ai:Ui,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:Si,l10n:ji,languages:nn,notebooks:zi,scm:fn,speech:mn,tasks:Ni,tests:en,window:rn,workspace:sn,Breakpoint:Oe.$GL,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$yM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$xM,CallHierarchyIncomingCall:Oe.$6K,CallHierarchyItem:Oe.$5K,CallHierarchyOutgoingCall:Oe.$7K,CancellationError:T.$5,CancellationTokenSource:E.$3d,CandidatePortSource:o.CandidatePortSource,CodeAction:Oe.$2K,CodeActionKind:Oe.$3K,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$8K,Color:Oe.$iL,ColorInformation:Oe.$jL,ColorPresentation:Oe.$kL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$cL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$dL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$sL,DebugAdapterExecutable:Oe.$KL,DebugAdapterInlineImplementation:Oe.$NL,DebugAdapterNamedPipeServer:Oe.$ML,DebugAdapterServer:Oe.$LL,DebugConfigurationProviderTriggerKind:Rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$VK,DiagnosticRelatedInformation:Oe.$UK,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$HK,DocumentHighlight:Oe.$XK,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$YK,DocumentLink:Oe.$hL,DocumentSymbol:Oe.$1K,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$QL,InlineValueText:Oe.$RL,InlineValueVariableLookup:Oe.$SL,InlineValueEvaluatableExpression:Oe.$TL,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:C.$Sd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$4L,FileDecoration2:Oe.$4L,FileSystemError:Oe.$VL,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Oe.$WL,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$IL,InlineCompletionItem:Oe.$eL,InlineCompletionList:Oe.$fL,Hover:Oe.$WK,IndentAction:k.IndentAction,Location:Oe.$TK,MarkdownString:Oe.$9K,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Oe.$0K,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$IK,ProcessExecution:Oe.$qL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$3L,Range:Oe.$JK,RelativePattern:Oe.$EL,Selection:Oe.$KK,SelectionRange:Oe.$4K,SemanticTokens:Oe.$ZL,SemanticTokensBuilder:Oe.$YL,SemanticTokensEdit:Oe.$1L,SemanticTokensEdits:Oe.$2L,SemanticTokensLegend:Oe.$XL,ShellExecution:Oe.$rL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$_K,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$$K,SnippetString:Oe.$SK,SourceBreakpoint:Oe.$HL,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$ZK,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$tL,TaskGroup:Oe.$pL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$lL,TerminalQuickFixTerminalCommand:Oe.$nL,TerminalQuickFixOpener:Oe.$mL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$oL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$OK,SnippetTextEdit:Oe.$QK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$DL,ThemeIcon:Oe.$CL,TreeItem:Oe.$uL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$mM,UIKind:It.UIKind,Uri:g.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$RK,DocumentDropEdit:Oe.$AL,DocumentPasteEdit:Oe.$BL,InlayHint:Oe.$bL,InlayHintLabelPart:Oe.$aL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$NK,ResolvedAuthority:Oe.$LK,ManagedResolvedAuthority:Oe.$MK,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$bM,NotebookRange:Oe.$6L,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$7L,NotebookData:Oe.$8L,NotebookRendererScript:Oe.$_L,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$0L,NotebookCellOutputItem:Oe.$9L,NotebookCellStatusBarItem:Oe.$$L,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$PK,NotebookKernelSourceAction:Oe.$aM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$dM,LinkedEditingRanges:Oe.$cM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$eM,TestMessage:Oe.$fM,TestMessage2:Oe.$fM,TestTag:Oe.$gM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:Oe.$zL,DataTransferItem:Oe.$vL,CoveredCount:Oe.$hM,FileCoverage:Oe.$iM,StatementCoverage:Oe.$jM,BranchCoverage:Oe.$kM,FunctionCoverage:Oe.$lM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$nM,TabInputTextDiff:Oe.$oM,TabInputTextMerge:Oe.$pM,TabInputCustom:Oe.$qM,TabInputNotebook:Oe.$sM,TabInputNotebookDiff:Oe.$tM,TabInputWebview:Oe.$rM,TabInputTerminal:Oe.$uM,TabInputInteractiveWindow:Oe.$vM,TabInputChat:Oe.$wM,TelemetryTrustedValue:t.$uo,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Oe.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$OL,ThreadFocus:Oe.$PL,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$Ugc=qt}),define(Pe[290],Ae([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,255,15,116,82,83]),function(pe,e,E,T,C,F,R,m,g,w,A,k,l,$,v,a,s,t,n,o,c,h,i,r,u,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Hr)(d.$Jfc,d.$Ifc,1),(0,E.$Hr)(r.$jj,i.$Vgc,1),(0,E.$Hr)(a.$Uec,a.$Vec,1),(0,E.$Hr)(m.$6M,m.$5M,0),(0,E.$Hr)(R.$dfc,R.$bfc,0),(0,E.$Hr)(t.$ffc,t.$efc,0),(0,E.$Hr)(k.$Tfc,k.$Xfc,0),(0,E.$Hr)(F.$Zfc,F.$Yfc,0),(0,E.$Hr)(g.$UM,g.$TM,0),(0,E.$Hr)(b.$Kfc,b.$Lfc,0),(0,E.$Hr)(n.$Rec,n.$Qec,0),(0,E.$Hr)(T.$tgc,T.$sgc,1),(0,E.$Hr)(l.$dgc,l.$egc,0),(0,E.$Hr)($.$yfc,$.$xfc,0),(0,E.$Hr)(A.$Ggc,A.$Fgc,0),(0,E.$Hr)(w.$Bfc,w.$Efc,0),(0,E.$Hr)(v.$Yxb,v.$Zxb,0),(0,E.$Hr)(s.$Tgc,s.$Sgc,0),(0,E.$Hr)(C.$afc,C.$_ec,0),(0,E.$Hr)(o.$Gfc,o.$Ffc,0),(0,E.$Hr)(c.$4M,c.$1M,0),(0,E.$Hr)(h.$pfc,h.$qfc,0),(0,E.$Hr)(u.$Rfc,u.$Sfc,0)}),define(Pe[291],Ae([1,0,289,38,2,286,7,14,274]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class w extends F.$Ygc{j(){}getModule($,v){for(const a of this.b){const s=a($);if(s){$=s;break}}if(this.a.has($))return this.a.get($).load($,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends T.$Nfc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$5ic);const $=this.h.invokeFunction(E.$Ugc);this.r=this.h.createInstance(w,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,v,a){v=v.with({path:k(v.path,".js")});const s=$?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const t=C.URI.revive(await this.C.$asBrowserUri(v)),n=await fetch(t.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${v.toString(!0)}#vscode-extension`,h=`${o}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(b){throw console.error(s?`Loading code for extension ${s} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${v.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}$&&await this.w.initializeLocalizedMessages($);const r={},u={exports:r},d=b=>{const f=this.r.getModule(b,v);if(f===void 0)throw new Error(`Cannot load module '${b}'`);return f};try{return a.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),i(u,r,d),u.exports!==r?u.exports:r}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),a.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+$;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,m.$2g)(10)}}e.$6ic=A;function k(l,$){return l.endsWith($)?l:l+$}}),define(Pe[292],Ae([1,0,69,70,15,38,199,86,291]),function(pe,e,E,T,C,F,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Hr)(C.$ij,new E.$Xh(R.$Xgc,[!0],!0)),(0,T.$Hr)(F.$Ofc,g.$6ic,0),(0,T.$Hr)(m.$gfc,m.$hfc,0)}),define(Pe[297],Ae([1,0,24,5,79,287,276,19,88,13,2,290,292]),function(pe,e,E,T,C,F,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(i){return/^(file|vscode-remote):/i.test(i)}const v=fetch.bind(self);function a(i){self.fetch=async function(r,u){return r instanceof Request||$(String(r))&&(r=(await i(A.URI.parse(String(r)))).toString(!0)),v(r,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,u,d,b,f){(async()=>($(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(r,u,d??!0,b,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(r,u){if(/^file:/i.test(r.toString()))r=w.$jg.uriToBrowserUri(A.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(p){function y(q){return typeof q=="string"||q instanceof URL?String(q).replace(/^file:\/\//i,"vscode-file://vscode-app"):q}const S=fetch.bind(self);self.fetch=function(q,j){return q instanceof Request?S(q,j):S(y(q),j)},self.XMLHttpRequest=class extends XMLHttpRequest{open(q,j,M,U,P){return super.open(q,y(j),M??!0,U,P)}};const N=importScripts.bind(self);self.importScripts=(...q)=>{N(...q.map(y))},N(p)}.toString()}('${r}'))`;u=u||{},u.name=u.name||m.$nc(r.toString());const f=new Blob([b],{type:"application/javascript"}),D=URL.createObjectURL(f);return new i(D,u)}}else self.Worker=class extends R.$7ic{constructor(i,r){super(l,i,{name:m.$nc(i.toString()),...r})}};const s=new class{constructor(){this.pid=void 0}exit(i){k()}};class t{constructor(){const r=new MessageChannel,u=new T.$Sd;let d=!1;l(r.port2,[r.port2]),r.port1.onmessage=b=>{const{data:f}=b;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const D=E.$ge.wrap(new Uint8Array(f,0,f.byteLength));if((0,C.$nm)(D,2)){d=!0,o("received terminate message from renderer");return}u.fire(D)},this.protocol={onMessage:u.event,send:b=>{if(!d){const f=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);r.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(r=>{const u=i.onMessage(d=>{u.dispose();const b=JSON.parse(d.toString());i.send((0,C.$mm)(0)),r({protocol:i,initData:b})});i.send((0,C.$mm)(1))})}let o=i=>k();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(r){c(r)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new F.$1gc(u.protocol,u.initData,s,null,r.data);a(b=>d.asBrowserUri(b)),o=b=>d.terminate(b)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f6b7ba78b8850751f083306b8f5d745c8a0ddcf/core/vs/workbench/api/worker/extensionHostWorker.js.map
