/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(G){for(var e=[],N=0,T=G.length;N<T;N++)e[N]=W[G[N]];return e};define(W[22],V([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const y=new Map,L=new Map,s=new Map,d=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function o(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let g=[];typeof G=="function"&&typeof G.getStats=="function"&&(g=G.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of g)switch(a.type){case 10:t(y,a);break;case 11:case 12:o(y,a);break;case 21:t(L,a);break;case 22:o(L,a);break;case 33:t(s,a);break;case 34:o(s,a);break;case 31:t(d,a);break;case 32:o(d,a);break}let c=0;s.forEach(a=>c+=a);function h(a){const i=[];return a.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:h(y),amdInvoke:h(L),nodeRequire:h(s),nodeEval:h(d),nodeRequireTotal:c}}static toMarkdownTable(y,L){let s="";const d=[];return y.forEach((t,o)=>{d[o]=t.length}),L.forEach(t=>{t.forEach((o,g)=>{typeof o>"u"&&(o=t[g]="-");const c=o.toString().length;d[g]=Math.max(c,d[g])})}),y.forEach((t,o)=>{s+=`| ${t+" ".repeat(d[o]-t.toString().length)} `}),s+=`|
`,y.forEach((t,o)=>{s+=`| ${"-".repeat(d[o])} `}),s+=`|
`,L.forEach(t=>{t.forEach((o,g)=>{typeof o<"u"&&(s+=`| ${o+" ".repeat(d[g]-o.toString().length)} `)}),s+=`|
`}),s}}e.$U=N}),define(W[4],V([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sd=e.$rd=e.$qd=void 0;let N;function T(n){N=n}e.$qd=T;function y(){return N}e.$rd=y;class L{constructor(){this.a=0,this.d=new WeakMap}b(r){return s([d(a("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[d(" "),o(g(r.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),o(g(r.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),o(g(r.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(r,b){console.log(...this.b([t("observable value changed"),o(r.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(r){if(r.size!==0)return o(" (changed deps: "+[...r].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const b=r.handleChange;this.d.set(r,new Set),r.handleChange=(O,j)=>(this.d.get(r).add(O),b.apply(r,[O,j]))}handleDerivedRecomputed(r,b){const O=this.d.get(r);console.log(...this.b([t("derived recomputed"),o(r.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(O),{data:[{fn:r._computeFn}]}])),O.clear()}handleFromEventObservableTriggered(r,b){console.log(...this.b([t("observable from event triggered"),o(r.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const b=r.handleChange;this.d.set(r,new Set),r.handleChange=(O,j)=>(this.d.get(r).add(O),b.apply(r,[O,j]))}handleAutorunTriggered(r){const b=this.d.get(r);console.log(...this.b([t("autorun"),o(r.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:r._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let b=r.getDebugName();b===void 0&&(b=""),console.log(...this.b([t("transaction"),o(b,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$sd=L;function s(n){const r=new Array,b=[];let O="";function j(A){if("length"in A)for(const f of A)f&&j(f);else"text"in A?(O+=`%c${A.text}`,r.push(A.style),A.data&&b.push(...A.data)):"data"in A&&b.push(...A.data)}j(n);const P=[O,...r];return P.push(...b),P}function d(n){return o(n,{color:"black"})}function t(n){return o(i(`${n}: `,10),{color:"black",bold:!0})}function o(n,r={color:"black"}){function b(j){return Object.entries(j).reduce((P,[A,f])=>`${P}${A}:${f};`,"")}const O={color:r.color};return r.strikeThrough&&(O["text-decoration"]="line-through"),r.bold&&(O["font-weight"]="bold"),{text:n,style:b(O)}}function g(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?c(n,r):h(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function c(n,r){let b="[ ",O=!0;for(const j of n){if(O||(b+=", "),b.length-5>r){b+="...";break}O=!1,b+=`${g(j,r-b.length)}`}return b+=" ]",b}function h(n,r){let b="{ ",O=!0;for(const[j,P]of Object.entries(n)){if(O||(b+=", "),b.length-5>r){b+="...";break}O=!1,b+=`${j}: ${g(P,r-b.length)}`}return b+=" }",b}function a(n,r){let b="";for(let O=1;O<=r;O++)b+=n;return b}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(W[5],V([0,1,4]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=void 0;let T;function y(w){T=w}e.$zd=y;let L;function s(w){L=w}e.$Ad=s;class d{get TChange(){return null}reportChanges(){this.get()}read(E){return E?E.readObservable(this):this.get()}map(E,U){const S=U===void 0?void 0:E,l=U===void 0?E:U;return L({owner:S,debugName:()=>{const M=k(l);if(M!==void 0)return M;const z=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(l.toString());if(z)return`${this.debugName}.${z[2]}`;if(!S)return`${this.debugName} (mapped)`}},M=>l(this.read(M),M))}recomputeInitiallyAndOnChange(E,U){return E.add(T(this,U)),this}}e.$Bd=d;class t extends d{constructor(){super(...arguments),this.c=new Set}addObserver(E){const U=this.c.size;this.c.add(E),U===0&&this.f()}removeObserver(E){this.c.delete(E)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Cd=t;function o(w,E){const U=new i(w,E);try{w(U)}finally{U.finish()}}e.$Dd=o;let g;function c(w){if(g)w(g);else{const E=new i(w,void 0);g=E;try{w(E)}finally{E.finish(),g=void 0}}}e.$Ed=c;async function h(w,E){const U=new i(w,E);try{await w(U)}finally{U.finish()}}e.$Fd=h;function a(w,E,U){w?E(w):o(E,U)}e.$Gd=a;class i{constructor(E,U){this._fn=E,this.b=U,this.a=[],(0,N.$rd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():k(this._fn)}updateObserver(E,U){this.a.push({observer:E,observable:U}),E.beginUpdate(U)}finish(){const E=this.a;for(let U=0;U<E.length;U++){const{observer:S,observable:l}=E[U];S.endUpdate(l)}this.a=null,(0,N.$rd)()?.handleEndTransaction()}}e.$Hd=i;const n=new Map,r=new WeakMap;function b(w,E,U,S,l){const M=r.get(w);if(M)return M;const F=O(w,E,U,S,l);if(F){let z=n.get(F)??0;z++,n.set(F,z);const p=z===1?F:`${F}#${z}`;return r.set(w,p),p}}e.$Id=b;function O(w,E,U,S,l){const M=r.get(w);if(M)return M;const F=S?A(S)+".":"";let z;if(E!==void 0)if(typeof E=="function"){if(z=E(),z!==void 0)return F+z}else return F+E;if(U!==void 0&&(z=k(U),z!==void 0))return F+z;if(S!==void 0){for(const p in S)if(S[p]===l)return F+p}}const j=new Map,P=new WeakMap;function A(w){const E=P.get(w);if(E)return E;const U=f(w);let S=j.get(U)??0;S++,j.set(U,S);const l=S===1?U:`${U}#${S}`;return P.set(w,l),l}function f(w){const E=w.constructor;return E?E.name:"Object"}function k(w){const E=w.toString(),S=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(E);return(S?S[1]:void 0)?.trim()}e.$Jd=k;function m(w,E){return typeof w=="string"?new I(void 0,w,E):new I(w,void 0,E)}e.$Kd=m;class I extends t{get debugName(){return b(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(E,U,S){super(),this.b=E,this.d=U,this.a=S}get(){return this.a}set(E,U,S){if(this.a===E)return;let l;U||(U=l=new i(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.a;this.e(E),(0,N.$rd)()?.handleObservableChanged(this,{oldValue:M,newValue:E,change:S,didChange:!0,hadValue:!0});for(const F of this.c)U.updateObserver(F,this),F.handleChange(this,S)}finally{l&&l.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(E){this.a=E}}e.$Ld=I;function D(w,E){return typeof w=="string"?new $(void 0,w,E):new $(w,void 0,E)}e.$Md=D;class $ extends I{e(E){this.a!==E&&(this.a&&this.a.dispose(),this.a=E)}dispose(){this.a?.dispose()}}e.$Nd=$}),define(W[9],V([0,1,43,2,5,4]),function(G,e,N,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=void 0;function s(i){return new h(void 0,i,void 0,void 0)}e.$9c=s;function d(i,n){return new h(i.debugName,n,void 0,void 0)}e.$0c=d;function t(i,n){return new h(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$$c=t;function o(i,n){const r=new T.$Rc,b=t({debugName:i.debugName??(()=>(0,y.$Jd)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(O,j)=>{r.clear(),n(O,j,r)});return(0,T.$Qc)(()=>{b.dispose(),r.dispose()})}e.$_c=o;function g(i){const n=new T.$Rc,r=d({debugName:()=>(0,y.$Jd)(i)||"(anonymous)"},b=>{n.clear(),i(b,n)});return(0,T.$Qc)(()=>{r.dispose(),n.dispose()})}e.$ad=g;var c;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(c||(c={}));class h{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const r=this.h();if(r!==void 0)return r}const n=(0,y.$Jd)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,r,b,O){this.h=n,this._runFn=r,this.i=b,this.j=O,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,L.$rd)()?.handleAutorunCreated(this),this.k(),(0,T.$Jc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Kc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,L.$rd)()?.handleAutorunTriggered(this);const b=this.g;this.g=this.i?.(),this._runFn(this,b)}}finally{r||(0,L.$rd)()?.handleAutorunFinished(this);for(const b of this.f)b.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,N.$7c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:O=>O===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}e.$bd=h,function(i){i.Observer=h}(s||(e.$9c=s={}));function a(i,n){let r;return d({debugName:()=>(0,y.$Jd)(n)},b=>{const O=i.read(b),j=r;r=O,n({lastValue:j,newValue:O})})}e.$cd=a}),define(W[10],V([0,1,6,2,5,4]),function(G,e,N,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=void 0;const s=(i,n)=>i===n;function d(i,n){return n!==void 0?new a(i,void 0,n,void 0,void 0,void 0,s):new a(void 0,void 0,i,void 0,void 0,void 0,s)}e.$td=d;function t(i,n){return new a(i.owner,i.debugName,n,void 0,void 0,void 0,i.equalityComparer??s)}e.$ud=t;function o(i,n){return new a(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$vd=o;function g(i,n){let r,b;n===void 0?(r=i,b=void 0):(b=i,r=n);const O=new T.$Rc;return new a(b,()=>(0,y.$Jd)(r)??"(anonymous)",j=>(O.clear(),r(j,O)),void 0,void 0,()=>O.dispose(),s)}e.$wd=g;function c(i,n){let r,b;n===void 0?(r=i,b=void 0):(b=i,r=n);const O=new T.$Rc;return new a(b,()=>(0,y.$Jd)(r)??"(anonymous)",j=>{O.clear();const P=r(j);return P&&O.add(P),P},void 0,void 0,()=>O.dispose(),s)}e.$xd=c,(0,y.$Ad)(t);var h;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class a extends y.$Cd{get debugName(){return(0,y.$Id)(this,this.p,this._computeFn,this.n,this)??"(anonymous)"}constructor(n,r,b,O,j,P=void 0,A){super(),this.n=n,this.p=r,this._computeFn=b,this.q=O,this.s=j,this.t=P,this.u=A,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,L.$rd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const r=this.e!==0,b=this.h;this.e=3;const O=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,O)}finally{for(const P of this.l)P.removeObserver(this);this.l.clear()}const j=r&&!this.u(b,this.h);if((0,L.$rd)()?.handleDerivedRecomputed(this,{oldValue:b,newValue:this.h,change:void 0,didChange:j,hadValue:r}),j)for(const P of this.c)P.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const r=this.j===1;if(this.e===3&&(this.e=1,!r))for(const b of this.c)b.handlePossibleChange(this);if(r)for(const b of this.c)b.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const r=[...this.c];for(const b of r)b.endUpdate(this)}if(this.j<0)throw new N.$cb}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const r of this.c)r.handlePossibleChange(this)}}handleChange(n,r){if(this.k.has(n)&&!this.l.has(n)){const b=this.s?this.s({changedObservable:n,change:r,didChange:j=>j===n},this.m):!0,O=this.e===3;if(b&&(this.e===1||O)&&(this.e=2,O))for(const j of this.c)j.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const r=n.get();return this.k.add(n),this.l.delete(n),r}addObserver(n){const r=!this.c.has(n)&&this.j>0;super.addObserver(n),r&&n.beginUpdate(this)}removeObserver(n){const r=this.c.has(n)&&this.j>0;super.removeObserver(n),r&&n.endUpdate(this)}}e.$yd=a}),define(W[23],V([0,1,2,9,5,10,4]),function(G,e,N,T,y,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=void 0;function d(m){return new t(m)}e.$dd=d;class t extends y.$Bd{constructor(I){super(),this.a=I}get debugName(){return this.toString()}get(){return this.a}addObserver(I){}removeObserver(I){}toString(){return`Const: ${this.a}`}}function o(m){const I=(0,y.$Kd)("promiseValue",{});return m.then(D=>{I.set({value:D},void 0)}),I}e.$ed=o;function g(m,I){return new Promise(D=>{let $=!1,w=!1;const E=m.map(S=>({isFinished:I(S),state:S})),U=(0,T.$9c)(S=>{const{isFinished:l,state:M}=E.read(S);l&&($?U.dispose():w=!0,D(M))});$=!0,w&&U.dispose()})}e.$fd=g;function c(m,I){return new h(m,I)}e.$gd=c;class h extends y.$Cd{constructor(I,D){super(),this.h=I,this._getValue=D,this.b=!1,this.l=$=>{const w=this._getValue($),E=this.a,U=!this.b||E!==w;let S=!1;U&&(this.a=w,this.b&&(S=!0,(0,y.$Gd)(h.globalTransaction,l=>{(0,s.$rd)()?.handleFromEventObservableTriggered(this,{oldValue:E,newValue:w,change:void 0,didChange:U,hadValue:this.b});for(const M of this.c)l.updateObserver(M,this),M.handleChange(this,void 0)},()=>{const l=this.j();return"Event fired"+(l?`: ${l}`:"")})),this.b=!0),S||(0,s.$rd)()?.handleFromEventObservableTriggered(this,{oldValue:E,newValue:w,change:void 0,didChange:U,hadValue:this.b})}}j(){return(0,y.$Jd)(this._getValue)}get debugName(){const I=this.j();return"From Event"+(I?`: ${I}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$hd=h,function(m){m.Observer=h;function I(D,$){let w=!1;h.globalTransaction===void 0&&(h.globalTransaction=D,w=!0);try{$()}finally{w&&(h.globalTransaction=void 0)}}m.batchEventsGlobally=I}(c||(e.$gd=c={}));function a(m,I){return new i(m,I)}e.$id=a;class i extends y.$Cd{constructor(I,D){super(),this.debugName=I,this.b=D,this.h=()=>{(0,y.$Dd)($=>{for(const w of this.c)$.updateObserver(w,this),w.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(m){return typeof m=="string"?new r(m):new r(void 0,m)}e.$jd=n;class r extends y.$Cd{get debugName(){return(0,y.$Id)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(I,D){super(),this.a=I,this.b=D}trigger(I,D){if(!I){(0,y.$Dd)($=>{this.trigger($,D)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)I.updateObserver($,this),$.handleChange(this,D)}get(){}}function b(m,I,D){const $=(0,y.$Kd)("debounced",void 0);let w;return D.add((0,T.$9c)(E=>{const U=m.read(E);w&&clearTimeout(w),w=setTimeout(()=>{(0,y.$Dd)(S=>{$.set(U,S)})},I)})),$}e.$kd=b;function O(m,I,D){const $=(0,y.$Kd)("triggeredRecently",!1);let w;return D.add(m(()=>{$.set(!0,void 0),w&&clearTimeout(w),w=setTimeout(()=>{$.set(!1,void 0)},I)})),$}e.$ld=O;function j(m){const I=new A(!1,void 0);return m.addObserver(I),(0,N.$Qc)(()=>{m.removeObserver(I)})}e.$md=j;function P(m,I){const D=new A(!0,I);return m.addObserver(D),I?I(m.get()):m.reportChanges(),(0,N.$Qc)(()=>{m.removeObserver(D)})}e.$nd=P,(0,y.$zd)(P);class A{constructor(I,D){this.b=I,this.c=D,this.a=0}beginUpdate(I){this.a++}endUpdate(I){this.a--,this.a===0&&this.b&&(this.c?this.c(I.get()):I.reportChanges())}handlePossibleChange(I){}handleChange(I,D){}}function f(m){let I;return(0,L.$td)($=>(I=m($,I),I))}e.$od=f;function k(m,I){let D;const $=(0,y.$Kd)("derivedObservableWithWritableCache.counter",0),w=(0,L.$td)(m,E=>($.read(E),D=I(E,D),D));return Object.assign(w,{clearCache:E=>{D=void 0,$.set($.get()+1,E)}})}e.$pd=k}),define(W[11],V([0,1,5,10,9,23,4]),function(G,e,N,T,y,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return N.$Kd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return N.$Md}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return N.$Dd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return N.$Gd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$td}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$ud}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$vd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$wd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$9c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$cd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$ad}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$0c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$_c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return L.$dd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return L.$kd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return L.$od}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return L.$pd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return L.$md}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return L.$nd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return L.$gd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return L.$ed}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return L.$jd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return L.$id}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return L.$fd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return L.$ld}}),!1&&(0,s.$qd)(new s.$sd)}),define(W[24],V([0,1,6,2]),function(G,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function y(P){const A=P;return A?typeof A.read=="function":!1}e.$4d=y;function L(P){const A=P;return A?[A.on,A.pause,A.resume,A.destroy].every(f=>typeof f=="function"):!1}e.$5d=L;function s(P){const A=P;return A?L(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}e.$6d=s;function d(P,A){return new t(P,A)}e.$7d=d;class t{constructor(A,f){this.e=A,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(f=>f(A))}h(A){this.c.error.length===0?(0,N.$1)(A):this.c.error.slice(0).forEach(f=>f(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,f){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(A,f){if(this.a.destroyed)return;let k;switch(A){case"data":k=this.c.data;break;case"end":k=this.c.end;break;case"error":k=this.c.error;break}if(k){const m=k.indexOf(f);m>=0&&k.splice(m,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(k=>k())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(P,A){const f=[];let k;for(;(k=P.read())!==null;)f.push(k);return A(f)}e.$8d=o;function g(P,A,f){const k=[];let m;for(;(m=P.read())!==null&&k.length<f;)k.push(m);return m===null&&k.length>0?A(k):{read:()=>{if(k.length>0)return k.shift();if(typeof m<"u"){const I=m;return m=void 0,I}return P.read()}}}e.$9d=g;function c(P,A){return new Promise((f,k)=>{const m=[];h(P,{onData:I=>{A&&m.push(I)},onError:I=>{A?k(I):f(void 0)},onEnd:()=>{f(A?A(m):void 0)}})})}e.$0d=c;function h(P,A,f){P.on("error",k=>{f?.isCancellationRequested||A.onError(k)}),P.on("end",()=>{f?.isCancellationRequested||A.onEnd()}),P.on("data",k=>{f?.isCancellationRequested||A.onData(k)})}e.$$d=h;function a(P,A){return new Promise((f,k)=>{const m=new T.$Rc,I=[],D=E=>{if(I.push(E),I.length>A)return m.dispose(),P.pause(),f({stream:P,buffer:I,ended:!1})},$=E=>(m.dispose(),k(E)),w=()=>(m.dispose(),f({stream:P,buffer:I,ended:!0}));m.add((0,T.$Qc)(()=>P.removeListener("error",$))),P.on("error",$),m.add((0,T.$Qc)(()=>P.removeListener("end",w))),P.on("end",w),m.add((0,T.$Qc)(()=>P.removeListener("data",D))),P.on("data",D)})}e.$_d=a;function i(P,A){const f=d(A);return f.end(P),f}e.$ae=i;function n(){const P=d(()=>{throw new Error("not supported")});return P.end(),P}e.$be=n;function r(P){let A=!1;return{read:()=>A?null:(A=!0,P)}}e.$ce=r;function b(P,A,f){const k=d(f);return h(P,{onData:m=>k.write(A.data(m)),onError:m=>k.error(A.error?A.error(m):m),onEnd:()=>k.end()}),k}e.$de=b;function O(P,A,f){let k=!1;return{read:()=>{const m=A.read();return k?m:(k=!0,m!==null?f([P,m]):P)}}}e.$ee=O;function j(P,A,f){let k=!1;const m=d(f);return h(A,{onData:I=>k?m.write(I):(k=!0,m.write(f([P,I]))),onError:I=>m.error(I),onEnd:()=>{k||(k=!0,m.write(P)),m.end()}}),m}e.$fe=j}),define(W[12],V([0,1,25,24]),function(G,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const y=typeof Buffer<"u",L=new N.$V(()=>new Uint8Array(256));let s,d;class t{static alloc(l){return y?new t(Buffer.allocUnsafe(l)):new t(new Uint8Array(l))}static wrap(l){return y&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new t(l)}static fromString(l,M){return!(M?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(l)):(s||(s=new TextEncoder),new t(s.encode(l)))}static fromByteArray(l){const M=t.alloc(l.length);for(let F=0,z=l.length;F<z;F++)M.buffer[F]=l[F];return M}static concat(l,M){if(typeof M>"u"){M=0;for(let p=0,_=l.length;p<_;p++)M+=l[p].byteLength}const F=t.alloc(M);let z=0;for(let p=0,_=l.length;p<_;p++){const K=l[p];F.set(K,z),z+=K.byteLength}return F}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=t.alloc(this.byteLength);return l.set(this),l}toString(){return y?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(l,M){return new t(this.buffer.subarray(l,M))}set(l,M){if(l instanceof t)this.buffer.set(l.buffer,M);else if(l instanceof Uint8Array)this.buffer.set(l,M);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),M);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,M){a(this.buffer,l,M)}readUInt32LE(l){return i(this.buffer,l)}writeUInt32LE(l,M){n(this.buffer,l,M)}readUInt8(l){return r(this.buffer,l)}writeUInt8(l,M){b(this.buffer,l,M)}indexOf(l,M=0){return o(this.buffer,l instanceof t?l.buffer:l,M)}}e.$ge=t;function o(S,l,M=0){const F=l.byteLength,z=S.byteLength;if(F===0)return 0;if(F===1)return S.indexOf(l[0]);if(F>z-M)return-1;const p=L.value;p.fill(l.length);for(let J=0;J<l.length;J++)p[l[J]]=l.length-J-1;let _=M+l.length-1,K=_,H=-1;for(;_<z;)if(S[_]===l[K]){if(K===0){H=_;break}_--,K--}else _+=Math.max(l.length-K,p[S[_]]),K=l.length-1;return H}e.$he=o;function g(S,l){return S[l+0]<<0>>>0|S[l+1]<<8>>>0}e.$ie=g;function c(S,l,M){S[M+0]=l&255,l=l>>>8,S[M+1]=l&255}e.$je=c;function h(S,l){return S[l]*2**24+S[l+1]*2**16+S[l+2]*2**8+S[l+3]}e.$ke=h;function a(S,l,M){S[M+3]=l,l=l>>>8,S[M+2]=l,l=l>>>8,S[M+1]=l,l=l>>>8,S[M]=l}e.$le=a;function i(S,l){return S[l+0]<<0>>>0|S[l+1]<<8>>>0|S[l+2]<<16>>>0|S[l+3]<<24>>>0}e.$me=i;function n(S,l,M){S[M+0]=l&255,l=l>>>8,S[M+1]=l&255,l=l>>>8,S[M+2]=l&255,l=l>>>8,S[M+3]=l&255}e.$ne=n;function r(S,l){return S[l]}e.$oe=r;function b(S,l,M){S[M]=l}e.$pe=b;function O(S){return T.$8d(S,l=>t.concat(l))}e.$qe=O;function j(S){return T.$ce(S)}e.$re=j;function P(S){return T.$0d(S,l=>t.concat(l))}e.$se=P;async function A(S){return S.ended?t.concat(S.buffer):t.concat([...S.buffer,await P(S.stream)])}e.$te=A;function f(S){return T.$ae(S,l=>t.concat(l))}e.$ue=f;function k(S){return T.$de(S,{data:l=>typeof l=="string"?t.fromString(l):t.wrap(l)},l=>t.concat(l))}e.$ve=k;function m(S){return T.$7d(l=>t.concat(l),S)}e.$we=m;function I(S,l){return T.$ee(S,l,M=>t.concat(M))}e.$xe=I;function D(S,l){return T.$fe(S,l,M=>t.concat(M))}e.$ye=D;function $(S){let l=0,M=0,F=0;const z=new Uint8Array(Math.floor(S.length/4*3)),p=K=>{switch(M){case 3:z[F++]=l|K,M=0;break;case 2:z[F++]=l|K>>>2,l=K<<6,M=3;break;case 1:z[F++]=l|K>>>4,l=K<<4,M=2;break;default:l=K<<2,M=1}};for(let K=0;K<S.length;K++){const H=S.charCodeAt(K);if(H>=65&&H<=90)p(H-65);else if(H>=97&&H<=122)p(H-97+26);else if(H>=48&&H<=57)p(H-48+52);else if(H===43||H===45)p(62);else if(H===47||H===95)p(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${S[K]}`)}}const _=F;for(;M>0;)p(0);return t.wrap(z).slice(0,_)}e.$ze=$;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:S},l=!0,M=!1){const F=M?E:w;let z="";const p=S.byteLength%3;let _=0;for(;_<S.byteLength-p;_+=3){const K=S[_+0],H=S[_+1],J=S[_+2];z+=F[K>>>2],z+=F[(K<<4|H>>>4)&63],z+=F[(H<<2|J>>>6)&63],z+=F[J&63]}if(p===1){const K=S[_+0];z+=F[K>>>2],z+=F[K<<4&63],l&&(z+="==")}else if(p===2){const K=S[_+0],H=S[_+1];z+=F[K>>>2],z+=F[(K<<4|H>>>4)&63],z+=F[H<<2&63],l&&(z+="=")}return z}e.$Ae=U}),define(W[26],V([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(W[13],V([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.StringEOL=void 0;var N;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(N||(e.StringEOL=N={}));function T(y){let L=0,s=0,d=0,t=0;for(let o=0,g=y.length;o<g;o++){const c=y.charCodeAt(o);c===13?(L===0&&(s=o),L++,o+1<g&&y.charCodeAt(o+1)===10?(t|=2,o++):t|=3,d=o+1):c===10&&(t|=1,L===0&&(s=o),L++,d=o+1)}return L===0&&(s=y.length),[L,s,y.length-d,t]}e.$et=T}),define(W[14],V([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var N;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(N||(e.LanguageId=N={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var L;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(L||(e.StandardTokenType=L={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class d{static getLanguageId(o){return(o&255)>>>0}static getTokenType(o){return(o&768)>>>8}static containsBalancedBrackets(o){return(o&1024)!==0}static getFontStyle(o){return(o&30720)>>>11}static getForeground(o){return(o&16744448)>>>15}static getBackground(o){return(o&4278190080)>>>24}static getClassNameFromMetadata(o){let c="mtk"+this.getForeground(o);const h=this.getFontStyle(o);return h&1&&(c+=" mtki"),h&2&&(c+=" mtkb"),h&4&&(c+=" mtku"),h&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(o,g){const c=this.getForeground(o),h=this.getFontStyle(o);let a=`color: ${g[c]};`;h&1&&(a+="font-style: italic;"),h&2&&(a+="font-weight: bold;");let i="";return h&4&&(i+=" underline"),h&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(o){const g=this.getForeground(o),c=this.getFontStyle(o);return{foreground:g,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$ct=d}),define(W[27],V([0,1,28]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=void 0;class T{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,d){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=d}replace(s,d,t){if(s>=this.a.length)return;if(d===0){this.insert(s,t);return}else if(t===0){this.delete(s,d);return}const o=this.a.slice(0,s),g=this.a.slice(s+d),c=y(t,this.b);this.a=o.concat(c,g)}delete(s,d){d===0||s>=this.a.length||this.a.splice(s,d)}insert(s,d){if(d===0||s>=this.a.length)return;const t=[];for(let o=0;o<d;o++)t[o]=this.b;this.a=(0,N.$Wb)(this.a,s,t)}}e.$XB=T;function y(L,s){const d=[];for(let t=0;t<L;t++)d[t]=s;return d}}),define(W[7],V([0,1,14]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=void 0;class T{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,d){const t=T.defaultTokenMetadata,o=new Uint32Array(2);return o[0]=s.length,o[1]=t,new T(o,s,d)}constructor(s,d,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(s){return s instanceof T?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,d,t){if(this.c!==s.c||this.b!==s.b)return!1;const o=d<<1,g=o+(t<<1);for(let c=o;c<g;c++)if(this.a[c]!==s.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const d=this.a[(s<<1)+1],t=N.$ct.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const d=this.a[(s<<1)+1];return N.$ct.getTokenType(d)}getForeground(s){const d=this.a[(s<<1)+1];return N.$ct.getForeground(d)}getClassName(s){const d=this.a[(s<<1)+1];return N.$ct.getClassNameFromMetadata(d)}getInlineStyle(s,d){const t=this.a[(s<<1)+1];return N.$ct.getInlineStyleFromMetadata(t,d)}getPresentation(s){const d=this.a[(s<<1)+1];return N.$ct.getPresentationFromMetadata(d)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return T.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,d,t){return new y(this,s,d,t)}static convertToEndOffset(s,d){const o=(s.length>>>1)-1;for(let g=0;g<o;g++)s[g<<1]=s[g+1<<1];s[o<<1]=d}static findIndexInTokensArray(s,d){if(s.length<=2)return 0;let t=0,o=(s.length>>>1)-1;for(;t<o;){const g=t+Math.floor((o-t)/2),c=s[g<<1];if(c===d)return g+1;c<d?t=g+1:c>d&&(o=g)}return t}withInserted(s){if(s.length===0)return this;let d=0,t=0,o="";const g=new Array;let c=0;for(;;){const h=d<this.b?this.a[d<<1]:-1,a=t<s.length?s[t]:null;if(h!==-1&&(a===null||h<=a.offset)){o+=this.c.substring(c,h);const i=this.a[(d<<1)+1];g.push(o.length,i),d++,c=h}else if(a){if(a.offset>c){o+=this.c.substring(c,a.offset);const i=this.a[(d<<1)+1];g.push(o.length,i),c=a.offset}o+=a.text,g.push(o.length,a.tokenMetadata),t++}else break}return new T(new Uint32Array(g),o,this.d)}}e.$ft=T;class y{constructor(s,d,t,o){this.a=s,this.b=d,this.c=t,this.d=o,this.e=s.findTokenIndexAtOffset(d),this.f=0;for(let g=this.e,c=s.getCount();g<c&&!(s.getStartOffset(g)>=t);g++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const d=this.a.getEndOffset(this.e+s);return Math.min(this.c,d)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,d){return this.a.getInlineStyle(this.e+s,d)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(W[29],V([0,1,7]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.$gt=void 0,e.$gt=new Uint32Array(0).buffer;class T{static deleteBeginning(s,d){return s===null||s===e.$gt?s:T.delete(s,0,d)}static deleteEnding(s,d){if(s===null||s===e.$gt)return s;const t=y(s),o=t[t.length-2];return T.delete(s,d,o)}static delete(s,d,t){if(s===null||s===e.$gt||d===t)return s;const o=y(s),g=o.length>>>1;if(d===0&&o[o.length-2]===t)return e.$gt;const c=N.$ft.findIndexInTokensArray(o,d),h=c>0?o[c-1<<1]:0,a=o[c<<1];if(t<a){const O=t-d;for(let j=c;j<g;j++)o[j<<1]-=O;return s}let i,n;h!==d?(o[c<<1]=d,i=c+1<<1,n=d):(i=c<<1,n=h);const r=t-d;for(let O=c+1;O<g;O++){const j=o[O<<1]-r;j>n&&(o[i++]=j,o[i++]=o[(O<<1)+1],n=j)}if(i===o.length)return s;const b=new Uint32Array(i);return b.set(o.subarray(0,i),0),b.buffer}static append(s,d){if(d===e.$gt)return s;if(s===e.$gt)return d;if(s===null)return s;if(d===null)return null;const t=y(s),o=y(d),g=o.length>>>1,c=new Uint32Array(t.length+o.length);c.set(t,0);let h=t.length;const a=t[t.length-2];for(let i=0;i<g;i++)c[h++]=o[i<<1]+a,c[h++]=o[(i<<1)+1];return c.buffer}static insert(s,d,t){if(s===null||s===e.$gt)return s;const o=y(s),g=o.length>>>1;let c=N.$ft.findIndexInTokensArray(o,d);c>0&&o[c-1<<1]===d&&c--;for(let h=c;h<g;h++)o[h<<1]+=t;return s}}e.$ht=T;function y(L){return L instanceof Uint32Array?L:new Uint32Array(L)}e.$it=y}),define(W[30],V([0,1,28,12,44,13,29,15]),function(G,e,N,T,y,L,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0;class t{static deserialize(g,c,h){const a=new Uint32Array(g.buffer),i=(0,T.$ke)(g,c);c+=4;const n=(0,T.$ke)(g,c);c+=4;const r=[];for(let b=0;b<n;b++){const O=(0,T.$ke)(g,c);c+=4,r.push(a.subarray(c/4,c/4+O/4)),c+=O}return h.push(new t(i,r)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(g,c){this.a=g,this.b=c}getLineRange(){return new d.$Ns(this.a,this.a+this.b.length)}getLineTokens(g){return this.b[g-this.a]}appendLineTokens(g){this.b.push(g)}serializeSize(){let g=0;g+=4,g+=4;for(let c=0;c<this.b.length;c++){const h=this.b[c];if(!(h instanceof Uint32Array))throw new Error("Not supported!");g+=4,g+=h.byteLength}return g}serialize(g,c){(0,T.$le)(g,this.a,c),c+=4,(0,T.$le)(g,this.b.length,c),c+=4;for(let h=0;h<this.b.length;h++){const a=this.b[h];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,T.$le)(g,a.byteLength,c),c+=4,g.set(new Uint8Array(a.buffer),c),c+=a.byteLength}return c}applyEdit(g,c){const[h,a]=(0,L.$et)(c);this.c(g),this.d(new y.$Ds(g.startLineNumber,g.startColumn),h,a)}c(g){if(g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn)return;const c=g.startLineNumber-this.a,h=g.endLineNumber-this.a;if(h<0){const a=h-c;this.a-=a;return}if(!(c>=this.b.length)){if(c<0&&h>=this.b.length){this.a=0,this.b=[];return}if(c===h){this.b[c]=s.$ht.delete(this.b[c],g.startColumn-1,g.endColumn-1);return}if(c>=0)if(this.b[c]=s.$ht.deleteEnding(this.b[c],g.startColumn-1),h<this.b.length){const a=s.$ht.deleteBeginning(this.b[h],g.endColumn-1);this.b[c]=s.$ht.append(this.b[c],a),this.b.splice(c+1,h-c)}else this.b[c]=s.$ht.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const a=-c;this.a-=a,this.b[h]=s.$ht.deleteBeginning(this.b[h],g.endColumn-1),this.b=this.b.slice(h)}}}d(g,c,h){if(c===0&&h===0)return;const a=g.lineNumber-this.a;if(a<0){this.a+=c;return}if(!(a>=this.b.length)){if(c===0){this.b[a]=s.$ht.insert(this.b[a],g.column-1,h);return}this.b[a]=s.$ht.deleteEnding(this.b[a],g.column-1),this.b[a]=s.$ht.insert(this.b[a],g.column-1,h),this.e(g.lineNumber,c)}}e(g,c){if(c===0)return;const h=[];for(let a=0;a<c;a++)h[a]=null;this.b=N.$Wb(this.b,g,h)}}e.$jt=t}),define(W[16],V([0,1,12,30]),function(G,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YB=void 0;class y{static deserialize(s){let d=0;const t=(0,N.$ke)(s,d);d+=4;const o=[];for(let g=0;g<t;g++)d=T.$jt.deserialize(s,d,o);return o}constructor(){this.a=[]}add(s,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(d);return}}this.a.push(new T.$jt(s,[d]))}finalize(){return this.a}serialize(){const s=this.b(),d=new Uint8Array(s);return this.c(d),d}b(){let s=0;s+=4;for(let d=0;d<this.a.length;d++)s+=this.a[d].serializeSize();return s}c(s){let d=0;(0,N.$le)(s,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(s,d)}}e.$YB=y}),define(W[31],V([0,1,32,3,17,45]),function(G,e,N,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function s($){return $===47||$===92}e.$Vf=s;function d($){return $.replace(/[\\/]/g,N.$gc.sep)}e.$Wf=d;function t($){return $.indexOf("/")===-1&&($=d($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Xf=t;function o($,w=N.$gc.sep){if(!$)return"";const E=$.length,U=$.charCodeAt(0);if(s(U)){if(s($.charCodeAt(1))&&!s($.charCodeAt(2))){let l=3;const M=l;for(;l<E&&!s($.charCodeAt(l));l++);if(M!==l&&!s($.charCodeAt(l+1))){for(l+=1;l<E;l++)if(s($.charCodeAt(l)))return $.slice(0,l+1).replace(/[\\/]/g,w)}}return w}else if(b(U)&&$.charCodeAt(1)===58)return s($.charCodeAt(2))?$.slice(0,2)+w:$.slice(0,2);let S=$.indexOf("://");if(S!==-1){for(S+=3;S<E;S++)if(s($.charCodeAt(S)))return $.slice(0,S+1)}return""}e.$Yf=o;function g($){if(!T.$i||!$||$.length<5)return!1;let w=$.charCodeAt(0);if(w!==92||(w=$.charCodeAt(1),w!==92))return!1;let E=2;const U=E;for(;E<$.length&&(w=$.charCodeAt(E),w!==92);E++);return!(U===E||(w=$.charCodeAt(E+1),isNaN(w)||w===92))}e.$Zf=g;const c=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i($,w=T.$i){const E=w?c:h;return!(!$||$.length===0||/^\s+$/.test($)||(E.lastIndex=0,E.test($))||w&&a.test($)||$==="."||$===".."||w&&$[$.length-1]==="."||w&&$.length!==$.trim().length||$.length>255)}e.$1f=i;function n($,w,E){const U=$===w;return!E||U?U:!$||!w?!1:(0,y.$7e)($,w)}e.$2f=n;function r($,w,E,U=N.sep){if($===w)return!0;if(!$||!w||w.length>$.length)return!1;if(E){if(!(0,y.$8e)($,w))return!1;if(w.length===$.length)return!0;let l=w.length;return w.charAt(w.length-1)===U&&l--,$.charAt(l)===U}return w.charAt(w.length-1)!==U&&(w+=U),$.indexOf(w)===0}e.$3f=r;function b($){return $>=65&&$<=90||$>=97&&$<=122}e.$4f=b;function O($,w){return T.$i&&$.endsWith(":")&&($+=N.sep),(0,N.$ic)($)||($=(0,N.$jc)(w,$)),$=(0,N.$hc)($),T.$i?($=(0,y.$Pe)($,N.sep),$.endsWith(":")&&($+=N.sep)):($=(0,y.$Pe)($,N.sep),$||($=N.sep)),$}e.$5f=O;function j($){const w=(0,N.$hc)($);return T.$i?$.length>3?!1:P(w)&&($.length===2||w.charCodeAt(2)===92):w===N.$gc.sep}e.$6f=j;function P($,w=T.$i){return w?b($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$7f=P;function A($,w=T.$i){return P($,w)?$[0]:void 0}e.$8f=A;function f($,w,E){return w.length>$.length?-1:$===w?0:(E&&($=$.toLowerCase(),w=w.toLowerCase()),$.indexOf(w))}e.$9f=f;function k($){const w=$.split(":");let E,U,S;for(const l of w){const M=Number(l);(0,L.$Hf)(M)?U===void 0?U=M:S===void 0&&(S=M):E=E?[E,l].join(":"):l}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:U!==void 0?U:void 0,column:S!==void 0?S:U!==void 0?1:void 0}}e.$0f=k;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D($,w,E=8){let U="";for(let l=0;l<E;l++){let M;l===0&&T.$i&&!w&&(E===3||E===4)?M=I:M=m,U+=M.charAt(Math.floor(Math.random()*M.length))}let S;return w?S=`${w}-${U}`:S=U,$?(0,N.$jc)($,S):S}e.$$f=D}),define(W[18],V([0,1,6,3,17,8]),function(G,e,N,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.Schemas=void 0;var s;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(s||(e.Schemas=s={}));function d(h,a){return L.URI.isUri(h)?(0,y.$7e)(h.scheme,a):(0,y.$8e)(h,a+":")}e.$_f=d;function t(h,...a){return a.some(i=>d(h,i))}e.$ag=t,e.$bg="vscode-tkn",e.$cg="tkn";class o{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${s.vscodeRemoteResource}`}set(a,i,n){this.a[a]=i,this.b[a]=n}setConnectionToken(a,i){this.c[a]=i}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(j){return N.$1(j),a}const i=a.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[i],b=this.c[i];let O=`path=${encodeURIComponent(a.path)}`;return typeof b=="string"&&(O+=`&${e.$cg}=${encodeURIComponent(b)}`),L.URI.from({scheme:T.$o?this.d:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this.f,query:O})}}e.$dg=new o,e.$eg="vs/../../extensions",e.$fg="vs/../../node_modules",e.$gg="vs/../../node_modules.asar",e.$hg="vs/../../node_modules.asar.unpacked",e.$ig="vscode-app";class g{static{this.a=e.$ig}asBrowserUri(a){const i=this.b(a,G);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===s.vscodeRemote?e.$dg.rewrite(a):a.scheme===s.file&&(T.$m||T.$q===`${s.vscodeFileResource}://${g.a}`)?a.with({scheme:s.vscodeFileResource,authority:a.authority||g.a,query:null,fragment:null}):a}asFileUri(a){const i=this.b(a,G);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===s.vscodeFileResource?a.with({scheme:s.file,authority:a.authority!==g.a?a.authority:null,query:null,fragment:null}):a}b(a,i){return L.URI.isUri(a)?a:L.URI.parse(i.toUrl(a))}}e.$jg=new g;var c;(function(h){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(b){let O;typeof b=="string"?O=new URL(b).searchParams:b instanceof URL?O=b.searchParams:L.URI.isUri(b)&&(O=new URL(b.toString(!0)).searchParams);const j=O?.get(i);if(j)return a.get(j)}h.getHeadersFromQuery=n;function r(b,O,j){if(!globalThis.crossOriginIsolated)return;const P=O&&j?"3":j?"2":"1";b instanceof URLSearchParams?b.set(i,P):b[i]=P}h.addSearchParam=r})(c||(e.COI=c={}))}),define(W[33],V([0,1,22,18,3,8]),function(G,e,N,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VC=void 0;class s{constructor(h,a,i){this.id=h,this.dependencies=a,this.callback=i}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,a,i)=>{typeof h!="string"&&(i=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this.c.push(new s(h,a,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const a=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!a)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(h){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",b),n.removeEventListener("error",O)},b=j=>{r(),a(this.c.pop())},O=j=>{r(),i(j)};n.addEventListener("load",b),n.addEventListener("error",O),this.f&&(h=this.f.createScriptURL(h)),n.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(h){return new Promise((a,i)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),a(this.c.pop())}catch(n){i(n)}})}async j(h){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=L.URI.parse(h).fsPath,b=a.readFileSync(r).toString(),O=n.wrap(b.replace(/^#!.*/,""));return new i.Script(O).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const t=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function g(c,h,a){if(N.$T){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[c]&&(c=o[c]);const i=`${c}/${h}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const j=`${a&&!y.$o?T.$gg:T.$fg}/${i}`;n=T.$jg.asBrowserUri(j).toString(!0)}const r=d.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{G([c],i,n)})}e.$VC=g}),define(W[19],V([0,1,31,18,32,3,17,8]),function(G,e,N,T,y,L,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=e.DataUri=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=void 0;function t(a){return(0,d.$wc)(a,!0)}e.$qg=t;class o{constructor(i){this.a=i}compare(i,n,r=!1){return i===n?0:(0,s.$Ze)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===T.Schemas.file)return N.$3f(t(i),t(n),this.a(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.$Hg)(i.authority,n.authority))return N.$3f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return d.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$zg)(i)||i.authority}basename(i){return y.$gc.basename(i.path)}extname(i){return y.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===T.Schemas.file?n=d.URI.file(y.$mc(t(i))).path:(n=y.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===T.Schemas.file?n=d.URI.file(y.$hc(t(i))).path:n=y.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Hg)(i.authority,n.authority))return;if(i.scheme===T.Schemas.file){const O=y.$lc(t(i),t(n));return L.$i?N.$Wf(O):O}let r=i.path||"/";const b=n.path||"/";if(this.a(i)){let O=0;for(const j=Math.min(r.length,b.length);O<j&&!(r.charCodeAt(O)!==b.charCodeAt(O)&&r.charAt(O).toLowerCase()!==b.charAt(O).toLowerCase());O++);r=b.substr(0,O)+r.substr(O)}return y.$gc.relative(r,b)}resolvePath(i,n){if(i.scheme===T.Schemas.file){const r=d.URI.file(y.$kc(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=N.$Xf(n),i.with({path:y.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$7e)(i,n)}hasTrailingPathSeparator(i,n=y.sep){if(i.scheme===T.Schemas.file){const r=t(i);return r.length>N.$Yf(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=y.sep){return(0,e.$Ig)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=y.sep){let r=!1;if(i.scheme===T.Schemas.file){const b=t(i);r=b!==void 0&&b.length===N.$Yf(b).length&&b[b.length-1]===n}else{n="/";const b=i.path;r=b.length===1&&b.charCodeAt(b.length-1)===47}return!r&&!(0,e.$Ig)(i,n)?i.with({path:i.path+"/"}):i}}e.$rg=o,e.$sg=new o(()=>!1),e.$tg=new o(a=>a.scheme===T.Schemas.file?!L.$k:!0),e.$ug=new o(a=>!0),e.$vg=e.$sg.isEqual.bind(e.$sg),e.$wg=e.$sg.isEqualOrParent.bind(e.$sg),e.$xg=e.$sg.getComparisonKey.bind(e.$sg),e.$yg=e.$sg.basenameOrAuthority.bind(e.$sg),e.$zg=e.$sg.basename.bind(e.$sg),e.$Ag=e.$sg.extname.bind(e.$sg),e.$Bg=e.$sg.dirname.bind(e.$sg),e.$Cg=e.$sg.joinPath.bind(e.$sg),e.$Dg=e.$sg.normalizePath.bind(e.$sg),e.$Eg=e.$sg.relativePath.bind(e.$sg),e.$Fg=e.$sg.resolvePath.bind(e.$sg),e.$Gg=e.$sg.isAbsolutePath.bind(e.$sg),e.$Hg=e.$sg.isEqualAuthority.bind(e.$sg),e.$Ig=e.$sg.hasTrailingPathSeparator.bind(e.$sg),e.$Jg=e.$sg.removeTrailingPathSeparator.bind(e.$sg),e.$Kg=e.$sg.addTrailingPathSeparator.bind(e.$sg);function g(a,i){const n=[];for(let r=0;r<a.length;r++){const b=i(a[r]);a.some((O,j)=>j===r?!1:(0,e.$wg)(b,i(O)))||n.push(a[r])}return n}e.$Lg=g;var c;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(j=>{const[P,A]=j.split(":");P&&A&&r.set(P,A)});const O=n.path.substring(0,n.path.indexOf(";"));return O&&r.set(a.META_DATA_MIME,O),r}a.parseMetaData=i})(c||(e.DataUri=c={}));function h(a,i,n){if(i){let r=a.path;return r&&r[0]!==y.$gc.sep&&(r=y.$gc.sep+r),a.with({scheme:n,authority:i,path:r})}return a.with({scheme:n})}e.$Mg=h}),define(W[20],V([0,1,46,6,34,2,19,3,26,25]),function(G,e,N,T,y,L,s,d,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.Promises=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=void 0;function g(R){return!!R&&typeof R.then=="function"}e.$Ng=g;function c(R){const u=new N.$3d,v=R(u.token),C=new Promise((B,q)=>{const Y=u.token.onCancellationRequested(()=>{Y.dispose(),u.dispose(),q(new T.$5)});Promise.resolve(v).then(Q=>{Y.dispose(),u.dispose(),B(Q)},Q=>{Y.dispose(),u.dispose(),q(Q)})});return new class{cancel(){u.cancel()}then(B,q){return C.then(B,q)}catch(B){return this.then(void 0,B)}finally(B){return C.finally(B)}}}e.$Og=c;function h(R,u,v){return new Promise((C,B)=>{const q=u.onCancellationRequested(()=>{q.dispose(),C(v)});R.then(C,B).finally(()=>q.dispose())})}e.$Pg=h;function a(R,u){return new Promise((v,C)=>{const B=u.onCancellationRequested(()=>{B.dispose(),C(new T.$5)});R.then(v,C).finally(()=>B.dispose())})}e.$Qg=a;async function i(R){let u=-1;const v=R.map((C,B)=>C.then(q=>(u=B,q)));try{return await Promise.race(v)}finally{R.forEach((C,B)=>{B!==u&&C.cancel()})}}e.$Rg=i;function n(R,u,v){let C;const B=setTimeout(()=>{C?.(void 0),v?.()},u);return Promise.race([R.finally(()=>clearTimeout(B)),new Promise(q=>C=q)])}e.$Sg=n;function r(R){return new Promise((u,v)=>{const C=R();g(C)?C.then(u,v):u(C)})}e.$Tg=r;class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const v=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(v,v).then(C)})}return new Promise((v,C)=>{this.b.then(v,C)})}return this.a=u(),new Promise((v,C)=>{this.a.then(B=>{this.a=null,v(B)},B=>{this.a=null,C(B)})})}dispose(){this.f=!0}}e.$Ug=b;class O{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$Vg=O;class j{constructor(){this.a=new Map}queue(u,v){const B=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(u)===B&&this.a.delete(u)});return this.a.set(u,B),B}}e.$Wg=j;const P=(R,u)=>{let v=!0;const C=setTimeout(()=>{v=!1,u()},R);return{isTriggered:()=>v,dispose:()=>{clearTimeout(C),v=!1}}},A=R=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,R())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class f{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,v=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((B,q)=>{this.d=B,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=v===t.$Pd?A(C):P(v,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Xg=f;class k{constructor(u){this.a=new f(u),this.b=new b}trigger(u,v){return this.a.trigger(()=>this.b.queue(u),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Yg=k;class m{constructor(){this.a=!1,this.b=new Promise((u,v)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Zg=m;class I extends m{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$1g=I;function D(R,u){return u?new Promise((v,C)=>{const B=setTimeout(()=>{q.dispose(),v()},R),q=u.onCancellationRequested(()=>{clearTimeout(B),q.dispose(),C(new T.$5)})}):c(v=>D(R,v))}e.$2g=D;function $(R,u=0,v){const C=setTimeout(()=>{R(),v&&B.dispose()},u),B=(0,L.$Qc)(()=>{clearTimeout(C),v?.deleteAndLeak(B)});return v?.add(B),B}e.$3g=$;function w(R){const u=[];let v=0;const C=R.length;function B(){return v<C?R[v++]():null}function q(Y){Y!=null&&u.push(Y);const Q=B();return Q?Q.then(q):Promise.resolve(u)}return Promise.resolve(null).then(q)}e.$4g=w;function E(R,u=C=>!!C,v=null){let C=0;const B=R.length,q=()=>{if(C>=B)return Promise.resolve(v);const Y=R[C++];return Promise.resolve(Y()).then(X=>u(X)?Promise.resolve(X):q())};return q()}e.$5g=E;function U(R,u=C=>!!C,v=null){if(R.length===0)return Promise.resolve(v);let C=R.length;const B=()=>{C=-1;for(const q of R)q.cancel?.()};return new Promise((q,Y)=>{for(const Q of R)Q.then(X=>{--C>=0&&u(X)?(B(),q(X)):C===0&&q(v)}).catch(X=>{--C>=0&&(B(),Y(X))})})}e.$6g=U;class S{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new y.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((v,C)=>{this.f.push({factory:u,c:v,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const v=u.factory();v.then(u.c,u.e),v.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$7g=S;class l extends S{constructor(){super(1)}}e.$8g=l;class M{constructor(){this.a=new te,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$9g=M;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,v=s.$sg){const C=v.getComparisonKey(u);let B=this.a.get(C);if(!B){B=new l;const q=this.f++,Y=y.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(C),this.h(),this.d?.deleteAndDispose(q),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$2c),this.d.set(q,Y),this.a.set(C,B)}return B}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$0g=F;class z{constructor(u,v){this.a=-1,typeof u=="function"&&typeof v=="number"&&this.setIfNotSet(u,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},v)}setIfNotSet(u,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},v))}}e.$$g=z;class p{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,v,C=globalThis){this.cancel();const B=C.setInterval(()=>{u()},v);this.d=(0,L.$Qc)(()=>{C.clearInterval(B),this.d=void 0})}dispose(){this.cancel()}}e.$_g=p;class _{constructor(u,v){this.b=-1,this.a=u,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ah=_;class K{constructor(u,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=u,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$bh=K;class H extends _{constructor(u,v){super(u,v),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$ch=H;class J extends L.$Sc{constructor(u,v){super(),this.g=u,this.h=v,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of u)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$dh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$fh=(R,u)=>{(0,d.$B)(()=>{if(v)return;const C=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$fh=(R,u,v)=>{const C=R.requestIdleCallback(u,typeof v=="number"?{timeout:v}:void 0);let B=!1;return{dispose(){B||(B=!0,R.cancelIdleCallback(C))}}},e.$eh=R=>(0,e.$fh)(globalThis,R)}();class ee{constructor(u,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(C){this.l=C}finally{this.g=!0}},this.f=(0,e.$fh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$gh=ee;class he extends ee{constructor(u){super(globalThis,u)}}e.$hh=he;async function ue(R,u,v){let C;for(let B=0;B<v;B++)try{return await R()}catch(q){C=q,await D(u)}throw C}e.$ih=ue;class te{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,v,C){return this.a={taskId:u,cancel:()=>C?.(),promise:v},v.then(()=>this.d(u),()=>this.d(u)),v}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let v,C;const B=new Promise((q,Y)=>{v=q,C=Y});this.b={run:u,promise:B,promiseResolve:v,promiseReject:C}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$jh=te;class oe{constructor(u,v=()=>Date.now()){this.d=u,this.f=v,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$kh=oe;var ne;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,v)=>{this.a=u,this.b=v})}complete(u){return new Promise(v=>{this.a(u),this.d={outcome:0,value:u},v()})}error(u){return new Promise(v=>{this.b(u),this.d={outcome:1,value:u},v()})}cancel(){return this.error(new T.$5)}}e.$lh=x;var ie;(function(R){async function u(C){let B;const q=await Promise.all(C.map(Y=>Y.then(Q=>Q,Q=>{B||(B=Q)})));if(typeof B<"u")throw B;return q}R.settled=u;function v(C){return new Promise(async(B,q)=>{try{await C(B,q)}catch(Y){q(Y)}})}R.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(u){this.a=void 0,this.b=void 0,this.d=!1,this.promise=u.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$mh=se;class ce{constructor(u){this.b=u,this.a=new o.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$nh=ce;var re;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(re||(re={}));class Z{static fromArray(u){return new Z(v=>{v.emitMany(u)})}static fromPromise(u){return new Z(async v=>{v.emitMany(await u)})}static fromPromises(u){return new Z(async v=>{await Promise.all(u.map(async C=>v.emitOne(await C)))})}static merge(u){return new Z(async v=>{await Promise.all(u.map(async C=>{for await(const B of C)v.emitOne(B)}))})}static{this.EMPTY=Z.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new y.$Sd,queueMicrotask(async()=>{const v={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(u(v)),this.j()}catch(C){this.k(C)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(u,v){return new Z(async C=>{for await(const B of u)C.emitOne(v(B))})}map(u){return Z.map(this,u)}static filter(u,v){return new Z(async C=>{for await(const B of u)v(B)&&C.emitOne(B)})}filter(u){return Z.filter(this,u)}static coalesce(u){return Z.filter(u,v=>!!v)}coalesce(){return Z.coalesce(this)}static async toPromise(u){const v=[];for await(const C of u)v.push(C);return v}toPromise(){return Z.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$oh=Z;class ae extends Z{constructor(u,v){super(v),this.l=u}cancel(){this.l.cancel()}}e.$ph=ae;function de(R){const u=new N.$3d,v=R(u.token);return new ae(u,async C=>{const B=u.token.onCancellationRequested(()=>{B.dispose(),u.dispose(),C.reject(new T.$5)});try{for await(const q of v){if(u.token.isCancellationRequested)return;C.emitOne(q)}B.dispose(),u.dispose()}catch(q){B.dispose(),u.dispose(),C.reject(q)}})}e.$qh=de;class le{constructor(){this.a=new x,this.b=new Z(C=>{if(u){C.reject(u);return}return v&&C.emitMany(v),this.d=B=>C.reject(B),this.f=B=>C.emitOne(B),this.a.p});let u,v;this.f=C=>{v||(v=[]),v.push(C)},this.d=C=>{u||(u=C)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$rh=le}),define(W[21],V([0,1,35]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=e.$VB=e.$UB=void 0,e.$UB=new class{clone(){return this}equals(L){return this===L}};function T(L,s){return new N.$nt([new N.$mt(0,"",L)],s)}e.$VB=T;function y(L,s){const d=new Uint32Array(2);return d[0]=0,d[1]=(L<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new N.$ot(d,s===null?e.$UB:s)}e.$WB=y}),define(W[36],V([0,1,20,6,3,37,13,15,47,21,27,16,7]),function(G,e,N,T,y,L,s,d,t,o,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5B=e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=void 0;var a;(function(A){A[A.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(f,k){this.tokenizationSupport=k,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$ZB=i;class n extends i{constructor(f,k,m,I){super(f,k),this._textModel=m,this._languageIdCodec=I}updateTokensUntilLine(f,k){const m=this._textModel.getLanguageId();for(;;){const I=this.getFirstInvalidLine();if(!I||I.lineNumber>k)break;const D=this._textModel.getLineContent(I.lineNumber),$=j(this._languageIdCodec,m,this.tokenizationSupport,D,!0,I.startState);f.add(I.lineNumber,$.tokens),this.store.setEndState(I.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,k){const m=this.getStartState(f.lineNumber);if(!m)return 0;const I=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),$=D.substring(0,f.column-1)+k+D.substring(f.column-1),w=j(this._languageIdCodec,I,this.tokenizationSupport,$,!0,m),E=new h.$ft(w.tokens,$,this._languageIdCodec);if(E.getCount()===0)return 0;const U=E.findTokenIndexAtOffset(f.column-1);return E.getStandardTokenType(U)}tokenizeLineWithEdit(f,k,m){const I=f.lineNumber,D=f.column,$=this.getStartState(I);if(!$)return null;const w=this._textModel.getLineContent(I),E=w.substring(0,D-1)+m+w.substring(D-1+k),U=this._textModel.getLanguageIdAtPosition(I,0),S=j(this._languageIdCodec,U,this.tokenizationSupport,E,!0,$);return new h.$ft(S.tokens,E,this._languageIdCodec)}isCheapToTokenize(f){const k=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<k||f===k&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,k,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(k<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,m),{heuristicTokens:!1};let I=this.b(k);const D=this._textModel.getLanguageId();for(let $=k;$<=m;$++){const w=this._textModel.getLineContent($),E=j(this._languageIdCodec,D,this.tokenizationSupport,w,!0,I);f.add($,E.tokens),I=E.endState}return{heuristicTokens:!0}}b(f){let k=this._textModel.getLineFirstNonWhitespaceColumn(f);const m=[];let I=null;for(let w=f-1;k>1&&w>=1;w--){const E=this._textModel.getLineFirstNonWhitespaceColumn(w);if(E!==0&&E<k&&(m.push(this._textModel.getLineContent(w)),k=E,I=this.getStartState(w),I))break}I||(I=this.tokenizationSupport.getInitialState()),m.reverse();const D=this._textModel.getLanguageId();let $=I;for(const w of m)$=j(this._languageIdCodec,D,this.tokenizationSupport,w,!1,$).endState;return $}}e.$1B=n;class r{constructor(f){this.d=f,this.a=new b,this.b=new O,this.b.addRange(new t.$Ls(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,k){if(!k)throw new T.$cb("Cannot set null/undefined state");this.b.delete(f);const m=this.a.setEndState(f,k);return m&&f<this.d&&this.b.addRange(new t.$Ls(f+1,f+2)),m}acceptChange(f,k){this.d+=k-f.length,this.a.acceptChange(f,k),this.b.addRangeAndResize(new t.$Ls(f.startLineNumber,f.endLineNumberExclusive),k)}acceptChanges(f){for(const k of f){const[m]=(0,s.$et)(k.text);this.acceptChange(new d.$Ns(k.range.startLineNumber,k.range.endLineNumber+1),m+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$Ls(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,k){return f===1?k:this.getEndState(f-1)}getFirstInvalidLine(f){const k=this.getFirstInvalidEndStateLineNumber();if(k===null)return null;const m=this.getStartState(k,f);if(!m)throw new T.$cb("Start state must be defined");return{lineNumber:k,startState:m}}}e.$2B=r;class b{constructor(){this.a=new g.$XB(null)}getEndState(f){return this.a.get(f)}setEndState(f,k){const m=this.a.get(f);return m&&m.equals(k)?!1:(this.a.set(f,k),!0)}acceptChange(f,k){let m=f.length;k>0&&m>0&&(m--,k--),this.a.replace(f.startLineNumber,m,k)}acceptChanges(f){for(const k of f){const[m]=(0,s.$et)(k.text);this.acceptChange(new d.$Ns(k.range.startLineNumber,k.range.endLineNumber+1),m+1)}}}e.$3B=b;class O{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$Ls(f.start+1,f.endExclusive),f.start}delete(f){const k=this.a.findIndex(m=>m.contains(f));if(k!==-1){const m=this.a[k];m.start===f?m.endExclusive===f+1?this.a.splice(k,1):this.a[k]=new t.$Ls(f+1,m.endExclusive):m.endExclusive===f+1?this.a[k]=new t.$Ls(m.start,f):this.a.splice(k,1,new t.$Ls(m.start,f),new t.$Ls(f+1,m.endExclusive))}}addRange(f){t.$Ls.addRange(f,this.a)}addRangeAndResize(f,k){let m=0;for(;!(m>=this.a.length||f.start<=this.a[m].endExclusive);)m++;let I=m;for(;!(I>=this.a.length||f.endExclusive<this.a[I].start);)I++;const D=k-f.length;for(let $=I;$<this.a.length;$++)this.a[$]=this.a[$].delta(D);if(m===I){const $=new t.$Ls(f.start,f.start+k);$.isEmpty||this.a.splice(m,0,$)}else{const $=Math.min(f.start,this.a[m].start),w=Math.max(f.endExclusive,this.a[I-1].endExclusive),E=new t.$Ls($,w+D);E.isEmpty?this.a.splice(m,I-m):this.a.splice(m,I-m,E)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$4B=O;function j(A,f,k,m,I,D){let $=null;if(k)try{$=k.tokenizeEncoded(m,I,D.clone())}catch(w){(0,T.$1)(w)}return $||($=(0,o.$WB)(A.encodeLanguageId(f),D)),h.$ft.convertToEndOffset($.tokens,m.length),$}class P{constructor(f,k){this.b=f,this.d=k,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,N.$eh)(f=>{this.f=!1,this.h(f)}))}h(f){const k=Date.now()+f.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<k?(0,y.$B)(m):this.g())};m()}j(){const f=this.b._textModel.getLineCount(),k=new c.$YB,m=L.$Od.create(!1);do if(m.elapsed()>1||this.l(k)>=f)break;while(this.k());this.d.setTokens(k.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const k=this.b?.getFirstInvalidLine();return k?(this.b.updateTokensUntilLine(f,k.lineNumber),k.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,k){this.b.store.invalidateEndStateRange(new d.$Ns(f,k))}}e.$5B=P}),define(W[38],V([0,1,34,2,37,14,35]),function(G,e,N,T,y,L,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kGb=void 0;class d extends T.$Sc{constructor(o,g,c,h,a,i,n){super(),this.c=o,this.f=g,this.g=c,this.h=h,this.j=a,this.m=i,this.n=n,this.a=[],this.b=this.B(new N.$Sd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(o,g,c){throw new Error("Not supported!")}createBackgroundTokenizer(o,g){if(this.h)return this.h(o,g)}tokenizeEncoded(o,g,c){const h=Math.random()*1e4<1,a=this.n||h,i=a?new y.$Od(!0):void 0,n=this.c.tokenizeLine2(o,c,500);if(a){const b=i.elapsed();(h||b>32)&&this.m(b,o.length,h)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${o.substring(0,100)}`),new s.$ot(n.tokens,c);if(this.g){const b=this.a,O=n.tokens;for(let j=0,P=O.length>>>1;j<P;j++){const A=O[(j<<1)+1],f=L.$ct.getLanguageId(A);b[f]||(b[f]=!0,this.b.fire(f))}}let r;return c.equals(n.ruleStack)?r=c:r=n.ruleStack,new s.$ot(n.tokens,r)}}e.$kGb=d}),define(W[39],V([0,1,21,2,11]),function(G,e,N,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lGb=void 0;class L extends T.$Sc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,o){super(),this.a=d,this.b=t,this.c=o,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,o){throw new Error("Not supported!")}tokenizeEncoded(d,t,o){return d.length>=this.c.get()?(0,N.$WB)(this.a,o):this.b.tokenizeEncoded(d,t,o)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$lGb=L}),define(W[40],V([0,1,33,20,11,3,15,48,36,16,7,38,39]),function(G,e,N,T,y,L,s,d,t,o,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qGb=void 0;class a extends d.$8u{constructor(r,b,O,j,P,A,f,k){super(r,b,O,j),this.s=P,this.t=A,this.u=f,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new T.$ah(()=>this.w(),10),this.c.set(k,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,b){this.t=r,this.u=b,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,b){this.a&&(this.a.store.invalidateEndStateRange(new s.$Ns(r,b)),this.q.schedule())}async v(){this.a=null;const r=this.t,b=this.u,O=await this.s.getOrCreateGrammar(r,b);if(!(this.b||r!==this.t||b!==this.u||!O)){if(O.grammar){const j=new h.$lGb(this.u,new c.$kGb(O.grammar,O.initialState,!1,void 0,()=>!1,(P,A,f)=>{this.s.reportTokenizationTime(P,r,O.sourceExtensionId,A,f)},!1),this.c);this.a=new t.$ZB(this.f.length,j)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:b}=await(0,N.$VC)("vscode-textmate","release/main.js");this.m=b}const r=new Date().getTime();for(;;){let b=0;const O=new o.$YB,j=new i;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||b>200)break;b++;const k=this.f[f.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(k,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,m.endState)){const D=this.m(f.startState,m.endState);j.setState(f.lineNumber,D)}else j.setState(f.lineNumber,null);if(g.$ft.convertToEndOffset(m.tokens,k.length),O.add(f.lineNumber,m.tokens),new Date().getTime()-r>20)break}if(b===0)break;const P=j.getStateDeltas();if(this.s.setTokensAndStates(this.h,O.serialize(),P),new Date().getTime()-r>20){(0,L.$B)(()=>this.w());return}}}}e.$qGb=a;class i{constructor(){this.a=-1,this.b=[]}setState(r,b){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(b):this.b.push({startLineNumber:r,stateDeltas:[b]}),this.a=r}getStateDeltas(){return this.b}}}),define(W[41],V([0,1,19]),function(G,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nGb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(L){if(this.a[L.scopeName]){const s=this.a[L.scopeName];N.$vg(s.location,L.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${L.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${L.location.toString()}`)}this.a[L.scopeName]=L}getGrammarDefinition(L){return this.a[L]||null}}e.$nGb=T}),define(W[42],V([0,1,2,41]),function(G,e,N,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pGb=e.$oGb=void 0,e.$oGb="No TM Grammar registered for this language.";class y extends N.$Sc{constructor(s,d,t,o){super(),this.a=s,this.b=t.INITIAL,this.c=new T.$nGb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:o,loadGrammar:async g=>{const c=this.c.getGrammarDefinition(g);if(!c)return this.a.logTrace(`No grammar found for scope ${g}`),null;const h=c.location;try{const a=await this.a.readFile(h);return t.parseRawGrammar(a,h.path)}catch(a){return this.a.logError(`Unable to load and parse grammar for scope ${g} from ${h}`,a),null}},getInjections:g=>{const c=g.split(".");let h=[];for(let a=1;a<=c.length;a++){const i=c.slice(0,a).join(".");h=[...h,...this.f[i]||[]]}return h}}));for(const g of d){if(this.c.register(g),g.injectTo){for(const c of g.injectTo){let h=this.f[c];h||(this.f[c]=h=[]),h.push(g.scopeName)}if(g.embeddedLanguages)for(const c of g.injectTo){let h=this.g[c];h||(this.g[c]=h=[]),h.push(g.embeddedLanguages)}}g.language&&this.h.set(g.language,g.scopeName)}}has(s){return this.h.has(s)}setTheme(s,d){this.j.setTheme(s,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,d){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$oGb);const o=this.c.getGrammarDefinition(t);if(!o)throw new Error(e.$oGb);const g=o.embeddedLanguages;if(this.g[t]){const a=this.g[t];for(const i of a)for(const n of Object.keys(i))g[n]=i[n]}const c=Object.keys(g).length>0;let h;try{h=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:g,tokenTypes:o.tokenTypes,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.$oGb):a}return{languageId:s,grammar:h,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:o.sourceExtensionId}}}e.$pGb=y}),define(W[49],V([0,1,8,42,40]),function(G,e,N,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function L(d,t){return new s(d,t)}e.create=L;class s{constructor(t,o){this.f=o,this.b=new Map,this.c=[],this.a=t.host;const g=o.grammarDefinitions.map(c=>({location:N.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(g)}async g(t){const o=this.f.textmateMainUri,g=await new Promise((n,r)=>{G([o],n,r)}),c=await new Promise((n,r)=>{G([this.f.onigurumaMainUri],n,r)}),a=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>c.createOnigScanner(n),createOnigString:n=>c.createOnigString(n)});return new T.$pGb({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this.a.readFile(n)},t,g,i)}acceptNewModel(t){const o=N.URI.revive(t.uri),g=this;this.b.set(t.controllerId,new y.$qGb(o,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,h){const a=await g.d;return a?(g.c[h]||(g.c[h]=a.createGrammar(c,h)),g.c[h]):Promise.resolve(null)},setTokensAndStates(c,h,a){g.a.setTokensAndStates(t.controllerId,c,h,a)},reportTokenizationTime(c,h,a,i,n){g.a.reportTokenizationTime(c,h,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,o){this.b.get(t).onEvents(o)}retokenize(t,o,g){this.b.get(t).retokenize(o,g)}acceptModelLanguageChanged(t,o,g){this.b.get(t).onLanguageId(o,g)}acceptRemovedModel(t){const o=this.b.get(t);o&&(o.dispose(),this.b.delete(t))}async acceptTheme(t,o){(await this.d)?.setTheme(t,o)}acceptMaxTokenizationLineLength(t,o){this.b.get(t).acceptMaxTokenizationLineLength(o)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f6b7ba78b8850751f083306b8f5d745c8a0ddcf/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
